﻿var lastClickTime = (new Date()).valueOf();

function isFastClick() {
    var currentTime = (new Date()).valueOf();
    console.log("c_" + currentTime + "|" + "l_" + lastClickTime);
    if (currentTime - lastClickTime < 500) {
        return true;
    }
    lastClickTime = currentTime;
    return false;
}

// 2019-5-5 15:13:42 手机号正则表达式
var regPhoneNum = /^1[3-9][0-9]{9}$/;

var vpRelation = ['', '本人', '父母', '子女', '配偶', '亲戚', '', '', '', '其他'];

// 2017-01-09 14:52:51 上传通知权限
// 2017-4-20 09:36:29 仅iOS调用 防止Android报传入参数错误
function SetNoticeAuth() {
    if (currentPlatform == "iOS") {
        console.log("SetNoticeAuth: accountId=" + localStorage.currentAccountId + "; noticeAuth=" + localStorage.noticeAuth);
        if (localStorage.currentAccountId != null && localStorage.currentAccountId.length != 0) {
            console.log('TODO: AJAX: ' + "noticeAuth=" + localStorage.noticeAuth + "&a=" + localStorage.currentAccountId + "&p=" + currentPlatform + "&t=" + deviceToken + '&v=' + currentAppVersion);
            $.ajax({
                type: "POST",
                timeout: 3000,
                url: serviceUrl + "/Account/SetNoticeAuth?noticeAuth=" + localStorage.noticeAuth,
                data: { noticeAuth: localStorage.noticeAuth },
                dataType: "JSON",
                xhrFields: {
                    withCredentials: true
                },
                crossDomain: true,
                contentType: "applicaion/json",
                beforeSend: function (request) {
                    request.setRequestHeader("FW-Account-Id", localStorage.currentAccountId);
                    request.setRequestHeader("FW-Device-Platform", currentPlatform);
                    request.setRequestHeader("FW-Push-Token", deviceToken);
                    request.setRequestHeader("FW-App-Version", currentAppVersion);
                    request.setRequestHeader("FW-Xhr-Timestamps", Date.parse(new Date()));
                    request.setRequestHeader("FW-Xhr-Token", calcToken(request));
                    request.setRequestHeader("FW-I18n-Status", localStorage.isEnglishMode);
                },
                success: function (data) {
                    if (data.result == 1) {
                        console.log("上传通知权限成功");
                    }
                    else {
                        console.log(data.msg);
                    }
                }
            });
        }
    }
}

// 显示APP内浏览器
function showInAppBrowser(url, target, options) {
    console.log(url);
    cordova.InAppBrowser.open(url, target, options);
}

// 显示APP内浏览器，新版插件适配，增加默认配置隐藏地址栏
function showInAppBrowser(url, target) {
    console.log(url);
    if (currentPlatform == "Android") {
        var option = "location=yes,clearcache=no,toolbar=yes,hideurlbar=yes";
    }
    else {
        var option = "location=no,clearcache=no,toolbar=yes,closebuttoncaption=关闭";
    }

    var inapp = cordova.InAppBrowser.open(url, target, option);
    return inapp;
}

// 计算token
function calcToken(config) {
    var param = new Object();
    var paraName = new Array();

    if (config.data != null) {
        for (var i in config.data) {
            if (config.data[i] != undefined) {
                param[i.toLowerCase()] = config.data[i];
                paraName.push(i.toLowerCase());
            }
        }
    }

    if (config.headers != null) {
        for (var i in config.headers) {
            //console.log(i);
            if (i.indexOf("FW-") > -1 && config.headers[i] != undefined) {
                param[i.toLowerCase()] = config.headers[i];
                paraName.push(i.toLowerCase());
            }
        }
    }
    paraName.sort();
    //console.log(param);
    var strOri = '';
    for (var i in paraName) {
        strOri += paraName[i] + "=" + param[paraName[i]] + "&";
    }

    if (strOri.length > 0) {
        strOri = strOri.substr(0, strOri.length - 1);
    }

    return md5(strOri);
}

// 获取QueryString数值
function getQueryVariable(queryString, variable) {
    if (queryString == null) {
        queryString = window.location.search.substring(1);
    }
    var vars = queryString.split('&');
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split('=');
        if (decodeURIComponent(pair[0]) == variable) {
            return decodeURIComponent(pair[1]);
        }
    }
    return null;
}

// 计算密码强度
function calcPwdLevel(pwd) {
    var strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9]).*$", "g");
    // 2020-3-13 18:03:48 中档强度要求由7位改为8位
    var mediumRegex = new RegExp("^(?=.{8,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
    var enoughRegex = new RegExp("(?=.{6,}).*", "g");
    if (!enoughRegex.test(pwd)) {
        return 0;
    }
    else if (strongRegex.test(pwd)) {
        return 3;
    }
    else if (mediumRegex.test(pwd)) {
        return 2;
    }
    else {
        return 1;
    }
}

// 2024-2-20 15:36:05 ZZL hzfwx-700 传一个字符串获取字节数
function getStringByteSize(str) {
    var size = 0;
    //if (str.startsWith('"') && str.endsWith('"')) {
    //    str = str.substr(1, str.length-1)
    //}         
    for (var i = 0; i < str.length; i++) {
        var charCode = str.charCodeAt(i);
        if (charCode < 0x80) {
            //ASCII字符占用1个字节
            size += 1;
        } else if (charCode < 0x0800) {
            //非ASCII字符但小于0x0800,占用2个字节（例如拉丁文扩展字符）
            size += 2;
        } else if ((charCode >= 0x4E00) && (charCode <= 0x9FA5)) {
            //每个汉字为匹配c#GetByteCount 每个汉字取2字符
            size += 2;
        } else if ((charCode >= 0x3400) && (charCode <= 0x4DBF)) {
            //补充CJK统一表意符号扩展A的汉字范围 也计为2个字节
            size += 2;
        } else if ((charCode >= 0x20000) && (charCode <= 0x2A6DF)) {
            //补充CJK统一表意符号扩展B的范围，计为2个字节
            size += 2;
        } else if (charCode === 0xFF08 || charCode === 0xFF09) {
            //中文括号
            size += 2;
        } else {
            size += 3;
        }
    }
    //var encodeStr = encodeURIComponent(str);
    //var multiByte = encodeStr.match(/%[\dA-F]{2}/gi).length / 3;
    //var asciiCharCount = str.length - multiByte;
    //size = asciiCharCount + (multiByte * 2);
    return size;
}

// 2019-5-26 17:08:01 jsencrypt.js RSA非对称加密解密
var jsencrypt = new JSEncrypt();
var pubkey = 'MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCgUdCgBg+glqg4Wwq8WgZvggYM+kpeBawWxh7xhJs1c5Lwrah5X3u49yaqoodnjxo2xRBGOCdM53aWmi7hUJ6zvgxsWmFMH+OgrWgg7TEWMCQiMzyu/OjtVGrE4djn2WfXPhkO53kNZsDH0IkKwIFYy9AJEXsh0oospyUZiI02EQIDAQAB';
jsencrypt.setPublicKey(pubkey);
