﻿angular.module('fwapp.controllers')

.controller('AboutUsController', function ($scope, $rootScope, $state, $http, $window, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform
, HospitalService, ComplainService, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, $fwCordovaToast) {

    /*测试开始的分割线*/
    //    $scope.info = {};
    //    $scope.info.visitPatientId = 'c6764145-df77-4c28-9124-8222e44b9d11';
    /*测试结束的分割线*/

    // APP下载二维码
    $scope.appQRCodeUrl = serviceUrl + '/img/app_qrcode.png';
    // 平台、版本号
    $scope.platform = currentPlatform;
    $scope.version = '';
    // 免责声明
    $scope.statement = new Object();

    // 意见反馈
    $scope.feedback = {
        content: '',
        contact: '',
        invalid: false
    }

    // 初始化版本号
    if ($window.plugins) {
        $cordovaAppVersion.getVersionNumber().then(function (version) {
            $scope.version = version;
        });
    }

    // 注册模态窗口：意见反馈
    $ionicModal.fromTemplateUrl('feedback.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.feedbackModal = modal;
    })

    // 注册模态窗口 免责声明
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl("statement.html"), {
        scope: $scope
    }).then(function (modal) {
        $scope.statementModal = modal;
    });

    $scope.$on('$destroy', function () {
        $scope.feedbackModal.remove();
        $scope.chatUsModal.remove();
        $scope.statementModal.remove();
    })

    // 意见反馈模态窗口显示
    $scope.feedbackShow = function () {
        $scope.feedbackModal.show();
    }

    // 意见反馈模态窗口关闭
    $scope.feedbackHide = function () {
        if ($scope.feedback.content != '') {
            $ionicPopup.confirm({
                template: "当前意见反馈信息未保存，确认离开？",
                cancelText: '取消',
                okText: '确定'
            }).then(function (res) {
                if (res) {
                    hideFeedBack();
                }
            })
        } else {
            hideFeedBack();
        }
    }

    // 意见反馈提交
    $scope.feedbackSubmit = function () {
        $ionicLoading.show();
        if ($scope.feedback.content == '') {
            $scope.feedback.invalid = true;
            $ionicLoading.hide();
            return;
        } else {
            $scope.feedback.invalid = false;
        }

        HospitalService.feedback($scope.feedback.content, $scope.feedback.invalid).then(function (data) {
            if (data.result == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('感谢您的意见反馈');
                hideFeedBack();
            }
        }, function () {
            $ionicLoading.hide();
            if ($window.plugins) {
                $cordovaToast.showShortButtom('网络连接异常，请重试');
            } else {
                console.warn("Toast: 网络连接异常，请重试");
            }
        });
    }

    // 隐藏模态窗口
    function hideFeedBack() {
        $scope.feedback = {
            content: '',
            contact: '',
            invalid: false
        };
        $scope.feedbackModal.hide();
    }

    // 注册模态窗口：联系我们
    $ionicModal.fromTemplateUrl('chatUs.html', {
        scope: $rootScope
    }).then(function (modal) {
        $rootScope.chatUsModal = modal;
    })

    // 联系我们模态窗口显示
    $rootScope.chatUsShow = function () {
        $rootScope.chatUs = {
            phone: '',
            content: "",
            invalid: false,
            phoneInvalid: false
        };
        $rootScope.chatUsModal.show();
    }

    // 联系我们模态窗口关闭
    $rootScope.chatUsHide = function () {
        if ($rootScope.chatUs.content != '') {
            $ionicPopup.confirm({
                template: "当前意见反馈信息未保存，确认离开？",
                cancelText: '取消',
                okText: '确定'
            }).then(function (res) {
                if (res) {
                    hideChatUs();
                }
            })
        } else {
            hideChatUs();
        }
    }

    // 意见反馈提交
    $rootScope.chatUsSubmit = function () {
        $ionicLoading.show();

        // 初始化提示图标状态
        $rootScope.chatUs.invalid = false;
        $rootScope.chatUs.phoneInvalid = false;

        // 验证
        if ($rootScope.chatUs.content == "") {
            $fwCordovaToast.showShortBottom("意见反馈不能为空");
            $rootScope.chatUs.invalid = true;
            $ionicLoading.hide();
            return;
        }
        else if ($rootScope.chatUs.content.length > 200) {
            $fwCordovaToast.showShortBottom("意见反馈最多为200字");
            $rootScope.chatUs.invalid = true;
            $ionicLoading.hide();
            return;
        }
        else if ($rootScope.chatUs.phone == "") {
            $fwCordovaToast.showShortBottom("联系方式不能为空");
            $rootScope.chatUs.phoneInvalid = true;
            $ionicLoading.hide();
            return;
        }
        else if (!regPhoneNum.test($rootScope.chatUs.phone)) {
            $fwCordovaToast.showShortBottom("手机号格式不正确");
            $rootScope.chatUs.phoneInvalid = true;
            $ionicLoading.hide();
            return;
        }
        else {
            $rootScope.chatUs.invalid = false;
            $rootScope.chatUs.phoneInvalid = false;
        }

        // 8 =》 联系我们
        ComplainService.submitComplain($rootScope.chatUs.content, $rootScope.chatUs.phone, "8").then(function (data) {
            if (data.result == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '提交成功',
                    template: '您好，非常感谢您对我院的信任，我们已收到您的意见反馈，我们会尽快处理。',
                    okText: '确定'
                });
                hideChatUs();
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (resp) {
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络'
            });
            $ionicLoading.hide();
        })
    }

    // 隐藏模态窗口
    function hideChatUs() {
        $rootScope.chatUs = {
            phone: '',
            content: "",
            invalid: false,
            phoneInvalid: false
        };
        $rootScope.chatUsModal.hide();
    }

    // 弹出免责声明
    $scope.statementShow = function () {
        $scope.statement.usage = 'about';
        $scope.statementModal.show();
    }

    // 隐藏免责声明
    $scope.statementHide = function () {
        $scope.statementModal.hide();
        $ionicScrollDelegate.scrollTop();
        $scope.statement.usage = '';
    }

    // 弹出用户隐私政策
    $scope.privacyPolicyShow = function () {
        // 2022.11.30 10:25 朱世博 未登录状态不显示解除授权按钮
        if (localStorage.currentAccountId == null || localStorage.currentAccountId.length == 0 || localStorage.currentAccountId == "") {
            $rootScope.privacyPolicyShow('noLogin');
        }
        else {
            $rootScope.privacyPolicyShow('deauthorize');
        }
    }

    // 隐藏用户隐私政策
    $scope.privacyPolicyHide = function () {
        $rootScope.privacyPolicyHide();
    }

    // 检查更新
    $scope.checkUpdate = function () {
        $rootScope.checkUpdate($scope.platform, false, true, false, true);
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $rootScope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'aboutUs');
        // 获取免责声明
        HospitalService.statement().then(function (data) {
            $scope.statement.content = data;
        });
    });

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'aboutUs') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
});