﻿angular.module('fwapp.controllers')

// 预约申请
.controller('AddWishController', function ($scope, $rootScope, $state, $stateParams, $timeout, $interval
, $fwCordovaToast, AddWishService, VisitPatientService, SchedulingService, DoctorInfoService, AccountService, TriageService
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaGeolocation) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义预约申请滑块
    var slideWishlist = $ionicSlideBoxDelegate.$getByHandle('slideWishlist');
    // 打哪儿来
    $scope.from = $stateParams.from;
    console.log($stateParams.from);
    // 从医师出诊表传过来的opInfoId
    $scope.opInfoId = $stateParams.opid;
    // 从智能分诊传过来的数据 0:from, 1:triageId, 2:vpId, 3:doctorId
    $scope.triageData = {};
    if ($scope.from.indexOf('app.triage') > -1) {
        var data = $scope.from.split(',');
        console.log(data);
        $scope.triageData.from = data[0];
        $scope.triageData.triageId = data[1];
        $scope.triageData.vpId = data[2];
        $scope.triageData.doctorId = data[3];
        console.log($scope.triageData);
    }
    // 根据传过来的opInfoId获取预约信息
    $scope.opInfo = new Object();
    // 初始滑块状态
    $scope.step = 0;
    // 标题数组
    $scope.titleList = ["用户须知", "选择就诊人", "选择预约方式", "选择医生", "选择条件", "选择症状", "智能分诊", "选择医生", "预约确认", "预约结果"]//new Array(); // ['用户须知', '选择就诊人', '选择预约方式', '选择医生', '选择条件'];
    // 用户须知数据
    $scope.agreement = new Object();
    // 就诊人相关
    $scope.vpList = new Object();
    $scope.vpNew = new Object();
    $scope.vpSelect = ''; // 就诊人ID
    // 症状
    $scope.apptComplaint = new Object();
    $scope.apptComplaint.data = "";
    // 预约方式 按医生=1 按条件=2
    $scope.wishType = ''; // 预约方式
    // 预约选项
    $scope.schedDateList = new Array();
    $scope.schedTimeList = new Array();
    $scope.divisionList = new Array();
    $scope.doctorLevelList = new Array();
    $scope.apptDoctorTips = new Object();
    // 按医生数据
    $scope.currentWishByDoctor = new Object();
    $scope.currentWishByDoctor.schedDate = ''; // 预约日期
    $scope.currentWishByDoctor.schedTime = ''; // 预约时段
    $scope.currentWishByDoctor.division = ''; // 预约科室
    // 医生出诊列表
    $scope.opInfoList = new Array();
    $scope.opInfoSelect = new Object();
    $scope.opInfoListEmpty = false;
    // 按条件数据
    $scope.currentWishByFilter = new Object(); // 奇葩 必须定义到变量的二级属性才能绑定ng-model 这是为什么
    $scope.currentWishByFilter.schedDate = ''; // 预约日期
    $scope.currentWishByFilter.schedTime = ''; // 预约时段
    $scope.currentWishByFilter.division = ''; // 预约科室
    $scope.currentWishByFilter.doctorLevel = ''; // 预约医师级别
    // 按医师搜索
    $scope.doctorSearch = new Object();
    $scope.doctorSearch.list = new Array(); // 医师搜索结果列表
    $scope.doctorSearch.keyword = ''; // 医师搜索关键词
    $scope.doctorSearch.isSearch = false;  // 是否搜索
    $scope.doctorSearch.isEmpty = false;  // 结果是否空

    // 预约成功后返回预约申请信息
    $scope.apptSuccessInfo = new Object();
    $scope.apptErrorMsg = '';
    // 验证通知
    $scope.verifyNoticeInfo = new Object();
    $scope.verifyNoticeInfo.noticeAuth = true;
    $scope.accountInfo = new Object();
    // 受限用户申诉
    $scope.complaintStatus = -1;
    $scope.complaintMsg = "";
    $scope.blackComplaint = {};
    $scope.blackComplaint.data = "";

    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 仅看可约
    $scope.showAvailable = false;

    // 用户须知倒计时
    $scope.confirmCountdown = devMode ? 1 : 10;

    // 地图实例
    $scope.map = {}
    $scope.mapSearch = {}
    // 地图模式
    $scope.mapMode = 'map';
    // 上一次地图模式
    $scope.mapLastMode = $scope.mapMode;
    // GCJ坐标
    $scope.locationGCJ = { lng: 0, lat: 0 };
    // 医院中心
    $scope.locationFWCenter = { lng: 116.351256, lat: 39.925325 };
    // 医院门诊
    $scope.locationFWOutpatient = { lng: 116.34998, lat: 39.925289 };
    // 医院停车场
    $scope.locationFWParking = { lng: 116.349711, lat: 39.925087 };
    // 天安门(测试用)
    $scope.locationTAM = { lng: 116.39732405, lat: 39.90874581 };
    // 天津之眼(测试用)
    $scope.locationTJZY = { lng: 117.18631, lat: 39.154161 };
    // 导航实例
    $scope.pathPlan = {};
    $scope.pathPlan.driving = {};
    $scope.pathPlan.transfer = {};
    $scope.pathPlan.riding = {};
    $scope.pathPlan.walking = {};
    // 地图总高度
    $scope.mapTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 108 : 88);
    // 起点
    $scope.startPoint = {};
    $scope.startPoint.keyword = "";
    $scope.startPoint.name = "";
    $scope.startPoint.location = { lng: 0, lat: 0 };
    // 搜索
    $scope.mapSearcData = {};
    $scope.mapSearcData.province = "";
    $scope.mapSearcData.city = "";
    $scope.mapSearcData.provinceList = {};
    $scope.mapSearcData.cityList = {};

    // 定义预约申请滚动条
    //var scrollTriage = $ionicScrollDelegate.$getByHandle('scrollTriage');
    // 症状
    $scope.symptomData = new Object();
    $scope.symptomData.isReview = false;
    $scope.symptomData.symptoms = [];
    // 复查信息
    $scope.reviewDataRequestId = '';
    $scope.reviewData = [];
    $scope.intoReview = false;
    // 症状查询
    $scope.addSymptomData = {};
    $scope.addSymptomData.keyword = '';
    // 分诊结果
    $scope.sysptomResult = {};
    // 医师列表
    $scope.doctorData = {};
    $scope.doctorData.doctorList = [];
    // 是否正在获取历史就诊
    $scope.isLoadingHistory = false;

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：填写症状
    $ionicModal.fromTemplateUrl('apptComplaint.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.apptComplaintModal = modal;
    });

    // 注册模态窗口：通知授权帮助
    $ionicModal.fromTemplateUrl('noticeAuthHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.noticeAuthHelpModal = modal;
    });

    // 注册模态窗口：医师介绍
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('doctorIntro.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 注册模态窗口：受限用户申诉
    $ionicModal.fromTemplateUrl('blackComplaint.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.blackComplaintModal = modal;
    });

    // 注册模态窗口 来院导航
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('map.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.amapModal = modal;
    });

    // 注册模态窗口 搜索起点
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('mapSearch.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.amapSearchModal = modal;
    });

    // 注册模态窗口：添加症状
    $ionicModal.fromTemplateUrl('addSymptom.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addSymptomModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.apptComplaintModal.remove();
        $scope.noticeAuthHelpModal.remove();
        $scope.doctorIntroModal.remove();
        $scope.showAvatarModal.remove();
        $scope.blackComplaintModal.remove();
        $scope.amapModal.remove();
        $scope.amapSearchModal.remove();
        $scope.addSymptomModal.remove();
    })
    // 医师介绍模态窗口
    // 增加医师搜索功能，追加doctorCode参数
    $scope.doctorIntro = function (doctorId, doctorLevel, doctorCode, doctorName) {
        $scope.schedulingModal = new Array();
        $scope.doctorInfo = new Object();
        if (doctorId == undefined || doctorId.length == 0) {
            $scope.doctorInfo.doctor_name = doctorName;
            $scope.doctorInfo.title = doctorLevel;
            $scope.doctorInfo.avatar_path = picPrefix + "/Sites/Uploaded/File/2012/1/Default.jpg";
            if (doctorCode != '') {
                $ionicLoading.show();
                DoctorInfoService.scheduling_new(doctorCode).then(function (data) {
                    $scope.schedulingModal = data;
                    console.log(data);
                    $ionicLoading.hide();
                }, function (resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络'
                    });
                    $ionicLoading.hide();
                });
            }
            $scope.doctorIntroModal.show();
            $ionicScrollDelegate.$getByHandle('intro').scrollTop();
            return;
        }
        $ionicLoading.show();
        DoctorInfoService.doctorInfo(doctorId).then(function (data) {
            $ionicLoading.hide();
            $scope.doctorInfo = data;
            if (doctorLevel.toString() != "") {
                $scope.doctorInfo.title = doctorLevel;
            }

            if (doctorCode != '') {
                DoctorInfoService.scheduling_new(doctorCode).then(function (data) {
                    $scope.schedulingModal = data;
                    console.log(data);
                }, function (resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络'
                    });
                    $ionicLoading.hide();
                });
            }

        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
        $scope.doctorIntroModal.show();
        $ionicScrollDelegate.$getByHandle('intro').scrollTop();
    }

    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
        $scope.doctorInfo = new Object();
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideWishlist.enableSlide(false);
    });
    // 滑到上一步
    $scope.lastSlide = function () {
        slideWishlist.previous();
        $scope.step = slideWishlist.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        // 智能分诊
        if ($scope.step == 0 && $scope.from.indexOf('app.triage') > -1 && $scope.triageData.vpId != null) {
            // 就诊人id
            var index = $.inArray($scope.triageData.vpId, $scope.vpList.map(function (e) {
                return e.VISIT_PATIENT_ID;
            }));
            $scope.vpSelect = $scope.vpList[index];
            // 预约方式为按医生
            $scope.wishType = '1';
            // opInfo赋值 已经在进入页面的时候异步获取opInfo
            $scope.opInfoSelect = $scope.opInfo;
            console.log($scope.opInfoSelect);
            // 跳转到预约确认页面
            $scope.toSlide(8);
        }
        else {
            slideWishlist.next();
            $scope.step = slideWishlist.currentIndex();
        }
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideWishlist.slide(index);
        $scope.step = slideWishlist.currentIndex();
        // 进入预约列表 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        // 按医生预约=1
        if (index == '3') {
            $scope.wishType = '1';
        }
        // 按条件预约=2
        else if (index == '4') {
            $scope.wishType = '2';
        }
        // 按症状预约=3
        else if (index == '5') {
            $scope.wishType = '3';
            // 获取常见症状
            TriageService.rlatSymptom("", $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                // 查询成功
                if (data.result == 1) {
                    $scope.addSymptomData.rlats = data.data;
                    $scope.addSymptomData.common = data.common;
                }
                // 无结果
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function (data) {
                ;
            })
            // 获取上次就诊
            if ($scope.vpSelect.IS_BIND_CARD != 1) {
                if ($scope.step == 1) {
                    $fwCordovaToast.showShortBottom('当前就诊人未绑定就诊卡，无法查询复诊信息');
                    $scope.symptomData.isReview = false;
                }
                return;
            }
            if ($scope.reviewDataRequestId.length == 0) {
                // 请求上次就诊信息
                $scope.isLoadingHistory = true;
                TriageService.getLastOpInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                    // 查询成功
                    if (data.result == 1) {
                        $scope.reviewDataRequestId = data.data;
                        $scope.symptomData.isReview = true;
                    }
                    else if (data.result == -1) {        // 查询缓存
                        if (data.is_null == 1) {
                            $scope.reviewDataRequestId = data.data;
                        }
                        else {    // 原本data.data能直接用的，但是上次就诊信息返回特殊处理了
                            $scope.reviewDataRequestId = data.data[0].REQUEST_ID;
                        }
                        $scope.symptomData.isReview = true;
                    }
                    // 无结果
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $scope.symptomData.isReview = false;
                    }
                    // 有结果
                    if ($scope.symptomData.isReview) {
                        // 获取上次就诊信息
                        TriageService.respLastOpInfo($scope.reviewDataRequestId).then(function (data) {
                            console.log(data);
                            // 查询成功
                            if (data.result == 1 && data.is_null == 0) {
                                $scope.reviewData = data.data;
                            }
                            // 无结果
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                                $scope.symptomData.isReview = false;
                            }
                            $ionicLoading.hide();
                            $scope.isLoadFinish = true;
                            $scope.isLoadingHistory = false;
                        }, function (data) {
                            $ionicLoading.hide();
                            $scope.isLoadFinish = true;
                            $scope.symptomData.isReview = false;
                            $scope.isLoadingHistory = false;
                        })
                    }
                    else {
                        $ionicLoading.hide();
                        $scope.isLoadFinish = true;
                        $scope.isLoadingHistory = false;
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $scope.isLoadFinish = true;
                    $scope.isLoadingHistory = false;
                })
            }
        }
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（用户须知）正常后退
        if ($scope.step == 0) {
            if ($scope.from.length > 0) {
                // 智能分诊
                if ($scope.from.indexOf('app.triage') > -1) {
                    var strGo = '$state.go("' + $scope.triageData.from + '", { triageId: "' + $scope.triageData.triageId + '", doctorId: "' + $scope.triageData.doctorId + '"});'
                    console.log(strGo);
                    eval(strGo);
                }
                else {
                    eval('$state.go(' + $scope.from + ');');
                }
            }
            else {
                //$scope.toggleSlideMenu();
                $rootScope.goBack();
            }
        }
        // 第3页（按医生预约）/第4页（按条件预约）/第5页（按症状预约）返回第2页（选择预约方式）
        else if ($scope.step == 3 || $scope.step == 4 || $scope.step == 5) {
            $scope.toSlide(2);
            // 离开预约列表 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
        }
        // 第8页（预约信息确认）返回第3、4页
        // 增加特殊规则 如果opInfoId不为空 返回选择就诊人
        else if ($scope.step == 8) {
            // 出诊排班
            if ($scope.from.indexOf('app.scheduling') > -1) {
                $scope.toSlide(1);
            }
            // 专家介绍/搜索
            else if ($scope.from.indexOf('app.doctorInfo') > -1) {
                $scope.toSlide(1);
            }
            // 智能分诊
            else if ($scope.from.indexOf('app.triage') > -1) {
                $scope.toSlide(0);
            }
            // 按医生
            else if ($scope.wishType == '1') {
                $scope.toSlide(3);
            }
            // 按条件
            else if ($scope.wishType == '2') {
                $scope.toSlide(4);
            }
            // 按症状
            else if ($scope.wishType == '3') {
                $scope.toSlide(7);
            }
        }
        // 第9页（预约结果）返回第2页/预约列表页
        else if ($scope.step == 9) {
            // 预约成功 回到预约列表
            if ($scope.apptErrorMsg.length == 0) {
                console.warn("TODO:跳转到预约列表页");
                $state.go('app.apptList', { status: '0', from: 'app.addWish' });
            }
            // 预约失败 回到第2页（选择预约方式）
            else {
                $scope.toSlide(2);
            }
        }
        // 其他页返回上一个滑块
        else {
            // 第2页（选择预约方式） 返回选择就诊人
            if ($scope.step == 2) {
                // 症状
                $scope.symptomData = new Object();
                $scope.symptomData.isReview = false;
                $scope.symptomData.symptoms = [];
                // 复查信息
                $scope.reviewDataRequestId = '';
                $scope.reviewData = [];
                $scope.intoReview = false;
                // 症状查询
                $scope.addSymptomData = {};
                // 分诊结果
                $scope.sysptomResult = {};
                // 医师列表
                $scope.doctorData = {};
                $scope.doctorData.doctorList = [];
                // 医师信息
                $scope.doctorInfo = {};
                $scope.schedulingModal = {};
                // 正在获取历史就诊
                $scope.isLoadingHistory = false;
            }
            slideWishlist.previous();
            $scope.step = slideWishlist.currentIndex();
        }
    }
    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.info($scope.vpList);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }
    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }
    // 2016-11-22 14:15:14 增加填写症状相关方法
    // 填写症状模态窗口显示
    $scope.apptComplaintShow = function () {
        $scope.apptComplaintModal.show();
    }
    // 填写症状模态窗口隐藏
    $scope.apptComplaintHide = function () {
        $scope.apptComplaintModal.hide();
        $scope.apptComplaint = new Object();
        $scope.apptComplaint.data = "";
    }
    // 提交症状信息
    $scope.addApptComplaint = function () {
        $ionicLoading.show();
        AddWishService.addApptComplaint($scope.vpSelect.VISIT_PATIENT_ID, encodeURIComponent($scope.apptComplaint.data)).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                // 隐藏模态窗口 继续原步骤
                $scope.apptComplaintHide();
                $scope.selectVisitPatientOri();
            }
            // 添加失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            $ionicLoading.hide();
        })
    }
    // 选择就诊人之前判断是否需要弹出窗口填写症状
    $scope.selectVisitPatient = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
        // 检查是否需要填写
        $ionicLoading.show();
        AddWishService.checkApptComplaint($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 需要填
            if (data.result == 1) {
                // 弹出模态窗口填写症状 再调用之后的步骤
                $scope.apptComplaint = new Object();
                $scope.apptComplaint.data = data.data;
                $scope.apptComplaintShow();
            }
            // 不需要填
            else if (data.result == 0) {
                // 调用之后的步骤
                $scope.selectVisitPatientOri();
            }
            // 错误
            else {
                $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            }
            $ionicLoading.hide();
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            $ionicLoading.hide();
        })
    }
    // 选择就诊人
    $scope.selectVisitPatientOri = function () {
        // 就诊人id 已在上一步赋值 传入参数index已取消
        //$scope.vpSelect = $scope.vpList[index];
        // 从医师出诊表传了opInfoId过来 直接跳转到预约确认界面
        if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
            // 预约方式为按医生
            $scope.wishType = '1';
            // opInfo赋值 已经在进入页面的时候异步获取opInfo
            $scope.opInfoSelect = $scope.opInfo;
            console.log($scope.opInfoSelect);
            // 跳转到预约确认页面
            $scope.toSlide(8);
        }
        // 继续下一步 选择预约方式等
        else {
            slideWishlist.next();
            $scope.step = slideWishlist.currentIndex();
        }
    }
    // 切换科室
    $scope.changeDivision = function (division) {
        $scope.currentWishByDoctor.division = division;
        $scope.loadOpInfoList();
    }
    // 切换时段
    $scope.changeSchedTime = function (schedTime) {
        $scope.currentWishByDoctor.schedTime = schedTime;
        $scope.loadOpInfoList();
    }
    // 按条件刷新医生列表
    $scope.loadOpInfoList = function (noLoading) {
        if (noLoading == null) {
            $ionicLoading.show();
        }
        $scope.opInfoListEmpty = false;
        AddWishService.scheduling($scope.currentWishByDoctor.division, $scope.currentWishByDoctor.schedDate, $scope.currentWishByDoctor.schedTime).then(function (data) {
            // 查询成功
            $scope.opInfoList = [];
            for (var i = 0; i < data.ds.length; i++) {
                // 若仅看可约 且 APPT_STATUS != 1 跳过
                if ($scope.showAvailable && data.ds[i].APPT_STATUS != "1") { continue; }
                $scope.opInfoList.push(data.ds[i])
            }
            if ($scope.opInfoList.length == 0) {
                $scope.opInfoListEmpty = true;
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListEmpty = true;
            $ionicLoading.hide();
        })
    }
    // 检查预约提示
    $scope.checkApptTips = function (index) {
        if ($scope.apptDoctorTips[$scope.opInfoList[index].DOCTOR_CODE] != undefined) {
            var tipPopup = $ionicPopup.show({
                title: '提示',
                template: $scope.apptDoctorTips[$scope.opInfoList[index].DOCTOR_CODE],
                scope: $scope,
                buttons: [{ text: "我知道了，继续预约", type: "button-calm"}]
            });
            tipPopup.then(function () {
                $scope.selectOpInfo($scope.opInfoList[index].ID);
            })
        } else {
            $scope.selectOpInfo($scope.opInfoList[index].ID);
        }
    }
    // 选择预约信息
    $scope.selectOpInfo = function (id) {
        // 2016-4-27 08:26:18 改为上下午分段
        AddWishService.getPeriod(id).then(function (data) {
            console.log(data);
            // 调用失败
            if (data.result == -1) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 已约满
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom("当前选择的医师已约满");
            }
            // 一个时段 直接赋值下一步
            else if (data.result == 1) {
                $scope.opInfoSelect = data.data[0];
                $scope.toSlide(8);
                $scope.doctorIntroHide();
            }
            // 多个时段 弹出选择
            else if (data.result == 2) {
                // 弹出ActionSheet
                // 遍历生成按钮
                var arrButton = new Array();
                for (var i in data.data) {
                    // 计算时段
                    var str = $scope.getSchedPeriodStr(data.data[i].SCHED_TIME, data.data[i].SCHED_PERIOD_CODE);
                    data.data[i].SCHED_PERIOD_STR = str;

                    // 判断预约状态 加后缀和样式
                    if (data.data[i].APPT_STATUS == "1") {
                        str += " (可预约)";
                        str = '<span>' + str + '</span>';
                    }
                    else {
                        str += " (已约满)";
                        str = '<span class="fw-action-sheet-error">' + str + '</span>';
                    }
                    arrButton.push({ text: str });
                }
                console.log(arrButton);
                var hideSheet = $ionicActionSheet.show({
                    buttons: arrButton,
                    titleText: "选择就诊时段",
                    cancelText: "取消",
                    cancel: function () {
                        hideSheet();
                    },
                    buttonClicked: function (index) {
                        if (data.data[index].APPT_STATUS != "1") {
                            return;
                        }
                        hideSheet();
                        $scope.opInfoSelect = data.data[index];
                        $scope.toSlide(8);
                        $scope.doctorIntroHide();
                    }
                });
            }
        })
    }
    // 选择预约条件
    $scope.selectCondition = function () {
        if ($scope.currentWishByFilter.division == "") {
            $fwCordovaToast.showShortBottom("请选择预约科别");
            return;
        }
        $scope.toSlide(8);
    }
    // 按医生预约提交
    $scope.submitApptByDoctor = function (opInfoId) {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $scope.disableSubmit = true;
        AddWishService.submitAppt($scope.wishType, $scope.vpSelect.VISIT_PATIENT_ID, $scope.opInfoSelect.ID, '', '', '', '').then(function (data) {
            // 预约成功
            if (data.result == 1) {
                $scope.apptSuccessInfo = data.data;
                $scope.apptErrorMsg = '';
            }
            // 预约失败
            else {
                $scope.apptSuccessInfo = new Object();
                $scope.apptErrorMsg = data.msg;
                // 2017-9-13 18:34:57 受限申诉状态 -1=非受限
                if (data.complaintStatus != null && data.complaintStatus != -1) {
                    $scope.complaintStatus = data.complaintStatus;
                    $scope.complaintMsg = data.complaintMsg;
                }
            }
            // TODO:跳转到预约成功页面 此页跳转至预约历史列表页面
            $scope.disableSubmit = false;
            $scope.toSlide(9);
            $scope.verifyNoticeAlert();
        }, function (data) {
            $scope.disableSubmit = false;
        })
    }
    // 按条件预约提交
    $scope.submitApptByFilter = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        console.log($scope.currentWishByFilter.schedTime);
        console.log('---');
        console.log($scope.schedTimeList);
        var date = $scope.schedDateList[$scope.currentWishByFilter.schedDate].code;
        var time = $scope.currentWishByFilter.schedTime == '' ? '' : $scope.schedTimeList[$scope.currentWishByFilter.schedTime].code;
        var divi = $scope.currentWishByFilter.division == '' ? '' : $scope.divisionList[$scope.currentWishByFilter.division].code;
        var level = $scope.currentWishByFilter.doctorLevel == '' ? '' : $scope.doctorLevelList[$scope.currentWishByFilter.doctorLevel].code;

        $scope.disableSubmit = true;
        AddWishService.submitAppt($scope.wishType, $scope.vpSelect.VISIT_PATIENT_ID, '', date, time, divi, level).then(function (data) {
            // 预约成功
            if (data.result == 1) {
                $scope.apptSuccessInfo = data.data;
                $scope.apptErrorMsg = '';
            }
            // 预约失败
            else {
                $scope.apptSuccessInfo = new Object();
                $scope.apptErrorMsg = data.msg;
                // 2017-9-13 18:34:57 受限申诉状态 -1=非受限
                if (data.complaintStatus != null && data.complaintStatus != -1) {
                    $scope.complaintStatus = data.complaintStatus;
                    $scope.complaintMsg = data.complaintMsg;
                }
            }
            // TODO:跳转到预约成功页面 此页跳转至预约历史列表页面
            $scope.disableSubmit = false;
            $scope.toSlide(9);
            $scope.verifyNoticeAlert();
        }, function (data) {
            $scope.disableSubmit = false;
        })
    }
    // 算就诊时段
    $scope.getSchedPeriodStr = function (schedTime, schedPeriodCode) {
        var str = "";
        if (schedTime == "上午" && schedPeriodCode == "A") {
            str = "08:00-09:30";
        }
        if (schedTime == "上午" && schedPeriodCode == "B") {
            str = "09:30-11:00";
        }
        if (schedTime == "下午" && schedPeriodCode == "A") {
            str = "13:00-14:30";
        }
        if (schedTime == "下午" && schedPeriodCode == "B") {
            str = "14:30-16:00";
        }
        return str;
    }

    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 搜索医师
    $scope.searchDoctor = function () {
        $ionicLoading.show();
        $scope.doctorSearch.isSearch = true;
        SchedulingService.getDoctorListByName($scope.doctorSearch.keyword).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.doctorSearch.list = data.data;
                $scope.doctorSearch.isEmpty = $scope.doctorSearch.list.length == 0;
            }
            $ionicLoading.hide();
        })
    }
    // 清空搜索结果
    $scope.clearSearch = function () {
        $scope.doctorSearch.list = new Array();
        $scope.doctorSearch.keyword = "";
        $scope.doctorSearch.isSearch = false;
        $scope.doctorSearch.isEmpty = false;
        console.log($scope.doctorSearch.isSearch);
    }

    // 医师介绍页确认预约
    $scope.apptModal = function (id, color) {
        if (id != "" && (color == "green" || color == "orange")) {
            $scope.selectOpInfo(id);
        }
    }

    // 2017-1-10 13:29:10 增加验证通知相关方法
    // 通知授权帮助模态窗口显示
    $scope.noticeAuthHelpShow = function () {
        $scope.noticeAuthHelpModal.show();
    }
    // 通知授权帮助模态窗口隐藏
    $scope.noticeAuthHelpHide = function () {
        $scope.noticeAuthHelpModal.hide();
        $ionicScrollDelegate.scrollTop();
    }
    // 跳转至个人中心
    $scope.goPersonal = function () {
        $state.go('app.personal');
    }
    // 2017-1-12 17:45:25 跳转到预约成功页面后 检测弹出 关联微信 iOS通知权限
    $scope.verifyNoticeAlert = function () {
        if ($scope.apptErrorMsg.length == 0) {
            // iOS通知权限赋值
            $scope.verifyNoticeInfo.isIOS = currentPlatform == "iOS" ? true : false;
            if ($scope.verifyNoticeInfo.isIOS) {
                $scope.verifyNoticeInfo.noticeAuth = localStorage.noticeAuth == "1" ? true : false;
                console.log("iOS noticeAuth: " + $scope.verifyNoticeInfo.noticeAuth);
            }
            // 拼接弹出的富文本
            var strHtml = "<div><p>请注意，您的：</p>";
            if (!$scope.verifyNoticeInfo.noticeAuth) {
                strHtml += "<p style='display:flex;align-items:center;'><i class='icon ion-ios-cog' style='width:40px;height:40px;padding-right:4px;font-size:40px;text-align:center;color:#89898c;'></i>设备未开启通知权限</p>";
            }
            if (!$scope.accountInfo.isBind) {
                strHtml += "<p style='display:flex;align-items:center;'><i class='icon fwicon-wechat' style='width:40px;height:40px;padding-right:4px;font-size:40px;text-align:center;color:#00c500;'></i>账号未关联微信</p>";
            }
            strHtml += "<p>未开启上述服务可能导致您收不到医师停诊通知，从而给您的就诊带来不便，请及时处理。</p></div>";
            // 没全开 需要弹出提示
            if (!$scope.verifyNoticeInfo.noticeAuth || !$scope.accountInfo.isBind) {
                $ionicPopup.show({
                    title: '预约成功',
                    template: strHtml, // 这是一段富文本
                    buttons: [{
                        text: '确定',
                        type: 'button-positive'
                    }]
                });
            }
        }
    }
    // 2017-4-10 08:38:08 医师头像放大
    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }
    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    $scope.switchShowAvailable = function () {
        $scope.showAvailable = !$scope.showAvailable;
        $scope.loadOpInfoList();
    }

    // 2017-9-13 17:57:22 增加受限用户申诉相关方法
    // 受限用户申诉模态窗口显示
    $scope.blackComplaintShow = function () {
        // 可申诉状态弹出填写窗口
        if ($scope.complaintStatus == 1) {
            $scope.blackComplaintModal.show();
        }
        // 未审核/已驳回 toast提示
        else {
            $fwCordovaToast.showShortBottom($scope.complaintMsg);
        }
    }
    // 受限用户申诉模态窗口隐藏
    $scope.blackComplaintHide = function () {
        $scope.blackComplaintModal.hide();
        $scope.blackComplaint = {};
        $scope.blackComplaint.data = "";
    }
    // 提交黑名单申诉
    $scope.submitBlackComplaint = function () {
        $ionicLoading.show();
        AddWishService.submitBlackComplaint($scope.vpSelect.VISIT_PATIENT_ID, encodeURIComponent($scope.blackComplaint.data)).then(function (data) {
            // 申诉成功
            if (data.result == 1) {
                // 重置申诉状态
                $scope.complaintStatus = data.complaintStatus;
                $scope.complaintMsg = data.complaintMsg;
                // 隐藏模态窗口
                $scope.blackComplaintHide();
            }
            // 申诉失败
            else {
                //$fwCordovaToast.showShortBottom(data.msg);
            }
            $fwCordovaToast.showShortBottom(data.msg);
            $ionicLoading.hide();
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            $ionicLoading.hide();
        })
    }

    // 弹出来院导航
    $scope.amapShow = function () {
        $scope.mapMode = 'map';
        $scope.mapLastMode = $scope.mapMode;
        $scope.startPoint.keyword = "我的位置";
        $scope.startPoint.name = "我的位置";
        $scope.amapModal.show();
        // 初始化地图
        $scope.initMap();
    }

    // 初始化地图
    $scope.initMap = function () {
        if (typeof (AMap) != "undefined") {
            $ionicLoading.show();
        }
        // 初始化地图
        $scope.map = new AMap.Map('aMapContainer', {
            resizeEnable: true,
            zoom: 15,
            center: [$scope.locationFWCenter.lng, $scope.locationFWCenter.lat]
        });
        // 工具栏
        $scope.map.plugin(["AMap.ToolBar"], function () {
            var toolBar = new AMap.ToolBar({
                locate: true// 定位按钮
                //autoPosition: true// 自动定位
            });
            $scope.map.addControl(toolBar);
        });
        // 比例尺
        $scope.map.plugin(["AMap.Scale"], function () {
            var scale = new AMap.Scale();
            $scope.map.addControl(scale);
        });
        // 医院标记点
        var marker = new AMap.Marker({
            icon: "lib/amap/mark_r.png",
            position: [$scope.locationFWCenter.lng, $scope.locationFWCenter.lat]
        });
        marker.setMap($scope.map);
        if (typeof (AMap) != "undefined") {
            $ionicLoading.hide();
        }
    }

    // 切换地图模式
    $scope.changeMapMode = function (mapMode) {
        if ($scope.mapLastMode == mapMode) {
            return;
        }
        $scope.mapMode = mapMode;
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        // 上次和本次都是导航
        if ($scope.mapLastMode != "map" && mapMode != "map") {
            // 清除所有导航结果
            for (var i in $scope.pathPlan) {
                if ($scope.pathPlan[i].clear) {
                    $scope.pathPlan[i].clear();
                }
            }
        }
        // 上次是地图 这次是导航 或 上次是导航 这次是地图
        else {
            // 销毁地图重新初始化 ps:iOS不触发resize事件
            $scope.map.destroy();
            $("#aMapContainer").css("height", mapMode == "map" ? ($scope.mapTotalHeight + "px") : "61.8vw");
            $scope.initMap();
            console.log('地图大小变为：' + $scope.map.getSize().width + "*" + $scope.map.getSize().height);
        }
        $scope.mapLastMode = mapMode;
        if (mapMode != "map") {
            if ($scope.startPoint.name == "我的位置") {
                // 根据定位导航
                $scope.getLocation(mapMode);
            }
            else {
                // 从起点开始导航
                $scope.planPath(mapMode, $scope.startPoint.location);
            }
        }
    }

    // 获取定位信息
    $scope.getLocation = function (mapMode) {
        $ionicLoading.show();
        // 插件定位
        console.log('定位开始');
        $cordovaGeolocation.getCurrentPosition({
            enableHighAccuracy: true,// 高精度
            timeout: 5000,// 超时时间
            maximumAge: 10000// 缓存有效时间
        }).then(function (position) {
            console.log('定位成功');
            console.log('WGS坐标：' + position.coords.longitude + ', ' + position.coords.latitude);
            // 高德坐标转换 WGS -> GCJ
            AMap.convertFrom(new AMap.LngLat(position.coords.longitude, position.coords.latitude), 'gps', function (status, result) {
                if (status == 'complete' && result.info == 'ok') {
                    console.log('坐标转换成功');
                    $scope.locationGCJ.lng = result.locations[0].lng;
                    $scope.locationGCJ.lat = result.locations[0].lat;
                    // 天安门坐标（测试用）
                    //$scope.locationGCJ.lng = $scope.locationTAM.lng;
                    //$scope.locationGCJ.lat = $scope.locationTAM.lat;
                    console.log('GCJ坐标：' + $scope.locationGCJ.lng + ', ' + $scope.locationGCJ.lat);
                    // 赋值给起点位置
                    $scope.startPoint.location.lng = $scope.locationGCJ.lng;
                    $scope.startPoint.location.lat = $scope.locationGCJ.lat;
                    // 规划路径
                    $scope.planPath(mapMode, $scope.startPoint.location);
                    $ionicLoading.hide();
                }
                else {
                    console.log('坐标转换失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('坐标转换失败，请稍后再试');
                    $ionicLoading.hide();
                }
            });
        }, function (error) {
            console.log('定位失败');
            console.log(error);
            $fwCordovaToast.showShortBottom('定位失败，请开启定位权限后再试');
            $ionicLoading.hide();
        });
    }

    // 导航
    $scope.planPath = function (mapMode, locationStart) {
        // 驾车
        if (mapMode == "driving") {
            $scope.planDriving(locationStart, $scope.locationFWParking);
        }
        // 公交
        else if (mapMode == "transfer") {
            $scope.planTransfer(locationStart, $scope.locationFWOutpatient);
        }
        // 骑行
        else if (mapMode == "riding") {
            $scope.planRiding(locationStart, $scope.locationFWOutpatient);
        }
        // 步行
        else if (mapMode == "walking") {
            $scope.planWalking(locationStart, $scope.locationFWOutpatient);
        }
        else {
            console.log('导航方式错误');
        }
    }

    // 驾车导航
    $scope.planDriving = function (start, end) {
        $ionicLoading.show();
        console.log('规划驾车路线开始');
        AMap.plugin(["AMap.Driving"], function () {
            $scope.pathPlan.driving = new AMap.Driving({
                map: $scope.map,
                panel: "aMapPanel_driving"
            });
            //根据起终点坐标规划路线
            $scope.pathPlan.driving.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                if (status == 'complete') {
                    console.log('规划驾车路线成功');
                    //console.log(result);
                    //$scope.map.panBy
                }
                else {
                    console.log('规划驾车路线失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('规划驾车路线失败，请稍后再试');
                }
                $ionicLoading.hide();
            });

        });
    }

    // 公交导航
    $scope.planTransfer = function (start, end) {
        $ionicLoading.show();
        console.log('计算起点所在城市开始');
        AMap.plugin(["AMap.Geocoder"], function () {
            var geocoder = new AMap.Geocoder();
            geocoder.getAddress(new AMap.LngLat(start.lng, start.lat), function (status, result) {
                // TODO:  && result.info === 'OK'
                if (status == 'complete') {
                    console.log('计算起点所在城市成功');
                    console.log('起点为：' + result.regeocode.addressComponent.province + ',' + result.regeocode.addressComponent.city + ',' + result.regeocode.addressComponent.citycode + ',' + result.regeocode.addressComponent.adcode);
                    console.log('规划公交路线开始');
                    AMap.plugin(["AMap.Transfer"], function () {
                        $scope.pathPlan.transfer = new AMap.Transfer({
                            map: $scope.map,
                            panel: "aMapPanel_transfer",
                            city: result.regeocode.addressComponent.citycode,
                            cityd: "010"
                        });
                        //根据起终点坐标规划路线
                        $scope.pathPlan.transfer.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                            if (status == 'complete') {
                                console.log('规划公交路线成功');
                                //console.log(result);
                            }
                            else {
                                console.log('规划公交路线失败');
                                console.log(status);
                                console.log(result);
                                $fwCordovaToast.showShortBottom('规划公交路线失败，请稍后再试');
                            }
                        });

                    });
                }
                else {
                    console.log('计算起点所在城市失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('计算起点所在城市失败，请稍后再试');
                }
                $ionicLoading.hide();
            });
        });
    }

    // 骑行导航
    $scope.planRiding = function (start, end) {
        $ionicLoading.show();
        console.log('规划骑行路线开始');
        AMap.plugin(["AMap.Riding"], function () {
            $scope.pathPlan.riding = new AMap.Riding({
                map: $scope.map,
                panel: "aMapPanel_riding"
            });
            //根据起终点坐标规划路线
            $scope.pathPlan.riding.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                if (status == 'complete') {
                    console.log('规划骑行路线成功');
                    //console.log(result);
                }
                else {
                    console.log('规划骑行路线失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('规划骑行路线失败，请稍后再试');
                }
                $ionicLoading.hide();
            });

        });
    }

    // 步行导航
    $scope.planWalking = function (start, end) {
        $ionicLoading.show();
        console.log('规划步行路线开始');
        AMap.plugin(["AMap.Walking"], function () {
            $scope.pathPlan.walking = new AMap.Walking({
                map: $scope.map,
                panel: "aMapPanel_walking"
            });
            //根据起终点坐标规划路线
            $scope.pathPlan.walking.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                if (status == 'complete') {
                    console.log('规划步行路线成功');
                    //console.log(result);
                }
                else {
                    console.log('规划步行路线失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('规划步行路线失败，请稍后再试');
                }
                $ionicLoading.hide();
            });

        });
    }

    // 隐藏来院导航
    $scope.amapHide = function () {
        $("#aMapContainer").css("height", $scope.mapTotalHeight + "px");
        $scope.amapModal.hide();
        $scope.mapLastMode = 'map';
        $scope.map.destroy();
    }

    // 弹出起点搜索
    $scope.amapSearchShow = function () {
        //$scope.mapSearcData = {};
        $ionicLoading.show();
        $scope.amapSearchModal.show();
        if ($scope.mapSearch._amap_id) {
            console.log("搜索地图已初始化，id: " + $scope.mapSearch._amap_id);
            $scope.searchStart();
        }
        else {
            console.log("搜索地图未初始化");
            $scope.initMapSearch();
        }
    }

    // 初始化起点搜索地图
    $scope.initMapSearch = function () {
        // 初始化地图
        $scope.mapSearch = new AMap.Map('aMapSearchContainer', {
            resizeEnable: true,
            zoom: 10,
            center: [$scope.locationTAM.lng, $scope.locationTAM.lat]
        });
        // 工具栏
        $scope.mapSearch.plugin(["AMap.ToolBar"], function () {
            var toolBar = new AMap.ToolBar({
                locate: true// 定位按钮
                //autoPosition: true// 自动定位
            });
            $scope.mapSearch.addControl(toolBar);
        });
        // 比例尺
        $scope.mapSearch.plugin(["AMap.Scale"], function () {
            var scale = new AMap.Scale();
            $scope.mapSearch.addControl(scale);
        });
        // 省市搜索
        AMap.service('AMap.DistrictSearch', function () {
            //实例化DistrictSearch
            $scope.mapSearch.districtSearch = new AMap.DistrictSearch({
                level: 'country',
                subdistrict: 1,
                showbiz: false
            });
            // 获取全国省份列表
            $scope.mapSearch.districtSearch.search(100000, function (status, result) {
                console.log(status);
                console.log(JSON.stringify(result));
                if (status == "complete" && result.info == "OK") {
                    $scope.mapSearcData.provinceList = result.districtList[0].districtList;
                    //$scope.mapSearcData.cityList = {};
                }
                $ionicLoading.hide();
            })
        })
        // 搜索地点
        $scope.mapSearch.plugin(["AMap.PlaceSearch"], function () {
            $scope.mapSearch.placeSearch = new AMap.PlaceSearch({
                pageSize: 20,
                pageIndex: 1
            });
        });
        // 搜索结果
        $scope.mapSearch.placeSearchRender = new Lib.AMap.PlaceSearchRender();
    }

    // 搜索所属城市
    $scope.searchCity = function () {
        // 清空原城市列表
        $scope.mapSearcData.city = "";
        $scope.mapSearcData.cityList.length = 0;
        // 设置地图中心
        $scope.mapSearch.setCenter($scope.mapSearcData.provinceList[$scope.mapSearcData.province].center)
        // 搜索当前省份所属城市
        $scope.mapSearch.districtSearch.setLevel("province");
        $scope.mapSearch.districtSearch.search($scope.mapSearcData.provinceList[$scope.mapSearcData.province].adcode, function (status, result) {
            console.log(status);
            console.log(JSON.stringify(result.districtList[0].districtList));
            if (status == "complete" && result.info == "OK") {
                $scope.$apply($scope.mapSearcData.cityList = result.districtList[0].districtList);
                //$scope.mapSearcData.cityList = {};
            }
        })
        // 在当前省份搜索
        $scope.searchStart();
    }

    // 选择城市
    $scope.selectCity = function () {
        console.log(JSON.stringify($scope.mapSearcData.cityList[$scope.mapSearcData.city]));
        // 设置地图中心
        $scope.mapSearch.setCenter($scope.mapSearcData.cityList[$scope.mapSearcData.city].center)
        // 在当前城市搜索
        $scope.searchStart();
    }

    // 清空关键词
    $scope.clearKeyword = function () {
        if ($scope.startPoint.keyword == "我的位置") {
            $scope.startPoint.keyword = "";
        }
    }

    // 搜索地点
    $scope.searchStart = function () {
        console.log('搜索地点开始');
        if($scope.startPoint.keyword == "" || $scope.startPoint.keyword.length == 0 || $scope.startPoint.keyword == "我的位置"){
            // 定位位置设置地图中心
            $scope.mapSearch.setCenter(new AMap.LngLat($scope.locationGCJ.lng, $scope.locationGCJ.lat));
            $scope.mapSearch.setZoom(16);
            // 清除搜索结果
            $scope.startPoint.keyword = "我的位置"
            document.getElementById('startName').value = "我的位置";
            document.getElementById('startLng').value = $scope.locationGCJ.lng;
            document.getElementById('startLat').value = $scope.locationGCJ.lat;
            $scope.mapSearch.placeSearch.clear();
            document.getElementById("aMapPanel_search").innerHTML = "";
            $ionicLoading.hide();
            return;
        }
        var adcode = "";
        // 已选城市
        if ($scope.mapSearcData.cityList && $scope.mapSearcData.city && $scope.mapSearcData.cityList[$scope.mapSearcData.city]) {
            adcode = $scope.mapSearcData.cityList[$scope.mapSearcData.city].adcode;
        }
        // 已选省份
        else if ($scope.mapSearcData.provinceList && $scope.mapSearcData.province && $scope.mapSearcData.provinceList[$scope.mapSearcData.province]) {
            adcode = $scope.mapSearcData.provinceList[$scope.mapSearcData.province].adcode;
        }
        // 设置搜索范围
        $scope.mapSearch.placeSearch.setCity(adcode);
        // 搜索地点
        $scope.mapSearch.placeSearch.search($scope.startPoint.keyword, function (status, result) {
            console.log(status);
            console.log(JSON.stringify(result));
            if (status == "complete") {
                if (result.info == "OK") {
                    $scope.mapSearch.placeSearchRender.autoRender({
                        placeSearchInstance: $scope.mapSearch.placeSearch,
                        methodName: "search",
                        methodArgumments: [adcode, $scope.searchStart],
                        data: result,
                        map: $scope.mapSearch,
                        panel: "aMapPanel_search"
                    });
                }
                else if (result.info == "TIP_CITIES") {
                    // 提示选择城市 缩小范围
                    $fwCordovaToast.showShortBottom('搜索范围过大，请选择省份、城市后再试');
                }
            }
            if (status == "no_data") {
                // 无搜索结果
                $fwCordovaToast.showShortBottom('无搜索结果');
            }
            $ionicLoading.hide();
        })
    }

    // 选择起点
    $scope.selectSatart = function () {
        // 从hidden取值赋值给起点
        if (document.getElementById('startName').value != "" && document.getElementById('startName').value.length > 0
        && document.getElementById('startLng').value != "" && document.getElementById('startLng').value.length > 0
        && document.getElementById('startLat').value != "" && document.getElementById('startLat').value.length > 0) {
            $scope.startPoint.name = document.getElementById('startName').value;
            $scope.startPoint.location.lng = document.getElementById('startLng').value;
            $scope.startPoint.location.lat = document.getElementById('startLat').value;
            console.log("起点：" + JSON.stringify($scope.startPoint));
            // 清除所有导航结果
            for (var i in $scope.pathPlan) {
                if ($scope.pathPlan[i].clear) {
                    $scope.pathPlan[i].clear();
                }
            }
            // 规划路径方式
            $scope.planPath($scope.mapMode, $scope.startPoint.location);
        }
        // 我的位置
        else if($scope.startPoint.keyword == "" || $scope.startPoint.keyword.length == 0 || $scope.startPoint.keyword == "我的位置"){
            // 清除所有导航结果
            for (var i in $scope.pathPlan) {
                if ($scope.pathPlan[i].clear) {
                    $scope.pathPlan[i].clear();
                }
            }
            // 规划路径方式
            $scope.planPath($scope.mapMode, $scope.locationGCJ);
        }
        else {
            $fwCordovaToast.showShortBottom('请选择起点');
            return;
        }
        // 隐藏起点搜索
        $scope.amapSearchHide();
    }

    // 隐藏起点搜索
    $scope.amapSearchHide = function () {
        $scope.amapSearchModal.hide();
        if ($scope.startPoint.keyword == "" || $scope.startPoint.keyword.length == 0) {
            $scope.startPoint.keyword = "我的位置"
        }
        // 清除搜索结果
        $scope.mapSearch.placeSearch.clear();
        document.getElementById("aMapPanel_search").innerHTML = "";
        //$scope.mapSearcData = {};
        //$scope.mapSearch.destroy();
    }

    // 填写症状模态窗口显示
    $scope.addSymptomShow = function () {
        if ($scope.symptomData.symptoms.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的症状过多');
            return;
        }
        $scope.addSymptomData.keyword = "";
        $scope.addSymptomData.results = [];
        $scope.addSymptomModal.show();
        // 自动获取焦点
        $timeout(function () {
            document.getElementById("searchSymptom").focus();
        }, 500);
    }
    // 填写症状模态窗口隐藏
    $scope.addSymptomHide = function () {
        $scope.addSymptomModal.hide();
    }
    // 查询症状
    $scope.searchSymptom = function () {
        $scope.addSymptomData.results = [];
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        TriageService.symptomSearch($scope.addSymptomData.keyword, $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.results = data.data;
                $ionicScrollDelegate.scrollTop();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("搜索超时，请稍后再试");
        })
    }
    // 添加症状
    $scope.addSymptom = function (data) {
        if ($scope.symptomData.symptoms.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的症状过多');
            return;
        }
        if ($scope.symptomData.symptoms.indexOf(data) > -1) {
            $fwCordovaToast.showShortBottom('您选择的症状已存在');
            return false;
        }
        $scope.symptomData.symptoms.push(data);
        // 可能伴随症状
        TriageService.rlatSymptom($scope.symptomData.symptoms.join(","), $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.rlats = data.data;
                $scope.addSymptomData.common = data.common;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            ;
        })
        $scope.addSymptomHide();
    }
    // 删除症状
    $scope.deleteSymptom = function (index) {
        $scope.symptomData.symptoms.splice(index, 1);
        // 可能伴随症状
        TriageService.rlatSymptom($scope.symptomData.symptoms.join(","), $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.rlats = data.data;
                $scope.addSymptomData.common = data.common;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            ;
        })
    }
    // 分诊
    $scope.getTriageResult = function () {
        // 症状为空 toast
        if ($scope.symptomData.symptoms.length == 0 && $scope.isLoadingHistory) {
            //$fwCordovaToast.showShortBottom("正在加载历史就诊，请稍候");
            return;
        }
        $scope.sysptomResult = {};
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 计算分诊结果
        TriageService.result($scope.vpSelect.VISIT_PATIENT_ID, $scope.symptomData.symptoms.join(), $scope.symptomData.isReview, $scope.reviewDataRequestId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.sysptomResult = data.data;
                $scope.nextSlide();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络连接异常，请稍后重试");
        })
    }
    // 获取指定科别医师列表
    $scope.getDoctorList = function (speciality, division) {
        console.log(speciality, division);
        $scope.doctorData.doctorList = [];
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 获取指定科别医师列表
        SchedulingService.getDoctorListBySpeciality(speciality).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.doctorData.doctorList = data.data;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 重新计算滚动条高度
            $scope.slideChanged();
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        })
        // 页面调用时触发 从预约挂号退回时略过
        if (division != null && division.length > 0) {
            console.log($scope.sysptomResult.triage_id, division);
            // 分诊科别选择回调
            TriageService.selectDivision($scope.sysptomResult.triage_id, division).then(function (data) {
                ;
            }, function (data) {
                ;
            })
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.nextSlide();
        }
    }

    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }

        $ionicLoading.show();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                if ($scope.from.length > 0) {
                    // 智能分诊
                    if ($scope.from.indexOf('app.triage') > -1) {
                        var strGo = '$state.go("' + $scope.triageData.from + '", { triageId: "' + $scope.triageData.triageId + '", doctorId: "' + $scope.triageData.doctorId + '"});'
                        console.log(strGo);
                        eval(strGo);
                    }
                    else {
                        eval('$state.go(' + $scope.from + ');');
                    }
                }
                else {
                    $state.go('app.home');
                }
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'addWish');
        // 获取用户须知信息
        AddWishService.agreement().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.agreement = data.data;
            }
            // 查询失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: data.msg
                });
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        })
        /*
        // 获取添加预约申请步骤
        AddWishService.addWishSteps().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.titleList = data.data;
                console.log(data.data);
            }
            // 查询失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: data.msg
                });
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        */
        // 获取按条件预约下拉框数据
        // 获取预约日期
        AddWishService.schedDateList().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.schedDateList = data.data;
                $scope.currentWishByDoctor.schedDate = $scope.schedDateList[0].code;
                //$scope.currentWishByFilter.schedDate = $scope.schedDateList[0].code;
                $scope.currentWishByFilter.schedDate = "0";
                if ($scope.schedTimeList.length > 0 && $scope.divisionList.length > 0) {
                    $scope.loadOpInfoList(true);
                }
            }
            // 查询失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: data.msg
                });
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        // 获取预约时段
        AddWishService.schedTimeList().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.schedTimeList = data.data;
                $scope.currentWishByDoctor.schedTime = data.data[0].code;
                if ($scope.schedDateList.length > 0 && $scope.divisionList.length > 0) {
                    $scope.loadOpInfoList(true);
                }
            }
            // 查询失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: data.msg
                });
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        // 获取预约科室
        SchedulingService.divisions().then(function (data) {
            // 查询成功
            $scope.divisionList = data;
            $scope.currentWishByDoctor.division = data[0].code;
            if ($scope.schedDateList.length > 0 && $scope.schedTimeList.length > 0) {
                $scope.loadOpInfoList(true);
            }
        })
        // 获取医师级别
        AddWishService.doctorLevelList().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.doctorLevelList = data.data;
            }
            // 查询失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: data.msg
                });
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        // 预约提示
        AddWishService.apptDoctorTips().then(function (data) {
            if (data.result == 1) {
                $scope.apptDoctorTips = data.data;
                // 开启用户须知倒计时
                $interval(function () { $scope.confirmCountdown -= 1; }, 1000, 10)
            }
        })
        // 根据传过来的opInfoId获取预约信息
        if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
            AddWishService.opInfo($scope.opInfoId).then(function (data) {
                // 查询成功
                if (data.result == 1) {
                    var str = $scope.getSchedPeriodStr(data.data.SCHED_TIME, data.data.SCHED_PERIOD_CODE);
                    data.data.SCHED_PERIOD_STR = str;
                    $scope.opInfo = data.data;
                }
                // 查询失败
                else {
                    console.log(data.msg);
                }
            })
        }

        // 获取就诊人列表
        $scope.loadVpList();

        // 获取账户信息 是否绑定微信 是否关注公众号
        if ('' != localStorage.currentAccountId) {
            // 获取用户信息
            AccountService.accountInfo().then(function (data) {
                if (data.result == 1) {
                    $scope.accountInfo = data.data;
                    // 新api 有绑定微信的状态值
                    if (null != data.isBind) {
                        $scope.accountInfo.isBind = data.isBind;
                        // 已绑定 有关注公众号的状态值
                        if (null != data.isFollow) {
                            $scope.accountInfo.isFollow = data.isFollow;
                            // 已关注 有个人微信信息
                            if (null != data.wxInfo) {
                                $scope.accountInfo.wxInfo = data.wxInfo;
                            }
                        }
                        // 有滚动信息
                        if (null != data.marqueeMsg) {
                            $scope.accountInfo.marqueeMsg = data.marqueeMsg;
                        }
                        // 有iOS允许推送帮助
                        if (null != data.iOSAllowNoticeHelp) {
                            $scope.accountInfo.iOSAllowNoticeHelp = data.iOSAllowNoticeHelp;
                        }
                    }
                }
                console.log($scope.accountInfo);
            })
        }
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'addWish') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
