﻿angular.module('fwapp.controllers')

// 预约管理
.controller('ApptController', function ($scope, $rootScope, $state, $stateParams, $fwCordovaToast, ApptService
    , $ionicModal, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform) {
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    $scope.apptList = new Object();
    $scope.status = $stateParams.status;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 2017-1-13 13:19:48 列表页可以点进去看4条注意事项
    $scope.apptInfo = new Object();

    // 注册模态窗口：预约详情
    $ionicModal.fromTemplateUrl('apptDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.apptDetailModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.apptDetailModal.remove();
    })

    // 预约详情模态窗口显示
    $scope.apptDetailShow = function (index) {
        if ($scope.status == 0 && $scope.apptList[index].STATUS == '1') {
            $scope.apptInfo.index = index;
            $scope.apptDetailModal.show();
        }
    }
    // 预约详情模态窗口隐藏
    $scope.apptDetailHide = function () {
        $scope.apptDetailModal.hide();
        $ionicScrollDelegate.scrollTop();
    }

    //console.log($scope.status);
    $scope.changeStatus = function (status) {
        $scope.status = status;
        $scope.loadApptList();
    }
    // 获取预约列表
    $scope.loadApptList = function () {
        $ionicLoading.show();
        ApptService.apptlist($scope.status).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                //console.log(data.data);
                $scope.apptList = data.data;
                // 2017-1-13 13:19:48 列表页可以点进去看4条注意事项
                $scope.apptInfo.remark = data.remark;
            }
            // 查询失败
            else {
                console.log(data.msg)
            }
            // 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        })
    }
    // 取消预约
    $scope.cancelAppt = function (apptInfoId) {
        var confirmPopup = $ionicPopup.confirm({
            title: '取消预约确认',
            template: "此操作不可逆，您确定要取消当前预约吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                ApptService.cancelAppt(apptInfoId).then(function (data) {
                    // 取消成功
                    if (data.result == 1) {
                        //console.log("取消预约成功" + data.data);
                        $scope.loadApptList();
                        $fwCordovaToast.showShortBottom("取消预约成功");
                    }
                    // 取消失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg)
                    }
                })
            }
        })
    };
    $scope.cancelRefuse = function (apptStatus) {
        switch (apptStatus) {
            case "3":
                $fwCordovaToast.showShortBottom("由于医师停诊，本次预约已自动取消");
                break;
            case "1":
            case "2":
            case "4":
            default:
                $fwCordovaToast.showShortBottom("该日预约挂号已关闭，不可取消");
                break;
        }
    }
    // 返回按钮
    $scope.goBack = function () {
        if ($scope.from == "app.message") {
            $rootScope.goBack();
        }
        else {
            $state.go('app.personal');
        }
    }

    $scope.$on('$ionicView.enter', function () {
        // 读取预约列表
        $scope.loadApptList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                if ($scope.from.length > 0) {
                    $state.go($scope.from);
                }
                else {
                    $state.go('app.personal');
                }
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'apptList');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'apptList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})