﻿angular.module('fwapp.controllers')

// 就医指南
.controller('ArticleWebController', function ($scope, $rootScope, $state, $stateParams, ArticleService, $fwCordovaToast, $cordovaInAppBrowser
    , $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, $ionicLoading) {

    // 定义预约申请滑块
    var slideArticleWeb = $ionicSlideBoxDelegate.$getByHandle('slideArticleWeb');
    // 定义预约申请滚动条
    var scrollArticleWeb = $ionicScrollDelegate.$getByHandle('scrollArticleWeb');
    // 初始滑块状态
    $scope.step = 0;
    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
    // 当前页
    $scope.pageNum = 1;
    // 每页数量
    $scope.pageSize = 20;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕，防止无内容闪现
    $scope.isLoadFinish = false;
    // 页面标题列表
    $scope.titleList = ["", "", ""];
    // 一级栏目Id
    $scope.firstColumnId = ($stateParams.firstColumnId == null || $stateParams.firstColumnId.length == 0) ? "" : $stateParams.firstColumnId;
    // 二级栏目Id
    $scope.secondColumnId = ($stateParams.secondColumnId == null || $stateParams.secondColumnId.length == 0) ? "" : $stateParams.secondColumnId;
    // 文章Id
    $scope.articleId = ($stateParams.articleId == null || $stateParams.articleId.length == 0) ? "" : $stateParams.articleId;
    // 二级文章列表
    $scope.columnList = [];
    // 文章列表
    $scope.articleList = [];
    // 文章内容
    $scope.articleDetail = new Object();
    // 二级栏目标志位
    $scope.columnIndex = 1;
    // 父级栏目Id
    $scope.columnParentId = "";
    // 当前栏目Id
    $scope.columnId = "";
    // 文章类型
    $scope.articleType = ($stateParams.articleType == null || $stateParams.articleType.length == 0) ? "" : $stateParams.articleType;


    // 滑到上一步
    $scope.lastSlide = function () {
        slideArticleWeb.previous();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideArticleWeb.next();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideArticleWeb.slide(index);
    }
    // 滑块切换触发
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideArticleWeb.currentIndex();
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();

        // 回到栏目选择页#0 清空文章列表和内容
        if ($scope.step == 0) {
            $ionicScrollDelegate.scrollTop();
            $scope.pageNum = 1;
            $scope.articleList = [];
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.articleDetail = new Object();
            $scope.isLoadFinish = false;
        }
        // 列表页滚到记录高度
        else if ($scope.step == 1) {
            $scope.isLoadFinish = false;
            scrollArticleWeb.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.articleDetail = new Object();
        }
        // 其他页滚到顶
        else {
            $ionicScrollDelegate.scrollTop();
        }
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（二级栏目列表）或者第1页（文章列表） 从首页直接进文章内容页 正常后退回首页
        if (($scope.step == 0) || ($scope.step == 1 && $scope.firstColumnId == '' && $scope.secondColumnId != '') || ($scope.step == 2 && $scope.firstColumnId == '' && $scope.secondColumnId == '' && $scope.articleId != "")) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他情况返回上一个滑块
        else {
            $scope.lastSlide();
        }
    }

    // 获取二级栏目列表
    $scope.loadIndex = function (id) {
        $ionicLoading.show();

        // 获取栏目列表页
        ArticleService.index(id).then(function (data) {
            if (data.result == 1) {
                // 设置标题
                $scope.titleList[0] = data.title;
                // 将数据存入数组，传至前端
                for (var i = 0; i < data.data.length; i++) {
                    $scope.columnList.push(data.data[i]);
                }

                $scope.isLoadFinish = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
            }
            else if (data.result == 2) {
                // 设置标题
                $scope.titleList[0] = data.title;
                $scope.isLoadFinish = true;
                $scope.columnIndex = 0;
            }
            else {
                $scope.isLoadFinish = true;
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            $ionicLoading.hide();
        }, function (data) {
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            $ionicLoading.hide();
        })
    }

    // 获取文章列表
    $scope.loadList = function (columnId) {
        // 并发标志位
        var sign = 2;
        // 从栏目列表来
        if ('undefined' != typeof (columnId)) {
            $ionicLoading.show();
            // 跳转
            $scope.nextSlide();
            $scope.columnId = columnId;
        }

        if ($scope.columnId == "") {
            $scope.columnId = $scope.secondColumnId;
        }

        // 获取栏目名称，得到标题
        ArticleService.columnName($scope.columnId).then(function (data) {
            if (data.result == 1) {
                $scope.titleList[1] = data.data;
            }
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            sign--;
            if (sign == 0) {
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
            }
        }, function (data) {
            sign--;
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })

        ArticleService.list($scope.columnId, $scope.pageNum, $scope.pageSize).then(function (data) {
            if (data.result == 1) {

                if (data.data.page.length == 0) {
                    $scope.isLoadFinish = true;
                    $scope.articleList = [];
                    $ionicLoading.hide();
                    return;
                }

                // 新获取的列表追加到文章列表后
                for (var i = 0; i < data.data.page.length; i++) {
                    $scope.articleList.push(data.data.page[i]);
                }

                // 计算是否可继续加载
                $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                // 当前页数+1
                $scope.pageNum++;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                //console.log(data);
                //$ionicLoading.hide();
            }
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            }
            sign--;
            if (sign == 0) {
                // 加载完毕
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
            }
        }, function (data) {
            sign--;
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }

    // 获取文章详情
    $scope.loadDetail = function (index) {

        // 2017-8-15 BST 处理外部链接
        if ($scope.articleList[index].ExternalLink != null && $scope.articleList[index].ExternalLink != '') {
            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open($scope.articleList[index].ExternalLink, '_blank', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser($scope.articleList[index].ExternalLink, '_blank');
            return;
        }

        // 记录当前列表页滚动条位置
        $scope.scrollPosition = scrollArticleWeb.getScrollPosition();
        $ionicLoading.show();
        // 标题赋值
        $scope.titleList[2] = $scope.articleList[index].Title;
        // 跳转
        $scope.nextSlide();

        ArticleService.detail($scope.articleList[index].ArticleId).then(function (data) {
            if (data.result == 1) {
                console.log(data);
                $scope.articleDetail = data.data;
                // 重新计算滚动条高度
                $ionicScrollDelegate.resize();
            }
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }

    // 通过首页进入文章列表
    $scope.loadListById = function (id) {
        $ionicLoading.show();
        // 跳转
        $scope.nextSlide();
        var sign = 0;
        if ($scope.firstColumnId != "") {
            sign = 3;
        } else {
            sign = 2;
        }

        // 先公共获取文章列表，再获取上一级栏目列表
        ArticleService.list(id, $scope.pageNum, $scope.pageSize).then(function (data) {

            if (data.result == 1) {
                if (data.data.page.length == 0) {
                    $scope.isLoadFinish = true;
                    $scope.articleList = [];
                    $ionicLoading.hide();
                    return;
                }

                // 新获取的列表追加到文章列表后
                for (var i = 0; i < data.data.page.length; i++) {
                    $scope.articleList.push(data.data.page[i]);
                }

                // 计算是否可继续加载
                $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                // 当前页数+1
                $scope.pageNum++;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
            }
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            sign--;
            if (sign == 0) {
                // 加载完毕
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
            }
        }, function (data) {
            sign--;
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })

        // 获取栏目名称，得到标题
        ArticleService.columnName(id).then(function (data) {
            if (data.result == 1) {
                $scope.titleList[1] = data.data;
            }
            else if (data.result == 2) {
                // 没查到
                $scope.titleList[1] = "";
            }
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            sign--;
            if (sign == 0) {
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
            }
        }, function (data) {
            sign--;
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })

        // 如果第一个参数不为空
        if ($scope.firstColumnId != "") {
            ArticleService.index($scope.firstColumnId).then(function (data) {
                if (data.result == 1) {
                    // 标题复制
                    $scope.titleList[0] = data.title;
                    for (var i = 0; i < data.data.length; i++) {
                        $scope.columnList.push(data.data[i]);
                    }

                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                else if (data.result == 2) {
                    // 标题复制
                    $scope.titleList[0] = data.title;
                    $scope.columnIndex = 0;
                }
                else {
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
                }

                sign--;
                if (sign == 0) {
                    $scope.isLoadFinish = true;
                    $ionicLoading.hide();
                }
            }, function (data) {
                sign--;
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            })
        }
    }

    // 通过首页进入文章详情
    $scope.loadDetailById = function (id) {
        $ionicLoading.show();
        // 跳转
        $scope.toSlide(2);
        // 并发标志位
        var sign = 1;
        if ($scope.firstColumnId != "") {
            sign++;
        }
        if ($scope.secondColumnId != "") {
            sign += 2;
        }

        // 获取文章详情
        ArticleService.detail(id, $scope.articleType).then(function (data) {
            if (data.result == 1) {
                // 2017-8-15 BST 处理外部链接
                if (data.data.ExternalLink != null && data.data.ExternalLink != '') {
                    //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                    //$cordovaInAppBrowser.open(data.data.ExternalLink, '_blank', option).then(function (event) { });
                    //2023.7.31 新插件原有调用方式参数不生效
                    showInAppBrowser(data.data.ExternalLink, '_blank');
                    return;
                }

                // 设置标题
                $scope.titleList[2] = data.data.Title;

                $scope.articleDetail = data.data;
            }
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            sign--;
            if (sign == 0) {
                $ionicLoading.hide();
            }
        }, function (data) {
            sign--;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })

        if ($scope.secondColumnId != "") {
            ArticleService.list($scope.secondColumnId, $scope.pageNum, $scope.pageSize).then(function (data) {
                if (data.result == 1) {
                    if (data.data.page.length == 0) {
                        $scope.isLoadFinish = true;
                        $scope.articleList = [];
                        $ionicLoading.hide();
                        return;
                    }

                    // 新获取的列表追加到文章列表后
                    for (var i = 0; i < data.data.page.length; i++) {
                        $scope.articleList.push(data.data.page[i]);
                    }

                    // 计算是否可继续加载
                    $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                    // 当前页数+1
                    $scope.pageNum++;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                else {
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                }
                sign--;
                if (sign == 0) {
                    // 加载完毕
                    $scope.isLoadFinish = true;
                    $ionicLoading.hide();
                }
            }, function (data) {
                sign--;
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            })

            // 获取栏目名称，得到标题
            ArticleService.columnName($scope.secondColumnId).then(function (data) {
                if (data.result == 1) {
                    $scope.titleList[1] = data.data;
                }
                else {
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                }
                sign--;
                if (sign == 0) {
                    $ionicLoading.hide();
                }
            }, function (data) {
                sign--;
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            })
        }

        // 如果第一个参数不为空
        if ($scope.firstColumnId != "") {
            ArticleService.index($scope.firstColumnId).then(function (data) {
                if (data.result == 1) {
                    // 标题复制
                    $scope.titleList[0] = data.title;
                    for (var i = 0; i < data.data.length; i++) {
                        $scope.columnList.push(data.data[i]);
                    }

                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                else if (data.result == 2) {
                    // 标题复制
                    $scope.titleList[0] = data.title;
                    $scope.columnIndex = 0;
                }
                else {
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
                }
                sign--;
                if (sign == 0) {
                    $scope.isLoadFinish = true;
                    $ionicLoading.hide();
                }
            }, function (data) {
                sign--;
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            })
        }
    }


    // 是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore && $scope.step == 1;
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideArticleWeb.enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'articleWeb');
        //console.log($scope.newsId);

        // 从首页进入文章详情
        if ($scope.articleId != '') {
            //跳转至文章详情
            $scope.loadDetailById($scope.articleId);
            console.log("1");

        }
        // 从首页进入文章列表
        else if ($scope.secondColumnId != '' && $scope.articleId == '') {
            // 跳转至文章列表
            $scope.loadListById($scope.secondColumnId);
            console.log("2");
        }
        // 从首页进入二级栏目列表
        else if ($scope.firstColumnId != '' && $scope.secondColumnId == '' && $scope.articleId == '') {
            // 直接跳二级目录
            $scope.loadIndex($scope.firstColumnId);
            console.log("3");
        }
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'articleWeb') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
})