angular.module('fwapp.controllers')

.controller('AutoInquiryController', function ($scope, $rootScope, $state, $stateParams, $timeout, $filter,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicPlatform, $ionicSlideBoxDelegate,
    $ionicActionSheet, $cordovaDatePicker, $cordovaInAppBrowser,
    AutoInquiryService, VisitPatientService, OpApptService, DoctorInfoService, AddWishService, TriageService, RequestService,
    $fwCordovaToast, $ionicScrollDelegate) {
    // 就诊人ID
    $scope.vpId = "";
    // 就诊人列表
    $scope.vpList = [];
    // 选中就诊人信息
    $scope.vpInfo = new Object();

    // 标注上个页面 triage opAppt
    $scope.firstFrom = "";
    // 来源入口
    $scope.typeEntrance = 0;
    // 从智能分诊或预约挂号页面进入 -> 0新问诊; 从分诊预约界面退回-> 1 ->展示对话记录
    $scope.continueInquiry = "";

    //一次对话
    $scope.dialogueNew = {};
    //对话列表
    $scope.dialogueList = [];
    // 对话ID
    $scope.dialogueId = "";
    // 页面高度
    $scope.size = {};
    $scope.size.isKeyboardShow = false;
    $scope.size.wrapPaddingTop = 44;
    $scope.size.wrapPaddingBottom = 0;
    $scope.set_paddingBottom = 0; //记录当前页面高度

    //记录含有推荐科室的建议
    var str_advices = "";
    //显示推荐分诊标志 0不显示  1显示
    $scope.cur_triage = 0;
    //推荐分诊代码
    $scope.str_triage = "";
    //需要显示推荐分诊的content
    $scope.advices_triage = "";

    //设置问题隐藏
    $scope.qstn_hide = 0;
    // 是否正在获取
    $scope.isLoading = false;

    //前端传给后端的数据格式
    $scope.requestData = {
        "patientId": "",
        "sessionId": "",
        "step": 0,
        "questions": [
            {
                "id": "",
                "type": "",
                "options": []
            }
        ]
    };
    //后端传给前端的数据格式
    $scope.receiveData = {
        "status": "",
        "message": "",
        "data": {
            "patientId": "",
            "sessionId": "",
            "step": 1,
            "jump": 0,
            "advices": { "order": "", "content": [] },
            "results": {
                "departments": [],
                "docs": [],
                "complain": "",
                "info": {
                    "history": "",
                    "other": ""
                },
                "his_info":{}
            },
            "table": [
                {
                    "name": ""
                }
            ],
            "questions": [
                {
                    "id": "",
                    "type": "",
                    "content": "",
                    "instruction": "",
                    "options": []
                }
            ]
        }
    };
    //文章标题
    $scope.article_header = "";
    //文章内容
    $scope.article_content = "";

    // 输入框对象
    $scope.answer = {};
    // 输入框的文本
    $scope.answer.text = "";
    // 输入框的单位
    $scope.answer.unit = "";

    // 推荐科室
    $scope.departmentAdvice = false;
    $scope.departmentAdviceData = {};

    // 日志埋点，传入参数
    $scope.logParam = [];

    // 开启新问诊
    $scope.newInquiryDisable = false;

    // #region 模态框相关

    // 注册模态窗口：医师介绍
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('doctorIntro.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 注册模态窗口：选择医生
    $ionicModal.fromTemplateUrl('doctorList.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorListModal = modal;
    });

    // 注册模态窗口：文章
    $ionicModal.fromTemplateUrl('article.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.articleModal = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 注册模态窗口：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注册模态窗口：预问诊病历
    $ionicModal.fromTemplateUrl('autoRecord.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.autoRecordModel = modal;
    });

    // 文章模态窗口显示
    $scope.articleModalShow = function () {
        $scope.articleModal.show();
    }

    // 文章模态窗口隐藏
    $scope.articleModalHide = function () {
        $scope.articleModal.hide();
    }

    // 选择医生列表模态窗口显示
    $scope.doctorListModalShow = function () {
        $scope.doctorListModal.show();
    }

    // 选择医生模态窗口隐藏
    $scope.doctorListModalHide = function () {
        $scope.doctorListModal.hide();
    }

    // 医师介绍显示
    $scope.doctorIntroShow = function () {
        $scope.doctorIntroModal.show();
    }

    // 医师介绍隐藏
    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
    }

    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    // 预问诊病历展示
    $scope.autoRecordShow = function (){
        $scope.autoRecordModel.show();
    }

    // 预问诊病历隐藏
    $scope.autoRecordHide = function (){
        $scope.autoRecordModel.hide();
    }

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.doctorIntroModal.remove();
        $scope.articleModal.remove();
        $scope.doctorListModal.remove();
        $scope.showAvatarModal.remove();
        $scope.popVplist.remove();
        $scope.autoRecordModel.remove();
    })

    // #endregion

    // 单选
    $scope.curData = {};
    // 当前回答 单选 其他
    $scope.curData.other = "";
    // 当前回答 单选
    $scope.cur_data = "";
    // 设置单选
    $scope.set_cur_data = function (id) {
        $scope.cur_data = id;

        $scope.requestData.questions[0].options = [];
        // 循环找出单选结果
        for(var i = 0; i < $scope.receiveData.data.questions[0].options.length; i++){
            // 找到当前这到题
            if($scope.receiveData.data.questions[0].options[i].id == $scope.cur_data){
                var option = {};
                option.id = $scope.cur_data;
                option.type = $scope.receiveData.data.questions[0].options[i].type;
                // 如果是其他
                if($scope.receiveData.data.questions[0].options[i].type == 2){
                    option.text = $scope.curData.other;
                }
                else{
                    option.text = $scope.receiveData.data.questions[0].options[i].text;
                }

                $scope.requestData.questions[0].options.push(option);
            }
        }

        var logThree = $scope.logParam.filter(e => e.type == 3);
        if($scope.receiveData.data.step == 1 && logThree.length == 0){
            // 日志埋点，3，第一次选项或光标激活
            var log = {};
            log.type = 3;
            log.time = new Date().getTime();
            $scope.logParam.push(log);
        }
    }

    // 多选
    $scope.curDatas = {};
    // 当前回答 多选 其他
    $scope.curDatas.other = "";
    // 当前回答 多选 分组互斥
    $scope.cur_datas = "";
    // 设置多选
    $scope.set_cur_datas = function (id) {
        console.log($scope.receiveData.data.questions[0].options);
        // 循环找出多选结果
        for(var i = 0; i < $scope.receiveData.data.questions[0].options.length; i++){
            // 找到当前这到题
            if($scope.receiveData.data.questions[0].options[i].id == id){
                // 需要判断互斥。。。
                if($scope.requestData.questions[0].options.length > 0){
                    // 如果是互斥的
                    if($scope.receiveData.data.questions[0].options[i].option_classify != $scope.cur_datas && $scope.cur_datas != ""){
                        $fwCordovaToast.showShortBottom("当前选项与已选项冲突，不能选择。");
                        return;
                    }
                }

                var option = {};
                option.id = id;
                option.type = $scope.receiveData.data.questions[0].options[i].type;
                // 如果是其他
                if($scope.receiveData.data.questions[0].options[i].type == "2"){
                    option.text = $scope.curDatas.other;
                }
                else{
                    option.text = $scope.receiveData.data.questions[0].options[i].text;
                }

                // 判断是否包含
                if(!$scope.cur_datas_search(id)){
                    $scope.requestData.questions[0].options.push(option);
                    $scope.cur_datas = $scope.receiveData.data.questions[0].options[i].option_classify;
                }
                else{
                    // 删除数组
                    for(var j = 0; j < $scope.requestData.questions[0].options.length; j++){
                        if($scope.requestData.questions[0].options[j].id == option.id){
                            $scope.requestData.questions[0].options.splice(j, 1);
                        }
                    }
                    // 如果数组为空，将分组清空
                    if($scope.requestData.questions[0].options.length == 0){
                        $scope.cur_datas = "";
                    }
                }
            }
        }
    }

    //设置多选-其他
    $scope.set_other_choose = function () {
        for(var i = 0; i < $scope.receiveData.data.questions[0].options.length; i++){
            if($scope.receiveData.data.questions[0].options[i].type == "2"){
                if(!$scope.cur_datas_search($scope.receiveData.data.questions[0].options[i].id)){
                    $scope.set_cur_datas($scope.receiveData.data.questions[0].options[i].id);
                }
            }
        }
    }

    // (新)多选判断
    $scope.cur_datas_search = function (id) {
        var has_hint = false;
        for (var i = 0; i < $scope.requestData.questions[0].options.length; i++) {
            if ($scope.requestData.questions[0].options[i].id == id) {
                has_hint = true;
            }
        }
        return has_hint;
    }

    // 2022-1-7 08:44:47 HM #49707 智能分诊文章增加跳转外链，isExternalLink是否为外链，url为外链地址
    //智能分诊推荐
    $scope.reserve = function (vpId, name, id, type, groupItem, isExternalLink, url) {
        // 这里加个ajax，记录一下点击的次数
        AutoInquiryService.clickAdvicesDetail($scope.vpId, $scope.dialogueId, id, name).then(function (result) { });
        console.log(type);
        if (type == "function") {
            // 需要特殊处理，op_sched
            if (id == "op_sched") {
                console.log(groupItem);

                // 病种
                $scope.group = {};
                $scope.group.name = name;
                for (var i = 0; i < groupItem.length; i++) {
                    if (groupItem[i].key == "group_type") {
                        $scope.group.type = groupItem[i].value;
                    }
                    if (groupItem[i].key == "group_code") {
                        $scope.group.code = groupItem[i].value;
                    }
                }

                $scope.group.childList = [];
                $scope.group.doctorListIsLoadFinish = false;

                // 首先要走一个ajax，根据id取查是否有内科治疗和外科手术
                $ionicLoading.show();
                AutoInquiryService.getGroupDetail($scope.group.type, $scope.group.code).then(function (data) {
                    if (data.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    else {
                        if (data.is_null == 0) {
                            $scope.group.code = data.data[0].GROUP_CODE;// 默认选中第一个
                            $scope.group.childList = data.data;
                        }

                        // 查询医师
                        $scope.doctorList();
                        // 展示模态框
                        $scope.doctorListModalShow();
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
                })
            }
            else if (id == "opAppt") {
                // 如果是新问诊，并且会话没有结束m
                if ($scope.continueInquiry == 0 && $scope.receiveData.status != '2') {
                    // 向服务器请求，终止会话
                    $scope.requestData.patientId = $scope.receiveData.data.patientId;
                    $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                    $scope.requestData.step = -1;
                    $scope.requestData.questions[0].type = type + ":" + name;
                    if ($scope.receiveData.status == "1") {
                        $scope.requestData.questions[0].id = "status1";
                    } else {
                        $scope.requestData.questions[0].id = "status2";
                    }

                    AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
                }

                $state.go("app." + id);
            }
            else {
                // 如果是新问诊，并且会话没有结束m
                if ($scope.continueInquiry == 0 && $scope.receiveData.status != '2') {
                    // 向服务器请求，终止会话
                    $scope.requestData.patientId = $scope.receiveData.data.patientId;
                    $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                    $scope.requestData.step = -1;
                    $scope.requestData.questions[0].type = type + ":" + name;
                    if ($scope.receiveData.status == "1") {
                        $scope.requestData.questions[0].id = "status1";
                    } else {
                        $scope.requestData.questions[0].id = "status2";
                    }

                    AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
                }

                $state.go("app." + id, { from: "autoInquiry", vpid: vpId, autoFirstFrom: $scope.firstFrom });
            }
        }
        else if (type == "article") {
            if (isExternalLink == 'true' || isExternalLink == true) {
                //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                //$cordovaInAppBrowser.open(url, '_system', option).then(function (event) { });
                //2023.7.31 新插件原有调用方式参数不生效
                showInAppBrowser(url, '_system');
            }
            else {
                //读取数据库中的文章内容
                $ionicLoading.show();
                AutoInquiryService.getArticleContent(id, groupItem).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    else {
                        //调用article模态框
                        $scope.article_header = data.data.article.title;
                        $scope.article_content = data.data.article.content;
                        $scope.articleModalShow();
                    }
                }, function () {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
                })
            }
        }
        // 这个又做了
        else if (type == "doctor") {
            $ionicLoading.show();
            AutoInquiryService.doctorInfo(id).then(function (data) {
                $ionicLoading.hide();
                if (data.reuslt == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else {
                    $scope.group = {};
                    $scope.group.name = data.data.doctorName;
                    $scope.group.type = "doctor";

                    $scope.doctorIntro(data.data.doctorId, data.data.doctorLevel, data.data.doctorCode, data.data.doctorName, data.data.doctorPath, data.data.doctorSpeciality);
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
            })
        }
        // 大数据组说，这个也先不做了，放后边
        else if (type == "department") {
            // 如果是新问诊，并且会话没有结束m
            if ($scope.continueInquiry == 0 && $scope.receiveData.status != '2') {
                // 向服务器请求，终止会话
                $scope.requestData.patientId = $scope.receiveData.data.patientId;
                $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                $scope.requestData.step = -1;
                $scope.requestData.questions[0].type = type + ":" + name;
                if ($scope.receiveData.status == "1") {
                    $scope.requestData.questions[0].id = "status1";
                } else {
                    $scope.requestData.questions[0].id = "status2";
                }

                AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
            }

            $state.go("app.triage", { vpId: vpId, speciality: id, firstFrom: $scope.firstFrom });
        }
    }
    inquiryReserve = function (vpId, departmentName, departmentId) {
        triageReserve(vpId, departmentName, departmentId);
    }
    //分诊预约跳转实现方法
    function triageReserve(vpId, departmentName, departmentId) {
        if ($scope.continueInquiry == 0) {
            //中止此次问诊对话
            try {
                $scope.requestData.patientId = $scope.receiveData.data.patientId;
                $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                $scope.requestData.step = -1;
                $scope.requestData.questions[0].type = departmentName;
                if ($scope.receiveData.status == "1") {
                    $scope.requestData.questions[0].id = "status1";
                } else {
                    $scope.requestData.questions[0].id = "status2";
                }
                AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
            } catch (ex) { }
        }
        //调用接口,实现预约跳转
        //$state.go("app.triage", { vpId: vpId, speciality: departmentId });
        $state.go("app.triage", { vpId: vpId, speciality: departmentId, firstFrom: $scope.firstFrom });
    }

    $scope.advices_triage_search = function (content) {
        //实现将分诊信息添加到对应content下
        var array = $scope.advices_triage.split("|");
        var has_hint = false;
        for (var i in array) {
            if (array[i] == content) {
                has_hint = true;
            }
        }
        return has_hint;
    }

    //设置问题内容收起
    $scope.set_qstn_hide = function (event) {
        if ($scope.qstn_hide == 0) {
            $scope.qstn_hide = 1;
            $scope.size.wrapPaddingBottom = 0;
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollBottom(true);
        } else {
            $scope.qstn_hide = 0;
            $scope.size.wrapPaddingBottom = $scope.set_paddingBottom;
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollBottom(true);
        }
    }

    //请求第一次会话
    getFirstInquiryData = function (vpId, dialogueId, requestData) {
        $scope.requestData.patientId = vpId;
        requestData = JSON.stringify(requestData);
        var requestDataStr = encodeURIComponent(requestData);
        requestDataStr = requestDataStr.replace(/%/g, '！');
        AutoInquiryService.getInquiryData(vpId, dialogueId, requestDataStr, $scope.typeEntrance).then(function (result) {
            if (result.result == 1) {
                $scope.dialogueId = result.dialogueId;
                //将请求到的问诊数据赋值
                $scope.receiveData = JSON.parse(result.data);

                // 判断是否有建议，有建议需要处理建议，再添加问题
                if ($scope.receiveData.data.advices_new.length != 0) {
                    // 获取在问题前的建议数组
                    var advicesFront = $scope.receiveData.data.advices_new.filter(item => item.order == 1);
                    var advicesAfter = $scope.receiveData.data.advices_new.filter(item => item.order == 2);

                    // 将两个数组排序
                    advicesFront = advicesFront.sort(function (x, y){
                        return x.seq - y.seq;
                    });
                    advicesAfter = advicesAfter.sort(function (x, y){
                        return x.seq - y.seq;
                    });

                    // 先添加在问题前的
                    for(var i = 0; i < advicesFront.length; i++){
                        newDialogue("doctor", advicesFront[i], "advices");
                    }
                    // 添加问题
                    for(var i = 0; i < $scope.receiveData.data.questions.length; i++){
                        newDialogue("doctor", $scope.receiveData.data.questions[i], "questions");
                    }
                    // 再添加问题后的
                    for(var i = 0; i < advicesAfter.length; i++){
                        newDialogue("doctor", advicesAfter[i], "advices");
                    }
                }
                // 没有建议，直接添加问题
                else { 
                    // 添加问题
                    for(var i = 0; i < $scope.receiveData.data.questions.length; i++){
                        newDialogue("doctor", $scope.receiveData.data.questions[i], "questions");
                    }
                }

                // 日志埋点，2，第一次请求响应
                var log = {};
                log.type = 2;
                log.time = new Date().getTime();
                $scope.logParam.push(log);

                // 开启新会话按钮状态
                $scope.newInquiryDisable = true;
            } 
            else {
                $fwCordovaToast.showShortBottom(result.msg);
            }

            fnKeyboardhide();
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
        });
    }

    // 1.提交准备
    $scope.cur_result = "";
    $scope.beforeSubmit = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $scope.cur_result = "";
        //将回答结果赋值给$scope.requestData
        $scope.requestData.patientId = $scope.vpId;
        $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
        $scope.requestData.step = $scope.receiveData.data.step;
        $scope.requestData.questions[0].id = $scope.receiveData.data.questions[0].id;
        $scope.requestData.questions[0].type = $scope.receiveData.data.questions[0].type;

        if($scope.receiveData.data.step == 1){
            // 日志埋点，4，第一次提交
            var log = {};
            log.type = 4;
            log.time = new Date().getTime();
            $scope.logParam.push(log);
        }

        // option已经再各个环境设置好了，除了自由输入和时间选择
        //单选
        if ($scope.receiveData.data.questions[0].type == '1') {
            if($scope.requestData.questions[0].options.length == 0){
                $fwCordovaToast.showShortBottom("您还未选择任一选项");
                return;
            }

            // 如果是其他，要走个正则
            if($scope.requestData.questions[0].options[0].type == 2){
                if($scope.curData.other == ""){
                    $fwCordovaToast.showShortBottom("请填写其他内容");
                    return;
                }
                
                $scope.requestData.questions[0].options[0].text = $scope.curData.other;
                // 正则
                var regexModel = null;
                for(var i = 0; i < $scope.receiveData.data.questions[0].options.length; i++){
                    if ($scope.receiveData.data.questions[0].options[i].type == "2"){
                        regexModel = $scope.receiveData.data.questions[0].options[i];
                    }
                }
                if(regexModel == null){
                    $fwCordovaToast.showShortBottom("单选选择失败，网络异常，请稍后再试");
                    return;
                }

                var regex = regexModel.regex;
                if(regex != ""){
                    regex = new RegExp(regex);
                    if(!regex.exec($scope.requestData.questions[0].options[0].text)){
                        $fwCordovaToast.showShortBottom("输入不合法，请检查后再次输入");
                        return;
                    }
                }
            }

            $scope.cur_result = $scope.requestData.questions[0].options[0].text;
        }
        //多选
        else if ($scope.receiveData.data.questions[0].type == '2') {
            if($scope.requestData.questions[0].options.length == 0){
                $fwCordovaToast.showShortBottom("您还未选择任一选项");
                return;
            }

            console.log($scope.requestData.questions[0].options);
            for(var i = 0; i < $scope.requestData.questions[0].options.length; i++){
                if($scope.requestData.questions[0].options[i].type == 2){
                    if($scope.curDatas.other == ""){
                        $fwCordovaToast.showShortBottom("请填写其他内容");
                        return;
                    }

                    $scope.requestData.questions[0].options[i].text = $scope.curDatas.other;
                    // 正则
                    var regex = $scope.receiveData.data.questions[0].options[i].regex;
                    if(regex != ""){
                        regex = new RegExp(regex);
                        if(!regex.exec($scope.requestData.questions[0].options[i].text)){
                            $fwCordovaToast.showShortBottom("输入不合法，请检查后再次输入");
                            $scope.cur_result = "";
                            return;
                        }
                    }
                }
                console.log($scope.requestData.questions[0].options[i].text);
                $scope.cur_result = $scope.cur_result + $scope.requestData.questions[0].options[i].text + "，";
            }

            $scope.cur_result = $scope.cur_result.substr(0, $scope.cur_result.length - 1);
        }
        //输入框
        else if ($scope.receiveData.data.questions[0].type == '3') {
            console.log($scope.answer.text);
            if($scope.answer.text.length == 0){
                $fwCordovaToast.showShortBottom("您还未输入回答");
                return;
            }
            else{
                // 各种验证（本来这块，我是很想留给api的，但是现在这个解构不允许我这么做，要么工作量等同于重写TVT）
                // 如果有单位
                if($scope.receiveData.data.questions[0].options[0].unit.length > 0){
                    if($scope.answer.unit == ""){
                        $fwCordovaToast.showShortBottom("您还未选择任一选项单元");
                        return;
                    }
                }

                // 正则
                console.log($scope.receiveData);
                var regex = $scope.receiveData.data.questions[0].options[0].regex;
                if(regex != ""){
                    regex = new RegExp(regex);
                    if(!regex.exec($scope.answer.text)){
                        $fwCordovaToast.showShortBottom("输入不合法，请检查后再次输入");
                        return;
                    }
                }

                // 数字范围
                if($scope.receiveData.data.questions[0].options[0].number_range.length > 0){
                    if($scope.receiveData.data.questions[0].options[0].number_range[0] != -1 && $scope.receiveData.data.questions[0].options[0].number_range[0] > $scope.answer.text){
                        $fwCordovaToast.showShortBottom("数值应大于" + $scope.receiveData.data.questions[0].options[0].number_range[0]);
                        return;
                    }
                    if($scope.receiveData.data.questions[0].options[0].number_range[1] != -1 && $scope.receiveData.data.questions[0].options[0].number_range[1] < $scope.answer.text){
                        $fwCordovaToast.showShortBottom("数值应小于" + $scope.receiveData.data.questions[0].options[0].number_range[1]);
                        return;
                    }
                }

                // 输入长度
                if($scope.receiveData.data.questions[0].options[0].input_length.length > 0){
                    if($scope.receiveData.data.questions[0].options[0].input_length[0] != -1 && $scope.receiveData.data.questions[0].options[0].input_length[0] > $scope.answer.text.length){
                        $fwCordovaToast.showShortBottom("输入字数应大于" + $scope.receiveData.data.questions[0].options[0].input_length[0]);
                        return;
                    }

                    if($scope.receiveData.data.questions[0].options[0].input_length[1] != -1 && $scope.receiveData.data.questions[0].options[0].input_length[1] < $scope.answer.text.length){
                        $fwCordovaToast.showShortBottom("输入字数应小于" + $scope.receiveData.data.questions[0].options[0].input_length[1]);
                        return;
                    }
                }

                // 正常，添加option
                var option = {};
                option.id = $scope.receiveData.data.questions[0].id;
                option.type = $scope.receiveData.data.questions[0].type;
                option.text = $scope.answer.text;

                // 如果有单位
                if($scope.answer.unit != ""){
                    option.text = option.text + $scope.answer.unit;
                }

                console.log($scope.requestData);
                $scope.requestData.questions[0].options.push(option);

                $scope.cur_result = option.text;
            }
        }
        //时间选择
        else if ($scope.receiveData.data.questions[0].type == '4') {
            if($scope.answer.text == ""){
                $fwCordovaToast.showShortBottom("您还未选择时间");
                return;
            }
            else{
                if($scope.receiveData.data.questions[0].options[0].date_range.length > 0){
                    // 当前选择的时间
                    var date = new Date(Date.parse($scope.answer.text.replace(/-/g, "/")));
                    if($scope.receiveData.data.questions[0].options[0].date_range[0] != -1){
                        var targetDate = new Date(Date.parse($scope.receiveData.data.questions[0].options[0].date_range[0].replace(/-/g, "/")));
                        if(targetDate.getTime() > date.getTime()){
                            $fwCordovaToast.showShortBottom("时间应大于" + $scope.receiveData.data.questions[0].options[0].date_range[0]);
                            return;
                        }
                    }

                    if($scope.receiveData.data.questions[0].options[0].date_range[1] != -1){
                        var targetDate = new Date(Date.parse($scope.receiveData.data.questions[0].options[0].date_range[1].replace(/-/g, "/")));
                        if(targetDate.getTime() < date.getTime()){
                            $fwCordovaToast.showShortBottom("时间应小于" + $scope.receiveData.data.questions[0].options[0].date_range[1]);
                            return;
                        }
                    }
                }
                $scope.cur_result = $scope.answer.text;
            }
        }
        //出错
        else {
            $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
            return;
        }
        submit();
    }

    // 2.提交
    submit = function () {
        saveDataBase(); // 存库并请求下一次对话
    }

    // 3.存库并请求下一次对话 
    saveDataBase = function () {
        $scope.isLoading = true;
        //请求新的数据
        AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) {
            $scope.isLoading = false;
            // 清除患者本次回答
            // 单选
            $scope.cur_data = "";
            $scope.curData.other = "";
            // 多选
            $scope.cur_datas = "";
            $scope.curDatas.other = "";
            // 文本
            $scope.answer.text = "";
            $scope.answer.unit = "";

            // 输入框初始高度
            $("#textarea").css("height", "35px");
            // 患者对话
            newDialogue("patient", $scope.cur_result, "");

            if (result.result == 1) {
                $scope.dialogueId = result.dialogueId;
                //将请求到的问诊数据赋值
                $scope.receiveData = JSON.parse(result.data);
                // 判断是否有建议，有建议需要处理建议，再添加问题
                if ($scope.receiveData.data.advices_new.length != 0) {
                    // 如果会话结束了，添加系统消息，为预问诊病历
                    if($scope.receiveData.status == "2" && $scope.typeEntrance != "3"){
                        if($scope.receiveData.data.results.his_info != null && JSON.stringify($scope.receiveData.data.results.his_info) != "{}"){
                            newDialogue("system", "系统已根据您的病情生成预问诊病历，点击查看", "his_info");
                        }
                    }

                    // 获取在问题前的建议数组
                    var advicesFront = $scope.receiveData.data.advices_new.filter(item => item.order == 1);
                    var advicesAfter = $scope.receiveData.data.advices_new.filter(item => item.order == 2);

                    // 将两个数组排序
                    advicesFront = advicesFront.sort(function (x, y){
                        return x.seq - y.seq;
                    });
                    advicesAfter = advicesAfter.sort(function (x, y){
                        return x.seq - y.seq;
                    });

                    // 先添加在问题前的
                    for(var i = 0; i < advicesFront.length; i++){
                        newDialogue("doctor", advicesFront[i], "advices");
                    }
                    // 添加问题
                    for(var i = 0; i < $scope.receiveData.data.questions.length; i++){
                        newDialogue("doctor", $scope.receiveData.data.questions[i], "questions");
                    }
                    // 再添加问题后的
                    for(var i = 0; i < advicesAfter.length; i++){
                        newDialogue("doctor", advicesAfter[i], "advices");
                    }
                }
                // 没有建议，直接添加问题
                else { 
                    // 添加问题
                    for(var i = 0; i < $scope.receiveData.data.questions.length; i++){
                        newDialogue("doctor", $scope.receiveData.data.questions[i], "questions");
                    }
                }

                // 判断是否有科室的推荐
                var dialogueData = $scope.dialogueList.filter(e => e.data.code == 'function');
                // 如果有function
                if(dialogueData.length > 0){
                    // 有几个function，循环一下
                    console.log(dialogueData);
                    for(var i = 0; i < dialogueData.length; i++){
                        var schedData = dialogueData[i].data.data.filter(e => e.id == 'op_sched');
                        // 如果有op_sched，显示推荐分诊按钮
                        if(schedData.length > 0){
                            $scope.departmentAdvice = true;
                            // 将这次推荐，单独存个起来
                            $scope.departmentAdviceData = dialogueData[i];
                        }
                    }
                }

                if($scope.receiveData.data.step == 2){
                    // 日志埋点，5，第二次响应
                    var log = {};
                    log.type = 5;
                    log.time = new Date().getTime();
                    $scope.logParam.push(log);
                    var logStr = JSON.stringify($scope.logParam);
                    AutoInquiryService.insertLog($scope.vpId, logStr, $scope.dialogueId).then(function (data) {});
                }

                //重置本次记录的答案
                $scope.requestData.questions[0].id = "";
                $scope.requestData.questions[0].type = "";
                $scope.requestData.questions[0].options = [];

                $timeout(function () {
                    $ionicScrollDelegate.resize();
                    var paddingBottom = $("#inquiryFooter").height(); //($("#inquiryFooter").height() - 10) > 80 ? ($("#inquiryFooter").height() - 10) : 80;
                    if ($scope.receiveData.status == "2") {
                        paddingBottom = 40;
                    }
                    $scope.size.wrapPaddingBottom = paddingBottom;
                    $scope.set_paddingBottom = paddingBottom;
                    $ionicScrollDelegate.scrollBottom(true);

                    // 在这加是因为，直接点提交，也监听不到，键盘收起的事件
                    if (currentPlatform == "iOS") {
                        fnKeyboardhide();
                    }
                }, 100);
            } 
            else {
                document.getElementById("inquiryFooter").style.display = "none";
                $fwCordovaToast.showShortBottom(result.msg);
            }
        }, function () {
            $scope.isLoading = false;
            $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
        });
    }

    // 4.添加新对话
    newDialogue = function (account, data, type) {
        $scope.dialogueNew = { account: account, data: data, type: type };
        $scope.dialogueList.push($scope.dialogueNew);
    }

    //新问诊
    $scope.newInquiry = function () {
        $scope.newInquiryDisable = false;
        $scope.qstn_hide = 0;
        $scope.set_paddingBottom = 0;
        $scope.continueInquiry = 0;
        if (document.getElementById("rec_depts")) {
            $("#rec_depts").remove();
        }
        $scope.dialogueNew = {};
        $scope.dialogueList = [];
        $scope.dialogueId = "";
        str_advices = "";
        $scope.cur_triage = 0;
        $scope.str_triage = "";
        $scope.advices_triage = "";
        $scope.requestData = {
            "patientId": "",
            "sessionId": "",
            "step": 0,
            "questions": [
                {
                    "id": "",
                    "type": "",
                    "options": []
                }
            ]
        };
        $ionicScrollDelegate.scrollTop();

        $scope.answer.text = "";
        $scope.curData.other = "";
        $scope.cur_data = "";
        $scope.curDatas.other = "";
        $scope.cur_datas = "";

        // 重置推荐科室
        $scope.departmentAdvice = false;
        $scope.departmentAdviceData = {};

        // 日志埋点，1，第一次请求
        $scope.logParam = [];
        var log = {};
        log.type = 1;
        log.time = new Date().getTime();
        $scope.logParam.push(log);

        //加载第一次会话
        getFirstInquiryData($scope.vpId, $scope.dialogueId, $scope.requestData);
    }

    // 5.设置以上均无/不清楚 =>提交
    $scope.set_cur_value = function () {
        if($scope.requestData.questions[0].options.length > 0){
            $ionicPopup.confirm({
                title: '提交确认',
                template: '您有勾选的回答项，是否仍提交<span class="calm">' + "无" + '</span>?',
                cancelText: '取消',
                okText: '确认'
            }).then(function (res) {
                if (res) {
                    $scope.requestData.questions[0].options = [];
                    var option = {
                        "id": "",
                        "type": "",
                        "text": ""
                    };
                    option.id = "A00";
                    option.type = "2";
                    option.text = "无";
                    $scope.curDatas.other = "无";
                    $scope.requestData.questions[0].options.push(option);
                    $scope.beforeSubmit();
                }
                else { }
            })
        }
        else{
            $scope.requestData.questions[0].options = [];
            var option = {
                "id": "",
                "type": "",
                "text": ""
            };
            option.id = "A00";
            option.type = "2";
            option.text = "无";
            $scope.curDatas.other = "无";
            $scope.requestData.questions[0].options.push(option);
            $scope.beforeSubmit();
        }
    }

    // 6.输入框行高
    $scope.autoHeight = function (id) {
        // 35是初始一行高度
        $("#textarea").css("height", "35px");
        var height = $("#" + id)[0].scrollHeight;
        if (height == 35) { }
        else {
            // +2是上下边距
            $("#" + id).css("height", ($("#" + id)[0].scrollHeight + 2) + "px");
        }
    }

    // 7.显示问题说明
    $scope.ShowInstruction = function (instruction) {
        $ionicPopup.alert({
            title: '说明',
            template: instruction,
            okText: "确定"
        });
    }

    // 日期选择
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // 8.初始化
    $scope.$on('$ionicView.loaded', function () {
        //ionic.Platform.fullScreen(true, false);
        VisitPatientService.visitPatientList().then(function (data) {
            if (data.result == 1) {
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到就诊人信息");
                    return;
                }
                // 第一就诊人
                var vpid = "";
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                        $scope.vpInfo = data.data[i];
                    }
                    //从智能分诊界面返回,使用传递来的患者ID
                    if ($stateParams.vpid != "") {
                        if (data.data[i].VISIT_PATIENT_ID == $stateParams.vpid) {
                            vpid = data.data[i].VISIT_PATIENT_ID;
                            $scope.vpInfo = data.data[i];
                        }
                    }
                }
                if ($scope.vpId == "") {
                    $scope.vpId = vpid;
                }
                $scope.firstFrom = $stateParams.firstFrom;
                // 判断是从哪个入口进的
                if($scope.firstFrom.indexOf('opAppt') > -1){
                    // 如果是从按症状预约进入的
                    $scope.typeEntrance = 2;
                }
                // 如果是健康应答
                else if($scope.firstFrom.indexOf('hlthInquiry') > -1){
                    $scope.typeEntrance = 3;
                }
                else {
                    // 是从智能分诊进入的
                    $scope.typeEntrance = 1;
                }
                $scope.continueInquiry = $stateParams.continueInquiry;
                if ($stateParams.continueInquiry == 1) {
                    //从分诊返回,加载用户对话记录
                    AutoInquiryService.getLastInquiryRecordNew($scope.vpId).then(function (result) {
                        if(result.result != 1){
                            $fwCordovaToast.showShortBottom(result.msg);
                        }
                        else{
                            $scope.dialogueId = result.dialogueId;

                            // 转json对象
                            var dataList = JSON.parse(JSON.stringify(result.data));
                            $scope.dialogueList = dataList;
                            console.log($scope.dialogueList);
                            $scope.continueInquiry = 1;

                            $ionicScrollDelegate.resize();
                            $scope.size.wrapPaddingBottom = 40;
                            $ionicScrollDelegate.scrollBottom();
                            
                            if (currentPlatform == "iOS"){
                                fnKeyboardhide();
                            }

                            // 返回的，需要将变量改为true，改为可开启状态。
                            $scope.newInquiryDisable = true;
                        }
                    }, function () {
                        $ionicLoading.hide();
                        $scope.isLoadFinish = true;
                        $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
                    });
                } 
                else {
                    // 日志埋点，1，第一次请求
                    $scope.logParam = [];
                    var log = {};
                    log.type = 1;
                    log.time = new Date().getTime();
                    $scope.logParam.push(log);


                    // 2021-3-11 20:08:49 HM 应对4S，在这要加一下，原来的智能分诊的功能。获取上次就诊记录
                    if($scope.firstFrom.indexOf('hlthInquiry') == -1){
                        $ionicLoading.show();
                        TriageService.getLastOpInfo($scope.vpId).then(function (triData) {
                            var hasResult = false;
                            var reviewDataRequestId = "";
                            // 查询成功
                            if (triData.result == 1){
                                reviewDataRequestId = triData.data;
                                hasResult = true;
                            }
                            // 查询缓存
                            else if (triData.result == -1) {
                                if (triData.is_null == 1) {
                                    reviewDataRequestId = triData.data;
                                }
                                else {    // 原本data.data能直接用的，但是上次就诊信息返回特殊处理了
                                    reviewDataRequestId = triData.data[0].REQUEST_ID;
                                }

                                hasResult = true;
                            }
                            // 无结果
                            else {
                                hasResult = false;
                            }
                            // 有结果
                            if (hasResult) {
                                // 获取上次就诊信息
                                TriageService.respLastOpInfo(reviewDataRequestId).then(function (respData) {
                                    console.log(respData);
                                    // 查询成功
                                    if (respData.result == 1 && respData.is_null == 0) {
                                    
                                        // 先添加个问题前的
                                        var advicesModel = {};
                                        advicesModel.code = "text";
                                        advicesModel.content = "系统查询到您以来过我院就诊，可直接选择对应医生";
                                        advicesModel.data = [];
                                        advicesModel.order = "1";
                                        advicesModel.seq = 0;
                                        newDialogue("doctor", advicesModel, "advices");

                                         // 再加载一些医生
                                        var advicesDoctor = {};
                                        advicesDoctor.data = [];
                                        for(var i = 0; i < respData.data.length; i++){
                                            var doctorModel = {};
                                            doctorModel.addition = "";
                                            doctorModel.avater_path = respData.data[i].AVATER_PATH;
                                            doctorModel.doctor_level = respData.data[i].DOCTOR_LEVEL;
                                            doctorModel.id = respData.data[i].DOCTOR_CODE;
                                            doctorModel.name = respData.data[i].DOCTOR_NAME;
                                            doctorModel.speciality = respData.data[i].SPECIALITY_NEW;

                                            advicesDoctor.seq = i;
                                            advicesDoctor.data.push(doctorModel);
                                        }
                                        advicesDoctor.code = "doctor";
                                        advicesDoctor.content = "";
                                        advicesDoctor.order = "1";
                                    
                                        newDialogue("doctor", advicesDoctor, "advices");
                                    }
                                    // 无结果
                                    else {
                                    }

                                    //加载第一次会话
                                    getFirstInquiryData($scope.vpId, $scope.dialogueId, $scope.requestData);
                                    $ionicLoading.hide();
                                }, function (data) {
                                    $ionicLoading.hide();
                                    $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
                                })
                            }
                            else {
                                $ionicLoading.hide();
                                //加载第一次会话
                                getFirstInquiryData($scope.vpId, $scope.dialogueId, $scope.requestData);
                            }
                        }, function (data) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
                        })
                    }
                    else{
                        //加载第一次会话
                        getFirstInquiryData($scope.vpId, $scope.dialogueId, $scope.requestData);
                    }
                }
            }
            else {
                $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
            }
        }, function () {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
        })
    })

    //监听键盘高度
    function fnKeyboardshow(e) {
        if (currentPlatform == "iOS") {
            // 2023-10-09 18:52:00 ZYZ 升级wkwebview后已自动托管键盘弹起时的高度计算，此处取消iOS特殊处理，修复键盘弹起时露出白边问题
            //$scope.size.isKeyboardShow = true;
            // 2023-09-27 10:32:00 CGZ 升级wkwebview后已自动托管键盘弹起时的高度计算，此处取消手动计算，修复智能分诊footer中的输入框被键盘顶出屏幕的问题
            //$scope.size.footerPaddingBottom = e.keyboardHeight;
            //var contentPaddingTop = window.screen.height - $("#inquiryHeader").height() - $("#inquiryFooter").height() - $('#inquiry-content-box').height();
            //var contentPaddingBottom = e.keyboardHeight + 20;
            $scope.size.footerPaddingBottom = 0;
            var contentPaddingTop = 0;
            var contentPaddingBottom = 0;
            
            $timeout(function(){
                $scope.size.contentPaddingTop = contentPaddingTop;
                $scope.size.contentPaddingBottom = contentPaddingBottom;
                
                $ionicScrollDelegate.scrollBottom();
                $ionicScrollDelegate.resize();
            }, 1);
        }
        else if (currentPlatform == "Android") {
            //将页面整体上移
            $ionicScrollDelegate.resize();
            $scope.size.wrapPaddingBottom = $("#inquiryFooter").height();
            $ionicScrollDelegate.scrollBottom();
        }
    }

    window.addEventListener('native.keyboardshow', fnKeyboardshow);

    function fnKeyboardhide(e) {
        if (currentPlatform == "iOS") {
            $scope.size.isKeyboardShow = false;
            $scope.size.footerPaddingBottom = 0;
            
            $timeout(function(){
                $scope.size.contentPaddingTop = 0;
                $scope.size.contentPaddingBottom = $("#inquiryFooter").height();
                
                $ionicScrollDelegate.scrollBottom();
                $ionicScrollDelegate.resize();
            }, 1);
        }
        else if (currentPlatform == "Android") {
            //将页面整体下移
            $ionicScrollDelegate.resize();
            $scope.size.wrapPaddingBottom = $("#inquiryFooter").height();
            $ionicScrollDelegate.scrollBottom();
        }
    }

    window.addEventListener('native.keyboardhide', fnKeyboardhide);
    
    // 8.2.进入
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'autoInquiry');
        if (currentPlatform == "iOS") {
            window.cordova.plugins.Keyboard.disableScroll(true);
        }
    });

    // 8.3.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'autoInquiry') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        if (currentPlatform == "iOS") {
            window.cordova.plugins.Keyboard.disableScroll(false);
        }
        // 2020-10-23 18:47:35 解除监听事件
        window.removeEventListener('native.keyboardshow', fnKeyboardshow);
        window.removeEventListener('native.keyboardhide', fnKeyboardhide);
    });

    // 8.4.回home
    $scope.goBack = function () {
        if ($scope.receiveData.status != "2" && $scope.continueInquiry == 0) {
            try {
                //传递中止信号
                $scope.requestData.patientId = $scope.receiveData.data.patientId;
                $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                $scope.requestData.step = -1;
                if ($scope.receiveData.status == "1") {
                    $scope.requestData.questions[0].id = "status1";
                } else {
                    $scope.requestData.questions[0].id = "status2";
                }
                AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
            } catch (ex) {

            }
        }

        // 2021-3-17 13:28:46 HM 应大数据组要求，返回也要加log= =
        var logStr = JSON.stringify($scope.logParam);
        AutoInquiryService.insertLog($scope.vpId, logStr, $scope.dialogueId).then(function (data) {});
        
        // 如果健康应答回首页
        if($scope.firstFrom.indexOf('hlthInquiry') > -1){
            $state.go("app.home");
        }
        else{
            $state.go("app." + $scope.firstFrom, { from: "autoInquiry", vpId: $scope.vpId });
        }
    }

    // 9.1.就诊人列表：打开
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }
    // 9.2.就诊人列表：切换就诊人
    $scope.changeVp = function (vpid) {
        if ($scope.vpId != vpid) {
            $ionicPopup.confirm({
                title: '切换就诊人会重置当前问诊会话,是否确认重置？',
                cancelText: '取消',
                okText: '确认'
            }).then(function (res) {
                if (res) {
                    $scope.continueInquiry = 0;
                    if (document.getElementById("rec_depts")) {
                        $("#rec_depts").remove();
                    }

                    $scope.vpId = vpid;
                    for (var i = 0; i < $scope.vpList.length; i++) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.vpId) {
                            $scope.vpInfo = $scope.vpList[i];
                        }
                    }
                    $scope.popVplist.hide();

                    //终止当前问诊
                    if ($scope.receiveData.status != "2" && $scope.continueInquiry == 0) {
                        try {
                            //传递中止信号
                            $scope.requestData.patientId = $scope.receiveData.data.patientId;
                            $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                            $scope.requestData.step = -1;
                            if ($scope.receiveData.status == "1") {
                                $scope.requestData.questions[0].id = "status1";
                            } else {
                                $scope.requestData.questions[0].id = "status2";
                            }
                            AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
                        } catch (ex) {

                        }
                    }
                    //加载新问诊
                    $scope.newInquiry();
                }
            });
        }
    }

    // 10.去反馈
    $scope.goAutoInquiryFeedBack = function () {
        console.log(1);
        $state.go('app.autoInquiryFeedback');
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // 测试专用
    $scope.test = function (){
        // 病种
        $scope.group = {};
        $scope.group.type = "BZ";
        $scope.group.code = "01";
        $scope.group.name = "冠心病";
        $scope.group.childList = [];
        $scope.group.doctorListIsLoadFinish = false;

        // 首先要走一个ajax，根据id取查是否有内科治疗和外科手术
        $ionicLoading.show();
        AutoInquiryService.getGroupDetail($scope.group.type, $scope.group.code).then(function (data){
            if(data.result == 0){
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else{
                if(data.is_null == 0){
                    $scope.group.code = data.data[0].GROUP_CODE;// 默认选中第一个
                    $scope.group.childList = data.data;
                }
                // 展示模态框
                $scope.doctorListModalShow();
                // 查询医师
                $scope.doctorList();
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
        })
    }

    // 修改选择治疗方式
    $scope.changeSpecialitySubgroup = function (groupCode){
        $scope.group.code = groupCode;
        $scope.group.doctorListIsLoadFinish = false;
        $ionicLoading.show();
        // 查询医师
        $scope.doctorList();
    }

    // 根据code查询医师列表
    $scope.doctorList = function (){
        $scope.group.doctorList = [];
        AutoInquiryService.doctorList($scope.group.type, $scope.group.code).then(function (data){
            $ionicLoading.hide();
            if(data.result == 0){
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else{
                // 增加+ 智能分诊查询医师，显示排班
                for (var i = 0; i < data.data.length; i++) {
                    var result = data.data[i];
                    if (data.data[i].REG_DATE == "") {
                        $scope.group.doctorList.push(result);
                        continue;
                    }
                    var regDate = data.data[i].REG_DATE.split(",");
                    var regDateList = new Array();
                    for (var j = 0; j < regDate.length; j++) {
                        var obj = new Object();
                        var reg = regDate[j].split("|");
                        reg[0] = reg[0].slice(5);
                        obj.date = reg[0];
                        obj.count = reg[1];
                        regDateList.push(obj);
                    }

                    result.regDateList = regDateList;
                    $scope.group.doctorList.push(result);
                }

                $scope.group.doctorListIsLoadFinish = true;
                console.log($scope.group.doctorList);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
        })
    }

    // 显示医师简介
    // 医师介绍
    $scope.doctorIntro = function (doctorId, doctorLevel, doctorCode, doctorName, doctorPath, doctorSpeciality) {
        $scope.doctorInfo = new Object();
        $ionicLoading.show();
        // 2019-9-23 15:31:08 HM 医师简介优化，GW没有维护的数据，从前一页拽过来
        if (doctorId == undefined || doctorId.length == 0) {
            var data = new Object();
            data.avatar_path = doctorPath;
            data.description = "";
            data.doctor_code = doctorCode;
            data.doctor_id = doctorId;
            data.doctor_name = doctorName;
            data.speciality = doctorSpeciality;
            data.title = doctorLevel;
            $scope.doctorInfo = data;

            OpApptService.getDoctorScheduling(doctorCode).then(function (data) {
                $scope.schedulingModal = data;
                console.log(data);
                $ionicLoading.hide();
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
        }
        else{
             DoctorInfoService.doctorInfo(doctorId).then(function (data) {
                $scope.doctorInfo = data;
                if (doctorLevel.toString() != "") {
                    $scope.doctorInfo.title = doctorLevel;
                }
                // 当前医师出诊表
                if (doctorCode != '') {
                    OpApptService.getDoctorScheduling(doctorCode).then(function (result) {
                        $scope.schedulingModal = result;
                        console.log(result);
                        $ionicLoading.hide();
                    }, function (resp) {
                        var alertPopup = $ionicPopup.alert({
                            title: '网络错误',
                            template: '加载失败,请检查网络'
                        });
                        $ionicLoading.hide();
                    });
                }
            }, function (resp) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
            });
        }
        $scope.doctorIntroModal.show();
        $ionicScrollDelegate.$getByHandle('intro').scrollTop();
    }

    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }

    // 医师介绍页确认预约
    $scope.apptModal = function (id, color) {
        if (id != "" && (color == "green" || color == "orange")) {
            // 改为上下午分段
            if (isOpAppt || $rootScope.opApptData.status) {
                OpApptService.getOpSchedInfo(id).then(funcCBSGetPeriod2);
            }
            else {
                AddWishService.getPeriod(id).then(funcCBSGetPeriod2);
            }
            function funcCBSGetPeriod2(data) {
                console.log(data);
                // 调用失败
                if (data.result == -1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                // 已约满
                else if (data.result == 0) {
                    $fwCordovaToast.showShortBottom("当前选择的医师已约满");
                }
                // 一个时段 直接赋值下一步
                else {
                    // 如果是新问诊，并且会话没有结束m
                    if ($scope.continueInquiry == 0 && $scope.receiveData.status != '2') {
                        // 向服务器请求，终止会话
                        $scope.requestData.patientId = $scope.receiveData.data.patientId;
                        $scope.requestData.sessionId = $scope.receiveData.data.sessionId;
                        $scope.requestData.step = -1;
                        $scope.requestData.questions[0].type =  $scope.group.type + ":" + $scope.group.name;
                        if ($scope.receiveData.status == "1") {
                            $scope.requestData.questions[0].id = "status1";
                        } else {
                            $scope.requestData.questions[0].id = "status2";
                        }

                        AutoInquiryService.getInquiryData($scope.vpId, $scope.dialogueId, JSON.stringify($scope.requestData), $scope.typeEntrance).then(function (result) { });
                    }

                    if (isOpAppt || $rootScope.opApptData.status) {
                        $state.go("app.opAppt", { opid: data.data[0].ID, vpId: $scope.vpId, from: 'app.autoInquiry,' + $scope.firstFrom });
                    }
                    else {
                        $state.go("app.addWish", { opid: data.data[0].ID, vpId: $scope.vpId, from: 'app.autoInquiry,' + $scope.firstFrom });
                    }
                }
            }
        }
    }

    // 推荐分诊
    $scope.set_triage = function (){
        newDialogue($scope.departmentAdviceData.account, $scope.departmentAdviceData.data, $scope.departmentAdviceData.type);

        $timeout(function () {
            $ionicScrollDelegate.resize();
            var paddingBottom = $("#inquiryFooter").height(); //($("#inquiryFooter").height() - 10) > 80 ? ($("#inquiryFooter").height() - 10) : 80;
            if ($scope.receiveData.status == "2") {
                paddingBottom = 40;
            }
            $scope.size.wrapPaddingBottom = paddingBottom;
            $scope.set_paddingBottom = paddingBottom;
            $ionicScrollDelegate.scrollBottom(true);
                    
            if (currentPlatform == "iOS") {
                fnKeyboardhide();
            }
        }, 1);
    }

    // 监听焦点
    $scope.logFocus = function (){
        var logThree = $scope.logParam.filter(e => e.type == 3);
        if($scope.receiveData.data.step == 1 && logThree.length == 0){
            // 日志埋点，3，第一次选项或光标激活
            var log = {};
            log.type = 3;
            log.time = new Date().getTime();
            $scope.logParam.push(log);
        }
    }

    // 选中选项，自动录入文本框，替发送
    $scope.optionNext = function (text){
        $scope.answer.text = text;
        $scope.beforeSubmit();
    }

    // 打开系统通知
    $scope.openMsg = function (){
        // 如果会话结束了，添加系统消息，为预问诊病历
        if($scope.receiveData.status == "2" && $scope.receiveData.data.results.his_info != null){
            $scope.autoRecordShow();
        }
    }
});
