﻿angular.module('fwapp.controllers')

.controller('AutoInquiryFeedbackController', function ($scope, $rootScope, $state, $stateParams, $timeout,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicPlatform, $ionicSlideBoxDelegate,
    $ionicActionSheet,
    AutoInquiryService, VisitPatientService,
    $fwCordovaToast, $ionicScrollDelegate) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 注册模态窗口：自动问诊-详细
    $ionicModal.fromTemplateUrl('autoInquiryResult.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.resultModal = modal;
    });

    // 1.进入
    $scope.$on('$ionicView.enter', function () {

        $scope.toFeedbackList();

        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'autoInquiryFeedback');
    });

    // 2.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'autoInquiryFeedback') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 3.销毁
    $scope.$on('$destroy', function () {
        $scope.resultModal.remove();
    })

    // 4.回home
    $scope.goBack = function () {
        $state.go("app.home");
    }

    // 5.结果模态窗隐藏
    $scope.resultModalHide = function () {
        $scope.resultModal.hide();
    }

    // 6.反馈列表
    $scope.toFeedbackList = function () {
        AutoInquiryService.feedBackList().then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom("加载列表出现错误");
            }
            else {
                $scope.feedbackList = result.dt;
            }
        })
    }

    // 7.反馈详细
    $scope.toFeedbackResult = function (index) {
        $scope.time = $scope.feedbackList[index].DATE_CREATED;
        $scope.feedBackResult = JSON.parse($scope.feedbackList[index].RESULT);
        $scope.resultModal.show();
    }
});