﻿angular.module('fwapp.controllers')

.controller('CasePrintController', function ($scope, $rootScope, $state, $stateParams, $timeout, $interval,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicPlatform,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicActionSheet, $fwCordovaToast, $cordovaDatePicker,
    $cordovaImagePicker, $cordovaCamera, $cordovaFileTransfer,
    CasePrintService, VisitPatientService, RequestService, PaymentService) {

    // 申请Id
    $scope.applyId = $stateParams.applyId;
    // 申请模型
    $scope.casePrint = new Object();

    // 单份费用
    $scope.single_pay = 0;
    // 总费用
    $scope.base_pay = 0;

    // 步骤控制
    $scope.step = 0;
    // Slide控制
    var caseSlide = $ionicSlideBoxDelegate.$getByHandle('caseSlide');

    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;

    // 同意书内容
    $scope.agreeContent = [
        "<div>1、请完整填写您的信息。</div>",
        "<div>2、内科病案复印1份收取36元，外科病案复印1份收取46元。</div>",
        "<div>3、病案归档时间为出院7-10天，请耐心等待。</div>",
        "<div>4、病案复印时间为上午8:00-11:30，下午13:00-17：00，请耐心等待。</div>"
    ];
    $scope.agreeTemp = "";

    // 同意倒计时
    $scope.countdown = 10;

    // 图片base64
    casePrint_src = { front: '', back: '', proven: '', add: '' };


    // 支付方式
    $scope.pay_method = 1;
    // 订单号
    $scope.outTradeNo = "";
    // 支付结果
    $scope.appResult = "";

    // 是否正在支付
    $scope.isWaitPay = false;

    // 是否成人
    $scope.isAdult = true;

    // 方法
    // 1.加载就诊人列表(删除)

    // 2.提交
    $scope.submit = function () {
        if (!check()) {
            return;
        }
        // 基本信息页
        if ($scope.step == 1) {
            if ($scope.applyId == "") {
                casePrintCheckPatient();
            }
            else {
                nextStep();
            }
        }
        // 图片信息页
        else if ($scope.step == 2) {
            CasePrintService.checkUrlHasLoad($scope.applyId, $scope.casePrint.APPLY_RELATION).then(function (result) {
                if (result.result == 0) {
                    $fwCordovaToast.showShortBottom(result.msg);
                }
                else {
                    if (result.hasPicture == 0) {
                        $fwCordovaToast.showShortBottom("请上传身份证正、反、手持照");
                    }
                    else {
                        nextStep();
                    }
                }
            });
        }
        else {
            // step=5 =>信息确认 =>计算费用
            if ($scope.step == 5) {
                $scope.casePrint.STATUS = 2;
                calc();
            }

            CasePrintService.submit($scope.applyId, $scope.casePrint).then(function (result) {
                $ionicLoading.hide();
                if (result.result == 0) {
                    $fwCordovaToast.showShortBottom(result.msg);
                }
                else {
                    nextStep();
                }
            })
        }
    }

    // 3.设置份数
    $scope.setCount = function (type) {
        if (type == "+") {
            if ($scope.casePrint.PRINT_COUNT >= 20) {
                $fwCordovaToast.showShortBottom("已超过最大复印份数");
            }
            else {
                $scope.casePrint.PRINT_COUNT++;
            }
        }
        else if (type == "-") {
            if ($scope.casePrint.PRINT_COUNT <= 0) {
                $fwCordovaToast.showShortBottom("已超过最小复印份数");
            }
            else {
                $scope.casePrint.PRINT_COUNT--;
            }
        }
    }

    // 4.上一步
    $scope.lastStep = function () {
        if ($scope.step == 1) {
            if ($scope.agreeTemp == "") {
                $state.go('app.home');
            }
            else {
                lastStep();
            }
        }
        else {
            lastStep();
        }
    }

    // 5.提交前检查
    check = function () {
        var ifSubmit = true;

        if ($scope.step == 1) {
            var array = [{ key: "PATIENT_NAME", value: "患者姓名" }, { key: "PATIENT_IDCARD_CODE", value: "身份证号" }, { key: "PATIENT_OUT_DATE", value: "出院时间"}];
            for (i in array) {
                if (eval("$scope.casePrint." + array[i].key) == "" || eval("$scope.casePrint." + array[i].key) == null) {
                    ifSubmit = false;
                    $fwCordovaToast.showShortBottom("请填写" + array[i].value);
                }
            }
        }
        else if ($scope.step == 2) {
            var array = [{ key: "IDCARD_PRONT_URL", value: "身份证正面照" }, { key: "IDCARD_BACK_URL", value: "身份证反面照" }, { key: "PROVEN_URL", value: "身份证正面与本人合照"}];
            for (i in array) {
                if (eval("$scope.casePrint." + array[i].key) == "" || eval("$scope.casePrint." + array[i].key) == null) {
                    ifSubmit = false;
                    $fwCordovaToast.showShortBottom("请上传" + array[i].value);
                }
            }

            if (ifSubmit) {
                if (!$scope.isAdult) {
                    if ($scope.casePrint.APPLY_RELATION == "" || $scope.casePrint.APPLY_RELATION == null) {
                        ifSubmit = false;
                        $fwCordovaToast.showShortBottom("请选择申请人与患者的关系");
                    }
                }
            }
        }
        else if ($scope.step == 3) {
            if ($scope.casePrint.PRINT_COUNT == 0) {
                ifSubmit = false;
                $fwCordovaToast.showShortBottom("请选择复印份数");
            }
        }
        else if ($scope.step == 4) {
            var array = [
                { key: "ACCESS_NAME", value: "获取人姓名" },
                { key: "ACCESS_TEL", value: "获取人手机号" },
                { key: "ACCESS_PROVINCE", value: "所在省" },
                { key: "ACCESS_CITY", value: "所在市" },
                { key: "ACCESS_COUNTY", value: "所在县" },
                { key: "ACCESS_ADDR", value: "详细地址" }
            ];

            for (i in array) {
                if (eval("$scope.casePrint." + array[i].key) == "" || eval("$scope.casePrint." + array[i].key) == null) {
                    ifSubmit = false;
                    $fwCordovaToast.showShortBottom("请填写" + array[i].value);
                }
            }

            var reg = /^(0|86|17951)?(13[0-9]|15[012356789]|17[0356789]|18[0-9]|14[57])[0-9]{8}$/;
            if (!reg.test($scope.casePrint.ACCESS_TEL)) {
                ifSubmit = false;
                $fwCordovaToast.showShortBottom("非正确的手机号格式");
            }
        }

        return ifSubmit;
    }

    // 5.1. baseInfo => picInfo
    casePrintCheckPatient = function () {
        $ionicLoading.show();
        RequestService.casePrintCheckPatient($scope.casePrint.PATIENT_NAME, $scope.casePrint.PATIENT_IDCARD_CODE, $scope.casePrint.PATIENT_OUT_DATE).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.applyId = result.applyId;
                // 获取下回答 病区和inpatientId写进去了
                caseAnswer();
                nextStep();
            }
        })
    }

    // 6.获取回答
    caseAnswer = function () {
        $ionicLoading.show();

        CasePrintService.caseAnswer($scope.applyId).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 99) {
                $state.go("app.personal");
            }
            else if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                if (result.dt.length == 0) {
                    // 有applyId 但没有回答 =>走新建申请流程
                    $scope.applyId = "";
                    checkHasApply();
                }
                else {
                    $scope.casePrint = result.dt[0];
                    // 出院时间处理一下
                    $scope.casePrint.PATIENT_OUT_DATE = (new Date(result.dt[0].PATIENT_OUT_DATE)).Format("yyyy-MM-dd");
                    // 创建时间处理一下
                    $scope.casePrint.DATE_CREATED = (new Date(result.dt[0].DATE_CREATED)).Format("yyyy-MM-dd hh:mm");
                    // 份数处理一下
                    $scope.casePrint.PRINT_COUNT = $scope.casePrint.PRINT_COUNT == null ? 0 : $scope.casePrint.PRINT_COUNT;

                    // 市处理一下
                    getCity();
                    // 县处理一下
                    getCounty();

                    // 是否成人处理一下
                    $scope.isAdult = result.isAdult;
                }
            }
        })
    }

    // 7.图片上传
    $scope.chooseImg = function () { }

    // 9.1.省市县：省
    getProvince = function () {
        CasePrintService.getProvince().then(function (result) {
            $scope.provinces = result.provinces;
        })
    }

    // 9.2.省市县：市
    $scope.getCity = function () {
        $scope.casePrint.ACCESS_CITY = "";
        $scope.casePrint.ACCESS_COUNTY = "";
        // 市
        getCity();
    }
    // 9.2.1.市
    getCity = function () {
        CasePrintService.getCity($scope.casePrint.ACCESS_PROVINCE).then(function (result) {
            $scope.citys = result.citys;
        })
    }

    // 9.3.省市县：县
    $scope.getCounty = function () {
        $scope.casePrint.ACCESS_COUNTY = "";
        // 县
        getCounty();
    }
    // 9.3.1.县
    getCounty = function () {
        CasePrintService.getCounty($scope.casePrint.ACCESS_CITY).then(function (result) {
            $scope.countys = result.countys;
        })
    }

    // 10.计算费用
    calc = function () {
        CasePrintService.calcPay($scope.applyId).then(function (result) {
            if (result.result == 1) {
                $scope.base_pay = result.base_pay.toFixed(2);
                $scope.single_pay = result.single_pay;
            }
        })
    }

    // 11.不支付
    $scope.unPay = function () {
        $ionicPopup.confirm({
            title: '操作确认',
            template: '正在进行<span class="calm">取消支付</span>，<span class="calm">取消支付</span>的订单不会进入审核流程，是否取消支付?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                $scope.applyId = "";
                // 去申请列表
                $state.go("app.casePrintList");
            }
            else { }
        })
    }

    // 支付相关
    // 12.支付
    $scope.unifiedOrder = function () {

        if ($scope.pay_method != 1 && $scope.pay_method != 6) {
            $fwCordovaToast.showShortBottom("支付方式错误，请选择支付方式！");
            return;
        }

        var pay_method = $scope.pay_method;

        $scope.isWaitPay = true;

        $ionicLoading.show();
        CasePrintService.unifiedOrder($scope.applyId, pay_method).then(function (data) {
            // 出现错误
            if (data.result == 0) {
                // 啊 圈
                $ionicLoading.hide();
                $scope.isWaitPay = false;
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                switch (pay_method) {
                    // 微信支付                                                                                                                   
                    case 1: case "1":
                        {
                            callWXPay(data.data);
                            break;
                        }
                        // 支付宝                                                          
                    case 6: case "6":
                        {
                            callAliPay(data.data);
                            break;
                        }
                        // 其他                                                           
                    default:
                        $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                        $scope.isWaitPay = false;
                        $ionicLoading.hide();
                        break;
                }
            }
        })
    }

    // 12.1.微信支付
    function callWXPay(paydata) {
        // 订单号
        $scope.outTradeNo = paydata.out_trade_no;
        // 支付状态
        $scope.appResult = "";
        $scope.fromWeixin = false;
        // 注册后台唤醒事件
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $scope.isWaitPay = false;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            return;
        }
    }

    // 12.1.1.微信支付成功
    function WXPaySuccess(statusCode) {
        // 支付状态
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                // 去检查HIS是否处理
                checkHisDealWithPay($scope.applyId);
            }
            // 虚假的支付成功
            else {
                $scope.isWaitPay = false;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $scope.isWaitPay = false;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
        })

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
    }

    // 12.1.2 微信支付失败
    function WXPayFailed(statusCode) {
        // 支付状态
        $scope.appResult = statusCode;
        $scope.isWaitPay = false;
        $fwCordovaToast.showShortBottom(-1 == statusCode ? "支付错误" : "用户取消或支付超时");

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
        // 啊 圈
        $ionicLoading.hide();
    }

    // 12.2.支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        // 订单号
        $scope.outTradeNo = aliBizContent.out_trade_no;
        // 支付结果
        $scope.appResult = "";

        // 注册后台唤醒事件
        document.addEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = false;
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $scope.isWaitPay = false;
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 12.2.1.支付宝支付成功
    function AliPaySuccess(statusCode) {
        // 支付结果
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                // 去检查HIS是否处理
                checkHisDealWithPay($scope.applyId);
            }
            // 虚假的支付成功
            else {
                $scope.isWaitPay = false;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $scope.isWaitPay = false;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
        })

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
    }

    // 12.2.2.支付宝支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        switch (statusCode.resultStatus) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }

        $scope.isWaitPay = false;
        $fwCordovaToast.showShortBottom(errMsg);

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
        // 啊 圈
        $ionicLoading.hide();
    }

    // 12.3.验证HIS是否处理
    checkHisDealWithPay = function (applyId) {
        setTimeout(function () {
            CasePrintService.checkHisDealWithPay(applyId).then(function (result) {
                // 啊 圈
                $ionicLoading.hide();
                $scope.isWaitPay = false;

                // HIS处理了 但处理失败
                if (result.result == 0) {
                    $fwCordovaToast.showShortBottom(result.msg);
                }
                else if (result.result == 1) {
                    $fwCordovaToast.showShortBottom("押金缴纳成功，病案复印申请进入审核流程，请耐心等待!");

                    // 等一等
                    setTimeout(function () {
                        // 回列表页
                        $state.go("app.casePrintList");
                    }, 1500);
                }
            });
        }, 1500);
    }

    // 后台唤醒 =>取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $ionicLoading.show();
                // 查询支付状态
                PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
                    // 真·支付成功
                    if (data.result == 1) {
                        // 默默回调
                        PaymentService.appCallback($scope.casePrint.CASE_PRINT_APPLY_ID, $scope.outTradeNo, "0").then(function (data) { });

                        checkHisDealWithPay($scope.casePrint.CASE_PRINT_APPLY_ID);
                    }
                    // 虚假的支付成功
                    else {
                        // 默默回调
                        PaymentService.appCallback($scope.casePrint.CASE_PRINT_APPLY_ID, $scope.outTradeNo, "-1").then(function (data) { });

                        $scope.isWaitPay = false;
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
                    }

                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;

                    // 支付方式重置
                    $scope.pay_method = 1;
                    // 订单号重置
                    $scope.outTradeNo = "";
                    // 支付状态重置
                    $scope.appResult = "";

                    $ionicLoading.hide();
                });

            }
        }, 1000);
    }


    // 13.是否有未完成的申请
    checkHasApply = function () {
        $ionicLoading.show();
        CasePrintService.checkHasApply().then(function (result) {
            $ionicLoading.hide();
            if (result.result == 99) {
                $state.go("app.personal");
            }
            // 出现错误
            else if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            // 有待审核的申请
            else if (result.result == -1) {

                $ionicPopup.confirm({
                    title: '提示',
                    template: '您有仍在审核的申请，新添加申请需等待此申请审核完毕！如您想修改此申请信息，请点击重填申请，之后将取消这份申请，新增一份保留您原信息的申请，您可以进行修改并重提交。是否重填信息?',
                    okText: '重填申请',
                    cancelText: '等待审核'
                }).then(function (res) {
                    // 重填申请
                    if (res) {
                        reApply(result.applyId);
                    }
                    // 等待审核 =>回列表页
                    else {
                        $state.go("app.casePrintList");
                    }
                })
            }
            else {
                // 有待完成的申请
                if (result.applyId != "") {

                    $ionicPopup.confirm({
                        title: '提示',
                        template: '您有仍未填写完毕的申请，是否继续填写此申请?',
                        okText: '继续填写',
                        cancelText: '取消'
                    }).then(function (res) {
                        // 继续填写
                        if (res) {
                            nextStep();
                            $scope.applyId = result.applyId;
                            caseAnswer();
                        }
                        // 取消 
                        else {
                            // 取消这份申请
                            caseCancel(result.applyId);
                            // 出同意书
                            agreeAlert();
                        }
                    })
                }
                // 无待完成的申请
                else {
                    // 出同意书
                    agreeAlert();
                }
            }
        })
    }

    // 14.取消这份申请 （code==11，status=3的话，这里包括退费
    caseCancel = function (applyId) {
        var cancel_code = 11;
        CasePrintService.caseModify(cancel_code, applyId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else { }
        });
    }

    // 15.重填写申请
    reApply = function (applyId) {
        $ionicLoading.show();
        CasePrintService.reApply(applyId).then(function (result) {
            // 结束转圈
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                // 取消原申请 (这里包括退费）
                caseCancel(applyId);
                nextStep();
                $scope.applyId = result.new_applyId;
                // 新的回答
                caseAnswer();
            }
        });
    }

    // 16.出同意书
    agreeAlert = function () {
        // 同意书
        var template = "";
        $ionicLoading.show();
        CasePrintService.getAgreeAlert().then(function (result) {

            $ionicLoading.hide();

            // 出错就旧版同意书吧
            if (result.result == 0) {
                for (var i in $scope.agreeContent) {
                    template += $scope.agreeContent[i];
                }
            }
            else {
                template = result.html;
            }

            $scope.agreeTemp = template;
            // 用户须知倒计时
            $interval(function () { $scope.countdown -= 1; }, 1000, 10)
        })
    }

    // 17.选择支付方式
    $scope.changePayMethod = function (type) {
        $scope.pay_method = type;
    }


    // 图片相关

    // 18.1.选择图片
    $scope.setUrl = function (id) {
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(id);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(id);
                        return true;
                        break;
                }
            }
        })
    }

    // 18.1.1.由相册选择图片
    $scope.selectImg = function (id) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            $scope.uploadImg(imageDataList[0], id);
        }, function (err) {
        });
    }

    // 18.1.2.调用摄像头拍照
    $scope.cameraImg = function (id) {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData, id);
        }, function (err) {
        });
    }

    // 18.2.上传图片
    $scope.uploadImg = function (imageData, id) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "CASE_PRINT", ifDES: "1" }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理         
            if (result.response == undefined) {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("上传失败");
            }
            else {
                if (result.response.indexOf('上传失败') >= 0) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(result.response);
                }
                else {
                    saveUrlDataBase(id, result.response);
                    $fwCordovaToast.showLongBottom("请等待");
                }
            }
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showLongBottom("上传失败，错误原因：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 18.3.保存图片Url
    saveUrlDataBase = function (id, url) {
        CasePrintService.saveUrlDataBase($scope.applyId, id, url).then(function (result) {
            // 啊 圈
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                // Url赋值
                $scope.casePrint[id] = url;
            }
        });
    }

    // 18.4.删除图片
    $scope.detUrl = function (id) {
        CasePrintService.detUrl($scope.applyId, id).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                // Url清空
                $scope.casePrint[id] = null;
            }
        });
    }

    // 19.填写页 =>申请列表页
    $scope.goCaseList = function () {

        $ionicPopup.confirm({
            title: '提示',
            template: '是否停止填写此份申请，前往我的复印申请列表页?',
            okText: '确定',
            cancelText: '取消'
        }).then(function (res) {
            // 确定
            if (res) {
                $state.go("app.casePrintList");
            }
            // 取消 
            else { }
        })
    }

    // 页面的进入与退出
    // 1.准备
    ionic.DomUtil.ready(function () {
        // 禁用左右滑动
        caseSlide.enableSlide(false);
    });

    // 2.进入（多次）
    $scope.$on('$ionicView.enter', function () {
        // 设置初始化
        $scope.step = 0;
        caseSlide.slide($scope.step);

        // 患者信息初始化
        $scope.applyId = $stateParams.applyId;

        // 加载省市县：省
        getProvince();

        // 未指定applyId
        if ($scope.applyId == "") {
            checkHasApply();
        }
        // 指定applyId
        else {
            nextStep();
            caseAnswer();
        }

        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'casePrint');
    });

    // 3.1.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'casePrint') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });


    // slide切换
    // 1.切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 2.回home
    $scope.goBack = function () {
        $state.go("app.home");
    }

    // 3.1.跳页
    slideStep = function (step) {
        caseSlide.slide(step);
        $ionicScrollDelegate.resize();
    }
    // 3.2.下一步
    nextStep = function () {
        $scope.step++;
        slideStep($scope.step);
    }
    // 3.3.上一步
    lastStep = function () {
        $scope.step--;
        slideStep($scope.step);
    }

    $scope.goNextStep = function () {
        nextStep();
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
});