﻿angular.module('fwapp.controllers')

.controller('CasePrintListController', function ($scope, $rootScope, $state, $stateParams, $timeout,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicPlatform,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicActionSheet, $fwCordovaToast,
    CasePrintService, PaymentService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 申请列表
    $scope.caselist = null;

    // 单份费用
    $scope.single_pay = 0;
    // 总费用
    $scope.base_pay = 0;

    // 步骤控制
    $scope.step = 0;
    // Slide控制
    var casePrintListSlide = $ionicSlideBoxDelegate.$getByHandle('casePrintListSlide');

    // 病案复印模型
    $scope.casePrint = new Object();

    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;

    // 物流单号（每申请为单位）
    $scope.ems_codes = [];
    // 物流路程（每单号为单位）
    $scope.ems_traces = [];
    // 物流标记颜色
    $scope.color = ["bisque", "cadetblue", "bisque", "lightblue"];

    // 支付方式
    $scope.pay_method = 1;
    // 订单号
    $scope.outTradeNo = "";
    // 支付结果
    $scope.appResult = "";

    // 是否正在支付
    $scope.isWaitPay = false;

    // 方法
    // 1.加载申请列表
    loadCaseList = function () {
        $ionicLoading.show();

        CasePrintService.loadCaseList().then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                for (i in result.dt) {

                    // 接收方式处理一下
                    result.dt[i].ACCESS_TYPE == 1 ? "EMS邮递" : "自提";

                    // 创建时间处理一下
                    result.dt[i].DATE_CREATED = (new Date(result.dt[i].DATE_CREATED)).Format("yyyy-MM-dd");
                    // 支付时间处理一下
                    result.dt[i].DATE_PAID = result.dt[i].DATE_PAID == null ? result.dt[i].DATE_PAID : (new Date(result.dt[i].DATE_PAID)).Format("yyyy-MM-dd");

                    // 状态处理一下
                    switch (result.dt[i].STATUS) {
                        case 1: { result.dt[i].STATUS = "申请填写中"; break; }
                        case 2: { result.dt[i].STATUS = "待缴纳押金"; break; }
                        case 3: { result.dt[i].STATUS = "已提交 等待审核"; break; }
                        case 4: { result.dt[i].STATUS = "申请已拒绝"; break; }
                        case 5: { result.dt[i].STATUS = "申请退回 待修改"; break; }
                        case 6: { result.dt[i].STATUS = "病案待复印"; break; }
                        case 7: { result.dt[i].STATUS = "病案已复印"; break; }
                        case 9: { result.dt[i].STATUS = "病案已邮递"; break; }
                        case 10: { result.dt[i].STATUS = "病案已自提"; break; }
                        case 11: { result.dt[i].STATUS = "申请已取消"; break; }
                    }
                }
                $scope.caselist = result.dt;
            }
        })
    }

    // 2.点击查看申请
    $scope.caseAnswer = function (applyId) {
        listCaseAnswer(applyId);
        listNextStep();
    }
    // 申请信息
    listCaseAnswer = function (applyId) {
        $ionicLoading.show();
        CasePrintService.caseAnswer(applyId).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.casePrint = result.dt[0];
                // 出院时间处理一下
                $scope.casePrint.PATIENT_OUT_DATE = (new Date(result.dt[0].PATIENT_OUT_DATE)).Format("yyyy-MM-dd");
                // 申请时间处理一下
                $scope.casePrint.DATE_CREATED = (new Date(result.dt[0].DATE_CREATED)).Format("yyyy-MM-dd hh:ss");
            }
        })
    }


    // 3.修改申请状态
    $scope.caseModify = function (applyId, modifyStatus) {
        if (applyId == "") {
            $fwCordovaToast.showShortBottom("请求缺失申请id");
            return;
        }
        // 修改申请 OR 继续填写
        if (modifyStatus == 1 || modifyStatus == -1) {
            if (modifyStatus == 1) {
                CasePrintService.caseModify(modifyStatus, applyId).then(function (result) {
                    if (result.result == 0) {
                        $fwCordovaToast.showShortBottom(result.msg);
                    }
                    else {
                        $state.go("app.casePrint", { applyId: applyId });
                    }
                });
            }
            else {
                $state.go("app.casePrint", { applyId: applyId });
            }
        }
        // 删除申请 OR  取消申请
        else if (modifyStatus == 0 || modifyStatus == 11) {
            var modify = { 0: "删除", 11: "取消" };
            // 二次提示
            $ionicPopup.confirm({
                title: '操作确认',
                template: '正在对申请进行<span class="calm">' + modify[modifyStatus] + '</span>操作，<span class="calm">' + modify[modifyStatus] + '</span>不可回退，是否要继续?',
                okText: '确认',
                cancelText: '取消'
            }).then(function (res) {
                if (res) {
                    CasePrintService.caseModify(modifyStatus, applyId).then(function (result) {
                        if (result.result == 0) {
                            $fwCordovaToast.showShortBottom(result.msg);
                        }
                        else {
                            // 取消申请
                            if (modifyStatus == 11) {
                                var tip = result.status == 3 ? "申请已取消，已缴纳的押金将在3-5天内退回，请耐心等待!" : "申请已取消";
                                $fwCordovaToast.showShortBottom(tip);
                            }
                            // 删除申请
                            else {
                                $fwCordovaToast.showShortBottom("申请已删除");
                            }
                            // 重加载申请列表
                            loadCaseList();
                        }
                    })
                }
                else { }
            });
        }
        // 非法的请求
        else { }
    }

    // 4.去支付
    $scope.goPay = function (applyId) {
        // 申请信息
        listCaseAnswer(applyId);

        // 去支付页
        $scope.step = 2;
        listSlideStep($scope.step);

        // 计算费用
        CasePrintService.calcPay(applyId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.base_pay = result.base_pay.toFixed(2);
                $scope.single_pay = result.single_pay;
            }
        })
    }

    // 5.不支付
    $scope.unPay = function () {
        $ionicPopup.confirm({
            title: '操作确认',
            template: '正在进行<span class="calm">取消支付</span>，<span class="calm">取消支付</span>的订单不会进入审核流程，是否取消支付?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                // 回列表页
                $scope.step = 0;
                listSlideStep($scope.step);
            }
            else { }
        })
    }

    // 6.去邮递
    $scope.goEMS = function (applyId) {
        CasePrintService.checkEmsCode(applyId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.ems_codes = result.dt;
                // 无订单号
                if ($scope.ems_codes.length == 0) {
                    $fwCordovaToast.showShortBottom("未查询到此申请的邮单号");
                }
                // 有订单号 切页
                else {
                    $scope.step = 3;
                    listSlideStep($scope.step);
                }
            }
        })
    }

    // 7.邮递路程信息
    $scope.getEmsTrace = function (ems_code) {
        // 要调接口 带个转圈
        $ionicLoading.show();
        $scope.ems_traces = [];

        CasePrintService.getEmsTrace(ems_code).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                if (result.traces.length == 0) {
                    $fwCordovaToast.showShortBottom("此单号还未生成物流信息，请耐心等待！");
                }
                else {
                    $scope.ems_traces = result.traces;
                    // 页面高度调整
                    $ionicScrollDelegate.resize();
                }
            }
        })
    }

    // 8.选择支付方式
    $scope.changePayMethod = function (type) {
        $scope.pay_method = type;
    }


    // 支付详细相关
    // 9.支付
    $scope.unifiedOrder = function () {

        if ($scope.pay_method != 1 && $scope.pay_method != 6) {
            $fwCordovaToast.showShortBottom("支付方式错误，请选择支付方式！");
            return;
        }

        var pay_method = $scope.pay_method;

        $scope.isWaitPay = true;

        $ionicLoading.show();
        CasePrintService.unifiedOrder($scope.casePrint.CASE_PRINT_APPLY_ID, pay_method).then(function (data) {
            // 出现错误
            if (data.result == 0) {
                $scope.isWaitPay = false;
                // 啊 圈
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                switch (pay_method) {
                    // 微信支付                                               
                    case 1: case "1":
                        {
                            callWXPay(data.data);
                            break;
                        }
                        // 支付宝                                     
                    case 6: case "6":
                        callAliPay(data.data);
                        break;
                    // 其他                                               
                    default:
                        $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                        $ionicLoading.hide();
                        break;
                }
            }
        })
    }

    // 9.1.微信支付
    function callWXPay(paydata) {
        // 订单号
        $scope.outTradeNo = paydata.out_trade_no;
        // 支付状态
        $scope.appResult = "";
        $scope.fromWeixin = false;
        // 注册后台唤醒事件
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                $fwCordovaToast.showShortBottom("开始WXPaySuccess");
                WXPaySuccess(data);
            }, function (error) {
                $fwCordovaToast.showShortBottom("开始WXPayFailed");
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $scope.isWaitPay = false;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            return;
        }
    }

    // 9.1.1.微信支付成功
    function WXPaySuccess(statusCode) {
        // 支付状态
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                // 去检查HIS是否处理
                checkHisDealWithPay($scope.casePrint.CASE_PRINT_APPLY_ID);
            }
            // 验证失败
            else {
                $scope.isWaitPay = false;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $scope.isWaitPay = false;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
        })

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
    }

    // 9.1.2 微信支付失败
    function WXPayFailed(statusCode) {
        // 支付状态
        $scope.appResult = statusCode;
        $scope.isWaitPay = false;
        $fwCordovaToast.showShortBottom(-1 == statusCode ? "支付错误" : "用户取消或支付超时");

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
        // 啊 圈
        $ionicLoading.hide();
    }

    // 9.2.支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        // 订单号
        $scope.outTradeNo = aliBizContent.out_trade_no;
        // 支付结果
        $scope.appResult = "";

        // 注册后台唤醒事件
        document.addEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = false;
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $scope.isWaitPay = false;
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 9.2.1.支付宝支付成功
    function AliPaySuccess(statusCode) {
        // 支付结果
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                // 去检查HIS是否处理
                checkHisDealWithPay($scope.casePrint.CASE_PRINT_APPLY_ID);
            }
            // 验证失败
            else {
                $scope.isWaitPay = false;
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $scope.isWaitPay = false;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
        })

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
    }

    // 9.2.2.支付宝支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        switch (statusCode.resultStatus) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }

        $scope.isWaitPay = false;
        $fwCordovaToast.showShortBottom(errMsg);

        // 默默回调一下
        PaymentService.appCallback($scope.casePrint.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) { });

        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;

        // 支付方式重置
        $scope.pay_method = 1;
        // 订单号重置
        $scope.outTradeNo = "";
        // 支付状态重置
        $scope.appResult = "";
        // 啊 圈
        $ionicLoading.hide();
    }

    // 9.3.验证HIS是否处理
    checkHisDealWithPay = function (applyId) {
        setTimeout(function () {
            CasePrintService.checkHisDealWithPay(applyId).then(function (result) {
                // 啊 圈
                $ionicLoading.hide();
                $scope.isWaitPay = false;

                // HIS处理了 但处理失败
                if (result.result == 0) {
                    $fwCordovaToast.showShortBottom(result.msg);
                }
                else if (result.result == 1) {
                    $fwCordovaToast.showShortBottom("复印费用缴纳成功，申请进入审核流程，请耐心等待!");
                    // 重加载
                    loadCaseList();

                    // 缓一缓
                    setTimeout(function () {
                        // 切页
                        $scope.step = 0;
                        listSlideStep($scope.step);
                    }, 1500);

                }
            });

        }, 1500);
    }

    // 后台唤醒 取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $ionicLoading.show();
                // 查询支付状态
                PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
                    // 真·支付成功
                    if (data.result == 1) {
                        // 默默回调
                        PaymentService.appCallback($scope.casePrint.CASE_PRINT_APPLY_ID, $scope.outTradeNo, "0").then(function (data) { });

                        checkHisDealWithPay($scope.casePrint.CASE_PRINT_APPLY_ID);
                    }
                    // 虚假的支付成功
                    else {
                        // 默默回调
                        PaymentService.appCallback($scope.casePrint.CASE_PRINT_APPLY_ID, $scope.outTradeNo, "-1").then(function (data) { });

                        $scope.isWaitPay = false;
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
                    }

                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;


                    // 支付方式重置
                    $scope.pay_method = 1;
                    // 订单号重置
                    $scope.outTradeNo = "";
                    // 支付状态重置
                    $scope.appResult = "";

                    $ionicLoading.hide();
                });
            }
        }, 1000);
    }


    // slide切换
    // 1.切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 2.后退
    $scope.goBack = function () {
        // 回个人中心
        if ($scope.step == 0) {
            $state.go("app.personal");
        }
        // 回列表
        else {
            // 邮递信息重置
            $scope.ems_traces = [];
            // 单份费用重置
            $scope.single_pay = 0;
            // 总费用重置
            $scope.base_pay = 0;

            $scope.step = 0;
            listSlideStep($scope.step);
        }
    }

    // 3.1.跳页
    listSlideStep = function (step) {
        casePrintListSlide.slide(step);
        $ionicScrollDelegate.resize();
    }
    // 3.2.上一步
    listNextStep = function () {
        $scope.step++;
        listSlideStep($scope.step);
    }
    // 3.3.下一步
    listLastStep = function () {
        $scope.step--;
        listSlideStep($scope.step);
    }



    // 页面的进入与退出
    // 1.准备
    ionic.DomUtil.ready(function () {
        // 禁用左右滑动
        casePrintListSlide.enableSlide(false);
    });

    // 2.进入（多次）
    $scope.$on('$ionicView.enter', function () {
        // 加载申请列表
        loadCaseList();

        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'casePrintList');
    });

    // 3.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'casePrintList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
});