﻿angular.module('fwapp.controllers')

.controller('cashierController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast
, PaymentService, VisitPatientService, CashierService, OpPaymentService) {

    // 支付途径
    $scope.paymentInfo = new Object();
    $scope.paymentInfo.method = "1";
    $scope.paymentInfo.methodCH = "微信支付";
    $rootScope.paymentRouteList = [];
    // 页面标记位
    $rootScope.cashierShowIndex = 0;
    // 从微信返回
    $scope.fromWeixin = true;
    // 商户订单号
    $scope.outTradeNo = "";
    // 微信支付返回结果
    $scope.appResult = "";
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 倒计时
    $scope.cashierCountdown = 10;
    // 门诊缴费opPaymentId
    $scope.opPaymentId = "";
    // 北京医保的url
    $scope.bjybPageUrl = "";

    // 切换支付方式
    $scope.switchPaymentMethod = function (value) {
        var method = $scope.filterPaymentMethod(value);
        if (method == null) {
            $fwCordovaToast.showShortBottom('当前支付方式不可用, 请选择其他支付方式');
            return;
        }
        // 不可用
        if (method.status == "0") {
            $fwCordovaToast.showShortBottom(method.descr);
            return;
        }
        if (value == 0 && !$scope.isBalanceEnable) {
            $fwCordovaToast.showShortBottom("余额不足，不够本次支付");
            return;
        }
        $scope.paymentInfo.method = method.value;
        if (value == '1') {
            $scope.paymentInfo.methodCH = "微信支付";
        }
        else if (value == '6') {
            $scope.paymentInfo.methodCH = "支付宝支付";
        }
        else if (value == '4') {
            $scope.paymentInfo.methodCH = "银联支付";
        }
        else if (value == '0') {
            $scope.paymentInfo.methodCH = "门诊预存账户支付";
        }
        else if (value == '10') {
            $scope.paymentInfo.methodCH = "医保移动支付";
        }
    }

    // 筛选支付方式
    $scope.filterPaymentMethod = function (value) {
        return $rootScope.paymentRouteList.filter(e => e.value == value)[0];
    }

    // 余额是否可用
    $scope.isBalanceEnable = function () {
        return Number($scope.cashierBalance) > 0 && Number($scope.cashierBalance) >= Number($scope.cashierMoney);
    }

    // 关闭模态框
    $scope.closeModel = function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'cashierBackbutton') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        $scope.cashierClose();
        // 终止定时器
        $interval.cancel($scope.timer);
        $scope.paymentInfo.method = "";
    }

    // 重新支付
    $scope.headOrder = function () {
        $rootScope.cashierShowIndex = 0;

        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $scope.cashierCountdown = 10;
        $interval.cancel($scope.timer);
    }

    // 继续支付
    $scope.againOrder = function () {
        if ($scope.paymentInfo.method == "10") {
            // 获取订单状态，如果还是这个时候成功了，就跳转成功，如果失败了，就跳转的
            $scope.paymentGetTradeStatus("1");
        }
        else {
            $scope.unifiedOrder();
        }
    }

    // 完成支付
    $scope.endOrder = function () {
        if ($scope.outTradeNo == "") {
            $fwCordovaToast.showShortBottom("订单尚未支付成功");
        }
        else {
            // 提出了公共的方法
            $scope.paymentGetTradeStatus();
        }
    }

    // 支付
    $scope.unifiedOrder = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // loading
        $rootScope.cashierShowIndex = 1;

        // 判断是不是10，因为有可能是重新支付过来的。
        if ($scope.cashierCountdown == 10) {
            // 开启倒计时
            $scope.timer = $interval(function () {
                $scope.cashierCountdown -= 1;
            }, 1000, 10);
        }

        // 初始化
        $scope.vpInfo = new Object();
        $scope.payData = new Object();

        var prepaidType = 1;// 门诊or住院
        var rlatObjType = "";// 转换成大写的type
        var money = $scope.cashierMoney;
        // 门诊预存充值，可以用
        if ($scope.cashierDescr == "payment") {
        }
        // 在线问诊（易复诊）
        else if ($scope.cashierDescr == "consultation") {
            rlatObjType = "BY_TREAT";
        }
        // 在线简易门诊，视频问诊
        else if ($scope.cashierDescr == "olTreat") {
            rlatObjType = "OL_TREAT";
        }
        // 在线简易门诊,药品快递到家
        else if ($scope.cashierDescr == "olTreatExpress") {
            rlatObjType = "OL_TREAT_EXPRESS";
        }
        // 核酸检测预约
        else if ($scope.cashierDescr == "coronavirus") {
            rlatObjType = "NCP_APPLY";
        }
        // 急诊预存充值
        else if ($scope.cashierDescr == "emrCharge") {
            prepaidType = 3;
            rlatObjType = "EMR_CHARGE";
        }
        // 医师服务费，补、0挂
        else if ($scope.cashierDescr == "medicalService") {
            rlatObjType = "MEDICAL_SERVICE";
        }
        // 门诊缴费，暂未启用
        else if ($scope.cashierDescr == "opPayment") {
            rlatObjType = "OP_PAYMENT";
        }
        // 预约挂号缴费，暂未启用
        else if ($scope.cashierDescr == "opAppt") {
            rlatObjType = "REG_REGISTER";
        }
        // 住院预存充值，暂未启用
        else if ($scope.cashierDescr == "ipCharge") {
            prepaidType = 2;
            rlatObjType = "IP_CHARGE";
        }
        // 病案复印押金，暂未启用
        else if ($scope.cashierDescr == "casePrint") {
            rlatObjType = "CASE_PRINT";
        }

        // 医保移动支付链接初始化
        $scope.bjybPageUrl = "";

        // 统一下单
        CashierService.unifiedOrder($scope.cashierVpId, prepaidType, $scope.cashierDescrCH, money, rlatObjType, $scope.cashierRlatObjId, $scope.paymentInfo.method, $scope.cashierFeeItem, $scope.cashierDoctorCode
            , $scope.cashierBalance, $scope.cashierMedicalServiceType, $scope.cashierDoctorName, $scope.cashierMedicalServiceDate, $scope.cashierRegLevelCode, $scope.cashierRegLevelName).then(function (data) {
            if (data.result == 1) {
                $scope.vpInfo = data.data.patient;
                $scope.payData = data.data.payData;

                $scope.opPaymentId = data.data.opPaymentId;
                if ((rlatObjType == "OL_TREAT_EXPRESS" || rlatObjType == "NCP_APPLY") && $scope.paymentInfo.method == "0") {
                    if ($scope.opPaymentId != undefined && $scope.opPaymentId != null && $scope.opPaymentId != "") {
                        // 查询缴费状态
                        OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (dataOpPay) {
                            // 获取成功 result = 1
                            if (dataOpPay.result == 1) {
                                // 缴费成功
                                if (dataOpPay.payment_result == 1) {
                                    $scope.payResult.code = 1;
                                    $scope.payResult.data = $scope.opPaymentId;
                                    $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                    $rootScope.cashierShowIndex = 2;
                                }
                                // 缴费失败
                                else {
                                    $scope.payResult.code = 0;
                                    $scope.payResult.data = dataOpPay.msg;
                                    $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                    $rootScope.cashierShowIndex = 3;
                                }
                            }
                            // 获取失败
                            else {
                                $fwCordovaToast.showShortBottom(dataOpPay.msg);
                            }
                        }, function (dataOpPay) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(dataOpPay.msg);
                        })
                    }
                    else {
                        // 为空的话，支付失败了
                        $scope.payResult.code = 0;
                        $scope.payResult.data = "支付方式为预交金支付，但是opPaymentId是空的";
                        $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                        $rootScope.cashierShowIndex = 3;
                    }
                }
                else {
                    $scope.pay($scope.payData, data.data.jumpBJYBMiniProgram);
                }
            }
            else {
                // 失败返回
                $scope.payResult.code = 0;
                $scope.payResult.data = data.msg;
                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                $fwCordovaToast.showShortBottom(data.msg);
                $rootScope.cashierShowIndex = 3;
            }
        })
    }

    // 统一支付选择入口
    $scope.pay = function (data, jumpBJYBMiniProgram) {
        switch ($scope.paymentInfo.method) {
            case 1: case "1":
                callWXPay(data);
                break;
            case 4: case "4":
                $scope.fromWeixin = false;
                $scope.outTradeNo = data;
                //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                //$cordovaInAppBrowser.open(serviceUrl + "/Payment/OrderResult?orderId=" + data, '_blank', option).then(function (event) { })
                //2023.7.31 新插件原有调用方式参数不生效
                var inapp = showInAppBrowser(serviceUrl + "/Payment/OrderResult?orderId=" + data, '_blank');

                // 添加状态监听器
                inapp.addEventListener('exit', function (event) {
                    //console.log('InAppBrowser exit加载：' + event.url);
                    OnResume();
                });

                inapp.addEventListener('loadstart', function (event) {
                    //console.log('InAppBrowser loadstart加载：' + event.url);
                    if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
                        || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
                        || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
                        if (event.url.endsWith("Success")) {
                            WXPaySuccess(0);
                        } else if (event.url.endsWith("Failed")) {
                            WXPayFailed(-2);
                        }

                        $cordovaInAppBrowser.close();
                    }
                });
                break;
            case 6: case "6": // 支付宝
                callAliPay(data);
                break;
            case 10: case "10": // 医保移动支付
                $scope.fromWeixin = false;
                $scope.outTradeNo = data;

                // 暂时只支持支付宝小程序
                $scope.bjybMobilePayment("zfb", jumpBJYBMiniProgram);
                break;
            default: // 其他
                // 失败返回信息
                $scope.payResult.code = 0;
                $scope.payResult.data = "暂不支持所选的支付方式";
                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                break;
        }
    }

    // 分平台调用微信支付插件
    function callWXPay(paydata) {
        $scope.outTradeNo = paydata.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $rootScope.cashierShowIndex = 3;
            $scope.payResult.code = 0;
            $scope.payResult.data = "您的系统暂不支持微信支付";
            $scope.payResult.paymentMethod = "";
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            return;
        }
    }

    // 监听inAppBrowser页面跳转，若到支付结果页，关闭inAppBrowser并跳转结果页面
    $rootScope.$on("$cordovaInAppBrowser:loadstart", function (e, event) {
        if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
            || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
            || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
            if (event.url.endsWith("Success")) {
                WXPaySuccess(0);
            } else if (event.url.endsWith("Failed")) {
                WXPayFailed(-2);
            }

            $cordovaInAppBrowser.close();
        }
    })

    // 用户直接关闭弹出支付Browser处理
    $rootScope.$on("$cordovaInAppBrowser:exit", function (e, event) {
        //console.log('cashierController$$$InAppBrowser exit加载：' + event.url);
        OnResume();
    })

    // 后台唤醒 取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $scope.paymentGetTradeStatus();
            }
        }, 1000);
    }

    // 查询支付状态，进行一下封装
    $scope.paymentGetTradeStatus = function (againOrder) {
        // 查询支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            var paymentStatus = false;
            // 真·支付成功
            if (data.result == 1) {
                paymentStatus = true;
                // 回调 保存到服务器
                PaymentService.appCallback($scope.cashierVpId, $scope.outTradeNo, "0").then(function (data) {
                });
                if ($scope.opPaymentId != undefined && $scope.opPaymentId != null && $scope.opPaymentId != "") {
                    // 查询缴费状态
                    OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (dataOpPay) {
                        // 获取成功 result = 1
                        if (dataOpPay.result == 1) {
                            // 缴费成功
                            if (dataOpPay.payment_result == 1) {
                                $scope.payResult.code = 1;
                                $scope.payResult.data = $scope.opPaymentId;
                                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                $rootScope.cashierShowIndex = 2;
                            }
                            // 缴费失败
                            else {
                                $scope.payResult.code = 0;
                                $scope.payResult.data = dataOpPay.msg;
                                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                $rootScope.cashierShowIndex = 3;
                            }
                        }
                        // 获取失败
                        else {
                            $fwCordovaToast.showShortBottom(dataOpPay.msg);
                        }
                    }, function (dataOpPay) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(dataOpPay.msg);
                    })
                }
                else {
                    $scope.payResult.code = 1;
                    $scope.payResult.data = data.data;
                    $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                    $rootScope.cashierShowIndex = 2;
                }
            }
            // 支付失败或支付取消
            else {
                paymentStatus = false;
            }

            // 支付成功了
            if (paymentStatus == true) {
                // 解绑后台唤醒事件监测
                document.removeEventListener("resume", OnResume, false);
                // 由微信回调返回
                $scope.fromWeixin = true;
                $scope.outTradeNo = "";
                $scope.appResult = "";
            }
            else {
                // 支付失败，要区分医保移动支付还是自费
                if ($scope.paymentInfo.method == "10") {
                    // 医保支付失败了，可能是没支付，或者支付成功未回调，这里先什么都不做，打个console出来看看。
                    console.log("医保移动支付失败");
                    console.log(data);

                    // 如果患者点了，手动调起
                    if (againOrder == "1") {
                        if ($scope.bjybPageUrl == "") {
                            $fwCordovaToast.showShortBottom("订单上传中，请稍后");
                        }
                        else {
                            $scope.bjybMobilePayment("zfb", $scope.bjybPageUrl);
                        }
                    }
                }
                // 自费
                else {
                    // 支付失败
                    $rootScope.cashierShowIndex = 3;
                    $scope.payResult.code = 0;
                    $scope.payResult.data = "网络异常, 请稍后重试";
                    $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                    $fwCordovaToast.showShortBottom("订单尚未支付成功");
                    // 回调 保存到服务器
                    PaymentService.appCallback($scope.cashierVpId, $scope.outTradeNo, "-1").then(function (data) {
                    });

                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;
                    $scope.outTradeNo = "";
                    $scope.appResult = "";
                }
            }
        });
    }

    // 支付成功
    function WXPaySuccess(statusCode) {
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                if ($scope.opPaymentId != undefined && $scope.opPaymentId != null && $scope.opPaymentId != "") {
                    // 查询缴费状态
                    OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (dataOpPay) {
                        // 获取成功 result = 1
                        if (dataOpPay.result == 1) {
                            // 缴费成功
                            if (dataOpPay.payment_result == 1) {
                                $scope.payResult.code = 1;
                                $scope.payResult.data = $scope.opPaymentId;
                                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                $rootScope.cashierShowIndex = 2;
                            }
                            // 缴费失败
                            else {
                                $scope.payResult.code = 0;
                                $scope.payResult.data = dataOpPay.msg;
                                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                $rootScope.cashierShowIndex = 3;
                            }
                        }
                        // 获取失败
                        else {
                            $fwCordovaToast.showShortBottom(dataOpPay.msg);
                        }
                    }, function (dataOpPay) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(dataOpPay.msg);
                    })
                }
                else {
                    $scope.payResult.code = 1;
                    $scope.payResult.data = data.data;
                    $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                    $rootScope.cashierShowIndex = 2;
                }
            }
            //
            else {
                // 支付失败
                $rootScope.cashierShowIndex = 3;
                $scope.payResult.code = 0;
                $scope.payResult.data = data.msg;
                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            // 支付失败
            $rootScope.cashierShowIndex = 3;
            $scope.payResult.code = 0;
            $scope.payResult.data = "网络异常, 请稍后重试";
            $scope.payResult.paymentMethod = $scope.paymentInfo.method;
            $fwCordovaToast.showShortBottom("网络异常, 请稍后重试");
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.cashierVpId, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function WXPayFailed(statusCode) {
        $scope.appResult = statusCode;
        var errorMsg = -1 == statusCode ? "支付错误" : "用户取消或支付超时";

        // 支付失败
        $rootScope.cashierShowIndex = 3;
        $scope.payResult.code = 0;
        $scope.payResult.data = errorMsg;
        $scope.payResult.paymentMethod = $scope.paymentInfo.method;
        $fwCordovaToast.showShortBottom(errorMsg);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.cashierVpId, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        $scope.outTradeNo = aliBizContent.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $rootScope.cashierShowIndex = 3;
            $scope.payResult.code = 0;
            $scope.payResult.data = "您的系统暂不支持支付宝支付";
            $scope.payResult.paymentMethod = "";
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            return;
        }
    }

    // 支付成功
    function AliPaySuccess(statusCode) {
        $scope.appResult = "";
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                if ($scope.opPaymentId != undefined && $scope.opPaymentId != null && $scope.opPaymentId != "") {
                    // 查询缴费状态
                    OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (dataOpPay) {
                        // 获取成功 result = 1
                        if (dataOpPay.result == 1) {
                            // 缴费成功
                            if (dataOpPay.payment_result == 1) {
                                $scope.payResult.code = 1;
                                $scope.payResult.data = $scope.opPaymentId;
                                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                $rootScope.cashierShowIndex = 2;
                            }
                            // 缴费失败
                            else {
                                $scope.payResult.code = 0;
                                $scope.payResult.data = dataOpPay.msg;
                                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                                $rootScope.cashierShowIndex = 3;
                            }
                        }
                        // 获取失败
                        else {
                            $fwCordovaToast.showShortBottom(dataOpPay.msg);
                        }
                    }, function (dataOpPay) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(dataOpPay.msg);
                    })
                }
                else {
                    $scope.payResult.code = 1;
                    $scope.payResult.data = data.data;
                    $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                    $rootScope.cashierShowIndex = 2;
                }
            }
            //
            else {
                // 支付失败
                $rootScope.cashierShowIndex = 3;
                $scope.payResult.code = 0;
                $scope.payResult.data = data.msg;
                $scope.payResult.paymentMethod = $scope.paymentInfo.method;
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            // 支付失败
            $rootScope.cashierShowIndex = 3;
            $scope.payResult.code = 0;
            $scope.payResult.data = "网络异常, 请稍后重试";
            $scope.payResult.paymentMethod = $scope.paymentInfo.method;
            $fwCordovaToast.showShortBottom("网络异常, 请稍后重试");
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.cashierVpId, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        // 2019-11-1 07:42:48 HM 发现阿里接口可能改了，没有statusCode为最终code,statusCode.resultStatus被弃用
        if (statusCode.resultStatus) {
            statusCode = statusCode.resultStatus;
        }
        switch (statusCode) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }
        // 支付失败
        $rootScope.cashierShowIndex = 3;
        $scope.payResult.code = 0;
        $scope.payResult.data = errMsg;
        $scope.payResult.paymentMethod = $scope.paymentInfo.method;
        $fwCordovaToast.showShortBottom("" + errMsg);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.cashierVpId, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 跳转小程序
    $scope.bjybMobilePayment = function (type, jumpBJYBMiniProgram) {
        // 放在作用域里，但实际读的参数，还是入参的参数
        $scope.bjybPageUrl = jumpBJYBMiniProgram;

        if (type == "zfb") {
            // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
            var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent(jumpBJYBMiniProgram));

            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser(herfUrl, '_system');

            document.addEventListener("resume", OnResume, false);

            // var param = { type: "BJYB", url: pageUrl };

            // var funcSuccess = function (data) {
            //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用成功");
            //     console.log(data);
            // }
            // var funcError = function (data) {
            //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用失败");
            //     console.log(data);
            // }

            // window.plugins.MiniProgramPlugin.launchZFBMiniProgramByPageUrl(param, funcSuccess, funcError);
        }
        else {
            $fwCordovaToast.showShortBottom("暂不支持微信小程序");
        }
    }

    $scope.$on('modal.shown', function () {
        // 医保
        console.log("看看收银台中，是不是医保患者");
        console.log($scope.cashierIsMI);
        if ($scope.cashierIsMI == true) {
            $scope.paymentInfo.method = "10";
            $scope.paymentInfo.methodCH = "医保移动支付";
        }

        // 2020-10-23 19:12:04 处理返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.closeModel();
        }, 250, 'cashierBackbutton');
    });
})
