﻿angular.module('fwapp.controllers')

// 更改手机号
.controller('ChangePhoneNumberController', function ($scope, $rootScope, $ionicHistory, ChangePhoneNumberService, $state, $stateParams, $ionicPopup, $ionicSlideBoxDelegate, $window, $ionicHistory, $ionicPlatform) {

    $scope.title = "验证旧手机号";

    $scope.phone = {
        number: '',
        code: ''
    }

    $scope.newphone = {
        number: '',
        code: ''
    }
    // 验证码发送时间间隔
    $scope.timespan = 0;

    $scope.goBack = function () {
        //        $ionicHistory.goBack();
        $state.go("app.securityCenter");
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'changePhoneNumber');
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
//        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'changePhoneNumber') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
//        }, 500);
    });

    // slide box
    var slideBox = $ionicSlideBoxDelegate.$getByHandle('slideBox');

    //不准滑动
    $scope.lockSilde = function () {
        $ionicSlideBoxDelegate.enableSlide(false);
    }

    //旧手机获取验证码
    $scope.getVerifyCode = function () {
        //如果填写的旧号码正确
        if ($scope.phone.number == $stateParams.phoneNumber) {
            ChangePhoneNumberService.sendVericodeByPhone($stateParams.phoneNumber, "2").then(function (data) {
                // 发送成功
                if (data.result == 1) {
                    // 倒计时
                    $scope.timespan = 60;
                    TimeCount();
                }
                // 服务调用失败
                else if (data.result == 0) {
                    var alertPopup = $ionicPopup.alert({
                        title: '短信验证失败',
                        template: data.msg
                    });
                }
                // 发送次数过多
                else {
                    var alertPopup = $ionicPopup.alert({
                        title: '短信验证失败',
                        template: '获取验证码失败，请稍后重试'
                    });
                }
            });
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '手机号错误',
                template: '您输入的手机号与本账号手机号不符，请检查'
            });
        }
    }

    //验证旧手机验证码
    $scope.verifyCode = function () {
        $scope.accountId = localStorage.currentAccountId;
        // 如果不能获取到accountId，转到登录页，如果能，修改密码
        if ($scope.accountid == '') {
            var alertPopup = $ionicPopup.alert({
                title: '请先登录',
                template: null
            });
            // 删除用户信息
            localStorage.hasLogin = 0;
            $rootScope.hasLogin = 0;
            localStorage.currentAccountId = "";
            // 初始化一下消息中心提示
            // 是否有未读消息
            $rootScope.hasUnread = false;
            $rootScope.unReadCount = 0;
            // 跳转到登录页
            $state.go('login');
        }
        else {
            ChangePhoneNumberService.compareVericode($scope.phone.number, $scope.phone.code, currentPlatform, deviceToken, "2").then(function (data) {
                if (data.result == 1) {
                    slideBox.next();
                    $scope.title = "设置新手机号";
                    $scope.timespan = 0; //倒计时清零
                }
                else {
                    var alertPopup = $ionicPopup.alert({
                        title: '短信验证失败',
                        template: data.msg
                    });
                }
            })
        }
    }

    //新手机获取验证码
    $scope.getVerifyCodeNew = function () {
        ChangePhoneNumberService.sendVericodeByPhone($scope.newphone.number, "3").then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                var alertPopup = $ionicPopup.alert({
                    title: '短信验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '短信验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        });
    }

    //验证新手机验证码
    $scope.verifyCodeNew = function () {
        $scope.accountId = localStorage.currentAccountId;
        // 如果不能获取到accountId，转到登录页，如果能，修改密码
        if ($scope.accountid == '') {
            var alertPopup = $ionicPopup.alert({
                title: '请先登录',
                template: null
            });
            // 删除用户信息
            localStorage.hasLogin = 0;
            $rootScope.hasLogin = 0;
            localStorage.currentAccountId = "";
            // 初始化一下消息中心提示
            // 是否有未读消息
            $rootScope.hasUnread = false;
            $rootScope.unReadCount = 0;
            // 跳转到登录页
            $state.go('login');
        }
        else {
            ChangePhoneNumberService.compareVericode($scope.newphone.number, $scope.newphone.code, currentPlatform, deviceToken, "3").then(function (data) {
                if (data.result == 1) {
                    changePhoneNumber($scope.accountId, $scope.phone.code, $scope.newphone.number, $scope.newphone.code);
                }
                else {
                    var alertPopup = $ionicPopup.alert({
                        title: '短信验证失败',
                        template: data.msg
                    });
                }
            })
        }
    }

    //更改账户手机号
    function changePhoneNumber(accountId, vericode1, newPhoneNumber, vericode2) {
        ChangePhoneNumberService.changePhoneNumber(accountId, vericode1, newPhoneNumber, vericode2).then(function (data) {
            if (data.result == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '修改成功',
                    template: null
                });
                localStorage.hasLogin = 0;
                $rootScope.hasLogin = 0;
                localStorage.currentAccountId = null;
                // 初始化一下消息中心提示
                // 是否有未读消息
                $rootScope.hasUnread = false;
                $rootScope.unReadCount = 0;
                $state.go('login');
            }
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '修改失败',
                    template: data.msg
                });
            }
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
})