﻿angular.module('fwapp.controllers')

.controller('ChangeReservedPhoneController', function ($scope, $rootScope, $state, $http, $window, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform
, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, $fwCordovaToast, $stateParams, $ionicSlideBoxDelegate
, VisitPatientService, OpRegService, AccountService, ChangePhoneNumberService, RequestService) {

    // 检查登录状态
    $rootScope.checkLogin();
    // 定义滑块
    var reservedPhoneSlide = $ionicSlideBoxDelegate.$getByHandle('reservedPhoneSlide');

    // 就这人Id
    $scope.vpId = $stateParams.vpid;
    // 就诊人详情
    $scope.vpInfo = {};
    // 手机号、验证码、图片验证码
    $scope.phoneInfo = {};
    // 手机号
    $scope.phoneInfo.oldPhone = "";
    $scope.phoneInfo.newPhone = "";
    $scope.phoneInfo.oldPhone_show = "";
    // 验证码
    $scope.phoneInfo.oldVerifyCode = "";
    $scope.phoneInfo.newVerifyCode = "";
    // 图片验证码
    $scope.phoneInfo.oldImageVericode = {};
    $scope.phoneInfo.oldImageVericode.src = {};
    $scope.phoneInfo.oldImageVericode.vpImageVericode = "";
    $scope.phoneInfo.newImageVericode = {};
    $scope.phoneInfo.newImageVericode.src = {};
    $scope.phoneInfo.newImageVericode.vpImageVericode = "";
    // 倒计时
    $scope.oldTimespan = 0;
    $scope.newTimespan = 0;
    // 定义初始滑块
    $scope.step = 0;
    // 记一下requestID，用户之后查询原手机号
    $scope.requestId = "";
    // 真实预留手机号
    $scope.phoneNum = "";
    // 查询信息是否有结果
    $scope.loadFinish = false;
    // 错误信息
    $scope.loadMsg = "";

    // #region 滑块相关
    // 滑到上一步
    $scope.lastSlide = function () {
        reservedPhoneSlide.previous();
        $scope.step = reservedPhoneSlide.currentIndex();
    }

    // 滑到下一步
    $scope.nextSlide = function () {
        reservedPhoneSlide.next();
        $scope.step = reservedPhoneSlide.currentIndex();
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        reservedPhoneSlide.slide(index);
        $scope.step = reservedPhoneSlide.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = reservedPhoneSlide.currentIndex();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // #endregion

    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        console.log("自" + $scope.phoneInfo.oldPhone);
        console.log("原" + $scope.phoneNum);
        if ($scope.phoneInfo.oldPhone != $scope.phoneNum) {
            $fwCordovaToast.showShortBottom("原手机号输入有误，请重新输入");
            return;
        }

        // 发送验证码
        $scope.sendVericode($scope.phoneInfo.oldPhone, $scope.phoneInfo.oldImageVericode.vpImageVericode, "old");
    }

    // 检查两次手机号输入的是否一致
    $scope.checkPhoneNum = function () {
        if ($scope.phoneInfo.oldPhone == $scope.phoneInfo.newPhone) {
            $fwCordovaToast.showShortBottom("与原手机号一致，请重新输入");
            return;
        }

        $scope.sendVericode($scope.phoneInfo.newPhone, $scope.phoneInfo.newImageVericode.vpImageVericode, 'new');
    }

    // 提交修改
    $scope.submit = function () {
        $ionicLoading.show();
        // 传旧手机号、新手机号
        RequestService.changeReservedPhone($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, $scope.phoneInfo.oldPhone, $scope.phoneInfo.newPhone, $scope.phoneInfo.oldVerifyCode, $scope.phoneInfo.newVerifyCode).then(function (data) {
            if (data.result == 99) {    // 链接超时
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }

            if (data.is_null != 1) {
                $ionicLoading.hide();

                $ionicPopup.alert({
                    title: "提示",
                    template: "修改预留手机号成功",
                    okText: "确定"
                }).then(function (res) {
                    $state.go("app.visitPatient", { vpid: $scope.vpId });
                });
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误，修改预留手机号失败2");
                $ionicLoading.hide();
            }
        }, function () {
            // 真的网络错误 
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，修改预留手机号失败1");
        })
    }

    // 获取图片验证码 (公共)
    $scope.getImageVericode = function (type) {
        AccountService.getImageVericode().then(function (data) {
            console.log(type);
            // 需要验证码
            if (data.result == 1) {
                if (type == "old") {
                    $scope.phoneInfo.oldImageVericode.src = "data:image/jpeg;base64," + data.data;
                    $scope.phoneInfo.oldImageVericode.vpImageVericode = "";
                }
                else {
                    $scope.phoneInfo.newImageVericode.src = "data:image/jpeg;base64," + data.data;
                    $scope.phoneInfo.newImageVericode.vpImageVericode = "";
                }
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
        });
    }

    // 发送短信验证码 (公共)
    $scope.sendVericode = function (phone, imageVericode, type) {
        $ionicLoading.show();

        var usage = "";
        if (type == "old") {
            usage = "2";
        }
        else {
            usage = "3";
        }

        // 向旧手机号发送验证码
        AccountService.sendVericodeByPhone(phone, usage, imageVericode).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("已向您的手机发送验证码，请填写验证码");

                if (type == "old") {
                    // 倒计时
                    $scope.oldTimespan = 60;
                    OldTimeCount();
                }
                else {
                    // 倒计时
                    $scope.newTimespan = 60;
                    NewTimeCount();
                }
            }
            else {
                $scope.getImageVericode(type);
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 比对验证码 (公共)
    $scope.compareVericode = function (phone, vericode, type) {
        var usage = "";
        if (type == "old") {
            usage = "2";
        }
        else {
            usage = "3";
        }

        $ionicLoading.show();
        ChangePhoneNumberService.compareVericode(phone, vericode, currentPlatform, deviceToken, usage).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                console.log("验证成功" + type);
                if (type == "old") {
                    // 如果是旧的，直接跳下一页
                    $scope.getImageVericode("new");
                    $scope.toSlide(2);
                }
                else {
                    $scope.submit();
                }
            }
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg,
                    okText: "确定"
                });
            }
        })
    };

    // 倒计时
    function OldTimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.oldTimespan = $scope.oldTimespan - 1);
        } else {
            $scope.oldTimespan = $scope.oldTimespan - 1;
        }
        resendTimeer = setTimeout(OldTimeCount, 1000);
        if ($scope.oldTimespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    function NewTimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.newTimespan = $scope.newTimespan - 1);
        } else {
            $scope.newTimespan = $scope.newTimespan - 1;
        }
        resendTimeer = setTimeout(NewTimeCount, 1000);
        if ($scope.newTimespan <= 0) {
            clearTimeout(resendTimeer);
        }
    }

    // 跳转
    $scope.goBack = function () {
        if ($scope.step == 0 || $scope.step == 1) {
            // 跳转到就诊人管理
            $state.go("app.visitPatient", { vpid: $scope.vpId });
        }
        else if ($scope.step == 2) {
            $scope.toSlide(1);
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        reservedPhoneSlide.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'changeReservedPhone');

        // 获取就诊人详情
        $ionicLoading.show();
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            console.log(data);
            if (data.result == 0) {
                $ionicLoading.hide();
                $scope.loadFinish = true;
                $scope.loadMsg = data.msg;
            }
            else {
                $scope.vpInfo = data.data;
                $scope.vpInfo.oldPhone = "";
                $scope.vpInfo.newPhone = "";
                $scope.phoneNum = "";

                if (data.data.IS_BIND_CARD != '1') {
                    $scope.loadFinish = true;
                    $scope.loadMsg = "就诊人未绑定就诊卡，请绑卡后重试";
                }

                // 直接拿手机号
                RequestService.GetReservedPhone($scope.vpId).then(function (dataPC) {
                    $ionicLoading.hide();
                    // 成功
                    if (dataPC.result == 1 && dataPC.is_null != 1) {
                        // 放在成功这赋值
                        $scope.requestId = dataPC.data[0].REQUEST_ID;
                        // 将真正的预留手机号手机号记录一下
                        $scope.phoneNum = dataPC.data[0].PHONENUM;

                        if ($scope.phoneNum != "") {
                            // 获取图片验证码
                            $scope.getImageVericode("old");
                            $scope.toSlide(1);

                            // 2020-9-18 10:45:51 HM 白老师上午说，把原手机号带进去
                            $scope.phoneInfo.oldPhone = $scope.phoneNum;
                            // 将手机号脱敏，加星
                            $scope.phoneInfo.oldPhone_show = $scope.phoneNum.toString().substring(0, 3) + "****" + $scope.phoneNum.toString().substring(7, $scope.phoneNum.toString().length);
                        }
                        else {
                            $scope.loadFinish = true;
                            $scope.loadMsg = "未找到就诊人预留手机号信息";
                        }
                    }
                    else if (dataPC.result == 99) {
                        $scope.loadFinish = true;
                        $scope.loadMsg = "网络错误，连接服务器超时请稍后重试";
                    }
                    else {
                        $scope.loadFinish = true;
                        $scope.loadMsg = dataPC.msg;
                    }
                }, function (data) {
                    // 获取失败 显示 点击重新获取
                    $scope.loadFinish = true;
                    $scope.loadMsg = "网络错误，获取预留手机号请稍后重试";
                })
            }
        })
    });

    // 页面退出
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'changeReservedPhone') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})