﻿angular.module('fwapp.controllers')

// 检查预约
.controller('CheckApptController', function ($scope, $rootScope, $state, $stateParams, $timeout, $fwCordovaToast, RequestService, PersonalService
    , $ionicModal, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, dateFilter) {
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }
    // 检查预约列表
    $scope.checkApptList = [];
    // 获取检查预约状态
    $scope.isLoading = false;
    // 检查预约序列
    $scope.checkApptIndex = 0;
    // 检查可改约日期数据
    $scope.apptSchedDate = [];
    // 检查预约日期 给控件用的
    $scope.apptDate = {};
    $scope.apptDate.target = "";
    $scope.apptDate.targetOri = "";
    $scope.apptDate.dateMode = "white";
    $scope.apptDate.dateList = [];
    $scope.apptDate.minDate = "1970-01-01";
    $scope.apptDate.maxDate = "1970-01-01";
    // 缓存
    $scope.apptDate.targetCache = "";
    // 改期时段
    $scope.apptDate.targetTime = "";
    $scope.apptDate.targetTimeOri = "";
    // 改期时段ID
    $scope.apptDate.timeAreaId = "";
    // 是否正在改期
    $scope.isChangingDate = false;
    // 打哪儿来
    $scope.from = $stateParams.from;

    // 2022-1-19 10:11:14 HM #49853 检查预约改约bug，index有问题，这里记录检查单号
    $scope.CHECK_APPT_ID = "";
    $scope.checkSign = {};

    // 注册模态窗口：检查预约详情
    $ionicModal.fromTemplateUrl('checkApptDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.checkApptDetailModal = modal;
    });

    // 注册模态窗口：预约改期
    $ionicModal.fromTemplateUrl('changeApptDate.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.changeApptDateModal = modal;
    });

    // 注册模态窗口：知情同意书签字
    $ionicModal.fromTemplateUrl('informedConsent.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.InformedConsentModal = modal;
    });

    // 注册模态窗口：患者签字窗口
    $ionicModal.fromTemplateUrl('patientSign.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.patientSignModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.checkApptDetailModal.remove();
        $scope.changeApptDateModal.remove();
        //cfw 2023年2月22日17:51:35 增加模态窗销毁
        $scope.InformedConsentModal.remove();
        $scope.patientSignModal.remove();
    })

    // 预约详情模态窗口显示
    $scope.checkApptDetailShow = function (index) {
        $scope.checkApptIndex = index;

        // 初次赋值
        $scope.CHECK_APPT_ID = $scope.checkApptList[index].CHECK_APPT_ID;

        $scope.checkApptDetailModal.show();
        $ionicScrollDelegate.$getByHandle('checkAppt').scrollTop();
    }
    // 预约详情模态窗口隐藏
    $scope.checkApptDetailHide = function () {
        $scope.checkApptDetailModal.hide();
        $scope.checkApptIndex = 0;
    }
    // 知情同意书签字模态窗口显示
    $scope.InformedConsentShow = function () {
        event.stopPropagation();
        $scope.InformedConsentModal.show();
        $ionicScrollDelegate.scrollTop();
    }
    // 知情同意书签字模态窗口隐藏
    $scope.InformedConsentHide = function () {
        // cfw 2023年3月25日20:13:43 返回时清空知情 同意书签名
        $scope.checkSign.hzqm_img_show = "";
        $scope.checkSign.jsqm_img_show = "";
        $scope.checkSign.button_HZQM_enable = false;
        $scope.checkSign.button_JSQM_enable = false;
        $scope.checkSign.Modify_flag = true;
        $scope.InformedConsentModal.hide();
    }

    // 患者签字模态窗口显示
    $scope.PatientSignShow = function () {
        event.stopPropagation();
        $scope.patientSignModal.show();
    }
    // 患者签字模态窗口隐藏
    $scope.PatientSignHide = function () {
        $scope.patientSignModal.hide();
    }
    // 获取检查预约列表
    $scope.getCheckApptList = function (isChangeSched) {
        $ionicLoading.show();
        $scope.isLoading = true;
        RequestService.checkApptList().then(function (data) {
            //console.log(JSON.stringify(data));
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        $scope.loadResult = 3;
                    } else {
                        // 有记录
                        $scope.loadResult = 0;
                        $scope.checkApptList = data.data;
                    }
                    $ionicLoading.hide();
                    $scope.isLoading = false;
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            $scope.isLoading = false;
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckApptList();
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $scope.loadResult = 3;
                return;
            }
            // 后边遍历获取条形码 可能耗时较长
            $ionicLoading.show();
            // 格式化数据
            for (var i in data.data) {
                // 检查日期
                if (data.data[i].hasOwnProperty("ORDER_DATE") && data.data[i]["ORDER_DATE"] != null && data.data[i]["ORDER_DATE"].length > 0) {
                    data.data[i]["ORDER_DATE_FORMAT"] = new Date(data.data[i]["ORDER_DATE"]).Format("yyyy年M月d日");
                }
                // 注意事项
                if (data.data[i].hasOwnProperty("PRECAUTIONS") && data.data[i]["PRECAUTIONS"] != null && data.data[i]["PRECAUTIONS"].length > 0) {
                    data.data[i]["PRECAUTIONS_FORMAT"] = data.data[i]["PRECAUTIONS"].split("|  ").join("").split("|");
                }
                // 温馨提示
                if (data.data[i].hasOwnProperty("TIPS") && data.data[i]["TIPS"] != null && data.data[i]["TIPS"].length > 0) {
                    data.data[i]["TIPS_FORMAT"] = data.data[i]["TIPS"].split("|").join("").split("|");
                }
                // 2019-9-5 09:53:01 由于iOS审核被拒 检查号序着急上线 暂时拼在了检查时间后边 老版本直接显示 新版本需判断截断字符串
                if (data.data[i].hasOwnProperty("ORDER_TIME") && data.data[i]["ORDER_TIME"] != null && data.data[i]["ORDER_TIME"].length > 0
                    && data.data[i]["ORDER_TIME"].indexOf("   ") > -1 && $scope.formatOrderNum(data.data[i]["ORDER_NUM"]) > 0) {
                    data.data[i]["ORDER_TIME"] = data.data[i]["ORDER_TIME"].substr(0, data.data[i]["ORDER_TIME"].indexOf("   "));
                }

                // 2022-1-19 10:33:21 HM 如果是改约，查一下checkAppid
                if (isChangeSched && $scope.CHECK_APPT_ID == data.data[i]["CHECK_APPT_ID"]) {
                    $scope.CHECK_APPT_ID = data.data[i]["CHECK_APPT_ID"];
                    $scope.checkApptIndex = i;
                }
            }
            // 卡号条形码列表
            var barcodeList = [];
            var ajaxCount = 0;
            // 假`就诊卡号列表
            var hisCardNumList = new Set(data.data.map(e => e["PATIENT_ID"]));
            console.log(hisCardNumList);
            hisCardNumList.forEach(hisCardNum => {
                ajaxCount++;
                PersonalService.getCardCodeBarcode("", hisCardNum).then(function (dataBarcode) {
                    // 获取成功
                    if (dataBarcode.result == 1) {
                        // 把条形码赋值给预约单
                        for (var i in data.data) {
                            if (data.data[i]["PATIENT_ID"] == hisCardNum) {
                                data.data[i]["BARCODE_SRC"] = "data:image/jpeg;base64," + dataBarcode.data;
                            }
                        }
                    }
                    // 获取失败
                    else {
                        ;
                    }
                    ajaxCount--;
                    // 已全部返回
                    if (ajaxCount == 0) {
                        $ionicLoading.hide();
                    }

                }, function (dataBarcode) {
                    ajaxCount--;
                    // 已全部返回
                    if (ajaxCount == 0) {
                        $ionicLoading.hide();
                    }
                });
            });

            $scope.checkApptList = data.data;
            console.log($scope.checkApptList);
            // 改期回调
            if (isChangeSched) {
                // 隐藏改期窗口
                $scope.changeApptDateHide();
            }
        })
    }

    // 2019-8-29 17:06:46 由于Number()在页面调用返回false 提到function里
    $scope.formatOrderNum = function (strOrderNum) {
        if (!strOrderNum || strOrderNum.length == 0) {
            return 0;
        }
        var orderNum = Number(strOrderNum);
        return orderNum > 0 ? orderNum : 0;
    }

    // 返回按钮
    $scope.goBack = function () {
        if ($scope.from == "app.message" || $scope.from == "app.specialNeeds") {
            $rootScope.goBack();
        }
        else {
            $state.go('app.home');
        }
    }

    // 获取检查预约列表
    $scope.getCheckItemSched = function () {
        // 不可改期
        if ($scope.checkApptList[$scope.checkApptIndex].MODIFY_STATUS != "1") {
            if ($scope.checkApptList[$scope.checkApptIndex].MODIFY_STATUS_REMARK != "") {
                $fwCordovaToast.showShortBottom($scope.checkApptList[$scope.checkApptIndex].MODIFY_STATUS_REMARK);
            }
            return;
        }
        $ionicLoading.show();
        RequestService.getCheckItemSched($scope.checkApptList[$scope.checkApptIndex].PATIENT_ID, $scope.checkApptList[$scope.checkApptIndex].MEDICIAL_ITEM_ID).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        // 有记录
                        $scope.formatCheckItemSchedData(data.data);
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.formatCheckItemSchedData(data.data);
        })
    }

    // 格式化并赋值预约改期数据
    $scope.formatCheckItemSchedData = function (data) {
        // 格式化日期
        data.forEach(e => e["ORDER_DATE_FORMAT"] = new Date(e["ORDER_DATE"]).Format("yyyy-MM-dd"));
        // 先赋值 待选择日期后处理
        $scope.apptSchedDate = data;
        console.log($scope.apptSchedDate);
        // 可预约日期列表
        var dateList = new Set(data.map(e => e["ORDER_DATE_FORMAT"]));
        $scope.apptDate.dateList = Array.from(dateList).sort();
        if ($scope.apptDate.dateList.length > 0) {
            $timeout(function () {
                $scope.apptDate.minDate = $scope.apptDate.dateList[0];
                $scope.apptDate.maxDate = $scope.apptDate.dateList[$scope.apptDate.dateList.length - 1];
                console.log($scope.apptDate.minDate + " - " + $scope.apptDate.maxDate);
            }, 0);
        }
        console.log($scope.apptDate.dateList);
        // 当前选择日期
        var dateTarget = $scope.checkApptList[$scope.checkApptIndex].ORDER_DATE;
        // 格式化
        if (dateTarget != null && dateTarget.length > 0) {
            dateTarget = new Date(dateTarget).Format("yyyy-MM-dd");
        }
        $scope.apptDate.target = dateTarget;
        // 深度制 脏检测
        $scope.apptDate.targetOri = dateTarget;
        // 时段
        $scope.apptDate.targetTime = $scope.checkApptList[$scope.checkApptIndex].ORDER_TIME;
        $scope.apptDate.targetTimeOri = $scope.checkApptList[$scope.checkApptIndex].ORDER_TIME;
        // 预约改期模态窗口显示
        $scope.changeApptDateShow();
    }
    // 弹出选择时段
    $scope.selectTimeShow = function () {
        console.log("改期: " + $scope.apptDate.targetOri + " => " + $scope.apptDate.target);
        // 过滤ActionSheet的数据源
        var arrTime = $scope.apptSchedDate.filter(e => e["ORDER_DATE_FORMAT"] == $scope.apptDate.target);
        // 遍历生成按钮
        var arrButton = [];
        arrTime.forEach(e => {
            var str = e["ORDER_TIME"];
            // 判断预约状态 加后缀和样式
            if (e["ORDER_STATUS"] == "0") {
                str += " (可预约)";
                str = '<span>' + str + '</span>';
            }
            else {
                str += " (已约满)";
                str = '<span class="fw-action-sheet-error">' + str + '</span>';
            }
            arrButton.push({ text: str });
        });
        console.log(arrButton);
        // 弹出透明loading防止快速连击关闭modal
        $ionicLoading.show({ template: " " });
        // 确定标识
        var isOk = false;
        // 弹出ActionSheet
        var hideSheet = $ionicActionSheet.show({
            buttons: arrButton,
            titleText: "选择预约时段",
            cancelText: "取消",
            cancel: function () {
                // 未选择时段 回滚日期
                if (!isOk) {
                    // 读取缓存
                    if ($scope.apptDate.targetCache == "") {
                        $scope.apptDate.targetCache = $scope.apptDate.targetOri;
                    }
                    $scope.apptDate.target = $scope.apptDate.targetCache;
                }
                hideSheet();
                $timeout(function () {
                    $ionicLoading.hide();
                }, 200)
            },
            buttonClicked: function (index) {
                // 约满
                if (arrTime[index]["ORDER_STATUS"] == "1") {
                    return false;
                }
                console.log(arrTime[index]);
                $scope.apptDate.targetTime = arrTime[index]["ORDER_TIME"];
                $scope.apptDate.timeAreaId = arrTime[index]["TIME_AREA_ID"];
                // 写入缓存
                $scope.apptDate.targetCache = $scope.apptDate.target;
                isOk = true;
                hideSheet();
                $timeout(function () {
                    $ionicLoading.hide();
                }, 200)
            }
        });
    }
    // 预约改期模态窗口显示
    $scope.changeApptDateShow = function () {
        $scope.isChangingDate = true;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
        $scope.changeApptDateModal.show();
        $ionicScrollDelegate.$getByHandle('changeApptDate').scrollTop();
    }
    // 检查预约改期提交
    $scope.checkApptUpdate = function () {
        // 提交改期申请
        $ionicLoading.show();
        console.log($scope.apptDate);
        RequestService.checkApptUpdate($scope.checkApptList[$scope.checkApptIndex].PATIENT_ID, $scope.checkApptList[$scope.checkApptIndex].CHECK_APPT_ID
            , $scope.apptDate.target, $scope.apptDate.timeAreaId).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        console.log(data);
                        // 改期成功
                        if (data.data[0].UPDATE_RESULT == "True") {
                            // 重新获取检查预约列表
                            $scope.getCheckApptList(true);
                        }
                        // 失败
                        else {
                            // 2021-4-11 12:31:35 HM 改成popup的alert
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.data[0].ERROR_MSG,
                                okText: "确定"
                            });
                        }
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请重试",
                    okText: "确定"
                });
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            console.log(data);
            // 改期成功
            if (data.data[0].UPDATE_RESULT == "True") {
                // 重新获取检查预约列表
                $scope.getCheckApptList(true);
            }
            // 失败
            else {
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: data.data[0].ERROR_MSG,
                    okText: "确定"
                });
            }
        })
    }
    // 预约改期模态窗口隐藏
    $scope.changeApptDateHide = function () {
        $scope.changeApptDateModal.hide();
        $scope.isChangingDate = false;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
    }

    $scope.$on('$ionicView.enter', function () {
        // 获取检查预约列表
        $scope.getCheckApptList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'checkApptList');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'checkApptList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    $scope.checkSign.Modify_flag = true;//是否可修改
    $scope.checkSign.button_HZQM_enable = false;//患者签名按钮是否可用
    $scope.checkSign.button_JSQM_enable = false;//家属签名按钮是否可用
    $scope.jSignature = false;//初始化画布变量
    $scope.Check_no = "";//操作的检查单号

    //cfw 2023年2月23日09:12:44 点击打开知情同意书  入参：检查单号
    $scope.OpeninformedConsent = function (check_no) {
        // cfw 2023年3月20日10:41:14  初始化图片路径为空，解决二次进入不刷新问题
        $scope.checkSign.hzqm_img_show = "";
        $scope.checkSign.jsqm_img_show = "";
        $scope.checkSign.Modify_flag = true;

        $ionicLoading.show();
        //调用方法获取病历图片及签字内容
        //    var check_no = "63191484";
        check_no = check_no.substring(3);
        $scope.Check_no = check_no;
        RequestService.getRecordPic(check_no).then(function (data) {
            if (data.is_null == "1") {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("未找到该检查的知情同意书");
            } else {
                $scope.ipreg_InformedConsent = data.data;
                for (let index = 0; index < $scope.ipreg_InformedConsent.length; index++) {
                    const element = $scope.ipreg_InformedConsent[index];
                    if (element.SEQ == "0") {
                        //病历图片在第一行数据中
                        $scope.img_base64 = "data:image/jpg;base64," + element.REPORT_DATA;
                    }
                    element.IP_RECORD_SIGN_ID = "";
                    element.HIS_APPLY_ID = "";
                    element.IMAGE_ID = "";
                    element.DATA = "";
                }
                //查看患者是否已有签名数据
                if (data.list_RECORD_SIGN_DETAIL != undefined) {
                    console.log(data.list_RECORD_SIGN_DETAIL);
                    //患者已签字，页面加载患者签字图片，并且不可修改；将签字图片绑定到全局变量
                    for (var index = 0; index < data.list_RECORD_SIGN_DETAIL.length; index++) {
                        $scope.ipreg_InformedConsent[index].IMAGE_ID = data.list_RECORD_SIGN_DETAIL[index].IMAGE_ID;
                    }
                    //置修改状态为失效
                    $scope.checkSign.Modify_flag = false;

                    $scope.checkSign.hzqm_img_show = $scope.imgServerUrl + $scope.ipreg_InformedConsent[0].IMAGE_ID;//赋值前台显示，解决图片裂开问题
                    $scope.checkSign.jsqm_img_show = $scope.imgServerUrl + $scope.ipreg_InformedConsent[1].IMAGE_ID;//赋值前台显示，解决图片裂开问题

                    if ($scope.ipreg_InformedConsent[0].IMAGE_ID != undefined && $scope.ipreg_InformedConsent[0].IMAGE_ID != "") {
                        $scope.checkSign.button_HZQM_enable = true;//按钮是否起效关联图片是否显示，如果有图片，则按钮起效
                    }
                    if ($scope.ipreg_InformedConsent[1].IMAGE_ID != undefined && $scope.ipreg_InformedConsent[1].IMAGE_ID != "") {
                        $scope.checkSign.button_JSQM_enable = true;//按钮是否起效关联图片是否显示，如果有图片，则按钮起效
                    }
                }


                $scope.InformedConsentShow();//显示新冠感染风险模态窗
                $ionicLoading.hide();
            }

        }, function (error) {
            console.log(error)
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(error.msg);
        });


    }

    //cfw 2023年1月31日13:53:48 签字按钮点击事件，显示签字模态框
    $scope.ShowSign = function (sign_type) {
        if ($scope.checkSign.Modify_flag) {
            $scope.sign_type = sign_type;//当前操作的签名

            $scope.PatientSignShow();//显示新冠感染风险模态窗
            $ionicLoading.hide();
            if ($scope.jSignature == false) {
                //初始化画布
                $("#signature").jSignature({ width: 340, height: 200, color: "#000", lineWidth: 4 });
                $scope.jSignature = true;
            }
        } else {
            $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
        }

    }
    //画布-重置按钮--重置画布
    $scope.resetSign = function () {
        $("#signature").jSignature("clear");
    }

    //画布-确认按钮-获取签名图片并绑定到页面中
    $scope.commitSignPic = function () {
        var sig = $("#signature");
        if (sig.jSignature('getData', 'native').length != 0) {
            // 将签名值赋值到对应点位
            var base64_sign = sig.jSignature('getData');

            //$("#img_"+$scope.sign_type).attr("src","data:"+base64_sign);//给点位赋值  cfw pb 不直接从画板赋值图片，在上传成功后，从服务器用路径加载

            //图片上传至服务器，拿到存储url
            //生产库打开注释
            base64_sign = base64_sign.slice(base64_sign.indexOf(';base64,') + ';base64,'.length);
            $scope.smsUploadImg(base64_sign, $scope.sign_type);

            $("#signature").jSignature("clear");

            $scope.PatientSignHide();//显示新冠感染风险模态窗
            //签名完成后滚动到页面底部
            $scope.anchorScroll("button_bottom");
        } else {
            $fwCordovaToast.showLongBottom("请进行签名。");
        }
    }
    //画布-取消按钮
    $scope.cancelSign = function () {
        $("#signature").jSignature("clear");
        $scope.PatientSignHide();//隐藏签名窗口
        //签名完成后滚动到页面底部
        $scope.anchorScroll("button_bottom");
    }
    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    //前台图片显示绑定变量
    $scope.checkSign.hzqm_img_show = "";
    $scope.checkSign.jsqm_img_show = "";
    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;
    // 上传签名图片至服务器
    $scope.smsUploadImg = function (imageData, idw) {

        // 上传图片路径 云平台
        //var url ="http://10.91.52.11:1133/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=jpg";

        // 上传图片路径 生产库
        //var url = encodeURI(uploadUrl + "/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=jpg");

        //cfw 2023年5月30日10:33:42 修改图片存储格式为png,避免略缩图存储为一个黑色背景图
        var url = encodeURI(uploadUrl + "/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=png");

        RequestService.imgUpload(url, imageData).then(function (data) {
            if (data == "error") {
                $cordovaToast.showShortBottom("签字图片保存失败");
            } else {
                // 上传成功 返回值result是图片地址
                $scope.img_temp = data;

                if (idw == "HZQM") {
                    $scope.ipreg_InformedConsent[0].IMAGE_ID = $scope.img_temp;//赋值后台存储
                    $scope.checkSign.hzqm_img_show = $scope.imgServerUrl + $scope.img_temp;//赋值前台显示，解决图片裂开问题
                    $scope.checkSign.button_HZQM_enable = true;//清除按钮是否可用
                } else if (idw == "JSQM") {
                    $scope.ipreg_InformedConsent[1].IMAGE_ID = $scope.img_temp;
                    $scope.checkSign.jsqm_img_show = $scope.imgServerUrl + $scope.img_temp;//赋值前台显示，解决图片裂开问题
                    $scope.checkSign.button_JSQM_enable = true;//清除按钮是否可用
                }
            }
        });
    }

    //删除某个签名图片
    $scope.deleteSign = function (sign_type) {
        if ($scope.checkSign.Modify_flag) {
            if (sign_type == "HZQM") {
                if ($scope.checkSign.button_HZQM_enable) {
                    $scope.ipreg_InformedConsent[0].IMAGE_ID = "";
                    $scope.checkSign.hzqm_img_show = "";//赋值前台显示为空，解决图片裂开问题
                    $scope.checkSign.button_HZQM_enable = false;//清除按钮是否可用

                }
            } else if (sign_type == "JSQM") {
                if ($scope.checkSign.button_JSQM_enable) {
                    $("#img_JSQM").attr("src", "");//给点位赋值
                    $scope.ipreg_InformedConsent[1].IMAGE_ID = "";
                    $scope.checkSign.jsqm_img_show = "";//赋值前台显示为空，解决图片裂开问题
                    $scope.checkSign.button_JSQM_enable = false;//图片后面的删除按钮是否可用
                }
            }
        } else {
            $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
        }
    }

    // 提交签名数据
    $scope.saveSign = function () {
        if ($scope.checkSign.Modify_flag) {

            $ionicLoading.show();
            // $scope.ipreg_InformedConsent[0].IMAGE_ID = "/uploaded/IP_RECORD_SIGN/a0531a63-3dbd-49e9-8676-5ef503971e06.jpg";//app无法上传图片，临时赋值图片路径
            // $scope.ipreg_InformedConsent[1].IMAGE_ID = "/uploaded/IP_RECORD_SIGN/f393e897-0aa7-4064-9409-18616449c730.jpg";//app无法上传图片，临时赋值图片路径

            $scope.ipreg_InformedConsent[0].REPORT_DATA = "";//提交前，清除病历图片
            //校验是否签名（至少签一个）
            if ($scope.ipreg_InformedConsent[0].IMAGE_ID != '' && $scope.ipreg_InformedConsent[1].IMAGE_ID != '') {
                var submitObj = JSON.stringify($scope.ipreg_InformedConsent);

                //提交到数据库
                RequestService.saveRecordSign(submitObj, $scope.Check_no).then(function (data) {
                    if (data.result == 1) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("签名成功。");
                        $scope.InformedConsentHide();//隐藏当前页面
                    } else if (data.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
                    }
                }, function (error) {
                    console.log(error)
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(error.msg);
                });
            } else {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("请进行患者和直系亲属签名。");
            }
        } else {
            $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
        }

    }
})
