﻿angular.module('fwapp.controllers')

.controller('CheckController', function ($scope, $rootScope, $state, $ionicPlatform, $stateParams, $window, $timeout,
$ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $cordovaInAppBrowser,
VisitPatientService, RequestService, AccountService, ReportService, ChangePhoneNumberService, $fwCordovaToast) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 检查列表
    $scope.checkList = [];
    // 当前检查项目类型
    $scope.checkType = 1;
    // 是否加载完成
    $scope.isLoadFinish = false;
    // 检查结果
    $scope.checkResult = {
        INDEX: 0,
        REPORT_IMAGE: ''
    }
    //下载验证成功的ID
    $scope.downloadId = "";
    //手机验证成功的ID
    $scope.authId = "";
    $scope.timespan = 0;
    //手机验证后直接进入
    $scope.thisResultIndex = 0;
    $scope.thisResultFunc = "";
    // 验卡模型
    $scope.vpVerify = {
        phone_num: '',
        phone_num_show: '',
        imageVericode: '',
        messageVericode: ''
    };
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    
    // 防止多次获取验证码
    $scope.disableGetVericode = false;
    $scope.reqId = '';

    // 就诊人列表
    $scope.vpList = [];
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 检查报告图像
    $scope.imgCheckResult = {};
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);

    // 注册模态窗口:检查结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultModal = modal;
    });
    // 注册模态窗口:验证手机号
    $ionicModal.fromTemplateUrl('verifyPhone.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.vpVerify.imageVericode = "";
        $scope.vpVerify.messageVericode = "";
        $scope.getImageVericode();
        $scope.verifyPhoneModal = modal;

    });

    // 隐藏模态窗口:验证手机号
    $scope.verifyPhoneModalHide = function () {
        // 隐藏
        $scope.verifyPhoneModal.hide();
    }

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注销模态窗口
    $scope.$on('$destroy', function () {
        $scope.checkResultModal.remove();
        $scope.verifyPhoneModal.remove();
    });

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.log(data);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 读取检查列表
    $scope.loadCheckList = function (type) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.checkList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        RequestService.checkList($scope.vpId, type, localStorage.queryToken).then(function (data) {
            if (data.result == 99) {    // 链接超时
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                loadFinish();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadCheckList($scope.checkType);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.result == -1) {
                $timeout(function () {
                    if (data.is_null != 1) {
                        $scope.checkList = data.data;
                    }
                    loadFinish();

                }, 1500);
                return;
            }
            if (data.is_null != 1) {
                $scope.checkList = data.data;
                loadFinish();
                return;
            }
            loadFinish();

        });
    }

    function loadFinish() {
        $ionicLoading.hide();
        $scope.isLoadFinish = true;
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid;
        $scope.vpInfo = new Object();
        $scope.loadVPInfo();
        $scope.loadCheckList($scope.checkType);
        $scope.popVplist.hide();
    }

    // 切换检查类型
    $scope.changeType = function (type) {
        $scope.checkType = type;
        $scope.loadCheckList(type);
    }

    // 查看检查结果
    $scope.checkResultShow = function (index) {
        $scope.thisResultIndex = index;
        $scope.thisResultFunc = "check";
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
        if ($scope.checkList[index].CHECK_STATUS == '0') {
            $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
            return false;
        }
        if ($scope.vpInfo.IS_SELF == 1) {
            $scope.checkResult.TITLE = "检查报告";
            $scope.getCheckInfo(index);
            $scope.checkResultModal.show();
        }
        else {
            //验证身份及授权
            ReportService.verify($scope.vpId).then(function(data) {
                //已验证过
                if (data.result == 1) {
                    $scope.checkResult.TITLE = "检查报告";
                    $scope.getCheckInfo(index);
                    $scope.checkResultModal.show();
                }
                else if(data.result == 0) {
                    $scope.verifyPhoneModal.show();
                    $scope.GetReservedPhone();
                }
                else {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            }, function() {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                return;
            })
        }
    }

    // 关闭检查结果
    $scope.checkResultHide = function () {
        $scope.checkResultModal.hide();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
    }

    // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            var src = $("#imgCheckResultOrigin").prop("src");
            // 防止赋值不同步
            if (src == "") {
                $timeout(function () {
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, 0);
                return;
            }
            // 无图片
            if ($("#imgCheckResult").length != 1) {
                return;
            }
            // 初始化
            if ($("#divCheckResult>#imgCheckResult").length == 0) {
                // 还原节点位置
                $("#divCheckResult").append($("#imgCheckResult"));
                // 删除控件
                //$("#divCheckResult .pinch-zoom-container").remove();
                // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
                $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            }
            // 复制图片路径
            $("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgCheckResult");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgCheckResult = new PinchZoom.default(img, zoomOptions);
            $scope.imgCheckResult.enable();
            console.log($scope.imgCheckResult);
        }, 0);
    }

    // 获取检查报告图片
    $scope.getCheckInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        RequestService.checkResult($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            $scope.reqId = data.reqId;
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckInfo(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        });
    }

    // #region 检查报告下载

    //下载PDF
    $scope.downloadPDF = function (reqId, index) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        if (reqId != null && reqId.length > 0) {
            ReportService.saveDownloadRecord($scope.vpId, $scope.thisResultFunc, reqId,
                $scope.thisResultFunc == "lis" ? $scope.lisList[index].TEST_ORDER_NAME : $scope.checkList[index].DESCRIPTION, "PDF",
                $scope.thisResultFunc == "lis" ? $scope.lisList[index].INSPECTION_ID : $scope.checkList[index].ID).then(function (data) {
                    $scope.downloadId = data.downloadId;
                })
            RequestService.downloadPDF(reqId, $scope.vpId).then(function (data) {
                if (data.result == 1) {
                    ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 1);
                    var url = data.data;
                    //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                    //$cordovaInAppBrowser.open(url, '_system', option).then(function (event) {});
                    //2023.7.31 新插件原有调用方式参数不生效
                    showInAppBrowser(url, '_system');
                    loadFinish();
                    return;
                }
                // 链接超时
                else if (data.result == 99) {
                    ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 2);
                    loadFinish();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                    return;
                } else {
                    ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 2);
                    loadFinish();
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            });
        } else {
            loadFinish();
            $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
            return;
        }
    }

    // #endregion

    // #region 非本人授权浏览

    // 获取预留手机号
    $scope.GetReservedPhone = function () {
        $ionicLoading.show();
        RequestService.GetReservedPhone($scope.vpId).then(function (data) {
            // 圈消失
            $ionicLoading.hide();
            // 链接超时
            if (data.result == 99) {  
                $fwCordovaToast.showShortBottom('获取预留手机号失败，服务繁忙，请重试');
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            var phone = data.data[0].PHONENUM;
            $scope.vpVerify.phone_num = phone;
            $scope.vpVerify.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
        });
    }
    
    //获取短信验证码
    $scope.verifyToGetMsgVericode = function () {
        // 验证图片验证码
        if ($scope.vpVerify.imageVericode == null || $scope.vpVerify.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        AccountService.sendVericodeByPhone($scope.vpVerify.phone_num, "10", $scope.vpVerify.imageVericode,$scope.vpId,$scope.thisResultFunc).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1){
                //记录验证信息
                ReportService.saveVerifyInfo($scope.vpId,$scope.thisResultFunc).then(function(data){
                    if(data.result == 1){
                        $scope.authId = data.authId;
                        $scope.disableGetVericode = true;
                        $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");
                        // 倒计时
                        $scope.timespan = 60;
                        TimeCount();
                    }else{
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        return;
                    }
                })
            }else if (data.result == 0) {// 服务调用失败
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
            $scope.disableGetVericode = false;
        },function(){
            $scope.disableGetVericode = false;
        });
    }

    //验证手机验证码
    $scope.verifyCardSubmit = function () {
        if ($scope.vpVerify.phone_num == '' || $scope.vpVerify.messageVericode == '') {
            $fwCordovaToast.showShortBottom('请完整填写预留手机验证信息');
            return false;
        }
        $scope.disableVerify = true;
        ChangePhoneNumberService.compareVericode($scope.vpVerify.phone_num, $scope.vpVerify.messageVericode, currentPlatform, deviceToken, "10").then(function (data) {
            if (data.result == 1) {
                $scope.timespan = 0; //倒计时清零
                $fwCordovaToast.showShortBottom("验证成功。");
                //记录验证信息
                ReportService.updateVerifyInfo($scope.vpId,$scope.authId).then(function(data){
                    if(data.result == 1){
                        $scope.verifyPhoneModal.hide();
                        if($scope.thisResultFunc == "check"){
                            $scope.checkResult.TITLE = "检查报告";
                            $scope.getCheckInfo($scope.thisResultIndex);
                            $scope.checkResultModal.show();
                        }else if($scope.thisResultFunc == "lis"){
                            $scope.getLisInfo($scope.thisResultIndex);
                            $scope.lisResultModal.show();
                            AccountService.getWatermark().then(function (data) {
                                $scope.watermark = data.data;
                            });
                        }
                    }else{
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        $scope.disableVerify = false;
                        return;
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    $scope.disableVerify = false;
                    return;
                })
            }else {
                $scope.getImageVericode();
                $scope.vpVerify.imageVericode = "";
                $scope.vpVerify.messageVericode = "";
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            $scope.disableVerify = false;
        }, function (data) {
            $scope.disableVerify = false;
        })
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpVerify.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
            $scope.disableGetVericode = false;
        }
    };

    // #endregion

    // 后退
    $scope.goBack = function () {
        if ($stateParams.vpid == "" || $scope.from == "app.message") {
            $window.history.back();
        } else {
            $state.go('app.visitPatient', { vpid: $scope.vpId });
        }
    }

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }

        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'check');
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    if (data.data[i].IS_BIND_CARD == '1') {
                        $scope.vpList.push(data.data[i]);
                        if (vpid == "") {
                            vpid = data.data[i].VISIT_PATIENT_ID;
                        }
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }

                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                } else {
                    $scope.loadVPInfo();
                    $scope.queryPassword().then(function (data) {
                        if (data) {
                            // 如果是适老化，默认展示全部
                            if ($rootScope.elderly){
                                $scope.changeType(0);
                            }
                            else {
                                $scope.loadCheckList(1);
                            }
                        }
                    })
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    })

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'check') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
});