﻿angular.module('fwapp.controllers')

.controller('ComplainController', function ($scope, $rootScope, $state, $http, $window, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform
, HospitalService, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, $fwCordovaToast
, ComplainService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 配置项
    $scope.config = {};

    // 提交model
    $scope.complain = {};
    $scope.complain.CONTENT_COMPLAIN = "";
    $scope.complain.PHONENUM = "";
    $scope.complain.COMPLAIN_TYPE = "";

    $scope.submitComplain = function () {
        // 验证
        if ($scope.complain.CONTENT_COMPLAIN == "") {
            $fwCordovaToast.showShortBottom("投诉意见不能为空");
            return;
        }
        else if ($scope.complain.CONTENT_COMPLAIN.length > 200) {
            $fwCordovaToast.showShortBottom("投诉意见最多为200字");
            return;
        }
        else if ($scope.complain.PHONENUM == "") {
            $fwCordovaToast.showShortBottom("联系方式不能为空");
            return;
        }
        else if (!regPhoneNum.test($scope.complain.PHONENUM)) {
            $fwCordovaToast.showShortBottom("非正确的手机号格式");
            return;
        }
        else if ($scope.complain.COMPLAIN_TYPE == "") {
            $fwCordovaToast.showShortBottom("请选择投诉分类");
            return;
        }

        $ionicLoading.show();
        ComplainService.submitComplain($scope.complain.CONTENT_COMPLAIN, $scope.complain.PHONENUM, $scope.complain.COMPLAIN_TYPE).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '提交成功',
                    template: '您好，非常感谢您对我院的信任，我们已收到您的投诉反馈意见，我们会尽快处理。',
                    okText: '确定'
                });
                $scope.complain.CONTENT_COMPLAIN = "";
                $scope.complain.PHONENUM = "";
                $scope.complain.COMPLAIN_TYPE = "";
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (resp) {
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络'
            });
            $ionicLoading.hide();
        })
    }

    // 返回
    $scope.goBack = function () {
        $state.go("app.personal");
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'complain');

        // 获取配置项
        ComplainService.getConfig().then(function (data) {
            if (data.result == 1) {
                $scope.config = data.data;
                if ($scope.config.serverStatus == "0") {
                    // 这个需要编一下
                    $fwCordovaToast.showShortBottom("您好，当前不可进行投诉。");
                }
            }
        })
    });

    // 页面退出
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'complain') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
});