﻿angular.module('fwapp.controllers')

// 在线问诊/复诊诊疗
.controller('ConsultationController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
, ConsultationService, DoctorInfoService, UploadImgService, RequestService, SrvyService, VisitPatientService, OpApptService, AddWishService, OlTreatRecipeService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义在线问诊/复诊诊疗滑块
    var slideConsultation = $ionicSlideBoxDelegate.$getByHandle('slideConsultation');
    // 服务开关
    $scope.isServerOn = true;
    // 初始滑块状态
    $scope.step = 0;
    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;
    // 传过来的问诊方式
    $scope.treatTypeParam = $stateParams.treatType;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 医师列表
    $scope.doctorList = [];
    $scope.doctorListEmpty = false;
    // 选中医师信息
    $scope.selectDoctor = new Object();
    // 支付记录id
    $scope.applyId = "";
    // 是否为复诊患者
    $scope.IsConsultation = "0";
    // 仅看可咨询
    $scope.showAvailable = false;
    // 按医师搜索
    $scope.doctorSearch = {};
    $scope.doctorSearch.list = []; // 医师搜索结果列表
    $scope.doctorSearch.keyword = ""; // 医师搜索关键词
    $scope.doctorSearch.isSearch = false;  // 是否搜索
    $scope.doctorSearch.isEmpty = false;  // 结果是否空
    // 配置Config
    $scope.configData = {};
    // 选择科别code
    $scope.divisionCode = "";
    // 页面是否加载完毕
    $scope.isLoadFinish = false;
    // titleName
    $scope.titleName = "在线问诊";
    // 病情信息对象
    $scope.infomation = {};
    $scope.infomation.infomation = ""; // 病情描述
    $scope.infomation.help = ""; // 希望获得的帮助
    $scope.infomation.visitHospital = ""; // 已就诊医院及科室
    $scope.infomation.isDrug = 0; // 用药情况，1=有，0=无
    $scope.infomation.drug = ""; // 用药情况
    $scope.infomation.isAllergy = 0; //过敏史，1=有，0=无
    $scope.infomation.allergy = ""; //过敏史
    $scope.infomation.isPreviousDisease = 0; //既往病史，1=有，0=无
    $scope.infomation.previousDisease = ""; // 既往病史
    $scope.infomation.imgList = []; // 图片URL
    $scope.infomation.purpose = ""; // 咨询目的
    $scope.infomation.guardianName = "";// 监护人姓名
    $scope.infomation.guardianPhone = "";// 监护人手机号
    $scope.infomation.disease = [];// 所患疾病数组
    $scope.infomation.diseaseStr = "";// 所患疾病显示字符串
    $scope.infomation.takeMedWay = 0;// 取药方式
    // 大图列表
    $scope.uploadImgList = [];
    // 图片服务器路径
    $scope.imgServerUrl = uploadUrl;
    $scope.slides = [];
    $scope.currentImgIndex = 0;
    $scope.currentSlideIndex = 0;
    // 病情信息Id
    $scope.infomationId = "";
    // 病情信息历史记录
    $scope.infomationHistoryList = [];
    // 是否需要支付
    $scope.needPay = true;
    // 本次咨询目的数组
    $scope.purposeList = [];
    // 咨询目的其他的是否展示
    $scope.purposeOtherShow = false;
    // 从哪进来的,1=按科室预约，2=按病区预约
    $scope.fromDivision = 0;
    // 病区
    $scope.doctorDivision = {};
    $scope.doctorDivision.name = "";
    $scope.doctorDivision.code = "";
    // 模板内容
    $scope.tmpl = new Object();
    // 模板信息
    $scope.tmplInfo = new Object();
    // 总题数
    $scope.qstnCount = 0;
    // 问卷结果
    $scope.srvyResult = new Object();
    // 当前问卷ID
    $scope.currentRec = new Object();
    // 疾病查询
    $scope.addDiseaseData = {};
    $scope.addDiseaseData.keyword = '';
    // 知情同意书
    $scope.informedConsent = {};
    $scope.informedConsent.agree = false;
    // 是否选择医师
    $scope.chooseDoctor = false;
    // 是否显示用药情况选择
    $scope.drugRadioShow = true;
    // 记录request的次数
    $scope.requestNum = 0;
    // 选择病区/病种/技术title
    $scope.groupTitleName = "";
    // 选中的病种/技术
    $scope.group = {};
    // 视频问诊排班日期
    $scope.videoSchedDateList = [];
    // 视频问诊排班
    $scope.videoSchedList = [];
    // 选中的问诊排班日志
    $scope.videoSchedDateCheck = "";
    // 视频问诊知情同意书
    $scope.videoInformedConsent = {};
    $scope.videoInformedConsent.agree = false;
    // 选择的问诊方式
    $scope.treatType = "";
    // 医保信息
    $scope.MI = {};
    // 是否为医保患者
    $scope.isPatientMI = false;
    // 2021-10-8 15:52:54 HM 所选择的医师类型
    $scope.doctorType = 1;
    // 传过来的问诊方式
    $scope.treatTypeParam = $stateParams.treatType;
    // 选择科室
    $scope.divisionSelect = {};
    $scope.divisionSelect.code = "";

    // 再定义一个视频状态
    $scope.videoType = 1;

    // 2022-2-21 16:06:53 WX 体检报告解读 体检信息
    $scope.examListInfo = "";
    // 2022-3-15 16:39:55 WX DICOM列表
    $scope.dicomList = [];

    // 是否需要上传医保卡照片
    $scope.uploadMIImage = false;

    // #region 模态框

    // 注册模态窗口：医师介绍
    $ionicModal.fromTemplateUrl('doctorIntro.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 大图浏览
    $ionicModal.fromTemplateUrl("popup_image.html", {
        scope: $scope,
        animation: "fade-in"
    }).then(function (modal) {
        $scope.popupImageModal = modal;
    });

    // 病情信息历史记录
    $ionicModal.fromTemplateUrl("infomationHistory.html", {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationHistory = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 注册模态窗口：量表评估
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('srvyTmpl.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.srvyModal = modal;
    });

    // 注册模态窗口：选择疾病
    $ionicModal.fromTemplateUrl('infomationDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationDiseaseModal = modal;
    });

    // 注册模态窗口：搜索疾病
    $ionicModal.fromTemplateUrl('addDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addDiseaseModal = modal;
    });

    // 注册模态窗口：知情同意书
    $ionicModal.fromTemplateUrl('informedConsent.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.informedConsentModal = modal;
    });

    // 注册模态窗口：用户须知
    $ionicModal.fromTemplateUrl('consultationDescription.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.consultationDescriptionModal = modal;
    });

    // 注册模态窗口：视频问诊排班
    $ionicModal.fromTemplateUrl('videoSched.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.videoSchedModal = modal;
    });

    // 注册模态窗口：上传医保卡
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('uploadMI.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.uploadMIModal = modal;
    });

    // 注册模态窗口：DICOM列表
    $ionicModal.fromTemplateUrl("dicomList.html", {
        scope: $scope
    }).then(function (modal) {
        $scope.dicomListModal = modal;
    });

    // 注册模态窗口：添加DICOM
    $ionicModal.fromTemplateUrl("addDicom.html", {
        scope: $scope
    }).then(function (modal) {
        $scope.addDicomModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.doctorIntroModal.remove();
        $scope.popupImageModal.remove();
        $scope.infomationHistory.remove();
        $scope.showAvatarModal.remove();
        $scope.srvyModal.remove();
        $scope.infomationDiseaseModal.remove();
        $scope.addDiseaseModal.remove();
        $scope.informedConsentModal.remove();
        $scope.consultationDescriptionModal.remove();
        $scope.videoSchedModal.remove();
        $scope.uploadMIModal.remove();
        $scope.dicomListModal.remove();
        $scope.addDicomModal.remove();
    })

    // 用户须知显示
    $scope.consultationDescriptionShow = function () {
        $scope.consultationDescriptionModal.show();
    }

    // 用户须知隐藏
    $scope.consultationDescriptionHide = function () {
        $scope.consultationDescriptionModal.hide();
    }

    // 视频问诊排班显示
    $scope.videoSchedModalShow = function () {
        $scope.treatTypeParam = null;
        $scope.videoSchedModal.show();
    }

    // 视频问诊排班隐藏
    $scope.videoSchedModalHide = function () {
        $scope.treatTypeParam = null;
        $scope.videoSchedModal.hide();
    }

    // 上传医保卡显示
    $scope.uploadMIModalShow = function () {
        $scope.uploadMIModal.show();
    }

    // 上传医保卡隐藏
    $scope.uploadMIModalHide = function () {
        $scope.uploadMIModal.hide();
    }

    // DICOM列表显示
    $scope.dicomListModalShow = function () {
        $scope.dicomListModal.show();
    }

    // DICOM列表隐藏
    $scope.dicomListModalHide = function () {
        $scope.dicomListModal.hide();
    }

    // 添加DICOM显示
    $scope.addDicomModalShow = function () {
        $scope.addDicomModal.show();
    }

    // 添加DICOM隐藏
    $scope.addDicomModalHide = function () {
        $scope.addDicomModal.hide();
    }
    // #endregion

    // #region 滑动方法

    // 滑到上一步
    $scope.lastSlide = function () {
        slideConsultation.previous();
        $scope.step = slideConsultation.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideConsultation.next();
        $scope.step = slideConsultation.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideConsultation.slide(index);
        $scope.step = slideConsultation.currentIndex();
        console.log("toSlide =>" + index);
    }
    // #endregion

    // 0.选择问诊方式
    $scope.consultationTypeMethod = function (index) {
        $scope.consultationType = index;
        $scope.toSlide(1);
    }

    // cfw 2022年12月19日13:52:38 问诊方式增加  智能导诊
    // 跳转自动问诊
    $scope.toAutoInquiry = function () {
        //cfw 2022年12月20日09:04:13 不用处理问诊新、旧逻辑，直接按新的走
        $state.go("app.autoInquiry", { vpid: $scope.inVpid, firstFrom: "consultation", continueInquiry: 0 });
        // TriageService.checkServerStatus().then(function (data) {
        //     if (data.data == "1") {
        //         // 走新的
        //         $state.go("app.autoInquiry", { vpid: $scope.vpSelect.VISIT_PATIENT_ID, firstFrom: "opAppt", continueInquiry: 0 });
        //     }
        //     else {
        //         // 走旧的
        //         $scope.toSlide('5');
        //     }
        // }, function (data) {
        //     $ionicLoading.hide();
        //     $fwCordovaToast.showShortBottom('网络错误，获取服务状态失败');
        // })
    }

    // 1.切换选择预约方式
    $scope.apptMethod = function (index) {
        // 初始化一下筛选条件
        $scope.doctorDivision.code = "";
        $scope.doctorDivision.name = "";
        $scope.showAvailable = false;
        $scope.doctorSearch.keyword = "";
        // 初始化一下默认选择的科别，不初始化的话，都去查了心内科
        $scope.divisionCode = "";
        // 先给个默认的，然后再改
        $scope.groupTitleName = "在线问诊";
        $scope.group = {};

        // 按科室预约
        if (index == 1) {
            $scope.fromDivision = 1;
            // 默认选择心内科
            $scope.divisionCode = $scope.configData.divisionList[0].code;
            $scope.divisionSelect.code = $scope.configData.divisionList[0].code;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "选择问诊医生";
        }
        else if (index == 2) {
            $scope.fromDivision = 2;
            // 先选一下病区
            $scope.toSlide(2);
            $scope.groupTitleName = "选择病区";
            $scope.titleName = "选择问诊医生";
        }
        else if (index == 3) {
            // 药师咨询仅限3个月内曾在我院就诊或开药的患者。
            $ionicLoading.show();
            RequestService.getOpDrug($scope.inVpid, localStorage.queryToken).then(function (data) {
                if (data.result == 99) {    // 链接超时
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                    return;
                }
                if (data.result == -2) {    // 需要输入查询密码
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                    return;
                }
                if (data.result != 1 && data.result != -1) {  // 请求错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                if (data.result == -1) {        // 请求缓存
                    $timeout(function () {
                        if (data.is_null != 1) {
                            if ($scope.configData.pharmacistContent != "") {
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: $scope.configData.pharmacistContent,
                                    okText: "确定"
                                }).then(function () {
                                    $scope.fromDivision = 3;
                                    $scope.loadDoctorList();
                                });
                            }
                            else {
                                $scope.fromDivision = 3;
                                $scope.loadDoctorList();
                            }
                        }
                        $ionicLoading.hide();
                    }, 1500);
                }

                if (data.is_null != 1) {
                    $ionicLoading.hide();
                    if ($scope.configData.pharmacistContent != "") {
                        $ionicPopup.alert({
                            title: '提示',
                            template: $scope.configData.pharmacistContent,
                            okText: "确定"
                        }).then(function () {
                            $scope.fromDivision = 3;
                            $scope.loadDoctorList();
                        });
                    }
                    else {
                        $scope.fromDivision = 3;
                        $scope.loadDoctorList();
                    }
                } else {
                    $fwCordovaToast.showLongBottom($scope.configData.pharmacistToast);
                    $ionicLoading.hide();
                }
            });
            $scope.titleName = "选择问诊药师";
        }
        else if (index == 4) {
            // 复诊续方资质延长，同在线问诊
            $scope.fromDivision = 4;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "选择资质延长医生";
        }
        // 按病种预约
        else if (index == 5) {
            $scope.fromDivision = 5;
            // 选病种，重新赋值。
            // 获取病种
            $ionicLoading.show();
            OpApptService.getSpecialityGroupList("BZ").then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else {
                    $scope.configData.bzGroup = data.data.groupList;
                    $scope.groupTitleName = data.data.title;
                    $scope.titleName = "选择问诊医生";
                    $scope.toSlide(2);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
        // 按特色技术预约
        else if (index == 6) {
            $scope.fromDivision = 6;
            // 选技术，重新赋值
            // 获取技术
            $ionicLoading.show();
            OpApptService.getSpecialityGroupList("JS").then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else {
                    $scope.configData.jsGroup = data.data.groupList;
                    $scope.groupTitleName = data.data.title;
                    $scope.titleName = "选择问诊医生";
                    $scope.toSlide(2);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
        // 专家复诊
        else if (index == 7) {
            $scope.fromDivision = 7;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "专家复诊";
        }
        // 护理门诊
        else if (index == 8) {
            // 2022-3-24 15:15:51 WX 护理门诊咨询也先分类再加载医师列表
            $scope.fromDivision = 8;
            $ionicLoading.show();
            ConsultationService.getSpecialityGroupList().then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else {
                    $scope.configData.zcGroup = data.data.groupList;
                    $scope.groupTitleName = data.data.title;
                    $scope.titleName = "选择问诊护士";
                    $scope.toSlide(2);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
        // 营养咨询
        else if (index == 9) {
            $scope.fromDivision = 9;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "营养咨询";
        }
        // 康复咨询
        else if (index == 10) {
            $scope.fromDivision = 10;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "康复咨询";
        }
        // 病区复诊
        else if (index == 11) {
            $scope.fromDivision = 11;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "病区复诊";
        }
        // 老年人咨询（免费）
        else if (index == 12) {
            $scope.fromDivision = 12;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "老年人咨询";
        }
        // 2022-2-17 11:08:53 WX 体检报告解读
        else if (index == 13) {
            $ionicLoading.show();
            // 先判断用户是否有高端体检且没过期
            RequestService.examList($scope.inVpid).then(function (data) {
                if (data.result == 1 && data.to_appoint == 1) {
                    $scope.examListInfo = JSON.stringify(data.data[0]);
                    $scope.fromDivision = 13;
                    $scope.loadDoctorList();
                    $scope.titleName = "体检报告解读";
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: "确定"
                    });
                    $ionicLoading.hide();
                    return;
                }
            }, function () {
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: '请求失败，请稍后再试',
                    okText: "确定"
                });
                $ionicLoading.hide();
                return;
            })
        }
        // 2022-3-31 10:04:05 WX 医学影像咨询
        else if (index == 14) {
            $scope.fromDivision = 14;
            $ionicLoading.show();
            ConsultationService.getCategoryGroupList().then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else {
                    $scope.configData.kbGroup = data.data.groupList;
                    $scope.groupTitleName = data.data.title;
                    $scope.titleName = "选择影像咨询医师";
                    $scope.toSlide(2);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
        // 2022-5-10 10:42:07 WX 客服咨询
        else if (index == 15) {
            $scope.fromDivision = 15;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(3);
            $scope.titleName = "客服咨询";
        }
        // 2023.2.6 8:48 朱世博 荣耀健康研究
        else if (index == 16) {
            $ionicLoading.show();
            // 判断患者是否为荣耀健康研究患者
            ConsultationService.isHonorPatient($scope.inVpid).then(function (data) {
                if (data.result == 1) {
                    $scope.fromDivision = 16;
                    $scope.loadDoctorList();
                    // 直接选医生
                    $scope.toSlide(3);
                    $scope.titleName = "荣耀健康研究";
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: "确定"
                    });
                    $ionicLoading.hide();
                    return;
                }
            }, function () {
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: '请求失败，请稍后再试',
                    okText: "确定"
                });
                $ionicLoading.hide();
                return;
            })
        }
    }

    // 1.1选择病区（未加载问诊列表）
    $scope.selectDoctorDivision = function (index) {
        $scope.doctorDivision.code = $scope.configData.doctorDivisionList[index].code;
        $scope.doctorDivision.name = $scope.configData.doctorDivisionList[index].name;
        $scope.loadDoctorList();
        $scope.toSlide(3);
    }

    // 1.2选择病种/特色技术（未加载问诊列表）
    $scope.selectGroup = function (groupCode, groupType) {
        // 这里其实可以用1个数组，但是为了区分吧，写成两个
        if (groupType == "BZ") {
            // 病种的数组
            var item = $scope.configData.bzGroup.filter(e => e.GROUP_CODE == groupCode)[0];
            $scope.group = item;

            if (typeof item.SUBGROUP_LIST == "undefined") {
            }
            else {
                $scope.group.GROUP_CODE = item.SUBGROUP_LIST[0].GROUP_CODE;
            }
        }
        else if (groupType == "JS") {
            // 技术的数组
            var item = $scope.configData.jsGroup.filter(e => e.GROUP_CODE == groupCode)[0];
            $scope.group = item;
            if (typeof item.SUBGROUP_LIST == "undefined") {
            }
            else {
                $scope.group.GROUP_CODE = item.SUBGROUP_LIST[0].GROUP_CODE;
            }
        }
        // 2022-3-25 08:46:22 WX 新增专长
        else if (groupType == "ZC") {
            // 专长的数组
            var item = $scope.configData.zcGroup.filter(e => e.GROUP_CODE == groupCode)[0];
            $scope.group = item;
        }
        // 2022-3-31 10:26:24 WX 新增科别
        else if (groupType == "KB") {
            // 科别的数组
            var item = $scope.configData.kbGroup.filter(e => e.GROUP_CODE == groupCode)[0];
            $scope.group = item;
            // 科别不传科别，传doctorDivisionCode
            $scope.doctorDivision.code = item.GROUP_CODE;
        }
        // 加载医师列表
        $scope.loadDoctorList();
        // 直接选医生
        $scope.toSlide(3);
    }

    // 1.3切换治疗方式（已加载问诊列表）
    $scope.changeSpecialitySubgroup = function (groupCode) {
        $scope.group.GROUP_CODE = groupCode;
        // 加载医师列表
        $scope.loadDoctorList();
    }

    // 2.查询可问诊医师列表
    $scope.loadDoctorList = function () {
        $ionicLoading.show();
        $scope.doctorListEmpty = false;
        $scope.doctorList = [];

        // 2020年7月23日14:02:28 HM 增加药师咨询列表
        $scope.doctorType = 1;
        // 普通图文问诊医生
        if ($scope.fromDivision == 3) {
            $scope.doctorType = 2;
        }
        // 资质延长
        else if ($scope.fromDivision == 4) {
            $scope.doctorType = 3;
        }
        // 专家复诊_视频
        else if ($scope.fromDivision == 7) {
            $scope.doctorType = 4;
            $scope.videoType = 1;
        }
        // 护理门诊咨询
        else if ($scope.fromDivision == 8) {
            $scope.doctorType = 5;
        }
        // 营养咨询
        else if ($scope.fromDivision == 9) {
            $scope.doctorType = 6;
        }
        // 康复咨询
        else if ($scope.fromDivision == 10) {
            $scope.doctorType = 7;
        }
        // 病区复诊_视频
        else if ($scope.fromDivision == 11) {
            $scope.doctorType = 4;
            $scope.videoType = 2;
        }
        // 老年人咨询（免费）_视频
        else if ($scope.fromDivision == 12) {
            $scope.doctorType = 4;
            $scope.videoType = 3;
        }
        // 2022-2-22 15:53:54 WX 体检报告解读
        else if ($scope.fromDivision == 13) {
            $scope.doctorType = 4;
            $scope.videoType = 4;
        }
        // 2022-3-31 10:27:25 WX 医学影像
        else if ($scope.fromDivision == 14) {
            //2022年5月23日18:33:33 cfw 医学影像咨询type按1处理
            //$scope.doctorType = 8;
            $scope.doctorType = 1;
        }
        // 2022-5-10 10:43:27 WX 客服咨询
        else if ($scope.fromDivision == 15) {
            $scope.doctorType = 9;
        }
        // 2023.2.7 10:04 朱世博 荣耀健康研究
        else if ($scope.fromDivision == 16) {
            $scope.doctorType = 4;
            $scope.videoType = 6;
        }
        ConsultationService.getDoctorListV2($scope.showAvailable, $scope.doctorSearch.keyword, $scope.divisionCode, $scope.doctorDivision.code,
            $scope.doctorType, $scope.group.GROUP_CODE, $scope.group.GROUP_TYPE, $scope.videoType).then(function (data) {

                console.log(data);
                if (data.result == 1) {
                    $scope.doctorList = data.data;

                    // 医师列表是空的情况
                    if ($scope.doctorList.length == 0) {
                        $scope.doctorListEmpty = true;
                        // 重新计算高度
                        $ionicScrollDelegate.resize();
                        $ionicLoading.hide();

                        // 2023-1-19 10:54:46 HM 医师列表是空的情况，可以跳转医师主页的分类，这里给他弹提示
                        if ($scope.doctorType == 2 || ($scope.doctorType == 4 && $scope.videoType == 4)) {
                            var alertPopup = $ionicPopup.alert({
                                title: '提示',
                                template: '未找到可咨询的' + ($scope.doctorType == 2 ? "药师" : "医师"),
                                okText: "确定"
                            });
                        }

                        return;
                    }

                    // 如果选择的是药师咨询，判断是否给他选择医师
                    // 2022-2-22 15:59:25 WX 如果选择的是体检报告解读，判断是否给他选择医师
                    if ($scope.doctorType == 2 || ($scope.doctorType == 4 && $scope.videoType == 4)) {
                        $scope.chooseDoctor = data.chooseDoctor;
                        if ($scope.chooseDoctor == true) {
                            // 跳转医师主页
                            $scope.doctorIntro($scope.doctorList[0].DOCTOR_CODE);
                        }
                        else {
                            // 直接选医生
                            $scope.toSlide(3);
                        }
                    }
                }
                else {
                    $scope.doctorListEmpty = true;
                }

                // 重新计算高度
                $ionicScrollDelegate.resize();
                $ionicLoading.hide();
            }, function () {
                $scope.doctorListEmpty = true;
                $ionicLoading.hide();
            })
    }

    // 2.1切换可咨询
    $scope.switchShowAvailable = function () {
        $scope.showAvailable = !$scope.showAvailable;
        $scope.loadDoctorList();
    }

    // 2.2搜索医师
    $scope.searchDoctor = function () {
        if ($scope.doctorSearch.keyword == "") {
            $fwCordovaToast.showShortBottom("请输入医生姓名进行搜索");
            return false;
        }
        $scope.doctorSearch.isSearch = true;
        $scope.loadDoctorList();
    }

    // 2.3清空搜索结果
    $scope.clearSearch = function () {
        $scope.doctorSearch.list = new Array();
        $scope.doctorSearch.keyword = "";
        $scope.opApptData.doctorName = "";
        $scope.doctorSearch.isSearch = false;
        $scope.doctorSearch.isEmpty = false;
        $scope.loadDoctorList();
    }

    // 2.4切换科室
    $scope.changeDivision = function (division) {
        // 普通版本
        if (!$rootScope.elderly) {
            $scope.divisionCode = division;
        }
        else {
            $scope.divisionCode = $scope.divisionSelect.code;
        }
        $scope.loadDoctorList();
    }

    // 3.跳转到医师介绍
    $scope.doctorIntro = function (doctorCode) {
        // 初始化
        $scope.treatType = "";
        $scope.selectDoctor = null;
        $scope.schedulingModal = null;

        $ionicLoading.show();

        // 2023-10-20 13:54:04 GX 阜外营养的一键问诊是营养师
        if ($stateParams.from == "app.flupDRI") {
            $scope.doctorType = 6;
        }

        // 获取医师主页信息
        DoctorInfoService.doctorMain(doctorCode, $scope.doctorType).then(function (data) {
            console.log(data);
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.doctorInfo = data.data;
                // 专长隐藏
                $scope.doctorInfo.specStatus = "0";
                // 简介隐藏
                $scope.doctorInfo.desStatus = "0";
                // 专长修改
                $scope.doctorInfo.speciality = data.data.specialty;

                OpApptService.getDoctorScheduling(data.data.doctor_code).then(function (result) {
                    $scope.schedulingModal = result;
                    $ionicScrollDelegate.$getByHandle('intro').scrollTop();
                    $ionicLoading.hide();

                    // 判断是否有排班，如果没有排班，预约挂号就不显示了
                    var hasOpAppt = false;
                    for (var i = 0; i < result.length; i++) {
                        if (result[i].am_id != "" || result[i].pm_id != "" || result[i].mid_id != "" || result[i].evening_id != "") {
                            hasOpAppt = true;
                            break;
                        }
                    }
                    if (!hasOpAppt) {
                        $scope.schedulingModal = null;
                    }

                    if ($scope.treatTypeParam == 2) {
                        $scope.chooseTreatType('2', doctorCode);
                    }
                    else {
                        $scope.doctorIntroModal.show();
                    }
                }, function (resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络',
                        okText: "确定"
                    });
                    $ionicLoading.hide();
                });
            }
        }, function (resp) {
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络',
                okText: "确定"
            });
        })
    }

    // #region 医师主页工具函数

    // 控制专长隐藏
    $scope.showSpec = function (status) {
        if (status == "0") {
            $("#speciality").removeClass("speDesShow");
            $("#speciality").addClass("speDesHide");
        }
        else {
            $("#speciality").removeClass("speDesHide");
            $("#speciality").addClass("speDesShow");
        }
        $scope.doctorInfo.specStatus = status;
    }

    // 控制简介隐藏
    $scope.showDes = function (status) {
        if (status == "0") {
            $("#description").removeClass("speDesShow");
            $("#description").addClass("speDesHide");
        }
        else {
            $("#description").removeClass("speDesHide");
            $("#description").addClass("speDesShow");
        }
        $scope.doctorInfo.desStatus = status;
    }

    // 医师介绍页确认预约，跳转预约挂号
    $scope.apptModal = function (id, color) {
        if (id != "" && (color == "green" || color == "orange")) {
            // 改为上下午分段
            if (isOpAppt || $rootScope.opApptData.status) {
                OpApptService.getOpSchedInfo(id).then(funcCBSGetPeriod2);
            }
            else {
                AddWishService.getPeriod(id).then(funcCBSGetPeriod2);
            }
            function funcCBSGetPeriod2(data) {
                console.log(data);
                // 调用失败
                if (data.result == -1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                // 已约满
                else if (data.result == 0) {
                    $fwCordovaToast.showShortBottom("当前选择的医师已约满");
                }
                // 一个时段 直接赋值下一步
                else {
                    if (isOpAppt || $rootScope.opApptData.status) {
                        $state.go("app.opAppt", { opid: data.data[0].ID, vpId: $scope.inVpid, from: 'app.consultation,' + $scope.doctorInfo.doctor_code });
                    }
                    else {
                        $state.go("app.addWish", { opid: data.data[0].ID, vpId: $scope.inVpid, from: 'app.consultation,' + $scope.doctorInfo.doctor_code });
                    }
                }
            }
        }
    }

    // 医师介绍隐藏
    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
        $scope.schedulingModal = null;
        $scope.doctorInfo = null;
    }

    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }

    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    // #endregion

    // 4.选择问诊方式（图文问诊医师，会直接跳到第6步）
    $scope.chooseTreatType = function (type, doctorCode) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 2022-3-31 11:10:36 WX 医师主页选不同的问诊方式，再次赋值问诊方式
        // 解决从图文问诊进入，选择图文视频都能问诊的医师，处理只能视频问诊的操作
        $scope.consultationType = type;

        // 初始化
        $scope.videoSchedList = [];
        $scope.videoSchedDateList = [];
        $scope.videoSchedDateCheck = "";
        $scope.selectDoctor = null;

        // 赋值
        $scope.treatType = type;

        // 先验证是否有预约
        $ionicLoading.show();
        // 2023-2-20 10:35:00 HM 增加参数传入，提前验证是否可进行预约
        // "1"代表，是否开启验证
        ConsultationService.consultationStatus($scope.inVpid, doctorCode, type, "1", $scope.examListInfo).then(function (data) {
            // 报错了
            if (data.result == 0) {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            // 有会话
            else if (data.result == 1) {
                $ionicLoading.hide();
                // 图文问诊
                if (data.treatType == "1") {
                    // 调易复诊sdk，进下一页吧
                    $scope.applyId = data.applyId;
                    $scope.needPay = false;

                    // 2022-2-9 10:06:52 HM 已经有会话，需要关闭医生主页的模态框
                    $scope.doctorIntroHide();
                    // 延迟500毫秒再跳转
                    setTimeout(function () {
                        $scope.toSlide(5);
                    }, 500);
                }
                // 视频问诊
                else {
                    var confirmPopup = $ionicPopup.confirm({
                        title: data.msg,
                        cancelText: '取消',
                        okText: '进入'
                    });
                    confirmPopup.then(function (res) {
                        if (res) {
                            $state.go("app.consultationList", { treatType: "2" });
                        }
                        else {
                            $scope.getVideoSchedList(doctorCode);
                        }
                    })
                }
            }
            // 无会话
            else {
                // 图文问诊
                if (type == "1") {
                    // 如果是复诊续方资质延长，走一下资质延长的验证
                    if ($scope.fromDivision == 4) {
                        ConsultationService.checkOLCondition($scope.inVpid).then(function (dataCon) {
                            $ionicLoading.hide();
                            if (dataCon.result == 0) {
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: data.msg,
                                    okText: "确定"
                                });
                            }
                            else {
                                // 需要进行资质延长
                                if (dataCon.status == 1) {
                                    // 获取最终的医生
                                    $scope.selectDoc("1", doctorCode);
                                }
                                // 有同意的记录
                                else if (dataCon.status == 3) {
                                    var confirmPopup = $ionicPopup.confirm({
                                        title: "提示",
                                        template: dataCon.msg,
                                        okText: "复诊续方",
                                        cancelText: "取消"
                                    });
                                    // 继续, 跳转
                                    confirmPopup.then(function (res) {
                                        if (res) {
                                            $state.go("app.olTreatRecipe", { from: "consultation" });
                                        }
                                    })
                                }
                                // 有拒绝的记录
                                else {
                                    var confirmPopup = $ionicPopup.confirm({
                                        title: "提示",
                                        template: dataCon.msg,
                                        okText: "预约挂号",
                                        cancelText: "取消"
                                    });
                                    // 继续, 跳转
                                    confirmPopup.then(function (res) {
                                        if (res) {
                                            $state.go("app.opAppt");
                                        }
                                    })
                                }
                            }
                        }, function () {
                            $ionicLoading.hide();
                            $ionicPopup.alert({
                                title: '提示',
                                template: "获取复诊续方资质延长，网络错误",
                                okText: "确定"
                            });
                        })
                    }
                    else {
                        $ionicLoading.hide();
                        // 获取最终的医生
                        $scope.selectDoc("1", doctorCode);
                    }
                }
                // 视频问诊
                else {
                    $scope.getVideoSchedList(doctorCode);
                }
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "获取阜外会话，网络错误",
                okText: "确定"
            });
        })
    }

    // 4.1 获取视频问诊排班列表
    $scope.getVideoSchedList = function (doctorCode) {
        ConsultationService.getVideoSchedList(doctorCode).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 展示排班列表
                // 日志展示列表
                for (var i = data.videoRegDay; i < data.videoSchedDateShow; i++) {
                    var nowDate = new Date();
                    // 加i天
                    var dateTime = nowDate.setDate(nowDate.getDate() + i);
                    var date = new Date(dateTime).Format("MM月dd日");
                    var week = new Date(dateTime).Format("周w");

                    var videoSchedDate = new Object();
                    videoSchedDate.date = date;
                    videoSchedDate.dateFormat = new Date(dateTime).Format("yyyy-MM-dd");
                    videoSchedDate.week = week;
                    videoSchedDate.isCheck = "0";
                    // 是否有号
                    videoSchedDate.sched = "0";
                    for (var j = 0; j < data.data.length; j++) {
                        if (data.data[j].SCHED_DATE == nowDate.Format("yyyy-MM-dd")) {
                            // 如果都是停诊，则滑动框显示停诊
                            if (data.data[j].STATUS == "2") {
                                videoSchedDate.sched = "2";
                            }
                            // 如果有一个可约，则滑动框显示有号
                            if (data.data[j].STATUS == "1" && data.data[j].SCHED_COUNT > data.data[j].CURRENT_COUNT) {
                                videoSchedDate.sched = "1";
                                // 2021-12-15 16:43:55 HM 这里应该break
                                break;
                            }
                        }
                    }
                    $scope.videoSchedDateList.push(videoSchedDate);
                }

                $scope.videoSchedDateList[0].isCheck = "1";
                $scope.videoSchedDateCheck = $scope.videoSchedDateList[0].dateFormat;

                // 这里是所有排班
                $scope.videoSchedList = data.data;

                $scope.videoSchedModalShow();
            }
        }, function (data) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络不佳，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 5.选择视频问诊日期
    $scope.changeVideoSched = function (index) {
        for (var i = 0; i < $scope.videoSchedDateList.length; i++) {
            if (i == index) {
                $scope.videoSchedDateList[i].isCheck = "1";
                $scope.videoSchedDateCheck = $scope.videoSchedDateList[i].dateFormat;
            }
            else {
                $scope.videoSchedDateList[i].isCheck = "0";
            }
        }
    }

    // #region 选择问诊日期工具函数

    // 格式化问诊时间
    $scope.convertTreatDate = function (type, schedDate) {
        var schedDateInt = parseInt(schedDate);
        // 2022-3-10 10:04:10 WX 体检报告解读 所有问诊结束时间提前5分钟   只改结束时间
        if ($scope.videoType == 4 && type == 1) {
            if (schedDate.toString().indexOf(".") > -1) {
                if (schedDateInt < 10) {
                    return "0" + schedDateInt + ":25";
                }
                else {
                    return schedDateInt + ":25";
                }
            } else {
                if (schedDateInt < 10) {
                    schedDateInt -= 1;
                    schedDateInt += "";
                    return "0" + schedDateInt + ":55";
                } else if (schedDateInt == 10) {
                    return "09:55";
                } else if (schedDateInt == 20) {
                    return "19:55";
                }
                else {
                    return schedDateInt - 1 + ":55";
                }
            }
        } else {
            if (schedDate.toString().indexOf(".") > -1) {
                if (schedDateInt < 10) {
                    return "0" + schedDateInt + ":30";
                }
                else {
                    return schedDateInt + ":30";
                }
            }
            else {
                if (schedDateInt < 10) {
                    return "0" + schedDateInt + ":00";
                }
                else {
                    return schedDateInt + ":00";
                }
            }
        }
    }

    // #endregion

    // 6.选择最终问诊医生或排班
    $scope.selectDoc = function (treatType, doctorCode, schedId) {
        // 初始化一下变量
        $scope.selectDoctor = null;

        // 赋值一下变量
        $scope.treatType = treatType;

        // 走一遍ajax，获取医师详情
        $ionicLoading.show();
        // 此方法是选择了医师、选择了排班，得到最终的结果，这个返回的数据作为用户最终的参数
        ConsultationService.getDoctorInfo($scope.inVpid, treatType, doctorCode, schedId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 这里selectDoctor，两个问诊方式，可能不太一样
                $scope.selectDoctor = data.data;

                $scope.videoSchedModalHide();
                $scope.doctorIntroHide();

                // 2022-2-21 10:16:38 WX 体检报告解读不需要填写病情描述，直接知情同意书，然后确认预约
                // videoType = 4 体检报告解读
                if ($scope.videoType == 4) {
                    $scope.needPay = false;
                    $scope.toSlide(5);
                } else {
                    // 填写病情描述
                    $scope.editInfomation();
                }
            }
        }, function (data) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络不佳，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 7.填写病情描述
    $scope.editInfomation = function () {
        $ionicLoading.show();
        // 初始化变量
        $scope.applyId = "";
        $scope.needPay = true;
        $scope.infomationId = "";
        $scope.infomation = {};
        $scope.infomation.disease = []; // 所患疾病数组
        $scope.infomation.diseaseStr = "";// 所患疾病字符串
        $scope.infomation.infomation = ""; // 病情描述
        $scope.infomation.help = ""; // 希望获得的帮助
        $scope.infomation.visitHospital = ""; // 已就诊医院及科室
        $scope.infomation.isDrug = 0; // 用药情况，1=有，0=无
        $scope.infomation.drug = ""; // 用药情况
        $scope.infomation.isAllergy = 0; //过敏史，1=有，0=无
        $scope.infomation.allergy = ""; //过敏史
        $scope.infomation.isPreviousDisease = 0; //既往病史，1=有，0=无
        $scope.infomation.previousDisease = ""; // 既往病史
        $scope.infomation.imgList = []; // 图片URL
        $scope.infomationHistoryList = [];
        $scope.infomation.purpose = "";
        $scope.infomation.guardianName = "";// 监护人名称
        $scope.infomation.guardianPhone = "";// 监护人手机号
        $scope.infomation.currentAreaCode = "";// 行政区划
        $scope.purposeOtherShow = false;
        $scope.infomation.takeMedWay = 0;// 取药方式

        var i = $scope.purposeList.length;
        var purposeNum = 0;
        var purposeCode = "";
        while (i--) {
            $scope.purposeList[i].status = "0";
            if ((',' + $scope.purposeList[i].way + ',').indexOf(',' + $scope.fromDivision.toString() + ',') != -1) {
                purposeNum++;
                purposeCode = $scope.purposeList[i].code;
            }
        }
        // 如果只有一个咨询目的，默认帮他点一下
        if (purposeNum == 1) {
            $scope.purposeCheckBox(purposeCode);
        }

        // 如果当前选中的大夫，不收费，这里也不收费
        if ($scope.selectDoctor.TREAT_FEE == -1) {
            $scope.needPay = false;
        }

        // 如果是视频问诊，这里需要提前给置
        $scope.MI = {};
        $scope.isPatientMI = false;
        $scope.uploadMIImage = false;

        // 先验证是否为医保患者
        RequestService.checkMI($scope.inVpid).then(function (dataMI) {
            if (dataMI.result == 1) {
                $scope.MI.REQUESTID = dataMI.requestId;
                $scope.MI.NOTICE = dataMI.descr;
                $scope.MI.HELP = dataMI.help;
                $scope.MI.VISIT_PATIENT_ID = $scope.inVpid;
                $scope.MI.URL_EXT = "OL_TREAT";

                // 如果是医保患者
                if (dataMI.isMI == "1") {
                    $scope.isPatientMI = true;
                    $scope.MI.IS_PATIENT_MI = true;
                }
                else {
                    $scope.isPatientMI = false;
                    $scope.MI.IS_PATIENT_MI = false;
                }
                console.log("是否为医保患者:" + $scope.isPatientMI);

                // 视频问诊
                if ($scope.treatType == 2) {
                    OlTreatRecipeService.needCheckMI($scope.inVpid, $scope.MI.REQUESTID, "OlTreatVideo").then(function (data) {
                        $ionicLoading.hide();

                        // 提示上传照片
                        if (data.result == 1) {
                            $scope.uploadMIImage = true;
                        }
                        // 已上传，无需再次上传
                        else if (data.result == 2) {
                            // 如果院内的医保卡号首信验证失败，他之前上传过也没用
                            if (dataMI.isMIVerify == "0") {
                                $scope.uploadMIImage = true;
                            }
                            else {
                                $scope.uploadMIImage = false;
                            }
                        }
                        // 不开启医保结算，一律按自费处理
                        else if (data.result == -1) {
                            $scope.isPatientMI = false;
                            $scope.uploadMIImage = false;
                        }
                        // 报错了
                        else {
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.msg,
                                okText: "确定"
                            });
                        }

                        // 如果是医保患者，这里自动给他选择来院取药
                        // 2024-3-21 14:42:43 HM 医保患者支持线上缴费了，他们没有区别了
                        //if ($scope.isPatientMI == true) {
                        //    $scope.changeRadio('takeMedWay', 1);
                        //}

                        if (data.result == 1 || data.result == 2 || data.result == -1) {
                            $scope.toSlide(4);
                            $ionicLoading.hide();

                            //cfw 2022年12月26日11:07:07 如果当前页面时从智能问诊页面过来，则获取患者预问诊病历，自动导入病情信息
                            if ($stateParams.from == "app.autoInquiry") {
                                //获取患者预问诊病历导入
                                $scope.getAutoInquiryInfo();
                            } else {
                                //走之前流程，判断患者是否有既往病情信息
                                $scope.getHistroyInfo();
                            }
                        }
                    }, function (data) {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: '提示',
                            template: "验证医保患者身份失败，请稍后重试",
                            okText: "确定"
                        });
                    })
                }
                else {
                    $scope.toSlide(4);
                    $ionicLoading.hide();

                    //cfw 2022年12月26日11:07:07 如果当前页面时从智能问诊页面过来，则获取患者预问诊病历，自动导入病情信息
                    if ($stateParams.from == "app.autoInquiry") {
                        //获取患者预问诊病历导入
                        $scope.getAutoInquiryInfo();
                    } else {
                        //走之前流程，判断患者是否有既往病情信息
                        $scope.getHistroyInfo();
                    }
                }
            }
            // 报错了
            else {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '提示',
                    template: dataMI.msg,
                    okText: "确定"
                });
            }
        }, function (data) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "判断是否为医保患者失败，请稍后再试",
                okText: "确定"
            });
        })
    }

    // 7.1根据requestId查询患者上一次就诊诊断，与7.1是异步的request，但如果不是空白填写，这个就不走
    $scope.getDiseaseResp = function (requestId) {
        ConsultationService.getDiseaseResp(requestId).then(function (data) {
            $scope.requestNum++;
            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
            if ($scope.requestNum == 2) {
                $ionicLoading.hide();
            }

            // 查询成功
            if (data.result == 1) {
                // 判断是否结果是否空
                if (data.is_null == 0) {
                    // 不为空，前来赋值
                    $scope.infomation.disease = data.data.diseaseList;
                    $scope.infomation.diseaseStr = data.data.diseaseStr;
                }
                // 结果空，应该是什么都不处理
                else {
                    console.log("结果是空的，应该什么都不用管");
                }
            }
            else {
                $fwCordovaToast.showShortBottom("获取上一次诊断失败");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取上一次诊断失败，请稍后再试");
        });
    }

    // 7.2拿门诊药品，用于复诊续方资质延长，与7.2是异步的request
    $scope.getOpDrug = function () {
        $scope.drugRadioShow = false;

        // 如果不是复诊续方资质延长直接踢回
        if ($scope.fromDivision != 4) {
            $scope.requestNum++;
            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
            if ($scope.requestNum == 2) {
                $ionicLoading.hide();
            }
            return;
        }

        $scope.infomation.drugOL = "";
        RequestService.getOpDrug($scope.inVpid, localStorage.queryToken).then(function (data) {
            $scope.requestNum++;
            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
            if ($scope.requestNum >= 2) {
                $ionicLoading.hide();
            }

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {    // 需要输入查询密码
                $scope.getOpDrug();
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.result == -1) {        // 请求缓存
                $timeout(function () {
                    if (data.is_null != 1) {
                        var drugListStr = "";

                        // 2020-12-21 11:03:51 HM 修改一下显示格式，分别展示可开药与不可开药列表
                        // 拆出两个数组
                        var yesList = data.data.filter(item => item.REMARKS != "该药品不支持在线复诊续方");
                        var noList = data.data.filter(item => item.REMARKS == "该药品不支持在线复诊续方");

                        drugListStr += "复诊续方药品：\r\n";
                        for (var i = 0; i < yesList.length; i++) {
                            drugListStr += yesList[i].DRUG_NAME + "，" + yesList[i].DRUG_USAGE + "\r\n";
                        }

                        if (noList.length > 0) {
                            drugListStr += "\r\n";
                            drugListStr += "不支持复诊续方申请药品：\r\n";
                            for (var i = 0; i < noList.length; i++) {
                                drugListStr += noList[i].DRUG_NAME + "，" + noList[i].DRUG_USAGE + "\r\n";
                            }
                        }
                        if (drugListStr != "") {
                            $scope.drugRadioShow = true;
                            $scope.infomation.drugOL = drugListStr;
                        }
                    }
                }, 500);
            }
            if (data.is_null != 1) {
                var drugListStr = "";
                // 2020-12-21 11:03:51 HM 修改一下显示格式，分别展示可开药与不可开药列表
                // 拆出两个数组
                var yesList = data.data.filter(item => item.REMARKS != "该药品不支持在线复诊续方");
                var noList = data.data.filter(item => item.REMARKS == "该药品不支持在线复诊续方");

                drugListStr += "复诊续方药品：\r\n";
                for (var i = 0; i < yesList.length; i++) {
                    drugListStr += yesList[i].DRUG_NAME + "，" + yesList[i].DRUG_USAGE + "\r\n";
                }

                if (noList.length > 0) {
                    drugListStr += "\r\n";
                    drugListStr += "不支持复诊续方申请药品：\r\n";
                    for (var i = 0; i < noList.length; i++) {
                        drugListStr += noList[i].DRUG_NAME + "，" + noList[i].DRUG_USAGE + "\r\n";
                    }
                }
                if (drugListStr != "") {
                    $scope.drugRadioShow = true;
                    $scope.infomation.drugOL = drugListStr;
                }
                console.log(drugListStr);
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取复诊续方药品失败，请稍后再试");
        });
    }

    // 7.3图片上传（显示按钮）
    $scope.imgAddActionSheet = function () {
        // 显示ActionSheet
        // 2022-3-21 15:58:07 WX DICOM影像只适用于视频有
        // 2024-07-11 11:32:00 CGZ 支持图文问诊上传DICOM影像
        if (devMode) {
            $ionicActionSheet.show({
                titleText: "请选择上传图片方式",
                buttons: [
                    { text: '<i class="icon ion-camera"></i> 拍照上传' },
                    { text: '<i class="icon ion-image"></i> 由相册选择' },
                    { text: '<i class="icon ion-medkit"></i> 上传DICOM影像' }
                ],
                cancelText: "取消",
                cancel: function () {
                    return true;
                },
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:     // 拍照上传
                            $scope.cameraImg();
                            return true;
                            break;
                        case 1:     // 由相册选择
                            $scope.selectImg();
                            return true;
                            break;
                        case 2:     // 上传DICOM影像
                            $scope.getDicomList();
                            return true;
                            break;
                    }
                }
            })
        } else {
            $ionicActionSheet.show({
                titleText: "请选择上传图片方式",
                buttons: [
                    { text: '<i class="icon ion-camera"></i> 拍照上传' },
                    { text: '<i class="icon ion-image"></i> 由相册选择' }
                ],
                cancelText: "取消",
                cancel: function () {
                    return true;
                },
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:     // 拍照上传
                            $scope.cameraImg();
                            return true;
                            break;
                        case 1:     // 由相册选择
                            $scope.selectImg();
                            return true;
                            break;
                    }
                }
            })
        }
    }

    // 7.3.1上传图片（处理业务）
    $scope.uploadImg = function (imageDataList) {
        // 没有病情信息ID，证明是新创建的
        if ($scope.infomationId == null || $scope.infomationId.length == 0) {
            $ionicLoading.show();
            // 没有就，建一个病情信息
            ConsultationService.submitInfomation("", "", "", "", 0,
                "", 0, "", 0, "", "",
                $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, "", "0", 0, "", "", "", $scope.treatType, "").then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        // 第二次赋值，存一下病情信息Id，用于后面点提交使用
                        $scope.infomationId = data.data;
                        UploadImage($scope.infomationId, imageDataList, 0);
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误");
                    $ionicLoading.hide();
                })
        }
        // 有病情信息ID，证明是保存复用的
        else {
            UploadImage($scope.infomationId, imageDataList, 0);
        }

    }

    // 7.4 获取患者既往病情信息  
    $scope.getHistroyInfo = function () {

        //cfw 2022年12月26日13:37:00 从7中提出公共方法

        // 跳转页面，先获取病情信息，然后让患者点击是否继续填写
        ConsultationService.getInfomationList($scope.inVpid).then(function (dataInfomation) {
            // $scope.toSlide(4);
            // $ionicLoading.hide();

            setTimeout(function () {
                // 有未关联的病情信息
                if (dataInfomation.result == 1) {
                    $ionicPopup.confirm({
                        title: "继续填写",
                        template: "您是否要继续填写病情信息？",
                        cancelText: "否",
                        okText: "是"
                    }).then(function (res) {
                        $ionicLoading.show();
                        $scope.requestNum = 0;
                        $scope.infomationHistoryList = dataInfomation.otherInfomation;

                        if (res) {
                            $scope.infomation.diseaseStr = dataInfomation.saveInfomation.DISEASE; // 所患疾病字符串
                            $scope.infomation.infomation = dataInfomation.saveInfomation.INFOMATION; // 病情描述
                            $scope.infomation.visitHospital = dataInfomation.saveInfomation.VISIT_HOSPITAL; // 已就诊医院及科室
                            $scope.infomation.isDrug = dataInfomation.saveInfomation.IS_DRUG; // 用药情况，1=有，0=无
                            $scope.infomation.drug = dataInfomation.saveInfomation.DRUG; // 用药情况
                            $scope.infomation.isAllergy = dataInfomation.saveInfomation.IS_ALLERGY; //过敏史，1=有，0=无
                            $scope.infomation.allergy = dataInfomation.saveInfomation.ALLERGY; //过敏史
                            $scope.infomation.isPreviousDisease = dataInfomation.saveInfomation.IS_PREVIOUS_DISEASE; //既往病史，1=有，0=无
                            $scope.infomation.previousDisease = dataInfomation.saveInfomation.PREVIOUS_DISEASE; // 既往病史
                            $scope.infomation.purpose = dataInfomation.saveInfomation.PURPOSE;
                            $scope.infomation.guardianName = dataInfomation.saveInfomation.GUARDIAN_NAME;// 监护人姓名
                            $scope.infomation.guardianPhone = dataInfomation.saveInfomation.GUARDIAN_PHONE;// 监护人手机号
                            $scope.infomation.currentAreaCode = dataInfomation.saveInfomation.CURRENT_AREA_CODE;// 行政区划
                            $scope.infomation.disease = dataInfomation.saveInfomation.DISEASE_LIST; // 所患疾病数组

                            // 判断是否为undefined
                            if (typeof $scope.infomation.disease == 'undefined') {
                                $scope.infomation.disease = [];
                            }

                            // 咨询目的
                            $scope.purposeOtherShow = false;
                            var purposeStr = new Array();
                            purposeStr = dataInfomation.saveInfomation.PURPOSE.split("；");
                            $scope.infomation.purpose = "";
                            for (var i = 0; i < $scope.purposeList.length; i++) {
                                $scope.purposeList[i].status = "0";
                                if (("," + $scope.purposeList[i].way + ",").indexOf("," + $scope.fromDivision + ",") == -1) {
                                    continue;
                                }
                                for (var j = 0; j < purposeStr.length; j++) {
                                    if (purposeStr[j] == $scope.purposeList[i].name) {
                                        // 帮他按一下
                                        $scope.purposeCheckBox($scope.purposeList[i].code);
                                    }
                                }
                            }
                            $scope.infomation.help = dataInfomation.saveInfomation.HELP; // 希望获得的帮助

                            // 取药方式
                            $scope.infomation.takeMedWay = dataInfomation.saveInfomation.TAKE_MED_WAY;

                            // 第一次赋值，病情描述的主键
                            $scope.infomationId = dataInfomation.saveInfomation.TREAT_INFOMATION_ID;

                            // 获取关联病情描述上传的图片，这里与7.2异步请求
                            UploadImgService.imgList("BY_CONSULTATION", $scope.infomationId).then(function (imgData) {
                                $scope.requestNum++;
                                // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
                                if ($scope.requestNum == 2) {
                                    $ionicLoading.hide();
                                }

                                if (imgData.result == 0) {
                                    $fwCordovaToast.showShortBottom(imgData.msg);
                                } else {
                                    $scope.infomation.imgList = imgData.data;

                                    // 2022-3-16 14:59:08 WX DICOM影像加入imgList
                                    $scope.getDicomImgList($scope.infomationId);
                                    setTimeout(function () {
                                        $ionicScrollDelegate.resize();
                                    }, 500);
                                }
                            }, function (data) {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom("获取图片列表，请稍后再试");
                            })

                            // 如果是复诊续方资质延长，根据最后一个【其他用药情况：】排除
                            if ($scope.fromDivision == 4) {
                                var indexStr = $scope.infomation.drug.lastIndexOf("其他用药情况：");
                                // 如果没找到
                                if (indexStr == -1) {
                                    $scope.infomation.drug = "";
                                    $scope.infomation.isDrug = 0;
                                }
                                else {
                                    // 7个字符：其他用药情况：   2个字符\r\n
                                    $scope.infomation.drug = $scope.infomation.drug.substring(indexStr + 9);
                                }
                            }
                        }
                        else {
                            // 如果不导入之前的，也就是从空白的开始。走下request，查一下这个患者的上次诊断
                            $scope.getDiseaseResp(dataInfomation.requestId);
                        }

                        // 这个方法主要是查询，用药史的，用于复诊续方资质延长。如果是资质延长，会直接跳过，具体逻辑有这个方法本身去处理
                        $scope.getOpDrug();
                    });
                }
                // 无未关联的病情信息
                else if (dataInfomation.result == 2) {
                    $ionicLoading.show();
                    $scope.requestNum = 0;
                    $scope.infomationHistoryList = dataInfomation.otherInfomation;

                    // 空白的，查询他上次的诊断、查询复诊续方的药品
                    $scope.getDiseaseResp(dataInfomation.requestId);
                    $scope.getOpDrug();
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: dataInfomation.msg,
                        okText: "确定"
                    });
                }
            }, 500);
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "获取病情信息，网络错误",
                okText: "确定"
            });
        })
    }

    // 7.5 cfw  如果患者是从【智能分诊】页面跳转过来，如果生成了预问诊病历，则导入页面  
    $scope.getAutoInquiryInfo = function () {
        //cfw 2022年12月26日13:37:00 
        // 跳转页面，先获取病情信息，然后让患者点击是否继续填写   （$stateParams.dialogueId 智能分诊对话的ID，获取预分诊病历）  --测试ID 64de85d6-5c4a-41ce-9785-cb994db5a1bf
        ConsultationService.getAutoInquiryInfoList($scope.inVpid, $stateParams.dialogueId).then(function (dataInfomation) {
            setTimeout(function () {
                // 有未关联的病情信息
                if (dataInfomation.result == 1) {
                    $ionicPopup.confirm({
                        title: "继续填写",
                        template: "根据您智能分诊结果，是否导入您的预问诊病历？",
                        cancelText: "否",
                        okText: "是"
                    }).then(function (res) {
                        $ionicLoading.show();

                        if (res) {
                            $scope.infomation.diseaseStr = dataInfomation.saveInfomation.DISEASE; // 所患疾病字符串
                            $scope.infomation.infomation = dataInfomation.saveInfomation.INFOMATION; // 病情描述
                            $scope.infomation.visitHospital = dataInfomation.saveInfomation.VISIT_HOSPITAL; // 已就诊医院及科室
                            $scope.infomation.isDrug = dataInfomation.saveInfomation.IS_DRUG; // 用药情况，1=有，0=无
                            $scope.infomation.drug = dataInfomation.saveInfomation.DRUG; // 用药情况
                            $scope.infomation.isAllergy = dataInfomation.saveInfomation.IS_ALLERGY; //过敏史，1=有，0=无
                            $scope.infomation.allergy = dataInfomation.saveInfomation.ALLERGY; //过敏史
                            $scope.infomation.isPreviousDisease = dataInfomation.saveInfomation.IS_PREVIOUS_DISEASE; //既往病史，1=有，0=无
                            $scope.infomation.previousDisease = dataInfomation.saveInfomation.PREVIOUS_DISEASE; // 既往病史
                            $scope.infomation.purpose = dataInfomation.saveInfomation.PURPOSE;
                            $scope.infomation.guardianName = dataInfomation.saveInfomation.GUARDIAN_NAME;// 监护人姓名
                            $scope.infomation.guardianPhone = dataInfomation.saveInfomation.GUARDIAN_PHONE;// 监护人手机号
                            $scope.infomation.currentAreaCode = dataInfomation.saveInfomation.CURRENT_AREA_CODE;// 行政区划
                            $scope.infomation.disease = dataInfomation.saveInfomation.DISEASE_LIST; // 所患疾病数组

                            // 后台未返回疾病，直接赋空
                            $scope.infomation.disease = [];
                            $ionicLoading.hide();

                            // 咨询目的
                            // 希望获得的帮助

                            // 第一次赋值，病情描述的主键
                            //$scope.infomationId = dataInfomation.saveInfomation.TREAT_INFOMATION_ID;

                            // 获取关联病情描述上传的图片，这里与7.2异步请求

                            // 如果是复诊续方资质延长，根据最后一个【其他用药情况：】排除

                            // 这个方法主要是查询，用药史的，用于复诊续方资质延长。如果是资质延长，会直接跳过，具体逻辑有这个方法本身去处理
                            $scope.getOpDrug();
                        }
                        else {
                            $ionicLoading.hide();
                            //如果选择了“否”，则走一遍之前逻辑，导入既往病情信息
                            $scope.getHistroyInfo();
                        }

                    });
                }
                else if (dataInfomation.result == 2) {
                    $ionicLoading.hide();
                    // 无未预分诊病历，则走一遍之前逻辑，导入既往病情信息
                    $scope.getHistroyInfo();
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: dataInfomation.msg,
                        okText: "确定"
                    });
                }
            }, 500);
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "获取预分诊病历，网络错误",
                okText: "确定"
            });
        })
    }

    // #region 图片上传工具函数

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            var imageDataList = [];
            imageDataList[0] = imageData;
            $scope.uploadImg(imageDataList);
        }, function (err) {
            //console.log("getPicture---"+err);
        });
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var imgCount = 9 - $scope.infomation.imgList.length;
        var options = {
            quality: 100,
            maximumImagesCount: imgCount,
            width: 0,
            height: 0
        };

        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            //console.log("cordovaImagePicker===" + imageDataList.length);
            $scope.uploadImg(imageDataList);
        }, function (err) {
            //console.log("cordovaImagePicker===error" + err);
        });
    }

    // 批量上传图片
    function UploadImage(infomationId, imageDataList, index) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageDataList[index].substr(imageDataList[index].lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: infomationId };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        if (index == 0) {
            $ionicLoading.show();
        }
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageDataList[index], options, true).then(function (result) {
            // 成功处理
            // 保存已上传图像路径
            $scope.imageAddSave(result.response);
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(infomationId, imageDataList, index + 1);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + JSON.stringify(error) + "。请稍后重试");
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(infomationId, imageDataList, index + 1);
            }
        }, function (progress) {
            ;
        });
    }

    // 保存已上传图像路径
    $scope.imageAddSave = function (path) {
        // 保存数据
        UploadImgService.imgAdd("BY_CONSULTATION", $scope.infomationId, '', path, '').then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else {
                $scope.infomation.imgList.push(data.data);
            }
            $ionicLoading.hide();
        });
    }

    // 显示图片删除按钮
    $scope.showImgDelete = function () {
        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
            $scope.infomation.imgList[i].isImgDelete = true;
        }
    }

    // 隐藏图片删除按钮
    $scope.cancelImgDelete = function () {
        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
            $scope.infomation.imgList[i].isImgDelete = false;
        }
    }

    // DICOM影像列表
    $scope.getDicomList = function () {
        $ionicLoading.show();
        var infomationId = $scope.infomationId
        ConsultationService.getDicomList($stateParams.vpid, infomationId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $scope.dicomList = data.data;
                if (!$scope.dicomListModal.isShown()) {
                    $scope.dicomListModalShow();
                }
            } else {
                $ionicPopup.alert({
                    title: "提示",
                    template: data.msg,
                    okText: "确定"
                });
            }
        }, function (data) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "获取DICOM列表失败，请稍后再试",
                okText: "确定"
            });
        });
    }

    // DICOM添加界面
    $scope.addDicom = function () {
        $scope.addDicomModalShow();
    }

    // DICOM引用
    $scope.quoteDicom = function (dicomId) {
        // 没有病情信息ID，证明是新创建的
        if ($scope.infomationId == null || $scope.infomationId.length == 0) {
            // 没有就，建一个病情信息
            ConsultationService.submitInfomation("", "", "", "", 0,
                "", 0, "", 0, "", "",
                $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, "", "0", 0, "", "", "", $scope.treatType, "").then(function (data) {
                    if (data.result == 1) {
                        // 第二次赋值，存一下病情信息Id，用于后面点提交使用
                        $scope.infomationId = data.data;
                        ConsultationService.quoteDicom(dicomId, $scope.infomationId, $stateParams.vpid).then(function (data) {
                            if (data.result == 1) {
                                $scope.dicomListModalHide();
                                // DICOM已经在服务器里了，直接前端加张图就行了
                                var dicomObj = {};
                                dicomObj.imgType = "dicom";
                                dicomObj.URL = "/www/img/sfz_back_case.png";
                                dicomObj.isImgDelete = false;
                                dicomObj.UPLOAD_IMG_ID = data.data["DICOM_CONTACT_ID"];
                                $scope.infomation.imgList.push(dicomObj);
                                $scope.dicomListModalHide();
                            } else {
                                $ionicPopup.alert({
                                    title: "提示",
                                    template: data.msg,
                                    okText: "确定"
                                });
                            }
                        }, function (data) {
                            $fwCordovaToast.showShortBottom("网络错误");
                            $ionicLoading.hide();
                        });
                    } else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误");
                    $ionicLoading.hide();
                });
        }
        // 有病情信息ID，证明是保存复用的
        else {
            ConsultationService.quoteDicom(dicomId, $scope.infomationId, $stateParams.vpid).then(function (data) {
                if (data.result == 1) {
                    $scope.dicomListModalHide();
                    // DICOM已经在服务器里了，直接前端加张图就行了
                    var dicomObj = {};
                    dicomObj.imgType = "dicom";
                    dicomObj.URL = "/www/img/sfz_back_case.png";
                    dicomObj.isImgDelete = false;
                    dicomObj.UPLOAD_IMG_ID = data.data["DICOM_CONTACT_ID"];
                    $scope.infomation.imgList.push(dicomObj);
                } else {
                    $ionicPopup.alert({
                        title: "提示",
                        template: data.msg,
                        okText: "确定"
                    });
                }
            }, function (data) {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            });
        }
    }

    // 完成DICOM引用
    $scope.finishUploadDicom = function () {
        $scope.addDicomModalHide();
        $scope.getDicomList();
    }

    // DICOM影像加入imgList
    $scope.getDicomImgList = function (infomationId) {
        ConsultationService.getDicomImgList(infomationId, $stateParams.vpid).then(function (data) {
            if (data.result == 1) {
                for (var i = 0; i < data.data.length; i++) {
                    $scope.infomation.imgList.push(data.data[i]);
                }
            } else {
                $ionicPopup.alert({
                    title: "提示",
                    template: data.msg,
                    okText: "确定"
                });
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络错误");
        });
    }
    // 删除图片
    $scope.imgDelete = function (img) {
        console.log(img);
        var id = img.UPLOAD_IMG_ID;
        $ionicPopup.confirm({
            title: "删除检查资料",
            template: "您确定要删除该资料图片？",
            cancelText: "取消",
            okText: "确定删除"
        }).then(function (res) {
            if (res) {
                // 2022-3-16 15:00:11 WX 新增图片类型dicom  如果是dicom影像，去WEB_DICOM_CONTACT里失效
                if (img.imgType == "dicom") {
                    ConsultationService.delDicom(img.UPLOAD_IMG_ID, $stateParams.vpid).then(function (data) {
                        if (data.result == 1) {
                            for (var i = 0; i < $scope.infomation.imgList.length; i++) {
                                if ($scope.infomation.imgList[i].UPLOAD_IMG_ID == id) {
                                    $scope.infomation.imgList.splice(i, 1);
                                }
                            }
                            $ionicLoading.hide();
                        } else {
                            $ionicLoading.hide();
                            $ionicPopup.alert({
                                title: "提示",
                                template: data.msg,
                                okText: "确定"
                            });
                        }
                    }, function (data) {
                        $fwCordovaToast.showShortBottom("网络错误");
                        $ionicLoading.hide();
                    });
                } else {
                    UploadImgService.imgDelete(id).then(function (data) {
                        if (data.result == 0) {
                            $fwCordovaToast.showShortBottom(data.msg);
                        } else {
                            for (var i = 0; i < $scope.infomation.imgList.length; i++) {
                                if ($scope.infomation.imgList[i].UPLOAD_IMG_ID == id) {
                                    $scope.infomation.imgList.splice(i, 1);
                                }
                            }
                        }
                        $ionicLoading.hide();
                    })
                }
            }
            $scope.showImgDelete();
        });
    }

    // 显示弹出大图
    $scope.popupImgShow = function (list, index) {
        $ionicModal.fromTemplateUrl("popup_image.html", {
            scope: $scope,
            animation: "fade-in"
        }).then(function (modal) {
            $scope.popupImageModal = modal;
            // 赋值图片列表
            $scope.uploadImgList = list;
            var cIndex = index;
            var preIndex = index == 0 ? list.length - 1 : index - 1;
            var nextIndex = index == list.length - 1 ? 0 : index + 1;

            $scope.currentImgIndex = cIndex;
            $scope.currentSlideIndex = 1;

            $scope.slides[0] = { src: list[preIndex].URL, seq: preIndex };
            $scope.slides[1] = { src: list[cIndex].URL, seq: cIndex };
            $scope.slides[2] = { src: list[nextIndex].URL, seq: nextIndex };
            //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
            // 显示弹出层
            $scope.popupImageModal.show();
        });
    }

    // 隐藏弹出大图
    $scope.popupImgHide = function () {
        // 清空图片列表
        $scope.uploadImgList = [];
        // 隐藏弹出
        $scope.popupImageModal.hide();
        $scope.popupImageModal.remove();
    }

    // 选中切换
    $scope.popupImgSlideChange = function (index) {
        var change = $scope.currentSlideIndex + ">" + index;
        $scope.currentSlideIndex = index;
        if (change == "2>0" || change == "0>1" || change == "1>2") {
            var sIndex = index + 1;
            if (sIndex == 3) {
                sIndex = 0;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex + 1;
            if (iIndex == $scope.uploadImgList.length) {
                iIndex = 0;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
        else if (change == "0>2" || change == "2>1" || change == "1>0") {
            var sIndex = index - 1;
            if (sIndex == -1) {
                sIndex = 2;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex - 1;
            if (iIndex == -1) {
                iIndex = $scope.uploadImgList.length - 1;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
    }

    // 阻止事件冒泡
    $scope.stopPropagation = function () {
        event.stopPropagation();
    }

    // #endregion

    // #region 病情描述工具函数

    // 咨询目的checkbox变换
    $scope.purposeCheckBox = function (code) {
        // 每点击一次，都重置一次
        $scope.infomation.purpose = "";
        for (var i = 0; i < $scope.purposeList.length; i++) {
            if ($scope.purposeList[i].code == code) {
                // 取反
                if ($scope.purposeList[i].status == "1") {
                    $scope.purposeList[i].status = "0";
                }
                else {
                    $scope.purposeList[i].status = "1";
                }
            }

            if (code == "999" && $scope.purposeList[i].status == "1") {
                $scope.purposeOtherShow = true;
            }
            else if (code == "999" && $scope.purposeList[i].status != "1") {
                $scope.purposeOtherShow = false;
                $scope.infomation.help = "";
            }

            if ($scope.purposeList[i].status == "1") {
                $scope.infomation.purpose += $scope.purposeList[i].name + "；";
            }
        }
        $ionicScrollDelegate.resize();
    }

    // 病情描述信息切换radio
    $scope.changeRadio = function (str, index) {
        if (str == "isDrug") {
            $scope.infomation.isDrug = index;
            if (index == 0) {
                $scope.infomation.drug = "";
            }
        }
        else if (str == "isAllergy") {
            $scope.infomation.isAllergy = index;
            if (index == 0) {
                $scope.infomation.allergy = "";
            }
        }
        else if (str == "isPreviousDisease") {
            $scope.infomation.isPreviousDisease = index;
            if (index == 0) {
                $scope.infomation.previousDisease = "";
            }
        }
        else if (str == "takeMedWay") {
            // 需要判断，患者是医保还是自费，医保患者，不允许选择快递到家
            //if ($scope.isPatientMI == true && index == 3) {
            //    $ionicPopup.alert({
            //        title: '提示',
            //        template: "医保患者，暂不支持快递到家业务，请选择来院取药",
            //        okText: "确定"
            //    });
            //}
            //else {
            //    $scope.infomation.takeMedWay = index;
            //}

            // 2024-3-21 14:32:29 HM 医保移动支付，现在支持线上缴费了，能快递到家了
            $scope.infomation.takeMedWay = index;
        }
        $ionicScrollDelegate.resize();
    }

    // 病情描述历史记录显示
    $scope.showInfomationHistory = function () {
        $scope.infomationHistory.show();
    }

    // 病情描述历史记录隐藏
    $scope.hideInfomationHistory = function () {
        $scope.infomationHistory.hide();
    }

    // 所患疾病显示
    $scope.showInfomationDisease = function () {
        $scope.infomationDiseaseModal.show();
    }

    // 所患疾病隐藏
    $scope.hideInfomationDisease = function () {
        $scope.infomation.diseaseStr = "";
        for (var i = 0; i < $scope.infomation.disease.length; i++) {
            $scope.infomation.diseaseStr += $scope.infomation.disease[i].DISEASE_NAME + "，";
        }
        $scope.infomation.diseaseStr = $scope.infomation.diseaseStr.substr(0, $scope.infomation.diseaseStr.length - 1);
        $scope.infomationDiseaseModal.hide();
    }

    // 添加所患疾病
    $scope.addDisease = function (disease, index) {
        var temp = {};
        temp.RECS_CODE = disease.RECS_CODE;
        temp.DISEASE_NAME = disease.DISEASE_NAME;

        if ($scope.diseaseIsSelected(temp) == true) {
            // 提示
            $ionicPopup.alert({
                title: "提示",
                template: "您已选择该项，请选择其他疾病",
                okText: "确定"
            }).then(function (res) {
                ;
            });
        }
        else {
            // 没有诊断，就添加
            $scope.infomation.disease.push(temp);
            console.log($scope.infomation.disease);

            if (index == 2) {
                $scope.hideAddDisease();
            }
        }
    }

    // 判断所患疾病是否已选中
    $scope.diseaseIsSelected = function (disease) {
        var flag = false;
        if ($scope.infomation.disease.length > 0) {
            $scope.infomation.disease.forEach(item => {
                if (item.RECS_CODE == disease.RECS_CODE) {
                    flag = true;
                }
            });
        }
        return flag;
    }

    // 删除所患疾病
    $scope.deleteDisease = function (index) {
        $scope.infomation.disease.splice(index, 1);
    }

    // 搜索所患疾病显示
    $scope.showAddDisease = function () {
        if ($scope.infomation.disease.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的疾病过多');
            return;
        }
        $scope.addDiseaseData.keyword = "";
        $scope.addDiseaseData.results = [];
        $scope.addDiseaseModal.show();
        // 自动获取焦点
        $timeout(function () {
            document.getElementById("searchDisease").focus();
        }, 500);
    }

    // 搜索所患疾病隐藏
    $scope.hideAddDisease = function () {
        $scope.addDiseaseModal.hide();
    }

    // 搜索所患疾病
    $scope.searchDisease = function () {
        $scope.addDiseaseData.results = [];
        $ionicLoading.show();
        ConsultationService.searchDisease($scope.addDiseaseData.keyword, $scope.inVpid).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addDiseaseData.results = data.data;
                $ionicScrollDelegate.scrollTop();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("搜索超时，请稍后再试");
        });
    }

    // #endregion

    // 7.4选择病情描述
    $scope.selectInfomation = function (index) {
        $ionicPopup.confirm({
            title: "导入确认",
            template: "是否要导入该病情信息？",
            cancelText: "否",
            okText: "是"
        }).then(function (res) {
            if (res) {
                // 通过病情信息Id获取病情信息详情
                $ionicLoading.show();
                ConsultationService.selectInfomation($scope.infomationHistoryList[index].TREAT_INFOMATION_ID).then(function (data) {
                    $scope.infomation.diseaseStr = data.data.DISEASE; // 所患疾病字符串
                    $scope.infomation.infomation = data.data.INFOMATION; // 病情描述
                    $scope.infomation.visitHospital = data.data.VISIT_HOSPITAL; // 已就诊医院及科室
                    $scope.infomation.isDrug = data.data.IS_DRUG; // 用药情况，1=有，0=无
                    // 如果是资质延长，这里不带入
                    if ($scope.fromDivision != 4) {
                        $scope.infomation.drug = data.data.DRUG; // 用药情况
                    }
                    else {
                        if ($scope.infomation.drugOL != "") {
                            $scope.infomation.drug = data.data.DRUG.replace($scope.infomation.drugOL, "");
                            $scope.infomation.drug = $scope.infomation.drug.replace("。其他用药情况：", "");
                            if ($scope.infomation.drug == "") {
                                $scope.infomation.isDrug = 0;
                            }
                        }
                    }
                    $scope.infomation.isAllergy = data.data.IS_ALLERGY; //过敏史，1=有，0=无
                    $scope.infomation.allergy = data.data.ALLERGY; //过敏史
                    $scope.infomation.isPreviousDisease = data.data.IS_PREVIOUS_DISEASE; //既往病史，1=有，0=无
                    $scope.infomation.previousDisease = data.data.PREVIOUS_DISEASE; // 既往病史
                    $scope.infomation.purpose = data.data.PURPOSE;
                    // 2020-5-20 15:55:14 HM 增加监护人信息
                    $scope.infomation.guardianName = data.data.GUARDIAN_NAME;
                    $scope.infomation.guardianPhone = data.data.GUARDIAN_PHONE;
                    $scope.infomation.currentAreaCode = data.data.CURRENT_AREA_CODE;
                    $scope.infomation.disease = data.data.DISEASE_LIST;// 所患疾病列表

                    // 咨询目的
                    $scope.purposeOtherShow = false;
                    var purposeStr = new Array();
                    purposeStr = data.data.PURPOSE.split("；");
                    $scope.infomation.purpose = "";
                    for (var i = 0; i < $scope.purposeList.length; i++) {
                        $scope.purposeList[i].status = "0";
                        if (("," + $scope.purposeList[i].way + ",").indexOf("," + $scope.fromDivision + ",") == -1) {
                            continue;
                        }
                        for (var j = 0; j < purposeStr.length; j++) {
                            if (purposeStr[j] == $scope.purposeList[i].name) {
                                // 帮他按一下
                                $scope.purposeCheckBox($scope.purposeList[i].code);
                            }
                        }
                    }
                    // 拿下边来赋值，因为到前边会被改成空字符串
                    $scope.infomation.help = data.data.HELP; // 希望获得的帮助

                    $scope.infomation.takeMedWay = data.data.TAKE_MED_WAY;// 取药方式

                    // 没有病情信息ID
                    if ($scope.infomationId == null || $scope.infomationId.length == 0) {
                        //创建新的病情信息
                        ConsultationService.submitInfomation("", "", "", "", 0,
                            "", 0, "", 0, "", "",
                            $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, "", "0", 0, "", "", "", $scope.treatType, "").then(function (dataInfomation) {
                                // 创建成功
                                if (dataInfomation.result == 1) {
                                    // 第三次赋值，存一下病情信息Id
                                    $scope.infomationId = dataInfomation.data;
                                    // 复制图片，新创建的id，和旧的导入的id
                                    ConsultationService.copyImg($scope.infomationId, $scope.infomationHistoryList[index].TREAT_INFOMATION_ID).then(function (dataCopy) {
                                        $ionicLoading.hide();
                                        if (dataCopy.result == 1) {
                                            $scope.infomation.imgList = dataCopy.data;

                                            // 2022-3-16 14:59:08 WX DICOM影像加入imgList
                                            $scope.getDicomImgList($scope.infomationId);
                                            setTimeout(function () {
                                                $ionicScrollDelegate.resize();
                                            }, 500);
                                        }
                                        else {
                                            $fwCordovaToast.showShortBottom(dataCopy.msg);
                                        }
                                    }, function () {
                                        $fwCordovaToast.showShortBottom("网络错误");
                                        $ionicLoading.hide();
                                    })
                                }
                                // 创建失败
                                else {
                                    $fwCordovaToast.showShortBottom(dataInfomation.msg);
                                    $ionicLoading.hide();
                                }
                            }, function () {
                                $fwCordovaToast.showShortBottom("网络错误");
                                $ionicLoading.hide();
                            })
                    }
                    // 有病情信息ID
                    else {
                        UploadImgService.imgList("BY_CONSULTATION", $scope.infomationId).then(function (dataImg) {
                            $ionicLoading.hide();
                            if (data.result == 0) {
                                $fwCordovaToast.showShortBottom(dataImg.msg);
                            } else {
                                $scope.infomation.imgList = dataImg.data;
                                if (devMode) {
                                    // 2022-3-16 14:59:08 WX DICOM影像加入imgList
                                    $scope.getDicomImgList($scope.infomationId);
                                    setTimeout(function () {
                                        $ionicScrollDelegate.resize();
                                    }, 500);
                                }
                                $ionicScrollDelegate.resize();
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("网络错误");
                            $ionicLoading.hide();
                        })
                    }

                    $scope.hideInfomationHistory();
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误，导入失败");
                    $ionicLoading.hide();
                    // 回选择预约方式页
                    if ($scope.chooseDoctor == true) {
                        $scope.toSlide(1);
                    }
                    else {
                        $scope.toSlide(3);
                    }
                })
            }
        });
    }

    // 8.保存问卷结果（这是一个支线任务）
    $scope.saveResult = function () {
        $ionicLoading.show();
        SrvyService.saveRecord($scope.tmplInfo.id, $scope.currentRec, $scope.inVpid, $scope.srvyResult).then(function (data) {
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("问卷填写完成！");
                // 初始化题目信息（防止再次进入显示混乱）
                $scope.tmpl = new Object();
                $scope.tmplInfo = new Object();
                $scope.qstnCount = 0;

                $scope.hideTmpl();

                $ionicLoading.hide();

                // 将recId回写infomation吧，关联
                ConsultationService.writeBackRecId(data.recId, $scope.infomationId).then(function (dataBack) {
                    $ionicLoading.hide();
                    if (dataBack.result == 1) {
                        // 回写成功之后，跳转
                        $scope.toSlide(5);
                    }
                    else {
                        $fwCordovaToast.showShortBottom(dataBack.msg);
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("回写RECID失败");
                    $ionicLoading.hide();
                })
            } else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    // #region 问卷工具类

    // 隐藏问卷填写信息
    $scope.hideTmpl = function () {
        $scope.srvyModal.hide();
    }

    // #endregion

    // 9.知情同意书
    // #region 知情同意书工具类

    // 知情同意书显示
    $scope.informedConsentShow = function () {
        $scope.informedConsentModal.show();
    }

    // 知情同意书关闭
    $scope.informedConsentHide = function () {
        $scope.informedConsentModal.hide();
    }

    // #endregion

    // 10.提交病情信息，进行支付操作
    $scope.submitInfomation = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 其他的对象
        var other = $scope.purposeList.filter(e => e.code == '999');

        // 2020-8-3 08:18:46 HM 如果是药师咨询，本次咨询目的只有药学咨询
        if ($scope.fromDivision == 3 || $scope.fromDivision == 4) {
            other.status = "0";
            $scope.infomation.help = "";

            var pur = $scope.purposeList.filter(e => e.way == $scope.fromDivision)[0];
            $scope.infomation.purpose = pur.name + "；";
        }
        // 填空判断
        if ($scope.infomation.disease.length == 0) {
            $fwCordovaToast.showShortBottom("请至少选择一项疾病。");
        }
        else if ($scope.infomation.infomation.length < 20) {
            $fwCordovaToast.showShortBottom("病情描述信息不得少于20个字。");
        }
        else if ($scope.infomation.purpose.length == 0) {
            $fwCordovaToast.showShortBottom("本次咨询的目的不能为空。");
        }
        else if (other.status == "1" && $scope.infomation.help.length < 5) {
            $fwCordovaToast.showShortBottom("本次咨询的目的不得少于5个字");
        }
        else if ($scope.infomation.visitHospital.length == 0) {
            $fwCordovaToast.showShortBottom("已就诊医院及科室不能为空。");
        }
        else if ($scope.infomation.isDrug == 1 && $scope.infomation.drug.length == 0) {
            $fwCordovaToast.showShortBottom("用药情况信息不能为空。");
        }
        else if ($scope.infomation.isAllergy == 1 && $scope.infomation.allergy.length == 0) {
            $fwCordovaToast.showShortBottom("过敏史信息不能为空。");
        }
        else if ($scope.infomation.isPreviousDisease == 1 && $scope.infomation.previousDisease.length == 0) {
            $fwCordovaToast.showShortBottom("既往病史信息不能为空。");
        }
        // 判断是否上传图片，要先判断是否有infomationId，还得再判断是否有图片，测试版api开启devmode
        else if (($scope.infomationId == null || $scope.infomationId.length == 0 || $scope.infomation.imgList.length == 0) && devMode == false && window.cordova) {
            $fwCordovaToast.showShortBottom("请上传检查资料。");
        }
        // 如果需要填写监护人信息，但是没有填，弹错误
        else if ($scope.vpInfo.IS_GUARDIAN == 1 && ($scope.infomation.guardianName.length == 0 || $scope.infomation.guardianPhone.length == 0)) {
            $fwCordovaToast.showShortBottom("请填写监护人信息。");
        }
        else if ($scope.infomation.currentAreaCode.length == 0) {
            $fwCordovaToast.showShortBottom("请选择现住址行政区划。");
        }
        else {
            // 只做提交病情信息这个事，插请求和收费之后再去做，此时的infomationId应该不会为空
            if ($scope.infomation.purpose.charAt($scope.infomation.purpose.length - 1) == "；") {
                $scope.infomation.purpose = $scope.infomation.purpose.substr(0, $scope.infomation.purpose.length - 1);
            }

            var diseaseString = "";
            for (var i = 0; i < $scope.infomation.disease.length; i++) {
                if ($scope.infomation.disease[i].RECS_CODE.length != 0) {
                    diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@" + $scope.infomation.disease[i].RECS_CODE + "|";
                }
                else if ($scope.infomation.disease[i].DISEASE_NAME.length != 0) {
                    diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@0|";
                }
            }
            diseaseString = diseaseString.substr(0, diseaseString.length - 1);
            // 增加疾病格式化判断，保证提交的诊断全是标准化诊断
            if (diseaseString.indexOf("@") == -1) {
                $fwCordovaToast.showShortBottom("疾病格式错误，请重新选择疾病");
                return;
            }

            // 如果是复诊续方资质延长
            if ($scope.fromDivision == 4) {
                $scope.infomation.isDrug = 1;
                if ($scope.infomation.drug != "" && $scope.infomation.drug.length > 0) {
                    var drugStr = $scope.infomation.drugOL + "\r\n";
                    drugStr += "其他用药情况：\r\n";
                    drugStr += $scope.infomation.drug;
                    $scope.infomation.drug = drugStr;
                }
                else {
                    $scope.infomation.drug = $scope.infomation.drugOL;
                }
            }

            // 如果是视频问诊，需要验证是否选择了取药方式
            if ($scope.treatType == 2) {
                if ($scope.infomation.takeMedWay != 1 && $scope.infomation.takeMedWay != 3) {
                    $fwCordovaToast.showShortBottom("请选择取药方式");
                    return;
                }
            }

            $ionicLoading.show();
            ConsultationService.submitInfomation(diseaseString, $scope.infomation.infomation, $scope.infomation.help, $scope.infomation.visitHospital,
                $scope.infomation.isDrug, $scope.infomation.drug, $scope.infomation.isAllergy, $scope.infomation.allergy, $scope.infomation.isPreviousDisease, $scope.infomation.previousDisease,
                $scope.infomation.purpose, $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, $scope.infomationId, "1",
                $scope.vpInfo.IS_GUARDIAN, $scope.infomation.guardianName, $scope.infomation.guardianPhone, $scope.infomation.currentAreaCode, $scope.treatType, $scope.infomation.takeMedWay).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        // 第四次赋值，提交完成后的infomationId
                        $scope.infomationId = data.data;

                        // API控制，是否填问卷，填哪份问卷
                        if (data.srvy.isSrvy == 1) {
                            console.log("应该跳到体检问卷里了");
                            // 加载模板
                            SrvyService.items(data.srvy.srvyTmpl).then(function (dataSrvy) {
                                $scope.tmpl = dataSrvy.QSTN_LIST;
                                $scope.tmplInfo.name = dataSrvy.TMPL_NAME;
                                $scope.tmplInfo.id = dataSrvy.TMPL_ID;
                                $scope.tmplInfo.display = dataSrvy.TMPL_DISPLAY;
                                $scope.qstnCount = $scope.tmpl.length;

                                $scope.isLoadFinish_Tmpl = true;

                                $ionicScrollDelegate.resize();
                                $ionicScrollDelegate.scrollTop();

                                if ($scope.tmplInfo.display == "SLIDE") {
                                    $timeout(function () {
                                        $scope.$broadcast('slideTmplList.init');
                                        $ionicLoading.hide();
                                    }, 300);
                                } else {
                                    $ionicLoading.hide();
                                }
                            })

                            $scope.srvyList = [];
                            $scope.srvyModal.show();
                        }
                        else {
                            // 插入病情信息成功，跳转
                            $scope.toSlide(5);
                        }
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误");
                    $ionicLoading.hide();
                })
        }
    }

    // 11.立即咨询（图文问诊医师会直接跳到14）
    $scope.goConsultation = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $ionicLoading.show();
        // 2020-9-23 11:26:52 HM 增加复诊续方资质延长，把就诊方式改下
        var consultationWay = 1;
        if ($scope.fromDivision == 1 || $scope.fromDivision == 2) {
            consultationWay = 1;
        }
        else if ($scope.fromDivision == 3) {
            consultationWay = 2;
        }
        else if ($scope.fromDivision == 4) {
            consultationWay = 3;
        }

        // 图文问诊
        if ($scope.treatType == "1") {
            // 验证是否有applyId，没有的话创建申请，再验证支付状态，再调易复诊
            if ($scope.applyId == null || $scope.applyId.length == 0) {
                ConsultationService.submitApply($scope.inVpid, $scope.selectDoctor.TREAT_DOCTOR_ID, $scope.IsConsultation, consultationWay, $scope.isPatientMI).then(function (dataSubmit) {
                    $ionicLoading.hide();
                    if (dataSubmit.result == 1) {
                        $scope.applyId = dataSubmit.data;

                        // 2023-2-22 16:32:14 HM 增加幂等处理，这里返回的状态，可能是未支付，支付中，已发起会话 三个状态
                        // 未支付，走收银台
                        if (dataSubmit.status == 0) {
                            // 如果医师服务费为-1，为免费的
                            if ($scope.selectDoctor.TREAT_FEE == -1) {
                                $scope.respApply();
                            }
                            else {
                                // 读后台一个开关，如果是医保患者，后台开关是关，则走自费
                                if ($scope.isPatientMI == true && dataSubmit.byTreatBJYBPayStatus == "0") {
                                    $scope.isPatientMI = false;
                                }

                                //收银台
                                $scope.cashier("consultation", $scope.selectDoctor.TREAT_FEE, $scope.inVpid, $scope.applyId, "", "", $scope.selectDoctor.DOCTOR_CODE, $scope.isPatientMI, "", "", $scope.selectDoctor.TREAT_FEE).then(function (dataCashier) {
                                    if (dataCashier.code == 1) {
                                        $scope.respApply();
                                    }
                                    else {
                                        $scope.applyId = "";
                                        // 2024-4-17 09:54:17 HM 先把倒计时做出来
                                        $state.go('app.consultationList', { treatType: "1" });
                                    }
                                })
                            }
                        }
                        // 支付中，暂时不用管，让他等一会 再点一次
                        else if (dataSubmit.status == 1) {
                            $fwCordovaToast.showShortBottom("当前网络不佳，请重试");
                        }
                        // 调用易复诊SDK发起会话
                        else if (dataSubmit.status == 2) {
                            if (dataSubmit.imType == "1") {
                                var param = {
                                    accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                                    accountId: $scope.inVpid,
                                    patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                                    patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                                    patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                                    patientHeadPic: $scope.vpInfo.HEAD_PIC,
                                    patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                                    doctorId: dataSubmit.doctorCode,
                                    doctorEmployeeCardNo: dataSubmit.staffNumber, // 胸卡号
                                    hospitalOrderId: $scope.applyId,
                                    fuzhen: $scope.IsConsultation
                                };

                                var funcSuccess = function (funcData) {
                                    console.log('百洋：toChat 调用成功');
                                    console.log(funcData);
                                }

                                var funcError = function (funcData) {
                                    console.log('百洋：toChat 调用失败');
                                    console.log(funcData);
                                }
                                // 2023-10-07 11:09:00 CGZ 移除道一巡和易复诊插件
                                //window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                            }
                            // 调腾讯SDK
                            else {
                                var param = { type: "chat", param: dataSubmit.imUrl };

                                var funcSuccess = function (data) {
                                    console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                                    console.log(data);
                                }
                                var funcError = function (data) {
                                    console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                                    console.log(data);
                                }

                                window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
                            }
                        }
                        else {
                            $fwCordovaToast.showShortBottom("网络错误");
                        }
                    }
                    else {
                        $fwCordovaToast.showShortBottom(dataSubmit.msg);
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误");
                })
            }
            // 调易复诊
            else {
                ConsultationService.getBYStatus($scope.applyId).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    // 有会话，会话已经结束
                    else if (data.result == 2) {
                        $state.go('app.consultationList');
                    }
                    // 1 = 有会话，正在会话中,3 = 查不到会话
                    else if (data.result == 1 || data.result == 3) {
                        // 调易复诊SDK
                        if (data.data.IM_TYPE == "1") {
                            var param = {
                                accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                                accountId: $scope.inVpid,
                                patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                                patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                                patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                                patientHeadPic: $scope.vpInfo.HEAD_PIC,
                                patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                                doctorId: data.data.DOCTOR_CODE,
                                doctorEmployeeCardNo: data.data.STAFF_NUMBER, // 胸卡号
                                hospitalOrderId: $scope.applyId,
                                fuzhen: $scope.IsConsultation
                            };

                            var funcSuccess = function (funcData) {
                                console.log('百洋：toChat 调用成功');
                                console.log(funcData);
                            }

                            var funcError = function (funcData) {
                                console.log('百洋：toChat 调用失败');
                                console.log(funcData);
                            }
                            // 2023-10-07 11:09:00 CGZ 移除道一巡和易复诊插件
                            //window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                        }
                        // 调腾讯SDK
                        else {
                            var param = { type: "chat", param: data.data.IM_URL };

                            var funcSuccess = function (data) {
                                console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                                console.log(data);
                            }
                            var funcError = function (data) {
                                console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                                console.log(data);
                            }

                            window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
                        }
                    }
                })
            }
        }
        // 视频问诊
        else {
            $ionicLoading.hide();
            if ($scope.uploadMIImage == true) {
                $scope.uploadMIShow();
            }
            else {
                $scope.submitVideoApply();
            }
        }
    }

    // 12.上传医保卡
    $scope.uploadMIShow = function () {
        var data = $scope.MI;
        $scope.uploadMIModalShow();
        $scope.$broadcast("uploadMIShow", data);
    }

    // 12.1上传医保卡提交
    $scope.$on('uploadMIHide', function (event, data) {
        $scope.uploadMIModalHide();
        if (data.type == "submit") {
            console.log("成功了");
            // 上传完医保卡，这里直接添加视频问诊申请
            $scope.submitVideoApply();
        }
    })

    // 13.添加视频问诊申请
    $scope.submitVideoApply = function () {
        $ionicLoading.show();
        // 由这个方法返回金额和treatApplyId
        ConsultationService.submitVideoApply($scope.inVpid, $scope.selectDoctor.TREAT_SCHED_ID, $scope.isPatientMI, $scope.examListInfo).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                // 加timeout，否则前端会卡死
                $timeout(function () {
                    $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: "确定"
                    });
                }, 500);
            }
            else {
                // 要支付
                if (data.data.PAY_STATUS == "1") {
                    // 医保患者或非医保，直接缴费，医保患者由轮询控制，退40块钱
                    // 2024-2-21 13:59:10 HM hzfwx-713 视频问诊支持直连移动支付方式，收银台支持跳转到首信移动支付
                    // 2024-4-8 15:40:50 HM 加个后台开关，如果后台开关是关的，不走医保移动支付，传给收银台的是false
                    if (data.data.BJYBMI_PAY_STATUS != "1") {
                        $scope.isPatientMI = false;
                    }
                    //$scope.isPatientMI = false;
                    $ionicLoading.hide();
                    // 收银台
                    // 这里用selectDoctor，是因为，为了和给患者显示的金额保持一致
                    $scope.cashier("olTreat", $scope.selectDoctor.TREAT_FEE, $scope.inVpid, data.data.TREAT_APPLY_ID, "", "", $scope.selectDoctor.DOCTOR_CODE, $scope.isPatientMI, "", "", $scope.selectDoctor.TREAT_FEE).then(function (dataCashier) {
                        // 支付成功 获取订单状态
                        if (dataCashier.code == 1) {
                            // 等待支付轮询结果
                            $scope.respApplyVideo(data.data.TREAT_APPLY_ID);
                        }
                        else {
                            // 支付失败也走这，但其实号已经占上了
                            $state.go("app.olTreatVideo", { treatApplyId: data.data.TREAT_APPLY_ID, vpId: $scope.inVpid });
                        }
                    })
                }
                // 不要支付
                else {
                    $ionicLoading.hide();
                    $scope.respApplyVideo(data.data.TREAT_APPLY_ID);
                }
            }
        }, function (data) {
            $ionicLoading.hide();
            // 加timeout，否则前端会卡死
            $timeout(function () {
                $ionicPopup.alert({
                    title: '提示',
                    template: "添加视频问诊预约失败，请稍后再试",
                    okText: "确定"
                });
            }, 500);
        })
    }

    // 14.验证支付状态，调易复诊
    $scope.respApply = function () {
        $ionicLoading.show();
        ConsultationService.respApply($scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                // 2021-10-20 15:44:46 HM 需要根据返回值判断调用百洋还是腾讯IM
                if (data.data.IM_TYPE == "1") {
                    // 调易复诊sdk
                    // 2020-2-6 14:02:52 HM 在线咨询功能修改，这里全部默认为初诊患者，0为初诊、1为就诊
                    var param = {
                        accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                        accountId: $scope.inVpid,
                        patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                        patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                        patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                        patientHeadPic: $scope.vpInfo.HEAD_PIC,
                        patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                        doctorId: $scope.selectDoctor.DOCTOR_CODE,
                        doctorEmployeeCardNo: $scope.selectDoctor.STAFF_NUMBER, // 胸卡号
                        hospitalOrderId: $scope.applyId,
                        fuzhen: $scope.IsConsultation
                    };

                    var funcSuccess = function (funcData) {
                        console.log('百洋：toChat 调用成功');
                        console.log(funcData);
                    }

                    var funcError = function (funcData) {
                        console.log('百洋：toChat 调用失败');
                        console.log(funcData);
                    }
                    // 2023-10-07 11:09:00 CGZ 移除道一巡和易复诊插件
                    //window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                }
                else {
                    // 调腾讯小程序SDK
                    var param = { type: "chat", param: data.data.IM_URL };

                    var funcSuccess = function (data) {
                        console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                        console.log(data);
                    }
                    var funcError = function (data) {
                        console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                        console.log(data);
                    }

                    window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
                }
            }
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误");
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误");
            $ionicLoading.hide();
        })
    }

    // 14.1验证支付状态，视频问诊
    $scope.respApplyVideo = function (applyId) {
        $ionicLoading.show();
        // 等待支付轮询结果
        OlTreatRecipeService.getSubmitApply(applyId).then(function (dataResp) {
            $ionicLoading.hide();
            //轮询成功
            if (dataResp.result == 1) {
                // 轮询成功
                if (dataResp.applyResult == 1) {
                    // 插个异步请求，关联复诊表
                    if ($stateParams.from.indexOf("subTreatRemind") > -1) {
                        OlTreatRecipeService.relationTreatRemind(applyId, $scope.inVpid).then(function (data) { });
                    }
                    // 直接跳转到【视频问诊页面】
                    $state.go("app.olTreatVideo", { treatApplyId: applyId, vpId: $scope.inVpid });
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: dataResp.msg,
                        okText: "确定"
                    });
                }
            }
            else if (dataResp.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "服务繁忙，请稍后重试",
                    okText: "确定"
                });
            }
            // 获取失败
            else {
                $ionicPopup.alert({
                    title: '提示',
                    template: dataResp.msg,
                    okText: "确定"
                });
            }
        }, function (dataResp) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: dataResp.msg,
                okText: "确定"
            });
        })
    }

    // 须知我同意，直接跳医师模态
    $scope.agree = function () {
        // $scope.doctorIntro($stateParams.doctorCode);
        //cfw 2022年12月21日14:19:54 增加从智能分诊调用方式
        if ($stateParams.from == "app.autoInquiry") {
            //如果是智能分诊调用，跳转到图文或视频问诊
            $scope.chooseTreatType($stateParams.consultationType, $stateParams.doctorCode);
        } else {
            //之前默认为医师主页
            $scope.doctorIntro($stateParams.doctorCode);
        }
        $timeout(function () {
            $scope.consultationDescriptionHide();
        }, 1000);
    }

    // 返回
    $scope.goBack = function () {
        // 病情描述
        if ($scope.step == 4) {
            // 先判断是否什么都没填，如果什么都没填，直接返回，不存储
            if ($scope.infomation.disease.length == 0 && $scope.infomation.infomation == "" && $scope.infomation.purpose == "" && $scope.infomation.visitHospital == "" &&
                $scope.infomation.drug == "" && $scope.infomation.allergy == "" && $scope.infomation.previousDisease == "" && $scope.infomation.guardianName == "" && $scope.infomation.guardianPhone == "") {

                // 回选择预约方式页
                if ($scope.chooseDoctor == true) {
                    $scope.toSlide(1);
                }
                // 如果病情资料返回，直接返回到预约方式页
                else if ($stateParams.doctorCode != '') {
                    $scope.toSlide(1);
                }
                else {
                    $scope.toSlide(3);
                }
            }
            else {
                $ionicPopup.confirm({
                    title: "保存确认",
                    template: "是否要保存已经填写的病情信息？",
                    cancelText: "否",
                    okText: "是"
                }).then(function (res) {
                    if (res) {
                        $ionicLoading.show();
                        // 向库插入病情信息,infomationId有可能为空，有可能不为空，为空的是为纯萌新填写，不为空的为复用之前的。
                        if ($scope.infomation.purpose.charAt($scope.infomation.purpose.length - 1) == "；") {
                            $scope.infomation.purpose = $scope.infomation.purpose.substr(0, $scope.infomation.purpose.length - 1);
                        }

                        var diseaseString = "";
                        for (var i = 0; i < $scope.infomation.disease.length; i++) {
                            if ($scope.infomation.disease[i].RECS_CODE.length != 0) {
                                diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@" + $scope.infomation.disease[i].RECS_CODE + "|";
                            }
                            else if ($scope.infomation.disease[i].DISEASE_NAME.length != 0) {
                                diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@0|";
                            }
                        }
                        diseaseString = diseaseString.substr(0, diseaseString.length - 1);

                        // 如果是复诊续方资质延长
                        if ($scope.fromDivision == 4) {
                            $scope.infomation.isDrug = 1;
                            if ($scope.infomation.drug != "" && $scope.infomation.drug.length > 0) {
                                var drugStr = $scope.infomation.drugOL + "\r\n";
                                drugStr += "其他用药情况：\r\n";
                                drugStr += $scope.infomation.drug;
                                $scope.infomation.drug = drugStr;
                            }
                            else {
                                $scope.infomation.drug = $scope.infomation.drugOL;
                            }
                        }

                        if ($scope.infomation.takeMedWay == 0) {
                            $scope.infomation.takeMedWay = "";
                        }

                        ConsultationService.submitInfomation(diseaseString, $scope.infomation.infomation, $scope.infomation.help, $scope.infomation.visitHospital, $scope.infomation.isDrug,
                            $scope.infomation.drug, $scope.infomation.isAllergy, $scope.infomation.allergy, $scope.infomation.isPreviousDisease, $scope.infomation.previousDisease, $scope.infomation.purpose,
                            $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, $scope.infomationId, "0", $scope.vpInfo.IS_GUARDIAN, $scope.infomation.guardianName, $scope.infomation.guardianPhone, $scope.infomation.currentAreaCode, $scope.treatType, $scope.infomation.takeMedWay).then(function (data) {
                                $ionicLoading.hide();
                                if (data.result == 1) {
                                    $fwCordovaToast.showShortBottom("保存成功");
                                }
                                else {
                                    $fwCordovaToast.showShortBottom(data.msg + "，保存失败");
                                }
                                // 回选择预约方式页
                                if ($scope.chooseDoctor == true) {
                                    $scope.toSlide(1);
                                }
                                // 如果病情资料返回，直接返回到预约方式页
                                else if ($stateParams.doctorCode != '') {
                                    $scope.toSlide(1);
                                }
                                else {
                                    $scope.toSlide(3);
                                }
                            }, function () {
                                $fwCordovaToast.showShortBottom("网络错误，保存失败");
                                $ionicLoading.hide();
                                // 回选择预约方式页
                                if ($scope.chooseDoctor == true) {
                                    $scope.toSlide(1);
                                }
                                // 如果病情资料返回，直接返回到预约方式页
                                else if ($stateParams.doctorCode != '') {
                                    $scope.toSlide(1);
                                }
                                else {
                                    $scope.toSlide(3);
                                }
                            })
                    }
                    else {
                        // 回选择预约方式页
                        if ($scope.chooseDoctor == true) {
                            $scope.toSlide(1);
                        }
                        // 如果病情资料返回，直接返回到预约方式页
                        else if ($stateParams.doctorCode != '') {
                            $scope.toSlide(1);
                        }
                        else {
                            $scope.toSlide(3);
                        }
                    }
                });
            }
        }
        // 支付确认
        else if ($scope.step == 5) {
            // 回选择预约方式页
            if ($scope.chooseDoctor == true) {
                $scope.toSlide(1);
            }
            // 如果病情资料返回，直接返回到预约方式页
            else if ($stateParams.doctorCode != '') {
                $scope.toSlide(1);
            }
            else {
                $scope.toSlide(3);
            }
        }
        // 选择医生
        else if ($scope.step == 3) {
            if ($scope.fromDivision == 1 || $scope.fromDivision == 3) {
                $scope.toSlide(1);
            }
            else if ($scope.fromDivision == 2 || $scope.fromDivision == 5 || $scope.fromDivision == 6 || $scope.fromDivision == 8 || $scope.fromDivision == 14) {
                $scope.toSlide(2);
            }
            else if ($scope.fromDivision == 4 || ($scope.fromDivision == 15 && $stateParams.from == "customer")) {
                $state.go("app.olTreatRecipe", { from: "consultation" });
            }
            else {
                $scope.toSlide(1);
            }
        }
        // 选择病区
        else if ($scope.step == 2) {
            $scope.toSlide(1);
        }
        // 选择预约方式
        else if ($scope.step == 1) {
            $scope.toSlide(0);
        }
        else {
            if ($scope.step == 0 && $stateParams.from.indexOf('autoInquiry') > -1) {
                $state.go("app.autoInquiry", { vpid: $stateParams.vpid, firstFrom: $stateParams.autoFirstFrom, continueInquiry: 1 });
            }
            else if ($scope.step == 0 && ($stateParams.from.indexOf('app.flupSrvy') > -1 || $stateParams.from.indexOf('app.flupCHD') > -1)
                || $stateParams.from.indexOf('app.flupDRI') > -1 || $stateParams.from.indexOf('app.flupAF') > -1) {
                // hzg 专病随访或冠心病管理进入
                // gx  2023.08.18新增膳食营养管理进入
                // gx 新增心律失常随访（AF）进入
                $state.go($stateParams.from, { vpId: $stateParams.vpid });
            }
            else {
                $state.go('app.home');
            }
        }
    }

    // 页面切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        //$fwCordovaToast.showShortBottom("step: " + $scope.step);
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideConsultation.enableSlide(false);
    });

    $scope.$on('$ionicView.enter', function () {
        $ionicLoading.show();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'consultation');

        ConsultationService.visitPatientInfo($scope.inVpid).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            } else {
                $scope.vpInfo = data.data;

                ConsultationService.getConfig().then(function (conData) {
                    if (conData.result == 0) {
                        $fwCordovaToast.showShortBottom(conData.msg);
                        $ionicLoading.hide();
                    }
                    else {
                        $scope.configData = conData.data;
                        $scope.purposeList = $scope.configData.helpList;
                        // 页面进入
                        $scope.isLoadFinish = true;
                        if ($stateParams.doctorCode != '') {
                            $ionicLoading.hide();
                            $scope.fromDivision = 1;
                            $scope.consultationDescriptionShow();
                        }
                        // 2022-2-22 14:27:08 WX 高端体检 从dealWithCard跳过来，通过参数跳过选择问诊方式这步
                        // 且高端体检跳转的一定没有doctorCode
                        else if ($stateParams.from.indexOf('explainReport') > -1) {
                            $scope.consultationType = 2;
                            $scope.toSlide(1);
                            $scope.apptMethod(13);
                        }
                        // 2023-11-16 18:04:02 ZZL hzfwx-349 添加荣耀高危用户视频问诊
                        else if ($stateParams.from.indexOf('honor') > -1) {
                            $scope.consultationType = 2;
                            $scope.toSlide(1);
                            $scope.apptMethod(16);
                        }
                        else {
                            ConsultationService.consultationStatus($scope.inVpid, "", "").then(function (statusData) {
                                $ionicLoading.hide();
                                if (statusData.result == 0) {
                                    $fwCordovaToast.showShortBottom(statusData.msg);
                                }
                                // 有会话
                                else if (statusData.result == 1) {
                                    // 图文问诊
                                    if (statusData.treatType == "1") {
                                        var confirmPopup = $ionicPopup.confirm({
                                            title: statusData.msg,
                                            cancelText: '取消',
                                            okText: '进入'
                                        });
                                        // 进入会话，调用易复诊SDK
                                        confirmPopup.then(function (res) {
                                            if (res) {
                                                // 调易复诊SDK
                                                if (statusData.IM_TYPE == "1") {
                                                    var param = {
                                                        accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                                                        accountId: $scope.inVpid,
                                                        patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                                                        patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                                                        patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                                                        patientHeadPic: $scope.vpInfo.HEAD_PIC,
                                                        patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                                                        doctorId: statusData.doctorCode, // 四位医师代码
                                                        doctorEmployeeCardNo: statusData.staffNumber, // 胸卡号
                                                        hospitalOrderId: statusData.applyId,
                                                        fuzhen: $scope.IsConsultation
                                                    };

                                                    var funcSuccess = function (funcData) {
                                                        console.log('百洋：toChat 调用成功');
                                                        console.log(funcData);
                                                    }

                                                    var funcError = function (funcData) {
                                                        console.log('百洋：toChat 调用失败');
                                                        console.log(funcData);
                                                    }
                                                    // 2023-10-07 11:09:00 CGZ 移除道一巡和易复诊插件
                                                    //window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                                                }
                                                // 调腾讯SDK
                                                else {
                                                    var param = { type: "chat", param: statusData.IM_URL };

                                                    var funcSuccess = function (data) {
                                                        console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                                                        console.log(data);
                                                    }
                                                    var funcError = function (data) {
                                                        console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                                                        console.log(data);
                                                    }

                                                    window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
                                                }
                                            }
                                            else {
                                                // 如果来自复诊续方资质延长
                                                if ($stateParams.from.indexOf('olCondition') > -1) {
                                                    $scope.apptMethod(4);
                                                }
                                                // 如果来自复诊续方客服咨询
                                                else if ($stateParams.from.indexOf('customer') > -1) {
                                                    $scope.apptMethod(15);
                                                }
                                            }
                                        })
                                    }
                                    // 视频问诊
                                    else {
                                        var confirmPopup = $ionicPopup.confirm({
                                            title: statusData.msg,
                                            cancelText: '取消',
                                            okText: '进入'
                                        });
                                        // 进入会话
                                        confirmPopup.then(function (res) {
                                            if (res) {
                                                $state.go("app.consultationList", { treatType: "2" });
                                            }
                                        })
                                    }
                                }
                                else {
                                    // 如果来自复诊续方资质延长
                                    if ($stateParams.from.indexOf('olCondition') > -1) {
                                        $scope.apptMethod(4);
                                    }
                                    // 如果来自复诊续方客服咨询
                                    else if ($stateParams.from.indexOf('customer') > -1) {
                                        $scope.apptMethod(15);
                                    }
                                }
                            }, function () {
                                $fwCordovaToast.showShortBottom("获取会话状态：网络错误");
                                $ionicLoading.hide();
                            })
                        }
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误");
                    $ionicLoading.hide();
                })
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误");
            $ionicLoading.hide();
        });

        // 将模板消息服务叫醒
        ConsultationService.initServiceTmplMessage();
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'consultation') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
