﻿angular.module('fwapp.controllers')

// 核酸检测预约
.controller('CoronavirusController', function ($scope, $rootScope, $state, $http, $window, $interval, $timeout, $stateParams, $filter, $cordovaInAppBrowser, $cordovaDatePicker
, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform, $ionicSlideBoxDelegate, $ionicActionSheet, $fwCordovaToast
, CoronavirusService, VisitPatientService, OpRegService, PaymentService, AccountService, RequestService, CasePrintService, OpApptService, IpRegService) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义门诊缴费滑块
    var slideCoronavirus = $ionicSlideBoxDelegate.$getByHandle('slideCoronavirus');
    // 初始滑块状态
    $scope.step = 0;
    // 初始滑块状态--我的预约列表
    $scope.stepApplyList = 0;
    // 用户须知数据
    $scope.agreement = new Object();
    // 服务开启状态
    $scope.isServerOn = true;
    // 倒计时
    $scope.confirmCountdown = devMode ? 1 : 10;
    // 就诊人列表
    $scope.vpList = [];
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人ID
    $scope.vpId = "";
    // 2023-8-28 13:55:26 ZZL #hzfwx-107 现住址省市县字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 建卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '',
        //2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 绑卡模型
    $scope.vpBind = {
        name: '',
        card_num: '',
        card_num_show: '',
        phone_num: null,
        phone_num_show: '',
        veri_code: '',
        patient_id: '',
        is_self: 0
    };
    // 绑卡前一步是否来自选卡
    $scope.lastSelectCard = false;
    // 图片验证码
    $scope.imageVericode = {};
    // 来院登记
    $scope.temperature = {};
    $scope.tempSelect = [ { key: "是", value: 1 }, { key: "否", value: 0 } ];
    $scope.waySelect = [ "自驾车", "飞机", "火车" ];
    // 检查预约日期 给控件用的
    $scope.apptDate = {};
    // 日期数组
    $scope.apptDate.dateList = [];
    // 时段数组
    $scope.apptDate.timeList = [];
    // 选中的日期
    $scope.apptDate.target = "";
    // 选中的时段
    $scope.apptDate.targetTime = "";
    // 时段ID
    $scope.apptDate.timeAreaId = "";
    // 申请ID
    $scope.apptDate.applyId = "";
    // 申请列表
    $scope.applyList = [];
    // 申请列表错误信息
    $scope.applyListErrorMsg = "";
    // 医师代码
    $scope.doctorCode = "";
    // 是否显示条形码
    $scope.barCodeShow = "0";
    $scope.checkPosition = "0";
    // groupId
    $scope.groupId = "";
    // 要展示的预约天数
    $scope.apptDays = [];
    // 是否可预约
    $scope.isAppt = false;
    // 支付成功的申请
    $scope.payApply = {};
    // 从哪来的，用不用支付
    $scope.from = $stateParams.from;
    // 记一下上一步是从哪跳来的
    $scope.lastStep = 0;
    // 定时器关闭
    $scope.timerStop = false;
    // 没有支付的applyId
    $scope.notPayApplyId = "";
    // title数组
    $scope.titleList = ["用户须知", "选择预约方式", "选择就诊人", "来院人员登记", "选择预约日期", "预约成功", "我的预约", "预约详情"];
    // 外来的vpid，不让他选就诊人了
    $scope.paramVpId = $stateParams.vpid;
    $scope.paramFirstFrom = $stateParams.autoFirstFrom;
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}

    // 核酸检测方式配置项
    $scope.modeConfigList = [];
    // 核酸检测方式
    $scope.checkMode = "1";

    // 流调开关
    $scope.isOpenApptTemp = "0";

    // #region 滑块相关
    // 滑到上一步
    $scope.lastSlide = function () {
        slideCoronavirus.previous();
        $scope.step = slideCoronavirus.currentIndex();
    }

    // 滑到下一步
    $scope.nextSlide = function () {
        slideCoronavirus.next();
        $scope.step = slideCoronavirus.currentIndex();
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        if(index == 6){
            $scope.lastStep = slideCoronavirus.currentIndex();
            console.log("上一步：" +$scope.lastStep);
        }

        slideCoronavirus.slide(index);
        $scope.step = slideCoronavirus.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideCoronavirus.currentIndex();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // #endregion

    // #region 模态框相关

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：在线建档
    $ionicModal.fromTemplateUrl('applyCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.applyCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bind_card.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口:选就诊卡
    $ionicModal.fromTemplateUrl('chooseCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.chooseCardModal = modal;
    });

    // 新来院登记
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('temperature.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.temperatureModalNew = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.applyCardModal.remove();
        $scope.bindCardModal.remove();
        $scope.chooseCardModal.remove();
        $scope.temperatureModalNew.remove();
    })

    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.vpNew.idCardType = $scope.idCardTypeList[0].id;
        $scope.addVisitPatientModal.show();
    }

    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }

    // 办卡模态窗口显示
    $scope.applyCardShow = function (type) {
        // 复用办卡模态窗口，用于未开通预存患者上传身份证
        if (type == undefined) {
            $scope.applyCardType = 1;
        }
        else {
            $scope.applyCardType = type;
        }
        $scope.applyCardModal.show();
    }

    // 办卡模态窗口隐藏
    $scope.applyCardHide = function () {
        $scope.applyCardModal.hide();
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '',
            marital: 0
        }
    }

    // 绑卡模态窗口隐藏
    $scope.bindCardModalHide = function () {
        $scope.bindCardModal.hide();
        $scope.timespan = 0;
        $scope.vpBind = {
            name: '',
            card_num: '',
            card_num_show: '',
            phone_num: null,
            phone_num_show: '',
            veri_code: '',
            patient_id: '',
            is_self: 0
        };

        if ($scope.lastSelectCard) {
            $scope.chooseCardModalShow();
        }
    }

    // 新增 选卡部分显示
    $scope.chooseCardModalShow = function () {
        $scope.chooseCardModal.show();
    }

    // 新增 选卡部分隐藏
    $scope.chooseCardModalHide = function () {
        $scope.chooseCardModal.hide();
    }

    $scope.temperatureHideNew = function () {
        $scope.temperatureModalNew.hide();
    }

    // #endregion

    // 1.我同意
    $scope.agree = function () {
        // 去下一页，选择预约方式
        $scope.toSlide(1);
    }

    // 2.选择预约方式
    $scope.selectWay = function (index){
        if(index == 1){
            // 2020-8-25 17:03:37 HM 如果来自自动问诊，帮他选择就诊人
            if ($scope.from.indexOf('autoInquiry') > -1) {
                // 就诊人id
                var i = $.inArray($scope.paramVpId, $scope.vpList.map(function (e) {
                    return e.VISIT_PATIENT_ID;
                }));
                $scope.selectVp(i);
            }
            else {
                // 去下一页，个人预约
                $scope.toSlide(2);
            }
        }
        else if(index == 2){
            // 去下一页，团队预约
            // 弹alert
            $ionicPopup.alert({
                title: '提示',
                template: $scope.agreement.team,
                okText: "确定"
            });
        }
    }

    // 3.选择就诊人
    $scope.selectVp = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];

        // 必须要求全绑卡
        if ($scope.vpSelect.IS_BIND_CARD == '1') {
            // 检查是否开通预存账户
            $ionicLoading.show();
            PaymentService.checkPrePayAccount($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                // 请求错误
                if (data.result == 0 || data.result == -99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                // 请求成功
                if (data.result == 1) {
                    // 未开通预存账户
                    if (data.is_null == 1) {
                        console.log('开通预存账户');
                        OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $ionicLoading.hide();
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0 直接提交
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                if ($scope.vpApply.id_type == '0') {
                                    $scope.applyCardType = 2;
                                    $scope.submitCardApply();
                                }
                                else {
                                    // 显示办卡提示
                                    var applyCardPopup = $ionicPopup.show({
                                        title: '注意',
                                        template: "患者预存账户未开通，请上传身份证开通预存账户",
                                        buttons: [{
                                            text: '确定',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                applyCardPopup.close();
                                                // 不加timeout popup关不掉
                                                $timeout(function () {
                                                    $scope.applyCardShow(2);
                                                }, 0);
                                            }
                                        }]
                                    });
                                }
                            }
                            // 获取失败
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        })
                        return;
                    }
                    // 门诊预存账户余额为负数
                    else if (data.is_null == 2) {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                        return;
                    }

                    // 已开通预存账户
                    console.log(data.data);
                    $ionicLoading.hide();

                    // 下一步
                    $scope.vpId = $scope.vpSelect.VISIT_PATIENT_ID;
                    // $scope.temperatureOpen();
                    // 2020-10-26 10:06:27 HM 新流调
                    $scope.temperatureShowNew(4);
                }
                else {
                    $ionicLoading.hide();
                }
            })
        }
        // 未绑卡
        else {
            $ionicLoading.show();
            // 获取办卡状态
            OpRegService.patientCheck($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    // 无卡 --> 办卡
                    if (data.is_null == 1) {
                        console.log('无卡: ' + data.msg);
                        var createCardMsg = data.msg;
                        // 创建建卡申请 供上传图片使用
                        OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 1).then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 显示办卡提示
                                var applyCardPopup = $ionicPopup.show({
                                    title: '注意',
                                    template: createCardMsg,
                                    buttons: [{
                                        text: '确定',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            applyCardPopup.close();
                                            // 不加timeout popup关不掉
                                            $timeout(function () {
                                                $scope.applyCardShow(1);
                                            }, 0);
                                        }
                                    }]
                                });
                            }
                            // 获取失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                            $ionicLoading.hide();
                        })
                    }
                    // 一张卡 --> 下一步
                    else if (data.is_null == 0) {
                        console.log('一张卡: ' + data.msg);
                        // 没绑卡的 后台已经自动半绑卡/半绑卡的也在这
                        $scope.requestId = data.requestId;
                        VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, data.data).then(function (result) {
                            $ionicLoading.hide();
                            if (result.result == 1) {
                                var phone = result.phone_num;
                                var card_num = result.card_num;
                                if (phone == "" || card_num == "") {
                                    $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                                }
                                else {
                                    // 手机号
                                    $scope.vpBind.phone_num = phone;
                                    // 卡号
                                    $scope.vpBind.card_num = card_num;

                                    // 带*手机号
                                    $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                                    // 带*卡号
                                    $scope.vpBind.card_num_show = result.card_num_show;

                                    $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;

                                    // 获取图片验证码
                                    $scope.getImageVericode();
                                    $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                                    $scope.bindCardModal.show();
                                }
                            }
                            else {
                                $fwCordovaToast.showShortBottom(result.msg);
                            }
                        })
                    }
                    // 多张卡 --> 绑卡
                    else if (data.is_null == 2) {
                        console.log('多张卡: ' + data.msg);
                        $scope.requestId = data.requestId;
                        // 未绑卡状态 => 多卡 => 半绑，用过his_card_num => 不选了，绑它
                        if ($scope.vpSelect.IS_BIND_CARD == "2" && $scope.vpSelect.HIS_CARD_NUM != "") {
                            VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, $scope.vpSelect.HIS_CARD_NUM).then(function (result) {
                                $ionicLoading.hide();
                                if (result.result == 1) {
                                    // 拿到了手机号+卡号
                                    var phone = result.phone_num;
                                    var card_num = result.card_num;

                                    if (phone == "" || card_num == "") {
                                        $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                                    }
                                    else {
                                        // 手机号
                                        $scope.vpBind.phone_num = phone;
                                        // 卡号
                                        $scope.vpBind.card_num = card_num;

                                        // 带*手机号
                                        $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                                        // 带*卡号
                                        $scope.vpBind.card_num_show = result.card_num_show;

                                        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;

                                        // 获取图片验证码
                                        $scope.getImageVericode();
                                        $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                                        $scope.bindCardModal.show();
                                    }
                                }
                                else {
                                    $fwCordovaToast.showShortBottom(result.msg);
                                }
                            })
                        }
                        else {
                            $ionicLoading.hide();
                            $scope.cardList = data.data;
                            // 多卡提示
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.msg,
                                okText: "确定"
                            }).then(function () {
                                $scope.chooseCardModalShow();
                            });
                        }
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误，获取办卡状态");
                    }
                }
                // 获取错误
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误，获取办卡状态");
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误，获取办卡状态");
            })
        }
    }
    // #region 就诊人相关

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if($scope.vpNew.idCardType == 5){
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text +'不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.log($scope.vpList);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        })
    }

    // 提交建卡申请
    $scope.submitCardApply = function () {
        // 格式化手机号
        $scope.formatPhone();
        if ($scope.applyCardType == 1) {
            // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
            // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
            var isAddrFormat = false;
            // 现住址不为空-老流程填的，放过，走后边验证
            if ($scope.vpApply.address != '') {
                isAddrFormat = false;
            }
            // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
            else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
                isAddrFormat = true;
                $scope.vpApply.address = '';
                var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
                $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
                var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
                $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
                var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
                $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
                $scope.vpApply.address += $scope.vpApply.address_detail;
            }
            // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
            else {
                $fwCordovaToast.showShortBottom('请完整填写现住址信息');
                return false;
            }
            if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
                || ($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))
                || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
            // 2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
            var addressByteSize = getStringByteSize($scope.vpApply.address);
            //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
            // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
            if (isAddrFormat && addressByteSize > 40) {
                $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
                addressByteSize = getStringByteSize($scope.vpApply.address);
            }
            else if (addressByteSize <= 10 || addressByteSize > 40) {
                var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: msgStr,
                    okText: '确定'
                }).then(function () {
                });
                return false;
            }
        }
        else if ($scope.applyCardType == 2) {
            if (($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
        }

        $ionicLoading.show();
        // 提交建卡申请
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type, $scope.vpApply.marital).then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                // data == 1 --> 建卡成功
                if (data.data == 1) {
                    $scope.applyCardHide();     // 隐藏绑定页面
                    if ($scope.applyCardType == 1) {
                        $fwCordovaToast.showShortBottom('在线建档成功');
                    }
                    else if ($scope.applyCardType == 2) {
                        $fwCordovaToast.showShortBottom('开通预存账户成功');
                    }

                    // 就诊人列表
                    // 2020-9-4 17:45:57 HM 处理bug，获取排班需要建卡的his_card_num，没有重新赋值
                    VisitPatientService.visitPatientList().then(function (vpData) {
                        // 获取成功
                        if (vpData.result == 1) {
                            $scope.vpList = vpData.data;
                            console.log($scope.vpList);
                            var vpId = $scope.vpSelect.VISIT_PATIENT_ID;
                            var vpListFilter = $scope.vpList.filter(e => e.VISIT_PATIENT_ID == vpId);
                            var vpTemp = vpListFilter.length > 0 ? vpListFilter[0] : null;
                            var index = $scope.vpList.indexOf(vpTemp);
                            console.log(index);
                            $scope.selectVp(index);
                        }
                        // 获取失败
                        else {
                            $fwCordovaToast.showShortBottom(vpData.msg);
                        }
                    })
                }
                // data == 0 --> 建卡失败
                else if (data.data == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }
            // 获取失败
            else if (data.result == 99) {
                $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
            }
            else {
                // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                //$fwCordovaToast.showShortBottom(data.msg);
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: '确定'
                });
            }
            $ionicLoading.hide();
        })
    }

    // 格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // #region 应该是用不到的上传图片

    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿, type == -1 --> 正面医保卡照片, type == -2 --> 手持医保卡照片,
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }

    // 删除身份证照片
    $scope.deleteImg = function (type) {
        // confirm
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 50,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        //var uri = encodeURI("http://10.10.101.11:8080/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);

        // 2020-3-5 10:58:30 HM 医保验证
        if (type == -1 || type == -2) {
            options.params = { urlExt: "CASE_PRINT", ifDES: "1" };
            uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        }

        // 显示上传等待
        $ionicLoading.show();
        // 上传图片
        //$fwCordovaToast.showShortBottom(uri);
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            //$cordovaToast.showLongBottom(angular.toJson(result));
            //console.log(result);
            //console.log(result.response);
            if (type == 0 || type == 1 || type == 2) {
                var fileResult = {};
                eval("fileResult = " + result.response);
                $ionicLoading.hide();
                // 上传成功
                if (fileResult.result == 1) {
                    $fwCordovaToast.showShortBottom("上传成功");
                    // 头像面
                    if (type == 0) {
                        $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                    }
                    // 国徽面
                    else if (type == 1) {
                        $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                    }
                    // 户口簿
                    else if (type == 2) {
                        $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                    }
                }
                // 上传失败
                else {
                    $fwCordovaToast.showShortBottom(fileResult.msg);
                }
            }
            // 医保验证
            else if (type == -1 || type == -2) {
                if (result.response == undefined) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom("上传失败");
                }
                else {
                    if (result.response.indexOf('上传失败') >= 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom(result.response);
                    }
                    else {
                        $ionicLoading.hide();
                        if (type == -1) {
                            $scope.MI.MI_IMG_URL = result.response;
                        }
                        else {
                            $scope.MI.MI_PATIENT_IMG_URL = result.response;
                        }
                    }
                }
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }

    // #endregion

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function (vpId, phone, card_num, imageVericode) {
        // 验证图片验证码
        if (imageVericode == null || imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }

        $ionicLoading.show();
        RequestService.checkPatientCard(vpId, card_num, phone).then(function (data) {
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，" + data.msg);
                return;
            }
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，未找到相应患者信息");
                return;
            }

            // patient_id赋值
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            // 就诊卡绑定 => 验证码：5
            $scope.getMsgVericode(phone, '5', imageVericode);
        });
    }

    // 2018.1.8 获取短信验证码 带参数
    $scope.getMsgVericode = function (phoneNum, num, imgVericode) {
        AccountService.sendVericodeByPhone(phoneNum, num, imgVericode).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");

                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            else {
                $scope.getImageVericode();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 绑卡 2018.12.29 绑卡 => 自动开通电子就诊卡
    $scope.bindCardSubmit = function () {
        if (!$scope.checkCardNum()) {
            return false;
        }

        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }

        VisitPatientService.bindVisitPatient($scope.vpSelect.VISIT_PATIENT_ID, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self, true).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                // 隐藏绑定页面
                $scope.bindCardModalHide();

                // 如果来自选卡：隐藏选卡页面
                if ($scope.lastSelectCard) {
                    $scope.chooseCardModalHide();
                }

                // 就诊人列表
                $ionicLoading.show();
                VisitPatientService.visitPatientList().then(function (data) {
                    // 获取成功
                    if (data.result == 1) {
                        $scope.vpList = data.data;
                        console.log($scope.vpList);
                        var vpId = $scope.vpSelect.VISIT_PATIENT_ID;
                        var vpListFilter = $scope.vpList.filter(e => e.VISIT_PATIENT_ID == vpId);
                        var vpTemp = vpListFilter.length > 0 ? vpListFilter[0] : null;
                        var index = $scope.vpList.indexOf(vpTemp);
                        console.log(index);
                        $scope.selectVp(index);
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                })

                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
        })
    }

    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败 回滚
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwcordovaToast.showShortTop("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 20190930 新增：选择这张卡
    $scope.bindThisCard = function (index) {
        $ionicPopup.confirm({
            title: '选择绑卡确认',
            template: '是否绑定此就诊卡?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                bindCardSelectSubmit(index);
            }
            else { }
        });
    }

    // 20190930 新增：选卡=>绑它
    bindCardSelectSubmit = function (index) {
        if (index < 0 || index >= $scope.cardList.length || $scope.cardList[index] == null
            || $scope.cardList[index].PATIENT_ID == null || $scope.cardList[index].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardSelectV2($scope.vpSelect.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 这里出来是半绑卡状态
                VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (result) {
                    $ionicLoading.hide();
                    if (result.result == 1) {
                        // 拿到了手机号+卡号
                        var phone = result.phone_num;
                        var card_num = result.card_num;

                        if (phone == "" || card_num == "") {
                            $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                        }
                        else {
                            // 手机号
                            $scope.vpBind.phone_num = phone;
                            // 卡号
                            $scope.vpBind.card_num = card_num;

                            // 带*手机号
                            $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                            // 带*卡号
                            $scope.vpBind.card_num_show = result.card_num_show;

                            $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;

                            // 获取图片验证码
                            $scope.getImageVericode();
                            $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");

                            // 上一步是选卡
                            $scope.lastSelectCard = true;
                            // 选卡模态窗关闭
                            $scope.chooseCardModalHide();
                            // 绑卡 开
                            $scope.bindCardModal.show();
                        }
                    }
                })
            }
        })
    }

    // #endregion

    // #region 旧来院登记小黑屋

    // 4.来院登记
    $scope.temperatureOpen = function (){
        $scope.temperature = {};
        $scope.temperature.VISIT_PATIENT_ID = $scope.vpSelect.VISIT_PATIENT_ID;
        $ionicLoading.show();
        VisitPatientService.lastTemperature($scope.vpSelect.VISIT_PATIENT_ID).then(function(result){
            if(result.result == 1){

                // 2020-07-10 本地处理一下
                if(result.dt[0].IDCARD_CODE != null && result.dt[0].IDCARD_CODE.substr(0, 3) == "110"){
                    $scope.BJ.COUNTRY = result.dt[0].COUNTRY;
                }
                if(result.dt[0].FAMILY_IDCARD_CODE != null && result.dt[0].FAMILY_IDCARD_CODE.substr(0, 3) == "110"){
                    $scope.BJ.FAMILY_COUNTRY = result.dt[0].FAMILY_COUNTRY;
                }

                // 救一手旧数据
                if(result.dt[0].IS_NOT_BACK == null && result.dt[0].FAMILY_IS_NOT_BACK == null){
                    // 时间处理
                    result.dt[0].FAMILY_DATE_BACK = (result.dt[0].FAMILY_DATE_BACK == null? null : (new Date(result.dt[0].FAMILY_DATE_BACK)).Format("yyyy-MM-dd"));
                    result.dt[0].DATE_BACK = (result.dt[0].DATE_BACK == null? null:(new Date(result.dt[0].DATE_BACK)).Format("yyyy-MM-dd"));

                    $scope.temperature = result.dt[0];
                    // 旧数据重新选择省市县
                    // 2020-07-10 北京也采集地址了，不能轻易清了
                    $scope.clearBackSelect();
                    $scope.clearFamilyBackSelect();

                    $ionicLoading.hide();
                    $scope.popOpen(result.dt[0]);
                    return;
                }

                // 就诊人市/县
                var type = result.dt[0].IS_NOT_BACK == 1 ? 1 : 3;
                $scope.getCitys(type, result.dt[0]);
            }
            else if(result.result == -1){
                // 预留手机号
                RequestService.GetReservedPhone($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1 && data.is_null != 1){
                        $scope.temperature.PHONENUM = data.data[0].PHONENUM;
                    }
                    // 去下一页，流调页面
                    $scope.toSlide(3);
                });
            }
            else{
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom(result.msg);
            }
        })
    }
    // #region 来院登记相关

    // 2020-02-20 来院人员登记
    $scope.selectThis = function (type, value) {
        $scope.temperature[type] = value;

        // 防一手家属的历史数据京籍，改成非京籍在北京
        if(type == "FAMILY_IS_NOT_BACK" && value == 1){
            $scope.clearFamilySelect();
        }

        $ionicScrollDelegate.resize();
    }

    // 2020-02-24 来院人员登记 省市县：省
    $scope.getProvince = function () {
        CasePrintService.getProvince().then(function (result) {
            $scope.provinces = result.provinces;
        })
    }

    // 2020-03-05 省市县 =>很多省市县
    $scope.addrSetting = {
            1: { PROVINCE: "PROVINCE", CITY: "CITY", COUNTRY: "COUNTRY", citys: "citys", countrys: "countrys" },
            2: { PROVINCE: "FAMILY_PROVINCE", CITY: "FAMILY_CITY", COUNTRY: "FAMILY_COUNTRY", citys:"family_citys", countrys:"family_countrys" },
            3: { PROVINCE: "BACK_PROVINCE", CITY: "BACK_CITY", COUNTRY: "BACK_COUNTRY", citys:"back_citys", countrys:"back_countrys" },
            4: { PROVINCE: "FAMILY_BACK_PROVINCE", CITY: "FAMILY_BACK_CITY", COUNTRY: "FAMILY_BACK_COUNTRY", citys: "family_back_citys", countrys: "family_back_countrys" }
        };
    $scope.citys = { citys:[], family_citys:[], back_citys:[], family_back_citys:[] };
    $scope.countrys = { countrys:[], family_countrys:[], back_countrys:[], family_back_countrys:[] };

    // 省市县：市
    $scope.getCity = function (type) {
        $scope.temperature[$scope.addrSetting[type].CITY] = "";
        $scope.temperature[$scope.addrSetting[type].COUNTRY] = "";
        $scope.getCitys(type, null);
    }
    // 市
    $scope.getCitys = function(type, temp){
        var t = (temp == null? $scope.temperature[$scope.addrSetting[type].PROVINCE] : temp[$scope.addrSetting[type].PROVINCE]);
        CasePrintService.getCity(t).then(function (result) {
            $scope.citys[$scope.addrSetting[type].citys] = result.citys;
            // 初加载
            if(temp != null){
                $scope.getCountrys(type, temp);
            }
        })
    }

    // 省市县：县
    $scope.getCountry = function (type) {
        $scope.temperature[$scope.addrSetting[type].COUNTRY] = "";
        $scope.getCountrys(type, null);
    }
    // 县
    $scope.getCountrys = function(type, temp){
        var c = (temp == null ? $scope.temperature[$scope.addrSetting[type].CITY] : temp[$scope.addrSetting[type].CITY]);
        CasePrintService.getCounty(c).then(function (result) {
            $scope.countrys[$scope.addrSetting[type].countrys] = result.countys;
            // 初加载
            if(temp != null){
                if(type == 2 || type == 4){
                    $scope.isUse(temp);
                }
                else{
                    if(temp.HAS_FAMILY == 1){
                        type = temp.FAMILY_IS_NOT_BACK == 1 ? 2 : 4;
                        $scope.getCitys(type, temp);
                    }
                    else{
                        $scope.isUse(temp);
                    }
                }
            }
        })
    }

    // 2020-07-10 北京市下区
    $scope.getBJCounty = function(){
         CasePrintService.getCounty("北京市").then(function (result) {
            $scope.BJCounty = result.countys;
        });
    }

    // 2020-07-10
    $scope.BJ = { FAMILY_COUNTRY: "", COUNTRY: "" };

    // 是否复用
    $scope.isUse = function(temp){
        $timeout(function(){
            // 时间处理一下
            temp.FAMILY_DATE_BACK = (temp.FAMILY_DATE_BACK == null? null : (new Date(temp.FAMILY_DATE_BACK)).Format("yyyy-MM-dd"));
            temp.DATE_BACK = (temp.DATE_BACK == null? null:(new Date(temp.DATE_BACK)).Format("yyyy-MM-dd"));
            $scope.temperature = temp;
        },500);

        $ionicLoading.hide();
        $scope.popOpen(temp);
    }
    // 是否复用提示
    $scope.popOpen = function(temp){
        // 去下一页，流调页面
        $scope.toSlide(3);
        $ionicPopup.show({
            title: '提示',
            template: "您存在来院人员登记信息，是否应用?",
            buttons: [
            {
                text: '否',
                onTap: function(){
                    $scope.temperature = {};
                    $scope.temperature.VISIT_PATIENT_ID = $scope.vpSelect.VISIT_PATIENT_ID;
                    $scope.temperature.APPT_TEMPERATURE_ID = temp.APPT_TEMPERATURE_ID;
                    // 2020-07-20 把临时参数也清了
                    $scope.BJ = { FAMILY_COUNTRY: "", COUNTRY: "" };
                    $ionicScrollDelegate.scrollTop();
                }
            },
            { text: '是', type: 'button-positive' }]
        });
    }
    // 清除冗余数据
    $scope.clearSelect = function(){
        $scope.temperature.PROVINCE = "";
        $scope.temperature.CITY = "";
        $scope.temperature.COUNTRY = "";
        $scope.temperature.ADDRESS = "";
    }
    $scope.clearBackSelect = function(){
        $scope.temperature.DATE_BACK = "";
        $scope.temperature.WAY_BACK = "";
        $scope.temperature.BACK_PROVINCE = "";
        $scope.temperature.BACK_CITY = "";
        $scope.temperature.BACK_COUNTRY = "";
        $scope.temperature.BACK_ADDRESS = "";
    }
    $scope.clearFamilySelect = function(){
        $scope.temperature.FAMILY_PROVINCE = "";
        $scope.temperature.FAMILY_CITY = "";
        $scope.temperature.FAMILY_COUNTRY = "";
        $scope.temperature.FAMILY_ADDRESS = "";
    }
    $scope.clearFamilyBackSelect = function(){
        $scope.temperature.FAMILY_DATE_BACK = "";
        $scope.temperature.FAMILY_WAY_BACK = "";
        $scope.temperature.FAMILY_BACK_PROVINCE = "";
        $scope.temperature.FAMILY_BACK_CITY = "";
        $scope.temperature.FAMILY_BACK_COUNTRY = "";
        $scope.temperature.FAMILY_BACK_ADDRESS = "";
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // #endregion

    // 5.提交流调，获取可预约日期
    $scope.temperatureSubmit = function(){
        console.log($scope.temperature);

        if($scope.temperature.PHONENUM == undefined || $scope.temperature.PHONENUM == ""
            || $scope.temperature.IS_TOUCH == undefined
            || $scope.temperature.IS_INFECT == undefined
            || $scope.temperature.IS_LIVE_HIGH_RISK == undefined
            || $scope.temperature.IS_EXIT_BORDER == undefined
            || $scope.temperature.HAS_FAMILY == undefined){
            $fwCordovaToast.showLongBottom("请完整填写就诊人信息");
            return;
        }

        var reg = /^1[3-9][0-9]{9}$/;
        if (!reg.test($scope.temperature.PHONENUM)) {
            $fwCordovaToast.showLongBottom("请填写正确手机号码");
            return;
        }

        if($scope.vpSelect.IDCARD_CODE.substr(0, 3) != '110' || $scope.vpSelect.IDCARD_TYPE == 5){
            if($scope.temperature.IS_NOT_BACK == undefined ){
                $fwCordovaToast.showLongBottom("请选择是否常住（居住21天以上）北京");
                return;
            }

            if($scope.temperature.IS_NOT_BACK == 1){
                if($scope.temperature.PROVINCE == undefined || $scope.temperature.PROVINCE == ""
                || $scope.temperature.CITY == undefined || $scope.temperature.CITY == ""
                || $scope.temperature.COUNTRY == undefined || $scope.temperature.COUNTRY == ""
                || $scope.temperature.ADDRESS == undefined || $scope.temperature.ADDRESS == ""
                || $scope.temperature.ADDRESS == "无"){
                    $fwCordovaToast.showLongBottom("请选择来京常住省/市/县，并填写详细住址");
                    return;
                }
            }
            else{
                if($scope.temperature.DATE_BACK == undefined || $scope.temperature.DATE_BACK == ""
                || $scope.temperature.WAY_BACK == undefined
                || $scope.temperature.BACK_PROVINCE == undefined || $scope.temperature.BACK_PROVINCE == ""
                || $scope.temperature.BACK_CITY == undefined || $scope.temperature.BACK_CITY == ""
                || $scope.temperature.BACK_COUNTRY == undefined || $scope.temperature.BACK_COUNTRY == ""
                || $scope.temperature.BACK_ADDRESS == undefined || $scope.temperature.BACK_ADDRESS == ""
                || $scope.temperature.BACK_ADDRESS == "无"){
                    $fwCordovaToast.showLongBottom("请填写返京时间/方式，选择返京前居住省/市/县，并填写详细住址");
                    return;
                }
            }
        }
        // 2020-07-10 北京收集详细地址
        else{
            if($scope.BJ.COUNTRY == undefined || $scope.BJ.COUNTRY == ""
                || $scope.temperature.ADDRESS == undefined || $scope.temperature.ADDRESS == ""
                || $scope.temperature.ADDRESS == "无"){
                    $fwCordovaToast.showLongBottom("请选择在京所在区，并填写详细住址");
                    return;
                }
        }

        // 陪同家属
        if($scope.temperature.HAS_FAMILY == 1){
            if($scope.temperature.FAMILY_NAME == undefined || $scope.temperature.FAMILY_NAME == ""
                || $scope.temperature.FAMILY_IDCARD_CODE == undefined || $scope.temperature.FAMILY_IDCARD_CODE == ""
                || $scope.temperature.FAMILY_PHONENUM == undefined || $scope.temperature.FAMILY_PHONENUM == ""
                || $scope.temperature.FAMILY_IS_TOUCH == undefined
                || $scope.temperature.FAMILY_IS_INFECT == undefined
                || $scope.temperature.FAMILY_IS_LIVE_HIGH_RISK == undefined
                || $scope.temperature.FAMILY_IS_EXIT_BORDER == undefined){
                $fwCordovaToast.showLongBottom("请完整填写陪同家属信息");
                return;
            }

            reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            if (!reg.test($scope.temperature.FAMILY_IDCARD_CODE)) {
                $fwCordovaToast.showLongBottom("陪同家属身份证格式错误");
                return;
            }
            reg = /^1[3-9][0-9]{9}$/;
            if (!reg.test($scope.temperature.FAMILY_PHONENUM)) {
                $fwCordovaToast.showLongBottom("陪同家属联系方式格式错误");
                return;
            }

            if($scope.temperature.FAMILY_IDCARD_CODE.substr(0, 3) != '110'){
                if($scope.temperature.FAMILY_IS_NOT_BACK == undefined) {
                    $fwCordovaToast.showLongBottom("请选择家属是否常住（居住21天以上）北京");
                    return;
                }

                if($scope.temperature.FAMILY_IS_NOT_BACK == 1){
                     if($scope.temperature.FAMILY_PROVINCE == undefined || $scope.temperature.FAMILY_PROVINCE == ""
                        || $scope.temperature.FAMILY_CITY == undefined || $scope.temperature.FAMILY_CITY == ""
                        || $scope.temperature.FAMILY_COUNTRY == undefined || $scope.temperature.FAMILY_COUNTRY == ""
                        || $scope.temperature.FAMILY_ADDRESS == undefined || $scope.temperature.FAMILY_ADDRESS == ""
                        || $scope.temperature.FAMILY_ADDRESS == "无"){
                        $fwCordovaToast.showLongBottom("请选择陪同家属来京常住省/市/县，并填写详细住址");
                        return;
                    }
                }
                else{
                    if($scope.temperature.FAMILY_DATE_BACK == undefined || $scope.temperature.FAMILY_DATE_BACK == ""
                        || $scope.temperature.FAMILY_WAY_BACK == undefined
                        || $scope.temperature.FAMILY_BACK_PROVINCE == undefined || $scope.temperature.FAMILY_BACK_PROVINCE == ""
                        || $scope.temperature.FAMILY_BACK_CITY == undefined || $scope.temperature.FAMILY_BACK_CITY == ""
                        || $scope.temperature.FAMILY_BACK_COUNTRY == undefined || $scope.temperature.FAMILY_BACK_COUNTRY == ""
                        || $scope.temperature.FAMILY_BACK_ADDRESS == undefined || $scope.temperature.FAMILY_BACK_ADDRESS == ""
                        || $scope.temperature.FAMILY_BACK_ADDRESS == "无"){
                        $fwCordovaToast.showLongBottom("请填写陪同家属返京时间/方式，选择陪同家属返京前居住省/市/县，并填写详细住址");
                        return;
                    }
                }
            }
            // 2020-07-10 北京收集详细地址
            else{
                if($scope.BJ.FAMILY_COUNTRY == undefined || $scope.BJ.FAMILY_COUNTRY == ""
                    || $scope.temperature.FAMILY_ADDRESS == undefined || $scope.temperature.FAMILY_ADDRESS == ""
                    || $scope.temperature.FAMILY_ADDRESS == "无"){
                    $fwCordovaToast.showLongBottom("请选择陪同家属在京所在区，并填写详细住址");
                    return;
                }
            }
        }

        // 清除冗余数据 就诊人非京籍
        if($scope.vpSelect.IDCARD_CODE.substr(0, 3) != '110'){
            // 常驻
            if($scope.temperature.IS_NOT_BACK == 1){
                $scope.clearBackSelect();
            }
            else{
                $scope.clearSelect();
            }
        }
        else{
            $scope.temperature.PROVINCE = "北京市";
            $scope.temperature.CITY = "北京市";
            $scope.temperature.COUNTRY = $scope.BJ.COUNTRY;

            $scope.clearBackSelect();
        }

        // 有陪同家属 && 非家属京籍
        if($scope.temperature.HAS_FAMILY == 1 && $scope.temperature.FAMILY_IDCARD_CODE.substr(0, 3) != "110"){
            // 常驻
            if($scope.temperature.FAMILY_IS_NOT_BACK == 1){
                $scope.clearFamilyBackSelect();
            }
            else{
                $scope.clearFamilySelect();
            }
        }
        else{
            $scope.temperature.FAMILY_PROVINCE = "北京市";
            $scope.temperature.FAMILY_CITY = "北京市";
            $scope.temperature.FAMILY_COUNTRY = $scope.BJ.FAMILY_COUNTRY;

            $scope.clearFamilyBackSelect();
        }

        $ionicLoading.show();
        VisitPatientService.temperatureSubmit($scope.temperature).then(function (result){
            $ionicLoading.hide();
            if(result.result == 0){
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else{
                // 如果有msg 提示出来，没有则证明成功。这样可以兼容旧版本
                if(result.msg != ""){
                    $fwCordovaToast.showLongBottom(result.msg);
                }
                $scope.getCheckItemSched();
            }
        })
    }

    // #endregion

    // 4.新来院登记展示
    $scope.temperatureShowNew = function (step) {
        if ($scope.isOpenApptTemp == "1") {
            var data = {
                vpId: $scope.vpId,
                from: "coronavirus",
                step: step
            };

            $scope.$broadcast("temperatureShow", data);
            $scope.temperatureModalNew.show();
        }
        else {
            $scope.getCheckItemSched();
        }
    }

    // 5.新来院登记提交
    $scope.$on('temperatureHide', function (event, data) {
        $scope.temperatureHideNew();
        // 如果是提交
        if(data.type == "submit"){
            // 判断是否进黑名单
            $ionicLoading.show();
            VisitPatientService.EpidemiolSrvyToTemperature($scope.vpId, "2").then(function (result){
                $ionicLoading.hide();
                if(result.result == 0){
                    $fwCordovaToast.showShortBottom(result.msg);
                }
                else{
                    $scope.getCheckItemSched();
                }
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
        }
    });

    // 5.1 获取可预约时间
    $scope.getCheckItemSched = function (){
        $ionicLoading.show();
        // 这个我忘了为什么加 |0了，回头问一下
        RequestService.getCheckItemSched($scope.vpSelect.HIS_CARD_NUM, $scope.groupId + "|" + $scope.checkPosition).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        // 有记录
                        $scope.formatCheckItemSchedData(data.data);
                        $scope.toSlide(4);
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }

            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }

            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            $scope.formatCheckItemSchedData(data.data);
            $scope.toSlide(4);
        })
    }

    // 5.2 格式化并赋值预约改期数据
    $scope.formatCheckItemSchedData = function (data) {
        // 格式化日期
        data.forEach(e => e["ORDER_DATE_FORMAT"] = new Date(e["ORDER_DATE"]).Format("yyyy-MM-dd"));
        // 可预约日期列表
        $scope.apptDate.dateList = $scope.apptDays;
        console.log($scope.apptDate.dateList);// 最终的日期数组

        // 可预约时段
        $scope.apptDate.timeList = [];
        for(var i = 0; i < $scope.apptDate.dateList.length; i++){
            var timeList = [];
            for(var j = 0; j < data.length; j++){
                if($scope.apptDate.dateList[i] == data[j].ORDER_DATE_FORMAT){
                    var temp = {};
                    temp.date = data[j].ORDER_DATE_FORMAT;
                    temp.time = data[j].ORDER_TIME;
                    temp.areaId = data[j].TIME_AREA_ID;
                    temp.checked = false;

                    if(data[j].ORDER_STATUS == "0"){
                        temp.status = 0;// 可预约
                    }
                    else {
                        temp.status = 1;// 已约满
                    }

                    // 不管可不可预约，得显示出来
                    $scope.isAppt = true;
                    timeList.push(temp);
                }
            }
            var appt = new Object();
            appt.date = $scope.apptDate.dateList[i];
            appt.timeList = timeList;
            $scope.apptDate.timeList.push(appt);
        }
        console.log($scope.apptDate.timeList);
    }

    // 6.选择检测方式
    $scope.changeMode = function (modeStr) {
        for (var i = 0; i < $scope.modeConfigList.length; i++) {
            if (modeStr == $scope.modeConfigList[i].modeStr) {
                $scope.modeConfigList[i].checkStatus = 1;
                $scope.checkPosition = $scope.modeConfigList[i].position;
                $scope.groupId = $scope.modeConfigList[i].groupId;
                $scope.checkMode = modeStr;
                $scope.getCheckItemSched();
            }
            else {
                $scope.modeConfigList[i].checkStatus = 0;
            }
        }
    }

    // 6.1 选中时间
    $scope.selectTime = function (date, areaId) {
        console.log(date);
        console.log(areaId);
        for(var i = 0; i < $scope.apptDate.timeList.length; i++){
            for(var j = 0; j < $scope.apptDate.timeList[i].timeList.length; j++){
                if($scope.apptDate.timeList[i].timeList[j].areaId == areaId && $scope.apptDate.timeList[i].date == date){
                    if($scope.apptDate.timeList[i].timeList[j].status == 1){
                        $fwCordovaToast.showShortBottom("当前选择时段已约满");
                        return;
                    }

                    $scope.apptDate.timeList[i].timeList[j].checked = true;
                    $scope.apptDate.target = $scope.apptDate.timeList[i].timeList[j].date;
                    $scope.apptDate.targetTime = $scope.apptDate.timeList[i].timeList[j].time;
                    $scope.apptDate.timeAreaId = $scope.apptDate.timeList[i].timeList[j].areaId;

                }
                else{
                    $scope.apptDate.timeList[i].timeList[j].checked = false;
                }
            }
        }
    }

    // 6.2 提交选择时间
    $scope.submitApply = function () {
        // 先插入待支付的订单
        $ionicLoading.show();
        CoronavirusService.submitApply($scope.vpSelect.VISIT_PATIENT_ID, $scope.apptDate.target, $scope.apptDate.targetTime, $scope.apptDate.timeAreaId, $scope.checkMode).then(function (data){
            console.log(data);
            if(data.result == 99){
                $fwCordovaToast.showShortBottom("网络超时，提交预约申请失败请稍后重试");
                $ionicLoading.hide();
            }

            if(data.result == 0){
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }

            if(data.result == 1 && data.is_null == 1){
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }

            if(data.result == 1 && data.is_null == 0){
                $scope.apptDate.applyId = data.APPLY_ID;

                // 去支付
                //$scope.payOrder($scope.vpSelect.VISIT_PATIENT_ID, data.data[0].CHECK_LIST_NUM, $scope.apptDate.applyId, "Single");

                // 2022-1-19 14:38:03 HM 不缴费了
                $scope.paySuccess($scope.apptDate.applyId);
            }
        }, function (data) {
            $ionicPopup.alert({
                title: '提示',
                template: data.msg,
                okText: "确定"
            });
            $ionicLoading.hide();
        })
    }

    // 7.我的预约
    $scope.applyListShow = function () {
        if($scope.step == 6){
            return;
        }
        else if($scope.step == 7){
            $scope.lastSlide();
        }

        $scope.getApplyList();
        $scope.toSlide(6);
    }

    // 7.1 获取我的预约详情
    $scope.getApplyList = function (){
        $scope.applyList = [];
        // 向后台请求数据
        $ionicLoading.show();
        CoronavirusService.getApplyList().then(function (data){
            $ionicLoading.hide();
            console.log(data);
            if(data.result == 1){
                $scope.applyList = data.data;
            }
            else {
                $scope.applyListErrorMsg = data.msg;
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误，获取我的预约列表失败");
            $ionicLoading.hide();
        })
    }

    // 8.预约详情
    $scope.applyDetailShow = function (index) {
        if ($scope.applyList[index].STATUS != 4) {
            return;
        }

        $ionicLoading.show();
        CoronavirusService.getApplyDetail($scope.applyList[index].NCP_APPLY_ID).then(function (data){
            console.log(data);
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        $fwCordovaToast.showShortBottom("获取预约详情失败，请稍后重试");
                    } else {
                        $scope.barCodeLoading(data);
                    }
                    $ionicLoading.hide();
                    // 去判断是否要加载条形码，然后跳下一页
                }, 1000);
                return;
            }

            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.getCheckApptList(index);
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $scope.loadResult = 3;
                return;
            }

            $scope.barCodeLoading(data);
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误，获取预约详情失败");
            $ionicLoading.hide();
        })
    }

    // 8.1加载条形码，跳下一页
    $scope.barCodeLoading = function (data){
        $ionicLoading.show();

        $scope.selectApply = {};
        // 筛选一下checkApptList
        var checkApptId = data.reqData.data.CHECK_APPT_ID;
        for(var i = 0; i < data.data.length; i++){
            if(checkApptId == data.data[i].CHECK_APPT_ID){
                $scope.selectApply = data.data[i];
                break;
            }
        }

        // 这里是因为，这个检查去门诊取消了，才查不了
        if(JSON.stringify($scope.selectApply) == "{}"){
            $fwCordovaToast.showShortBottom("错误，该申请不可查看详情");
            $ionicLoading.hide();
            return;
        }
        // 格式化数据
        // 检查日期
        if ($scope.selectApply.hasOwnProperty("ORDER_DATE") && $scope.selectApply["ORDER_DATE"] != null && $scope.selectApply["ORDER_DATE"].length > 0) {
            $scope.selectApply["ORDER_DATE_FORMAT"] = new Date($scope.selectApply["ORDER_DATE"]).Format("yyyy年M月d日");
        }
        // 注意事项
        if ($scope.selectApply.hasOwnProperty("PRECAUTIONS") && $scope.selectApply["PRECAUTIONS"] != null && $scope.selectApply["PRECAUTIONS"].length > 0) {
            $scope.selectApply["PRECAUTIONS_FORMAT"] = $scope.selectApply["PRECAUTIONS"].split("|  ").join("").split("|");
        }
        // 温馨提示
        if ($scope.selectApply.hasOwnProperty("TIPS") && $scope.selectApply["TIPS"] != null && $scope.selectApply["TIPS"].length > 0) {
            $scope.selectApply["TIPS_FORMAT"] = $scope.selectApply["TIPS"].split("|").join("").split("|");
        }
        // 2019-9-5 09:53:01 由于iOS审核被拒 检查号序着急上线 暂时拼在了检查时间后边 老版本直接显示 新版本需判断截断字符串
        if ($scope.selectApply.hasOwnProperty("ORDER_TIME") && $scope.selectApply["ORDER_TIME"] != null && $scope.selectApply["ORDER_TIME"].length > 0
            && $scope.selectApply["ORDER_TIME"].indexOf("   ") > -1 && $scope.formatOrderNum($scope.selectApply["ORDER_NUM"]) > 0) {
            $scope.selectApply["ORDER_TIME"] = $scope.selectApply["ORDER_TIME"].substr(0, $scope.selectApply["ORDER_TIME"].indexOf("   "));
        }
        // 赋值一下vpId和hisCardNum
        $scope.selectApply.VISIT_PATIENT_ID = data.reqData.data.VISIT_PATIENT_ID;
        $scope.selectApply.HIS_CARD_NUM = data.reqData.data.HIS_CARD_NUM;
        $scope.barCodeShow = data.reqData.data.BARCODE_SHOW;

        VisitPatientService.onlineCardInfo($scope.selectApply.VISIT_PATIENT_ID, $scope.selectApply.HIS_CARD_NUM).then(function (dataCard) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(dataCard.msg);
                $ionicLoading.hide();
            }
            else {
                $scope.selectApply.BARCODE_SRC = "data:image/jpeg;base64," + dataCard.data;

                console.log($scope.selectApply);
                $ionicLoading.hide();
                // 下一页
                $scope.toSlide(7);
            }
        })
    }

    // 8.3取消申请
    $scope.cancelApply = function (applyId) {
        $ionicLoading.show();
        CoronavirusService.cancelApply(applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("预约已取消");
                // 刷一下列表
                $scope.getApplyList();

                // 刷一下定时器
                // $scope.getTimeLimit();
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误，取消申请失败");
            $ionicLoading.hide();
        })
    }

    // 8.4手动取消申请
    $scope.cancelApplyManual = function (applyId) {
        var confirmPopup = $ionicPopup.confirm({
            title: '取消预约确认',
            template: "此操作不可逆，您确定要取消当前核酸检测预约吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $scope.cancelApply(applyId);
            }
        })
    }

    // 8.5不支付，直接预约成功
    $scope.paySuccess = function (applyId) {
        //如果来自Single，加载详情
        $ionicLoading.show();
        CoronavirusService.getApplyDetail(applyId).then(function (dataApply) {
            console.log(dataApply);
            $ionicLoading.hide();
            if (dataApply.result == 1) {
                // 筛选一下
                var checkApptId = dataApply.reqData.data.CHECK_APPT_ID;
                for (var i = 0; i < dataApply.data.length; i++) {
                    if (checkApptId == dataApply.data[i].CHECK_APPT_ID) {
                        $scope.payApply = dataApply.data[i];
                        break;
                    }
                }

                // 格式化数据
                // 检查日期
                if ($scope.payApply.hasOwnProperty("ORDER_DATE") && $scope.payApply["ORDER_DATE"] != null && $scope.payApply["ORDER_DATE"].length > 0) {
                    $scope.payApply["ORDER_DATE_FORMAT"] = new Date($scope.payApply["ORDER_DATE"]).Format("yyyy年M月d日");
                }
                // 注意事项
                if ($scope.payApply.hasOwnProperty("PRECAUTIONS") && $scope.payApply["PRECAUTIONS"] != null && $scope.payApply["PRECAUTIONS"].length > 0) {
                    $scope.payApply["PRECAUTIONS_FORMAT"] = $scope.payApply["PRECAUTIONS"].split("|  ").join("").split("|");
                }
                // 温馨提示
                if ($scope.payApply.hasOwnProperty("TIPS") && $scope.payApply["TIPS"] != null && $scope.payApply["TIPS"].length > 0) {
                    $scope.payApply["TIPS_FORMAT"] = $scope.payApply["TIPS"].split("|").join("").split("|");
                }
                // 2019-9-5 09:53:01 由于iOS审核被拒 检查号序着急上线 暂时拼在了检查时间后边 老版本直接显示 新版本需判断截断字符串
                if ($scope.payApply.hasOwnProperty("ORDER_TIME") && $scope.payApply["ORDER_TIME"] != null && $scope.payApply["ORDER_TIME"].length > 0
                    && $scope.payApply["ORDER_TIME"].indexOf("   ") > -1 && $scope.formatOrderNum($scope.payApply["ORDER_NUM"]) > 0) {
                    $scope.payApply["ORDER_TIME"] = $scope.payApply["ORDER_TIME"].substr(0, $scope.payApply["ORDER_TIME"].indexOf("   "));
                }

                console.log($scope.payApply);
                // 下一页，支付成功页面
                $scope.toSlide(5);
            }
            else {
                $fwCordovaToast.showShortBottom(dataApply.msg);
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误：支付成功，获取详情失败");
        })
    }

    // 精确加法
    $scope.numAdd = function (num1, num2) {
        // 2018-9-10 13:17:22 改用BigNumber计算
        return BigNumber(num1).plus(num2).toNumber();
    }

    // 2019-8-29 17:06:46 由于Number()在页面调用返回false 提到function里
    $scope.formatOrderNum = function (strOrderNum) {
        if (!strOrderNum || strOrderNum.length == 0) {
            return 0;
        }
        var orderNum = Number(strOrderNum);
        return orderNum > 0 ? orderNum : 0;
    }

    //#region 小黑屋
    // 8.2支付（其实可以提出来）from: List/Single
    $scope.payOrder = function (vpId, checkListNum, applyId, from){
        $ionicLoading.show();
        $scope.opPayment4001(vpId, checkListNum, "NCP_APPLY").then(function (data4001){
            console.log(data4001);
            // 4001成功了
            if(data4001.result == 1){
                // 循环一下列表，计算一下总金额
                var fee = 0;
                var strFeeItemCode = "";
                for(var i = 0; i < data4001.data.opPaymentGroupList.length; i++){
                    fee = $scope.numAdd(fee, data4001.data.opPaymentGroupList[i].CHECK_LIST_FEE);
                    strFeeItemCode += "," + data4001.data.opPaymentGroupList[i].CHARGE_ITEM_CODE;
                }
                // 判断一下金额是否大于0
                if(fee <= 0 || strFeeItemCode.length <= 0){
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("4001：网络错误，获取代缴费金额失败");
                }
                strFeeItemCode = strFeeItemCode.substr(1);

                // 调4005
                console.log("strFeeItemCode" + strFeeItemCode);
                console.log("fee" + fee);
                $scope.opPayment4005(vpId, strFeeItemCode, fee).then(function (data4005){
                    console.log("4005返回值:" + JSON.stringify(data4005));
                    // 4005成功了
                    if(data4005.result == 1){
                        // 判断是否需要补收医事服务费，这里应该不用收，那也判断一下吧
                        if(data4005.data.msFeeStatus == true){
                            console.log("需要补收医事服务费");
                            fee = $scope.numAdd(fee, data4005.data.msFee);
                        }
                        var balance = data4005.data.balance;
                        $ionicLoading.hide();
                        // 走门诊缴费那一套，调收银台
                        $scope.cashier("coronavirus", fee, vpId, applyId, balance, strFeeItemCode, $scope.doctorCode).then(function (dataCashier) {
                            // 支付成功
                            if (dataCashier.code == 1) {
                                $fwCordovaToast.showShortBottom("支付成功");
                                if(from == "List"){
                                    // 如果来自List，重新加载列表
                                    $scope.getApplyList();
                                    // 重新获取定时器
                                    $scope.getTimeLimit();
                                }
                                else{
                                    //如果来自Single，加载详情
                                    $ionicLoading.show();
                                    CoronavirusService.getApplyDetail(applyId).then(function (dataApply){
                                        console.log(dataApply);
                                        $ionicLoading.hide();
                                        if(dataApply.result == 1){
                                            // 筛选一下
                                            var checkApptId = dataApply.reqData.data.CHECK_APPT_ID;
                                            for(var i = 0; i < dataApply.data.length; i++){
                                                if(checkApptId == dataApply.data[i].CHECK_APPT_ID){
                                                    $scope.payApply = dataApply.data[i];
                                                    break;
                                                }
                                            }

                                            // 格式化数据
                                            // 检查日期
                                            if ($scope.payApply.hasOwnProperty("ORDER_DATE") && $scope.payApply["ORDER_DATE"] != null && $scope.payApply["ORDER_DATE"].length > 0) {
                                                $scope.payApply["ORDER_DATE_FORMAT"] = new Date($scope.payApply["ORDER_DATE"]).Format("yyyy年M月d日");
                                            }
                                            // 注意事项
                                            if ($scope.payApply.hasOwnProperty("PRECAUTIONS") && $scope.payApply["PRECAUTIONS"] != null && $scope.payApply["PRECAUTIONS"].length > 0) {
                                                $scope.payApply["PRECAUTIONS_FORMAT"] = $scope.payApply["PRECAUTIONS"].split("|  ").join("").split("|");
                                            }
                                            // 温馨提示
                                            if ($scope.payApply.hasOwnProperty("TIPS") && $scope.payApply["TIPS"] != null && $scope.payApply["TIPS"].length > 0) {
                                                $scope.payApply["TIPS_FORMAT"] = $scope.payApply["TIPS"].split("|").join("").split("|");
                                            }
                                            // 2019-9-5 09:53:01 由于iOS审核被拒 检查号序着急上线 暂时拼在了检查时间后边 老版本直接显示 新版本需判断截断字符串
                                            if ($scope.payApply.hasOwnProperty("ORDER_TIME") && $scope.payApply["ORDER_TIME"] != null && $scope.payApply["ORDER_TIME"].length > 0
                                                && $scope.payApply["ORDER_TIME"].indexOf("   ") > -1 && $scope.formatOrderNum($scope.payApply["ORDER_NUM"]) > 0) {
                                                $scope.payApply["ORDER_TIME"] = $scope.payApply["ORDER_TIME"].substr(0, $scope.payApply["ORDER_TIME"].indexOf("   "));
                                            }

                                            console.log($scope.payApply);
                                            // 下一页，支付成功页面
                                            $scope.toSlide(5);
                                        }
                                        else{
                                            $fwCordovaToast.showShortBottom(dataApply.msg);
                                        }
                                    }, function () {
                                        $fwCordovaToast.showShortBottom("网络错误：支付成功，获取详情失败");
                                    })
                                }
                            }
                            else{
                                if(from == "List"){
                                    // 如果来自List，什么都不做，打印失败信息
                                    $fwCordovaToast.showShortBottom(dataCashier.msg);
                                }
                                else{
                                    // 如果来自Single，开启定时器
                                    // 不管支付取消、还是支付失败，到这了就是开单成功的
                                    $scope.getTimeLimit();
                                }
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("网络错误：支付失败");
                        })
                    }
                    else{
                        $fwCordovaToast.showShortBottom(data4005.msg);
                        $ionicLoading.hide();
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("4005：网络错误");
                    $ionicLoading.hide();
                })
            }
            else{
                $fwCordovaToast.showShortBottom(data4001.msg);
                $ionicLoading.hide();
            }
        }, function () {
            $fwCordovaToast.showShortBottom("4001：网络错误");
            $ionicLoading.hide();
        })
    }

    // 获取支付时间限制
    $scope.getTimeLimit = function () {
        CoronavirusService.getTimeLimit().then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                $rootScope.payTimeLeftNCP = data.data;
                if ($rootScope.payStatusNCP != 1) {
                    $rootScope.payStatusNCP = 1;
                }
                // 倒计时
                $scope.timerStop = true;
                $scope.timeCountdown();

                // 复制applyId，这是没有支付的applyId
                $scope.notPayApplyId = data.applyId;
            }
            // 获取失败
            else {
                $scope.timerStop = false;
                $rootScope.payStatusNCP = 0;
                $rootScope.payTimeLeftNCP = 0;
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 倒计时
    $scope.timeCountdown = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftNCP = $rootScope.payTimeLeftNCP - 1);
        } else {
            $rootScope.payTimeLeftNCP = $rootScope.payTimeLeftNCP - 1;
        }
        clearTimeout($rootScope.payResendTimeerNCP);
        if ($rootScope.payTimeLeftNCP > 0) {
            $rootScope.payResendTimeerNCP = setTimeout($scope.timeCountdown, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusNCP = 0);
            } else {
                $rootScope.payStatusNCP = 0;
            }
            // 超时处理
            $scope.checkTimeout();
        }
    }

    // 超时处理
    $scope.checkTimeout = function () {
        if($scope.timerStop){
            // 取消
            $scope.cancelApply($scope.notPayApplyId);
        }
    }

    // 回库操作
    $scope.backLibiray = function (){
        $ionicLoading.show();
        // 做一下回库操作
        CoronavirusService.backLibiray().then(function (backData){
            if(backData.result == 1){
                $ionicLoading.hide();
            }
            else{
                $fwCordovaToast.showShortBottom(backData.msg);
                $ionicLoading.hide();
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误，回库操作失败");
            $ionicLoading.hide();
        })
    }
    //#endregion

    // 返回
    $scope.goBack = function () {
        if($scope.step == 0) {
            if($scope.from.indexOf('autoInquiry') > -1) {
                $state.go("app.autoInquiry", {vpid: $scope.paramVpId, firstFrom: $scope.paramFirstFrom, continueInquiry: 1});
            }
            else {
                $state.go("app.home");
            }
        }
        // 加了新流调，可以直接返回选择就诊人页
        else if($scope.step == 4){
            if($scope.from.indexOf('autoInquiry') > -1) {
                $scope.toSlide(1);
            }
            else {
                $scope.toSlide(2);
            }
        }
        else if($scope.step == 5 || $scope.step == 6){
            $scope.toSlide(0);
        }
        else {
            $scope.lastSlide();
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideCoronavirus.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'coronavirus');

        // 获取服务开启状态
        $ionicLoading.show();
        CoronavirusService.checkServerStatus().then(function (data){
            // 开启
            if(data.result == 1){
                $scope.isServerOn = true;
                // 获取配置信息
                CoronavirusService.getConfig().then(function (dataConfig) {
                    if (dataConfig.result == 1) {
                        $scope.agreement.desc = dataConfig.data.coronavirusDescr; // 用户须知
                        $scope.agreement.team = dataConfig.data.teamDescr;// 团队须知
                        $scope.apptDays = dataConfig.data.apptDays;// 最多可预约几天
                        $scope.doctorCode = dataConfig.data.doctorCode;// 医师代码

                        // 五混一等配置项
                        $scope.modeConfigList = dataConfig.data.modeConfigList;
                        for (var i = 0; i < $scope.modeConfigList.length; i++) {
                            $scope.modeConfigList[i].checkStatus = 0;

                            // 默认选中一混一
                            if ($scope.modeConfigList[i].modeStr == "1") {
                                $scope.modeConfigList[i].checkStatus = 1;
                                $scope.checkPosition = $scope.modeConfigList[i].position;
                                $scope.groupId = $scope.modeConfigList[i].groupId;
                                $scope.checkMode = $scope.modeConfigList[i].modeStr;
                            }
                        }

                        // 核酸开关
                        $scope.isOpenApptTemp = dataConfig.data.isOpenApptTemp;

                        // 获取就诊人列表
                        VisitPatientService.visitPatientList().then(function (dataVpList) {
                            $ionicLoading.hide();
                            // 获取成功
                            if (dataVpList.result == 1) {
                                // 第一就诊人
                                var vpid = "";
                                var vpidSelf = "";
                                console.log(dataVpList.data.length);
                                for (var i = 0; i < dataVpList.data.length; i++) {
                                    $scope.vpList.push(dataVpList.data[i]);
                                    if (vpid == "") {
                                        vpid = dataVpList.data[i].VISIT_PATIENT_ID;
                                    }
                                    if (vpidSelf == "" && dataVpList.data[i].IS_SELF == "1") {
                                        vpidSelf = dataVpList.data[i].VISIT_PATIENT_ID;
                                    }
                                }

                                // 若参数无就诊人信息
                                if ($scope.vpId == "") {
                                    // 默认第一就诊人
                                    // 2018-9-18 17:33:31 改为本人
                                    $scope.vpId = vpidSelf;
                                }
                                else {
                                    $scope.loadVPInfo();
                                }

                                // 开启用户须知倒计时
                                $interval(function () {
                                    $scope.confirmCountdown -= 1;
                                }, 1000, 10);

                                // 判断是否需要支付的
                                if($scope.from == "home" || $scope.from == "personal"){
                                    // 向后台请求下数据，看下还剩几秒，不取得话，刷新页面会置为0
                                    $scope.applyListShow();
                                }

                                //$scope.getTimeLimit();
                            }
                            else {
                                $fwCordovaToast.showShortBottom(dataVpList.msg);
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("网络错误，获取就诊人信息失败");
                            $ionicLoading.hide();
                        })
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误，获取配置信息失败");
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误，获取配置信息失败");
                    $ionicLoading.hide();
                })
            }
            // 关闭
            else {
                $scope.isServerOn = false;
                $scope.agreement.desc = data.msg;
                $ionicLoading.hide();
            }
        }, function () {
            $scope.isServerOn = false;
            $fwCordovaToast.showShortBottom("网络错误，获取服务开启状态失败");
            $ionicLoading.hide();
        })

        // 2020.02.24 省市县：省
        $scope.getProvince();
        // 2020-07-10 北京的区
        $scope.getBJCounty();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();

        // 回库操作
        //$scope.backLibiray();

        //设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if (data.result == 1) {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证"}];
        //    }
        //});

    });

    // 页面退出
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'coronavirus') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})