﻿angular.module('fwapp.controllers')

// ******************************
// 心脑血管病风险评估
// ******************************
.controller('CvdriskController', function ($scope, CvdriskService, $ionicPopup, $ionicLoading, $state, $stateParams, $ionicLoading, $fwCordovaToast) {

    //tc第一个输入框的显示状态
    $scope.tc1 = true;
    //tc第二个输入框的显示状态
    $scope.tc2 = false;
    //hdlc第一个输入框的显示状态
    $scope.hdlc1 = true;
    //hdlc第二个输入框的显示状态
    $scope.hdlc2 = false;

    //模拟单选框的图片
    $scope.img11 = "img/isRa.png";
    $scope.img12 = "img/noRa.png";
    $scope.img21 = "img/isRa.png";
    $scope.img22 = "img/noRa.png";

    //登录者的accountId
    $scope.currentAccountId = localStorage.currentAccountId;
    //就诊人的vpId
    $scope.vpId = $stateParams.vpId;

    //是否成功获取就诊人信息
    $scope.isSuccessVp = false;
    //是否可以点击提交按钮
    $scope.isSubmit = true;

    //初始基础数据
    $scope.formData = { sex: '2', age: '', region: '1', area: '0', waist: '', tc_unit: '1',
        tc: '', hdlc_unit: '1', hdlc: '', sbp: '', dbp: '', drug: '0', dm: '0', csmoke: '0', fh_ascvd: '0',
        vpId: $scope.vpId, accountId: $scope.currentAccountId, type: 'insert'
    };

    //获取就诊人性别和年龄
    $ionicLoading.show();
    CvdriskService.getSex($scope.vpId).then(function (data) {
        $ionicLoading.hide();
        if (data.result == 1) {
            $scope.formData.sex = data.sex;
            $scope.formData.age = data.age;
            if (data.age < 20 || data.age > 85) {
                $ionicPopup.alert({
                    title: '提示',
                    template: '本工具仅适用于20-85岁的人群',
                    okText: "好的"
                });
                $scope.isSubmit = false;
            }
            $scope.isSuccessVp = true;
        }
        else {
            $fwCordovaToast.showShortBottom(data.msg);
        }
    }, function (resp) {
        $ionicLoading.hide();
        $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
    });

    //提交数据
    $scope.frmSubmit = function () {
        $ionicLoading.show();
        var msg = $scope.validInput($scope.formData);
        if (msg != "") {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(msg);
            return false;
        }
        CvdriskService.result($scope.formData).then(function (data) {
            if (data.result == 1) {
                CvdriskService.resultTwo($scope.formData).then(function (data) {
                    $ionicLoading.hide();
                    $state.go('app.cvdriskResult', { data: data.msg });
                }, function (err) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                });
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        });
    }

    // 输入验证
    $scope.validInput = function (formData) {
        var msg = "";
        if (!angular.isNumber(formData.age) || !angular.isNumber(formData.waist) || !angular.isNumber(formData.tc)
            || !angular.isNumber(formData.hdlc) || !angular.isNumber(formData.sbp) || !angular.isNumber(formData.dbp)) {
            return "数值项不能为空或非数字";
        }
        if (formData.age < 20 || formData.age > 85) {
            msg = msg + "&emsp;年龄应在20-85之间<br/>";
        }
        if (formData.waist < 50 || formData.waist > 130) {
            msg = msg + "&emsp;腰围应在50-130之间<br/>";
        }
        if (formData.region != 1 && formData.region != 0) {
            msg = msg + "&emsp;现住址地区不在给定范围内<br/>";
        }
        if (formData.area != 1 && formData.area != 0) {
            msg = msg + "&emsp;现住址地区不在给定范围内<br/>";
        }
        if (formData.tc_unit != 1 && formData.tc_unit != 2) {
            msg = msg + "&emsp;总胆固醇单位不在给定范围内<br/>";
        }
        if (formData.tc_unit == 1 && (formData.tc < 80 || formData.tc > 400)) {
            msg = msg + "&emsp;总胆固醇应在80-400mg/dl之间<br/>";
        }
        if (formData.tc_unit == 2 && (formData.tc < 2 || formData.tc > 11)) {
            msg = msg + "&emsp;总胆固醇应在2-11mmol/L之间<br/>";
        }
        if (formData.hdlc_unit != 1 && formData.hdlc_unit != 2) {
            msg = msg + "&emsp;高密度脂蛋白胆固醇单位不在给定范围内<br/>";
        }
        if (formData.hdlc_unit == 1 && (formData.hdlc < 20 || formData.hdlc > 130)) {
            msg = msg + "&emsp;高密度脂蛋白胆固醇应在20-130mg/dl之间<br/>";
        }
        if (formData.hdlc_unit == 2 && (formData.hdlc < 0.5 || formData.hdlc > 4)) {
            msg = msg + "&emsp;高密度脂蛋白胆固醇应在0.5-4mmol/L之间<br/>";
        }
        if (formData.sbp < 70 || formData.sbp > 200) {
            msg = msg + "&emsp;收缩压应在70-200之间<br/>";
        }
        if (formData.dbp < 40 || formData.dbp > 140) {
            msg = msg + "&emsp;舒张压应在40-140之间<br/>";
        }
        if (formData.drug != 1 && formData.drug != 0) {
            msg = msg + "&emsp;服用降压药不在给定范围内<br/>";
        }
        if (formData.dm != 1 && formData.dm != 0) {
            msg = msg + "&emsp;患糖尿病不在给定范围内<br/>";
        }
        if (formData.csmoke != 1 && formData.csmoke != 0) {
            msg = msg + "&emsp;现在是否吸烟不在给定范围内<br/>";
        }
        if (formData.fh_ascvd != 1 && formData.fh_ascvd != 0) {
            msg = msg + "&emsp;心脑血管病家族史不在给定范围内<br/>";
        }
        return msg;
    }

    //切换单选框选中状态及输入框显示的方法
    $scope.ontcunit1 = function () {
        $scope.tc2 = false;
        $scope.formData.tc = '';
        $scope.tc1 = true;
        $scope.img11 = "img/isRa.png";
        $scope.img12 = "img/noRa.png";
    }

    $scope.ontcunit2 = function () {
        $scope.tc1 = false;
        $scope.formData.tc = '';
        $scope.tc2 = true;
        $scope.img12 = "img/isRa.png";
        $scope.img11 = "img/noRa.png";
    }

    $scope.hdlcunit1 = function () {
        $scope.hdlc2 = false;
        $scope.formData.hdlc = '';
        $scope.hdlc1 = true;
        $scope.img21 = "img/isRa.png";
        $scope.img22 = "img/noRa.png";
    }

    $scope.hdlcunit2 = function () {
        $scope.hdlc1 = false;
        $scope.formData.hdlc = '';
        $scope.hdlc2 = true;
        $scope.img22 = "img/isRa.png";
        $scope.img21 = "img/noRa.png";
    }

})

// ******************************
// 评估报告页
// ******************************
.controller('CvdriskResultController', function ($scope, $stateParams, $ionicPopup, $state) {
    console.log($stateParams.data);
    if (Object.prototype.toString.call($stateParams.data) != '[object Object]') {
        $stateParams.data = JSON.parse($stateParams.data);
    }
    $scope.RiskLevelColor10 = $stateParams.data.RiskLevelColor10;
    $scope.CalcScore10 = $stateParams.data.CalcScore10;
    $scope.RiskLevel10 = $stateParams.data.RiskLevel10;
    $scope.StandardScore10 = $stateParams.data.StandardScore10;

    $scope.IsShow99 = ($stateParams.data.RiskLevel99 != null && $stateParams.data.RiskLevel99 != '');
    $scope.RiskLevel99 = $stateParams.data.RiskLevel99;
    $scope.RiskLevelColor99 = $stateParams.data.RiskLevelColor99;
    $scope.CalcScore99 = $stateParams.data.CalcScore99;
    $scope.StandardScore99 = $stateParams.data.StandardScore99;
    $scope.CalcLifeRiskAgeMax = $stateParams.data.CalcLifeRiskAgeMax;

    $scope.OptimalContent = $stateParams.data.OptimalContent;

    $scope.NoticeList = $stateParams.data.NoticeList;
    $scope.ASCVDModel = $stateParams.data.ASCVDModel;
    $scope.saveIt = function () {
        $fwCordovaToast.showShortBottom("您还未登录，登录后可保存记录");
    };
})

// ******************************
// 评估报告列表页
// ******************************
.controller('CvdriskListController', function ($scope, $stateParams, $ionicPopup, $state, $ionicLoading, $ionicPlatform, CvdriskService) {
    // 列表结果
    $scope.cvdList = [];
    // 加载完成
    $scope.isLoadFinish = false;
    // vpId
    $scope.vpId = $stateParams.vpId;

    // 列表展示
    $scope.loadList = function () {
        CvdriskService.getCvdriskList($scope.vpId).then(function (data) {
            $scope.isLoadFinish = true;
            if (data.result == 0) {
                $scope.cvdList = [];
            }
            else {
                if (data.is_null == 1) {
                    $scope.cvdList = [];
                }
                else {
                    $scope.cvdList = data.data;
                }
            }
        }, function (data) {
            $scope.cvdList = [];
            $scope.isLoadFinish = true;
        })
    }

    // 查看详情
    $scope.resultShow = function (index) {
        $ionicLoading.show();
        CvdriskService.resultTwo($scope.cvdList[index]).then(function (data) {
            $ionicLoading.hide();
            $state.go('app.cvdriskResult', { data: data.msg });
        });
    }

    // 立即填写
    $scope.goCVDRisk = function () {
        $state.go("app.cvdrisk", { vpId: $scope.vpId });
    }

    // 返回
    $scope.goBack = function () {
        if ($stateParams.from == "app.flupDRI") {
            $state.go("app.flupDRI", { vpId: $scope.vpId });
        }
        else {
            $state.go("app.health", { vpid: $scope.vpId, from: $stateParams.from });
        }
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'cvdriskList');

        $scope.loadList();
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'cvdriskList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
