﻿angular.module('fwapp.controllers')

.controller('DealWithCardController', function ($scope, $rootScope, $state, $stateParams, $q, $timeout, $sce, $window, $interval, $filter
, $ionicPopup, $ionicPopover, $ionicModal, $ionicLoading, $ionicPlatform, $ionicActionSheet, $ionicSlideBoxDelegate, $ionicScrollDelegate
, $cordovaToast, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaInAppBrowser, $cordovaDatePicker, $fwCordovaToast
, VisitPatientService, OpRegService, AccountService, RequestService, PaymentService, DealWithCardService, PatientMealService, flupSrvyService, HospitalService, IpRegService) {

    // slide控制
    var dealWithSlide = $ionicSlideBoxDelegate.$getByHandle('dealWithSlide');

    // 加载控制
    $scope.isLoadFinish = false;

    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;

    // 步骤控制
    $scope.step = 0;
    $scope.lastStep = 0;

    // 标题控制
    $scope.name = "";
    $scope.lastName = "";

    // 倒计时控制
    $scope.timespan = 0;

    // 用户须知倒计时控制
    var countdown = devMode ? 1 : 10;
    // 2021-11-12 08:41:25 HM 在线问诊中用户须知读秒修改成5秒。
    if ($stateParams.go == "consultation") {
        countdown = 5;
    }
    $scope.confirmCountdown = countdown;

    // 建卡：1 OR 预存金账户：2
    $scope.applyCardType = 1;

    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};

    // 跳转控制
    var go = $stateParams.go;
    $scope.fromGo = go;

    // (最低)通过要求
    $scope.request_status = "bind";
    // 是否要求预存金账户
    $scope.request_prepay = false;
    // 无就诊记录是否终止
    $scope.request_stopWithoutCard = false;
    // 非住院是否终止
    $scope.request_stopWithoutIP = false;
    // 是否判需要认证医保
    $scope.request_needMICheck = true;
    // (最终)会跳转路由
    $scope.request_url = "app.message";
    // 用户须知
    $scope.request_confirm = "<p>用户须知</p>";
    // 非急诊是否终止
    $scope.request_stopWithoutEmr = false;
    // 是否需要判断本人
    $scope.request_needSelf = false;

    // 医保卡号提示
    $scope.MICodeHelp = "医保卡卡号位于卡片正面";

    // 最多就诊人数
    $scope.bind_count = 0;

    // patientcheck里的requestId，换手机号/卡号用
    $scope.requestId = "";

    // 就诊人列表
    $scope.vpList = [];
    // 选中的就诊人信息
    $scope.vpInfo = new Object();

    $scope.DRInum = 0;
    $scope.AFnum = 0;

    //2023-8-28 13:55:26 ZZL #hzfwx-107 字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 绑卡模型
    $scope.vpBind = {
        name: '',
        card_num: '',
        card_num_show: '',
        phone_num: null,
        phone_num_show: '',
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    // 建卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '',
        insurance_type: 0,
        mi_patient_code: '',
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 验卡模型
    $scope.vpVerify = {
        phone_num: '',
        phone_num_show: '',
        imageVericode: '',
        messageVericode: ''
    };
    // 新增就诊人模型
    $scope.vpNew =
    {
        realName: '',
        idCardCode: '',
        idCardType: '1',
        sex: '',
        birthday: ''
    };
    // 医保模型
    $scope.MI =
    {
        REQUESTID: '',
        NOTICE: '',
        HELP: '',
        MI_PATIENT_CODE: '',
        MI_PATIENT_IMG_URL: '',
        MI_IMG_URL: ''
    };
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}

    // 方法
    // 1.加载就诊人列表
    $scope.loadVpList = function () {
        $ionicLoading.show();
        $scope.vpList = [];
        VisitPatientService.visitPatientList().then(function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            if (data.result == 1) {
                if (data.data.length == 0) {
                    // 2021-10-29 21:09:09 HM 不知道为什么要跳个人中心
                    // $state.go("app.personal");
                    //$fwCordovaToast.showLongBottom("未找到就诊人信息");
                    return;
                }
                else {
                    $scope.vpList = data.data;
                }
            }
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 2.一切的开始：是否要求开通预存金
    $scope.isRequestPrePay = function (index) {
        // =>去验预存金
        if ($scope.request_prepay) {
            checkPrePay(index);
        }
        // =>去验通过
        else {
            checkPass(index);
        }
    }

    // 2.1.检查预存
    checkPrePay = function (index) {
        $scope.vpInfo = $scope.vpList[index];

        // 已绑卡 || 半绑卡 || 3/4绑卡
        if ($scope.vpInfo.IS_BIND_CARD == '1' || $scope.vpInfo.IS_BIND_CARD == "2" || $scope.vpInfo.IS_BIND_CARD == "3") {
            $ionicLoading.show();
            PaymentService.checkPrePayAccount($scope.vpInfo.VISIT_PATIENT_ID, 2).then(function (data) {
                if (data.result == 0 || data.result == -99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }

                if (data.result == 99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络问题，请稍后再试");
                    return;
                }

                if (data.result == 1) {
                    // 未开通预存账户
                    if (data.is_null == 1) {
                        console.log("未开预存金账户");
                        OpRegService.createCardApply($scope.vpInfo.VISIT_PATIENT_ID, 2).then(function (data) {
                            $ionicLoading.hide();
                            if (data.result == 1) {
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                $scope.applyCardType = 2;
                                if ($scope.vpApply.id_type == '0') {
                                    // 直接提交
                                    $scope.submitCardApply();
                                }
                                else {
                                    // 显示开通预存账户
                                    $ionicPopup.alert({
                                        title: '请注意',
                                        template: "患者预存账户未开通，请上传身份证开通预存账户",
                                        okText: "确定"
                                    }).then(function () {
                                        $scope.lastStep = $scope.step;
                                        $scope.lastName = $scope.name;

                                        $scope.step = 2;
                                        $scope.name = "预存金账户开通";
                                        slideStep($scope.step);
                                    });
                                }
                            }
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        })
                        return;
                    }
                    // 门诊预存账户余额为负数
                    else if (data.is_null == 2) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(data.msg);
                        return;
                    }
                    // 剩下的为：已开通预存金账户 且账户非负余额
                    else {
                        console.log("已开预存金账户");
                        $ionicLoading.hide();
                        checkPass(index);
                    }
                }
            })
        }
        // 未绑卡
        else if ($scope.vpInfo.IS_BIND_CARD == "0") {
            checkPatientCardStatus(index);
        }
        // 未激活
        else if ($scope.vpInfo.IS_BIND_CARD == "4") {
            $fwCordovaToast.showShortBottom('请先前往自助机激活就诊卡');
        }
        // 其他状态
        else {
            $fwCordovaToast.showShortBottom("就诊卡绑卡状态非法");
        }
    }

    // 2.2.检查是否通过
    checkPass = function (index) {
        $scope.vpInfo = $scope.vpList[index];

        // 最低要求：未绑卡
        if ($scope.request_status == "un_bind") {
            // 非住院停止 =>去验住院
            if ($scope.request_stopWithoutIP) {
                checkIP(index);
            }
            // 非急诊停止 =>去验急诊
            else if ($scope.request_stopWithoutEmr) {
                checkEmr(index);
            }
            else {
                // 需医保验证 =>去验医保
                if ($scope.request_needMICheck) {
                    $scope.checkMI(index);
                }
                else {
                    // =>离开
                    $scope.leaveMethod();
                }
            }
        }

        // 最低要求：半绑卡
        if ($scope.request_status == "half_bind") {
            // 未绑卡 =>半绑卡 检查实体卡 => 自动半绑定 =>结束
            if ($scope.vpInfo.IS_BIND_CARD == '0') {
                checkPatientCardStatus(index);
            }
            else {
                // 非住院停止 =>去验住院
                if ($scope.request_stopWithoutIP) {
                    checkIP(index);
                }
                // 非急诊停止 =>去验急诊
                else if ($scope.request_stopWithoutEmr) {
                    checkEmr(index);
                }
                else {
                    // 需医保验证 =>去验医保
                    if ($scope.request_needMICheck) {
                        $scope.checkMI(index);
                    }
                    else {
                        // =>离开
                        $scope.leaveMethod();
                    }
                }
            }
        }

        // 最低要求：3/4绑卡
        if ($scope.request_status == "three_quarters") {
            console.log("没这个需求");
        }

        // 最低要求：绑卡
        if ($scope.request_status == "bind") {
            // 未绑卡 || 半绑卡 =>都去检查实体卡 => 获取预留手机号 =>绑卡
            if ($scope.vpInfo.IS_BIND_CARD == '0' || $scope.vpInfo.IS_BIND_CARD == '2') {
                checkPatientCardStatus(index);
            }
            // 3/4绑卡 =>验卡
            else if ($scope.vpInfo.IS_BIND_CARD == '3') {
                // 获取预留电话
                $scope.GetReservedPhone($scope.vpInfo);
                $scope.getImageVericode();
                // 去验卡
                $scope.lastStep = $scope.step;
                $scope.lastName = $scope.name;

                $scope.step = 5;
                $scope.name = "验证就诊卡";
                slideStep($scope.step);
            }
            // 未激活 =>提示
            else if ($scope.vpInfo.IS_BIND_CARD == "4") {
                $fwCordovaToast.showShortBottom('请先前往自助机激活就诊卡');
            }
            else {
                // 非住院停止 =>去验住院
                if ($scope.request_stopWithoutIP) {
                    checkIP(index);
                }
                // 非急诊停止 =>去验急诊
                else if ($scope.request_stopWithoutEmr) {
                    checkEmr(index);
                }
                else {
                    // 需医保验证 =>去验医保
                    if ($scope.request_needMICheck) {
                        $scope.checkMI(index);
                    }
                    // =>离开
                    else {
                        $scope.leaveMethod();
                    }
                }
            }
        }
    }

    // 2.3.检查实体卡状态
    checkPatientCardStatus = function (index) {
        $scope.vpInfo = $scope.vpList[index];

        $ionicLoading.show();
        OpRegService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
            if (data.result == 1) {
                // 无就诊卡
                if (data.is_null == 1) {
                    // 无卡终止
                    if ($scope.request_stopWithoutCard) {
                        $ionicLoading.hide();

                        // 可能在建卡页，要回列表
                        if ($scope.step != 1) {
                            $scope.loadVpList();
                            $scope.step = 1;
                            $scope.goBack($scope.step);
                        }

                        $fwCordovaToast.showShortBottom("没有就诊记录，您尚未在我院就诊！");
                    }
                    else {
                        console.log('无就诊卡：开始办卡流程');
                        var msg = data.msg;
                        // 先创建建卡申请 供上传图片使用
                        OpRegService.createCardApply($scope.vpInfo.VISIT_PATIENT_ID, 1).then(function (data) {
                            $ionicLoading.hide();
                            // 创建建卡申请 成功
                            if (data.result == 1) {
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                $scope.vpApply.insurance_type = data.data.INSURANCE_TYPE;
                                $scope.vpApply.mi_patient_code = data.data.MI_PATIENT_CODE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                var applyCardPopup = $ionicPopup.alert({
                                    title: '请注意',
                                    template: msg,
                                    okText: '确定'
                                }).then(function () {
                                    // 去建卡
                                    $scope.lastStep = $scope.step;
                                    $scope.lastName = $scope.name;

                                    $scope.step = 2;
                                    $scope.name = "申办就诊卡";
                                    slideStep($scope.step);
                                });
                            }
                            // 失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        })
                    }
                }
                // 有就诊卡 单卡 || 多卡但半绑+用过his_card_num  =>预约挂号过 =>绑它
                else if (data.is_null == 0 || (data.is_null == 2 && $scope.vpInfo.IS_BIND_CARD == "2" && $scope.vpInfo.HIS_CARD_NUM != "")) {
                    console.log('有就诊卡：单卡状态');
                    // 要求预存
                    if ($scope.request_prepay) {
                        // 但=0没检查过预存
                        // 刷新，查看下预存，这次会走IS_BIND_CARD=2，因为后台patientCheck会自动半绑
                        if ($scope.vpInfo.IS_BIND_CARD == 0) {
                            $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkPrePay");
                        }
                        // (原IS_BIND_CARD = 1，2，3)已经检查过预存
                        else {
                            // 要求全绑
                            if ($scope.request_status = "bind") {
                                // 获取requestid
                                $scope.requestId = data.requestId;
                                // 单卡
                                if (data.is_null == 0) {
                                    $scope.getPhoneAndCardNum($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, data.data);
                                }
                                // 多卡但用过his_card_num =>绑它
                                else {
                                    $scope.getPhoneAndCardNum($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, $scope.vpInfo.HIS_CARD_NUM);
                                }
                            }
                            // 不要求全绑
                            else {
                                // 非住院停止 =>去验住院
                                if ($scope.request_stopWithoutIP) {
                                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                                }
                                // 非急诊停止 =>去验急诊
                                if ($scope.request_stopWithoutEmr) {
                                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                                }
                                else {
                                    // 需医保验证 =>去验医保
                                    if ($scope.request_needMICheck) {
                                        $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                                    }
                                    // =>离开
                                    else {
                                        $scope.leaveMethod();
                                    }
                                }
                            }
                        }
                    }
                    // 不要求预存
                    else {
                        // 要求全绑
                        if ($scope.request_status = "bind") {
                            // requestid赋值
                            $scope.requestId = data.requestId;
                            // 单卡
                            if (data.is_null == 0) {
                                $scope.getPhoneAndCardNum($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, data.data);
                            }
                            // 多卡但用过his_card_num =>绑它
                            else {
                                $scope.getPhoneAndCardNum($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, $scope.vpInfo.HIS_CARD_NUM);
                            }
                        }
                        // 不要求全绑
                        else {
                            // 非住院停止 =>去验住院
                            if ($scope.request_stopWithoutIP) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                            }
                            // 非急诊停止 =>去验急诊
                            else if ($scope.request_stopWithoutEmr) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                            }
                            else {
                                // 是否医保验证
                                if ($scope.request_needMICheck) {
                                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                                }
                                else {
                                    // =>离开
                                    $scope.leaveMethod();
                                }
                            }
                        }
                    }
                }
                // 有就诊卡 多卡状态
                else if (data.is_null == 2) {
                    console.log('有就诊卡：多卡状态');
                    $ionicLoading.hide();
                    $scope.cardList = data.data;
                    // requestid赋值
                    $scope.requestId = data.requestId;

                    // 多卡提示
                    $ionicPopup.alert({
                        title: '请注意',
                        template: data.msg,
                        okText: "好的"
                    }).then(function () {
                        // 去选卡
                        $scope.lastStep = $scope.step;
                        $scope.lastName = $scope.name;

                        $scope.step = 4;
                        $scope.name = "就诊卡选择绑定";
                        slideStep($scope.step);
                    });
                }
                // 其他状态(出错)
                else {
                    $ionicLoading.hide();
                    console.log('其他状态：出错');
                    $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
                }
            }
            // result != 1(出错)
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误，请稍后再试");
            }

        }, function () {
            // 真的网络错误
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 2.3.1 把getPhoneAndCardNum提出来
    $scope.getPhoneAndCardNum = function (requestId, vpid, his_card_num) {
        VisitPatientService.getPhoneAndCardNum(requestId, vpid, his_card_num).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 1) {
                // 拿到了手机号+卡号
                var phone = result.phone_num;
                var card_num = result.card_num;

                if (phone == "" || card_num == "") {
                    $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                }
                else {
                    // 手机号
                    $scope.vpBind.phone_num = phone;
                    // 卡号
                    $scope.vpBind.card_num = card_num;
                    // 带*手机号
                    $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                    // 带*卡号
                    $scope.vpBind.card_num_show = result.card_num_show;
                    // 就诊人姓名
                    $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;

                    // 获取图片验证码
                    $scope.getImageVericode();
                    $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                    $scope.lastStep = $scope.step;
                    $scope.lastName = $scope.name;

                    $scope.step = 3;
                    $scope.name = "就诊卡绑定";
                    slideStep($scope.step);
                }
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
            }
        })
    }

    // 3.1.单实体卡：验证患者信息
    $scope.checkPatientInfo = function (vpId, phone, card_num, imageVericode) {

        // 检查图片验证码
        if (imageVericode == null || imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }

        $ionicLoading.show();
        RequestService.checkPatientCard(vpId, card_num, phone).then(function (data) {
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('服务繁忙，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，" + data.msg);
                return;
            }
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，未找到相应患者信息");
                return;
            }

            // patient_id赋值
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            // 就诊卡绑定 => 验证码：5
            $scope.getMsgVericode(phone, '5', imageVericode);
        });
    }

    // 4.1.多实体卡：选择这张卡
    $scope.bindThisCard = function (index) {
        $ionicPopup.confirm({
            title: '请注意',
            template: '是否绑定此就诊卡?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                bindCardSelectSubmit(index);
            }
            else { }
        });
    }

    // 4.2.多实体卡：选卡
    bindCardSelectSubmit = function (index) {
        if (index < 0 || index >= $scope.cardList.length || $scope.cardList[index] == null
            || $scope.cardList[index].PATIENT_ID == null || $scope.cardList[index].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardSelectV2($scope.vpInfo.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 最低要求：要求全绑的 直接发短信 绑了再议
                if ($scope.request_status == "bind") {
                    $scope.getPhoneAndCardNum($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID);
                }
                // 最低要求：不要求全绑 即半绑
                else {
                    // 要求预交金
                    if ($scope.request_prepay) {
                        // 但IS_BIND_CARD=0没有检查过预存
                        if ($scope.vpInfo.IS_BIND_CARD == '0') {
                            $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkPrePay");
                        }
                        // 其他小伙伴检查过预存了
                        else {
                            $ionicLoading.hide();
                            // 非住院停止 =>去验住院
                            if ($scope.request_stopWithoutIP) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                            }
                            // 非急诊停止 =>去验急诊
                            else if ($scope.request_stopWithoutEmr) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                            }
                            else {
                                // 需医保验证 =>去验医保
                                if ($scope.request_needMICheck) {
                                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                                }
                                // =>离开
                                else {
                                    $scope.leaveMethod();
                                }
                            }
                        }
                    }
                    // 不需要预存金
                    else {
                        $ionicLoading.hide();
                        // 非住院停止 =>去验住院
                        if ($scope.request_stopWithoutIP) {
                            $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                        }
                        // 非急诊停诊 =>去验急诊
                        else if ($scope.request_stopWithoutEmr) {
                            $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                        }
                        else {
                            // 需医保验证 =>去验医保
                            if ($scope.request_needMICheck) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                            }
                            // =>离开
                            else {
                                $scope.leaveMethod();
                            }
                        }
                    }
                }
            }
        })
    }

    // 5.1.建卡：格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    //2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    //2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 5.2.建卡：提交
    $scope.submitCardApply = function () {
        // 格式化手机号
        $scope.formatPhone();

        if ($scope.applyCardType == 1) {
            // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
            // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
            var isAddrFormat = false;
            // 现住址不为空-老流程填的，放过，走后边验证
            if ($scope.vpApply.address != '') {
                isAddrFormat = false;
            }
            // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
            else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
                isAddrFormat = true;
                $scope.vpApply.address = '';
                var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
                $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
                var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
                $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
                var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
                $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
                $scope.vpApply.address += $scope.vpApply.address_detail;
            }
            // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
            else {
                $fwCordovaToast.showShortBottom('请完整填写现住址信息');
                return false;
            }
            // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，删除北京医保卡号验证($scope.vpApply.insurance_type == 1 && $scope.vpApply.mi_patient_code == "")
            if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
                || ($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == '')
                || $scope.vpApply.insurance_type == 0)
                || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
            // 2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
            var addressByteSize = getStringByteSize($scope.vpApply.address);
            //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
            // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
            if (isAddrFormat && addressByteSize > 40) {
                $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
                addressByteSize = getStringByteSize($scope.vpApply.address);
            }
            else if (addressByteSize <= 10 || addressByteSize > 40) {
                var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: msgStr,
                    okText: '确定'
                }).then(function () {
                });
                return false;
            }
            // 2023-12-8 13:46:23 ZZL hzfwx-442 医保卡号添加长度限制，超过15位提示，避免超长导致自助机接口报错
            // 2024-2-22 9:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，去掉前端、后端、接口、轮询限制，屏蔽掉
            if ($scope.vpApply.mi_patient_code !== undefined && $scope.vpApply.mi_patient_code !== '' && $scope.vpApply.mi_patient_code !== null && $scope.vpApply.mi_patient_code.length > 15) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '医保卡号格式不正确，请检查后重新填写',
                    okText: '确定'
                }).then(function () {
                    $scope.MICodeHelpModalShow();
                });
                return false;
            }
        }
        else if ($scope.applyCardType == 2) {
            if (($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
        }
        else { }

        $ionicLoading.show();
        // 提交建卡申请
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type,
            $scope.vpApply.insurance_type, $scope.vpApply.mi_patient_code, $scope.vpApply.marital).then(function (data) {
                if (data.result == 1) {
                    // 建卡成功
                    if (data.data == 1) {

                        if ($scope.applyCardType == 1) {
                            $fwCordovaToast.showShortBottom("在线建档成功！");
                        }
                        else {
                            // 改成不明示
                            console.log("开通预存金账户成功");
                        }

                        // 要求开预存金账户
                        if ($scope.request_prepay) {
                            // 之前未绑卡 且真没卡 走得建档流程
                            // 回去检查预交金 【毕竟之前未查 =>实际上建档时会开预交金 =>所以有预交金、会走CHECKPASS】
                            if ($scope.vpInfo.IS_BIND_CARD == '0') {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkPrePay");
                            }
                            // 之前是半、3/4、全绑卡 无预交金 走得开预交金流程
                            // 开了预交金 所以这次直接走CHECKPASS
                            // 注：要是还检查预交金 会走缓存
                            else {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkPass");
                            }
                        }
                        // 无需检查预存金
                        // 单纯没绑卡 且无卡 =>建了张卡
                        else {
                            $ionicLoading.hide();

                            if ($scope.request_stopWithoutIP) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                            }
                            // 非急诊停止 =>去验急诊
                            else if ($scope.request_stopWithoutEmr) {
                                $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                            }
                            else {
                                // 是否医保验证
                                if ($scope.request_needMICheck) {
                                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                                }
                                // =>离开
                                else {
                                    $scope.leaveMethod();
                                }
                            }
                        }
                    }
                    // 建卡失败
                    else if (data.data == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }
                else if (data.result == 99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
                }
                // 其他错误
                else {
                    $ionicLoading.hide();
                    // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                    //$fwCordovaToast.showShortBottom(data.msg);
                    var alertPopup = $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: '确定'
                    });
                }
            })
    }

    // 6.1.图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
            $scope.vpVerify.imageVericode = "";
        }, function (data) {
            // 网络问题导致失败：显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 绑卡：短信验证码（不要了）

    // 6.2.绑卡：提交
    $scope.bindCardSubmit = function () {
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }

        $ionicLoading.hide();
        // 绑卡
        VisitPatientService.bindVisitPatient($scope.vpInfo.VISIT_PATIENT_ID, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self, true).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $fwCordovaToast.showShortBottom('绑定就诊卡成功');

                // 需要检查预存金账户
                if ($scope.request_prepay) {
                    // 之前是IS_BIND_CARD=0没有检查过
                    // 刷新，再检查下预存账户，这次会走IS_BIND_CARD=1
                    if ($scope.vpInfo.IS_BIND_CARD == '0') {
                        $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkPrePay");
                    }
                    // IS_BIND_CARD = 1，2，3的检查过了！
                    else {
                        $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkPass");
                    }
                }
                // 无需检查预存金账户
                else {
                    $ionicLoading.hide();
                    if ($scope.request_stopWithoutIP) {
                        $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                    }
                    // 非急诊停止 =>去验急诊
                    else if ($scope.request_stopWithoutEmr) {
                        $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                    }
                    else {
                        // 是否医保验证
                        if ($scope.request_needMICheck) {
                            $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                        }
                        else {
                            $scope.leaveMethod();
                        }
                    }
                }
            }
        });
    }

    // 6.3.绑卡：检查就诊卡号
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $cordovaToast.showShortTop("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 7.1.验卡：短信验证码(验卡似乎不需要验证checkPatientInfo)
    $scope.verifyToGetMsgVericode = function () {
        $scope.getMsgVericode($scope.vpVerify.phone_num, '9', $scope.vpVerify.imageVericode);
    }

    // 7.2.验卡：提交
    $scope.verifyCardSubmit = function () {
        if ($scope.vpVerify.phone_num == '' || $scope.vpVerify.messageVericode == '') {
            $fwCordovaToast.showShortBottom('请完整填写绑卡验证信息');
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardOlAchieve($scope.vpInfo.VISIT_PATIENT_ID, $scope.vpVerify.phone_num, $scope.vpVerify.messageVericode).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $fwCordovaToast.showShortBottom('就诊卡验证成功！');

                // 非住院停止
                if ($scope.request_stopWithoutIP) {
                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkIP");
                }
                // 非急诊停诊
                else if ($scope.request_stopWithoutEmr) {
                    $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkEmr");
                }
                else {
                    // 是否医保验证
                    if ($scope.request_needMICheck) {
                        $scope.thenCheck($scope.vpInfo.VISIT_PATIENT_ID, "checkMI");
                    }
                    else {
                        $scope.leaveMethod();
                    }
                }
            }
        })
    }

    // 8.1.新增就诊人：前往
    $scope.addVp = function () {
        $scope.lastStep = $scope.step;
        $scope.lastName = $scope.name;

        $scope.step = 6;
        $scope.name = "新增就诊人";

        $scope.vpNew =
        {
            realName: '',
            idCardCode: '',
            idCardType: '1',
            sex: '',
            birthday: ''
        };
        slideStep($scope.step);
    }

    // 8.2.新增就诊人：提交
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if ($scope.vpNew.idCardType == 5) {
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text + '不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        $ionicLoading.show();
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("添加就诊人成功");
                var vpId = data.data.VISIT_PATIENT_ID;
                $scope.thenCheck(vpId, "isRequestPrePay");
            }
            // 添加失败
            else {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg,
                    okText: '好的'
                });
            }
        })
    }

    // 9.获取预留手机号
    $scope.GetReservedPhone = function (vp) {
        $ionicLoading.show();
        RequestService.GetReservedPhone(vp.VISIT_PATIENT_ID).then(function (data) {
            // 圈消失
            $ionicLoading.hide();
            // 链接超时
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom('获取预留手机号失败，服务繁忙，请重试');
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }

            var phone = data.data[0].PHONENUM;
            // 验证里的预留手机号
            if (vp.IS_BIND_CARD == '3') {
                $scope.vpVerify.phone_num = phone;
                $scope.vpVerify.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
            }
            // 绑卡里的预留手机号
            else {
                $scope.vpBind.phone_num = phone;
                $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
            }
        });
    }

    // 10.1.获取短信验证码
    $scope.getMsgVericode = function (phoneNum, num, imgVericode) {
        AccountService.sendVericodeByPhone(phoneNum, num, imgVericode).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");

                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            else {
                $scope.getImageVericode();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 10.2.重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 11.检查是否住院
    checkIP = function (index) {
        $scope.vpInfo = $scope.vpList[index];

        if ($scope.vpInfo.IS_BIND_CARD != '1') {
            $fwCordovaToast.showShortBottom("就诊人未完全绑定就诊卡");
            return;
        }

        $ionicLoading.show();
        RequestService.getIPPatientInfo($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
            $ionicLoading.hide();
            // 请求错误
            if (data.result == 0 || data.result == -99) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                // 无就诊人
                if (data.is_null == 1 || data.data.length <= 0) {
                    $fwCordovaToast.showShortBottom("未找到患者的住院记录");
                }
                // 住院状态
                else if ((data.data[0].PATIENT_STATUS == "0" && data.data[0].DATE_DISCHARGE == "") || data.data[0].PATIENT_STATUS == "9") {
                    // 是否医保验证
                    if ($scope.request_needMICheck) {
                        $scope.checkMI(index);
                    }
                    else {
                        $scope.leaveMethod();
                    }
                }
                // 非住院状态
                else {
                    $fwCordovaToast.showShortBottom("患者非住院状态");
                }
            }
        });
    }

    // 12.获取当前vpid所在vplist的里index
    getIndex = function (vpId) {
        var index = 0;
        for (i in $scope.vpList) {
            if ($scope.vpList[i].VISIT_PATIENT_ID == vpId) {
                index = i;
            }
        }
        return index;
    }

    // 13.跳转路由
    getUrl = function (go, vpid) {
        DealWithCardService.getUrl(go, vpid).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom("获取跳转出错");
            }
            else {
                // url后台设置，是网页打开
                if (result.isAppInBrowser) {
                    //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                    //$cordovaInAppBrowser.open(result.url, '_blank', option).then(function (event) { });
                    //2023.7.31 新插件原有调用方式参数不生效
                    showInAppBrowser(result.url, '_blank');
                }
                // url从sys_config里取(有多参数)
                else {
                    eval(result.url);
                }
            }
        })
    }

    // 14.须知里点击了【同意】
    $scope.confirmAgree = function () {
        // 加载就诊人列表
        $scope.loadVpList();

        $scope.lastStep = $scope.step;
        $scope.lastName = $scope.name;

        $scope.step = 1;
        $scope.name = "选择就诊人";
        slideStep($scope.step);
    }

    // 15.验证医保患者是否需要提交照片
    $scope.checkMI = function (index) {
        $scope.vpInfo = $scope.vpList[index];
        $ionicLoading.show();
        DealWithCardService.needCheckMI($scope.vpInfo.VISIT_PATIENT_ID).then(function (result) {
            // 需要
            if (result.result == 1) {
                // 检查医保
                RequestService.checkMI($scope.vpInfo.VISIT_PATIENT_ID).then(function (result) {
                    $ionicLoading.hide();
                    if (result.result == 1) {
                        console.log("验医保：IS_MI_PATIENT=" + result.isMI);
                        // 是医保
                        if (result.isMI == "1") {
                            $scope.MI.REQUESTID = result.requestId;
                            $scope.MI.NOTICE = result.descr;
                            $scope.MI.HELP = result.help;
                            $scope.step = 7;
                            $scope.name = "医保认证";
                            slideStep($scope.step);
                        }
                        else {
                            $scope.leaveMethod();
                        }
                    }
                    // 拿文字失败 || 没响应 || 未查到就诊人
                    else {
                        $fwCordovaToast.showLongBottom(result.msg);
                    }
                })
            }
            // 不需要(开关未开、就诊人表已有信息) =>离开
            else if (result.result == -1) {
                console.log("验医保：开关未开、就诊人表已有信息");
                $ionicLoading.hide();
                $scope.leaveMethod();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom(result.msg);
            }
        });
    }

    // 16.离开的几行代码合并
    $scope.leaveMethod = function () {
        if ($scope.request_needSelf == true && $scope.vpInfo.IS_SELF != "1") {
            $fwCordovaToast.showLongBottom("仅允许关系为本人的就诊人查看");
            return;
        }

        // 需要处理的
        if ($scope.request_url == "") {
            getUrl(go, $scope.vpInfo.VISIT_PATIENT_ID);
        }
        else {
            // 2021-4-20 10:09:53 HM 如果跳转参数是健康咨询，多加几个参数。
            if ($scope.request_url == "hlthInquiry") {
                $state.go("app.autoInquiry", { vpid: $scope.vpInfo.VISIT_PATIENT_ID, firstFrom: "hlthInquiry", continueInquiry: 0 });
            }
            // 2021-12-06 16:49:56 HM 如果跳转的参数是首页，什么也不做
            else if ($scope.request_url == "app.home") {
                return;
            }
            // 2022-2-22 14:17:36 WX 高端体检    多带一个参数  多跳一步
            else if ($scope.request_url == "explainReport") {
                $state.go("app.consultation", { vpid: $scope.vpInfo.VISIT_PATIENT_ID, from: "explainReport" });
                return;
            }
            // 2022-5-25 10:42:20 HM 患者点餐，跳转小程序
            else if ($scope.request_url == "patientMeal") {
                // 判断患者是不是在院状态
                $ionicLoading.show();
                RequestService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
                    console.log(data);
                    if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {
                        var flag = false;
                        for (var i = 0; i < data.data.length; i++) {
                            if (data.data[i].hasOwnProperty("DATE_IN") && data.data[i]["DATE_IN"] != "" && data.data[i].hasOwnProperty("DATE_OUT") && data.data[i]["DATE_OUT"] == "") {
                                flag = true;
                            }
                        }

                        if (flag) {
                            PatientMealService.getPatientMealUrl(data.data[0]["INPATIENT_ID"]).then(function (params) {
                                $ionicLoading.hide();
                                if (params.result == 1) {
                                    var funcSuccess = function (data) {
                                        console.log("MiniProgramPlugin：patientMeal 调用成功");
                                        console.log(data);
                                    }
                                    var funcError = function (data) {
                                        console.log("MiniProgramPlugin：patientMeal 调用失败");
                                        console.log(data);
                                    }

                                    window.plugins.PatientMealPlugin.patientMeal(params.data, funcSuccess, funcError);
                                }
                                else {
                                    $fwCordovaToast.showShortBottom(params.msg);
                                }
                            }, function () {
                                // 真的网络错误
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                            })
                        }
                        else {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("请选择住院患者");
                        }
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("未找到患者信息");
                    }
                }, function () {
                    // 真的网络错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                })
            }
            // 2022-6-15 10:51:22 HM 膳食指导
            else if ($scope.request_url == "dietaryGuidance") {
                // 判断患者住没住过院
                $ionicLoading.show();
                RequestService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
                    console.log(data);

                    if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {
                        var flag = false;
                        for (var i = 0; i < data.data.length; i++) {
                            if (data.data[i].hasOwnProperty("DATE_OUT") && data.data[i]["DATE_OUT"] != "") {
                                flag = true;
                            }
                        }

                        if (flag) {
                            $ionicLoading.hide();
                            $state.go("app.srvy", { vpid: $scope.vpInfo.VISIT_PATIENT_ID, type: "DIETARY_GUIDANCE" });
                        }
                        else {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("未找到当前患者住院记录，暂不支持进行膳食指导");
                        }
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("未找到患者信息");
                    }
                }, function () {
                    // 真的网络错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                })
            }
            // 2022-7-19 10:22:16 CGZ 从特需进入门诊缴费明细 多带一个参数 能返回
            else if ($scope.request_url == "app.opConsumption") {
                $state.go($scope.request_url, { vpid: $scope.vpInfo.VISIT_PATIENT_ID, from: "app.opPayment" });
                return;
            }
            // 2023-2-27 10:08:40 HM 增加冠心病随访，选择就诊人入组
            else if ($scope.request_url == "app.flupCHD") {
                $ionicLoading.show();
                flupSrvyService.checkPatientCHD($scope.vpInfo.VISIT_PATIENT_ID).then(function (chdData) {
                    console.log(chdData);
                    if (chdData.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(chdData.msg);
                    }
                    else {
                        // 已入组
                        if (chdData.status == 2) {
                            $ionicLoading.hide();
                            $state.go("app.flupCHD", { vpId: $scope.vpInfo.VISIT_PATIENT_ID });
                        }
                        // 未入组
                        else {
                            RequestService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
                                console.log("1111");
                                console.log(data);
                                if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {

                                    data.data.sort((a, b) => (
                                        // 排序 出院日期日期DESC
                                        new Date(a.DATE_OUT).Format('yyyy-MM-dd').localeCompare(new Date(b.DATE_OUT).Format('yyyy-MM-dd')) * (-1)
                                    ))
                                    console.log("2222");
                                    console.log(data);

                                    var idb = "";
                                    for (var i = 0; i < data.data.length; i++) {
                                        // 出院日期为空说明疑似在院状态，or 最近1周内出院
                                        //if (data.data[i].hasOwnProperty("DATE_IN") && data.data[i]["DATE_IN"] != "" && data.data[i].hasOwnProperty("DATE_OUT") && data.data[i]["DATE_OUT"] == "") {

                                        var nowDate = new Date();
                                        if (!data.data[i].hasOwnProperty("DATE_OUT") || data.data[i]["DATE_OUT"] == null || data.data[i]["DATE_OUT"] == ""
                                            || (new Date(data.data[i]["DATE_OUT"].replace(/-/g, "/"))) >= nowDate.setDate(nowDate.getDate() - chdData.configDic["outDay"])) {

                                            console.log("进来了");

                                            if (data.data[i].hasOwnProperty("HIS_ID") && data.data[i]["HIS_ID"] != null && data.data[i]["HIS_ID"] != ""
                                                && data.data[i].hasOwnProperty("WARD_OUT") && data.data[i]["WARD_OUT"] != null && data.data[i]["WARD_OUT"] != ""
                                                && ("," + chdData.configDic["outWard"] + ",").indexOf("," + data.data[i]["WARD_OUT"] + ",") > -1) {

                                                idb = data.data[i]["HIS_ID"];
                                            }
                                        }

                                        if (idb != "") {
                                            break;
                                        }
                                    }

                                    if (idb == "") {
                                        $ionicLoading.hide();
                                        // 2023-4-20 14:20:57 CGZ 高晓津提出更名，经袁老师请示赵院同意，改名为健康改善计划
                                        // 2023-6-28 10:31:08 CGZ 由于医务处要弄全院统一的慢病管理，不同意冠二自己加健康改善计划的知情同意书，更名暂缓
                                        $fwCordovaToast.showShortBottom("未找到当前患者住院记录，暂不支持进行慢病术后提升");
                                        //$fwCordovaToast.showShortBottom("未找到当前患者住院记录，暂不支持进行健康改善计划");
                                    }
                                    else {
                                        // 走入组流程
                                        HospitalService.scanResult("HTTPS://WX.FUWAI.COM/FLUPCHD?IDB=" + idb).then(function (scanData) {
                                            $ionicLoading.hide();
                                            if (scanData.result == 0) {
                                                $fwCordovaToast.showShortBottom(scanData.msg);
                                            } else {
                                                $state.go("app.flupCHD", { vpId: scanData.data.param.vpId });
                                            }
                                        }, function (error) {
                                            $fwCordovaToast.showShortBottom("扫码失败");
                                            $ionicLoading.hide();
                                        })
                                    }
                                }
                                else {
                                    $ionicLoading.hide();
                                    $fwCordovaToast.showShortBottom("未找到患者信息");
                                }
                            }, function () {
                                // 真的网络错误
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                            })
                        }
                    }
                }, function () {
                    // 真的网络错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                })
            }
            else if ($scope.request_url == "app.flupDRI") {
                $ionicLoading.show();
                flupSrvyService.checkPatientDRI($scope.vpInfo.VISIT_PATIENT_ID).then(function (chdData) {
                    console.log(chdData);
                    if (chdData.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(chdData.msg);
                    }
                    else {
                        // 已入组
                        if (chdData.status == 2) {
                            $ionicLoading.hide();
                            $scope.loadSrvyInfo();
                        }
                        // 未入组
                        else {
                            // 走入组流程
                            RequestService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
                                if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {
                                    data.data.sort((a, b) => (
                                        // 排序 出院日期日期DESC
                                        new Date(a.DATE_OUT).Format('yyyy-MM-dd').localeCompare(new Date(b.DATE_OUT).Format('yyyy-MM-dd')) * (-1)
                                    ))
                                    console.log("2222");
                                    console.log(data);

                                    var idb = "";
                                    for (var i = 0; i < data.data.length; i++) {
                                        idb = data.data[i]["HIS_ID"];
                                        if (idb != "") {
                                            // 走入组流程
                                            flupSrvyService.DRIscanResult(data.data[i].IDCARD_CODE, data.data[i].INPATIENT_ID, data.data[i].DATE_IN, data.data[i].DATE_OUT, data.data[i].OUTPATIENT_ID, data.data[i].PHONENUM, data.data[i].BA_ID, data.data[i].WARD_OUT).then(function (scanData) {
                                                if (scanData.result == 0) {
                                                    $fwCordovaToast.showShortBottom(scanData.msg);
                                                } else {
                                                    $scope.loadSrvyInfo();
                                                }
                                            }, function (error) {
                                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                                $ionicLoading.hide();
                                            })
                                            break;
                                        }
                                    }

                                    if (idb == "") {
                                        $ionicLoading.hide();
                                        $fwCordovaToast.showShortBottom("未找到当前患者住院记录，暂不支持进行住院满意度调查");
                                    }
                                }
                                else {
                                    $ionicLoading.hide();
                                    $fwCordovaToast.showShortBottom("未找到患者信息");
                                }
                            }, function (error) {
                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                $ionicLoading.hide();
                            })
                        }
                    }
                }, function () {
                    // 真的网络错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                })
                //$state.go("app.flupDRI", { vpId: $scope.vpInfo.VISIT_PATIENT_ID });
                //return;
            }
            else if ($scope.request_url == "app.flupAF") {
                $ionicLoading.show();
                var ba_id = "";
                flupSrvyService.checkPatientAF($scope.vpInfo.VISIT_PATIENT_ID).then(function (chdData) {
                    console.log(chdData);
                    if (chdData.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(chdData.msg);
                    }
                    else {
                        // 已入组
                        if (chdData.status == 2) {
                            $ionicLoading.hide();
                            $scope.loadAFSrvyInfo();
                        }
                        // 未入组
                        else {
                            ba_id = chdData.data;//未入组时候为空，已入组但是没有出院时间为具体数据的BA_ID
                            // 走入组流程
                            RequestService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
                                if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {
                                    data.data.sort((a, b) => (
                                        // 排序 出院日期日期DESC
                                        new Date(a.DATE_OUT).Format('yyyy-MM-dd').localeCompare(new Date(b.DATE_OUT).Format('yyyy-MM-dd')) * (-1)
                                    ))
                                    console.log(data);

                                    var idb = "";
                                    for (var i = 0; i < data.data.length; i++) {
                                        // 2023-09-27 09:26:00 GX 心律失常随访入组增加病区过滤
                                        if (ba_id == "") {
                                            //未入组
                                            if (data.data[i].hasOwnProperty("HIS_ID") && data.data[i]["HIS_ID"] != null && data.data[i]["HIS_ID"] != ""
                                                && data.data[i].hasOwnProperty("WARD_OUT") && data.data[i]["WARD_OUT"] != null && data.data[i]["WARD_OUT"] != ""
                                                && ("," + chdData.configDic["outWard"] + ",").indexOf("," + data.data[i]["WARD_OUT"] + ",") > -1) {

                                                idb = data.data[i]["HIS_ID"];
                                                ba_id = data.data[i].BA_ID;
                                            }
                                        }
                                        else {
                                            //已入组，但是没有出院时间，根据BA_ID查到具体数据，修改出院时间
                                            if (data.data[i].hasOwnProperty("HIS_ID") && data.data[i]["HIS_ID"] != null && data.data[i]["HIS_ID"] != ""
                                                && data.data[i].hasOwnProperty("WARD_OUT") && data.data[i]["WARD_OUT"] != null && data.data[i]["WARD_OUT"] != ""
                                                && ("," + chdData.configDic["outWard"] + ",").indexOf("," + data.data[i]["WARD_OUT"] + ",") > -1
                                                && ba_id == data.data[i].BA_ID) {

                                                idb = data.data[i]["HIS_ID"];
                                            }
                                        }
                                        if (idb != "") {
                                            // 走入组流程
                                            flupSrvyService.AFscanResult(data.data[i].IDCARD_CODE, data.data[i].INPATIENT_ID, data.data[i].DATE_IN, data.data[i].DATE_OUT, data.data[i].OUTPATIENT_ID, data.data[i].PHONENUM, ba_id, data.data[i].WARD_OUT).then(function (scanData) {
                                                if (scanData.result == 0) {
                                                    $fwCordovaToast.showShortBottom(scanData.msg);
                                                } else {
                                                    $scope.loadAFSrvyInfo();
                                                }
                                            }, function (error) {
                                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                                $ionicLoading.hide();
                                            })
                                            break;
                                        }
                                    }

                                    if (idb == "") {
                                        $ionicLoading.hide();
                                        $fwCordovaToast.showShortBottom("未找到当前患者住院记录，暂不支持进行住院满意度调查");
                                    }
                                }
                                else {
                                    $ionicLoading.hide();
                                    $fwCordovaToast.showShortBottom("未找到患者信息");
                                }
                            }, function (error) {
                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                $ionicLoading.hide();
                            })
                        }
                    }
                }, function () {
                    // 真的网络错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                })
            }
            // 2023-11-16 18:00:56 ZZL hzfwx-349 荣耀健康研究，一键跳转视频问诊
            else if ($scope.request_url == "honor") {
                $state.go("app.consultation", { vpid: $scope.vpInfo.VISIT_PATIENT_ID, from: "honor" });
                return;
            }
            else {
                $state.go($scope.request_url, { vpid: $scope.vpInfo.VISIT_PATIENT_ID });
            }
        }
    }

    $scope.loadSrvyInfo = function () {
        var ifnext = true;
        $ionicLoading.show();
        if ($scope.DRInum > 10) {
            $scope.DRInum = 0;
            console.log("未找到当前患者出院记录，暂不支持进行住院满意度调查");
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("未找到当前患者出院记录，暂不支持进行住院满意度调查");
            return;
        }
        flupSrvyService.getDRIFlupPatient($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
            if (data.result != 1) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                if (data.data.length > 0) {
                    for (var i = 0; i < data.data.length; i++) {
                        if (data.data[i].taskList && data.data[i].taskList.length != 0) {
                            ifnext = false;
                            break;
                        }
                    }
                    if (!ifnext) {
                        $scope.DRInum = 0;
                        $ionicLoading.hide();
                        $state.go("app.flupDRI", { vpId: $scope.vpInfo.VISIT_PATIENT_ID });
                    }
                    else {
                        $timeout(function () {
                            $scope.DRInum++;
                            console.log("请求" + $scope.DRInum + "次");
                            $scope.loadSrvyInfo();
                        }, 1000);
                    }
                }
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        });
    }

    $scope.loadAFSrvyInfo = function () {
        var ifnext = true;
        $ionicLoading.show();
        if ($scope.AFnum > 30) {
            $scope.AFnum = 0;
            console.log("未找到当前患者出院记录，暂不支持进行住院满意度调查");
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("未找到当前患者出院记录，暂不支持进行住院满意度调查");
            return;
        }
        flupSrvyService.getAFFlupPatient($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
            if (data.result != 1) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                if (data.data.length > 0) {
                    for (var i = 0; i < data.data.length; i++) {
                        if (data.data[i].taskList && data.data[i].taskList.length == 0) {
                            ifnext = false;
                            break;
                        }
                    }
                    if (ifnext) {
                        $scope.AFnum = 0;
                        $ionicLoading.hide();
                        $state.go("app.flupAF", { vpId: $scope.vpInfo.VISIT_PATIENT_ID });
                    }
                    else {
                        $timeout(function () {
                            $scope.AFnum++;
                            console.log("请求" + $scope.AFnum + "次");
                            $scope.loadAFSrvyInfo();
                        }, 1000);
                    }
                }
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        });
    }

    // 17.刷新，再检查的几行代码合并
    $scope.thenCheck = function (vpid, type) {
        // 刷新vpList，获取index
        VisitPatientService.visitPatientList().then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $scope.vpList = data.data;
                var index = getIndex(vpid);

                switch (type) {
                    // 回一切的开始
                    // 只新增就诊人会用
                    case "isRequestPrePay":
                        $scope.isRequestPrePay(index);
                        break;
                    // 去验预存金
                    case "checkPrePay":
                        checkPrePay(index);
                        break;
                    // 去验通过
                    case "checkPass":
                        checkPass(index);
                        break;
                    // 去验住院
                    case "checkIP":
                        checkIP(index);
                        break;
                    // 去验医保
                    case "checkMI":
                        $scope.checkMI(index);
                        break;
                    // 去验急诊
                    case "checkEmr":
                        checkEmr(index);
                        break;
                    // 配置错误
                    default:
                        $fwCordovaToast.showShortBottom("配置错误");
                        break;
                }
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function () {
            $ionicLoading.hide();
        })
    }

    // 18 医保部分提交
    $scope.addMIPatientInfo = function () {
        // 2024-2-22 11:09:17 ZZL hzfwx-714 三代医保卡升级，改为MICode医保卡号为可选参数，去掉必填
        //if ($scope.MI.MI_PATIENT_CODE == undefined) {
        //    $fwCordovaToast.showShortBottom("请填写您的医保卡号");
        //    return;
        //}

        //if ($scope.MI.MI_IMG_URL == undefined) {
        //    $fwCordovaToast.showShortBottom("请上传您的医保卡正面图片");
        //    return;
        //}
        //if ($scope.MI.MI_PATIENT_IMG_URL == undefined) {
        //    $fwCordovaToast.showShortBottom("请上传您的手持医保卡图片");
        //    return;
        //}

        DealWithCardService.addMIPatientInfo($scope.vpInfo.VISIT_PATIENT_ID, $scope.MI.REQUESTID,
            $scope.MI.MI_PATIENT_CODE, $scope.MI.MI_IMG_URL, $scope.MI.MI_PATIENT_IMG_URL).then(function (result) {
                if (result.result == 1) {
                    // =>离开
                    $scope.leaveMethod();
                }
                // 这里应该是 院内医保号 != 患者手输入号
                else {
                    $fwCordovaToast.showShortBottom(result.msg);
                }
            })
    }

    // 19.删除就诊人
    $scope.deleteVisitPatient = function (vpId) {
        VisitPatientService.visitPatientInfo(vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                if (!data.data.DELETABLE) {
                    $fwCordovaToast.showShortBottom("用户每两个月只能删除一个就诊人");
                    return;
                }

                var confirmPopup = $ionicPopup.confirm({
                    title: '确定要删除该就诊人？',
                    template: $sce.trustAsHtml(data.vpRemoveDescr), //从服务端获取更新的内容
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmPopup.then(function (res) {
                    if (res) {
                        VisitPatientService.removeVisitPatient(vpId).then(function (result) {
                            if (result.result == 0) {
                                $fwCordovaToast.showShortBottom(result.msg);
                            } else {
                                $fwCordovaToast.showShortBottom("删除成功");
                                $scope.loadVpList();
                            }
                        });
                    }
                });
            }
        })
    }

    // 20.检查是否急诊
    checkEmr = function (index) {
        $scope.vpInfo = $scope.vpList[index];

        if ($scope.vpInfo.IS_BIND_CARD != '1') {
            $fwCordovaToast.showShortBottom("就诊人未完全绑定就诊卡");
            return;
        }

        $ionicLoading.show();
        RequestService.getEmrPatientInfo($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
            $ionicLoading.hide();
            // 请求错误
            if (data.result == 0 || data.result == -99) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                // 无就诊人
                if (data.is_null == 1 || data.data.length <= 0) {
                    $fwCordovaToast.showShortBottom("未找到患者的急诊记录");
                }
                // 急诊状态
                else {
                    // 是否医保验证
                    if ($scope.request_needMICheck) {
                        $scope.checkMI(index);
                    }
                    // 是否需要住院验证
                    else if ($scope.request_stopWithoutIP) {
                        checkIP(index);
                    }
                    else {
                        $scope.leaveMethod();
                    }
                }
            }
        });
    }

    // 图片部分
    // 1.1.调起控件
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿
        // type == -1 --> 医保验证(手持), type == -2 --> 医保验证(正)
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }

    // 1.2.1由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }
    // 1.2.2.调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }

    // 1.3.上传图片
    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        // 2020.02.27 医保验证
        if (type == -1 || type == -2) {
            options.params = { urlExt: "CASE_PRINT", ifDES: "1" };
            uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        }
        $ionicLoading.show();
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            // 旧版
            if (type == 0 || type == 1 || type == 2) {
                var fileResult = {};
                eval("fileResult = " + result.response);
                $ionicLoading.hide();
                // 上传成功
                if (fileResult.result == 1) {
                    $fwCordovaToast.showShortBottom("上传成功");
                    // 头像面
                    if (type == 0) {
                        $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                    }
                    // 国徽面
                    else if (type == 1) {
                        $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                    }
                    // 户口簿
                    else if (type == 2) {
                        $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                    }
                }
                // 上传失败
                else {
                    $fwCordovaToast.showShortBottom(fileResult.msg);
                }
            }
            // 新增 医保验证
            else {
                if (result.response == undefined) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom("上传失败");
                }
                else {
                    if (result.response.indexOf('上传失败') >= 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom(result.response);
                    }
                    else {
                        $ionicLoading.hide();
                        if (type == -1) {
                            $scope.MI.MI_PATIENT_IMG_URL = result.response;
                        }
                        else {
                            $scope.MI.MI_IMG_URL = result.response;
                        }
                    }
                }
            }
        }, function (error) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }

    // 1.4.删除身份证照片
    $scope.deleteImg = function (type) {
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }

    // 2.1.医保图片 上传
    $scope.setUrl = function (type) {
        // 手持 == -1，  正面 == -2
        $scope.imgAddActionSheet(type);
    }
    // 2.2 医保图片 删除
    $scope.detUrl = function (type) {
        if (type == -1) {
            $scope.MI.MI_PATIENT_IMG_URL = "";
        }
        else {
            $scope.MI.MI_IMG_URL = "";
        }
    }

    // slide切换
    // 1.切页触发
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 2.后退（回首页）
    $scope.goBack = function () {
        // 清空
        // 绑卡模型
        $scope.vpBind = {
            name: '',
            card_num: '',
            card_num_show: '',
            phone_num: null,
            phone_num_show: '',
            veri_code: '',
            patient_id: '',
            is_self: 0,
            imageVericode: ''
        }
        // 建卡模型
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '',
            insurance_type: 0,
            mi_patient_code: '',
            marital: 0
        }
        // 验卡模型
        $scope.vpVerify = {
            phone_num: '',
            phone_num_show: '',
            imageVericode: '',
            messageVericode: ''
        };
        // 新增就诊人模型
        $scope.vpNew = {
            realName: '',
            idCardCode: '',
            idCardType: '1',
            sex: '',
            birthday: ''
        };

        if ($scope.step == 0 || $scope.step == 1) {
            // 如果是患者点餐，走特殊逻辑，回到上一页
            if ($scope.request_url == "patientMeal" || $scope.request_url == "app.opConsumption") {
                $rootScope.goBack();
            }
            else {
                $state.go("app.home");
            }
        }
        else if ($scope.step == 3) {
            // 上一步在选卡
            if ($scope.lastStep == 4) {
                // 注：设置选择的上一步为选择就诊人
                $scope.lastStep = 1;
                $scope.lastName = "选择就诊人";

                $scope.step = 4;
                $scope.name = "就诊卡选择绑定";
                slideStep($scope.step);
            }
            else {
                $scope.lastStep = 1;
                $scope.lastName = "选择就诊人";

                $scope.step = 1;
                $scope.name = "选择就诊人";
                slideStep($scope.step);
            }
        }
        else {
            $scope.step = 1;
            $scope.lastStep = 1;
            $scope.name = "选择就诊人";
            $scope.lastName = "选择就诊人";
            slideStep($scope.step);
        }
    }

    // 3.切页
    slideStep = function (step) {
        dealWithSlide.slide(step);
        $scope.slideChanged();
    }

    // 模态窗口
    // 医保认证帮助
    $ionicModal.fromTemplateUrl('MI_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MIHelpModal = modal;
    });
    $scope.MIHelpModalShow = function () {
        $scope.MIHelpModal.show();
    }
    $scope.MIHelpModalHide = function () {
        $scope.MIHelpModal.hide();
    }

    // 医保号帮助
    $ionicModal.fromTemplateUrl('MICode_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MICodeHelpModal = modal;
    });
    $scope.MICodeHelpModalShow = function () {
        $scope.MICodeHelpModal.show();
    }
    $scope.MICodeHelpModalHide = function () {
        $scope.MICodeHelpModal.hide();
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // 页面的进入与退出
    // 1.准备
    ionic.DomUtil.ready(function () {
        // 禁用左右滑动
        dealWithSlide.enableSlide(false);
    });

    // 2.加载（只执行一次）
    $scope.$on('$ionicView.loaded', function () {
        $ionicLoading.show();
        DealWithCardService.getTemplate(go).then(function (result) {
            if (result.result == -1) {
                $ionicLoading.hide();
                // 2023-9-8 10:14:49 CGZ 允许未登录状态进入个人中心，此处未登录改为跳转登录页
                //$state.go("app.personal");
                $state.go("login");
            }
            else {
                if (result.template != null) {
                    $scope.request_status = result.template.status;
                    $scope.request_prepay = result.template.prepay;
                    $scope.request_stopWithoutCard = result.template.stopWithoutCard;
                    $scope.request_stopWithoutIP = result.template.stopWithoutIP;
                    $scope.request_stopWithoutEmr = result.template.stopWithoutEmr;
                    $scope.request_url = result.template.url;
                    $scope.request_confirm = result.template.confirm;
                    $scope.request_needMICheck = result.template.needMICheck;
                    $scope.request_needSelf = result.template.needSelf;
                }
                $scope.bind_count = result.bind_count;

                // 配置里没有用户须知
                if ($scope.request_confirm == "") {
                    // 跳过同意须知
                    $scope.confirmAgree();
                }
                else {
                    // 处理用户须知
                    $scope.name = "用户须知";
                    $ionicLoading.hide();

                    $scope.isLoadFinish = true;

                    // 开启用户须知倒计时
                    $interval(function () {
                        $scope.confirmCountdown -= 1;
                    }, 1000, 10);
                }
            }
        })
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();
    })

    // 3.进入（执行多次）
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack(true);
            e.preventDefault();
            return false;
        }, 135, 'dealWithCard');

        // 设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if (data.result == 1) {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证"}];
        //    }
        //});
    });

    // 4.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'dealWithCard') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 5.销毁
    $scope.$on('$destroy', function () {
        $scope.MIHelpModal.remove();
        $scope.MICodeHelpModal.remove();
    })

    // #region 跳转我的在线问诊

    $scope.goConsultationList = function () {
        $state.go('app.consultationList');
    }

    // #endregion
})