﻿angular.module('fwapp.controllers')

// 医院介绍
.controller('DepartmentController', function ($scope, DepartmentService, $state, $ionicScrollDelegate, $timeout, SchedulingService, $ionicLoading, $ionicPlatform, $ionicPopup) {
    $scope.department = new Object();

    DepartmentService.department().then(function (data) {
        $ionicLoading.hide();
        $scope.department = data;
        for (var i = 0; i < data.length; i++) {
            $scope.department[i].isShow = i == 0;
        }
    }, function (resp) {
        var alertPopup = $ionicPopup.alert({
            title: '网络错误',
            template: '加载失败,请检查网络'
        });
        $ionicLoading.hide();
    });
    $ionicLoading.show();

    $scope.hideLists = function (index) {
        for (var i = 0; i < $scope.department.length; i++) {
            if (i != index) {
                $scope.department[i].isShow = false;
            } else {
                $scope.department[i].isShow = !$scope.department[i].isShow;
            }
            //$scope.department[i].isShow = i == index;
        }

        $ionicScrollDelegate.scrollTop();
        $timeout(function () {
            $ionicScrollDelegate.resize();
        }, 1000);
    }

    $scope.doctor = function (deptId, deptName) {
        $state.go("app.doctor", { deptId: deptId, deptName: deptName });
    }

    $scope.goBack = function () {
        $state.go("app.home");
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'department');
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'department') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})