﻿angular.module('fwapp.controllers')

.controller('DischargeController', function ($scope, $rootScope, $ionicPopup, $state, $timeout, $ionicSlideBoxDelegate, $filter, $ionicPlatform,
 $fwCordovaToast, $ionicLoading, dischargeService, RequestService) {
    // 检查登录状态
    $rootScope.checkLogin();

    //定义滑块
    var slideDischarge = $ionicSlideBoxDelegate.$getByHandle('slideDischarge');

    //审核完成后的提示
    $scope.tips = "";
    //出院带药完成后的提示
    var medSuccessTips = "";

    //初始页面
    $scope.step = 0;

    //标题
    $scope.title = ["住院结算审核查询", "住院结算审核进度"];

    //姓名、住院号初始化
    $scope.formData = { patientName: "", inpatientId: "" };

    $scope.$on('$ionicView.loaded', function () {
        //禁止滑块手动滑动
        $ionicSlideBoxDelegate.enableSlide(false);
        //添加物理后退键
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
        }, 135, 'discharge');
    })

    //清除物理后退键
    $scope.$on('$ionicView.unloaded', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'discharge') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })

    //返回事件
    $scope.goBack = function () {
        if ($scope.step == 0) {
            $rootScope.goBack();
        } else {
            $scope.lastSlide();
        }
    };

    // 滑到上一步
    $scope.lastSlide = function () {
        slideDischarge.previous();
        $scope.step = slideDischarge.currentIndex();
    };

    // 滑到下一步
    $scope.nextSlide = function () {
        slideDischarge.next();
        $scope.step = slideDischarge.currentIndex();
    };

    //下拉事件
    $scope.dropdownRefresh = function () {
        if ($scope.step == 0) {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');
        } else {
            $scope.submit();
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');
        }
    }

    //查询事件
    $scope.submit = function () {
        if ($scope.formData.patientName.length == 0 || $scope.formData.inpatientId.length == 0) {
            $fwCordovaToast.showShortBottom("请输入姓名、住院号");
            return false;
        }
        $ionicLoading.show();
        RequestService.getIPDischargeAudit($scope.formData).then(function (data) {
            if (data.result == 1 || data.result == -1) {
                if (data.is_null == 1) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("未找到住院患者信息");
                } else {
                    if (data.data[0] == null || data.data[0] == '') {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误");
                    } else {
//                        if (data.data[0].DATE_WARD_OUT == null || data.data[0].DATE_WARD_OUT == "") {
//                            $ionicLoading.hide();
//                            $fwCordovaToast.showShortBottom("护士站未办理出院");
//                        } else {
                            dischargeService.result(data.data[0].REQUEST_ID).then(function (data1) {
                                $ionicLoading.hide();
                                $scope.tips = data1.data;
                                medSuccessTips = data1.dataMedication;
                                $scope.ischargeResult(data.data[0]);
                                $scope.nextSlide();
                            }, function (resp) {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom("网络错误");
                            });
//                        }
                    }
                }
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误");
        });
    };

    //记录查询内容
    $scope.result = function (requestId) {
        ;
    }

    //进度页颜色及内容处理
    $scope.ischargeResult = function (data) {
        //第一个球的颜色
        $scope.color1 = "discharge_ash";
        //第二个球的颜色
        $scope.color2 = "discharge_ash";
        //第三个球的颜色
        $scope.color3 = "discharge_ash";
        //是否显示流程完成提示
        $scope.isSuccess = false;

        //是否医保用户
        $scope.isHealthCare = data.IS_HEALTH_CARE == 1 ? true : false;

        //护士站出院时间
        $scope.dateWardValue = data.DATE_WARD_OUT == "" ? "" : $filter('date')(new Date(data.DATE_WARD_OUT), 'yyyy年MM月dd日');
        //医保审核时间
        $scope.dateHealthCareAudit = data.DATE_HEALTH_CARE_AUDIT == "" ? "" : $filter('date')(new Date(data.DATE_HEALTH_CARE_AUDIT), 'yyyy年MM月dd日');
        //住院收费审核时间
        $scope.dataWindowAudit = data.DATE_WINDOW_AUDIT == "" ? "" : $filter('date')(new Date(data.DATE_WINDOW_AUDIT), 'yyyy年MM月dd日');

        //护士站
        if ($scope.dateWardValue != "") {
            $scope.color1 = "discharge_green";
        }

        //医保
        if ($scope.color1 == "discharge_ash") {
            $scope.color2 = "discharge_ash";
        } else {
            if ($scope.dateHealthCareAudit == "") {
                $scope.color2 = "discharge_yellow";
            } else {
                $scope.color2 = "discharge_green";
            }
        }

        //住院收费
        if ($scope.isHealthCare && $scope.color2 == "discharge_ash") {
            $scope.color3 = "discharge_ash";
        } else if ($scope.isHealthCare && $scope.color2 == "discharge_yellow") {
            $scope.color3 = "discharge_ash";
        } else if ($scope.isHealthCare && $scope.color2 == "discharge_green") {
            if ($scope.dataWindowAudit == "") {
                $scope.color3 = "discharge_yellow";
            } else {
                $scope.color3 = "discharge_green";
            }
        } else if (!$scope.isHealthCare && $scope.color1 == "discharge_ash") {
            $scope.color3 = "discharge_ash";
        } else if (!$scope.isHealthCare && $scope.color1 == "discharge_green") {
            if ($scope.dataWindowAudit == "") {
                $scope.color3 = "discharge_yellow";
            } else {
                $scope.color3 = "discharge_green";
            }
        }

        //全部审核完成
        if ($scope.color3 == "discharge_green") {
            $scope.isSuccess = true;
        }

        //护士站提示
        if ($scope.color1 == "discharge_ash") {
            $scope.dateWardValue = "目前未申请出院";
        }

        //医保提示
        if ($scope.color2 == "discharge_yellow") {
            $scope.dateHealthCareAudit = "审核中...";
        } else if ($scope.color2 == "discharge_ash") {
            $scope.dateHealthCareAudit = "未审核";
        }

        //住院收费提示
        if ($scope.color3 == "discharge_yellow") {
            $scope.dataWindowAudit = "审核中..."
        }
        else if ($scope.color3 == "discharge_ash") {
            $scope.dataWindowAudit = "未审核"
        }

        // 201910112
        // 出院带药状态判断
        $scope.medStatusColor = "discharge_ash";
        $scope.medData = "没有待准备的药品";
        $scope.medSuccessTips = "";

        //是否显示流程完成提示
        $scope.medIsSuccess = false;

        if (data.DISCHARGE_MED_STATUS == 2) {
            $scope.medStatusColor = "discharge_green";
            // 出院带药时间
            $scope.medData = data.DATE_MED_AUDIT == "" ? "" : $filter('date')(new Date(data.DATE_MED_AUDIT), 'yyyy年MM月dd日');
            // 取药提示，并拼接楼号
            $scope.medSuccessTips = medSuccessTips.replace("{{0}}", data.MED_PHARMACY);
            $scope.medIsSuccess = true;
        }
        if (data.DISCHARGE_MED_STATUS == 1) {
            $scope.medStatusColor = "discharge_yellow";
            $scope.medData = "药品准备中...";
        }
    }
})