﻿angular.module('fwapp.controllers')

.controller('DiseaseHistoryController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $cordovaDatePicker,
    AccountService, VisitPatientService, RequestService, DiseaseHistoryService, $fwCordovaToast, $ionicPlatform, $ionicHistory) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 是否加载完成
    $scope.isLoadFinish = false;
    // 保存按钮可用
    $scope.canSave = true;

    // 疾病列表
    $scope.diseaseList = [];
    $scope.threeHigh = new Object();
    $scope.threeHighOri = "";
    // 打哪儿来
    $scope.from = ($stateParams.from == null || $stateParams.from.length == 0) ? "" : $stateParams.from;

    //#region 就诊人
    // 就诊人ID
    $scope.vpId = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "" : $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人列表
    $scope.vpList = [];

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        if ($scope.vpId != vpid) {
            $scope.saveThreeHigh();
            $scope.vpId = vpid;
            $scope.vpInfo = new Object();
            $scope.loadVPInfo();
            $scope.loadDiseaseList();
        }
        $scope.popVplist.hide();
    }
    //#endregion

    //#region 注册模态窗口：添加既往史
    $ionicModal.fromTemplateUrl('addDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addDiseaseModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addDiseaseModal.remove();
    })

    // 添加既往史 模态窗口显示
    $scope.addDiseaseShow = function () {
        $scope.diseaseNew = new Object();
        $scope.diseaseNew.id = "";
        $scope.diseaseNew.name = "";
        $scope.diseaseNew.date = new Date().Format("yyyy-MM-dd");
        $scope.diseaseNew.status = 1;
        $scope.addDiseaseModal.show();
    }

    // 添加既往史 模态窗口隐藏
    $scope.addDiseaseHide = function () {
        $scope.addDiseaseModal.hide();
        $ionicScrollDelegate.resize();
        $scope.diseaseNew = new Object();
    }
    //#endregion

    //#region 编辑既往史


    function loadStart() {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        $scope.canSave = false;
    }

    function loadFinish() {
        $scope.isLoadFinish = true;
        $scope.canSave = true;
        $ionicLoading.hide();
    }

    // 获取既往史列表
    $scope.loadDiseaseList = function () {
        loadStart();

        $scope.diseaseList = [];
        $scope.threeHigh = new Object();
        $scope.threeHighOri = "";

        DiseaseHistoryService.list($scope.vpId, localStorage.queryToken).then(function (data) {
            //console.log(data);
            // 无效QueryToken
            if (data.result == -2) {
                loadFinish();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadDiseaseList();
                    }
                })
                return;
            }
            // 请求错误
            else if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            else if (data.result == 1) {
                // 患病日期格式化
                for (var i in data.data) {
                    if (currentPlatform == "iOS") {
                        data.data[i].DATE_DISEASE = data.data[i].DATE_DISEASE.replace(/-/g, "/");
                    }
                    data.data[i].DATE_DISEASE = new Date(data.data[i].DATE_DISEASE).Format("yyyy-MM-dd");
                }
                $scope.diseaseList = data.data;
                // 三高赋值
                for (var i in $scope.diseaseList) {
                    if ($scope.diseaseList[i].DISEASE_TYPE == "th_gxy") {
                        $scope.threeHigh.isGxy = $scope.diseaseList[i].STATUS == 1 ? 1 : 0;
                        $scope.threeHigh.gxyDate = $scope.diseaseList[i].DATE_DISEASE;
                    }
                    if ($scope.diseaseList[i].DISEASE_TYPE == "th_tnb") {
                        $scope.threeHigh.isTnb = $scope.diseaseList[i].STATUS == 1 ? 1 : 0;
                        $scope.threeHigh.tnbDate = $scope.diseaseList[i].DATE_DISEASE;
                    }
                    if ($scope.diseaseList[i].DISEASE_TYPE == "th_gzxz") {
                        $scope.threeHigh.isGzxz = $scope.diseaseList[i].STATUS == 1 ? 1 : 0;
                        $scope.threeHigh.gzxzDate = $scope.diseaseList[i].DATE_DISEASE;
                    }
                }
                if ($scope.threeHigh.gxyDate == null) {
                    $scope.threeHigh.gxyDate = new Date().Format("yyyy-MM-dd");
                }
                if ($scope.threeHigh.tnbDate == null) {
                    $scope.threeHigh.tnbDate = new Date().Format("yyyy-MM-dd");
                }
                if ($scope.threeHigh.gzxzDate == null) {
                    $scope.threeHigh.gzxzDate = new Date().Format("yyyy-MM-dd");
                }
                $scope.threeHighOri = jQuery.param($scope.threeHigh);
                console.log($scope.threeHighOri);

            }
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            loadFinish();
        });
    }

    // 添加其他疾病
    $scope.addDisease = function () {
        // 排空
        if ($scope.diseaseNew.name.length == 0) {
            $fwCordovaToast.showShortBottom("疾病名称不能为空");
            return;
        }
        loadStart();
        DiseaseHistoryService.editDisease($scope.diseaseNew.id, $scope.vpId, $scope.diseaseNew.name, $scope.diseaseNew.date, $scope.diseaseNew.status).then(function (data) {
            // 请求错误
            if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                $scope.diseaseList.push(new Object({ DISEASE_NAME: $scope.diseaseNew.name, DATE_DISEASE: $scope.diseaseNew.date, DISEASE_TYPE: "other", STATUS: 1 }));
                console.log($scope.diseaseList);
            }
            $scope.addDiseaseHide();
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollBottom();
            loadFinish();
        });
    }

    // 删除既往史
    $scope.deleteDisease = function (index) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除既往史',
            template: "您确定要删除此条既往史吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                loadStart();
                DiseaseHistoryService.deleteDisease($scope.diseaseList[index].DISEASE_HISTORY_ID).then(function (data) {
                    // 请求错误
                    if (data.result == 0) {
                        loadFinish();
                        $fwCordovaToast.showShortBottom(data.msg);
                        return;
                    }
                    // 请求成功
                    if (data.result == 1) {
                        //$scope.diseaseList[index].STATUS = 0;
                        $scope.diseaseList.splice(index, 1);
                        console.log($scope.diseaseList);
                    }
                    $scope.addDiseaseHide();
                    $ionicScrollDelegate.resize();
                    loadFinish();
                });
            }
        })
    }

    // 保存三高
    $scope.saveThreeHigh = function () {
        var strQuery = jQuery.param($scope.threeHigh);
        if ($scope.threeHighOri == strQuery) {
            // 没变
            console.log("三高未改变");
            return;
        }
        console.log(strQuery);
        DiseaseHistoryService.saveThreeHigh($scope.vpId, $scope.threeHigh).then(function (data) {
            console.log(data);
            // 请求错误
            if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                console.log("三高保存成功");
            }
        });
    }
    //#endregion

    // 后退 重写goBack
    $scope.goBack = function () {
        if ($stateParams.vpid == "") {
            $rootScope.goBack();
        }
        else {
            if ($scope.from.length > 0) {
                $state.go($scope.from, { vpid: $scope.vpId, from: "app.diseaseHistory" });
            }
            else {
                $state.go('app.visitPatient', { vpid: $scope.vpId });
            }
        }
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'diseaseHistory');
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }

                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                } else {
                    console.log($scope.vpId);
                    $scope.loadVPInfo();

                    $scope.loadDiseaseList();
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        $scope.saveThreeHigh();
        // 解除返回键绑定
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'diseaseHistory') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });

    //#region cordova日期选择
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
    //#endregion

    //#region 多选控件
    // 延迟重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicScrollDelegate.resize();
        }, 500);
    }

    // 可取消单选按钮
    $scope.flupCheckbox = function (qstnId, dicValue) {
        $scope.threeHigh[qstnId] = $scope.threeHigh[qstnId] == dicValue ? "" : dicValue;
        // 调试用赋值
        if (devMode && $scope.threeHigh.isGxy == 1) {
            $scope.threeHigh.gxyDate = new Date().Format("yyyy-MM-dd");
        }
        if (devMode && $scope.threeHigh.isTnb == 1) {
            $scope.threeHigh.tnbDate = new Date().Format("yyyy-MM-dd");
        }
        if (devMode && $scope.threeHigh.isGzxz == 1) {
            $scope.threeHigh.gzxzDate = new Date().Format("yyyy-MM-dd");
        }
        $scope.scrollResize();
    }
    //#endregion
});
