﻿angular.module('fwapp.controllers')

// 出诊医师列表
.controller('DoctorController', function ($scope, DoctorService, $state, $stateParams, DeptInfoService, $ionicLoading, $ionicPlatform, $ionicPopup) {
    $scope.doctor = new Object();
    $scope.deptName = $stateParams.deptName;
    $ionicLoading.show();

    // 修改为视图全面进入后触发
    $scope.$on('$ionicView.enter', function () {
        DoctorService.doctor_web($stateParams.deptId).then(function (data) {
            //console.log(data);
            $ionicLoading.hide();
            $scope.doctor = data;
        }, function (resp) {
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络'
            });
            $ionicLoading.hide();
        });
    });

    //    DeptInfoService.deptInfo($stateParams.deptId).then(function (data) {
    //        $scope.deptInfo = data;
    //    });

    $scope.deptInfo = function () {
        $state.go("app.deptInfo", { deptId: $stateParams.deptId });
    }

    $scope.doctorInfo = function (doctorId, doctorCode, doctorName, doctorLevel) {
        $state.go("app.doctorInfo", { doctorId: doctorId, deptId: $stateParams.deptId, doctorCode: doctorCode, deptName: $stateParams.deptName, doctorName: doctorName, doctorLevel: doctorLevel });
    }

    $scope.goBack = function () {
        $state.go("app.department");
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'doctor');
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'doctor') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})