﻿angular.module('fwapp.controllers')

// 医院介绍
.controller('DoctorInfoController', function ($scope, $rootScope, $state, $ionicLoading, $stateParams,
    DoctorInfoService, AddWishService, OpApptService, $ionicHistory, $ionicPlatform, $ionicActionSheet, $fwCordovaToast, $ionicPopup, $ionicModal) {
    //
    $ionicLoading.show();
    $scope.doctorInfo = new Object();
    $scope.showTabIndex = 0;

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.showAvatarModal.remove();
    })

    // 2017-4-10 08:38:08 医师头像放大
    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }
    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    $scope.goBack = function () {
        // 2017-4-20 16:17:42 返回至搜索页
        console.log($stateParams.deptId, $stateParams.deptName);
        // 来自搜索
        if ($stateParams.deptId == '' && $stateParams.deptName == '') {
            console.log('goBackToSearch');
            //$rootScope.goBack();
            $state.go('app.search');
        }
        // 原路径
        else {
            $state.go("app.doctor", { deptId: $stateParams.deptId, deptName: $stateParams.deptName });
        }
    }

    $scope.switchTab = function (tabIndex) {
        $scope.showTabIndex = tabIndex;
    }

    $scope.appt = function (id, color) {
        if (id != "" && (color == "green" || color == "orange")) {
            // 改为上下午分段
            if (isOpAppt || $rootScope.opApptData.status) {
                OpApptService.getOpSchedInfo(id).then(funcCBSGetPeriod);
            }
            else {
                AddWishService.getPeriod(id).then(funcCBSGetPeriod);
            }
            function funcCBSGetPeriod(data) {
                console.log(data);
                // 调用失败
                if (data.result == -1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                // 已约满
                else if (data.result == 0) {
                    $fwCordovaToast.showShortBottom("当前选择的医师已约满");
                }
                // 一个时段 直接赋值下一步
                else if (data.result == 1) {
                    $scope.opInfoSelect = data.data[0];
                    //                    $scope.toSlide(5);
                    if (isOpAppt || $rootScope.opApptData.status) {
                        $state.go("app.opAppt", { opid: data.data[0].ID, from: '"app.doctorInfo",{ doctorId: "' + $stateParams.doctorId + '", deptId: "' + $stateParams.deptId + '", doctorCode:"' + $stateParams.doctorCode + '", deptName: "' + $stateParams.deptName + '", doctorName:"' + $stateParams.doctorName + '", doctorLevel:"' + $stateParams.doctorLevel + '"}' });
                    }
                    else {
                        $state.go("app.addWish", { opid: data.data[0].ID, from: '"app.doctorInfo",{ doctorId: "' + $stateParams.doctorId + '", deptId: "' + $stateParams.deptId + '", doctorCode:"' + $stateParams.doctorCode + '", deptName: "' + $stateParams.deptName + '", doctorName:"' + $stateParams.doctorName + '", doctorLevel:"' + $stateParams.doctorLevel + '"}' });
                    }
                }
                // 多个时段 弹出选择
                else if (data.result == 2) {
                    // 弹出ActionSheet
                    // 遍历生成按钮
                    var arrButton = new Array();
                    for (var i in data.data) {
                        // 计算时段
                        var str = "";
                        if (data.data[i].SCHED_TIME == "上午" && data.data[i].SCHED_PERIOD_CODE == "A") {
                            str = "08:00-09:30";
                        }
                        if (data.data[i].SCHED_TIME == "上午" && data.data[i].SCHED_PERIOD_CODE == "B") {
                            str = "09:30-11:00";
                        }
                        if (data.data[i].SCHED_TIME == "下午" && data.data[i].SCHED_PERIOD_CODE == "A") {
                            str = "13:00-14:30";
                        }
                        if (data.data[i].SCHED_TIME == "下午" && data.data[i].SCHED_PERIOD_CODE == "B") {
                            str = "14:30-16:00";
                        }

                        // 追加到预约时段后边 方便确认页显示
                        if (data.data[i].SCHED_TIME == "上午" || data.data[i].SCHED_TIME == "下午") {
                            data.data[i].SCHED_TIME += " " + str;
                        }

                        // 判断预约状态 加后缀和样式
                        if (data.data[i].APPT_STATUS == "1") {
                            str += " (可预约)";
                            str = '<span>' + str + '</span>';
                        }
                        else {
                            str += " (已约满)";
                            str = '<span class="fw-action-sheet-error">' + str + '</span>';
                        }
                        arrButton.push({ text: str });
                    }
                    console.log(arrButton);
                    var hideSheet = $ionicActionSheet.show({
                        buttons: arrButton,
                        titleText: "选择就诊时段",
                        cancelText: "取消",
                        cancel: function () {
                            hideSheet();
                        },
                        buttonClicked: function (index) {
                            if (data.data[index].APPT_STATUS != "1") {
                                return;
                            }
                            hideSheet();
                            //                            console.log(index);
                            //                            console.log(data.data[index]);
                            //                            $scope.opInfoSelect = data.data[index];
                            //                            console.log($scope.opInfoSelect);
                            //                            $scope.toSlide(5);
                            //                            console.log(data.data[index]);
                            if (isOpAppt || $rootScope.opApptData.status) {
                                $state.go("app.opAppt", { opid: data.data[index].ID, from: '"app.doctorInfo",{ doctorId: "' + $stateParams.doctorId + '", deptId: "' + $stateParams.deptId + '", doctorCode:"' + $stateParams.doctorCode + '", deptName: "' + $stateParams.deptName + '", doctorName:"' + $stateParams.doctorName + '", doctorLevel:"' + $stateParams.doctorLevel + '"}' });
                            }
                            else {
                                $state.go("app.addWish", { opid: data.data[index].ID, from: '"app.doctorInfo",{ doctorId: "' + $stateParams.doctorId + '", deptId: "' + $stateParams.deptId + '", doctorCode:"' + $stateParams.doctorCode + '", deptName: "' + $stateParams.deptName + '", doctorName:"' + $stateParams.doctorName + '", doctorLevel:"' + $stateParams.doctorLevel + '"}' });
                            }
                            //$state.go("app.opAppt", { opid: data.data[index].ID, from: 'app.doctorInfo' })
                        }
                    });
                }
            }
        } else {
            //alert("NO ID");
        }
        //            $state.go("app.opAppt", { opid: id });

    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'doctorInfo');

        if ($stateParams.doctorId == undefined || $stateParams.doctorId.toString() == "") {
            $ionicLoading.hide();
            $scope.doctorInfo = {
                doctor_name: $stateParams.doctorName,
                title: $stateParams.doctorLevel
            }
        } else {
            DoctorInfoService.doctorInfo($stateParams.doctorId).then(function (data) {
                $ionicLoading.hide();
                $scope.doctorInfo = data;
                if ($stateParams.doctorLevel.toString() != "") {
                    $scope.doctorInfo.title = $stateParams.doctorLevel;
                }
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
        }
        // 2017-4-24 16:08:17 医师代码不为空再获取 避免报错
        if ($stateParams.doctorCode != null && $stateParams.doctorCode.length > 0) {
            if (isOpAppt || $rootScope.opApptData.status) {
                OpApptService.getDoctorScheduling($stateParams.doctorCode).then(funcCBSScheduling_new, funcCBEScheduling_new);
            }
            else {
                DoctorInfoService.scheduling_new($stateParams.doctorCode).then(funcCBSScheduling_new, funcCBEScheduling_new);
            }
            function funcCBSScheduling_new(data) {
                $scope.scheduling = data;
                console.log(data);
            }
            function funcCBEScheduling_new(resp) {
                $ionicLoading.hide();
                //alert("加载失败,请检查网络");
            }
        }
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        //        setTimeout(function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'doctorInfo') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        //        }, 500);
    });
})