﻿angular.module('fwapp.controllers')

.controller('DonateBloodController', function ($scope, $rootScope, $state, $http, $window, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform, $timeout
, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, $fwCordovaToast, $ionicSlideBoxDelegate, DonateBloodService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义在线问诊/复诊诊疗滑块
    var slideBlood = $ionicSlideBoxDelegate.$getByHandle('slideBlood');
    // 服务状态
    $scope.isServerOn = false;
    // 初始滑块状态
    $scope.step = 0;
    // 定义model
    $scope.blood = {
        FIXEDWARD: "",
        PATIENT_NAME: "",
        IDCARD_CODE: "",
        TEL: "",
        DATE_APPLY: "",
        TIME_APPLY: "",
        AGREE: false,
        APPLY_ADDR: "",
        DONATE_BLOOD_ID: ""
    };
    // 配置项
    $scope.config = {};
    // 宣教显示项目
    $scope.prop = {
        title: "",
        content: "",
        submit: false
    };
    // 申请列表
    $scope.applyList = [];
    // 时段列表
    $scope.applyTimeList = [];
    // 首页配置图
    $scope.homePage = "";

    // #region 滑块相关
    // 滑到上一步
    $scope.lastSlide = function () {
        slideBlood.previous();
        $scope.step = slideBlood.currentIndex();
    }

    // 滑到下一步
    $scope.nextSlide = function () {
        slideBlood.next();
        $scope.step = slideBlood.currentIndex();
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        console.log("要去第" + index + "页");
        slideBlood.slide(index);
        $scope.step = slideBlood.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideBlood.currentIndex();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // #endregion

    // #region 模态框相关

    // 注册模态窗口：宣教相关
    $ionicModal.fromTemplateUrl('prop.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.propModal = modal;
    });

    // 模态框显示
    $scope.propShow = function () {
        $scope.propModal.show();
    }

    // 模态框隐藏
    $scope.propHide = function () {
        $scope.propModal.hide();
    }

    // #endregion

    // 0.展开文章列表
    $scope.showArticle = function (i) {
        // 取反
        $scope.config.articleList[i].openShow = !$scope.config.articleList[i].openShow;
        $ionicScrollDelegate.resize();
    }

    // 0.1获取文章详情
    $scope.getArticle = function (articleId) {
        // 重置变量
        $scope.prop.title = "";
        $scope.prop.content = "";
        $scope.prop.submit = false;

        // 循环取值
        for (var i = 0; i < $scope.config.articleList.length; i++) {
            for (var j = 0; j < $scope.config.articleList[i].articleList.length; j++) {
                if (articleId == $scope.config.articleList[i].articleList[j].ARTICLE_ID) {
                    $scope.prop.title = $scope.config.articleList[i].articleList[j].TITLE;
                    $scope.prop.content = $scope.config.articleList[i].articleList[j].CONTENT;
                }
            }
        }

        $scope.propShow();
    }

    // 1.立即登记
    $scope.register = function () {
        console.log("1.立即登记");
        // 重置变量
        $scope.blood = {
            FIXEDWARD: "",
            PATIENT_NAME: "",
            IDCARD_CODE: "",
            TEL: "",
            DATE_APPLY: "",
            TIME_APPLY: "",
            AGREE: false,
            APPLY_ADDR: "",
            DONATE_BLOOD_ID: ""
        };
        $scope.applyTimeList = [];
        if ($scope.config.applyDate.length == 0 || $scope.isServerOn == false) {
            $fwCordovaToast.showShortBottom("暂无可选择的审核时间，请下个工作日再试。");
            return;
        }
        $scope.toSlide(2);
    }

    // 1.1阅读承诺书
    $scope.pledgeShow = function () {
        $scope.prop.title = $scope.config.pledge.title;
        $scope.prop.content = $scope.config.pledge.content;
        $scope.prop.submit = true;
        $scope.propShow();
    }

    // 1.2勾选承诺书
    $scope.pledgeShowCheck = function () {
        if ($scope.blood.AGREE == true) {
            $scope.pledgeShow();
        }
    }

    // 1.3选择登记时间
    $scope.findTime = function () {
        // 先重置变量
        $scope.applyTimeList = [];
        $scope.blood.TIME_APPLY = "";

        // for循环
        for (var i = 0; i < $scope.config.applyDate.length; i++) {
            if ($scope.blood.DATE_APPLY == $scope.config.applyDate[i].date) {
                $scope.applyTimeList = $scope.config.applyDate[i].time;
            }
        }
        $ionicScrollDelegate.resize();
    }

    // 2.登记提交
    $scope.submitBlood = function () {
        console.log("1.登记提交");

        // 验证必填
        if ($scope.blood.FIXEDWARD == "" || $scope.blood.PATIENT_NAME == "" || $scope.blood.IDCARD_CODE == ""
            || $scope.blood.TEL == "" || $scope.blood.DATE_APPLY == "" || $scope.blood.TIME_APPLY == "") {

            $fwCordovaToast.showShortBottom("必填项不得为空，请完善后提交");
            return;
        }

        // 验证同意书是否勾选
        if ($scope.blood.AGREE == false) {
            $fwCordovaToast.showShortBottom("请阅读并同意献血承诺书");
            return;
        }

        // 走ajax提交
        $ionicLoading.show();
        DonateBloodService.submit($scope.blood.FIXEDWARD, $scope.blood.PATIENT_NAME, $scope.blood.IDCARD_CODE, $scope.blood.TEL, $scope.blood.DATE_APPLY, $scope.blood.TIME_APPLY, $scope.blood.DONATE_BLOOD_ID).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.blood.APPLY_ADDR = data.data.applyAddr;
                // 弹出献血前须知
                $scope.prop.title = $scope.config.matter.title;
                $scope.prop.content = $scope.config.matter.content;
                $scope.prop.submit = true;
                $scope.propShow();

                // 0.5秒后再弹出
                $timeout(function () {
                    $scope.toSlide(3);
                }, 500);
            }
        }, function (resp) {
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络'
            });
            $ionicLoading.hide();
        })
    }

    // 3.获取申请列表
    $scope.applyListShow = function () {
        $scope.applyList = [];
        $ionicLoading.show();
        DonateBloodService.getApplyList().then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.applyList = data.data.applyList;
                $scope.toSlide(4);
            }
        }, function (resp) {
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络'
            });
            $ionicLoading.hide();
        })
    }

    // 4.删除预约
    $scope.deleteApply = function (applyId) {
        // confirm
        $ionicPopup.confirm({
            title: "提示",
            template: "确认删除该条登记信息么？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                DonateBloodService.deleteApply(applyId).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom("删除失败" + data.msg);
                    }
                    else {
                        $scope.applyListShow();
                    }
                }, function (resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络'
                    });
                    $ionicLoading.hide();
                })
            }
        })
    }

    // 5.修改预约
    $scope.updateApply = function (i) {
        // 获取修改的值
        var obj = $scope.applyList[i];
        $scope.blood = {
            FIXEDWARD: obj.PATIENT_WARD,
            PATIENT_NAME: obj.PATIENT_NAME,
            IDCARD_CODE: obj.IDCARD_CODE,
            TEL: obj.PHONENUM,
            DATE_APPLY: obj.APPLY_DATE,
            AGREE: false,
            APPLY_ADDR: "",
            DONATE_BLOOD_ID: obj.DONATE_BLOOD_ID
        };

        // 先拿选择日期，再赋值
        $scope.findTime();
        // 延时赋值，我也不知道为什么。。。
        $timeout(function () {
            $scope.blood.TIME_APPLY = obj.APPLY_TIME;
        }, 1);
        $scope.toSlide(2);
    }

    // 重新计算高度
    $scope.resize = function () {
        $ionicScrollDelegate.resize();
    }

    // 返回
    $scope.goBack = function () {
        if ($scope.step == 0) {
            $state.go("app.home");
        }
        else if ($scope.step == 1) {
            $scope.toSlide(0);
        }
        else if ($scope.step == 2) {
            $scope.toSlide(0);
        }
        else if ($scope.step == 3) {
            $scope.toSlide(0);
        }
        else if ($scope.step == 4) {
            $scope.toSlide(0);
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideBlood.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'donateBlood');

        // 获取服务状态
        DonateBloodService.checkServerStatus().then(function (data) {
            if (data.result == 1) {
                $scope.isServerOn = true;
            }
        });

        // 获取配置项
        DonateBloodService.getConfig().then(function (result) {
            if (result.result == 1) {
                $scope.config = result.data;
            }
        });
    });

    // 页面退出
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'donateBlood') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})