angular.module('fwapp.controllers')

// 健康宣教
.controller('EduController', function ($scope, $rootScope, $state, EduService, $fwCordovaToast, $cordovaInAppBrowser
    , $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, $ionicLoading, $stateParams) {

    // 定义预约申请滑块
    var slideEduc = $ionicSlideBoxDelegate.$getByHandle('slideEduc');
    // 定义预约申请滚动条
    var scrollEduc = $ionicScrollDelegate.$getByHandle('scrollEduc');
    // 初始滑块状态
    $scope.step = 0;
    // 目录
    $scope.columnList = [];
    // 当前栏目id
    $scope.columnId = 0;
    // 文章列表
    $scope.articleList = [];
    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
    // 文章内容
    $scope.articleDetail = new Object();
    // 当前页
    $scope.pageNum = 1;
    // 每页数量
    $scope.pageSize = 20;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕，防止无内容闪现
    $scope.isLoadFinish = false;
    // 页面标题列表
    $scope.titleList = ["健康宣教", "", ""];
    // 简介列表
    $scope.articleEncyList = [];
    // 视频列表
    $scope.articleVideoList = [];
    // 视频页数
    $scope.videoPageRepeat = 0;
    // 搜索框
    $scope.article = {};
    $scope.article.articleSearch = "";
    // 滑到上一步
    $scope.lastSlide = function () {
        slideEduc.previous();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideEduc.next();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideEduc.slide(index);
    }
    // 滑块切换触发
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideEduc.currentIndex();
        // 回到栏目选择页#0 清空文章列表和内容
        if ($scope.step == 0) {
            $scope.pageNum = 1;
            $scope.articleList = [];
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.articleDetail = new Object();
            $scope.isLoadFinish = false;
        }
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        // 列表页滚到记录高度
        if ($scope.step == 1) {
            scrollEduc.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.articleDetail = new Object();
        }
        // 其他页滚到顶
        else {
            $ionicScrollDelegate.scrollTop();
        }
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择栏目）正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他页返回上一个滑块
        else {
            if ($scope.step == 1) {
                // 返回的时候清空
                $scope.article.articleSearch = "";
                //返回膳食营养随访
                if ($stateParams.columnId == '1008') {
                    $state.go("app.flupDRI", { vpId: $stateParams.vpId });
                    return;
                }
                // 2023-9-6 gx 返回心律失常随访
                if ($stateParams.columnId == '1004') {
                    $state.go("app.flupAF", { vpId: $stateParams.vpId });
                    return;
                }
                // 2022-8-8 19:19:18 hzg 返回冠心病随访
                if ($stateParams.vpId != '') {
                    $state.go("app.flupCHD", { vpId: $stateParams.vpId });
                    return;
                }
                if ($stateParams.columnId != '') {
                    $state.go("app.home");
                    return;
                }
            }
            $scope.lastSlide();
        }
    }
    // 获取目录
    $scope.loadIndex = function () {
        $ionicLoading.show();
        EduService.educ().then(function (data) {
            if (data.result == 1) {
                $ionicLoading.hide();
                $scope.columnList = data.data;

                // 如果有带来的columnid，直接往里跳
                if ($stateParams.columnId != '') {
                    for (var i = 0; i < data.data.length; i++) {
                        if ($stateParams.columnId == data.data[i].ColumnId) {
                            $scope.loadList(i);
                        }
                    }
                }
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 获取列表
    $scope.loadList = function (index, isSearch) {
        //$scope.isLoadFinish = false;
        // 从栏目列表来的
        // 2022-1-27 08:28:14 HM 华为应用市场拒审，原因为在js里 0 == ''，故这里如果是搜索，传-1
        if ('undefined' != typeof (index) && -1 != index) {
            $ionicLoading.show();
            // 当前栏目
            $scope.columnId = $scope.columnList[index].ColumnId;
            // 标题赋值
            $scope.titleList[1] = $scope.columnList[index].Name;
            $scope.titleList[2] = $scope.columnList[index].Name;
            // 跳转
            // $scope.nextSlide();
        }
        if (isSearch == 1) {
            $scope.pageNum = 1;
            $scope.pageSize = 10;
            $scope.articleList = [];
        }
        console.log($scope.article.articleSearch);
        EduService.educList($scope.columnId, $scope.article.articleSearch, $scope.pageNum, $scope.pageSize).then(function (data) {
            if (data.result == 1) {
                if ($scope.article.articleSearch == "") {
                    // 新获取的列表追加到文章列表后
                    for (var i = 0; i < data.data.page.length; i++) {
                        $scope.articleList.push(data.data.page[i]);
                    }
                    // 计算是否可继续加载
                    $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                    // 当前页数+1
                    $scope.pageNum++;
                    // 简介列表
                    $scope.articleEncyList = [];
                    for (var i = 0; i < data.data.pageEncy.length; i++) {
                        $scope.articleEncyList.push(data.data.pageEncy[i]);
                    }
                    // 视频列表
                    $scope.articleVideoList = [];
                    for (var i = 0; i < data.data.pageVideo.length; i++) {
                        $scope.articleVideoList.push(data.data.pageVideo[i]);
                    }
                    if ($scope.articleVideoList.length > 0) {
                        var arrPage = new Array(Math.ceil($scope.articleVideoList.length / 2));
                        for (var i = 0; i < arrPage.length; i++) {
                            arrPage[i] = i;
                        }
                        $scope.videoPageRepeat = arrPage;
                    }
                    if ('undefined' != typeof (index) && -1 != index) {
                        $scope.nextSlide();
                    }
                }
                else {
                    $scope.articleEncyList = [];
                    $scope.articleVideoList = [];
                    $scope.articleList = data.data.page;

                    $ionicScrollDelegate.resize();
                    $ionicScrollDelegate.scrollTop();
                }

                // 加载完毕
                $scope.isLoadFinish = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                //$ionicLoading.hide();
            }
            else {
                $scope.isLoadFinish = true;
                //$ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            }
            // 从栏目列表来的
            if ('undefined' != typeof (index) && -1 != index) {
                $ionicLoading.hide();
            }
        }, function (data) {
            $scope.isLoadFinish = true;
            //$ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            // 从栏目列表来的
            if ('undefined' != typeof (index) && -1 != index) {
                $ionicLoading.hide();
            }
        })
    }
    // 获取内容
    $scope.loadDetail = function (index, type) {
        var articleList = [];
        if (type == "Ency") {
            articleList = $scope.articleEncyList;
        }
        else if (type == "Video") {
            articleList = $scope.articleVideoList;
        }
        else {
            articleList = $scope.articleList;
        }

        // 2017-8-15 BST 处理外部链接
        if (articleList[index].ExternalLink != '') {
            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open(articleList[index].ExternalLink, '_system', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser(articleList[index].ExternalLink, '_system');
            return;
        }

        // 记录当前列表页滚动条位置
        $scope.scrollPosition = scrollEduc.getScrollPosition();
        $ionicLoading.show();
        // 跳转
        $scope.nextSlide();
        EduService.article(articleList[index].ArticleId).then(function (data) {
            if (data.result == 1) {
                $scope.articleDetail = data.data;
                // 重新计算滚动条高度
                setTimeout(function () { $ionicScrollDelegate.resize(); });
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore && $scope.step == 1 && $scope.article.articleSearch == "";
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideEduc.enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'Educ');
        // 获取栏目列表
        $scope.loadIndex();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'Educ') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
})
