﻿angular.module('fwapp.controllers')

// 快递支付
.controller('ExpressController', function ($scope, $rootScope, $state, $stateParams, $fwCordovaToast, $timeout
    , $ionicModal, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicSlideBoxDelegate
    , ExpressService, CasePrintService, OpPaymentService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 在线简易门诊申请ID
    $scope.applyId = $stateParams.applyId;
    // 定义立即支付滑块
    var slideExpress = $ionicSlideBoxDelegate.$getByHandle('slideExpress');
    // 立即支付滑块定义
    $scope.step = 0;
    // 快递相关
    $scope.express = {};
    // 是否存在收货地址
    $scope.express.isExist = false;
    // 收货人姓名
    $scope.express.RECEIVER_NAME = "";
    // 收货人手机号
    $scope.express.PHONENUM = "";
    // 重复输入手机号
    $scope.express.PHONENUM_REPEAT = "";
    // 收货人省
    $scope.express.PROVINCE = "";
    // 收货人县
    $scope.express.CITY = "";
    // 收货人市
    $scope.express.COUNTY = "";
    // 收货人详细地址
    $scope.express.DETAIL_ADDRESS = "";
    // 添加地址默认
    $scope.express.IS_DEFAULT = false;
    // 加载完成
    $scope.finishLoading = false;
    // 收货地址ID
    $scope.express.EXPRESS_ADDRESS_ID = "";
    // 省
    $scope.provinces = [];
    // 市
    $scope.citys = [];
    // 县
    $scope.countys = [];
    // 收货列表
    $scope.express.addressList = [];
    // 新增or更新, 1 = 新增，2 = 更新
    $scope.addressAU = 1;
    // 默认收货地址
    $scope.defaultExpressAddress = {};
    // 快递公司
    $scope.express.expressInfo = {};
    // 是否保价
    $scope.express.insured = 0;
    // 支付相关
    $scope.paymentInfo = {};
    // 药品列表
    $scope.recipeList = [];
    // 就诊人ID
    $scope.vpId = "";
    // 处方单数组
    $scope.feeItemsList = [];
    // 审核医师代码
    $scope.doctorCode = "";
    // 知情同意书
    $scope.informedConsent = {};
    // 知情同意书title
    $scope.informedConsent.title = "";
    // 知情同意书content
    $scope.informedConsent.content = "";
    // 知情同意书agree
    $scope.informedConsent.agree = false;
    // 是否医保患者
    $scope.miPatient = false;

    // 注册模态窗口 知情同意书
    $ionicModal.fromTemplateUrl('informedConsent.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.informedConsentModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.informedConsentModal.remove();
    })

    // 知情同意书显示
    $scope.informedConsentShow = function () {
        $scope.informedConsentModal.show();
    }

    // 知情同意书关闭
    $scope.informedConsentHide = function () {
        $scope.informedConsentModal.hide();
    }

    // 滑到下一步
    $scope.nextSlide = function () {
        slideExpress.next();
        $scope.step = slideExpress.currentIndex();
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideExpress.slide(index);
        $scope.step = slideExpress.currentIndex();
    }

    // 滑到上一步
    $scope.lastSlide = function () {
        slideExpress.previous();
        $scope.step = slideExpress.currentIndex();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideExpress.currentIndex();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 跳转添加收货地址页面
    $scope.toAddAddress = function () {
        // 初始化变量
        // 收货人姓名
        $scope.express.RECEIVER_NAME = "";
        // 收货人手机号
        $scope.express.PHONENUM = "";
        // 重复输入手机号
        $scope.express.PHONENUM_REPEAT = "";
        // 收货人省
        $scope.express.PROVINCE = "";
        // 收货人县
        $scope.express.CITY = "";
        // 收货人市
        $scope.express.COUNTY = "";
        // 收货人详细地址
        $scope.express.DETAIL_ADDRESS = "";
        // 添加地址默认
        $scope.express.IS_DEFAULT = false;
        // 收货地址ID
        $scope.express.EXPRESS_ADDRESS_ID = "";

        $scope.addressAU = 1;
        $scope.toSlide(2);
    }

    // 修改默认地址
    $scope.defaultAddress = function () {
        $scope.express.IS_DEFAULT = !$scope.express.IS_DEFAULT;
    }

    // 获取省
    $scope.getProvince = function () {
        CasePrintService.getProvince().then(function (result) {
            $scope.provinces = result.provinces;
        })
    }

    // 省市县：市
    $scope.getCity = function () {
        $scope.express.CITY = "";
        $scope.express.COUNTY = "";
        if ($scope.express.PROVINCE == "") {
            $scope.citys = [];
            $scope.countys = [];
        }
        else {
            CasePrintService.getCity($scope.express.PROVINCE).then(function (result) {
                $scope.citys = result.citys;

                // 重新计算高度
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();
            })
        }
    }

    // 省市县：县
    $scope.getCounty = function () {
        $scope.express.COUNTY = "";
        if ($scope.express.CITY == "") {
            $scope.countys = [];
        }
        else {
            CasePrintService.getCounty($scope.express.CITY).then(function (result) {
                $scope.countys = result.countys;

                // 无下级区县
                if ($scope.countys.length == 0) {
                    $scope.countys = [];
                    $scope.countys.push({ COUNTY: "无下级区/县" });
                    console.log($scope.countys);
                }

                // 重新计算高度
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();
            })
        }
    }

    // 添加收货地址
    $scope.addAddress = function () {
        var reg = /^1[3-9][0-9]{9}$/;

        if ($scope.express.RECEIVER_NAME == "") {
            $fwCordovaToast.showShortBottom("收货人姓名不能为空");
        }
        else if ($scope.express.PHONENUM == "") {
            $fwCordovaToast.showShortBottom("收货人手机号不能为空");
        }
        else if ($scope.express.PHONENUM_REPEAT == "") {
            $fwCordovaToast.showShortBottom("收货人手机号不能为空");
        }
        else if ($scope.express.PHONENUM != $scope.express.PHONENUM_REPEAT) {
            $fwCordovaToast.showShortBottom("两次输入的手机号不一致");
        }
        else if (!reg.test($scope.express.PHONENUM)) {
            $fwCordovaToast.showShortBottom("请填写正确手机号码");
        }
        else if ($scope.express.PROVINCE == "") {
            $fwCordovaToast.showShortBottom("请选择省份");
        }
        else if ($scope.express.CITY == "") {
            $fwCordovaToast.showShortBottom("请选择市");
        }
        else if ($scope.express.COUNTY == "") {
            $fwCordovaToast.showShortBottom("请选择县");
        }
        else if ($scope.express.DETAIL_ADDRESS == "") {
            $fwCordovaToast.showShortBottom("详细地址不能为空");
        }
        else {
            $ionicLoading.show();
            ExpressService.updateAddress($scope.express.RECEIVER_NAME, $scope.express.PHONENUM, $scope.express.PROVINCE, $scope.express.CITY
            , $scope.express.COUNTY, $scope.express.DETAIL_ADDRESS, $scope.express.IS_DEFAULT, $scope.express.EXPRESS_ADDRESS_ID, "0").then(function (data) {
                $ionicLoading.hide();
                if (data.result == 1) {
                    $fwCordovaToast.showShortBottom("维护成功");
                    $scope.express.isExist = true;
                    $scope.getAddressList();
                    $scope.toSlide(1);

                    // 2021-10-29 20:43:12 HM 修改快递信息，首页默认不会修改
                    if ($scope.express.IS_DEFAULT == true) {
                        $scope.defaultExpressAddress.PROVINCE = $scope.express.PROVINCE;
                        $scope.defaultExpressAddress.CITY = $scope.express.CITY;
                        $scope.defaultExpressAddress.COUNTY = $scope.express.COUNTY;
                        $scope.defaultExpressAddress.DETAIL_ADDRESS = $scope.express.DETAIL_ADDRESS;
                        $scope.defaultExpressAddress.RECEIVER_NAME = $scope.express.RECEIVER_NAME;
                        $scope.defaultExpressAddress.PHONENUM = $scope.express.PHONENUM;
                    }
                }
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function (err) {
                $fwCordovaToast.showShortBottom("维护收货地址，网络错误。");
            })
        }
    }

    // 删除收货地址
    $scope.deleteAddress = function () {
        $ionicLoading.show();
        ExpressService.updateAddress($scope.express.RECEIVER_NAME, $scope.express.PHONENUM, $scope.express.PROVINCE, $scope.express.CITY
        , $scope.express.COUNTY, $scope.express.DETAIL_ADDRESS, $scope.express.IS_DEFAULT, $scope.express.EXPRESS_ADDRESS_ID, "1").then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("维护成功");
                $scope.express.isExist = true;
                $scope.getAddressList();
                $scope.toSlide(1);
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (err) {
            $fwCordovaToast.showShortBottom("维护收货地址，网络错误。");
        })
    }

    // 获取收货地址列表
    $scope.getAddressList = function () {
        $ionicLoading.show();
        ExpressService.getAddressList().then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $scope.express.addressList = data.data;
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (err) {
            $fwCordovaToast.showShortBottom("获取收货地址列表，网络错误。");
        })
    }

    // 选择收货地址
    $scope.selectAddress = function () {
        $scope.getAddressList();
        $scope.toSlide(1);
    }

    // 选中收货地址
    $scope.clickAddress = function (index) {
        $scope.express.addressList[index].SELECTED = 1;
        // 赋值默认地址
        $scope.defaultExpressAddress.PROVINCE = $scope.express.addressList[index].PROVINCE;
        $scope.defaultExpressAddress.CITY = $scope.express.addressList[index].CITY;
        $scope.defaultExpressAddress.COUNTY = $scope.express.addressList[index].COUNTY;
        $scope.defaultExpressAddress.DETAIL_ADDRESS = $scope.express.addressList[index].DETAIL_ADDRESS;
        $scope.defaultExpressAddress.RECEIVER_NAME = $scope.express.addressList[index].RECEIVER_NAME;
        $scope.defaultExpressAddress.PHONENUM = $scope.express.addressList[index].PHONENUM;
        $scope.defaultExpressAddress.IS_DEFAULT = $scope.express.addressList[index].IS_DEFAULT;
        $scope.defaultExpressAddress.EXPRESS_ADDRESS_ID = $scope.express.addressList[index].EXPRESS_ADDRESS_ID;
        $scope.toSlide(0);
        // 首页加载完成
        $scope.finishLoading = true;
        $scope.getOpPending($scope.applyId);
    }

    // 更新收货地址
    $scope.updateAddress = function (index) {
        console.log($scope.express.addressList);
        // 复制变量
        // 收货人姓名
        $scope.express.RECEIVER_NAME = $scope.express.addressList[index].RECEIVER_NAME;
        // 收货人手机号
        $scope.express.PHONENUM = $scope.express.addressList[index].PHONENUM;
        // 重复输入手机号
        $scope.express.PHONENUM_REPEAT = "";
        // 收货人省
        $scope.express.PROVINCE = $scope.express.addressList[index].PROVINCE;
        // 收货人市，不知道什么原因= = 蜜汁问题吧，这里不初始化，三级联动第二次进入的时候不好用
        $scope.express.CITY = "";
        // 收货人县
        $scope.express.COUNTY = "";
        // 收货人详细地址
        $scope.express.DETAIL_ADDRESS = $scope.express.addressList[index].DETAIL_ADDRESS;
        // 添加地址默认
        $scope.express.IS_DEFAULT = $scope.express.addressList[index].IS_DEFAULT == 1 ? true : false;
        // 收货地址ID
        $scope.express.EXPRESS_ADDRESS_ID = $scope.express.addressList[index].EXPRESS_ADDRESS_ID;

        CasePrintService.getCity($scope.express.PROVINCE).then(function (result) {
            $scope.citys = result.citys;

            console.log($scope.express.addressList[index].CITY);
            CasePrintService.getCounty($scope.express.addressList[index].CITY).then(function (data) {
                $scope.countys = data.countys;
                // 无下级区县
                if ($scope.countys.length == 0) {
                    $scope.countys = [];
                    $scope.countys.push({ COUNTY: "无下级区/县" });
                    console.log($scope.countys);
                }

                $timeout(function () {
                    // 收货人市
                    $scope.express.CITY = $scope.express.addressList[index].CITY;
                    // 收货人县
                    $scope.express.COUNTY = $scope.express.addressList[index].COUNTY;
                }, 500);

                // 重新计算高度
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();

                $scope.addressAU = 2;
                $scope.toSlide(2);
            })
        })
    }

    // 获取待缴费列表
    $scope.getOpPending = function (applyId) {
        $ionicLoading.show();
        ExpressService.getOpPending(applyId).then(function (data) {
            $ionicLoading.hide();
            $scope.paymentInfo.req4001 = data.requestId;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $rootScope.goBack();
                return;
            }
            // 正常有结果
            $scope.paymentInfo.req4001 = data.requestId;
            $scope.paymentInfo.req4005 = "";

            // 药品列表
            $scope.repiceList = data.data;
            console.log($scope.repiceList);

            // 医师代码
            $scope.doctorCode = $scope.repiceList[0].DOCTOR_CODE;

            $scope.finishLoading = true;
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取缴费列表，网络错误。");
        })
    }

    // 格式化价格 至少两位小数 返回字符串
    $scope.formatFee = function (fee) {
        fee = BigNumber(fee).toNumber();
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于2位小数 补0
        if (indexPoint == -1 || lengthFee - indexPoint < 3) {
            feeShow = fee.toFixed(2);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 2024-4-22 14:27:16 wcx 和自助机接口计算规则统一 先显示4位小数
    $scope.formatFeeV2 = function (fee) {
        fee = BigNumber(fee).toNumber();
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于4位小数 补0
        if (indexPoint == -1 || lengthFee - indexPoint < 5) {
            feeShow = fee.toFixed(4);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 计算合计 拼待缴费项目代码
    $scope.calcTotalFee = function () {
        // 总金额
        var totalFee = 0;
        $scope.feeItemsList = [];
        var temp = [];

        // 2024-4-23 10:59:56 wcx 按处方号分组四舍五入计算金额
        var checkListNumGroup = new Set($scope.repiceList.map(e => e.CHECK_LIST_NUM));
        checkListNumGroup.forEach(checkListNum => {
            var group = {};
            group.FEE_ITME_LIST = $scope.repiceList.filter(e => e.CHECK_LIST_NUM == checkListNum);
            // 计算检查单费用合计(每单四舍五入保留两位小数)
            group.CHECK_LIST_FEE = 0;
            // 缴费项目代码
            group.CHARGE_ITEM_CODE = "";
            // 遍历检查单
            for (var i in group.FEE_ITME_LIST) {
                // 检查单费用合计
                //group.CHECK_LIST_FEE += group.FEE_ITME_LIST[i].TOTAL_PRICE * 10000;
                group.CHECK_LIST_FEE = $scope.numAdd(group.CHECK_LIST_FEE, group.FEE_ITME_LIST[i].TOTAL_PRICE);
                // 缴费项目代码拼接
                temp.push(group.FEE_ITME_LIST[i].CHARGE_ITEM_CODE);
            }
            // 每单四舍五入保留两位小数
            group.CHECK_LIST_FEE = $scope.roundFee(group.CHECK_LIST_FEE);
            // 计算总金额
            totalFee = $scope.numAdd(totalFee, group.CHECK_LIST_FEE);
        });

        //for (var i in $scope.repiceList) {
        //    // 改用bigNumber
        //    // totalFee += $scope.repiceList[i].TOTAL_PRICE;
        //    totalFee = $scope.numAdd(totalFee, $scope.repiceList[i].TOTAL_PRICE);
        //    temp.push($scope.repiceList[i].CHARGE_ITEM_CODE);
        //}

        for (var i = 0; i < temp.length; i++) {
            for (var j = i + 1; j < temp.length; j++) {
                if (temp[i] == temp[j]) {
                    temp.splice(j, 1);
                    j--;
                }
            }
        }

        $scope.feeItemsList = temp;
        return totalFee;
    }

    // 四舍五入
    $scope.roundFee = function (fee) {
        // 2020-11-3 10:21:14 HM 5厘钱问题，改用bigNumber计算，times乘法，div除法
        return BigNumber(Math.round(BigNumber(fee).times(100).toNumber())).div(100).toNumber();
        //return Math.round(fee * 100) / 100;
    }

    // 精确加法
    $scope.numAdd = function (num1, num2) {
        // 2018-9-10 13:17:22 改用BigNumber计算
        return BigNumber(num1).plus(num2).toNumber();
    }

    // 结算
    $scope.checkOrder = function () {
        $ionicLoading.show();
        var totalFeeCalc = $scope.roundFee($scope.calcTotalFee());

        var feeItem = "";
        for (var i = 0; i < $scope.feeItemsList.length; i++) {
            feeItem += "," + $scope.feeItemsList[i];
        }
        feeItem = feeItem.substr(1);

        // 核对金额 获取门诊预缴金余额
        OpPaymentService.opPaymentAmountCalc($scope.vpId, feeItem, $scope.formatFee(totalFeeCalc)).then(function (data) {
            $scope.paymentInfo.req4005 = data.requestId;
            $ionicLoading.hide();

            // 链接超时
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
            }
            // 调用失败
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 调用成功
            else if (data.result == 1) {
                // 数据异常
                if (data.is_null == 1 || data.data[0].TOTAL_FEE == "-1") {
                    if (data.msg != null && data.msg != '') {
                        $fwCordovaToast.showLongBottom(data.msg);
                    }
                    else {
                        $fwCordovaToast.showShortBottom("获取缴费信息失败");
                    }
                }
                // 查询成功
                else {
                    // 后台返回金额
                    var realFee = Number(data.data[0].TOTAL_FEE);
                    if (Number.isNaN(realFee)) {
                        $fwCordovaToast.showShortBottom("获取缴费信息失败");
                    }
                    // 金额错误
                    else if (realFee != totalFeeCalc) {
                        console.log("realFee" + realFee);
                        console.log("totalFeeCalc" + totalFeeCalc);
                        $fwCordovaToast.showShortBottom("获取缴费信息失败");
                    }
                    // 金额正确
                    else {
                        console.log("金额正确");
                        console.log(data);

                        var msFee = 0;
                        var msFeeCount = 0;

                        if (data.data != null && data.data.length > 0) {
                            for (var i in data.data) {
                                if (!Number.isNaN(Number(data.data[i].MEDICAL_SERVICE_FEE))) {
                                    msFee += Number(data.data[i].MEDICAL_SERVICE_FEE);
                                    // 加个不等于0的
                                    if (msFee != 0) {
                                        msFeeCount++;
                                    }
                                }
                            }
                        }

                        var money = $scope.numAdd(totalFeeCalc, Number(msFee));
                        console.log(money);
                        var balance = Number(data.data[0].BALANCE);

                        // 如果是医保患者
                        if ($scope.miPatient == true) {
                            // 如果补收医师服务费有问题，则不让他缴费

                            console.log("msFeeCount:" + msFeeCount);
                            if (msFeeCount > 0) {
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: '请前往门诊窗口进行缴费',
                                    okText: '确定'
                                });
                                return;
                            }

                            // 要验证互联互通
                            $ionicLoading.show();
                            OpPaymentService.checkRecipeWithoutRegistration($scope.vpId, feeItem, $scope.paymentInfo.req4001).then(function (checkRecipeData) {
                                $ionicLoading.hide();
                                if (checkRecipeData.result == 1) {

                                    $scope.submitExpress(money, balance, feeItem);
                                }
                                else {
                                    $ionicPopup.alert({
                                        title: '提示',
                                        template: '请前往门诊窗口进行缴费',
                                        okText: '确定'
                                    });
                                }
                            }, function () {
                                $ionicLoading.hide();
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: '请前往门诊窗口进行缴费',
                                    okText: '确定'
                                });
                            })
                        }
                        else {
                            if (msFeeCount > 0) {
                                var confirmPopup = $ionicPopup.confirm({
                                    title: '提示',
                                    template: "您有" + msFeeCount + "笔医事服务费需要补收，共" + msFee + "元，系统将自动收取",
                                    cancelText: '取消',
                                    okText: '确定'
                                }).then(function (res) {
                                    if (res) {
                                        $scope.submitExpress(money, balance, feeItem);
                                    }
                                })
                            }
                            else {
                                $scope.submitExpress(money, balance, feeItem);
                            }
                        }
                    }
                }
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    $scope.submitExpress = function (money, balance, feeItem) {
        $ionicLoading.show();
        ExpressService.submitExpress($scope.applyId, $scope.vpId, $scope.defaultExpressAddress.EXPRESS_ADDRESS_ID,
            $scope.express.expressInfo[0].company, money, $scope.express.expressInfo[0].method[0]).then(function (dataSubmit) {

            $ionicLoading.hide();
            if (dataSubmit.result == 1) {
                // 成功
                // 收银台
                $scope.cashier("olTreatExpress", money, $scope.vpId, $scope.applyId, balance, feeItem, $scope.doctorCode, $scope.miPatient).then(function (dataCashier) {
                    // 支付成功
                    if (dataCashier.code == 1) {
                        $fwCordovaToast.showShortBottom("支付成功");
                        $rootScope.goBack();
                    }
                })
            }
            else {
                // 2021-9-27 08:33:04 HM 有个患者，没看到提示，这里改成alert
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: dataSubmit.msg,
                    okText: '确定'
                });
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("插入快递信息错误");
        })
    }

    // 返回键
    $scope.goBack = function () {
        // 第0页返回到上一个模块
        if ($scope.step == 0) {
            $rootScope.goBack();
        }
        else {
            if ($scope.step == 2) {
                $scope.getAddressList();
            }
            $scope.lastSlide();
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideExpress.enableSlide(false);
    });

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        console.log($scope.applyId);
        $ionicLoading.show();
        // 页面进入读取相关配置
        ExpressService.getConfig($scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                // 快递信息
                $scope.express.expressInfo = data.data.expressInfo;
                // 是否保价
                $scope.express.insured = data.data.expressInsured;
                // 知情同意书标题
                $scope.informedConsent.title = data.data.informedConsentTitle;
                // 知情同意书内容
                $scope.informedConsent.content = data.data.informedConsentContent;
                // 是否为医保患者
                $scope.miPatient = data.data.MIPatient == 1;

                console.log("公司" + $scope.express.expressInfo[0].company);
                console.log("支付方式" + $scope.express.expressInfo[0].method[0]);

                $scope.vpId = data.data.vpId;

                if (data.data.expressAddress == undefined || data.data.expressAddress == null) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: '提示',
                        template: "您还没有收货地址，请点击前往设置。",
                        cancelText: '取消',
                        okText: '设置'
                    }).then(function (res) {
                        if (res) {
                            $scope.toAddAddress();
                        }
                        else {
                            $scope.finishLoading = true;
                        }
                    })
                }
                else {
                    $scope.express.isExist = true;
                    $scope.defaultExpressAddress = data.data.expressAddress;
                    $scope.getOpPending($scope.applyId);
                }
            }
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("页面进入，网络错误。");
        })

        // 先拿到省
        $scope.getProvince();

        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'express');
    });

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'express') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})