﻿angular.module('fwapp.controllers')

.controller('FeeItemController', function ($scope, $rootScope, $state, FeeItemService, AccountService, $fwCordovaToast
    , $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, $ionicLoading, $cordovaInAppBrowser) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 初始滑块状态
    $scope.step = 0;
    // 分类列表
    $scope.typeList = [];
    // 当前分类
    $scope.currentTypeIndex = 0;

    // 当前页
    $scope.pageNum = 1;
    // 每页数量
    $scope.pageSize = 20;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕，防止无内容闪现
    $scope.isLoadFinish = false; ;
    // 项目列表
    $scope.itemList = [];

    // 查询条件
    $scope.keyword = { text: '' };
    // 发改委收费项目查询URL
    $scope.urlsfxm = "";

    // 加载列表
    $scope.loadList = function (index) {
        if (index == undefined) {
            index = $scope.currentTypeIndex;
        }
        $scope.currentTypeIndex = index;
        if ($scope.typeList[$scope.currentTypeIndex].type == 'SFXM') {
            $scope.dmdwjbgs();
            return;
        }
        $ionicSlideBoxDelegate.$getByHandle('slideFeeItem').slide(1);
        console.log($scope.keyword.text);
        FeeItemService.List($scope.typeList[$scope.currentTypeIndex].type, $scope.keyword.text, $scope.pageNum).then(function (data) {
            if (data.result == -1) {
                // 未登录，转至登录页
                $state.go("login");
                //$fwCordovaToast.showShortBottom("请登录!");
                return;
            } else if (data.result == 0) {
                // 无在院患者
                $state.go("app.home");
                $fwCordovaToast.showShortBottom("未找到就诊人当前住院信息!");
                return;
            }

            if (data.result == 1) {
                for (var i = 0; i < data.data.page.length; i++) {
                    $scope.itemList.push(data.data.page[i]);
                }
                // 是否可继续加载
                $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                // 当前页数+1
                $scope.pageNum++;
                // 加载完毕
                $scope.isLoadFinish = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
            }
            else {
                $scope.isLoadFinish = true;
                //$ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            }
        }, function (data) {
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
        })
    }

    // 滑块切换触发
    $scope.slideChanged = function () {
        $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideFeeItem').currentIndex();
        if ($scope.step == 0) {
            $scope.itemList = [];
            $scope.pageNum = 1;
            $scope.isLoadFinish = false;
            $scope.keyword.text = "";
        }
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择栏目）正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他页返回上一个滑块
        else {
            $ionicSlideBoxDelegate.$getByHandle('slideFeeItem').slide(0);
        }
    }

    // 是否可继续加载
    $scope.moreDataCanBeLoaded = function () {
        return ($scope.isLoadFinish && $scope.canLoadMore && $scope.step == 1) || ($scope.isLoadFinish && $scope.canLoadMore && $scope.step == 2);
    }

    // 清除关键词
    $scope.clearKeyword = function () {
        $scope.keyword.text = "";
        $scope.keywordSearch();
    }

    // 关键词搜素
    $scope.keywordSearch = function () {
        $scope.itemList = [];
        $scope.pageNum = 1;
        $scope.isLoadFinish = false;
        $ionicScrollDelegate.resize();
        //$scope.keyword = { text: '' };
        //$scope.keyword.text = document.getElementById('SearchText').value;
        $scope.loadList();
    }

    // 2020-11-12 更新收费项目展示方式
    // 倒霉的物价办公室
    $scope.dmdwjbgs = function () {
        // 2021-1-21 09:44:12 张博要求正式上线
        if (true || devMode) {
            $ionicSlideBoxDelegate.$getByHandle('slideFeeItem').slide(2);
            FeeItemService.PriceItemList($scope.typeList[$scope.currentTypeIndex].type, $scope.keyword.text, $scope.pageNum).then(function (data) {
                if (data.result == -1) {
                    // 未登录，转至登录页
                    $state.go("login");
                    //$fwCordovaToast.showShortBottom("请登录!");
                    return;
                } else if (data.result == 0) {
                    // 无在院患者
                    $state.go("app.home");
                    $fwCordovaToast.showShortBottom("未找到就诊人当前住院信息!");
                    return;
                }

                if (data.result == 1) {
                    for (var i = 0; i < data.data.page.length; i++) {
                        $scope.itemList.push(data.data.page[i]);
                    }
                    // 是否可继续加载
                    $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                    // 当前页数+1
                    $scope.pageNum++;
                    // 加载完毕
                    $scope.isLoadFinish = true;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                else {
                    $scope.isLoadFinish = true;
                    //$ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
                }
            }, function (data) {
                $scope.isLoadFinish = true;
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            })
        }
        else {
            if ($scope.urlsfxm != '' && $scope.urlsfxm.length > 0) {
                //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                //$cordovaInAppBrowser.open($scope.urlsfxm, '_blank', option).then(function (event) { })
                //2023.7.31 新插件原有调用方式参数不生效
                showInAppBrowser($scope.urlsfxm, '_blank');
            }
            else {
                $fwCordovaToast.showShortBottom("北京发改委网站暂时不可用");
            }
        }
    }

    $scope.enterEvent = function (e) {
        var key = window.event ? e.keyCode : e.which;
        if (key == 13) {
            console.log("enter : " + $scope.keyword.text);
            $scope.keywordSearch();
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        $ionicSlideBoxDelegate.$getByHandle('slideFeeItem').enableSlide(false);

        FeeItemService.Url_SFXM().then(function (data) {
            $scope.urlsfxm = data;
        })

        AccountService.checkInHospital().then(function (data) {
            if (data.result == -1) {
                // 未登录，转至登录页
                $state.go("login");
                //$fwCordovaToast.showShortBottom("请登录!");
                return;
            } else if (data.result == 0) {
                // 无在院患者
                $state.go("app.home");
                $fwCordovaToast.showShortBottom("未找到就诊人当前住院信息!");
                return;
            }
            $scope.typeList = [
        { name: '收费项目', type: 'SFXM', icon: 'fwicon-sfxm' },
            //{ name: '医疗器械', type: 'YYCL', icon: 'fwicon-ylqx' },
        {name: '西药', type: 'MZYP', icon: 'fwicon-xy' },
        { name: '中草药', type: 'MZZY', icon: 'fwicon-zcy'}];
        });
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'feeItem');
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'feeItem') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
})