﻿angular.module('fwapp.controllers')

.controller('FlupController', function ($scope, $rootScope, $state, $timeout, FlupService,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet,
    $cordovaDatePicker, $fwCordovaToast) {

    // 初始滑块状态
    $scope.step = 0;

    // 随访列表
    $scope.subjectList = [];

    // 模板内容
    $scope.tmpl = new Object();
    // 模板信息
    $scope.tmplInfo = new Object();
    // 总题数
    $scope.qstnCount = 0;
    // 随访结果
    $scope.flupResult = new Object();
    // 当前随访ID
    $scope.currentSubject = new Object();

    // 当前显示删除图片列表ID
    $scope.delImgQstn = new Object();
    // 当前添加图片列表ID
    $scope.addImgQstn = new Object();
    // 图片服务器路径
    $scope.uploadUrl = uploadUrl;

    // 随访列表是否加载完毕
    $scope.isLoadFinish_Subject = false;
    // 随访表单是否加载完毕
    $scope.isLoadFinish_Tmpl = false;

    // 加载随访记录
    $scope.loadSubejctList = function () {
        $ionicLoading.show();
        FlupService.subjectList().then(function (data) {
            if (data.result == 1) {
                $scope.subjectList = data.data;
            }
            $scope.isLoadFinish_Subject = true;
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        })
    }

    // 显示模板信息
    $scope.showTmpl = function (tmplId, subjectId) {
        $ionicSlideBoxDelegate.$getByHandle('slideFlupList').slide(1);
        $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideFlupList').currentIndex();

        $scope.currentSubject = subjectId;
        $scope.loadTmpl(tmplId);
    }

    // 加载模板信息
    $scope.loadTmpl = function (tmplId) {
        $scope.isLoadFinish_Tmpl = false;
        $ionicLoading.show();

        $scope.tmpl = new Object();

        if ($scope.tmplInfo.display == "SLIDE") {
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
        }

        // 加载模板
        FlupService.items(tmplId).then(function (data) {
            $scope.tmpl = data.QSTN_LIST;
            $scope.tmplInfo.name = data.TMPL_NAME;
            $scope.tmplInfo.id = data.TMPL_ID;
            $scope.tmplInfo.display = data.TMPL_DISPLAY;
            $scope.qstnCount = $scope.tmpl.length;

            $scope.isLoadFinish_Tmpl = true;

            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();

            if ($scope.tmplInfo.display == "SLIDE") {
                $timeout(function () {
                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').enableSlide(false);

                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
                    $scope.cQstn = 0;

                    $ionicLoading.hide();
                }, 500);
            } else {
                $ionicLoading.hide();
            }
        })

        // 加载结果
        FlupService.loadRecord(tmplId, $scope.currentSubject).then(function (data) {
            $scope.flupResult = data;
        })
    }

    // 保存随访结果
    $scope.saveResult = function () {
        $ionicLoading.show();
        FlupService.saveRecord($scope.tmplInfo.id, $scope.currentSubject, $.param($scope.flupResult)).then(function (data) {
            if (data.result == 1) {
                if (data.nTmplId != '') {
                    $scope.loadTmpl(data.nTmplId);
                } else {
                    $fwCordovaToast.showShortBottom("随访填写完成！");

                    // 初始化题目信息（防止再次进入显示混乱）
                    $scope.tmpl = new Object();
                    $scope.tmplInfo = new Object();
                    $scope.qstnCount = 0;

                    $ionicSlideBoxDelegate.$getByHandle('slideFlupList').slide(0);
                    $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideFlupList').currentIndex();
                    $scope.loadSubejctList();
                }
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        });
    }

    //#region 每道题一个slide版本
    // 当前问题
    $scope.cQstn = 0;

    // 上一题
    $scope.preQstn = function () {
        // 调整问题slide
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').previous();
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();
        // 重计算scroll高度
        $ionicScrollDelegate.$getByHandle('scollFlup').resize();
        $ionicScrollDelegate.$getByHandle('scollFlup').scrollTop();
    }

    // 下一题
    $scope.nextQstn = function () {
        // 调整问题slide
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').next();
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();
        // 重计算scroll高度
        $ionicScrollDelegate.$getByHandle('scollFlup').resize();
        $ionicScrollDelegate.$getByHandle('scollFlup').scrollTop();
    }

    //#endregion

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他（第1页后退到列表页）
        else {
            // 初始化题目信息（防止再次进入显示混乱）
            $scope.tmpl = new Object();
            $scope.tmplInfo = new Object();
            $scope.qstnCount = 0;

            $ionicSlideBoxDelegate.$getByHandle('slideFlupList').slide(0);
            $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideFlupList').currentIndex();
            $scope.loadSubejctList();
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        $ionicSlideBoxDelegate.$getByHandle('slideFlupList').enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'flup');
        // 获取栏目列表
        $scope.loadSubejctList();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'flup') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })

    //#region 随访真伪控件
    // 随访重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('scollFlup').resize();
        }, 500);
    }

    // 随访伪单选按钮
    $scope.flupRadio = function (qstnId, dicValue) {
        $scope.flupResult[qstnId] = dicValue;
        $scope.scrollResize();
    }

    // 随访伪多选按钮
    $scope.flupCheckBox = function (qstnId, dicValue) {
        if ($scope.flupResult[qstnId] == null || $scope.flupResult[qstnId] == '') {
            $scope.flupResult[qstnId] = dicValue;
        }
        else {
            var value = $scope.flupResult[qstnId].split(',');
            if (value.indexOf(dicValue) == -1) {
                value.push(dicValue);
            } else {
                value.splice(value.indexOf(dicValue), 1);
            }
            var returnValue = '';
            for (var i = 0; i < value.length; i++) {
                returnValue += value[i] + ",";
            }
            if (returnValue.endsWith(',')) {
                returnValue = returnValue.substr(0, returnValue.length - 1);
            }
            $scope.flupResult[qstnId] = returnValue;
        }
        $scope.scrollResize();
    }

    // 随访真时间选择器
    $scope.flupDate = function (qstnId, type) {
        var defaultDate = new Date();

        if ($scope.flupResult[qstnId] != undefined && $scope.flupResult[qstnId] != null && $scope.flupResult[qstnId] != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                $scope.flupResult[qstnId] = $scope.flupResult[qstnId].replace(/-/g, "/");
            }
            defaultDate = new Date($scope.flupResult[qstnId]);
        }
        var options = {
            mode: 'date',  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            var resultDate = new Date(date);
            $scope.flupResult[qstnId] = resultDate.Format('yyyy-MM-dd');
            $scope.scrollResize();
        })
    }

    //#region 随访图片处理
    // 随访图片上传ActionSheet显示
    $scope.imgAddActionSheet = function (qstnId) {
        // 记录问题ID
        $scope.addImgQstn = qstnId;
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                $scope.addImgQstn = new Object();
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "Flup/" + $scope.currentSubject + "/" + $scope.addImgQstn }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/uploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();
            if (result.indexOf('上传失败') >= 0) {
                $fwCordovaToast.showShortBottom(result);
            } else {
                // 保存图片
                $scope.flupResult[$scope.addImgQstn] += ";" + result;
            }
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 图片删除显示
    $scope.showImgDelete = function (qstnId) {
        $scope.delImgQstn = qstnId;
    }

    // 图片删除隐藏
    $scope.cancelImgDelete = function () {
        $scope.delImgQstn = new Object(); 
    }

    // 图片删除
    $scope.imgDelete = function (qstnId, imgUrl) {
        console.log(imgUrl)
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                var clist = $scope.flupResult[qstnId].split(';');
                var nList = '';
                for (var i = 0; i < clist.length; i++) {
                    console.log(clist[i]);
                    if (clist[i] != imgUrl) {
                        nList += clist[i] + ';';
                    }
                }
                if (nList != '') {
                    nList = nList.substr(0, nList.length - 1);
                }
                $scope.flupResult[qstnId] = nList;
                console.log($scope.flupResult[qstnId]);
            }
            // 重新显示删除按钮
            $scope.showImgDelete(qstnId);
        });
    }
    //#endregion

    //#endregion
})