﻿angular.module('fwapp.controllers')

    .controller('flupDRIController', function ($scope, $rootScope, $state, $stateParams, $timeout,
        flupSrvyService, SrvyService, EduService, UploadImgService, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet,
        $ionicModal, $ionicPopover, $cordovaDatePicker, $fwCordovaToast, $cordovaInAppBrowser, $cordovaCamera, $cordovaFileTransfer, $cordovaImagePicker) {

        // 图片服务器路径
        $scope.imgServerUrl = uploadUrl;

        // 随访滑动
        $scope.step = 0;
        var slideFlupList = $ionicSlideBoxDelegate.$getByHandle('slideFlupList');

        $scope.Consent = new Object();
        $scope.Consent.agree = false;
        $scope.Consent.content = "";
        $scope.Consent.title = "";
        // 模态框里的须知
        $scope.statement = new Object();
        $scope.statement.content = "";
        $scope.statement.title = "";

        // 确认列表
        $scope.agreeList = [false, false];

        // 激活的随访患者index
        $scope.activeTask = 0;
        // 激活的患者的index
        $scope.patientIndex = 0;

        // 就诊人ID
        $scope.vpId = '';
        // 随访任务ID
        $scope.taskId = '';
        // 随访任务
        $scope.flupList = [];
        // 随访任务信息
        $scope.flupInfo = new Object();
        // 随访记录列表
        $scope.flupRecList = new Object();
        // 随访患者ID
        $scope.patientId = '';
        // 在线问诊医师列表
        $scope.doctorList = [];

        $scope.taskList = [];
        $scope.bttaskList = [];
        $scope.nobttaskList = [];
        $scope.nexttaskList = [];

        $scope.bttaskStatus = false;
        $scope.nobttaskStatus = false;

        $scope.taskInfo = new Object();
        // 模板内容
        $scope.tmpl = new Object();
        // 模板信息
        $scope.tmplInfo = new Object();
        // 总题数
        $scope.qstnCount = 0;
        // 问卷结果
        $scope.srvyResult = new Object();
        // 当前问卷ID
        $scope.currentRec = new Object();
        // 反馈列表(评价)
        $scope.fbResultList = new Object();
        // 反馈列表(评分)
        $scope.fbCalcList = new Object();
        // 反馈列表(图片)
        $scope.imgList = new Object();
        // 反馈TAB页
        $scope.feebbackTab = 0;
        // 问卷ID
        $scope.tmplId = '';
        // 问卷记录id
        $scope.recId = '';

        // 是否有未读消息
        $scope.hasUnread = true;
        // 消息列表
        $scope.messageList = [];
        // 当前页
        $scope.pageNum = 1;
        // 是否可继续加载
        $scope.canLoadMore = false;

        // 健康宣教文章列表
        $scope.articleList = new Object();

        // 拨打电话记录ID
        $scope.cdBatBotTaskId = "";

        // 图片列表
        $scope.ocrImageList = [];

        // 图片结果列表
        $scope.ocrResultList = [];

        // 管理计划
        $scope.flupCheckList = [];

        // 自费弹出模态框事件
        $scope.statementShow = function () {
            $scope.statement.title = $scope.Consent.title;
            $scope.statement.content = $scope.Consent.content;

            $scope.statementModal.show();
        }

        $scope.statementHide = function () {
            $scope.statementModal.hide();
            $ionicScrollDelegate.scrollTop();
        }

        // #region 模态框口
        // 注册模态窗口 免责声明
        $ionicModal.fromTemplateUrl('statement.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.statementModal = modal;
        });
        // 随访问卷
        $ionicModal.fromTemplateUrl('templates/srvyTmpl.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.srvyModal = modal;
        });
        // 建议反馈
        $ionicModal.fromTemplateUrl('templates/feedback.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.feedbackModal = modal;
        });
        // 出院注意事项
        $ionicModal.fromTemplateUrl('precaution.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.precautionModal = modal;
        });
        $scope.precautionModalShow = function () {
            $scope.precautionModal.show();
        }
        $scope.precautionModalHide = function () {
            $scope.precautionModal.hide();
        }
        // 销毁模态窗口
        $scope.$on('$destroy', function () {
            $scope.srvyModal.remove();
            $scope.feedbackModal.remove();
            $scope.precautionModal.remove();
        })
        // #endregion

        // #region 滑动方法
        // 滑到上一步
        $scope.lastSlide = function () {
            slideFlupList.previous();
            $scope.step = slideFlupList.currentIndex();
        }
        // 滑到下一步
        $scope.nextSlide = function () {
            slideFlupList.next();
            $scope.step = slideFlupList.currentIndex();
        }
        // 滑到指定页
        $scope.toSlide = function (index) {
            slideFlupList.slide(index);
            $scope.step = slideFlupList.currentIndex();
        }
        // 页面切换
        $scope.slideChanged = function () {
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();
        }
        // 随访患者slide切换
        $scope.patientSlideChanged = function () {
            var index = $ionicSlideBoxDelegate.$getByHandle('flupPatientList').currentIndex();
            $scope.calcSlideHeight(index);
            $scope.patientIndex = $ionicSlideBoxDelegate.$getByHandle('flupPatientList').currentIndex();
            $scope.flupInfo = $scope.flupList[index];
            $scope.taskList = $scope.flupList[index].taskList;
            $scope.bttaskList = $scope.flupList[index].bttaskList;
            $scope.nobttaskList = $scope.flupList[index].nobttaskList;
            $scope.bttaskStatus = false;
            $scope.nobttaskStatus = false;
            for (var i = 0; i < $scope.bttaskList.length; i++) {
                if ($scope.bttaskList[i].IsFlupTask == 1) {
                    $scope.bttaskStatus = true;
                    break;
                }
            }
            for (var i = 0; i < $scope.nobttaskList.length; i++) {
                if ($scope.nobttaskList[i].IsFlupTask == 1) {
                    $scope.nobttaskStatus = true;
                }
            }
            $scope.taskInfo = $scope.flupList[index].taskList[0];
            $scope.vpId = $scope.flupList[index].VISIT_PATIENT_ID; // APP患者ID
            $scope.patientId = $scope.flupList[index].PATIENT_ID; // 随访患者ID
            $scope.changeArticleList(); // 切换健康宣教
        }
        // #endregion

        // 日期展示统一为：yyyy年mm月dd日
        $scope.dateFormat = function (date) {
            var arr = [];
            if (date.length > 10) {
                date = date.substring(0, 10);
            }
            if (date.indexOf("-") > 0) {
                arr = date.split("-");
            }
            if (date.indexOf(".") > 0) {
                arr = date.split(".");
            }
            return parseFloat(arr[0]) + "年" + parseFloat(arr[1]) + "月" + parseFloat(arr[2]) + "日";
        }

        // 返回危急程度
        $scope.riskLevel = function (risk_level) {
            return risk_level == 1 ? "低危" : (risk_level == 2 ? "中危" : "高危");
        }

        // 管理计划-折叠展开
        $scope.set_collapse_expand = function (num) {
            console.log(num);
            if ($scope.flupCheckList[num].show == 1) {
                $scope.flupCheckList[num].show = 0;
            }
            else {
                $scope.flupCheckList[num].show = 1;
            }

            // 重新计算一下高度
            $ionicScrollDelegate.resize();
        }

        // 重新计算slide高度，防止slide空白
        $scope.calcSlideHeight = function (index) {
            $timeout(function () {
                if ($scope.flupList.length > 1) {
                    var dom = document.querySelectorAll('.flupPatientSlide .slider-slide')[index];
                    if (dom != undefined) {
                        var domHeight = dom.getBoundingClientRect().bottom - dom.getBoundingClientRect().top;
                        $scope.customHeight = {
                            'height': domHeight + 'px'
                        }
                    }
                }
                slideFlupList.update();
                $ionicScrollDelegate.resize();
                $ionicScrollDelegate.scrollTop();
            }, 100);
        }

        //#region 随访相关
        // 是否同意加入专病随访
        $scope.confirmAgree = function (PATIENT_ID, isJoinFlup) {
            flupSrvyService.DRIjoinFlup(PATIENT_ID, isJoinFlup).then(function (data) {
                if (data.result != 1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    for (var i = 0; i < $scope.flupList.length; i++) {
                        if ($scope.flupList[i].PATIENT_ID == PATIENT_ID) {
                            $scope.flupList[i].NOTICE = '';
                            $scope.calcSlideHeight(i);
                        }
                    }
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            });
            return true;
        }

        // 读取随访任务
        $scope.loadSrvyInfo = function () {
            $scope.flupList = [];
            $scope.isLoadFinish = false;
            $scope.cdBatBotTaskId = "";
            $scope.ocrImageList = [];
            $ionicLoading.show();
            flupSrvyService.getDRIFlupPatient($stateParams.vpId).then(function (data) {
                console.log("123");
                console.log(data);
                if (data.result != 1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    $scope.flupList = data.data;
                    if (data.data.length > 0) {
                        if ($stateParams.vpId != '') {
                            for (var i = 0; i < data.data.length; i++) {
                                if (data.data[i].PATIENT_ID == $scope.patientId) {
                                    $scope.activeTask = i;
                                }
                            }
                        }
                        // 展示随访患者信息
                        $scope.flupInfo = data.data[$scope.activeTask];
                        $scope.vpId = data.data[$scope.activeTask].VISIT_PATIENT_ID;
                        $scope.patientId = data.data[$scope.activeTask].PATIENT_ID;
                        // 语音电话ID
                        $scope.cdBatBotTaskId = data.data[$scope.activeTask].CD_BAT_BOT_ID;
                        console.log($scope.cdBatBotTaskId);
                        // 医师列表
                        $scope.doctorList = data.doctorList;
                        // 调查问卷
                        $scope.taskList = data.data[$scope.activeTask].taskList;
                        $scope.taskInfo = data.data[$scope.activeTask].taskList[0];
                        $scope.bttaskList = data.data[$scope.activeTask].bttaskList;
                        $scope.nobttaskList = data.data[$scope.activeTask].nobttaskList;
                        for (var i = 0; i < $scope.bttaskList.length; i++) {
                            if ($scope.bttaskList[i].IsFlupTask == 1) {
                                $scope.bttaskStatus = true;
                                break;
                            }
                        }
                        for (var i = 0; i < $scope.nobttaskList.length; i++) {
                            if ($scope.nobttaskList[i].IsFlupTask == 1) {
                                $scope.nobttaskStatus = true;
                            }
                        }
                        // 2020-6-1 13:43:30 HM 增加复诊续方知情同意书
                        $scope.Consent.content = data.data[$scope.activeTask].content;
                        $scope.Consent.title = data.data[$scope.activeTask].title;
                        // 健康宣教
                        $scope.articleList = data.articleList;
                        // 未读消息
                        $scope.hasUnread = data.data[$scope.activeTask].HAS_UNREAD == 'false' ? false : true;
                        // 更新页面
                        if (data.data.length > 1) {
                            $scope.calcSlideHeight($scope.activeTask);
                        }
                    }
                }
                $scope.isLoadFinish = true;
                $ionicLoading.hide();
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            });
        }

        // 进入随访记录
        $scope.flupRecord = function (PATIENT_ID, type) {
            $scope.isLoadFinish = false;
            $ionicLoading.show();
            flupSrvyService.getDRIFlupPatient($stateParams.vpId).then(function (data) {
                if (data.result != 1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    $scope.flupList = data.data;
                    if (data.data.length > 0) {
                        $scope.taskList = data.data[$scope.patientIndex].taskList;
                        $scope.bttaskList = data.data[$scope.patientIndex].bttaskList;
                        $scope.nobttaskList = data.data[$scope.patientIndex].nobttaskList;
                        $scope.taskInfo = data.data[$scope.patientIndex].taskList[0];
                        for (var i = 0; i < $scope.bttaskList.length; i++) {
                            if ($scope.bttaskList[i].IsFlupTask == 1) {
                                $scope.bttaskStatus = true;
                                break;
                            }
                        }
                        for (var i = 0; i < $scope.nobttaskList.length; i++) {
                            if ($scope.nobttaskList[i].IsFlupTask == 1) {
                                $scope.nobttaskStatus = true;
                            }
                        }
                        flupSrvyService.srvyRecordList(PATIENT_ID).then(function (data) {
                            if (data.result != 1) {
                                $fwCordovaToast.showShortBottom(data.msg);
                            } else {
                                $scope.flupRecList = data.data;
                            }
                            $scope.isLoadFinish = true;
                            $ionicLoading.hide();
                        }, function () {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
                        });
                    }
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            });

            if (type == 1) {
                $scope.toSlide(1);
            }
        }

        // 填写问卷
        $scope.showTmpl = function (tmplId, taskId, recId, type) {
            $scope.taskId = taskId;
            $scope.currentRec = recId;
            $scope.cdBatBotTaskId = "";
            for (var i = 0; i < $scope.flupList.length; i++) {
                if ($scope.patientId == $scope.flupList[i].PATIENT_ID) {
                    $scope.activeTask = i;
                }
            }
            $scope.ocrImageList = [];
            $scope.loadTmpl(tmplId, type);
        }

        // 加载模板信息
        $scope.loadTmpl = function (tmplId, type) {
            $scope.isLoadFinish_Tmpl = false;
            $ionicLoading.show();
            $scope.tmpl = new Object();
            $scope.srvyResult = new Object();
            if ($scope.tmplInfo.display == "SLIDE") {
                $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
            }
            // 加载模板
            SrvyService.items(tmplId).then(function (data) {
                $scope.tmpl = data.QSTN_LIST;
                $scope.tmplInfo.name = data.TMPL_NAME;
                $scope.tmplInfo.id = data.TMPL_ID;
                $scope.tmplInfo.display = data.TMPL_DISPLAY;
                $scope.qstnCount = $scope.tmpl.length;
                $scope.isLoadFinish_Tmpl = true;

                $ionicScrollDelegate.resize();
                $ionicScrollDelegate.scrollTop();
                if ($scope.tmplInfo.display == "SLIDE") {
                    $timeout(function () {
                        $scope.$broadcast('slideTmplList.init');
                        $ionicLoading.hide();
                    }, 300);
                } else {
                    $ionicLoading.hide();
                }
            })
            if (type == "1") {
                $scope.feedbackModal.hide();
            }

            $scope.srvyList = [];
            $scope.srvyModal.show();
        }

        // 隐藏问卷填写信息
        $scope.hideTmpl = function () {
            for (var i = 0; i < $scope.bttaskList.length; i++) {
                if ($scope.bttaskList[i].IsFlupTask == 1) {
                    $scope.bttaskStatus = true;
                    break;
                }
            }
            for (var i = 0; i < $scope.nobttaskList.length; i++) {
                if ($scope.nobttaskList[i].IsFlupTask == 1) {
                    $scope.nobttaskStatus = true;
                }
            }
            $scope.srvyModal.hide();
        }

        // 保存问卷结果
        $scope.saveResult = function () {
            if (JSON.stringify($scope.srvyResult) == "{}") {
                $ionicPopup.alert({
                    title: '提示',
                    template: '当前问卷所有问题均未填写，请检查',
                    okText: "确定"
                });
            }
            else {
                $ionicPopup.confirm({
                    title: '提交确认',
                    template: '请注意，问卷提交后不可修改！请您再次确认是否提交?',
                    cancelText: '取消',
                    okText: '确认'
                }).then(function (res) {
                    if (res) {
                        var url = "";
                        for (var i = 0; i < $scope.ocrImageList.length; i++) {
                            if ($scope.ocrImageList[i].status != -1) {
                                url += url + ";";
                            }
                        }
                        if (url != "") {
                            url = url.substr(0, url.length - 1);
                        }

                        $ionicLoading.show();
                        flupSrvyService.saveRecord($scope.tmplInfo.id, $scope.currentRec, $scope.vpId, $scope.taskId, $scope.patientId, $scope.srvyResult, url).then(function (data) {
                            if (data.result == 1) {
                                if (data.nTmplId != '') {
                                    $scope.loadTmpl(data.nTmplId);
                                } else {
                                    $scope.initTmpl();
                                    $scope.showFeedback(data.recId);
                                    if ($scope.taskId != '') {
                                        $scope.loadSrvyInfo();
                                    }
                                }
                            } else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                            $ionicLoading.hide();
                        });
                    }
                });
            }
        }

        // 初始化题目信息（防止再次进入显示混乱）
        $scope.initTmpl = function () {
            $fwCordovaToast.showShortBottom("问卷填写完成！");
            $scope.tmpl = new Object();
            $scope.tmplInfo = new Object();
            $scope.qstnCount = 0;
            $scope.tmplId = '';
            $scope.recId = '';
            $scope.hideTmpl();
        }

        // 显示反馈信息
        $scope.showFeedback = function (recId) {
            $scope.ocrResultList = [];

            $ionicLoading.show();
            flupSrvyService.getOcrImageResultList(recId).then(function (params) {
                if (params.result == 1) {
                    $scope.ocrResultList = params.data;
                    $scope.nexttaskList = [];
                    SrvyService.getFeedBack(recId).then(function (data) {
                        $scope.feebbackTab = 0;
                        $scope.srvyType = data.TMPL_ID;
                        $scope.tmplId = data.TMPL_ID;
                        $scope.fbResultList = data.FB_RESULT_LIST;
                        $scope.fbCalcList = data.FB_CALC_LIST;
                        $scope.imgList = data.IMGLIST;
                        $scope.fbResultCount = Object.getOwnPropertyNames($scope.fbResultList).length;
                        $scope.tmpl = data.QSTN_LIST;
                        $scope.srvyResult = data.REC_QSTN;
                        $scope.recId = recId;
                        for (var i = 0; i < $scope.bttaskList.length; i++) {
                            if ($scope.bttaskList[i].TMPL_ID == $scope.srvyType) {
                                $scope.bttaskList[i].IsFlupTask = "0";
                            }
                        }
                        $scope.bttaskStatus = false;
                        for (var i = 0; i < $scope.bttaskList.length; i++) {
                            if ($scope.bttaskList[i].IsFlupTask == 1) {
                                $scope.bttaskStatus = true;
                                break;
                            }
                        }
                        for (var i = 0; i < $scope.bttaskList.length; i++) {
                            if ($scope.bttaskList[i].IsFlupTask == "1") {
                                $scope.nexttaskList.push($scope.bttaskList[i]);
                            }
                        }

                        $scope.feedbackModal.show();
                        $ionicSlideBoxDelegate.$getByHandle('slideFeedback').enableSlide(false);
                        $scope.feedbackTabChange(0);
                        $ionicLoading.hide();
                    }, function () {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络连接异常，请重试");
                    });
                }
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络连接异常，请重试");
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            })
        }

        $scope.calcIsRisk = function () {
            for (var i = 0; i < $scope.flupRecList.length; i++) {
                if ($scope.recId == $scope.flupRecList[i].REC_ID) {
                    return $scope.flupRecList[i].RISK_LEVEL > 1;
                }
            }
            return false;
        }

        // 切换
        $scope.feedbackTabChange = function (index) {
            $scope.feebbackTab = index;
            $ionicSlideBoxDelegate.$getByHandle('slideFeedback').slide(index);
            $ionicSlideBoxDelegate.$getByHandle('slideFeedback').update();
            $ionicScrollDelegate.$getByHandle("scrollFeedback").resize();
            $ionicScrollDelegate.$getByHandle("scrollFeedback").scrollTop();
        }

        // 隐藏反馈信息
        $scope.hideFeedback = function () {
            $scope.feedbackModal.hide();
            $scope.tmpl = new Object();
            $scope.srvyResult = new Object();
            // 更新问卷记录列表
            $scope.flupRecord($scope.patientId, 1);
        }
        //#endregion


        // #region 健康记录 健康宣教
        // 健康记录跳转
        $scope.goHealth = function (HLTH_NAME) {
            var tileHrefSrvy = '';
            switch (HLTH_NAME) {
                case '':
                    $state.go("app.health", { vpid: $scope.vpId, from: "app.flupDRI" });
                    break;
                case '血压':
                case '心率':
                case '血糖':
                case '身高体重':
                case '特殊事件':
                    $state.go("app.health", { vpid: $scope.vpId, from: "app.flupDRI", titleName: HLTH_NAME });
                    break;
                case '饮食':
                    $state.go('app.diet', { vpid: $scope.vpId, from: "app.flupDRI" });
                    break;
                case '吸烟':
                    tileHrefSrvy = 'FAGERSTORM';
                case '运动':
                    tileHrefSrvy = 'IPAQ';
                case '睡眠':
                    tileHrefSrvy = 'PSQI';
                case '焦虑':
                    tileHrefSrvy = 'SAS';
                    $state.go('app.srvy', { vpid: $scope.vpId, type: tileHrefSrvy, from: "app.flupDRI" });
                    break;
                case '风险预测':
                    $state.go('app.cvdriskList', { vpId: $scope.vpId, from: "app.flupDRI" });
                    break;
            }
        }

        // 健康宣教跳转
        $scope.goEdu = function (columnId) {
            $state.go("app.edu", { columnId: columnId, vpId: $scope.vpId });
        }

        // 宣教文章切换
        $scope.changeArticleList = function () {
            flupSrvyService.getFlupEduContent($scope.flupInfo.FLUP_TYPE_ID, 5).then(function (data) {

            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            });
        }

        // 浏览文章
        $scope.loadDetail = function (index) {
            // 外链文章
            if ($scope.articleList[index].ExternalLink != '') {
                //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                //$cordovaInAppBrowser.open($scope.articleList[index].ExternalLink, '_system', option).then(function (event) { });
                //2023.7.31 新插件原有调用方式参数不生效
                showInAppBrowser($scope.articleList[index].ExternalLink, '_system');
                return;
            }
            // 请求文章详情
            $ionicLoading.show();
            EduService.article($scope.articleList[index].ArticleId).then(function (data) {
                if (data.result == 1) {
                    $scope.articleDetail = data.data;
                    $ionicScrollDelegate.resize();
                    $ionicScrollDelegate.scrollTop();
                    $ionicLoading.hide();
                }
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                }
            }, function (data) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            })
            $scope.toSlide(3);
        }
        //#endregion

        // 进入在线问诊
        $scope.goConsultation = function (doctorCode) {
            $state.go("app.consultation", { vpid: $scope.flupInfo.VISIT_PATIENT_ID, from: "app.flupDRI", doctorCode: doctorCode });
        }


        // 调用语音电话
        $scope.cdBatBotStart = function () {
            console.log("1111");

            $ionicLoading.show();
            flupSrvyService.cdBatBotStart($scope.vpId, $scope.patientId, $scope.tmplInfo.id, $scope.taskId).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: "确定"
                    });
                }
                else {
                    $scope.cdBatBotTaskId = data.taskId;

                    $ionicPopup.alert({
                        title: '提示',
                        template: "电话已呼出，请留意接听。电话挂断后，请点击刷新按钮，系统将自动带回结果",
                        okText: "确定"
                    });
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            })
        }

        // 获取语音电话结果
        $scope.cdBatBotResult = function () {
            if ($scope.cdBatBotTaskId == "") {
                $fwCordovaToast.showShortBottom("请点击语音上传按钮");
                return;
            }

            $ionicLoading.show();
            flupSrvyService.cdBatBotResult($scope.vpId, $scope.cdBatBotTaskId).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $ionicPopup.alert({
                        title: '提示',
                        template: "语音电话结果为空，请重新点击，或尝试手动录入",
                        okText: "确定"
                    });
                    $scope.cdBatBotTaskId = "";
                }
                else {
                    console.log(data.data);
                    $scope.srvyResult["CHD_Q02"] = data.data.highPressure;
                    $scope.srvyResult["CHD_Q03"] = data.data.heartRate;
                    $scope.srvyResult["CHD_Q04"] = data.data.hemorrHage;
                    $scope.srvyResult["CHD_Q05"] = data.data.chdDisease;
                    $scope.srvyResult["CHD_Q06"] = data.data.backToHospital;

                    if (data.data.bloodInStool != null) {
                        $scope.srvyResult["CHD_Q20"] = data.data.bloodInStool;
                    }
                    if (data.data.heartSymptom != null) {
                        $scope.srvyResult["CHD_Q21"] = data.data.heartSymptom;
                    }
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            })
        }

        // 图片上传
        $scope.imgAddActionSheetCHD = function () {
            // 显示ActionSheet
            $ionicActionSheet.show({
                titleText: '请选择上传图片方式',
                buttons: [
                    { text: '<i class="icon ion-camera"></i> 拍照上传' },
                    { text: '<i class="icon ion-image"></i>由相册选择' }
                ],
                cancelText: '取消',
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:     // 拍照上传
                            $scope.cameraImg();
                            return true;
                            break;
                        case 1:     // 由相册选择
                            $scope.selectImg();
                            return true;
                            break;
                    }
                }
            })
        }

        // 调用摄像头拍照
        $scope.cameraImg = function () {
            var options = {
                // 2023-4-11 14:55:27 CGZ 孟爱伟测试上传图片需6秒左右，尝试降低图片质量，提高上传速度
                //quality: 100,
                quality: 60,
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: false,
                encodingType: Camera.EncodingType.JPEG,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation: true
            };

            $cordovaCamera.getPicture(options).then(function (imageData) {
                console.log(imageData);
                var imageDataList = [];
                imageDataList[0] = imageData;
                $scope.uploadImg(imageDataList, "1");
            }, function (err) {

            });
        }

        // 由相册选择图片
        $scope.selectImg = function () {
            var options = {
                // 2023-4-11 14:55:27 CGZ 孟爱伟测试上传图片需6秒左右，尝试降低图片质量，提高上传速度
                //quality: 100,
                quality: 60,
                maximumImagesCount: 1,
                width: 0,
                height: 0
            };

            $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
                console.log(imageDataList.length);
                $scope.uploadImg(imageDataList, "2");
            }, function (err) {

            });
        }

        // 上传图片
        $scope.uploadImg = function (imageData, uploadType) {
            // 上传图片参数
            var options = new FileUploadOptions();
            options.fileKey = "fileAddPic";
            options.fileName = imageData[0].substr(imageData[0].lastIndexOf('/') + 1);
            options.mimeType = "text/plain";

            // 上传图片参数
            var params = { urlExt: "FLUP_SRVY/" + $scope.vpId + "/CHD_Q19" }
            options.params = params;

            // 上传图片路径
            var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");

            // 显示上传等待
            $ionicLoading.show({
                template: '图片上传中...'
            })

            // 上传图片
            $cordovaFileTransfer.upload(uri, imageData[0], options, true).then(function (result) { // 成功处理
                if (result.responseCode != "200") {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("图片上传失败，请重试！");
                }
                else {
                    // 图片上传的路径
                    var url = result.response;

                    // 保存数据
                    flupSrvyService.cdBatBotOCRInfo($scope.vpId, $scope.patientId, $scope.tmplInfo.id, $scope.taskId, uploadType, url).then(function (ocrData) {
                        if (ocrData.result == 0) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(data.msg);
                            return;
                        }
                        else {
                            UploadImgService.imgAdd("CHD", ocrData.flupTaskId, '', url, '').then(function (data) {
                                $ionicLoading.hide();
                                if (data.result == 0) {
                                    $fwCordovaToast.showShortBottom(data.msg);
                                    return;
                                }
                                else {
                                    var img = {};
                                    img.url = url;
                                    // 删除图片状态
                                    img.delStatus = 0;

                                    // 图片质量合格
                                    if (ocrData.quality == "1") {
                                        var qualityFlug = false;
                                        if (ocrData.data.HGB != null) {
                                            $scope.srvyResult["CHD_Q07"] = parseFloat(ocrData.data.HGB);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.LDL_C != null) {
                                            $scope.srvyResult["CHD_Q08"] = parseFloat(ocrData.data.LDL_C);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.GLU != null) {
                                            $scope.srvyResult["CHD_Q09"] = parseFloat(ocrData.data.GLU);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.CREA != null) {
                                            $scope.srvyResult["CHD_Q10"] = parseFloat(ocrData.data.CREA);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.ALT != null) {
                                            $scope.srvyResult["CHD_Q11"] = parseFloat(ocrData.data.ALT);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.AST != null) {
                                            $scope.srvyResult["CHD_Q12"] = parseFloat(ocrData.data.AST);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.CK != null) {
                                            $scope.srvyResult["CHD_Q13"] = parseFloat(ocrData.data.CK);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.CKMB != null) {
                                            $scope.srvyResult["CHD_Q14"] = parseFloat(ocrData.data.CKMB);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.HBA1C != null) {
                                            $scope.srvyResult["CHD_Q15"] = parseFloat(ocrData.data.HBA1C);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.HR != null) {
                                            $scope.srvyResult["CHD_Q16"] = parseFloat(ocrData.data.HR);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.EF != null) {
                                            $scope.srvyResult["CHD_Q17"] = parseFloat(ocrData.data.EF);
                                            qualityFlug = true;
                                        }
                                        if (ocrData.data.LVEDD != null) {
                                            $scope.srvyResult["CHD_Q18"] = parseFloat(ocrData.data.LVEDD);
                                            qualityFlug = true;
                                        }

                                        // 没识别出来
                                        if (qualityFlug == false) {
                                            img.status = 0;
                                        }
                                        // 识别出来了
                                        else {
                                            img.status = 1;
                                        }
                                    }
                                    // 图片质量不合格
                                    else {
                                        img.status = 2;
                                    }

                                    $scope.ocrImageList.push(img);
                                }
                            });
                        }
                    }, function () {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络连接异常，请重试");
                    })
                }
            }, function (error) {   // 错误处理
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("上传失败，错误：" + JSON.stringify(error) + "。请重试");
            })
        }

        // 展示删除按钮
        $scope.showImgDeleteOCR = function (url) {
            for (var i = 0; i < $scope.ocrImageList.length; i++) {
                if ($scope.ocrImageList[i].url == url) {
                    $scope.ocrImageList[i].delStatus = 1;
                }
            }
        }

        // 隐藏删除按钮
        $scope.hideImgDeleteOCR = function () {
            for (var i = 0; i < $scope.ocrImageList.length; i++) {
                $scope.ocrImageList[i].delStatus = 0;
            }
        }

        // 删除按钮
        $scope.imgDeleteOCR = function (url) {
            $ionicPopup.confirm({
                title: '提示',
                template: '是否要删除该图像',
                cancelText: '取消',
                okText: '确认'
            }).then(function (res) {
                if (res) {
                    var delete_index = -1;
                    for (var i = 0; i < $scope.ocrImageList.length; i++) {
                        if ($scope.ocrImageList[i].url == url) {
                            delete_index = i;
                        }
                    }
                    if (delete_index > -1) {
                        // 2023-1-17 17:56:36 HM 删除数组下标，不需要赋值
                        $scope.ocrImageList.splice(delete_index, 1);
                    }
                }
            });
        }


        // 初始化
        $scope.$on('$ionicView.loaded', function () {
            // 加载随访任务
            $scope.loadSrvyInfo();
        })

        // 后退
        $scope.goBack = function () {
            if ($scope.step > 0) {
                $scope.toSlide(0);
                for (var i = 0; i < $scope.flupList.length; i++) {
                    if ($scope.patientId == $scope.flupList[i].PATIENT_ID) {
                        $scope.activeTask = i;
                    }
                }
            } else {
                $state.go('app.home');
            }
        }

        // 页面进入
        $scope.$on('$ionicView.enter', function () {
            // 绑定返回键
            $ionicPlatform.registerBackButtonAction(function (e) {
                $scope.goBack();
                e.preventDefault();
                return false;
            }, 135, 'flupDRI');
        })

        // dom准备就绪 禁用滑动
        ionic.DomUtil.ready(function () {
            slideFlupList.enableSlide(false);
        })

        // 页面退出，解除后退绑定
        $scope.$on('$ionicView.beforeLeave', function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'flupDRI') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        })
    });