﻿angular.module('fwapp.controllers')

.controller('FlupINRController', function ($scope, $rootScope, $state, $stateParams, $q, $timeout, $sce, $window,
    $ionicPopup, $ionicPopover, $ionicModal, $ionicLoading, $fwCordovaToast, $cordovaToast, $ionicPlatform,
    $ionicActionSheet, $ionicSlideBoxDelegate, $ionicScrollDelegate, $cordovaDatePicker, $cordovaImagePicker, $cordovaCamera, $cordovaFileTransfer,
    FlupINRService, VisitPatientService, InstructionService) {

    $scope.dev = true;

    // 检查登录状态
    $rootScope.checkLogin();
    // 定义Slide控制
    var slideFlupINR = $ionicSlideBoxDelegate.$getByHandle('slideFlupINR');

    // 就诊人列表
    $scope.vpList = new Object();
    // 当前选择的就诊人
    $scope.vpInfo = new Object();
    // 当前选择的就诊人pid
    $scope.patientId = "";

    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;

    $scope.inrPatient = false;

    // 记录名称 => INR COMPLICATION DRUG
    $scope.recordType = "";
    // 记录显示形式 默认卡片
    $scope.asCard = true;


    // chart相关
    // 是否以chart表现
    $scope.asChart = true;
    // 类型
    $scope.chartType = "day";
    // 今天
    $scope.today = new Date().Format("yyyy-MM-dd");
    // chart模型
    $scope.chart = { date: null, INR: null, COMPLICATION: null, WARFARIN: null }


    // 是否在设置时间
    $scope.isSetTime = null;
    // 是否在回顾信息
    $scope.isHistory = null;
    // 是否在修改信息
    $scope.isModify = null;

    // 是否今日INR => 是否可以咨询
    $scope.isSeekAdvice = false;
    // 是否最新INR
    $scope.isLatestINR = false;
    // 是否有新消息
    $scope.hasNewMessage = false;
    // 此药物是否三天内INR
    $scope.isThirdINR = false;

    // 此药物提交是否INR提交之后关联的
    // false 半片判断
    // true  上次华法林剂量判断
    $scope.drugSubmitAfterINR = false;


    // Slide计数相关
    // 本步
    $scope.step = 0;
    // 上步
    $scope.lastStep = 0;
    // 上步名称
    $scope.lastName = "";
    // 标题
    $scope.name = "华法林抗凝管理";


    // 文章相关
    $scope.columns = new Object();
    $scope.articleStatus = 0;
    $scope.articleTitle = "";
    $scope.articleContent = "";


    // 问卷相关
    // 是否开始长篇问卷
    $scope.isBeginLongQuestion = false;
    // 长篇问卷模型(标识radio、标识是否进入下一题、标识完成的外链id)
    $scope.longQuestion =
    {
        INR: null, finishINR: 0, idINR: '',
        complication: null, finishComplication: 0, idComplication: '',
        drug: null, finishDrug: 0, idDrug: '',
        life: null, finishLife: 0, idLife: '',
        diet: null,
        weight: null
    };

    // 草
    $scope.lq_drugList = [];
    $scope.lq_inrList = [];
    $scope.lq_complicationList = [];


    // 药物列表是否打开
    $scope.isDrugListOpen = false;
    // 回顾列表是否打开
    $scope.isHistoryListOpen = false;
    // 检索内 曾用药是否打开
    $scope.isPastDrugOpen = false;
    // 检索内 心血管用药是否打开
    $scope.isCVDOpen = false;
    // 是否消息打开
    $scope.isMessageOpen = false;

    // 单个药物 用药时间列表
    $scope.timePointList = [];
    // 单个药物 用药时间
    $scope.timeNew = new Object();
    // 要删除的药物id
    $scope.delImgId = "";


    // 图片相关
    // INR图片
    $scope.INRImgResult = [];
    // 并发症图片
    $scope.complicationImgResult = [];
    // 药物图片
    $scope.drugImgResult = [];
    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;

    // 药物字典
    $scope.medList = [];
    // 药物检索
    $scope.searchList = [];

    // 调药助手文本
    $scope.drugHelp =
      "出院后，可通过抽血化验(凝血功能)，测出国际标准化比值(INR)，根据化验结果(INR值)，调整华法林(每片3mg)用量，使INR值维持在1.8-2.5之间。<br/>"
    + "i.当INR值在1.8-2.5之间时，说明先前服用的药物剂量可能是合适的，则继续维持先前华法林剂量，服用2天后再查INR值；<br>"
    + "ii.当INR值<1.8时，说明先前每天服用的抗凝药物剂量不够，应在先前剂量的基础上增加0.5-0.75mg(1/6-1/4片)(常为1/4片)，服用2天后再查INR值；<br>"
    + "iii.当INR>2.5但<3.0时，说明先前每天服用的抗凝药物剂量可能稍多，应在先前剂量的基础上减少0.5-0.75mg(1/6-1/4片)(常为1/4片），服用2天后再查INR值；<br>"
    + "iv.当INR>3.0或很接近3.0时，说明先前每天服用的抗凝药物剂量过高，当日停用“华法林”，第二天到医院化验INR值(如果仍高于3.0则继续停用)，<br>"
    + "直到INR值<2.5时，再在先前剂量的基础上减少0.5-0.75mg(1/6-1/4片)(常为1/4片)，服用2天后再查INR值。";

    // 留言板array
    $scope.msg = [];

    // 曾用药
    $scope.DrugsOfPast = [];
    // 心血管文本
    $scope.DrugsOfCVD = ["辛伐他丁", "阿司匹林", "波生坦", "替米沙坦", "普罗帕酮"];


    // 个人信息相关
    $scope.operaType = "";

    // 以下是模型们
    // 1.INR模型
    $scope.INR = {
        INR_PATIENT_ID: '',
        PATIENT_NAME: '',
        HIS_CARD_NUM: '',
        ACCOUNT_ID: '',
        INR_RECORD_ID: '',
        INR_DATE: '',
        INR_VALUE: ''
    };

    // 2.并发症模型
    $scope.complication = {
        INR_COMPLICATION_RECORD_ID: '',
        INR_PATIENT_ID: '',
        PATIENT_NAME: '',
        HIS_CARD_NUM: '',
        ACCOUNT_ID: '',
        COMPLICATION_DATE: '',
        COMPLICATION_TYPE: '请选择',
        COMPLICATION_LEVEL: '请选择',
        COMPLICATION_EVENT: '请选择',
        COMPLICATION_DESC: '',
        COMPLICATION_IS_CURE: 0
    };

    $scope.complication_to_str = { 1: '轻微出血', 2: '严重出血', 3: '血栓栓塞', 4: '其他' };
    $scope.complication_to_num = { 轻微出血: 1, 严重出血: 2, 血栓栓塞: 3, 其他: 4 };

    // 3.药物模型
    $scope.drug = {
        FLUP_DRUG_PERSENT_ID: '',
        INR_PATIENT_ID: '',
        PATIENT_NAME: '',
        HIS_CARD_NUM: '',
        CREATED_ID: '',
        MODIFIED_ID: '',
        DRUG_DATE: '',
        DRUG_CATEGORY: '其他类',
        DRUG_NAME: '',
        DRUG_ORIGIN: '',
        DRUG_QUANTITY: '',
        DRUG_TYPE: '请选择',
        DRUG_TYPE_DESC: '',
        DRUG_UNIT: '',
        DRUG_SLICE_QUANTITY: '',
        DRUG_DAILY_QUANTITY: '',
        DRUG_SINGLE_QUANTITY: '',
        DRUG_DOUBLE_QUANTITY: '',
        DRUG_EACH_QUANTITY: '',
        DRUG_EFFECT: 0,
        DATE_FINISHED: ''
    };

    $scope.drug_to_str = { 1: '每日', 2: '单双日', 3: '一日一次', 4: '一日两次', 5: '一日三次', 6: '其他' };
    $scope.drug_to_num = { 每日: 1, 单双日: 2, 一日一次: 3, 一日两次: 4, 一日三次: 5, 其他: 6 };

    // 4.删除
    // 5.删除

    // 6.删除

    // 7.药物检索模型
    $scope.searchName = { value: '' };

    // 8.个人信息模型
    $scope.self =
    {
        HAS_OPERATION: false,
        OPERATION_TYPE: '',
        OPERATION_NAME: '',
        AFIB: false,
        HIGH_BP: false,
        DIABETES: false,
        HEART: false,
        BLOOD_FAT: false,
        BLOOD_DISEASE: false,
        OTHER: ''
    };

    // 8.1 是否完善个人信息
    $scope.finishSelf = false;

    // 9.Radio模型(个人信息用)
    $scope.radios = [{ key: '是', value: true }, { key: '否', value: false}];

    // 10.药物影响模型 (footer用)
    $scope.effects =
    {
        1: { color: "orangered", text: "高度可能增强", risk: '出血' },
        2: { color: "orange", text: "有可能增强", risk: '出血' },
        3: { color: "yellow", text: "可能增强", risk: '出血' },
        4: { color: "dodgerblue", text: "高度可能减弱", risk: '血栓栓塞' },
        5: { color: "cadetblue", text: "有可能减弱", risk: '血栓栓塞' },
        6: { color: "lightblue", text: "可能减弱", risk: '血栓栓塞' }
    };

    // 11.问题模型(留言用)
    $scope.ask = { content: '' };

    // 12.生活信息模型
    $scope.LIFE =
    {
        PATIENT_ID: '',
        HIS_CARD_NUM: '',
        PATIENT_NAME: '',
        ACCOUNT_ID: '',
        DIET_CHANGED: '',
        WEIGHT_CHANGED: ''
    };

    //注册模态窗口
    // 1.INR
    $ionicModal.fromTemplateUrl('INR.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.INRModal = modal;
    });
    // 2.并发症
    $ionicModal.fromTemplateUrl('complication.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.complicationModal = modal;
    });
    // 3.药物
    $ionicModal.fromTemplateUrl('drug.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.drugModal = modal;
    });
    // 4.添加时间
    $ionicModal.fromTemplateUrl('time.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.timeModal = modal;
    });
    // 5.药物检索
    $ionicModal.fromTemplateUrl('searchDrug.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.searchDrugModal = modal;
    });
    // 6.删除
    // 7.消息助手
    $ionicModal.fromTemplateUrl('messageHelper.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.messageHelperModal = modal;
    });


    // 8.导航/帮助
    $ionicModal.fromTemplateUrl('helpColumn.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.helpColumnHelp = modal;
    });
    // 8.5 半高 导航/帮助
    $ionicModal.fromTemplateUrl('help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.HelpModal = modal;
    });

    // 9.其他model开帮助
    $scope.HelpColumnShow = function () {
        $scope.HelpColumnModal.show();
    }
    $scope.HelpColumnHide = function () {
        $scope.HelpColumnModal.hide();
    }


    //模态窗口的显示/隐藏
    // 1.INR
    $scope.INRShow = function () {
        $scope.INRModal.show();
    }
    $scope.INRHide = function () {
        // 是否回顾置空
        $scope.isHistory = null;
        // 是否咨询置空
        $scope.isSeekAdvice = false;

        // INR图片置空
        $scope.INRImgResult = [];
        // INR模型置空
        $scope.INR = {
            INR_PATIENT_ID: '',
            PATIENT_NAME: '',
            HIS_CARD_NUM: '',
            ACCOUNT_ID: '',
            INR_RECORD_ID: '',
            INR_DATE: '',
            INR_VALUE: ''
        };

        // 在长篇问卷
        if ($scope.isBeginLongQuestion) {
            // 提交后 点的后退
            if ($scope.longQuestion.finishINR == 1) { }
            // 看了看 点的后退
            else {
                $scope.longQuestion.INR = false;
                $scope.longQuestion.finishINR = 1;
            }
        }

        $scope.INRModal.hide();
    }

    // 2.并发症
    $scope.complicationShow = function () {
        $scope.complicationModal.show();
    }
    $scope.complicationHide = function () {
        // 按键是否显示置空
        $scope.isHistory = null;
        // 并发症图片置空
        $scope.complicationImgResult = [];
        // 并发症模型置空
        $scope.complication = {
            INR_COMPLICATION_RECORD_ID: '',
            INR_PATIENT_ID: '',
            PATIENT_NAME: '',
            HIS_CARD_NUM: '',
            ACCOUNT_ID: '',
            COMPLICATION_DATE: '',
            COMPLICATION_TYPE: '请选择',
            COMPLICATION_LEVEL: '请选择',
            COMPLICATION_EVENT: '请选择',
            COMPLICATION_DESC: '',
            COMPLICATION_IS_CURE: 0
        };

        // 在长篇问卷
        if ($scope.isBeginLongQuestion) {
            // 提交后 点的后退
            if ($scope.longQuestion.finishComplication == 1) { }
            // 看了看 点的后退
            else {
                $scope.longQuestion.complication = false;
                $scope.longQuestion.finishComplication = 1;
            }
        }

        $scope.complicationModal.hide();
    }

    // 3.药物
    $scope.drugShow = function () {
        $scope.drugModal.show();
    }
    $scope.drugHide = function () {
        // 标题
        if ($scope.isModify) {
            $scope.name = "现用药物调整"
        }
        else {
            $scope.name = "抗凝随访管理"
        }

        // 是否是回顾置空
        $scope.isHistory = null;
        // 是否是修改置空
        $scope.isModify = null;

        // 药物图片置空
        $scope.drugImgResult = [];
        // 药物模型置空
        $scope.drug = {
            FLUP_DRUG_PERSENT_ID: '',
            INR_PATIENT_ID: '',
            PATIENT_NAME: '',
            HIS_CARD_NUM: '',
            CREATED_ID: '',
            MODIFIED_ID: '',
            DRUG_DATE: '',
            DRUG_CATEGORY: '其他类',
            DRUG_NAME: '',
            DRUG_ORIGIN: '',
            DRUG_QUANTITY: '',
            DRUG_TYPE: '请选择',
            DRUG_UNIT: '请选择',
            DRUG_SLICE_QUANTITY: '',
            DRUG_DAILY_QUANTITY: '',
            DRUG_SINGLE_QUANTITY: '',
            DRUG_DOUBLE_QUANTITY: '',
            DRUG_EACH_QUANTITY: '',
            DRUG_EFFECT: 0,
            DATE_FINISHED: ''
        };


        // 在长篇问卷
        if ($scope.isBeginLongQuestion) {
            // 提交后 点的后退
            if ($scope.longQuestion.finishDrug == 1) { }
            // 看了看 点的后退
            else {
                $scope.longQuestion.drug = false;
                $scope.longQuestion.finishDrug = 1;
            }
        }

        $scope.drugModal.hide();
    }

    // 4.添加时间
    $scope.timeShow = function (drug) {
        $scope.timeNew = new Object();
        // 默认当前时间
        $scope.timeNew.time = (new Date()).Format("hh:mm");
        // 现有用药 => $scope.timePointList
        $scope.timePointList = [
            { time: drug.TIME_1, dosage: drug.QUANTITY_1 },
            { time: drug.TIME_2, dosage: drug.QUANTITY_2 },
            { time: drug.TIME_3, dosage: drug.QUANTITY_3 }
        ]
        // 去除null
        for (var i = 0; i < $scope.timePointList.length; i++) {
            if ($scope.timePointList[i].time == null || $scope.timePointList[i].dosage == null) {
                $scope.timePointList.splice(i, 1);
                i--;
            }
        }
        $scope.timeModal.show();
    }
    $scope.timeHide = function () {
        $scope.drug = null;
        $scope.timeModal.hide();
    }

    // 5.药物检索
    $scope.searchDrugShow = function () {
        // 检索曾用药
        FlupINRService.getLastDrug($scope.patientId).then(function (result) {
            if (result.result == 0) { }
            else {
                $scope.DrugsOfPast = result.data;
            }
        })
        $scope.searchDrugModal.show();
    }
    $scope.searchDrugHide = function () {
        // 检索栏清空
        $scope.searchName.value = "";
        // 检索列表清空
        $scope.searchList = [];
        $scope.searchDrugModal.hide();
    }

    // 6.调药助手(modal改alert)
    $scope.drugHelperShow = function () {
        $ionicPopup.alert({
            title: "调药助手",
            template: $scope.drugHelp,
            okText: '我知道了'
        })
    }

    // 7.消息助手
    $scope.messageHelperShow = function () {
        $scope.getContent();
        $scope.messageHelperModal.show();
    }
    $scope.messageHelperHide = function () {
        $scope.checkMessage();
        $scope.msg = [];
        $scope.messageHelperModal.hide();
    }
    // 8.删除
    // 9. 半高 导航/帮助
    $scope.helpShow = function () {
        $scope.HelpModal.show();
    }
    $scope.helpHide = function () {
        // 文章置空
        $scope.articleStatus = 0;
        $scope.articleTitle = "";
        $scope.articleContent = "";

        $scope.HelpModal.hide();
    }

    // 填充就诊人列表
    $scope.loadVpList = function () {
        $ionicLoading.show();
        VisitPatientService.visitPatientList().then(function (data) {
            if (data.result == 1) {
                if (data.data.length == 0) {
                    $fwCordovaToast.showLongBottom("未找到绑定的就诊人信息");
                    $state.go("app.personal");
                    return;
                }
                else {
                    $scope.vpList = data.data;
                    if ($scope.inVpid != null && $scope.inVpid != "") {
                        var index = 0;
                        for (var i in $scope.vpList) {
                            if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.inVpid) {
                                index = i;
                            }
                        }
                        $scope.checkPatient($scope.vpList[index]);
                    }
                }
            }
            else {
                $fwCordovaToast.showLongBottom(data.msg);
                $state.go("app.dealWithCard", { go: "inr" });
            }
        })
    }

    // 跳转
    // slide = 0
    // 1.首页
    $scope.goPage = function (patientId) {
        getINRInfo(patientId);
        INRchart(patientId);
        $scope.checkMessage();

        // 保存当前step
        $scope.lastStep = $scope.step;
        $scope.lastName = $scope.name;

        // 调整页面大小
        $scope.slideChanged();
    }

    // slide = 1
    // 1.点击INR提交
    $scope.goINR = function () {
        $scope.isHistory = false;
        $scope.isSeekAdvice = false;
        $scope.INRShow();
    }
    // 2.点击并发症提交
    $scope.goComplication = function () {
        $scope.isHistory = false;
        $scope.complicationShow();
    }

    // 3.点击药物调整
    $scope.drugListOpen = function () {
        $scope.isDrugListOpen = !$scope.isDrugListOpen;
        $ionicScrollDelegate.resize();
    }
    // 3.1.点击 添加新药物
    $scope.goDrug = function () {
        // 非回顾
        $scope.isHistory = false;
        $scope.drugShow();
    }
    // 3.2.点击调整现有药物
    $scope.goModifyPersentDrug = function () {
        // 标题
        $scope.name = "现用药物调整";
        $scope.isSetTime = false;
        $scope.getDrugPersent();
        $scope.step = 1;
        slideFlupINR.slide($scope.step);
    }

    // 4.点击回顾信息 
    $scope.historyListOpen = function () {
        $scope.isHistoryListOpen = !$scope.isHistoryListOpen;
        $ionicScrollDelegate.resize();
    }
    // 4.1-3 点击INR回顾 并发症回顾 药物回顾
    $scope.goHistory = function (recordType) {
        // 回顾
        $scope.getRecordList(recordType);

        // 并发症统计
        if (recordType == "COMPLICATION") {
            getComplicationInfo($scope.patientId);
        }
        getRecordName(recordType);

        $scope.step = 2;
        slideFlupINR.slide($scope.step);
    }
    // 4.4 点击个人信息回顾
    $scope.goSelf = function () {
        // 标题
        $scope.name = "个人信息";
        $scope.getSelf();
        $scope.step = 6;
        slideFlupINR.slide($scope.step);
    }

    // 5.点击设置药物提醒时间
    $scope.goSetTime = function () {
        // 标题
        $scope.name = "药物提醒";
        $scope.isSetTime = true;
        $scope.getDrugPersent();
        $scope.step = 1;
        slideFlupINR.slide($scope.step);
    }
    // 6.点击健康宣教


    // 7.1-2 药物检索内的二级菜单
    $scope.upPastDrug = function () {
        $scope.isPastDrugOpen = !$scope.isPastDrugOpen;
        $ionicScrollDelegate.resize();
    }

    $scope.upCVDDrug = function () {
        $scope.isCVDOpen = !$scope.isCVDOpen;
        $ionicScrollDelegate.resize();
    }

    // slide = 2
    // 1.INR 回顾 => 单INR
    $scope.historyGoINR = function (INR) {
        $scope.INR = INR;
        $scope.getImage($scope.INR.INR_RECORD_ID, "INR");
        $scope.isHistory = true;

        $scope.INRShow();
    }
    // 2.并发症 回顾 => 单并发症
    $scope.historyGoComplication = function (complication) {
        $scope.complication = complication;
        // 之前上传的图片
        $scope.getImage($scope.complication.INR_COMPLICATION_RECORD_ID, "COMPLICATION");
        // 是回顾
        $scope.isHistory = true;
        $scope.complicationShow();
    }
    // 3.药物 回顾 => 单药物
    $scope.historyGoDrug = function (drug) {
        $scope.drug = drug;
        $scope.getImage($scope.drug.FLUP_DRUG_PERSENT_ID, "DRUG");
        $scope.isHistory = true;
        $scope.drugShow();
    }
    // 4.调整 现有药物 => 单药物
    $scope.goModifyDrug = function (drug) {
        $scope.drug = drug;
        // 标题
        $scope.name = "药物调整-" + drug.DRUG_NAME;
        // 获取图片
        $scope.getImage($scope.drug.FLUP_DRUG_PERSENT_ID, "DRUG");
        // 非回顾
        $scope.isHistory = false;
        // 是修改
        $scope.isModify = true;
        $scope.drugShow();
    }
    // 5.添加药物提醒时间点(一个时间点)
    $scope.goAddTimePoint = function (drug) {
        if (drug.QUANTITY_3 != null && drug.TIME_3 != null) {
            $fwCordovaToast.showLongBottom("暂可设置3个用药提醒点");
            return;
        }
        $scope.drug = drug;
        $scope.timeShow(drug);
    }

    // slide = 3
    // 6.帮助
    $scope.goHelp = function () {
        // 保存当前step
        $scope.lastStep = $scope.step;
        $scope.lastName = $scope.name;

        // 标题
        $scope.name = "导航/帮助";

        var text = { 0: "", 1: "", 2: "drug_modify", 3: "history", 4: "", 5: "drug_stop", 6: "message", 7: "self_info", 8: "long_question" };
        getColumns(text[$scope.lastStep]);

        // 至第4页
        $scope.step = 3;
        slideFlupINR.slide($scope.step);
        // 调整页面大小
        $scope.slideChanged();

        console.log($ionicScrollDelegate.getScrollPosition().top.toFixed(0));
    }

    // slide = 4
    // 7.停用药物
    $scope.goStopDrug = function (drug) {
        $scope.drug = drug;
        // 标题
        $scope.name = "药物停用-" + drug.DRUG_NAME;
        // 至第5页
        $scope.step = 4;
        slideFlupINR.slide($scope.step);
        // 调整页面大小
        $scope.slideChanged();
    }

    // slide = 5
    // 8.消息tab页
    $scope.goMessage = function () {
        // 对话内容
        $scope.getContent();
        // 标题
        $scope.name = "历史咨询";
        // 至第6页
        $scope.step = 5;
        slideFlupINR.slide($scope.step);
        // 调整页面大小
        $scope.slideChanged();
    }

    // slide = 7
    // 9.个人消息页

    // slide = 8
    // 10.长篇问卷
    $scope.goLongQuestion = function () {
        $scope.isBeginLongQuestion = true;
        $scope.step = 7;
        slideFlupINR.slide($scope.step);
    }

    // 特殊 其他MODAL开帮助
    $scope.goHelpByModal = function (key) {
        getColumns(key);
        $scope.HelpColumnShow();
    }

    // 方法
    // 1.获取现有药物
    $scope.getDrugPersent = function () {
        FlupINRService.getDrugPersent($scope.patientId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                if (result.list.length != 0) {
                    for (var i in result.list) {
                        // 药物类别处理一下
                        result.list[i].DRUG_CATEGORY = result.list[i].DRUG_CATEGORY == 1 ? "华法林类" : "其他类";
                        // 用药模式处理一下
                        result.list[i].DRUG_TYPE = $scope.drug_to_str[result.list[i].DRUG_TYPE];
                    }
                    $scope.drugRecord = result.list;
                    $scope.slideChanged();
                }
                else {
                    $scope.drugRecord = null;
                }
            }
        })
    }

    // 2.获取回顾列表
    $scope.getRecordList = function (recordType) {
        $scope.recordType = recordType;
        FlupINRService.getRecord(recordType, $scope.patientId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                switch (recordType) {
                    case 'INR':
                        {
                            if (result.list.length == 0) {
                                $scope.INRRecord = null;
                            }
                            else {
                                // INR水平类型增多了 sql里删除了case when 改成前端判断 
                                for (var i in result.list) {
                                    var str = "";
                                    switch (result.list[i].INR_LEVEL) {
                                        case -1: str = "偏低"; break;
                                        case 0: str = "控制良好"; break;
                                        case 1: str = "偏高"; break;
                                        case 9: str = "控制稳定"; break;
                                    }
                                    result.list[i].INR_LEVEL = str;
                                }
                                $scope.INRRecord = result.list;
                            }
                            break;
                        }
                    case 'COMPLICATION':
                        {
                            if (result.list.length == 0) {
                                $scope.complicationRecord = null;
                            }
                            else {
                                $scope.complicationRecord = result.list;
                            }
                            break;
                        }
                    case 'DRUG':
                        {
                            if (result.list.length == 0) {
                                $scope.drugRecord = null;
                                console.log($scope.drugRecord);
                            }
                            else {
                                for (var i in result.list) {
                                    // 药物类别处理一下
                                    result.list[i].DRUG_CATEGORY = result.list[i].DRUG_CATEGORY == 1 ? "华法林类" : "其他类";
                                    // 用药模式处理一下
                                    result.list[i].DRUG_TYPE = $scope.drug_to_str[result.list[i].DRUG_TYPE];
                                }
                                $scope.drugRecord = result.list;
                            }
                            break;
                        }
                }

                $scope.slideChanged();
            }
        })
    }

    // 3.已删除

    // 4.查询产地
    $scope.findOrigin = function (name) {
        for (i in $scope.medList) {
            var medName = $scope.medList[i].NAME + "(" + $scope.medList[i].MANUFACTURER + ")";
            if (medName == name) {
                $scope.drug.DRUG_ORIGIN = $scope.medList[i].MANUFACTURER;
                break;
            }
        }
    }

    //5.计算总剂量
    $scope.calcDrugQuantity = function (drug) {

        if (drug.DRUG_UNIT == "请选择") {
            $fwCordovaToast.showLongBottom("未能计算药物周剂量，请选择药物单位");
            $scope.drug.DRUG_QUANTITY = "";
            return;
        }

        // 置0
        drug.DRUG_QUANTITY = 0;

        // 每日 =>总
        if (drug.DRUG_TYPE == "每日") {
            drug.DRUG_QUANTITY = drug.DRUG_DAILY_QUANTITY * 7;

            if (drug.DRUG_UNIT == "片") {
                // 又莫得填写每片mg
                if (drug.DRUG_SLICE_QUANTITY == null || drug.DRUG_SLICE_QUANTITY == "") {
                    $fwCordovaToast.showLongBottom("未能计算药物周剂量，请填写每片剂量");
                    $scope.drug.DRUG_QUANTITY = "";
                    return;
                }
                else {
                    drug.DRUG_QUANTITY *= drug.DRUG_SLICE_QUANTITY;
                }
            }
        }
        // 单双日 =>总
        else if (drug.DRUG_TYPE == "单双日") {
            if (drug.DRUG_SINGLE_QUANTITY == null || drug.DRUG_SINGLE_QUANTITY == "") { }
            else {
                drug.DRUG_QUANTITY += drug.DRUG_SINGLE_QUANTITY * 4;
            }
            if (drug.DRUG_DOUBLE_QUANTITY == null || drug.DRUG_DOUBLE_QUANTITY == "") { }
            else {
                drug.DRUG_QUANTITY += drug.DRUG_DOUBLE_QUANTITY * 3;
            }

            if (drug.DRUG_UNIT == "片") {
                // 又莫得填写每片mg
                if (drug.DRUG_SLICE_QUANTITY == null || drug.DRUG_SLICE_QUANTITY == "") {
                    $fwCordovaToast.showLongBottom("未能计算药物周剂量，请填写每片剂量");
                    $scope.drug.DRUG_QUANTITY = "";
                    return;
                }
                else {
                    drug.DRUG_QUANTITY *= drug.DRUG_SLICE_QUANTITY;
                }
            }
        }
        // 神奇的情况
        else { }
        // 最终结果赋值
        $scope.drug.DRUG_QUANTITY = drug.DRUG_QUANTITY;
    }

    // 6.1.INR提交前检查(空值、负值、过大值)
    $scope.CheckINR = function () {
        if ($scope.INR.INR_VALUE == "") {
            $fwCordovaToast.showLongBottom("请填写INR数值");
            return;
        }
        if ($scope.INR.INR_DATE == "") {
            $fwCordovaToast.showLongBottom("请填写INR时间");
            return;
        }
        if ($scope.INR.INR_VALUE <= 0) {
            $fwCordovaToast.showLongBottom("INR数值不正确");
            return;
        }
        if ($scope.INR.INR_VALUE >= 10) {
            $ionicPopup.confirm({
                title: 'INR数值过高',
                template: '您提交的INR数值过高，请注意填写是否正确，是否提交?',
                okText: '确认',
                cancelText: '取消'
            }).then(function (res) {
                if (res) {
                    $scope.CheckSameDayINR();
                }
                else { }
            });
        }
        else {
            $scope.CheckSameDayINR();
        }
    }

    // 6.2.INR提交前检查(是否同天数据)
    $scope.CheckSameDayINR = function () {
        $ionicLoading.show();
        $scope.INR.INR_PATIENT_ID = $scope.patientId;
        $scope.INR.PATIENT_NAME = $scope.vpInfo.VISIT_PATIENT_NAME;
        $scope.INR.HIS_CARD_NUM = $scope.vpInfo.HIS_CARD_NUM;
        $scope.INR.ACCOUNT_ID = $scope.vpInfo.ACCOUNT_ID;

        FlupINRService.checkINR($scope.INR).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else if (result.result == -1) {
                var template = "存在同天INR记录";
                template += "(";
                template += "INR检测时间：" + result.date;
                template += " INR数值：" + result.value;
                template += ")";
                template += "，是否覆盖原记录？";

                $ionicPopup.confirm({
                    title: '同天数据',
                    template: template,
                    okText: '覆盖',
                    cancelText: '取消'
                }).then(function (res) {
                    if (res) {
                        $scope.submitINR();
                    }
                    else { }
                });
            }
            // 同天数据 => 无
            else {
                $scope.submitINR();
            }
        })
    }

    // 6.3.INR提交
    $scope.submitINR = function () {
        $ionicLoading.show();

        FlupINRService.submitINR($scope.INR).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {

                // !处理下时间
                if (currentPlatform == "iOS") {
                    result.INR.INR_DATE = result.INR.INR_DATE.replace(/-/g, "/");
                }

                $scope.INR = result.INR;

                // 如果当前在长问卷
                if ($scope.isBeginLongQuestion) {
                    $scope.longQuestion.finishINR = 1;
                    $scope.longQuestion.idINR = result.recordId;

                    $scope.lq_inrList.push({ id: result.recordId, result: $scope.INR });
                }

                // 是否今日INR
                $scope.isSeekAdvice = result.isTodayINR;
                // 最新INR
                $scope.isLatestINR = result.isLatestINR;
                // 三天INR
                $scope.isThirdINR = result.isThirdINR;

                // 重新画chart
                INRchart($scope.patientId);
                // 重新统计INR整体信息
                getINRInfo($scope.patientId);
                // 重新加载INR回顾列表
                $scope.getRecordList('INR');

                // 是最近且三天
                if (result.isLatestINR && result.isThirdINR) {
                    // 获取上一条华法林
                    FlupINRService.getPerDrugInfo($scope.patientId, $scope.INR.INR_DATE).then(function (result) {
                        // 没上一条华法林 =>显示
                        if (result.data.length == 0) {
                            $scope.isHistory = true;
                        }
                        else {
                            // 是否改变华法林用量
                            $ionicPopup.confirm({
                                title: "药物修改",
                                template: "此次INR提交前后，是否修改了华法林用量?",
                                cancelText: '未修改',
                                okText: '是的，修改'
                            }).then(function (res) {
                                if (res) {
                                    // 是否关联INR
                                    $scope.drugSubmitAfterINR = true;

                                    // INR隐藏 
                                    $scope.INRModal.hide();

                                    // INR提交日期前 最近的 在用的华法林相关数值 赋值给drug
                                    $scope.drug = result.data[0];

                                    // 处理一下时间
                                    var date = result.data[0].DRUG_DATE;
                                    if (currentPlatform == "iOS") {
                                        date = date.replace(/-/g, "/");
                                    }

                                    $scope.drug.DRUG_DATE = (new Date(date)).Format("yyyy-MM-dd");
                                    $scope.drug.DRUG_CATEGORY = '华法林类';

                                    // 药物出现
                                    $scope.drugShow();
                                }
                            });
                        }

                        dealWithINR(result.isLatestINR);
                    });
                }
                else {
                    $scope.isHistory = true;
                    dealWithINR(result.isLatestINR);
                }

                $fwCordovaToast.showLongBottom("INR填报提交成功！");

                // 默默提交INR图片
                $scope.SaveImg(result.recordId, "INR");
            }
        })
    }

    // 7.1.并发症提交前检查
    $scope.checkComplication = function () {
        if ($scope.complication.COMPLICATION_DATE == "") {
            $fwCordovaToast.showLongBottom("请填写并发症开始时间");
            return;
        }

        if ($scope.complication.COMPLICATION_TYPE == "请选择") {
            $fwCordovaToast.showLongBottom("请填写并发症类型");
            return;
        }

        if ($scope.complication.COMPLICATION_DESC == "") {
            $fwCordovaToast.showLongBottom("请填写并发症描述");
            return;
        }

        // 判断并发症是否严重
        if ($scope.complication.COMPLICATION_TYPE == "严重出血" || $scope.complication.COMPLICATION_TYPE == "血栓栓塞") {
            var isCurePopup = $ionicPopup.confirm({
                title: '提示',
                template: '此并发症严重，是否已就诊?',
                buttons: [
                    { text: '未就诊', type: 'button-positive',
                        onTap: function (e) {
                            // 未治疗标识
                            $scope.complication.COMPLICATION_IS_CURE = 0;
                            $ionicPopup.alert({
                                title: "建议",
                                template: "建议您尽快前往医院就诊！",
                                okText: '好的'
                            }).then(function () {
                                $scope.submitComplication();
                            })
                        }
                    },
                    { text: '已就诊', type: 'button-positive',
                        onTap: function (e) {
                            $scope.complication.COMPLICATION_IS_CURE = 1;
                            // 但莫得就诊图片
                            if ($scope.complicationImgResult.length == 0) {
                                $ionicPopup.confirm({
                                    title: '建议',
                                    template: '建议您补充此次就诊出院小结/诊断证明图片，同时请注意近期INR监测，如有任何不适请尽快医院就诊！',
                                    cancelText: '补充图片',
                                    okText: '立即提交'
                                }).then(function (res) {
                                    if (res) {
                                        $scope.submitComplication();
                                    }
                                })
                            }
                        }
                    }
                ]
            });
        }
        else {
            $scope.submitComplication();
        }
    }

    // 7.2.并发症提交
    $scope.submitComplication = function () {
        $scope.complication.INR_PATIENT_ID = $scope.patientId;
        $scope.complication.PATIENT_NAME = $scope.vpInfo.VISIT_PATIENT_NAME;
        $scope.complication.HIS_CARD_NUM = $scope.vpInfo.HIS_CARD_NUM;
        $scope.complication.ACCOUNT_ID = $scope.vpInfo.ACCOUNT_ID;

        $scope.complication.COMPLICATION_TYPE = $scope.complication_to_num[$scope.complication.COMPLICATION_TYPE];

        // 圈
        $ionicLoading.show();
        FlupINRService.submitComplication($scope.complication).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                // 是回顾
                $scope.isHistory = true;

                // 处理一下并发症类型
                $scope.complication.COMPLICATION_TYPE = $scope.complication_to_str[$scope.complication.COMPLICATION_TYPE];

                // 如果当前在长问卷
                if ($scope.isBeginLongQuestion) {
                    $scope.longQuestion.finishComplication = 1;

                    $scope.longQuestion.idComplication = result.recordId + ";";
                    $scope.lq_complicationList.push({ id: result.recordId, result: $scope.complication });
                }

                // 重画chart
                INRchart($scope.patientId);
                // 重加载回顾列表
                $scope.getRecordList('COMPLICATION');

                // 提示
                $fwCordovaToast.showLongBottom("并发症填报提交成功！");

                // 默默提交并发症图片
                $scope.SaveImg(result.recordId, "COMPLICATION");
            }
        })
    }

    // 8.1.药物提交前检查
    $scope.checkDrug = function () {
        if ($scope.drug.DRUG_DATE == "") {
            $fwCordovaToast.showLongBottom("请填写药物开始时间");
            return;
        }

        if ($scope.drug.DRUG_NAME == "") {
            $fwCordovaToast.showLongBottom("请选择药物名称");
            return;
        }

        if ($scope.drug.DRUG_CATEGORY == "") {
            $fwCordovaToast.showLongBottom("药品类别判断出错，请重新选择药物名称");
            return;
        }

        if ($scope.drug.DRUG_CATEGORY != "华法林类") {
            if ($scope.drug.DRUG_EACH_QUANTITY == "" || $scope.drug.DRUG_EACH_QUANTITY == undefined) {
                $fwCordovaToast.showLongBottom("请填写每次剂量");
                return;
            }
            else {
                if ($scope.drug.DRUG_EACH_QUANTITY < 0) {
                    $fwCordovaToast.showLongBottom("每次剂量不可小于0");
                    return;
                }
            }
        }
        // 华法林类
        else {
            if ($scope.drug.DRUG_TYPE == '请选择' || $scope.drug.DRUG_TYPE == '') {
                $fwCordovaToast.showLongBottom("请选择用药模式");
                return;
            }
            // 每日用药
            else if ($scope.drug.DRUG_TYPE == '每日') {
                if ($scope.drug.DRUG_DAILY_QUANTITY == undefined || $scope.drug.DRUG_DAILY_QUANTITY == "") {
                    $fwCordovaToast.showLongBottom("请填写每日剂量");
                    return;
                }
                else {
                    if ($scope.drug.DRUG_DAILY_QUANTITY < 0) {
                        $fwCordovaToast.showLongBottom("每日剂量不可小于0");
                        return;
                    }
                }
            }
            // 单双日用药
            else {
                if ($scope.drug.DRUG_SINGLE_QUANTITY == undefined || $scope.drug.DRUG_SINGLE_QUANTITY == "") {
                    $fwCordovaToast.showLongBottom("请填写单日剂量");
                    return;
                }
                else {
                    if ($scope.drug.DRUG_SINGLE_QUANTITY < 0) {
                        $fwCordovaToast.showLongBottom("单日剂量不可小于0");
                        return;
                    }
                }

                if ($scope.drug.DRUG_DOUBLE_QUANTITY == undefined || $scope.drug.DRUG_DOUBLE_QUANTITY == "") {
                    $fwCordovaToast.showLongBottom("请填写双日剂量");
                    return;
                }
                else {
                    if ($scope.drug.DRUG_DOUBLE_QUANTITY < 0) {
                        $fwCordovaToast.showLongBottom("双日剂量不可小于0");
                        return;
                    }
                }
            }
        }

        $scope.drug.INR_PATIENT_ID = $scope.patientId;
        $scope.drug.PATIENT_NAME = $scope.vpInfo.VISIT_PATIENT_NAME;
        $scope.drug.HIS_CARD_NUM = $scope.vpInfo.HIS_CARD_NUM;
        $scope.drug.CREATED_ID = $scope.vpInfo.ACCOUNT_ID;
        $scope.drug.MODIFIED_ID = $scope.vpInfo.ACCOUNT_ID;

        // 处理一下药物类别
        $scope.drug.DRUG_CATEGORY = $scope.drug.DRUG_CATEGORY == "华法林类" ? 1 : 0;

        // 圈
        $ionicLoading.show();
        FlupINRService.checkDrug($scope.drug, $scope.drugSubmitAfterINR).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                $scope.submitDrug();
            }
        })
    }



    // 8.2.药物提交
    $scope.submitDrug = function () {
        // 处理一下用药模式
        $scope.drug.DRUG_TYPE = $scope.drug_to_num[$scope.drug.DRUG_TYPE];

        // 圈
        $ionicLoading.show();
        FlupINRService.submitDrug($scope.drug).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                // 处理一下药物类别
                $scope.drug.DRUG_CATEGORY = $scope.drug.DRUG_CATEGORY == 1 ? "华法林类" : "其他类";
                // 处理一下用药模式
                $scope.drug.DRUG_TYPE = $scope.drug_to_str[$scope.drug.DRUG_TYPE];
                // 处理一下药效
                $scope.drug.DRUG_EFFECT = result.effect;

                // 默默提交药物图片
                $scope.SaveImg(result.recordId, "DRUG");

                // 如果当前在长问卷
                if ($scope.isBeginLongQuestion) {
                    $scope.longQuestion.finishDrug = 1;
                    $scope.longQuestion.idDrug += result.recordId + ";";
                    $scope.lq_drugList.push({ id: result.recordId, result: $scope.drug });
                }

                // 重加载现有药物列表
                $scope.getDrugPersent();
                // 重新画chart
                INRchart($scope.patientId);
                // 是回顾
                $scope.isHistory = true;

                $fwCordovaToast.showLongBottom("药物记录提交成功！");

                // 药效提醒
                var template = "";
                if ($scope.drug.DRUG_CATEGORY == 1 || $scope.drug.DRUG_CATEGORY == '华法林类') {
                    template = "华法林可引起严重甚至致命的出血，应定期检测国际标准化比值(INR)。此外，药物、食品的改变及其他因素也可影响INR水平。";
                }
                else {
                    if ($scope.drug.DRUG_EFFECT != 0) {
                        var eff = $scope.effects[$scope.drug.DRUG_EFFECT].text;
                        var risk = $scope.effects[$scope.drug.DRUG_EFFECT].risk;
                        template = "本药将" + eff + "华法林药效，增加" + risk + "风险，同时服用期间请勤测INR值，如有任何不适请及时医院就诊！";
                    }
                }

                if (template != "") {
                    // 请注意
                    $ionicPopup.alert({
                        title: "请注意",
                        template: template,
                        okText: '我知道了'
                    }).then(function () {
                        // 如果是从INR提交蹦跶过来的 要蹦跶回去
                        if ($scope.drugSubmitAfterINR) {
                            // 是否是回顾状态
                            $scope.isHistory = true;
                            $scope.drugSubmitAfterINR = false;
                            // 药物隐藏
                            $scope.drugHide();
                            // INR出来
                            $scope.INRShow();
                        }
                    })
                }
                else {
                    // 如果是从INR提交蹦跶过来的 要蹦跶回去
                    if ($scope.drugSubmitAfterINR) {
                        // 是否是回顾状态
                        $scope.isHistory = true;
                        $scope.drugSubmitAfterINR = false;
                        // 药物隐藏
                        $scope.drugHide();
                        // INR出来
                        $scope.INRShow();
                    }
                }
            }
        })
    }

    // 9.选择患者
    $scope.checkPatient = function (vpInfo) {
        FlupINRService.checkPatient(vpInfo.HIS_CARD_NUM).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else if (result.result == -1) {
                $fwCordovaToast.showLongBottom("所选患者未入选INR随访课题");
            }
            else {
                $scope.inrPatient = true;

                $scope.vpInfo = vpInfo;
                $scope.patientId = result.patientId
                $scope.goPage($scope.patientId);
            }
        })
    }

    // 10.选择的患者的整体INR信息
    getINRInfo = function (patientId) {
        FlupINRService.getINRInfo(patientId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                $scope.info = result.list[0];
            }
        })
    }

    // 10.1选择的患者的整体并发症信息
    getComplicationInfo = function (patientId) {
        FlupINRService.getComplicationInfo(patientId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                $scope.complicationInfo = result.list[0];
            }
        })
    }

    // 11.回顾页面 修改INR
    $scope.goModifyINR = function (INR) {
        var confirmBpPopup = $ionicPopup.confirm({
            title: '确认修改',
            template: '是否修改INR相关数值?',
            cancelText: '取消',
            okText: '确认'
        });

        confirmBpPopup.then(function (res) {
            if (res) {
                $scope.INR = INR;
                $scope.getImage($scope.INR.INR_RECORD_ID, "INR");
                // 非回顾
                $scope.isHistory = false;
                $scope.INRShow();
            }
            else { }
        });
    }

    // 11.2 回顾页面 删除并发症 药物记录
    $scope.onHold = function (recordType, id) {

        var text = { COMPLICATION: "并发症", DRUG: "药物" };

        var confirmBpPopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除此' + text[recordType] + '记录?',
            cancelText: '取消',
            okText: '删除'
        });

        confirmBpPopup.then(function (res) {
            if (res) {
                FlupINRService.deleteRecord(recordType, id).then(function (result) {
                    if (result.result == 1) {
                        $fwCordovaToast.showLongBottom("删除成功！");
                        // 重加载记录列表
                        $scope.getRecordList(recordType);
                    }
                    else {
                        $fwCordovaToast.showLongBottom(result.msg);
                    }
                });
            }
            else { }
        });
    }

    // 12.停用当前用药
    $scope.onHoldPersent = function (drug) {
        // 开始/停药时间检查
        if ($scope.drug.DRUG_DATE > $scope.drug.DATE_FINISHED) {
            $fwCordovaToast.showLongBottom("停药时间不能早于开始用药时间");
            return;
        }
        if ($scope.today < $scope.drug.DATE_FINISHED) {
            $fwCordovaToast.showLongBottom("停药时间不能超过今日");
            return;
        }

        // 二次提示
        var confirmBpPopup = $ionicPopup.confirm({
            title: '停用确认',
            template: '是否确认停用此药品？',
            cancelText: '取消',
            okText: '停用'
        });
        confirmBpPopup.then(function (res) {
            if (res) {
                FlupINRService.deleteDrugPersent(drug.FLUP_DRUG_PERSENT_ID, drug.DATE_FINISHED, $scope.patientId, $scope.vpInfo.ACCOUNT_ID).then(function (result) {
                    if (result.result == 1) {
                        var template = "";
                        switch (result.drug_effect) {
                            case 1:
                            case 2:
                            case 3:
                                {
                                    temp = "停药此药后可能引起INR降低，请勤测INR值，并按照医嘱适当调整华法林剂量，如有任何不适请及时医院就诊！";
                                    break;
                                }
                            case 4:
                            case 5:
                            case 5:
                                {
                                    temp = "停药此药后可能引起INR升高，请勤测INR值，并按照医嘱适当调整华法林剂量，如有任何不适请及时医院就诊！";
                                    break;
                                }
                        }

                        if (template == "") {
                            $scope.goBack();
                        }
                        else {
                            // 请注意
                            $ionicPopup.alert({
                                title: "停药注意",
                                template: template,
                                okText: '我知道了'
                            }).then(function () {
                                $scope.goBack();
                            })
                        }
                    }
                    else {
                        $fwCordovaToast.showLongBottom(result.msg);
                    }
                });
            }
            else { }
        });
    }

    // 13.提交用药时间(在这加添加用药计划表)
    $scope.addTimePoint = function (drug) {
        // 判断时间点是否与已有重复
        for (var i in $scope.timePointList) {
            if ($scope.timePointList[i].time == $scope.timeNew.time) {
                $fwCordovaToast.showLongBottom("用药时间重复，请选择其他时间");
                return;
            }
        }
        // 排空
        if ($scope.timeNew.dosage == null || $scope.timeNew.dosage.length == 0) {
            $fwCordovaToast.showLongBottom("剂量不可为空");
            return;
        }
        // 添加时间 => 全部用药时间
        $scope.timePointList.push(new Object({ time: $scope.timeNew.time, dosage: $scope.timeNew.dosage }));

        // timePointList按用药时间排序
        $scope.timePointList.sort(sortDrugTime);

        // 加入drug
        for (var i = 0; i < $scope.timePointList.length; i++) {
            $scope.drug["TIME_" + (i + 1)] = $scope.timePointList[i].time;
            $scope.drug["QUANTITY_" + (i + 1)] = $scope.timePointList[i].dosage;
        }
        // 保存
        saveTimePoint(drug);
    }

    // 13.1 药物时间排序
    sortDrugTime = function (a, b) {
        var indexa = a.time.indexOf(":");
        var timea = parseInt(a.time.substr(0, indexa) + a.time.substr(indexa + 1));
        var indexb = b.time.indexOf(":");
        var timeb = parseInt(b.time.substr(0, indexb) + b.time.substr(indexb + 1));
        return timea - timeb;
    }

    // 14.提交用药时间 => 用药时间数量
    $scope.countTimePoint = function () {
        var count = 0;
        for (var i = 0; i < $scope.timePointList.length; i++) {
            if ($scope.timePointList[i].status == 1) {
                count++;
            }
        }
        return count;
    }

    // 15.删除用药时间
    $scope.deleteTimePoint = function (drug, index) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除用药时间点',
            template: "确定要删除这个时间吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $scope.timePointList = [
                    { time: drug.TIME_1, dosage: drug.QUANTITY_1 },
                    { time: drug.TIME_2, dosage: drug.QUANTITY_2 },
                    { time: drug.TIME_3, dosage: drug.QUANTITY_3 }
                 ]
                $scope.timePointList.splice(index - 1, 1);

                // drug置空
                for (var i = 0; i < 3; i++) {
                    drug["TIME_" + (i + 1)] = null;
                    drug["QUANTITY_" + (i + 1)] = null;
                }

                // $scope.timePointList除空（要排序）
                for (var i = 0; i < $scope.timePointList.length; i++) {
                    if ($scope.timePointList[i].time == null || $scope.timePointList[i].dosage == null) {
                        $scope.timePointList.splice(i, 1);
                        i--;
                    }
                }
                // $scope.timePointList排序
                $scope.timePointList.sort(function (a, b) {
                    var indexa = a.time.indexOf(":");
                    var timea = parseInt(a.time.substr(0, indexa) + a.time.substr(indexa + 1));
                    var indexb = b.time.indexOf(":");
                    var timeb = parseInt(b.time.substr(0, indexb) + b.time.substr(indexb + 1));
                    return timea - timeb;
                });

                // 加入drug
                for (var i = 0; i < $scope.timePointList.length; i++) {
                    drug["TIME_" + (i + 1)] = $scope.timePointList[i].time;
                    drug["QUANTITY_" + (i + 1)] = $scope.timePointList[i].dosage;
                }

                // 保存
                saveTimePoint(drug);
            }
        })
    }

    // 15.1.删除药品全部提醒时间
    $scope.deleteDrugPlan = function (drug) {
        $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除此用药计划? 将删除全部用药时间',
            cancelText: '取消',
            okText: '确认'
        }).then(function (res) {
            if (res) {
                FlupINRService.deleteDrugPlan(drug.FLUP_DRUG_PERSENT_ID, $scope.vpInfo.VISIT_PATIENT_ID).then(function (result) {
                    if (result.result == 1) {
                        // 重加载当前用药
                        $scope.getDrugPersent();
                    }
                    else {
                        $fwCordovaToast.showLongBottom(result.msg);
                    }
                });
            }
        })
    }

    // 16.保存用药时间
    saveTimePoint = function (drug) {
        // 打包参数
        var mp = new Object({
            VISIT_PATIENT_ID: $scope.vpInfo.VISIT_PATIENT_ID,
            VISIT_PATIENT_NAME: $scope.vpInfo.VISIT_PATIENT_NAME,
            HIS_CARD_CODE: $scope.vpInfo.HIS_CARD_NUM,
            ACCOUNT_ID: $scope.vpInfo.ACCOUNT_ID,
            MEDICATION_PLAN_ID: drug.MEDICATION_PLAN_ID,
            NAME: drug.DRUG_NAME,
            TIME1: drug.TIME_1,
            DOSAGE1: drug.QUANTITY_1,
            TIME2: drug.TIME_2,
            DOSAGE2: drug.QUANTITY_2,
            TIME3: drug.TIME_3,
            DOSAGE3: drug.QUANTITY_3,
            MEDICATION_ID: drug.FLUP_DRUG_PERSENT_ID,
            ACCESS_NAME: 'FLUP_INR_DRUG_PERSENT'
        });
        // 向用药计划添加数据
        FlupINRService.addDrugPlan(mp).then(function (result) {
            if (result.result == 1) {
                // 当前用药更新
                $scope.getDrugPersent();
                // 关闭添加时间单页
                $scope.timeHide();
            }
            else {
                $fwCordovaToast.showLongBottom(result.msg);
            }
        });
    }

    // 17.获取回顾信息后 => 获取图片
    $scope.getImage = function (recordId, type) {
        FlupINRService.getImage(recordId, type).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                switch (type) {
                    case "INR":
                        {
                            $scope.INRImgResult = [];
                            for (i in result.list) {
                                var img = { ID: i, SRC: result.list[i].URL, type: result.list[i].TYPE };
                                $scope.INRImgResult.push(img);
                            }
                            break;
                        }
                    case "COMPLICATION":
                    case "COMPLICARION_IMG":
                        {
                            $scope.complicationImgResult = [];
                            for (i in result.list) {
                                var img = { ID: i, SRC: result.list[i].URL, DISPLAY: result.list[i].TYPE };
                                $scope.complicationImgResult.push(img);
                            }
                            break;
                        }
                    case "DRUG":
                        {
                            $scope.drugImgResult = [];
                            for (i in result.list) {
                                var img = { ID: i, SRC: result.list[i].URL, type: result.list[i].TYPE };
                                $scope.drugImgResult.push(img);
                            }
                            break;
                        }
                }
            }
        });
    }

    // 18.1 去INRchart
    $scope.toINRchart = function (type) {
        $scope.chartType = type;
        INRchart();
    }

    // 18.INRchart
    function INRchart() {
        FlupINRService.INRchart($scope.patientId, $scope.chartType).then(function (result) {
            if (result.result == 0) { }
            else {

                // 模型赋值
                $scope.chart = { date: result.date, INR: result.INR, COMPLICATION: result.COMPLICATION, WARFARIN: result.WARFARIN }

                $("#INRchart").highcharts({
                    credits: {
                        enabled: false
                    },
                    chart: {
                        zoomType: 'x'
                    },
                    title: {
                        text: 'INR/并发症/华法林',
                        style: { fontSize: 15, color: '#444' }
                    },
                    subtitle: {
                        enabled: false
                    },
                    xAxis: {
                        categories: result.date
                    },
                    yAxis: [{
                        min: 0,
                        title: { text: null },
                        labels: {
                            align: 'left',
                            x: -10
                        },
                        plotLines: [
                        {
                            value: 3,
                            color: 'red',
                            dashStyle: 'shortdash',
                            width: 0.5,
                            label: { text: 'INR危险值(3)', style: { color: 'red' }, verticalAlign: 'top', align: 'left', y: -5 }
                        }
                        ],
                        plotBands: [
                        {
                            from: 1.8,
                            to: 2.5,
                            color: '#f3fcff',
                            label: { text: null }
                        }
                        ]
                    },
                    {
                        min: 0,
                        opposite: true,
                        title: { text: null },
                        labels: {
                            align: 'right',
                            x: 10
                        }
                    }
                    ],
                    legend: {
                        enable: true,
                        verticalAlign: 'top',
                        align: 'left',
                        x: 0,
                        y: 25
                    },
                    tooltip: {
                        crosshairs: true,
                        shared: true,
                        formatter: function () {
                            var html = "";
                            if (this.points != null) {
                                // this.point[1]不一定是华法林 俩条点时是 
                                // 一个点时 this.point[0]可能时INR 也可能华法林 所以按name判断
                                for (i in this.points) {
                                    if (this.points[i].series.name == "INR") {
                                        html += '<div>INR：' + this.points[i].y + '</div> ';
                                    }
                                    else if (this.points[i].series.name == "华法林") {
                                        html += '<div>华法林剂量：' + this.points[i].y + '</div> ';
                                    }
                                    else { }
                                }
                            }
                            else {
                                var complication = "";
                                for (i in result.date) {
                                    if (result.date[i] == this.x) {
                                        var num = result.COMPLICATION[i];
                                        if (num == -1) {
                                            complication = "出现并发症";
                                        }
                                        else {
                                            complication = $scope.complication_to_str[num];
                                        }
                                    }
                                }
                                html += "<div>并发症：" + complication + "</div> ";
                            }

                            var drug = "<br /><div>当前用药：<div>";
                            for (i in result.MEDICAL) {
                                var medical = result.MEDICAL[i];
                                if (medical.time == this.x) {
                                    for (j in medical.medical) {
                                        drug += "<br /><div> " + medical.medical[j] + "</div>";
                                    }
                                    // 假如无循环
                                    if (medical.medical.length == 0) {
                                        drug = "<div>当前用药：无</div>";
                                    }
                                }
                            }
                            // 假如无循环
                            if (result.MEDICAL.length == 0) {
                                drug = "<div>当前用药：无</div>";
                            }
                            html += drug;
                            return html;
                        }
                    },
                    plotOptions: {
                        line: {
                            connectNulls: true,
                            dataLabels: {
                                enabled: true
                            },
                            enableMouseTracking: true
                        }
                    },
                    series: [{
                        name: 'INR',
                        type: 'line',
                        yAxis: 0,
                        data: result.INR
                    },
                    {
                        name: '并发症',
                        type: 'scatter',
                        yAxis: 0,
                        data: result.COMPLICATIONZ
                    },
                    {
                        name: '华法林',
                        type: 'line',
                        yAxis: 1,
                        data: result.WARFARIN
                    }
                    ]
                });
            }
        });
    }

    // 18.3 
    $scope.toINRtable = function () {
        $scope.asChart = !$scope.asChart;
    }


    // 19.1 检索药物
    $scope.searchDrug = function () {
        FlupINRService.getMedicalList($scope.searchName.value).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom("药物检索失败");
            }
            else {
                $scope.searchList = result.medList;
            }
        })
    }

    // 19.2 检索后 => 选择药物
    $scope.selectIt = function (search) {
        // 名称
        $scope.drug.DRUG_NAME = search.NAME;
        // 厂家
        $scope.drug.DRUG_ORIGIN = search.MANUFACTURER;

        // 药物类型
        if (search.NAME.search('华法林') != -1) {
            $scope.drug.DRUG_CATEGORY = "华法林类";
            // 单位给片 每片剂量赋值
            $scope.drug.DRUG_UNIT = search.UNIT_PACK;
            $scope.drug.DRUG_SLICE_QUANTITY = search.UNIT_DOSE;
        }
        else {
            $scope.drug.DRUG_CATEGORY = "其他类";
            // 单位给ml/g之类的
            $scope.drug.DRUG_UNIT = search.UNIT_SPEC;
        }

        // 通用名
        $scope.drug.DRUG_COMMON_NAME = search.COMMON_NAME;

        // 药物检索模态窗关闭
        $scope.searchDrugModal.hide();
    }

    // 19.3 点击提示 => 检索药物
    $scope.searchDrugByClick = function (drugName) {
        $scope.searchName.value = drugName;
        $scope.searchDrug();
    }

    // 20.切换华法林和其他药物
    $scope.changeDrugCategory = function () {
        if ($scope.drug.DRUG_CATEGORY == '华法林类') {
            $scope.drug.DRUG_TYPE = "请选择";
            $scope.drug.DRUG_UNIT = "请选择";
        }
        else {
            $scope.drug.DRUG_TYPE = "请选择";
            $scope.drug.DRUG_UNIT = "";
        }
    }

    // 21.回顾列表 页面{{NAME}}显示
    getRecordName = function (recordType) {
        var text = { INR: "INR填报历史回顾", COMPLICATION: "并发症填报历史回顾", DRUG: "用药历史回顾" };
        $scope.name = text[recordType];
    }

    // 22.提交咨询
    $scope.submitAsk = function () {
        FlupINRService.submitAsk($scope.patientId, $scope.ask.content).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom("咨询提交失败");
            }
            else {
                // 患者提问置空 
                $scope.ask = { content: '' };
                // 获取咨询
                $scope.getContent();
            }
        })
    }

    // 23.获取咨询
    $scope.getContent = function () {
        FlupINRService.getContent($scope.patientId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom("咨询显示失败:" + result.msg);
            }
            else {
                $scope.msg = result.dt;
            }
        })
    }

    // 24.是否拥有新消息
    $scope.checkMessage = function () {
        FlupINRService.checkMessage($scope.patientId).then(function (result) {
            if (result.result == 0) {
                $scope.hasNewMessage = false;
            }
            else {
                $scope.hasNewMessage = true;
                $scope.isMessageOpen = true;
            }
        })
    }

    // 25.给医生发警告(INR危险)
    sentDangerINR = function (INRdate, INRvalue) {
        FlupINRService.sentDangerINR($scope.patientId, INRdate, INRvalue).then(function (result) {
        })
    }

    // 26.补充图片的提交（不要了）
    $scope.submitComplicationImg = function () {
        // 提交图片
        $scope.SaveImg($scope.complication.INR_COMPLICATION_RECORD_ID, "COMPLICATION_IMG");
    }

    // 27.回顾信息时 要修改INR
    $scope.isToModify = function (type) {
        // 文本对照
        var text = { INR: 'INR', COMPLICATION: '并发症', DRUG: '药品' };

        $ionicPopup.confirm({
            title: '修改' + text[type],
            template: "是否修改此" + text[type] + "信息?",
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                $scope.isHistory = false;
                $scope.getImage($scope.INR.INR_RECORD_ID, type);
            }
        })
    }

    // 28. 单选切换
    $scope.changeRadio = function (name, value) {
        $scope.self[name] = value;
    }

    // 29 药物排序
    $scope.sortDrug = function (name) {

        $scope.drugRecord.sort(function (a, b) {
            var thenSort = a[name].localeCompare(b[name], 'zh-CN')
            return 1;
        });
    }

    // 30.清空检索栏时处理
    $scope.clearSearch = function () {
        if ($scope.searchName.value == "") {
            $scope.searchList = [];
        }
    }

    // 31.主菜单帮助
    getColumns = function (key) {
        $ionicLoading.show();
        FlupINRService.getColumns(key).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 1) {
                $scope.columns = result.data;
            }
            else {
                $fwCordovaToast.showLongBottom(result.msg);
            }
        })
    }
    // 31.1 主菜单打开关闭
    $scope.changeDilation = function (column) {
        column.dilation = !column.dilation;
    }

    // 32 文章
    $scope.getArticle = function (id) {
        $scope.articleStatus = 0;
        $ionicLoading.show();
        InstructionService.getArticle(id).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $scope.articleTitle = data.data.TITLE;
                $scope.articleContent = data.data.CONTENT;
                $scope.articleStatus = 1;
                $scope.helpShow();
            }
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 33.长篇问卷 ($scope.longQuestion.finish 只标识是否进入下一题)
    $scope.longQuestChangeRadio = function (name, value) {
        $scope.longQuestion[name] = value;

        switch (name) {
            case "INR":
                {
                    $scope.longQuestion.finishINR = !value;
                    if (value) {
                        $scope.INRShow();
                    }
                    break;
                }
            case "complication":
                {
                    $scope.longQuestion.finishComplication = !value;
                    if (value) {
                        $scope.complicationShow();
                    }
                    break;
                }
            case "drug":
                {
                    $scope.longQuestion.finishDrug = !value;
                    if (value) {
                        $scope.drugShow();
                    }
                    break;
                }
            case "life":
                {
                    $scope.longQuestion.finishLife = 1;
                }
        }
    }

    // 34.获取滚动条高度
    $scope.getScrollHigh = function () {
        var high = $ionicScrollDelegate.getScrollPosition().top + 50;
        return high + "px";
    }

    // 35.1 获取患者自身补充信息
    $scope.getSelf = function () {
        FlupINRService.getSelf($scope.patientId).then(function (result) {
            if (result.result == 1) {
                // 是否完善了个人信息
                $scope.finishSelf = result.self[0].FINISH_SELF == 1 ? true : false;

                // 是 self赋值
                if ($scope.finishSelf) {
                    $scope.self = result.self[0];
                }
                // 否 self默认 只姓名赋值
                else {
                    $scope.self.PATIENT_NAME = result.self[0].PATIENT_NAME;
                    $scope.self.INR_SCORE = result.self[0].INR_SCORE;
                }
            }
            else {
                $fwCordovaToast.showLongBottom(result.msg);
            }
        })
    }


    // 35.2 提交患者自身补充信息
    $scope.submitSelf = function () {
        FlupINRService.submitSelf($scope.self, $scope.patientId).then(function (result) {
            if (result.result == 1) {
                $fwCordovaToast.showLongBottom("个人信息补充成功！");
                $scope.finishSelf = true;
            }
            else {
                $fwCordovaToast.showLongBottom(result.msg);
            }
        })
    }

    // 35.3 是否修改
    $scope.changeFinishSelf = function () {
        $ionicPopup.confirm({
            title: "修改个人信息",
            template: "是否修改此个人信息?",
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                $scope.finishSelf = false;
            }
        })
    }


    // 36.生活表提交
    $scope.submitLife = function () {
        // 首先 先把生活表鲨了
        if ($scope.longQuestion.life) {

            // 整理一下
            $scope.LIFE.PATIENT_ID = $scope.patientId;
            $scope.LIFE.HIS_CARD_NUM = $scope.vpInfo.HIS_CARD_NUM;
            $scope.LIFE.PATIENT_NAME = $scope.vpInfo.VISIT_PATIENT_NAME;
            $scope.LIFE.ACCOUNT_ID = $scope.vpInfo.ACCOUNT_ID;
            $scope.LIFE.DIET_CHANGED = $scope.longQuestion.diet ? 1 : 0;
            $scope.LIFE.WEIGHT_CHANGED = $scope.longQuestion.weight ? 1 : 0;
            $scope.LIFE.WEIGHT = $scope.LIFE.WEIGHT == null ? 0 : $scope.LIFE.WEIGHT;

            FlupINRService.submitLife($scope.LIFE).then(function (result) {
                if (result.result == 0) {
                    $fwCordovaToast.showLongBottom(result.msg);
                }
                else {
                    // 把生活表id带回来
                    $scope.longQuestion.idLife = result.idLife;
                    // 再把外联表鲨了
                    submitLongQuestion();
                }
            })
        }
        else {
            // 直接把外联表鲨了
            submitLongQuestion();
        }
    }

    // 37.提交外联表
    submitLongQuestion = function () {
        if ($scope.longQuestion.idINR == '' && $scope.longQuestion.idComplication == '' && $scope.longQuestion.idDrug == '' && $scope.longQuestion.idLife == '') {
            $fwCordovaToast.showLongBottom("最少应有一项检测结果上传！");
            return;
        }

        FlupINRService.submitLongQuestion($scope.longQuestion.idINR, $scope.longQuestion.idComplication, $scope.longQuestion.idDrug, $scope.longQuestion.idLife, $scope.patientId).then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                // alert细分 啊！！！
                $fwCordovaToast.showLongBottom("您已完成问卷！");

                // i
                // 有病发 + 无INR + 无药物 √
                if ($scope.longQuestion.idComplication != "" && $scope.longQuestion.idINR == "" && $scope.longQuestion.idDrug == "") {
                    var complication_danger = false;
                    var complication_common = false;
                    var is_cure = false;

                    console.log($scope.lq_complicationList);

                    // 判断一下并发症里是不是严重
                    for (i in $scope.lq_complicationList) {
                        if ($scope.lq_complicationList[i].result.COMPLICATION_TYPE == "严重出血" || $scope.lq_complicationList[i].result.COMPLICATION_TYPE == "血栓栓塞") {

                            complication_danger = true;

                            // 就诊过
                            if ($scope.lq_complicationList[i].result.COMPLICATION_IS_CURE == 1) {
                                is_cure = true;
                            }
                        }
                        else {
                            complication_common = true;
                        }
                    }

                    var template = "";

                    // 严重
                    if (complication_danger) {
                        // 已就诊
                        if (is_cure) {
                            // 但莫得图
                            if ($scope.complicationImgResult.length == 0) {
                                template += "建议补充相关就诊出院小结/诊断证明等图片，并注意近期INR检测，如有任何不适请尽快医院就诊！";
                            }
                            else {
                                template += "建议注意近期勤测INR，如有任何不适请尽快医院就诊！";
                            }
                        }
                        // 尚未就诊
                        else {
                            template += "建议尽快医院就诊！";
                        }

                        var alertPopup = $ionicPopup.alert({
                            title: '并发症填报提示',
                            template: template,
                            okText: '我知道了'
                        }).then(function () {
                            $scope.goBack();
                        });
                    }
                    // 普通
                    else {
                        FlupINRService.lq_feedback($scope.patientId).then(function (result) {
                            // 出错/无上一次INR记录
                            if (result.result == 0) {
                                template += "因近期发生轻微出血事件，建议检测INR并填报！";
                            }
                            else {
                                // 今日之后
                                if (result.is_after == 1) {
                                    template += "因近期发生轻微出血事件，建议检测INR并填报！";
                                }
                                else {
                                    template += "若出血量较多、或不易止血、或反复出血，请尽快就诊，同时检测INR；若出血症状已缓解，建议下次INR检测时间为：" + result.next_inr_date;
                                }
                            }

                            var alertPopup = $ionicPopup.alert({
                                title: '并发症填报提示',
                                template: template,
                                okText: '我知道了'
                            }).then(function () {
                                $scope.goBack();
                            });
                        })
                    }
                }

                // ii
                // 无并发症 + 有INR + 无药物调整 √
                else if ($scope.longQuestion.idComplication == "" && $scope.longQuestion.idINR != "" && $scope.longQuestion.idDrug == "") {
                    // INR提示文字处理
                    if ($scope.lq_inrList[0].result.INR_LEVEL == '偏低' || $scope.lq_inrList[0].result.INR_LEVEL == '偏高') {
                        var text = $scope.lq_inrList[0].result.INR_LEVEL == '偏低' ? "低于" : "高于";

                        var title = "INR数值" + text + "目标范围";
                        var template = "INR数值" + text + "目标范围，建议参考调药助手，调整华法林剂量，建议下次INR检测时间：" + $scope.lq_inrList[0].result.FEEDBACK_INR_DATE;

                        // INR危险
                        if ($scope.lq_inrList[0].result.INR_IS_DANGER == 1) {
                            text = $scope.lq_inrList[0].result.INR_LEVEL == '偏低' ? "过低" : "过高";
                            var risk = $scope.lq_inrList[0].result.INR_LEVEL == '偏低' ? "血栓栓塞" : "出血";

                            title = "INR控制欠佳";
                            template = "INR控制欠佳，INR值" + text + "，具有" + risk + "的风险！";
                        }
                    }
                    else {
                        var title = $scope.lq_inrList[0].result.INR_LEVEL == '控制良好' ? "INR控制良好" : "INR控制稳定";
                        var template = $scope.isLatestINR ? '当前INR处于目标范围，请继续保持，建议下次INR检测时间为：' + $scope.lq_inrList[0].result.FEEDBACK_INR_DATE
                                                : '当前INR处于目标范围，请继续保持，您提交的INR检测结果为历史数据，以最新INR数值计算，建议下次INR检测时间为：' + $scope.lq_inrList[0].result.FEEDBACK_INR_DATE;
                    }

                    var alertPopup = $ionicPopup.alert({
                        title: title,
                        template: template,
                        okText: '我知道了'
                    }).then(function () {
                        $scope.goBack();
                    });
                }

                // iii
                // 无并发症 + 无INR + 有药物调整 √
                else if ($scope.longQuestion.idComplication == "" && $scope.longQuestion.idINR == "" && $scope.longQuestion.idDrug != "") {
                    // 根据药效提示
                    var temp = "";
                    for (i in $scope.lq_drugList) {
                        if ($scope.lq_drugList[i].result.DRUG_CATEGORY == '华法林类' || $scope.lq_drugList[i].result.DRUG_CATEGORY == 1) {
                            temp += "华法林可引起严重、甚至致命的出血，应定期检测国际标准化比值(INR)。此外，药物、食品的改变及其他因素也可影响INR水平。"
                        }
                        else {
                            var num = $scope.lq_drugList[i].result.DRUG_EFFECT;
                            if (num != 0) {
                                var eff = $scope.effects[num].text;
                                var risk = $scope.effects[num].risk;
                                temp += $scope.lq_drugList[i].result.DRUG_NAME + "将" + eff + "华法林药效，增加" + risk + "风险！";
                            }
                        }
                    }

                    var template = "";
                    if (temp == "") {
                        template = "建议您维持华法林用量，同时注意生活饮食对INR值得影响。如有不适，请尽快来院就诊！";
                    }
                    else {
                        template = "请注意，" + temp + "服药期间请勤测INR值，如有任何不适请及时医院就诊！";
                    }

                    var alertPopup = $ionicPopup.alert({
                        title: '药物填报提示',
                        template: template,
                        okText: '我知道了'
                    }).then(function () {
                        $scope.goBack();
                    });
                }

                // iv
                // 无并发症 + 有INR + 有药物调整 √
                else if ($scope.longQuestion.idComplication == "" && $scope.longQuestion.idINR != "" && $scope.longQuestion.idDrug != "") {
                    // 根据药效提示 + 提示反馈时间

                    // INR提示文字处理
                    if ($scope.lq_inrList[0].result.INR_LEVEL == '偏低' || $scope.lq_inrList[0].result.INR_LEVEL == '偏高') {
                        var text = $scope.lq_inrList[0].result.INR_LEVEL == '偏低' ? "低于" : "高于";

                        var title = "INR数值" + text + "目标范围";
                        var template = "INR数值" + text + "目标范围，建议参考调药助手，调整华法林剂量，建议下次INR检测时间：" + $scope.lq_inrList[0].result.FEEDBACK_INR_DATE;

                        // INR危险
                        if ($scope.lq_inrList[0].result.INR_IS_DANGER == 1) {
                            text = $scope.lq_inrList[0].result.INR_LEVEL == '偏低' ? "过低" : "过高";
                            var risk = $scope.lq_inrList[0].result.INR_LEVEL == '偏低' ? "血栓栓塞" : "出血";

                            title = "INR控制欠佳";
                            template = "INR控制欠佳，INR值" + text + "，具有" + risk + "的风险！";
                        }
                    }
                    else {
                        var title = $scope.lq_inrList[0].result.INR_LEVEL == '控制良好' ? "INR控制良好" : "INR控制稳定";
                        var template = $scope.isLatestINR ? '当前INR处于目标范围，请继续保持，建议下次INR检测时间为：' + $scope.lq_inrList[0].result.FEEDBACK_INR_DATE
                                                : '当前INR处于目标范围，请继续保持，您提交的INR检测结果为历史数据，以最新INR数值计算，建议下次INR检测时间为：' + $scope.lq_inrList[0].result.FEEDBACK_INR_DATE;
                    }

                    // 根据药效提示
                    var temp = "";
                    for (i in $scope.lq_drugList) {
                        if ($scope.lq_drugList[i].result.DRUG_CATEGORY == 1 || $scope.lq_drugList[i].result.DRUG_CATEGORY == '华法林类') {
                            temp += "华法林可引起严重、甚至致命的出血，应定期检测国际标准化比值(INR)。此外，药物、食品的改变及其他因素也可影响INR水平。";
                        }
                        else {
                            var num = $scope.lq_drugList[i].result.DRUG_EFFECT;
                            if (num != 0) {
                                var eff = $scope.effects[num].text;
                                var risk = $scope.effects[num].risk;
                                temp += $scope.lq_drugList[i].result.DRUG_NAME + "将" + eff + "华法林药效，增加" + risk + "风险！";
                            }
                        }
                    }
                    // 无任何药效
                    if (temp == "") {
                    }
                    else {
                        template += " 请注意，药物方面，" + temp + "建议您服药期间勤测INR值，如有任何不适请及时医院就诊！";
                    }

                    $ionicPopup.alert({
                        title: "INR/药物填报提示",
                        template: template,
                        okText: '我知道了'
                    }).then(function () {
                        $scope.goBack();
                    });
                }

                // v
                // 其他情况
                else {
                    var template = "建议您注意生活饮食对INR值得影响，如有任何不适请及时医院就诊！";

                    $ionicPopup.alert({
                        title: "提示",
                        template: template,
                        okText: '我知道了'
                    }).then(function () {
                        $scope.goBack();
                    });
                }
            }
        })
    }

    // 个人问卷相关
    // 38.手术名称
    $scope.add_opera_name = function (name) {
        if ($scope.self.OPERATION_TYPE.indexOf(name) == -1) {
            $scope.self.OPERATION_TYPE += name + ";";
        }
        else {
            $scope.self.OPERATION_TYPE = $scope.self.OPERATION_TYPE.replace(name + ";", "");
        }
    }

    // 长篇问卷相关
    // 删除
    $scope.lq_delete = function (type, id) {
        // 对照
        var deleteType = { complication: { list: 'lq_complicationList', id: 'idComplication' }, drug: { list: 'lq_drugList', id: 'idDrug'} };

        // 不显示
        var lq_list = [];
        var temp = eval("$scope." + deleteType[type].list);
        for (i in temp) {
            if (temp[i].id != id) {
                lq_list.push({ id: temp[i].id, result: temp[i].result });
            }
        }
        temp = lq_list;

        if (type == "complication") { $scope.lq_complicationList = temp; }
        else { $scope.lq_drugList = temp; }

        // 外联id中删除
        var delete_id = deleteType[type].id;
        $scope.longQuestion[delete_id] = $scope.longQuestion[delete_id].replace(id + ";", "");

        // 外联id：空 =>是否近期：否
        if ($scope.longQuestion[delete_id] == "") {
            $scope.longQuestion[type] = false;
        }

        // 库中删除 如果是drug 把迁移记录也全鲨了
        FlupINRService.lq_delete(type, id, $scope.patientId).then(function (result) {
        })
    }

    $scope.lq_add = function (type) {
        if (type == "complication") {
            $scope.isHistory = false;
            $scope.complicationShow();
        }
        else if (type == "drug") {
            $scope.isHistory = false;
            $scope.drugShow();
        }
        else { }
    }

    // 页面的准备、加载、进入、退出、销毁
    // 1.准备
    ionic.DomUtil.ready(function () {
        // 禁用左右滑动
        slideFlupINR.enableSlide(false);
    });
    // 2.加载
    $scope.$on('$ionicView.loaded', function () {
        // 填充就诊人列表
        $scope.loadVpList();
    })
    // 3.进入
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'flupINR');
    });
    // 4.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'flupINR') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
    // 5.销毁
    $scope.$on('$destroy', function () {
        $scope.INRModal.remove();
        $scope.complicationModal.remove();
        $scope.drugModal.remove();
        $scope.timeModal.remove();
        $scope.searchDrugModal.remove();
        $scope.messageHelperModal.remove();
    })


    // Slide相关
    // 1.后退
    $scope.goBack = function () {
        // 第1页 后退dealWithCard
        if ($scope.step == 0) {
            // 清空patientid
            // $scope.patientId = "";
            // $scope.name = "选择就诊人";
            // $scope.step = 0;
            // slideFlupINR.slide($scope.step);

            $state.go("app.dealWithCard", { go: "inr" });
        }
        // 第4页(帮助)
        else if ($scope.step == 3) {
            if ($scope.lastStep == 0) {
                // 重加载INR折现图
                INRchart($scope.patientId);
                // 重检查信息
                $scope.checkMessage();
            }

            // 因为帮助可能从多个地方来 0-8 哪来回哪
            $scope.name = $scope.lastName;
            $scope.step = $scope.lastStep;
            slideFlupINR.slide($scope.step);
        }
        // 第5页(药物停用) 后退第2页(调整当前用药/时间)
        else if ($scope.step == 4) {
            // 药物图片置空
            $scope.drugImgResult = [];
            // 药物模型置空
            $scope.drug = {
                FLUP_DRUG_PERSENT_ID: '',
                INR_PATIENT_ID: '',
                PATIENT_NAME: '',
                HIS_CARD_NUM: '',
                CREATED_ID: '',
                MODIFIED_ID: '',
                DRUG_DATE: '',
                DRUG_CATEGORY: '其他类',
                DRUG_NAME: '',
                DRUG_ORIGIN: '',
                DRUG_QUANTITY: '',
                DRUG_TYPE: '请选择',
                DRUG_TYPE_DESC: '',
                DRUG_UNIT: '',
                DRUG_SLICE_QUANTITY: '',
                DRUG_DAILY_QUANTITY: '',
                DRUG_SINGLE_QUANTITY: '',
                DRUG_DOUBLE_QUANTITY: '',
                DRUG_EACH_QUANTITY: '',
                DRUG_EFFECT: 0,
                DATE_FINISHED: ''
            };

            // 现有药物列表更新
            $scope.getDrugPersent();

            $scope.name = "现用药物调整";
            $scope.step = 1;
            slideFlupINR.slide($scope.step);
        }
        // 第8页(长篇问卷) 清空
        else if ($scope.step == 7) {
            // 置空
            $scope.longQuestion =
            {
                INR: null, finishINR: 0, idINR: '',
                complication: null, finishComplication: 0, idComplication: '',
                drug: null, finishDrug: 0, idDrug: '',
                life: null, finishLife: 0, idLife: '',
                diet: null,
                weight: null
            };

            // 置空
            $scope.lq_inrList = [];
            $scope.lq_complicationList = [];
            $scope.lq_drugList = [];

            // 未开始长问卷
            $scope.isBeginLongQuestion = false;

            // 重加载INR折现图
            INRchart($scope.patientId);
            // 重检查信息
            $scope.checkMessage();

            $scope.name = "华法林抗凝管理";
            $scope.step = 0;
            slideFlupINR.slide($scope.step);
        }
        // 其他页 后退第1页
        else {
            // 重加载INR折现图
            INRchart($scope.patientId);
            // 重检查信息
            $scope.checkMessage();

            $scope.name = "华法林抗凝管理";
            $scope.step = 0;
            slideFlupINR.slide($scope.step);
        }
    }

    // 2.切换触发
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 图片
    // 1.sheet
    $scope.imgAddActionSheet = function (display) {
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(display);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(display);
                        return true;
                        break;
                }
            }
        })
    }

    // 1.1.由相册选择图片
    $scope.selectImg = function (display) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            $scope.uploadImg(imageDataList[0], display);
        }, function (err) {
        });
    }

    // 1.2.调用摄像头拍照
    $scope.cameraImg = function (display) {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData, display);
        }, function (err) {
        });
    }

    // 2.上传图片
    $scope.uploadImg = function (imageData, display) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "FlupINR" }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/uploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();

            alert(JSON.stringify(result));

            if (result.response == undefined) {
                $fwCordovaToast.showLongBottom("上传失败");
            }
            else {
                if (result.response.indexOf('上传失败') >= 0) {
                    $fwCordovaToast.showLongBottom("上传失败");
                }
                else {
                    $fwCordovaToast.showLongBottom("请等待...");

                    if (display == "INR") {
                        var index = $scope.INRImgResult.length + 1;
                        $scope.INRImgResult.push({ ID: index, SRC: result.response, DISPLAY: display });
                    }
                    else if (display == "DRUG") {
                        var index = $scope.drugImgResult.length + 1;
                        $scope.drugImgResult.push({ ID: index, SRC: result.response, DISPLAY: display });
                    }
                    else if (display == "COMPLICATION") {
                        var index = $scope.drugImgResult.length + 1;
                        $scope.complicationImgResult.push({ ID: index, SRC: result.response, DISPLAY: display });
                    }
                    else {
                        $fwCordovaToast.showLongBottom("lost display");
                    }
                }
            }
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showLongBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 3.图片保存
    $scope.SaveImg = function (recordId, display) {
        var imgStr = "";

        if (display == "INR") {
            imgStr = JSON.stringify($scope.INRImgResult);
        }
        else if (display == "DRUG") {
            imgStr = JSON.stringify($scope.drugImgResult);
        }
        else if (display == "COMPLICATION" || display == "COMPLICATION_IMG") {
            imgStr = JSON.stringify($scope.complicationImgResult);
        }
        else {
            return;
        }

        // 图片保存
        FlupINRService.saveImg($scope.vpInfo.VISIT_PATIENT_ID, recordId, display, imgStr).then(function (result) {
            if (result.result != 1) {
                $cordovaToast.showLongBottom(result.msg);
            }
        });
    }

    // 3.2 INR提交后的一些处理
    dealWithINR = function (isLatestINR) {
        // INR时间处理
        if ($scope.INR.INR_DATE == null || $scope.INR.INR_DATE == "") { }
        else {
            $scope.INR.INR_DATE = (new Date($scope.INR.INR_DATE)).Format("yyyy-MM-dd");
        }

        // 反馈时间处理
        if ($scope.INR.FEEDBACK_INR_DATE == null || $scope.INR.FEEDBACK_INR_DATE == "") { }
        else {
            $scope.INR.FEEDBACK_INR_DATE = (new Date($scope.INR.FEEDBACK_INR_DATE)).Format("yyyy-MM-dd");
        }

        // INR提示文字处理
        if ($scope.INR.INR_LEVEL == -1 || $scope.INR.INR_LEVEL == 1) {
            // 是今天的数据
            if ($scope.isSeekAdvice) {
                var text = $scope.INR.INR_LEVEL == -1 ? "低于" : "高于";

                var title = "INR数值" + text + "目标范围";
                var template = "INR数值" + text + "目标范围，建议参考调药助手，调整华法林剂量，建议下次INR检测时间：" + $scope.INR.FEEDBACK_INR_DATE + "。同时建议您在线留言医生，辅助治疗。";

                // INR危险
                if ($scope.INR.INR_IS_DANGER == 1) {

                    text = $scope.INR.INR_LEVEL == -1 ? "过低" : "过高";
                    var risk = $scope.INR.INR_LEVEL == -1 ? "血栓栓塞" : "出血";

                    title = "INR控制欠佳";
                    template = "INR控制欠佳，INR值" + text + "，具有" + risk + "的风险，建议尽快医院就诊！同时建议您在线留言医生。";

                    // 通知医生
                    sentDangerINR($scope.INR.INR_DATE, $scope.INR.INR_VALUE);
                }
            }
            // 非今日数据
            else {
                var text = $scope.INR.INR_LEVEL == -1 ? "低于" : "高于";

                var title = "INR数值" + text + "目标范围";
                var template = "INR数值" + text + "目标范围，您提交的INR检测结果为历史数据，根据最新的INR检测结果计算，建议下次INR检测时间为：" + $scope.INR.FEEDBACK_INR_DATE;

                // INR危险 => 通知医生
                if ($scope.INR.INR_IS_DANGER == 1) {

                    text = $scope.INR.INR_LEVEL == -1 ? "过低" : "过高";
                    var risk = $scope.INR.INR_LEVEL == -1 ? "血栓栓塞" : "出血";

                    title = "INR控制欠佳";
                    template = "INR控制欠佳，INR值" + text + "，具有" + risk + "的风险，建议尽快医院就诊。您提交的INR检测结果为历史数据，根据最新的INR检测结果计算，建议下次INR检测时间为：" + $scope.INR.FEEDBACK_INR_DATE;

                    // 发危险警告
                    sentDangerINR($scope.INR.INR_DATE, $scope.INR.INR_VALUE);
                }
            }
        }
        else {
            var title = $scope.INR.INR_LEVEL == 0 ? "INR控制良好" : "INR控制稳定";
            var template = isLatestINR ? '当前INR处于目标范围，请继续保持，建议下次INR检测时间：' + $scope.INR.FEEDBACK_INR_DATE + '。'
                                                : '当前INR处于目标范围，请继续保持，您提交的INR检测结果为历史数据，以最新INR数值计算，建议下次INR检测时间为：' + $scope.INR.FEEDBACK_INR_DATE;
        }

        var alertPopup = $ionicPopup.alert({
            title: title,
            template: template,
            okText: '我知道了'
        });

        // INR水平处理
        var str = "";
        switch ($scope.INR.INR_LEVEL) {
            case -1: str = "偏低"; break;
            case 0: str = "控制良好"; break;
            case 1: str = "偏高"; break;
            case 9: str = "控制稳定"; break;
        }
        $scope.INR.INR_LEVEL = str;
    }

    // 4.图片准备删除
    $scope.showImgDelete = function (id) {
        $scope.delImgId = id;
    }

    // 4.1.图片删除
    $scope.imgDelete = function (id, display) {
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                if (display == "INR") {
                    toImgDelete(id, $scope.INRImgResult);
                }
                else if (display == "DRUG") {
                    toImgDelete(id, $scope.drugImgResult);
                }
                else if (display == "COMPLICATION" || display == "COMPLICATION_IMG") {
                    toImgDelete(id, $scope.complicationImgResult);
                }
                else {
                    $fwCordovaToast.showLongBottom("图片删除失败，图片类型不正确");
                }
            }
        });
    }

    // 4.2.图片删除
    toImgDelete = function (id, imgResult) {
        // 转录
        var result = imgResult;
        for (var i = 0; i < result.length; i++) {
            var singResult = result[i];
            if (singResult.ID == id) {
                result.splice(i, 1);
            }
        }
        // 原数组置空
        imgResult = [];
        // 重赋值
        for (var i = 0; i < result.length; i++) {
            imgResult.push({ ID: i + 1, SRC: result[i].SRC, dispaly: result[i].DISPLAY });
        }
        $fwCordovaToast.showLongBottom("删除成功！");
    }

    // 日期选择
    $scope.datePicker = function (target, type, minDate, maxDate) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        if (minDate != undefined || minDate != null) {
            options.minDate = minDate;
        }

        if (maxDate != undefined || maxDate != null) {
            options.maxDate = maxDate;
        }

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
});