﻿angular.module('fwapp.controllers')

.controller('HealthController', function ($scope, $rootScope, $stateParams, $state, $timeout, $interval, $sce,
 $ionicPopover, $ionicModal, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet, $cordovaDatePicker, $cordovaInAppBrowser,$cordovaDatePicker, $fwCordovaToast,
 AccountService, HealthService, VisitPatientService) {

    // 检查登录状态
    $rootScope.checkLogin();

    if ($stateParams.titleName != null && $stateParams.titleName.length > 0) {
        $scope.titleName = $stateParams.titleName;
    } else {
        $scope.titleName = "健康记录";
    }
    $scope.tabName = "记录";
    //血压记录
    $scope.bp = {
        newSBP: "",
        newDBP: "",
        modifySBP: "",
        modifyDBP: "",
        bpid: "",
        measureTime: ""
    };
    //心率记录
    $scope.hr = {
        newRate: "",
        modifyRate: "",
        hrid: "",
        measureTime: ""
    };
    //特殊事件
    $scope.se = {
        symptoms: "",
        appearedTime: "",
        seid: "",
        durationHour: "",
        durationMinute: "",
        relieveMethod: ""
    }
    // cfw 2022年6月8日08:33:47 透析记录
    $scope.txjl = {};
    // 身高体重
    $scope.hw = {
        newHeight: "",
        newWeight: "",
        modifyHeight: "",
        modifyWeight: "",
        htid: "",
        measureTime: ""
    };
    // 血糖
    $scope.bg = {
        newGlu: "",
        modifyGlu: "",
        bgid: "",
        measureTime: "",
        timeArea: ""
    };
    // 步数
    $scope.stepRecord = {
        newStep: "",
        modifyStep: "",
        stepid: "",
        measureTime: ""
    };
    // ECG心电测量
    $scope.er = {
        ecgType: "",
        avgHeartRate: "",
        ecgArrhythmiaType: "",
        userStmptom: "",
        samplingFrequency: "",
        measureTime: ""
    };
    //血压记录列表
    //$scope.BloodPressureList = new Object();
    //心率记录列表
    //$scope.HeartRateList = new Object();
    //特殊事件列表
    $scope.SpecialEventList = new Object();
    //cfw 2022年6月8日08:30:53 透析记录列表
    $scope.DialysisList = new Object();
    // 身高体重列表
    $scope.HeightWeightList = new Object();
    // 血糖列表
    //$scope.BloodGlucoseList = new Object();
    // 步数列表
    $scope.stepRecordList = new Object();
    // 血氧列表
    //$scope.BloodOxygenList = new Object();
    // ECG心电测量列表
    $scope.EcgRecordList = new Object();
    // 心率月份数据
    $scope.HeartRateMonthData = {};
    // 心率日期数据
    $scope.HeartRateDateData = {};
    // 近期心率数据
    $scope.RecentHeartRate = {};
    // 血压月份数据
    $scope.BloodPressureMonthData = {};
    // 血压日期数据
    $scope.BloodPressureDateData = {};
    // 近期血压数据
    $scope.RecentBloodPressure = {};
    // 血糖月份数据
    $scope.BloodGlucoseMonthData = {};
    // 血糖日期数据
    $scope.BloodGlucoseDateData = {};
    // 近期血糖数据
    $scope.RecentBloodGlucose = {};
    // 血氧月份数据
    $scope.BloodOxygenMonthData = {};
    // 血氧日期数据
    $scope.BloodOxygenDateData = {};
    // 近期血氧数据
    $scope.RecentBloodOxygen = {};
    // 数据列表
    $scope.dateList = {};
    // 数据坐标
    $scope.monthIndex;
    $scope.dateIndex;
    // 数据时间
    $scope.dateStr;
    $scope.preNotice;
    // 用户须知倒计时
    $scope.confirmCountdown = 5;
    // 获取中
    $scope.isLoadHeartRateMonthFinish = false;
    $scope.isLoadBloodPressureMonthFinish = false;
    $scope.isLoadBloodGlucoseMonthFinish = false;
    $scope.isLoadBloodOxygenMonthFinish = false;
    $scope.isLoadEcgFinish = false;
    $scope.isLoadStepFinish = false;
    $scope.isLoadHeightWeightFinish = false;

    // 数据为空
    $scope.isHeartRateMonthNull = false;
    $scope.isBloodPressureMonthNull = false;
    $scope.isBloodGlucoseMonthNull = false;
    $scope.isBloodOxygenMonthNull = false;
    $scope.isEcgNull = false;
    $scope.isStepNull = false;
    $scope.isHeightWeightNull = false;
    $scope.privacyStatus = 2;
    // 个人资料显示权限
    $scope.personalDataShow = false;

    // 访问授权接口次数（首次访问且授权过期，引导用户重新授权）
    $scope.AuthNum = 0;

    // 心率月份下拉方法
    $scope.showHeartRateMonthData = function (month) {
        $scope.loadHeartRateDateList(month);
        // 1 折叠 0 展开
        if ($scope.HeartRateMonthData.find(i => i.MONTH == month).MONTH_SHOW == 1) {
            $scope.HeartRateMonthData.find(i => i.MONTH == month).MONTH_SHOW = 0;
        }
        else {
            $scope.HeartRateMonthData.find(i => i.MONTH == month).MONTH_SHOW = 1;
        }
    }
    // 心率日期列表modal
    $ionicModal.fromTemplateUrl('heart-rate.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.heartRateModal = modal;
    });
    // 打开心率日期列表modal
    $scope.openHeartRateDateDataModal = function (date) {
        $scope.heartRateModal.show();
        $scope.loadHeartRateList(date);

        let _month_index = $scope.HeartRateMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.HeartRateDateData[_month_index].findIndex(i => i.DAY == date);
        $scope.dateList = $scope.HeartRateDateData[_month_index][_index].chilren;

        $scope.monthIndex = _month_index;
        $scope.dateIndex = _index;
    }
    // 关闭心率日期列表modal
    $scope.closeHeartRateDateDataModal = function () {
        $scope.dateList = {};
        $scope.heartRateModal.hide();
    }

    // 血压月份下拉方法
    $scope.showBloodPressureMonthData = function (month) {
        $scope.loadBloodPressureDateList(month);
        // 1 折叠 0 展开
        if ($scope.BloodPressureMonthData.find(i => i.MONTH == month).MONTH_SHOW == 1) {
            $scope.BloodPressureMonthData.find(i => i.MONTH == month).MONTH_SHOW = 0;
        }
        else {
            $scope.BloodPressureMonthData.find(i => i.MONTH == month).MONTH_SHOW = 1;
        }
    }
    // 血压日期列表modal
    $ionicModal.fromTemplateUrl('blood-pressure.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.bloodPressureModal = modal;
    });
    // 打开血压日期列表modal
    $scope.openBloodPressureDateDataModal = function (date) {
        $scope.bloodPressureModal.show();
        $scope.loadBloodPressureList(date);

        let _month_index = $scope.BloodPressureMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodPressureDateData[_month_index].findIndex(i => i.DAY == date);
        $scope.dateList = $scope.BloodPressureDateData[_month_index][_index].chilren;

        $scope.monthIndex = _month_index;
        $scope.dateIndex = _index;
    }
    // 关闭血压日期列表modal
    $scope.closeBloodPressureDateDataModal = function () {
        $scope.dateList = {};
        $scope.bloodPressureModal.hide();
    }
    // 血压日期下拉方法
    $scope.showBloodPressureDateData = function (date) {
        $scope.loadBloodPressureList(date);
        let _month_index = $scope.BloodPressureMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodPressureDateData[_month_index].findIndex(i => i.DAY == date);
        // 1 折叠 0 展开
        if ($scope.BloodPressureDateData[_month_index][_index].DATE_SHOW == 1) {
            $scope.BloodPressureDateData[_month_index][_index].DATE_SHOW = 0;
        }
        else {
            $scope.BloodPressureDateData[_month_index][_index].DATE_SHOW = 1;
        }
    }
    // 血糖月份下拉方法
    $scope.showBloodGlucoseMonthData = function (month) {
        $scope.loadBloodGlucoseDateList(month);
        // 1 折叠 0 展开
        if ($scope.BloodGlucoseMonthData.find(i => i.MONTH == month).MONTH_SHOW == 1) {
            $scope.BloodGlucoseMonthData.find(i => i.MONTH == month).MONTH_SHOW = 0;
        }
        else {
            $scope.BloodGlucoseMonthData.find(i => i.MONTH == month).MONTH_SHOW = 1;
        }
    }
    // 血糖日期列表modal
    $ionicModal.fromTemplateUrl('blood-glucose.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.bloodGlucoseModal = modal;
    });
    // 打开血糖日期列表modal
    $scope.openBloodGlucoseDateDataModal = function (date) {
        $scope.bloodGlucoseModal.show();
        $scope.loadBloodGlucoseList(date);

        let _month_index = $scope.BloodGlucoseMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodGlucoseDateData[_month_index].findIndex(i => i.DAY == date);

        $scope.dateList = $scope.BloodGlucoseDateData[_month_index][_index].chilren;

        $scope.monthIndex = _month_index;
        $scope.dateIndex = _index;
    }
    // 关闭血糖日期列表modal
    $scope.closeBloodGlucoseDateDataModal = function () {
        $scope.dateList = {};
        $scope.bloodGlucoseModal.hide();
    }
    // 血氧月份下拉方法
    $scope.showBloodOxygenMonthData = function (month) {
        $scope.loadBloodOxygenDateList(month);
        // 1 折叠 0 展开
        if ($scope.BloodOxygenMonthData.find(i => i.MONTH == month).MONTH_SHOW == 1) {
            $scope.BloodOxygenMonthData.find(i => i.MONTH == month).MONTH_SHOW = 0;
        }
        else {
            $scope.BloodOxygenMonthData.find(i => i.MONTH == month).MONTH_SHOW = 1;
        }
    }
    // 血氧日期列表modal
    $ionicModal.fromTemplateUrl('blood-oxygen.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.bloodOxygenModal = modal;
    });
    // 打开血氧日期列表modal
    $scope.openBloodOxygenDateDataModal = function (date) {
        $scope.bloodOxygenModal.show();
        $scope.loadBloodOxygenList(date);

        let _month_index = $scope.BloodOxygenMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodOxygenDateData[_month_index].findIndex(i => i.DAY == date);

        $scope.dateList = $scope.BloodOxygenDateData[_month_index][_index].chilren;

        $scope.monthIndex = _month_index;
        $scope.dateIndex = _index;
    }
    // 关闭血氧日期列表modal
    $scope.closeBloodOxygenDateDataModal = function () {
        $scope.dateList = {};
        $scope.bloodOxygenModal.hide();
    }

    // 打哪来
    $scope.from = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "menu" : "vpInfo";
    if ($stateParams.from != null && $stateParams.from.length != 0) {
        $scope.from = $stateParams.from;
    }
    // 就诊人ID
    $scope.vpId = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "" : $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 用户信息
    $scope.accountInfo = new Object();

    $scope.vpList = new Object();

    var nowDate = new Date();
    var day = nowDate.getDate();
    var month = nowDate.getMonth() + 1;
    var year = nowDate.getFullYear();

    //标题
    $scope.titleList = [
        { name: '血压' },
        { name: '心率' },
        { name: '特殊事件' },
        { name: '身高体重' },
        { name: '血糖' },
        // 2022-7-15 20:16:08 CGZ 透析记录上线
        // 2022-8-17 11:10:46 CGZ 按于飞要求“透析记录”更名为“透前信息”
        { name: '透前信息' }
    ]

    $scope.chartType = {
        bp: "byDay",
        hr: "byDay",
        hw: "byDay",
        bg: "byDay",
        stepRecord: "byDay",
        bo: "byDay"
    }

    //cfw 透析记录号
    $scope.txjl_DIALYSIS_RECORD_ID = "";
    $scope.txjl_buttonName = "";

    // 建议list
    $scope.hlthAdviceList = [];

    // 心脑血管病风险评估 开关
    $scope.cvdRiskServerStatus = devMode ? true : false;

    // 华为运动健康是否可点击
    $scope.hwHealthKitFlag = -1;
    // 华为的身高体重
    $scope.hwBody = {};
    $scope.url = "";
    // 刷新计时器
    $scope.refreshTimer = undefined;
    // 刷新计时器间隔毫秒
    $scope.refreshTimerInterval = 1000 * 3;

    // 初始化刷新计时器
    $scope.refreshTimerInit = function () {
        $scope.refreshTimerDestroy();
        $scope.refreshTimer = $interval(function () {
            $scope.checkHealthKitAuth();
        }, $scope.refreshTimerInterval);
        // 获取会话列表
        $scope.checkHealthKitAuth();
    }

    // 销毁刷新计时器
    $scope.refreshTimerDestroy = function () {
        if (angular.isDefined($scope.refreshTimer)) {
            $interval.cancel($scope.refreshTimer);
            $scope.refreshTimer = undefined;
        }
    }

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addBloodPressureModal.remove();
        $scope.modifyBloodPressureModal.remove();
        $scope.addHeartRateModal.remove();
        $scope.modifyHeartRateModal.remove();
        $scope.addSpecialEventModal.remove();
        $scope.modifySpecialEventModal.remove();
        $scope.AddDialysisRecordModal.remove();
        $scope.addHeightWeightModal.remove();
        $scope.modifyHeightWeightModal.remove();
        $scope.addBloodGlucoseModal.remove();
        $scope.modifyBloodGlucoseModal.remove();
        $scope.EcgRecordModal.remove();
        $scope.honorModeModal.remove();
        $scope.honorRecordModal.remove();
    })

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注册弹出菜单：标题列表
    $ionicPopover.fromTemplateUrl('title_popover.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.titlePopver = popover;
    });

    // 注册模态窗口：前置温馨提示
    $ionicModal.fromTemplateUrl('preNotice.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.preNoticeModal = modal;
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }

            // 读取就诊人信息
            $scope.loadVpInfo();
            // 读取就诊人列表
            $scope.loadVpList();

            // 获取用户信息
            AccountService.accountInfo().then(function (data) {
                if (data.result == 1) {
                    $scope.accountInfo = data.data;
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            })

            //$scope.loadBloodPressureList();

            //$scope.loadHeartRateList();

            //$scope.loadSpecialEventList();

            //cfw 2022年6月8日11:08:21 加载时获取透析记录列表
            //$scope.loadDialysis_RrecordList();

            // 2021-3-12 13:25:19 HM 应4S标准，增加健康指标
            $scope.getHlthAdvice();

            // 2022-8-23 18:06:04 HM 需要获取华为可穿戴设备
            $scope.checkHealthKitAuth();

            //$scope.loadBloodOxygenList();

            //$scope.loadEcgRecordList();

            $scope.refreshTimerInit();
        })
    });

    $scope.loadHeartRateMonthList = function () {
        $scope.isHeartRateMonthNull = false;
        $ionicLoading.show();
        HealthService.getHeartRateMonthList($scope.vpId).then(function (data) {
            if (data.result == 1) {
                // 心率月份
                $scope.HeartRateMonthData = data.data;
                // 近期心率
                $scope.RecentHeartRate = data.rhr;
                $scope.isLoadHeartRateMonthFinish = true;
                if (data.data.length == 0) {
                    $scope.isHeartRateMonthNull = true;
                }
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadHeartRateDateList = function (month) {
        $ionicLoading.show();
        HealthService.getHeartRateDateList($scope.vpId, month).then(function (data) {
            if (data.result == 1) {
                let index = $scope.HeartRateMonthData.findIndex(i => i.MONTH == month);
                $scope.HeartRateDateData[index] = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodPressureMonthList = function () {
        $scope.isBloodPressureMonthNull = false;
        $ionicLoading.show();
        HealthService.getBloodPressureMonthList($scope.vpId).then(function (data) {
            if (data.result == 1) {
                // 血压月份
                $scope.BloodPressureMonthData = data.data;
                // 近期血压
                $scope.RecentBloodPressure = data.rbp;
                $scope.isLoadBloodPressureMonthFinish = true;
                if (data.data.length == 0) {
                    $scope.isBloodPressureMonthNull = true;
                }
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodPressureDateList = function (month) {
        $ionicLoading.show();
        HealthService.getBloodPressureDateList($scope.vpId, month).then(function (data) {
            if (data.result == 1) {
                let index = $scope.BloodPressureMonthData.findIndex(i => i.MONTH == month);
                $scope.BloodPressureDateData[index] = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodGlucoseMonthList = function () {
        $scope.isBloodGlucoseMonthNull = false;
        $ionicLoading.show();
        HealthService.getBloodGlucoseMonthList($scope.vpId).then(function (data) {
            if (data.result == 1) {
                // 血糖月份
                $scope.BloodGlucoseMonthData = data.data;
                // 近期血糖
                $scope.RecentBloodGlucose = data.rbg;
                $scope.isLoadBloodGlucoseMonthFinish = true;
                if (data.data.length == 0) {
                    $scope.isBloodGlucoseMonthNull = true;
                }
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodGlucoseDateList = function (month) {
        $ionicLoading.show();
        HealthService.getBloodGlucoseDateList($scope.vpId, month).then(function (data) {
            if (data.result == 1) {
                let index = $scope.BloodGlucoseMonthData.findIndex(i => i.MONTH == month);
                $scope.BloodGlucoseDateData[index] = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodOxygenMonthList = function () {
        $scope.isBloodOxygenMonthNull = false;
        $ionicLoading.show();
        HealthService.getBloodOxygenMonthList($scope.vpId).then(function (data) {
            if (data.result == 1) {
                // 血氧月份
                $scope.BloodOxygenMonthData = data.data;
                // 近期血氧
                $scope.RecentBloodOxygen = data.rbo;
                $scope.isLoadBloodOxygenMonthFinish = true;
                if (data.data.length == 0) {
                    $scope.isBloodOxygenMonthNull = true;
                }
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodOxygenDateList = function (month) {
        HealthService.getBloodOxygenDateList($scope.vpId, month).then(function (data) {
            if (data.result == 1) {
                let index = $scope.BloodOxygenMonthData.findIndex(i => i.MONTH == month);
                $scope.BloodOxygenDateData[index] = data.data;
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadBloodPressureList = function (date) {
        $ionicLoading.show();
        let _month_index = $scope.BloodPressureMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodPressureDateData[_month_index].findIndex(i => i.DAY == date);
        $scope.dateStr = $scope.BloodPressureDateData[_month_index][_index].DAY;

        // 1 折叠 0 展开
        let _show = $scope.BloodPressureDateData[_month_index][_index].DATE_SHOW;
        // 数据默认从第1页开始取
        let _pageNum = _show ? 1 : $scope.BloodPressureDateData[_month_index][_index].chilren.pageNum + 1;
        HealthService.getBloodPressureList($scope.vpId, date, date, _pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.BloodPressureDateData[_month_index][_index].chilren = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadHeartRateList = function (date) {
        $ionicLoading.show();
        let _month_index = $scope.HeartRateMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.HeartRateDateData[_month_index].findIndex(i => i.DAY == date);
        $scope.dateStr = $scope.HeartRateDateData[_month_index][_index].DAY;

        // 1 折叠 0 展开
        let _show = $scope.HeartRateDateData[_month_index][_index].DATE_SHOW;
        // 数据默认从第1页开始取
        let _pageNum = _show == 1 ? 1 : $scope.HeartRateDateData[_month_index][_index].chilren.pageNum + 1;

        HealthService.getHeartRateList($scope.vpId, date, date, _pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.HeartRateDateData[_month_index][_index].chilren = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    $scope.loadSpecialEventList = function () {
        HealthService.getSpecialEventList($scope.vpId).then(function (data) {
            $scope.SpecialEventList = data.ds;
            //console.log(data.ds);
        });
    }

    //cfw 2022年6月8日11:06:21 获取透析记录列表
    $scope.loadDialysis_RrecordList = function () {
        HealthService.getDialysis_RrecordList($scope.vpId).then(function (data) {
            $scope.DialysisList = data.ds;
        });
    }

    // 获取身高体重记录
    $scope.loadHeightWeightList = function () {
        HealthService.getHeightWeightList($scope.vpId).then(function (data) {
            $scope.HeightWeightList = data.ds;
            $scope.isLoadHeightWeightFinish = true;
            if (data.data.length == 0) {
                $scope.isBloodOxygenMonthNull = true;
            }
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();
        });
    }

    // 获取血糖记录
    $scope.loadBloodGlucoseList = function (date) {
        $ionicLoading.show();
        let _month_index = $scope.BloodGlucoseMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodGlucoseDateData[_month_index].findIndex(i => i.DAY == date);
        $scope.dateStr = $scope.BloodGlucoseDateData[_month_index][_index].DAY;
        // 1 折叠 0 展开
        let _show = $scope.BloodGlucoseDateData[_month_index][_index].DATE_SHOW;
        // 数据默认从第1页开始取
        let _pageNum = _show == 1 ? 1 : $scope.BloodGlucoseDateData[_month_index][_index].chilren.pageNum + 1;
        HealthService.getBloodGlucoseList($scope.vpId, date, date, _pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.BloodGlucoseDateData[_month_index][_index].chilren = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    // 获取步数记录
    $scope.loadStepRecordList = function () {
        HealthService.getStepRecordList($scope.vpId).then(function (data) {
            $scope.stepRecordList = data.ds;
            $scope.isLoadStepFinish = true;
            if (data.ds.length == 0) {
                $scope.isStepNull = true;
            }
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();
        })
    }

    // 获取血氧记录
    $scope.loadBloodOxygenList = function (date) {
        $ionicLoading.show();
        let _month_index = $scope.BloodOxygenMonthData.findIndex(i => i.MONTH == date.substring(0, 7));
        let _index = $scope.BloodOxygenDateData[_month_index].findIndex(i => i.DAY == date);
        $scope.dateStr = $scope.BloodOxygenDateData[_month_index][_index].DAY;
        // 1 折叠 0 展开
        let _show = $scope.BloodOxygenDateData[_month_index][_index].DATE_SHOW;
        // 数据默认从第1页开始取
        let _pageNum = _show == 1 ? 1 : $scope.BloodOxygenDateData[_month_index][_index].chilren.pageNum + 1;
        HealthService.getBloodOxygenList($scope.vpId, date, date, _pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.BloodOxygenDateData[_month_index][_index].chilren = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    // 获取ECG心电测量记录
    $scope.loadEcgRecordList = function () {
        HealthService.getEcgRecordList($scope.vpId).then(function (data) {
            $scope.EcgRecordList = data.ds;
            $scope.isLoadEcgFinish = true;
            if (data.ds.length == 0) {
                $scope.isEcgNull = true;
            }
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();
        });
    }

    //读取就诊人信息
    $scope.loadVpInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log(data);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid
        $scope.vpInfo = new Object();
        $scope.loadVpInfo();
        $scope.popVplist.hide();
        $scope.getHlthAdvice();

        // 切换就诊人先将访问全权限次数置为0
        $scope.AuthNum = 0;
        // 2022-8-23 18:05:19 HM 切换就诊人就要重新获取华为运动健康授权
        $scope.checkHealthKitAuth();

        if ($scope.titleName == "血压") {
            $scope.loadBloodPressureMonthList();
            if ($scope.tabName == '趋势') {
                chartBloodPressure();
            }
        } else if ($scope.titleName == "心率") {
            $scope.loadHeartRateMonthList();
            if ($scope.tabName == '趋势') {
                chartHeartRate();
            }
        } else if ($scope.titleName == "特殊事件") {
            $scope.loadSpecialEventList();
        } else if ($scope.titleName == "身高体重") {
            $scope.loadHeightWeightList();
            if ($scope.tabName == '趋势') {
                chartHeightWeight();
            }
        } else if ($scope.titleName == "血糖") {
            $scope.loadBloodGlucoseMonthList();
            if ($scope.tabName == '趋势') {
                chartBloodGlucose();
            }
        // 2022-8-17 11:10:46 CGZ 按于飞要求“透析记录”更名为“透前信息”
        } else if ($scope.titleName == "透前信息") {
            $scope.loadDialysis_RrecordList();
        } else if ($scope.titleName == "步数记录") {
            $scope.loadStepRecordList();
            if ($scope.tabName == "趋势") {
                chartStepRecord();
            }
        } else if ($scope.titleName == "血氧") {
            $scope.loadBloodOxygenMonthList();
            if ($scope.tabName == '趋势') {
                chartBloodOxygen();
            }
        } else if ($scope.titleName == "心电测试") {
            $scope.loadEcgRecordList();
        } else {
            $scope.loadBloodPressureMonthList();
            $scope.loadHeartRateMonthList();
            $scope.loadSpecialEventList();
            $scope.loadDialysis_RrecordList();
            $scope.loadHeightWeightList();
            $scope.loadBloodGlucoseMonthList();
            $scope.loadStepRecordList();
            $scope.loadBloodOxygenMonthList();
            $scope.loadEcgRecordList();
            chartHeartRate();
            chartBloodPressure();
            chartHeightWeight();
            chartBloodGlucose();
            chartStepRecord();
            chartBloodOxygen();
        }
    }

    // 切换标题/类型
    $scope.changeTitle = function (titleName) {
        $scope.titleName = titleName;
        $scope.titlePopver.hide();

        $scope.changeVp($scope.vpId);
    }

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 显示弹出菜单
    $scope.openTitlePopover = function ($event) {
        $scope.titlePopver.show($event);
    }

    //血压
    //添加血压modal
    $ionicModal.fromTemplateUrl('add-blood-pressure.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.addBloodPressureModal = modal;
    });
    //打开添加血压modal
    $scope.openAddBloodPressureModal = function () {
        $scope.bp.newSBP = "";
        $scope.bp.newDBP = "";
        $scope.addBloodPressureModal.show();
        //var dtNow = new Date();
        //var dtNowString = dtNow.getFullYear() + "-" + (dtNow.getMonth() + 1) + "-" + dtNow.getDate() + " " + dtNow.getHours() + ":" + dtNow.getMinutes()
        $scope.bp.measureTime = "";
    }
    //关闭添加血压modal
    $scope.closeAddBloodPressureModal = function () {
        $scope.addBloodPressureModal.hide();
    }
    //添加血压记录
    $scope.AddBloodPressure = function () {
        //console.log("newSBP:" + $scope.bp.newSBP + "    newDBP:" + $scope.bp.newDBP);
        if ($scope.bp.newSBP == "" || $scope.bp.newDBP == "" || $scope.bp.newSBP == null || $scope.bp.newDBP == null) {
            $fwCordovaToast.showShortBottom("请填写高压和低压");
        } else if ($scope.bp.measureTime == "") {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            HealthService.addBloodPressure($scope.vpId, $scope.bp.newSBP, $scope.bp.newDBP, $scope.bp.measureTime).then(function (data) {
                if (data.code == 1) {
                    $scope.addBloodPressureModal.hide();
                    $scope.loadBloodPressureMonthList();
                } else if (data.code == 0) {

                }

                $fwCordovaToast.showShortBottom(data.msg);
            });
        }
    }

    //修改血压modal
    $ionicModal.fromTemplateUrl('modify-blood-pressure.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modifyBloodPressureModal = modal;
    });
    //打开修改血压modal
    $scope.openModifyBloodPressureModal = function (bpid, sbp, dbp, measureTime, dataSource) {
        if (dataSource == 'HEALTH_KIT') {
            return;
        }
        $scope.modifyBloodPressureModal.show();
        $scope.bp.bpid = bpid;
        $scope.bp.modifySBP = parseInt(sbp);
        $scope.bp.modifyDBP = parseInt(dbp);
        $scope.bp.measureTime = measureTime;
    }
    //关闭修改血压modal
    $scope.closeModifyBloodPressureModal = function () {
        $scope.modifyBloodPressureModal.hide();
    }
    //修改血压记录
    $scope.ModifyBloodPressure = function () {
        if ($scope.bp.modifySBP == "" || $scope.bp.modifyDBP == "" || $scope.bp.modifySBP == null || $scope.bp.modifyDBP == null) {
            $fwCordovaToast.showShortBottom("请填写高压和低压");
        } else if ($scope.bp.measureTime == "") {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            HealthService.modifyBloodPressure($scope.bp.bpid, $scope.bp.modifySBP, $scope.bp.modifyDBP, $scope.bp.measureTime).then(function (data) {
                if (data.code == 1) {
                    $scope.modifyBloodPressureModal.hide();
                    $scope.loadBloodPressureList($scope.dateStr);
                    $scope.loadBloodPressureMonthList();
                } else if (data.code == 0) {

                }

                $fwCordovaToast.showShortBottom(data.msg);
            });
        }
    }
    //删除血压记录
    $scope.DeleteBloodPressure = function () {
        var confirmBpPopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除本条血压记录',
            cancelText: '取消',
            okText: '删除'
        });

        confirmBpPopup.then(function (res) {
            if (res) {
                HealthService.deleteBloodPressure($scope.bp.bpid, 0).then(function (data) {
                    if (data.code == 1) {
                        $scope.modifyBloodPressureModal.hide();
                        $scope.loadBloodPressureList($scope.dateStr);
                        $scope.loadBloodPressureMonthList();
                    } else if (data.code == 0) {

                    }

                    $fwCordovaToast.showShortBottom(data.msg);
                });
            }
            else {

            }
        });
    }
    //长按出菜单删除
    $scope.onHoldBp = function (bpid, dataSource) {
        if (dataSource == 'HEALTH_KIT') {
            return;
        }
        var ActionSheetBp = $ionicActionSheet.show({
            destructiveText: '删除',
            cancelText: '取消',
            destructiveButtonClicked: function () {
                ActionSheetBp();

                var confirmBpPopup = $ionicPopup.confirm({
                    title: '确认删除',
                    template: '是否确认删除本条血压记录',
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmBpPopup.then(function (res) {
                    if (res) {
                        HealthService.deleteBloodPressure(bpid, '-1').then(function (data) {
                            if (data.code == 1) {
                                $scope.modifyBloodPressureModal.hide();
                                $scope.loadBloodPressureList($scope.dateStr);
                                $scope.loadBloodPressureMonthList();
                            } else if (data.code == 0) {

                            }

                            $fwCordovaToast.showShortBottom(data.msg);
                        });
                    }
                    else {

                    }
                });
            }
        });
    }

    //心率
    //添加心率modal
    $ionicModal.fromTemplateUrl('add-heart-rate.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.addHeartRateModal = modal;
    });
    //打开添加心率modal
    $scope.openAddHeartRateModal = function () {
        $scope.hr.newRate = "";
        $scope.addHeartRateModal.show();
        //var dtNow = new Date();
        //var dtNowString = dtNow.getFullYear() + "-" + (dtNow.getMonth() + 1) + "-" + dtNow.getDate() + " " + dtNow.getHours() + ":" + dtNow.getMinutes()
        $scope.hr.measureTime = "";
    }
    //关闭添加心率modal
    $scope.closeAddHeartRateModal = function () {
        $scope.addHeartRateModal.hide();
    }
    //添加心率记录
    $scope.AddHeartRate = function () {
        if ($scope.hr.newRate == "" || $scope.hr.newRate == null) {
            $fwCordovaToast.showShortBottom("请填写心率");
        } else if ($scope.hr.measureTime == "" || $scope.hr.measureTime == null) {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            HealthService.addHeartRate($scope.vpId, $scope.hr.newRate, $scope.hr.measureTime).then(function (data) {
                if (data.code == 1) {
                    $scope.addHeartRateModal.hide();
                    $scope.loadHeartRateMonthList();
                } else if (data.code == 0) {

                }
                $fwCordovaToast.showShortBottom(data.msg);
            });
        }
    }

    //修改心率modal
    $ionicModal.fromTemplateUrl('modify-heart-rate.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modifyHeartRateModal = modal;
    });
    //打开修改心率modal
    $scope.openModifyHeartRateModal = function (hrid, rate, measureTime, dataSource) {
        if (dataSource == 'HEALTH_KIT') {
            return;
        }
        $scope.modifyHeartRateModal.show();
        $scope.hr.hrid = hrid;
        $scope.hr.modifyRate = parseInt(rate);
        $scope.hr.measureTime = measureTime;
    }
    //关闭修改心率modal
    $scope.closeModifyHeartRateModal = function () {
        $scope.modifyHeartRateModal.hide();
    }
    //修改心率记录
    $scope.ModifyHeartRate = function () {
        if ($scope.hr.modifyRate == "" || $scope.hr.modifyRate == null) {
            $fwCordovaToast.showShortBottom("请填写心率");
        } else if ($scope.hr.measureTime == "" || $scope.hr.measureTime == null) {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            HealthService.modifyHeartRate($scope.hr.hrid, $scope.hr.modifyRate, $scope.hr.measureTime).then(function (data) {
                if (data.code == 1) {
                    $scope.modifyHeartRateModal.hide();
                    $scope.loadHeartRateList($scope.dateStr);
                    $scope.loadHeartRateMonthList();
                } else if (data.code == 0) {

                }

                $fwCordovaToast.showShortBottom(data.msg);
            });
        }
    }
    //删除心率记录
    $scope.DeleteHeartRate = function () {
        var confirmHrPopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除本条心率记录',
            cancelText: '取消',
            okText: '删除'
        });

        confirmHrPopup.then(function (res) {
            if (res) {
                HealthService.deleteHeartRate($scope.hr.hrid, 0).then(function (data) {
                    if (data.code == 1) {
                        $scope.modifyHeartRateModal.hide();
                        $scope.loadHeartRateList($scope.dateStr);
                        $scope.loadHeartRateMonthList();
                    } else if (data.code == 0) {

                    }
                    $fwCordovaToast.showShortBottom(data.msg);
                });
            } else {

            }
        });
    }

    //长按出菜单删除
    $scope.onHoldHr = function (hrid, dataSource) {
        if (dataSource == 'HEALTH_KIT') {
            return;
        }
        var ActionSheetHr = $ionicActionSheet.show({
            destructiveText: '删除',
            cancelText: '取消',
            destructiveButtonClicked: function () {
                ActionSheetHr();

                var confirmHrPopup = $ionicPopup.confirm({
                    title: '确认删除',
                    template: '是否确认删除本条心率记录',
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmHrPopup.then(function (res) {
                    if (res) {
                        HealthService.deleteHeartRate(hrid, '-1').then(function (data) {
                            if (data.code == 1) {
                                $scope.modifyHeartRateModal.hide();
                                $scope.loadHeartRateList($scope.dateStr);
                                $scope.loadHeartRateMonthList();
                            } else if (data.code == 0) {

                            }

                            $fwCordovaToast.showShortBottom(data.msg);
                        });
                    } else {

                    }
                });
            }
        });
    }

    // 搜索更多心率
    $scope.searchMoreHeartRate = function (monthIndex, dateIndex) {
        $scope.searchHeartRateSubmit(true, monthIndex, dateIndex);
    }
    // 搜索提交心率
    $scope.searchHeartRateSubmit = function (isMore, monthIndex, dateIndex) {
        $ionicLoading.show();
        // 获取更多
        if (isMore) {
            // 保证页码不超过总页数
            if ($scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageNum < $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageCount) {
                $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageNum++;
            }
            else {
                return;
            }
        }
        // 重新加载
        else {
            $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageNum = 1;
        }
        HealthService.getHeartRateList($scope.vpId, $scope.dateStr, $scope.dateStr, $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 获取更多
                if (isMore) {
                    $scope.HeartRateDateData[monthIndex][dateIndex].chilren.totalCount = data.data.totalCount;
                    $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageCount = data.data.pageCount;
                    $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageNum = data.data.pageNum;
                    $scope.HeartRateDateData[monthIndex][dateIndex].chilren.pageSize = data.data.pageSize;
                    for (var i in data.data.page) {
                        $scope.HeartRateDateData[monthIndex][dateIndex].chilren.page.push(data.data.page[i]);
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                // 首次获取
                else {
                    $scope.HeartRateDateData[monthIndex][dateIndex].chilren = {};
                    $scope.HeartRateDateData[monthIndex][dateIndex].chilren = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();

            //console.log(data.ds);
            //$fwCordovaToast.showShortBottom(data.ds);
        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
    }

    // 搜索更多血压
    $scope.searchMoreBloodPressure = function (monthIndex, dateIndex) {
        $scope.searchBloodPressureSubmit(true, monthIndex, dateIndex);
    }
    // 搜索提交血压
    $scope.searchBloodPressureSubmit = function (isMore, monthIndex, dateIndex) {
        $ionicLoading.show();
        // 获取更多
        if (isMore) {
            // 保证页码不超过总页数
            if ($scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageNum < $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageCount) {
                $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageNum++;
            }
            else {
                return;
            }
        }
        // 重新加载
        else {
            $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageNum = 1;
        }
        HealthService.getBloodPressureList($scope.vpId, $scope.dateStr, $scope.dateStr, $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 获取更多
                if (isMore) {
                    $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.totalCount = data.data.totalCount;
                    $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageCount = data.data.pageCount;
                    $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageNum = data.data.pageNum;
                    $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.pageSize = data.data.pageSize;
                    for (var i in data.data.page) {
                        $scope.BloodPressureDateData[monthIndex][dateIndex].chilren.page.push(data.data.page[i]);
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                // 首次获取
                else {
                    $scope.BloodPressureDateData[monthIndex][dateIndex].chilren = {};
                    $scope.BloodPressureDateData[monthIndex][dateIndex].chilren = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();

        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
    }

    // 搜索更多血氧
    $scope.searchMoreBloodOxygen = function (monthIndex, dateIndex) {
        $scope.searchBloodOxygenSubmit(true, monthIndex, dateIndex);
    }
    // 搜索提交血氧
    $scope.searchBloodOxygenSubmit = function (isMore, monthIndex, dateIndex) {
        $ionicLoading.show();
        // 获取更多
        if (isMore) {
            // 保证页码不超过总页数
            if ($scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageNum < $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageCount) {
                $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageNum++;
            }
            else {
                return;
            }
        }
        // 重新加载
        else {
            $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageNum = 1;
        }
        HealthService.getBloodOxygenList($scope.vpId, $scope.dateStr, $scope.dateStr, $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 获取更多
                if (isMore) {
                    $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.totalCount = data.data.totalCount;
                    $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageCount = data.data.pageCount;
                    $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageNum = data.data.pageNum;
                    $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.pageSize = data.data.pageSize;
                    for (var i in data.data.page) {
                        $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren.page.push(data.data.page[i]);
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                // 首次获取
                else {
                    $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren = {};
                    $scope.BloodOxygenDateData[monthIndex][dateIndex].chilren = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();

        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
    }

    // 搜索更多血糖
    $scope.searchMoreBloodGlucose = function (monthIndex, dateIndex) {
        $scope.searchBloodGlucoseSubmit(true, monthIndex, dateIndex);
    }
    // 搜索提交血糖
    $scope.searchBloodGlucoseSubmit = function (isMore, monthIndex, dateIndex) {
        $ionicLoading.show();
        // 获取更多
        if (isMore) {
            // 保证页码不超过总页数
            if ($scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageNum < $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageCount) {
                $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageNum++;
            }
            else {
                return;
            }
        }
        // 重新加载
        else {
            $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageNum = 1;
        }
        HealthService.getBloodGlucoseList($scope.vpId, $scope.dateStr, $scope.dateStr, $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageNum).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 获取更多
                if (isMore) {
                    $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.totalCount = data.data.totalCount;
                    $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageCount = data.data.pageCount;
                    $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageNum = data.data.pageNum;
                    $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.pageSize = data.data.pageSize;
                    for (var i in data.data.page) {
                        $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren.page.push(data.data.page[i]);
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.$broadcast('scroll.refreshComplete');
                }
                // 首次获取
                else {
                    $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren = {};
                    $scope.BloodGlucoseDateData[monthIndex][dateIndex].chilren = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();

        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
    }

    //特殊事件
    //添加特殊事件modal
    $ionicModal.fromTemplateUrl('add-special-event.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.addSpecialEventModal = modal;
    });
    //打开添加特殊事件modal
    $scope.openAddSpecialEventModal = function () {
        $scope.se.symptoms = "";
        $scope.se.appearedTime = "";
        $scope.se.seid = "";
        $scope.se.durationHour = "";
        $scope.se.durationMinute = "";
        $scope.se.relieveMethod = "";

        $scope.addSpecialEventModal.show();
        //var dtNow = new Date();
        //var dtNowString = dtNow.getFullYear() + "-" + (dtNow.getMonth() + 1) + "-" + dtNow.getDate() + " " + dtNow.getHours() + ":" + dtNow.getMinutes()
        //$scope.se.appearedTime = dtNowString;
    }
    //关闭添加特殊事件modal
    $scope.closeAddSpecialEventModal = function () {
        $scope.addSpecialEventModal.hide();
    }
    //添加特殊事件记录
    $scope.AddSpecialEvent = function () {
        if ($scope.se.symptoms == "" || $scope.se.symptoms == null) {
            $fwCordovaToast.showShortBottom("请填写症状");
        } else if ($scope.se.appearedTime == "" || $scope.se.appearedTime == null) {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            //console.log($scope.se.durationHour.length);
            //console.log($scope.se.durationMinute.length);
            //if ($scope.se.durationHour.length <= 0) {
            //    $fwCordovaToast.showShortBottom("请填写小时数");
            //} else if ($scope.se.durationMinute.length <= 0) {
            //    $fwCordovaToast.showShortBottom("请填写分钟数");
            //} else {

            try {
                if (parseInt($scope.se.durationMinute) <= 60 && parseInt($scope.se.durationMinute) >= 0) {
                    HealthService.addSpecialEvent($scope.vpId, $scope.se.symptoms, $scope.se.durationHour, $scope.se.durationMinute, $scope.se.relieveMethod, $scope.se.appearedTime).then(function (data) {
                        if (data.code == 1) {
                            $scope.addSpecialEventModal.hide();
                            $scope.loadSpecialEventList();
                        } else if (data.code == 0) {

                        }

                        $fwCordovaToast.showShortBottom(data.msg);
                    });
                } else {
                    $fwCordovaToast.showShortBottom("分钟数必须为0-60之间的整数");
                }
            } catch (err) {
                console.log(err);
                $fwCordovaToast.showShortBottom("请填写小时数和分钟数");
            }
            //}
        }
    }

    //修改特殊事件modal
    $ionicModal.fromTemplateUrl('modify-special-event.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modifySpecialEventModal = modal;
    });
    //打开修改特殊事件modal
    $scope.openModifySpecialEventModal = function (seid, symptoms, appearedTime, durationHour, durationMinute, relieveMethod) {
        $scope.modifySpecialEventModal.show();
        $scope.se.seid = seid;
        $scope.se.symptoms = symptoms;
        $scope.se.appearedTime = appearedTime;
        $scope.se.durationHour = parseInt(durationHour);
        $scope.se.durationMinute = parseInt(durationMinute);
        $scope.se.relieveMethod = relieveMethod;
    }
    //关闭修改特殊事件modal
    $scope.closeSpecialEventModal = function () {
        $scope.modifySpecialEventModal.hide();
    }
    //修改特殊事件记录
    $scope.ModifySpecialEvent = function () {
        if ($scope.se.symptoms == "" || $scope.se.symptoms == null) {
            $fwCordovaToast.showShortBottom("请填写症状");
        } else if ($scope.se.appearedTime == "" || $scope.se.appearedTime == null) {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            //if ($scope.se.durationHour.length <= 0) {
            //    $fwCordovaToast.showShortBottom("请填写小时数");
            //} else if ($scope.se.durationMinute.length <= 0) {
            //    $fwCordovaToast.showShortBottom("请填写分钟数");
            //} else {
            try {
                if (parseInt($scope.se.durationMinute) <= 60 && parseInt($scope.se.durationMinute) >= 0) {
                    HealthService.modifySpecialEvent($scope.se.seid, $scope.se.symptoms, $scope.se.durationHour, $scope.se.durationMinute, $scope.se.relieveMethod, $scope.se.appearedTime).then(function (data) {
                        if (data.code == 1) {
                            $scope.modifySpecialEventModal.hide();
                            $scope.loadSpecialEventList();
                        } else if (data.code == 0) {

                        }

                        $fwCordovaToast.showShortBottom(data.msg);
                    });
                } else {
                    $fwCordovaToast.showShortBottom("分钟数必须为0-60之间的整数");
                }
            } catch (err) {
                console.log(err);
                $fwCordovaToast.showShortBottom("请填写小时数和分钟数");
            }
            //}
        }
    }
    //删除特殊事件记录
    $scope.DeleteSpecialEvent = function () {
        var confirmSePopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除本条特殊事件记录',
            cancelText: '取消',
            okText: '删除'
        });

        confirmSePopup.then(function (res) {
            if (res) {
                HealthService.deleteSpecialEvent($scope.se.seid, 0).then(function (data) {
                    if (data.code == 1) {
                        $scope.modifySpecialEventModal.hide();
                        $scope.loadSpecialEventList();
                    } else if (data.code == 0) {

                    }

                    $fwCordovaToast.showShortBottom(data.msg);
                });
            } else {

            }
        });
    }
    //长按出菜单删除
    $scope.onHoldSe = function (seid) {
        var ActionSheetSe = $ionicActionSheet.show({
            destructiveText: '删除',
            cancelText: '取消',
            destructiveButtonClicked: function () {
                ActionSheetSe();

                var confirmSePopup = $ionicPopup.confirm({
                    title: '确认删除',
                    template: '是否确认删除本条特殊事件记录',
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmSePopup.then(function (res) {
                    if (res) {
                        HealthService.deleteSpecialEvent(seid, '-1').then(function (data) {
                            if (data.code == 1) {
                                $scope.modifySpecialEventModal.hide();
                                $scope.loadSpecialEventList();
                            } else if (data.code == 0) {

                            }

                            $fwCordovaToast.showShortBottom(data.msg);
                        });
                    } else {

                    }
                });
            }
        });
    }

    //透析记录 cfw 2022年6月7日15:45:07 增加透析记录
    //药物名称选项
    $scope.Ywmc = {};
    $scope.Ywmc.a = false;
    $scope.Ywmc.b = false;
    $scope.Ywmc.c = false;
    $scope.Ywmc.d = false;

    //胸闷症状选项
    $scope.xmzz = {};
    $scope.xmzz.a = false;
    $scope.xmzz.b = false;

    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    //伪单选按钮赋值
    $scope.flupRadio = function (qstnId, dicValue) {
        $scope.txjl[qstnId] = dicValue;
    }

    //伪多选按钮赋值
    $scope.flupCheckBox = function (qstnId) {
        if (qstnId == "xmzz.a") {
            if ($scope.xmzz.a) {
                $scope.xmzz.a = false;
            } else {
                $scope.xmzz.a = true;
            }
        } else if (qstnId == "xmzz.b") {
            if ($scope.xmzz.b) {
                $scope.xmzz.b = false;
            } else {
                $scope.xmzz.b = true;
            }
        } else if (qstnId == "Ywmc.a") {
            if ($scope.Ywmc.a) {
                $scope.Ywmc.a = false;
            } else {
                $scope.Ywmc.a = true;
            }
        } else if (qstnId == "Ywmc.b") {
            if ($scope.Ywmc.b) {
                $scope.Ywmc.b = false;
            } else {
                $scope.Ywmc.b = true;
            }
        } else if (qstnId == "Ywmc.c") {
            if ($scope.Ywmc.c) {
                $scope.Ywmc.c = false;
            } else {
                $scope.Ywmc.c = true;
            }
        } else if (qstnId == "Ywmc.d") {
            if ($scope.Ywmc.d) {
                $scope.Ywmc.d = false;
            } else {
                $scope.Ywmc.d = true;
            }
        }
    }

    //添加透析记录modal
    $ionicModal.fromTemplateUrl('add-dialysis-record.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.AddDialysisRecordModal = modal;
    });

    //修改透析记录方法modal
    $scope.ModifyDialysisRecord = function (dialysis_record_id) {
        $scope.txjl_DIALYSIS_RECORD_ID = dialysis_record_id
        $scope.openAddDialysisRecordModal();
    }

    //新增透析记录方法modal
    $scope.ADDDialysisRecord = function () {
        $scope.txjl_DIALYSIS_RECORD_ID = ""
        $scope.openAddDialysisRecordModal();
    }

    //打开添加透析记录modal
    $scope.openAddDialysisRecordModal = function () {
        //判断是新增还是修改
        if ($scope.txjl_DIALYSIS_RECORD_ID == "") {
            //新增透析记录
            $scope.txjl = {};
            $scope.txjl_buttonName = "添加";
            //            HealthService.getDialysis_Detail($scope.vpId).then(function (data) {
            //            //新增页面时，置空
            //            $.extend($scope.txjl, data.ds);
            //            console.log("打开添加透析记录modal-cfw:"+$scope.txjl);
            //             });
        } else {
            //修改透析记录,将已查询记录赋值到前台页面
            $scope.txjl_buttonName = "保存";
            var aa = $scope.DialysisList.filter(e => e.DIALYSIS_RECORD_ID == $scope.txjl_DIALYSIS_RECORD_ID);
            if (aa != null) {
                //将尿量、抗凝时间、体温由string转化为number
                if (aa[0].NL_1_PJNL != null) {
                    if (aa[0].NL_1_PJNL.toString() != "") {
                        aa[0].NL_1_PJNL = Number(aa[0].NL_1_PJNL)
                    }
                }
                if (aa[0].ZJSS_KNZL_11 != null) {
                    if (aa[0].ZJSS_KNZL_11.toString() != "") {
                        aa[0].ZJSS_KNZL_11 = Number(aa[0].ZJSS_KNZL_11)
                    }
                }
                if (aa[0].YQQK_TW != null) {
                    if (aa[0].YQQK_TW.toString() != "") {
                        aa[0].YQQK_TW = Number(aa[0].YQQK_TW)
                    }
                }

                $scope.txjl = aa[0];
                //新增药物 多选条目赋值
                if ($scope.txjl.XM_YWMC_4.indexOf("A阿司匹林") != -1) {
                    $scope.Ywmc.a = true;
                }
                if ($scope.txjl.XM_YWMC_4.indexOf("B氯吡格雷") != -1) {
                    $scope.Ywmc.b = true;
                }
                if ($scope.txjl.XM_YWMC_4.indexOf("C低分子肝素") != -1) {
                    $scope.Ywmc.c = true;
                }
                if ($scope.txjl.XM_YWMC_4.indexOf("D其他") != -1) {
                    $scope.Ywmc.d = true;
                }

                //胸闷症状 多选条目赋值
                if ($scope.txjl.XM_4.indexOf("A胸闷") != -1) {
                    $scope.xmzz.a = true;
                }
                if ($scope.txjl.XM_4.indexOf("B胸痛") != -1) {
                    $scope.xmzz.b = true;
                }
            } else {
                $fwCordovaToast.showShortBottom("历史透析信息错误");
            }
        }
        $scope.AddDialysisRecordModal.show();
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    //关闭添加透析记录modal
    $scope.closeAddDialysisRecordModal = function () {
        $scope.txjl = {};
        $scope.txjl_DIALYSIS_RECORD_ID = "";
        $scope.Ywmc.a = false;
        $scope.Ywmc.b = false;
        $scope.Ywmc.c = false;
        $scope.Ywmc.d = false;
        $scope.xmzz.a = false;
        $scope.xmzz.b = false;
        $scope.AddDialysisRecordModal.hide();
    }

    //添加透析记录
    $scope.AddDialysisRecord = function () {
        //药品名称赋值
        $scope.txjl.XM_YWMC_4 = "";
        if ($scope.Ywmc.a) {
            $scope.txjl.XM_YWMC_4 = "A阿司匹林";
        }
        if ($scope.Ywmc.b) {
            $scope.txjl.XM_YWMC_4 += "|B氯吡格雷";
        }
        if ($scope.Ywmc.c) {
            $scope.txjl.XM_YWMC_4 += "|C低分子肝素";
        }
        if ($scope.Ywmc.d) {
            $scope.txjl.XM_YWMC_4 += "|D其他";
        }
        $scope.txjl.XM_4 = "";
        //透析症状赋值
        if ($scope.xmzz.a) {
            $scope.txjl.XM_4 = "A胸闷/憋气";
        }
        if ($scope.xmzz.b) {
            $scope.txjl.XM_4 += "|B胸痛";
        }

        //填写校验
        if ($scope.txjl.NL_1_NL == "" || $scope.txjl.NL_1_NL == null) {
            $scope.anchorScroll("NL_1_NL");
            $fwCordovaToast.showShortBottom("请填写第1题");
            return;
        } else if ($scope.txjl.NL_1_NL == "A有尿" && ($scope.txjl.NL_1_PJNL == "" || $scope.txjl.NL_1_PJNL == null)) {
            $scope.anchorScroll("NL_1_NL");
            $fwCordovaToast.showShortBottom("请填写第1.1题：平均尿量");
            return;
        }

        if ($scope.txjl.TXFZ_2 == "" || $scope.txjl.TXFZ_2 == null) {
            $scope.anchorScroll("TXFZ_2");
            $fwCordovaToast.showShortBottom("请填写第2题：是否有浮肿");
            return;
        } else if ($scope.txjl.TXFZ_2 == "A有" && ($scope.txjl.TXFZ_2_FZQK == "" || $scope.txjl.TXFZ_2_FZQK == null)) {
            $scope.anchorScroll("TXFZ_2");
            $fwCordovaToast.showShortBottom("请填写第2.1题：浮肿情况");
            return;
        }

        if ($scope.txjl.PWXX_3 == "" || $scope.txjl.PWXX_3 == null) {
            $scope.anchorScroll("PWXX_3");
            $fwCordovaToast.showShortBottom("请填写第3题：平卧休息情况");
            return;
        }
        if ($scope.txjl.XM_4 == "" || $scope.txjl.XM_4 == null) {
            $scope.anchorScroll("XM_4");
            $fwCordovaToast.showShortBottom("请填写第4题：是否胸闷");
            return;
        } else {
            if ($scope.txjl.XM_XMSJ_4 == "" || $scope.txjl.XM_XMSJ_4 == null) {
                $scope.anchorScroll("XM_XMSJ_4");
                $fwCordovaToast.showShortBottom("请填写第4.1题：症状出现时间");
                return;
            }
            if ($scope.txjl.XM_SFJZ_4 == "" || $scope.txjl.XM_SFJZ_4 == null) {
                $scope.anchorScroll("XM_4");
                $fwCordovaToast.showShortBottom("请填写第4.2题：是否就诊");
                return;
            }
            if ($scope.txjl.XM_ZLYW_4 == "" || $scope.txjl.XM_ZLYW_4 == null) {
                $scope.anchorScroll("XM_4");
                $fwCordovaToast.showShortBottom("请填写第4.3题：是否有新加治疗药物");
                return;
            }
            if ($scope.txjl.XM_ZLYW_4 == "A有" && ($scope.txjl.XM_YWMC_4 == "" || $scope.txjl.XM_YWMC_4 == null)) {
                $scope.anchorScroll("XM_4");
                $fwCordovaToast.showShortBottom("请填写第4.4题：治疗药物名称");
                return;
            }
        }

        if ($scope.txjl.NG_5 == "" || $scope.txjl.NG_5 == null) {
            $scope.anchorScroll("NG_5");
            $fwCordovaToast.showShortBottom("请填写第5题：脑梗塞情况");
            return;
        }
        if ($scope.txjl.CX_6 == "" || $scope.txjl.CX_6 == null) {
            $scope.anchorScroll("CX_6");
            $fwCordovaToast.showShortBottom("请填写第6题：出血症状");
            return;
        } else if ($scope.txjl.CX_6 == "F其它出血" && ($scope.txjl.CX_QT_6 == "" || $scope.txjl.CX_QT_6 == null)) {
            $scope.anchorScroll("CX_6");
            $fwCordovaToast.showShortBottom("请填写第6.1题：其它出血部位");
            return;
        }
        if ($scope.txjl.FX_7 == "" || $scope.txjl.FX_7 == null) {
            $scope.anchorScroll("FX_7");
            $fwCordovaToast.showShortBottom("请填写第7题：腹泻呕吐情况");
            return;
        }
        if ($scope.txjl.ZJSS_11 == "" || $scope.txjl.ZJSS_11 == null) {
            $scope.anchorScroll("ZJSS_11");
            $fwCordovaToast.showShortBottom("请填写第8题：是否手术");
            return;
        } else if ($scope.txjl.ZJSS_11 == "B有") {
            if ($scope.txjl.ZJSS_SSSJ_11 == "" || $scope.txjl.ZJSS_SSSJ_11 == null) {
                $scope.anchorScroll("ZJSS_11");
                $fwCordovaToast.showShortBottom("请填写第8.1题：手术日期");
                return;
            }
            if ($scope.txjl.ZJSS_KNZL_11 == "" || $scope.txjl.ZJSS_KNZL_11 == null) {
                $scope.anchorScroll("ZJSS_11");
                $fwCordovaToast.showShortBottom("请填写第8.2题：术后抗凝天数");
                return;
            }
        }

        if ($scope.txjl.YQQK_FR == "" || $scope.txjl.YQQK_FR == null) {
            $scope.anchorScroll("YQQK_FR");
            $fwCordovaToast.showShortBottom("请填写第9题：是否发热");
            return;
        } else if ($scope.txjl.YQQK_FR == "有" && ($scope.txjl.YQQK_TW == "" || $scope.txjl.YQQK_TW == null)) {
            $scope.anchorScroll("YQQK_TW");
            $fwCordovaToast.showShortBottom("请填写第9.1题：体温");
            return;
        }
        if ($scope.txjl.YQQK_KS == "" || $scope.txjl.YQQK_KS == null) {
            $scope.anchorScroll("YQQK_KS");
            $fwCordovaToast.showShortBottom("请填写第10题：咳嗽症状");
            return;
        }
        if ($scope.txjl.YQQK_TZRZZ == "" || $scope.txjl.YQQK_TZRZZ == null) {
            $scope.anchorScroll("YQQK_TZRZZ");
            $fwCordovaToast.showShortBottom("请填写第11题：同住人情况");
            return;
        }
        if ($scope.txjl.YQQK_YQ == "" || $scope.txjl.YQQK_YQ == null) {
            $scope.anchorScroll("YQQK_YQ");
            $fwCordovaToast.showShortBottom("请填写第12题：是否前往疫区");
            return;
        }
        if ($scope.txjl.YQQK_JCYQ == "" || $scope.txjl.YQQK_JCYQ == null) {
            $scope.anchorScroll("YQQK_JCYQ");
            $fwCordovaToast.showShortBottom("请填写第13题：是否接触疫区人员");
            return;
        }

        $ionicLoading.show();
        //判断是新增记录、修改记录
        if ($scope.txjl_DIALYSIS_RECORD_ID == "") {
            //新增
            try {
                HealthService.addDialysis_Rrecord($scope.vpId, JSON.stringify($scope.txjl)).then(function (data) {
                    if (data.code == 1) {
                        $ionicLoading.hide();
                        $scope.AddDialysisRecordModal.hide();

                        $scope.txjl = {};
                        $scope.txjl_DIALYSIS_RECORD_ID = "";
                        $scope.Ywmc.a = false;
                        $scope.Ywmc.b = false;
                        $scope.Ywmc.c = false;
                        $scope.Ywmc.d = false;
                        $scope.xmzz.a = false;
                        $scope.xmzz.b = false;

                        $scope.loadDialysis_RrecordList();
                    } else if (data.code == 0) {
                        $ionicLoading.hide();
                    }
                    $fwCordovaToast.showShortBottom(data.msg);
                });
            } catch (err) {
                console.log(err);
            }
        } else {
            //修改
            try {
                HealthService.modifyDialysis_Rrecord($scope.txjl.DIALYSIS_RECORD_ID, JSON.stringify($scope.txjl)).then(function (data) {
                    if (data.code == 1) {
                        $ionicLoading.hide();
                        $scope.AddDialysisRecordModal.hide();

                        $scope.txjl = {};
                        $scope.txjl_DIALYSIS_RECORD_ID = "";
                        $scope.Ywmc.a = false;
                        $scope.Ywmc.b = false;
                        $scope.Ywmc.c = false;
                        $scope.Ywmc.d = false;
                        $scope.xmzz.a = false;
                        $scope.xmzz.b = false;

                        $scope.loadDialysis_RrecordList();
                    } else if (data.code == 0) {
                        $ionicLoading.hide();
                    }
                    $fwCordovaToast.showShortBottom(data.msg);
                });
            } catch (err) {
                console.log(err);
            }
        }
    }

    //删除透析记录
    $scope.DeleteDialysisRecord = function () {
        // 2022-8-17 11:10:46 CGZ 按于飞要求“透析记录”更名为“透前信息”
        var confirmTxjlPopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除本条透前信息',
            cancelText: '取消',
            okText: '删除'
        });

        confirmTxjlPopup.then(function (res) {
            if (res) {
                HealthService.deleteDialysis_Rrecord($scope.txjl_DIALYSIS_RECORD_ID, '-1').then(function (data) {
                    if (data.code == 1) {
                        $scope.AddDialysisRecordModal.hide();
                        $scope.loadDialysis_RrecordList();
                    } else if (data.code == 0) {

                    }
                    $fwCordovaToast.showShortBottom(data.msg);
                });
            } else {

            }
        });
    }

    //长按出菜单删除透析记录
    $scope.onHoldTxjl = function (dialysisid) {
        var ActionSheetTxjl = $ionicActionSheet.show({
            destructiveText: '删除',
            cancelText: '取消',
            destructiveButtonClicked: function () {
                ActionSheetTxjl();

                // 2022-8-17 11:10:46 CGZ 按于飞要求“透析记录”更名为“透前信息”
                var confirmTxjlPopup = $ionicPopup.confirm({
                    title: '确认删除',
                    template: '是否确认删除本条透前信息',
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmTxjlPopup.then(function (res) {
                    if (res) {
                        HealthService.deleteDialysis_Rrecord(dialysisid, '-1').then(function (data) {
                            if (data.code == 1) {
                                $scope.AddDialysisRecordModal.hide();
                                $scope.loadDialysis_RrecordList();
                            } else if (data.code == 0) {

                            }
                            $fwCordovaToast.showShortBottom(data.msg);
                        });
                    } else {

                    }
                });
            }
        });

    }

    // #region 身高体重
    //添加身高体重modal
    $ionicModal.fromTemplateUrl('add-height-weight.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.addHeightWeightModal = modal;
    });
    //打开添加身高体重modal
    $scope.openAddHeightWeightModal = function () {
        $scope.hw.newHeight = "";
        $scope.hw.newWeight = "";
        $scope.addHeightWeightModal.show();
        $scope.hw.measureTime = "";
    }
    //关闭添加身高体重modal
    $scope.closeAddHeightWeightModal = function () {
        $scope.addHeightWeightModal.hide();
    }
    //添加身高体重记录
    $scope.AddHeightWeight = function () {
        if ($scope.hw.newHeight == "" || $scope.hw.newWeight == "" || $scope.hw.newHeight == null || $scope.hw.newWeight == null) {
            $fwCordovaToast.showShortBottom("请填写身高和体重");
        } else if ($scope.hw.measureTime == "") {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            HealthService.submitHeightWeight($scope.vpId, $scope.hw.newHeight, $scope.hw.newWeight, "Health", $scope.hw.measureTime).then(function (data) {
                if (data.result == 1) {
                    $scope.addHeightWeightModal.hide();
                    $scope.loadHeightWeightList();

                    $fwCordovaToast.showShortBottom("添加身高体重记录成功");
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            });
        }
    }

    //修改身高体重model
    $ionicModal.fromTemplateUrl('modify-height-weight.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modifyHeightWeightModal = modal;
    });
    //打开修改身高体重modal
    $scope.openModifyHeightWeightModal = function (htid, height, weight, measureTime) {
        $scope.modifyHeightWeightModal.show();
        $scope.hw.htid = htid;
        $scope.hw.modifyHeight = parseInt(height);
        $scope.hw.modifyWeight = parseInt(weight);
        $scope.hw.measureTime = measureTime;
    }
    //关闭修改身高体重modal
    $scope.closeModifyHeightWeightModal = function () {
        $scope.modifyHeightWeightModal.hide();
    }
    //修改身高体重
    $scope.ModifyHeightWeight = function () {
        if ($scope.hw.modifyHeight == "" || $scope.hw.modifyWeight == "" || $scope.hw.modifyHeight == null || $scope.hw.modifyWeight == null) {
            $fwCordovaToast.showShortBottom("请填写身高和体重");
        } else if ($scope.hw.measureTime == "") {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else {
            HealthService.modifyHeigthWeight($scope.hw.htid, $scope.hw.modifyHeight, $scope.hw.modifyWeight, $scope.hw.measureTime).then(function (data) {
                if (data.result == 1) {
                    $scope.modifyHeightWeightModal.hide();
                    $scope.loadHeightWeightList();

                    $fwCordovaToast.showShortBottom("修改身高体重记录成功");
                } else {

                    $fwCordovaToast.showShortBottom(data.msg);
                }
            });
        }
    }
    //删除身高体重记录
    $scope.DeleteHeightWeight = function () {
        var confirmBpPopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除本条身高体重记录',
            cancelText: '取消',
            okText: '删除'
        });

        confirmBpPopup.then(function (res) {
            if (res) {
                HealthService.deleteHeightWeight($scope.hw.htid).then(function (data) {
                    if (data.result == 1) {
                        $scope.modifyHeightWeightModal.hide();
                        $scope.loadHeightWeightList();

                        $fwCordovaToast.showShortBottom("删除成功");
                    } else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                });
            }
            else {

            }
        });
    }
    //长按出菜单删除
    $scope.onHoldHt = function (htid) {
        var ActionSheetHt = $ionicActionSheet.show({
            destructiveText: '删除',
            cancelText: '取消',
            destructiveButtonClicked: function () {
                ActionSheetHt();

                var confirmBpPopup = $ionicPopup.confirm({
                    title: '确认删除',
                    template: '是否确认删除本条身高体重记录',
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmBpPopup.then(function (res) {
                    if (res) {
                        HealthService.deleteHeightWeight(htid).then(function (data) {
                            if (data.result == 1) {
                                $scope.loadHeightWeightList();

                                $fwCordovaToast.showShortBottom("删除成功");
                            } else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        });
                    }
                    else {

                    }
                });
            }
        });
    }

    // #endregion

    // #region 血糖
    //添加血糖modal
    $ionicModal.fromTemplateUrl('add-blood-glucose.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.addBloodGlucoseModal = modal;
    });
    //打开添加血糖modal
    $scope.openAddBloodGlucoseModal = function () {
        $scope.bg.newGlu = "";
        $scope.addBloodGlucoseModal.show();
        //var dtNow = new Date();
        //var dtNowString = dtNow.getFullYear() + "-" + (dtNow.getMonth() + 1) + "-" + dtNow.getDate() + " " + dtNow.getHours() + ":" + dtNow.getMinutes()
        $scope.bg.measureTime = "";
    }
    //关闭添加血糖modal
    $scope.closeAddBloodGlucoseModal = function () {
        $scope.addBloodGlucoseModal.hide();
    }
    //添加血糖记录
    $scope.AddBloodGlucose = function () {
        if ($scope.bg.newGlu == "" || $scope.bg.newGlu == null) {
            $fwCordovaToast.showShortBottom("请填写血糖值");
        } else if ($scope.bg.measureTime == "") {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else if ($scope.bg.timeArea == "") {
            $fwCordovaToast.showShortBottom("请选择时间段");
        }
        else {
            HealthService.addBloodGlucose($scope.vpId, $scope.bg.newGlu, $scope.bg.measureTime, $scope.bg.timeArea).then(function (data) {
                if (data.result == 1) {
                    $scope.addBloodGlucoseModal.hide();
                    $scope.loadBloodGlucoseMonthList();

                    $fwCordovaToast.showShortBottom("添加成功");
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }

            });
        }
    }

    //修改血糖modal
    $ionicModal.fromTemplateUrl('modify-blood-glucose.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.modifyBloodGlucoseModal = modal;
    });
    //打开修改血糖modal
    $scope.openModifyBloodGlucoseModal = function (bgid, glu, measureTime, timeArea, dataSource) {
        if (dataSource == 'HEALTH_KIT') {
            return;
        }
        $scope.modifyBloodGlucoseModal.show();
        $scope.bg.bgid = bgid;
        $scope.bg.modifyGlu = parseInt(glu);
        $scope.bg.measureTime = measureTime;
        $scope.bg.timeArea = timeArea;
    }
    //关闭修改血糖modal
    $scope.closeModifyBloodGlucoseModal = function () {
        $scope.modifyBloodGlucoseModal.hide();
    }
    //修改血糖记录
    $scope.ModifyBloodGlucose = function () {
        if ($scope.bg.modifyGlu == "" || $scope.bg.modifyGlu == null) {
            $fwCordovaToast.showShortBottom("请填写血糖值");
        } else if ($scope.bg.measureTime == "") {
            $fwCordovaToast.showShortBottom("请填写记录时间");
        } else if ($scope.bg.timeArea == "") {
            $fwCordovaToast.showShortBottom("请选择时间段");
        } else {
            HealthService.modifyBloodGlucose($scope.bg.bgid, $scope.bg.modifyGlu, $scope.bg.measureTime, $scope.bg.timeArea).then(function (data) {
                if (data.result == 1) {
                    $scope.modifyBloodGlucoseModal.hide();
                    $scope.loadBloodGlucoseList($scope.dateStr);
                    $scope.loadBloodGlucoseMonthList();

                    $fwCordovaToast.showShortBottom("修改成功");
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }

            });
        }
    }
    //删除血糖记录
    $scope.DeleteBloodGlucose = function () {
        var confirmBpPopup = $ionicPopup.confirm({
            title: '确认删除',
            template: '是否确认删除本条血糖记录',
            cancelText: '取消',
            okText: '删除'
        });

        confirmBpPopup.then(function (res) {
            if (res) {
                HealthService.deleteBloodGlucose($scope.bg.bgid).then(function (data) {
                    if (data.result == 1) {
                        $scope.modifyBloodGlucoseModal.hide();
                        $scope.loadBloodGlucoseList($scope.dateStr);
                        $scope.loadBloodGlucoseMonthList();

                        $fwCordovaToast.showShortBottom("删除成功");
                    } else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                });
            }
            else {

            }
        });
    }
    //长按出菜单删除
    $scope.onHoldBg = function (bgid, dataSource) {
        if (dataSource == 'HEALTH_KIT') {
            return;
        }
        var ActionSheetBg = $ionicActionSheet.show({
            destructiveText: '删除',
            cancelText: '取消',
            destructiveButtonClicked: function () {
                ActionSheetBg();

                var confirmBgPopup = $ionicPopup.confirm({
                    title: '确认删除',
                    template: '是否确认删除本条血糖记录',
                    cancelText: '取消',
                    okText: '删除'
                });

                confirmBgPopup.then(function (res) {
                    if (res) {
                        HealthService.deleteBloodGlucose(bgid).then(function (data) {
                            if (data.result == 1) {
                                $scope.loadBloodGlucoseList($scope.dateStr);
                                $scope.loadBloodGlucoseMonthList();

                                $fwCordovaToast.showShortBottom("删除成功");
                            } else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        });
                    }
                    else {

                    }
                });
            }
        });
    }

    // #endregion

    //打开心电测量详情modal
    $ionicModal.fromTemplateUrl('ecg-record.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.EcgRecordModal = modal;
    });

    //打开心电测量详情
    $scope.openEcgRecordModal = function (ecgType, avgHeartRate, ecgArrhythmiaType, userStmptom, samplingFrequency, measureTime) {
        console.log(ecgType);
        console.log(avgHeartRate);
        console.log(ecgArrhythmiaType);
        console.log(userStmptom);
        console.log(samplingFrequency);
        $scope.EcgRecordModal.show();
        switch (String(ecgType)) {
            case "1":
                $scope.er.ecgType = "单导";
                break;
            case "6":
                $scope.er.ecgType = "6导";
                break;
            case "12":
                $scope.er.ecgType = "12导";
                break;
            case "18":
                $scope.er.ecgType = "18导";
                break;
            default:
                $scope.er.ecgType = "";
                break;
        }
        $scope.er.avgHeartRate = avgHeartRate;
        switch (String(ecgArrhythmiaType)) {
            case "0":
                $scope.er.ecgArrhythmiaType = "无结果";
                break;
            case "1":
                $scope.er.ecgArrhythmiaType = "窦性心律";
                break;
            case "2":
                $scope.er.ecgArrhythmiaType = "房性早搏";
                break;
            case "4":
                $scope.er.ecgArrhythmiaType = "室性早搏";
                break;
            case "8":
                $scope.er.ecgArrhythmiaType = "房颤";
                break;
            case "16":
                $scope.er.ecgArrhythmiaType = "心率过高";
                break;
            case "32":
                $scope.er.ecgArrhythmiaType = "心率过低";
                break;
            case "64":
                $scope.er.ecgArrhythmiaType = "不确定";
                break;
            default:
                $scope.er.ecgArrhythmiaType = "";
                break;
        }
        $scope.er.userStmptom = userStmptom;
        switch (String(userStmptom)) {
            case "0":
                $scope.er.userStmptom = "无症状";
                break;
            case "1":
                $scope.er.userStmptom = "无不适感";
                break;
            case "2":
                $scope.er.userStmptom = "胸闷";
                break;
            case "4":
                $scope.er.userStmptom = "胸痛";
                break;
            case "8":
                $scope.er.userStmptom = "心慌";
                break;
            case "16":
                $scope.er.userStmptom = "气短";
                break;
            case "32":
                $scope.er.userStmptom = "头晕";
                break;
            case "64":
                $scope.er.userStmptom = "疲劳";
                break;
            case "128":
                $scope.er.userStmptom = "睡眠不佳";
                break;
            case "256":
                $scope.er.userStmptom = "感冒发烧";
                break;
            case "512":
                $scope.er.userStmptom = "其他不适";
                break;
            default:
                $scope.er.userStmptom = "";
                break;
        }
        $scope.er.samplingFrequency = samplingFrequency;
        $scope.er.measureTime = measureTime;
    }
    //关闭心电测量详情
    $scope.closeEcgRecordModal = function () {
        $scope.EcgRecordModal.hide();
    }

    $scope.tabSwitch = function (tabName) {
        $scope.tabName = tabName;
        if ($scope.titleName == '血压' && tabName == '趋势') {
            chartBloodPressure();
        } else if ($scope.titleName == '心率' && tabName == '趋势') {
            chartHeartRate();
        } else if ($scope.titleName == "身高体重" && tabName == '趋势') {
            chartHeightWeight();
        } else if ($scope.titleName == "血糖" && tabName == '趋势') {
            chartBloodGlucose();
        } else if ($scope.titleName == "步数记录" && tabName == '趋势') {
            chartStepRecord();
        } else if ($scope.titleName == "血氧" && tabName == '趋势') {
            chartBloodOxygen();
        }
    }

    $scope.switchBloodPressureChart = function () {
        chartBloodPressure();
    }

    //highcharts
    //血压趋势图
    function chartBloodPressure() {
        HealthService.bloodPressureTendency($scope.chartType.bp, $scope.vpId).then(function (data) {
            console.log(data);
            $("#blood-pressure-chart").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '血压趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: 'mmHg'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '高压',
                    data: data[1]
                }, {
                    name: '低压',
                    data: data[2]
                }]
            });
        });
    }

    $scope.switchHeartRateChart = function () {
        chartHeartRate();
    }

    //highcharts
    //心率趋势图
    function chartHeartRate() {
        HealthService.heartRateTendency($scope.chartType.hr, $scope.vpId).then(function (data) {
            console.log(data);
            $("#heart-rate-chart").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '心率趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: '次/分钟'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '心率',
                    data: data[1]
                }]
            });
        });
    }

    // highcharts
    // BMI趋势图
    function chartHeightWeight() {
        HealthService.heightWeightTendency($scope.chartType.hw, $scope.vpId).then(function (data) {
            console.log(data);
            $("#height-weight-chart").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '身高体重趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                //yAxis: {
                //    title: {
                //        text: 'mmHg'
                //    }
                //},
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: 'BMI',
                    data: data[1]
                }]
            });
        });
    }

    $scope.switchHeightWeightChart = function () {
        chartHeightWeight();
    }

    // highcharts
    // 血糖趋势图
    function chartBloodGlucose() {
        HealthService.bloodGlucoseTendency($scope.chartType.bg, $scope.vpId).then(function (data) {
            console.log(data);
            $("#blood-glucose-chart").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '血糖趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: 'mmol/L'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '空腹',
                    data: data[1]
                }, {
                    name: '餐后2小时',
                    data: data[2]
                }]
            });
        });
    }

    $scope.switchBloodGlucoseChart = function () {
        chartBloodGlucose();
    }

    // highcharts
    // 步数记录趋势图
    function chartStepRecord() {
        HealthService.stepRecordTendency($scope.chartType.stepRecord, $scope.vpId).then(function (data) {
            console.log(data);
            $("#height-step-record").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '步数记录趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: '步'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '步数',
                    data: data[1]
                }]
            });
        });
    }

    $scope.switchStepRecordChart = function () {
        chartStepRecord();
    }

    $scope.tile = function (title) {
        if ((title == "步数记录" || title == "血氧") && $scope.hwHealthKitFlag == 0) {
            $ionicPopup.alert({
                title: '提示',
                template: "若使用该功能，请进行华为运动健康功能授权",
                okText: "确定"
            });
            return;
        }
        else if ((title == "步数记录" || title == "血氧" || title == "心电测量") && ($scope.hwHealthKitFlag == 1 || $scope.hwHealthKitFlag == 2 || $scope.hwHealthKitFlag == 4)) {
            $ionicLoading.show();
            HealthService.queryHealthKitAuth($scope.vpId, title).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 1) {
                    $scope.titleName = title;
                    $scope.changeVp($scope.vpId);
                }
                else if (data.result == 2) {
                    var confirmPopup = $ionicPopup.alert({
                        title: '提示',
                        template: '<p>若使用该功能，请开启“华为运动健康服务”</p><p>Android：进入华为运动健康App-我的-隐私管理-打开“华为运动健康服务”。</p><p>iOS：进入华为运动健康App-我的-第三方服务-打开“华为运动健康服务”。</p>',
                        okText: '确定'
                    });
                }
                else {
                    var confirmPopup = $ionicPopup.confirm({
                        title: '提示',
                        template: data.msg,
                        cancelText: '取消',
                        okText: '去授权'
                    });

                    confirmPopup.then(function (res) {
                        if (res) {
                            $ionicLoading.show();
                            HealthService.getCodeUrl($scope.vpId).then(function (data) {
                                $ionicLoading.hide();
                                if (data.result == 1) {
                                    console.log("看下一url");
                                    console.log(data.data);

                                    //var url = data.data;
                                    ////$cordovaInAppBrowser.open(url, '_system').then(function (event) { });
                                    ////2023.7.31 新插件原有调用方式参数不生效
                                    //showInAppBrowser(url, '_system');
                                    // 2024-10-22 09:38:55 ZZL 新增可穿戴设备知情同意书
                                    var notice = data.AuthorizationInstructions;
                                    var url = data.data;
                                    $scope.url = url;
                                    $scope.preNotice = notice;
                                    $scope.preNoticeShow();
                                    // 开启用户须知倒计时
                                    $interval(function () {
                                        $scope.confirmCountdown -= 1;
                                    }, 1000, 5);
                                }
                                else {
                                    $ionicPopup.alert({
                                        title: '提示',
                                        template: "网络错误，请稍后重试",
                                        okText: "确定"
                                    });
                                }
                            }, function (params) {
                                $ionicLoading.hide();
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: "网络错误，请稍后重试",
                                    okText: "确定"
                                });
                            })
                        }
                    });
                    return;
                }
            })
        }
        else {
            $scope.titleName = title;
            $scope.changeVp($scope.vpId);
        }
    }

    // highcharts
    // 血氧趋势图
    function chartBloodOxygen() {
        HealthService.bloodOxygenTendency($scope.chartType.bo, $scope.vpId).then(function (data) {
            console.log(data);
            $("#blood-oxygen-chart").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '血氧趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: '%'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '血氧',
                    data: data[1]
                }]
            });
        });
    }

    $scope.switchBloodOxygenChart = function () {
        chartBloodOxygen();
    }

    $scope.goBack = function () {
        if ($scope.preNoticeModal.isShown()) {
            $scope.preNoticeModal.hide();
        }
        $state.go("app.health", { vpid: $scope.vpId, from: $scope.from });
    }

    // #region 2022-4-8 16:08:05 hzg 只判断是否从专病随访进入，不影响原有流程
    $scope.tileHref = function (title) {
        switch (title) {
            case "饮食":
                $state.go("app.diet", { vpid: $scope.vpId, from: $scope.from.length > 0 ? $scope.from : '' });
                break;
            case "吸烟":
                $state.go("app.smoking", { vpid: $scope.vpId, from: $scope.from.length > 0 ? $scope.from : '' });
                break;
        }
    }

    $scope.tileHrefSrvy = function (type) {
        $state.go("app.srvy", { vpid: $scope.vpId, type: type, from: $scope.from.length > 0 ? $scope.from : '' });
    }

    $scope.goCVDRisk = function () {
        $state.go("app.cvdriskList", { vpId: $scope.vpId, from: $scope.from.length > 0 ? $scope.from : '' });
    }
    // #endregion

    $scope.goTile = function () {
        if ($scope.titleName == "健康记录") {
            if ($scope.from.indexOf('flupSrvy') > -1 || $scope.from.indexOf('flupCHD') > -1 || $scope.from.indexOf('flupDRI') > -1) {
                // 专病随访进入 hzg 20220105
                $state.go($scope.from, { vpId: $scope.vpId });
            }
            else if ($scope.from == "menu") {
                //$scope.toggleSlideMenu();
                //$rootScope.goBack();
                $state.go("app.home");
            }
            else if ($scope.from == "app.home") {
                $state.go("app.home");
            }
            else {
                $state.go('app.visitPatient', { vpid: $scope.vpId });
            }
        } else {
            $scope.titleName = "健康记录";
            $scope.getHlthAdvice();
        }
    }

    // 2021-3-12 13:25:19 HM 应4S标准，增加健康指标
    $scope.getHlthAdvice = function () {
        HealthService.getHlthAdvice($scope.vpId).then(function (data) {
            if (data.result == 0) {
                // 2021-4-26 13:34:23 HM 取消掉健康指标报错，这个报错前端给吃下来
                // $fwCordovaToast.showShortBottom(data.msg);
                $scope.hlthAdviceList = [];
            }
            else {
                $scope.hlthAdviceList = data.data;
            }

            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();
        });
    }

    $scope.goAdvice = function (type) {
        switch (type) {
            case "BLOOD_PRESSURE":
                $scope.tile('血压');
                break;
            case "HEART_RATE":
                $scope.tile('心率');
                break;
            case "SPECIAL_EVENT":
                $scope.tile('特殊事件');
                break;
            case "FOOD":
                $scope.tileHref('饮食');
                break;
            case "FAGERSTORM":
                $scope.tileHrefSrvy('FAGERSTORM');
                break;
            case "IPAQ":
                $scope.tileHrefSrvy('IPAQ');
                break;
            case "PSQI":
                $scope.tileHrefSrvy('PSQI');
                break;
            case "SAS":
                $scope.tileHrefSrvy('SAS');
                break;
            case "HEIGHT_WEIGHT":
                $scope.tile('身高体重');
                break;
            case "BLOOD_GLUCOSE":
                $scope.tile('血糖');
                break;
            case "DIALYSIS_RECORD":
                $scope.tile('透析患者健康记录');
                break;
        }
    }

    $scope.judgeAdvice = function (type) {
        // 包含的话，就隐藏，所以这里是false，可以直接用
        for (var i = 0; i < $scope.hlthAdviceList.length; i++) {
            if ($scope.hlthAdviceList[i].HEALTH_TYPE == type) {
                return false;
            }
        }
        return true;
    }

    // 是否提示血压异常
    $scope.getBPNoticeStatus = function () {
        var objBP = $scope.hlthAdviceList.filter(o => o.HEALTH_TYPE == "BLOOD_PRESSURE");
        if (objBP.length > 0 && objBP[0].BP_NOTICE != null) {
            $scope.bpNotice = objBP[0].BP_NOTICE;
            return true;
        }
        return false;
    }

    // 跳转在线问诊
    $scope.goConsultation = function () {
        $state.go('app.dealWithCard', { go: 'consultation' });
    }

    // 跳转预约挂号
    $scope.goOpAppt = function () {
        $state.go('app.opAppt');
    }

    // 跳转健康宣教
    $scope.goEdu = function (columnId) {
        $state.go("app.edu", { columnId: columnId });
    }

    // 跳转健康宣教文章
    $scope.goEduArticle = function (url) {
        //$cordovaInAppBrowser.open(url, '_system').then(function (event) { });
        //2023.7.31 新插件原有调用方式参数不生效
        showInAppBrowser(url, '_system');
    }

    //#region 小黑屋
    // 2022-9-1 08:46:51 HM 梦想真成真了，进小黑屋吧，就不动这部分代码了，以后拿起来，也能用
    // 2021-12-13 18:13:55 HM 北京市便民惠民评审，做个假的可穿戴，未来可能会梦想成真
    $scope.honor = {};
    $scope.honor.mode = "STEP_RECORD";
    $scope.honor.tabName = "记录";
    $scope.honor.list = [];
    $scope.honor.chartType = {
        bp: "byDay",
        hr: "byDay",
        hw: "byDay",
        bg: "byDay"
    }
    $scope.goHonor = function () {
        // 展示方式
        $scope.honorModeShow();
    }

    // 步数记录
    $scope.stepRecordHonor = function () {
        $scope.honor.mode = "STEP_RECORD";
        $scope.honor.tabName = "记录";
        $scope.honor.list = [];
        $scope.honor.chartType = {
            bp: "byDay",
            hr: "byDay",
            hw: "byDay",
            bg: "byDay"
        }

        $ionicLoading.show();
        HealthService.getStepRecordHonorList($scope.vpId, "STEP_RECORD").then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 变量赋值
                $scope.honor.mode = "STEP_RECORD";
                $scope.honor.list = data.ds;

                $scope.honorRecordShow();
            }
        }, function (data) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络不佳，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 心脏健康
    $scope.heartRecordHonor = function () {
        $scope.honor.mode = "STEP_RECORD";
        $scope.honor.tabName = "记录";
        $scope.honor.list = [];
        $scope.honor.chartType = {
            bp: "byDay",
            hr: "byDay",
            hw: "byDay",
            bg: "byDay"
        }

        $ionicLoading.show();
        HealthService.getStepRecordHonorList($scope.vpId, "HEART_WEAR").then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 变量赋值
                $scope.honor.mode = "HEART_WEAR";
                $scope.honor.list = data.ds;

                $scope.honorRecordShow();
            }
        }, function (data) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络不佳，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 荣耀切换
    $scope.honorTabSwitch = function (tabName) {
        $scope.honor.tabName = tabName;
        if ($scope.honor.mode == "HEART_WEAR" && tabName == '趋势') {
            honorChartHeartRate();
        }
        else if ($scope.honor.mode == "STEP_RECORD" && tabName == '趋势') {
            honorChartStepRecord();
        }
    }

    $scope.honorSwitch = function () {
        if ($scope.honor.mode == "HEART_WEAR") {
            honorChartHeartRate();
        }
        else if ($scope.honor.mode == "STEP_RECORD") {
            honorChartStepRecord();
        }
    }

    function honorChartHeartRate() {
        HealthService.heartRateTendencyHonor($scope.honor.chartType.hr, $scope.vpId).then(function (data) {
            console.log(data);
            console.log($("#heart-rate-chart-honor"));
            $("#heart-rate-chart-honor").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '静息心率趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: '次/分钟'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '心率',
                    data: data[1]
                }]
            });
        });
    }

    function honorChartStepRecord() {
        HealthService.stepRecordTendencyHonor($scope.honor.chartType.hr, $scope.vpId).then(function (data) {
            console.log(data);
            console.log($("#heart-rate-chart-honor"));
            $("#heart-rate-chart-honor").highcharts({
                credits: {
                    enabled: false
                },
                chart: {
                    type: 'line'
                },
                title: {
                    text: '步数记录趋势图'
                },
                //subtitle: {
                //    text: '副标题'
                //},
                xAxis: {
                    categories: data[0]
                },
                yAxis: {
                    title: {
                        text: '步'
                    }
                },
                tooltip: {
                    crosshairs: true,
                    shared: true
                },
                plotOptions: {
                    line: {
                        dataLabels: {
                            enabled: true
                        },
                        enableMouseTracking: true
                    }
                },
                series: [{
                    name: '步数',
                    data: data[1]
                }]
            });
        });
    }
    //#endregion

    $ionicModal.fromTemplateUrl('honorMode.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.honorModeModal = modal;
    });

    $ionicModal.fromTemplateUrl('honorRecord.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.honorRecordModal = modal;
    });

    // 荣耀手环方式显示
    $scope.honorModeShow = function () {
        $scope.honorModeModal.show();
    }

    // 荣耀手环方式隐藏
    $scope.honorModeHide = function () {
        $scope.honorModeModal.hide();
    }

    // 荣耀手环记录显示
    $scope.honorRecordShow = function () {
        $scope.honorRecordModal.show();
    }

    // 荣耀手环记录隐藏
    $scope.honorRecordHide = function () {
        $scope.honorRecordModal.hide();
    }

    // 查询当前就诊人是否授权华为运动健康
    $scope.checkHealthKitAuth = function () {
        if ($scope.vpId == "") {
            return;
        }
        $scope.AuthNum++;
        HealthService.checkAuthorzation($scope.vpId).then(function (data) {
            if (data.result == 1) {
                $scope.hwHealthKitFlag = data.status;

                if ($scope.hwHealthKitFlag == 1) {
                    HealthService.getHealthKitHeightWeight($scope.vpId).then(function (result) {
                        if (result.result == 1) {
                            $scope.hwBody = result.data;
                            $scope.personalDataShow = true;
                        }
                    }, function (params) {
                        $scope.hwBody = {};
                    })
                }
            }
            // 2023.4.27 15:42 朱世博 首次访问且授权过期，引导用户重新授权，第3次再弹框，原因是为了防止个别患者手机反应慢，给予一定的响应时间（3s）
            else if (data.result == 2) {
                $scope.hwHealthKitFlag = data.status;
                if ($scope.AuthNum == 3) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "华为运动健康授权过期",
                        template: "您的华为运动健康授权已过期，请您重新授权。",
                        cancelText: '稍后再说',
                        okText: '立即授权'
                    });
                    // 立即填写, 跳转
                    confirmPopup.then(function (res) {
                        if (res) {
                            // 跳转授权
                            $scope.goHealthKitAuth();
                        }
                    });
                }
            }
        }, function (params) {
            $scope.hwHealthKitFlag = -1;
        })
    }

    // 提示模态窗口显示
    $scope.preNoticeShow = function () {
        if (!$scope.preNoticeModal.isShown()) {
            $scope.preNoticeModal.show();
        }
        $scope.privacyStatus = 2;
    }

    $scope.preNoticeHide = function () {
       
        if ($scope.privacyStatus == 1) {
            if ($scope.preNoticeModal.isShown()) {
                $scope.preNoticeModal.hide();
            }
            showInAppBrowser($scope.url, '_system');
        } else {
            $ionicPopup.alert({
                title: '提示',
                template: "请勾选阅读须知",
                okText: "确定"
            });
        }
    }

    $scope.read = function () {
        if ($scope.privacyStatus != 1) {
            $scope.privacyStatus = 1;
        } else {
            $scope.privacyStatus = 2;
        }
    }

    // 去授权
    $scope.goHealthKitAuth = function () {
        if ($scope.hwHealthKitFlag != 0 && $scope.hwHealthKitFlag != 1) {
            return;
        }

        // 去授权
        if ($scope.hwHealthKitFlag == 0) {
            $ionicLoading.show();
            HealthService.getCodeUrl($scope.vpId).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 1) {
                    console.log("看下一url");
                    console.log(data.data);

                    var url = data.data;
                    //$cordovaInAppBrowser.open(url, '_system').then(function (event) { });
                    //2023.7.31 新插件原有调用方式参数不生效
                    //showInAppBrowser(url, '_system');
                    // 2024-10-22 09:38:55 ZZL 新增可穿戴设备知情同意书
                    var notice = data.AuthorizationInstructions;
                    $scope.url = url;
                    $scope.preNotice = notice;
                    $scope.preNoticeShow();
                    // 开启用户须知倒计时
                    $interval(function () {
                        $scope.confirmCountdown -= 1;
                    }, 1000, 5);
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: "网络错误，请稍后重试",
                        okText: "确定"
                    });
                }
            }, function (params) {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络错误，请稍后重试",
                    okText: "确定"
                });
            })
        }
        else {
            var confirmPopup = $ionicPopup.confirm({
                title: '提示',
                template: '是否确认取消华为运动健康授权？',
                cancelText: '取消',
                okText: '确认'
            });

            confirmPopup.then(function (res) {
                if (res) {
                    $ionicLoading.show();
                    HealthService.cancelAuthorzation($scope.vpId).then(function (data) {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: '提示',
                            template: "取消授权" + (data.result == 1 ? "成功" : "失败"),
                            okText: "确定"
                        });

                        // 重新获取授权
                        $scope.checkHealthKitAuth();
                    }, function (params) {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: '提示',
                            template: "网络错误，请稍后重试",
                            okText: "确定"
                        });
                    })
                }
            });
        }
    }

    // 手动刷新
    $scope.healthKitSync = function () {
        $ionicLoading.show();
        HealthService.healthKitSync($scope.vpId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "数据同步开始，10分钟后可在健康记录功能中查看",
                    okText: "确定"
                });
            }
            else {
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络错误，请稍后重试",
                    okText: "确定"
                });
            }
        }, function (params) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.titleName == "健康记录") {
                //alert('2');
                //$state.go("app.home");
                if ($stateParams.vpid == "") {
                    $state.go("app.home");
                    //$rootScope.goBack();
                }
                else {
                    if ($scope.from.indexOf('flupSrvy') > -1 || $scope.from.indexOf('flupCHD') > -1) {
                        // 返回专病随访 20220215 hzg
                        $state.go($scope.from, { vpId: $scope.vpId });
                    }
                    else {
                        //$scope.toggleSlideMenu();
                        $state.go('app.visitPatient', { vpid: $scope.vpId });
                    }
                }
            } else {
                //alert('1');
                $scope.titleName = "健康记录";
                if ($scope.from.indexOf('flupSrvy') > -1 || $scope.from.indexOf('flupCHD') > -1) {
                    $state.go("app.health", { vpid: $scope.vpId, from: $scope.from });
                }
                else {
                    $state.go("app.health");
                }
            }
            e.preventDefault();
            return false;
        }, 135, 'health');

        // 获取配置
        HealthService.getConfig().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                // 2021-4-27 20:03:04 候诊叫号显示等候人数及等待时间
                if (devMode || data.data.cvdRiskServerStatus) {
                    $scope.cvdRiskServerStatus = true;
                }
            }
        })
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        //        setTimeout(function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'health') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }

        $scope.refreshTimerDestroy();
        //        }, 500);
    });

    //#region cordova日期选择
    $scope.datePicker = function (target, type, value) {
        console.log(target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);
        }
        var options = {
            mode: type,  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != 'undefined') {
                var resultDate = new Date(date)
                switch (target) {
                    case 'bp.measureTime':    // 血压记录时间
                        $scope.bp.measureTime = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'hr.measureTime':      // 心率记录时间
                        $scope.hr.measureTime = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'se.appearedTime':       // 特殊事件症状出现时间
                        $scope.se.appearedTime = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'hw.measureTime':      // 身高体重时间
                        $scope.hw.measureTime = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'bg.measureTime':      // 血糖时间
                        $scope.bg.measureTime = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'edit_logtime':        // TBA
                        $scope.currentSolve.logtime = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'txjl.XM_XMSJ_4':        // 透析记录-胸闷出现时间
                        $scope.txjl.XM_XMSJ_4 = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                    case 'txjl.ZJSS_SSSJ_11':     // 透析记录-上次手术时间
                        $scope.txjl.ZJSS_SSSJ_11 = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                }
            }
        });
    }
    //#endregion
})
