﻿angular.module('fwapp.controllers')

.controller('HealthInfoController', function ($scope, $rootScope, $stateParams, $state, HealthInfoService, $ionicLoading,
    $ionicSlideBoxDelegate, $ionicModal, $cordovaDatePicker, $fwCordovaToast, VisitPatientService, $ionicPopover, AccountService) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 步骤
    $scope.step = "0";
    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 子模块标识
    $scope.part = ($stateParams.part == null || $stateParams.part.length == 0) ? "" : $stateParams.part;
    // 打哪儿来
    $scope.from = ($stateParams.from == null || $stateParams.from.length == 0) ? "" : $stateParams.from;
    //就诊人健康资料标识
    $scope.hasbaseinfo;
    //就诊人健康资料标识
    $scope.habodyinfo;
    //基础信息
    $scope.vpBaseInfo = new Object();
    //基础信息
    $scope.vpBodyInfo = new Object();
    //就诊人列表
    $scope.vpList = new Object();
    // 定义滑块
    var slideHealthInfo = $ionicSlideBoxDelegate.$getByHandle('slideHealthInfo');

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideHealthInfo.enableSlide(false);
        // 如果从诊前信息来 判断part跳转到子页面
        if ($scope.part != "") {
            console.log($scope.part);
            $ionicLoading.show();
            setTimeout(function () {
                if ($scope.part == "baseInfo") {
                    $scope.toSlide(1);
                }
                else if ($scope.part == "bodyInfo") {
                    $scope.toSlide(2);
                }
            }, 500);
        }
    });

    // 注册模态窗口：患者基本信息
    $ionicModal.fromTemplateUrl('baseinfo.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.baseInfoModal = modal;
    });
    // 注册模态窗口：身体概况信息
    $ionicModal.fromTemplateUrl('bodyinfo.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bodyInfoModal = modal;
    });

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.baseInfoModal.remove();
    })
    $scope.$on('$destroy', function () {
        $scope.bodyInfoModal.remove();
    })
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideHealthInfo.slide(index);
        $scope.step = slideHealthInfo.currentIndex();
        if ($scope.step == 1) {
            //载入就诊人健康资料
            loadBaseInfo();
        }
        if ($scope.step == 2) {
            //载入就诊人身体概况信息
            loadBodyInfo();
        }
        console.log("页码");
        console.log($scope.vpId);
        console.log($scope.step);
    }
    //查询用户下就诊人的健康资料信息  
    function loadBaseInfo() {
        HealthInfoService.healthinfo($scope.vpId, localStorage.queryToken).then(function (data) {
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        loadBaseInfo();
                    }
                })
                return;
            }
            // 请求错误
            else if (data.result != 1) {
                $ionicLoading.hide();
                $scope.vpBaseInfo.VISIT_PATIENT_ID = $scope.vpId;
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            else {
                $scope.vpBaseInfo = data.data;
            }
            $ionicLoading.hide();
        })
    }
    //查询就诊人身体概况信息
    function loadBodyInfo() {
        HealthInfoService.bodyinfo($scope.vpId, localStorage.queryToken).then(function (data) {
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        loadBodyInfo();
                    }
                })
                return;
            }
            // 请求错误
            else if (data.result != 1) {
                $ionicLoading.hide();
                $scope.vpBodyInfo.VISIT_PATIENT_ID = $scope.vpId;
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            else {
                $scope.vpBodyInfo = data.data;
            }
            $ionicLoading.hide();
        })
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择健康资料）正常后退
        if ($scope.step == 0) {
            if ($scope.from.length > 0) {
                $state.go($scope.from, { vpid: $scope.vpId, from: "app.healthinfo" });
            }
            else {
                $state.go('app.visitPatient', { vpid: $scope.vpId });
            }
        }
        // 其他页返回第一个滑块
        else {
            slideHealthInfo.slide(0);
            $scope.step = slideHealthInfo.currentIndex();
            console.log("页码");
            console.log($scope.step);
        }
    }
    //#region 基本信息维护
    $scope.baseInfoEditShow = function () {
        $scope.vpBaseInfo = new Object();
        loadBaseInfo();
        $scope.baseInfoModal.show();

    }

    $scope.baseInfoEditHide = function () {
        $scope.vpBaseInfo = new Object();
        loadBaseInfo();
        $scope.baseInfoModal.hide();
    }
    //#endregion

    //#region 身体概况信息维护
    $scope.bodyInfoEditShow = function () {
        $scope.vpBodyInfo = new Object();
        loadBodyInfo();
        $scope.bodyInfoModal.show();
    }

    $scope.bodyInfoEditHide = function () {
        $scope.vpBodyInfo = new Object();
        loadBodyInfo();
        $scope.bodyInfoModal.hide();
    }
    //#endregion

    //#region cordova日期选择
    $scope.datePicker = function (target, type, value) {
        var defaultDate = new Date();
        if (value != undefined && value != null && value != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);
        }
        var options = {
            mode: type,  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != 'undefined') {
                var resultDate = new Date(date)
                switch (target) {
                    case 'birthday':    // 查询开始时间
                        $scope.vpBaseInfo.BIRTHDAY = resultDate.Format('yyyy-MM-dd');
                        break;
                    default: break;
                }
            }
        });
    }
    //#endregion
    $scope.SaveBaseInfo = function () {
        console.log($scope.vpBaseInfo);
        HealthInfoService.savebaseinfo($scope.vpBaseInfo).then(function (data) {
            console.log($.param($scope.vpBaseInfo));
            if (data.code == 1) {
                $scope.baseInfoModal.hide();
                $fwCordovaToast.showShortBottom('添加成功');
                loadBaseInfo();
                //重新加载最新数据
            } else if (data.code == 0) {

            }

        });
    }
    $scope.SaveBodyInfo = function () {
        console.log($scope.vpBodyInfo);
        HealthInfoService.savebodyinfo($scope.vpBodyInfo).then(function (data) {
            console.log($.param($scope.vpBodyInfo));
            if (data.code == 1) {
                $scope.bodyInfoModal.hide();
                $fwCordovaToast.showShortBottom('添加成功');
                loadBodyInfo();
                //重新加载最新数据
            } else if (data.code == 0) {

            }

        });
    }

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            //console.log(data);

            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                //console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    //if (data.data[i].IS_BIND_CARD == '1') {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;

                    }
                    //}
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                    //console.log("vpid:" + vpid);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }

            // 读取就诊人信息
            $scope.loadVpInfo();
            // 读取就诊人列表
            $scope.loadVpList();

            // 获取用户信息
            AccountService.accountInfo().then(function (data) {
                if (data.result == 1) {
                    $scope.accountInfo = data.data;
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            })
        })
    });

    //读取就诊人信息
    $scope.loadVpInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log(data);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid
        $scope.vpInfo = new Object();
        $scope.loadVpInfo();
        $scope.popVplist.hide();

        loadBaseInfo();
        loadBodyInfo();
    }
})