﻿angular.module('fwapp.controllers')

.controller('InfomationController', function ($scope, $rootScope, $state, $http, $window, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform, $ionicSlideBoxDelegate
    , $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, $fwCordovaToast, $cordovaDatePicker, $timeout
    , ConsultationService, UploadImgService) {

    // 检查登录状态
    $rootScope.checkLogin();

    // 传来用户信息
    $scope.applyInfo = {};
    // 患者基本信息
    $scope.vpInfo = {};
    // 病情描述对象
    $scope.infomation = {};
    $scope.infomation.infomation = ""; // 病情描述
    $scope.infomation.help = ""; // 希望获得的帮助
    $scope.infomation.visitHospital = ""; // 已就诊医院及科室
    $scope.infomation.isDrug = 0; // 用药情况，1=有，0=无
    $scope.infomation.drug = ""; // 用药情况
    $scope.infomation.isAllergy = 0; //过敏史，1=有，0=无
    $scope.infomation.allergy = ""; //过敏史
    $scope.infomation.isPreviousDisease = 0; //既往病史，1=有，0=无
    $scope.infomation.previousDisease = ""; // 既往病史
    $scope.infomation.imgList = []; // 图片URL
    $scope.infomation.purpose = ""; // 咨询目的
    $scope.infomation.guardianName = ""; // 监护人姓名
    $scope.infomation.guardianPhone = ""; // 监护人手机号
    $scope.infomation.disease = []; // 所患疾病数组
    $scope.infomation.diseaseStr = ""; // 所患疾病显示字符串
    // 疾病查询
    $scope.addDiseaseData = {};
    $scope.addDiseaseData.keyword = '';
    // 希望获得的帮助
    $scope.purposeList = [];
    $scope.purposeOtherShow = false;// 是否选中了其他
    // 图文上传信息
    $scope.imgServerUrl = uploadUrl;

    // #region 模态框相关

    // 注册模态窗口：选择疾病
    $ionicModal.fromTemplateUrl('infomationDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationDiseaseModal = modal;
    });

    // 注册模态窗口：搜索疾病
    $ionicModal.fromTemplateUrl('addDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addDiseaseModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.infomationDiseaseModal.remove();
        $scope.addDiseaseModal.remove();
    })

    // #endregion

    // 1.查询信息
    $scope.loadInfomation = function () {
        // 如果有病情描述ID过来，就查一圈
        if ($scope.applyInfo.infomationId != "") {
            $ionicLoading.show();
            ConsultationService.selectInfomation($scope.applyInfo.infomationId).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: "确定"
                    });
                }
                else {
                    // 这里赋值
                    $scope.infomation.diseaseStr = data.data.DISEASE; // 所患疾病字符串
                    $scope.infomation.infomation = data.data.INFOMATION; // 病情描述
                    $scope.infomation.help = data.data.HELP; // 希望获得的帮助
                    $scope.infomation.visitHospital = data.data.VISIT_HOSPITAL; // 已就诊医院及科室
                    $scope.infomation.isDrug = data.data.IS_DRUG; // 用药情况，1=有，0=无

                    // 不考虑资质延长的情况
                    if($scope.infomation.drugOL != ""){
                        $scope.infomation.drug = data.data.DRUG.replace($scope.infomation.drugOL, "");
                        $scope.infomation.drug = $scope.infomation.drug.replace("。其他用药情况：", "");
                        if($scope.infomation.drug == ""){
                            $scope.infomation.isDrug = 0;
                        }
                    }

                    $scope.infomation.isAllergy = data.data.IS_ALLERGY; //过敏史，1=有，0=无
                    $scope.infomation.allergy = data.data.ALLERGY; //过敏史
                    $scope.infomation.isPreviousDisease = data.data.IS_PREVIOUS_DISEASE; //既往病史，1=有，0=无
                    $scope.infomation.previousDisease = data.data.PREVIOUS_DISEASE; // 既往病史
                    $scope.infomation.purpose = data.data.PURPOSE;

                    // 2020-5-20 15:55:14 HM 增加监护人信息
                    $scope.infomation.guardianName = data.data.GUARDIAN_NAME;
                    $scope.infomation.guardianPhone = data.data.GUARDIAN_PHONE;
                    $scope.infomation.currentAreaCode = data.data.CURRENT_AREA_CODE;
                    $scope.infomation.disease = data.data.DISEASE_LIST;// 所患疾病列表

                    var purposeStr = new Array();
                    purposeStr = data.data.PURPOSE.split("；");
                    $scope.infomation.purpose = "";
                    for(var i = 0; i < $scope.purposeList.length; i++){
                        $scope.purposeList[i].status = "0";
                        for(var j = 0; j < purposeStr.length; j++){
                            if(purposeStr[j] == $scope.purposeList[i].name){
                                $scope.purposeList[i].status = "1";
                            }
                        }

                        $scope.purposeOtherShow = false;
                        if($scope.purposeList[i].code == "999" && $scope.purposeList[i].status == "1"){
                            $scope.purposeOtherShow = true;
                        }

                        if($scope.purposeList[i].status == "1"){
                            $scope.infomation.purpose += $scope.purposeList[i].name + "；";
                        }
                    }

                    // 肯定有病情描述
                    UploadImgService.imgList("BY_CONSULTATION", $scope.infomationId).then(function (dataImg) {
                        $ionicLoading.hide();
                        if (data.result == 0) {
                            $fwCordovaToast.showShortBottom(dataImg.msg);
                        } else {
                            $scope.infomation.imgList = dataImg.data;
                            $ionicScrollDelegate.resize();
                        }
                    }, function () {
                        $fwCordovaToast.showShortBottom("网络错误");
                        $ionicLoading.hide();
                    })
                }
            }, function () {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络错误，请重试",
                    okText: "确定"
                });
            })
        }
        // 否则直接赋空值，让他自己填
        else {
            // 病情描述对象
            $scope.infomation = {};
            $scope.infomation.infomation = ""; // 病情描述
            $scope.infomation.help = ""; // 希望获得的帮助
            $scope.infomation.visitHospital = ""; // 已就诊医院及科室
            $scope.infomation.isDrug = 0; // 用药情况，1=有，0=无
            $scope.infomation.drug = ""; // 用药情况
            $scope.infomation.isAllergy = 0; //过敏史，1=有，0=无
            $scope.infomation.allergy = ""; //过敏史
            $scope.infomation.isPreviousDisease = 0; //既往病史，1=有，0=无
            $scope.infomation.previousDisease = ""; // 既往病史
            $scope.infomation.imgList = []; // 图片URL
            $scope.infomation.purpose = ""; // 咨询目的
            $scope.infomation.guardianName = ""; // 监护人姓名
            $scope.infomation.guardianPhone = ""; // 监护人手机号
            $scope.infomation.disease = []; // 所患疾病数组
            $scope.infomation.diseaseStr = ""; // 所患疾病显示字符串
            // 疾病查询
            $scope.addDiseaseData = {};
            $scope.addDiseaseData.keyword = '';
            // 希望获得的帮助
            $scope.purposeList = [];
            $scope.purposeOtherShow = false;// 是否选中了其他
        }
    }

    // 2.填写所患疾病
    $scope.showInfomationDisease = function () {
        // 如果是当天，不让展示
        if ($scope.applyInfo.isSubmit == false) {
            return;
        }

        $scope.infomationDiseaseModal.show();
    }

    // #region 所患疾病相关

    // 所患疾病隐藏
    $scope.hideInfomationDisease = function () {
        $scope.infomation.diseaseStr = "";
        for (var i = 0; i < $scope.infomation.disease.length; i++) {
            $scope.infomation.diseaseStr += $scope.infomation.disease[i].DISEASE_NAME + "，";
        }
        $scope.infomation.diseaseStr = $scope.infomation.diseaseStr.substr(0, $scope.infomation.diseaseStr.length - 1);
        $scope.infomationDiseaseModal.hide();
    }

    // 删除所患疾病
    $scope.deleteDisease = function (index) {
        $scope.infomation.disease.splice(index, 1);
    }

    // 搜索所患疾病显示
    $scope.showAddDisease = function () {
        if ($scope.infomation.disease.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的疾病过多');
            return;
        }
        $scope.addDiseaseData.keyword = "";
        $scope.addDiseaseData.results = [];
        $scope.addDiseaseModal.show();
        // 自动获取焦点
        $timeout(function () {
            document.getElementById("searchDisease").focus();
        }, 500);
    }

    // 搜索所患疾病隐藏
    $scope.hideAddDisease = function () {
        $scope.addDiseaseModal.hide();
    }

    // 搜索所患疾病
    $scope.searchDisease = function () {
        $scope.addDiseaseData.results = [];
        $ionicLoading.show();
        ConsultationService.searchDisease($scope.addDiseaseData.keyword, $scope.applyInfo.vpId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addDiseaseData.results = data.data;
                $ionicScrollDelegate.scrollTop();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("搜索超时，请稍后再试");
        });
    }

    // 添加所患疾病
    $scope.addDisease = function (disease, index) {
        var temp = {};
        temp.RECS_CODE = disease.RECS_CODE;
        temp.DISEASE_NAME = disease.DISEASE_NAME;

        if ($scope.diseaseIsSelected(temp) == true) {
            // 提示
            $ionicPopup.alert({
                title: "提示",
                template: "您已选择该项，请选择其他疾病",
                okText: "确定"
            }).then(function (res) {
                ;
            });
        }
        else {
            // 没有诊断，就添加
            $scope.infomation.disease.push(temp);
            console.log($scope.infomation.disease);

            if (index == 2) {
                $scope.hideAddDisease();
            }
        }
    }

    // 判断所患疾病是否已选中
    $scope.diseaseIsSelected = function (disease){
        var flag = false;
        if($scope.infomation.disease.length > 0){
            $scope.infomation.disease.forEach(item => {
                if(item.RECS_CODE == disease.RECS_CODE){
                    flag = true;
                }
            });
        }
        return flag;
    }

    // 咨询目的checkbox变换
    $scope.purposeCheckBox = function (code) {
        // 如果是当天，不让选
        if ($scope.applyInfo.isSubmit == false) {
            return;
        }

        // 每点击一次，都重置一次
        $scope.infomation.purpose = "";
        for (var i = 0; i < $scope.purposeList.length; i++) {
            if ($scope.purposeList[i].code == code) {
                if ($scope.purposeList[i].status == "1") {
                    $scope.purposeList[i].status = "0";
                }
                else {
                    $scope.purposeList[i].status = "1";
                }
            }

            if (code == "999" && $scope.purposeList[i].status == "1") {
                $scope.purposeOtherShow = true;
            }
            else if (code == "999" && $scope.purposeList[i].status != "1") {
                $scope.purposeOtherShow = false;
                $scope.infomation.help = "";
            }

            if ($scope.purposeList[i].status == "1") {
                $scope.infomation.purpose += $scope.purposeList[i].name + "；";
            }
        }
        $ionicScrollDelegate.resize();
    }

    // 病情描述信息切换radio
    $scope.changeRadio = function (str, index) {
        // 如果是当天，不让选
        if ($scope.applyInfo.isSubmit == false) {
            return;
        }

        if (str == "isDrug") {
            $scope.infomation.isDrug = index;
            if (index == 0) {
                $scope.infomation.drug = "";
            }
        }
        else if (str == "isAllergy") {
            $scope.infomation.isAllergy = index;
            if (index == 0) {
                $scope.infomation.allergy = "";
            }
        }
        else if (str == "isPreviousDisease") {
            $scope.infomation.isPreviousDisease = index;
            if (index == 0) {
                $scope.infomation.previousDisease = "";
            }
        }
        $ionicScrollDelegate.resize();
    }

    // #endregion

    // #region 图片上传工具函数

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            var imageDataList = [];
            imageDataList[0] = imageData;
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var imgCount = 9 - $scope.infomation.imgList.length;
        var options = {
            quality: 100,
            maximumImagesCount: imgCount,
            width: 0,
            height: 0
        };

        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList.length);
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 批量上传图片
    function UploadImage(infomationId, imageDataList, index) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageDataList[index].substr(imageDataList[index].lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: infomationId };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        if (index == 0) {
            $ionicLoading.show();
        }
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageDataList[index], options, true).then(function (result) {
            // 成功处理
            // 保存已上传图像路径
            $scope.imageAddSave(result.response);
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(infomationId, imageDataList, index + 1);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + JSON.stringify(error) + "。请稍后重试");
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(infomationId, imageDataList, index + 1);
            }
        }, function (progress) {
            ;
        });
    }

    // 保存已上传图像路径
    $scope.imageAddSave = function (path) {
        // 保存数据
        UploadImgService.imgAdd("BY_CONSULTATION", $scope.infomationId, '', path, '').then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else {
                $scope.infomation.imgList.push(data.data);
            }
            $ionicLoading.hide();
        });
    }

    // 显示图片删除按钮
    $scope.showImgDelete = function () {
        // 如果是当天，不让删除
        if ($scope.applyInfo.isSubmit == false) {
            return;
        }

        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
            $scope.infomation.imgList[i].isImgDelete = true;
        }
    }

    // 隐藏图片删除按钮
    $scope.cancelImgDelete = function () {
        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
            $scope.infomation.imgList[i].isImgDelete = false;
        }
    }

    // 删除图片
    $scope.imgDelete = function (id) {
        console.log(id);
        $ionicPopup.confirm({
            title: "删除检查资料",
            template: "您确定要删除该资料图片？",
            cancelText: "取消",
            okText: "确定删除"
        }).then(function (res) {
            if (res) {
                UploadImgService.imgDelete(id).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
                            if ($scope.infomation.imgList[i].UPLOAD_IMG_ID == id) {
                                $scope.infomation.imgList.splice(i, 1);
                            }
                        }
                    }
                    $ionicLoading.hide();
                })
            }
            $scope.showImgDelete();
        });
    }

    // 显示弹出大图
    $scope.popupImgShow = function (list, index) {
        $ionicModal.fromTemplateUrl("popup_image_infomation.html", {
            scope: $scope,
            animation: "fade-in"
        }).then(function (modal) {
            $scope.popupImageModal = modal;
            // 赋值图片列表
            $scope.uploadImgList = list;
            var cIndex = index;
            var preIndex = index == 0 ? list.length - 1 : index - 1;
            var nextIndex = index == list.length - 1 ? 0 : index + 1;

            $scope.currentImgIndex = cIndex;
            $scope.currentSlideIndex = 1;

            $scope.slides[0] = { src: list[preIndex].URL, seq: preIndex };
            $scope.slides[1] = { src: list[cIndex].URL, seq: cIndex };
            $scope.slides[2] = { src: list[nextIndex].URL, seq: nextIndex };
            //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
            // 显示弹出层
            $scope.popupImageModal.show();
        });
    }

    // 隐藏弹出大图
    $scope.popupImgHide = function () {
        // 清空图片列表
        $scope.uploadImgList = [];
        // 隐藏弹出
        $scope.popupImageModal.hide();
        $scope.popupImageModal.remove();
    }

    // 选中切换
    $scope.popupImgSlideChange = function (index) {
        var change = $scope.currentSlideIndex + ">" + index;
        $scope.currentSlideIndex = index;
        if (change == "2>0" || change == "0>1" || change == "1>2") {
            var sIndex = index + 1;
            if (sIndex == 3) {
                sIndex = 0;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex + 1;
            if (iIndex == $scope.uploadImgList.length) {
                iIndex = 0;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
        else if (change == "0>2" || change == "2>1" || change == "1>0") {
            var sIndex = index - 1;
            if (sIndex == -1) {
                sIndex = 2;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex - 1;
            if (iIndex == -1) {
                iIndex = $scope.uploadImgList.length - 1;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
    }

    // 阻止事件冒泡
    $scope.stopPropagation = function () {
        event.stopPropagation();
    }

    // #endregion

    // 3.提交病情信息，进行支付操作
    $scope.submitInfomation = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 其他的对象
        var other = $scope.purposeList.filter(e => e.code == '999');

        // 填空判断
        if ($scope.infomation.disease.length == 0) {
            $fwCordovaToast.showShortBottom("请至少选择一项疾病。");
        }
        else if ($scope.infomation.infomation.length < 20) {
            $fwCordovaToast.showShortBottom("病情描述信息不得少于20个字。");
        }
        else if ($scope.infomation.purpose.length == 0) {
            $fwCordovaToast.showShortBottom("本次咨询的目的不能为空。");
        }
        else if (other.status == "1" && $scope.infomation.help.length < 5) {
            $fwCordovaToast.showShortBottom("本次咨询的目的不得少于5个字");
        }
        else if ($scope.infomation.visitHospital.length == 0) {
            $fwCordovaToast.showShortBottom("已就诊医院及科室不能为空。");
        }
        else if ($scope.infomation.isDrug == 1 && $scope.infomation.drug.length == 0) {
            $fwCordovaToast.showShortBottom("用药情况信息不能为空。");
        }
        else if ($scope.infomation.isAllergy == 1 && $scope.infomation.allergy.length == 0) {
            $fwCordovaToast.showShortBottom("过敏史信息不能为空。");
        }
        else if ($scope.infomation.isPreviousDisease == 1 && $scope.infomation.previousDisease.length == 0) {
            $fwCordovaToast.showShortBottom("既往病史信息不能为空。");
        }
        // 判断是否上传图片，要先判断是否有infomationId，还得再判断是否有图片，测试版api开启devmode
        else if (($scope.infomationId == null || $scope.infomationId.length == 0 || $scope.infomation.imgList.length == 0) && devMode == false && window.cordova) {
            $fwCordovaToast.showShortBottom("请上传检查资料。");
        }
        // 如果需要填写监护人信息，但是没有填，弹错误
        else if ($scope.vpInfo.IS_GUARDIAN == 1 && ($scope.infomation.guardianName.length == 0 || $scope.infomation.guardianPhone.length == 0)){
            $fwCordovaToast.showShortBottom("请填写监护人信息。");
        }
        else if ($scope.infomation.currentAreaCode.length == 0){
            $fwCordovaToast.showShortBottom("请选择现住址行政区划。");
        }
        else {
            $ionicLoading.show();
            // 只做提交病情信息这个事，插请求和收费之后再去做，此时的infomationId应该不会为空
            if($scope.infomation.purpose.charAt($scope.infomation.purpose.length - 1) == "；"){
                $scope.infomation.purpose = $scope.infomation.purpose.substr(0, $scope.infomation.purpose.length - 1);
            }

            var diseaseString = "";
            for (var i = 0; i < $scope.infomation.disease.length; i++) {
                if ($scope.infomation.disease[i].RECS_CODE.length != 0) {
                    diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@" + $scope.infomation.disease[i].RECS_CODE + "|";
                }
                else if ($scope.infomation.disease[i].DISEASE_NAME.length != 0){
                    diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@0|";
                }
            }
            diseaseString = diseaseString.substr(0, diseaseString.length - 1);
            // 增加疾病格式化判断，保证提交的诊断全是标准化诊断
            if (diseaseString.indexOf("@") == -1){
                $fwCordovaToast.showShortBottom("疾病格式错误，请重新选择疾病");
                return;
            }

            ConsultationService.submitInfomation(diseaseString, $scope.infomation.infomation, $scope.infomation.help, $scope.infomation.visitHospital, 
            $scope.infomation.isDrug, $scope.infomation.drug, $scope.infomation.isAllergy, $scope.infomation.allergy, $scope.infomation.isPreviousDisease, $scope.infomation.previousDisease,
            $scope.infomation.purpose, $scope.applyInfo.vpId, $scope.applyInfo.doctorCode, $scope.applyInfo.infomationId, "1", 
            $scope.vpInfo.IS_GUARDIAN, $scope.infomation.guardianName, $scope.infomation.guardianPhone, $scope.infomation.currentAreaCode, $scope.treatType, "").then(function (data) {
                $ionicLoading.hide();
                if (data.result == 1) {
                    // 保存成功
                    $scope.goBack("submit");
                }
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
    }

    // 返回
    $scope.goBack = function (type) {
        var data = {
            type: type
        };

        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'infomationBackbutton') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        $scope.$emit("infomationHide", data);
    }

    // 由父级作用于传来的
    $scope.$on('infomationShow', function (event, data) {
        console.log(data);
        // 初始化
        $scope.applyInfo = data; // 传来有infomationId，有vpId
        $scope.infomationId = $scope.applyInfo.infomationId;
        // 2024-7-22 10:05:12 HM 传入个treatType字段
        $scope.treatType = $scope.applyInfo.treatType;
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        // 查一下需不需要监护人
        $ionicLoading.show();
        ConsultationService.visitPatientInfo($scope.applyInfo.vpId).then(function (result) {
            if (result.result == 0) {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: '提示',
                    template: result.msg,
                    okText: "确定"
                });
            }
            else {
                $scope.vpInfo = result.data;
                // 查一下配置config
                ConsultationService.getConfig().then(function (conData) {
                    $ionicLoading.hide();
                    if (conData.result == 0) {
                        $ionicPopup.alert({
                            title: '提示',
                            template: conData.msg,
                            okText: "确定"
                        });
                    }
                    else {
                        // 配置数据
                        $scope.configData = conData.data;
                        $scope.purposeList = $scope.configData.helpList;
                        // 查询信息
                        $scope.loadInfomation();
                    }
                }, function () {
                    $ionicPopup.alert({
                        title: '提示',
                        template: "网络错误，请重试",
                        okText: "确定"
                    });
                    $ionicLoading.hide();
                })
            }
        }, function () {
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
            $ionicLoading.hide();
        })

        // 2020-10-23 19:12:04 处理返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
        }, 250, 'infomationBackbutton');
    });
})