﻿angular.module('fwapp.controllers')

// 使用帮助
.controller('InstructionController', function ($scope,$compile, $rootScope, $state, InstructionService, $fwCordovaToast, $ionicLoading, $ionicPlatform, $ionicModal,$ionicScrollDelegate) {

    // 检查登录状态
    $rootScope.checkLogin();

    //栏目内容
    $scope.instructionList = "";
    //文章详情状态
    $scope.articleStatus = 0;
    //文章详情标题
    $scope.articleTitle = "";
    //文章详情内容
    $scope.articleContent = "";
    //展示数组
    $scope.articleShow = [];

    $ionicModal.fromTemplateUrl('modal.html', {
        scope: $scope,
    }).then(function (modal) {
        $scope.modal = modal;
    })

    $scope.openModal = function(){
        $scope.modal.show();
    }

    $scope.closeModal = function(){
        $scope.modal.hide();
        $scope.articleTitle = "";
        $scope.articleContent = "";
        $scope.articleStatus = 0;
    }

    // 修改为视图全面进入后触发
    $scope.$on('$ionicView.enter', function () {
        $ionicLoading.show();
        //获取列表
        InstructionService.getColumn().then(function(data){
            //获取成功
            if(data.result == 1){
                console.log(data.data);
                $scope.instructionList = data.data;
                for(var i=1;i<=data.data.length;i++){
                    $scope.articleShow.push(false);
                }
                console.log($scope.isShow);
                $ionicLoading.hide();
            }
            //获取失败
            else{
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }
        })
    });

    // 获取对应的文章详情
    $scope.getArticle = function(ARTICLE_ID){
        $scope.articleStatus = 0;
        $ionicLoading.show();
        InstructionService.getArticle(ARTICLE_ID).then(function(data){
            //获取成功
            if(data.result == 1){
                $scope.articleTitle = data.data.TITLE;
                $scope.articleContent = data.data.CONTENT;
                $scope.articleStatus = 1;
                $scope.openModal();
            }
            //获取失败
            else{
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        })
    }

    //展示文章列表
    $scope.showArticle = function(i){
        //重新计算滚动条高度
        $ionicScrollDelegate.resize();
        $scope.articleShow[i] = !$scope.articleShow[i];
    }

    // 重写goback
    $scope.goBack = function () {
        $rootScope.goBack();
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'instruction');
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'instruction') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });
})