﻿angular.module('fwapp.controllers')

// 门诊缴费明细
.controller('IpNurEduController', function ($scope, $rootScope, $state, $stateParams, $timeout, $http, $timeout, $interval, $fwCordovaToast
, IpNurEduService, VisitPatientService, AccountService, RequestService, PaymentService, PersonalService
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaInAppBrowser, $cordovaDatePicker) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义门诊缴费滑块
    var slideOpConsumption = $ionicSlideBoxDelegate.$getByHandle('slideIpNurEdu');
    
    // 服务开关
    $scope.isServerOn = false;
    // 服务状态描述
    $scope.serverStatusDescr = "";
    // 是否真机
    $scope.isDevice = (window.cordova && window.cordova.plugins) ? true : false;
    // 是否加载完成
    $scope.isLoadFinish = false;
    // 日期范围
    $scope.dateRange = 7;
    // 查询日期
    var dateEnd = new Date();
    var dateStart = new Date(dateEnd.getTime() - 7 * 24 * 60 * 60 * 1000);
    $scope.dp = {
        dateStart: dateStart.Format('yyyy-MM-dd'),
        dateEnd: dateEnd.Format('yyyy-MM-dd')
    };
   
    // 打哪儿来
    $scope.from = $stateParams.from;

    // 初始滑块状态
    $scope.step = 0;

    // 已选择就诊人
    $scope.vpSelect = {};
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    
    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 绑卡帮助
    $scope.configData = {};
    $scope.configData.bindCardHelp = "";
    // 检查预约列表
    $scope.checkApptList = [];
    // 检查预约序列
    $scope.checkApptIndex = 0;
    // 卡号条形码
    $scope.cardCodeBarcode = {};
    $scope.cardCodeBarcode.src = "";

    // 门诊缴费分组信息列表
    $scope.opConsumptionList = [];
    $scope.opConsumptionIndex = 0;

    // 已选择附加费数量缓存
    $scope.selectedAddFeeCountCache = 0;

    // 初始化ajax数量
    $scope.initAjaxCount = 0;

    // 2018-10-26 14:54:25 可用支付方式
    $rootScope.paymentRouteList = [];

    //页面计时请求标志
    $scope.timerRunFlag = false;
    //页面计时器
    $scope.timerTask = undefined;
    $scope.timerDjsTask = undefined;

    $scope.timeMinutes = "";//计时单位 分
    $scope.timeSecond = "";// 计时单位 秒

    // 注册模态窗口：宣教内容展示页面
    $ionicModal.fromTemplateUrl('eduPic.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.eduPicModal = modal;
    });

    // 宣教内容展示页面显示
    $scope.eduPicModal_show = function () {
        $scope.timerRunFlag = true;
        event.stopPropagation();

        //2023年11月24日16:50:02  cfw 打开宣教的时候，重新绑定返回键，如果图片显示器开着，先关闭图片显示器；否则关闭宣教展示页面
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.viewer != null && $scope.viewer.isShown) {
                $scope.viewer.hide();
            } else {
                //如果图片显示器未打开，则关闭宣教展示页
                $scope.eduPicModal_hide();
            }
        }, 256, 'ipNurEdu_ImageDisplay');

        $scope.eduPicModal.show();
    }
    // 宣教内容展示页面隐藏
    $scope.eduPicModal_hide = function () {
        //$scope.timerRunFlag = false;

        //定时计时逻辑取消
        //$interval.cancel($scope.timerTask);
        if (angular.isDefined($scope.timerTask)) {
            $interval.cancel($scope.timerTask);
            $scope.timerTask = undefined;
        }

        if (angular.isDefined($scope.timerDjsTask)) {
            $interval.cancel($scope.timerDjsTask);
            $scope.timerDjsTask = undefined;
        }

        $scope.timeMinutes = "";//计时单位 分
        $scope.timeSecond = "";// 计时单位 秒

        //2023年11月24日16:54:16  取消返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'ipNurEdu_ImageDisplay') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        $scope.eduPicModal.hide();
    }

    // 宣教内容展示页面隐藏--左上角返回，停止计时外，再刷新二级菜单
    $scope.eduPicModal_hide_back = function () {
        //$scope.timerRunFlag = false;

        //定时计时逻辑取消
        //$interval.cancel($scope.timerTask);
        if (angular.isDefined($scope.timerTask)) {
            $interval.cancel($scope.timerTask);
            $scope.timerTask = undefined;
        }

        if (angular.isDefined($scope.timerDjsTask)) {
            $interval.cancel($scope.timerDjsTask);
            $scope.timerDjsTask = undefined;
        }

        $scope.timeMinutes = "";//计时单位 分
        $scope.timeSecond = "";// 计时单位 秒

        //手动返回时，再次发起一次计时
        if ($scope.paeRecord.ZTBZ != '2' && $scope.paeRecord.ZTBZ != '1' && $scope.status != '1') {
            $scope.timer($scope.paeRecord.IDB, $scope.paeRecord.PAE_ID, "time");
        }

        //2023年8月8日11:01:02 刷新二级菜单
        $scope.selectEdu($scope.dicid);

        $scope.eduPicModal.hide();
    }

    //------------
    // 注册模态窗口：宣教答题页面
    $ionicModal.fromTemplateUrl('eduExam.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.eduExamModal = modal;
    });

    // 宣教内容展示页面显示
    $scope.eduExamModal_show = function () {
        event.stopPropagation();
        $scope.eduExamModal.show();
    }
    // 宣教内容展示页面隐藏
    $scope.eduExamModal_hide = function () {
        $scope.eduExamModal.hide();
    }

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.checkListDetailModal.remove();
        $scope.eduPicModal.remove();
    })

    // 滑到下一步
    $scope.nextSlide = function () {
        slideOpConsumption.next();
        $scope.step = slideOpConsumption.currentIndex();
    }
    
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOpConsumption.slide(index);
        $scope.step = slideOpConsumption.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第一页按历史记录返回 或 来自消息中心

        //if ($scope.step == 0 || $scope.from == "app.message") {
        //    $rootScope.goBack();
        //}
        if ($scope.step == 0) {
            $rootScope.goBack();
        }
        else if ($scope.step == 1 && $scope.from == "app.ipReg") {
            //2023年9月11日19:21:49 如果是住院单列表跳转而来，继续返回到住院单列表
            //$state.go("app.ipReg");
            $rootScope.goBack();
        }
        // 第1页滑动到第0页
        else if ($scope.step == 1) {
            //2023年8月8日11:04:49 刷新一级菜单
            $scope.getIpNoticeEdu();
            $scope.toSlide(0);
        }
        
        // 第2页滑动到第1页
        else if ($scope.step == 2) {
            //2023年8月8日11:04:49 刷新二级菜单，方法内跳转到第1页
            $scope.getEducationList($scope.his_idb, $scope.his_current_bqdm, $scope.his_ids);
        } 

        //// 来自消息中心
        //// 2022-4-8 14:44:04 CGZ 按褚老师要求将门诊缴费明细合并至门诊自助缴费模块中
        //if ($scope.from == "app.message" || $scope.from == "app.opPayment") {
        //    $rootScope.goBack();
        //}
        //else {
        //    $state.go("app.dealWithCard", { go: "ipNurEdu" });
            
        //}
    }

    // 滑块切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    //2023年9月11日18:40:30 页面初始化，根据来源，查询住院单列表进行展示  一级菜单
    $scope.getIpNoticeEdu = function () {
        IpNurEduService.getIpNoticeList().then(function (data) {
            $scope.isLoadFinish = true;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }
            if (data.result == "0") {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else if (data.result == "1") {
                $ionicLoading.hide();

                // 格式化数据
                data.data.forEach(e => {
                    // 拟入院日期
                    e.TZZYSJ = e.TZZYSJ.length == 0 ? "" : new Date(e.TZZYSJ).Format("yyyy年M月d日");
                });

                //判断页面跳转来源
                if ($scope.from == "app.message") {
                    //如果是消息通知跳转而来，筛选出消息通知中的患者宣教
                    var kh = $stateParams.kh;
                    $scope.IpNoticeList = data.data.filter(e => e.HIS_CARD_NUM == kh);
                } else if ($scope.from == "app.ipReg") {
                    //如果是住院单列表跳转而来，则根据住院单号，直接跳转至二级菜单
                    var ids_param = $stateParams.ids;
                    var idb_param = $stateParams.idb;
                    var bqdm_param = $stateParams.bqdm;
                    if (ids_param != undefined && ids_param != "") {
                        $scope.getEducationList("", "", ids_param);
                    } else {
                        $scope.getEducationList(idb_param, bqdm_param, "");
                    }
                } else {
                    $scope.IpNoticeList = data.data;
                }
                console.log(data.data);
            }
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 获取宣教内容  二级菜单
    $scope.his_idb = "";
    $scope.his_current_bqdm = "";
    $scope.his_ids = "";
    $scope.getEducationList = function (idb,current_bqdm,ids) {
        $ionicLoading.show();
        $scope.isLoadFinish = false;

        //2023年9月11日18:52:54 选择住院单后，全局变量赋值
        $scope.his_idb = idb;
        $scope.his_current_bqdm = current_bqdm;
        $scope.his_ids = ids;

        //cfw 2023年9月11日18:37:33 逻辑翻写，之前选就诊人，根据就诊人卡号查询idb获取宣教；现增加院前流程，可根据idb或者ids查询宣教
        // 根据卡号获取患者的宣教记录
        IpNurEduService.getPaeRecord(idb, current_bqdm, ids).then(function (data) {
            $scope.isLoadFinish = true;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }

            if (data.result == "0") {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else if (data.result == "1") {

                $ionicLoading.hide();
                $scope.his_idb = data.his_idb;
                console.log($scope.his_idb);
                $scope.ipNurEduList = data.data;
                console.log($scope.ipNurEduList);
                //2023年9月11日18:19:01 跳转第一页
                $scope.toSlide(1);
            }
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 点击二级菜单，查看宣教列表 三级菜单
    $scope.selectEdu = function (dicid) {
        console.log(dicid);

        $scope.dicid = dicid;
        $ionicLoading.show();
        IpNurEduService.getEduItem(dicid, $scope.his_idb, $scope.his_ids, $scope.his_current_bqdm).then(function (data) {
            $scope.isLoadFinish = true;
             //链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }

            if (data.result == "0") {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else if (data.result == "1") {
                $ionicLoading.hide();

                $scope.ipNurEduItemList = data.data;
                console.log($scope.ipNurEduItemList);
                //2023年9月11日18:20:50 修改调整逻辑
                if ($scope.step == 1) {
                     //滑到下一页
                    $scope.nextSlide();
                }
            }
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;
    // 图片插件
    $scope.viewer = {};

    // 点击二级菜单，查看宣教内容
    $scope.readEdu = function (paeid) {
        if (paeid == "") {
            return;
        }
        $ionicLoading.show();
        IpNurEduService.getPaeRecordItem(paeid).then(function (data) {
            //2023年9月19日09:53:40 时间加载初始化
            $scope.timeMinutes = "loading";
            //链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }

            if (data.result == "0") {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else if (data.result == "1") {
                $ionicLoading.hide();

                $scope.paeid = paeid;//全局变量paeid 赋值，

                $scope.paeRecord = data.web_paeRecord;//后台拿到最新的宣教发送记录（后台已经重新从内网抓取了一遍）
                $scope.pic_list = data.pic_list;//同时拿到宣教字典的图片列表

                //拿到宣教字典的问题
                $scope.promAndAnwser_list = data.promAndAnwser_list;
                console.log($scope.promAndAnwser_list);

                console.log($scope.paeRecord);
                console.log($scope.pic_list);
                if ($scope.paeRecord.PAE_ZTBZ == "1") {
                    //判断是否有题目，如果没有题目信息则进行提示
                    if ($scope.promAndAnwser_list.length == 0) {
                        $fwCordovaToast.showShortBottom("未找到宣教题目信息，请稍后重试");
                    } else {
                        //进入答题页面
                        $scope.eduExamModal_show();
                    }
                } else if ($scope.paeRecord.PAE_ZTBZ == "0" || $scope.paeRecord.PAE_ZTBZ == "2") {  //待观看和答题结束后进入观看页面
                    // 开启用户须知倒计时
                    $scope.confirmCountdown = Math.round($scope.paeRecord.PAE_DURATION) - $scope.paeRecord.PAE_GKSC;
                    $scope.timerDjsTask = $interval(function () {
                        $scope.confirmCountdown -= 1;//剩余秒数减1
                        if ($scope.confirmCountdown == 0) {
                            //如果倒计时结束，再发起一次计时请求，避免页面计时结束可答题，但后台状态未更新
                            $scope.timer($scope.paeRecord.IDB, $scope.paeRecord.PAE_ID, "time");
                        } else {
                            $scope.timeMinutes = parseInt($scope.confirmCountdown / 60);//  获取分钟数
                            if ($scope.timeMinutes < 10) {
                                $scope.timeMinutes = "0" + $scope.timeMinutes;
                            }
                            $scope.timeSecond = $scope.confirmCountdown % 60;// 获取秒
                            if ($scope.timeSecond < 10) {
                                $scope.timeSecond = "0" + $scope.timeSecond;
                            }
                        }
                    }, 1000, $scope.confirmCountdown);

                    //打开图片展示页面
                    $scope.eduPicModal_show();
                    //2023年10月27日09:44:23 cfw 进入宣教页面，滑到页面顶部
                    $ionicScrollDelegate.scrollTop();
                    $ionicScrollDelegate.resize();

                    //2023年11月14日10:20:36 cfw 此处引入图片插件，可对图片进行缩放
                    if ($scope.pic_list != undefined && $scope.pic_list.length > 0) {
                        $timeout(function () {
                            if ($scope.viewer.destroy) {
                                $scope.viewer.destroy();
                            }
                            $scope.viewer = new Viewer(document.getElementById('EduPicList'), {
                                //url:'data-original'
                                url(image) {
                                    return image.src;
                                },
                                // 图片名称显示
                                title: false
                            });
                        }, 1);
                    }

                    //进入页面后发起一次计时请求,后续每30s一次，定时任务  idb, paeid, type
                    $scope.isLoadFinish = true;
                    $scope.timer($scope.paeRecord.IDB, $scope.paeRecord.PAE_ID, "start");

                    //定时计时逻辑 每30s请求一次,不限制次数
                    //$scope.timerTask.then($scope.timer($scope.paeRecord.IDB, $scope.paeRecord.PAE_ID, "time"));

                    $scope.timerTask = $interval(function () { $scope.timer($scope.paeRecord.IDB, $scope.paeRecord.PAE_ID, "time"); }, 30000, -1);
                } 
            }
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    //计时达标，进入答题页面
    $scope.InExamPage = function () {
        //判断是否有题目，如果没有题目信息则进行提示
        if ($scope.promAndAnwser_list.length == 0) {
            $fwCordovaToast.showShortBottom("未找到宣教题目信息，请稍后重试");
        } else {
            //关闭宣教页面
            $scope.eduPicModal_hide();
            //进入答题页面
            $scope.eduExamModal_show();
        }
    }

    // 答题伪多选按钮
    $scope.flupCheckBox = function (problemId, dicValue) {
        //根据题目ID找对该题目信息
        var item = $scope.promAndAnwser_list.filter(e => e.PAE_PROBLEMID == problemId)[0];
        if (item != null) {
            //if(item.ISEDIT =="0") return;
            if (item.QUESTION_ANSWER == null || item.QUESTION_ANSWER == '') {
                item.QUESTION_ANSWER = dicValue;
            }
            else {
                var value = item.QUESTION_ANSWER.split(',');
                if (value.indexOf(dicValue) == -1) {
                    value.push(dicValue);
                } else {
                    value.splice(value.indexOf(dicValue), 1);
                }
                var returnValue = '';
                for (var i = 0; i < value.length; i++) {
                    returnValue += value[i] + ",";
                }
                if (returnValue.endsWith(',')) {
                    returnValue = returnValue.substr(0, returnValue.length - 1);
                }
                item.QUESTION_ANSWER = returnValue;
            }
        }
    }

    //答题伪单选按钮
    $scope.flupRadio = function (problemId, dicValue) {
        console.log("单选触发");
        //根据题目ID找对该题目信息
        var item = $scope.promAndAnwser_list.filter(e => e.PAE_PROBLEMID == problemId)[0];
        if (item != null) {
            item.QUESTION_ANSWER = dicValue;
        }
    }

    // 提交答题记录
    $scope.commitExam = function () {

        // 防止连击
        if (isFastClick()) {
            return;
        }
        console.log($scope.promAndAnwser_list);
        //cfw 2023年8月8日11:25:35 答题判空
        for (var i in $scope.promAndAnwser_list) {
            if ($scope.promAndAnwser_list[i].QUESTION_ANSWER == "") {
                $fwCordovaToast.showShortBottom("请选择" + $scope.promAndAnwser_list[i].PAE_PROBLEMNAME + "的答案。");
                return;
            }
        }

        $ionicLoading.show();
        var submitObj_model = JSON.stringify($scope.promAndAnwser_list);
        IpNurEduService.commitExam($scope.inVpid,$scope.paeid, submitObj_model).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                if (data.status == 1) {
                    //答题通过
                    $fwCordovaToast.showShortBottom("答题通过。");
                } else {
                    //答题未通过
                    $fwCordovaToast.showShortBottom("答题未通过，请您重新观看宣教内容并进行答题。");
                }
            }
            else if (data.result == 0 || data.result == 2 || data.result == 3) {//0 获取数据失败  2 回推记录到his失败  3 his已答题完成
                $fwCordovaToast.showShortBottom(data.msg);
            }

            //关闭答题页面
            $scope.eduExamModal_hide();
            //刷新二级菜单，调用点击一级菜单按钮
            $scope.selectEdu($scope.dicid);
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 页面计时方法
    $scope.tipFlag = true;
    $scope.timer = function (idb, paeid, type) {
        if ($scope.timerRunFlag == true) {
            IpNurEduService.commitTimer(idb, paeid, type).then(function (data) {
                if (data.result == "1") {
                    $scope.status = data.status;//宣教状态全局变量赋值
                    if (data.status == "1") {
                        //$fwCordovaToast.showShortBottom("宣教内容已有其他家属观看计时达标。");  正常情况计时情况下，也会置1，此处屏蔽
                    } else if (data.status == "2") {
                        $scope.paeRecord.PAE_ZTBZ = '2';
                        //如果在答题过程中，其他用户或者pad已答题成功，页面计时器不停止继续累加总观看时长
                        if (type == "start") {
                            $scope.tipFlag = false;
                        } 
                        if ($scope.tipFlag == true) {
                            $fwCordovaToast.showShortBottom("宣教内容已有其他家属观看并答题成功或无需答题。");
                            $scope.tipFlag = false;
                        }
                    }
                }
            }, function (data) {
                $ionicLoading.hide();
                $scope.isLoadFinish = true;
                $fwCordovaToast.showShortBottom(data.msg);
            });
        }
    }
    
    //$scope.timerTask = $interval(function () {}, 60000, -1);


    //#region 初始化
    // 加载就诊人列表
    $scope.loadVpList = function () {
        $scope.initAjaxCount++;
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            $scope.initAjaxCount--
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log($scope.vpList);
                //console.log($scope.inVpid);
                // 指定就诊人
                if ($scope.inVpid != null && $scope.inVpid != "") {
                    var index = 0;
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.inVpid) {
                            index = i;
                        }
                    }
                    // 跳过同意页
                    $scope.nextSlide();
                    // 选择对应就诊人
                    $scope.selectVp(index);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initAjaxCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOpConsumption.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.from == "app.message") {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'ipNurEdu');
        $ionicLoading.show();

        //2023年9月11日19:15:00 页面加载逻辑调整，不再选择就诊人
        $scope.getIpNoticeEdu();
        //$scope.getEducationList();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'ipNurEdu') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
    //#endregion 
})