﻿angular.module('fwapp.controllers')

// 住院登记
.controller('IpRegController', function ($scope, $rootScope, $state, $stateParams, $timeout, $http, $q, $timeout, $fwCordovaToast
, IpRegService, IpNurEduService, VisitPatientService, AccountService, RequestService, SrvyService, CasePrintService
    , $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaDatePicker, $cordovaCamera, $cordovaFileTransfer, $document) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义住院登记滑块
    var slideIpReg = $ionicSlideBoxDelegate.$getByHandle('slideIpReg');

    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 扫码hisCardNum
    $scope.hisCardNum = $stateParams.hisCardNum;
    // 扫码ipNoticeId
    $scope.ipNoticeId = $stateParams.ipNoticeId;
    // 初始滑块状态
    $scope.step = 0;
    // 用户须知数据
    $scope.agreement = new Object();
    // 当前住院单人年龄
    $scope.ipNoticeAge = 0;
    // 字典项数组
    $scope.dict = {
        prvn: [],
        origin_place_city: [],
        birthplace_city: [],
        nrcms_city: [],
        household_city: [],
        address_city: [],
        origin_place_dstr: [],
        birthplace_dstr: [],
        nrcms_dstr: [],
        household_dstr: [],
        address_dstr: [],
        dstr: [],
        nation: [],
        marrage: [],
        rlatship: [],
        job: [],
        doctype: [],
        patient_type: []
    }

    // 已选择就诊人
    $scope.vpSelect = {};
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 绑卡帮助
    $scope.configData = {};
    $scope.configData.bindCardHelp = "";

    // 当前用户住院单列表
    $scope.ipNoticeList = [];
    // 是否1岁以下
    $scope.isBaby = false;
    // 是否正在获取住院单列表
    $scope.isLoadingIpNoticeList = false;
    //所选住院单下标
    $scope.submitIndex = -1;
    // 住院登记信息
    $scope.ipReg = {};
    $scope.ipRegOri = {};
    // 图片路径
    $scope.srvy_test_img = "";
    //最近一次核酸日期
    $scope.latestSrvyDate = "";
    //最近一次核酸结果
    $scope.latestSrvyResult = "";
    // 住院预约信息 wxh
    $scope.ipRegAppt = { EXPECTED_IP_DATE : '', EXPECTED_BED_TYPE : '' };
    // 是否真机 wxh
    $scope.isDevice = (window.cordova && window.cordova.plugins) ? true : false;
    // 床位类型 wxh
    $scope.bedTypeList = ["单人间","双人间","多人间"];
    // 初始就诊人信息
    $scope.IpDateNotice = "";
    // 基础字典类型列表
    $scope.baseDictTypeList = ["AREA", "NATION", "MARRAGE", "RLATSHIP", "JOB", "DOCTYPE", "PATIENT_TYPE"];
    // 级联字典类型列表 籍贯,出生地,新农合,户口,现住址
    $scope.childDictTypeList = ["ORIGIN_PLACE", "BIRTHPLACE", "NRCMS", "HOUSEHOLD", "ADDRESS"];
    // 二级级联字典类型列表 出生地,新农合,户口,现住址
    $scope.grandchildDictTypeList = ["ORIGIN_PLACE", "BIRTHPLACE", "NRCMS", "HOUSEHOLD", "ADDRESS"];
    // 初始化获取基础字典数量
    $scope.initBaseDictCount = 0;
    // 初始化获取级联字典数量
    $scope.initChildDictCount = 0;
    // 初始化获取二级级联字典数量
    $scope.initGrandchildDictCount = 0;
    // 2019.02.21 SDX 二维码扫描住院单信息
    $scope.hisIpRegNotice = {
        PATIENT_ID:"",
        HIS_IP_NOTICE_ID:""
    };
    //2021-11-26 10:53:55 WX 流调题对象数组
    $scope.srvyQuestionArr = [];

    //2022年8月24日10:05:02 cfw 委托人身份证信息数组
    $scope.srvyIdCardArr = [];

    // 2021-4-14 09:30:50 功能开关
    $scope.funcSwitch = {
        // 住院登记填写拟入院日期、床位类型开关
        ipRegDateBedServerStatus: devMode ? true : false,
        // 住院登记填写拟入院日期白名单状态
        ipRegDateServerStatus: devMode ? true : false
    };
    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;

    // 2024年1月30日10:46:57 cfw 增加云平台加载图片配置
    // 2024-2-27 16:06:04 CGZ 这么加不对，devMode也是生产环境
    //if (devMode) {
    //    $scope.imgServerUrl = "http://10.91.52.11:1133";
    //}

    //2021-12-21 16:47:51 WX 初始化省市县
    $scope.provinces = [];
    $scope.cities = [];
    $scope.countries = [];

    //cfw 2023年3月24日08:53:21 增加是否院后流程标志
    $scope.PostHospitalProcess = false;

    //cfw 2023年9月21日15:02:55 增加患者急P标志
    $scope.isEmr = false;
    //增加是否可编辑标识
    $scope.EditFlag = true;

    //2023年11月20日10:38:31 cfw hzfwx-319 增加住院号为空提示标志
    $scope.ZyhTipFlag = false;

    //cfw 2023年4月12日13:58:51 特需知情同意书
    $scope.checkSign = {};
    // 特需知情同意书放大
    $scope.imgPinchZoom = {};
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);

    // 校验信息
    $scope.Confirm = { confirm_name: "", confirm_sfz: "" };
    // 预约信息
    $scope.Visit = {};
    // 固定预约信息
    $scope.RegularVisit = {};
    // 临时预约信息
    $scope.TempVisit = {};
    // 可预约时段
    $scope.arg_schInfo = [];
    $scope.temp_List = [];
    $scope.yyid = "";
    $scope.yydate = "";
    $scope.temp_yyid = "";
    $scope.time_slot = "";//时段
    $scope.temp_time_slot = "";//时段
    $scope.patientOrg = "";//病区
    $scope.schedulingInfomation = "";
    $scope.schedulingInfo = "";
    $scope.HIS_IDB = "";
    $scope.YYInfo = {};

    // 是否开放探视
    $scope.schedulingStatus = true;
    $scope.temp_schedulingStatus = true;
    // 是否展示二维码
    $scope.codeStatus = true;
    $scope.temp_codeStatus = true;

    $scope.src = "";
    $scope.temp_src = "";
    // 取消预约
    $scope.cancelStatus = "";
    $scope.temp_cancelStatus = "";

    // 预约类型
    $scope.appointmentType = "regular_lable";

    // 陪同码提示
    $scope.accompanyTipMessage = "";
    // 更改陪同电话
    $scope.accompanyTel = "";
    // 弹窗集合
    $scope.popups;

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：填写流调
    $ionicModal.fromTemplateUrl('editSRVY.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.editSRVYModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bindCardHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：入院须知
    $ionicModal.fromTemplateUrl('ipRegNotice.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.ipRegNoticeModal = modal;
    });

    // 注册模态窗口：新冠感染风险告知
    $ionicModal.fromTemplateUrl('ipRegPreNotice.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.ipRegPreNoticeModal = modal;
    });

    // 注册模态窗口：身份证信息上传
    $ionicModal.fromTemplateUrl('IdentityCardUpload.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.IdentityCardModal = modal;
    });

    // 注册模态窗口：新冠告知同意书
    $ionicModal.fromTemplateUrl('informedConsent_XG.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.InformedConsentModal = modal;
    });

    // 注册模态窗口：患者签字窗口
    $ionicModal.fromTemplateUrl('patientSign.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.patientSignModal = modal;
    });

    // 注册模态窗口：住院登记患者签字窗口
    $ionicModal.fromTemplateUrl('patientSign_IpNotice.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.patientSignModal_IpNotice = modal;
    });

    // 注册模态窗口：特需知情同意书页面
    $ionicModal.fromTemplateUrl('informedConsent_SpecialTread.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.patientSignSpecialModal_Page = modal;
    });

    // 注册模态窗口：特需知情同意书放大显示
    $ionicModal.fromTemplateUrl('pinchZoom_SpecialTread.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.pinchZoomSpecialModal = modal;
    });

    // 注册模态窗口：特需知情同意书签字版
    $ionicModal.fromTemplateUrl('patientSign_SpecialTread.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.patientSignSpecialModal_Board = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.ipRegNoticeModal.remove();
        $scope.editSRVYModal.remove();
        $scope.IdentityCardModal.remove();
        $scope.ipRegPreNoticeModal.remove();//cfw 2023年1月4日18:40:58
        $scope.InformedConsentModal.remove();
        $scope.patientSignModal.remove();
        $scope.patientSignModal_IpNotice.remove();
        $scope.patientSignSpecialModal_Page.remove();
        $scope.pinchZoomSpecialModal.remove();
        $scope.patientSignSpecialModal_Board.remove();
    })

    // 滑到下一步
    $scope.nextSlide = function () {
        slideIpReg.next();
        $scope.step = slideIpReg.currentIndex();
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第一页按历史记录返回 或 来自消息中心
        if ($scope.from == "app.ipVisitingAppointment") {
            $state.go("app.home");
        }
        else if ($scope.step == 0 || $scope.from == "app.message") {
            $rootScope.goBack();
        }
        // 来自二维码扫描
        else if ($scope.step == 1 && $scope.from == "qrcode") {
            $rootScope.goBack();
        }
        // 预约返回住院单列表页
        else if ($scope.step == 3 || $scope.step == 4) {
            $scope.toSlide(1);
        }
        // 其他页返回上一个滑块
        else {
            slideIpReg.previous();
            $scope.step = slideIpReg.currentIndex();
        }
    }

    // 滑到指定页 wxh
    $scope.toSlide = function (index) {
        slideIpReg.slide(index);
        $scope.step = slideIpReg.currentIndex();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 填写流调模态窗口显示
    $scope.editSRVYShow = function () {
        $scope.editSRVYModal.show();
    }
    // 填写流调模态窗口隐藏
    $scope.editSRVYHide = function () {
        $scope.editSRVYModal.hide();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showLongBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }
    //#region 绑定就诊卡
    // 绑卡模态窗口显示
    $scope.bindCardShow = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;
        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
        // 绑卡帮助为空时获取
        if ($scope.configData.bindCardHelp == "" || $scope.configData.bindCardHelp.length == 0) {
            $ionicLoading.show();
            // 获取绑卡帮助和本人关系说明
            IpRegService.getBindCardHelp().then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    $scope.configData.bindCardHelp = data.data.bindCardHelp;
                    $scope.configData.isSelfDescr = data.data.isSelfDescr;
                }
                // 获取失败
                else {
                    $fwCordovaToast.showLongBottom("网络异常,请稍后重试");
                }
                $ionicLoading.hide();
            })
        }
        $scope.bindCardModal.show();
    }
    // 绑卡模态窗口隐藏
    $scope.bindCardHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            id: '',
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0
        };
    }
    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpShow = function () {
        $scope.bindCardHelpModal.show();
    }
    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpHide = function () {
        $scope.bindCardHelpModal.hide();
    }
    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwCordovaToast.showLongBottom("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }
    // 绑卡提交
    $scope.bindCardSubmit = function () {
        console.log($scope.vpBind);
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showLongBottom('请完整填写就诊人信息');
            return false;
        }
        $ionicLoading.show();
        VisitPatientService.bindVisitPatient($scope.vpBind.id, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showLongBottom(data.msg);
            } else {
                $scope.bindCardHide();     // 隐藏绑定页面
                $scope.loadVpList();            // 重新获取患者信息
                // 2017.7.28 孙老师要求开通预存账户需上传身份证
                //$scope.toSlide(2);
                $fwCordovaToast.showLongBottom('就诊卡绑定成功');
            }
            $ionicLoading.hide();
        })
    }
    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpBind.id, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showLongBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showLongBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showLongBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        });
    }
    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }
    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
    //#endregion

    //#region 上传图片部分
    $scope.imgAddActionSheet = function () {
        $ionicScrollDelegate.resize();
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }
    // 由相册选择图片
    $scope.selectImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {});
    }
    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {});
    }
    // 上传图片至服务器
    $scope.uploadImg = function (imageData) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "IP_SRVY" }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片至服务器
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();
            // 上传成功 返回值result是图片地址
            $scope.srvy_test_img = result.response;
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 图片删除
    $scope.imgDelete = function () {
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                $scope.srvy_test_img = "";
                $fwCordovaToast.showShortBottom("删除成功");
                $ionicScrollDelegate.resize();
            }
        });
    }
    //#endregion

    // 选择住院单
    $scope.selectIpNotice = function (index) {
        $scope.PostHospitalProcess = false;//院后流程标志为true
        // if ($scope.ipNoticeList[index].NOTICE_STATUS != "0" && $scope.ipNoticeList[index].NOTICE_STATUS != "1") {
        //cfw 2023年3月24日13:59:06 增加院后流程，开发status为2的权限
        if ($scope.ipNoticeList[index].NOTICE_STATUS != "0" && $scope.ipNoticeList[index].NOTICE_STATUS != "1" && $scope.ipNoticeList[index].NOTICE_STATUS != "2") {
            $fwCordovaToast.showLongBottom($scope.ipNoticeList[index].NOTICE_STATUS_REMARK);
            return;
        }

        //cfw 2023年4月7日08:56:26 增加判断，住院单状态满足0、1、2之外，还需判断当前患者是否已入院，如果患者已入院，则不可操作
        if ($scope.ipNoticeList[index].HIS_ID == "" && $scope.ipNoticeList[index].INPATIENT_FLAG != "") {
            $fwCordovaToast.showLongBottom("患者已入院，当前住院单不可用。");
            return;
        }

        // 2019.02.22 BST 修复进入填写页面后退后，再次进入级联项不显示问题，需要重置一下$scope.ipReg
        $scope.ipReg = {};
        // 2019-8-16 19:07:11 获取已选择住院单信息 供前端判断是否1岁以下
        $scope.isBaby = $scope.ipNoticeList[index].AGE.length > 0 && $scope.ipNoticeList[index].AGE.indexOf('岁') == -1;
        // 2021-11-24 15:55:39 CGZ 获取患者年龄数字用于婚姻及家属关系验证 带岁字 且 不带/ 为大于6岁 年龄去掉岁字转换为数字 否则记为0
        var ageNum = 0;
        if ($scope.ipNoticeList[index].AGE.indexOf('岁') > -1 && $scope.ipNoticeList[index].AGE.indexOf('/') == -1) {
            ageNum = Number($scope.ipNoticeList[index].AGE.substr(0, $scope.ipNoticeList[index].AGE.length - 1));
        }
        $scope.ipNoticeAge = ageNum;

        //cfw 2023年3月3日11:12:15 选择住院单后，$scope.hisIpRegNotice全局变量进行赋值，
        $scope.hisIpRegNotice = $scope.ipNoticeList[index];


        //cfw 2023年3月23日15:06:24 判断住院单状态，是否为“已入院”或者his_id不为空（住院收费处窗口已登记）
        if ($scope.hisIpRegNotice.NOTICE_STATUS == "2" || $scope.hisIpRegNotice.HIS_ID != "") {
            $scope.PostHospitalProcess = true;//院后流程标志为true
            $scope.EditFlag = false;//院后流程，不可编辑基础信息，只能重新签字
        }

        //2023年9月21日15:04:31 hzfwx-157 cfw 住院登记增加急P流程，
        if ($scope.hisIpRegNotice.ISEMR == "1") {
            $scope.isEmr = true;
            $scope.EditFlag = true;//如果是急P患者，可重新编辑基础信息

        }

        //cfw 2024年1月30日11:24:07 急p云平台调试标记
        if (devMode) {
            $scope.isEmr = true;
            $scope.EditFlag = true;
        }

        //cfw 2023年3月24日18:08:13 修改方法，进入判断是否院后流程，判断结束后，再判断是否是扫码进入
        if ($scope.from == 'qrcode') {
            $scope.PostHospitalProcessMethod();
            // $scope.getLastIPRegLastInfoV2(index);
            return;
        }

        var indexVp = -1;
        if ($scope.ipNoticeList.length > index && $scope.vpList.length > 0) {
            var vpFilter = $scope.vpList.filter(e => e.HIS_CARD_NUM == $scope.ipNoticeList[index].PATIENT_ID);
            if (vpFilter.length > 0) {
                indexVp = $scope.vpList.indexOf(vpFilter[0]);
            }
        }
        // 继续原流程
        if (indexVp >= -1) {
            $scope.selectVp(indexVp, index);
        }
        else {
            $fwCordovaToast.showLongBottom('未找到当前就诊人住院单信息，暂时无法使用此功能');
        }
    }

    //选择预约时间 wxh
    $scope.selectExpectedDate = function () {
          var value = new Date(new Date().setDate(new Date().getDate() + 14)).Format('yyyy-MM-dd');
          var defaultDate = new Date(new Date().setDate(new Date().getDate() + 14));
          if (value != null && value != '') {
              // 处理iOS日期格式
              if (currentPlatform == "iOS") {
                  value = value.replace(/-/g, "/");
              }
              defaultDate = new Date(value);
          }
          var options = {
              mode: 'date',  	// 'date' or 'time' or 'datetime'
              date: defaultDate,
              maxDate: new Date(new Date().setDate(new Date().getDate() + 30)),//new Date() + 30 * 24 * 3600 * 1000,
              minDate: new Date(new Date().setDate(new Date().getDate() + 14)),
              okText: '确定',
              cancelText: '取消',
              doneButtonLabel: '确定',
              cancelButtonLabel: '取消',
              is24Hour: true,
              androidTheme: 3,
              locale: 'zh_cn'
          };

          $cordovaDatePicker.show(options).then(function (date) {
              if (typeof (date) != 'undefined') {
                  $scope.ipRegAppt.EXPECTED_IP_DATE = new Date(date).Format('yyyy-MM-dd');
              }
          });
      };

    //选择住院预约 wxh
    $scope.selectIpNoticeDate = function(index){
        $ionicLoading.show();
        $scope.IpDateNotice = $scope.ipNoticeList[index];
        // 2021-03-11 20:01:00 默认时间为两周后
        $scope.ipRegAppt = { EXPECTED_IP_DATE : new Date(new Date().setDate(new Date().getDate() + 14)).Format('yyyy-MM-dd'), EXPECTED_BED_TYPE : '' };
        IpRegService.getIPNoticeExpectedDate($scope.IpDateNotice.OUTPATIENT_ID,$scope.IpDateNotice.HIS_IP_NOTICE_ID).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 2021-03-11 20:01:00 data.data首次录入为空
                if (data.data != null && data.data != '') {
                    $scope.ipRegAppt.EXPECTED_IP_DATE = new Date(data.data.EXPECTED_IP_DATE).Format('yyyy-MM-dd');
                    if(data.data.EXPECTED_BED_TYPE != null){
                        $scope.ipRegAppt.EXPECTED_BED_TYPE = "" + data.data.EXPECTED_BED_TYPE;
                    }
                }

                // 2021-4-27 20:16:07 增加预约入院日期白名单 只有白名单内可见
                if (devMode || data.ipRegDateServerStatus) {
                    // 住院登记填写拟入院日期白名单状态
                    $scope.funcSwitch.ipRegDateServerStatus = true;
                }

                $scope.toSlide(3);
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom("网络异常,请稍后重试");
            }
            $ionicLoading.hide();
        })
        event.stopPropagation();
    }

    // 预约提交 wxh
    $scope.saveExpected = function(){
        // 2021-4-27 20:58:32 由于只有白名单用户可填写期望入院日期 取消限制
        if($scope.funcSwitch.ipRegDateServerStatus){
            if($scope.ipRegAppt.EXPECTED_IP_DATE == "年-月-日" || $scope.ipRegAppt.EXPECTED_IP_DATE == ""){
                $fwCordovaToast.showLongBottom('"期望入院日期"不得为空，请检查后再试');
                return;
            }
            if($scope.dateFormat(new Date($scope.ipRegAppt.EXPECTED_IP_DATE)) < $scope.dateFormat(new Date()) ||
                $scope.dateFormat(new Date($scope.ipRegAppt.EXPECTED_IP_DATE)) > $scope.dateFormat(new Date(new Date().setDate(new Date().getDate() + 30)))){
                $fwCordovaToast.showLongBottom('"期望入院日期"不可超过未来30天的范围，请检查后再试');
                return;
            }
        }
        if($scope.ipRegAppt.EXPECTED_BED_TYPE == "" ){
            $fwCordovaToast.showLongBottom('"期望床位类型"不得为空，请检查后再试');
            return;
        }
        $ionicLoading.show();
        IpRegService.addIPNoticeExpectedDate($scope.ipRegAppt.EXPECTED_IP_DATE,$scope.ipRegAppt.EXPECTED_BED_TYPE,
        $scope.IpDateNotice.PATIENT_NAME,$scope.IpDateNotice.OUTPATIENT_ID,$scope.IpDateNotice.HIS_IP_NOTICE_ID).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $fwCordovaToast.showLongBottom("提交成功");
                $scope.goBack();
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom("网络异常,请稍后重试");
            }
            $ionicLoading.hide();
        })

    }
    //格式化时间
    $scope.dateFormat = function(i) {
        var tf = function (e) {
            return (e < 10 ? '0' : '') + e;
        }
        var df = tf(i.getFullYear()) + "-" + tf(i.getMonth() + 1) + "-" + tf(i.getDate());
        return new Date(df);
    }

    // 选择就诊人
    $scope.selectVp = function (indexVp, index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 就诊人id
        $scope.vpSelect = $scope.vpList[indexVp];
        // 判断绑卡状态
        if ($scope.vpSelect.IS_BIND_CARD != 1) {
            // 显示绑卡提示
            var bindCardPopup = $ionicPopup.show({
                title: '提示',
                template: '就诊人未绑定就诊卡，请绑卡后再试',
                buttons: [{
                    text: '确定',
                    type: 'button-positive',
                    onTap: function (e) {
                        bindCardPopup.close();
                        // 不加timeout popup关不掉
                        $timeout(function () {
                            $scope.bindCardShow();
                        }, 0);
                    }
                }]
            });
            //$fwCordovaToast.showLongBottom("就诊人未绑定就诊卡，请先到个人中心-就诊人管理进行绑卡操作");
            return;
        }
        $ionicLoading.show();
        // HIS验证住院单信息
        IpRegService.checkIPNotice($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            console.log(data);
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("连接超时，请稍后重试");
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom('未找到当前就诊人住院单信息，暂时无法使用此功能');
                return;
            }
            // 正常有结果

            //cfw 2023年3月25日09:41:26 走新冠知情同意书判断流程
            $scope.informedConsentXG_tip(index);


        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(data.msg);
        });
    }

        //cfw 2023年3月25日09:35:58 新冠知情同意书新提一个方法，扫码进入业务与功能按钮进入共用；
    $scope.informedConsentXG_tip = function (index) {
        //cfw 2023年1月31日09:58:03 新增流程在进入住院登记前，弹框提示新冠感染告知书
        //判断新冠告知书弹框是否起效（数据库是否有配置）
        //查询后台记录，判断新冠告知书是否已签署
        IpRegService.getSignFlag_XG($scope.ipNoticeList[index].HIS_IP_NOTICE_ID).then(function (data) {
            $scope.sign_flag = data.sign_flag;
            $scope.applyId = data.applyId;
            $scope.IP_RECORD_SIGN_ID = data.IP_RECORD_SIGN_ID;
            //权限判断 新冠告知时候弹框，还是加载模板患者进行签字
            if ($scope.agreement.ipRegPreNotice != "" && $scope.agreement.ipRegPreNotice != undefined) {
                if ($scope.sign_flag == "true") {
                    //已签署新冠告知书，进入住院登记页面
                    // $scope.getIpReg();
                    //cfw 2023年3月24日10:57:06 新流程，判断是否院后
                    $scope.PostHospitalProcessMethod();
                }

                else if ($scope.sign_flag == "false" && $scope.ipNoticeList[index].InformedConsentXgHasWard == 'True') {
                    //未签署新冠告知书，进入签字页面

                    //调用方法获取病历图片及签字内容
                    IpRegService.getRecordPic($scope.applyId).then(function (data) {
                        $scope.ipreg_InformedConsent = data.data;
                        if ($scope.ipreg_InformedConsent != undefined) {
                            for (let index = 0; index < $scope.ipreg_InformedConsent.length; index++) {
                                const element = $scope.ipreg_InformedConsent[index];
                                if (element.SEQ == "0") {
                                    //病历图片在第一行数据中
                                    $scope.img_base64 = "data:image/jpg;base64," + element.REPORT_DATA;
                                }
                                element.IP_RECORD_SIGN_ID = "";
                                element.HIS_APPLY_ID = "";
                                element.IMAGE_ID = "";
                                element.DATA = "";

                            }
                            console.log($scope.ipreg_InformedConsent);
                            $scope.InformedConsentShow();//显示新冠感染风险模态窗
                            $ionicLoading.hide();
                        } else {
                            $fwCordovaToast.showLongBottom("获取同意书失败，请稍后重试！");
                            $ionicLoading.hide();
                        }
                    }, function (error) {
                        console.log(error)
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom(error.msg);
                    });
                }
                else if ($scope.sign_flag == "false" && $scope.ipNoticeList[index].InformedConsentXgHasWard == 'False') {
                    //病区未起效
                    $scope.ipRegPreNoticeShow();//显示新冠感染风险模态窗
                    $ionicLoading.hide();
                }
                else if ($scope.sign_flag == "null") {
                    //上线过渡期间，如果患者开单时没插事件表，走原来弹框提示逻辑
                    $scope.ipRegPreNoticeShow();//显示新冠感染风险模态窗
                    $ionicLoading.hide();
                }
                else {
                    //cfw 配置为false，进入住院患者登记数据加载方法
                    // $scope.getIpReg();
                    //cfw 2023年3月24日10:57:06 新流程，判断是否院后
                    $scope.PostHospitalProcessMethod();
                }
            } else {
                //cfw 配置为false，进入住院患者登记数据加载方法
                // $scope.getIpReg();
                //cfw 2023年3月24日10:57:06 新流程，判断是否院后
                $scope.PostHospitalProcessMethod();
            }

        }, function (error) {
            console.log(error)
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(error.msg);
        });
    }


    //cfw 2023年3月24日09:43:24 增加新业务，判断是否为院后流程
    $scope.PostHospitalProcessMethod = function () {
        $ionicLoading.show();
        console.log($scope.PostHospitalProcess);
        if ($scope.PostHospitalProcess) {
            // 院后流程，从HIS获取登记住院信息
            console.log("$scope.from:" + $scope.from);
            if ($scope.from == 'qrcode') {
                IpRegService.getLastIPRegInfoV2("", $scope.hisIpRegNotice["PATIENT_ID"], $scope.hisIpRegNotice["HIS_IP_NOTICE_ID"]).then(function (data) {
                    console.log(data)
                    // 链接超时
                    if (data.result == 99) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("连接超时，请稍后重试");
                        return;
                    }
                    // 空结果
                    if (data.is_null == 1) {
                        // 本地新建填写
                        $scope.getIpRegV2($scope.hisIpRegNotice);
                        return;
                    }
                    if (data.data.length > 0) {
                        var dataIpReg = data.data[0];

                        // 新生儿体重string-->number 防止ng-model报错
                        if (dataIpReg.NEWBORN_WEIGHT != null && dataIpReg.NEWBORN_WEIGHT.length > 0) {
                            dataIpReg.NEWBORN_WEIGHT = Number(dataIpReg.NEWBORN_WEIGHT);
                        }
                        //cfw 2023年3月15日09:47:06 增加逻辑，如果患者的户口、籍贯、现住址中的县为空，赋值 “不详”-000012
                        if (dataIpReg.HOUSEHOLD_DSTR == undefined || dataIpReg.HOUSEHOLD_DSTR == null || dataIpReg.HOUSEHOLD_DSTR == "") {
                            dataIpReg.HOUSEHOLD_DSTR = "000012";
                        }

                        if (dataIpReg.ORIGIN_PLACE_DSTR == undefined || dataIpReg.ORIGIN_PLACE_DSTR == null || dataIpReg.ORIGIN_PLACE_DSTR == "") {
                            dataIpReg.ORIGIN_PLACE_DSTR = "000012";
                        }

                        if (dataIpReg.ADDRESS_DSTR == undefined || dataIpReg.ADDRESS_DSTR == null || dataIpReg.ADDRESS_DSTR == "") {
                            dataIpReg.ADDRESS_DSTR = "000012";
                        }

                        dataIpReg.SFZ = $scope.hisIpRegNotice.IDCARD_CODE;

                        //后台提交数据
                        IpRegService.ipRegInfo_Save(dataIpReg, "", $scope.hisIpRegNotice.PATIENT_ID,
                            $scope.hisIpRegNotice.HIS_IP_NOTICE_ID, $scope.from, $scope.isBaby, "", "INHERIT").then(function (data) {
                                if (data.result == 0) {
                                    $fwCordovaToast.showLongBottom("窗口住院登记信息获取失败:" + data.msg);
                                    $ionicLoading.hide();
                                    return;
                                } else {
                                    console.log(data)
                                    if (data.result == 1) {
                                        if ($scope.isEmr) {
                                            $fwCordovaToast.showLongBottom("患者已登记并办理入院，请您核对信息后进行提交。");
                                        } else {
                                            $fwCordovaToast.showLongBottom("住院登记信息获取成功，请完成签字部分。");
                                        }
                                        //信息已入库，从fwweb库重新拉取一遍数据，这次包含患者签字信息
                                        $ionicLoading.hide();
                                        //如果不是院后流程，按院流程继续；判断是否扫码进入
                                        if ($scope.from == 'qrcode') {
                                            $scope.getLastIPRegLastInfoV2();
                                        } else {
                                            $scope.getIpReg();
                                        }
                                    } else {
                                        $ionicLoading.hide();
                                        toast(data.msg);
                                    }
                                }
                            }, function (error) {
                                console.log(error)
                                $ionicLoading.hide();
                                $fwCordovaToast.showLongBottom("网络错误，请稍后重试。");
                            })

                    }
                }, function (error) {
                    console.log(error)
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(error.msg);
                });
            } else {
                IpRegService.getLastIPRegInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (dataHIS) {
                    // 获取成功
                    if (dataHIS.result == 1) {
                        // 住院单信息不为空
                        if (dataHIS.is_null == 0) {
                            gotRehospital = true;
                            // 需要赋值的key集合
                            var keys = Object.keys(dataHIS.data[0]);
                            var keysExcept = ["LAST_IP_REG_ID", "REQUEST_ID", "PATIENT_ID", "VISIT_PATIENT_NAME"];
                            for (var i in keysExcept) {
                                var index = keys.indexOf(keysExcept[i]);
                                if (index > -1) {
                                    keys.splice(index, 1);
                                }
                            }
                            var dataIpReg = dataHIS.data[0];
                            // 新生儿体重string-->number 防止ng-model报错
                            if (dataIpReg.NEWBORN_WEIGHT != null && dataIpReg.NEWBORN_WEIGHT.length > 0) {
                                dataIpReg.NEWBORN_WEIGHT = Number(dataIpReg.NEWBORN_WEIGHT);
                            }
                            //cfw 2023年3月15日09:47:06 增加逻辑，如果患者的户口、籍贯、现住址中的县为空，赋值 “不详”-000012
                            if (dataIpReg.HOUSEHOLD_DSTR == undefined || dataIpReg.HOUSEHOLD_DSTR == null || dataIpReg.HOUSEHOLD_DSTR == "") {
                                dataIpReg.HOUSEHOLD_DSTR = "000012";
                            }

                            if (dataIpReg.ORIGIN_PLACE_DSTR == undefined || dataIpReg.ORIGIN_PLACE_DSTR == null || dataIpReg.ORIGIN_PLACE_DSTR == "") {
                                dataIpReg.ORIGIN_PLACE_DSTR = "000012";
                            }

                            if (dataIpReg.ADDRESS_DSTR == undefined || dataIpReg.ADDRESS_DSTR == null || dataIpReg.ADDRESS_DSTR == "") {
                                dataIpReg.ADDRESS_DSTR = "000012";
                            }

                            //cfw 前台给证件号  和 证件类型 赋值;和微信不同，证件类型要到后台处理
                            dataIpReg.SFZ = $scope.hisIpRegNotice.IDCARD_CODE;

                            //后台提交数据
                            IpRegService.ipRegInfo_Save(dataIpReg, $scope.vpSelect.VISIT_PATIENT_ID, $scope.hisIpRegNotice.PATIENT_ID,
                                $scope.hisIpRegNotice.HIS_IP_NOTICE_ID, $scope.from, $scope.isBaby, $scope.ipNoticeAge, "INHERIT").then(function (data) {
                                    if (data.result == 0) {
                                        $fwCordovaToast.showLongBottom("窗口住院登记信息获取失败:" + data.msg);
                                        $ionicLoading.hide();
                                        return;
                                    } else {
                                        console.log(data)
                                        if (data.result == 1) {
                                            if ($scope.isEmr) {
                                                $fwCordovaToast.showLongBottom("患者已登记并办理入院，请您核对信息后进行提交。");
                                            } else {
                                                $fwCordovaToast.showLongBottom("住院登记信息获取成功，请完成签字部分。");
                                            }
                                            //信息已入库，从fwweb库重新拉取一遍数据，这次包含患者签字信息
                                            $ionicLoading.hide();
                                            //如果不是院后流程，按院流程继续；判断是否扫码进入
                                            if ($scope.from == 'qrcode') {
                                                $scope.getLastIPRegLastInfoV2();
                                            } else {
                                                $scope.getIpReg();
                                            }
                                        } else {
                                            $ionicLoading.hide();
                                            toast(data.msg);
                                        }
                                    }
                                }, function (error) {
                                    console.log(error)
                                    $ionicLoading.hide();
                                    $fwCordovaToast.showLongBottom("网络错误，请稍后重试。");
                                })
                        }
                        // 住院单信息为空
                        else {
                            $ionicLoading.hide();
                            //如果从his获取信息失败，走原流程。如果为院后流程，his一定有值，应该不会走到这里
                            //如果不是院后流程，按院流程继续；判断是否扫码进入
                            if ($scope.from == 'qrcode') {
                                $scope.getLastIPRegLastInfoV2();
                            } else {
                                $scope.getIpReg();
                            }
                        }
                    } else {
                        $ionicLoading.hide();
                        //如果从his获取信息失败，走原流程。如果为院后流程，his一定有值，应该不会走到这里
                        //如果不是院后流程，按院流程继续；判断是否扫码进入
                        if ($scope.from == 'qrcode') {
                            $scope.getLastIPRegLastInfoV2();
                        } else {
                            $scope.getIpReg();
                        }
                    }
                }, function (errHIS) {
                    $ionicLoading.hide();
                    console.log(errHIS);
                });
            }

        } else {
            $ionicLoading.hide();
            //如果不是院后流程，按院流程继续；判断是否扫码进入
            if ($scope.from == 'qrcode') {
                $scope.getLastIPRegLastInfoV2();
            } else {
                $scope.getIpReg();
            }

        }
    }

    //院后流程页面点击事件
    $scope.basic_info_message = function () {
        if ($scope.PostHospitalProcess && !$scope.isEmr) {
            $fwCordovaToast.showLongBottom("住院登记信息获取成功，请完成签字部分。");
        }
    }

    //cfw 2023年1月31日10:56:58  住院登记数据加载判断方法抽离
    $scope.getIpReg = function () {
        $scope.button_HZQM_show_ipNotice = false;
        $scope.button_JSQM_show_ipNotice = false;
        $ionicLoading.show();
        // 获取已填写过的住院登记信息
        //cfw 2023年3月24日16:16:06 增加参数住院单号
        //cfw 2023年4月6日19:07:03 增加参数，患者卡号、历次已办理住院单 NOTICE_FINISH_LIST
        IpRegService.getIpReg($scope.vpSelect.VISIT_PATIENT_ID, $scope.hisIpRegNotice.HIS_IP_NOTICE_ID, $scope.hisIpRegNotice.OUTPATIENT_ID, $scope.vpSelect.HIS_CARD_NUM, $scope.hisIpRegNotice["NOTICE_FINISH_LIST"]).then(function (dataIpReg) {

            $scope.button_HZQM_show_ipNotice = false;
            $scope.button_JSQM_show_ipNotice = false;

            console.log(dataIpReg);
            if (dataIpReg.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom(dataIpReg.msg);
                return;
            }

            //2023年11月17日15:35:55 cfw 拿到住院单获取到的住院号
            var str_zyh = dataIpReg.data.HIS_ZYH;

            // 编辑已有数据
            if (dataIpReg.data.IP_REG_ID != null && dataIpReg.data.IP_REG_ID.length > 0) {
                // 新生儿体重string-->number 防止ng-model报错
                if (dataIpReg.data.NEWBORN_WEIGHT != null && dataIpReg.data.NEWBORN_WEIGHT.length > 0) {
                    dataIpReg.data.NEWBORN_WEIGHT = Number(dataIpReg.data.NEWBORN_WEIGHT);
                }

                //cfw 2023年3月2日21:04:32  判断患者签字清除按钮是否显示
                if (dataIpReg.data.HZQM_IMG != null && dataIpReg.data.HZQM_IMG.length > 0) {
                    $scope.button_HZQM_show_ipNotice = true;
                }
                //cfw 2023年3月2日21:04:32  判断家属签字清除按钮是否显示
                if (dataIpReg.data.JSQM_IMG != null && dataIpReg.data.JSQM_IMG.length > 0) {
                    $scope.button_JSQM_show_ipNotice = true;
                }

                // 赋值给脏检测源数据
                $.extend($scope.ipRegOri, dataIpReg.data);
                // 获取市/县字典
                $scope.getRlatDict(dataIpReg);
                // 深度复制
                // 2021-4-18 19:36:14 这里如果不注释掉 会导致多次赋值 select不会被选中
                //$.extend($scope.ipReg, dataIpReg.data);
                //$ionicLoading.hide();
                // 滑到下一页


                //cfw 2023年3月24日11:16:30 省市县地址拼接赋值
                $scope.household_content = dataIpReg.household_content;
                $scope.address_content = dataIpReg.address_content;
                $scope.origin_place_content = dataIpReg.origin_place_content;

                //2023年11月17日15:09:37  cfw hzfwx-319 增加住院展示
                if (dataIpReg.data.HIS_ZYH == null || dataIpReg.data.HIS_ZYH == undefined || dataIpReg.data.HIS_ZYH == "") {
                    $scope.ZyhTipFlag = true;
                }

                //cfw 2023年6月2日16:57:38 屏蔽此处，避免加载数据时出现白页
                //$ionicLoading.hide();
                slideIpReg.next();
                $scope.step = slideIpReg.currentIndex();
            }
            // 新建数据
            else {
                var ipNoticeFilter = $scope.ipNoticeList.length > 0 ? $scope.ipNoticeList.filter(e => e.PATIENT_ID == $scope.vpSelect.HIS_CARD_NUM) : [];
                var isRehospital = ipNoticeFilter.length > 0 && ipNoticeFilter[0].REHOSPITALIZATION == "1";
                var gotRehospital = false;
                // 非首次住院
                if (isRehospital) {
                    // 从HIS获取上次住院信息 (说人话就是这哥们原先住过院, 但是没用APP填过住院登记信息)
                    IpRegService.getLastIPRegInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (dataHIS) {
                        console.log(dataHIS);
                        // 获取成功
                        if (dataHIS.result == 1) {
                            // 住院单信息不为空
                            if (dataHIS.is_null == 0) {
                                gotRehospital = true;
                                // 需要赋值的key集合
                                var keys = Object.keys(dataHIS.data[0]);
                                var keysExcept = ["LAST_IP_REG_ID", "REQUEST_ID", "PATIENT_ID", "VISIT_PATIENT_NAME"];
                                for (var i in keysExcept) {
                                    var index = keys.indexOf(keysExcept[i]);
                                    if (index > -1) {
                                        keys.splice(index, 1);
                                    }
                                }
                                // 赋值
                                for (var i in keys) {
                                    dataIpReg.data[keys[i]] = dataHIS.data[0][keys[i]];
                                }
                                // 新生儿体重string-->number 防止ng-model报错
                                if (dataIpReg.data.NEWBORN_WEIGHT != null && dataIpReg.data.NEWBORN_WEIGHT.length > 0) {
                                    dataIpReg.data.NEWBORN_WEIGHT = Number(dataIpReg.data.NEWBORN_WEIGHT);
                                }
                                //cfw 2023年3月2日21:04:32  判断患者签字清除按钮是否显示
                                if (dataIpReg.data.HZQM_IMG != null && dataIpReg.data.HZQM_IMG.length > 0) {
                                    $scope.button_HZQM_show_ipNotice = true;
                                }
                                //cfw 2023年3月2日21:04:32  判断家属签字清除按钮是否显示
                                if (dataIpReg.data.JSQM_IMG != null && dataIpReg.data.JSQM_IMG.length > 0) {
                                    $scope.button_JSQM_show_ipNotice = true;
                                }

                                //2023年11月17日15:09:37  cfw hzfwx-319 增加住院展示
                                if (str_zyh != null && str_zyh != undefined && str_zyh != "") {
                                    dataIpReg.data.HIS_ZYH = str_zyh;
                                } else {
                                    $scope.ZyhTipFlag = true;
                                }

                                // 赋值给脏检测源数据
                                $.extend($scope.ipRegOri, dataIpReg.data);
                                // 获取市/县字典
                                $scope.getRlatDict(dataIpReg);

                                // 深度复制
                                //2022年6月13日10:08:39 CFW 同步上面读取外网登记逻辑， 这里如果不注释掉 会导致多次赋值 select不会被选中
                                //$.extend($scope.ipReg, dataIpReg.data);
                                //$ionicLoading.hide();

                                $ionicLoading.hide();
                                // 滑到下一页
                                slideIpReg.next();
                                $scope.step = slideIpReg.currentIndex();
                            }
                            // 住院单信息为空
                            else {
                                // 赋值给脏检测源数据
                                $.extend($scope.ipRegOri, dataIpReg.data);
                                // 深度复制
                                $.extend($scope.ipReg, dataIpReg.data);
                                $ionicLoading.hide();
                                // 滑到下一页
                                slideIpReg.next();
                                $scope.step = slideIpReg.currentIndex();
                            }
                        }
                        $ionicLoading.hide();
                    }, function (errHIS) {
                        console.log(errHIS);
                    });
                }
                // 首次住院 或 非首次入院但未获取到上次入院信息
                // 2021-4-14 15:46:02 这里有BUG 上边的异步请求还没返回 gotRehospital值未变 先进入此分支 导致.next()执行了两遍 应该放在else里以及回调函数中
                //if (!isRehospital || !gotRehospital) {
                // 首次入院
                else {
                    // 赋值给脏检测源数据
                    $.extend($scope.ipRegOri, dataIpReg.data);
                    // 深度复制
                    $.extend($scope.ipReg, dataIpReg.data);
                    $ionicLoading.hide();
                    // 滑到下一页
                    slideIpReg.next();
                    $scope.step = slideIpReg.currentIndex();
                }
            }
        });
    }

    $scope.domDict = ["配偶", "儿子", "女儿", "孙子、孙女或外孙子、外孙女", "父母", "祖父母或外祖父母", "兄、弟、姐、妹", "其他"];
    $scope.button_HZQM_show = false;
    $scope.button_JSQM_show = false;
    $scope.jSignature = false;//初始化画布变量

    //cfw 2023年1月31日13:53:48 签字按钮点击事件，显示签字模态框
    $scope.ShowSign = function (sign_type) {
        $scope.sign_type = sign_type;//当前操作的签名

        $scope.PatientSignShow();//显示新冠感染风险模态窗
        $ionicLoading.hide();
        if ($scope.jSignature == false) {
            //初始化画布
            $("#signature").jSignature({ width: 340, height: 200, color: "#000", lineWidth: 4 });
            $scope.jSignature = true;
        }
    }
    //画布-重置按钮--重置画布
    $scope.resetSign = function () {
        $("#signature").jSignature("clear");
    }

    //画布-确认按钮-获取签名图片并绑定到页面中
    $scope.commitSignPic = function () {
        var sig = $("#signature");
        if (sig.jSignature('getData', 'native').length != 0) {
            // 将签名值赋值到对应点位
            var base64_sign = sig.jSignature('getData');

            //给点位赋值  cfw pb 不直接从画板赋值图片，在上传成功后，从服务器用路径加载 生产库屏蔽
            //临时开放
            //$("#img_" + $scope.sign_type).attr("src", "data:" + base64_sign);

            base64_sign = base64_sign.slice(base64_sign.indexOf(';base64,') + ';base64,'.length);
            //图片上传至服务器，拿到存储url  
            $scope.smsUploadImg(base64_sign, $scope.sign_type, 'informed_XG');

            $("#signature").jSignature("clear"); 
            $scope.PatientSignHide();//显示新冠感染风险模态窗
            //签名完成后滚动到页面底部
            $scope.anchorScroll("button_bottom");
        } else {
            $fwCordovaToast.showLongBottom("请进行签名。");
        }
    }
    //画布-取消按钮
    $scope.cancelSign = function () {
        $("#signature").jSignature("clear");
        $scope.PatientSignHide();//隐藏签名窗口
        //签名完成后滚动到页面底部
        $scope.anchorScroll("button_bottom");
    }
    // 上传签名图片至服务器
    $scope.smsUploadImg = function (imageData, idw, sign_type) {

        // 上传图片参数
        //var options = new FileUploadOptions();
        //options.fileKey = "fileAddPic";
        //options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        //options.mimeType = "text/plain";

        // 上传图片参数
        //var params = { urlExt: "IP_InformedConsent_Sign" }
        //options.params = params;

        // 上传图片路径 生产库
        //var uri = encodeURI(uploadUrl + "/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=jpg");

        //cfw 2024年1月23日09:54:09 增加调试模式标志，图片上传服务器云平台生产配置不同
        // 2024-2-27 16:06:04 CGZ 这么加不对，devMode也是生产环境
        var url = "";
        if (false && devMode) {
            // 上传图片路径 云平台
            url = "http://10.91.52.11:1133/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=jpg";
        } else {
            //cfw 2023年5月30日10:28:55 图片存储格式改为png，避免略缩图存储时为一个黑色背景 
            url = encodeURI(uploadUrl + "/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=png");
        }

        // 显示上传等待
        // $ionicLoading.show({
        //     template: '图片上传中...'
        // })

        IpRegService.imgUpload(url, imageData).then(function (data) {
            if (data == "error") {
                $cordovaToast.showShortBottom("签字图片保存失败");
            } else {
                // 上传成功 返回值result是图片地址
                $scope.img_temp = data;
                if (sign_type == "informed_XG") {
                    if (idw == "HZQM") {
                        $scope.ipreg_InformedConsent[0].IMAGE_ID = $scope.img_temp;
                        $scope.button_HZQM_show = true;//清除按钮显示
                    } else if (type == "JSQM") {
                        $scope.ipreg_InformedConsent[1].IMAGE_ID = $scope.img_temp;
                        $scope.button_JSQM_show = true;//清除按钮显示
                    } HZQM_IMG
                } else if (sign_type == "ipNotice") {
                    if (idw == "HZQM") {
                        $scope.ipReg.HZQM_IMG = $scope.img_temp;
                        $scope.button_HZQM_show_ipNotice = true;//清除按钮显示
                    } else if (idw == "JSQM") {
                        $scope.ipReg.JSQM_IMG = $scope.img_temp;
                        $scope.button_JSQM_show_ipNotice = true;//清除按钮显示
                    }
                }
            }
        });

        // // 上传图片至服务器
        // $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
        //     $ionicLoading.hide();
        //     // 上传成功 返回值result是图片地址
        //     $scope.img_temp = result.response;

        //     $ionicPopup.alert({
        //         title: '上传图片至服务器：result.response回参',
        //         template: result.response
        //     });

        //     if ($scope.img_temp!= "") {
        //         if (sign_type == "informed_XG") {
        //             if (idw=="HZQM") {
        //                 $scope.ipreg_InformedConsent[0].IMAGE_ID = $scope.img_temp;
        //                 $scope.button_HZQM_show = true;//清除按钮显示
        //             }else if (type=="JSQM") {
        //                 $scope.ipreg_InformedConsent[1].IMAGE_ID = $scope.img_temp;
        //                 $scope.button_JSQM_show = true;//清除按钮显示
        //             }  HZQM_IMG
        //         }else if (sign_type == "ipNotice") {
        //             if (idw=="HZQM") {
        //                 $scope.ipReg.HZQM_IMG = $scope.img_temp;
        //                 $scope.button_HZQM_show_ipNotice = true;//清除按钮显示
        //             }else if (type=="JSQM") {
        //                 $scope.ipReg.JSQM_IMG = $scope.img_temp;
        //                 $scope.button_JSQM_show_ipNotice = true;//清除按钮显示
        //             } 
        //         }

        //     }
        //     $scope.img_temp = "";

        // }, function (error) {   // 错误处理
        //     $ionicLoading.hide();
        //     $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        // }, function (progress) {
        // });
    }

    //删除某个签名图片
    $scope.deleteSign = function (sign_type) {
        if (sign_type == "HZQM") {
            $("#img_HZQM").attr("src", "");//给点位赋值
            $scope.ipreg_InformedConsent[0].IMAGE_ID = "";
            $scope.button_HZQM_show = false;//图片后面的删除按钮隐藏
        } else if (sign_type == "JSQM") {
            $("#img_JSQM").attr("src", "");//给点位赋值
            $scope.ipreg_InformedConsent[1].IMAGE_ID = "";
            $scope.button_JSQM_show = false;//图片后面的删除按钮隐藏
        }
    }

    //新冠告知模态窗-点击确认
    $scope.confirm_xg = function () {
        $scope.ipRegPreNoticeHide();//隐藏当前页面
        // $scope.getIpReg();//调到住院登记流程
        //cfw 2023年3月25日09:39:21 新冠同意书之后，走院前院后流程判断
        $scope.PostHospitalProcessMethod();
    }

    // 提交签名数据
    $scope.saveSign = function () {
        console.log($scope.ipreg_InformedConsent);

        //校验是否签名（至少签一个）
        if ($scope.ipreg_InformedConsent[0].IMAGE_ID == '' && $scope.ipreg_InformedConsent[1].IMAGE_ID == '') {
            $fwCordovaToast.showLongBottom("请进行签名。");
        } else {
            //处理签字日期
            var sign_time_hzqm = $scope.ipreg_InformedConsent[4].DATA;
            var sign_time_jsqm = $scope.ipreg_InformedConsent[5].DATA;

            if (sign_time_hzqm != undefined && sign_time_hzqm != "") {
                $scope.ipreg_InformedConsent[4].DATA = $scope.dateToString(sign_time_hzqm);
            }
            if (sign_time_jsqm != undefined && sign_time_jsqm != "") {
                $scope.ipreg_InformedConsent[5].DATA = $scope.dateToString(sign_time_jsqm);
            }

            var submitObj = JSON.stringify($scope.ipreg_InformedConsent);

            //提交到数据库
            IpRegService.SaveRecordSign(submitObj, $scope.applyId, $scope.IP_RECORD_SIGN_ID).then(function (data) {
                if (data.result == 1) {
                    $fwCordovaToast.showLongBottom("签名成功，请填写住院登记信息。");
                    $scope.InformedConsentHide();//隐藏当前页面
                    // $scope.getIpReg();//跳到住院登记流程
                    //cfw 2023年3月25日09:39:21 新冠同意书之后，走院前院后流程判断
                    $scope.PostHospitalProcessMethod();
                }
            }, function (error) {
                console.log(error)
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom(error.msg);
            });
        }
    }

    // 日期转字符
    $scope.dateToString = function (time) {
        if (time instanceof Date) {
            var year = time.getFullYear();
            var month = time.getMonth() + 1;
            var day = time.getDate();

            var dateStr = year + "年" + month + "月" + day + "日";
            return dateStr;
        }
    }

    $scope.button_HZQM_show_ipNotice = false;
    $scope.button_JSQM_show_ipNotice = false;
    $scope.jSignature_IpNotice = false;//初始化画布变量

    //cfw 2023年3月1日08:39:08 住院登记-签字按钮点击事件，显示签字模态框
    $scope.ShowSign_IpNotice = function (sign_type) {
        $scope.sign_type_IpNotice = sign_type;//当前操作的签名

        $scope.PatientSignShow_IpNotice();//显示住院登记签字模态窗
        $ionicLoading.hide();
        if ($scope.jSignature_IpNotice == false) {
            //初始化画布
            $("#signature_ipNotice").jSignature({ width: 340, height: 200, color: "#000", lineWidth: 4 });
            $scope.jSignature_IpNotice = true;
        }
    }
    //画布-重置按钮--重置画布
    $scope.resetSign_IpNotice = function () {
        $("#signature_ipNotice").jSignature("clear");
    }

    //画布-确认按钮-获取签名图片并绑定到页面中
    $scope.commitSignPic_IpNotice = function () {
        var sig = $("#signature_ipNotice");
        if (sig.jSignature('getData', 'native').length != 0) {
            // 将签名值赋值到对应点位
            var base64_sign = sig.jSignature('getData');

            //$("#img_"+$scope.sign_type_IpNotice).attr("src","data:"+base64_sign);//给点位赋值  cfw pb 不直接从画板赋值图片，在上传成功后，从服务器用路径加载

            //图片上传至服务器，拿到存储url  
            //生产库打开注释

            base64_sign = base64_sign.slice(base64_sign.indexOf(';base64,') + ';base64,'.length);
            $scope.smsUploadImg(base64_sign, $scope.sign_type_IpNotice, 'ipNotice');

            $("#signature_ipNotice").jSignature("clear");
            $scope.PatientSignHide_IpNotice();//显示新冠感染风险模态窗
            //签名完成后滚动到页面底部
            $scope.anchorScroll("save_button");
        } else {
            $fwCordovaToast.showLongBottom("请进行签名。");
        }
    }
    //画布-取消按钮
    $scope.cancelSign_IpNotice = function () {
        $("#signature_ipNotice").jSignature("clear");
        $scope.PatientSignHide_IpNotice();//隐藏签名窗口
        //签名完成后滚动到页面底部
        $scope.anchorScroll("save_button");
    }

    //删除某个签名图片
    $scope.deleteSign_IpNotice = function (sign_type) {
        if (sign_type == "HZQM") {
            if ($scope.button_HZQM_show_ipNotice) {
                $("#img_HZQM").attr("src", "");//给点位赋值
                $scope.ipReg.HZQM_IMG = "";
                $scope.button_HZQM_show_ipNotice = false;//图片后面的删除按钮隐藏
            }
        } else if (sign_type == "JSQM") {
            if ($scope.button_JSQM_show_ipNotice) {
                $("#img_JSQM").attr("src", "");//给点位赋值
                $scope.ipReg.JSQM_IMG = "";
                $scope.button_JSQM_show_ipNotice = false;//图片后面的删除按钮隐藏
            }
        }
    }

    // 获取最新的getLastIPRegInfoV2
    $scope.getLastIPRegLastInfoV2 = function () {
        $scope.button_HZQM_show_ipNotice = false;
        $scope.button_JSQM_show_ipNotice = false;
        $ionicLoading.show();
        //cfw 赋值逻辑挪到选择住院单后，屏蔽此处
        //$scope.hisIpRegNotice = $scope.ipNoticeList[index];
        // 校验是否已填写
        IpRegService.checkIpRegV2($scope.hisIpRegNotice["PATIENT_ID"], $scope.hisIpRegNotice["HIS_IP_NOTICE_ID"], $scope.hisIpRegNotice["OUTPATIENT_ID"], $scope.hisIpRegNotice["NOTICE_FINISH_LIST"]).then(function (data) {
            // 未填写 查询his
            if(data.is_null == 1) {
                IpRegService.getLastIPRegInfoV2("", $scope.hisIpRegNotice["PATIENT_ID"], $scope.hisIpRegNotice["HIS_IP_NOTICE_ID"]).then(function(data){
                    console.log(data)
                    // 链接超时
                    if (data.result == 99) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("连接超时，请稍后重试");
                        return;
                    }
                    // 空结果
                    if (data.is_null == 1) {
                        // 本地新建填写
                        $scope.getIpRegV2($scope.hisIpRegNotice);
                        return;
                    }
                    if(data.data.length > 0){
                        var hisData = data.data[0];
                        // 新生儿体重string-->number 防止ng-model报错
                        if (hisData.NEWBORN_WEIGHT != null && hisData.NEWBORN_WEIGHT.length > 0) {
                            hisData.NEWBORN_WEIGHT = Number(hisData.NEWBORN_WEIGHT);
                        }

                        //cfw 2023年3月2日21:04:32  判断患者签字清除按钮是否显示
                        if (hisData.HZQM_IMG != null && hisData.HZQM_IMG.length > 0) {
                            $scope.button_HZQM_show_ipNotice = true;
                        }
                        //cfw 2023年3月2日21:04:32  判断家属签字清除按钮是否显示
                        if (hisData.JSQM_IMG != null && hisData.JSQM_IMG.length > 0) {
                            $scope.button_JSQM_show_ipNotice = true;
                        }

                        //2023年11月20日10:29:03 cfw APP扫码流程，若从his拉取到数据，赋值住院号
                        if (data.str_zyh != null && data.str_zyh != undefined && data.str_zyh != "") {
                            hisData.HIS_ZYH = data.str_zyh;
                        } else {
                            $scope.ZyhTipFlag = true;
                        }

                        // 赋值给脏检测源数据
                        $.extend($scope.ipRegOri, hisData);
                        // 获取市/县字典
                        var getChild = $scope.getRlatDict(new Object({data:hisData}));
                        // 若获取了市县字典，会在获取完毕后完成复制及取消LOADING
                        // 对于新申请无需获取市县字典的，需要在这里手动调用
                        // 待优化
                        if (!getChild) {
                            // 深度复制
                            $.extend($scope.ipReg, hisData);
                            $ionicLoading.hide();
                        }

                        // 滑到下一页
                        slideIpReg.next();
                        $scope.step = slideIpReg.currentIndex();
                    }
                },function(error){
                    console.log(error)
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(error.msg);
                });
            } else {
                // 本地新建填写
                $scope.getIpRegV2($scope.hisIpRegNotice);
            }
        },function(error){
            $fwCordovaToast.showLongBottom('网络连接失败');
        })
    }
    // 本地新建住院单信息并填写
    $scope.getIpRegV2 = function (hisIpRegNotice) {
        $scope.button_HZQM_show_ipNotice = false;
        $scope.button_JSQM_show_ipNotice = false;
        // 获取已填写的住院单
        IpRegService.getIpRegV2(hisIpRegNotice.PATIENT_ID, hisIpRegNotice.HIS_IP_NOTICE_ID, hisIpRegNotice.PATIENT_NAME, hisIpRegNotice.OUTPATIENT_ID, hisIpRegNotice.IDCARD_CODE, hisIpRegNotice.NOTICE_FINISH_LIST).then(function (data) {
            if(data.result == 1){
                // 新生儿体重string-->number 防止ng-model报错
                if (data.data.NEWBORN_WEIGHT != null && data.data.NEWBORN_WEIGHT.length > 0) {
                    data.data.NEWBORN_WEIGHT = Number(data.data.NEWBORN_WEIGHT);
                }

                //cfw 2023年3月2日21:04:32  判断患者签字清除按钮是否显示
                if (data.data.HZQM_IMG != null && data.data.HZQM_IMG.length > 0) {
                    $scope.button_HZQM_show_ipNotice = true;
                }
                //cfw 2023年3月2日21:04:32  判断家属签字清除按钮是否显示
                if (data.data.JSQM_IMG != null && data.data.JSQM_IMG.length > 0) {
                    $scope.button_JSQM_show_ipNotice = true;
                }

                //cfw 2023年3月24日11:16:30 省市县地址拼接赋值
                $scope.household_content = data.household_content;
                $scope.address_content = data.address_content;
                $scope.origin_place_content = data.origin_place_content;

                //2023年11月20日10:38:31  cfw hzfwx-319 增加住院展示
                if (data.data.HIS_ZYH == null && data.data.HIS_ZYH == undefined || data.data.HIS_ZYH == "") {
                    $scope.ZyhTipFlag = true;
                }

                data.data.IP_REG_ID = "";
                // 赋值给脏检测源数据
                $.extend($scope.ipRegOri, data.data);
                // 获取市/县字典
                var getChild = $scope.getRlatDict(data);
                // 若获取了市县字典，会在获取完毕后完成复制及取消LOADING
                // 对于新申请无需获取市县字典的，需要在这里手动调用
                // 待优化
                if (!getChild) {
                    // 深度复制
                    $.extend($scope.ipReg, data.data);
                    $ionicLoading.hide();
                }
                // 滑到下一页
                slideIpReg.next();
                $scope.step = slideIpReg.currentIndex();
            } else {
                $ionicLoading.hide();
            }
        },function(error){
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(error.msg);
        })
    }

    //获取流调界面
    $scope.goSRVY = function(index){
        if($scope.ipNoticeList[index].SRVY_CAN_EDIT == "0" || $scope.ipNoticeList[index].SRVY_CAN_EDIT == ""){
            $fwCordovaToast.showShortBottom("您的流调已被医师审核，无法修改，请办理自助入院登记");
            return;
        }else if($scope.ipNoticeList[index].SRVY_CAN_EDIT == "-1") {
            $fwCordovaToast.showShortBottom("您的流调记录有误，请稍后再试");
            return;
        }
        $scope.submitIndex = index;
        $ionicLoading.show();
        SrvyService.getSRVYResult($scope.ipNoticeList[index].PATIENT_ID,$scope.ipNoticeList[index].HIS_IP_NOTICE_ID).then(function (data) {
            if (data.result == 1) {
                console.log(data);
                //获取患者省 市  查询  用于回显 >1说明是第一次答题，不是回显  有进京和返京两道题  如果等于=1 说明是回显
                if (data.data.filter(e => e.QUESTION_TYPE == "SELECT_PROVINCE" && e.QUESTION_ANSWER != "")[0] != undefined) {

                    //Cfw 2022年7月8日09:36:46 屏蔽以下逻辑
                    //常驻北京题
                    //var isLiveBeiJing = data.data.filter(e => e.HIS_WORD_ID == "800")[0].QUESTION_ANSWER;
                    //if (isLiveBeiJing == "1") {
                    //    isLiveBeiJing = "否";
                    //} else if (isLiveBeiJing == "2") {
                    //    isLiveBeiJing = "是";
                    //}

                    //Cfw 2022年7月8日09:24:47 翻写词号800逻辑
                    //找到省市区 父级节点
                    var P_HIS_WORD_ID_TEMP = data.data.filter(e => e.QUESTION_TYPE == "SELECT_CITY")[0].P_HIS_WORD_ID;
                    //拿到父级节点答案
                    var P_question_answer = data.data.filter(e => e.HIS_WORD_ID == P_HIS_WORD_ID_TEMP)[0].QUESTION_ANSWER;
                    P_question_answer = P_question_answer == "1" ? "否" : "是";
                    var isLiveBeiJing = P_question_answer;

                    var proCode = data.data.filter(e => e.QUESTION_TYPE == "SELECT_PROVINCE" && e.QUESTION_ANSWER != "" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER;
                    var cityCode = data.data.filter(e => e.QUESTION_TYPE == "SELECT_CITY" && e.QUESTION_ANSWER != "" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER;
                    var countyCode = data.data.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.QUESTION_ANSWER != "" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER;
                    if (proCode != "" && cityCode != "") {
                        $scope.getAreas(4, proCode).then(function (data) {
                            setTimeout(function () {
                                $scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER = cityCode;
                            }, 500)
                            setTimeout(function () {
                                $scope.getAreas(5, cityCode, countyCode);
                            }, 1000);
                        });
                    }
                }
                $scope.srvyQuestionArr = data.data;
                $scope.srvy_test_img = data.imgUrl;
                $scope.editSRVYModal.show();
                $ionicScrollDelegate.scrollTop();
            }else{
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            $ionicLoading.hide();
        });
    }

    //前端展示类型判断
    $scope.showType = function (index, type) {
        //普通题
        var flag1 = $scope.srvyQuestionArr[index].QUESTION_TYPE == type && $scope.srvyQuestionArr[index].P_HIS_WORD_ID == 0;
        //常驻北京题  Cfw 2022年7月7日16:14:44 流调需求修改题目， HIS_WORD_ID 为800的常驻北京词号改变，修改词逻辑  屏蔽以下逻辑
        //var isLiveBeiJing = $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == "800")[0].QUESTION_ANSWER;
        //if (isLiveBeiJing == "1") {
        //    isLiveBeiJing = "否";
        //} else if (isLiveBeiJing == "2") {
        //    isLiveBeiJing = "是";
        //}
        //var flag2 = $scope.srvyQuestionArr[index].P_HIS_WORD_ID == "800" && isLiveBeiJing == $scope.srvyQuestionArr[index].CONDITION && $scope.srvyQuestionArr[index].QUESTION_TYPE == type;
        if ($scope.srvyQuestionArr[index].P_HIS_WORD_ID != 0 || $scope.srvyQuestionArr[index].P_HIS_WORD_ID != "") {
            //获取该题目父级题目答案
            var P_question_answer = $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == $scope.srvyQuestionArr[index].P_HIS_WORD_ID)[0].QUESTION_ANSWER;
            P_question_answer = P_question_answer == "1" ? "否" : "是";

            flag1 = P_question_answer == $scope.srvyQuestionArr[index].CONDITION && $scope.srvyQuestionArr[index].QUESTION_TYPE == type;
        } else {
            flag1 = $scope.srvyQuestionArr[index].QUESTION_TYPE == type;
        }

        return flag1;
    }

    //保存流调答案
    $scope.saveSRVY = function () {
        var srvyArrFinal = $scope.srvyQuestionArr;
        //筛选常驻北京题目未答项  Cfw 2022年7月7日16:31:49 屏蔽以下是否常驻北京题目的校验逻辑，
        // var srvyArr = $scope.srvyQuestionArr;
        //var isLiveBeiJing = $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == "800")[0].QUESTION_ANSWER;
        //if (isLiveBeiJing == "") {
        //    $fwCordovaToast.showShortBottom("请填写" + $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == "800")[0].QUESTION_NAME);
        //    return;
        //} else if (isLiveBeiJing == "2") {
        //    isLiveBeiJing = "是";
        //} else if (isLiveBeiJing == "1") {
        //    isLiveBeiJing = "否";
        //}

        //Cfw 2022年7月7日16:50:18 屏蔽以下
        //先删除所有对立题目
        //var srvyArrFinal = [];
        //for (i in srvyArr) {
        //    if (srvyArr[i].CONDITION == isLiveBeiJing || srvyArr[i].CONDITION == "") {
        //        srvyArrFinal.push(srvyArr[i]);
        //    }
        //}

        // //Cfw 2022年7月7日16:32:36  删除常驻北京对立题目或者其他题目下的子题目（选否，级联子项屏蔽）
        // var srvyArrTemp = [];//临时容器，存放不会显示的子项题目
        // var specialItem = $scope.srvyQuestionArr.filter(e => e.P_HIS_WORD_ID != "");
        // for (i in specialItem) {
        //     //找到父节点的answer
        //     var P_question_answer = $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == specialItem[i].P_HIS_WORD_ID)[0].QUESTION_ANSWER;
        //     P_question_answer = P_question_answer == "1"?"否":"是";
        //     //父节点answer和当前节点condition比较，如果不相同则保留
        //     if (P_question_answer != specialItem[i].CONDITION)
        //      {
        //         srvyArrTemp.push(specialItem[i]);
        //     }
        // }
        // // cfw 2022年7月7日16:32:36  删除所有对立题目   
        // var srvyArrFinal = srvyArr;
        // for (i in srvyArrFinal) {
        //     for(j in srvyArrTemp)
        //     {
        //         if(srvyArrFinal[i].EPIDEMIOL_WORD_ID == srvyArrTemp[j].EPIDEMIOL_WORD_ID){
        //             srvyArrFinal.splice(i, 1);
        //         }
        //     }

        //     //图片单独传递，从数组中剔除
        //     if(srvyArrFinal[i].QUESTION_TYPE == "IMG")
        //     {
        //         srvyArrFinal.splice(i, 1);
        //     }

        // }

        //cfw 2022年7月11日08:29:21 屏蔽上面逻辑，保存题目逻辑时所有题目都进行保存，不再排除常住北京对立题目。

        // 2022-2-23 13:34:12 WX 核酸图片改为非必选题
        //if ($scope.srvy_test_img == "") {
        //    $fwCordovaToast.showShortBottom("请上传核酸检测证明");
        //    return;
        //}
        //图片单独传递，从数组中剔除
        for (i in srvyArrFinal) {
            if (srvyArrFinal[i].QUESTION_TYPE == "IMG") {
                srvyArrFinal.splice(i, 1);
            }
        }

        // cfw 2022年7月11日08:31:37 保存校验必填逻辑修改，校验子项是否填写
        for (i in srvyArrFinal) {
            if (srvyArrFinal[i].P_HIS_WORD_ID != "") {
                //找到父节点的answer

                var aaa = srvyArrFinal.filter(e => e.HIS_WORD_ID == srvyArrFinal[i].P_HIS_WORD_ID)[0];
                var P_question_answer = srvyArrFinal.filter(e => e.HIS_WORD_ID == srvyArrFinal[i].P_HIS_WORD_ID)[0].QUESTION_ANSWER;
                P_question_answer = P_question_answer == "1" ? "否" : "是";
                //父节点answer和当前节点condition比较，如果不相同则保留
                if (P_question_answer == srvyArrFinal[i].CONDITION && srvyArrFinal[i].QUESTION_ANSWER == "" && srvyArrFinal[i].QUESTION_TYPE != "DATE") {
                    $fwCordovaToast.showShortBottom("请填写" + srvyArrFinal[i].QUESTION_NAME);
                    return;
                } else if (P_question_answer != srvyArrFinal[i].CONDITION && srvyArrFinal[i].QUESTION_ANSWER != "" && srvyArrFinal[i].QUESTION_TYPE != "DATE") {
                    srvyArrFinal[i].QUESTION_ANSWER = "";
                }
            } else {
                if (srvyArrFinal[i].QUESTION_ANSWER == "" && srvyArrFinal[i].QUESTION_TYPE != "DATE") {
                    $fwCordovaToast.showShortBottom("请填写" + srvyArrFinal[i].QUESTION_NAME);
                    return;
                }
            }
        }
        console.log(srvyArrFinal);
        var stringArr = JSON.stringify(srvyArrFinal);
        SrvyService.saveSRVY(stringArr, $scope.srvy_test_img, $scope.ipNoticeList[$scope.submitIndex].PATIENT_ID, $scope.ipNoticeList[$scope.submitIndex].HIS_IP_NOTICE_ID, $scope.ipNoticeList[$scope.submitIndex].PATIENT_NAME).then(function (data) {
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("流调填写成功，请办理自助入院登记");
                $scope.editSRVYModal.hide();
                $scope.srvy_test_img = "";
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
        });
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = $scope.srvyQuestionArr[target].QUESTION_ANSWER;
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        $scope.srvyQuestionArr[target].QUESTION_ANSWER = resultDate.Format('yyyy-MM-dd');
                        break;
                    case "time":
                        $scope.srvyQuestionArr[target].QUESTION_ANSWER = resultDate.Format('hh:mm');
                        break;
                    case "datetime":
                        $scope.srvyQuestionArr[target].QUESTION_ANSWER = resultDate.Format('yyyy-MM-dd hh:mm:ss');
                        break;
                }
            }
        });
    }

    //初始化获取所有省
    $scope.getAreas = function (type, answer, countyCode) {
        var defferd = $q.defer();
        IpRegService.getDict("AREA", answer.split('|')[0]).then(function (data) {
            // 获取成功
            if (data.result == 1) {

                //Cfw 2022年7月8日09:24:47 以下屏蔽
                // var isLiveBeiJing = "";
                // if ($scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == "800")[0] != undefined) {
                //     isLiveBeiJing = $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == "800")[0].QUESTION_ANSWER;
                //     if (isLiveBeiJing == "2") {
                //         isLiveBeiJing = "是";
                //     } else if (isLiveBeiJing == "1") {
                //         isLiveBeiJing = "否";
                //     }
                // }

                //Cfw 2022年7月8日09:24:47 翻写词号800逻辑
                var isLiveBeiJing = "";
                if ($scope.srvyQuestionArr.length > 0) {
                    //找到省市区 父级节点
                    var P_HIS_WORD_ID_TEMP = $scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_CITY")[0].P_HIS_WORD_ID;
                    //拿到父级节点答案
                    var P_question_answer = $scope.srvyQuestionArr.filter(e => e.HIS_WORD_ID == P_HIS_WORD_ID_TEMP)[0].QUESTION_ANSWER;
                    P_question_answer = P_question_answer == "1" ? "否" : "是";
                    isLiveBeiJing = P_question_answer;
                }
                //页面加载
                if (type == 1) {
                    $scope.provinces = data.data;
                    $scope.cities = [];
                    $scope.countries = [];
                    //页面选择了省，清空市和县
                } else if (type == 2) {
                    $scope.cities = data.data;
                    $scope.countries = [];
                    if ($scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_CITY" && e.CONDITION == isLiveBeiJing)[0] != undefined) {
                        $scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_CITY" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER = "";
                    }
                    if ($scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.CONDITION == isLiveBeiJing)[0] != undefined) {
                        $scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER = "";
                    }
                    //页面选择了市，清空县
                } else if (type == 3) {
                    $scope.countries = data.data;
                    if ($scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.CONDITION == isLiveBeiJing)[0] != undefined) {
                        $scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER = "";
                    }
                    //页面加载市下拉框
                } else if (type == 4) {
                    $scope.cities = data.data;
                    $scope.countries = [];
                    //页面加载县下拉框
                } else if (type == 5) {
                    $scope.srvyQuestionArr.filter(e => e.QUESTION_TYPE == "SELECT_COUNTY" && e.CONDITION == isLiveBeiJing)[0].QUESTION_ANSWER = countyCode;
                    $scope.countries = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
        defferd.resolve();
        return defferd.promise;
    }

    // 获取关联字典
    $scope.getRlatDict = function (data) {
        var toGetChildDict = false;
        // 获取市/县字典
        for (var type in $scope.childDictTypeList) {
            // 如果有省份数据 获取城市字典
            if (data.data[$scope.childDictTypeList[type] + "_PRVN"] != null && data.data[$scope.childDictTypeList[type] + "_PRVN"].length > 0) {
                toGetChildDict = true;
                $scope.initChildDictCount++;
                $scope.getChildDict($scope.childDictTypeList[type], "PRVN", data.data[$scope.childDictTypeList[type] + "_PRVN"], true);
            }
        }
        return toGetChildDict;
    }

    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    // 2022-5-27 14:08:06 CGZ 建立一个错误信息字典给前端显示红线用
    $scope.errorDic = {};

    // 保存点击
    $scope.saveClick = function () {
        // 初始化错误信息字典
        $scope.errorDic = {};
        var commitFlag = "COMMIT";
        //2024年1月23日08:55:17  cfw 保存增加入参isemr，后台判断是否记日志
        var param_isEmr = "";

        // 表单验证
        // 2019-8-16 19:15:46 婴儿验证 其余清空
        // 2024年1月22日10:40:51 cfw急P流程修改，此处必填校验无须考虑急P，急P不限制必填；另外，如果患者是急P,则一定是院后流程（$scope.PostHospitalProcess）（急P取决于HIS接口查询zy_patient必填有空值）
        if (!$scope.PostHospitalProcess) {
        //if (!$scope.PostHospitalProcess || $scope.isEmr) {
            commitFlag = "";
            if ($scope.isBaby) {
                if ($scope.ipReg.BIRTH_HOSPITAL == null || $scope.ipReg.BIRTH_HOSPITAL.length == 0) {
                    $scope.anchorScroll("BIRTH_HOSPITAL");
                    $scope.errorDic.BIRTH_HOSPITAL = true;
                    $fwCordovaToast.showLongBottom('“出生医院”不得为空，请填写后再试');
                    return;
                }
                if ($scope.ipReg.BIRTH_HOSPITAL && $scope.ipReg.BIRTH_HOSPITAL.length > 25) {
                    $scope.anchorScroll("BIRTH_HOSPITAL");
                    $scope.errorDic.BIRTH_HOSPITAL = true;
                    $fwCordovaToast.showLongBottom('“出生医院”不得超过25字，请修改后再试');
                    return;
                }
                // 2021-4-18 19:53:31 虽然不知道微信为啥注释掉了 但是保持与微信同步
                //            if ($scope.ipReg.NEWBORN_WEIGHT && (typeof ($scope.ipReg.NEWBORN_WEIGHT) != "number" || $scope.ipReg.NEWBORN_WEIGHT % 1 != 0
                //                || $scope.ipReg.NEWBORN_WEIGHT < 0 || $scope.ipReg.NEWBORN_WEIGHT >= 10000000)) {
                //                $scope.anchorScroll("NEWBORN_WEIGHT");
                //                $fwCordovaToast.showLongBottom('“新生儿体重”不正确,请检查后再试');
                //                return;
                //            }
            }
            else {
                $scope.ipReg.BIRTH_HOSPITAL = "";
                $scope.ipReg.NEWBORN_WEIGHT = 0;
            }

            if ($scope.ipReg.DOCUMENT_TYPE == null || $scope.ipReg.DOCUMENT_TYPE.length == 0) {
                $scope.anchorScroll("DOCUMENT_TYPE");
                $scope.errorDic.DOCUMENT_TYPE = true;
                $fwCordovaToast.showLongBottom('“证件类型”不得为空，请填写后再试');
                return;
            }

            if ($scope.ipReg.SFZ == null || $scope.ipReg.SFZ.length == 0) {
                $scope.anchorScroll("SFZ");
                $scope.errorDic.SFZ = true;
                $fwCordovaToast.showLongBottom('“证件号”不得为空，请填写后再试');
                return;
            }

            // 2021-4-18 20:58:52 增加非空验证 与微信同步
            if ($scope.ipReg.NATION == null || $scope.ipReg.NATION.length == 0) {
                $scope.anchorScroll("NATION");
                $scope.errorDic.NATION = true;
                $fwCordovaToast.showLongBottom('“民族”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.MARRIAGE == null || $scope.ipReg.MARRIAGE.length == 0) {
                $scope.anchorScroll("MARRIAGE");
                $scope.errorDic.MARRIAGE = true;
                $fwCordovaToast.showLongBottom('“婚姻”不得为空，请填写后再试');
                return;
            }
            // 2021-11-19 17:39:03 WX 按变更要求补充婚姻状况及家属关系
            if (($scope.ipReg.MARRIAGE == "2" || $scope.ipReg.MARRIAGE == "3" || $scope.ipReg.MARRIAGE == "4") && $scope.ipNoticeAge < 18) {
                $scope.anchorScroll("MARRIAGE");
                $scope.errorDic.MARRIAGE = true;
                $fwCordovaToast.showLongBottom('“婚姻”与年龄不符，请重新填写');
                return;
            }
            if ($scope.ipReg.JOB == null || $scope.ipReg.JOB.length == 0) {
                $scope.anchorScroll("JOB");
                $scope.errorDic.JOB = true;
                $fwCordovaToast.showLongBottom('“职业”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ORIGIN_PLACE_PRVN == null || $scope.ipReg.ORIGIN_PLACE_PRVN.length == 0) {
                $scope.anchorScroll("ORIGIN_PLACE_PRVN");
                $scope.errorDic.ORIGIN_PLACE_PRVN = true;
                $fwCordovaToast.showLongBottom('“籍贯-省”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ORIGIN_PLACE_CITY == null || $scope.ipReg.ORIGIN_PLACE_CITY.length == 0) {
                $scope.anchorScroll("ORIGIN_PLACE_CITY");
                $scope.errorDic.ORIGIN_PLACE_CITY = true;
                $fwCordovaToast.showLongBottom('“籍贯-市”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ORIGIN_PLACE_DSTR == null || $scope.ipReg.ORIGIN_PLACE_DSTR.length == 0) {
                $scope.anchorScroll("ORIGIN_PLACE_DSTR");
                $scope.errorDic.ORIGIN_PLACE_DSTR = true;
                $fwCordovaToast.showLongBottom('“籍贯-县”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.BIRTHPLACE_PRVN == null || $scope.ipReg.BIRTHPLACE_PRVN.length == 0) {
                $scope.anchorScroll("BIRTHPLACE_PRVN");
                $scope.errorDic.BIRTHPLACE_PRVN = true;
                $fwCordovaToast.showLongBottom('“出生地-省”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.BIRTHPLACE_CITY == null || $scope.ipReg.BIRTHPLACE_CITY.length == 0) {
                $scope.anchorScroll("BIRTHPLACE_CITY");
                $scope.errorDic.BIRTHPLACE_CITY = true;
                $fwCordovaToast.showLongBottom('“出生地-市”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.BIRTHPLACE_DSTR == null || $scope.ipReg.BIRTHPLACE_DSTR.length == 0) {
                $scope.anchorScroll("BIRTHPLACE_DSTR");
                $scope.errorDic.BIRTHPLACE_DSTR = true;
                $fwCordovaToast.showLongBottom('“出生地-县”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.WORK_ADDRESS == null || $scope.ipReg.WORK_ADDRESS.length == 0) {
                $scope.anchorScroll("WORK_ADDRESS");
                $scope.errorDic.WORK_ADDRESS = true;
                $fwCordovaToast.showLongBottom('“工作单位及地址”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.WORK_ADDRESS && $scope.ipReg.WORK_ADDRESS.length > 50) {
                $scope.anchorScroll("WORK_ADDRESS");
                $scope.errorDic.WORK_ADDRESS = true;
                $fwCordovaToast.showLongBottom('“工作单位及地址”不得超过50字，请修改后再试');
                return;
            }
            if ($scope.ipReg.WORK_TEL && !(/^[0-9|+|\-\| ]{0,20}$/.test($scope.ipReg.WORK_TEL))) {
                $scope.anchorScroll("WORK_TEL");
                $scope.errorDic.WORK_TEL = true;
                $fwCordovaToast.showLongBottom('“单位联系电话”格式不正确或超过20字，请检查后再试');
                return;
            }
            if ($scope.ipReg.WORK_POSTCODE && !(/^[0-9]{0,6}$/.test($scope.ipReg.WORK_POSTCODE))) {
                $scope.anchorScroll("WORK_POSTCODE");
                $scope.errorDic.WORK_POSTCODE = true;
                $fwCordovaToast.showLongBottom('“单位邮编”应为纯数字且不得超过6字，请检查后再试');
                return;
            }
            if ($scope.ipReg.HOUSEHOLD_PRVN == null || $scope.ipReg.HOUSEHOLD_PRVN.length == 0) {
                $scope.anchorScroll("HOUSEHOLD_PRVN");
                $scope.errorDic.HOUSEHOLD_PRVN = true;
                $fwCordovaToast.showLongBottom('“户口地址-省”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.HOUSEHOLD_CITY == null || $scope.ipReg.HOUSEHOLD_CITY.length == 0) {
                $scope.anchorScroll("HOUSEHOLD_CITY");
                $scope.errorDic.HOUSEHOLD_CITY = true;
                $fwCordovaToast.showLongBottom('“户口地址-市”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.HOUSEHOLD_DSTR == null || $scope.ipReg.HOUSEHOLD_DSTR.length == 0) {
                $scope.anchorScroll("HOUSEHOLD_DSTR");
                $scope.errorDic.HOUSEHOLD_DSTR = true;
                $fwCordovaToast.showLongBottom('“户口地址-县”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.HOUSEHOLD_DETAIL == null || $scope.ipReg.HOUSEHOLD_DETAIL.length == 0) {
                $scope.anchorScroll("HOUSEHOLD_DETAIL");
                $scope.errorDic.HOUSEHOLD_DETAIL = true;
                $fwCordovaToast.showLongBottom('“户口详细地址”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.HOUSEHOLD_DETAIL && $scope.ipReg.HOUSEHOLD_DETAIL.length > 50) {
                $scope.anchorScroll("HOUSEHOLD_DETAIL");
                $scope.errorDic.HOUSEHOLD_DETAIL = true;
                $fwCordovaToast.showLongBottom('“户口详细地址”不得超过50字，请检查后再试');
                return;
            }
            if ($scope.ipReg.HOUSEHOLD_POSTCODE && !(/^[0-9]{0,6}$/.test($scope.ipReg.HOUSEHOLD_POSTCODE))) {
                $scope.anchorScroll("HOUSEHOLD_POSTCODE");
                $scope.errorDic.HOUSEHOLD_POSTCODE = true;
                $fwCordovaToast.showLongBottom('“户口地邮编”应为纯数字且不得超过6字，请检查后再试');
                return;
            }
            if ($scope.ipReg.ADDRESS_PRVN == null || $scope.ipReg.ADDRESS_PRVN.length == 0) {
                $scope.anchorScroll("ADDRESS_PRVN");
                $scope.errorDic.ADDRESS_PRVN = true;
                $fwCordovaToast.showLongBottom('“现住址-省”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ADDRESS_CITY == null || $scope.ipReg.ADDRESS_CITY.length == 0) {
                $scope.anchorScroll("ADDRESS_CITY");
                $scope.errorDic.ADDRESS_CITY = true;
                $fwCordovaToast.showLongBottom('“现住址-市”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ADDRESS_DSTR == null || $scope.ipReg.ADDRESS_DSTR.length == 0) {
                $scope.anchorScroll("ADDRESS_DSTR");
                $scope.errorDic.ADDRESS_DSTR = true;
                $fwCordovaToast.showLongBottom('“现住址-县”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ADDRESS_DETAIL == null || $scope.ipReg.ADDRESS_DETAIL.length == 0) {
                $scope.anchorScroll("ADDRESS_DETAIL");
                $scope.errorDic.ADDRESS_DETAIL = true;
                $fwCordovaToast.showLongBottom('“现住址详细地址”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.ADDRESS_DETAIL && $scope.ipReg.ADDRESS_DETAIL.length > 50) {
                $scope.anchorScroll("ADDRESS_DETAIL");
                $scope.errorDic.ADDRESS_DETAIL = true;
                $fwCordovaToast.showLongBottom('“现住址详细地址”不得超过50字，请检查后再试');
                return;
            }
            if ($scope.ipReg.ADDRESS_POSTCODE && !(/^[0-9]{0,6}$/.test($scope.ipReg.ADDRESS_POSTCODE))) {
                $scope.anchorScroll("ADDRESS_POSTCODE");
                $scope.errorDic.ADDRESS_POSTCODE = true;
                $fwCordovaToast.showLongBottom('“现住址邮编”应为纯数字且不得超过6字，请检查后再试');
                return;
            }
            if ($scope.ipReg.TEL == null || $scope.ipReg.TEL.length == 0) {
                $scope.anchorScroll("TEL");
                $scope.errorDic.TEL = true;
                $fwCordovaToast.showLongBottom('“联系电话”不得为空，请填写后再试');
                return;
            }
            // 2021-11-19 17:39:03 WX 按变更要求限制联系电话为手机号
            if ($scope.ipReg.TEL && !(/^1[3-9][0-9]{9}$/.test($scope.ipReg.TEL))) {
                $scope.anchorScroll("TEL");
                $scope.errorDic.TEL = true;
                $fwCordovaToast.showLongBottom('“联系电话”需填写手机号码，请检查后再试');
                return;
            }
            if ($scope.ipReg.EMAIL && ($scope.ipReg.EMAIL.length > 50 || !(/^(?:[\w-]+\.?)*[\w-]+@(?:[\w-]+\.)+[\w]{2,4}$/.test($scope.ipReg.EMAIL)))) {
                $scope.anchorScroll("EMAIL");
                $scope.errorDic.EMAIL = true;
                $fwCordovaToast.showLongBottom('“Email”格式不正确或超过50字，请检查后再试');
                return;
            }
            if ($scope.ipReg.CONTACT_NAME == null || $scope.ipReg.CONTACT_NAME.length == 0) {
                $scope.anchorScroll("CONTACT_NAME");
                $scope.errorDic.CONTACT_NAME = true;
                $fwCordovaToast.showLongBottom('“家属姓名”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.CONTACT_NAME && $scope.ipReg.CONTACT_NAME.length > 5) {
                $scope.anchorScroll("CONTACT_NAME");
                $scope.errorDic.CONTACT_NAME = true;
                $fwCordovaToast.showLongBottom('“家属姓名”不得超过5字，请检查后再试');
                return;
            }
            if ($scope.ipReg.CONTACT_RLAT == null || $scope.ipReg.CONTACT_RLAT.length == 0) {
                $scope.anchorScroll("CONTACT_RLAT");
                $scope.errorDic.CONTACT_RLAT = true;
                $fwCordovaToast.showLongBottom('“家属关系”不得为空，请填写后再试');
                return;
            }
            // 2021-11-19 17:39:03 WX 按变更要求补充婚姻状况及家属关系
            if (($scope.ipReg.CONTACT_RLAT == "11" || $scope.ipReg.CONTACT_RLAT == "12" || $scope.ipReg.CONTACT_RLAT == "13" || $scope.ipReg.CONTACT_RLAT == "14") && $scope.ipNoticeAge < 18) {
                $scope.anchorScroll("CONTACT_RLAT");
                $scope.errorDic.CONTACT_RLAT = true;
                $fwCordovaToast.showLongBottom('“家属关系”与年龄不符，请重新填写');
                return;
            }
            if ($scope.ipReg.CONTACT_TEL == null || $scope.ipReg.CONTACT_TEL.length == 0) {
                $scope.anchorScroll("CONTACT_TEL");
                $scope.errorDic.CONTACT_TEL = true;
                $fwCordovaToast.showLongBottom('“家属联系电话”不得为空，请填写后再试');
                return;
            }
            // 2021-11-19 17:39:03 WX 按变更要求限制联系电话为手机号
            if ($scope.ipReg.CONTACT_TEL && !(/^1[3-9][0-9]{9}$/.test($scope.ipReg.CONTACT_TEL))) {
                $scope.anchorScroll("CONTACT_TEL");
                $scope.errorDic.CONTACT_TEL = true;
                $fwCordovaToast.showLongBottom('“家属联系电话”需填写手机号码，请检查后再试');
                return;
            }
            if ($scope.ipReg.CONTACT_ADDRESS && $scope.ipReg.CONTACT_ADDRESS.length > 50) {
                $scope.anchorScroll("CONTACT_ADDRESS");
                $scope.errorDic.CONTACT_ADDRESS = true;
                $fwCordovaToast.showLongBottom('“家属地址”不得超过50字，请检查后再试');
                return;
            }

            // 序列化数据提交
            var ipReg = $.param($scope.ipReg);
            // 脏检测
            if ($.param($scope.ipRegOri) == ipReg) {
                $fwCordovaToast.showLongBottom('患者信息未修改，无需保存');
                return;
            }
        } else if ($scope.isEmr) {
            //如果是急P,提交标识置空，如果是commit，后台置入库签名字段
            commitFlag = "";
            param_isEmr = "1";
        }

        //cfw 2023年3月1日09:29:22 增加住院登记签字校验
        if (($scope.ipReg.HZQM_IMG == null && $scope.ipReg.JSQM_IMG == null) || ($scope.ipReg.HZQM_IMG.length == 0 && $scope.ipReg.JSQM_IMG.length == 0)) {
            $fwCordovaToast.showLongBottom('请完成"患者签字"或"患者法定代理人/近亲属"签字');
            return false;
        }

        // $scope.ipReg.HZQM_IMG = "/uploaded/IP_RECORD_SIGN/a0531a63-3dbd-49e9-8676-5ef503971e06.jpg";//app无法上传图片，临时赋值图片路径
        // $scope.ipReg.JSQM_IMG = "/uploaded/IP_RECORD_SIGN/f393e897-0aa7-4064-9409-18616449c730.jpg";//app无法上传图片，临时赋值图片路径

        $ionicLoading.show();
        IpRegService.saveIpReg($scope.ipReg, $scope.vpSelect.VISIT_PATIENT_ID, $scope.hisIpRegNotice.PATIENT_ID, $scope.hisIpRegNotice.HIS_IP_NOTICE_ID, $scope.from, $scope.isBaby, $scope.ipNoticeAge, commitFlag, param_isEmr).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showLongBottom(data.msg);
                $ionicLoading.hide();
                return;
            } else {
                // 更新脏检测源数据
                $scope.ipRegOri = {};
                $.extend($scope.ipRegOri, $scope.ipReg);
                if (data.data != null && data.data.length > 0) {
                    $scope.accompanyTipMessage = JSON.parse(data.dataJson);
                    $scope.accompanyTel = $scope.ipReg.CONTACT_TEL;
                    $scope.tipMessage();
                } else {
                    // 2018-10-18 09:47:30 改为弹出confirm 可直接返回
                    var popupOptions = {
                        title: '保存成功',
                        template: "您已保存成功，请于入院日期到住院收费处办理入院",
                        buttons: [{
                            text: '返回',
                            onTap: function (e) {
                                $scope.goBack();
                            }
                        }, {
                            text: '继续填写',
                            type: 'button-positive'
                        }]
                    };
                    var confirmPopup = $ionicPopup.show(popupOptions);
                }
                $ionicLoading.hide();
                return;
            }
        })
    }

    // 2024-11-8 17:09:14  ZZL 清除所有弹窗
    $scope.closeAllPopus = function (className) {
        //if ($scope.popups.length > 0) {
        //    $scope.popups.forEach(function (popup) {
        //        if (popup) {
        //            popup.close;
        //        }
        //    });
        //}      
        //$scope.popups = [];
        var elements = $document[0].querySelectorAll(className);
        if (elements != null && elements.length > 0) {
            elements.forEach(function (element) {
                element.parentNode.removeChild(element);
            });
        }
    }

    $scope.tipMessage = function () {
        if ($scope.popups) {
            $scope.popups.close();
        }
        if ($scope.accompanyTipMessage != "") {
            $scope.closeAllPopus(".popup-container");
            var firstRow = $scope.accompanyTipMessage.paragraph.split('|')[0];
            var secondRow = $scope.accompanyTipMessage.paragraph.split('|')[1];
            var lighted = $scope.accompanyTipMessage.highlighted_words;
            firstRow = firstRow.replace(lighted[0], '<span style="color:red">1名家属</span>');
            secondRow = secondRow.replace(lighted[1], '<span style="color:red">陪同家属电话</span> <span class= "phone-number">' + $scope.accompanyTel + '</span> ');
            var timeLeft = 3;
            var innerHtml = "";
            innerHtml += '<h3>陪同办理入院家属确认</h3>';
            innerHtml += '<p>' + firstRow + '</p>';
            innerHtml += '<p>' + secondRow + '</p>';
            innerHtml += '<div class = "actions">';
            innerHtml += '<button id = "updateTel" class="button button-small button-block button-default" style="border-color: #b2b2b2;" ng-click ="updateTel()">更改陪同电话</buttion>';
            innerHtml += '<button id = "saveTelTime"  class="button button-small button-block button-positive" style="width: 90px;font-size: 12px; background-color: gray;border: 0;">确认正确(3s)</buttion>';
            innerHtml += '<button id = "saveTel"  class="button button-small button-block button-positive" style="width: 90px;font-size: 12px; display: none;" ng-click ="saveTel(1)">确认正确</buttion>';
            innerHtml += '</div>';
            var popupOptions = {
                //title: '陪同办理入院家属确认',
                template: innerHtml,
                buttons: [],
                cssClass: 'popup',
                scope: $scope
            };
            $scope.popups = $ionicPopup.show(popupOptions);
            var timeLeft = 3;
            var countDown = setInterval(function () {
                $("#saveTelTime").text('确认正确(' + timeLeft + 's)');
                timeLeft--;
                if (timeLeft < 0) {
                    clearInterval(countDown);
                    //$("#saveTel").removeAttr('disabled').removeAttr('style').text('确认正确');
                    ////$("#saveTel").attr('onclick ', 'saveTel(1)');
                    //$timeout(function () {
                    //  var element = angular.element(document.getElementById('saveTel'));
                    //    element.attr('data-ng-click ', 'saveTel(1)');
                    //    $compile(element)($scope);
                    //},1);
                    $("#saveTelTime").hide();
                    $("#saveTel").show();
                }
            }, 1000)
            //$scope.popups.push(popup);
        }
    }

    // 2024-11-8 10:05:04 ZZL 获取陪同家属更改弹窗
    $scope.updateTel = function () {
        $scope.popups.close();
        var innerHtml = "";
        innerHtml += '<h3>陪同办理入院家属确认</h3>';
        innerHtml += '<div style= "margin-top:2%;font-size:15px;font-weight:500;margin-bottom:2%">请输入陪同家属电话</div>';
        //innerHtml += '<input type = "textArea" name = "textinput" class = "my-input-class" id = "textArea" ng-model= "accompanyTel">';
        innerHtml += '<input type = "textArea" name = "textinput" class = "my-input-class" id = "textArea" value= "">';
        innerHtml += '<div class = "actions">';
        innerHtml += '<button id = "tipMessage" class="button button-small button-block button-default" style="border-color: #b2b2b2; margin-right:3rem;" ng-click ="tipMessage()">取消</buttion>';
        innerHtml += '<button id = "saveTel" class="button button-small button-block button-positive" style="width: 90px;font-size: 12px;" ng-click = "saveTel(2)">确认</buttion>';
        innerHtml += '</div>';

        var popupOptions = {
            title: '陪同办理入院家属确认',
            template: innerHtml,
            buttons: [],
            cssClass: 'popup',
            scope: $scope
        };
        $scope.popups = $ionicPopup.show(popupOptions);
        //$scope.popups.push(popup);
    }

    //2024-11-8 16:12:42 ZZL 保存陪同家属电话
    $scope.saveTel = function (t) {
        // 1:住院登记电话,2:更改后填写的陪同电话
        if (t == 1) {
            // 2024-12-4 10:14:00 ZZL 取住院申请单对应的hisCardNum
            IpRegService.saveIpAccompany($scope.vpSelect.VISIT_PATIENT_ID, $scope.hisIpRegNotice.HIS_IP_NOTICE_ID, $scope.accompanyTel, $scope.hisIpRegNotice.PATIENT_ID).then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    $scope.popups.close();
                    setTimeout(function () {
                        $fwCordovaToast.showShortBottom(data.data);
                    }, 1000);
                    $scope.goBack();
                    $ionicLoading.hide();
                }
                // 获取失败
                else {
                    $fwCordovaToast.showLongBottom(data.msg);
                }
            })
        } else {
            var divTip = $("#telTip");
            if (divTip == undefined || divTip.length == 0) {
                $("#textArea").after('<div id = "telTip" style="color:red;font-size:10px"></div>');
            }
            if ($("#textArea").val() == undefined || $("#textArea").val() == "") {
                $("#telTip").text('陪同家属电话输入框不得为空');
                return false;
            }
            if (($("#textArea").val() && !(/^1[3-9][0-9]{9}$/.test($("#textArea").val())))) {
                $("#textArea").css("border-bottom", "0.5px red solid");
                $("#telTip").text('“陪同家属电话”需填写手机号码,请检查后再试');
                return false;
            }
            $scope.accompanyTel = $document[0].getElementById('textArea').value;
            $scope.tipMessage();
        }
    }

    // 获取级联字典
    $scope.getChildDict = function (type, level, parentDictCode, isInit, isInit2) {
        if ($scope.childDictTypeList.indexOf(type) == -1) {
            return;
        }
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        if (parentDictCode == null || parentDictCode.length == 0) {
            parentDictCode = $scope.ipReg[type + "_" + level];
        }
        //console.log(parentDictCode);
        // 从有值改为空
        if (!isInit && (parentDictCode == null || parentDictCode == "")) {
            console.log(level);
            // 下级菜单清空
            if (level == "PRVN") {
                $scope.dict[type.toLowerCase() + "_city"] = [];
                $scope.dict[type.toLowerCase() + "_dstr"] = [];
                console.log($scope.dict[type.toLowerCase() + "_city"]);
                console.log($scope.dict[type.toLowerCase() + "_dstr"]);
                // 重置市县
                $scope.ipReg[type + "_CITY"] = "";
                $scope.ipReg[type + "_DSTR"] = "";
            }
            else if (level == "CITY") {
                $scope.dict[type.toLowerCase() + "_dstr"] = [];
                console.log($scope.dict[type.toLowerCase() + "_dstr"]);
                // 重置市
                $scope.ipReg[type + "_DSTR"] = "";
            }
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    if (!isInit) {
                        $scope.dict[dictKey + "_dstr"] = [];
                        // 重置市县
                        $scope.ipReg[type + "_CITY"] = "";
                        $scope.ipReg[type + "_DSTR"] = "";
                    }
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                    if (!isInit) {
                        // 重置市
                        $scope.ipReg[type + "_DSTR"] = "";
                    }
                }
                // 是初始化调用
                if (isInit) {
                    if (!isInit2) {
                        $scope.initChildDictCount--;
                    }
                    else {
                        $scope.initGrandchildDictCount--;
                    }
                    // 并发最后一个回来的
                    if (!isInit2 && $scope.initChildDictCount == 0) {
                        // 如果有城市数据 获取区县字典 (出生地/新农合)
                        for (var key in $scope.grandchildDictTypeList) {
                            if ($scope.ipRegOri[$scope.grandchildDictTypeList[key] + "_CITY"] != null && $scope.ipRegOri[$scope.grandchildDictTypeList[key] + "_CITY"].length > 0) {
                                $scope.initGrandchildDictCount++;
                                $scope.getChildDict($scope.grandchildDictTypeList[key], "CITY", $scope.ipRegOri[$scope.grandchildDictTypeList[key] + "_CITY"], true, true);
                            }
                        }
                    }
                    else if (isInit2 && $scope.initGrandchildDictCount == 0) {
                        console.log($scope.ipRegOri);
                        $timeout(function () {
                            // 深度复制
                            $.extend($scope.ipReg, $scope.ipRegOri);
                            console.log($scope.ipReg);
                            $ionicLoading.hide();
                        }, 500);
                    }
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    //#region 初始化
    // 加载就诊人列表
    $scope.loadVpList = function () {
        $scope.initBaseDictCount++;
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log($scope.vpList);
                //console.log($scope.inVpid);
                // 指定就诊人
                if ($scope.inVpid != null && $scope.inVpid != "") {
                    var index = 0;
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.inVpid) {
                            index = i;
                        }
                    }
                    // 跳过同意页
                    $scope.nextSlide();
                    // 选择对应就诊人
                    $scope.selectVp(index);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 格式化价格 至少两位小数 返回字符串
    $scope.formatFee = function(fee) {
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于2位小数 补0
        if(indexPoint == -1 || lengthFee - indexPoint < 3) {
            feeShow = fee.toFixed(2);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 获取当前用户住院单
    $scope.getIPNotice = function () {
        $scope.initBaseDictCount++;
        $scope.isLoadingIpNoticeList = true;
        // HIS验证住院单信息
        IpRegService.getIPNotice().then(function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 获取成功
            if (data.result == 1 || data.result == -1) {
                // 住院单列表不为空
                if (data.is_null == 0) {
                    // 格式化数据
                    data.data.forEach(e => {
                        // 拟入院日期
                        e.ADMISSION_DATE = e.ADMISSION_DATE.length == 0 ? "" : new Date(e.ADMISSION_DATE).Format("yyyy年M月d日");
                        // 预交押金
                        e.PREPAID_PAYMENT = $scope.formatFee(Number(e.PREPAID_PAYMENT));
                    });
                    $scope.ipNoticeList = data.data;

                    //2023年11月7日10:38:01  cfw　住院宣教增加总开关
                    console.log("护理宣教开关判断：" + $scope.ipNoticeList[0].IpNurEduMainSwitch);
                    if ($scope.ipNoticeList[0].IpNurEduMainSwitch == "True") {
                        //2023年9月11日18:29:13 cfw 住院单逻辑修改，加载住院单后，判断是否有宣教内容
                        IpNurEduService.getIpNoticeList().then(function (data) {
                            $scope.isLoadFinish = true;
                            // 链接超时
                            if (data.result == 99) {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                                return;
                            }
                            if (data.result == "0") {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(data.msg);
                                return;
                            } else if (data.result == "1") {
                                $scope.IpEduList = data.data;
                                console.log(data.data);
                                //2023年9月11日18:35:49 轮训处理住院单，如果住院单有对应宣教，则页面显示“住院宣教”按钮
                                for (var i = 0; i < $scope.ipNoticeList.length; i++) {
                                    var temp_edu = $scope.IpEduList.filter(e => e.IDS == $scope.ipNoticeList[i].HIS_IP_NOTICE_ID);
                                    if (temp_edu != null && temp_edu.length > 0) {
                                        $scope.ipNoticeList[i].NurEdu_flag = "1";
                                    } else {
                                        //2023年10月30日14:23:12 cfw 已入院患者发送宣教his业务并未插入ids字段，部分患者入院不会关联ids，此处若ids为空，则用idb进行关联匹配
                                        var temp_eduByIdb = $scope.IpEduList.filter(e => e.IDB == $scope.ipNoticeList[i].HIS_ID);
                                        if (temp_eduByIdb != null && temp_eduByIdb.length > 0) {
                                            $scope.ipNoticeList[i].NurEdu_flag = "1";
                                            //2023年10月31日17:01:59  如果患者已入院，拿到宣教的病区代码，后续跳转做参数
                                            $scope.ipNoticeList[i].NurBqdm = temp_eduByIdb[0].CURRENT_BQDM;
                                        }
                                    }
                                }
                            }
                        }, function (data) {
                            $ionicLoading.hide();
                            $scope.isLoadFinish = true;
                            $fwCordovaToast.showShortBottom(data.msg);
                        });
                    }

                    if ($scope.from == "app.ipVisitingAppointment") {
                        $scope.toSlide(1);
                    }
                }
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        }, function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        });
    }

    //2023年9月11日18:39:40 cfw 住院单跳转住院宣教
    $scope.goNurEduPage = function (index) {
        console.log("跳转宣教，idb:" + $scope.ipNoticeList[index].HIS_ID + ",病区代码：" + $scope.ipNoticeList[index].NurBqdm + ",ids：" + $scope.ipNoticeList[index].HIS_IP_NOTICE_ID);
        if ($scope.ipNoticeList[index].NurBqdm == undefined || $scope.ipNoticeList[index].NurBqdm == "") {
            //2023年10月31日17:44:39 如果病区代码为空，则是按ids进行关联，院前患者
            var dicParams = { "kh": "", from: "app.ipReg", ids: $scope.ipNoticeList[index].HIS_IP_NOTICE_ID, idb: "", bqdm: "" }
            $state.go("app.ipNurEdu", dicParams);
        } else {
            //2023年10月31日17:45:11 如果病区代码不为空，则是按idb关联，已入院患者
            var dicParams = { "kh": "", from: "app.ipReg", ids: "", idb: $scope.ipNoticeList[index].HIS_ID, bqdm: $scope.ipNoticeList[index].NurBqdm }
            $state.go("app.ipNurEdu", dicParams);
        }
    }

    // 获取当前用户住院单V2
    $scope.getIPNoticeV2 = function () {
        $scope.initBaseDictCount++;
        $scope.isLoadingIpNoticeList = true;
        // HIS验证住院单信息
        IpRegService.getIPNoticeV2($scope.hisCardNum, $scope.ipNoticeId).then(function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 获取成功
            if (data.result == 1 || data.result == -1) {
                // 住院单列表不为空
                if (data.is_null == 0) {
                    // 格式化数据
                    data.data.forEach(e => {
                        // 拟入院日期
                        e.ADMISSION_DATE = e.ADMISSION_DATE.length == 0 ? "" : new Date(e.ADMISSION_DATE).Format("yyyy年M月d日");
                        // 预交押金
                        e.PREPAID_PAYMENT = $scope.formatFee(Number(e.PREPAID_PAYMENT));
                    });
                    $scope.ipNoticeList = data.data;
                }
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
            $scope.nextSlide();
        }, function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        });
    }

    // 获取基础字典
    $scope.getBaseDict = function (type) {
        if ($scope.baseDictTypeList.indexOf(type) == -1) {
            return;
        }
        IpRegService.getDict(type, "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                if (type == "AREA") {
                    $scope.dict["prvn"] = data.data;
                }
                else {
                    $scope.dict[type.toLowerCase()] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2021-4-14 14:32:19 检查拟入院日期、床位类型服务状态
    $scope.checkDateBedServerStatus = function () {
        IpRegService.checkDateBedServerStatus().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 住院登记填写拟入院日期、床位类型开关
                if (devMode || data.data) {
                    $scope.funcSwitch.ipRegDateBedServerStatus = true;
                }
            }
            // 获取失败
            else {
                //$fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 2021-5-4 20:38:15 显示入院须知
    $scope.showIpRegNotice = function () {
        ;
    }
    // 入院须知模态窗口显示
    $scope.ipRegNoticeShow = function () {
        event.stopPropagation();
        $scope.ipRegNoticeModal.show();
    }
    // 入院须知模态窗口隐藏
    $scope.ipRegNoticeHide = function () {
        $scope.ipRegNoticeModal.hide();
    }

    // 新冠感染风险告知模态窗口显示
    $scope.ipRegPreNoticeShow = function () {
        $scope.ipRegPreNoticeModal.show();
    }
    // 新冠感染风险告知窗口隐藏
    $scope.ipRegPreNoticeHide = function () {
        $scope.ipRegPreNoticeModal.hide();
    }

    // 特需知情同意书模态窗口显示
    $scope.patientSignSpecialShow = function () {
        $scope.patientSignSpecialModal_Page.show();
    }
    // 特需知情同意书模态窗口隐藏
    $scope.patientSignSpecialHide = function () {
        // cfw 2023年4月13日13:46:37 返回时清空知情 同意书签名
        $scope.checkSign.hzqm_img_show = "";
        $scope.checkSign.jsqm_img_show = "";
        $scope.checkSign.button_HZQM_enable = false;
        $scope.checkSign.button_JSQM_enable = false;
        $scope.patientSignSpecialModal_Page.hide();
    }

    // 特需知情同意书放大显示
    $scope.pinchZoomSpecialShow = function () {
        $scope.createPinchZoom();
        $scope.pinchZoomSpecialModal.show();
    }
    // 特需知情同意书放大隐藏
    $scope.pinchZoomSpecialHide = function () {
        $scope.pinchZoomSpecialModal.hide();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        // 释放内存
        delete $scope.imgPinchZoom;
        $scope.imgPinchZoom = {};
    }

    // 2023-4-27 15:51:42 CGZ 双指移动触发pinchZoom手势缩放
    // 2023-4-27 16:03:20 CGZ 这个注册事件监听会报错，屏蔽待查
    //document.querySelector("#MedicalRecordImg").addEventListener('touchmove', function (event) {
    //    if (event.touches && event.touches.length == 2) {
    //        $scope.pinchZoomSpecialShow();
    //    }
    //});

    // 特需知情同意书签字窗口显示
    $scope.patientSignSpecialBoardShow = function () {
        $scope.patientSignSpecialModal_Board.show();
    }
    // 特需知情同意书签字窗口隐藏
    $scope.patientSignSpecialBoardHide = function () {
        $scope.patientSignSpecialModal_Board.hide();
    }

    //cfw 2022年8月22日15:47:05 增加患者身份证照片上传
    // 身份证信息上传模态窗口显示
    $scope.IdentityCardUploadShow = function () {
        event.stopPropagation();
        $scope.IdentityCardModal.show();
    }
    // 身份证信息上传模态窗口隐藏
    $scope.IdentityCardUploadHide = function () {
        $scope.IdentityCardModal.hide();
    }

    // 新冠告知书签字模态窗口显示
    $scope.InformedConsentShow = function () {
        event.stopPropagation();
        $scope.InformedConsentModal.show();
    }
    // 新冠告知书签字模态窗口隐藏
    $scope.InformedConsentHide = function () {
        $scope.InformedConsentModal.hide();
    }

    // 患者签字模态窗口显示
    $scope.PatientSignShow = function () {
        event.stopPropagation();
        $scope.patientSignModal.show();
    }
    // 患者签字模态窗口隐藏
    $scope.PatientSignHide = function () {
        $scope.patientSignModal.hide();
    }

    // 住院登记患者签字模态窗口显示
    $scope.PatientSignShow_IpNotice = function () {
        event.stopPropagation();
        $scope.patientSignModal_IpNotice.show();
    }
    // 住院登记患者签字模态窗口隐藏
    $scope.PatientSignHide_IpNotice = function () {
        $scope.patientSignModal_IpNotice.hide();
    }

    //初始化-加载身份证照片信息
    $scope.patient_show = "";
    $scope.patient_family_show = "";
    $scope.goIdentifiyCard = function (index) {
        //cfw 2023年4月7日13:22:13  身份证照片上传增加限制，判断当前患者是否已入院，如果患者已入院，则不可操作
        if ($scope.ipNoticeList[index].HIS_ID == "" && $scope.ipNoticeList[index].INPATIENT_FLAG != "") {
            $fwCordovaToast.showLongBottom("患者已入院，当前住院单不可用。");
            return;
        }

        //患者、委托人页面前台的名称 赋值
        console.log($scope.dict.patient_type);
        $scope.dict.patient_type.forEach(element => {
            if (element.DICT_CODE == 1) {
                $scope.patient_show = element.DICT_NAME;
            } else {
                $scope.patient_family_show = element.DICT_NAME;
            }
        });

        $scope.IpregIndex = index;
        SrvyService.getIdCardResult($scope.ipNoticeList[index].OUTPATIENT_ID, $scope.ipNoticeList[index].HIS_IP_NOTICE_ID, $scope.ipNoticeList[index].PATIENT_NAME, $scope.ipNoticeList[index].IDCARD_CODE, $scope.ipNoticeList[index].NOTICE_FINISH_LIST).then(function (data) {
            if (data.result == 1) {
                console.log(data);
                $scope.srvyIdCardArr = data.data;
                $scope.IdCard_number = $scope.srvyIdCardArr.length - 1;//拿到委托人的数量。减一是去除患者本人

                //var temp = "";
                //$scope.srvyIdCardArr.forEach(element => {
                //    temp = temp + " --  " + $scope.imgServerUrl + element.CARD_ZM;
                //});
                //$fwCordovaToast.showLongBottom(temp);

                //cfw 2023年2月14日10:27:07 微信试用需求，第一次加载，或者只有患者时，默认新增一位委托人
                if ($scope.srvyIdCardArr.length == 1) {
                    $scope.AddMemberIdentifiyCard();
                }

                $scope.IdentityCardUploadShow();
                $ionicScrollDelegate.scrollTop();
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            $ionicLoading.hide();
        });
    }

    //身份证照片--点击添加委托人
    $scope.IdCard_number = 0;
    $scope.AddMemberIdentifiyCard = function () {
        if ($scope.IdCard_number < 6) {
            Member_new = { ID: "", HIS_IP_NOTICE_ID: $scope.ipNoticeList[$scope.IpregIndex].HIS_IP_NOTICE_ID, PATIENT_NAME: "", IDENTITYCARDNO: "", TYPE: "2", CARD_ZM: "", CARD_FM: "", STATUS: "1", KH: $scope.ipNoticeList[$scope.IpregIndex].OUTPATIENT_ID, XH: $scope.IdCard_number + 2, POLLING_STATUS_SUBMIT: "0", RELATIONSHIP: "" };

            $scope.srvyIdCardArr.push(Member_new);
            $scope.IdCard_number = $scope.IdCard_number + 1;
            console.log($scope.srvyIdCardArr);
        } else {
            $fwCordovaToast.showLongBottom('只能添加6位委托人。');
        }

    }
    //身份证照片--点击移除委托人
    $scope.delMemberIdentifiyCard = function (index) {
        $scope.srvyIdCardArr[index].STATUS = '0';
        var xh = 1;
        $scope.srvyIdCardArr.forEach(element => {
            if (element.STATUS != '0') {
                element.XH = xh;
                xh = xh + 1;
            }
        });
        $scope.IdCard_number = $scope.IdCard_number - 1;
    }

    //#region 上传图片部分
    $scope.idCard_img_temp = "";//图片临时路径
    $scope.IdCardimgAddActionSheet = function (index, type) {
        $ionicScrollDelegate.resize();
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                return true;
            },
            buttonClicked: function (index_type) {
                switch (index_type) {
                    case 0:     // 拍照上传
                        $scope.idCardcameraImg(index, type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.idCardselectImg(index, type);
                        return true;
                        break;
                }
            }
        });
    }
    // 由相册选择图片
    $scope.idCardselectImg = function (index, type) {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.idCarduploadImg(imageData, index, type);
        }, function (err) { });
    }
    // 调用摄像头拍照
    $scope.idCardcameraImg = function (index, type) {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.idCarduploadImg(imageData, index, type);
        }, function (err) { });
    }
    // 上传图片至服务器
    $scope.idCarduploadImg = function (imageData, index, type) {

        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "IP_SRVY" }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片至服务器
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();
            // 上传成功 返回值result是图片地址
            $scope.idCard_img_temp = result.response;

            //2023年9月15日14:50:23 hzfwx-147 上传照片时APP出现“内存不足”提示，增加图片路径校验
            if ($scope.idCard_img_temp.indexOf('uploaded') < 0) {
                $cordovaToast.showShortBottom("上传失败，请保持网络稳定，并尝试重新上传");
            } else {
                if ($scope.idCard_img_temp != "") {
                    if (type == "ZM") {
                        $scope.srvyIdCardArr[index].CARD_ZM = $scope.idCard_img_temp;
                    } else if (type == "FM") {
                        $scope.srvyIdCardArr[index].CARD_FM = $scope.idCard_img_temp;
                    }
                }
            }
            $scope.idCard_img_temp = "";
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 图片删除
    $scope.idCardimgDelete = function (index, type) {
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                if (type == "ZM") {
                    $scope.srvyIdCardArr[index].CARD_ZM = "";
                } else if (type == "FM") {
                    $scope.srvyIdCardArr[index].CARD_FM = "";
                }
                $fwCordovaToast.showShortBottom("删除成功");
                $ionicScrollDelegate.resize();
            }
        });
    }
    //#endregion

    //保存身份证照片
    $scope.saveIdCard = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        var idCardArrFinal = $scope.srvyIdCardArr;
        //cfw 2023年2月3日11:02:01  
        var message = "";

        // cfw 2022年7月11日08:31:37 保存校验必填逻辑修改，校验子项是否填写
        for (i in idCardArrFinal) {
            if (idCardArrFinal[i].STATUS == "1") {
                var wtr_xh = Number(idCardArrFinal[i].XH) - 1;
                if (idCardArrFinal[i].TYPE == "1") {
                    //cfw 2023年2月14日08:50:50  屏蔽患者信息必填校验
                }
                if (idCardArrFinal[i].TYPE == "2") {
                    if (idCardArrFinal[i].PATIENT_NAME == "" && idCardArrFinal[i].IDENTITYCARDNO == "" && idCardArrFinal[i].CARD_ZM == "" && idCardArrFinal[i].CARD_FM == "" && idCardArrFinal[i].RELATIONSHIP == "") {
                        //如果患者信息都为空，则跳过校验该患者
                        continue;
                    }
                    if (idCardArrFinal[i].PATIENT_NAME == "") {
                        message = "请填写委托人" + wtr_xh + "姓名。";
                        break;
                    }
                    if (idCardArrFinal[i].IDENTITYCARDNO == "") {
                        message = "请填写委托人" + wtr_xh + "身份证号。";
                        break;
                    }
                    if (idCardArrFinal[i].RELATIONSHIP == "") {
                        message = "请填写委托人" + wtr_xh + "与患者关系。";
                        break;
                    }
                    if (idCardArrFinal[i].CARD_ZM == "") {
                        message = "请上传委托人" + wtr_xh + "身份证照片（国徽面）。";
                        break;
                    }
                    if (idCardArrFinal[i].CARD_FM == "") {
                        message = "请上传委托人" + wtr_xh + "身份证照片（头像面）。";
                        break;
                    }
                }
            }
        }

        if (message == "") {
            console.log(idCardArrFinal);

            var xh = 1;
            idCardArrFinal.forEach(element => {
                if (element.STATUS != '0') {
                    element.XH = xh;
                    xh = xh + 1;
                }
            });

            var stringArr = JSON.stringify(idCardArrFinal);
            SrvyService.saveIdCard(stringArr, $scope.ipNoticeList[$scope.IpregIndex].OUTPATIENT_ID, $scope.ipNoticeList[$scope.IpregIndex].HIS_IP_NOTICE_ID, $scope.ipNoticeList[$scope.IpregIndex].HIS_ID).then(function (data) {
                if (data.result == 1) {
                    $fwCordovaToast.showShortBottom("身份证上传成功，请办理自助入院登记");
                    $scope.IdentityCardUploadHide();
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
            });
        } else {
            $fwCordovaToast.showShortBottom(message);
        }
    }

    //cfw 2023年4月12日10:32:44 住院登记增加特需知情同意书
    $scope.patient_show = "";
    $scope.patient_family_show = "";


    $scope.checkSign.Modify_flag = true;//是否可修改
    $scope.checkSign.button_HZQM_enable = false;//患者签名按钮是否可用
    $scope.checkSign.button_JSQM_enable = false;//家属签名按钮是否可用

    $scope.jSignature_Special = false;//初始化画布变量

    $scope.OpeninformedConsentSpecial = function (index) {

        $scope.parm_his_ip_notice_id = $scope.ipNoticeList[index].HIS_IP_NOTICE_ID;
        $scope.parm_KH = $scope.ipNoticeList[index].OUTPATIENT_ID;

        // cfw 2023年3月20日10:41:14  初始化图片路径为空，解决二次进入不刷新问题
        $scope.hzqm_img_show = "";
        $scope.jsqm_img_show = "";
        $scope.button_HZQM_enable
        $scope.button_HZQM_enable
        $scope.Modify_flag = true;

        $ionicLoading.show();
        //调用方法获取病历图片及签字内容
        RequestService.getRecordPic_special($scope.parm_his_ip_notice_id).then(function (data) {
            if (data.is_null == "1") {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("未找到该知情同意书");
            } else {
                $scope.ipreg_InformedConsent = data.data;
                for (let index = 0; index < $scope.ipreg_InformedConsent.length; index++) {
                    const element = $scope.ipreg_InformedConsent[index];
                    if (element.SEQ == "0") {
                        //病历图片在第一行数据中
                        $scope.img_base64 = "data:image/jpg;base64," + element.REPORT_DATA;

                        //取出his_apply_id
                        $scope.parm_his_apply_id = element.LOGID;
                    }
                    element.IP_RECORD_SIGN_ID = "";
                    element.HIS_APPLY_ID = "";
                    element.IMAGE_ID = "";
                    element.DATA = "";
                }
                //查看患者是否已有签名数据
                if (data.list_RECORD_SIGN_DETAIL != undefined) {
                    console.log(data.list_RECORD_SIGN_DETAIL);
                    //患者已签字，页面加载患者签字图片，并且不可修改；将签字图片绑定到全局变量
                    for (var index = 0; index < data.list_RECORD_SIGN_DETAIL.length; index++) {
                        $scope.ipreg_InformedConsent[index].IMAGE_ID = data.list_RECORD_SIGN_DETAIL[index].IMAGE_ID;
                    }
                    //置修改状态为失效
                    // 2023-4-25 10:51:43 CGZ #64485 按于飞要求，特需知情同意书允许多次覆盖重签，直到住院单管理程序关闭签名开关为止
                    //$scope.checkSign.Modify_flag = false;

                    $scope.checkSign.hzqm_img_show = $scope.imgServerUrl + $scope.ipreg_InformedConsent[0].IMAGE_ID;//赋值前台显示，解决图片裂开问题
                    $scope.checkSign.jsqm_img_show = $scope.imgServerUrl + $scope.ipreg_InformedConsent[1].IMAGE_ID;//赋值前台显示，解决图片裂开问题

                    if ($scope.ipreg_InformedConsent[0].IMAGE_ID != undefined && $scope.ipreg_InformedConsent[0].IMAGE_ID != "") {
                        $scope.checkSign.button_HZQM_enable = true;//按钮是否起效关联图片是否显示，如果有图片，则按钮起效
                    }
                    if ($scope.ipreg_InformedConsent[1].IMAGE_ID != undefined && $scope.ipreg_InformedConsent[1].IMAGE_ID != "") {
                        $scope.checkSign.button_JSQM_enable = true;//按钮是否起效关联图片是否显示，如果有图片，则按钮起效
                    }
                }

                $scope.patientSignSpecialModal_Page.show();
                $ionicLoading.hide();
            }

        }, function (error) {
            console.log(error)
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(error.msg);
        });
    }

    $scope.goTSYY = function (index) {
        $scope.appointmentType = "regular_lable";
        $scope.Confirm.confirm_name = $scope.ipNoticeList[index].PATIENT_NAME;
        $scope.Confirm.confirm_sfz = $scope.ipNoticeList[index].IDCARD_CODE.substr(10);
        $scope.getYYInfo();
        $scope.toSlide(4);
        //$state.go("app.ipVisitingAppointment", { from: "app.ipReg", PATIENT_NAME: $scope.ipNoticeList[index].PATIENT_NAME, IDCARD_CODE: $scope.ipNoticeList[index].IDCARD_CODE.substr(10) });
    }

    //微信入口-身份校验后，走API拉取预约信息及排班
    $scope.getYYInfo = function () {
        //调用取消方法

        $scope.Visit.vis_name = "";
        $scope.Visit.vis_tel = "";
        $scope.Visit.vis_sfz = "";
        $scope.time_slot = "";
        IpRegService.confirmPatientYYInfo($scope.Confirm.confirm_name, $scope.Confirm.confirm_sfz).then(function (data) {
            if (data.result == 0) {
                //接口返回失败
                $scope.alertInfo(data.msg);
            } else if (data.result == 2) {
                //患者是否校验失败，提示校验信息
                $scope.alertInfo(data.msg);
            } else if (data.result == 1) {
                $scope.arg_schInfo = [];
                $scope.temp_List = [];
                //患者身份信息校验通过，展示固定和临时页面
                $scope.patientOrg = data.patientOrg;
                $scope.HIS_IDB = data.idb;
                //判断是否有临时预约信息
                if (data.list_vInfo_temp.length > 0) {
                    $scope.temp_schedulingStatus = false;

                    //生成临时预约的列表
                    for (var j = 0; j < data.list_vInfo_temp.length; j++) {
                        $scope.temp_List.push(data.list_vInfo_temp[j]);
                    }
                }
                else {
                    $scope.temp_schedulingStatus = true;
                    $scope.temp_codeStatus = false;
                    $scope.appointmentType = 'regular_lable';
                }

                //判断是否有固定预约信息
                if (data.list_vInfo_regular.length > 0) {
                    $scope.schedulingStatus = true;
                    $scope.codeStatus = true;
                    $scope.yyid = data.list_vInfo_regular[0].yyid;
                    $scope.Visit.vis_name = data.list_vInfo_regular[0].patient_name;
                    $scope.time_slot = data.list_vInfo_regular[0].yy_slot;
                    $scope.RegularVisit.vpInfo_patientname = data.list_vInfo_regular[0].patient_name;

                    if (data.list_vInfo_regular[0].patient_orgname != null) {
                        $scope.RegularVisit.vpInfo_orgname = data.list_vInfo_regular[0].patient_orgname;
                    }
                    if (data.list_vInfo_regular[0].org_location != null) {
                        $scope.RegularVisit.vpInfo_orglocation = data.list_vInfo_regular[0].org_location;
                    } else {
                        $scope.RegularVisit.vpInfo_orglocation = "";
                    }
                    $scope.RegularVisit.vpInfo_yysj = data.list_vInfo_regular[0].yy_date + " " + data.list_vInfo_regular[0].yy_slot;
                    $scope.RegularVisit.vpInfo_yyname = data.list_vInfo_regular[0].yy_xm;
                    $scope.RegularVisit.vpInfo_orgcode = data.list_vInfo_regular[0].patient_org;

                    if (data.list_vInfo_regular[0].yy_status == "未探视") {
                        //提交点击后设置提交按钮失效
                        $("#vp_info_page_cancel").attr("disabled", false);
                        $scope.cancelStatus = "取消预约";
                    } else if (data.list_vInfo_regular[0].yy_status == "探视中") {
                        $scope.cancelStatus = "探视中";
                        //提交点击后设置提交按钮失效
                        $("#vp_info_page_cancel").attr("disabled", true);
                    } else if (data.list_vInfo_regular[0].yy_status == "探视结束") {
                        $scope.cancelStatus = "探视结束";
                        //提交点击后设置提交按钮失效
                        $("#vp_info_page_cancel").attr("disabled", true);
                    }

                    // 如果当前扫码用户不是登记预约用户，不允许展示二维码
                    if (data.list_vInfo_regular[0].current_user == "1") {
                        $scope.src = "data:image/jpeg;base64," + data.list_vInfo_regular[0].QRcode;
                    } else {
                        $("#vp_info_qrc_img").hide();//二维码显示隐藏
                        $("#vp_info_page_cancel").hide();//取消预约按钮隐藏
                        $("#vp_info_page_tip").text("非本人预约，只为您展示预约信息。");//取消预约按钮隐藏

                    }
                }
                else {
                    $scope.codeStatus = false;
                    //如果没有固定预约信息，则展示排班信息
                    if (data.schedulingInfomation != "") {
                        //动态加载可预约时间段
                        $scope.schedulingInfomation = data.schedulingInfomation;
                        var temp_schInfo = $scope.schedulingInfomation.split('&&');
                        for (var i = 0; i < temp_schInfo.length; i++) {
                            arg_temp = temp_schInfo[i].split(',');

                            if (Number(arg_temp[1]) > 0) {
                                var temp = { ID: "time_" + i, timeslot: arg_temp[0], status: "enable", selected: "" };
                            } else {
                                var temp = { ID: "time_" + i, timeslot: arg_temp[0], status: "Unenable", selected: "" };
                            }
                            $scope.arg_schInfo.push(temp);
                        }
                    }
                    else {
                        $scope.schedulingStatus = false;
                        $scope.schedulingInfo = data.schedulingStatus;
                    }
                }
                if ($scope.appointmentType == 'temp_lable' && data.list_vInfo_temp.length > 0) {
                    if ($scope.temp_yyid != "") {
                        $scope.opQrcImage($scope.temp_yyid);
                        $scope.temp_codeStatus = true;
                    }
                    else {
                        $scope.toSlide(4);
                    }
                }
                else {
                    $scope.toSlide(4);
                }
                $("#regular_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                $("#temp_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                if ($scope.appointmentType == "regular_lable") {
                    $("#regular_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                }
                else {
                    $("#temp_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                }
            }
        }, function (error) {
            $fwCordovaToast.showLongBottom('网络连接失败');
        })
    }

    //选择预约时段--该时段已约满提示
    $scope.selectTimeUnable = function () {
        $scope.alertInfo("该时段已约满，请预约其他时段！");
    }

    //选择预约时段
    $scope.selectTime = function (param_time_slot) {
        for (var i = 0; i < $scope.arg_schInfo.length; i++) {
            var tempButton = $scope.arg_schInfo[i];
            if (tempButton.status == "enable") {
                if (tempButton.timeslot == param_time_slot) {
                    $scope.arg_schInfo[i].selected = "true";
                    $("#" + tempButton.ID).attr("style", "background-color: rgb(121,6,63);color: white;font-size: 13px;text-shadow: none;width: 90px;padding: .5em .2em;");

                } else {
                    $scope.arg_schInfo[i].selected = "";
                    $("#" + tempButton.ID).attr("style", "font-size: 13px;text-shadow: none;width: 90px;padding: .5em .2em;");

                }
            }
        }
    }

    $scope.saveAppointInfo_wx = function (cancel_type) {
        var org_timeSlot = "";//病区当日预约排班
        var type = "";
        var yyid = "";
        var yy_time = "";
        var time_slot = "";
        if (cancel_type == "regular") {
            org_timeSlot = $scope.schedulingInfomation;
            for (var i = 0; i < $scope.arg_schInfo.length; i++) {
                var tempButton = $scope.arg_schInfo[i];
                if (tempButton.status == "enable" && tempButton.selected == "true") {
                    $scope.time_slot = tempButton.timeslot;
                    time_slot = tempButton.timeslot;
                }
            }
            yyid = $scope.yyid;
            type = "2";//业务分类
            if ($scope.Visit.vis_name == "") {
                $scope.alertInfo("请输入探视人姓名！");
                return;

            } else if ($scope.Visit.vis_tel == "") {
                $scope.alertInfo("请输入探视人电话！");
                return;

            } else if ($scope.Visit.vis_sfz == "") {
                $scope.alertInfo("请输入探视人身份证号码！");
                return;
            } else if ($scope.time_slot == "") {
                $scope.alertInfo("请选择预约时间段！");
                return;
            }
        }
        else if (cancel_type == "temp") {
            type = "3";//业务分类
            yyid = $scope.temp_yyid;
            yy_time = $scope.yydate;
            time_slot = $scope.temp_time_slot;
            if ($scope.Visit.vis_name == "") {
                $scope.alertInfo("请输入探视人姓名！");
                return;

            } else if ($scope.Visit.vis_tel == "") {
                $scope.alertInfo("请输入探视人电话！");
                return;

            } else if ($scope.Visit.vis_sfz == "") {
                $scope.alertInfo("请输入探视人身份证号码！");
                return;
            }
        }


        //提交
        IpRegService.saveAppointment(yyid, $scope.Confirm.confirm_name, $scope.patientOrg, org_timeSlot, $scope.Visit.vis_name, $scope.Visit.vis_tel, $scope.Visit.vis_sfz, yy_time, time_slot, type, $scope.HIS_IDB).then(function (data) {
            if (data.result == 1) {
                $ionicPopup.alert({
                    title: "提示",
                    template: "预约成功！",
                    okText: "确定"
                }).then(function (res) {
                    $scope.getYYInfo();
                });
            } else if (data.result == 2) {
                //当前时段已约满，请跟换其他时段！
                $scope.alertInfo(data.msg);
                //刷新当前页面
                $scope.getYYInfo();
            } else if (data.result == 0) {
                $scope.alertInfo(data.msg);
            }
        }, function (error) {
            $fwCordovaToast.showLongBottom('网络连接失败');
        })
    }

    //取消预约信息弹框确认
    $scope.cancelAppointInfo_confirm = function (cancel_type) {
        var type = "";
        var yyid = "";
        if (cancel_type == "regular") {
            type = "2";//业务分类
            yyid = $scope.yyid;
        } else if (cancel_type == "temp") {
            type = "3";//业务分类
            yyid = $scope.temp_yyid;
        }
        var confirmPopup = $ionicPopup.confirm({
            title: "取消预约",
            cancelText: '取消',
            okText: '确定'
        });
        confirmPopup.then(function (res) {
            if (res) {
                IpRegService.cancelAppointment(yyid, $scope.Confirm.confirm_name, $scope.patientOrg, $scope.Visit.vis_name, $scope.time_slot, type, $scope.HIS_IDB).then(function (data) {
                    if (data.result == 1) {
                        $scope.Visit.vis_name = "";
                        $scope.Visit.vis_tel = "";
                        $scope.Visit.vis_sfz = "";
                        $scope.time_slot = "";
                        $scope.HIS_IDB = "";
                        $scope.temp_yyid = "";
                        $ionicPopup.alert({
                            title: "提示",
                            template: "取消成功！",
                            okText: "确定"
                        }).then(function (res) {
                            //刷新当前页面
                            $scope.getYYInfo();
                        });
                    } else if (data.result == 2) {
                        if (cancel_type == "regular" || cancel_type == "temp") {
                            //当前探视状态为探视中或者探视结束，不可取消
                            $scope.alertInfo(data.msg);
                            //刷新当前页面
                            $scope.getYYInfo();
                        } else {
                            //当前探视状态为探视中或者探视结束，不可取消
                            $scope.alertInfo(data.msg);
                            window.location.reload(true);//刷新当前页面，已有已有记录，自动跳转到预约码展示
                        }

                    } else if (data.result == 0) {
                        $scope.alertInfo(data.msg);
                    }
                }, function (error) {
                    $fwCordovaToast.showLongBottom('网络连接失败');
                })
            }
        })
    }

    //页面顶部标签 固定临时 切换
    $scope.type_switch = function (type) {
        console.log(type + "页面标签切换");
        $scope.Visit.vis_name = "";
        $scope.Visit.vis_tel = "";
        $scope.Visit.vis_sfz = "";
        $scope.time_slot = "";
        $("#regular_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
        $("#temp_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
        if (type == "regular_lable") {
            $scope.appointmentType = 'regular_lable';
            $("#regular_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
        } else {
            $scope.appointmentType = 'temp_lable';
            $("#temp_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
        }
    }

    $scope.alertInfo = function (msg) {
        $ionicPopup.alert({
            title: "提示",
            template: msg,
            okText: "确定"
        }).then(function (res) {
            console.log(msg);
        });
    }

    $scope.showTempVisitPate = function (yyid) {
        $scope.temp_yyid = yyid;
        for (var i = 0; i < $scope.temp_List.length; i++) {
            var vpinfo = $scope.temp_List[i];
            if (vpinfo.yyid == yyid) {
                //预约日期和预约时间全局变量赋值
                $scope.yydate = vpinfo.yy_date;
                $scope.temp_time_slot = vpinfo.yy_slot;
                $scope.TempVisit.vpInfo_yysj = vpinfo.yy_date + "  " + vpinfo.yy_slot;
                $scope.TempVisit.vpInfo_orgcode = vpinfo.patient_org;
                $scope.Visit = {};
                if (vpinfo.yy_status == "未登记") {
                    $scope.temp_codeStatus = false;
                    $scope.temp_schedulingStatus = false;
                }
                else {
                    $scope.temp_codeStatus = true;
                    $scope.temp_schedulingStatus = false;
                }
            }
        }
        $scope.toSlide(5);
    }

    //临时预约列表 查看预约二维码按钮
    $scope.opQrcImage = function (yyid) {
        $scope.temp_yyid = yyid;
        for (var i = 0; i < $scope.temp_List.length; i++) {
            var vpinfo = $scope.temp_List[i];
            if (vpinfo.yyid == yyid) {
                $scope.yydate = vpinfo.yy_date;
                $scope.temp_time_slot = vpinfo.yy_slot;
                $scope.TempVisit.vpInfo_patientname = vpinfo.patient_name;

                if (vpinfo.patient_orgname != null) {
                    $scope.TempVisit.vpInfo_orgname = vpinfo.patient_orgname;
                }
                if (vpinfo.org_location != null) {
                    $scope.TempVisit.vpInfo_orglocation = vpinfo.org_location;
                } else {
                    $scope.TempVisit.vpInfo_orglocation = "";
                }
                $scope.TempVisit.vpInfo_yysj = vpinfo.yy_date + " " + vpinfo.yy_slot;
                $scope.TempVisit.vpInfo_yyname = vpinfo.yy_xm;
                $scope.TempVisit.vpInfo_orgcode = vpinfo.patient_org;
                if (vpinfo.yy_status == "未登记") {
                    $scope.temp_codeStatus = false;
                }
                else if (vpinfo.yy_status == "未探视") {
                    $scope.temp_codeStatus = true;
                    //提交点击后设置提交按钮失效
                    $("#temp_vp_info_page_cancel").attr("disabled", false);
                    $scope.temp_cancelStatus = "取消预约";
                } else if (vpinfo.yy_status == "探视中") {
                    $scope.temp_codeStatus = true;
                    $scope.temp_cancelStatus = "探视中";
                    //提交点击后设置提交按钮失效
                    $("#temp_vp_info_page_cancel").attr("disabled", true);
                } else if (vpinfo.yy_status == "探视结束") {
                    $scope.temp_codeStatus = true;
                    $scope.temp_cancelStatus = "探视结束";
                    //提交点击后设置提交按钮失效
                    $("#temp_vp_info_page_cancel").attr("disabled", true);
                }

                $scope.temp_src = "data:image/jpeg;base64," + vpinfo.QRcode;
                $scope.Visit = {};
                if (vpinfo.yy_status == "未登记") {
                    $scope.temp_codeStatus = false;
                    $scope.temp_schedulingStatus = false;
                }
                else {
                    $scope.temp_codeStatus = true;
                    $scope.temp_schedulingStatus = false;
                }
            }
        }
        $scope.toSlide(5);
    }

    // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            //var src = $("#imgCheckResultOrigin").prop("src");
            //// 防止赋值不同步
            //if (src == "") {
            //    $timeout(function () {
            //        // 创建图片手势控件
            //        $scope.createPinchZoom();
            //    }, 0);
            //    return;
            //}
            //// 无图片
            //if ($("#imgCheckResult").length != 1) {
            //    return;
            //}
            //// 初始化
            //if ($("#divCheckResult>#imgCheckResult").length == 0) {
            //    // 还原节点位置
            //    $("#divCheckResult").append($("#imgCheckResult"));
            //    // 删除控件
            //    //$("#divCheckResult .pinch-zoom-container").remove();
            //    // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
            //    $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            //}
            //// 复制图片路径
            //$("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgPinchZoom");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgPinchZoom = new PinchZoom.default(img, zoomOptions);
            $scope.imgPinchZoom.enable();
        }, 0);
    }

    //cfw 2023年1月31日13:53:48 签字按钮点击事件，显示签字模态框
    $scope.ShowSign_special = function (sign_type) {
        if ($scope.checkSign.Modify_flag) {
            $scope.sign_type = sign_type;//当前操作的签名

            $scope.patientSignSpecialBoardShow();//显示特需签字版
            $ionicLoading.hide();
            if ($scope.jSignature_Special == false) {
                //初始化画布
                $("#signature_special").jSignature({ width: 340, height: 200, color: "#000", lineWidth: 4 });
                $scope.jSignature_Special = true;
            }
        } else {
            $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
        }

    }

    //画布-重置按钮--重置画布
    $scope.resetSign_special = function () {
        $("#signature_special").jSignature("clear");
    }

    //画布-确认按钮-获取签名图片并绑定到页面中
    $scope.commitSignPic_special = function () {
        var sig = $("#signature_special");
        if (sig.jSignature('getData', 'native').length != 0) {
            // 将签名值赋值到对应点位
            var base64_sign = sig.jSignature('getData');

            //$("#img_"+$scope.sign_type).attr("src","data:"+base64_sign);//给点位赋值  cfw pb 不直接从画板赋值图片，在上传成功后，从服务器用路径加载

            //图片上传至服务器，拿到存储url
            //生产库打开注释
            base64_sign = base64_sign.slice(base64_sign.indexOf(';base64,') + ';base64,'.length);
            $scope.smsUploadImg_special(base64_sign, $scope.sign_type);

            $("#signature_special").jSignature("clear");

            $scope.patientSignSpecialBoardHide();
            //签名完成后滚动到页面底部
            $scope.anchorScroll("button_bottom");
        } else {
            $fwCordovaToast.showLongBottom("请进行签名。");
        }
    }
    //画布-取消按钮
    $scope.cancelSign_special = function () {
        $("#signature_special").jSignature("clear");
        $scope.patientSignSpecialBoardHide();//隐藏签名窗口
        //签名完成后滚动到页面底部
        $scope.anchorScroll("button_bottom");
    }
    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    //前台图片显示绑定变量
    $scope.checkSign.hzqm_img_show = "";
    $scope.checkSign.jsqm_img_show = "";
    // 上传签名图片至服务器
    $scope.smsUploadImg_special = function (imageData, idw) {
        //cfw 2024年1月23日09:54:09 增加调试模式标志，图片上传服务器云平台生产配置不同
        // 2024-2-27 16:06:04 CGZ 这么加不对，devMode也是生产环境
        var url = "";
        if (false && devMode) {
            // 上传图片路径 云平台
            url = "http://10.91.52.11:1133/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=jpg";
        } else {
            // 上传图片路径 生产库
            //var url = encodeURI(uploadUrl + "/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=jpg");

            //cfw 2023年5月30日10:28:55 图片存储格式改为png，避免略缩图存储时为一个黑色背景 
            url = encodeURI(uploadUrl + "/UploadHandler.ashx?Type=base64string&IsCut=0&IsDes=0&RlatType=IP_RECORD_SIGN&NeedFileType=png");
        }

        RequestService.imgUpload(url, imageData).then(function (data) {
            if (data == "error") {
                $cordovaToast.showShortBottom("签字图片保存失败");
            } else {
                // 上传成功 返回值result是图片地址
                $scope.img_temp = data;

                if (idw == "HZQM") {
                    $scope.ipreg_InformedConsent[0].IMAGE_ID = $scope.img_temp;//赋值后台存储
                    $scope.checkSign.hzqm_img_show = $scope.imgServerUrl + $scope.img_temp;//赋值前台显示，解决图片裂开问题
                    $scope.checkSign.button_HZQM_enable = true;//清除按钮是否可用
                } else if (idw == "JSQM") {
                    $scope.ipreg_InformedConsent[1].IMAGE_ID = $scope.img_temp;
                    $scope.checkSign.jsqm_img_show = $scope.imgServerUrl + $scope.img_temp;//赋值前台显示，解决图片裂开问题
                    $scope.checkSign.button_JSQM_enable = true;//清除按钮是否可用
                }
            }
        });
    }

    //删除某个签名图片
    $scope.deleteSign_special = function (sign_type) {
        if ($scope.checkSign.Modify_flag) {
            if (sign_type == "HZQM") {
                if ($scope.checkSign.button_HZQM_enable) {
                    $scope.ipreg_InformedConsent[0].IMAGE_ID = "";
                    $scope.checkSign.hzqm_img_show = "";//赋值前台显示为空，解决图片裂开问题
                    $scope.checkSign.button_HZQM_enable = false;//清除按钮是否可用

                }
            } else if (sign_type == "JSQM") {
                if ($scope.checkSign.button_JSQM_enable) {
                    $("#img_JSQM").attr("src", "");//给点位赋值
                    $scope.ipreg_InformedConsent[1].IMAGE_ID = "";
                    $scope.checkSign.jsqm_img_show = "";//赋值前台显示为空，解决图片裂开问题
                    $scope.checkSign.button_JSQM_enable = false;//图片后面的删除按钮是否可用
                }
            }
        } else {
            $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
        }
    }

    // 提交签名数据
    $scope.saveSign_special = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        if ($scope.checkSign.Modify_flag) {

            $ionicLoading.show();
            // $scope.ipreg_InformedConsent[0].IMAGE_ID = "/uploaded/IP_RECORD_SIGN/a0531a63-3dbd-49e9-8676-5ef503971e06.jpg";//app无法上传图片，临时赋值图片路径
            // $scope.ipreg_InformedConsent[1].IMAGE_ID = "/uploaded/IP_RECORD_SIGN/f393e897-0aa7-4064-9409-18616449c730.jpg";//app无法上传图片，临时赋值图片路径

            $scope.ipreg_InformedConsent[0].REPORT_DATA = "";//提交前，清除病历图片
            //校验是否签名（至少签一个）
            // 2023-4-27 14:24:43 CGZ 这里写错了，改成或才是至少签一个
            if ($scope.ipreg_InformedConsent[0].IMAGE_ID != '' || $scope.ipreg_InformedConsent[1].IMAGE_ID != '') {
                var submitObj = JSON.stringify($scope.ipreg_InformedConsent);

                //提交到数据库
                IpRegService.saveRecordSign_special(submitObj, $scope.parm_his_ip_notice_id, $scope.parm_his_apply_id, $scope.parm_KH).then(function (data) {
                    if (data.result == 1) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("签名成功。");
                        $scope.patientSignSpecialHide();
                    } else if (data.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
                    }
                }, function (error) {
                    console.log(error)
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(error.msg);
                });
            } else {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("请进行患者和直系亲属签名。");
            }
        } else {
            $fwCordovaToast.showLongBottom("您已签署，无需再次签署。");
        }
    }

    //cfw 2023年6月16日13:15:36 预问诊按钮跳转小程序
    $scope.Openweapp = function (index) {
        console.log("开始跳转小程序");
        // 住院预问诊
        //var param = { type: "ipPreCollection", param: "hisCardNum=374343e1-d9a6-4ca2-9010-d46da55f99f2&ipNoticeId=515929" }
        var param = { type: "ipPreCollection", param: "hisCardNum=" + $scope.ipNoticeList[index].PATIENT_ID + "&ipNoticeId=" + $scope.ipNoticeList[index].HIS_IP_NOTICE_ID }
        var funcSuccess = function (data) {
        }
        var funcError = function (data) {
        }
        window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideIpReg.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'ipReg');
        $ionicLoading.show();
        // 获取用户须知信息
        IpRegService.agreement().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.agreement.ipRegDescription = data.data;
                // 2021-5-4 20:55:17 入院须知
                $scope.agreement.ipRegNotice = data.ipRegNotice;

                //cfw 2023年1月31日09:55:37 屏蔽以下内容，新冠感染提示挪到点击住院单时处理
                //cfw  2023年1月4日18:30:02 入院须知后增加 感染新冠风险 告知
                $scope.agreement.ipRegPreNotice = data.ipRegPreNotice;
                //if ($scope.agreement.ipRegPreNotice != "" || $scope.agreement.ipRegPreNotice != undefined) {
                //    $scope.ipRegPreNoticeShow();//显示新冠感染风险模态窗
                //}
            }
            // 查询失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
        if($scope.from == "qrcode"){
            $scope.getIPNoticeV2();
        } else {
            // 加载就诊人列表
            $scope.loadVpList();
            // 获取当前用户住院单
            $scope.getIPNotice();
        }
        // 获取基础字典
        for (var type in $scope.baseDictTypeList) {
            $scope.initBaseDictCount++;
            $scope.getBaseDict($scope.baseDictTypeList[type]);
        }
        // 2021-4-14 14:32:19 检查拟入院日期、床位类型服务状态
        $scope.checkDateBedServerStatus();
        // 2021-12-21 09:02:00 WX 住院流调新增是否常驻北京题目
        $scope.getAreas(1, "");
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'ipReg') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
    //#endregion
})
