﻿angular.module('fwapp.controllers')

.controller('IpSatisController', function ($scope, $rootScope, $state, $stateParams, $ionicLoading, $ionicPopup,
    $fwCordovaToast, $cordovaToast, $ionicPlatform, $ionicActionSheet, $ionicSlideBoxDelegate, $ionicScrollDelegate,
    IpSatisService, RequestService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义Slide控制
    var slideIpSatis = $ionicSlideBoxDelegate.$getByHandle('slideIpSatis');

    // 评价类别及值
    $scope.satis = { IP: 0, TREAT: 0, SVC: 0, EQUIP: 0, PROC: 0 };
    $scope.levels =
        [
            { key: "非常满意", value: 5 },
            { key: "满意", value: 4 },
            { key: "一般", value: 3 },
            { key: "不满意", value: 2 },
            { key: "非常不满意", value: 1 }
        ];

    // 待评价满意度列表
    $scope.ipSatisSrvyList = [];

    // 进行rid请求
    $scope.request = { PATIENT_NAME: "", INPATIENT_ID: "" };

    $scope.stepLast = -1;
    $scope.step = -1;

    // 评价id
    $scope.satisId = "";
    // 评价
    $scope.answer =
        {
            IP_SATIS_LEVEL: 0,
            IP_UNSATIS_REASON: "",

            TREAT_SATIS_LEVEL: 0,
            TREAT_UNSATIS_REASON_DOC: "",
            TREAT_UNSATIS_REASON_NUR: "",

            SVC_SATIS_LEVEL: 0,
            SVC_UNSATIS_REASON_DOC: "",
            SVC_UNSATIS_REASON_NUR: "",
            SVC_UNSATIS_DEPT: "",
            SVC_UNSATIS_REASON_DEPT: "",
            SVC_UNSATIS_REASON_OTHER: "",

            EQUIP_SATIS_LEVEL: 0,
            EQUIP_UNSATIS_REASON_WARD: "",
            EQUIP_UNSATIS_DEPT: "",
            EQUIP_UNSATIS_REASON_DEPT: "",
            EQUIP_UNSTIS_REASON_PUBLIC: "",

            PROC_SATIS_LEVEL: 0,
            PROC_UNSATIS_POINT: "",
            PROC_UNSATIS_REASON_POINT: "",

            ORIGIN: 0,
            ADVICE_CONTENT: ""
        };

    // 以下是方法

    // 0.提交前
    $scope.beforeSubmit = function () {
        if (!check()) {
            $ionicLoading.hide();
            return;
        }

        $ionicPopup.confirm({
            title: "住院满意度随访问卷",
            template: "随访问卷提交后不可修改，是否提交？",
            cancelText: '返回修改',
            okText: '立即提交'
        }).then(function (res) {
            if (res) {
                $scope.submit();
            }
            else {
                return;
            }
        })
    }

    // 1.提交
    $scope.submit = function () {

        $ionicLoading.show();

        $scope.answer.IP_SATIS_SRVY_ID = $scope.satisId;
        $scope.answer.IP_SATIS_LEVEL = $scope.satis.IP;
        $scope.answer.TREAT_SATIS_LEVEL = $scope.satis.TREAT;
        $scope.answer.SVC_SATIS_LEVEL = $scope.satis.SVC;
        $scope.answer.EQUIP_SATIS_LEVEL = $scope.satis.EQUIP;
        $scope.answer.PROC_SATIS_LEVEL = $scope.satis.PROC;

        IpSatisService.submit($scope.answer).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $fwCordovaToast.showShortBottom("随访问卷提交成功! 感谢您的合作与支持");
                setTimeout(function () {
                    if ($scope.stepLast == 0) {
                        ipSatisSrvyList();
                        // 2021-4-20 08:59:35 HM 增加滚到顶部
                        $ionicScrollDelegate.scrollTop();
                        $ionicScrollDelegate.resize();
                    }
                    else {
                        $state.go('app.home');
                    }
                }, 2000);
            }
        })
    }

    // 2.检查
    check = function () {
        if ($scope.satisId == "") {
            $fwCordovaToast.showShortBottom("随访问卷提交失败，请稍后重试");
            return false;
        }

        if ($scope.satis.IP == 0) {
            $fwCordovaToast.showShortBottom("请选择对就医整体的满意程度");
            return false;
        }
        else if ($scope.satis.IP == 1 || $scope.satis.IP == 2) {
            if ($scope.answer.IP_UNSATIS_REASON == "") {
                $fwCordovaToast.showShortBottom("请填写对就医整体不满意的原因");
                return false;
            }
        }

        if ($scope.satis.TREAT == 0) {
            $fwCordovaToast.showShortBottom("请选择对医疗水平的满意程度");
            return false;
        }
        else if ($scope.satis.TREAT == 2 || $scope.satis.TREAT == 1) {
            if ($scope.answer.TREAT_UNSATIS_REASON_DOC == "" && $scope.answer.TREAT_UNSATIS_REASON_NUR == "") {
                $fwCordovaToast.showShortBottom("请填写对医疗水平不满意的原因");
                return false;
            }
        }

        if ($scope.satis.SVC == 0) {
            $fwCordovaToast.showShortBottom("请选择对服务态度的满意程度");
            return false;
        }
        else if ($scope.satis.SVC == 2 || $scope.satis.TREAT == 1) {
            if ($scope.answer.SVC_UNSATIS_REASON_DOC == "" && $scope.answer.SVC_UNSATIS_REASON_NUR == "" &&
                    $scope.answer.SVC_UNSATIS_REASON_DEPT == "" && $scope.answer.SVC_UNSATIS_REASON_OTHER == "") {
                $fwCordovaToast.showShortBottom("请填写对服务态度不满意的原因");
                return false;
            }
        }

        if ($scope.satis.EQUIP == 0) {
            $fwCordovaToast.showShortBottom("请选择对硬件设施的满意程度");
            return false;
        }
        else if ($scope.satis.EQUIP == 2 || $scope.satis.EQUIP == 1) {
            if ($scope.answer.EQUIP_UNSATIS_REASON_WARD == "" &&
                    $scope.answer.EQUIP_UNSATIS_REASON_DEPT == "" && $scope.answer.EQUIP_UNSTIS_REASON_PUBLIC == "") {
                $fwCordovaToast.showShortBottom("请填写对硬件设施不满意的原因");
                return false;
            }
        }

        if ($scope.satis.PROC == 0) {
            $fwCordovaToast.showShortBottom("请选择对就医流程的满意程度");
            return false;
        }
        else if ($scope.satis.PROC == 2 || $scope.satis.PROC == 1) {
            if ($scope.answer.PROC_UNSATIS_REASON_POINT == "") {
                $fwCordovaToast.showShortBottom("请填写对就医流程不满意的原因");
                return false;
            }
        }

        return true;
    }

    // 3.选择赋值
    $scope.selectThis = function (type, value) {
        $scope.satis[type] = value;

        // 重新计算高度
        $ionicScrollDelegate.resize();
    }

    // 4.待填写评价列表加载
    ipSatisSrvyList = function () {
        IpSatisService.ipSatisSrvyList().then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
                setTimeout(function () {
                    $state.go('app.home');
                }, 1000);
            }
            else {
                $scope.ipSatisSrvyList = result.list;
                // 去往列表页
                $scope.step = 0;
                slideIpSatis.slide($scope.step);
            }
        })
    }

    // 5.列表页 某个待评价 => 评价页
    $scope.IpSatis = function (satisId) {
        $scope.satisId = satisId;
        $scope.stepLast = 0;
        $scope.step = 2;
        slideIpSatis.slide($scope.step);

        console.log($scope.satisId);
    }

    // 5.5 检查当月是否正确次数
    $scope.ipSatieCheckMonthCount = function () {
        IpSatisService.ipSatieCheckMonthCount().then(function (result) {
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.ipSatisCheckPatient();
            }
        })
    }

    // 6.基本信息页 => 评价页
    $scope.ipSatisCheckPatient = function () {
        $ionicLoading.show();
        RequestService.ipSatisCheckPatient($scope.request.INPATIENT_ID, $scope.request.PATIENT_NAME).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.satisId = result.satisId;
                // 去往评价页
                $scope.stepLast = 1;
                $scope.step = 2;
                slideIpSatis.slide($scope.step);

                console.log($scope.satisId);
            }
        })
    }

    // 7. 取消评价
    $scope.cancelIpSatis = function (satisId) {
        IpSatisService.cancelIpSatis(satisId).then(function (result) { })
    }


    // 页面的进入与退出
    // 1.准备
    ionic.DomUtil.ready(function () {
        // 禁用左右滑动
        slideIpSatis.enableSlide(false);
    });

    // 2.加载
    $scope.$on('$ionicView.loaded', function () {
        // 未指定satisId
        if ($stateParams.satisId == "") {
            ipSatisSrvyList();
        }
        // App扫微信码进
        else if ($stateParams.satisId == "AppScanCode") {
            $scope.step = 1;
            slideIpSatis.slide($scope.step);
        }
        // 指定satisId
        else {
            $scope.satisId = $stateParams.satisId;
            $scope.step = 2;
            slideIpSatis.slide($scope.step);
        }
    })

    // 3.进入
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'ipSatis');
    });

    // 4.退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'ipSatis') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 5.后退
    $scope.goBack = function () {
        switch ($scope.step) {
            // 首页
            case -1:
                // 列表页
            case 0:
                // 基础页
            case 1:
                {
                    // 2021-4-18 21:25:58 增加个人中心入口 改为全局返回
                    //$state.go('app.home');
                    $rootScope.goBack();
                    break;
                }
            case 2:
                {
                    $ionicPopup.confirm({
                        title: "住院满意度随访问卷",
                        template: "您尚未完成住院满意度随访问卷，后退将不保存任何内容，是否后退？",
                        cancelText: '取消',
                        okText: '确定'
                    }).then(function (res) {
                        if (res) {
                            $scope.cancelIpSatis($scope.satisId);
                            // 前一步列表页
                            if ($scope.stepLast == 0) {
                                ipSatisSrvyList();
                            }
                            // 前一步Home、基础页
                            else {
                                $state.go('app.home');
                            }
                        }
                        else {
                            return;
                        }
                    })
                    break;
                }
        }
    }
});