﻿angular.module('fwapp.controllers')

    // 住院登记
    .controller('IPVisitingAppointmentController', function ($scope, $rootScope, $state, $stateParams, $timeout, $http, $q, $timeout, $fwCordovaToast
        , IpRegService, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPopup, $ionicPlatform, $ionicActionSheet, $cordovaDatePicker, $cordovaCamera, $cordovaFileTransfer) {
        // 检查登录状态
        $rootScope.checkLogin();

        // 初始滑块状态
        $scope.step = 0;

        // 校验信息
        $scope.Confirm = { confirm_name: "", confirm_sfz: "" };
        // 打哪儿来
        $scope.from = $stateParams.from;
        // 预约信息
        $scope.Visit = {};
        // 固定预约信息
        $scope.RegularVisit = {};
        // 临时预约信息
        $scope.TempVisit = {};
        // 可预约时段
        $scope.arg_schInfo = [];
        $scope.temp_List = [];
        $scope.yyid = "";
        $scope.yydate = ""; 
        $scope.temp_yyid = "";
        $scope.time_slot = "";//时段
        $scope.temp_time_slot = "";//时段
        $scope.patientOrg = "";//病区
        $scope.schedulingInfomation = "";
        $scope.schedulingInfo = "";
        $scope.HIS_IDB = ""; 
        $scope.YYInfo = {};

        // 是否开放探视
        $scope.schedulingStatus = true;
        $scope.temp_schedulingStatus = true;
        // 是否展示二维码
        $scope.codeStatus = true;
        $scope.temp_codeStatus = true;

        $scope.src = "";
        $scope.temp_src = "";
        // 取消预约
        $scope.cancelStatus = "";
        $scope.temp_cancelStatus = "";

        // 预约类型
        $scope.appointmentType = "regular_lable";

        // 定义住院登记滑块
        var slideIPVisitingAppointment = $ionicSlideBoxDelegate.$getByHandle('slideIPVisitingAppointment');

        // 滑到下一步
        $scope.nextSlide = function () {
            slideIPVisitingAppointment.next();
            $scope.step = slideIPVisitingAppointment.currentIndex();
        }

        // 后退 重写goBack
        $scope.goBack = function () {
            slideIPVisitingAppointment.previous();
            $scope.step = slideIPVisitingAppointment.currentIndex();
        }

        // 滑到指定页 wxh
        $scope.toSlide = function (index) {
            slideIPVisitingAppointment.slide(index);
            $scope.step = slideIPVisitingAppointment.currentIndex();
        }

        // 滑块切换
        $scope.slideChanged = function () {
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
        }
        
        // 身份校验
        $scope.confirmSfz = function () {
            IpRegService.confirmPatient($scope.Confirm.confirm_name, $scope.Confirm.confirm_sfz).then(function (data) {
                if (data.result == 0) {
                    //接口返回失败
                    $scope.alertInfo(data.msg);
                } else if (data.result == 2) {
                    //患者是否校验失败，提示校验信息
                    $scope.alertInfo(data.msg);
                } else if (data.result == 1) {
                    //患者身份信息校验通过
                    $scope.getYYInfo();
                }
            }, function (error) {
                $fwCordovaToast.showLongBottom('网络连接失败');
            })
        }

        //微信入口-身份校验后，走API拉取预约信息及排班
        $scope.getYYInfo = function () {
            //调用取消方法
            $scope.arg_schInfo = [];
            $scope.temp_List = [];
            IpRegService.confirmPatientYYInfo($scope.Confirm.confirm_name, $scope.Confirm.confirm_sfz).then(function (data) {
                if (data.result == 0) {
                    //接口返回失败
                    $scope.alertInfo(data.msg);
                } else if (data.result == 2) {
                    //患者是否校验失败，提示校验信息
                    $scope.alertInfo(data.msg);
                } else if (data.result == 1) {
                    //患者身份信息校验通过，展示固定和临时页面
                    $scope.patientOrg = data.patientOrg;
                    $scope.HIS_IDB = data.idb; 
                    //判断是否有临时预约信息
                    if (data.list_vInfo_temp.length > 0) {
                        $scope.temp_schedulingStatus = false;

                        //生成临时预约的列表
                        for (var j = 0; j < data.list_vInfo_temp.length; j++) {
                            $scope.temp_List.push(data.list_vInfo_temp[j]);
                        }
                    }
                    else {
                        $scope.temp_schedulingStatus = true;
                        $scope.temp_codeStatus = false;
                        $scope.appointmentType = 'regular_lable';
                    }

                    //判断是否有固定预约信息
                    if (data.list_vInfo_regular.length > 0) {
                        $scope.schedulingStatus = true;
                        $scope.codeStatus = true;
                        $scope.yyid = data.list_vInfo_regular[0].yyid;
                        $scope.Visit.vis_name = data.list_vInfo_regular[0].patient_name;
                        $scope.time_slot = data.list_vInfo_regular[0].yy_slot;
                        $scope.RegularVisit.vpInfo_patientname = data.list_vInfo_regular[0].patient_name;

                        if (data.list_vInfo_regular[0].patient_orgname != null) {
                            $scope.RegularVisit.vpInfo_orgname = data.list_vInfo_regular[0].patient_orgname;
                        }
                        if (data.list_vInfo_regular[0].org_location != null) {
                            $scope.RegularVisit.vpInfo_orglocation = data.list_vInfo_regular[0].org_location;
                        } else {
                            $scope.RegularVisit.vpInfo_orglocation = "";
                        }
                        $scope.RegularVisit.vpInfo_yysj = data.list_vInfo_regular[0].yy_date + " " + data.list_vInfo_regular[0].yy_slot;
                        $scope.RegularVisit.vpInfo_yyname = data.list_vInfo_regular[0].yy_xm;
                        $scope.RegularVisit.vpInfo_orgcode = data.list_vInfo_regular[0].patient_org;

                        if (data.list_vInfo_regular[0].yy_status == "未探视") {
                            //提交点击后设置提交按钮失效
                            $("#vp_info_page_cancel").attr("disabled", false);
                            $scope.cancelStatus = "取消预约";
                        } else if (data.list_vInfo_regular[0].yy_status == "探视中") {
                            $scope.cancelStatus = "探视中";
                            //提交点击后设置提交按钮失效
                            $("#vp_info_page_cancel").attr("disabled", true);
                        } else if (data.list_vInfo_regular[0].yy_status == "探视结束") {
                            $scope.cancelStatus = "探视结束";
                            //提交点击后设置提交按钮失效
                            $("#vp_info_page_cancel").attr("disabled", true);
                        }

                        // 如果当前扫码用户不是登记预约用户，不允许展示二维码
                        if (data.list_vInfo_regular[0].current_user == "1") {
                            $scope.src = "data:image/jpeg;base64," + data.list_vInfo_regular[0].QRcode;
                        } else {
                            $("#vp_info_qrc_img").hide();//二维码显示隐藏
                            $("#vp_info_page_cancel").hide();//取消预约按钮隐藏
                            $("#vp_info_page_tip").text("非本人预约，只为您展示预约信息。");//取消预约按钮隐藏

                        }
                    }
                    else {
                        $scope.codeStatus = false;
                        //如果没有固定预约信息，则展示排班信息
                        if (data.schedulingInfomation != "") {
                            //动态加载可预约时间段
                            $scope.schedulingInfomation = data.schedulingInfomation;
                            var temp_schInfo = $scope.schedulingInfomation.split('&&');
                            for (var i = 0; i < temp_schInfo.length; i++) {
                                arg_temp = temp_schInfo[i].split(',');

                                if (Number(arg_temp[1]) > 0) {
                                    var temp = { ID: "time_" + i, timeslot: arg_temp[0], status: "enable", selected: "" };
                                } else {
                                    var temp = { ID: "time_" + i, timeslot: arg_temp[0], status: "Unenable", selected: "" };
                                }
                                $scope.arg_schInfo.push(temp);
                            }
                        }
                        else {
                            $scope.schedulingStatus = false;
                            $scope.schedulingInfo = data.schedulingStatus;
                        }
                    }
                    if ($scope.appointmentType == 'temp_lable' && data.list_vInfo_temp.length > 0) {
                        if ($scope.temp_yyid != "") {
                            $scope.opQrcImage($scope.temp_yyid);
                            $scope.temp_codeStatus = true;
                        }
                        else {
                            $scope.toSlide(1);
                        }
                    }
                    else {
                        $scope.toSlide(1);
                    }
                    $("#regular_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                    $("#temp_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                    if ($scope.appointmentType == "regular_lable") {
                        $("#regular_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                    }
                    else {
                        $("#temp_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
                    }
                }
            }, function (error) {
                $fwCordovaToast.showLongBottom('网络连接失败');
            })
        }

        //选择预约时段--该时段已约满提示
        $scope.selectTimeUnable = function () {
            $scope.alertInfo("该时段已约满，请预约其他时段！");
        }


        //选择预约时段
        $scope.selectTime = function(param_time_slot) {
            for (var i = 0; i < $scope.arg_schInfo.length; i++) {
                var tempButton = $scope.arg_schInfo[i];
                if (tempButton.status == "enable") {
                    if (tempButton.timeslot == param_time_slot) {
                        $scope.arg_schInfo[i].selected = "true";
                        $("#" + tempButton.ID).attr("style", "background-color: rgb(121,6,63);color: white;font-size: 13px;text-shadow: none;width: 90px;padding: .5em .2em;");

                    } else {
                        $scope.arg_schInfo[i].selected = "";
                        $("#" + tempButton.ID).attr("style", "font-size: 13px;text-shadow: none;width: 90px;padding: .5em .2em;");

                    }
                }
            }
        }

        //2023年9月8日18:07:28  cfw  微信扫码提交预约信息  新提交方式，单独处理微信的固定和临时预约申请；
        $scope.saveAppointInfo_wx = function (cancel_type) {
            var org_timeSlot = "";//病区当日预约排班
            var type = "";
            var yyid = "";
            var yy_time = "";
            var time_slot = "";
            if (cancel_type == "regular") {
                org_timeSlot = $scope.schedulingInfomation;
                for (var i = 0; i < $scope.arg_schInfo.length; i++) {
                    var tempButton = $scope.arg_schInfo[i];
                    if (tempButton.status == "enable" && tempButton.selected == "true") {
                        $scope.time_slot = tempButton.timeslot;
                        time_slot = tempButton.timeslot;
                    }
                }
                yyid = $scope.yyid;
                type = "2";//业务分类
                if ($scope.Visit.vis_name == "") {
                    $scope.alertInfo("请输入探视人姓名！");
                    return;

                } else if ($scope.Visit.vis_tel == "") {
                    $scope.alertInfo("请输入探视人电话！");
                    return;

                } else if ($scope.Visit.vis_sfz == "") {
                    $scope.alertInfo("请输入探视人身份证号码！");
                    return;
                } else if ($scope.time_slot == "") {
                    $scope.alertInfo("请选择预约时间段！");
                    return;
                }
            }
            else if (cancel_type == "temp") {
                type = "3";//业务分类
                yyid = $scope.temp_yyid;
                yy_time = $scope.yydate;
                time_slot = $scope.temp_time_slot;
                if ($scope.Visit.vis_name == "") {
                    $scope.alertInfo("请输入探视人姓名！");
                    return;

                } else if ($scope.Visit.vis_tel == "") {
                    $scope.alertInfo("请输入探视人电话！");
                    return;

                } else if ($scope.Visit.vis_sfz == "") {
                    $scope.alertInfo("请输入探视人身份证号码！");
                    return;
                }
            }


            //提交
            IpRegService.saveAppointment(yyid, $scope.Confirm.confirm_name, $scope.patientOrg, org_timeSlot, $scope.Visit.vis_name, $scope.Visit.vis_tel, $scope.Visit.vis_sfz, yy_time, time_slot, type, $scope.HIS_IDB).then(function (data) {
                if (data.result == 1) {
                    $ionicPopup.alert({
                        title: "提示",
                        template: "预约成功！",
                        okText: "确定"
                    }).then(function (res) {
                        //刷新当前页面
                        $scope.getYYInfo();
                    });        
                } else if (data.result == 2) {
                    //当前时段已约满，请跟换其他时段！
                    $scope.alertInfo(data.msg);
                    //刷新当前页面
                    $scope.getYYInfo();
                } else if (data.result == 0) {
                    $scope.alertInfo(data.msg);
                }
            }, function (error) {
                $fwCordovaToast.showLongBottom('网络连接失败');
            })
        }

        //取消预约信息弹框确认
        $scope.cancelAppointInfo_confirm = function (cancel_type) {
            var type = "";
            var yyid = "";
            if (cancel_type == "regular") {
                type = "2";//业务分类
                yyid = $scope.yyid;
            } else if (cancel_type == "temp") {
                type = "3";//业务分类
                yyid = $scope.temp_yyid;
            }
            var confirmPopup = $ionicPopup.confirm({
                title: "取消预约",
                cancelText: '取消',
                okText: '确定'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    IpRegService.cancelAppointment(yyid, $scope.Confirm.confirm_name, $scope.patientOrg, $scope.Visit.vis_name, $scope.time_slot, type, $scope.HIS_IDB).then(function (data) {
                        if (data.result == 1) {
                            $scope.Visit.vis_name = "";
                            $scope.Visit.vis_tel = "";
                            $scope.Visit.vis_sfz = "";
                            $scope.time_slot = "";
                            $scope.HIS_IDB = "";
                            $scope.temp_yyid = "";
                            $ionicPopup.alert({
                                title: "提示",
                                template: "取消成功！",
                                okText: "确定"
                            }).then(function (res) {
                                //刷新当前页面
                                $scope.getYYInfo();
                            });   
                        } else if (data.result == 2) {
                            if (cancel_type == "regular" || cancel_type == "temp") {
                                //当前探视状态为探视中或者探视结束，不可取消
                                $scope.alertInfo(data.msg);
                                //刷新当前页面
                                $scope.getYYInfo();
                            } else {
                                //当前探视状态为探视中或者探视结束，不可取消
                                $scope.alertInfo(data.msg);
                                window.location.reload(true);//刷新当前页面，已有已有记录，自动跳转到预约码展示
                            }

                        } else if (data.result == 0) {
                            $scope.alertInfo(data.msg);
                        }
                    }, function (error) {
                        $fwCordovaToast.showLongBottom('网络连接失败');
                    })
                }
            })
        }

        //页面顶部标签 固定临时 切换
        $scope.type_switch = function (type) {
            console.log(type + "页面标签切换");
            $scope.Visit.vis_name = "";
            $scope.Visit.vis_tel = "";
            $scope.Visit.vis_sfz = "";
            $scope.time_slot = "";
            $("#regular_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
            $("#temp_lable").attr("style", "text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
            if (type == "regular_lable") {
                $scope.appointmentType = 'regular_lable';
                $("#regular_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
            } else {
                $scope.appointmentType = 'temp_lable';
                $("#temp_lable").attr("style", "background-color: rgb(121,6,63);color: white;text-shadow: none;border: 1px solid #79063f; height: 40px; width: 50%; display: flex; justify-content: center; align-items: center;");
            }
        }

        $scope.alertInfo = function (msg){
            $ionicPopup.alert({
                title: "提示",
                template: msg,
                okText: "确定"
            }).then(function (res) {
                console.log(msg);
            });
        } 

        $scope.showTempVisitPate = function (yyid) {
            $scope.temp_yyid = yyid;
            for (var i = 0; i < $scope.temp_List.length; i++) {
                var vpinfo = $scope.temp_List[i];
                if (vpinfo.yyid == yyid) {
                    //预约日期和预约时间全局变量赋值
                    $scope.yydate = vpinfo.yy_date;
                    $scope.temp_time_slot = vpinfo.yy_slot;
                    $scope.TempVisit.vpInfo_yysj = vpinfo.yy_date + "  " + vpinfo.yy_slot;
                    $scope.TempVisit.vpInfo_orgcode = vpinfo.patient_org;
                    $scope.Visit = {};
                    if (vpinfo.yy_status == "未登记") {
                        $scope.temp_codeStatus = false;
                        $scope.temp_schedulingStatus = false;
                    }
                    else {
                        $scope.temp_codeStatus = true;
                        $scope.temp_schedulingStatus = false;
                    }
                }
            }
            $scope.toSlide(2);
        }

        //临时预约列表 查看预约二维码按钮
        $scope.opQrcImage = function (yyid) {
            $scope.temp_yyid = yyid;
            for (var i = 0; i < $scope.temp_List.length; i++) {
                var vpinfo = $scope.temp_List[i];
                if (vpinfo.yyid == yyid) {
                    $scope.yydate = vpinfo.yy_date;
                    $scope.temp_time_slot = vpinfo.yy_slot;
                    $scope.TempVisit.vpInfo_patientname = vpinfo.patient_name;

                    if (vpinfo.patient_orgname != null) {
                        $scope.TempVisit.vpInfo_orgname = vpinfo.patient_orgname;
                    }
                    if (vpinfo.org_location != null) {
                        $scope.TempVisit.vpInfo_orglocation = vpinfo.org_location;
                    } else {
                        $scope.TempVisit.vpInfo_orglocation = "";
                    }
                    $scope.TempVisit.vpInfo_yysj = vpinfo.yy_date + " " + vpinfo.yy_slot;
                    $scope.TempVisit.vpInfo_yyname = vpinfo.yy_xm;
                    $scope.TempVisit.vpInfo_orgcode = vpinfo.patient_org;
                    if (vpinfo.yy_status == "未登记") {
                        $scope.temp_codeStatus = false;
                    }
                    else if (vpinfo.yy_status == "未探视") {
                        $scope.temp_codeStatus = true;
                        //提交点击后设置提交按钮失效
                        $("#temp_vp_info_page_cancel").attr("disabled", false);
                        $scope.temp_cancelStatus = "取消预约";
                    } else if (vpinfo.yy_status == "探视中") {
                        $scope.temp_codeStatus = true;
                        $scope.temp_cancelStatus = "探视中";
                        //提交点击后设置提交按钮失效
                        $("#temp_vp_info_page_cancel").attr("disabled", true);
                    } else if (vpinfo.yy_status == "探视结束") {
                        $scope.temp_codeStatus = true;
                        $scope.temp_cancelStatus = "探视结束";
                        //提交点击后设置提交按钮失效
                        $("#temp_vp_info_page_cancel").attr("disabled", true);
                    }

                    $scope.temp_src = "data:image/jpeg;base64," + vpinfo.QRcode;
                    $scope.Visit = {};
                    if (vpinfo.yy_status == "未登记") {
                        $scope.temp_codeStatus = false;
                        $scope.temp_schedulingStatus = false;
                    }
                    else {
                        $scope.temp_codeStatus = true;
                        $scope.temp_schedulingStatus = false;
                    }
                }
            }
            $scope.toSlide(2);
        }

        // 页面进入，绑定后退事件
        $scope.$on('$ionicView.enter', function () {
            $ionicPlatform.registerBackButtonAction(function (e) {
                $rootScope.goBack();
                e.preventDefault();
                return false;
            }, 135, 'ipVisitingAppointment');
            //if ($scope.from == "app.ipReg") {
            //    $scope.Confirm.confirm_name = $stateParams.patientName;
            //    $scope.Confirm.confirm_sfz = $stateParams.idcardCode;
            //    $scope.getYYInfo();
            //}
        });

        // 页面退出，解除后退绑定
        $scope.$on('$ionicView.beforeLeave', function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'ipVisitingAppointment') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        });

        // dom准备就绪
        ionic.DomUtil.ready(function () {
            // 禁用滑动
            slideIPVisitingAppointment.enableSlide(false);
        });
    })
