﻿angular.module('fwapp.controllers')

// 健康科普
.controller('KnowledgeController', function ($scope, $rootScope, $state, ArticleService, $fwCordovaToast, $cordovaInAppBrowser
    , $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, $ionicLoading) {

    // 定义预约申请滑块
    var slideKnowledge = $ionicSlideBoxDelegate.$getByHandle('slideKnowledge');
    // 定义预约申请滚动条
    var scrollKnowledge = $ionicScrollDelegate.$getByHandle('scrollKnowledge');
    // 初始滑块状态
    $scope.step = 0;
    // 目录
    $scope.columnList = [];
    // 当前栏目id
    $scope.columnId = 0;
    // 文章列表
    $scope.articleList = [];
    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
    // 文章内容
    $scope.articleDetail = new Object();
    // 当前页
    $scope.pageNum = 1;
    // 每页数量
    $scope.pageSize = 10;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕，防止无内容闪现
    $scope.isLoadFinish = false;
    // 页面标题列表
    $scope.titleList = ["健康科普", "", ""];
    // 滑到上一步
    $scope.lastSlide = function () {
        slideKnowledge.previous();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideKnowledge.next();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideKnowledge.slide(index);
    }
    // 滑块切换触发
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideKnowledge.currentIndex();
        // 回到栏目选择页#0 清空文章列表和内容
        if ($scope.step == 0) {
            $scope.pageNum = 1;
            $scope.articleList = [];
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.articleDetail = new Object();
            $scope.isLoadFinish = false;
        }
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        // 列表页滚到记录高度
        if ($scope.step == 1) {
            scrollKnowledge.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.articleDetail = new Object();
        }
        // 其他页滚到顶
        else {
            $ionicScrollDelegate.scrollTop();
        }
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择栏目）正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他页返回上一个滑块
        else {
            $scope.lastSlide();
        }
    }
    // 获取目录
    $scope.loadIndex = function () {
        $ionicLoading.show();
        ArticleService.index("knowledge").then(function (data) {
            if (data.result == 1) {
                $scope.columnList = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 获取列表
    $scope.loadList = function (index) {
        //$scope.isLoadFinish = false;
        // 从栏目列表来的
        if ('undefined' != typeof (index)) {
            $ionicLoading.show();
            // 当前栏目
            $scope.columnId = $scope.columnList[index].id;
            // 标题赋值
            $scope.titleList[1] = $scope.columnList[index].name;
            $scope.titleList[2] = $scope.columnList[index].name;
            // 跳转
            $scope.nextSlide();
        }
        ArticleService.list($scope.columnId, $scope.pageNum, $scope.pageSize).then(function (data) {
            if (data.result == 1) {
                // 新获取的列表追加到文章列表后
                for (var i = 0; i < data.data.page.length; i++) {
                    $scope.articleList.push(data.data.page[i]);
                }
                // 计算是否可继续加载
                $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                // 当前页数+1
                $scope.pageNum++;
                // 加载完毕
                $scope.isLoadFinish = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                //$ionicLoading.hide();
            }
            else {
                $scope.isLoadFinish = true;
                //$ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            }
            // 从栏目列表来的
            if ('undefined' != typeof (index)) {
                $ionicLoading.hide();
            }
        }, function (data) {
            $scope.isLoadFinish = true;
            //$ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            // 从栏目列表来的
            if ('undefined' != typeof (index)) {
                $ionicLoading.hide();
            }
        })
    }
    // 获取内容
    $scope.loadDetail = function (index) {
        // 2017-8-15 BST 处理外部链接
        if ($scope.articleList[index].ExternalLink != '') {
            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open($scope.articleList[index].ExternalLink, '_blank', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser($scope.articleList[index].ExternalLink, '_blank');
            return;
        }
        // 记录当前列表页滚动条位置
        $scope.scrollPosition = scrollKnowledge.getScrollPosition();
        $ionicLoading.show();
        // 跳转
        $scope.nextSlide();
        ArticleService.detail($scope.articleList[index].ArticleId).then(function (data) {
            if (data.result == 1) {
                $scope.articleDetail = data.data;
                // 重新计算滚动条高度
                $ionicScrollDelegate.resize();
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore && $scope.step == 1;
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideKnowledge.enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else{
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'knowledge');
        // 获取栏目列表
        $scope.loadIndex();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'knowledge') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
})