﻿angular.module('fwapp.controllers')

// 查体预约
.controller('MedicalAppointController', function ($scope, $rootScope, $state, MedicalAppointService, $fwCordovaToast, $cordovaInAppBrowser
    , $ionicPopup, $ionicSlideBoxDelegate, $cordovaDatePicker, $ionicScrollDelegate, $ionicPlatform, $ionicLoading) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义预约申请滑块
    var slideMed = $ionicSlideBoxDelegate.$getByHandle('slideMed');
    // 定义预约申请滚动条
    var scrollMed = $ionicScrollDelegate.$getByHandle('scrollMed');
    // 初始滑块状态
    $scope.step = 0;
    // 套餐类型
    $scope.type = "";
    $scope.typeid = "";

    $scope.successList = "";

    $scope.dateList = null;

    //定义保存数据的类
    $scope.data = new Object();
    $scope.data =
    {
        APPT_DRINKING_FREQ: 0,
        APPT_SMOKE_FREQ: 0
    }
    //
    $scope.isshow = false;
    //隐藏下一步
    $scope.nextshow = true;

    //隐藏返显框
    $scope.backshow = false;
    //是否全部填完，后台验证
    $scope.isAll = false;


    //定义复选框
    $scope.satis = {
        APPT_GXY: 0, APPT_GXZ: 0, APPT_NZF: 0, APPT_SZB: 0, APPT_GXB: 0,
        APPT_EXZL: 0, APPT_XJGS: 0, APPT_LXZL: 0, APPT_YCBS: 0, APPT_TNB: 0,
        APPT_GYS: 0, APPT_ZFG: 0, APPT_DNB: 0, APPT_SSWKS: 0, APPT_ZKJC: 0
    };
    $scope.levels = [{
        key: "无", value: 0
    }, {
        key: "有", value: 1
    }];
    $scope.marriage = {
        APPT_MARRIAGE: 2
    };
    $scope.marlevels = [{
        key: "已婚", value: 2
    }, {
        key: "未婚", value: 1 
    }];

    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };

    // 页面标题列表
    $scope.titleList = ["检体预约", "", ""];
    // 滑到上一步
    $scope.lastSlide = function () {
        slideMed.previous();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideMed.next();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideMed.slide(index);
    }
    // 滑块切换触发
    $scope.MyAppoint = function () {
        $state.go("app.medicalAppointForm");
    }

    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideMed.currentIndex();
        if ($scope.step == 0) {
            $scope.pageNum = 1;
            $scope.articleList = [];
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.articleDetail = new Object();
            $scope.isLoadFinish = false;
        }
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        // 列表页滚到记录高度
        if ($scope.step == 1) {
            scrollMed.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.articleDetail = new Object();
        }
        // 其他页滚到顶
        else {
            $ionicScrollDelegate.scrollTop();
        }
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择栏目）正常后退
        if ($scope.step == 0) {
            $state.go('app.home');
        }
        if ($scope.step == 3 && $scope.isshow == true) {
            $scope.isshow = false;
            $scope.backshow = false;
            $scope.lastSlide();
            $scope.nextshow = true;
        }
        if ($scope.step == 3) {
            $scope.nextshow = true;
            $scope.backshow = false;
            $scope.lastSlide();
        }
        if ($scope.step == 1) {
            $state.go('app.home');
        }
        // 其他页返回上一个滑块
        else {
            $scope.lastSlide();
        }
    }

    // 是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore && $scope.step == 1;
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideMed.enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'medicalAppoint');
        // 直接加载套餐列表
        $scope.accountId = localStorage.currentAccountId;
        if ($scope.accountId == null || $scope.accountId == "" || $scope.accountId == undefined) {
            $state.go('login');
        }
        else {
            $scope.loadDetail();
        }

    })
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'medicalAppoint') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
    //列表
    $scope.loadDetail = function () {
        $scope.step = 1;
        MedicalAppointService.Detail().then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom("无数据!");
            }
            else {
                var specialPopup = $ionicPopup.show({
                    title: '特别提醒',
                    template: '1. 切勿查体前贸然停药。</br>2. 套餐内容可能做部分调整，按照健康管理中心临时通知为准。',
                    buttons: [{
                        text: '确定',
                        type: 'button-positive',
                        onTap: function (e) {
                            specialPopup.close();
                        }
                    }]
                });
                slideMed.slide(1);
                $scope.titleName = "预约检体";
                $scope.feeDetailList = data.data;
                $ionicLoading.show();
                setTimeout(function () { $ionicScrollDelegate.resize(); });
                $ionicLoading.hide();

            }
        })
    }
    //详情
    $scope.selectDetail = function (Eid, EXAM_NAME, EXAM_BASEINFO_ID) {
        // 记录当前列表页滚动条位置
        $scope.step = 2;
        slideMed.slide(2);

        $scope.type = EXAM_NAME;
        $scope.typeid = EXAM_BASEINFO_ID;
        MedicalAppointService.SelectDetail(Eid).then(function (data) {
            if (data.result == 0) {
                $ionicPopup.alert({
                    template: '无数据'
                });
            }
            else {

                $scope.baseInfoDetail = data.data;
                $ionicLoading.show();
                // 跳转
                slideMed.slide(2);
                // 重新计算滚动条高度
                setTimeout(function () { $ionicScrollDelegate.resize(); });
                $ionicLoading.hide();
            }
        })
    }
    $scope.next = function () {
        $scope.step = 2;
        slideMed.slide(3);
        $ionicLoading.show();
        setTimeout(function () { $ionicScrollDelegate.resize(); });
        $ionicLoading.hide();
        $scope.GetWorkDays();

    }
    $scope.nextform = function () {
        $scope.step = 2;
        slideMed.slide(3);
        $ionicLoading.show();
        setTimeout(function () { $ionicScrollDelegate.resize(); });
        $ionicLoading.hide();
    }
    //点击提交后切到返显页面
    $scope.showform = function () {
        if ($scope.AllNull() == false) {
        }
        else {
            $scope.step = 3;
            slideMed.slide(4);
            $ionicLoading.show();
            setTimeout(function () { $ionicScrollDelegate.resize(); });
            $ionicLoading.hide();
        }
    }
    $scope.showmyorder = function (configKey, APPT_DATE) {
        MedicalAppointService.GetConfig(configKey, APPT_DATE).then(function (data) {
            $scope.successList = data.data;
        })
    }

    $scope.order = function () {
        $state.go('app.medicalAppointForm');

    }

    //继续填写表单
    $scope.nextForm = function () {
        if ($scope.isnull($scope.data.APPT_NAME) == false) {
            $fwCordovaToast.showShortBottom('姓名不得为空，请检查后再试');
            return;
        }
        if ($scope.checkCard($scope.data.APPT_IDCARD_CODE) == false) {
            $fwCordovaToast.showShortBottom('身份证号错误，请检查后再试');
            return;
        }
        if ($scope.isphone($scope.data.APPT_PHONENUM) == false) {
            $fwCordovaToast.showShortBottom('手机号错误，请检查后再试');
            return;
        }
        if ($scope.isnull($scope.data.APPT_DATE) == false) {
            $fwCordovaToast.showShortBottom('预约日期不得为空，请检查后再试');
            return;
        }
        else {
            $scope.HasAppoint();
        }
    }
    //复选框选择赋值
    $scope.selectThis = function (type, value) {

        $scope.satis[type] = value;
    }
    //婚姻复选框选择赋值
    $scope.selectmarThis = function (type, value) {

        $scope.marriage[type] = value;
    }
    //提交表单
    $scope.SubInfo = function () {
        $scope.data.APPT_GXY = $scope.satis.APPT_GXY;
        $scope.data.APPT_GXZ = $scope.satis.APPT_GXZ;
        $scope.data.APPT_NZF = $scope.satis.APPT_NZF;
        $scope.data.APPT_SZB = $scope.satis.APPT_SZB;
        $scope.data.APPT_GXB = $scope.satis.APPT_GXB;
        $scope.data.APPT_EXZL = $scope.satis.APPT_EXZL;
        $scope.data.APPT_XJGS = $scope.satis.APPT_XJGS;
        $scope.data.APPT_LXZL = $scope.satis.APPT_LXZL;
        $scope.data.APPT_YCBS = $scope.satis.APPT_YCBS;
        $scope.data.APPT_TNB = $scope.satis.APPT_TNB;
        $scope.data.APPT_GYS = $scope.satis.APPT_GYS;
        $scope.data.APPT_ZFG = $scope.satis.APPT_ZFG;
        $scope.data.APPT_DNB = $scope.satis.APPT_DNB;
        $scope.data.APPT_SSWKS = $scope.satis.APPT_SSWKS;
        $scope.data.APPT_ZKJC = $scope.satis.APPT_ZKJC;
        $scope.data.APPT_MARRIAGE = $scope.marriage.APPT_MARRIAGE;
        $scope.data.YY_EXAM_NAME = $scope.type;
        $scope.data.YY_EXAM_BASEINFO_ID = $scope.typeid;
        if ($scope.data.APPT_SMOKE_YEAR == 0) {
            $scope.data.APPT_SMOKE_FREQ = 0
        }
        if ($scope.data.APPT_DRINKING_YEAR == 0) {
            $scope.data.APPT_DRINKING_FREQ = 0
        }

        MedicalAppointService.SubInfo($scope.data, $scope.isAll).then(function (data) {
            // 预约成功
            if (data.result == 1) {
                var alertPopup = $ionicPopup.alert({
                    title: '提交成功',
                    template: '您已经预约成功'
                });
                $scope.showmyorder("ExaminationSuccessInfo", $scope.data.APPT_DATE);
                slideMed.slide(5);
                $scope.data.APPT_DRINKING_FREQ = 0;
                $scope.data.APPT_SMOKE_FREQ = 0;
            }
            // 提交失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '提交失败',
                    template: data.msg
                });
            }
        }, function (data) {
            var alertPopup = $ionicPopup.alert({
                title: '网络异常',
                template: data.msg
            });
        });
    };
    //身份证号验证
    var vcity = { 11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古",
        21: "辽宁", 22: "吉林", 23: "黑龙江", 31: "上海", 32: "江苏",
        33: "浙江", 34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南",
        42: "湖北", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆",
        51: "四川", 52: "贵州", 53: "云南", 54: "西藏", 61: "陕西", 62: "甘肃",
        63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门", 91: "国外"
    };
    $scope.checkCard = function (obj) {
        //校验长度，类型 
        if ($scope.isCardNo(obj) === false) {
            return false;
        }
        //检查省份 
        if ($scope.checkProvince(obj) === false) {
            return false;
        }
        //校验生日 
        if ($scope.checkBirthday(obj) === false) {
            return false;
        }
        //检验位的检测 
        if ($scope.checkParity(obj) === false) {
            return false;
        }
        return true;
    };
    //检查号码是否符合规范，包括长度，类型 
    $scope.isCardNo = function (obj) {
        //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X 
        var reg = /(^\d{15}$)|(^\d{17}(\d|X)$)/;
        if (reg.test(obj) === false) {
            return false;
        }
        return true;
    };
    //取身份证前两位,校验省份 
    $scope.checkProvince = function (obj) {
        var province = obj.substr(0, 2);
        if (vcity[province] == undefined) {
            return false;
        }
        return true;
    };
    //检查生日是否正确 
    $scope.checkBirthday = function (obj) {
        var len = obj.length;
        //身份证15位时，次序为省（3位）市（3位）年（2位）月（2位）日（2位）校验位（3位），皆为数字 
        if (len == '15') {
            var re_fifteen = /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/;
            var arr_data = obj.match(re_fifteen);
            var year = arr_data[2];
            var month = arr_data[3];
            var day = arr_data[4];
            var birthday = new Date('19' + year + '/' + month + '/' + day);
            return $scope.verifyBirthday('19' + year, month, day, birthday);
        }
        //身份证18位时，次序为省（3位）市（3位）年（4位）月（2位）日（2位）校验位（4位），校验位末尾可能为X 
        if (len == '18') {
            var re_eighteen = /^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/;
            var arr_data = obj.match(re_eighteen);
            var year = arr_data[2];
            var month = arr_data[3];
            var day = arr_data[4];
            var birthday = new Date(year + '/' + month + '/' + day);
            return $scope.verifyBirthday(year, month, day, birthday);
        }
        return false;
    };
    //校验日期 
    $scope.verifyBirthday = function (year, month, day, birthday) {
        var now = new Date();
        var now_year = now.getFullYear();
        //年月日是否合理 
        if (birthday.getFullYear() == year && (birthday.getMonth() + 1) == month && birthday.getDate() == day) {
            //判断年份的范围（3岁到100岁之间) 
            var time = now_year - year;
            if (time >= 0 && time <= 130) {
                return true;
            }
            return false;
        }
        return false;
    };
    //校验位的检测 
    $scope.checkParity = function (obj) {
        //15位转18位 
        obj = $scope.changeFivteenToEighteen(obj);
        var len = obj.length;
        if (len == '18') {
            var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
            var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
            var cardTemp = 0, i, valnum;
            for (i = 0; i < 17; i++) {
                cardTemp += obj.substr(i, 1) * arrInt[i];
            }
            valnum = arrCh[cardTemp % 11];
            if (valnum == obj.substr(17, 1)) {
                return true;
            }
            return false;
        }
        return false;
    };
    //15位转18位身份证号 
    $scope.changeFivteenToEighteen = function (obj) {
        if (obj.length == '15') {
            var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
            var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
            var cardTemp = 0, i;
            obj = obj.substr(0, 6) + '19' + obj.substr(6, obj.length - 6);
            for (i = 0; i < 17; i++) {
                cardTemp += obj.substr(i, 1) * arrInt[i];
            }
            obj += arrCh[cardTemp % 11];
            return obj;
        }
        return obj;
    };
    $scope.isphone = function (phone) {
        var regPhoneNum = /^1[3-9][0-9]{9}$/;
        if (!regPhoneNum.test(phone)) {
            return false;
        }
        else {
            return true;
        }
    }

    $scope.isnull = function (data) {
        if (data == "" || data == null || data == undefined) {

            return false;
        }
    }

    $scope.HasAppoint = function () {
        MedicalAppointService.HasAppoint($scope.data.APPT_IDCARD_CODE, $scope.data.APPT_NAME, $scope.data.APPT_DATE).then(function (data) {
            if (data.result == 0) {
                $ionicPopup.alert({
                    template: '您已有预约'
                });
                return false;
            }
            else {
                $scope.nextWrite();
                //                $scope.isshow = true;
                //                $scope.nextshow = false;
                //                $scope.backshow = true;
                //                $scope.isAll = true;

            }
        })
    }

    //可预约的天数
    $scope.GetWorkDays = function (data) {
        MedicalAppointService.GetWorkDays().then(function (data) {
            $scope.dateList = data.data;
            $scope.data.APPT_DATE = $scope.dateList[0].SCHED_DATE;
        })
    }
    $scope.AllNull = function () {
        if ($scope.data.APPT_NATION == "" || $scope.data.APPT_NATION == null) {
            $ionicPopup.alert({
                template: '民族不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_BLOOD_TYPE == "" || $scope.data.APPT_BLOOD_TYPE == null) {
            $ionicPopup.alert({
                template: '血型不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_HEIGHT == "" || $scope.data.APPT_HEIGHT == null) {
            $ionicPopup.alert({
                template: '身高不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_WEIGHT == "" || $scope.data.APPT_NATION == null) {
            $ionicPopup.alert({
                template: '体重不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_ADDRESS == "" || $scope.data.APPT_ADDRESS == null) {
            $ionicPopup.alert({
                template: '常住地址不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_RELATIVES_NAME == "" || $scope.data.APPT_RELATIVES_NAME == null) {
            $ionicPopup.alert({
                template: '亲属姓名不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_RELATIVES_PHONENUM == "" || $scope.data.APPT_RELATIVES_PHONENUM == null) {
            $ionicPopup.alert({
                template: '亲属手机号不能为空'
            });
            return false;
        }
        if ($scope.isphone($scope.data.APPT_PHONENUM) == false) {
            $ionicPopup.alert({
                template: '手机号错误'
            });
            return false;
        }
        if ($scope.isphone($scope.data.APPT_RELATIVES_PHONENUM) == false) {
            $ionicPopup.alert({
                template: '亲属手机号错误'
            });
            return false;
        }
        if ($scope.data.APPT_PRESSURE == "" || $scope.data.APPT_PRESSURE == null) {
            $ionicPopup.alert({
                template: '工作压力不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_SURGERY == "" || $scope.data.APPT_SURGERY == null) {
            $ionicPopup.alert({
                template: '手术不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_OTHER == "" || $scope.data.APPT_OTHER == null) {
            $ionicPopup.alert({
                template: '其他不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_DISEASE_DESC == "" || $scope.data.APPT_DISEASE_DESC == null) {
            $ionicPopup.alert({
                template: '疾病描述不能为空'
            });
            return false;
        }
        if ($scope.data.APPT_NOW_DESC == "" || $scope.data.APPT_NOW_DESC == null) {
            $ionicPopup.alert({
                template: '主要不适不能为空'
            });
            return false;
        }
        // APPT_SMOKE_YEAR

        //        console.log($scope.data.APPT_SMOKE_YEAR);

        if ($scope.data.APPT_SMOKE_YEAR == 0) { }
        else if ($scope.data.APPT_SMOKE_YEAR == "" || $scope.data.APPT_SMOKE_YEAR == null) {
            console.log($scope.data.APPT_SMOKE_YEAR);
            $ionicPopup.alert({
                template: '烟龄不能为空'
            });
            return false;
        }
        else {
            if ($scope.data.APPT_SMOKE_FREQ == 0 || $scope.data.APPT_SMOKE_FREQ == "" || $scope.data.APPT_SMOKE_FREQ == null) {
                $ionicPopup.alert({
                    template: '吸烟频次不能为空'
                });
                return false;
            }
        }
        if ($scope.data.APPT_DRINKING_YEAR == 0) { }
        else if ($scope.data.APPT_DRINKING_YEAR == "" || $scope.data.APPT_DRINKING_YEAR == null) {
            $ionicPopup.alert({
                template: '酒龄不能为空'
            });
            return false;
        }
        else {
            if ($scope.data.APPT_DRINKING_FREQ == 0 || $scope.data.APPT_DRINKING_FREQ == "" || $scope.data.APPT_DRINKING_FREQ == null) {
                $ionicPopup.alert({
                    template: '饮酒频次不能为空'
                });
                return false;
            }
        }

        if ($scope.data.APPT_EATING_HABIT == "" || $scope.data.APPT_EATING_HABIT == null) {
            $ionicPopup.alert({
                template: '饮食习惯不能为空'
            });
            return false;
        }
    }
    $scope.nextWrite = function () {
        $ionicPopup.confirm({
            template: "为了让医生更加了解您的健康情况，建议您完善自身信息，是否完善信息？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                //$scope.HasAppoint();
                $scope.isshow = true;
                $scope.nextshow = false;
                $scope.backshow = true;
                $scope.isAll = true;

            }
            else {
                //$scope.HasAppoint();
                $scope.isAll = false;
                slideMed.slide(4);
            }

        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
    }
})
