﻿angular.module('fwapp.controllers')

// 就医指南
.controller('MedicalGuideController', function ($scope, $rootScope, $state, ArticleService, $fwCordovaToast, $cordovaInAppBrowser
    , $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, $ionicLoading) {

    // 定义预约申请滑块
    var slideMedicalGuide = $ionicSlideBoxDelegate.$getByHandle('slideMedicalGuide');
    // 定义预约申请滚动条
    var scrollMedicalGuide = $ionicScrollDelegate.$getByHandle('scrollMedicalGuide');
    // 初始滑块状态
    $scope.step = 0;
    // 目录
    $scope.columnList = [];
    // 当前栏目id
    $scope.columnId = 0;
    // 文章列表
    $scope.articleList = [];
    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
    // 文章内容
    $scope.articleDetail = new Object();
    // 当前页
    $scope.pageNum = 1;
    // 每页数量
    $scope.pageSize = 20;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕，防止无内容闪现
    $scope.isLoadFinish = false;
    // 页面标题列表
    $scope.titleList = ["就医指南", "", "", ""];
    // 二级栏目页
    $scope.secondColumnList = [];
    // 滑到上一步
    $scope.lastSlide = function () {
        slideMedicalGuide.previous();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideMedicalGuide.next();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideMedicalGuide.slide(index);
    }
    // 滑块切换触发
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideMedicalGuide.currentIndex();
        // 回到栏目选择页#0 清空文章列表和内容
        if ($scope.step == 0) {
            $scope.pageNum = 1;
            $scope.articleList = [];
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.articleDetail = new Object();
            $scope.isLoadFinish = false;
        }
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        // 列表页滚到记录高度
        if ($scope.step == 1) {
            scrollMedicalGuide.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.articleDetail = new Object();
        }
        // 其他页滚到顶
        else {
            $ionicScrollDelegate.scrollTop();
        }
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择栏目）正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $state.go("app.home");
        }
        else if ($scope.step == 3) {
            $scope.toSlide(2);
        }
        // 其他页返回第一个滑块
        else {
            $scope.toSlide(0);
        }
    }
    // 获取目录
    $scope.loadIndex = function () {
        $ionicLoading.show();
        ArticleService.index("medicalGuideV2").then(function (data) {
            if (data.result == 1) {
                $scope.columnList = data.data;
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 获取列表
    $scope.loadList = function (index) {
        //$scope.isLoadFinish = false;
        // 从栏目列表来的
        if ('undefined' != typeof (index)) {
            if ($scope.columnList[index].type == "site" || $scope.columnList[index].type == "parentColumn") {
                // 获取栏目列表
                ArticleService.getColumnList($scope.columnList[index].id, $scope.columnList[index].type).then(function (data) {
                    $scope.isLoadFinish = true;
                    if (data.result == 1) {
                        $scope.secondColumnList = data.data;
                        $scope.titleList[1] = $scope.columnList[index].name;
                        // 跳转
                        $scope.toSlide(1);
                    }
                    else {
                        $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                    }
                }, function (data) {
                    $scope.isLoadFinish = true;
                    $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                })
            }
            else {
                // 当前栏目
                $scope.columnId = $scope.columnList[index].id;
                // 标题赋值
                $scope.titleList[2] = $scope.columnList[index].name;
                $scope.titleList[3] = $scope.columnList[index].name;
                // 跳转
                $scope.toSlide(2);
            }
        }

        $scope.loadArticleList();
    }
    // 从二级栏目获取列表
    $scope.loadColumnList = function (index) {
        // 当前栏目
        $scope.columnId = $scope.secondColumnList[index].ColumnId;
        // 标题赋值
        $scope.titleList[2] = $scope.secondColumnList[index].Name;
        $scope.titleList[3] = $scope.secondColumnList[index].Name;
        console.log($scope.secondColumnList[index]);
        $scope.pageNum = 1;
        $scope.articleList = [];
        // 跳转
        $scope.toSlide(2);
        $scope.loadArticleList();
    }
    // 获取文章列表
    $scope.loadArticleList = function () {
        $ionicLoading.show();
        ArticleService.list($scope.columnId, $scope.pageNum, $scope.pageSize).then(function (data) {
            if (data.result == 1) {
                // 新获取的列表追加到文章列表后
                for (var i = 0; i < data.data.page.length; i++) {
                    $scope.articleList.push(data.data.page[i]);
                }
                // 计算是否可继续加载
                $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                // 当前页数+1
                $scope.pageNum++;
                // 加载完毕
                $scope.isLoadFinish = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
            }
            else {
                $scope.isLoadFinish = true;
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            }
            $ionicLoading.hide();
        }, function (data) {
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            $ionicLoading.hide();
        })
    }
    // 获取内容
    $scope.loadDetail = function (index) {
        // 2017-8-15 BST 处理外部链接
        if ($scope.articleList[index].ExternalLink != '') {
            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open($scope.articleList[index].ExternalLink, '_system', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser($scope.articleList[index].ExternalLink, '_system');
            return;
        }
        // 记录当前列表页滚动条位置
        $scope.scrollPosition = scrollMedicalGuide.getScrollPosition();
        $ionicLoading.show();
        // 跳转
        $scope.nextSlide();
        ArticleService.detail($scope.articleList[index].ArticleId).then(function (data) {
            if (data.result == 1) {
                $scope.articleDetail = data.data;
                // 重新计算滚动条高度
                $ionicScrollDelegate.resize();
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore && $scope.step == 2;
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideMedicalGuide.enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'medicalGuide');
        // 获取栏目列表
        $scope.loadIndex();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'medicalGuide') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
})