﻿angular.module('fwapp.controllers')

.controller('MedicationPlanController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $cordovaDatePicker,
    AccountService, VisitPatientService, RequestService, MedicationPlanService, $fwCordovaToast, $ionicSlideBoxDelegate, $ionicPlatform, $ionicHistory) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 我们也不知道为啥要写这句，但是不能删除
    if (window.cordova && window.cordova.plugins) {
        cordova.plugins.notification.local.schedule([]);
    }

    // 定义检验查询滑块
    var slideMedicationPlan = $ionicSlideBoxDelegate.$getByHandle('slideMedicationPlan');
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideMedicationPlan.enableSlide(false);
    });

    // 初始滑块状态
    $scope.step = 0;

    // 就诊人ID
    $scope.vpId = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "" : $stateParams.vpid;
    // 打哪儿来
    $scope.from = ($stateParams.from == null || $stateParams.from.length == 0) ? "" : $stateParams.from;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人列表
    $scope.vpList = [];

    // 是否加载完成
    $scope.isLoadFinish = false;

    // 用药计划列表
    $scope.mpList = [];
    // 时间点序列
    $scope.timePointIndex = 0;
    // 用药计划数据
    $scope.mpInfo = new Object();
    // 用药计划数据 用于返回时判断是否更改
    $scope.mpInfoOri = new Object();
    // 新建用药时间点
    $scope.timePointNew = new Object();
    // 用药时间表
    $scope.timePointList = [];
    // 用药时间表 序列化字符串 用于返回时判断是否更改
    $scope.timePointListOriParam = "";
    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 注册模态窗口：添加用药时间点
    $ionicModal.fromTemplateUrl('addTimePoint.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addTimePointModal = modal;
    });
    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addTimePointModal.remove();
    })

    // 添加用药时间点模态窗口显示
    $scope.addTimePointShow = function () {
        $scope.timePointNew = new Object();
        $scope.timePointNew.time = new Date().toTimeString().substr(0, 5);
        $scope.addTimePointModal.show();
    }
    // 添加用药时间点模态窗口隐藏
    $scope.addTimePointHide = function () {
        $scope.addTimePointModal.hide();
        $scope.timePointNew = new Object();
    }
    // 添加用药时间点
    $scope.addTimePoint = function () {
        // 判断时间点是否与已有重复
        for (var i in $scope.timePointList) {
            if ($scope.timePointList[i].status == 1 && $scope.timePointList[i].time == $scope.timePointNew.time) {
                $fwCordovaToast.showShortBottom("用药时间重复,请输入其他时间");
                return;
            }
        }
        // 排空
        if ($scope.timePointNew.dosage == null || $scope.timePointNew.dosage.length == 0) {
            $fwCordovaToast.showShortBottom("剂量不能为空");
            return;
        }
        // 超出9条返回
        if ($scope.countTimePoint() >= 9) {
            $fwCordovaToast.showShortBottom("超过时间点数量上限");
            return;
        }
        // 添加时间点
        $scope.timePointList.push(new Object({ time: $scope.timePointNew.time, dosage: $scope.timePointNew.dosage, status: 1 }));
        // 按用药时间点排序
        $scope.timePointList.sort(function (a, b) {
            var indexa = a.time.indexOf(":");
            var timea = parseInt(a.time.substr(0, indexa) + a.time.substr(indexa + 1));
            var indexb = b.time.indexOf(":");
            var timeb = parseInt(b.time.substr(0, indexb) + b.time.substr(indexb + 1));
            return timea - timeb;
        });
        for (var i in $scope.timePointList) {
            console.log($scope.timePointList[i].time + ',' + $scope.timePointList[i].dosage + ',' + $scope.timePointList[i].status);
        }
        $scope.addTimePointHide();
    }
    // 删除用药时间点
    $scope.deleteTimePoint = function (index) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除用药时间点',
            template: "您确定要删除用药时间点吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                //$scope.timePointList.splice(index, 1);
                $scope.timePointList[index].status = 0;
                console.log($scope.timePointList);
            }
        })
    }
    // 计算用药时间点数量
    $scope.countTimePoint = function () {
        var count = 0;
        for (var i = 0; i < $scope.timePointList.length; i++) {
            if ($scope.timePointList[i].status == 1) {
                count++;
            }
        }
        return count;
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideMedicationPlan.slide(index);
        $scope.step = slideMedicationPlan.currentIndex();
        if ($scope.step == 0) {
            $scope.mpInfo = new Object();
            $scope.mpInfoOri = new Object();
        }
        console.log("页码");
        console.log($scope.step);
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页 用药计划列表 正常后退
        if ($scope.step == 0) {
            //$rootScope.goBack();
            if ($stateParams.vpid == "") {
                //$scope.toggleSlideMenu();
                $rootScope.goBack();
            }
            else {
                //$scope.toggleSlideMenu();
                if ($scope.from.length > 0) {
                    $state.go($scope.from, { vpid: $scope.vpId, from: "app.medicationPlan" });
                }
                else {
                    $state.go('app.visitPatient', { vpid: $scope.vpId });
                }
            }
        }
        // 其他页返回第一个滑块
        else {
            // 检查是否更改
            $scope.checkChange();
            /*slideMedicationPlan.slide(0);
            $scope.step = slideMedicationPlan.currentIndex();
            console.log("页码");
            console.log($scope.step);
            $scope.mpInfo = new Object();
            $scope.mpInfoOri = new Object();*/
        }
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    //#region 列表加载

    // 读取用药计划列表
    $scope.loadMpList = function (needResetNoti) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.mpList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        MedicationPlanService.list($scope.vpId).then(function (data) {
            console.log(data);
            // 请求错误
            if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                $scope.mpList = data.data;
                if (needResetNoti) {
                    // 重设用药提醒
                    $scope.setNotification();
                }
            }
            loadFinish()
        });
    }

    // 读取用药计划详情
    $scope.loadMpInfo = function (mpId) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.mpInfo = new Object();
        $scope.mpInfoOri = new Object();
        $scope.toSlide(1);

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        // 新建
        if (mpId == null || mpId.length == 0) {
            console.log($scope.timePointList);
            $scope.mpInfo.VISIT_PATIENT_ID = $scope.vpId;
            $scope.mpInfo.CYCLE = "每日";
            $scope.mpInfo.DATE_START = new Date().Format('yyyy-MM-dd');
            $scope.mpInfo.IS_ALARM = 1;
            $.extend($scope.mpInfoOri, $scope.mpInfo);
            loadFinish();
        }
        // 编辑
        else {
            MedicationPlanService.detail(mpId).then(function (data) {
                console.log(data.result);
                // 请求错误
                if (data.result == 0) {
                    loadFinish();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                // 请求成功
                if (data.result == 1) {
                    $scope.mpInfo = data.data;
                    $.extend($scope.mpInfoOri, $scope.mpInfo);
                    // 时间点列表赋值
                    for (var i = 1; i < 10; i++) {
                        if (data.data["TIME" + i].length > 0) {
                            $scope.timePointList.push(new Object({ time: data.data["TIME" + i], dosage: data.data["DOSAGE" + i], status: 1 }));
                        }
                    }
                    for (var i in $scope.timePointList) {
                        console.log($scope.timePointList[i].time + ',' + $scope.timePointList[i].dosage + ',' + $scope.timePointList[i].status);
                    }
                    // 时间点列表源数据序列化
                    $scope.timePointListOriParam = "";
                    for (var i in $scope.timePointList) {
                        $scope.timePointListOriParam += $scope.timePointList[i].time + ',' + $scope.timePointList[i].dosage + ',' + $scope.timePointList[i].status + ';';
                    }
                    console.log($scope.timePointListOriParam);
                    $ionicScrollDelegate.scrollTop();
                    $ionicScrollDelegate.resize();
                }
                loadFinish();
            });
        }
    }

    function loadFinish() {
        $ionicLoading.hide();
        $scope.isLoadFinish = true;
    }

    //#endregion
    // 新建/编辑用药计划
    $scope.editMedicationPlan = function () {
        console.log($.param($scope.mpInfo));
        var timePointEmpty = true;
        for (var i in $scope.timePointList) {
            if ($scope.timePointList[i].status == 1) {
                timePointEmpty = false;
                break;
            }
        }
        // 查空
        if ($scope.mpInfo.NAME == null || $scope.mpInfo.NAME.length == 0
        || $scope.mpInfo.UNIT == null || $scope.mpInfo.UNIT.length == 0
        || $scope.mpInfo.CYCLE == null || $scope.mpInfo.CYCLE.length == 0
        || $scope.mpInfo.DATE_START == null || $scope.mpInfo.DATE_START.length == 0
        || timePointEmpty) {
            $fwCordovaToast.showShortBottom("必填项不得为空");
            return;
        }
        // 处理用药时间表
        // 复制一份 避免保存失败数据损坏
        var timePointListBak = [];
        $.extend(timePointListBak, $scope.timePointList);
        console.log(timePointListBak);
        // 剔除已删除元素
        for (var i in timePointListBak) {
            if (timePointListBak[i].status == 0) {
                timePointListBak.splice(i, 1);
            }
        }
        // 清空时间点
        for (var i = 1; i < 10; i++) {
            $scope.mpInfo["TIME" + i] = "";
            $scope.mpInfo["DOSAGE" + i] = "";
        }
        // 时间点重新赋值
        for (var i in timePointListBak) {
            $scope.mpInfo["TIME" + (Number(i) + 1)] = timePointListBak[i].time;
            $scope.mpInfo["DOSAGE" + (Number(i) + 1)] = timePointListBak[i].dosage;
        }
        // 处理开始用药日期
        if ($scope.mpInfo.CYCLE == '每日') {
            $scope.mpInfo.DATE_START = new Date().Format('yyyy-MM-dd');
        }
        console.log($scope.mpInfo);
        // 保存
        //MedicationPlanService.editPlan($.param($scope.mpInfo)).then(function (data) {
        MedicationPlanService.editPlan($scope.mpInfo).then(function (data) {
            console.log(data);
            // 请求错误
            if (data.result == "0") {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == "1") {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.loadMpList(true);
                $scope.toSlide(0);
                $scope.mpInfo = new Object();
                $scope.mpInfoOri = new Object();
            }
            loadFinish();
        });
    }

    // 检查是否更改
    $scope.checkChange = function () {
        var paramNow = "";
        for (var i in $scope.timePointList) {
            paramNow += $scope.timePointList[i].time + ',' + $scope.timePointList[i].dosage + ',' + $scope.timePointList[i].status + ';';
        }
        // true=改了 false=没改
        var isChange = false;
        if ($scope.timePointListOriParam != paramNow) {
            isChange = true;
            console.log($scope.timePointListOriParam);
            console.log(paramNow);
        }
        if (isChange || ($.param($scope.mpInfoOri) != $.param($scope.mpInfo))) {
            // 提示保存
            var confirmPopup = $ionicPopup.confirm({
                title: '保存用药计划',
                template: "用药计划已更改,是否保存？",
                cancelText: '放弃更改',
                okText: '保存'
            }).then(function (res) {
                if (res) {
                    $scope.editMedicationPlan();
                }
                else {
                    $scope.toSlide(0);
                }
            })
        }
        else {
            $scope.toSlide(0);
        }
    }

    // 删除用药计划
    $scope.deleteMedicationPlan = function (mpId) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除用药计划',
            template: "您确定要删除用药计划吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                console.log('删除' + mpId);
                MedicationPlanService.deletePlan(mpId).then(function (data) {
                    console.log(data);
                    // 请求错误
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                        return;
                    }
                    // 请求成功
                    if (data.result == 1) {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $scope.loadMpList(true);
                    }
                });
            }
        })
    }

    // 切换提醒开关
    $scope.changeAlarm = function (mpId) {
        var needUpd = false;
        var isAlarm = 0;
        var index = 0;
        // 查找ID对应的用药计划 切换提醒状态
        for (var i in $scope.mpList) {
            if ($scope.mpList[i].MEDICATION_PLAN_ID == mpId) {
                needUpd = true;
                isAlarm = $scope.mpList[i].IS_ALARM == 1 ? 0 : 1;
                index = i;
                break;
            }
        }
        // 更新用药计划
        if (needUpd) {
            MedicationPlanService.changeAlarm(mpId, isAlarm).then(function (data) {
                console.log(data);
                // 请求错误
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                // 请求成功
                if (data.result == 1) {
                    //$fwCordovaToast.showShortBottom(data.msg);
                    // 更新用药计划列表
                    $scope.mpList[index].IS_ALARM = isAlarm;
                    // 重设用药提醒
                    $scope.setNotification();
                }
            });
        }
    }

    if (window.cordova && window.cordova.plugins) {
        // 本地提醒事件
        cordova.plugins.notification.local.on("schedule", function (notification) {
            console.log("本地提醒创建成功,id:" + notification.id);
        });
    }

    // 重设用药提醒
    $scope.setNotification = function () {
        console.log("这里重设闹钟");
        MedicationPlanService.notificationList().then(function (data) {
            console.log('有' + data.data.TIMELINE.length + '条用药计划');
            // 请求成功
            if (data.result == 1) {
                // TODO:调用插件生成本地提醒
                for (var i in data.data.TIMELINE) {
                    // 时间字符串转为时间
                    data.data.TIMELINE[i].at = new Date(data.data.TIMELINE[i].at);
                    // Android平台增加属性
                    if ($rootScope.currentPlatform == "Android") {
                        data.data.TIMELINE[i].title = "掌上阜外医院 " + data.data.TIMELINE[i].title;
                        data.data.TIMELINE[i].led = "79063F";
                    }
                }
                if (window.cordova && window.cordova.plugins) {
                    // 清空原有本地提醒
                    cordova.plugins.notification.local.cancelAll(function () {
                        console.log("清空本地提醒成功");
                        // 重新设置本地提醒
                        cordova.plugins.notification.local.schedule(data.data.TIMELINE);
                    }, this);
                }
            }
        });
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid;
        $scope.vpInfo = new Object();
        $scope.loadVPInfo();
        $scope.loadMpList(false);
        $scope.popVplist.hide();
    }

    // 滑块切换触发
    $scope.slideChanged = function () {
        // 返回清空数据
        //$scope.isLoadFinish = false;
        $scope.mpInfo = new Object();
        $scope.timePointList = [];

        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'medicationPlan');
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }

                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                } else {
                    console.log($scope.vpId);
                    $scope.loadVPInfo();

                    $scope.loadMpList(false);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'medicationPlan') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });

    //#region cordova日期选择
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
    //#endregion
});
