﻿angular.module('fwapp.controllers')

// 菜单模板页
.controller('MenuController', function ($scope, $rootScope, $state, $q, $timeout, AccountService, PersonalService, OpApptService, HospitalService, PaymentService, OpPaymentService, VisitPatientService, OpRegService
, $ionicSideMenuDelegate, $ionicModal, $ionicPlatform, $ionicPopup, $ionicLoading, $fwCordovaToast) {
    // 模拟键盘委托
    var simKeyDefferd;
    // 就诊人关系翻译
    $scope.vpRelation = vpRelation;
    // 收银台委托
    var cashierDefferd;
    // 支付返回
    $scope.payResult = new Object();
    $scope.payResult.code = 1;
    $scope.payResult.data = "";
    $scope.payResult.paymentMethod = "";
    // 第几页
    $rootScope.cashierShowIndex = 0;
    // 门诊缴费委托
    var opPayment4001Defferd;
    var opPayment4005Defferd;

    //定义失败次数
    $scope.errorNumber = 0;

    // 菜单显示隐藏
    $scope.toggleSlideMenu = function () {
        $ionicSideMenuDelegate.toggleLeft();
    }

    // 注销
    $scope.logout = function () {
        var logoutPopup = $ionicPopup.confirm({
            template: '<p style="text-align:center;">确认退出登录当前账号？</p>',
            cancelText: '取消',
            okText: '确认'
        });

        logoutPopup.then(function (res) {
            if (res) {
                AccountService.logout().then(function (data) {
                    // 注销成功
                    if (data.result == 1) {
                        // 删除用户信息
                        localStorage.hasLogin = 0;
                        $rootScope.hasLogin = 0;
                        localStorage.currentAccountId = "";
                        localStorage.queryToken = "";
                        $rootScope.currentAccountId = "";
                        // 初始化一下消息中心提示
                        // 是否有未读消息
                        $rootScope.hasUnread = false;
                        $rootScope.unReadCount = 0;
                        // 跳转到登录页
                        $state.go('login');
                    }
                });
            }
        })
    };

    // 注册模态窗口：查询密码
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('simKeyboard.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.simKeybordModal = modal;
    });

    // 注册模态窗口：收银台
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('cashier.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.cashierModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.simKeybordModal.remove();
        $scope.cashierModal.remove();
    })

    // 检查消息中心
    $scope.checkMessage = function () {
        // 消息提示
        if (typeof (localStorage["lastMsgId_" + localStorage.currentAccountId]) == "undefined"
            || localStorage["lastMsgId_" + localStorage.currentAccountId] == "undefined") {
            localStorage["lastMsgId_" + localStorage.currentAccountId] = 0;
        }
        PersonalService.lastMsg(localStorage["lastMsgId_" + localStorage.currentAccountId]).then(function (data) {
            if (data.result == 0 && data.lastMsgDate != undefined) {
                localStorage["lastMsgId_" + localStorage.currentAccountId] = data.lastMsgDate;
            }
            else if (data.result == 1) {
                if (typeof (localStorage["lastMsgId_" + localStorage.currentAccountId]) == "undefined"
                    || localStorage["lastMsgId_" + localStorage.currentAccountId] < data.lastMsgDate) {
                    $rootScope.hasUnread = true;
                    $rootScope.unReadCount = data.count;
                    // 2016-09-27 18:57:20 下版本再发
                    //if ($rootScope.unReadCount > 0 && $rootScope.version != $rootScope.laseVersion) {
                    //    var confirmPopup2 = $ionicPopup.confirm({
                    //        title: '新的未读消息',
                    //        template: '您有' + $rootScope.unReadCount + '条新消息, 请进入消息中心查看',
                    //        cancelText: '取消',
                    //        okText: '进入'
                    //    });
                    //    confirmPopup2.then(function (res) {
                    //        if (res) {
                    //            $state.go("app.message");
                    //        }
                    //    });
                    //}
                }
            }
        })
    }

    // 检查用户登录状态
    $rootScope.checkLogin = function () {
        if (localStorage.currentAccountId == null || localStorage.currentAccountId.length == 0) {
            localStorage.currentAccountId = "";
            // 2022.11.29 16:44 朱世博 个人中心、使用帮助不跳登陆页
            // 有时间再去看看能不能建个路由拦截器，这部分连同判断登录状态都应该写在路由拦截器
            if ($rootScope.route != "/app/personal" && $rootScope.route != "/app/instruction") {
                $state.go("login");
            }
            return false;
        }
        if (window.cordova && window.cordova.plugins && currentPlatform == "Android" && deviceToken == "") {
            // 获取推送ID
            window.plugins.jPushPlugin.getRegistrationID(function (regId) {
                deviceToken = regId;
            })
        }
        AccountService.checkLogin().then(function (data) {
            console.log(JSON.stringify(data));
            if (data.result == 0) {
                // 删除用户信息
                localStorage.hasLogin = 0;
                $rootScope.hasLogin = 0;
                localStorage.currentAccountId = "";
                localStorage.queryToken = "";
                $rootScope.currentAccountId = "";
                // 初始化一下消息中心提示
                // 是否有未读消息
                $rootScope.hasUnread = false;
                $rootScope.unReadCount = 0;
                // 跳转到登录页
                // 2022.11.29 16:44 朱世博 个人中心、使用帮助不跳登陆页
                // 有时间再去看看能不能建个路由拦截器，这部分连同判断登录状态都应该写在路由拦截器
                if ($rootScope.route != "/app/personal" && $rootScope.route != "/app/instruction") {
                    $state.go("login");
                }
                return false;
            }
        })

        return true;
    }

    // #region 查询密码
    // 显示模拟键盘
    $scope.queryPassword = function (descr) {
        simKeyDefferd = $q.defer();
        console.log(localStorage.queryToken);
        // 若有查询密码TOKEN信息
        if (localStorage.queryToken != undefined && localStorage.queryToken != '') {
            $ionicLoading.show();
            AccountService.checkQueryToken(localStorage.queryToken).then(function (data) {
                if (data.result == "1") {
                    $ionicLoading.hide();
                    simKeyDefferd.resolve(true);
                }
                else {
                    simKeyShow(descr)
                }
            }, function (data) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            });
        } else {
            simKeyShow(descr)
        }
        return simKeyDefferd.promise;
    }

    function simKeyShow(descr) {
        // 2019-1-11 10:16:40 增加查询密码使用提示
        if (descr) {
            $scope.simKeyDescr = descr;
        }
        // 获取用户信息
        $ionicLoading.show();
        AccountService.accountInfo().then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                if (!data.data.QUERY_PASSWORD) {
                    $scope.simKeyUsage = 0
                    $scope.simKeyInfo = "首次使用，请设置查询密码";
                } else {
                    $scope.simKeyUsage = 2
                    $scope.simKeyInfo = "请输入查询密码";
                }
                $scope.simShowIndex = 0;
                $scope.simKeyValue = [];
                // 注册返回键事件
                $ionicPlatform.registerBackButtonAction(function (e) {
                    $scope.simKeyClose();
                    e.preventDefault();
                    return false;
                }, 525, 'simKey');
                $scope.simKeybordModal.show();
            } else {
                simKeyDefferd.resolve(false);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 忘记密码 WXH 2019-11-12
    $scope.resetPwd = function () {
        $scope.simKeyClose();
        $state.go("app.queryPassword", { type: 'changePwd', phoneNumber: '' });
    }

    // 模拟键盘输入完成事件
    $scope.simKeyFinish = function () {
        //console.log($scope.simKeyValue);
        switch ($scope.simKeyUsage) {
            case 0:     // 设置查询密码1
                $scope.simKeyValue1 = $scope.simKeyValue;
                $scope.simKeyInfo = "请再次输入查询密码";
                $scope.simKeyValue = [];
                $scope.simKeyUsage = 1;
                break;
            case 1:     // 确认查询密码
                console.log('from menu');
                var temp1 = '';
                var temp2 = '';
                for (var i = 0; i < 6; i++) {
                    temp1 += $scope.simKeyValue1[i];
                    temp2 += $scope.simKeyValue[i];
                }
                if (temp1 != temp2) {
                    $scope.simKeyValue = [];
                    $fwCordovaToast.showShortBottom("两次输入的密码不一致");
                } else {
                    $scope.simShowIndex = 1;    // 等待页
                    AccountService.setQueryPassword('', temp1).then(function (data) {
                        if (data.result == 0) {
                            $scope.simShowIndex = 0;
                            $scope.simKeyValue = [];
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                        else {
                            AccountService.checkQueryPassword(localStorage.currentAccountId, temp, true).then(function (data) {
                                if (data.result != 0) {
                                    localStorage.queryToken = data.data;

                                    $scope.simShowIndex = 2;    // 成功
                                    $timeout(function () {
                                        SimKeyHide();
                                        simKeyDefferd.resolve(true);
                                    }, 1000);
                                }
                            })
                        }
                    });
                }
            case 2:     // 验证查询密码
                var temp = '';
                for (var i = 0; i < 6; i++) {
                    temp += $scope.simKeyValue[i];
                }
                $scope.simShowIndex = 1;    // 等待页
                AccountService.checkQueryPassword(localStorage.currentAccountId, temp, true).then(function (data) {
                    if (data.result == 0) {
                        $scope.errorNumber = $scope.errorNumber + 1;
                        $scope.simShowIndex = 3;
                        $scope.simKeyResult = data.msg;
                        $timeout(function () {
                            $scope.simShowIndex = 0;
                            $scope.simKeyValue = [];
                        }, 2000);
                    }
                    else {
                        $scope.errorNumber = 0;
                        localStorage.queryToken = data.data;
                        $scope.simShowIndex = 2;    // 成功
                        $timeout(function () {
                            SimKeyHide();
                            simKeyDefferd.resolve(true);
                        }, 1000);
                    }
                })
                break;
        }
    }

    // 模拟键盘关闭事件
    $scope.simKeyClose = function () {
        SimKeyHide();
        simKeyDefferd.resolve(false);
        return simKeyDefferd.promise;
    }

    function SimKeyHide() {
        $scope.simKeyDescr = null;
        $scope.simKeybordModal.hide();
        // 注销掉返回键事件
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'simKey') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    }


    // #endregion

    // 扫码
    $rootScope.scanCode = function () {
        $ionicLoading.show();
        cordova.plugins.barcodeScanner.scan(function (result) {
            $ionicLoading.hide();
            // result.cancelled 1 | 0
            if (!result.cancelled) {
                //alert("扫码成功: \n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
                var resultText = result.text;
                // result.text有值
                if (resultText) {
                    // 如果是冠心病随访，先替他走一个半绑卡
                    if (resultText.toUpperCase().indexOf("HTTPS://WX.FUWAI.COM/FLUPCHD") > -1 || resultText.toUpperCase().indexOf("HTTP://WX.FUWAI.COM/FLUPCHD") > -1) {

                        var i = resultText.toUpperCase().indexOf("IDCARDCODE");
                        var idcardCode = resultText.substring(i + 11, i + 11 + 18);

                        $ionicLoading.show();
                        VisitPatientService.visitPatientInfoByIDCard(idcardCode).then(function (data) {
                            if (data.result == 1) {
                                if (data.data.HIS_CARD_NUM != null && data.data.HIS_CARD_NUM != "") {
                                    $ionicLoading.hide();
                                    $scope.scanResult(resultText);
                                }
                                // 替他走一下半绑卡，主要是获取hisCardNum
                                else {
                                    // 获取办卡状态
                                    OpRegService.patientCheck(data.data.VISIT_PATIENT_ID).then(function (pateintCheckData) {
                                        // 获取成功
                                        if (pateintCheckData.result == 1) {
                                            if (pateintCheckData.is_null == 1) {
                                                $ionicLoading.hide();
                                                $fwCordovaToast.showShortBottom("检查就诊卡，网络错误，请稍后重试");
                                            }
                                            // 一张卡 --> 下一步
                                            else if (pateintCheckData.is_null == 0) {
                                                $ionicLoading.hide();
                                                $scope.scanResult(resultText);
                                            }
                                            // 多张卡 --> 绑卡
                                            else if (pateintCheckData.is_null == 2) {
                                                $ionicLoading.hide();
                                                $fwCordovaToast.showShortBottom("请前往个人中心，进行绑卡操作");
                                            }
                                            else {
                                                $ionicLoading.hide();
                                                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                            }
                                        }
                                        // 获取错误
                                        else {
                                            $ionicLoading.hide();
                                            $fwCordovaToast.showShortBottom(pateintCheckData.msg ? pateintCheckData.msg : "网络错误,请稍后重试");
                                        }
                                    }, function () {
                                        $ionicLoading.hide();
                                        $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                    })
                                }
                            }
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                                $ionicLoading.hide();
                            }
                        }, function (error) {
                            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                            $ionicLoading.hide();
                        })
                    }
                    else {
                        $scope.scanResult(resultText);
                    }
                }
            }
        }, function (error) {
            $fwCordovaToast.showShortBottom("扫码失败: \n" + error);
            $ionicLoading.hide();
        }, {
            preferFrontCamera: false, // iOS and Android
            showFlipCameraButton: true, // iOS and Android
            showTorchButton: true, // iOS and Android
            disableAnimations: false, // iOS
            disableSuccessBeep: false, // iOS and Android
            prompt: "请把条形码/二维码置于扫码框内", // Android
            //formats : "QR_CODE,PDF_417", // default: all but PDF_417 and RSS_EXPANDED
            orientation: "none", // Android only (portrait|landscape), default unset so it rotates with the device
            torchOn: false, // Android, launch with the torch switched on (if available)
            resultDisplayDuration: 0, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            saveHistory: false // Android, save scan history (default false)
        });
    }

    // 扫码ajax
    $scope.scanResult = function (resultText) {
        $ionicLoading.show();
        HospitalService.scanResult(resultText).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                if (data.data.type == "href") {
                    $state.go(data.data.state, data.data.param);
                }
            }
        }, function (error) {
            $fwCordovaToast.showShortBottom("扫码失败");
            $ionicLoading.hide();
        })
    }

    // 收银台
    // descr 模块代码
    // money 支付金额
    // vpId 就诊人Id
    // rlatObjId 对象ID
    // balance feeItem doctorCode仅限门诊缴费
    // 1.门诊预存充值："payment", 金额, vpId
    // 2.在线问诊（易复诊）："consultation", 金额, vpId, treatApplyId
    // 3.在线简易门诊："olTreat", 金额, vpId, treatApplyId, "", "", doctorCode, IS_MI, FUND_PAY, PERSON_COUNT_PAY, fee
    // 4.在线简易门诊药品快递到家："olTreatExpress", 金额, vpId, treatApplyId, balance, feeItem, doctor
    // 5.核酸检测预约："coronavirus", 金额, vpId, applyId, balance, feeItem, doctor
    // 6.急诊预存充值："emrCharge", 金额, vpId
    // 7.医事服务费，补、0挂：
    $scope.cashier = function (descr, money, vpId, rlatObjId, balance, feeItem, doctorCode, isMI, fundPay, personCountPay, fee, medicalServiceType, doctorName, medicalServiceDate, regLevelCode, regLevleName) {
        cashierDefferd = $q.defer();

        // 支付返回
        $scope.payResult = new Object();
        $scope.payResult.code = 0;
        $scope.payResult.data = "";
        $scope.payResult.paymentMethod = "";

        // 初始化
        $scope.cashierDescr = "";
        $scope.cashierDescrCH = "";
        $scope.cashierVpId = "";
        $scope.cashierMoney = "";
        $scope.cashierRlatObjId = "";
        $scope.cashierBalance = "";
        $scope.cashierFeeItem = "";
        $scope.cashierDoctorCode = "";
        $scope.cashierIsMI = "";
        $scope.cashierFundPay = "";
        $scope.cashierPersonCountPay = "";
        $scope.cashierFee = "";
        $scope.cashierMedicalServiceType = "";
        $scope.cashierDoctorName = "";
        $scope.cashierMedicalServiceDate = "";
        $scope.cashierRegLevelCode = "";
        $scope.cashierRegLevelName = "";
        $rootScope.paymentRouteList = [];

        // 公共的，可以提出来
        $scope.cashierDescr = descr;
        console.log(money);
        $scope.cashierMoney = $scope.formatFee(money);
        $scope.cashierVpId = vpId;
        console.log($scope.cashierMoney);
        // 在线问诊（易复诊）
        if (descr == "consultation") {
            $scope.cashierDescrCH = "在线问诊";
            $scope.cashierRlatObjId = rlatObjId;
            $scope.cashierDoctorCode = doctorCode;
            $scope.cashierIsMI = isMI;
            $scope.cashierFundPay = $scope.formatFee(fundPay);
            $scope.cashierPersonCountPay = $scope.formatFee(personCountPay);
            $scope.cashierFee = $scope.formatFee(fee);
        }
        // 门诊预存充值，可以用
        else if (descr == "payment") {
            $scope.cashierDescrCH = "门诊预存充值";
        }
        // 在线简易门诊、视频问诊
        else if (descr == "olTreat") {
            $scope.cashierDescrCH = "互联网复诊费";
            $scope.cashierRlatObjId = rlatObjId;
            $scope.cashierDoctorCode = doctorCode;
            $scope.cashierIsMI = isMI;
            $scope.cashierFundPay = $scope.formatFee(fundPay);
            $scope.cashierPersonCountPay = $scope.formatFee(personCountPay);
            $scope.cashierFee = $scope.formatFee(fee);
        }
        // 在线简易门诊药品快递到家
        else if (descr == "olTreatExpress") {
            $scope.cashierDescrCH = "药品快递到家";
            $scope.cashierRlatObjId = rlatObjId;
            $scope.cashierBalance = $scope.formatFee(balance);
            $scope.cashierFeeItem = feeItem;
            $scope.cashierDoctorCode = doctorCode;
            // 药品快递到家，支持医保了要
            $scope.cashierIsMI = isMI;
        }
        // 核酸检测
        else if (descr == "coronavirus") {
            $scope.cashierDescrCH = "核酸检测检查费";
            $scope.cashierRlatObjId = rlatObjId;
            $scope.cashierBalance = $scope.formatFee(balance);
            $scope.cashierFeeItem = feeItem;
            $scope.cashierDoctorCode = doctorCode;
        }
        // 急诊预存充值
        else if (descr == "emrCharge") {
            $scope.cashierDescrCH = "急诊预存充值";
        }
        // 医师服务费，补、0挂
        else if (descr == "medicalService") {
            $scope.cashierDescrCH = "医事服务费";
            $scope.cashierDoctorCode = doctorCode;
            $scope.cashierIsMI = isMI;
            $scope.cashierMedicalServiceType = medicalServiceType;
            $scope.cashierDoctorName = doctorName;
            $scope.cashierMedicalServiceDate = medicalServiceDate;
            $scope.cashierRegLevelCode = regLevelCode;
            $scope.cashierRegLevelName = regLevleName;
        }
        // 预约挂号缴费，暂未启用
        else if (descr == "opAppt") {

        }
        // 门诊缴费，暂未启用
        else if (descr == "opPayment") {

        }
        // 住院预存充值，暂未启用
        else if (descr == "ipCharge") {

        }
        // 病案复印押金，暂未启用
        else if (descr == "casePrint") {

        }

        // 获取可选择支付方式
        PaymentService.getPaymentRoute().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                console.log(data);
                $rootScope.paymentRouteList = data.data;
                $scope.cashierOpen();
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.cashierClose();
            }
        })

        return cashierDefferd.promise;
    }
    // 模拟开启事件
    $scope.cashierOpen = function () {
        $rootScope.cashierShowIndex = 0;
        console.log($scope.cashierShowIndex);
        $scope.cashierModal.show();

        // 初始化变量
        $scope.paymentInfo = new Object();
        $scope.paymentInfo.method = "1";
        $scope.paymentInfo.methodCH = "微信支付";
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $scope.cashierCountdown = 10;
    }

    // 模拟关闭事件
    $scope.cashierClose = function () {
        $scope.cashierHide();
        cashierDefferd.resolve($scope.payResult);
        return cashierDefferd.promise;
    }

    $scope.cashierHide = function () {
        $scope.cashierModal.hide();
        // 注销掉返回键事件
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'cashier') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    }

    // 格式化价格 至少两位小数 返回字符串
    $scope.formatFee = function (fee) {
        fee = BigNumber(fee).toNumber();
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于2位小数 补0
        if (indexPoint == -1 || lengthFee - indexPoint < 3) {
            feeShow = fee.toFixed(2);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 2024-4-22 14:27:16 wcx 和自助机接口计算规则统一 先显示4位小数
    $scope.formatFeeV2 = function (fee) {
        fee = BigNumber(fee).toNumber();
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于4位小数 补0
        if (indexPoint == -1 || lengthFee - indexPoint < 5) {
            feeShow = fee.toFixed(4);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // #region 门诊缴费委托

    // 获取门诊待缴费列表
    // vpId 就诊人ID
    // rlatObjId 检查单号、处方号（若需要）
    $scope.opPayment4001 = function (vpId, rlatObjId, rlatObjType) {
        opPayment4001Defferd = $q.defer();
        var result4001 = new Object();

        OpPaymentService.opPendingPaymentV2(vpId, rlatObjId, rlatObjType).then(function (data) {
            console.log(data);
            result4001.result = data.result;
            result4001.requestId = data.requestId;
            if (data.result == 1) {
                // 成功，且有值
                if (data.is_null != 1) {
                    // 需要规整下数据，再返回
                    var opPaymentGroupList = [];
                    var addFeeNumList = [];

                    // 根据检查单号、处方号进行分组
                    var checkListNumGroup = new Set(data.data.map(e => e.CHECK_LIST_NUM));
                    checkListNumGroup.forEach(checkListNum => {
                        var group = {};
                        // 2020-7-13 18:09:45 HM 在线问诊开检查，把IDA拿出来，以后的功能可能也需要
                        group.IDA = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].IDA;

                        group.MEDICIAL_ITEM_ID = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].MEDICIAL_ITEM_ID;
                        group.CHECK_LIST_NUM = checkListNum;
                        group.FEE_ITME_LIST = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum);
                        // 计算检查单费用合计(每单四舍五入保留两位小数)
                        group.CHECK_LIST_FEE = 0;
                        // 附加项检查单号列表
                        group.ADD_FEE_NUM_LIST = [];
                        // 缴费项目代码
                        group.CHARGE_ITEM_CODE = "";
                        // 是否包含抗排异药物
                        group.SPECIALITY_ITEM_REMARK2 = false;
                        // 是否包含CT检查费
                        group.SPECIALITY_ITEM_REMARK3 = false;
                        // 检查单类别
                        group.CHARGE_ITEM_TYPE_CODE = "";
                        group.CHARGE_ITEM_TYPE_NAME = "";
                        // 检查单内项目名称集合
                        group.CHARGE_ITEM_NAME = "";
                        // 开单日期
                        group.ORDER_DATE = "";

                        // 遍历检查单
                        for (var i in group.FEE_ITME_LIST) {
                            // 检查单费用合计
                            group.CHECK_LIST_FEE = $scope.numAdd(group.CHECK_LIST_FEE, group.FEE_ITME_LIST[i].TOTAL_PRICE);
                            // 附加项检查单号
                            if (group.FEE_ITME_LIST[i].ADD_FEE_NUM != "0" && !group.ADD_FEE_NUM_LIST.includes(group.FEE_ITME_LIST[i].ADD_FEE_NUM)) {
                                group.ADD_FEE_NUM_LIST.push(group.FEE_ITME_LIST[i].ADD_FEE_NUM);
                            }
                            // 2024-4-22 14:30:04 wcx 补足为四位小数
                            // 格式化价格 补足至少两位小数
                            group.FEE_ITME_LIST[i].UNIT_PRICE_SHOW = $scope.formatFeeV2(group.FEE_ITME_LIST[i].UNIT_PRICE);
                            group.FEE_ITME_LIST[i].TOTAL_PRICE_SHOW = $scope.formatFeeV2(group.FEE_ITME_LIST[i].TOTAL_PRICE);
                            // 如果不存在 追加缴费项目代码
                            if (group.CHARGE_ITEM_CODE.indexOf(group.FEE_ITME_LIST[i].CHARGE_ITEM_CODE) == -1) {
                                group.CHARGE_ITEM_CODE += "," + group.FEE_ITME_LIST[i].CHARGE_ITEM_CODE;
                            }
                            // 是抗排异药物
                            if (group.FEE_ITME_LIST[i].SPECIALITY_ITEM_REMARK2) {
                                group.SPECIALITY_ITEM_REMARK2 = true;
                            }
                            // 是CT检查费
                            if (group.FEE_ITME_LIST[i].SPECIALITY_ITEM_REMARK3) {
                                group.SPECIALITY_ITEM_REMARK3 = true;
                            }
                            // 检查单类别 只显示: 1=药费, 2=检查费
                            if ((group.FEE_ITME_LIST[i].CATEGORY == "1" || group.FEE_ITME_LIST[i].CATEGORY == "2")) {
                                // 检查单内项目名称集合
                                group.CHARGE_ITEM_NAME += "、" + group.FEE_ITME_LIST[i].CHARGE_ITEM_NAME;
                                if (group.CHARGE_ITEM_TYPE_CODE.indexOf(group.FEE_ITME_LIST[i].CATEGORY) == -1) {
                                    group.CHARGE_ITEM_TYPE_CODE += "," + group.FEE_ITME_LIST[i].CATEGORY;
                                }
                            }
                            // 开单日期
                            if (i == 0) {
                                group.ORDER_DATE = new Date(group.FEE_ITME_LIST[i].ORDER_TIME).Format("yyyy年MM月dd日");;
                            }
                        }
                        // 2024-4-23 16:12:00 wcx 详情页合计价格单独列出
                        group.CHECK_DETAIL_FEE_SHOW = $scope.formatFeeV2(group.CHECK_LIST_FEE);
                        // 每单四舍五入保留两位小数
                        group.CHECK_LIST_FEE = $scope.roundFee(group.CHECK_LIST_FEE);
                        // 格式化价格 补足至少两位小数
                        group.CHECK_LIST_FEE_SHOW = $scope.formatFee(group.CHECK_LIST_FEE);
                        // 缴费项目代码 去掉开头逗号
                        if (group.CHARGE_ITEM_CODE.length > 0) {
                            group.CHARGE_ITEM_CODE = group.CHARGE_ITEM_CODE.substr(1);
                        }
                        group.SELECTED = false;
                        // 检查单类别
                        group.CHARGE_ITEM_TYPE_CODE = group.CHARGE_ITEM_TYPE_CODE.substr(1);
                        group.CHARGE_ITEM_TYPE_NAME = group.CHARGE_ITEM_TYPE_CODE.replace("1", "药费").replace("2", "检查费");
                        // 检查单内项目名称集合
                        group.CHARGE_ITEM_NAME = group.CHARGE_ITEM_NAME.substr(1);

                        // 2023-6-21 11:17:35 HM 增加保健医处方
                        group.INSPECT_STAFF_STATUS = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].INSPECT_STAFF_STATUS;

                        // 2023-5-30 08:33:53 HM 增加北京医保app
                        group.APP_UPLOAD_STATUS = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].APP_UPLOAD_STATUS;

                        opPaymentGroupList.push(group);
                        // 附加项代码列表
                        for (var i in group.ADD_FEE_NUM_LIST) {
                            if (!addFeeNumList.includes(group.ADD_FEE_NUM_LIST[i])) {
                                addFeeNumList.push(group.ADD_FEE_NUM_LIST[i]);
                            }
                        }
                    });
                    // 2018-9-7 17:18:25 排序 日期DESC, 药费/检查费, 检查单号
                    opPaymentGroupList.sort((a, b) => {
                        var result = a.ORDER_DATE.localeCompare(b.ORDER_DATE) * (-100)
                            + a.CHARGE_ITEM_TYPE_CODE.localeCompare(b.CHARGE_ITEM_TYPE_CODE) * 10
                            + (Number(a.CHECK_LIST_NUM) < Number(b.CHECK_LIST_NUM) ? -1 : 1);
                        return result;
                    });
                    console.log(opPaymentGroupList);
                    console.log(addFeeNumList);

                    // 患者身份类别
                    result4001.healthCareType = data.data[0].HEALTH_CARE_TYPE;// 3北京医保

                    result4001.data = new Object();
                    result4001.data.opPaymentGroupList = opPaymentGroupList;
                    result4001.data.addFeeNumList = addFeeNumList;
                    opPayment4001Defferd.resolve(result4001);
                }
                // 成功，但是没值
                else {
                    result4001.result = 0;
                    result4001.msg = data.msg;
                    opPayment4001Defferd.resolve(result4001);
                }
            }
            else if (data.result == 99) {
                result4001.msg = "连接超时，请稍后重试";
                opPayment4001Defferd.resolve(result4001);
            }
            else {
                // 出错误了，直接返回
                result4001.msg = data.msg;
                opPayment4001Defferd.resolve(result4001);
            }
        }, function (err) {
            opPayment4001Defferd.reject("网路错误，获取门诊待缴费列表失败");
        })

        return opPayment4001Defferd.promise;
    }

    // 校验门诊待缴费项目金额
    // vpId 就诊人ID
    // strFeeItemCode 逗号拼接的检查单号、处方号
    // totalFeeCalc 计算的金额
    $scope.opPayment4005 = function (vpId, strFeeItemCode, totalFeeCalc) {
        opPayment4005Defferd = $q.defer();
        var result4005 = new Object()
        OpPaymentService.opPaymentAmountCalc(vpId, strFeeItemCode, totalFeeCalc).then(function (data) {
            result4005.result = data.result;
            result4005.requestId = data.requestId;
            // 链接超时
            if (data.result == 99) {
                result4005.msg = "连接超时，请稍后重试";
                opPayment4005Defferd.resolve(result4005);
            }
            // 调用失败
            else if (data.result == 0) {
                // 出错误了，直接返回
                result4005.msg = data.msg;
                opPayment4005Defferd.resolve(result4005);
            }
            // 调用成功
            else if (data.result == 1) {
                // 数据异常
                if (data.is_null == 1 || data.data[0].TOTAL_FEE == "-1") {
                    if (data.msg != null && data.msg != '') {
                        result4005.result = 0;
                        result4005.msg = data.msg;
                        opPayment4005Defferd.resolve(result4005);
                    }
                    else {
                        result4005.result = 0;
                        result4005.msg = "获取缴费信息失败";
                        opPayment4005Defferd.resolve(result4005);
                    }
                }
                // 查询成功
                else {
                    // 后台返回金额
                    var realFee = Number(data.data[0].TOTAL_FEE);
                    if (Number.isNaN(realFee)) {
                        result4005.result = 0;
                        result4005.msg = "获取缴费信息失败";
                        opPayment4005Defferd.resolve(result4005);
                    }
                    // 金额错误
                    else if (realFee != totalFeeCalc) {
                        result4005.result = 0;
                        result4005.msg = "获取缴费信息失败";
                        opPayment4005Defferd.resolve(result4005);
                    }
                    // 金额正确
                    else {
                        // 2018-8-23 08:56:57 补收医事服务费
                        // 2018-9-18 09:40:14 医事服务费改为多笔
                        var msFeeStatus = false;
                        var msFee = 0;
                        var msFeeCount = 0;
                        var balance = 0;
                        if (data.data != null && data.data.length > 0) {
                            for (var i in data.data) {
                                if (!Number.isNaN(Number(data.data[i].MEDICAL_SERVICE_FEE))) {
                                    msFeeStatus = true;
                                    msFee += Number(data.data[i].MEDICAL_SERVICE_FEE);
                                    msFeeCount++;
                                }
                            }
                        }

                        // 余额正确
                        if (!Number.isNaN(Number(data.data[0].BALANCE))) {
                            balance = Number(data.data[0].BALANCE);
                        }

                        result4005.data = new Object();
                        result4005.data.msFeeStatus = msFeeStatus;// 是否需要补收医事服务费
                        result4005.data.msFee = msFee;// 补收医事服务费金额
                        result4005.data.msFeeCount = msFeeCount;// 补收几笔医师服务费
                        result4005.data.balance = balance;// 预存余额
                        opPayment4005Defferd.resolve(result4005);
                    }
                }
            }
        }, function (err) {
            opPayment4005Defferd.reject("网路错误，校验门诊待缴费项目金额失败");
        })

        return opPayment4005Defferd.promise;
    }

    // 精确加法
    $scope.numAdd = function (num1, num2) {
        // 2018-9-10 13:17:22 改用BigNumber计算
        return BigNumber(num1).plus(num2).toNumber();
    }

    // 四舍五入到两位小数 返回数字
    $scope.roundFee = function (fee) {
        // 2020-11-3 10:21:14 HM 5厘钱问题，改用bigNumber计算，times乘法，div除法
        return BigNumber(Math.round(BigNumber(fee).times(100).toNumber())).div(100).toNumber();
        //return Math.round(fee * 100) / 100;
    }

    // #endregion
})