﻿angular.module('fwapp.controllers')

    .controller('MessageController', function ($scope, $rootScope, $state, $ionicPlatform, $ionicLoading, $ionicViewSwitcher, $ionicScrollDelegate, $cordovaInAppBrowser, PersonalService, OpConsumptionService) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 消息列表
    $scope.messageList = [];
    // 当前页
    $scope.pageNum = 1;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕
    $scope.isLoadFinish = false;
    // 搜索消息中心
    $scope.inputType = "";

    // 加载数据
    $scope.loadList = function () {
        if ($scope.inputType != "") {
            $scope.pageNum = 1;
            $scope.messageList = [];
        }

        PersonalService.messageList($scope.pageNum, $scope.inputType).then(function (data) {
            for (var i = 0; i < data.msgList.length; i++) {
                $scope.messageList.push(data.msgList[i]);
            }
            if ($scope.inputType != "") {
                $ionicScrollDelegate.scrollTop();
                if (data.msgList.length == 0) {
                    $fwCordovaToast.showShortBottom("未找到指定消息");
                }
            }
            $scope.canLoadMore = (data.pageNum - 1) * data.pageSize + data.msgList.length < data.totalCount;
            $scope.pageNum++;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');

            $scope.isLoadFinish = true;
        });
    }

    // 滚动条用，用于控制是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore;
        console.log($scope.isLoadFinish && $scope.canLoadMore);
    }

    // 2020-2-21 08:28:33 无脑返回首页 避免死循环
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        //$state.go('app.home');
        $rootScope.goBack();
    }

    // 进入视频探视微信小程序
    $scope.olTreatVisit = function () {
        var param = { type: "olTreatVisit", param: "olTreatVisit" };

        var funcSuccess = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
            console.log(data);
        }
        var funcError = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
            console.log(data);
        }

        window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
    }

    // 2022.10.26 14:45 跳转科普视频
    $scope.jumpVideo = function (url) {
        //$cordovaInAppBrowser.open(url, '_system').then(function (event) { });
        //2023.7.31 新插件原有调用方式参数不生效
        showInAppBrowser(url, '_system');
    }

    // 2023-3-21 09:36:46 HM 跳转电子发票
    $scope.jumpPayEInvoice = function (messageId) {
        $ionicLoading.show();
        OpConsumptionService.lookUpEInvoice(messageId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0){
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                //$cordovaInAppBrowser.open(data.data, '_system').then(function (event) { });
                //2023.7.31 新插件原有调用方式参数不生效
                showInAppBrowser(data.data, '_system');
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 2023-3-24 14:22:00 HM 跳转微信小程序
    $scope.jumpMiniProgram = function (type, url) {
        var param = { type: type, param: url };
    
        var funcSuccess = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
            console.log(data);
        }
        var funcError = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
            console.log(data);
        }

        window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'message');

        $ionicLoading.show();
        $scope.loadList();

        // 消息提示
        PersonalService.lastMsg(localStorage["lastMsgId_" + localStorage.currentAccountId]).then(function (data) {
            localStorage["lastMsgId_" + localStorage.currentAccountId] = data.lastMsgDate;
            $rootScope.hasUnread = false;
            $rootScope.unReadCount = 0;
            $ionicLoading.hide();
        })
    });

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'message') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 2018-6-28 14:48:35 点击消息跳转
    $scope.goState = function (state, params) {
        //console.log(state);
        //console.log(params);
        if (state == null || state == "") {
            return;
        }
        // 2025-01-14 14:04:33 zyz 无偿献血跳新小程序
        if (state == "app.donateBlood") {
            var param = { type: "donateBlood", param: "donateBlood" }
            var funcSuccess = function (data) {
            }
            var funcError = function (data) {
            }
            window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
        }
        else {
            $state.go(state, params);
        }
    }
})