﻿angular.module('fwapp.controllers')

// 医院动态
.controller('NewsController', function ($scope, $rootScope, $state, $stateParams, ArticleService, $fwCordovaToast, $cordovaInAppBrowser
    , $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicPlatform, $ionicLoading) {

    // 定义预约申请滑块
    var slideNews = $ionicSlideBoxDelegate.$getByHandle('slideNews');
    // 定义预约申请滚动条
    var scrollNews = $ionicScrollDelegate.$getByHandle('scrollNews');
    // 文章id
    $scope.newsId = ($stateParams.id == null || $stateParams.id.length == 0) ? "" : $stateParams.id;
    // 栏目id 默认"11"=医院新闻动态
    $scope.columnId = ($stateParams.columnId == null || $stateParams.columnId.length == 0) ? "11" : $stateParams.columnId;
    // 初始滑块状态
    $scope.step = 0;
    // 文章列表
    $scope.articleList = [];
    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
    // 文章内容
    $scope.articleDetail = new Object();
    // 当前页
    $scope.pageNum = 1;
    // 每页数量
    $scope.pageSize = 10;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕，防止无内容闪现
    $scope.isLoadFinish = false;
    // 页面标题列表
    $scope.titleList = ["医院动态", ""];
    // 2022-7-6 15:20:14 CGZ 支持特需医疗中心三个病区
    if ($scope.columnId == "1380") {
        //$scope.titleList[0] = "干部病区";
        // 2025-1-9 15:50:40 CGZ 干部病区更名为16病区
        $scope.titleList[0] = "16病区";
    } else if ($scope.columnId == "1383") {
        $scope.titleList[0] = "特需一病区";
    } else if ($scope.columnId == "1384") {
        $scope.titleList[0] = "特需二病区";
    }
    // 滑到上一步
    $scope.lastSlide = function () {
        slideNews.previous();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideNews.next();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideNews.slide(index);
    }
    // 滑块切换触发
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideNews.currentIndex();
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        // 列表页滚到记录高度
        if ($scope.step == 0) {
            scrollNews.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.articleDetail = new Object();
        }
        // 内容页滚到顶
        else {
            $ionicScrollDelegate.scrollTop();
        }
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（文章列表）或者 从首页直接进文章内容页 正常后退回首页
        if (($scope.step == 0) || ($scope.step == 1 && $scope.newsId != '')) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他情况返回上一个滑块
        else {
            $scope.lastSlide();
        }
    }
    // 获取列表
    $scope.loadList = function (index) {
        //$scope.isLoadFinish = false;
        // 从栏目列表来的
        if ('undefined' != typeof (index)) {
            $ionicLoading.show();
            // 跳转
            $scope.nextSlide();
        }
        // 2022-7-6 14:58:48 CGZ 特需医疗中心三个病区的科室动态 支持传入columnId
        ArticleService.list($scope.columnId, $scope.pageNum, $scope.pageSize).then(function (data) {
            if (data.result == 1) {
                // 新获取的列表追加到文章列表后
                for (var i = 0; i < data.data.page.length; i++) {
                    // 缩短标题至4s的两行内 超过28字加...
                    data.data.page[i].Descr = data.data.page[i].Title.length > 21 ? data.data.page[i].Title.substring(0, 21) + '...' : data.data.page[i].Title;
                    data.data.page[i].ImageSrc = (data.data.page[i].ImageUrl == null || data.data.page[i].ImageUrl.length == 0) ? "img/articleDefault.png" : ((data.data.page[i].ImageUrl.indexOf("http://") > 0 ? "" : picPrefix) + data.data.page[i].ImageUrl);
                    $scope.articleList.push(data.data.page[i]);
                }
                // 第一页第一条置顶标题缩短至16字
                // 2022-7-6 15:15:58 CGZ 如果为空栏目会报错 此处增加非空判断
                if ($scope.pageNum == 1 && $scope.articleList.length > 0) {
                    $scope.articleList[0].Descr = $scope.articleList[0].Title.length > 21 ? $scope.articleList[0].Title.substring(0, 20) + '...' : $scope.articleList[0].Title;
                }
                // 计算是否可继续加载
                $scope.canLoadMore = (data.data.pageNum - 1) * data.data.pageSize + data.data.page.length < data.data.totalCount;
                // 当前页数+1
                $scope.pageNum++;
                // 加载完毕
                $scope.isLoadFinish = true;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                //console.log(data);
                //$ionicLoading.hide();
            }
            else {
                $scope.isLoadFinish = true;
                //$ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试!");
            }
            // 从栏目列表来的
            //if ('undefined' != typeof (index)) {
            $ionicLoading.hide();
            //}
        }, function (data) {
            $scope.isLoadFinish = true;
            //$ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            // 从栏目列表来的
            if ('undefined' != typeof (index)) {
                $ionicLoading.hide();
            }
        })
    }
    // 获取内容
    $scope.loadDetail = function (index) {
        // 2017-8-15 BST 处理外部链接
        if ($scope.articleList[index].ExternalLink != '') {
            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open($scope.articleList[index].ExternalLink, '_blank', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser($scope.articleList[index].ExternalLink, '_blank');
            return;
        }

        // 记录当前列表页滚动条位置
        $scope.scrollPosition = scrollNews.getScrollPosition();
        $ionicLoading.show();
        // 标题赋值
        $scope.titleList[1] = $scope.articleList[index].Title;
        // 跳转
        $scope.nextSlide();
        ArticleService.detail($scope.articleList[index].ArticleId).then(function (data) {
            if (data.result == 1) {
                $scope.articleDetail = data.data;
                $scope.articleDetail.Content = data.data.Content;
                // 重新计算滚动条高度
                $ionicScrollDelegate.resize();
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 根据文章id获取内容 从首页来的
    $scope.loadDetailById = function (newsId) {
        $ionicLoading.show();
        // 跳转
        $scope.nextSlide();
        ArticleService.detail(newsId).then(function (data) {
            console.log(data);
            if (data.result == 1) {
                $scope.articleDetail = data.data;
                $scope.articleDetail.Content = data.data.Content;
                console.log('content');
                // 标题赋值
                $scope.titleList[1] = data.data.Title;
                // 重新计算滚动条高度
                $ionicScrollDelegate.resize();
                $ionicLoading.hide();
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        })
    }
    // 是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore && $scope.step == 0;
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideNews.enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'news');
        //console.log($scope.newsId);
        // 进入列表页 获取文章列表
        if ('' == $scope.newsId) {
            $ionicLoading.show();
            $scope.loadList();
        }
        // 进入文章内容页
        else {
            $scope.loadDetailById($scope.newsId);
        }
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'news') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
})