﻿angular.module('fwapp.controllers')

// 在线诊疗-处方开药
.controller('OlTreatRecipeController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout, $interval, $filter
, $ionicPlatform, $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicActionSheet
, $cordovaFileTransfer, $cordovaImagePicker, $cordovaCamera, $cordovaImagePicker, $cordovaDatePicker, $fwCordovaToast
, AccountService, VisitPatientService, RequestService, OlTreatRecipeService, OpRegService, PaymentService, IpRegService) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义门诊缴费滑块
    var slideOlTreatRecipe = $ionicSlideBoxDelegate.$getByHandle('slideOlTreatRecipe');

    // 服务开关
    $scope.isServerOn = $rootScope.isOlTreatRecipe;
    // 服务状态描述
    $scope.serverStatusDescr = "";

    // 倒计时
    $scope.confirmCountdown = devMode ? 1 : 10;

    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 处方列表
    $scope.prescriptionList = [];
    // 药品列表
    $scope.drugList = [];
    // 检查检验列表
    $scope.checkList = [];
    // 是否加载完成
    $scope.isLoadFinish = false;
    // 水印
    $scope.watermark = {};
    // 初始滑块状态
    $scope.step = 0;
    // 用户须知数据
    $scope.agreement = new Object();

    // 就诊人列表
    $scope.vpList = [];
    // 就诊人信息
    $scope.vpInfo = new Object();

    // 已选择处方序号
    $scope.prescriptionsIndexList = [];

    // 开药信息
    $scope.prescriptionInfo = {};
    $scope.prescriptionInfo.applyId = "";
    $scope.prescriptionInfo.applyCheckId = "";
    $scope.prescriptionInfo.takeMedWay = 1;
    $scope.prescriptionInfo.apply = {};
    $scope.prescriptionInfo.convrList = [];
    $scope.prescriptionInfo.recipeList = [];

    // 记录step从第几页来的
    $scope.treatStep = "";
    // 记录第6页是从哪页跳来的
    $scope.fromStep = -1;

    $scope.requestId = '';
    $scope.vpBind = {};
    // 2020-9-18 10:55:35 HM 绑卡的时候没有选择就诊人关系就能绑卡，这里初始化一下变量就能解决
    $scope.vpBind = {
        name: '',
        card_num: '',
        card_num_show: '',
        phone_num: null,
        phone_num_show: '',
        veri_code: '',
        patient_id: '',
        is_self: 0
    };
    $scope.imageVericode = {};
    // 绑卡前一步是否来自选卡
    $scope.lastSelectCard = false;
    // 是不是医保患者
    $scope.isPatientMI = false;

    // 防止多次提交
    $scope.disableAddVP = false;
    // 添加就诊人对象
    $scope.vpNew = {};
    // 2023-8-28 13:55:26 ZZL #hzfwx-107 字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 就诊人办卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '',
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 多张卡列表
    $scope.cardList = [];
    // 多张卡选择序列
    $scope.cardSelectIndex = 0;
    // 医保模型
    $scope.MI =
    {
        REQUESTID: '',
        NOTICE: '',
        HELP: '',
        MI_PATIENT_CODE: '',
        MI_PATIENT_IMG_URL: '',
        MI_IMG_URL: ''
    };
    // 是否展示物流配送
    $scope.deliveryShow = false;
    // 是否展示药品快递到家
    $scope.experssShow = false;
    // 病情确认
    $scope.isCondition = -1;
    // 是否为本人开药
    $scope.isSelf = -1;
    // 代开药人信息
    $scope.agent =
    {
        TREAT_AGENT_ID: '',
        AGENT_NAME: '',
        AGENT_IDCARD: '',
        AGENT_PHONE: ''
    };
    // 处方外配问题
    $scope.deliveryMIText = "";
    $scope.deliveryBYText = "";

    // 图片服务器地址
    $scope.imgServerUrl = uploadUrl;

    // 模态框里的须知
    $scope.statement = new Object();
    $scope.statement.content = "";
    $scope.statement.title = "";

    // 自费患者同意须知
    $scope.byStatement = new Object();
    $scope.byStatement.agree = false;
    $scope.byStatement.content = "";
    $scope.byStatement.title = "";

    // 医保患者同意须知
    $scope.miStatement = new Object();
    $scope.miStatement.agree = false;
    $scope.miStatement.content = "";
    $scope.miStatement.title = "";

    // 药品快递到家同意须知
    $scope.expressStatement = new Object();
    $scope.expressStatement.agree = false;
    $scope.expressStatement.content = "";
    $scope.expressStatement.title = "";

    // 复诊续方知情同意书
    $scope.informedConsent = new Object();
    $scope.informedConsent.agree = false;
    $scope.informedConsent.content = "";
    $scope.informedConsent.title = "";

    // 医保患者提交申请前确认
    $scope.miConfirmContent = "";

    // 行政区划数组,CODE
    $scope.currentAreaList = [];
    $scope.currentArea = new Object();
    $scope.currentArea.code = "";

    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}

    // 线下就诊记录requestId
    $scope.lastOpRequestId = "";

    // 获取门诊处方requestId
    $scope.opDrugRequestId = "";

    // 无货换药提示
    $scope.outSoldMsgTmpl = "";

    // 无货换药数组
    $scope.outSoldDrugList = [];

    // 来院取药疫情提示
    $scope.ncpTip = "";

    // 门诊药品住院药品
    $scope.opDrugList = [];
    $scope.ipDrugList = [];
    $scope.chooseRecipe = "OP";

    // 2022-12-9 10:22:35 HM 加个变量，用于是否展示选门诊or出院
    $scope.checkChooseRecipeStatus = false;

    // 选择开的药，还是开的检查
    $scope.chooseTypeData = 0;

    // #region 定义模态框

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：在线建档
    $ionicModal.fromTemplateUrl('applyCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.applyCardModal = modal;
    });

    // 注册模态窗口：多卡选择绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCardSelect.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardSelectModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bind_card.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口:选就诊卡
    $ionicModal.fromTemplateUrl('chooseCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.chooseCardModal = modal;
    });

    // 注册模态窗口:上传医保卡照片
    $ionicModal.fromTemplateUrl('uploadMI.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.uploadMIModal = modal;
    });

    // 注册模态窗口:病情确认
    $ionicModal.fromTemplateUrl('conditionConfirm.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.conditionConfirmModal = modal;
    });

    // 注册模态窗口：医保认证帮助
    $ionicModal.fromTemplateUrl('MI_HELP.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MIHelpModal = modal;
    });

    // 注册模态窗口 免责声明
    $ionicModal.fromTemplateUrl('statement.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.statementModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.applyCardModal.remove();
        $scope.addVisitPatientModal.remove();
        $scope.popVplist.remove();
        $scope.bindCardSelectModal.remove();
        $scope.bindCardModal.remove();
        $scope.chooseCardModal.remove();
        $scope.uploadMIModal.remove();
        $scope.MIHelpModal.remove();
        $scope.conditionConfirmModal.remove();
        $scope.statementModal.remove();
    })

    //#endregion

    // 滑到下一步
    $scope.nextSlide = function () {
        slideOlTreatRecipe.next();
        $scope.step = slideOlTreatRecipe.currentIndex();
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOlTreatRecipe.slide(index);
        $scope.step = slideOlTreatRecipe.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        if ($scope.step == 0) {
            if ($scope.from == "app.message") {
                $window.history.back();
            }
            else if ($stateParams.vpid != null && $stateParams.vpid != "" && $scope.from.indexOf('autoInquiry') == -1) {
                $state.go('app.visitPatient', { vpid: $stateParams.vpid });
            }
            else if ($scope.from.indexOf('autoInquiry') > -1) {
                $state.go("app.autoInquiry", { vpid: $stateParams.vpid, firstFrom: $stateParams.autoFirstFrom, continueInquiry: 1 });
            }
            else {
                $state.go('app.home');
            }
        }
        else if ($scope.step == 2) {
            if ($scope.from.indexOf('autoInquiry') > -1) {
                $scope.toSlide(0);
            }
            else {
                slideOlTreatRecipe.previous();
                $scope.step = slideOlTreatRecipe.currentIndex();
            }
        }
        else if ($scope.step == 3) {
            $scope.formatDrugList($scope.drugList);
            $scope.formatCheckList($scope.checkList);
            $scope.toSlide(2);
        }
        else if ($scope.step == 4) {
            $scope.formatDrugList($scope.drugList);
            $scope.formatCheckList($scope.checkList);
            $scope.toSlide(2);
        }
        else if ($scope.step == 5) {
            if ($scope.treatStep == "recipe") {
                $scope.toSlide(3);
            }
            else if ($scope.treatStep == "check") {
                $scope.toSlide(4);
            }
        }
        else if ($scope.step == 6) {
            $scope.toSlide($scope.fromStep);
        }
        else if ($scope.step == 7) {
            $scope.goOlTreatRecipeList();
        }
        // 其他页返回上一个滑块
        else {
            slideOlTreatRecipe.previous();
            $scope.step = slideOlTreatRecipe.currentIndex();
        }
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideOlTreatRecipe.currentIndex();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 同意
    $scope.agree = function () {
        if ($scope.isServerOn) {
            // 2020-8-25 17:03:37 HM 如果来自自动问诊，帮他选择就诊人
            if ($scope.from.indexOf('autoInquiry') > -1) {
                // 就诊人id
                var index = $.inArray($scope.vpId, $scope.vpList.map(function (e) {
                    return e.VISIT_PATIENT_ID;
                }));
                $scope.selectVp(index);
            }
            else {
                $scope.nextSlide();
            }
        }
        else if ($scope.serverStatusDescr != null && $scope.serverStatusDescr != "") {
            $fwCordovaToast.showShortBottom($scope.serverStatusDescr);
        }
    }

    // #region 就诊人相关
    // 选择就诊人
    $scope.selectVp = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 在这初始化一下变量
        $scope.chooseTypeData = 0;

        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
        // 2020-5-19 08:49:46 HM 增加选就诊人的限制，这次的是限制6岁以下患者申请
        $ionicLoading.show();
        OlTreatRecipeService.selectVpLimit($scope.vpSelect.VISIT_PATIENT_ID).then(function (dataLimit) {
            $ionicLoading.hide();
            // 成功
            if (dataLimit.result == 1) {
                // 代开药人信息
                $scope.agent =
                {
                    TREAT_AGENT_ID: '',
                    AGENT_NAME: '',
                    AGENT_IDCARD: '',
                    AGENT_PHONE: ''
                };
                // 病情确认
                $scope.isCondition = -1;
                // 是否为本人开药
                $scope.isSelf = -1;
                if ($scope.vpSelect.IS_BIND_CARD == '1') {
                    // 2020-5-8 15:27:04 HM 增加开通预存账户功能
                    // 检查是否开通预存账户
                    $ionicLoading.show();
                    PaymentService.checkPrePayAccount($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                        // 请求错误
                        if (data.result == 0 || data.result == -99) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(data.msg);
                            return;
                        }
                        // 请求成功
                        if (data.result == 1) {
                            // 未开通预存账户
                            if (data.is_null == 1) {
                                console.log('开通预存账户');
                                OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                                    // 获取成功
                                    if (data.result == 1) {
                                        $ionicLoading.hide();
                                        $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                        $scope.vpApply.name = data.data.PATIENT_NAME;
                                        $scope.vpApply.phone_num = data.data.PHONENUM;
                                        $scope.vpApply.address = data.data.ADDRESS;
                                        $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                        $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                        $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                        $scope.vpApply.is_self = data.data.IS_SELF;
                                        $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                        // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0 直接提交
                                        $scope.vpApply.id_type = data.data.ID_TYPE;
                                        // 2023-7-19 09:01:07 HM 婚姻情况
                                        $scope.vpApply.marital = data.data.MARITAL;

                                        if ($scope.vpApply.id_type == '0') {
                                            $scope.applyCardType = 2;
                                            $scope.submitCardApply();
                                        }
                                        else {
                                            // 显示办卡提示
                                            var applyCardPopup = $ionicPopup.show({
                                                title: '注意',
                                                template: "患者预存账户未开通，请上传身份证开通预存账户",
                                                buttons: [{
                                                    text: '确定',
                                                    type: 'button-positive',
                                                    onTap: function (e) {
                                                        applyCardPopup.close();
                                                        // 不加timeout popup关不掉
                                                        $timeout(function () {
                                                            $scope.applyCardShow(2);
                                                        }, 0);
                                                    }
                                                }]
                                            });
                                        }
                                    }
                                    // 获取失败
                                    else {
                                        $ionicLoading.hide();
                                        $fwCordovaToast.showShortBottom(data.msg);
                                    }
                                })
                                return;
                            }
                            // 门诊预存账户余额为负数
                            else if (data.is_null == 2) {
                                $fwCordovaToast.showShortBottom(data.msg);
                                $ionicLoading.hide();
                                return;
                            }

                            // 已开通预存账户
                            console.log(data.data);
                            // 2020-2-21 11:42:11 HM 输入密码了要
                            $scope.vpId = $scope.vpSelect.VISIT_PATIENT_ID;
                            $scope.isLoadFinish = false;
                            $scope.getDrugList();
                        }
                        else {
                            $ionicLoading.hide();
                        }
                    })
                }
                // 未绑卡
                else {
                    $ionicLoading.show();
                    // 获取办卡状态
                    OpRegService.patientCheck($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                        // 获取成功
                        if (data.result == 1) {
                            // 无卡 --> 办卡
                            if (data.is_null == 1) {
                                console.log('无卡: ' + data.msg);
                                // 弹个提示 只支持复诊患者
                                $ionicLoading.hide();
                                $fwCordovaToast.showLongBottom("复诊续方仅限我院复诊患者使用");
                            }
                            // 一张卡 --> 下一步
                            else if (data.is_null == 0) {
                                console.log('一张卡: ' + data.msg);
                                // 没绑卡的 后台已经自动半绑卡/半绑卡的也在这
                                // 获取requestid
                                $scope.requestId = data.requestId;
                                VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, data.data).then(function (result) {
                                    $ionicLoading.hide();
                                    if (result.result == 1) {
                                        // 拿到了手机号+卡号
                                        var phone = result.phone_num;
                                        var card_num = result.card_num;

                                        if (phone == "" || card_num == "") {
                                            $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                                        }
                                        else {
                                            // 手机号
                                            $scope.vpBind.phone_num = phone;
                                            // 卡号
                                            $scope.vpBind.card_num = card_num;

                                            // 带*手机号
                                            $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                                            // 带*卡号
                                            $scope.vpBind.card_num_show = result.card_num_show;

                                            $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;

                                            // 获取图片验证码
                                            $scope.getImageVericode();
                                            $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                                            $scope.bindCardModal.show();
                                        }
                                    }
                                    else {
                                        $fwCordovaToast.showShortBottom(result.msg);
                                    }
                                })
                            }
                            // 多张卡 --> 绑卡
                            else if (data.is_null == 2) {
                                console.log('多张卡: ' + data.msg);
                                $scope.requestId = data.requestId;
                                // 未绑卡状态 => 多卡 => 半绑，用过his_card_num => 不选了，绑它
                                if ($scope.vpSelect.IS_BIND_CARD == "2" && $scope.vpSelect.HIS_CARD_NUM != "") {
                                    VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, $scope.vpSelect.HIS_CARD_NUM).then(function (result) {
                                        $ionicLoading.hide();
                                        if (result.result == 1) {
                                            // 拿到了手机号+卡号
                                            var phone = result.phone_num;
                                            var card_num = result.card_num;

                                            if (phone == "" || card_num == "") {
                                                $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                                            }
                                            else {
                                                // 手机号
                                                $scope.vpBind.phone_num = phone;
                                                // 卡号
                                                $scope.vpBind.card_num = card_num;

                                                // 带*手机号
                                                $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                                                // 带*卡号
                                                $scope.vpBind.card_num_show = result.card_num_show;

                                                $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;

                                                // 获取图片验证码
                                                $scope.getImageVericode();
                                                $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                                                $scope.bindCardModal.show();
                                            }
                                        }
                                        else {
                                            $fwCordovaToast.showShortBottom(result.msg);
                                        }
                                    })
                                }
                                else {
                                    $ionicLoading.hide();
                                    $scope.cardList = data.data;
                                    // 多卡提示
                                    $ionicPopup.alert({
                                        title: '提示',
                                        template: data.msg,
                                        okText: "确定"
                                    }).then(function () {
                                        $scope.chooseCardModalShow();
                                    });
                                }
                            }
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                            }
                        }
                        // 获取错误
                        else {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误,请稍后重试");
                        }
                    }, function () {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                    })
                }
            }
            else {
                $fwCordovaToast.showShortBottom(dataLimit.msg);
                return;
            }
        })
        // 初始化变量
        $scope.isPatientMI = false;
        $scope.MI =
        {
            REQUESTID: '',
            NOTICE: '',
            HELP: '',
            MI_PATIENT_CODE: '',
            MI_PATIENT_IMG_URL: '',
            MI_IMG_URL: ''
        };
    }

    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if ($scope.vpNew.idCardType == 5) {
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text + '不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.log($scope.vpList);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        })
    }

    // 提交建卡申请
    $scope.submitCardApply = function () {
        // 格式化手机号
        $scope.formatPhone();
        if ($scope.applyCardType == 1) {
            // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
            // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
            var isAddrFormat = false;
            // 现住址不为空-老流程填的，放过，走后边验证
            if ($scope.vpApply.address != '') {
                isAddrFormat = false;
            }
            // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
            else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
                isAddrFormat = true;
                $scope.vpApply.address = '';
                var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
                $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
                var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
                $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
                var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
                $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
                $scope.vpApply.address += $scope.vpApply.address_detail;
            }
            // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
            else {
                $fwCordovaToast.showShortBottom('请完整填写现住址信息');
                return false;
            }
            if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
                || ($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                    || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))
                || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
            // 2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
            var addressByteSize = getStringByteSize($scope.vpApply.address);
            //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
            // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
            if (isAddrFormat && addressByteSize > 40) {
                $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
                addressByteSize = getStringByteSize($scope.vpApply.address);
            }
            else if (addressByteSize <= 10 || addressByteSize > 40) {
                var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: msgStr,
                    okText: '确定'
                }).then(function () {
                });
                return false;
            }
        } else if ($scope.applyCardType == 2) {
            if (($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
        }
        $ionicLoading.show();
        // 提交建卡申请
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type, $scope.vpApply.marital).then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                // data == 1 --> 建卡成功
                if (data.data == 1) {
                    $scope.applyCardHide();     // 隐藏绑定页面
                    $scope.loadVpList();            // 重新获取患者信息
                    //$scope.toSlide(2);
                    if ($scope.applyCardType == 1) {
                        $fwCordovaToast.showShortBottom('在线建档成功');
                    } else if ($scope.applyCardType == 2) {
                        $fwCordovaToast.showShortBottom('开通预存账户成功');
                        // 2020-2-21 11:42:38 HM 开通预存账户成功，直接输入密码
                        $scope.vpId = $scope.vpSelect.VISIT_PATIENT_ID;
                        $scope.isLoadFinish = false;
                        $scope.getDrugList();
                    }
                }
                // data == 0 --> 建卡失败
                else if (data.data == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }
            // 获取失败
            else if (data.result == 99) {
                $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
            } else {
                // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                //$fwCordovaToast.showShortBottom(data.msg);
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: '确定'
                });
            }
            $ionicLoading.hide();
        })
    }

    // 格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 办卡模态窗口显示
    $scope.applyCardShow = function (type) {
        // 复用办卡模态窗口，用于未开通预存患者上传身份证
        if (type == undefined) {
            $scope.applyCardType = 1;
        } else {
            $scope.applyCardType = type;
        }
        $scope.applyCardModal.show();
    }

    // 办卡模态窗口隐藏
    $scope.applyCardHide = function () {
        $scope.applyCardModal.hide();
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '',
            marital: 0
        }
    }

    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.vpNew.idCardType = $scope.idCardTypeList[0].id;
        $scope.addVisitPatientModal.show();
    }

    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }

    // 多卡选择绑卡模态窗口显示
    $scope.bindCardSelectShow = function () {
        $scope.bindCardSelectModal.show();
    }

    // 多卡选择绑卡模态窗口隐藏
    $scope.bindCardSelectHide = function () {
        $scope.bindCardSelectModal.hide();
    }

    // 新增 选卡部分
    $scope.chooseCardModalShow = function () {
        $scope.chooseCardModal.show();
    }
    $scope.chooseCardModalHide = function () {
        $scope.chooseCardModal.hide();
    }

    // 绑卡模态窗口隐藏
    $scope.bindCardModalHide = function () {
        $scope.bindCardModal.hide();
        $scope.timespan = 0;
        $scope.vpBind = {
            name: '',
            card_num: '',
            card_num_show: '',
            phone_num: null,
            phone_num_show: '',
            veri_code: '',
            patient_id: '',
            is_self: 0
        };

        if ($scope.lastSelectCard) {
            $scope.chooseCardModalShow();
        }
    }

    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿, type == -1 --> 正面医保卡照片, type == -2 --> 手持医保卡照片,
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }

    // 删除身份证照片
    $scope.deleteImg = function (type) {
        // confirm
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 50,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        //var uri = encodeURI("http://10.10.101.11:8080/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);

        // 2020-3-5 10:58:30 HM 医保验证
        if (type == -1 || type == -2) {
            options.params = { urlExt: "CASE_PRINT", ifDES: "1" };
            uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        }

        // 显示上传等待
        $ionicLoading.show();
        // 上传图片
        //$fwCordovaToast.showShortBottom(uri);
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            //$cordovaToast.showLongBottom(angular.toJson(result));
            //console.log(result);
            //console.log(result.response);
            if (type == 0 || type == 1 || type == 2) {
                var fileResult = {};
                eval("fileResult = " + result.response);
                $ionicLoading.hide();
                // 上传成功
                if (fileResult.result == 1) {
                    $fwCordovaToast.showShortBottom("上传成功");
                    // 头像面
                    if (type == 0) {
                        $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                    }
                    // 国徽面
                    else if (type == 1) {
                        $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                    }
                    // 户口簿
                    else if (type == 2) {
                        $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                    }
                }
                // 上传失败
                else {
                    $fwCordovaToast.showShortBottom(fileResult.msg);
                }
            }
            // 医保验证
            else if (type == -1 || type == -2) {
                if (result.response == undefined) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom("上传失败");
                }
                else {
                    if (result.response.indexOf('上传失败') >= 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom(result.response);
                    }
                    else {
                        $ionicLoading.hide();
                        if (type == -1) {
                            $scope.MI.MI_IMG_URL = result.response;
                        }
                        else {
                            $scope.MI.MI_PATIENT_IMG_URL = result.response;
                        }
                    }
                }
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }

    // 选择就诊卡
    $scope.selectCard = function (index) {
        if (index != $scope.cardSelectIndex && index < $scope.cardList.length) {
            $scope.cardSelectIndex = index;
        }
    }

    // 多卡选择绑卡提交
    $scope.bindCardSelectSubmit = function () {
        if ($scope.cardSelectIndex >= $scope.cardList.length || $scope.cardList[$scope.cardSelectIndex] == null
            || $scope.cardList[$scope.cardSelectIndex].PATIENT_ID == null || $scope.cardList[$scope.cardSelectIndex].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }
        $ionicLoading.show();
        var vpId = $scope.vpSelect.VISIT_PATIENT_ID;
        VisitPatientService.bindPatientCardSelect(vpId, $scope.cardList[$scope.cardSelectIndex].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }
            else {
                //$fwCordovaToast.showShortBottom('就诊卡绑定成功');
                $fwCordovaToast.showShortBottom(data.msg);
                // 获取就诊人列表
                VisitPatientService.visitPatientList().then(function (data) {
                    // 获取成功
                    if (data.result == 1) {
                        $scope.vpList = data.data;
                        console.log($scope.vpList);
                        // 重新选择就诊人 检查预存账户状态
                        var vpListFilter = $scope.vpList.filter(e => e.VISIT_PATIENT_ID == vpId);
                        var vpTemp = vpListFilter.length > 0 ? vpListFilter[0] : null;
                        var index = $scope.vpList.indexOf(vpTemp);
                        console.log(index);
                        $ionicLoading.hide();
                        $scope.selectVp(index);
                        // 隐藏绑定页面
                        $scope.bindCardSelectHide();
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                    }
                })
            }
        })
    }

    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function (vpId, phone, card_num, imageVericode) {
        // 验证图片验证码
        if (imageVericode == null || imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }

        $ionicLoading.show();
        RequestService.checkPatientCard(vpId, card_num, phone).then(function (data) {
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，" + data.msg);
                return;
            }
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，未找到相应患者信息");
                return;
            }

            // patient_id赋值
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            // 就诊卡绑定 => 验证码：5
            $scope.getMsgVericode(phone, '5', imageVericode);
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 2018.1.8 获取短信验证码 带参数
    $scope.getMsgVericode = function (phoneNum, num, imgVericode) {
        AccountService.sendVericodeByPhone(phoneNum, num, imgVericode).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");

                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            else {
                $scope.getImageVericode();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败 回滚
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwcordovaToast.showShortTop("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 绑卡 2018.12.29 绑卡 => 自动开通电子就诊卡
    $scope.bindCardSubmit = function () {
        if (!$scope.checkCardNum()) {
            return false;
        }

        if ($scope.vpBind.patient_id == '') {
            $fwCordovaToast.showShortBottom('缺失患者id');
            return false;
        }

        if ($scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请选择患者身份');
            return false;
        }

        VisitPatientService.bindVisitPatient($scope.vpSelect.VISIT_PATIENT_ID, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self, true).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                // 隐藏绑定页面
                $scope.bindCardModalHide();

                // 如果来自选卡：隐藏选卡页面 
                if ($scope.lastSelectCard) {
                    $scope.chooseCardModalHide();
                }
                //$scope.loadVpList();         // 重新获取患者信息

                // 2020-3-7 11:11:48 HM 重新选择就诊人 检查预存账户状态,等一下患者列表
                // 就诊人列表
                $ionicLoading.show();
                VisitPatientService.visitPatientList().then(function (data) {
                    // 获取成功
                    if (data.result == 1) {
                        $scope.vpList = data.data;
                        console.log($scope.vpList);
                        var vpId = $scope.vpSelect.VISIT_PATIENT_ID;
                        var vpListFilter = $scope.vpList.filter(e => e.VISIT_PATIENT_ID == vpId);
                        var vpTemp = vpListFilter.length > 0 ? vpListFilter[0] : null;
                        var index = $scope.vpList.indexOf(vpTemp);
                        console.log(index);
                        $scope.selectVp(index);
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                })
                // TODO
                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
        })
    }

    // 20190930 新增：选择这张卡
    $scope.bindThisCard = function (index) {
        $ionicPopup.confirm({
            title: '选择绑卡确认',
            template: '是否绑定此就诊卡?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                bindCardSelectSubmit(index);
            }
            else { }
        });
    }

    // 20190930 新增：选卡=>绑它
    bindCardSelectSubmit = function (index) {
        if (index < 0 || index >= $scope.cardList.length || $scope.cardList[index] == null
            || $scope.cardList[index].PATIENT_ID == null || $scope.cardList[index].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardSelectV2($scope.vpSelect.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 这里出来是半绑卡状态
                VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (result) {
                    $ionicLoading.hide();
                    if (result.result == 1) {
                        // 拿到了手机号+卡号
                        var phone = result.phone_num;
                        var card_num = result.card_num;

                        if (phone == "" || card_num == "") {
                            $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                        }
                        else {
                            // 手机号
                            $scope.vpBind.phone_num = phone;
                            // 卡号
                            $scope.vpBind.card_num = card_num;

                            // 带*手机号
                            $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                            // 带*卡号
                            $scope.vpBind.card_num_show = result.card_num_show;

                            $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;

                            // 获取图片验证码
                            $scope.getImageVericode();
                            $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");

                            // 上一步是选卡
                            $scope.lastSelectCard = true;
                            // 选卡模态窗关闭
                            $scope.chooseCardModalHide();
                            // 绑卡 开
                            $scope.bindCardModal.show();
                        }
                    }
                })
            }
        })
    }

    // #endregion

    // 读取药品列表
    $scope.getDrugList = function () {
        $scope.drugList = [];
        // 2021-10-25 13:37:55 HM #46516 初诊患者可以开检查，这里先发一个开药请求，让患者能过去，这步做成同步的
        OlTreatRecipeService.getOpDrugReq($scope.vpId, localStorage.queryToken).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 发线下就诊记录id，这步是个异步的
                OlTreatRecipeService.getLastOpInfo($scope.vpId).then(function (dataOpInfo) {
                    $ionicLoading.hide();
                    if (dataOpInfo.result == 0) {
                        $fwCordovaToast.showShortBottom(dataOpInfo.msg);
                    }
                    else {
                        $scope.opDrugRequestId = data.data;
                        $scope.toSlide(2);
                        $scope.lastOpRequestId = dataOpInfo.data;
                    }
                }, function (dataOpInfo) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(dataOpInfo.msg);
                });
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 读取检查检验项目列表
    $scope.getCheckList = function () {
        $scope.checkList = [];
        OlTreatRecipeService.getCheckList().then(function (data) {
            if (data.result == 1) {
                $scope.checkList = data.data;
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                return;
            }
        })
    }

    // 整理药品列表
    $scope.formatDrugList = function (list) {
        // 默认选择门诊的
        $scope.chooseRecipe = "OP";

        var opFlag = false;
        var ipFlag = false;

        list.forEach(e => {
            e.SELECTED = false;
            e.DAYS_TO_SUBMIT = Number(e.MED_DAYS);
            e.DAYS_MAX = Number(e.MAX_MED_DAYS);

            // 把初始化赋值放在这里
            // 如果有出院的药，才进行赋值
            if (e.DRUG_TYPE == "IP" && $scope.chooseRecipe != "IP") {
                $scope.chooseRecipe = e.DRUG_TYPE;
            }

            if (e.DRUG_TYPE == "OP") {
                opFlag = true;
            }
            if (e.DRUG_TYPE == "IP") {
                ipFlag = true;
            }
        });

        $scope.checkChooseRecipeStatus = opFlag && ipFlag;
        $scope.drugList = list;
    }

    // 整理检查检验列表列表
    $scope.formatCheckList = function (list) {
        list.forEach(e => {
            e.SELECTED = false;
        });
        $scope.checkList = list;
    }

    // 修改开药天数
    $scope.changeDrugDays = function (index, delta) {
        if (index < 0 || index >= $scope.drugList.length) {
            return;
        }
        // 保留老数据 供验证回滚使用
        var oldVal = $scope.drugList[index].DAYS_TO_SUBMIT;
        $scope.drugList[index].DAYS_TO_SUBMIT += delta;
        $scope.checkDrugDays(index, oldVal);
    }

    // 验证开药天数
    $scope.checkDrugDays = function (index, oldVal) {
        if (index < 0 || index >= $scope.drugList.length) {
            return false;
        }
        console.log(oldVal + " => " + $scope.drugList[index].DAYS_TO_SUBMIT);
        if ($scope.drugList[index].DAYS_TO_SUBMIT == null || $scope.drugList[index].DAYS_TO_SUBMIT < 0 || $scope.drugList[index].DAYS_TO_SUBMIT % 1 != 0) {
            $scope.drugList[index].DAYS_TO_SUBMIT = oldVal;
            $fwCordovaToast.showLongBottom($scope.drugList[index].DRUG_NAME + "的开药天数必须是（1 - " + $scope.drugList[index].MAX_MED_DAYS + "）之间的整数");
            return false;
        }
        if ($scope.drugList[index].DAYS_TO_SUBMIT < 1) {
            $scope.drugList[index].DAYS_TO_SUBMIT = 1;
            $fwCordovaToast.showLongBottom($scope.drugList[index].DRUG_NAME + "的开药天数最少为 1 天");
            return false;
        }
        if ($scope.drugList[index].DAYS_TO_SUBMIT > $scope.drugList[index].DAYS_MAX) {
            $scope.drugList[index].DAYS_TO_SUBMIT = $scope.drugList[index].DAYS_MAX;
            $fwCordovaToast.showLongBottom($scope.drugList[index].DRUG_NAME + "的开药天数最多为 " + $scope.drugList[index].MAX_MED_DAYS + " 天");
            return false;
        }
    }

    function loadFinish() {
        $ionicLoading.hide();
        $scope.isLoadFinish = true;
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid;
        $scope.vpInfo = new Object();
        $scope.loadVPInfo();
        $scope.getDrugList();
        $scope.popVplist.hide();
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 医保验证
    $scope.checkMI = function () {
        $ionicLoading.show();
        // 改一下，直接去内网查是不是医保
        RequestService.checkMI($scope.vpId).then(function (dataMI) {
            loadFinish();
            if (dataMI.result == 1) {
                $scope.MI.REQUESTID = dataMI.requestId;
                $scope.MI.NOTICE = dataMI.descr;
                $scope.MI.HELP = dataMI.help;
                // 是医保患者
                if (dataMI.isMI == "1") {
                    console.log("是医保患者");
                    $scope.isPatientMI = true;
                }
                // 不是医保患者，就得走自费了
                else {
                    console.log("不医保患者");
                    $scope.isPatientMI = false;
                }

                $scope.conditionConfirmShow();
            }
            // 报错了
            else {
                $fwCordovaToast.showShortBottom(dataMI.msg);
            }
        });
    }

    // 医保部分提交
    $scope.addMIPatientInfo = function () {
        $ionicLoading.show();
        // 2024-2-22 11:09:17 ZZL hzfwx-714 三代医保卡升级，$scope.MI.MI_PATIENT_CODE改成默认传""
        //var miCode = document.getElementById("miCode").value;
        //$scope.MI.MI_PATIENT_CODE = miCode;
        OlTreatRecipeService.addMIPatientInfo($scope.vpId, $scope.MI.REQUESTID, $scope.isPatientMI, $scope.MI.MI_PATIENT_CODE, $scope.MI.MI_IMG_URL, $scope.MI.MI_PATIENT_IMG_URL).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 1) {
                // 保存成功，进入下一页
                $scope.uploadMIHide();

                // 2020-8-4 19:22:23 HM 医保部分提交挪到了后边，直接提交
                $scope.submitApplyCommon();
            }
            // 这里应该是 院内医保号 != 患者手输入号
            else {
                $fwCordovaToast.showShortBottom(result.msg);
            }
        })
    }

    // 删除图片
    $scope.detUrl = function (index) {
        // url清空
        if (index == -1) {
            $scope.MI.MI_IMG_URL = "";
        }
        else {
            $scope.MI.MI_PATIENT_IMG_URL = "";
        }
    }

    // 上传医保卡部分
    $scope.uploadMIShow = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        $scope.uploadMIModal.show();
    }
    $scope.uploadMIHide = function () {
        $scope.uploadMIModal.hide();
    }

    // 帮助相关
    $scope.MIHelpModalShow = function () {
        $scope.MIHelpModal.show();
    }
    $scope.MIHelpModalHide = function () {
        $scope.MIHelpModal.hide();
    }

    // 确认病情
    $scope.submitCondition = function () {
        if ($scope.isCondition == -1) {
            $ionicPopup.alert({
                title: "提示",
                template: "请您确认病情是否有变化",
                okText: "确定"
            }).then(function (res) {
                console.log("请您确认病情是否有变化");
            });
        }
        else if ($scope.isCondition == 1) {
            $ionicPopup.alert({
                title: "提示",
                template: "请您来我院进行线下就诊",
                okText: "确定"
            }).then(function (res) {
                console.log("请您来我院进行线下就诊");
            });
        }
        else if ($scope.currentArea.code == "") {
            $ionicPopup.alert({
                title: "提示",
                template: "请选择行政区划",
                okText: "确定"
            }).then(function (res) {
                console.log("请选择行政区划");
            });
        }
        else {
            $scope.agent.TREAT_AGENT_ID = "";
            $scope.conditionConfirmHide();

            // 等0.5s再跳吧
            $timeout(function () {
                // 先过滤一下，出院带药还是门诊处方
                $scope.drugList = $scope.drugList.filter(function (x) {
                    return x.DRUG_TYPE == $scope.chooseRecipe;
                })

                // 如果当前是第二页（选择方式），跳到选药品第三页
                if ($scope.step == 2) {
                    $scope.toSlide(3);
                }
                // 如果当前是第四页（选检查），跳转到药品第五页
                else if ($scope.step == 4) {
                    $scope.toSlide(5);
                }
            }, 500);
        }
        $scope.agent.TREAT_AGENT_ID = "";
    }

    // 确认病情相关
    $scope.conditionConfirmShow = function () {
        $scope.opDrugList = $scope.drugList.filter(function (x) {
            return x.DRUG_TYPE == "OP";
        });

        $scope.ipDrugList = $scope.drugList.filter(function (x) {
            return x.DRUG_TYPE == "IP";
        });

        $scope.conditionConfirmModal.show();
    }
    $scope.conditionConfirmHide = function () {
        $scope.conditionConfirmModal.hide();
    }

    // 切换changeRadio
    $scope.changeRadio = function (key, value) {
        if (key == 'isCondition') {
            $scope.isCondition = value;
        }
        if (key == 'isSelf') {
            $scope.isSelf = value;
        }
        // 重新计算高度
        $ionicScrollDelegate.resize();
    }

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'olTreatRecipe');

        // 检查在线开药开关
        OlTreatRecipeService.checkServerStatus().then(function (data) {
            // 开放
            if (isOlTreatRecipe || data.result == 1) {
                // 获取配置
                OlTreatRecipeService.getConfig().then(function (data) {
                    // 查询成功
                    if (data.result == 1) {
                        $scope.agreement.olTreatRecipeDescr = data.data.olTreatRecipeDescr;
                        $scope.isServerOn = true;
                        $scope.deliveryMIText = data.data.deliveryMI;
                        $scope.deliveryBYText = data.data.deliveryBY;

                        // 2020-3-25 10:26:10 HM 增加自费患者免责声明
                        $scope.byStatement.content = data.data.byStatementContent;
                        $scope.byStatement.title = data.data.byStatementTitle;

                        // 2020-3-27 09:13:33 HM 增加医保患者免责声明
                        $scope.miStatement.content = data.data.miStatementContent;
                        $scope.miStatement.title = data.data.miStatementTitle;

                        // 2020-4-24 16:12:50 HM 增加药品快递到家免责申明
                        $scope.expressStatement.content = data.data.expressStatementContent;
                        $scope.expressStatement.title = data.data.expressStatementTitle;

                        // 2020-6-1 13:43:30 HM 增加复诊续方知情同意书
                        $scope.informedConsent.content = data.data.informedConsentContent;
                        $scope.informedConsent.title = data.data.informedConsentTitle;

                        // 2020-4-17 14:45:37 HM 增加医保处方外延申请前确认信息
                        $scope.miConfirmContent = data.data.miConfirmContent;

                        // 2020-6-11 14:08:26 HM 增加行政区划数组
                        $scope.currentAreaList = data.data.currentAreaList;
                    }
                    // 查询失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                    }
                })
            }
            // 关闭
            else if (data.result == -99) {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.isServerOn = false;
                $scope.serverStatusDescr = data.msg;
                $scope.agreement.olTreatRecipeDescr = data.msg;
                $ionicLoading.hide();
            }
            // 异常
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                $scope.isServerOn = false;
                $ionicLoading.hide();
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            $scope.isServerOn = false;
            $ionicLoading.hide();
        })
    });

    // 切换选择
    $scope.switchSelected = function (index) {
        if ($scope.step == 3) {
            if (index < 0 || index >= $scope.drugList.length) {
                return;
            }
            // 药品是否可选
            if ($scope.isItemEnable(index)) {
                $scope.drugList[index].SELECTED = !$scope.drugList[index].SELECTED;
            }
            else {
                $fwCordovaToast.showLongBottom($scope.drugList[index].REMARKS);
            }
        }
        else if ($scope.step == 4) {
            $scope.checkList[index].SELECTED = !$scope.checkList[index].SELECTED;
        }
        else if ($scope.step == 5) {
            if ($scope.treatStep == "recipe") {
                $scope.checkList[index].SELECTED = !$scope.checkList[index].SELECTED;
            }
            else if ($scope.treatStep == "check") {
                if (index < 0 || index >= $scope.drugList.length) {
                    return;
                }
                // 药品是否可选
                if ($scope.isItemEnable(index)) {
                    $scope.drugList[index].SELECTED = !$scope.drugList[index].SELECTED;
                }
                else {
                    $fwCordovaToast.showShortBottom($scope.drugList[index].REMARKS);
                }
            }
        }
    }

    // 处方是否可选
    $scope.isItemEnable = function (index) {
        // 备注为""
        return $scope.drugList[index].REMARKS == "";
    }

    // 检查开药申请
    $scope.checkApply = function () {
        $ionicLoading.show();
        var checkNum = "";
        $scope.checkList.filter(e => e.SELECTED).forEach(e => {
            checkNum += "," + e.CHECK_ITEM_ID;
        });

        var recipeNum = "";
        var checkResult = true;
        var outSoldDrugName = "";
        $scope.drugList.filter(e => e.SELECTED).forEach(e => {
            // 验证开药天数
            console.log(e.DRUG_NAME + ": " + e.DRUG_ID + "-" + e.RECIPE_ID + "@" + e.DAYS_TO_SUBMIT);
            if (e.DAYS_TO_SUBMIT == null || e.DAYS_TO_SUBMIT < 0 || e.DAYS_TO_SUBMIT % 1 != 0) {
                //$fwCordovaToast.showShortBottom(e.DRUG_NAME + "的开药天数必须是（1 - " + e.MAX_MED_DAYS + "）之间的整数");
                checkResult = false;
                return false;
            }
            if (e.DAYS_TO_SUBMIT < 1) {
                //e.DAYS_TO_SUBMIT = 1;
                //$fwCordovaToast.showShortBottom(e.DRUG_NAME + "的开药天数最少为 1 天");
                checkResult = false;
                return false;
            }
            if (e.DAYS_TO_SUBMIT > e.DAYS_MAX) {
                //e.DAYS_TO_SUBMIT = e.DAYS_MAX;
                //$fwCordovaToast.showShortBottom(e.DRUG_NAME + "的开药天数最多为 " + e.MAX_MED_DAYS + " 天");
                checkResult = false;
                return false;
            }
            recipeNum += "," + e.DRUG_ID + "-" + e.RECIPE_ID + "@" + e.DAYS_TO_SUBMIT;

            for (var i = 0; i < $scope.outSoldDrugList.length; i++) {
                if (e.DRUG_ID == $scope.outSoldDrugList[i]) {
                    outSoldDrugName += e.DRUG_NAME + "，";
                }
            }
        });
        if (!checkResult) {
            $ionicLoading.hide();
            return false;;
        }
        recipeNum = recipeNum.substr(1);
        checkNum = checkNum.substr(1);
        if (outSoldDrugName != "") {
            outSoldDrugName = outSoldDrugName.substr(0, outSoldDrugName.length - 1);
            $scope.outSoldMsgTmpl = $scope.outSoldMsgTmpl.replace("xxx", outSoldDrugName);
        }

        // 第3页，当前页是药品，要跳转到检查那边去
        if ($scope.step == 3) {
            if (recipeNum == "") {
                $fwCordovaToast.showShortBottom("请选择药品及开药天数");
                $ionicLoading.hide();
                return false;
            }

            if (outSoldDrugName != "") {
                $ionicLoading.hide();
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: $scope.outSoldMsgTmpl,
                    cancelText: '不同意',
                    okText: '同意'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        $ionicLoading.show();
                        $scope.checkApplyCommon(recipeNum, checkNum);
                    }
                })
            }
            else {
                $scope.checkApplyCommon(recipeNum, checkNum);
            }
        }

        // 第4页，当前页是检查，要跳到药品，那边去
        if ($scope.step == 4) {
            if (checkNum == "") {
                $fwCordovaToast.showShortBottom("请选择检查检测项目");
                $ionicLoading.hide();
                return false;
            }

            OlTreatRecipeService.checkApply($scope.vpId, recipeNum, checkNum, $scope.chooseRecipe).then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    // 轮询成功
                    if (data.checkResult == 1) {
                        $scope.prescriptionInfo.applyCheckId = data.applyCheckId;

                        OlTreatRecipeService.checkRecipe(recipeNum, checkNum, $scope.isPatientMI, $scope.vpId, $scope.opDrugRequestId).then(function (dataRepice) {
                            if (dataRepice.result == 1) {
                                // 判断药品状态，主要是用于后面展示不展示物流配送
                                if (dataRepice.data.drugStatus == 1) {
                                    $scope.deliveryShow = true;
                                }
                                else {
                                    $scope.deliveryShow = false;
                                }

                                // 判断快递状态，主要是用于后面展示药品快递到家
                                if (dataRepice.data.experssStatus == 1) {
                                    $scope.experssShow = true;
                                }
                                else {
                                    $scope.experssShow = false;
                                }

                                // 疫情提示
                                $scope.ncpTip = dataRepice.data.ncpTip;

                                // 获取药品结果
                                OlTreatRecipeService.getOpDrugResp($scope.opDrugRequestId).then(function (data) {
                                    if ((data.result == -1 && data.is_null != -1) || data.is_null != 1) {
                                        $scope.formatDrugList(data.data);
                                        $scope.outSoldMsgTmpl = data.outSoldMsgTmpl;
                                        $scope.outSoldDrugList = data.outSoldIDAList;

                                        // 还得获取个医保信息
                                        RequestService.checkMI($scope.vpId).then(function (dataMI) {
                                            $ionicLoading.hide();
                                            if (dataMI.result == 1) {
                                                $scope.MI.REQUESTID = dataMI.requestId;
                                                $scope.MI.NOTICE = dataMI.descr;
                                                $scope.MI.HELP = dataMI.help;
                                                // 是医保患者
                                                if (dataMI.isMI == "1") {
                                                    console.log("是医保患者");
                                                    $scope.isPatientMI = true;
                                                }
                                                // 不是医保患者，就得走自费了
                                                else {
                                                    console.log("不医保患者");
                                                    $scope.isPatientMI = false;
                                                }

                                                // 2023-8-31 15:46:57 HM 从方法选择那边进来，按说都应该验证过资质延长和线下就诊记录了，这里不用再走请求了
                                                var confirmPopup = $ionicPopup.confirm({
                                                    title: "您是否需要继续开具处方药品",
                                                    cancelText: '跳过',
                                                    okText: '继续'
                                                });
                                                // 继续, 跳转
                                                confirmPopup.then(function (res) {
                                                    $scope.treatStep = "check";
                                                    if (res) {
                                                        $scope.conditionConfirmShow();
                                                    }
                                                    else {
                                                        $scope.fromStep = 4;
                                                        $scope.toSlide(6);
                                                    }
                                                })
                                            }
                                            // 报错了
                                            else {
                                                $fwCordovaToast.showShortBottom(dataMI.msg);
                                            }
                                        }, function (dataRepice) {
                                            $ionicLoading.hide();
                                            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                                        })

                                        // 需要验证资质延长
                                        // 再获取请求结果，并验证是否有在线问诊资质延长资格
                                        // OlTreatRecipeService.checkOLCondition($scope.lastOpRequestId, $scope.vpId).then(function (checkData) {
                                        //     $ionicLoading.hide();
                                        //     // 允许使用复诊续方
                                        //     if (checkData.result == 1 && checkData.status == 1) {
                                        //         var confirmPopup = $ionicPopup.confirm({
                                        //             title: "您是否需要继续开具处方药品",
                                        //             cancelText: '跳过',
                                        //             okText: '继续'
                                        //         });
                                        //         // 继续, 跳转
                                        //         confirmPopup.then(function (res) {
                                        //             $scope.treatStep = "check";
                                        //             if (res) {
                                        //                 $scope.conditionConfirmShow();
                                        //             }
                                        //             else {
                                        //                 $scope.fromStep = 4;
                                        //                 $scope.toSlide(6);
                                        //             }
                                        //         })
                                        //     }
                                        //     else {
                                        //         $scope.fromStep = 4;
                                        //         $scope.toSlide(6);
                                        //     }
                                        // }, function (checkData) {
                                        //     $ionicLoading.hide();
                                        //     $fwCordovaToast.showShortBottom(checkData.msg);
                                        // })
                                    }
                                    else {
                                        $ionicLoading.hide();
                                        $scope.fromStep = 4;
                                        $scope.toSlide(6);
                                    }
                                });
                            }
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(dataRepice.msg);
                            }
                        }, function (dataRepice) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(dataRepice.msg);
                        })
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }
                // 超时
                else if (data.result == 99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
                }
                // 获取失败
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function (data) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            })
        }

        if ($scope.step == 5 && $scope.treatStep == "recipe") {
            $scope.treatStepCommon(recipeNum, checkNum);
        }

        // 先选的检查，再选的药
        if ($scope.step == 5 && $scope.treatStep == "check") {
            if (outSoldDrugName != "") {
                $ionicLoading.hide();
                var confirmPopup = $ionicPopup.confirm({
                    title: "提示",
                    template: $scope.outSoldMsgTmpl,
                    cancelText: '不同意',
                    okText: '同意'
                });
                // 继续, 跳转
                confirmPopup.then(function (res) {
                    if (res) {
                        $ionicLoading.show();
                        $scope.treatStepCommon(recipeNum, checkNum);
                    }
                })
            }
            else {
                $scope.treatStepCommon(recipeNum, checkNum);
            }
        }
    }

    // 公共跳转
    $scope.treatStepCommon = function (recipeNum, checkNum) {
        OlTreatRecipeService.checkApply($scope.vpId, recipeNum, checkNum, $scope.chooseRecipe).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 轮询成功
                if (data.checkResult == 1) {
                    $scope.prescriptionInfo.applyCheckId = data.applyCheckId;

                    OlTreatRecipeService.checkRecipe(recipeNum, checkNum, $scope.isPatientMI, $scope.vpId, $scope.opDrugRequestId).then(function (dataRepice) {
                        $ionicLoading.hide();
                        if (dataRepice.result == 1) {
                            // 判断药品状态，主要是用于后面展示不展示物流配送
                            if (dataRepice.data.drugStatus == 1) {
                                $scope.deliveryShow = true;
                            }
                            else {
                                $scope.deliveryShow = false;
                            }

                            // 判断快递状态，主要是用于后面展示药品快递到家
                            if (dataRepice.data.experssStatus == 1) {
                                $scope.experssShow = true;
                            }
                            else {
                                $scope.experssShow = false;
                            }

                            // 疫情提示
                            $scope.ncpTip = dataRepice.data.ncpTip;

                            $scope.fromStep = 5;
                            $scope.toSlide(6);
                        }
                        else {
                            $fwCordovaToast.showShortBottom(dataRepice.msg);
                        }
                    }, function (dataRepice) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(dataRepice.msg);
                    })
                }
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }
            // 超时
            else if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
            }
            // 获取失败
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 公共跳转
    $scope.checkApplyCommon = function (recipeNum, checkNum) {
        OlTreatRecipeService.checkApply($scope.vpId, recipeNum, checkNum, $scope.chooseRecipe).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 轮询成功
                if (data.checkResult == 1) {
                    $scope.prescriptionInfo.applyCheckId = data.applyCheckId;

                    OlTreatRecipeService.checkRecipe(recipeNum, checkNum, $scope.isPatientMI, $scope.vpId, $scope.opDrugRequestId).then(function (dataRepice) {
                        $ionicLoading.hide();
                        // 获取成功
                        if (dataRepice.result == 1) {
                            // 判断药品状态，主要是用于后面展示不展示物流配送
                            if (dataRepice.data.drugStatus == 1) {
                                $scope.deliveryShow = true;
                            }
                            else {
                                $scope.deliveryShow = false;
                            }

                            // 判断快递状态，主要是用于后面展示药品快递到家
                            if (dataRepice.data.experssStatus == 1) {
                                $scope.experssShow = true;
                            }
                            else {
                                $scope.experssShow = false;
                            }

                            // 疫情提示
                            $scope.ncpTip = dataRepice.data.ncpTip;

                            // 2023-8-31 15:46:57 HM 从方法选择那边进来，按说都应该验证过资质延长和线下就诊记录了，这里不用再走请求了
                            var confirmPopup = $ionicPopup.confirm({
                                title: "您是否需要继续开具检查检验项目",
                                cancelText: '跳过',
                                okText: '继续'
                            });
                            // 继续, 跳转
                            confirmPopup.then(function (res) {
                                $scope.treatStep = "recipe";
                                if (res) {
                                    $scope.toSlide(5);
                                }
                                else {
                                    $scope.fromStep = 3;
                                    $scope.toSlide(6);
                                }
                            })

                            // 2023-4-23 13:47:50 HM 验证是否有门诊就诊记录
                            //OlTreatRecipeService.respLastOpInfoNew($scope.lastOpRequestId, "olTreatCheck").then(function (dataOpInfo) {
                            //    $ionicLoading.hide();
                            //    if (dataOpInfo.result == 99) {
                            //        $scope.fromStep = 3;
                            //        $scope.toSlide(6);
                            //        return;
                            //    }

                            //    if (dataOpInfo.is_null == 1) {
                            //        $scope.fromStep = 3;
                            //        $scope.toSlide(6);
                            //        return;
                            //    }

                            //    if (dataOpInfo.data == null || dataOpInfo.data.length == []) {
                            //        $scope.fromStep = 3;
                            //        $scope.toSlide(6);
                            //        return;
                            //    }

                            //    var confirmPopup = $ionicPopup.confirm({
                            //        title: "您是否需要继续开具检查检验项目",
                            //        cancelText: '跳过',
                            //        okText: '继续'
                            //    });
                            //    // 继续, 跳转
                            //    confirmPopup.then(function (res) {
                            //        $scope.treatStep = "recipe";
                            //        if (res) {
                            //            $scope.toSlide(5);
                            //        }
                            //        else {
                            //            $scope.fromStep = 3;
                            //            $scope.toSlide(6);
                            //        }
                            //    })
                            //}, function () {
                            //    $ionicLoading.hide();
                            //    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                            //})
                        }
                        else {
                            $fwCordovaToast.showShortBottom(dataRepice.msg);
                        }
                    }, function (dataRepice) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(dataRepice.msg);
                    })
                }
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(data.msg);
                }
            }
            // 超时
            else if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
            }
            // 获取失败
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 选择取药方式
    $scope.switchTakeMedWay = function (way) {
        $scope.prescriptionInfo.takeMedWay = way;

        if (way == 3) {
            var alertPopup = $ionicPopup.alert({
                title: "提示",
                template: "快递到家患者药品邮费需自付",
                okText: '确定'
            });
            // 继续, 跳转
            alertPopup.then(function (res) {
                if (res) {
                }
            })
        }
        $ionicScrollDelegate.resize();
    }

    // 提交开药申请step1
    $scope.submitApply = function () {
        if ($scope.prescriptionInfo.takeMedWay == 0) {
            $fwCordovaToast.showShortBottom("请选择取药方式");
            return;
        }

        // 2020-4-17 16:40:41 HM 增加医保患者处方外配申请确认
        if ($scope.prescriptionInfo.takeMedWay == 2 && $scope.isPatientMI) {
            var confirmPopup = $ionicPopup.confirm({
                title: "提示",
                template: $scope.miConfirmContent,
                okText: '继续',
                cancelText: '取消'
            });
            // 继续, 跳转
            confirmPopup.then(function (res) {
                if (res) {
                    // 2020-8-4 19:17:26 HM 在这验证是否需要上传医保卡
                    $ionicLoading.show();
                    OlTreatRecipeService.needCheckMI($scope.vpId, $scope.MI.REQUESTID, "OlTreat").then(function (data) {
                        $ionicLoading.hide();
                        // 提示上传照片
                        if (data.result == 1) {
                            $scope.uploadMIShow();
                        }
                        // 已上传，无需再次上传
                        else if (data.result == 2) {
                            $scope.submitApplyCommon();
                        }
                        // 不开启医保结算，一律按自费处理
                        else if (data.result == -1) {
                            $scope.isPatientMI = false;
                            $scope.submitApplyCommon();
                        }
                        // 报错了
                        else {
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                    })
                }
            })
        }
        // 2022-4-13 08:47:51 HM 来院取药病情有疫情提示
        else if ($scope.prescriptionInfo.takeMedWay == 1 && $scope.ncpTip != "") {
            var alertPopup = $ionicPopup.alert({
                title: "提示",
                template: $scope.ncpTip,
                okText: '确认'
            });
            // 继续, 跳转
            alertPopup.then(function (res) {
                if (res) {
                    $scope.submitApplyCommon();
                }
            })
        }
        else {
            $scope.submitApplyCommon();
        }
    }

    // 提交开药申请step2
    $scope.submitApplyCommon = function () {
        $ionicLoading.show();
        OlTreatRecipeService.submitApply($scope.prescriptionInfo.applyCheckId, $scope.prescriptionInfo.takeMedWay, $scope.agent.TREAT_AGENT_ID, $scope.currentArea.code).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.prescriptionInfo.applyId = data.data;

                // 不收费
                if (data.payStatus == 0) {
                    OlTreatRecipeService.getSubmitApply($scope.prescriptionInfo.applyId).then(function (dataResp) {
                        $ionicLoading.hide();
                        console.log("轮询结果：" + JSON.stringify(dataResp));
                        //获取成功
                        if (dataResp.result == 1) {
                            // 轮询成功
                            if (dataResp.applyResult == 1) {

                                // 判断是否开启视频，需要视频，调视频，不需要视频直接进入会话页
                                if (data.videoStatus) {
                                    // 调视频
                                    $state.go('app.videoCall');
                                }
                                else {
                                    // 获取申请会话
                                    $scope.getApplyConvr();
                                }
                            }
                            else {
                                $fwCordovaToast.showShortBottom(dataResp.msg);
                            }
                        }
                        else if (dataResp.result == 99) {
                            $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
                        }
                        // 获取失败
                        else {
                            $fwCordovaToast.showShortBottom(dataResp.msg);
                        }
                    }, function (dataResp) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom(dataResp.msg);
                    })
                }
                // 收费
                else {
                    // 医师代码
                    var doctorCode = data.doctorCode;
                    var fee = data.fee;

                    $ionicLoading.hide();

                    // 收银台
                    $scope.cashier("olTreat", fee, $scope.vpId, $scope.prescriptionInfo.applyId, "", "", doctorCode, $scope.isPatientMI, "", "", fee).then(function (dataCashier) {
                        // 支付成功 获取订单状态
                        if (dataCashier.code == 1) {
                            $ionicLoading.show();
                            OlTreatRecipeService.getSubmitApply($scope.prescriptionInfo.applyId).then(function (dataResp) {
                                $ionicLoading.hide();
                                //轮询成功
                                if (dataResp.result == 1) {
                                    // 轮询成功
                                    if (dataResp.applyResult == 1) {
                                        // 判断是否开启视频，需要视频，调视频，不需要视频直接进入会话页
                                        if (data.videoStatus) {
                                            // 调视频
                                            $state.go('app.videoCall');
                                        }
                                        else {
                                            // 获取申请会话
                                            $scope.getApplyConvr();
                                        }
                                    }
                                    else {
                                        $fwCordovaToast.showShortBottom(dataResp.msg);
                                    }
                                }
                                else if (dataResp.result == 99) {
                                    $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
                                }
                                // 获取失败
                                else {
                                    $fwCordovaToast.showShortBottom(dataResp.msg);
                                }
                            }, function (dataResp) {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(dataResp.msg);
                            })
                        }
                        else {
                            // 去列表页面
                            $scope.goOlTreatRecipeList();
                        }
                    })
                }
            }
            // 获取失败
            else {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: "提示",
                    template: data.msg,
                    okText: "确认"
                });
            }
        }, function (data) {
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: "提示",
                template: data.msg,
                okText: "确认"
            });
        })
    }

    // 获取申请会话
    $scope.getApplyConvr = function () {
        $ionicLoading.show();
        OlTreatRecipeService.getApplyConvr($scope.prescriptionInfo.applyId).then(function (data) {
            $ionicLoading.hide();
            // 获取成功
            if (data.result == 1) {
                console.log(data.data);
                $scope.prescriptionInfo.apply = data.data.apply;
                $scope.prescriptionInfo.convrList = data.data.convrList;
                $scope.prescriptionInfo.recipeList = data.data.recipeList;
                $scope.prescriptionInfo.checkList = data.data.checkList;
                $scope.toSlide(7);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 日期格式化
    $scope.getDateFormat = function (strDate, format) {
        return new Date(strDate.replace(/-/g, '/')).Format(format);
    }

    // 跳转到列表页
    $scope.goOlTreatRecipeList = function () {
        $state.go('app.olTreatRecipeList', { status: '0', from: 'app.olTreatRecipe' });
    }

    // 自费弹出模态框事件
    $scope.statementShow = function (index) {
        if (index == 1) {
            $scope.statement.title = $scope.byStatement.title;
            $scope.statement.content = $scope.byStatement.content;
        }
        else if (index == 2) {
            $scope.statement.title = $scope.miStatement.title;
            $scope.statement.content = $scope.miStatement.content;
        }
        else if (index == 4) {
            $scope.statement.title = $scope.informedConsent.title;
            $scope.statement.content = $scope.informedConsent.content;
        }
        else {
            $scope.statement.title = $scope.expressStatement.title;
            $scope.statement.content = $scope.expressStatement.content;
        }

        $scope.statementModal.show();
    }

    $scope.statementHide = function () {
        $scope.statementModal.hide();
        $ionicScrollDelegate.scrollTop();
    }

    // 复诊续方，资质延长判断
    $scope.checkOLCondition = function () {
        console.log("2再拿资质延长");
        $ionicLoading.show();
        // 再获取请求结果，并验证是否有在线问诊资质延长资格
        OlTreatRecipeService.checkOLCondition($scope.lastOpRequestId, $scope.vpId).then(function (checkData) {
            console.log(checkData);
            if (checkData.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(checkData.msg);
                return;
            }

            if (checkData.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }

            if (checkData.result == 1) {
                loadFinish();
                // 允许使用复诊续方
                if (checkData.status == 1) {
                    // 2023-8-31 15:26:53 HM 不往下走了，如果是药的话，再走这个逻辑
                    if ($scope.chooseTypeData == 2) {
                        // 如果开的检查，这里走原来的逻辑，这里直接往下走
                        $scope.toSlide(4);
                    }
                    else {
                        $scope.checkMI();
                    }
                }
                // 引导患者进入预约挂号
                else if (checkData.status == 2) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "提示",
                        template: checkData.msg,
                        okText: '预约挂号',
                        cancelText: '取消',
                    });
                    // 继续, 跳转
                    confirmPopup.then(function (res) {
                        if (res) {
                            $state.go("app.opAppt");
                        }
                    })
                }
                // 引导患者进入在线问诊资质延长
                else if (checkData.status == 3) {
                    var html = "<div>";
                    html += "<p>" + checkData.titleMsg + "</p>";

                    // 预约挂号
                    html += "<div style='display: flex;padding-bottom: 1em;'>";
                    html += "<div style='width: calc(100% - 4em)'>" + checkData.opApptMsg + "</div>";
                    html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
                    html += "<button class='button button-small button-calm' ng-click='stateGo(1);' style='max-height: 4em;line-height: 1.5em;'>";
                    html += "<span style='font-size:14px;'>预约挂号</span>";
                    html += "</button>";
                    html += "</div>";
                    html += "</div>";

                    // 视频问诊
                    html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;padding-bottom: 1em;'>";
                    html += "<div style='width: calc(100% - 4em)'>" + checkData.olTreatVideoMsg + "</div>";
                    html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
                    html += "<button class='button button-small button-calm' ng-click='stateGo(2);' style='max-height: 4em;line-height: 1.5em;'>";
                    html += "<span style='font-size:14px;'>视频问诊</span>";
                    html += "</button>";
                    html += "</div>";
                    html += "</div>";

                    // 在线延长
                    // 2023-4-28 14:15:44 CGZ 发布前跟郭雨辰确认，“在线延长”改为“延长资质”
                    html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;'>";
                    html += "<div style='width: calc(100% - 4em)'>" + checkData.byTreatConditionMsg + "</div>";
                    html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
                    html += "<button class='button button-small button-calm' ng-click='stateGo(3);' style='max-height: 4em;line-height: 1.5em;'>";
                    html += "<span style='font-size:14px;'>延长资质</span>";
                    html += "</button>";
                    html += "</div>";
                    html += "</div>";

                    // 客服咨询
                    // 2023年11月16日09:59:31 gx 复诊续方弹出提示框新增客服咨询 #hzfwx-332
                    html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;'>";
                    html += "<div style='width: calc(100% - 4em)'>" + checkData.customerMsg + "</div>";
                    html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
                    html += "<button class='button button-small button-calm' ng-click='stateGo(4);' style='max-height: 4em;line-height: 1.5em;'>";
                    html += "<span style='font-size:14px;'>客服咨询</span>";
                    html += "</button>";
                    html += "</div>";
                    html += "</div>";

                    html += "</div>";

                    $scope.confirmPopup = $ionicPopup.alert({
                        title: "提示",
                        template: html,
                        buttons: [
                            {
                                text: "取消",
                                onTap: function (e) { }
                            }
                        ],
                        scope: $scope
                    });

                    // 注释上边的代码，还原下边的代码，走原路径

                    //var confirmPopup = $ionicPopup.confirm({
                    //    title: "提示",
                    //    template: checkData.msg,
                    //    okText: '在线延长',
                    //    cancelText: '取消'
                    //});
                    //// 继续, 跳转
                    //confirmPopup.then(function (res) {
                    //    if (res) {
                    //        $state.go("app.consultation", {vpid: $scope.vpId, from: "olCondition"});
                    //    }
                    //})
                }
                // 有进行中的会话，调易复诊SDK
                else if (checkData.status == 0) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: "提示",
                        title: checkData.msg,
                        cancelText: '取消',
                        okText: '进入'
                    });
                    // 进入会话，调用易复诊SDK
                    confirmPopup.then(function (res) {
                        if (res) {
                            // 调易复诊SDK
                            if (checkData.data.IM_TYPE == "1") {
                                var param = {
                                    accountSourceId: checkData.data.ACCOUNT_ID,
                                    accountId: checkData.data.VISIT_PATIENT_ID,
                                    patientName: checkData.data.VISIT_PATIENT_NAME,
                                    patientSex: checkData.data.SEX == '1' ? "男" : "女",
                                    patientBirthday: checkData.data.BIRTHDAY.slice(0, 10),
                                    patientHeadPic: checkData.data.HEAD_PIC,
                                    patientPhoneNo: checkData.data.PHONE_NUM,
                                    doctorId: checkData.data.DOCTOR_CODE, // 四位医师代码
                                    doctorEmployeeCardNo: checkData.data.STAFF_NUMBER, // 胸卡号
                                    hospitalOrderId: checkData.data.TREAT_APPLY_ID,
                                    fuzhen: "0"
                                };

                                var funcSuccess = function (funcData) {
                                    console.log('百洋：toChat 调用成功');
                                    console.log(funcData);
                                }

                                var funcError = function (funcData) {
                                    console.log('百洋：toChat 调用失败');
                                    console.log(funcData);
                                }
                                // 2023-10-07 11:09:00 CGZ 移除道一巡和易复诊插件
                                //window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                            }
                            // 调腾讯SDK
                            else {
                                var param = { type: "chat", param: checkData.data.IM_URL };

                                var funcSuccess = function (data) {
                                    console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                                    console.log(data);
                                }
                                var funcError = function (data) {
                                    console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                                    console.log(data);
                                }

                                window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
                            }
                        }
                    })
                }
            }
            else {
                loadFinish();
                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                return;
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 跳转
    $scope.stateGo = function (type) {
        $scope.confirmPopup.close();

        $timeout(function () {
            if (type == 1) {
                $state.go("app.opAppt");
            }
            else if (type == 2) {
                $state.go("app.consultation", { vpid: $scope.vpId });
            }
            else if (type == 3) {
                $state.go("app.consultation", { vpid: $scope.vpId, from: "olCondition" });
            }
            else if (type == 4) {
                $state.go("app.consultation", { vpid: $scope.vpId, from: "customer" });
            }
        }, 500);
    }

    // 选择类型
    $scope.chooseType = function (type) {
        // 2023-8-31 15:23:57 HM 记录一下这个type，后续的方法，需要用到
        $scope.chooseTypeData = type;

        // 开药
        if (type == 1) {
            if ($scope.opDrugRequestId == "" || $scope.lastOpRequestId == "") {
                $fwCordovaToast.showShortBottom("连接超时，请重试");
            }
            else {
                // 获取药品结果
                $ionicLoading.show();
                console.log("1先拿药");
                OlTreatRecipeService.getOpDrugResp($scope.opDrugRequestId).then(function (data) {
                    if (data.result == 99) {    // 链接超时
                        loadFinish();
                        $fwCordovaToast.showShortBottom("连接超时，请重试");
                        return;
                    }
                    if (data.result == -2) {    // 需要输入查询密码
                        loadFinish();
                        $scope.chooseType(1);
                        return;
                    }
                    if (data.result != 1 && data.result != -1) {  // 请求错误
                        loadFinish();
                        $fwCordovaToast.showShortBottom(data.msg);
                        return;
                    }
                    if (data.result == -1) {        // 请求缓存
                        $timeout(function () {
                            if (data.is_null != 1) {
                                $scope.formatDrugList(data.data);
                                $scope.checkOLCondition();
                                $scope.outSoldMsgTmpl = data.outSoldMsgTmpl;
                                $scope.outSoldDrugList = data.outSoldIDAList;
                            }
                            else {
                                loadFinish();
                            }
                        }, 1500);
                    }
                    if (data.is_null != 1) {
                        $scope.formatDrugList(data.data);
                        $scope.checkOLCondition();
                        $scope.outSoldMsgTmpl = data.outSoldMsgTmpl;
                        $scope.outSoldDrugList = data.outSoldIDAList;
                    } else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        loadFinish();
                    }
                });
            }
        }
        // 开检查
        else {
            $scope.checkOLCondition();

            // 2023-4-23 13:47:50 HM 验证是否有门诊就诊记录
            //$ionicLoading.show();
            //OlTreatRecipeService.respLastOpInfoNew($scope.lastOpRequestId, "olTreatCheck").then(function (data) {
            //    $ionicLoading.hide();
            //    if (data.result == 99) {
            //        $fwCordovaToast.showShortBottom("网络超时，请稍后重试");
            //        return;
            //    }

            //    if (data.is_null == 1) {
            //        $fwCordovaToast.showShortBottom("仅允许半年内有门诊挂号就诊记录患者申请");
            //        return;
            //    }

            //    if (data.data == null || data.data.length == []) {
            //        $fwCordovaToast.showShortBottom("仅允许半年内有门诊挂号就诊记录患者申请");
            //        return;
            //    }

            //    loadFinish();
            //    $scope.toSlide(4);
            //}, function () {
            //    $ionicLoading.hide();
            //    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
            //})
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOlTreatRecipe.enableSlide(false);
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 第一就诊人
                var vpid = "";
                var vpidSelf = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                    if (vpidSelf == "" && data.data[i].IS_SELF == "1") {
                        vpidSelf = data.data[i].VISIT_PATIENT_ID;
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    // 2018-9-18 17:33:31 改为本人
                    $scope.vpId = vpidSelf;
                }
                else {
                    $scope.loadVPInfo();
                }

                // 开启用户须知倒计时
                $interval(function () {
                    $scope.confirmCountdown -= 1;
                }, 1000, 10);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });

        //设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if (data.result == 1) {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证"}];
        //    }
        //});

        // 2020-9-18 09:15:35 HM 增加了资质延长后，感觉选择就诊人请求太多了，故整理一下
        $scope.getCheckList();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();
    })

    // 本人数量
    $scope.calcSelf = function () {
        var count = $scope.vpList.filter(e => e.IS_SELF == "1").length;
        return count;
    }

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'olTreatRecipe') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 判断是否有选择
    $scope.hasSelect = function (index) {
        if (index == 1) {
            return $scope.drugList.filter(e => e["SELECTED"] == true).length > 0;
        }

        if (index == 2) {
            return $scope.checkList.filter(e => e["SELECTED"] == true).length > 0;
        }
    }

    // 选择药品类型
    $scope.chooseRecipeType = function (params) {
        $scope.chooseRecipe = params;
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
})
