﻿angular.module('fwapp.controllers')

// 视频问诊
.controller('OlTreatVideoController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
, ConsultationService, RequestService, OlTreatRecipeService, ExpressService, ReportService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义视频问诊滑块
    var slideOlTreatVideo = $ionicSlideBoxDelegate.$getByHandle('slideOlTreatVideo');
    // 初始滑块状态
    $scope.step = -1;
    // 传进来的applyId
    $scope.applyId = $stateParams.treatApplyId;
    // 传进来的vpId
    $scope.vpId = $stateParams.vpId;
    // 支付页面对象
    $scope.payData = {};
    // 倒计时
    $scope.payTimeLeftVideo = 0;
    // 是否加载完成
    $scope.isLoadFinish = false;
    // 定时器关闭
    $scope.timerStop = false;
    // 会话列表
    $scope.chatList = [];
    // 药品快递到家同意须知
    $scope.expressStatement = new Object();
    $scope.expressStatement.agree = false;
    $scope.expressStatement.content = "";
    $scope.expressStatement.title = "";
    // 图文上传信息
    $scope.imgServerUrl = uploadUrl;
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);
    // 快递信息
    $scope.orderRoute = new Object();
    // 医保信息
    $scope.MI = {};
    $scope.isPatientMI = false;

    // #region 滑动方法

    // 滑到上一步
    $scope.lastSlide = function () {
        slideOlTreatVideo.previous();
        $scope.step = slideOlTreatVideo.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideOlTreatVideo.next();
        $scope.step = slideOlTreatVideo.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOlTreatVideo.slide(index);
        $scope.step = slideOlTreatVideo.currentIndex();
        console.log("toSlide =>" + index);
    }

    // #endregion

    // #region 模态框相关

    // 注册模态窗口 查看病情描述
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('infomation.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationModal = modal;
    });

    // 注册模态窗口 免责声明
    $ionicModal.fromTemplateUrl('statement.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.statementModal = modal;
    });

    // 注册模态窗口 互联网门诊病历
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultModal = modal;
    });

    // 注册模态窗口 查询快递信息
    $ionicModal.fromTemplateUrl('templates/expressInfo.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.expressInfoModal = modal;
    });

    // 注册模态窗口 上传医保卡
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('uploadMI.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.uploadMIModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.infomationModal.remove();
        $scope.statementModal.remove();
        $scope.checkResultModal.remove();
        $scope.expressInfoModal.remove();
        $scope.uploadMIModal.remove();
    })

    // 病情描述模态框展示
    $scope.infomationModalShow = function () {
        $scope.infomationModal.show();
    }

    // 病情描述模态框隐藏
    $scope.infomationModalHide = function () {
        $scope.infomationModal.hide();
    }

    // 免责声明模态框展示
    $scope.statementModalShow = function () {
        $scope.statementModal.show();
    }

    // 免责声明模态框隐藏
    $scope.statementModalHide = function () {
        $scope.statementModal.hide();
    }

    // 互联网门诊病历显示
    $scope.checkResultShow = function () {
        $scope.checkResultModal.show();
    }

    // 互联网门诊病历隐藏
    $scope.checkResultHide = function () {
        $scope.checkResultModal.hide();
    }

    // 查询快递信息窗口显示
    $scope.expressInfoShow = function () {
        $scope.expressInfoModal.show();
    }

    // 查询快递信息窗口关闭
    $scope.expressInfoHide = function () {
        $scope.expressInfoModal.hide();
    }

    // 上传医保卡显示
    $scope.uploadMIModalShow = function () {
        $scope.uploadMIModal.show();
    }

    // 上传医保卡隐藏
    $scope.uploadMIModalHide = function () {
        $scope.uploadMIModal.hide();
    }

    // #endregion

    // 1.加载页面
    $scope.loadTreatApply = function () {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        ConsultationService.loadTreatApply($scope.applyId, $scope.vpId).then(function (data) {
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                $scope.payData = data.data;
                $scope.toSlide(0);

                if ($scope.payData.miPatient == "1") {
                    $scope.isPatientMI = true;
                }
                else {
                    $scope.isPatientMI = false;
                }

                // 认后台一个开关，如果不是开的状态，当自费处理
                if ($scope.payData.olTreatVideoBJYBPayStatus != "1") {
                    $scope.isPatientMI = false;
                }

                // 未支付
                if ($scope.payData.payStatus == 0) {
                    // 获取支付时间限制
                    $scope.getTimeLimit();
                }
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }
    // #region 待支付及倒计时工具类
    // 获取支付时间限制
    $scope.getTimeLimit = function () {
        ConsultationService.getTimeLimitVideo($scope.applyId, "2").then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                $rootScope.payTimeLeftOlTreatVideo = data.data;
                if ($rootScope.payStatusOlTreatVideo != 1) {
                    $rootScope.payStatusOlTreatVideo = 1;
                }
                // 倒计时
                $scope.timerStop = true;
                $scope.timeCountdown();
            }
            else {
                $scope.timerStop = false;
                $rootScope.payStatusOlTreatVideo = 0;
                $rootScope.payTimeLeftOlTreatVideo = 0;
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 倒计时
    $scope.timeCountdown = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftOlTreatVideo = $rootScope.payTimeLeftOlTreatVideo - 1);
        } else {
            $rootScope.payTimeLeftOlTreatVideo = $rootScope.payTimeLeftOlTreatVideo - 1;
        }
        clearTimeout($rootScope.payResendTimeerOlTreatVideo);
        if ($rootScope.payTimeLeftOlTreatVideo > 0) {
            $rootScope.payResendTimeerOlTreatVideo = setTimeout($scope.timeCountdown, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusOlTreatVideo = 0);
            } else {
                $rootScope.payStatusOlTreatVideo = 0;
            }
        }
    }

    // #endregion

    // 1.1取消
    $scope.cancelApply = function () {
        $ionicLoading.show();
        ConsultationService.overTimeVideoApply($scope.applyId, $scope.vpId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else if (data.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络超时，请重试",
                    okText: "确定"
                });
            }
            // 有可能有1，有可能有2
            else {
                // 医保移动支付跳转
                if (data.ybUrl != "") {
                    // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
                    var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent(data.ybUrl));

                    //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                    //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
                    //2023.7.31 新插件原有调用方式参数不生效
                    showInAppBrowser(herfUrl, '_system');

                    // 注册个返回事件
                    document.addEventListener("resume", OnResumeYBCancel, false);
                }
                else {
                    $fwCordovaToast.showShortBottom("取消成功");

                    // 不管是退钱，还是不退钱，都直接goback
                    $scope.goBack();
                }

                // 重新获取时间
                $scope.getTimeLimit();
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络失败，请稍后再试",
                okText: "确定"
            });
        })
    }

    // app后台回到
    function OnResumeYBCancel() {
        setTimeout(function () {
            $scope.loadTreatApply();

            // 解绑后台唤醒事件监测
            document.removeEventListener("resume", OnResumeYBCancel, false);
        }, 1000);
    }

    // 2.手动取消
    $scope.cancelVideoApply = function () {
        $ionicPopup.confirm({
            title: "提示",
            template: "是否确认取消预约？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $scope.cancelApply();
            }
        })
    }

    // 3.立即支付
    $scope.unifiedOrder = function () {
        // 2022-6-13 10:01:51 HM 早上给李菲菲查数，发现了bug，视频问诊都按先自费处理，签到的时候，再分解。
        $scope.cashier("olTreat", $scope.payData.treatFeeNum, $scope.vpId, $scope.applyId, "", "", $scope.payData.doctorCode, $scope.isPatientMI, "", "", $scope.payData.treatFeeNum).then(function (dataCashier) {
            // 支付成功 获取订单状态
            if (dataCashier.code == 1) {
                // 等待支付轮询结果
                $scope.respApplyVideo($scope.applyId);
                // 重新获取支付时间
                $scope.getTimeLimit();
            }
        })
    }

    // 3.1验证支付状态，视频问诊
    $scope.respApplyVideo = function (applyId) {
        $ionicLoading.show();
        // 等待支付轮询结果
        OlTreatRecipeService.getSubmitApply(applyId).then(function (dataResp) {
            $ionicLoading.hide();
            //轮询成功
            if (dataResp.result == 1) {
                // 轮询成功
                if (dataResp.applyResult == 1) {
                    // 重新刷新页面
                    $scope.loadTreatApply();
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: dataResp.msg,
                        okText: "确定"
                    });
                }
            }
            else if (dataResp.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "服务繁忙，请稍后重试",
                    okText: "确定"
                });
            }
            // 获取失败
            else {
                $ionicPopup.alert({
                    title: '提示',
                    template: dataResp.msg,
                    okText: "确定"
                });
            }
        }, function (dataResp) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: dataResp.msg,
                okText: "确定"
            });
        })
    }

    // 4.退号操作
    $scope.signOutVideoApply = function () {
        $ionicPopup.confirm({
            title: "提示",
            template: "当前操作不可逆，是否确认取消预约？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                // 退号，退费
                $scope.cancelApply();
            }
        })
    }

    // 5.视频问诊签到
    $scope.videoSignIn = function () {
        $scope.MI = {};
        $ionicLoading.show();
        ConsultationService.videoSignIn($scope.vpId, $scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                // 2022-12-30 10:42:20 HM 如果是首信接口没认，让他重新上传医保卡照片
                if (data.resultSignIn == 2) {
                    $scope.MI.REQUESTID = "";// 这个字段可以为空，因为用了新版本了，后台API会走新的
                    $scope.MI.NOTICE = data.descr;
                    $scope.MI.HELP = data.help;
                    $scope.MI.VISIT_PATIENT_ID = $scope.vpId;
                    $scope.MI.URL_EXT = "OL_TREAT";
                    $scope.isPatientMI = true;

                    // 认后台一个开关，如果不是开的状态，当自费处理
                    // 其实这里不会走到，首信接口，李建改成拿身份证号验证了，不会走到这个分支了
                    if ($scope.payData.olTreatVideoBJYBPayStatus != "1") {
                        $scope.isPatientMI = false;
                    }

                    $scope.MI.IS_PATIENT_MI = true;

                    $ionicPopup.alert({
                        title: '提示',
                        template: data.verifyMsg,
                        okText: "确定"
                    }).then(function () {
                        $timeout(function () {
                            $scope.uploadMIShow();
                        }, 500);
                    });
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: "确定"
                    });
                }
            }
            else if (data.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络不佳，请重新进行签到",
                    okText: "确定"
                });
            }
            else {
                // 这里成功，可以用toast
                $fwCordovaToast.showShortBottom("签到成功");
                $scope.loadTreatApply();
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
        })
    }

    // 5.1 上传医保卡
    $scope.uploadMIShow = function () {
        var data = $scope.MI;
        $scope.uploadMIModalShow();
        $scope.$broadcast("uploadMIShow", data);
    }

    // 5.2 上传医保卡提交
    $scope.$on('uploadMIHide', function (event, data) {
        $scope.uploadMIModalHide();
        if (data.type == "submit") {
            console.log("成功了");
            // 上传完医保卡，再重新走签到
            $scope.videoSignIn();
        }
    })

    // 6.进入房间
    $scope.videoGetIntoRoom = function () {
        $ionicLoading.show();
        ConsultationService.videoGetIntoRoom($scope.vpId, $scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 进入视频
                var param = { roomId: data.data.ROOM_ID, applyId: data.data.TREAT_APPLY_ID, userId: $scope.vpId };

                var funcSuccess = function (data) {
                    console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                    console.log(data);
                }
                var funcError = function (data) {
                    console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                    console.log(data);
                }

                window.plugins.MiniProgramPlugin.launchMiniProgram(param, funcSuccess, funcError);
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
        })
    }

    // 7.查看诊疗资料
    $scope.treatApplyVdieoDetail = function (isSlide) {
        $scope.chatList = [];
        $ionicLoading.show();
        ConsultationService.getTreatApplyVideoConvr($scope.applyId).then(function (data) {
            $ionicLoading.hide();
            console.log(data);
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                $scope.chatList = data.data;
                if (isSlide == true) {
                    // 跳转到下一页
                    $scope.toSlide(1);
                }
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
        })
    }

    // 8.查看病情描述
    $scope.goInfomation = function () {
        var isSubmit = true;
        var schedDate = new Date($scope.payData.dateSched);
        var nowDate = new Date();
        if (nowDate.getTime() - schedDate.getTime() > 0) {
            isSubmit = false;
        }
        console.log(isSubmit);
        var data = {
            "infomationId": $scope.payData.infomationId,
            "vpId": $scope.vpId,
            "doctorCode": $scope.payData.doctorCode,
            "isSubmit": isSubmit,
            "treatType": 2
        };

        $scope.infomationModalShow();
        $scope.$broadcast("infomationShow", data);
    }

    // 8.1接收病情描述返回
    $scope.$on('infomationHide', function (event, data) {
        $scope.infomationModalHide();
        if (data.type == "submit") {
            console.log("成功了");
        }
    })

    // 9.知情同意
    $scope.toExpress = function (takeMedWay) {

        var html = "<p>请您认真阅读并同意<span style='color:blue;text-decoration:underline;' ng-click='statementShow()'><<" + $scope.expressStatement.title + ">></span><p>";

        $scope.popupConfirm = $ionicPopup.confirm({
            title: "提示",
            template: html,
            buttons: [
                {
                    text: "不同意",
                    onTap: function (e) { }
                },
                {
                    text: "同意",
                    type: "button-positive",
                    onTap: function (e) {
                        // 前端加个判断吧，如果不是3，说明还没落库，能少走一个ajax，直接跳转了
                        if (takeMedWay != "3") {
                            $scope.submitApply();
                        }
                        else {
                            $timeout(function () {
                                // 跳转到快递到家模块
                                $state.go("app.express", { applyId: $scope.applyId });
                            }, 500);
                        }
                    }
                }
            ],
            scope: $scope
        });
    }

    // 9.1展示须知内容
    $scope.statementShow = function () {
        $scope.popupConfirm.close();
        $scope.statementModalShow();
    }

    // 10.提交开药申请
    $scope.submitApply = function () {
        $ionicLoading.show();
        ConsultationService.confirmVideoMedWay($scope.applyId, $scope.vpId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 跳转到快递到家模块
                $state.go("app.express", { applyId: $scope.applyId });
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 11.检查缴费
    $scope.toOpPayment = function (rlatObjId) {
        // 跳转至门诊缴费
        $state.go("app.opPayment", { status: "0", vpid: $scope.vpId, from: "app.olTreatVideo", rlatObjId: rlatObjId });
    }

    // 12.查看门诊病历
    $scope.toOpRecord = function (idr, reportChatTime) {
        $scope.queryPassword().then(function (data) {
            if (data) {
                $scope.toOpRecordReq(idr, reportChatTime);
            }
        })
    }

    // 12.1创建手势控件
    // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            var src = $("#imgCheckResultOrigin").prop("src");
            // 防止赋值不同步
            if (src == "") {
                $timeout(function () {
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, 0);
                return;
            }
            // 无图片
            if ($("#imgCheckResult").length != 1) {
                return;
            }
            // 初始化
            if ($("#divCheckResult>#imgCheckResult").length == 0) {
                // 还原节点位置
                $("#divCheckResult").append($("#imgCheckResult"));
                // 删除控件
                //$("#divCheckResult .pinch-zoom-container").remove();
                // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
                $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            }
            // 复制图片路径
            $("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgCheckResult");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgCheckResult = new PinchZoom.default(img, zoomOptions);
            $scope.imgCheckResult.enable();
            console.log($scope.imgCheckResult);
        }, 0);
    }

    // 12.2查看门诊病历，走request
    $scope.toOpRecordReq = function (idr, reportChatTime) {
        // 走request
        $ionicLoading.show();
        RequestService.getNuClearList($scope.vpId, idr, "MZBL", localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请稍后重试",
                    okText: "确定"
                });
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.toOpRecordReq(idr, reportChatTime);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }

            $scope.checkResult = {
                INDEX: 0,
                REPORT_IMAGE: ''
            }
            // 清空图片
            $("#imgCheckResult").prop("src", "");
            // 释放内存
            delete $scope.imgCheckResult;
            $scope.imgCheckResult = {};

            // 有结果 显示base64图片
            $scope.checkResult.TITLE = "互联网门诊病历";
            $scope.checkResult.INDEX = 0;
            $scope.checkResult.REPORT_IMAGE = "data:image/png;base64," + data.data;

            // 2023-10-26 14:48:00 CGZ 保存reqId用于pdf文件下载，idr用于文件下载记录，报告消息时间用于拼接文件名
            $scope.reqId = data.reqId;
            $scope.reportId = idr;
            $scope.reportChatTime = reportChatTime;

            // 创建图片手势控件
            $scope.createPinchZoom();

            // 打开模态框
            $scope.checkResultShow();
        }, function (err) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 12.3下载PDF
    $scope.downloadPDF = function (reqId, index, checkResultType) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        if (reqId != null && reqId.length > 0) {
            var usage = "olRecord";
            // 2023-10-26 11:18:00 CGZ 文件名改为拼接报告时间/就诊时间，默认当前时间
            var strReportTime = new Date().Format("yyyyMMddhhmmss");
            if ($scope.reportChatTime != null && $scope.reportChatTime != '') {
                strReportTime = new Date(Date.parse($scope.reportChatTime)).Format("yyyyMMddhhmmss");
            }
            var fileName = "互联网门诊病历" + "_" + strReportTime;
            var fileId = $scope.reportId;
            var fileType = "PDF";
            var columnName = "REPORT_PDF";

            ReportService.saveDownloadRecord($scope.vpId, usage, reqId, fileName, fileType, fileId, columnName).then(function (data) {
                $scope.downloadId = data.downloadId;
                RequestService.downloadPDF(reqId, $scope.vpId, columnName, checkResultType, fileName).then(function (data) {
                    if (data.result == 1) {
                        ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 1);
                        var url = data.data;
                        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                        //$cordovaInAppBrowser.open(url, '_system', option).then(function (event) {});
                        //2023.7.31 新插件原有调用方式参数不生效
                        showInAppBrowser(url, '_system');
                        $scope.isLoadFinish = true;
                        $ionicLoading.hide();
                        return;
                    }
                    // 链接超时
                    else if (data.result == 99) {
                        ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 2);
                        $scope.isLoadFinish = true;
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("连接超时，请重试");
                        return;
                    } else {
                        ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 2);
                        $scope.isLoadFinish = true;
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        return;
                    }
                });
            })
        } else {
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
            return;
        }
    }

    // 13.查看物流信息
    $scope.toExpressInfo = function () {
        $ionicLoading.show();
        ExpressService.getOrderRoute($scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                $scope.orderRoute = data.data.Result;
                $scope.expressInfoShow();
            }
            else {
                $fwCordovaToast.showShortBottom("暂无快递信息");
            }
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取物流信息，网络错误。");
        })
    }

    // 14.查看处方信息（带签名）
    $scope.toDrugRecord = function () {
        $ionicLoading.show();
        OlTreatRecipeService.getDrugRecord($scope.vpId, $scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请稍后重试",
                    okText: "确定"
                });
                return;
            }

            if (data.result != 1 && data.result != -1) {  // 请求错误
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }

            $scope.checkResult = {
                INDEX: 0,
                REPORT_IMAGE: ''
            }
            // 清空图片
            $("#imgCheckResult").prop("src", "");
            // 释放内存
            delete $scope.imgCheckResult;
            $scope.imgCheckResult = {};

            // 有结果 显示base64图片
            $scope.checkResult.TITLE = "互联网门诊处方";
            $scope.checkResult.INDEX = 0;
            $scope.checkResult.REPORT_IMAGE = "data:image/png;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();

            // 打开模态框
            $scope.checkResultShow();
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("查看处方信息，网络错误。");
        })
    }

    // 15.入院登记
    $scope.toIpReg = function () {
        $state.go("app.ipReg");
    }

    // 16.满意度调查
    $scope.toSatis = function (apptType) {
        // 不是体检报告解读的   跳到普通满意度调查
        if (apptType != 4) {
            $state.go("app.satis", { status: 1 });
            // 是体检报告解读的，获取题，弹模态框
        } else {
            $state.go("app.examExplainReportSatis", { treatApplyId: $scope.applyId });
        }
    }

    // 返回
    $scope.goBack = function () {
        if ($scope.step == 1) {
            $scope.toSlide(0);
        }
        else {
            $state.go("app.consultationList", { treatType: "2" });
        }
    }

    // 页面切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        //$fwCordovaToast.showShortBottom("step: " + $scope.step);
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOlTreatVideo.enableSlide(false);
    });

    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'olTreatVideo');

        // 获取配置
        OlTreatRecipeService.getConfig().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                // 2020-4-24 16:12:50 HM 增加药品快递到家免责申明
                $scope.expressStatement.content = data.data.expressStatementContent;
                $scope.expressStatement.title = data.data.expressStatementTitle;

                $scope.loadTreatApply();
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }
        })
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'olTreatVideo') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
