﻿angular.module('fwapp.controllers')

.controller('OnlineArchivesController', function ($scope, $rootScope, $state, $stateParams, $q, $timeout, $sce, $window, $filter
, $ionicPopup, $ionicPopover, $ionicModal, $ionicLoading, $ionicPlatform, $ionicActionSheet, $ionicSlideBoxDelegate, $ionicScrollDelegate
, $cordovaToast, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaDatePicker, $fwCordovaToast
, VisitPatientService, OpRegService, AccountService, RequestService, TriageService, IpRegService) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义Slide控制
    var slideOnlineArchives = $ionicSlideBoxDelegate.$getByHandle('slideOnlineArchives');

    // 就诊人列表
    $scope.vpList = [];
    // 当前选择的就诊人
    $scope.vpInfo = new Object();

    // 二维码数组
    $scope.qrCodeSrc = [];
    // 条形码数组
    $scope.barCodeSrc = [];

    // 健康卡二维码数组
    $scope.healthQRCodeSrc = [];
    // 健康卡卡号数组
    $scope.healthCode = [];

    // 关系(本人、子女等)数组
    $scope.relative = [];

    // Slide计数
    $scope.step = 0;
    // timespan计数
    $scope.timespan = 0;

    // 背景颜色
    $scope.color = "#fff";
    // 标题名称
    $scope.name = "电子就诊卡";

    // 医保卡号提示
    $scope.MICodeHelp = "医保卡卡号位于卡片正面";

    // 添加就诊人模型
    $scope.vpNew = {
        realName: '',
        idCardCode: '',
        idCardType: '1',
        sex: '',
        birthday: ''
    };
    // 就诊卡绑定模型
    $scope.vpBind = {
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    // 2023-8-28 13:55:26 ZZL #hzfwx-107 现住址省市县字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 开通(申办)就诊卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '',
        insurance_type: 0,
        mi_patient_code: '',
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 开通电子就诊卡模型
    $scope.onlineCard = {
        phoneNum: null,
        phoneNumShow: null,
        messageVericode: '',
        imageVericode: ''
    }
    // 2021-4-22 20:07:58 电子就诊卡只显示条形码或二维码 避免同时出现两种码扫码窗扫不出来
    // 电子就诊卡 显示码类型 默认为条形码
    $scope.showCodeType = "bar";

    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};

    $scope.isLoadFinish = true;

    // 2020.03.02 补选卡
    // 换手机号/卡号用
    $scope.requestId = "";
    // 绑卡前一步是否来自选卡
    $scope.lastSelectCard = false;
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}

    //注册模态窗口

    // 模态窗口:添加就诊人
    $ionicModal.fromTemplateUrl('addVisitPatient.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });
    // 模态窗口:绑定就诊卡
    $ionicModal.fromTemplateUrl('bind_card.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });
    // 模态窗口:绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bind_card_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });
    // 模态窗口:开通电子就诊卡
    $ionicModal.fromTemplateUrl('onlineCardInfo.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.onlineCardInfoModal = modal;
    });
    // 模态窗口:开通就诊卡
    $ionicModal.fromTemplateUrl('applyCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.applyCardModal = modal;
    });
    // 20200302新增 注册模态窗口:选就诊卡
    $ionicModal.fromTemplateUrl('chooseCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.chooseCardModal = modal;
    });

    // 医保号帮助
    $ionicModal.fromTemplateUrl('MICode_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MICodeHelpModal = modal;
    });
    $scope.MICodeHelpModalShow = function () {
        $scope.MICodeHelpModal.show();
    }
    $scope.MICodeHelpModalHide = function () {
        $scope.MICodeHelpModal.hide();
    }

    // 页面的加载、销毁与切换
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用左右滑动
        slideOnlineArchives.enableSlide(false);
    });

    // 页面销毁(移除模态窗)
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.onlineCardInfoModal.remove();
        $scope.applyCardModal.remove();
        $scope.bindCardHelpModal.remove();
        // 新增：选卡
        $scope.chooseCardModal.remove();
        $scope.MICodeHelpModal.remove();
    })

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOnlineArchives.slide(index);
        $scope.step = slideOnlineArchives.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页 正常后退
        if ($scope.step == 0) {
            $state.go('app.home');
        }
        // 其他页返回上一个滑块
        else {
            $scope.changeSlideBack();
            //slideOnlineArchives.previous();
            $scope.step = slideOnlineArchives.currentIndex();
        }

    }
    // 切换滑块触发
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 2018.12.29 检查就诊卡状态
    $scope.checkPatientCardStatus = function (vp) {
        $scope.vpInfo = vp;
        // 1 => 已绑卡 => 拥有电子卡 => 显示
        if (vp.IS_BIND_CARD == '1') {
            // e1 => 正常显示
            if (vp.ECARD_STATUS == '1') {
                $scope.name = "电子就诊卡";
                $scope.color = "#79063f";
                $scope.toSlide(1);
            }
            // 无电子卡 => 开通
            else if (vp.ECARD_STATUS == null || vp.ECARD_STATUS == '0' || vp.ECARD_STATUS == '2') {
                $scope.GetReservedPhone(vp);
            }
            // e9 => 有电子卡 但未激活
            else if (vp.ECARD_STATUS == '9') {
                $fwCordovaToast.showShortBottom('请前往门诊大厅激活电子卡');
            }
        }
        // 0 => 未绑卡 OR 2 => 半绑卡 => 绑卡
        else if (vp.IS_BIND_CARD == null || vp.IS_BIND_CARD == '' || vp.IS_BIND_CARD == '0' || vp.IS_BIND_CARD == '2') {
            $scope.checkApplyCard(vp);
        }
        // 3 => 3/4绑卡 => 短信验证
        else if (vp.IS_BIND_CARD == '3') {
            $scope.GetReservedPhone(vp);
        }
        // 4 => 未激活
        else if (vp.IS_BIND_CARD == '4') {
            $fwCordovaToast.showShortBottom('请前往自助机激活就诊卡');
        }
    }

    // 2020.01 
    $scope.goEHealthCard = function () {
        $ionicLoading.show();
        // 电子健康卡 递归
        $scope.getHealthCardInfo(0);
    }

    // 1.去健康卡详细
    $scope.checkHealthCard = function (vpInfo) {
        if ($scope.healthQRCodeSrc[vpInfo.VISIT_PATIENT_ID] == undefined) {
            $fwCordovaToast.showShortBottom('数据加载，请稍后再试');
            return;
        }

        if (vpInfo.IS_BIND_CARD != "1" || vpInfo.HIS_CARD_NUM == '') {
            $fwCordovaToast.showShortBottom('非绑卡用户，暂不支持开通电子卡');
            return;
        }

        // 没有健康卡
        if ($scope.healthQRCodeSrc[vpInfo.VISIT_PATIENT_ID] == '') {
            $scope.getLastOpInfo(vpInfo);
        }
        // 有
        else {
            $scope.vpInfo = vpInfo;
            $scope.step = 3;
            $scope.toSlide($scope.step);
        }
    }

    // 2.获取健康卡code
    $scope.getHealthCardInfo = function (i) {
        var vpid = $scope.vpList[i].VISIT_PATIENT_ID;
        VisitPatientService.getHealthCardInfo(vpid).then(function (result) {
            // 报错
            if (result.result == 0) {
                $fwCordovaToast.showShortBottom(result.msg);
            }
            else {
                $scope.healthQRCodeSrc[vpid] = result.src;
                $scope.healthCode[vpid] = result.code;
            }

            i = i + 1;
            if (i < $scope.vpList.length) {
                $scope.getHealthCardInfo(i);
            }
            else {
                $ionicLoading.hide();
                $scope.name = "电子健康卡";
                $scope.step = 2;
                $scope.toSlide($scope.step);
            }
        });
    }

    // 3.获取上次就诊信息
    $scope.getLastOpInfo = function (vpInfo) {
        $ionicLoading.show();
        TriageService.getLastOpInfo(vpInfo.VISIT_PATIENT_ID).then(function (data) {
            // 成功
            if (data.result == 1) {
                $scope.requestId = data.data;
                $scope.hasRequestId = true;
            }
            // 缓存(噫...)
            else if (data.result == -1) {
                if (data.is_null == 1) {
                    $scope.requestId = data.data;
                }
                else {    // 原本data.data能直接用的，但是上次就诊信息返回特殊处理了
                    $scope.requestId = data.data[0].REQUEST_ID;
                }
                $scope.hasRequestId = true;
            }
            // 失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.hasRequestId = false;
            }

            if ($scope.hasRequestId) {
                // resp
                TriageService.respLastOpInfo($scope.requestId).then(function (data) {
                    // 已处理
                    if (data.result == 1) {
                        // 有
                        if (data.is_null == 0) {
                            // 弹是否开通电子健康卡
                            $scope.isApplyHealthCard(vpInfo);
                        }
                        // 无
                        else {
                            $fwCordovaToast.showShortBottom("非门诊就诊患者，暂不支持开通电子卡");
                        }
                    }
                    // 未处理
                    else {
                        $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                    }
                    $ionicLoading.hide();
                }, function (data) {
                    $ionicLoading.hide();
                })
            }
            else {
                $ionicLoading.hide();
            }
        }, function (data) {
            $ionicLoading.hide();
        })
    }

    // 4.二次窗口确定是否开通健康卡
    $scope.isApplyHealthCard = function (vpInfo) {
        $ionicPopup.confirm({
            title: '健康电子卡',
            template: '即将自动开通健康电子卡，是否确定?',
            okText: '确定',
            cancelText: '放弃'
        }).then(function (res) {
            if (res) {
                // 调接口 申请电子健康卡
                VisitPatientService.registerHealthCard(vpInfo.VISIT_PATIENT_ID).then(function (result) {
                    if (result.result == 0) {
                        $fwCordovaToast.showShortBottom(result.msg);
                    }
                    else {
                        // 二维码添进数组
                        $scope.healthQRCodeSrc[vpInfo.VISIT_PATIENT_ID] = result.src;
                        $scope.healthCode[vpInfo.VISIT_PATIENT_ID] = result.code;

                        $scope.vpInfo = vpInfo;
                        $scope.step = 3;
                        $scope.toSlide($scope.step);
                    }
                });
            }
        });
    }

    // 切换至二维码页
    $scope.changeSlideBack = function () {
        if ($scope.step == 0) {
        }
        else {
            $scope.name = "电子就诊卡";
            $scope.color = "#fff";
            $scope.toSlide(0);
        }
    }

    // 模态窗口的显示/隐藏
    // 模态窗口:添加就诊人 显示/隐藏
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = {
            realName: '',
            idCardCode: '',
            idCardType: '1',
            sex: '',
            birthday: ''
        };
        $scope.addVisitPatientModal.show();
    }
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = {
            realName: '',
            idCardCode: '',
            idCardType: '1',
            sex: '',
            birthday: ''
        };
    }
    // 模态窗口:绑定就诊卡 显示/隐藏
    $scope.bindCardModalShow = function (vp) {
        $scope.vpInfo = vp;
        $scope.getImageVericode();
        $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;
        $scope.bindCardModal.show();
    }
    $scope.bindCardModalHide = function () {
        $scope.bindCardModal.hide();
        $scope.timespan = 0;
        $scope.vpBind = {
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0
        };
    }
    // 模态窗口:绑卡帮助 显示/隐藏
    $scope.bindCardHelpModalShow = function () {
        $scope.bindCardHelpModal.show();
    }
    $scope.bindCardHelpModalHide = function () {
        $scope.bindCardHelpModal.hide();
    }
    // 模态窗口:开通电子就诊卡 显示/隐藏
    $scope.onlineCardInfoShow = function (vp) {
        $scope.vpInfo = vp;
        $scope.getImageVericode();
        $scope.onlineCardInfoModal.show();
    }
    $scope.onlineCardInfoHide = function () {
        $scope.onlineCardInfoModal.hide();
        $scope.timespan = 0;
        $scope.onlineCard = {
            phoneNum: null,
            phoneNumShow: null,
            messageVericode: '',
            imageVericode: ''
        }
    }
    // 2021-4-22 20:07:58 电子就诊卡只显示条形码或二维码 避免同时出现两种码扫码窗扫不出来
    // 切换显示码类型
    $scope.switchShowCodeType = function () {
        if ($scope.showCodeType == 'bar') {
            $scope.showCodeType = 'qr';
        }
        else {
            $scope.showCodeType = 'bar';
        }
    }
    // 模态窗口:在线建档 显示/隐藏
    $scope.applyCardShow = function () {
        $scope.applyCardModal.show();
    }
    $scope.applyCardHide = function () {
        $scope.applyCardModal.hide();
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '',
            insurance_type: 0,
            mi_patient_code: '',
            marital: 0
        }
    }

    // 新增模态窗口:选卡部分
    $scope.chooseCardModalShow = function () {
        $scope.chooseCardModal.show();
    }
    $scope.chooseCardModalHide = function () {
        $scope.chooseCardModal.hide();
    }

    // 填充就诊人列表
    $scope.loadVpList = function () {
        $scope.isLoadFinish = false;
        VisitPatientService.visitPatientList().then(function (data) {
            $scope.isLoadFinish = true;
            if (data.result == 1) {
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }
                else {
                    $scope.vpList = data.data;
                    for (var i = 0; i < $scope.vpList.length; i++) {
                        // 已绑卡 且 有FW电子卡 =>获取FW电子卡
                        if ($scope.vpList[i].IS_BIND_CARD == '1' && ($scope.vpList[i].ECARD_STATUS == '1' || $scope.vpList[i].ECARD_STATUS == '9')) {
                            $scope.getECardInfo($scope.vpList[i].VISIT_PATIENT_ID, $scope.vpList[i].HIS_CARD_NUM);
                        }
                    }
                }
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }
    // 获取ECard标识
    $scope.loadFlag = function () {
        VisitPatientService.getECardFlag().then(function (data) {
            console.log(data);
            if (data.result == 1) {
                $scope.ECardFlag = data.ECardFlag;
                $scope.applyCardFlag = data.applyCardFlag;
            }
        })
    }

    // 绑卡且开卡患者 获取电子卡数据
    $scope.getECardInfo = function (vpid, cardNum) {
        // 二维码
        VisitPatientService.onlineQRCardInfo(vpid, cardNum).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.qrCodeSrc[vpid] = "data:image/jpeg;base64," + data.data;
            }
        })
        // 条形码
        VisitPatientService.onlineCardInfo(vpid, cardNum).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.barCodeSrc[vpid] = "data:image/jpeg;base64," + data.data;
            }
        })
    }

    // 点击[+] 新添加就诊人
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if ($scope.vpNew.idCardType == 5) {
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text + '不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // 合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("添加就诊人成功");
                // 刷新就诊人列表(就诊人信息)
                $scope.loadVpList();
                // 判断身份证状态
                $scope.checkApplyCard(data.data);
                $scope.addVisitPatientHide();
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }

    // 格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 点击[确认提交] 开通就诊卡
    $scope.submitCardApply = function () {
        // 格式化手机号
        $scope.formatPhone();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
        // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
        var isAddrFormat = false;
        // 现住址不为空-老流程填的，放过，走后边验证
        if ($scope.vpApply.address != '') {
            isAddrFormat = false;
        }
        // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
        else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
            isAddrFormat = true;
            $scope.vpApply.address = '';
            var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
            $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
            var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
            $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
            var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
            $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
            $scope.vpApply.address += $scope.vpApply.address_detail;
        }
        // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
        else {
            $fwCordovaToast.showShortBottom('请完整填写现住址信息');
            return false;
        }
        // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，删除北京医保卡号验证($scope.vpApply.insurance_type == 1 && $scope.vpApply.mi_patient_code == "")
        if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
            || $scope.vpApply.insurance_type == 0
            || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        // 2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
        var addressByteSize = getStringByteSize($scope.vpApply.address);
        //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
        // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
        if (isAddrFormat && addressByteSize > 40) {
            $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
            addressByteSize = getStringByteSize($scope.vpApply.address);
        }
        else if (addressByteSize <= 10 || addressByteSize > 40) {
            var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: msgStr,
                okText: '确定'
            }).then(function () {
            });
            return false;
        }
        // 2023-12-8 13:46:23 ZZL hzfwx-442 医保卡号添加长度限制，超过15位提示，避免超长导致自助机接口报错
        // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，去掉前端、后端、接口、轮询限制，屏蔽掉
        if ($scope.vpApply.mi_patient_code !== undefined && $scope.vpApply.mi_patient_code !== '' && $scope.vpApply.mi_patient_code !== null && $scope.vpApply.mi_patient_code.length > 15) {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '医保卡号格式不正确，请检查后重新填写',
                okText: '确定'
            }).then(function () {
                $scope.MICodeHelpModalShow();
            });
            return false;
        }
        $ionicLoading.show();
        // 提交建卡申请
        // 20181229 BST 暂时把这里的提交建卡申请也按0处理，ZTBZ = 2的建卡机会流程还有问题，暂时不开
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type,
            $scope.vpApply.insurance_type, $scope.vpApply.mi_patient_code, $scope.vpApply.marital).then(function (data) {
                console.log(data);
                // 获取成功
                if (data.result == 1) {
                    // 建卡成功
                    if (data.data == 1) {
                        $scope.applyCardHide();
                        $scope.addVisitPatientHide();
                        $scope.loadVpList();
                        $fwCordovaToast.showShortBottom('在线建档成功');
                    }
                    // 建卡失败
                    else if (data.data == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }
                // 获取失败
                else if (data.result == 99) {
                    $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
                } else {
                    // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                    //$fwCordovaToast.showShortBottom(data.msg);
                    var alertPopup = $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: '确定'
                    });
                }
                $ionicLoading.hide();
            })
    }

    // 检查身份证 获取办卡状态
    $scope.checkApplyCard = function (vp) {
        $scope.vpInfo = vp;
        $ionicLoading.show();
        // 获取办卡状态
        OpRegService.patientCheck(vp.VISIT_PATIENT_ID).then(function (data) {
            if (data.result == 1) {
                // 没有就诊卡
                if (data.is_null == 1) {
                    $ionicLoading.hide();
                    // 不可以办卡
                    if ($scope.applyCardFlag == 'false') {
                        $fwCordovaToast.showShortBottom("未找到患者的就诊卡信息");
                    }
                    else {
                        console.log('开始办卡流程');
                        var createCardMsg = data.msg;
                        // 创建建卡申请 供上传图片使用
                        OpRegService.createCardApply(vp.VISIT_PATIENT_ID, 1).then(function (data) {
                            // 创建建卡申请 成功
                            if (data.result == 1) {
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                $scope.vpApply.insurance_type = data.data.INSURANCE_TYPE;
                                $scope.vpApply.mi_patient_code = data.data.MI_PATIENT_CODE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                $ionicPopup.alert({
                                    title: '请注意',
                                    template: createCardMsg,
                                    okText: '确定'
                                }).then(function () {
                                    // 去建卡
                                    $scope.applyCardShow();
                                });
                            }
                            // 失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        })
                    }
                }
                // 有就诊卡 单卡状态
                else if (data.is_null == 0) {
                    console.log('有就诊卡：单卡状态');
                    $scope.requestId = data.requestId;
                    $scope.getPhoneAndCardNum($scope.requestId, vp.VISIT_PATIENT_ID, data.data, false);
                }
                // 有就诊卡 多卡状态
                else if (data.is_null == 2) {
                    console.log('有就诊卡：多卡状态');
                    $scope.requestId = data.requestId;

                    // 未绑卡状态 => 多卡 => 半绑，用过his_card_num => 不选了，绑它
                    if (vp.IS_BIND_CARD == "2" && vp.HIS_CARD_NUM != "") {
                        $scope.getPhoneAndCardNum($scope.requestId, vp.VISIT_PATIENT_ID, vp.HIS_CARD_NUM, false);
                    }
                    else {
                        $ionicLoading.hide();
                        $scope.cardList = data.data;
                        // 多卡提示
                        $ionicPopup.alert({
                            title: '请注意',
                            template: data.msg,
                            okText: "好的"
                        }).then(function () {
                            $scope.chooseCardModalShow();
                        });
                    }
                }
                // 其他状态(出错)
                else {
                    $ionicLoading.hide();
                    $scope.addVisitPatientModal.hide();
                    $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                }
            }
            // 获取办卡状态 错误
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误,请稍后重试");
            }

        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    // [图片验证码]的显示
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 点击[确认绑定] 绑定就诊卡 询问是否开通电子卡 (2018.12.29 绑卡 => 自动开通电子就诊卡)
    $scope.bindCardSubmit = function () {
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        // 绑定并开通电子就诊卡
        VisitPatientService.bindVisitPatient($scope.vpInfo.VISIT_PATIENT_ID, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self, true).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                //重置电子就诊卡  (2018.12.29 绑卡 => 自动开通电子就诊卡)
                $scope.loadVpList();
                $scope.bindCardModalHide();
                $fwCordovaToast.showShortBottom('就诊卡绑定、电子就诊卡开通成功');
            }
        });
    }

    // 检测就诊卡号是否合规则
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败 回滚
        if (!regex.exec($scope.vpBind.card_num)) {
            $cordovaToast.showShortTop("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 点击[获取验证码] pid赋值
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpInfo.VISIT_PATIENT_ID, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            // 就诊卡绑定 => 验证码：5
            $scope.getMsgVericode($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode);
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 开通电子就诊卡中 预留电话
    $scope.GetReservedPhone = function (vp) {
        $ionicLoading.show();
        RequestService.GetReservedPhone(vp.VISIT_PATIENT_ID).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            var phone = data.data[0].PHONENUM;
            $scope.onlineCard.phoneNum = phone;
            $scope.onlineCard.phoneNumShow = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
            $scope.onlineCardInfoShow(vp);
        });
    }

    // 开电子卡 IS_BIND_CARD=1 =>验证码:8    =>只验证 IS_BIND_CARD=3 =>验证码:9
    $scope.toGetMsgVericode = function () {
        if ($scope.vpInfo.IS_BIND_CARD == '1') {
            $scope.getMsgVericode($scope.onlineCard.phoneNum, '8', $scope.onlineCard.imageVericode);
        }
        else if ($scope.vpInfo.IS_BIND_CARD == '3') {
            $scope.getMsgVericode($scope.onlineCard.phoneNum, '9', $scope.onlineCard.imageVericode);
        }
        else {
            $fwCordovaToast.showShortBottom('绑卡状态错误');
        }
    }

    // 2018.1.8 获取短信验证码 带参数
    $scope.getMsgVericode = function (phoneNum, num, imgVericode) {
        AccountService.sendVericodeByPhone(phoneNum, num, imgVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }

    // 2018.12.29 绑卡验证(原电子卡开通) 
    $scope.applyECard = function () {
        if ($scope.onlineCard.phoneNum == '' || $scope.onlineCard.imageVericode == '' || $scope.onlineCard.messageVericode == '') {
            $fwCordovaToast.showShortBottom('请完整填写绑卡验证信息');
            return false;
        }

        // 开电子卡 => IS_BIND_CARD == '1' (ECARD_STATUS = null、0、2)
        if ($scope.vpInfo.IS_BIND_CARD == '1') {
            VisitPatientService.applyECard($scope.vpInfo.VISIT_PATIENT_ID, $scope.onlineCard.phoneNum, $scope.onlineCard.messageVericode).then(function (data) {
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    $scope.loadVpList();
                    $scope.onlineCardInfoHide();
                    $fwCordovaToast.showShortBottom('电子卡开通成功');
                }
            })
        }
        // 只验证 => IS_BIND_CARD == '3'
        else if ($scope.vpInfo.IS_BIND_CARD == '3') {
            VisitPatientService.bindPatientCardOlAchieve($scope.vpInfo.VISIT_PATIENT_ID, $scope.onlineCard.phoneNum, $scope.onlineCard.messageVericode).then(function (data) {
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    $scope.loadVpList();
                    $scope.onlineCardInfoHide();
                    $fwCordovaToast.showShortBottom('就诊卡验证成功');
                }
            })
        }
    }

    // 20200302 新增 把getPhoneAndCardNum提出来
    $scope.getPhoneAndCardNum = function (requestId, vpid, his_card_num, isLastStepSelectCard) {
        VisitPatientService.getPhoneAndCardNum(requestId, vpid, his_card_num).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 1) {
                // 拿到了手机号+卡号
                var phone = result.phone_num;
                var card_num = result.card_num;

                if (phone == "" || card_num == "") {
                    $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                }
                else {
                    // 手机号
                    $scope.vpBind.phone_num = phone;
                    // 卡号
                    $scope.vpBind.card_num = card_num;

                    // 带*手机号
                    $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                    // 带*卡号
                    $scope.vpBind.card_num_show = result.card_num_show;

                    $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;

                    // 获取图片验证码
                    $scope.getImageVericode();
                    $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");

                    // 上一步是选卡
                    if (isLastStepSelectCard) {
                        $scope.lastSelectCard = true;
                        // 选卡模态窗关闭
                        $scope.chooseCardModalHide();
                    }

                    $scope.bindCardModal.show();
                }
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
            }
        })
    }

    // 20200302 新增：选择这张卡
    $scope.bindThisCard = function (index) {
        $ionicPopup.confirm({
            title: '选择绑卡确认',
            template: '是否绑定此就诊卡?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                bindCardSelectSubmit(index);
            }
            else { }
        });
    }

    // 20200302 新增：选卡=>绑它
    bindCardSelectSubmit = function (index) {
        if (index < 0 || index >= $scope.cardList.length || $scope.cardList[index] == null
            || $scope.cardList[index].PATIENT_ID == null || $scope.cardList[index].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardSelect($scope.vpInfo.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 这里出来是半绑卡状态 =>全绑了
                $scope.getPhoneAndCardNum($scope.requestId, $scope.vpInfo.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID, true);
            }
        })
    }

    // 图片上传部分

    // 图片上传
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }
    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }
    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }

    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        //var uri = encodeURI("http://10.10.101.11:8080/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        // 显示上传等待
        $ionicLoading.show();
        // 上传图片
        //$fwCordovaToast.showShortBottom(uri);
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            //$cordovaToast.showLongBottom(angular.toJson(result));
            //console.log(result);
            //console.log(result.response);
            var fileResult = {};
            eval("fileResult = " + result.response);
            $ionicLoading.hide();
            // 上传成功
            if (fileResult.result == 1) {
                $fwCordovaToast.showShortBottom("上传成功");
                // 头像面
                if (type == 0) {
                    $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                }
                // 国徽面
                else if (type == 1) {
                    $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                }
                // 户口簿
                else if (type == 2) {
                    $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                }
            }
            // 上传失败
            else {
                $fwCordovaToast.showShortBottom(fileResult.msg);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }
    // 删除身份证照片
    $scope.deleteImg = function (type) {
        // confirm
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // 页面加载
    $scope.$on('$ionicView.loaded', function () {
        // 填充就诊人列表 关系列表
        $scope.loadVpList();
        // 获取ECard标识
        $scope.loadFlag();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();

        //设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if (data.result == 1) {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证"}];
        //    }
        //});
    })

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'onlineArchives');
    });

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'onlineArchives') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
