﻿angular.module('fwapp.controllers')

// 预约挂号列表
.controller('OpApptListController', function ($scope, $rootScope, $state, $stateParams, $fwCordovaToast, OpApptService, ApptService, OpRegService
    , $ionicModal, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform) {
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    $scope.opApptList = [];
    $scope.apptInfo = {};
    $scope.remark = {
        remarkWish: '',
        remarkAppt: ''
    };
    $scope.errMsg = "";
    $scope.status = $stateParams.status;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 适老化select
    $scope.config = {};
    $scope.config.changeStatus = $stateParams.status;

    // 医师搜索姓名
    $scope.doctorSearch = "";

    // 医保退费url
    $scope.ybRefundPageUrl = "";

    // 注册模态窗口：预约详情
    $ionicModal.fromTemplateUrl('apptDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.apptDetailModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.apptDetailModal.remove();
    })

    // 预约详情模态窗口显示
    $scope.apptDetailShow = function (index) {
        if ($scope.status == 0 && $scope.opApptList[index].STATUS == '1') {
            $scope.apptInfo.index = index;
            $scope.apptDetailModal.show();
        }
    }
    // 预约详情模态窗口隐藏
    $scope.apptDetailHide = function () {
        $scope.apptDetailModal.hide();
        $ionicScrollDelegate.scrollTop();
    }

    //console.log($scope.status);
    $scope.changeStatus = function (status) {
        // 清空医师姓名
        $scope.doctorSearch = "";

        $scope.status = status;
        $scope.loadOpApptList();
    }

    // 获取合并预约挂号列表
    $scope.loadOpApptList = function () {
        $ionicLoading.show();
        OpApptService.getOpApptList($scope.status, $scope.doctorSearch).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                //console.log(data.data);
                $scope.opApptList = data.data;
                // 2020-1-2 09:50:15 HM 由于减重门诊不能在自助机取号，故修改remark
                // $scope.remark.remarkWish = data.remarkWish;
                // $scope.remark.remarkAppt = data.remarkAppt;
                $scope.remark.remarkWish = $scope.opApptList.REG_REMARK;
                $scope.remark.remarkAppt = $scope.opApptList.REG_REMARK;
            }
            // 查询失败
            else {
                $scope.opApptList = [];
                $scope.errMsg = data.msg;
            }
            // 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        })
    }

    // 取消当日号挂号申请
    $scope.cancelOpAppt = function (index) {
        if ($scope.opApptList[index]
            && (($scope.opApptList[index].TYPE == 'WISH' && $scope.opApptList[index].STATUS == 1)
            || ($scope.opApptList[index].TYPE == 'APPT' && ($scope.opApptList[index].STATUS == 1 || $scope.opApptList[index].STATUS == 2 || $scope.opApptList[index].STATUS == 4)))) {
            var confirmPopup = $ionicPopup.confirm({
                title: '取消挂号确认',
                template: "此操作不可逆，您确定要取消当前挂号吗？",
                cancelText: '取消',
                okText: '确定'
            }).then(function (res) {
                if (res) {
                    console.log($scope.opApptList[index].ID);
                    $ionicLoading.show();
                    // 取消预约
                    if ($scope.opApptList[index].TYPE == 'WISH') {
                        ApptService.cancelAppt($scope.opApptList[index].ID).then(function (data) {
                            // 取消成功
                            if (data.result == 1) {
                                // 重新获取预约挂号列表
                                $scope.loadOpApptList();
                                $fwCordovaToast.showShortBottom("取消挂号成功");
                            }
                            // 取消失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg)
                            }
                            $ionicLoading.hide();
                        }, function (data) {
                            $fwCordovaToast.showShortBottom(data.msg);
                            $ionicLoading.hide();
                        })
                    }
                    // 取消挂号
                    else if ($scope.opApptList[index].TYPE == 'APPT') {
                        OpRegService.cancelReg($scope.opApptList[index].ID).then(function (data) {
                            // 取消成功
                            if (data.result == 1) {

                                if (data.bjybRefund == "1") {
                                    $scope.bjybRefundOpAppt(index);
                                }

                                // 重新获取预约挂号列表
                                $scope.loadOpApptList();
                                $fwCordovaToast.showShortBottom("取消挂号成功");
                            }
                            // 取消失败
                            else {
                                $fwCordovaToast.showLongBottom(data.msg);
                            }
                            $ionicLoading.hide();
                        }, function (data) {
                            $fwCordovaToast.showShortBottom(data.msg);
                            $ionicLoading.hide();
                        })
                    }
                }
            })
        }
        else {
            $fwCordovaToast.showShortBottom("当前状态不可取消挂号");
        }
    }

    $scope.ybCancel = function (type) {
        if (type == "zfb") {
            // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
            var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent($scope.ybRefundPageUrl));

            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser(herfUrl, '_system');
        }
        else {
            $fwCordovaToast.showShortBottom("暂不支持微信小程序");
        }
    }

    // 北京医保移动支付退费
    $scope.bjybRefundOpAppt = function (index) {
        // 获取小程序路径
        $ionicLoading.show();
        OpApptService.BJYBMobileCancelReg($scope.opApptList[index].ID).then(function (bjybData) {
            $ionicLoading.hide();
            if (bjybData.result == 1) {
                $scope.ybRefundPageUrl = bjybData.url;

                // 目前只支持 支付宝小程序，选择方式注释
                $scope.ybCancel('zfb');

                // var html = "<div>";
                // html += "<p>请选择取消预约方式</p>";

                // // 微信小程序
                // html += "<div style='display: flex;padding-bottom: 1em;'>";
                // html += "<div style='width: calc(100% - 4em)'>微信小程序</div>";
                // html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
                // html += "<button class='button button-small button-calm' ng-click='ybCancel(\"wx\");' style='max-height: 4em;line-height: 1.5em;'>";
                // html += "<span style='font-size:14px;'>跳转</span>";
                // html += "</button>";
                // html += "</div>";
                // html += "</div>";

                // // 支付宝小程序
                // html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;'>";
                // html += "<div style='width: calc(100% - 4em)'>支付宝小程序</div>";
                // html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
                // html += "<button class='button button-small button-calm' ng-click='ybCancel(\"zfb\");' style='max-height: 4em;line-height: 1.5em;'>";
                // html += "<span style='font-size:14px;'>跳转</span>";
                // html += "</button>";
                // html += "</div>";
                // html += "</div>";

                // html += "</div>";

                // $scope.confirmPopup = $ionicPopup.alert({
                //     title: "提示",
                //     template: html,
                //     buttons: [
                //         {
                //             text: "取消",
                //             onTap: function (e) { }
                //         }
                //     ],
                //     scope: $scope
                // });
            }
            else {
                $fwCordovaToast.showShortBottom(bjybData.msg);

                // 重新获取预约挂号列表
                $scope.loadOpApptList();
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 返回按钮
    $scope.goBack = function () {
        if ($scope.from == "app.message") {
            $rootScope.goBack();
        }
        else {
            $state.go('app.personal');
        }
    }
    // 继续支付
    // 2020-10-29 19:31:50 被弃用了
    $scope.goOpReg = function () {
        $state.go('app.opReg');
    }
    $scope.goOpAppt = function () {
        $state.go('app.opAppt');
    }

    // 修改状态
    $scope.changeStatusSelect = function () {
        $scope.changeStatus($scope.config.changeStatus);
    }

    $scope.$on('$ionicView.enter', function () {
        // 读取预约挂号列表
        $scope.loadOpApptList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                if ($scope.from.length > 0) {
                    $state.go($scope.from);
                }
                else {
                    $state.go('app.personal');
                }
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'opApptList');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'opApptList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})