﻿angular.module('fwapp.controllers')

// 门诊缴费明细
.controller('OpConsumptionController', function ($scope, $rootScope, $state, $stateParams, $timeout, $http, $timeout, $interval, $fwCordovaToast
, OpConsumptionService, VisitPatientService, AccountService, RequestService, PaymentService, PersonalService
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaInAppBrowser, $cordovaDatePicker) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义门诊缴费滑块
    var slideOpConsumption = $ionicSlideBoxDelegate.$getByHandle('slideOpConsumption');
    
    // 服务开关
    $scope.isServerOn = false;
    // 服务状态描述
    $scope.serverStatusDescr = "";
    // 是否真机
    $scope.isDevice = (window.cordova && window.cordova.plugins) ? true : false;
    // 是否加载完成
    $scope.isLoadFinish = false;
    // 日期范围
    $scope.dateRange = 7;
    // 查询日期
    var dateEnd = new Date();
    var dateStart = new Date(dateEnd.getTime() - 7 * 24 * 60 * 60 * 1000);
    $scope.dp = {
        dateStart: dateStart.Format('yyyy-MM-dd'),
        dateEnd: dateEnd.Format('yyyy-MM-dd')
    };

    // 状态 待缴费 已缴费
    $scope.status = $stateParams.status;
    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;
    // 打哪儿来
    $scope.from = $stateParams.from;

    // 初始滑块状态
    $scope.step = 0;

    // 已选择就诊人
    $scope.vpSelect = {};
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    
    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 绑卡帮助
    $scope.configData = {};
    $scope.configData.bindCardHelp = "";
    // 检查预约列表
    $scope.checkApptList = [];
    // 检查预约序列
    $scope.checkApptIndex = 0;
    // 卡号条形码
    $scope.cardCodeBarcode = {};
    $scope.cardCodeBarcode.src = "";

    // 门诊缴费分组信息列表
    $scope.opConsumptionList = [];
    $scope.opConsumptionIndex = 0;

    // 已选择附加费数量缓存
    $scope.selectedAddFeeCountCache = 0;

    // 初始化ajax数量
    $scope.initAjaxCount = 0;

    // 2018-10-26 14:54:25 可用支付方式
    $rootScope.paymentRouteList = [];

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bindCardHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：检查单详情
    $ionicModal.fromTemplateUrl('checkListDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.checkListDetailModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.checkListDetailModal.remove();
    })

    // 滑到下一步
    $scope.nextSlide = function () {
        slideOpConsumption.next();
        $scope.step = slideOpConsumption.currentIndex();
    }
    
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOpConsumption.slide(index);
        $scope.step = slideOpConsumption.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 来自消息中心
        // 2022-4-8 14:44:04 CGZ 按褚老师要求将门诊缴费明细合并至门诊自助缴费模块中
        if ($scope.from == "app.message" || $scope.from == "app.opPayment") {
            $rootScope.goBack();
        }
        else {
            $state.go("app.dealWithCard", { go: "opConsumption" });
            
            // slideOpConsumption.previous();
            // $scope.step = slideOpConsumption.currentIndex();
            // $scope.dp.dateStart = dateStart.Format('yyyy-MM-dd');
            // $scope.dp.dateEnd = dateEnd.Format('yyyy-MM-dd');
            // $scope.opConsumptionList.length = 0;
        }
    }

    // 滑块切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }
    //#region 绑定就诊卡
    // 绑卡模态窗口显示
    $scope.bindCardShow = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;
        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
        // 绑卡帮助为空时获取
        if ($scope.configData.bindCardHelp == "" || $scope.configData.bindCardHelp.length == 0) {
            $ionicLoading.show();
            // 获取绑卡帮助和本人关系说明
            OpConsumptionService.getBindCardHelp().then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    $scope.configData.bindCardHelp = data.data.bindCardHelp;
                    $scope.configData.isSelfDescr = data.data.isSelfDescr;
                }
                // 获取失败
                else {
                    $fwCordovaToast.showShortBottom("网络异常,请稍后重试");
                }
                $ionicLoading.hide();
            })
        }
        $scope.bindCardModal.show();
    }
    // 绑卡模态窗口隐藏
    $scope.bindCardHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            id: '',
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0
        };
    }
    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpShow = function () {
        $scope.bindCardHelpModal.show();
    }
    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpHide = function () {
        $scope.bindCardHelpModal.hide();
    }
    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwCordovaToast.showShortBottom("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }
    // 绑卡提交
    $scope.bindCardSubmit = function () {
        console.log($scope.vpBind);
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        $ionicLoading.show();
        VisitPatientService.bindVisitPatient($scope.vpBind.id, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.bindCardHide();     // 隐藏绑定页面
                $scope.loadVpList();            // 重新获取患者信息
                // 2017.7.28 孙老师要求开通预存账户需上传身份证 
                //$scope.toSlide(2);
                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
            $ionicLoading.hide();
        })
    }
    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpBind.id, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        });
    }
    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }
    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
    //#endregion

    // 选择就诊人
    $scope.selectVp = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
        // 判断绑卡状态
        if ($scope.vpSelect.IS_BIND_CARD != 1) {
            // 显示绑卡提示
            var bindCardPopup = $ionicPopup.show({
                title: '提示',
                template: '就诊人未绑定就诊卡，请绑卡后再试',
                buttons: [{
                    text: '确定',
                    type: 'button-positive',
                    onTap: function (e) {
                        bindCardPopup.close();
                        // 不加timeout popup关不掉
                        $timeout(function () {
                            $scope.bindCardShow();
                        }, 0);
                    }
                }]
            });
            //$fwCordovaToast.showShortBottom("就诊人未绑定就诊卡，请先到个人中心-就诊人管理进行绑卡操作");
            return;
        }
        // 获取门诊缴费清单
        $scope.getConsumptionList();
    }

    // 获取门诊缴费清单
    $scope.getConsumptionList = function () {
        // 检查日期
        if (!$scope.checkDate()) {
            return;
        }
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        $scope.opConsumptionList.length = 0;
        // HIS获取门诊待缴费项目列表
        OpConsumptionService.getConsumptionList($scope.inVpid, $scope.dp.dateStart, $scope.dp.dateEnd).then(function (data) {
            //console.log(data);
            //console.log(JSON.stringify(data));
            $scope.isLoadFinish = true;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                if ($scope.step == 0) {
                    // 滑到下一页
                    $scope.nextSlide();
                }
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('未找到指定时间的门诊缴费明细');
                return;
            }
            // 正常有结果
            // 分组遍历
            
            data.data.filter(e => (
                // 过滤空值
                e.ORDER_TIME != '' && e.RECEIPT_CODE != ''
            )).sort((a,b) => (
                // 排序 收费日期DESC
                new Date(a.ORDER_TIME).Format('yyyy-MM-dd').localeCompare(new Date(b.ORDER_TIME).Format('yyyy-MM-dd')) * (-1)
            )).forEach(e => {
                e.ORDER_DATE = new Date(e.ORDER_TIME).Format('yyyy-MM-dd');
                e.ORDER_TIME_SHOW = new Date(e.ORDER_TIME).Format('yyyy-MM-dd hh:mm:ss');
                // 格式化价格 补足至少两位小数
                e.TOTAL_FEE_SHOW = $scope.formatFee(Number(e.TOTAL_FEE));
                e.REAL_FEE_SHOW = $scope.formatFee(Number(e.REAL_FEE));
                // 缴费 = 1, 退费 = 0
                e.TYPE = Number(e.TOTAL_FEE) < 0 ? 0 : 1;
                // 拼入门诊缴费清单
                $scope.opConsumptionList.push(e);
            });
            
            console.log($scope.opConsumptionList);
            if ($scope.step == 0) {
                // 滑到下一页
                $scope.nextSlide();
            }
            // 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 获取门诊缴费明细
    $scope.getConsumptionDetail = function (index) {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        $scope.opConsumptionIndex = index;
        $scope.opConsumptionList[$scope.opConsumptionIndex].DETAIL = [];
        // HIS获取门诊待缴费项目列表
        OpConsumptionService.getConsumptionDetail($scope.inVpid, $scope.opConsumptionList[$scope.opConsumptionIndex].RECEIPT_CODE).then(function (data) {
            //console.log(data);
            //console.log(JSON.stringify(data));
            $scope.isLoadFinish = true;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('未找到指定的门诊缴费明细详情');
                return;
            }
            // 正常有结果
            var detail = [];
            data.data.filter(e => (
                // 按缴费/退费过滤明细
                ($scope.opConsumptionList[$scope.opConsumptionIndex].TYPE == 1 && Number(e.TOTAL_PRICE) >= 0) 
                || ($scope.opConsumptionList[$scope.opConsumptionIndex].TYPE == 0 && Number(e.TOTAL_PRICE) < 0)
            )).forEach(e => {
                // 格式化价格 补足至少两位小数
                e.UNIT_PRICE_SHOW = $scope.formatFee(Number(e.UNIT_PRICE));
                e.TOTAL_PRICE_SHOW = $scope.formatFee(Number(e.TOTAL_PRICE));
                detail.push(e);
            });
            $scope.opConsumptionList[$scope.opConsumptionIndex].DETAIL = detail;
            console.log($scope.opConsumptionList[$scope.opConsumptionIndex].DETAIL);
            $scope.checkListDetailShow(index);
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 开具电子发票
    $scope.createEInvoice = function (index) {
        var confirmPopup = $ionicPopup.confirm({
            title: "提示",
            template: "是否需要开具电子发票？",
            cancelText: '取消',
            okText: '确定'
        });
        // 立即填写, 跳转
        confirmPopup.then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpConsumptionService.createEInvoice($scope.inVpid, $scope.opConsumptionList[index].RECEIPT_CODE).then(function (data) {
                    $ionicLoading.hide();
                    if (data.status == "0") {
                        $ionicPopup.alert({
                            title: '提示`',
                            template: data.msg,
                            okText: "确定"
                        });
                    }
                    else {
                        $fwCordovaToast.showLongBottom("提交开具电子发票申请成功，稍后将发送到您的手机，请留意消息中心提醒。");
                        $scope.getConsumptionList();

                        /*
                        var confirmPopup = $ionicPopup.alert({
                            title: '提示`',
                            template: "提交开具电子发票申请成功，稍后将发送到您的手机，请留意消息中心提醒。",
                            okText: "确定"
                        });
                        confirmPopup.then(function (res) {
                            if (res) {
                                $scope.getConsumptionList();
                            }
                        }) 
                        **/
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: '提示`',
                        template: "开具电子发票失败，请稍后重试",
                        okText: "确定"
                    });
                })
            }
        })
    }

    // 查看电子发票
    $scope.openEInvoice = function (url) {
        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
        //$cordovaInAppBrowser.open(url, '_system', option).then(function (event) { });
        //2023.7.31 新插件原有调用方式参数不生效
        showInAppBrowser(url, '_system');
    }
    
    //#region cordova日期选择
    $scope.datePicker = function (target) {
        console.log(target);
        var value = new Date().Format('yyyy-MM-dd');
        switch (target) {
            case 'dateStart':    // 开始时间
                value = $scope.dp.dateStart;
                break;
            case 'dateEnd':      // 结束时间
                value = $scope.dp.dateEnd;
                break;
        }
        var defaultDate = new Date();
        if (value != null && value != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);
        }
        var options = {
            mode: 'date',  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != 'undefined') {
                var resultDate = new Date(date)
                $scope.setDate(target, resultDate.Format('yyyy-MM-dd'));
                $scope.getConsumptionList();
            }
        });
    }

    // 设置日期
    $scope.setDate = function (target, value) {
        var dNew = Date.parse(value);
        if (isNaN(dNew)) {
            $fwCordovaToast.showShortBottom("日期格式错误");
            return;
        }
        switch (target) {
            case 'dateStart':    // 开始时间
                $scope.dp.dateStart = new Date(dNew).Format('yyyy-MM-dd');
                break;
            case 'dateEnd':      // 结束时间
                $scope.dp.dateEnd = new Date(dNew).Format('yyyy-MM-dd');
                break;
        }
    }

    // 设置日期范围
    $scope.setDateRange = function (days) {
        if (typeof(days) == "number" && !isNaN(days) && $scope.dateRange != days) {
            $scope.dateRange = days;
            // 非自定义 设置日期
            if ($scope.dateRange != -1) {
                var dateNow = new Date();
                $scope.setDate('dateStart', new Date(dateNow.getTime() - days * 24 * 60 * 60 * 1000));
                $scope.setDate('dateEnd', dateNow.Format('yyyy-MM-dd'));
                $scope.getConsumptionList();
            }

        }
    }

    // 检查日期
    $scope.checkDate = function () {
        // 最大查询跨度90天
        var delta = 90 * 24 * 60 * 60 * 1000;
        var dStart = Date.parse($scope.dp.dateStart);
        var dEnd = Date.parse($scope.dp.dateEnd);
        if (isNaN(dStart)) {
            $fwCordovaToast.showShortBottom("开始时间格式错误");
            return false;
        }
        if (isNaN(dEnd)) {
            $fwCordovaToast.showShortBottom("结束时间格式错误");
            return false;
        }
        if (dStart > dEnd) {
            $fwCordovaToast.showShortBottom("开始时间不得晚于结束时间");
            return false;
        }
        if (dStart + delta < dEnd) {
            $fwCordovaToast.showShortBottom("查询间隔不得超过90天");
            return false;
        }
        return true;
    }
    //#endregion

    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    // 精确加法
    $scope.numAdd = function (num1, num2) {
        // 2018-9-10 13:17:22 改用BigNumber计算
        return BigNumber(num1).plus(num2).toNumber();
    }

    // 四舍五入到两位小数 返回数字
    $scope.roundFee = function(fee) {
        return Math.round(fee * 100) / 100;
    }

    // 格式化价格 至少两位小数 返回字符串
    $scope.formatFee = function(fee) {
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于2位小数 补0
        if(indexPoint == -1 || lengthFee - indexPoint < 3) {
            feeShow = fee.toFixed(2);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 检查预约详情模态窗口显示
    $scope.checkListDetailShow = function (index) {
        $scope.opConsumptionIndex = index;
        $scope.checkListDetailModal.show();
        $ionicScrollDelegate.$getByHandle('checkListDetail').scrollTop();
        console.log($scope.opConsumptionIndex);
    }
    // 检查预约详情模态窗口隐藏
    $scope.checkListDetailHide = function () {
        $scope.checkListDetailModal.hide();
        $scope.opConsumptionIndex = 0;
    }

    //#region 初始化
    // 加载就诊人列表
    $scope.loadVpList = function () {
        $scope.initAjaxCount++;
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            $scope.initAjaxCount--
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log($scope.vpList);
                //console.log($scope.inVpid);
                // 指定就诊人
                if ($scope.inVpid != null && $scope.inVpid != "") {
                    var index = 0;
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.inVpid) {
                            index = i;
                        }
                    }
                    // 跳过同意页
                    $scope.nextSlide();
                    // 选择对应就诊人
                    $scope.selectVp(index);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initAjaxCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOpConsumption.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.from == "app.message") {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'opConsumption');
        $ionicLoading.show();
        // 加载就诊人列表
        // $scope.loadVpList();

        $scope.getConsumptionList();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'opConsumption') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
    //#endregion 
})