﻿angular.module('fwapp.controllers')

// 门诊缴费
.controller('OpPaymentController', function ($scope, $rootScope, $state, $stateParams, $timeout, $http, $timeout, $interval, $fwCordovaToast, $filter
, OpPaymentService, VisitPatientService, AccountService, RequestService, PaymentService, PersonalService, OpRegService, CashierService
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaInAppBrowser, $cordovaDatePicker) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义门诊缴费滑块
    var slideOpPayment = $ionicSlideBoxDelegate.$getByHandle('slideOpPayment');
    
    // 服务开关
    $scope.isServerOn = false;
    // 服务状态描述
    $scope.serverStatusDescr = "";

    // 状态 待缴费 已缴费
    $scope.status = $stateParams.status;
    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 2020年7月20日13:18:23 HM 检查单/处方号
    $scope.rlatObjId = $stateParams.rlatObjId;

    // 初始滑块状态
    $scope.step = 0;
    // 用户须知数据
    $scope.agreement = new Object();
    // 支付信息
    $scope.paymentInfo = {};
    $scope.paymentInfo.addFeeNumList = [];
    // 收费项目代码拼接字符串
    $scope.paymentInfo.strFeeItemCode = "";
    // requestId
    $scope.paymentInfo.req4001 = "";
    $scope.paymentInfo.req4005 = "";
    // 后端返回真实金额
    $scope.paymentInfo.realFee = 0;
    // 补收医事服务费
    $scope.paymentInfo.msFee = 0;
    // 补收医事服务费笔数
    $scope.paymentInfo.msFeeCount = 0;
    // 预缴金余额
    $scope.paymentInfo.balance = 0;
    // 支付方式 0=预缴金余额 1=微信 4=北京银行银联支付
    $scope.paymentInfo.method = '0';

    // 职工金卡相关金额
    // 是否为保健医
    $scope.paymentInfo.inspectStaffStatus = "0";
    // 个人支付金额
    $scope.paymentInfo.goldCardPersonalPayMoney = 0;
    // 费用总金额
    $scope.paymentInfo.goldCardPayAllMoney = 0;
    // 报销金额
    $scope.paymentInfo.goldCardApplyMoney = 0;

    // 已选择就诊人
    $scope.vpSelect = {};
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: '',
        phone_num_show: '',
        card_num_show: ''
    }
    // 缴费信息ID
    $scope.opPaymentId = "";
    // 缴费错误信息
    $scope.opPaymentErrorMsg = {};
    $scope.opPaymentErrorMsg.msg = '';
    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 仅看可约
    $scope.showAvailable = false;
    // 从微信返回
    $scope.fromWeixin = true;
    // 商户订单号
    $scope.outTradeNo = "";
    // 微信支付返回结果
    $scope.appResult = "";
    // 支付成功显示model
    $scope.resultShow = {};
    // 是否支付成功
    $scope.isPaySuccess = false;
    // 是否缴费成功
    $scope.isChargeSuccess = false;
    // 是否继续支付
    $scope.isContinueToPay = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 用户须知倒计时
    $scope.confirmCountdown = devMode ? 1 : 10;
    // 绑卡帮助
    $scope.configData = {};
    $scope.configData.bindCardHelp = "";
    // 检查预约列表
    $scope.checkApptList = [];
    // 检查预约序列
    $scope.checkApptIndex = 0;
    // 卡号条形码
    $scope.cardCodeBarcode = {};
    $scope.cardCodeBarcode.src = "";

    // 门诊缴费分组信息列表
    $scope.opPaymentGroupList = [];
    $scope.opPaymentGroupIndex = 0;

    // 已选择附加费数量缓存
    $scope.selectedAddFeeCountCache = 0;

    // 初始化ajax数量
    $scope.initAjaxCount = 0;

    // 2018-10-26 14:54:25 可用支付方式
    $rootScope.paymentRouteList = [];

    // 2019年12月5日09:55:33 HM 检查可改约日期数据
    $scope.apptSchedDate = [];
     // 检查预约日期 给控件用的
    $scope.apptDate = {};
    $scope.apptDate.target = "";
    $scope.apptDate.targetOri = "";
    $scope.apptDate.dateMode = "white";
    $scope.apptDate.dateList = [];
    $scope.apptDate.minDate = "1970-01-01";
    $scope.apptDate.maxDate = "1970-01-01";
    // 缓存
    $scope.apptDate.targetCache = "";
    // 改期时段
    $scope.apptDate.targetTime = "";
    $scope.apptDate.targetTimeOri = "";
    // 改期时段ID
    $scope.apptDate.timeAreaId = "";
    // 是否正在改期
    $scope.isChangingDate = false;
    // 正在改期的检查序号
    $scope.changeCheckIndex = 0;
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}
    // 4001报错信息
    $scope.opPendingErrorMsg = "";

    // 北京医保小程序支付方式
    $scope.paymentRouteListYB = [];

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bindCardHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：检查单详情
    $ionicModal.fromTemplateUrl('checkListDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.checkListDetailModal = modal;
    });

    // 注册模态窗口：检查预约详情
    $ionicModal.fromTemplateUrl('checkApptDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.checkApptDetailModal = modal;
    });

    // 注册模态窗口：预约改期
    $ionicModal.fromTemplateUrl('changeApptDate.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.changeApptDateModal = modal;
    });

    // 注册模态窗口:选就诊卡
    $ionicModal.fromTemplateUrl('chooseCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.chooseCardModal = modal;
    });

    // 预约详情模态窗口隐藏
    $scope.checkApptDetailHide = function () {
        $scope.checkApptDetailModal.hide();
        $scope.checkApptIndex = 0;
    }

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.checkApptDetailModal.remove();
        $scope.checkListDetailModal.remove();
        $scope.changeApptDateModal.remove();
        $scope.chooseCardModal.remove();
    })

    // 滑到下一步
    $scope.nextSlide = function () {
        slideOpPayment.next();
        $scope.step = slideOpPayment.currentIndex();
    }
    
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOpPayment.slide(index);
        $scope.step = slideOpPayment.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第2页 从待支付列表页返回时初始化数据
        if ($scope.step == 2) {
            // 支付信息
            $scope.paymentInfo = {};
            $scope.paymentInfo.addFeeNumList = [];
            // 收费项目代码拼接字符串
            $scope.paymentInfo.strFeeItemCode = "";
            // requestId
            $scope.paymentInfo.req4001 = "";
            $scope.paymentInfo.req4005 = "";
            // 后端返回真实金额
            $scope.paymentInfo.realFee = 0;
            // 补收医事服务费
            $scope.paymentInfo.msFee = 0;
            // 预缴金余额
            $scope.paymentInfo.balance = 0;
            // 支付方式 0=预缴金余额 1=微信 2=支付宝
            $scope.paymentInfo.method = '0';
            // 缴费信息ID
            $scope.opPaymentId = "";
            // 缴费错误信息
            $scope.opPaymentErrorMsg = {};
            $scope.opPaymentErrorMsg.msg = '';
            // 防止多次提交
            $scope.disableAddVP = false;
            // 防止多次提交
            $scope.disableSubmit = false;
            // 仅看可约
            $scope.showAvailable = false;
            // 从微信返回
            $scope.fromWeixin = true;
            // 商户订单号
            $scope.outTradeNo = "";
            // 微信支付返回结果
            $scope.appResult = "";
            // 支付成功显示model
            $scope.resultShow = {};
            // 是否支付成功
            $scope.isPaySuccess = false;
            // 是否缴费成功
            $scope.isChargeSuccess = false;
            // 是否继续支付
            $scope.isContinueToPay = false;

            // 职工金卡相关金额
            $scope.paymentInfo.inspectStaffStatus = "0";
            $scope.paymentInfo.goldCardPersonalPayMoney = 0;
            $scope.paymentInfo.goldCardPayAllMoney = 0;
            $scope.paymentInfo.goldCardApplyMoney = 0;

            //console.log("reset data");
        }
        // 第一页按历史记录返回 或 来自消息中心
        if ($scope.step == 0 || $scope.from == "app.message" || $scope.from == "app.olTreatVideo" || $scope.from == "app.opPendingCheck") {
            $rootScope.goBack();
        }
        // 第4页（缴费结果 && 缴费成功）返回就诊人列表
        else if ($scope.step == 4 && $scope.isPaySuccess && $scope.isChargeSuccess) {
            // 支付信息
            $scope.paymentInfo = {};
            $scope.paymentInfo.addFeeNumList = [];
            // 收费项目代码拼接字符串
            $scope.paymentInfo.strFeeItemCode = "";
            // requestId
            $scope.paymentInfo.req4001 = "";
            $scope.paymentInfo.req4005 = "";
            // 后端返回真实金额
            $scope.paymentInfo.realFee = 0;
            // 补收医事服务费
            $scope.paymentInfo.msFee = 0;
            // 预缴金余额
            $scope.paymentInfo.balance = 0;
            // 支付方式 0=预缴金余额 1=微信 2=支付宝
            $scope.paymentInfo.method = '0';
            // 缴费信息ID
            $scope.opPaymentId = "";
            // 缴费错误信息
            $scope.opPaymentErrorMsg = {};
            $scope.opPaymentErrorMsg.msg = '';
            // 防止多次提交
            $scope.disableAddVP = false;
            // 防止多次提交
            $scope.disableSubmit = false;
            // 仅看可约
            $scope.showAvailable = false;
            // 从微信返回
            $scope.fromWeixin = true;
            // 商户订单号
            $scope.outTradeNo = "";
            // 微信支付返回结果
            $scope.appResult = "";
            // 支付成功显示model
            $scope.resultShow = {};
            // 是否支付成功
            $scope.isPaySuccess = false;
            // 是否缴费成功
            $scope.isChargeSuccess = false;
            // 是否继续支付
            $scope.isContinueToPay = false;

            // 职工金卡相关金额
            $scope.paymentInfo.inspectStaffStatus = "0";
            $scope.paymentInfo.goldCardPersonalPayMoney = 0;
            $scope.paymentInfo.goldCardPayAllMoney = 0;
            $scope.paymentInfo.goldCardApplyMoney = 0;

            //console.log("reset data");
            $scope.toSlide(1);
        }
        // 其他页返回上一个滑块
        else {
            slideOpPayment.previous();
            $scope.step = slideOpPayment.currentIndex();
        }
    }

    // 滑块切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    
    // 同意
    $scope.agree = function () {
        if($scope.isServerOn){
            $scope.nextSlide();
        }
        else if($scope.serverStatusDescr != null && $scope.serverStatusDescr != ""){
            $fwCordovaToast.showShortBottom($scope.serverStatusDescr);
        }
    }

    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.vpNew.idCardType = $scope.idCardTypeList[0].id;
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if($scope.vpNew.idCardType == 5){
                text = "证件编码";
            }
            
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text +'不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }
              

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }
    //#region 绑定就诊卡
    // 绑卡模态窗口显示
    $scope.bindCardShow = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;
        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
        // 绑卡帮助为空时获取
        if ($scope.configData.bindCardHelp == "" || $scope.configData.bindCardHelp.length == 0) {
            $ionicLoading.show();
            // 获取绑卡帮助和本人关系说明
            OpPaymentService.getBindCardHelp().then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    $scope.configData.bindCardHelp = data.data.bindCardHelp;
                    $scope.configData.isSelfDescr = data.data.isSelfDescr;
                }
                // 获取失败
                else {
                    $fwCordovaToast.showShortBottom("网络异常,请稍后重试");
                }
                $ionicLoading.hide();
            })
        }
        $scope.bindCardModal.show();
    }
    // 绑卡模态窗口隐藏
    $scope.bindCardHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            id: '',
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0,
            card_num_show: '',
            phone_num_show: ''
        };
    }
    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpShow = function () {
        $scope.bindCardHelpModal.show();
    }
    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpHide = function () {
        $scope.bindCardHelpModal.hide();
    }
    // 新增 选卡部分
    $scope.chooseCardModalShow = function () {
        $scope.chooseCardModal.show();
    }
    $scope.chooseCardModalHide = function () {
        $scope.chooseCardModal.hide();
    }
    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwCordovaToast.showShortBottom("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }
    // 绑卡提交
    $scope.bindCardSubmit = function () {
        console.log($scope.vpBind);
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        $ionicLoading.show();
        VisitPatientService.bindVisitPatient($scope.vpBind.id, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.bindCardHide();     // 隐藏绑定页面
                $scope.loadVpList();            // 重新获取患者信息
                // 2017.7.28 孙老师要求开通预存账户需上传身份证 
                //$scope.toSlide(2);
                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
            $ionicLoading.hide();
        })
    }
    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpBind.id, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        });
    }
    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }
    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
    //#endregion

    // 选择就诊人
    $scope.selectVp = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
        // 判断绑卡状态
        if ($scope.vpSelect.IS_BIND_CARD != 1) {
            // 走建卡或者绑卡
            $ionicLoading.show();
            // 获取办卡状态
            OpRegService.patientCheck($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                // 获取成功
                if (data.result == 1){
                    // 无卡 --> 办卡
                    if (data.is_null == 1){
                        console.log('无卡: ' + data.msg);
                        // 弹个提示 只支持复诊患者
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("患者无待缴费信息");
                    }
                    // 一张卡 --> 下一步
                    else if (data.is_null == 0){
                        console.log('一张卡: ' + data.msg);
                        // 没绑卡的 后台已经自动半绑卡/半绑卡的也在这
                        // 获取requestid
                        $scope.requestId = data.requestId;
                        VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, data.data).then(function (result) {
                            $ionicLoading.hide();
                            if (result.result == 1){
                                // 拿到了手机号+卡号
                                var phone = result.phone_num;
                                var card_num = result.card_num;
                                if (phone == "" || card_num == "") {
                                    $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                                }
                                else {
                                    // 手机号
                                    $scope.vpBind.phone_num = phone;
                                    // 卡号
                                    $scope.vpBind.card_num = card_num;

                                    // 带*手机号
                                    $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                                    // 带*卡号
                                    $scope.vpBind.card_num_show = result.card_num_show;

                                    $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
                                    $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;

                                    // 获取图片验证码
                                    $scope.getImageVericode();
                                    $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                                    $scope.bindCardModal.show();
                                }
                            }
                            else {
                                $fwCordovaToast.showShortBottom(result.msg);
                            }
                        })
                    }
                    // 多张卡 --> 绑卡
                    else if (data.is_null == 2){
                        console.log('多张卡: ' + data.msg);
                        $scope.requestId = data.requestId;

                        // 未绑卡状态 => 多卡 => 半绑，用过his_card_num => 不选了，绑它
                        if ($scope.vpSelect.IS_BIND_CARD == "2" && $scope.vpSelect.HIS_CARD_NUM != ""){
                            VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, $scope.vpSelect.HIS_CARD_NUM).then(function (result) {
                                $ionicLoading.hide();
                                if (result.result == 1) {
                                    // 拿到了手机号+卡号
                                    var phone = result.phone_num;
                                    var card_num = result.card_num;

                                    if (phone == "" || card_num == "") {
                                        $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                                    }
                                    else {
                                        // 手机号
                                        $scope.vpBind.phone_num = phone;
                                        // 卡号
                                        $scope.vpBind.card_num = card_num;

                                        // 带*手机号
                                        $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                                        // 带*卡号
                                        $scope.vpBind.card_num_show = result.card_num_show;

                                        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
                                        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;

                                        // 获取图片验证码
                                        $scope.getImageVericode();
                                        $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");
                                        $scope.bindCardModal.show();
                                    }
                                }
                                else {
                                    $fwCordovaToast.showShortBottom(result.msg);
                                }
                            })
                        }
                        else {
                            $ionicLoading.hide();
                            $scope.cardList = data.data;
                            // 多卡提示
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.msg,
                                okText: "确定"
                            }).then(function () {
                                $scope.chooseCardModalShow();
                            });
                        }
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                    }
                }
                // 获取错误
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误，获取办卡状态");
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误，获取办卡状态");
            })

            return;
        }
        $ionicLoading.show();
        console.log("到这个了e");
        // HIS获取门诊待缴费项目列表
        // 2020-7-20 13:32:33 HM 用V2
        var rlatObjType = "";
        if ($scope.from == "app.olTreatVideo") {
            rlatObjType = "OL_TREAT_VIDEO_CHECK";
        }
        if ($scope.from == "app.opPendingCheck") {
            rlatObjType = "OP_PENDING_CHECK";
        }

        // OpPaymentService.opPendingPayment($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
        OpPaymentService.opPendingPaymentV2($scope.vpSelect.VISIT_PATIENT_ID, $scope.rlatObjId, rlatObjType).then(function (data) {
            //console.log(data);
            //console.log(JSON.stringify(data));
            $scope.paymentInfo.req4001 = data.requestId;
            // 分组遍历
            $scope.opPaymentGroupList.length = 0;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $ionicLoading.hide();
                // $fwCordovaToast.showShortBottom(data.msg);
                $scope.opPendingErrorMsg = data.msg;
                // 滑到下一页
                $scope.nextSlide();
                return;
            }
            // 正常有结果
            $scope.paymentInfo.req4001 = data.requestId;
            $scope.paymentInfo.req4005 = "";
            var checkListNumGroup = new Set(data.data.map(e => e.CHECK_LIST_NUM));
            checkListNumGroup.forEach(checkListNum => {
                var group = {};
                // 2019年12月9日08:16:17 HM 支持缴费前检查预约
                group.MEDICIAL_ITEM_ID = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].MEDICIAL_ITEM_ID;
                group.CHECK_LIST_NUM = checkListNum;
                group.FEE_ITME_LIST = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum);
                // 计算检查单费用合计(每单四舍五入保留两位小数)
                group.CHECK_LIST_FEE = 0;
                // 附加项检查单号列表
                group.ADD_FEE_NUM_LIST = [];
                // 缴费项目代码
                group.CHARGE_ITEM_CODE = "";
                // 是否包含抗排异药物
                group.SPECIALITY_ITEM_REMARK2 = false;
                // 是否包含CT检查费
                group.SPECIALITY_ITEM_REMARK3 = false;
                // 2018-9-7 16:14:52 新增3项
                // 检查单类别
                group.CHARGE_ITEM_TYPE_CODE = "";
                group.CHARGE_ITEM_TYPE_NAME = "";
                // 检查单内项目名称集合
                group.CHARGE_ITEM_NAME = "";
                // 开单日期
                group.ORDER_DATE = "";
                // 遍历检查单
                for (var i in group.FEE_ITME_LIST) {
                    // 检查单费用合计
                    //group.CHECK_LIST_FEE += group.FEE_ITME_LIST[i].TOTAL_PRICE * 10000;
                    group.CHECK_LIST_FEE = $scope.numAdd(group.CHECK_LIST_FEE, group.FEE_ITME_LIST[i].TOTAL_PRICE);
                    // 附加项检查单号
                    if (group.FEE_ITME_LIST[i].ADD_FEE_NUM != "0" && !group.ADD_FEE_NUM_LIST.includes(group.FEE_ITME_LIST[i].ADD_FEE_NUM)) {
                        group.ADD_FEE_NUM_LIST.push(group.FEE_ITME_LIST[i].ADD_FEE_NUM);
                    }
                    // 2024-4-22 14:30:04 wcx 补足为四位小数
                    // 格式化价格 补足至少两位小数
                    group.FEE_ITME_LIST[i].UNIT_PRICE_SHOW = $scope.formatFeeV2(group.FEE_ITME_LIST[i].UNIT_PRICE);
                    group.FEE_ITME_LIST[i].TOTAL_PRICE_SHOW = $scope.formatFeeV2(group.FEE_ITME_LIST[i].TOTAL_PRICE);
                    // 如果不存在 追加缴费项目代码
                    if (group.CHARGE_ITEM_CODE.indexOf(group.FEE_ITME_LIST[i].CHARGE_ITEM_CODE) == -1) {
                        group.CHARGE_ITEM_CODE += "," + group.FEE_ITME_LIST[i].CHARGE_ITEM_CODE;
                    }
                    // 是抗排异药物
                    if (group.FEE_ITME_LIST[i].SPECIALITY_ITEM_REMARK2) {
                        group.SPECIALITY_ITEM_REMARK2 = true;
                    }
                    // 是CT检查费
                    if (group.FEE_ITME_LIST[i].SPECIALITY_ITEM_REMARK3) {
                        group.SPECIALITY_ITEM_REMARK3 = true;
                    }
                    // 检查单类别 只显示: 1=药费, 2=检查费
                    if ((group.FEE_ITME_LIST[i].CATEGORY == "1" || group.FEE_ITME_LIST[i].CATEGORY == "2")) {
                        // 检查单内项目名称集合
                        group.CHARGE_ITEM_NAME += "、" + group.FEE_ITME_LIST[i].CHARGE_ITEM_NAME;
                        if (group.CHARGE_ITEM_TYPE_CODE.indexOf(group.FEE_ITME_LIST[i].CATEGORY) == -1) {
                            group.CHARGE_ITEM_TYPE_CODE += "," + group.FEE_ITME_LIST[i].CATEGORY;
                        }
                    }
                    // 开单日期
                    if (i == 0) {
                        group.ORDER_DATE = new Date(group.FEE_ITME_LIST[i].ORDER_TIME).Format("yyyy年MM月dd日");;
                    }
                }
                // 2024-4-23 16:12:00 wcx 详情页合计价格单独列出
                group.CHECK_DETAIL_FEE_SHOW = $scope.formatFeeV2(group.CHECK_LIST_FEE);
                // 每单四舍五入保留两位小数
                //group.CHECK_LIST_FEE = $scope.roundFee(group.CHECK_LIST_FEE / 10000);
                group.CHECK_LIST_FEE = $scope.roundFee(group.CHECK_LIST_FEE);
                // 格式化价格 补足至少两位小数
                group.CHECK_LIST_FEE_SHOW = $scope.formatFee(group.CHECK_LIST_FEE);
                // 缴费项目代码 去掉开头逗号
                if (group.CHARGE_ITEM_CODE.length > 0) {
                    group.CHARGE_ITEM_CODE = group.CHARGE_ITEM_CODE.substr(1);
                }
                group.SELECTED = false;
                // 检查单类别
                group.CHARGE_ITEM_TYPE_CODE = group.CHARGE_ITEM_TYPE_CODE.substr(1);
                group.CHARGE_ITEM_TYPE_NAME = group.CHARGE_ITEM_TYPE_CODE.replace("1","药费").replace("2","检查费");
                // 检查单内项目名称集合
                group.CHARGE_ITEM_NAME = group.CHARGE_ITEM_NAME.substr(1);

                // 2023-6-21 11:20:10 HM 增加保健医处方
                group.INSPECT_STAFF_STATUS = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].INSPECT_STAFF_STATUS;

                // 2023-5-30 08:33:53 HM 增加北京医保app
                group.APP_UPLOAD_STATUS = data.data.filter(e => e.CHECK_LIST_NUM == checkListNum)[0].APP_UPLOAD_STATUS;

                // 拼入检查单列表
                // 2019-8-29 17:47:04 符合检查单类别且名称不为空才拼入
                // 2019-12-10 21:27:28 导致附加费未拼入列表 无法勾选 还原
                // 2020-5-9 14:27:53 这版本一直没发布 好像也不用还原了 再改回去
                // 2020-5-26 19:11:24 导致附加费未拼入列表 无法勾选 应该让附加费拼入opPaymentGroupList 但在可缴费列表中不显示
//                if ((group.CHARGE_ITEM_TYPE_CODE == "1" || group.CHARGE_ITEM_TYPE_CODE == "2") && group.CHARGE_ITEM_NAME != "") {
                $scope.opPaymentGroupList.push(group);
//                }
                // 附加项代码列表
                for (var i in group.ADD_FEE_NUM_LIST) {
                    if (!$scope.paymentInfo.addFeeNumList.includes(group.ADD_FEE_NUM_LIST[i])) {
                        $scope.paymentInfo.addFeeNumList.push(group.ADD_FEE_NUM_LIST[i]);
                    }
                }
            });
            // 2018-9-7 17:18:25 排序 日期DESC, 药费/检查费, 检查单号 
            $scope.opPaymentGroupList.sort((a,b) => { 
	            var result = a.ORDER_DATE.localeCompare(b.ORDER_DATE) * (-100) 
                           + a.CHARGE_ITEM_TYPE_CODE.localeCompare(b.CHARGE_ITEM_TYPE_CODE) * 10
	                       + (Number(a.CHECK_LIST_NUM) < Number(b.CHECK_LIST_NUM) ? -1 : 1);
	            return result;
            });
            console.log($scope.opPaymentGroupList);
            console.log($scope.paymentInfo.addFeeNumList);

            // 患者身份类别
            $scope.healthCareType = data.data[0].HEALTH_CARE_TYPE;// 3北京医保

            // 滑到下一页
            $scope.nextSlide();
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    // 检查单是否可见
    $scope.isItemShow = function(index) {
        // 2020-5-9 14:27:53 这版本一直没发布 先加到devMode里
        // 2020-5-26 19:11:24 导致附加费未拼入列表 无法勾选 应该让附加费拼入opPaymentGroupList 但在可缴费列表中不显示
//        if (devMode) {
        // 2019-12-10 21:43:41 排除附加费 只显示: 1=药费, 2=检查费 且名称不为空
        return ($scope.opPaymentGroupList[index].CHARGE_ITEM_TYPE_CODE == "1" || $scope.opPaymentGroupList[index].CHARGE_ITEM_TYPE_CODE == "2") && $scope.opPaymentGroupList[index].CHARGE_ITEM_NAME != "";
//        }
//        else {
//            return true;
//        }
    }

    // 检查单是否可选
    $scope.isItemEnable = function(index) {
        // 2018-9-7 17:44:44 取消抗排异药不可缴费限制
        //return !$scope.paymentInfo.addFeeNumList.includes($scope.opPaymentGroupList[index].CHECK_LIST_NUM);
        //&& !$scope.opPaymentGroupList[index].SPECIALITY_ITEM_REMARK2;
        // 2019-8-29 15:49:27 增加CT检查费不可教费限制
        if ($scope.paymentInfo.addFeeNumList.includes($scope.opPaymentGroupList[index].CHECK_LIST_NUM) || $scope.opPaymentGroupList[index].SPECIALITY_ITEM_REMARK3) {
            return false;
        }
        else if ($scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS == "1" && $scope.opPaymentGroupList[index].CHARGE_ITEM_TYPE_CODE == "2") {
            return false;
        }
        else if ($scope.opPaymentGroupList.filter(e => e.INSPECT_STAFF_STATUS == "1" && e.SELECTED == true).length > 0 && $scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS != "1") {
            return false;
        }
        else if ($scope.opPaymentGroupList.filter(e => e.INSPECT_STAFF_STATUS != "1" && e.SELECTED == true).length > 0 && $scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS == "1") {
            return false;
        }
        // 2023-5-29 13:32:59 HM 增加已上传到医保APP限制选择
        else if ($scope.opPaymentGroupList[index].APP_UPLOAD_STATUS == "1") {
            return false;
        }
        else {
            return true;
        }
    }

    // 选择按钮是否可用
    $scope.isSelectEnabled = function (index) {
        // 2018-9-7 17:44:44 取消抗排异药不可缴费限制
        //return $scope.opPaymentGroupList[index].FEE_ITME_LIST.filter(e => e.SPECIALITY_ITEM_REMARK2).length == 0;
        // 2019-8-29 15:49:27 增加CT检查费不可教费限制
        if ($scope.opPaymentGroupList[index].FEE_ITME_LIST.filter(e => e.SPECIALITY_ITEM_REMARK3).length > 0) {
            return false;
        }
        else if ($scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS == "1" && $scope.opPaymentGroupList[index].CHARGE_ITEM_TYPE_CODE == "2") {
            return false;
        }
        else if ($scope.opPaymentGroupList.filter(e => e.INSPECT_STAFF_STATUS == "1" && e.SELECTED == true).length > 0 && $scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS != "1") {
            return false;
        }
        else if ($scope.opPaymentGroupList.filter(e => e.INSPECT_STAFF_STATUS != "1" && e.SELECTED == true).length > 0 && $scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS == "1") {
            return false;
        }
        // 2023-5-29 13:32:59 HM 增加已上传到医保APP限制选择
        else if ($scope.opPaymentGroupList[index].APP_UPLOAD_STATUS == "1") {
            return false;
        }
        else {
            return true;
        }
    }

    // 切换选择
    $scope.switchSelected = function (index, allSelect) {
        // 检查单是否可选
        if ($scope.isItemEnable(index)) {
            $scope.opPaymentGroupList[index].SELECTED = !$scope.opPaymentGroupList[index].SELECTED;
            
            // 2020-5-9 14:27:53 这版本一直没发布 先加到devMode里
            // 2019-12-2 08:23:40 HM 支持缴费前检查预约，MEDICIAL_ITEM_ID是拿groupId改的，自助机接口返回groupId即可以自动预约（个别除外，但也请求），为空即不可自动预约，非全选。    
            // 2021-5-5 17:05:39 取消缴费前预约检查
            if (false && devMode && ($scope.opPaymentGroupList[index].CHARGE_ITEM_TYPE_NAME == "检查费" && !allSelect && $scope.opPaymentGroupList[index].MEDICIAL_ITEM_ID != "")) {
                
                // 反选操作
                if ($scope.opPaymentGroupList[index].preSelected == true && $scope.opPaymentGroupList[index].SELECTED == false) {
                    $scope.opPaymentGroupList[index].preSelected = false;
                }

                // 若选中
                if ($scope.opPaymentGroupList[index].SELECTED == true) {
                    $ionicLoading.show();
                    // 理论上是，他真的是false
                    $scope.opPaymentGroupList[index].preSelected = false;
                    RequestService.preCheckAppt($scope.vpSelect.VISIT_PATIENT_ID, $scope.opPaymentGroupList[index].CHECK_LIST_NUM).then(function (data) {
                        console.log(data);
                        $ionicLoading.hide();

                        if (data.result == 99) {    // 链接超时
                            $fwCordovaToast.showShortBottom('连接超时，请重试');
                            $scope.opPaymentGroupList[index].SELECTED = false;
                            return;
                        }
                        if (data.result != 1 && data.result != -1) {  // 请求错误
                            $fwCordovaToast.showShortBottom(data.msg);
                            $scope.opPaymentGroupList[index].SELECTED = false;
                            return;
                        }
                        if (data.is_null == 1 || data.data.length <= 0) { // 空结果什么都不做
                            return;
                        }

                        // 正常结果
                        $scope.opPaymentGroupList[index].preDate = new Date(data.data[0].ORDER_DATE).Format("yyyy年MM月dd日");
                        $scope.opPaymentGroupList[index].preTime = data.data[0].ORDER_TIME;
                        $scope.opPaymentGroupList[index].preSelected = true;
                    
                    }, function (data) {
                        $ionicLoading.hide();
                        $scope.opPaymentGroupList[index].SELECTED == false;
                        $fwCordovaToast.showShortBottom(data.msg);
                    });
                }
            }

            // 有附加项
            if ($scope.opPaymentGroupList[index].ADD_FEE_NUM_LIST.length > 0) {
                // 遍历附加项
                for (var i in $scope.opPaymentGroupList[index].ADD_FEE_NUM_LIST) {
                    $scope.switchSelectedAddItem($scope.opPaymentGroupList[index].ADD_FEE_NUM_LIST[i], $scope.opPaymentGroupList[index].SELECTED);
                }
            }

            // 如果选择了保健医，这里不让他选择其他的
            if ($scope.opPaymentGroupList[index].INSPECT_STAFF_STATUS == "1") {
                for (var i = 0; i < $scope.opPaymentGroupList.length; i++) {
                    if ($scope.opPaymentGroupList[i].INSPECT_STAFF_STATUS != "1") {
                        $scope.opPaymentGroupList[i].SELECTED = false;
                    }
                }
            }
            // 如果选了其他的，这里不让他选择保健医
            else {
                for (var i = 0; i < $scope.opPaymentGroupList.length; i++) {
                    if ($scope.opPaymentGroupList[i].INSPECT_STAFF_STATUS == "1") {
                        $scope.opPaymentGroupList[i].SELECTED = false;
                    }
                }
            }
        }
    }

    // 自动切换选择附加项
    $scope.switchSelectedAddItem = function (checkListNum, isSelceted) {
        // 对应附加项 可能有多个
        var addItemList = $scope.opPaymentGroupList.filter(e => e.CHECK_LIST_NUM == checkListNum);
        for (var i in addItemList) {
            // 当前项选中 附加项选中 不动 已经有别的项给选了
            // 当前项选中 附加项未选中 勾选
            if (isSelceted && !addItemList[i].SELECTED) {
                addItemList[i].SELECTED = true;
            }
            // 当前项未选中 附加项选中 查找其他项 如果有 不动 如果没有 取消选择
            if (!isSelceted && addItemList[i].SELECTED) {
                var selectedItemList = $scope.opPaymentGroupList.filter(e => (e.ADD_FEE_NUM_LIST.includes(checkListNum) && e.SELECTED));
                if (selectedItemList.length == 0) {
                    addItemList[i].SELECTED = false;
                }
            }
            // 当前项未选中 附加项未选中 不动 不应该出现
        }
    }

    // 是否全选
    $scope.isSelectAll = function () {
        var countDisabled = 0;
        var countSelected = 0;
        for (var i in $scope.opPaymentGroupList) {
            // 不可选
            if (!$scope.isItemEnable(i)) {
                countDisabled++;
            }
            // 可选 且 当前已选
            else if ($scope.opPaymentGroupList[i].SELECTED) {
                countSelected++;
            }
        }
        //console.log("disabled: " + countDisabled + ", selected: " + countSelected);
        // 所有可选的都选了 且 有选了的
        if (($scope.opPaymentGroupList.length == countDisabled + countSelected) && countSelected > 0) {
            return true;
        }
        return false;
    }

    // 全选按钮是否可用
    $scope.isSelectAllEnabled = function () {
        var countSelected = 0;
        for (var i in $scope.opPaymentGroupList) {
            // 可选
            if ($scope.isItemEnable(i)) {
                // 当前已选
                if ($scope.opPaymentGroupList[i].SELECTED) {
                    countSelected++;
                }
                // 当前未选
                else {
                    return true;
                }
            }
        }
        return countSelected > 0;
    }

    // 全选
    $scope.selectAll = function () {
        // 2019年12月4日18:26:05 HM 支持缴费前检查预约
        var value = !$scope.isSelectAll();
        var checkListNum = "";
        var checkListSign = false;
        for (var i in $scope.opPaymentGroupList) {
            // 全选
            if (value) {
                // 可选 且 当前未选
                if ($scope.isItemEnable(i) && !$scope.opPaymentGroupList[i].SELECTED) {
                    // 全选传true，只勾选不请求，下面拼接字符串，统一请求
                    $scope.switchSelected(i, true);
                }
                
                // 2020-5-9 14:27:53 这版本一直没发布 先加到devMode里
                if (devMode && $scope.opPaymentGroupList[i].MEDICIAL_ITEM_ID != "") {
                    checkListSign = true;// 标志
                    checkListNum = checkListNum + $scope.opPaymentGroupList[i].CHECK_LIST_NUM + ",";
                }
            }
            // 全部取消
            else {
                $scope.opPaymentGroupList[i].SELECTED = value;
            }
            
            // 2020-5-9 14:27:53 这版本一直没发布 先加到devMode里
            // 2021-5-5 17:05:39 取消缴费前预约检查
            if (false && devMode) {
                $scope.opPaymentGroupList[i].preSelected = false;
            }
        }
            
        // 2020-5-9 14:27:53 这版本一直没发布 先加到devMode里
        // 2021-5-5 17:05:39 取消缴费前预约检查
        if (false && devMode) {
            // 全选
            if (value && checkListSign) {
                checkListNum = checkListNum.substring(0, checkListNum.length - 1);
                $ionicLoading.show();
                RequestService.preCheckAppt($scope.vpSelect.VISIT_PATIENT_ID, checkListNum).then(function (data) {
                    $ionicLoading.hide();
                    console.log(data);
                    if (data.result == 99) {    // 链接超时
                        $fwCordovaToast.showShortBottom('连接超时，请重试');
                        // 若失败，把所有的selected全部取消
                        for(var i in $scope.opPaymentGroupList){
                            $scope.opPaymentGroupList[i].SELECTED = false;
                        }
                        return;
                    }
                    if (data.result != 1 && data.result != -1) {  // 请求错误
                        $fwCordovaToast.showShortBottom(data.msg);
                        // 若失败，把所有的selected全部取消
                        for(var i in $scope.opPaymentGroupList){
                            $scope.opPaymentGroupList[i].SELECTED = false;
                        }
                        return;
                    }
                    if (data.is_null == 1 || data.data.length <= 0) { // 空结果
                        return;
                    }
                    // 应该还能优化吧
                    for(var i = 0; i < data.data.length; i++){
                        for(var j = 0; j < $scope.opPaymentGroupList.length; j++){
                            if($scope.opPaymentGroupList[j].CHECK_LIST_NUM == data.data[i].CHECK_LIST_NUM){
                                $scope.opPaymentGroupList[j].preDate = new Date(data.data[i].ORDER_DATE).Format("yyyy年MM月dd日");
                                $scope.opPaymentGroupList[j].preTime = data.data[i].ORDER_TIME;
                                $scope.opPaymentGroupList[j].preSelected = true;
                            }
                        }
                    }
                }, function (data) {
                    // 若失败，把所有的selected全部取消
                    for(var i in $scope.opPaymentGroupList){
                        $scope.opPaymentGroupList[i].SELECTED = false;
                    }
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                });
            }
        }
    }

    // 精确加法
    $scope.numAdd = function (num1, num2) {
        // 2018-9-10 13:17:22 改用BigNumber计算
        return BigNumber(num1).plus(num2).toNumber();
        /*
        //console.log("add start");
        //console.log(num1);
        //console.log(num2);
        var digit1 = (num1.toString().split(".")[1] || "").length;
        var digit2 = (num2.toString().split(".")[1] || "").length;
        //console.log(digit1);
        //console.log(digit2);
        var baseNum1 = Math.pow(10, digit1);
        var baseNum2 = Math.pow(10, digit2);
        var baseNum = Math.max(baseNum1, baseNum2);
        //console.log(baseNum1);
        //console.log(baseNum2);
        var baseNumAfter1 = baseNum / baseNum1;
        var baseNumAfter2 = baseNum / baseNum2;
        //console.log(baseNumAfter1);
        //console.log(baseNumAfter2);
        //var n = (num1 * baseNum + num2 * baseNum) / baseNum;
        var n = (num1 * baseNum1 * baseNumAfter1 + num2 * baseNum2 * baseNumAfter2) / baseNum;
        //console.log("(" + num1 + " * " + baseNum + " + " + num2 + " * " + baseNum + ") / " + baseNum + " = " + m);
        //console.log("add end");
        return n;
        */
    }

    // 计算合计 拼待缴费项目代码
    $scope.calcTotalFee = function (isBuildItemCode) {
        // 总金额
        var totalFee = 0;
        // 待缴费项目代码字符串
        var strItemCode = "";
        for (var i in $scope.opPaymentGroupList) {
            if ($scope.opPaymentGroupList[i].SELECTED) {
                totalFee = $scope.numAdd(totalFee, $scope.opPaymentGroupList[i].CHECK_LIST_FEE);
                //totalFee += $scope.opPaymentGroupList[i].CHECK_LIST_FEE * 10000;
                if (isBuildItemCode) {
                    strItemCode += "," + $scope.opPaymentGroupList[i].CHARGE_ITEM_CODE;
                }
            }
        }
        if (isBuildItemCode) {
            strItemCode = strItemCode.substr(1);
            $scope.paymentInfo.strFeeItemCode = strItemCode;
        }
        //console.log(totalFee);
        //return totalFee / 10000;
        return totalFee;
    }

    // 计算支付金额 总价再加上补收的医事服务费
    $scope.calcPaymentAmount = function () {
        var totalFee = 0;
        // 如果是保健医，认李建接口的返回值
        if ($scope.paymentInfo.inspectStaffStatus == "1") {
            totalFee = $scope.paymentInfo.goldCardPersonalPayMoney;
        }
        else {
            totalFee = $scope.calcTotalFee();
        }

        if (!Number.isNaN($scope.paymentInfo.msFee) && $scope.paymentInfo.msFee > 0 && $scope.ybPayEnable() == false) {
            return $scope.numAdd(totalFee, $scope.paymentInfo.msFee);
        }
        return totalFee;
    }

    // 四舍五入到两位小数 返回数字
    $scope.roundFee = function (fee) {
        // 2020-11-3 10:21:14 HM 5厘钱问题，改用bigNumber计算，times乘法，div除法
        return BigNumber(Math.round(BigNumber(fee).times(100).toNumber())).div(100).toNumber();
        //return Math.round(fee * 100) / 100;
    }

    // 格式化价格 至少两位小数 返回字符串
    $scope.formatFee = function (fee) {
        fee = BigNumber(fee).toNumber();
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于2位小数 补0
        if(indexPoint == -1 || lengthFee - indexPoint < 3) {
            feeShow = fee.toFixed(2);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 2024-4-22 14:27:16 wcx 和自助机接口计算规则统一 先显示4位小数
    $scope.formatFeeV2 = function (fee) {
        fee = BigNumber(fee).toNumber();
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于4位小数 补0
        if (indexPoint == -1 || lengthFee - indexPoint < 5) {
            feeShow = fee.toFixed(4);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 检查预约详情模态窗口显示
    $scope.checkListDetailShow = function (index) {
        $scope.opPaymentGroupIndex = index;
        $scope.checkListDetailModal.show();
        $ionicScrollDelegate.$getByHandle('checkListDetail').scrollTop();
        console.log($scope.opPaymentGroupIndex);
    }
    // 检查预约详情模态窗口隐藏
    $scope.checkListDetailHide = function () {
        $scope.checkListDetailModal.hide();
        $scope.opPaymentGroupIndex = 0;
    }

    // 已选择附加费数量
    $scope.selectedAddFeeCount = function () {
        var items = $scope.opPaymentGroupList.filter((e, i) => !$scope.isItemEnable(i) && e.SELECTED);
        if ($scope.selectedAddFeeCountCache != items.length) {
            $ionicScrollDelegate.resize();
            $scope.selectedAddFeeCountCache = items.length;
        }
        return items.length;
    }

    // 结算 检查订单
    $scope.checkOrder = function (medicalServiceFlag) {
        $ionicLoading.show();
        var totalFeeCalc = $scope.calcTotalFee(true);
        console.log(totalFeeCalc);
        if (totalFeeCalc == 0) {
            $fwCordovaToast.showShortBottom("请选择待缴费项目");
            $ionicLoading.hide();
            return false;
        }

        // 判断是否为保健医
        // 职工金卡相关金额
        $scope.paymentInfo.inspectStaffStatus = "0";
        $scope.paymentInfo.goldCardPersonalPayMoney = 0;
        $scope.paymentInfo.goldCardPayAllMoney = 0;
        $scope.paymentInfo.goldCardApplyMoney = 0;

        for (var i in $scope.opPaymentGroupList) {
            if ($scope.opPaymentGroupList[i].SELECTED && $scope.opPaymentGroupList[i].INSPECT_STAFF_STATUS == "1") {
                $scope.paymentInfo.inspectStaffStatus = "1";
                break;
            }
        }

        // 核对金额 获取门诊预缴金余额
        OpPaymentService.opPaymentAmountCalc($scope.vpSelect.VISIT_PATIENT_ID, $scope.paymentInfo.strFeeItemCode, $scope.formatFee(totalFeeCalc)).then(function (data) {
            //console.log(data);
            //console.log(JSON.stringify(data));
            $scope.paymentInfo.req4005 = data.requestId;
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
            }
            // 调用失败
            else if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 调用成功
            else if (data.result == 1) {
                // 数据异常
                if (data.is_null == 1 || data.data[0].TOTAL_FEE == "-1") {
                    $ionicLoading.hide();
                    if (data.msg != null && data.msg != '') {
                        $fwCordovaToast.showLongBottom(data.msg);
                    }
                    else {
                        $fwCordovaToast.showLongBottom("获取缴费信息失败");
                    }
                }
                // 查询成功
                else {
                    $scope.checkOrderCommon(data, totalFeeCalc, medicalServiceFlag);
                }
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    $scope.checkOrderCommon = function (data, totalFeeCalc, medicalServiceFlag) {
        // 后台返回金额
        var realFee = Number(data.data[0].TOTAL_FEE);
        if (Number.isNaN(realFee)) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取缴费信息失败");
        }
        // 金额错误
        else if (realFee != totalFeeCalc) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取缴费信息失败");
        }
        // 金额正确
        else {
            // 医师服务费放个list中
            $scope.msFeeList = [];
            // 0挂的方个List中
            $scope.zeroRegDoctorList = [];

            // 2018-8-23 08:56:57 补收医事服务费
            // 2018-9-18 09:40:14 医事服务费改为多笔
            if (data.data != null && data.data.length > 0) {
                $scope.paymentInfo.msFee = 0;
                $scope.paymentInfo.msFeeCount = 0;
                for (var i in data.data) {
                    if (!Number.isNaN(Number(data.data[i].MEDICAL_SERVICE_FEE))) {
                        $scope.msFeeList.push(data.data[i]);
                        $scope.paymentInfo.msFee += Number(data.data[i].MEDICAL_SERVICE_FEE);
                        $scope.paymentInfo.msFeeCount++;
                    }
                }
            }
            $scope.paymentInfo.realFee = realFee;
            // 余额正确
            if (!Number.isNaN(Number(data.data[0].BALANCE))) {
                $scope.paymentInfo.balance = Number(data.data[0].BALANCE);
            }
            // 余额足够 默认付款方式置为预存余额
            if ($scope.paymentInfo.balance >= $scope.paymentInfo.realFee) {
                $scope.paymentInfo.method = '0';
            }
            // 余额不足 默认付款方式置为微信
            else {
                $scope.paymentInfo.method = '1';
            }

            // 2023-8-16 09:15:54 HM 增加判断，只有医保患者走互联互通
            if ($scope.healthCareType == "3" || $scope.healthCareType == 3) {
                // 2023-5-30 14:46:52 HM 判断是否走互联互通
                OpPaymentService.checkRecipeWithoutRegistration($scope.vpSelect.VISIT_PATIENT_ID, $scope.paymentInfo.strFeeItemCode, $scope.paymentInfo.req4001).then(function (checkRecipeData) {
                    $ionicLoading.hide();
                    if (checkRecipeData.result == 1 && $scope.ybPayEnable() == true) {
                        $scope.paymentInfo.method = '10';
                        console.log($scope.msFeeList);
                        if (medicalServiceFlag != "1") {
                            $scope.nextSlide();
                        }
                    }
                    else {
                        // 需要补0挂，给他放行
                        if (checkRecipeData.zeroRegDoctorList.length > 0) {
                            $scope.paymentInfo.method = '10';
                            $scope.zeroRegDoctorList = checkRecipeData.zeroRegDoctorList;
                            console.log($scope.zeroRegDoctorList);

                            if (medicalServiceFlag != "1") {
                                $scope.nextSlide();
                            }
                        }
                        else {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '请前往门诊窗口进行缴费',
                                okText: '确定'
                            });
                        } 
                    }
                }, function () {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: '提示',
                        template: '请前往门诊窗口进行缴费',
                        okText: '确定'
                    });
                })
            }
            // 如果是保健医，要先走报销分解，才能跳转
            else if ($scope.paymentInfo.inspectStaffStatus == "1") {
                OpPaymentService.getGoldCardChargeDivide($scope.vpSelect.VISIT_PATIENT_ID, $scope.paymentInfo.strFeeItemCode, realFee).then(function (goldCardData) {
                    $ionicLoading.hide();
                    console.log(goldCardData);

                    if (goldCardData.result == 1) {
                        $scope.paymentInfo.goldCardPersonalPayMoney = Number(goldCardData.data.personalPayMoney);
                        $scope.paymentInfo.goldCardPayAllMoney = Number(goldCardData.data.payAllMoney);
                        $scope.paymentInfo.goldCardApplyMoney = Number(goldCardData.data.applyMoney);

                        // 跳转到选择付款方式
                        $scope.nextSlide();
                    }
                    else {
                        $fwCordovaToast.showShortBottom("获取缴费信息失败，请前往门诊收费窗口缴费");
                    }
                }, function () {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("获取缴费信息失败，请前往门诊收费窗口缴费");
                })
            }
            else {
                $ionicLoading.hide();
                // 跳转到选择付款方式
                $scope.nextSlide();
            } 
        }
    }

    // 余额是否可用
    $scope.isBalanceEnable = function() {
        return $scope.paymentInfo.balance > 0 && $scope.paymentInfo.balance >= $scope.paymentInfo.realFee;
    }

    // 筛选支付方式
    $scope.filterPaymentMethod = function (value) {
        return $rootScope.paymentRouteList.filter(e => e.value == value)[0];
    }

    // 切换支付方式
    $scope.switchPaymentMethod = function (value) {
        var method = $scope.filterPaymentMethod(value);
        if (method == null) {
            $fwCordovaToast.showShortBottom('当前支付方式不可用, 请选择其他支付方式');
            return;
        }
        // 不可用
        if (method.status == "0") {
            $fwCordovaToast.showShortBottom(method.descr);
            return;
        }
        // 余额不足
        if (method.value == 0 && !$scope.isBalanceEnable()) {
            $fwCordovaToast.showShortBottom("门诊预存余额不足，请选择其他支付方式");
            return;
        }
        $scope.paymentInfo.method = method.value;
    }

    // 确认支付 提交订单
    $scope.submitOrder = function() {
        $ionicLoading.show();
        // 获取卡号二维码
        $scope.getCardCodeBarcode();

        // 如果金额等于0，把支付方式改成-1
        var paymentMethod = $scope.paymentInfo.method;
        if ($scope.calcPaymentAmount() == 0) {
            paymentMethod = -1;
        }

        var bjybMobilePaymentStatus = "0";
        if (paymentMethod == "10") {
            bjybMobilePaymentStatus = "1";
        }

        // 添加门诊缴费记录
        OpPaymentService.orderPayment($scope.vpSelect.VISIT_PATIENT_ID, $scope.paymentInfo.strFeeItemCode, $scope.calcPaymentAmount()
            , paymentMethod, $scope.paymentInfo.req4001, $scope.paymentInfo.req4005, $scope.paymentInfo.inspectStaffStatus, bjybMobilePaymentStatus).then(function (data) {
            console.log(data);
            //console.log(JSON.stringify(data));
            // 链接超时
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom("连接超时，请稍后重试");
            }
            // 调用失败
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 调用成功
            else if (data.result == 1) {
                $scope.opPaymentId = data.data.OP_PAYMENT_ID;
                // 支付异常
                if(data.payment_result == 0) {
                    //$fwCordovaToast.showShortBottom(data.msg);
                    $scope.isPaySuccess = false;
                    $scope.isChargeSuccess = false;

                }
                // 支付成功
                else {
                    $scope.isPaySuccess = true;
                    $scope.isChargeSuccess = true;
                    $scope.opPaymentErrorMsg.msg = "";
                    // 有检查预约
                    if ($scope.formatCheckApptInfo(data)) {
                        console.log(data.check_appt_list);
                        $scope.checkApptList = data.check_appt_list;
                    }
                }
                // 滑到下一页
                $scope.nextSlide();
            }
            // 待支付(微信/支付宝/BOBPAY)
            else if (data.result == 3) {
                $scope.opPaymentId = data.data.OP_PAYMENT_ID;

                switch (data.data.PAYMENT_ROUTE) {
                    case 1: case "1":       // 微信
                        callWXPay(data.data.APP_PAY_INFO);
                        break;
                    case 4: case "4":       // 北京银行银联
                        $scope.fromWeixin = false;
                        $scope.outTradeNo = data.data.APP_PAY_INFO;
                        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                        //$cordovaInAppBrowser.open(serviceUrl + "/Payment/OrderResult?orderId=" + data.data.APP_PAY_INFO, '_blank', option).then(function (event) { })
                        //2023.7.31 新插件原有调用方式参数不生效
                        var inapp = showInAppBrowser(serviceUrl + "/Payment/OrderResult?orderId=" + data.data.APP_PAY_INFO, '_blank');
                        // 添加状态监听器
                        inapp.addEventListener('exit', function (event) {
                            //console.log('InAppBrowser exit加载：' + event.url);
                            OnResume();
                        });
                        inapp.addEventListener('loadstart', function (event) {
                            //console.log('loadstart loadstart加载：' + event.url);
                            if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
                                if (event.url.endsWith("Success")) {
                                    WXPaySuccess(0);
                                } else if (event.url.endsWith("Failed")) {
                                    WXPayFailed(-2);
                                }
                                $cordovaInAppBrowser.close();
                            }
                        });
                        break;
                    case 6: case "6": // 支付宝
                        callAliPay(data.data.APP_PAY_INFO);
                        break;
                    case 10: case "10":// 北京医保APP
                        // 只是变量是支付成功，但其实不是真的成功
                        $scope.fromWeixin = false;
                        $scope.outTradeNo = data.data.APP_PAY_INFO;

                        // 暂时只支持支付宝小程序
                        $scope.bjybMobilePayment("zfb");
                        break;
                    default: // 其他
                        $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                        break;
                }
            }
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        });
    }

    // 格式化检查预约信息
    $scope.formatCheckApptInfo = function (data) {
        // 有检查预约
        if (data.check_appt_list != null) {
            // 格式化数据
            for (var i in data.check_appt_list) {
                // 检查日期
                if (data.check_appt_list[i].hasOwnProperty("ORDER_DATE") && data.check_appt_list[i]["ORDER_DATE"] != null && data.check_appt_list[i]["ORDER_DATE"].length > 0) {
                    data.check_appt_list[i]["ORDER_DATE_FORMAT"] = new Date(data.check_appt_list[i]["ORDER_DATE"]).Format("yyyy年M月d日");
                }
                // 注意事项
                if (data.check_appt_list[i].hasOwnProperty("PRECAUTIONS") && data.check_appt_list[i]["PRECAUTIONS"] != null && data.check_appt_list[i]["PRECAUTIONS"].length > 0) {
                    data.check_appt_list[i]["PRECAUTIONS_FORMAT"] = data.check_appt_list[i]["PRECAUTIONS"].split("|  ").join("").split("|");
                }
                // 温馨提示
                if (data.check_appt_list[i].hasOwnProperty("TIPS") && data.check_appt_list[i]["TIPS"] != null && data.check_appt_list[i]["TIPS"].length > 0) {
                    data.check_appt_list[i]["TIPS_FORMAT"] = data.check_appt_list[i]["TIPS"].split("|").join("").split("|");
                }
            }
            console.log(data.check_appt_list);
            return true;
        }
        return false;
    }

    // 2019年12月4日18:26:05 HM 支持缴费前检查预约
    // 获取检查预约列表
    $scope.getCheckItemSched = function (index) {
        // 先初始化一下
        $scope.changeCheckIndex = 0;
        $ionicLoading.show();
        // 再赋值
        $scope.changeCheckIndex = index;
        RequestService.getCheckItemSched($scope.vpSelect.HIS_CARD_NUM, $scope.opPaymentGroupList[$scope.changeCheckIndex].MEDICIAL_ITEM_ID).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        // 有记录
                        $scope.formatCheckItemSchedData(data.data);
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.formatCheckItemSchedData(data.data);
        })
    }

    // 格式化并赋值预约改期数据
    $scope.formatCheckItemSchedData = function (data) {
        // 格式化日期
        data.forEach(e => e["ORDER_DATE_FORMAT"] = new Date(e["ORDER_DATE"]).Format("yyyy-MM-dd"));
        // 先赋值 待选择日期后处理
        $scope.apptSchedDate = data;
        console.log($scope.apptSchedDate);
        // 可预约日期列表
        var dateList = new Set(data.map(e => e["ORDER_DATE_FORMAT"]));
        $scope.apptDate.dateList = Array.from(dateList).sort();
        if($scope.apptDate.dateList.length > 0) {
            $timeout(function () {
                $scope.apptDate.minDate = $scope.apptDate.dateList[0];
                $scope.apptDate.maxDate = $scope.apptDate.dateList[$scope.apptDate.dateList.length - 1];
                console.log($scope.apptDate.minDate + " - " + $scope.apptDate.maxDate);
            }, 0);
        }
        console.log($scope.apptDate.dateList);
        // 当前选择日期
        console.log($scope.opPaymentGroupList[$scope.changeCheckIndex]);
        var dateTarget = $scope.opPaymentGroupList[$scope.changeCheckIndex].preDate;
        // 格式化
        if (dateTarget != null && dateTarget.length > 0) {
            dateTarget = dateTarget.substring(0, dateTarget.length - 1);
            dateTarget = dateTarget.replace('年', '-');
            dateTarget = dateTarget.replace('月', '-');
            //dateTarget = new Date(dateTarget).Format("yyyy-MM-dd");
        }
        console.log(dateTarget);
        $scope.apptDate.target = dateTarget;
        // 深度制 脏检测
        $scope.apptDate.targetOri = dateTarget;
        // 时段
        $scope.apptDate.targetTime = $scope.opPaymentGroupList[$scope.changeCheckIndex].preTime;
        $scope.apptDate.targetTimeOri = $scope.opPaymentGroupList[$scope.changeCheckIndex].preTime;
        // 预约改期模态窗口显示
        $scope.changeApptDateShow();
    }

    // 弹出选择时段
    $scope.selectTimeShow = function () {
        console.log("改期: " + $scope.apptDate.targetOri + " => " + $scope.apptDate.target);
        // 过滤ActionSheet的数据源
        var arrTime = $scope.apptSchedDate.filter(e => e["ORDER_DATE_FORMAT"] == $scope.apptDate.target);
        // 遍历生成按钮
        var arrButton = [];
        arrTime.forEach(e => {
            var str = e["ORDER_TIME"];
            // 判断预约状态 加后缀和样式
            if (e["ORDER_STATUS"] == "0") {
                str += " (可预约)";
                str = '<span>' + str + '</span>';
            }
            else {
                str += " (已约满)";
                str = '<span class="fw-action-sheet-error">' + str + '</span>';
            }
            arrButton.push({ text: str });
        });
        console.log(arrButton);
        // 弹出透明loading防止快速连击关闭modal
        $ionicLoading.show({template: " "});
        // 确定标识
        var isOk = false;
        // 弹出ActionSheet
        var hideSheet = $ionicActionSheet.show({
            buttons: arrButton,
            titleText: "选择预约时段",
            cancelText: "取消",
            cancel: function () {
                // 未选择时段 回滚日期
                if (!isOk) {
                    // 读取缓存
                    if ($scope.apptDate.targetCache == "") {
                        $scope.apptDate.targetCache = $scope.apptDate.targetOri;
                    }
                    $scope.apptDate.target = $scope.apptDate.targetCache;
                }
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            },
            buttonClicked: function (index) {
                // 约满
                if (arrTime[index]["ORDER_STATUS"] == "1") {
                    return false;
                }
                console.log(arrTime[index]);
                $scope.apptDate.targetTime = arrTime[index]["ORDER_TIME"];
                $scope.apptDate.timeAreaId = arrTime[index]["TIME_AREA_ID"];
                // 写入缓存
                $scope.apptDate.targetCache = $scope.apptDate.target;
                isOk = true;
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            }
        });
    }

    // 检查预约改期提交
    $scope.checkApptUpdate = function () {
        // 提交改期申请
        $ionicLoading.show();
        console.log($scope.apptDate.target);

        RequestService.checkApptUpdate($scope.vpSelect.HIS_CARD_NUM, "", $scope.apptDate.target, $scope.apptDate.timeAreaId, $scope.opPaymentGroupList[$scope.changeCheckIndex].CHECK_LIST_NUM).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        console.log(data);
                        // 改期成功
                        if (data.data[0].UPDATE_RESULT == "True") {
                            // 关闭就完了
                            $scope.opPaymentGroupList[$scope.changeCheckIndex].preDate = new Date($scope.apptDate.target).Format("yyyy年MM月dd日");
                            $scope.opPaymentGroupList[$scope.changeCheckIndex].preTime = $scope.apptDate.targetTime;
                            $scope.changeApptDateHide();
                        }
                        // 失败
                        else {
                            $fwCordovaToast.showShortBottom(data.data[0].ERROR_MSG);
                        }
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            console.log(data);
            // 改期成功
            if (data.data[0].UPDATE_RESULT == "True") {
                // 关闭就完了
                $scope.opPaymentGroupList[$scope.changeCheckIndex].preDate = new Date($scope.apptDate.target).Format("yyyy年MM月dd日");
                $scope.opPaymentGroupList[$scope.changeCheckIndex].preTime = $scope.apptDate.targetTime;
                $scope.changeApptDateHide();
            }
            // 失败
            else {
                $fwCordovaToast.showShortBottom(data.data[0].ERROR_MSG);
            }
        })
    }

    // 预约改期模态窗口显示
    $scope.changeApptDateShow = function () {
        $scope.isChangingDate = true;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
        $scope.changeApptDateModal.show();
        $ionicScrollDelegate.$getByHandle('changeApptDate').scrollTop();
    }

    // 预约改期模态窗口隐藏
    $scope.changeApptDateHide = function () {
        $scope.changeApptDateModal.hide();
        $scope.isChangingDate = false;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
    }
    
    //#region 支付宝
    // 调用支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        $scope.outTradeNo = aliBizContent.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 支付成功
    function AliPaySuccess(statusCode) {
        $ionicLoading.show();
        $scope.resultShow = {};
        $scope.appResult = "";
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                // 支付成功
                $scope.isPaySuccess = true;
                $scope.appResult = "0";
                $scope.resultShow = data.data;
                // 查询缴费状态
                OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (data) {
                    $ionicLoading.hide();
                    // 获取成功 result = 1
                    if (data.result == 1) {
                        // 缴费成功
                        if (data.payment_result == 1) {
                            $scope.isChargeSuccess = true;
                            $scope.opPaymentErrorMsg.msg = "";
                            // 有检查预约
                            if ($scope.formatCheckApptInfo(data)) {
                                console.log(data.check_appt_list);
                                $scope.checkApptList = data.check_appt_list;
                            }
                        }
                        // 缴费失败
                        else {
                            $scope.isChargeSuccess = false;
                            $scope.opPaymentErrorMsg.msg = data.msg;
                        }
                        $scope.toSlide(4);
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                })
            }
            // 
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.appResult = "-1";
                $scope.opPaymentErrorMsg.msg = data.msg;
                $scope.toSlide(4);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('获取订单状态失败');
            $scope.opPaymentErrorMsg.msg = "获取订单状态失败";
            $scope.toSlide(4);
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        switch (statusCode.resultStatus) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }
        $fwCordovaToast.showShortBottom(errMsg);
        // 支付失败
        $scope.isPaySuccess = false;
        $scope.opPaymentErrorMsg.msg = errMsg;
        $scope.toSlide(4);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $ionicLoading.hide();
    }
    //#endregion

    //#region 微信支付
    // 分平台调用微信支付插件
    function callWXPay(paydata) {
        $scope.outTradeNo = paydata.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 支付成功
    function WXPaySuccess(statusCode) {
        $ionicLoading.show();
        $scope.resultShow = {};
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                // 支付成功
                $scope.isPaySuccess = true;
                $scope.resultShow = data.data;
                // 查询缴费状态
                OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (data) {
                    $ionicLoading.hide();
                    // 获取成功 result = 1
                    if (data.result == 1) {
                        // 缴费成功
                        if (data.payment_result == 1) {
                            $scope.isChargeSuccess = true;
                            $scope.opPaymentErrorMsg.msg = "";
                            // 有检查预约
                            if ($scope.formatCheckApptInfo(data)) {
                                console.log(data.check_appt_list);
                                $scope.checkApptList = data.check_appt_list;
                            }
                        }
                        // 缴费失败
                        else {
                            $scope.isChargeSuccess = false;
                            $scope.opPaymentErrorMsg.msg = data.msg;
                        }
                        $scope.toSlide(4);
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                })
            }
            //
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.opPaymentErrorMsg.msg = data.msg;
                $scope.toSlide(4);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('获取订单状态失败');
            $scope.opPaymentErrorMsg.msg = "获取订单状态失败";
            $scope.toSlide(4);
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function WXPayFailed(statusCode) {
        $scope.appResult = statusCode;
        $fwCordovaToast.showShortBottom(-1 == statusCode ? "支付错误" : "用户取消或支付超时");
        // 支付失败
        $scope.isPaySuccess = false;
        $scope.opPaymentErrorMsg.msg = -1 == statusCode ? "支付错误" : "用户取消或支付超时";
        $scope.toSlide(4);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $ionicLoading.hide();
    }

    // 后台唤醒 取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $ionicLoading.show();
                $scope.resultShow = {};
                // 查询支付状态
                PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
                    // 真·支付成功
                    if (data.result == 1) {
                        $fwCordovaToast.showShortBottom('支付成功');
                        // 支付成功
                        $scope.isPaySuccess = true;
                        $scope.resultShow = data.data;
                        // 查询缴费状态
                        OpPaymentService.opPaymentStatus($scope.opPaymentId).then(function (data) {
                            $ionicLoading.hide();
                            // 获取成功 result = 1
                            if (data.result == 1) {
                                // 缴费成功
                                if (data.payment_result == 1) {
                                    $scope.isChargeSuccess = true;
                                    $scope.opPaymentErrorMsg.msg = "";
                                    // 有检查预约
                                    if ($scope.formatCheckApptInfo(data)) {
                                        console.log(data.check_appt_list);
                                        $scope.checkApptList = data.check_appt_list;
                                    }
                                }
                                // 缴费失败
                                else {
                                    $scope.isChargeSuccess = false;
                                    $scope.opPaymentErrorMsg.msg = data.msg;
                                }
                                $scope.toSlide(4);
                            }
                            // 获取失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        }, function (data) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(data.msg);
                        })
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "0").then(function (data) {
                            ;
                        });
                    }
                    //
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom('支付失败');
                        // 支付失败
                        $scope.isPaySuccess = false;
                        $scope.opPaymentErrorMsg.msg = "支付失败";
                        $scope.toSlide(4);
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "-1").then(function (data) {
                            ;
                        });
                    }
                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;
                    $scope.outTradeNo = "";
                    $scope.appResult = "";
                    $ionicLoading.hide();
                });
            }
        }, 1000);
    }
    //#endregion
    
    //#region 北京银行银联
    // 监听inAppBrowser页面跳转，若到支付结果页，关闭inAppBrowser并跳转结果页面
    $rootScope.$on("$cordovaInAppBrowser:loadstart", function (e, event) {
        if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
            if (event.url.endsWith("Success")) {
                WXPaySuccess(0);
            } else if (event.url.endsWith("Failed")) {
                WXPayFailed(-2);
            }

            $cordovaInAppBrowser.close();
        }
    })

    // 用户直接关闭弹出支付Browser处理
    $rootScope.$on("$cordovaInAppBrowser:exit", function (e, event) {
        OnResume();
    })
    //#endregion

    // 获取卡号条形码
    $scope.getCardCodeBarcode = function () {
        PersonalService.getCardCodeBarcode($scope.vpSelect.VISIT_PATIENT_ID, "").then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.cardCodeBarcode.src = "data:image/jpeg;base64," + data.data;
            }
            // 获取失败
            else {
                $scope.cardCodeBarcode.src = "";
            }
        }, function (data) {
            $scope.cardCodeBarcode.src = "";
        });
    }

    // 检查预约详情模态窗口显示
    $scope.checkApptDetailShow = function (index) {
        $scope.checkApptIndex = index;
        $scope.checkApptDetailModal.show();
        $ionicScrollDelegate.$getByHandle('checkAppt').scrollTop();
        console.log($scope.checkApptList);
        console.log($scope.checkApptIndex);
    }
    // 检查预约详情模态窗口隐藏
    $scope.checkApptDetailHide = function () {
        $scope.checkApptDetailModal.hide();
        $scope.checkApptIndex = 0;
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // 新增：选择这张卡
    $scope.bindThisCard = function (index) {
        $ionicPopup.confirm({
            title: '选择绑卡确认',
            template: '是否绑定此就诊卡?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                bindCardSelectSubmit(index);
            }
            else { }
        });
    }

    // 新增：选卡=>绑它
    bindCardSelectSubmit = function (index) {
        if (index < 0 || index >= $scope.cardList.length || $scope.cardList[index] == null
            || $scope.cardList[index].PATIENT_ID == null || $scope.cardList[index].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardSelectV2($scope.vpSelect.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 这里出来是半绑卡状态
                VisitPatientService.getPhoneAndCardNum($scope.requestId, $scope.vpSelect.VISIT_PATIENT_ID, $scope.cardList[index].PATIENT_ID).then(function (result) {
                    $ionicLoading.hide();
                    if (result.result == 1) {
                        // 拿到了手机号+卡号
                        var phone = result.phone_num;
                        var card_num = result.card_num;

                        if (phone == "" || card_num == "") {
                            $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                        }
                        else {
                            // 手机号
                            $scope.vpBind.phone_num = phone;
                            // 卡号
                            $scope.vpBind.card_num = card_num;

                            // 带*手机号
                            $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                            // 带*卡号
                            $scope.vpBind.card_num_show = result.card_num_show;

                            $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
                            $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;

                            // 获取图片验证码
                            $scope.getImageVericode();
                            $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");

                            // 上一步是选卡
                            $scope.lastSelectCard = true;
                            // 选卡模态窗关闭
                            $scope.chooseCardModalHide();
                            // 绑卡 开
                            $scope.bindCardModal.show();
                        }
                    }
                })
            }
        })
    }

    // 跳转至门诊缴费明细
    $scope.goOpConsumption = function () {
        $state.go("app.opConsumption", { vpid: $scope.vpSelect.VISIT_PATIENT_ID, from: "app.opPayment" });
    }

    // 跳转小程序
    $scope.bjybMobilePayment = function (type) {
        // 先去找首信，请求所需的参数
        $ionicLoading.show();
        OpPaymentService.bjybMobilePayment($scope.vpSelect.VISIT_PATIENT_ID, $scope.opPaymentId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 跳转小程序的路径url
                $scope.bjybHerfUrl(type, data.url);
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 医保移动支付跳转
    $scope.bjybHerfUrl = function (type, url) {
        if (type == "zfb") {
            // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
            var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent(url));

            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser(herfUrl, '_system');

            document.addEventListener("resume", OnResume, false);

            // var param = { type: "BJYB", url: pageUrl };

            // var funcSuccess = function (data) {
            //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用成功");
            //     console.log(data);
            // }
            // var funcError = function (data) {
            //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用失败");
            //     console.log(data);
            // }

            // window.plugins.MiniProgramPlugin.launchZFBMiniProgramByPageUrl(param, funcSuccess, funcError);
        }
        else {
            $fwCordovaToast.showShortBottom("暂不支持微信小程序");
        }
    }

    // 医保移动支付，是否可选
    $scope.ybPayEnable = function () {
        return (isYBAppPay || $scope.filterPaymentMethod('10') != null) && $scope.healthCareType == '3';
    }

    // 医保移动支付，补医师服务费
    $scope.medicalService = function (msFee, zero, serviceType) {
        console.log(msFee);
        console.log(zero);

        if (serviceType == "0") {
            //收银台
            $scope.cashier("medicalService", 0, $scope.vpSelect.VISIT_PATIENT_ID, "", "", $scope.paymentInfo.strFeeItemCode, zero.doctorCode, true, "", "", "", serviceType, ""
                , "", zero.doctorLevel, "").then(function (dataCashier) {

                    // 支付成功
                    if (dataCashier.code == 1) {
                        // 刷一下4005
                        $scope.checkOrder("1");
                    }
                })
        }
        else {
            //收银台
            $scope.cashier("medicalService", msFee.MEDICAL_SERVICE_FEE, $scope.vpSelect.VISIT_PATIENT_ID, "", "", $scope.paymentInfo.strFeeItemCode, msFee.DOCTOR_CODE, true, "", "", "", serviceType, msFee.DOCTOR_NAME
            , msFee.MEDICAL_SERVICE_DATE, msFee.REG_LEVEL_CODE, msFee.REG_LEVEL_NAME).then(function (dataCashier) {
                // 支付成功
                if (dataCashier.code == 1) {
                    // 刷一下4005
                    $scope.checkOrder("1");
                }
            })
        }
    }

    //#region 初始化
    // 加载就诊人列表
    $scope.loadVpList = function () {
        $scope.initAjaxCount++;
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            $scope.initAjaxCount--
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log($scope.vpList);
                //console.log($scope.inVpid);
                // 指定就诊人
                if ($scope.inVpid != null && $scope.inVpid != "") {
                    var index = 0;
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.inVpid) {
                            index = i;
                        }
                    }
                    // 跳过同意页
                    $scope.nextSlide();
                    // 选择对应就诊人
                    $scope.selectVp(index);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initAjaxCount == 0 && $scope.from != "app.olTreatVideo" && $scope.from != "app.opPendingCheck") {
                $ionicLoading.hide();
            }
        })
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOpPayment.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'opPayment');
        $ionicLoading.show();
        // 检查预约挂号开关
        OpPaymentService.checkServerStatus().then(function (data) {
            // 开放
            if (data.result == 1) {
                $scope.isServerOn = true;
                $scope.serverStatusDescr = "";
            }
            // 关闭
            else if (data.result == -99) {
                // 如果有检查单号过来，当开放处理
                if ($scope.rlatObjId != "") {
                    $scope.isServerOn = true;
                    $scope.serverStatusDescr = "";
                }
                else {
                    $scope.isServerOn = false;
                    $scope.serverStatusDescr = data.msg
                    $fwCordovaToast.showShortBottom($scope.serverStatusDescr);
                }
            }
            // 异常
            else {
                $scope.isServerOn = false;
                $scope.serverStatusDescr = "网络异常，请稍后重试";
                $fwCordovaToast.showShortBottom($scope.serverStatusDescr);
            }
        }, function (data) {
            $scope.isServerOn = false;
            $scope.serverStatusDescr = "网络异常，请稍后重试";
            $fwCordovaToast.showShortBottom($scope.serverStatusDescr);
        })
        // 获取可选择支付方式
        PaymentService.getPaymentRoute().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $rootScope.paymentRouteList = data.data;
                $scope.paymentRouteListYB = data.ybData;
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        // 获取用户须知信息
        OpPaymentService.agreement().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.agreement.opPaymentDescription = data.data;
                // 开启用户须知倒计时
                $interval(function () { $scope.confirmCountdown -= 1; }, 1000, 10)
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
        // 加载就诊人列表
        $scope.loadVpList();

        //设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if(data.result == 1){
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else{
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
        //    }
        //})

    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'opPayment') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
    //#endregion 
})
