angular.module('fwapp.controllers')

// 待检项目列表
.controller('OpPendingCheckController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
, RequestService, VisitPatientService, ReportService, AccountService, ChangePhoneNumberService, PersonalService) {

    // 检查登录状态
    $rootScope.checkLogin();

    // 传进来的vpId
    $scope.vpId = $stateParams.vpid;

    // 待检项目列表数组
    $scope.pendingCheckList = [];

    // 就诊人信息
    $scope.vpInfo = new Object();
    
    //手机验证后直接进入
    $scope.thisResultFunc = "";
    $scope.thisResultReportType = "";
    $scope.thisResultTestOrderName = "";
    $scope.thisResultInspectionId = "";
    $scope.thisResultIDP = "";
    $scope.thisResultRepName = "";
    $scope.thisResultTestSamplingTime = "";
    $scope.thisResultTestSampleClassName = "";
    
    $scope.reqId = '';
    $scope.watermark = {};

    // 检查结果
    $scope.checkResult = {
        INDEX: 0,
        REPORT_IMAGE: '',
        TITLE: "我的检查检验"
    }
    // LIS结果
    $scope.lisResult = {
        INDEX: 0,
        TEST_ORDER_NAME: '',
        SAMPLING_TIME: '',
        SAMPLE_CLASS_NAME: '',
        LIS_RESULT: []
    }
    // 检查报告图像
    $scope.imgCheckResult = {};
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);

    // 检验是否有异常
    $scope.screenFlag = true;
    $scope.showAvailable = false;

    // 注意事项
    $scope.zysx = "";

    // lis需要的加载完成
    $scope.isLoadFinish = false;

    // 检查列表需要的加载完成
    $scope.loadFinish = false;

    // 检查可改约日期数据
    $scope.apptSchedDate = [];

    // 检查预约日期 给控件用的
    $scope.apptDate = {};
    $scope.apptDate.target = "";
    $scope.apptDate.targetOri = "";
    $scope.apptDate.dateMode = "white";
    $scope.apptDate.dateList = [];
    $scope.apptDate.minDate = "1970-01-01";
    $scope.apptDate.maxDate = "1970-01-01";
    // 缓存
    $scope.apptDate.targetCache = "";
    // 改期时段
    $scope.apptDate.targetTime = "";
    $scope.apptDate.targetTimeOri = "";
    // 改期时段ID
    $scope.apptDate.timeAreaId = "";
    // 是否正在改期
    $scope.isChangingDate = false;
    // 改约顺序
    $scope.checkApptIndex = -1;

    // 注册模态窗口:检查结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultModal = modal;
    });

    // 注册模态窗口:LIS结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('lis_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.lisResultModal = modal;
    });

    // 注册模态窗口：注意事项
    $ionicModal.fromTemplateUrl('attentionInfo.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.attentionInfoModal = modal;
    });

    // 注册模态窗口：预约改期
    $ionicModal.fromTemplateUrl('changeApptDate.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.changeApptDateModal = modal;
    });

    // 注销模态窗口
    $scope.$on('$destroy', function () {
        $scope.checkResultModal.remove();
        $scope.lisResultModal.remove();
        $scope.attentionInfoModal.remove();
        $scope.changeApptDateModal.remove();
    });

    // 0.读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;

                // 获取待检项目列表
                $scope.getOpPendingCheckList();
            }
        })
    }

    // 1.获取待检项目列表
    $scope.getOpPendingCheckList = function () {
        $scope.pendingCheckList = [];
        $scope.loadFinish = false;

        $ionicLoading.show();
        RequestService.opPendingCheck($scope.vpId).then(function (data) {
            console.log(data);

            $ionicLoading.hide();
            if (data.result != 1 || data.is_null == 1 || data.data == null) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络错误，获取待检项目列表失败",
                    okText: "确定"
                });
            }
            else {
                $scope.pendingCheckList = data.data;
                for (var i = 0; i < $scope.pendingCheckList.length; i++){
                    $scope.pendingCheckList[i].PoiCode = "";
                    $scope.pendingCheckList[i].PoiName = "";

                    // 时间格式化
                    $scope.pendingCheckList[i].DUEDATE = new Date($scope.pendingCheckList[i].DUEDATE).Format("yyyy-MM-dd");

                    $scope.getNavigate($scope.pendingCheckList[i].CHECK_QUEUE_NAME, i);
                }
            }
            $scope.loadFinish = true;
        }, function () {
            $scope.loadFinish = true;
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，获取待检项目列表失败",
                okText: "确定"
            });
            $ionicLoading.hide();
        })
    }

    // 2.去缴费
    $scope.toOpPayment = function () {
        // 跳转至门诊缴费
        $state.go("app.opPayment", { from: "app.opPendingCheck", vpid: $scope.vpId });
    }

    // 3.查看报告
    $scope.toReport = function (jclx, reportType, testOrderName, inspectionId, idp, repName, samplingTime, sampleClassName) {
        // 检查结果
        $scope.checkResult = {
            REPORT_IMAGE: '',
            TITLE: '我的检查检验'
        }

        $scope.thisResultFunc = "";
        $scope.thisResultReportType = "";
        $scope.thisResultTestOrderName = "";
        $scope.thisResultInspectionId = "";
        $scope.thisResultIDP = "";
        $scope.thisResultRepName = "";
        $scope.thisResultTestSamplingTime = "";
        $scope.thisResultTestSampleClassName = "";

        $scope.screenFlag = true;
        $scope.showAvailable = false;

        $scope.queryPassword().then(function (data) {
            if (data){
                $scope.thisResultFunc = jclx;
                $scope.thisResultReportType = reportType;
                $scope.thisResultTestOrderName = testOrderName;
                $scope.thisResultInspectionId = inspectionId;
                $scope.thisResultIDP = idp;
                $scope.thisResultRepName = repName;
                $scope.thisResultTestSamplingTime = samplingTime;
                $scope.thisResultTestSampleClassName = sampleClassName;
        
                if (jclx == "检查"){
                    $scope.getCheckInfo();
                }
                else if (jclx == "化验"){
                    $scope.getLisInfo();
                    $scope.lisResultModal.show();
                    AccountService.getWatermark().then(function (data) {
                        $scope.watermark = data.data;
                    });
                }
            }
        })
    }

    // 3.1 获取检查图片
    $scope.getCheckInfo = function () {
        $ionicLoading.show();
        // 查询是否会乱码
        ReportService.isErrorCheckResult($scope.vpId, $scope.thisResultReportType).then(function (data) {
            // 直接看
            if (data.result == 1){
                RequestService.checkResult($scope.vpId, $scope.thisResultIDP, $scope.thisResultRepName, localStorage.queryToken).then(function (checkResultData) {
                    $scope.checkResultModal.show();
                    $ionicLoading.hide();
                    $scope.reqId = checkResultData.reqId;
                    if (checkResultData.result == 99) {    // 链接超时
                        $fwCordovaToast.showShortBottom("连接超时，请重试");
                        return;
                    }
                    if (checkResultData.result == -2) {
                        $scope.queryPassword().then(function (data) {
                            if (data) {
                                $scope.getCheckInfo();
                            }
                        })
                        return;
                    }
                    if (checkResultData.result != 1 && checkResultData.result != -1) {  // 请求错误
                        $fwCordovaToast.showShortBottom(checkResultData.msg);
                        return;
                    }
                    if (checkResultData.is_null == 1) { // 空结果
                        return;
                    }
                    // 有结果 显示base64图片
                    $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + checkResultData.data;
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, function (err) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                })
            }
            // 乱码了
            else if (data.result == 2) {
                $ionicLoading.hide();
                $ionicPopup.confirm({
                    title: '提示',
                    template: data.msg,
                    okText: '下载',
                    cancelText: '取消'
                }).then(function (res) {
                    // 下载PDF
                    if (res) {
                        $ionicLoading.show();
                        RequestService.checkResult($scope.vpId, $scope.thisResultIDP, $scope.thisResultRepName, localStorage.queryToken).then(function (checkResultData) {
                            $ionicLoading.hide();
                            if (checkResultData.result == 99) {    // 链接超时
                                $fwCordovaToast.showShortBottom("连接超时，请重试");
                                return;
                            }
                            if (checkResultData.result == -2) {
                                $scope.queryPassword().then(function (data) {
                                    if (data) {
                                        $scope.getCheckInfo();
                                    }
                                })
                                return;
                            }
                            if (checkResultData.result != 1 && checkResultData.result != -1) {  // 请求错误
                                $fwCordovaToast.showShortBottom(checkResultData.msg);
                                return;
                            }
                            if (checkResultData.is_null == 1) { // 空结果
                                return;
                            }
                            // 有结果 执行下载PDF
                            $scope.downloadPDF(checkResultData.reqId);
                        }, function (err) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("连接超时，请重试");
                        });
                    }
                })
            }
            else {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
        }, function () {
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: '当前请求失败，请稍后再试',
                okText: "确定"
            });
            return;
        })
    }

    // 3.2 获取LIS检验结果
    $scope.getLisInfo = function () {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        RequestService.lisResult($scope.vpId, $scope.thisResultInspectionId, localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getLisInfo();
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.reqId = data.data[0].REQUEST_ID;
            $scope.lisResult.INDEX = 0;
            $scope.lisResult.TEST_ORDER_NAME = $scope.thisResultTestOrderName;
            $scope.lisResult.SAMPLING_TIME = $scope.thisResultTestSamplingTime;
            $scope.lisResult.SAMPLE_CLASS_NAME = $scope.thisResultTestSampleClassName;
            $scope.lisResult.LIS_RESULT = data.data;

            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        });
    }

    //#region 查看报告方法

     // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            var src = $("#imgCheckResultOrigin").prop("src");
            // 防止赋值不同步
            if (src == "") {
                $timeout(function () {
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, 0);
                return;
            }
            // 无图片
            if ($("#imgCheckResult").length != 1) {
                return;
            }
            // 初始化
            if ($("#divCheckResult>#imgCheckResult").length == 0) {
                // 还原节点位置
                $("#divCheckResult").append($("#imgCheckResult"));
                // 删除控件
                //$("#divCheckResult .pinch-zoom-container").remove();
                // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
                $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            }
            // 复制图片路径
            $("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgCheckResult");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgCheckResult = new PinchZoom.default(img, zoomOptions);
            $scope.imgCheckResult.enable();
            console.log($scope.imgCheckResult);
        }, 0);
    }

    // 关闭检查结果
    $scope.checkResultHide = function () {
        $scope.checkResultModal.hide();
        $scope.checkResult = {
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
    }

    //下载PDF
    $scope.downloadPDF = function (reqId) {
        $ionicLoading.show();
        if (reqId != null && reqId.length > 0) {
            var resultFunc = "";
            if ($scope.thisResultFunc == "检查") {
                resultFunc = "check";
            }
            else {
                resultFunc = "lis";
            }

            ReportService.saveDownloadRecord($scope.vpId, resultFunc, reqId,
                resultFunc == "lis" ? $scope.thisResultTestOrderName : $scope.thisResultReportType, 
                "PDF",
                resultFunc == "lis" ? $scope.thisResultInspectionId : $scope.thisResultIDP).then(function(data) {
                    $scope.downloadId = data.downloadId;
                    RequestService.downloadPDF(reqId, $scope.vpId).then(function(dataPdf) {
                        if (dataPdf.result == 1) {
                            ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 1);
                            var url = dataPdf.data;
                            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                            //$cordovaInAppBrowser.open(url, '_system', '').then(function (event) {});
                            //2023.7.31 新插件原有调用方式参数不生效
                            showInAppBrowser(url, '_system');

                            $ionicLoading.hide();
                            return;
                        }
                        // 链接超时
                        else if (dataPdf.result == 99) {
                            ReportService.changeDownloadStatus($scope.vpId,$scope.downloadId,2);
                            
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("连接超时，请重试");
                            return;
                        }
                        else {
                            ReportService.changeDownloadStatus($scope.vpId,$scope.downloadId,2);
                            
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                            return;
                        }
                    }, function(errPdf) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    });
              }, function(err) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
              });
        }
        else {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
            return;
        }
    }

    // 关闭LIS结果查看
    $scope.lisResultHide = function () {
        $scope.lisResultModal.hide();
        $scope.lisResult = {
            INDEX: 0,
            TEST_ORDER_NAME: '',
            SAMPLING_TIME: '',
            SAMPLE_CLASS_NAME: '',
            LIS_RESULT: []
        }
    }

    // 仅显示异常
    $scope.screen = function () {
        $scope.screenFlag = !$scope.screenFlag;
        $scope.showAvailable = !$scope.showAvailable;
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    //#endregion
   
    // 4.导航
    $scope.getNavigate = function (aliasName, index) {
        PersonalService.getNavigateCode(aliasName).then(function (data){
            if(data.result == 1){
                $scope.pendingCheckList[index].PoiName = data.data.PoiName;
                $scope.pendingCheckList[index].PoiCode = data.data.PoiCode;
            }
        })
    }

    // 5.注意事项
    $scope.attentionInfo = function (zysx) {
        $scope.zysx = zysx;
        $scope.attentionInfoModal.show();
    }

    $scope.attentionInfoHide = function () {
        $scope.zysx = "";
        $scope.attentionInfoModal.hide();
    }

    // 6.改约
    $scope.getCheckItemSched = function (index) {
        $scope.checkApptIndex = index;

        // 不可改期
        if ($scope.pendingCheckList[$scope.checkApptIndex].CAN_MODIFY != "1") {
            if ($scope.pendingCheckList[$scope.checkApptIndex].CAN_NOT_MODIFY_MSG != "") {
                $fwCordovaToast.showShortBottom($scope.pendingCheckList[$scope.checkApptIndex].CAN_NOT_MODIFY_MSG);
            }
            return;
        }

        $ionicLoading.show();
        RequestService.getCheckItemSched($scope.pendingCheckList[$scope.checkApptIndex].PATIENT_ID, $scope.pendingCheckList[$scope.checkApptIndex].GROUPID + "|" + $scope.pendingCheckList[$scope.checkApptIndex].CHECK_POINT).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        // 有记录
                        $scope.formatCheckItemSchedData(data.data);
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.formatCheckItemSchedData(data.data);
        })
    }

    // 格式化并赋值预约改期数据
    $scope.formatCheckItemSchedData = function (data) {
        // 格式化日期
        data.forEach(e => e["ORDER_DATE_FORMAT"] = new Date(e["ORDER_DATE"]).Format("yyyy-MM-dd"));
        // 先赋值 待选择日期后处理
        $scope.apptSchedDate = data;
        console.log($scope.apptSchedDate);
        // 可预约日期列表
        var dateList = new Set(data.map(e => e["ORDER_DATE_FORMAT"]));
        $scope.apptDate.dateList = Array.from(dateList).sort();
        if($scope.apptDate.dateList.length > 0) {
            $timeout(function () {
                $scope.apptDate.minDate = $scope.apptDate.dateList[0];
                $scope.apptDate.maxDate = $scope.apptDate.dateList[$scope.apptDate.dateList.length - 1];
                console.log($scope.apptDate.minDate + " - " + $scope.apptDate.maxDate);
            }, 0);
        }
        console.log($scope.apptDate.dateList);
        // 当前选择日期
        var dateTarget = $scope.pendingCheckList[$scope.checkApptIndex].DUEDATE;
        // 格式化
        if (dateTarget != null && dateTarget.length > 0) {
            dateTarget = new Date(dateTarget).Format("yyyy-MM-dd");
        }
        $scope.apptDate.target = dateTarget;
        // 深度制 脏检测
        $scope.apptDate.targetOri = dateTarget;
        // 时段
        $scope.apptDate.targetTime = $scope.pendingCheckList[$scope.checkApptIndex].DUETIME;
        $scope.apptDate.targetTimeOri = $scope.pendingCheckList[$scope.checkApptIndex].DUETIME;
        // 预约改期模态窗口显示
        $scope.changeApptDateShow();
    }
    // 预约改期模态窗口显示
    $scope.changeApptDateShow = function () {
        $scope.isChangingDate = true;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
        $scope.changeApptDateModal.show();
        $ionicScrollDelegate.$getByHandle('changeApptDate').scrollTop();
    }
    // 预约改期模态窗口隐藏
    $scope.changeApptDateHide = function () {
        $scope.changeApptDateModal.hide();
        $scope.isChangingDate = false;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
    }
    // 弹出选择时段
    $scope.selectTimeShow = function () {
        console.log("改期: " + $scope.apptDate.targetOri + " => " + $scope.apptDate.target);
        // 过滤ActionSheet的数据源
        var arrTime = $scope.apptSchedDate.filter(e => e["ORDER_DATE_FORMAT"] == $scope.apptDate.target);
        // 遍历生成按钮
        var arrButton = [];
        arrTime.forEach(e => {
            var str = e["ORDER_TIME"];
            // 判断预约状态 加后缀和样式
            if (e["ORDER_STATUS"] == "0") {
                str += " (可预约)";
                str = '<span>' + str + '</span>';
            }
            else {
                str += " (已约满)";
                str = '<span class="fw-action-sheet-error">' + str + '</span>';
            }
            arrButton.push({ text: str });
        });
        console.log(arrButton);
        // 弹出透明loading防止快速连击关闭modal
        $ionicLoading.show({template: " "});
        // 确定标识
        var isOk = false;
        // 弹出ActionSheet
        var hideSheet = $ionicActionSheet.show({
            buttons: arrButton,
            titleText: "选择预约时段",
            cancelText: "取消",
            cancel: function () {
                // 未选择时段 回滚日期
                if (!isOk) {
                    // 读取缓存
                    if ($scope.apptDate.targetCache == "") {
                        $scope.apptDate.targetCache = $scope.apptDate.targetOri;
                    }
                    $scope.apptDate.target = $scope.apptDate.targetCache;
                }
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            },
            buttonClicked: function (index) {
                // 约满
                if (arrTime[index]["ORDER_STATUS"] == "1") {
                    return false;
                }
                console.log(arrTime[index]);
                $scope.apptDate.targetTime = arrTime[index]["ORDER_TIME"];
                $scope.apptDate.timeAreaId = arrTime[index]["TIME_AREA_ID"];
                // 写入缓存
                $scope.apptDate.targetCache = $scope.apptDate.target;
                isOk = true;
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            }
        });
    }
    // 检查预约改期提交
    $scope.checkApptUpdate = function () {
        // 提交改期申请
        $ionicLoading.show();
        console.log($scope.apptDate);
        RequestService.checkApptUpdate($scope.pendingCheckList[$scope.checkApptIndex].PATIENT_ID, $scope.pendingCheckList[$scope.checkApptIndex].YYID
            , $scope.apptDate.target, $scope.apptDate.timeAreaId).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        console.log(data);
                        // 改期成功
                        if (data.data[0].UPDATE_RESULT == "True") {
                            // 重新获取列表
                            $scope.changeApptDateHide();
                            $scope.getOpPendingCheckList();
                        }
                        // 失败
                        else {
                            // 2021-4-11 12:31:35 HM 改成popup的alert
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.data[0].ERROR_MSG,
                                okText: "确定"
                            });
                        }
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请重试",
                    okText: "确定"
                });
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            console.log(data);
            // 改期成功
            if (data.data[0].UPDATE_RESULT == "True") {
                // 重新获取列表
                $scope.changeApptDateHide();
                $scope.getOpPendingCheckList();
            }
            // 失败
            else {
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: data.data[0].ERROR_MSG,
                    okText: "确定"
                });
            }
        })
    }




    // 返回
    $scope.goBack = function () {
        $state.go("app.dealWithCard", { go: "opPendingCheck" });
    }

    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'subVisit');

        // 读取就诊人信息
        $scope.loadVPInfo();
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'opPendingCheck') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
