﻿angular.module('fwapp.controllers')

.controller('OpQuestionnaireController', function ($scope, $rootScope, $state, $stateParams, $timeout,
    SrvyService,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet, $ionicModal, $ionicPopover,
    $cordovaFileTransfer, $cordovaCamera, $cordovaDatePicker, $fwCordovaToast) {

    // 问卷类型
    $scope.type = $stateParams.type;
    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 预约挂号ID
    $scope.opregId = $stateParams.opregid;
    $scope.slideSuccessShow = false;
    $scope.step = 0;

    // 问卷信息
    $scope.srvyInfo = new Object();
    // 模板内容
    $scope.tmpl = new Object();
    // 模板信息
    $scope.tmplInfo = new Object();
    // 问卷结果
    $scope.srvyResult = new Object();

    // 当前显示删除图片列表ID
    $scope.delImgQstn = new Object();
    // 当前添加图片列表ID
    $scope.addImgQstn = new Object();
    // 图片服务器路径
    $scope.uploadUrl = uploadUrl;
    // 图片显示数组
    $scope.picList = [];

    // 读取问卷信息
    $scope.loadSrvyInfo = function () {
        $ionicLoading.show();
        SrvyService.srvyInfo($scope.type, $scope.vpId).then(function (data) {
            if (data.result == 1) {
                $scope.srvyInfo = data.data;
                $scope.loadTmpl($scope.srvyInfo.TMPL_ID);
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }
    $scope.loadSrvyInfo();

    // 加载模板信息
    $scope.loadTmpl = function (tmplId) {
        $scope.isLoadFinish_Tmpl = false;
        $scope.tmpl = new Object();
        $scope.srvyResult = new Object();

        if ($scope.tmplInfo.display == "SLIDE") {
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
        }

        // 加载模板
        SrvyService.items(tmplId).then(function (data) {
            $scope.tmpl = data.QSTN_LIST;
            $scope.tmplInfo.name = data.TMPL_NAME;
            $scope.tmplInfo.id = data.TMPL_ID;
            $scope.tmplInfo.display = data.TMPL_DISPLAY;
            $scope.qstnCount = $scope.tmpl.length;

            $scope.isLoadFinish_Tmpl = true;

            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();

            if ($scope.tmplInfo.display == "SLIDE") {
                $timeout(function () {
                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').enableSlide(false);

                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
                    $ionicLoading.hide();
                }, 300);
            } else {
                $ionicLoading.hide();
            }
        })

        $scope.srvyList = [];
    }

    // 保存问卷结果
    $scope.saveResult = function () {
        $ionicLoading.show();
        SrvyService.saveRecord($scope.tmplInfo.id, "", $scope.vpId, $scope.srvyResult).then(function (data) {
            if (data.result == 1) {
                SrvyService.saveQuestionnaire(data.recId, $scope.opregId).then(function (dataSave) {
                    if (dataSave.result == 1) {
                        //$fwCordovaToast.showShortBottom("问卷填写完成！");
                        // 初始化题目信息（防止再次进入显示混乱）
                        //$scope.tmpl = new Object();
                        //$scope.tmplInfo = new Object();
                        //$scope.modelTil = new Object();
                        //$scope.loadSrvyInfo();
                        //$state.go('app.opQuestionnaireSuccess', { tmplInfoName: $scope.tmplInfo.name });
                        $ionicSlideBoxDelegate.$getByHandle('slideSuccess').next();
                        $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideSuccess').currentIndex();
                        $scope.scrollResize();
                    }
                    $ionicLoading.hide();
                });
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }
        });
    }

    //#region 每道题一个slide版本
    // 当前问题
    $scope.cQstn = 0;

    // 查空
    $scope.checkEmpty = function (qstnInfo) {
        if (qstnInfo.INPUT_TYPE == 'LIST') {
            if (qstnInfo.CHILDS.length > 0) {
                for (var i = 0; i < qstnInfo.CHILDS.length; i++) {
                    if (!$scope.checkEmpty(qstnInfo.CHILDS[i])) {
                        return false;
                    }
                }
            }
        }
        if (qstnInfo.IS_REQUIRED == '1') {
            if (qstnInfo.CONDITION_TYPE == 0 || (qstnInfo.CONDITION_TYPE == 1 &&
                ($scope.srvyResult[qstnInfo.CONDITION_PARENT] == qstnInfo.CONDITION_VALUE
                || $scope.srvyResult[qstnInfo.CONDITION_PARENT].split(',').indexOf(qstnInfo.CONDITION_VALUE) > -1))) {

                if ($scope.srvyResult[qstnInfo.QSTN_ID] == undefined || $scope.srvyResult[qstnInfo.QSTN_ID] == '') {
                    $fwCordovaToast.showShortBottom("必填项不得为空");
                    return false;
                }
                if (qstnInfo.CHILDS.length > 0) {
                    for (var i = 0; i < qstnInfo.CHILDS.length; i++) {
                        if (!$scope.checkEmpty(qstnInfo.CHILDS[i])) {
                            return false;
                        }
                    }
                }
            }

            return true;
        }
        return true;
    }

    //#endregion

    //#region 问卷真伪控件
    // 问卷重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('scollQuest').resize();
        }, 500);
    }

    // 问卷伪单选按钮
    $scope.flupRadio = function (qstnId, dicValue) {
        $scope.srvyResult[qstnId] = dicValue;
        $scope.scrollResize();
    }

    // 问卷伪多选按钮
    $scope.flupCheckBox = function (qstnId, dicValue, dicDis) {
        //        if ($scope.srvyResult[qstnId] == null || $scope.srvyResult[qstnId] == '') {
        //            $scope.srvyResult[qstnId] = dicValue;
        //        }
        //        else {
        //            var value = $scope.srvyResult[qstnId].split(',');
        //            if (value.indexOf(dicValue) == -1) {
        //                value.push(dicValue);
        //            } else {
        //                value.splice(value.indexOf(dicValue), 1);
        //            }
        //            var returnValue = '';
        //            for (var i = 0; i < value.length; i++) {
        //                returnValue += value[i] + ",";
        //            }
        //            if (returnValue.endsWith(',')) {
        //                returnValue = returnValue.substr(0, returnValue.length - 1);
        //            }
        //            $scope.srvyResult[qstnId] = returnValue;
        //        }
        $scope.srvyResult[qstnId] = dicDis;
        $scope.scrollResize();
    }

    // 提示信息
    $scope.modelTil = new Object();
    // 注册模态窗口
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('opQuestionnaireModel.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.questModel = modal;
    });
    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.questModel.remove();
    })
    $scope.hideTmpl = function () {
        $scope.questModel.hide();
    }
    // 问卷模态窗口选择器
    $scope.flupModel = function (item) {
        $scope.item = item;
        $scope.questModel.show();
    }
    // 模态单选
    $scope.flupRadioModel = function (qstnId, dicValue, disp) {
        $scope.flupRadio(qstnId, dicValue);
        $scope.modelTil[qstnId] = disp;
        $scope.hideTmpl();
    }
    // 模态多选
    $scope.fluoCheckboxModel = function (qstnId, dicValue, disp) {
        if ($scope.modelTil[qstnId] == null || $scope.modelTil[qstnId] == '') {
            $scope.modelTil[qstnId] = disp;
        }
        else {
            var value = $scope.modelTil[qstnId].split(',');
            if (value.indexOf(disp) == -1) {
                value.push(disp);
            } else {
                value.splice(value.indexOf(disp), 1);
            }
            var returnValue = '';
            for (var i = 0; i < value.length; i++) {
                returnValue += value[i] + ",";
            }
            if (returnValue.endsWith(',')) {
                returnValue = returnValue.substr(0, returnValue.length - 1);
            }
            $scope.modelTil[qstnId] = returnValue;
        }
        $scope.flupCheckBox(qstnId, dicValue, $scope.modelTil[qstnId]);
    }

    // 问卷真时间选择器
    $scope.flupDate = function (qstnId, type) {
        var defaultDate = new Date();

        if ($scope.srvyResult[qstnId] != undefined && $scope.srvyResult[qstnId] != null && $scope.srvyResult[qstnId] != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                $scope.srvyResult[qstnId] = $scope.srvyResult[qstnId].replace(/-/g, "/");
            }
            defaultDate = new Date($scope.srvyResult[qstnId]);
        }
        var options = {
            mode: 'date',  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            var resultDate = new Date(date);
            $scope.srvyResult[qstnId] = resultDate.Format('yyyy-MM-dd');
            $scope.scrollResize();
        })
    }

    //#region 问卷图片处理
    // 问卷图片上传ActionSheet显示
    $scope.imgAddActionSheet = function (qstnId) {
        // 记录问题ID
        $scope.addImgQstn = qstnId;
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                $scope.addImgQstn = new Object();
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "OP_QUESTIONNAIRE" };
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();
            if (result.response.indexOf('上传失败') >= 0) {
                $fwCordovaToast.showShortBottom(result);
            } else {
                // 保存图片
                if ($scope.srvyResult[$scope.addImgQstn] == null || $scope.srvyResult[$scope.addImgQstn] == "undefined") {
                    $scope.srvyResult[$scope.addImgQstn] = result.response;
                }
                else {
                    $scope.srvyResult[$scope.addImgQstn] += ";" + result.response;
                }

                $scope.picList.push(result.response);
            }
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 图片删除显示
    $scope.showImgDelete = function (qstnId) {
        $scope.delImgQstn = qstnId;
    }

    // 图片删除隐藏
    $scope.cancelImgDelete = function () {
        $scope.delImgQstn = new Object();
    }

    // 图片删除
    $scope.imgDelete = function (qstnId, imgUrl) {
        console.log(imgUrl)
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                var clist = $scope.srvyResult[qstnId].split(';');
                var nList = '';
                for (var i = 0; i < clist.length; i++) {
                    console.log(clist[i]);
                    if (clist[i] != imgUrl) {
                        nList += clist[i] + ';';
                    }
                }
                if (nList != '') {
                    nList = nList.substr(0, nList.length - 1);
                }
                $scope.srvyResult[qstnId] = nList;

                for (var i = 0; i < $scope.picList.length; i++) {
                    if ($scope.picList[i] == imgUrl) {
                        $scope.picList.splice(i, 1);
                    }
                }

                console.log($scope.srvyResult[qstnId]);
            }
            // 重新显示删除按钮
            $scope.showImgDelete(qstnId);
        });
    }
    //#endregion

    // 后退
    $scope.goBack = function () {
        $state.go('app.personal');
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        $ionicSlideBoxDelegate.$getByHandle('slideSuccess').enableSlide(false);
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'questionnaire');
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'questionnaire') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
});