﻿angular.module('fwapp.controllers')

// 当日预约
.controller('OpRegController', function ($scope, $rootScope, $state, $stateParams, $timeout, $interval, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaInAppBrowser, $fwCordovaToast
, OpRegService, RequestService, VisitPatientService, SchedulingService, DoctorInfoService, AccountService, PaymentService, IpRegService) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义当日预约滑块
    var slideApptToday = $ionicSlideBoxDelegate.$getByHandle('slideApptToday');
    // 定义支付滑块
    var slidePay = $ionicSlideBoxDelegate.$getByHandle('slidePay');
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideApptToday.enableSlide(false);
        slidePay.enableSlide(false);
    });
    // 初始滑块状态
    $scope.step = 0;
    // 标题数组
    $scope.titleList = ['用户须知', '选择就诊人', '选择医生', '挂号信息确认', '费用支付', '挂号结果'];
    // 配置信息
    $scope.configData = {};
    // 服务开关
    $scope.isServerOn = true;
    // 就诊人相关
    $scope.vpList = new Object();
    $scope.vpNew = new Object();
    $scope.vpSelect = ''; // 就诊人ID
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    // 多张卡列表
    $scope.cardList = [];
    // 多张卡选择序列
    $scope.cardSelectIndex = 0;
    //2023-8-28 13:55:26 ZZL #hzfwx-107 字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 就诊人办卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '', 
        insurance_type: 0,
        mi_patient_code: '',
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 就诊人办卡页面显示
    $scope.applyCardType = 1;
    // 获取验证码倒计时
    $scope.timespan = 0;
    // 门诊挂号信息
    $scope.opRegData = {};
    $scope.opRegData.division = ''; // 预约科室
    $scope.opRegData.schedDate = ''; // 预约日期
    $scope.opRegData.schedTime = ''; // 预约时段
    // 医生出诊列表
    $scope.opInfoList = new Array();
    $scope.opInfoSelect = new Object();
    $scope.opInfoListEmpty = false;
    // 按医师搜索
    $scope.doctorSearch = new Object();
    $scope.doctorSearch.list = new Array(); // 医师搜索结果列表
    $scope.doctorSearch.keyword = ''; // 医师搜索关键词
    $scope.doctorSearch.isSearch = false;  // 是否搜索
    $scope.doctorSearch.isEmpty = false;  // 结果是否空
    // 锁定挂号信息
    $scope.lockedRegInfo = {};
    // 挂号错误信息
    $scope.regErrorMsg = '';

    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 仅看可约
    $scope.showAvailable = false;
    // 从微信返回
    $scope.fromWeixin = true;
    // 商户订单号
    $scope.outTradeNo = "";
    // 微信支付返回结果
    $scope.appResult = "";
    // 支付成功显示model
    $scope.resultShow = {};
    // 是否支付成功
    $scope.isPaySuccess = false;
    // 是否挂号成功
    $scope.isRegSuccess = false;
    // 是否继续支付
    $scope.isContinueToPay = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 支付途径
    $scope.paymentInfo = new Object();
    $scope.paymentInfo.method = "1";

    // 用户须知倒计时
    $scope.confirmCountdown = devMode ? 1 : 10;

     // 医保卡号提示
    $scope.MICodeHelp = "医保卡卡号位于卡片正面";

    // 2018-10-26 14:54:25 可用支付方式
    $rootScope.paymentRouteList = [];

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bindCardHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：多卡选择绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCardSelect.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardSelectModal = modal;
    });

    // 注册模态窗口：在线建档
    $ionicModal.fromTemplateUrl('applyCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.applyCardModal = modal;
    });

    // 注册模态窗口：医师介绍
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('doctorIntro.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 注册模态窗口：支付
    $ionicModal.fromTemplateUrl('pay.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.payModal = modal;
        $scope.slidePayReady();
    });

    // 医保号帮助
    $ionicModal.fromTemplateUrl('MICode_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MICodeHelpModal = modal;
    });
    $scope.MICodeHelpModalShow = function () {
        $scope.MICodeHelpModal.show();
    }
    $scope.MICodeHelpModalHide = function () {
        $scope.MICodeHelpModal.hide();
    }

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.bindCardSelectModal.remove();
        $scope.applyCardModal.remove();
        $scope.doctorIntroModal.remove();
        $scope.showAvatarModal.remove();
        $scope.payModal.remove();
        $scope.MICodeHelpModal.remove();
    })

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideApptToday.slide(index);
        $scope.step = slideApptToday.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（用户须知）正常后退
        if ($scope.step == 0) {
            $rootScope.goBack();
        }
        // 第4页（支付确认） 或 第5页（预约结果）返回个人中心页
        else if ($scope.step == 4 || $scope.step == 5) {
            $state.go('app.personal');
        }
        // 其他页返回上一个滑块
        else {
            slideApptToday.previous();
            $scope.step = slideApptToday.currentIndex();
        }
    }

    // 切换滑块触发
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.info($scope.vpList);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        })
    }

    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.addVisitPatientModal.show();
    }

    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }

    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }

    //#region 绑定就诊卡
    // 绑卡模态窗口显示
    $scope.bindCardShow = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;
        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
        $scope.bindCardModal.show();
    }

    // 绑卡模态窗口隐藏
    $scope.bindCardHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            id: '',
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0
        };
    }

    // 多卡选择绑卡模态窗口显示
    $scope.bindCardSelectShow = function () {
        $scope.bindCardSelectModal.show();
    }

    // 多卡选择绑卡模态窗口隐藏
    $scope.bindCardSelectHide = function () {
        $scope.bindCardSelectModal.hide();
    }

    // 选择就诊卡
    $scope.selectCard = function (index) {
        if (index != $scope.cardSelectIndex && index < $scope.cardList.length) {
            $scope.cardSelectIndex = index;
        }
    }

    // 多卡选择绑卡提交
    $scope.bindCardSelectSubmit = function () {
        if ($scope.cardSelectIndex >= $scope.cardList.length || $scope.cardList[$scope.cardSelectIndex] == null 
            || $scope.cardList[$scope.cardSelectIndex].PATIENT_ID == null || $scope.cardList[$scope.cardSelectIndex].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }
        $ionicLoading.show();
        var vpId = $scope.vpSelect.VISIT_PATIENT_ID;
        VisitPatientService.bindPatientCardSelect(vpId, $scope.cardList[$scope.cardSelectIndex].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            } 
            else {
                //$fwCordovaToast.showShortBottom('就诊卡绑定成功');
                $fwCordovaToast.showShortBottom(data.msg);
                // 获取就诊人列表
                VisitPatientService.visitPatientList().then(function (data) {
                    // 获取成功
                    if (data.result == 1) {
                        $scope.vpList = data.data;
                        console.log($scope.vpList);
                        // 重新选择就诊人 检查预存账户状态
                        var vpListFilter = $scope.vpList.filter(e => e.VISIT_PATIENT_ID == vpId);
                        var vpTemp = vpListFilter.length > 0 ? vpListFilter[0] : null;
                        var index = $scope.vpList.indexOf(vpTemp);
                        console.log(index);
                        $ionicLoading.hide();
                        $scope.selectVisitPatient(index);
                        // 隐藏绑定页面
                        $scope.bindCardSelectHide();
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                    }
                })
            }
        })
    }

    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpShow = function () {
        $scope.bindCardHelpModal.show();
    }

    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpHide = function () {
        $scope.bindCardHelpModal.hide();
    }

    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $cordovaToast.showShortTop("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 绑卡提交
    $scope.bindCardSubmit = function () {
        console.log($scope.vpBind);
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        $ionicLoading.show();
        VisitPatientService.bindVisitPatient($scope.vpBind.id, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self, false).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.bindCardHide();     // 隐藏绑定页面
                $scope.loadVpList();            // 重新获取患者信息
                // 2017.7.28 孙老师要求开通预存账户需上传身份证 
                //$scope.toSlide(2);
                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
            $ionicLoading.hide();
        })
    }

    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpBind.id, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        });
    }

    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
    //#endregion
    //#region 在线办卡
    // 办卡模态窗口显示
    $scope.applyCardShow = function (type) {
        // 复用办卡模态窗口，用于未开通预存患者上传身份证
        if (type == undefined) {
            $scope.applyCardType = 1;
        } else {
            $scope.applyCardType = type;
        }
        $scope.applyCardModal.show();
    }
    // 办卡模态窗口隐藏
    $scope.applyCardHide = function () {
        $scope.applyCardModal.hide();
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '', 
            insurance_type: 0,
            mi_patient_code: '',
            marital: 0
        }
    }
    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }
    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }
    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }
    // 上传图片
    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        //var uri = encodeURI("http://10.10.101.11:8080/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        // 显示上传等待
        $ionicLoading.show();
        // 上传图片
        //$fwCordovaToast.showShortBottom(uri);
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            //$cordovaToast.showLongBottom(angular.toJson(result));
            //console.log(result);
            //console.log(result.response);
            var fileResult = {};
            eval("fileResult = " + result.response);
            $ionicLoading.hide();
            // 上传成功
            if (fileResult.result == 1) {
                $fwCordovaToast.showShortBottom("上传成功");
                // 头像面
                if (type == 0) {
                    $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                }
                // 国徽面
                else if (type == 1) {
                    $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                }
                // 户口簿
                else if (type == 2) {
                    $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                }
            }
            // 上传失败
            else {
                $fwCordovaToast.showShortBottom(fileResult.msg);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }
    // 删除身份证照片
    $scope.deleteImg = function (type) {
        // confirm
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }
    
    // 格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    //2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 提交建卡申请
    $scope.submitCardApply = function () {
        console.log($scope.vpApply);
        // 格式化手机号
        $scope.formatPhone();
        if ($scope.applyCardType == 1) {
            // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
            // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
            var isAddrFormat = false;
            // 现住址不为空-老流程填的，放过，走后边验证
            if ($scope.vpApply.address != '') {
                isAddrFormat = false;
            }
            // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
            else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
                isAddrFormat = true;
                $scope.vpApply.address = '';
                var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
                $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
                var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
                $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
                var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
                $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
                $scope.vpApply.address += $scope.vpApply.address_detail;
            }
            // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
            else {
                $fwCordovaToast.showShortBottom('请完整填写现住址信息');
                return false;
            }
            // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，删除北京医保卡号验证($scope.vpApply.insurance_type == 1 && $scope.vpApply.mi_patient_code == "")
            if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
                || ($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == '')
                || $scope.vpApply.insurance_type == 0)
                || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
            //2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
            var addressByteSize = getStringByteSize($scope.vpApply.address);
            //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
            // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
            if (isAddrFormat && addressByteSize > 40) {
                $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
                addressByteSize = getStringByteSize($scope.vpApply.address);
            }
            else if (addressByteSize <= 10 || addressByteSize > 40) {
                var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: msgStr,
                    okText: '确定'
                }).then(function () {
                });
                return false;
            }
            // 2023-12-8 13:46:23 ZZL hzfwx-442 医保卡号添加长度限制，超过15位提示，避免超长导致自助机接口报错
            // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，去掉前端、后端、接口、轮询限制，屏蔽掉
            if ($scope.vpApply.mi_patient_code !== undefined && $scope.vpApply.mi_patient_code !== '' && $scope.vpApply.mi_patient_code !== null && $scope.vpApply.mi_patient_code.length > 15) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '医保卡号格式不正确，请检查后重新填写',
                    okText: '确定'
                }).then(function () {
                    $scope.MICodeHelpModalShow();
                });
                return false;
            }
        } else if ($scope.applyCardType == 2) {
            if (($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
        }
        $ionicLoading.show();
        // 2024-2-22 16:09:17 ZZL hzfwx-714 三代医保卡升级，$scope.vpApply.mi_patient_code改成默认传""
        // 提交建卡申请
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type,
            $scope.vpApply.insurance_type, $scope.vpApply.mi_patient_code, $scope.vpApply.marital).then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                // data == 1 --> 建卡成功
                if (data.data == 1) {
                    $scope.applyCardHide();     // 隐藏绑定页面
                    $scope.loadVpList();            // 重新获取患者信息
                    $scope.toSlide(2);
                    if ($scope.applyCardType == 1) {
                        $fwCordovaToast.showShortBottom('在线建档成功');
                    } else if ($scope.applyCardType == 2) {
                        $fwCordovaToast.showShortBottom('开通预存账户成功');
                    }
                }
                // data == 0 --> 建卡失败
                else if (data.data == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }
            // 获取失败
            else if (data.result == 99) {
                $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
            } else {
                // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                //$fwCordovaToast.showShortBottom(data.msg);
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: '确定'
                });
            }
            $ionicLoading.hide();
        })
    }
    //#endregion
    // 选择就诊人之前判断是否需要弹出窗口绑卡/办卡
    $scope.selectVisitPatient = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
        // 2017.7.27 bst 孙老师试用反馈，无默认绑卡功能，全部要求绑定
        // 2017.8.8 bst 杨国胜有要求改回来 MDZZ
        if ($scope.vpSelect.IS_BIND_CARD == '1' || $scope.vpSelect.IS_BIND_CARD == '2' || $scope.vpSelect.IS_BIND_CARD == '3') {
            // 2017.7.27 bst 孙老师试用反馈，若患者未开通预存账户，需上传身份证照片
            // 检查是否开通预存账户
            $ionicLoading.show();
            PaymentService.checkPrePayAccount($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                // 请求错误
                if (data.result == 0 || data.result == -99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                // 请求成功
                if (data.result == 1) {
                    // 未开通预存账户
                    if (data.is_null == 1) {
                        console.log('开通预存账户');
                        OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $ionicLoading.hide();
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0 直接提交
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                if ($scope.vpApply.id_type == '0') {
                                    $scope.applyCardType = 2;
                                    $scope.submitCardApply();
                                }
                                else {
                                    // 显示办卡提示
                                    var applyCardPopup = $ionicPopup.show({
                                        title: '注意',
                                        template: "患者预存账户未开通，请上传身份证开通预存账户",
                                        buttons: [{
                                            text: '确定',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                applyCardPopup.close();
                                                // 不加timeout popup关不掉
                                                $timeout(function () {
                                                    $scope.applyCardShow(2);
                                                }, 0);
                                            }
                                        }]
                                    });
                                }
                            }
                            // 获取失败
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        })
                        return;
                    }
                    // 门诊预存账户余额为负数
                    else if (data.is_null == 2) { 
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                        return;
                    }
                    // 已开通预存账户
                    console.log(data.data);
                    // 跳转到下一页
                    $scope.toSlide(2);
                }
                $ionicLoading.hide();
            })
        }
        // 未绑卡
        else if ($scope.vpSelect.IS_BIND_CARD == '0') {
            $ionicLoading.show();
            // 获取办卡状态
            OpRegService.patientCheck($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    // 无卡 --> 办卡
                    if (data.is_null == 1) {
                        console.log('无卡: ' + data.msg);
                        var createCardMsg = data.msg;
                        // 创建建卡申请 供上传图片使用
                        OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 1).then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                $scope.vpApply.insurance_type = data.data.INSURANCE_TYPE;
                                $scope.vpApply.mi_patient_code = data.data.MI_PATIENT_CODE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                // 显示办卡提示
                                var applyCardPopup = $ionicPopup.show({
                                    title: '注意',
                                    template: createCardMsg,
                                    buttons: [{
                                        text: '确定',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            applyCardPopup.close();
                                            // 不加timeout popup关不掉
                                            $timeout(function () {
                                                $scope.applyCardShow(1);
                                            }, 0);
                                        }
                                    }]
                                });
                            }
                            // 获取失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                            $ionicLoading.hide();
                        })
                    }
                    // 一张卡 --> 下一步
                    else if (data.is_null == 0) {
                        console.log('一张卡: ' + data.msg);
                        // 2019-6-6 17:27:53 一张卡可能未开通预存账户 调用选择就诊人重新判断
                        //$scope.toSlide(2);
                        // 2019-6-13 13:43:17 重新获取就诊人列表 刷新绑卡等状态
                        VisitPatientService.visitPatientList().then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $ionicLoading.hide();
                                $scope.vpList = data.data;
                                console.log($scope.vpList);
                                // 重新选择当前就诊人
                                $scope.selectVisitPatient(index);
                            }
                            // 获取失败
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        }, function () {
                            $ionicLoading.hide();
                        })
                    }
                    // 多张卡 --> 绑卡
                    else if (data.is_null == 2) {
                        console.log('多张卡: ' + data.msg);
                        $scope.cardList = data.data;
                        $ionicLoading.hide();
                        // 显示绑卡提示
                        var bindCardPopup = $ionicPopup.show({
                            title: '提示',
                            template: data.msg,
                            buttons: [{
                                text: '确定',
                                type: 'button-positive',
                                onTap: function (e) {
                                    bindCardPopup.close();
                                    // 不加timeout popup关不掉
                                    $timeout(function () {
                                        $scope.bindCardSelectShow();
                                    }, 0);
                                }
                            }]
                        });
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                    }
                }
                // 获取错误
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误,请稍后重试");
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            })
        }
    }
    // 切换科室
    $scope.changeDivision = function (division) {
        $scope.opRegData.division = division;
        $scope.loadOpInfoList();
    }
    // 切换时段
    $scope.changeSchedTime = function (schedTime) {
        $scope.opRegData.schedTime = schedTime;
        $scope.loadOpInfoList();
    }
    // 仅看可约
    $scope.switchShowAvailable = function () {
        $scope.showAvailable = !$scope.showAvailable;
        $scope.loadOpInfoList();
    }
    // 按条件刷新医生列表
    $scope.loadOpInfoList = function () {
        $ionicLoading.show();
        $scope.opInfoListEmpty = false;
        // 可选搜索条件
        var doctorLevel = $scope.opRegData.doctorLevel ? $scope.opRegData.doctorLevel : "";
        var speciality = $scope.opRegData.speciality ? $scope.opRegData.speciality : "";
        var doctorName = $scope.opRegData.doctorName ? $scope.opRegData.doctorName : "";
        OpRegService.getScheduling($scope.opRegData.division, $scope.opRegData.schedTime, doctorLevel, speciality, doctorName).then(function (data) {
            // 查询成功
            $scope.opInfoList = [];
            for (var i = 0; i < data.ds.length; i++) {
                // 若仅看可约 且 APPT_STATUS != 1 跳过
                if ($scope.showAvailable && data.ds[i].APPT_STATUS != "1") { continue; }
                $scope.opInfoList.push(data.ds[i])
            }
            if ($scope.opInfoList.length == 0) {
                $scope.opInfoListEmpty = true;
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListEmpty = true;
            $ionicLoading.hide();
        })
    }
    // 搜索医师
    $scope.searchDoctor = function () {
        $scope.doctorSearch.isSearch = true;
        $scope.opRegData.doctorName = $scope.doctorSearch.keyword;
        $scope.loadOpInfoList();
    }

    // 清空搜索结果
    $scope.clearSearch = function () {
        $scope.doctorSearch.list = new Array();
        $scope.doctorSearch.keyword = "";
        $scope.opRegData.doctorName = "";
        $scope.doctorSearch.isSearch = false;
        $scope.doctorSearch.isEmpty = false;
        $scope.loadOpInfoList();
    }

    // 医师介绍
    $scope.doctorIntro = function (doctorId, doctorLevel) {
        // 若无对照医师信息，不做弹出处理
        if (doctorId == undefined || doctorId.length == 0) {
            return;
        }
        $scope.doctorInfo = new Object();
        $ionicLoading.show();
        DoctorInfoService.doctorInfo(doctorId).then(function (data) {
            $ionicLoading.hide();
            $scope.doctorInfo = data;
            if (doctorLevel.toString() != "") {
                $scope.doctorInfo.title = doctorLevel;
            }
        }, function (resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
        });
        $scope.doctorIntroModal.show();
        $ionicScrollDelegate.$getByHandle('intro').scrollTop();
    }
    // 医师介绍隐藏
    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
    }
    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }
    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }
    // 确认预约信息提示
    $scope.checkOpRegTips = function (index) {
        var opInfo = $scope.opInfoList[index];
        console.log($scope.configData);
        if ($scope.configData.doctorTips[$scope.opInfoList[index].DOCTOR_CODE] != undefined) {
            var tipPopup = $ionicPopup.show({
                title: '提示',
                template: $scope.configData.doctorTips[$scope.opInfoList[index].DOCTOR_CODE],
                scope: $scope,
                buttons: [{ text: "我知道了，继续预约", type: "button-calm"}]
            });
            tipPopup.then(function () {
                $scope.selectOpInfo(index);
            })
        } else {
            $scope.selectOpInfo(index);
        }
    }

    // 选择预约信息
    $scope.selectOpInfo = function (index) {
        $scope.opInfoSelect = $scope.opInfoList[index];
        $scope.toSlide(3);
        console.log($scope.opInfoSelect);
    }
    // 提交当日号挂号申请
    $scope.submitReg = function () {
        console.log($scope.opInfoSelect);
        $ionicLoading.show();
        // 提交当日号挂号申请
        OpRegService.submitReg($scope.vpSelect.VISIT_PATIENT_ID, $scope.opInfoSelect.ID).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 锁号成功，获取reg_info
                if (data.reg_result == 1) {
                    // 获取支付时间限制
                    $scope.getTimeLimit();
                    // 跳转支付确认界面
                    $scope.lockedRegInfo = data.reg_info;
                    $scope.QuerstionnaireIsShowPersonal = data.reg_info.IS_QSTN;
                    $scope.QuerstionnaireType = data.reg_info.QSTN_TYPE;
                    $scope.toSlide(4);
                }
                // 锁号失败，TOAST msg
                else if (data.reg_result == 0) {
                    $fwCordovaToast.showLongBottom(data.msg);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            $fwCordovaToast.showShortBottom(data.msg);
            $ionicLoading.hide();
        })
    }
    // 取消当日号挂号申请
    $scope.cancelReg = function () {
        // confirm
        $ionicPopup.confirm({
            template: "取消挂号操作无法恢复，确认取消？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                console.log($scope.lockedRegInfo);
                $ionicLoading.show();
                // 取消当日号挂号申请
                OpRegService.cancelReg($scope.lockedRegInfo.OP_REG_ID).then(function (data) {
                    // 取消成功
                    if (data.result == 1) {
                        // 继续支付确认 正常后退
                        if ($scope.isContinueToPay) {
                            $rootScope.goBack();
                        }
                        // 退到选择医师界面
                        else {
                            $scope.toSlide(2);
                        }
                    }
                    // 取消失败
                    else {
                        $fwCordovaToast.showLongBottom(data.msg);
                    }
                    $ionicLoading.hide();
                }, function (data) {
                    $fwCordovaToast.showShortBottom(data.msg);
                    $ionicLoading.hide();
                })
            }
        })
    }
    // 获取支付时间限制
    $scope.getTimeLimit = function () {
        OpRegService.getTimeLimit().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $rootScope.payTimeLeft = data.data;
                if ($rootScope.payStatus != 1) {
                    $rootScope.payStatus = 1;
                }
                // 倒计时
                $scope.timeCountdown();
            }
            // 获取失败
            else {
                $rootScope.payStatus = 0;
                $rootScope.payTimeLeft = 0;
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 超时处理
    $scope.checkTimeout = function () {
        //$ionicLoading.show();
        $scope.regErrorMsg = "未在规定时间内成功支付, 挂号自动取消";
        $scope.toSlide(5);
    }
    
    // 筛选支付方式
    $scope.filterPaymentMethod = function (value) {
        return $rootScope.paymentRouteList.filter(e => e.value == value)[0];
    }

    // 切换支付方式
    $scope.switchPaymentMethod = function (value) {
        var method = $scope.filterPaymentMethod(value);
        if (method == null) {
            $fwCordovaToast.showShortBottom('当前支付方式不可用, 请选择其他支付方式');
            return;
        }
        // 不可用
        if (method.status == "0") {
            $fwCordovaToast.showShortBottom(method.descr);
            return;
        }
        $scope.paymentInfo.method = method.value;
    }

    // 创建支付订单
    $scope.unifiedOrder = function () {
        $ionicLoading.show();
        OpRegService.unifiedOrder($scope.lockedRegInfo.OP_REG_ID, $scope.paymentInfo.method).then(function (data) {
            console.log(data);
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            } else {
                switch ($scope.paymentInfo.method) {
                    case 1: case "1":
                        callWXPay(data.data);
                        break;
                    case 4: case "4":
                        $scope.fromWeixin = false;
                        $scope.outTradeNo = data.data;
                        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                        //$cordovaInAppBrowser.open(serviceUrl + "/Payment/OrderResult?orderId=" + data.data, '_blank', option).then(function (event) { })
                        //2023.7.31 新插件原有调用方式参数不生效
                        var inapp = showInAppBrowser(serviceUrl + "/Payment/OrderResult?orderId=" + data.data, '_blank');

                        // 添加状态监听器
                        inapp.addEventListener('exit', function (event) {
                            //console.log('InAppBrowser exit加载：' + event.url);
                            OnResume();
                        });

                        inapp.addEventListener('loadstart', function (event) {
                            //console.log('loadstart loadstart加载：' + event.url);
                            if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
                                if (event.url.endsWith("Success")) {
                                    WXPaySuccess(0);
                                } else if (event.url.endsWith("Failed")) {
                                    WXPayFailed(-2);
                                }

                                $cordovaInAppBrowser.close();
                            }
                        });
                        break;
                    case 6: case "6": // 支付宝
                        callAliPay(data.data);
                        break;
                    default: // 其他
                        $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                        $ionicLoading.hide();
                        break;
                }
            }
        }, function (resp) {
            $fwCordovaToast.showShortBottom("通信失败, 请检查网络");
            $ionicLoading.hide();
        });
    }

    // 调用支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        $scope.outTradeNo = aliBizContent.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 支付成功
    function AliPaySuccess(statusCode) {
        $ionicLoading.show();
        $scope.resultShow = {};
        $scope.appResult = "";
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                // 支付成功
                $scope.isPaySuccess = true;
                $scope.appResult = "0";
                $scope.resultShow = data.data;
                // 查询挂号状态
                OpRegService.regStatus($scope.lockedRegInfo.OP_REG_ID).then(function (data) {
                    $ionicLoading.hide();
                    // 获取成功 result = 1
                    if (data.result == 1) {
                        // 挂号成功 reg_result = 1 挂号成功，获取reg_info
                        if (data.reg_result == 1) {
                            $scope.isRegSuccess = true;
                            $scope.lockedRegInfo = data.reg_info;
                            $scope.regErrorMsg = "";
                        }
                        // 挂号失败
                        else {
                            $scope.isRegSuccess = false;
                            $scope.regErrorMsg = data.msg;
                        }
                        $scope.toSlide(5);
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                })
            }
            // 
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.appResult = "-1";
                $scope.regErrorMsg = data.msg;
                $scope.toSlide(5);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
            $scope.regErrorMsg = "网络异常, 请稍后重试";
            $scope.toSlide(5);
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        switch (statusCode.resultStatus) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }
        $fwCordovaToast.showShortBottom(errMsg);
        // 支付失败
        $scope.isPaySuccess = false;
        $scope.regErrorMsg = errMsg;
        $scope.toSlide(5);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $ionicLoading.hide();
    }

    // 分平台调用微信支付插件
    function callWXPay(paydata) {
        $scope.outTradeNo = paydata.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 监听inAppBrowser页面跳转，若到支付结果页，关闭inAppBrowser并跳转结果页面
    $rootScope.$on("$cordovaInAppBrowser:loadstart", function (e, event) {
        if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
            if (event.url.endsWith("Success")) {
                WXPaySuccess(0);
            } else if (event.url.endsWith("Failed")) {
                WXPayFailed(-2);
            }

            $cordovaInAppBrowser.close();
        }
    })

    // 用户直接关闭弹出支付Browser处理
    $rootScope.$on("$cordovaInAppBrowser:exit", function (e, event) {
        //console.log('onregController$$$InAppBrowser exit加载：' + event.url);
        OnResume();
    })

    // 支付成功
    function WXPaySuccess(statusCode) {
        $ionicLoading.show();
        $scope.resultShow = {};
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                // 支付成功
                $scope.isPaySuccess = true;
                $scope.resultShow = data.data;
                // 查询挂号状态
                OpRegService.regStatus($scope.lockedRegInfo.OP_REG_ID).then(function (data) {
                    $ionicLoading.hide();
                    // 获取成功 result = 1
                    if (data.result == 1) {
                        // 挂号成功 reg_result = 1 挂号成功，获取reg_info
                        if (data.reg_result == 1) {
                            $scope.isRegSuccess = true;
                            $scope.lockedRegInfo = data.reg_info;
                            $scope.regErrorMsg = "";
                        }
                        // 挂号失败
                        else {
                            $scope.isRegSuccess = false;
                            $scope.regErrorMsg = data.msg;
                        }
                        $scope.toSlide(5);
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                })
            }
            //
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.regErrorMsg = data.msg;
                $scope.toSlide(5);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
            $scope.regErrorMsg = "网络异常, 请稍后重试";
            $scope.toSlide(5);
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function WXPayFailed(statusCode) {
        $scope.appResult = statusCode;
        $fwCordovaToast.showShortBottom(-1 == statusCode ? "支付错误" : "用户取消或支付超时");
        // 支付失败
        $scope.isPaySuccess = false;
        $scope.regErrorMsg = -1 == statusCode ? "支付错误" : "用户取消或支付超时";
        $scope.toSlide(5);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $ionicLoading.hide();
    }

    // 后台唤醒 取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $ionicLoading.show();
                $scope.resultShow = {};
                // 查询支付状态
                PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
                    // 真·支付成功
                    if (data.result == 1) {
                        $fwCordovaToast.showShortBottom('支付成功');
                        // 支付成功
                        $scope.isPaySuccess = true;
                        $scope.resultShow = data.data;
                        // 查询挂号状态
                        OpRegService.regStatus($scope.lockedRegInfo.OP_REG_ID).then(function (data) {
                            $ionicLoading.hide();
                            // 获取成功 result = 1
                            if (data.result == 1) {
                                // 挂号成功 reg_result = 1 挂号成功，获取reg_info
                                if (data.reg_result == 1) {
                                    $scope.isRegSuccess = true;
                                    $scope.lockedRegInfo = data.reg_info;
                                    $scope.regErrorMsg = "";
                                }
                                // 挂号失败
                                else {
                                    $scope.isRegSuccess = false;
                                    $scope.regErrorMsg = data.msg;
                                }
                                $scope.toSlide(5);
                            }
                            // 获取失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        }, function (data) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(data.msg);
                        })
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "0").then(function (data) {
                            ;
                        });
                    }
                    //
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
                        // 支付失败
                        $scope.isPaySuccess = false;
                        $scope.regErrorMsg = "网络异常, 请稍后重试";
                        $scope.toSlide(5);
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "-1").then(function (data) {
                            ;
                        });
                    }
                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;
                    $scope.outTradeNo = "";
                    $scope.appResult = "";
                    $ionicLoading.hide();
                });

            }
        }, 1000);
    }

    // 倒计时
    $scope.timeCountdown = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeft = $rootScope.payTimeLeft - 1);
        } else {
            $rootScope.payTimeLeft = $rootScope.payTimeLeft - 1;
        }
        clearTimeout($rootScope.payResendTimeer);
        if ($rootScope.payTimeLeft > 0) {
            $rootScope.payResendTimeer = setTimeout($scope.timeCountdown, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatus = 0);
            } else {
                $rootScope.payStatus = 0;
            }
            // 超时处理
            $scope.checkTimeout();
        }
    }
    //$rootScope.payTimeLeft = 603;
    //$scope.timeCountdown();

    $scope.slidePayReady = function () {
        // 根据支付状态 弹出跳转
        console.log(slidePay);
    }

    $scope.payShow = function () {
        $scope.payModal.show();
    }
    $scope.payHide = function () {
        $scope.payModal.hide();
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $ionicLoading.show();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $state.go('app.home');
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'apptToday');

        // 检查挂当日号开关
        OpRegService.checkServerStatus().then(function (data) {
            // 开放
            if (data.result == 1) {
                // 是否继续支付
                // 获取挂号信息
                OpRegService.getLatestReg().then(function (data) {
                    // 待支付 跳转到支付确认界面
                    if (data.result == 1 && data.data.isToday && data.data.opRegToday.STATUS == 2) {
                        // 获取支付时间限制
                        $scope.getTimeLimit();
                        // 跳转支付确认界面
                        $scope.lockedRegInfo = data.data.opRegToday;
                        $scope.isContinueToPay = true;
                        $scope.toSlide(4);
                    }
                    else {
                        //$fwCordovaToast.showShortBottom(data.msg);
                    }
                    console.log($scope.lockedRegInfo);
                    // 获取配置
                    OpRegService.getConfig().then(function (data) {
                        // 查询成功
                        if (data.result == 1) {
                            $scope.configData = data.data;
                            $scope.configData.doctorTips = JSON.parse($scope.configData.doctorTips);
                            $scope.opRegData.division = $scope.configData.divisionList[0].code; // 预约科室
                            $scope.opRegData.schedDate = $scope.configData.schedDateList[0].code; // 预约日期
                            $scope.opRegData.schedTime = $scope.configData.schedTimeList[0].code; // 预约时段
                            $scope.loadOpInfoList();
                            // 开启用户须知倒计时
                            $interval(function () { $scope.confirmCountdown -= 1; }, 1000, 10)
                        }
                        // 查询失败
                        else {
                            var alertPopup = $ionicPopup.alert({
                                title: '网络错误',
                                template: data.msg
                            });
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                    })
                    // 获取就诊人列表
                    $scope.loadVpList();
                });
                // 唤醒数据库
                PaymentService.wakeDBConnection().then(function (data) {
                    console.log(data);
                });
            }
            // 关闭
            else if (data.result == -99) {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.isServerOn = false;
                $scope.configData.apptDescription = data.msg;
                $ionicLoading.hide();
            }
            // 异常
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                $scope.isServerOn = false;
                $ionicLoading.hide();
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            $scope.isServerOn = false;
            $ionicLoading.hide();
        })
        // 获取可选择支付方式
        PaymentService.getPaymentRoute().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $rootScope.paymentRouteList = data.data;
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();
    });

    // wxh 跳转到小儿外科诊前信息表单
    $scope.goQuestionnaire = function() {
        $state.go('app.opQuestionnaire',{ vpid: $scope.lockedRegInfo.VISIT_PATIENT_ID, opregid: $scope.lockedRegInfo.OP_REG_ID, type:'CHILD'});
    }

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'apptToday') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
