﻿angular.module('fwapp.controllers')

// 挂号列表
.controller('OpRegListController', function ($scope, $rootScope, $state, $stateParams, $fwCordovaToast, OpRegService
    , $ionicModal, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform) {
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    $scope.opRegList = new Object();
    $scope.status = $stateParams.status;
    $scope.errMsg = "";

    //console.log($scope.status);
    $scope.changeStatus = function (status) {
        $scope.status = status;
        $scope.loadOpRegList();
    }
    // 获取挂号列表
    $scope.loadOpRegList = function () {
        $ionicLoading.show();
        OpRegService.getOpRegList($scope.status).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                //console.log(data.data);
                $scope.opRegList = data.data;
            }
            // 查询失败
            else {
                $scope.opRegList = [];
                $scope.errMsg = data.msg;
            }
            // 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        })
    }
    // 取消当日号挂号申请
    $scope.cancelOpReg = function (opRegId) {
        var confirmPopup = $ionicPopup.confirm({
            title: '取消预约确认',
            template: "此操作不可逆，您确定要取消当前挂号吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                console.log(opRegId);
                $ionicLoading.show();
                // 取消当日号挂号申请
                OpRegService.cancelReg(opRegId).then(function (data) {
                    // 取消成功
                    if (data.result == 1) {
                        // 重新获取挂号列表
                        $scope.loadOpRegList();
                    }
                    // 取消失败
                    else {
                        $fwCordovaToast.showLongBottom(data.msg);
                    }
                    $ionicLoading.hide();
                }, function (data) {
                    $fwCordovaToast.showShortBottom(data.msg);
                    $ionicLoading.hide();
                })
            }
        })
    }
    // 返回按钮
    $scope.goBack = function () {
        $state.go('app.personal');
    }
    $scope.goOpReg = function () {
        $state.go('app.opReg');
    }

    $scope.$on('$ionicView.enter', function () {
        // 读取挂号列表
        $scope.loadOpRegList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                if ($scope.from.length > 0) {
                    $state.go($scope.from);
                }
                else {
                    $state.go('app.personal');
                }
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'opRegList');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'opRegList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})