﻿angular.module('fwapp.controllers')

// 预付费
.controller('PaymentController', function ($scope, $rootScope, $state, $stateParams, $timeout
, $fwCordovaToast, AddWishService, PaymentService, VisitPatientService, SchedulingService, DoctorInfoService, $ionicModal
, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaInAppBrowser) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义预付费滑块
    var slideMoneylist = $ionicSlideBoxDelegate.$getByHandle('slideMoneylist');
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 初始滑块状态
    $scope.step = 0;
    // 标题数组
    $scope.titleList = ['用户须知', '选择就诊人', '充值金额和方式', '支付成功', '支付失败', '支付取消'];
    // 用户须知数据
    $scope.agreement = new Object();
    // 就诊人相关
    $scope.vpList = new Object();
    $scope.vpNew = new Object();
    $scope.vpSelect = ''; // 就诊人ID

    $scope.instruction = "";
    //$ionicLoading.show();

    // 按医生数据
    $scope.paymentInfo = new Object();
    //$scope.paymentInfo.schedDate = ''; // 预约日期
    //$scope.paymentInfo.schedTime = ''; // 预约时段
    $scope.paymentInfo.customAmount = 'no'; // 预约科室
    $scope.paymentInfo.amount = 50; //预存金额
    $scope.paymentInfo.patient = '-1'; //选择的就诊人
    $scope.paymentInfo.method = "1";
    $scope.paymentInfo.prepaidType = "1"; // 1=门诊 2=住院 3=急诊

    //保存按钮可用
    $scope.canSave = true;
    // 支付服务状态
    $scope.canPay = true;
    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 从微信返回
    $scope.fromWeixin = true;
    // 商户订单号
    $scope.outTradeNo = "";
    // 微信支付返回结果
    $scope.appResult = "";
    // 支付成功显示model
    $scope.resultShow = new Object();

    // 2018-10-26 14:54:25 可用支付方式
    $rootScope.paymentRouteList = [];

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideMoneylist.enableSlide(false);
    });
    // 滑到上一步
    $scope.lastSlide = function () {
        slideMoneylist.previous();
        $scope.step = slideMoneylist.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideMoneylist.next();
        $scope.step = slideMoneylist.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideMoneylist.slide(index);
        $scope.step = slideMoneylist.currentIndex();
        // 进入预约列表 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（用户须知）正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 第3页和第4页（充值成功/失败）返回第0页（用户须知）
        else if ($scope.step == 3 || $scope.step == 4) {
            $scope.toSlide(0);
            // 离开预约列表 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
        }
        // 其他页返回上一个滑块
        else {
            slideMoneylist.previous();
            $scope.step = slideMoneylist.currentIndex();
        }
    }
    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.info($scope.vpList);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 选择就诊人
    $scope.selectVisitPatient = function (index) {
        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
    }

    // 筛选支付方式
    $scope.filterPaymentMethod = function (value) {
        return $rootScope.paymentRouteList.filter(e => e.value == value)[0];
    }

    // 切换支付方式
    $scope.switchPaymentMethod = function (value) {
        var method = $scope.filterPaymentMethod(value);
        if (method == null) {
            $fwCordovaToast.showShortBottom('当前支付方式不可用, 请选择其他支付方式');
            return;
        }
        // 不可用
        if (method.status == "0") {
            $fwCordovaToast.showShortBottom(method.descr);
            return;
        }
        $scope.paymentInfo.method = method.value;
    }

    // 切换预存金额
    $scope.changeMoney = function (money) {
        $scope.paymentInfo.amount = money;
        $scope.paymentInfo.customAmount = 'no';
    }
    // 自定义金额
    $scope.customAmount = function () {
        $scope.paymentInfo.customAmount = 'yes';
    }
    // 切换就诊人
    $scope.changeVisitPatient = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $scope.paymentInfo.patient = index;
        $scope.vpSelect = $scope.vpList[index];

        // 2016-7-25 15:26:46 改成先验证账户是否开通再跳转
        $scope.checkPrePayAccount();
    }
    // 确认充值提交
    $scope.checkData = function () {
        //防止连击
        if (isFastClick()) {
            return;
        }
        if ($scope.paymentInfo.patient == '-1') {
            $fwCordovaToast.showShortBottom("请选择就诊人");
            return false;
        }
        if ($scope.paymentInfo.amount == '') {
            $fwCordovaToast.showShortBottom("请选择充值金额");
            return false;
        }
        if ($scope.paymentInfo.method == '') {
            $fwCordovaToast.showShortBottom("请选择充值方式");
            return false;
        }
        if ($scope.paymentInfo.amount <= 0 || $scope.paymentInfo.amount % 1 != 0) {
            $fwCordovaToast.showShortBottom("自定义金额必须是正整数");
            return false;
        }
        console.log($scope.vpSelect);

        loadStart();

        PaymentService.unifiedOrder($scope.vpSelect.VISIT_PATIENT_ID, $scope.vpSelect.HIS_CARD_NUM, $scope.paymentInfo.amount, $scope.paymentInfo.method, $scope.paymentInfo.prepaidType).then(function (data) {
            //从webservice返回的东西们~如data.prepayid就等于"wx20160715015837482b3f531b0127280127"
            //调cordova/WXSDK之类的东西
            console.log(data);
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                loadFinish();
            } else {
                switch ($scope.paymentInfo.method) {
                    case 1: case "1": // 微信支付
                        callWXPay(data.data);
                        break;
                    case 4: case "4": // 北京银行银联
                        $scope.fromWeixin = false;
                        $scope.outTradeNo = data.data;
                        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                        //$cordovaInAppBrowser.open(serviceUrl + "/Payment/OrderResult?orderId=" + data.data, '_blank', option).then(function (event) { })
                        //2023.7.31 新插件原有调用方式参数不生效
                        var inapp = showInAppBrowser(serviceUrl + "/Payment/OrderResult?orderId=" + data.data, '_blank');

                        // 添加状态监听器
                        inapp.addEventListener('exit', function (event) {
                            //console.log('InAppBrowser exit加载：' + event.url);
                            OnResume();
                        });

                        inapp.addEventListener('loadstart', function (event) {
                            //console.log('loadstart loadstart加载：' + event.url);
                            if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
                                if (event.url.endsWith("Success")) {
                                    WXPaySuccess(0);
                                } else if (event.url.endsWith("Failed")) {
                                    WXPayFailed(-2);
                                }

                                $cordovaInAppBrowser.close();
                            }
                        });
                        break;
                    case 6: case "6": // 支付宝
                        callAliPay(data.data);
                        break;
                    default: // 其他
                        $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                        $ionicLoading.hide();
                        break;
                }
            }
        }, function (resp) {
            $fwCordovaToast.showShortBottom("通信失败, 请检查网络");
        });
    }

    // 调用支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        $scope.outTradeNo = aliBizContent.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            loadFinish();
            return;
        }
    }

    // 支付成功
    function AliPaySuccess(statusCode) {
        $scope.resultShow = {};
        $scope.appResult = "";
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                $scope.appResult = "0";
                $scope.resultShow = data.data;
                $scope.toSlide(3);
            }
            // 
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.appResult = "-1";
                $scope.toSlide(4);
            }
            // 回调 保存到服务器
            PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
                ;
            });
            // 解绑后台唤醒事件监测
            document.removeEventListener("resume", OnResume, false);
            // 由微信回调返回
            $scope.fromWeixin = true;
            //$scope.outTradeNo = "";
            $scope.appResult = "";
            loadFinish();
        });
    }

    // 调用失败 或 支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        switch (statusCode.resultStatus) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }
        $fwCordovaToast.showShortBottom(errMsg);
        $scope.toSlide(4);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        loadFinish();
    }

    //#region 北京银行银联
    // 监听inAppBrowser页面跳转，若到支付结果页，关闭inAppBrowser并跳转结果页面
    $rootScope.$on("$cordovaInAppBrowser:loadstart", function (e, event) {
        if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
            if (event.url.endsWith("Success")) {
                WXPaySuccess(0);
            } else if (event.url.endsWith("Failed")) {
                WXPayFailed(-2);
            }
            $cordovaInAppBrowser.close();
        }
    })

    // 用户直接关闭弹出支付Browser处理
    $rootScope.$on("$cordovaInAppBrowser:exit", function (e, event) {
        //console.log('paymentController$$$InAppBrowser exit加载：' + event.url);
        OnResume();
    })
    //#endregion

    // 分平台调用微信支付插件
    function callWXPay(paydata) {
        $scope.outTradeNo = paydata.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            loadFinish();
            return;
        }
    }

    // 支付成功
    function WXPaySuccess(statusCode) {
        $scope.resultShow = {};
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                $scope.resultShow = data.data;
                $scope.toSlide(3);
            }
            // 
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.toSlide(4);
            }
            // 回调 保存到服务器
            PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
                ;
            });
            // 解绑后台唤醒事件监测
            document.removeEventListener("resume", OnResume, false);
            // 由微信回调返回
            $scope.fromWeixin = true;
            //$scope.outTradeNo = "";
            $scope.appResult = "";
            loadFinish();
        });
    }

    // 调用失败 或 支付失败
    function WXPayFailed(statusCode) {
        $scope.appResult = statusCode;
        $fwCordovaToast.showShortBottom(-1 == statusCode ? "支付错误" : "用户取消或支付超时");
        $scope.toSlide(4);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        loadFinish();
    }

    // 后台唤醒 取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $scope.resultShow = new Object();
                // 查询支付状态
                PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
                    // 真·支付成功
                    if (data.result == 1) {
                        $fwCordovaToast.showShortBottom('支付成功');
                        $scope.resultShow = data.data;
                        $scope.toSlide(3);
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "0").then(function (data) {
                            ;
                        });
                    }
                    // 
                    else {
                        $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
                        $scope.toSlide(4);
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "-1").then(function (data) {
                            ;
                        });
                    }
                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;
                    $scope.outTradeNo = "";
                    $scope.appResult = "";
                    loadFinish();
                });

            }
        }, 1000);
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        console.log('enter');
        // 获取就诊人列表
        $scope.loadVpList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'payment');
        // 获取充值说明
        PaymentService.instruction().then(function (data) {
            //console.log(data);
            if (data.result == -99) {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.canPay = false;
                return;
            }
            $scope.instruction = data;
            $ionicLoading.hide();
        }, function (resp) {
            $fwCordovaToast.showShortBottom('加载失败,请检查网络');
        });
        // 获取可选择支付方式
        PaymentService.getPaymentRoute().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $rootScope.paymentRouteList = data.data;
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        PaymentService.wakeDBConnection().then(function (data) {
            console.log(data);
        })
        $ionicLoading.hide();
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'payment') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    $scope.goPaymentDetail = function () {
        $state.go('app.paymentDetails');
    }

    // 加载开始
    function loadStart() {
        $scope.canSave = false;
        $ionicLoading.show();

    }
    // 加载结束
    function loadFinish() {
        $scope.canSave = true;
        $ionicLoading.hide();
    }

    /*****检查是否开户*****/
    // 当前就诊人的门诊预存账户尚未开通, 请先到门诊自助机或窗口办理
    $scope.checkPrePayAccount = function () {
        if ($scope.vpSelect.IS_BIND_CARD != '1') {
            $fwCordovaToast.showShortBottom("就诊人未绑定就诊卡");
            return;
        }
        loadStart();
        PaymentService.checkPrePayAccount($scope.vpSelect.VISIT_PATIENT_ID, 1).then(function (data) {
            // 请求错误
            if (data.result == 0 || data.result == -99) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                // 无门诊预存账户或账户状态异常
                if (data.is_null == 1) {
                    loadFinish();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                } else if (data.is_null == 2) { // 门诊预存账户余额未负数
                    loadFinish();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }

                // 当前账户可充值
                console.log(data.data);
                // 跳转到下一页
                $scope.nextSlide();
            }
            loadFinish();
        });
    }

    // 滑块切换事件
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
})
