﻿angular.module('fwapp.controllers')

// 预付费
.controller('PaymentDetailsController', function ($scope, $rootScope, $state, $stateParams, $timeout
, $fwCordovaToast, AddWishService, PaymentService, VisitPatientService, MedicationPlanService, PaymentDetailsService, SchedulingService, DoctorInfoService, $ionicModal
, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $ionicPopover) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义预付费滑块
    var paymentDetailsList = $ionicSlideBoxDelegate.$getByHandle('paymentDetailsList');

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        paymentDetailsList.enableSlide(false);
    });

    // 初始滑块状态
    $scope.step = 0;
    // 是否可提交
    $scope.canSave = true;

    // 支付列表
    $scope.paymentList = [];
    // 支付详情
    $scope.paymentInfo = new Object();
    // 可退费金额
    $scope.refundAmount = 0;
    // 退款说明
    $scope.refundInstruction = '';
    // 跳转id
    $scope.jumpPaymentId = "";
    // 订单退款记录
    $scope.refundList = [];

    //#region 就诊人
    // 就诊人ID
    $scope.vpId = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "" : $stateParams.vpid;
    // 就诊人列表
    $scope.vpList = [];
    // 就诊人信息
    $scope.vpInfo = new Object();

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }
                // 第一就诊人
                var vpid = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                }
                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }
                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                }
                else {
                    console.log($scope.vpId);
                    $scope.loadVPInfo();
                    $scope.loadPaymentList();
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        if ($scope.vpId != vpid) {
            $scope.vpId = vpid;
            $scope.vpInfo = new Object();
            $scope.loadVPInfo();
            $scope.loadPaymentList();
        }
        $scope.popVplist.hide();
    }
    //#endregion

    function loadStart() {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        $scope.canSave = false;
    }

    function loadFinish() {
        $scope.isLoadFinish = true;
        $scope.canSave = true;
        $ionicLoading.hide();
    }

    //#region 获取充值相关信息
    // 获取支付列表
    $scope.loadPaymentList = function () {
        loadStart();
        //$scope.paymentList = [];
        PaymentDetailsService.list('').then(function (data) {
            console.log(data);
            // 请求错误
            if (data.result == 0 || data.result == -99) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                $scope.paymentList = data.data;
                // 状态枚举
                for (var i in $scope.paymentList) {
                    // 订单状态
                    var statusTrade = $scope.paymentList[i].TRADE_STATUS;
                    var statusCharge = $scope.paymentList[i].CHARGE_STATUS;
                    var strStatus = "";
                    if (statusTrade == 0) {
                        strStatus = "未支付";
                    }
                    else if (statusTrade == -1) {
                        strStatus = "支付失败";
                    }
                    else if (statusTrade == -2) {
                        strStatus = "支付取消";
                    }
                    else if (statusTrade == 1) {
                        strStatus = "已支付";
                    }
                    else if (statusTrade == 2) {
                        if (statusCharge == 0) {
                            strStatus = "支付成功";
                        }
                        else if (statusCharge == 1) {
                            strStatus = "充值成功";
                        }
                        else if (statusCharge == 9) {
                            strStatus = "充值失败";
                        }
                    }
                    else if (statusTrade == 4) {
                        strStatus = "超时关闭";
                    }
                    $scope.paymentList[i].TRADE_STATUS_STR = strStatus;
                    // 退费状态
                    var status2 = $scope.paymentList[i].REFUND_STATUS;
                    var strStatus2 = "";
                    if (status2 == 0) {
                        strStatus2 = "未申请退费";
                    }
                    else if (status2 == -1) {
                        strStatus2 = "退费失败";
                    }
                    else if (status2 == 1) {
                        strStatus2 = "申请中";
                    }
                    else if (status2 == 2) {
                        strStatus2 = "已处理待退费";
                    }
                    else if (status2 == 3) {
                        strStatus2 = "已退费";
                    }
                    else if (status2 == 9) {
                        strStatus2 = "退费错误";
                    }
                    $scope.paymentList[i].REFUND_STATUS_STR = strStatus2;
                }
                // 跳转退费进度
                $scope.jumpRefundDetail();
                // 获取退款说明
                $scope.loadRefundInstruction();
                // 重置滚动条界面
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();
            }
            loadFinish();
        });
    }
    //#endregion

    //#region 获取退费相关信息
    // 获取退款声明
    $scope.loadRefundInstruction = function () {
        PaymentDetailsService.refundInstruction().then(function (data) {
            $scope.refundInstruction = data;
        });
    }

    // 获取可退费金额
    $scope.loadRefundAmount = function (index) {
        // 赋值
        $scope.paymentInfo = $scope.paymentList[index];
        console.log(index);
        console.log($scope.paymentInfo);
        $scope.vpId = $scope.paymentInfo.VISIT_PATIENT_ID;
        $scope.loadVPInfo();
        loadStart();
        // 跳转
        PaymentDetailsService.requestBalance($scope.paymentInfo.VISIT_PATIENT_ID, $scope.paymentInfo.PAYMENT_ID).then(function (data) {
            // 请求错误
            if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == 1) {
                // 未找到充值记录
                if (data.is_null == 1) {
                    loadFinish();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                // 有充值记录 余额赋值
                $scope.refundAmount = data.data;
                // 跳转至退费页面
                $scope.toSlide(1);
            }
            loadFinish();
        });
    }

    // 退费确认
    $scope.refundConfirm = function () {
        var confirmBpPopup = $ionicPopup.confirm({
            title: '退费确认',
            template: '是否确认退费？退费申请提交后不可撤销',
            cancelText: '取消',
            okText: '确认'
        });
        confirmBpPopup.then(function (res) {
            if (res) {
                // 退费申请提交
                loadStart();
                PaymentDetailsService.refund($scope.paymentInfo.VISIT_PATIENT_ID, $scope.paymentInfo.PAYMENT_ID, $scope.refundAmount).then(function (data) {
                    // 请求成功 且 可退
                    if (data.result == 1 && data.data == 1) {
                        console.log(data.data);
                        $scope.jumpPaymentId = $scope.paymentInfo.PAYMENT_ID;
                        $scope.loadPaymentList();
                        //$scope.toSlide(2);
                        $scope.refundList = [];
                        PaymentDetailsService.refundList($scope.jumpPaymentId).then(function (data) {
                            if (data.result == 1) {
                                $scope.refundList = data.data;
                                $scope.toSlide(2);
                            } else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                            loadFinish();
                        });
                    }
                    // 报错 或 不可退
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    loadFinish();
                });
            }
        });
    }

    $scope.loadRefundDetail = function (index) {
        loadStart();
        $scope.refundList = [];
        $scope.paymentInfo = $scope.paymentList[index];
        $scope.jumpPaymentId = $scope.paymentList[index].PAYMENT_ID;
        PaymentDetailsService.refundList($scope.jumpPaymentId).then(function (data) {
            if (data.result == 1) {
                $scope.refundList = data.data;
                $scope.toSlide(2);
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            loadFinish();
        });
    }

    // 查询退费进度（原始）
    //    $scope.loadRefundDetail = function (index) {
    //        $scope.paymentInfo = $scope.paymentList[index];
    //        $scope.jumpPaymentId = $scope.paymentList[index].PAYMENT_ID;
    //        $scope.toSlide(2);
    //    }

    // 跳转退费进度
    $scope.jumpRefundDetail = function () {
        for (var i in $scope.paymentList) {
            if ($scope.paymentList[i].PAYMENT_ID == $scope.jumpPaymentId) {
                $scope.paymentInfo = $scope.paymentList[i];
            }
        }
    }

    // 下拉刷新列表
    $scope.doRefresh = function () {
        if ($scope.step == 0 || $scope.step == 2) {
            $scope.loadPaymentList();
        }
        $scope.$broadcast("scroll.infiniteScrollComplete");
        $scope.$broadcast("scroll.refreshComplete");
    }
    //#endregion

    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;

    // 滑到上一步
    $scope.lastSlide = function () {
        paymentDetailsList.previous();
        $scope.step = paymentDetailsList.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        paymentDetailsList.next();
        $scope.step = paymentDetailsList.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        paymentDetailsList.slide(index);
        $scope.step = paymentDetailsList.currentIndex();
        // 进入预约列表 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        else if ($scope.step == 1 || $scope.step == 2) {
            $scope.paymentInfo = new Object();
            $scope.toSlide(0);
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
        }
        else {
            paymentDetailsList.previous();
            $scope.step = paymentDetailsList.currentIndex();
        }
    }

    //#region 页面事件
    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        // 获取就诊人列表
        $scope.loadVpList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'paymentDetail');
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'paymentDetail') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
    //#endregion
})