﻿angular.module('fwapp.controllers')

// 个人中心
.controller('PersonalController', function ($scope, $rootScope, $state, $fwCordovaToast, $filter
    , $ionicModal, $ionicPopup, $ionicLoading, $ionicPlatform, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicViewSwitcher, $cordovaDatePicker, $cordovaInAppBrowser
    , PersonalService, VisitPatientService, AccountService, ApptService, OpRegService, OpApptService, SatisService, ConsultationService, OlTreatRecipeService, HospitalService) {

    // 登录状态
    // 2023-9-8 08:27:34 CGZ 由于异步问题，此处不再单独变量赋值，改为使用$rootScope.hasLogin
    //$scope.isLogin = $rootScope.checkLogin();

    $scope.vpList = new Object();
    $scope.vpNew = new Object();
    $scope.accountInfo = new Object();

    $scope.apptCountNew = '';
    $scope.apptCountOld = '';
    $scope.apptCountCancel = '';

    $scope.opRegInfo = new Object();
    // 预约挂号列表
    $scope.opRegList = [];

    $scope.satisCount = 0;

    // 获取中
    $scope.isLoadAccountInfoFinish = false;
    $scope.isLoadVpListFinish = false;
    $scope.isLoadApptCountFinish = false;
    $scope.isGetWeChatBindCodeFinish = true;
    $scope.isLoadOpRegInfoFinish = false;
    $scope.isLoadOpRegListFinish = false;

    // 是否显示顶部绑定微信提示
    $scope.isShowBindWeChatMsg = true;
    // 绑定微信滑块
    var slideBindWechat = new Object();
    $scope.step = 0;
    // 微信绑定码
    $scope.weChatBindCode = '';
    // 本次模态窗口是否获取验证码
    $scope.isGetWeChatBindCode = false;
    // 获取微信绑定码倒计时
    $scope.timespan = 0;
    // 防止多次提交
    $scope.disableAddVP = false;
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}
    // 2021-4-14 09:30:50 个人中心入口开关
    $scope.funcSwitch = {
        // 投诉建议开关
        complainServerStatus: devMode ? true : false,
        // 患者随访（住院满意度）开关
        ipSatisFlupServerStatus: devMode ? true : false
    };

    // 医保退费url
    $scope.ybRefundPageUrl = "";

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：绑定微信
    $ionicModal.fromTemplateUrl('bindWeChat.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindWeChatModal = modal;
        // 定义预约申请滑块
        slideBindWechat = $ionicSlideBoxDelegate.$getByHandle('slideBindWechat');
        // 滑到上一步
        $scope.lastSlide = function () {
            slideBindWechat.previous();
            $scope.step = slideBindWechat.currentIndex();
        }
        // 滑到下一步
        $scope.nextSlide = function () {
            slideBindWechat.next();
            $scope.step = slideBindWechat.currentIndex();
        }
        // 切换滑块
        $scope.changeSlide = function () {
            if ($scope.step == 0) {
                $scope.nextSlide();
            }
            else {
                $scope.lastSlide();
            }
        }
        // 滑块切换触发
        $scope.slideChanged = function (e, index) {
            // 切页自动获取关联码
            if ($scope.weChatBindCode == "" && $scope.timespan == 0 && $scope.step == 0 && slideBindWechat.currentIndex() == 1) {
                $scope.getWeChatBindCode();
            }
            $scope.step = slideBindWechat.currentIndex();
            // 切页先置顶再算高度
            $ionicScrollDelegate.scrollTop();
            setTimeout(function () {
                $ionicScrollDelegate.resize();
            }, 500);
        }
        // 滑块切换完成重置高度 *ionic版本太低不支持
        /*$scope.$on("$ionicSlides.slideChangeEnd", function (event, data) {
        console.log('start');
        console.log('end');
        })*/
    })

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindWeChatModal.remove();
    })

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $scope.isLoadVpListFinish = true;
        })
    }

    // 获取挂号信息
    $scope.getRegInfo = function () {
        // 获取挂号信息
        $scope.isLoadOpRegInfoFinish = false;
        OpRegService.getLatestReg().then(function (data) {
            if (data.result == 1) {
                $scope.opRegInfo = data.data;
                if (data.data.isToday && data.data.opRegToday.STATUS == 2 && data.data.opRegToday.SECONDS_LEFT > 0) {
                    $rootScope.payTimeLeft = data.data.opRegToday.SECONDS_LEFT;
                    if ($rootScope.payStatus != 1) {
                        $rootScope.payStatus = 1;
                    }
                    // 倒计时
                    $scope.timeCountdown();
                }
            }
            else {
                //$fwCordovaToast.showShortBottom(data.msg);
            }
            console.log($scope.opRegInfo);
            $scope.isLoadOpRegInfoFinish = true;
        })
        // 获取当前挂号列表
        $scope.isLoadOpRegListFinish = false;
        OpApptService.getOpRegList("0").then(function (data) {
            if (data.result == 1) {
                // 设置默认隐藏详情
                for (var i in data.data) {
                    data.data[i].VISIBLE = false;
                }
                $scope.opRegList = data.data;
            }
            else {
                //$fwCordovaToast.showShortBottom(data.msg);
                // 2018-9-14 11:28:24 处理取消预约成功依然显示的问题
                $scope.opRegList = [];
            }
            console.log($scope.opRegList);
            $scope.isLoadOpRegListFinish = true;
        })
    }

    // 是否显示待支付预约挂号
    $scope.isShowOpRegInfo = function () {
        return $scope.isLoadOpRegInfoFinish && $scope.opRegInfo.isToday && $scope.opRegInfo.opRegToday.STATUS == 2 && $scope.opRegInfo.opRegToday.SECONDS_LEFT > 0;
    }

    // 是否显示预约挂号列表
    $scope.isShowOpRegList = function () {
        return $scope.isLoadOpRegListFinish && $scope.opRegList != null && $scope.opRegList.length > 0;
    }

    // 显示隐藏预约挂号详情
    $scope.setOpRegDetailVisible = function (index, status) {
        if ($scope.opRegList != null && $scope.opRegList.length > index && typeof (status) == "boolean") {
            $scope.opRegList[index].VISIBLE = status;
        }
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.top();
    }

    // 取消当日号挂号申请
    $scope.cancelOpReg = function (opRegId) {
        var confirmPopup = $ionicPopup.confirm({
            title: '取消预约确认',
            template: "此操作不可逆，您确定要取消当前挂号吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                // 取消当日号挂号申请
                OpRegService.cancelReg(opRegId).then(function (data) {
                    // 取消成功
                    if (data.result == 1) {
                        // 北京医保移动该支付方式，需要跳转到首信那边进行手动退费
                        if (data.bjybRefund == "1") {
                            // TODO，这个文案需要配置在sysConfig里，并且还得跟取消成功的推送在一起
                            $ionicPopup.alert({
                                title: '取消成功',
                                template: '请前往【我的预约挂号】进行医保退费',
                                okText: '确定'
                            });
                        }

                        // 获取挂号信息
                        $scope.getRegInfo();
                    }
                    // 取消失败
                    else {
                        $fwCordovaToast.showLongBottom(data.msg);
                    }
                    $ionicLoading.hide();
                }, function (data) {
                    $fwCordovaToast.showShortBottom(data.msg);
                    $ionicLoading.hide();
                })
            }
        })
    }

    $scope.ybCancel = function (type) {
        if (type == "zfb") {
            // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
            var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent($scope.ybRefundPageUrl));

            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
            //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
            //2023.7.31 新插件原有调用方式参数不生效
            showInAppBrowser(herfUrl, '_system');
        }
        else {
            $fwCordovaToast.showShortBottom("暂不支持微信小程序");
        }
    }

    // 超时处理
    $scope.checkTimeout = function () {
        $ionicLoading.show();
        setTimeout(function () {
            // 获取挂号信息
            $scope.getRegInfo();
            $ionicLoading.hide();
        }, 3000);
    }

    // 初始化
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'personal');
        // 未登录虽然此处不会跳转登录页，但是会返回false，不再执行下边的各项请求
        if (!$rootScope.checkLogin()) {
            return;
        }
        else {
            // 能进来就是已登录的用户
            // 2023-9-8 08:27:34 CGZ 由于异步问题，此处不再单独变量赋值，改为使用$rootScope.hasLogin
            //$scope.isLogin = true;
        }
        if ('' != localStorage.currentAccountId) {
            // 获取就诊人列表
            $scope.loadVpList();
            // 获取用户信息
            AccountService.accountInfo().then(function (data) {
                if (data.result == 1) {
                    $scope.accountInfo = data.data;
                    $scope.accountInfo.bindWeChatStepInApp = data.bindWeChatStepInApp;
                    $scope.accountInfo.bindWeChatStepInWeChat = data.bindWeChatStepInWeChat;
                    // 新api 有绑定微信的状态值
                    if (null != data.isBind) {
                        $scope.accountInfo.isBind = data.isBind;
                        // 已绑定 有关注公众号的状态值
                        if (null != data.isFollow) {
                            $scope.accountInfo.isFollow = data.isFollow;
                            // 已关注 有个人微信信息
                            if (null != data.wxInfo) {
                                $scope.accountInfo.wxInfo = data.wxInfo;
                            }
                        }
                        // 有滚动信息
                        if (null != data.marqueeMsg) {
                            $scope.accountInfo.marqueeMsg = data.marqueeMsg;
                        }
                    }
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                console.log($scope.accountInfo);
                $scope.isLoadAccountInfoFinish = true;
            })
            // 获取挂号信息
            $scope.getRegInfo();
            // 2018-4-8 16:24:15 获取未填写满意度调查数量
            SatisService.satisCount().then(function (data) {
                // 查询成功
                if (data.result == 1) {
                    //console.log(data.data);
                    $scope.satisCount = data.data.count;
                }
                // 查询失败
                else {
                    console.log(data.msg)
                }
            })

            // 首页黄条数组
            $scope.yellowStripList = [];

            // 2020-4-8 10:22:54 HM 统一ajax
            HospitalService.homeAjax().then(function (data) {
                $scope.videoInfo = false;
                $scope.consultationInfo = false;
                // 请求成功
                if (data.result == 1) {
                    // 视频候诊
                    if (data.data.videoCall.isShow == 1) {
                        var item = {};
                        item.content = data.data.videoCall.content;
                        item.type = "video";
                        item.isShow = true;
                        item.apptType = data.data.videoCall.videoApptType;
                        $scope.yellowStripList.push(item);
                    }
                    // 在线问诊
                    if (data.data.consultation.isShow == 1) {
                        var item = {};
                        item.content = data.data.consultation.content;
                        item.type = "consultation";
                        item.isShow = true;
                        $scope.yellowStripList.push(item);
                    }
                    // 转诊支付
                    if (data.data.referral.isShow == 1) {
                        var item = {};
                        item.content = data.data.referral.content;
                        item.type = "referral";
                        item.isShow = true;
                        item.alertMSG = data.data.referral.alertMSG;
                        $scope.yellowStripList.push(item);
                    }
                    // 愿检尽检
                    if (data.data.ncpApply.isShow == 1) {
                        var item = {};
                        item.content = data.data.ncpApply.secondsLeft;
                        item.type = "ncpApply";
                        item.isShow = true;
                        $scope.yellowStripList.push(item);
                        $rootScope.payTimeLeftNCP = data.data.ncpApply.secondsLeft;
                        if ($rootScope.payStatusNCP != 1) {
                            $rootScope.payStatusNCP = 1;
                        }
                        // 倒计时
                        $scope.timeCountdownNCP();
                    }
                    // 视频问诊
                    if (data.data.olTreatVideo.isShow == 1) {
                        var item = {};
                        item.content = data.data.olTreatVideo.secondsLeft;
                        item.type = "olTreatVideo";
                        item.isShow = true;
                        item.vpId = data.data.olTreatVideo.vpId;
                        item.treatApplyId = data.data.olTreatVideo.treatApplyId;
                        $scope.yellowStripList.push(item);

                        $rootScope.payTimeLeftOlTreatVideo = data.data.olTreatVideo.secondsLeft;
                        if ($rootScope.payStatusOlTreatVideo != 1) {
                            $rootScope.payStatusOlTreatVideo = 1;
                        }
                        // 倒计时
                        $scope.timeCountdownOlTreatVideo();
                    }
                    // 投诉建议开关
                    if (devMode || data.data.complainServerStatus.status) {
                        $scope.funcSwitch.complainServerStatus = true;
                    }
                    // 患者随访（住院满意度）开关
                    if (devMode || data.data.ipSatisFlupServerStatus.status) {
                        $scope.funcSwitch.ipSatisFlupServerStatus = true;
                    }
                    // 2023-4-14 13:39:11 HM 云南新开药
                    if (data.data.communityRecipe.isShow == 1) {
                        var item = {};
                        item.content = data.data.communityRecipe.content;
                        item.type = "communityRecipe";
                        item.isShow = true;
                        item.treatApplyId = data.data.communityRecipe.treatApplyId;
                        item.idCardCode = data.data.communityRecipe.idCardCode;// 已加密
                        $scope.yellowStripList.push(item);
                    }
                    // 2023-6-6 13:30:16 HM 北京医保APP
                    if (data.data.ybApp.isShow == 1) {
                        var item = {};
                        item.content = data.data.ybApp.content;
                        item.type = "ybApp";
                        item.isShow = true;
                        item.opPaymentId = data.data.ybApp.opPaymentId;
                        item.vpId = data.data.ybApp.vpId;
                        $scope.yellowStripList.push(item);
                    }
                    // 2024-3-21 13:09:30 HM 复诊续方快递到家
                    if (data.data.olTreatExpress.isShow == 1) {
                        var item = {};
                        item.content = data.data.olTreatExpress.secondsLeft;
                        item.type = "olTreatExpress";
                        item.isShow = true;
                        $scope.yellowStripList.push(item);

                        $rootScope.payTimeLeftOlTreat = data.data.olTreatExpress.secondsLeft;
                        if ($rootScope.payStatusOlTreat != 1) {
                            $rootScope.payStatusOlTreat = 1;
                        }
                        // 倒计时
                        $scope.timeCountdownOlTreatExpress();
                    }
                    // 2024-4-17 14:08:40 HM 图文问诊
                    if (data.data.byTreatPadding.isShow == 1) {
                        var item = {};
                        item.content = data.data.byTreatPadding.secondsLeft;
                        item.type = "byTreatPadding";
                        item.isShow = true;
                        $scope.yellowStripList.push(item);

                        $rootScope.payTimeLeftBYTreatPadding = data.data.byTreatPadding.secondsLeft;
                        if ($rootScope.payStatusBYTreatPadding != 1) {
                            $rootScope.payStatusBYTreatPadding = 1;
                        }
                        // 倒计时
                        $scope.timeCountdownBYTreatPadding();
                    }

                    // 2021-12-07 15:13:56 HM 增加适老化入口显示
                    $rootScope.elderlyEntrance = data.data.appConfig.elderlyEntrance;
                    if ($rootScope.elderlyEntrance == true) {
                        // APP配置，如适老化
                        if (typeof ($rootScope.elderly) == 'undefined' || $rootScope.elderly == null || $rootScope.elderly != data.data.appConfig.elderly) {
                            var temp = $rootScope.elderly;

                            $rootScope.elderly = data.data.appConfig.elderly;
                            localStorage.elderly = $rootScope.elderly;

                            $rootScope.sizeRank = data.data.appConfig.sizeRank;
                            localStorage.sizeRank = $rootScope.sizeRank;

                            // 之前的存进来，如果跟库里的不一样，就刷新一下
                            if (temp != data.data.appConfig.elderly) {
                                $ionicLoading.show();
                                $window.location.reload();
                            }
                        }
                    }
                }
            })

            $scope.checkMessage();
        }

        //设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if (data.result == 1) {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证"}];
        //    }
        //});
    })
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'personal') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.vpNew.idCardType = $scope.idCardTypeList[0].id;
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if ($scope.vpNew.idCardType == 5) {
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text + '不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.addVisitPatientModal.hide();
                $scope.loadVpList();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg,
                    okText: '确定'
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }

    // 获取预约数量
    $scope.getApptCount = function () {
        ApptService.apptCount().then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.apptCountNew = data.data.countNew;
                $scope.apptCountOld = data.data.countOld;
                $scope.apptCountCancel = data.data.countCancel;
            }
            // 添加失败
            else {
                console.log(data.msg);
            }
            $scope.isLoadApptCountFinish = true;
        });
    }
    $scope.getApptCount();

    // 隐藏绑定微信提示
    $scope.hideBindWeChatMsg = function () {
        $scope.isShowBindWeChatMsg = false;
    }
    // 弹出绑定微信模态窗口
    $scope.bindWeChatModalShow = function () {
        if ($scope.accountInfo.isBind) {
            return;
        }
        $scope.isGetWeChatBindCode = false;
        // 可获取新码时才清空老码 防止再次进入无码还无法获取新码
        if ($scope.timespan == 0) {
            $scope.weChatBindCode = '';
        }
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.bindWeChatModalHide();
            e.preventDefault();
            return false;
        }, 256, 'bindWeChatModalHide');
        $scope.bindWeChatModal.show();
    }

    // 隐藏绑定微信模态窗口
    $scope.bindWeChatModalHide = function () {
        // // 如果本次获取了验证码 可能已绑定微信 更新用户信息
        // 改为全部获取
        //if ($scope.isGetWeChatBindCode) {
        $scope.isLoadAccountInfoFinish = false;
        AccountService.accountInfo().then(function (data) {
            if (data.result == 1) {
                $scope.accountInfo = data.data;
                $scope.accountInfo.bindWeChatStepInApp = data.bindWeChatStepInApp;
                $scope.accountInfo.bindWeChatStepInWeChat = data.bindWeChatStepInWeChat;
                // 新api 有绑定微信的状态值
                if (null != data.isBind) {
                    $scope.accountInfo.isBind = data.isBind;
                    // 已绑定 有关注公众号的状态值
                    if (null != data.isFollow) {
                        $scope.accountInfo.isFollow = data.isFollow;
                        // 已关注 有个人微信信息
                        if (null != data.wxInfo) {
                            $scope.accountInfo.wxInfo = data.wxInfo;
                        }
                    }
                    // 有滚动信息
                    if (null != data.marqueeMsg) {
                        $scope.accountInfo.marqueeMsg = data.marqueeMsg;
                    }
                }
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $scope.isLoadAccountInfoFinish = true;
            console.log($scope.accountInfo);
        })
        //}
        // 可获取新码时才清空老码 防止再次进入无码还无法获取新码
        if ($scope.timespan == 0) {
            $scope.weChatBindCode = '';
        }
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'bindWeChatModalHide') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        $scope.bindWeChatModal.hide();
    }

    // 获取微信绑定码
    $scope.getWeChatBindCode = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        var isFirst = !$scope.isGetWeChatBindCode;
        $scope.isGetWeChatBindCode = true;
        $scope.isGetWeChatBindCodeFinish = false;
        $scope.weChatBindCode = '';
        PersonalService.getWeChatBindCode().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
                $scope.weChatBindCode = data.data;
                // 首次获取 如果有 弹出注意事项
                if (isFirst && data.info != null && data.info.length > 0) {
                    var confirmPopup = $ionicPopup.alert({
                        title: '注意',
                        template: data.info + '<style>.popup{ border: 1px solid #79063f;}</style>', //从服务端获取注意事项的内容
                        //cancelText: '取消',
                        okText: '确定'
                    });
                }
                // 如果在第一页 跳到第二页
                if ($scope.step == 0) {
                    $scope.nextSlide();
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $scope.isGetWeChatBindCodeFinish = true;
        })
    }

    // 2021-12-6 13:23:23 CGZ 关联微信改为微信授权绑定
    $scope.bindWeChat = function () {
        $ionicLoading.show();
        var scope = "snsapi_userinfo";
        var state = "_" + (+new Date());
        Wechat.auth(scope, state, function (response) {
            //console.log(JSON.stringify(response));
            // you may use response.code to get the access token.
            if (response.code == null) {
                $ionicPopup.alert({
                    title: '提示',
                    template: '获取微信授权信息失败，请稍后重试',
                    okText: '确定'
                });
                $ionicLoading.hide();
            }
            else {
                // 通过微信AuthCode关联微信
                PersonalService.bindWeChatByAuthCode(response.code).then(function (data) {
                    // 获取成功
                    if (data.result == 1) {
                        alert(data.data);
                    }
                    // 获取失败
                    else {
                        alert(data.data);
                        //$fwCordovaToast.showShortBottom(data.msg);
                    }
                    // 2021-12-07 17:54:00 请求一次性订阅消息
                    var paramSub = { scene: 3, reserved: state };
                    Wechat.wechatSubscribe(paramSub, function (responseSub) {
                        alert(JSON.stringify(responseSub));
                        if (responseSub.action == "confirm") {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '用户确认授权',
                                okText: '确定'
                            });
                        }
                        else if (responseSub.action == "cancel") {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '用户取消授权',
                                okText: '确定'
                            });
                        }
                        else {
                            $ionicPopup.alert({
                                title: '提示',
                                template: '请求一次性订阅消息失败',
                                okText: '确定'
                            });
                        }
                        $ionicLoading.hide();
                    }, function (reasonSub) {
                        $ionicPopup.alert({
                            title: '提示',
                            template: '请求一次性订阅消息失败: ' + reasonSub,
                            okText: '确定'
                        });
                        $ionicLoading.hide();
                    })
                }, function (resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络',
                        okText: '确定'
                    });
                    $ionicLoading.hide();
                })
                return;

                // 当前登录账号关联微信
                MineService.bindWechatByAuthCode($scope.username, response.code).then(function (dataBind) {
                    $ionicLoading.hide();
                    switch (dataBind.result) {
                        case 1:
                            localStorage.IONIC_USER_UNION_ID = dataBind.data;
                            $scope.userInfo.UNION_ID = localStorage.IONIC_USER_UNION_ID;
                            $cordovaToast.showShortBottom('关联微信成功');
                            break;
                        default:
                            $ionicPopup.alert({
                                title: '提示',
                                template: dataBind.data,
                                okText: '确定'
                            });
                            break;
                    }
                }, function (resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络',
                        okText: '确定'
                    });
                    $ionicLoading.hide();
                })
            }
        }, function (reason) {
            $ionicPopup.alert({
                title: '提示',
                template: '获取微信授权信息失败: ' + reason,
                okText: '确定'
            });
            $ionicLoading.hide();
        });
    }

    // 解绑微信
    $scope.unbindWeChat = function () {
        var confirmPopup = $ionicPopup.confirm({
            title: '解除关联微信',
            template: '解除关联微信后将无法再通过微信接收掌上阜外医院APP的通知消息，您确定要解除关联吗？',
            cancelText: '取消',
            okText: '解除关联'
        });
        // 确认解绑
        confirmPopup.then(function (res) {
            if (res) {
                $ionicLoading.show();
                PersonalService.unbindWeChat().then(function (data) {
                    // 解绑成功
                    if (data.result == 1) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    // 解绑失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    // 更新用户信息
                    AccountService.accountInfo().then(function (data) {
                        if (data.result == 1) {
                            $scope.accountInfo = data.data;
                            $scope.accountInfo.bindWeChatStepInApp = data.bindWeChatStepInApp;
                            $scope.accountInfo.bindWeChatStepInWeChat = data.bindWeChatStepInWeChat;
                            // 新api 有绑定微信的状态值
                            if (null != data.isBind) {
                                $scope.accountInfo.isBind = data.isBind;
                                // 已绑定 有关注公众号的状态值
                                if (null != data.isFollow) {
                                    $scope.accountInfo.isFollow = data.isFollow;
                                    // 已关注 有个人微信信息
                                    if (null != data.wxInfo) {
                                        $scope.accountInfo.wxInfo = data.wxInfo;
                                    }
                                }
                                // 有滚动信息
                                if (null != data.marqueeMsg) {
                                    $scope.accountInfo.marqueeMsg = data.marqueeMsg;
                                }
                            }
                        } else {
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                        $ionicLoading.hide();
                        console.log($scope.accountInfo);
                    })
                })
            }
        })
    }

    // 倒计时
    $scope.timeCountdown = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeft = $rootScope.payTimeLeft - 1);
        } else {
            $rootScope.payTimeLeft = $rootScope.payTimeLeft - 1;
        }
        clearTimeout($rootScope.payResendTimeer);
        if ($rootScope.payTimeLeft > 0) {
            $rootScope.payResendTimeer = setTimeout($scope.timeCountdown, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatus = 0);
            } else {
                $rootScope.payStatus = 0;
            }
            // 超时处理
            $scope.checkTimeout();
        }
    }

    // 重新获取绑定码倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 前往黄条公用方法
    $scope.goYellowStrip = function (strip) {
        if (strip.type == "video") {
            if (strip.apptType == "5") {
                // 进入小程序
                $scope.olTreatVisit();
            }
            else {
                $state.go('app.consultationList', { treatType: "2" });
            }
        }
        else if (strip.type == "consultation") {
            $scope.goChatRecord();
        }
        else if (strip.type == "ncpApply") {
            $state.go('app.coronavirus', { from: 'personal' });
        }
        else if (strip.type == "olTreatVideo") {
            $state.go('app.olTreatVideo', { vpId: strip.vpId, treatApplyId: strip.treatApplyId });
        }
        // 视频问诊待支付
        else if (strip.type == "referral") {
            $ionicPopup.alert({
                title: '在线问诊转诊提示',
                template: strip.alertMSG,
                okText: "确定"
            }).then(function () {
                $state.go('app.consultationList', { toPayReferral: "1" });
            });
        }
        // 云南新开药
        else if (strip.type == "communityRecipe") {
            $ionicPopup.confirm({
                title: '提示',
                template: '患者您好，医生已为您开具处方，您可进行在线缴费，药品快递到家',
                cancelText: '取消',
                okText: '查看'
            }).then(function (res) {
                if (res) {
                    $ionicLoading.show();
                    OlTreatRecipeService.convertCommunityApply(strip.treatApplyId, strip.idCardCode).then(function (data) {
                        $ionicLoading.hide();
                        if (data.result == 1) {
                            $state.go('app.olTreatRecipeList', { status: '0', from: 'app.home' });
                        }
                        else {
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                    }, function (data) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                    })
                }
            });
        }
        // 医保移动支付
        else if (strip.type == "ybApp") {
            //var html = "<div>";
            //html += "<p>请选择支付方式</p>";

            //// 微信小程序
            //html += "<div style='display: flex;padding-bottom: 1em;'>";
            //html += "<div style='width: calc(100% - 4em)'>微信小程序</div>";
            //html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
            //html += "<button class='button button-small button-calm' ng-click='ybPay(1, \"'" + strip.vpId + "\", \"" + strip.opPaymentId + "\");' style='max-height: 4em;line-height: 1.5em;'>";
            //html += "<span style='font-size:14px;'>跳转</span>";
            //html += "</button>";
            //html += "</div>";
            //html += "</div>";

            //// 支付宝小程序
            //html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;'>";
            //html += "<div style='width: calc(100% - 4em)'>支付宝小程序</div>";
            //html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
            //html += "<button class='button button-small button-calm' ng-click='ybPay(2, \"" + strip.vpId + "\", \"" + strip.opPaymentId + "\");' style='max-height: 4em;line-height: 1.5em;'>";
            //html += "<span style='font-size:14px;'>跳转</span>";
            //html += "</button>";
            //html += "</div>";
            //html += "</div>";

            //html += "</div>";

            //$scope.confirmPopup = $ionicPopup.alert({
            //    title: "提示",
            //    template: html,
            //    buttons: [
            //        {
            //            text: "取消",
            //            onTap: function (e) { }
            //        }
            //    ],
            //    scope: $scope
            //});

            $ionicPopup.confirm({
                title: '提示',
                template: '将自动跳转至北京医保支付宝小程序',
                cancelText: '取消',
                okText: '前往'
            }).then(function (res) {
                if (res) {
                    $scope.ybPay(2, strip.vpId, strip.opPaymentId);
                }
            });
        }
        // 复诊续方快递到家
        else if (strip.type == "olTreatExpress") {
            $state.go('app.olTreatRecipeList', { status: '0', from: 'app.personal' });
        }
        // 图文问诊
        else if (strip.type == "byTreatPadding") {
            $state.go('app.consultationList', { treatType: "1" });
        }
    }

    // 倒计时
    $scope.timeCountdownNCP = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftNCP = $rootScope.payTimeLeftNCP - 1);
        } else {
            $rootScope.payTimeLeftNCP = $rootScope.payTimeLeftNCP - 1;
        }
        clearTimeout($rootScope.payResendTimeerNCP);
        if ($rootScope.payTimeLeftNCP > 0) {
            $rootScope.payResendTimeerNCP = setTimeout($scope.timeCountdownNCP, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusNCP = 0);
            } else {
                $rootScope.payStatusNCP = 0;
            }
            // 超时处理
            $scope.checkTimeoutNCP();
        }
    }

    // 超时处理
    $scope.checkTimeoutNCP = function () {
        for (var i = 0; i < $scope.yellowStripList.length; i++) {
            if ($scope.yellowStripList[i].type == "ncpApply") {
                $scope.yellowStripList[i].isShow = false;
            }
        }
    }

    // 视频问诊支付倒计时
    $scope.timeCountdownOlTreatVideo = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftOlTreatVideo = $rootScope.payTimeLeftOlTreatVideo - 1);
        } else {
            $rootScope.payTimeLeftOlTreatVideo = $rootScope.payTimeLeftOlTreatVideo - 1;
        }
        clearTimeout($rootScope.payResendTimeerOlTreatVideo);
        if ($rootScope.payTimeLeftOlTreatVideo > 0) {
            $rootScope.payResendTimeerOlTreatVideo = setTimeout($scope.timeCountdownOlTreatVideo, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusOlTreatVideo = 0);
            } else {
                $rootScope.payStatusOlTreatVideo = 0;
            }
            // 超时处理
            $scope.checkTimeoutOlTreatVideo();
        }
    }

    // 视频问诊超时处理
    $scope.checkTimeoutOlTreatVideo = function () {
        console.log("个人中心视频问诊超时处理");
        for (var i = 0; i < $scope.yellowStripList.length; i++) {
            if ($scope.yellowStripList[i].type == "olTreatVideo") {
                $scope.yellowStripList[i].isShow = false;
            }
        }
    }

    // 复诊续方快递到家倒计时
    $scope.timeCountdownOlTreatExpress = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftOlTreat = $rootScope.payTimeLeftOlTreat - 1);
        } else {
            $rootScope.payTimeLeftOlTreat = $rootScope.payTimeLeftOlTreat - 1;
        }
        clearTimeout($rootScope.payResendTimeerOlTreat);
        if ($rootScope.payTimeLeftOlTreat > 0) {
            $rootScope.payResendTimeerOlTreat = setTimeout($scope.timeCountdownOlTreatExpress, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusOlTreat = 0);
            } else {
                $rootScope.payStatusOlTreat = 0;
            }

            // 超时处理
            $scope.checkTimeoutOlTreatExpress();
        }
    }

    // 复诊续方快递到家超时处理
    $scope.checkTimeoutOlTreatExpress = function () {
        console.log("个人中心复诊续方快递到家超时处理");
        for (var i = 0; i < $scope.yellowStripList.length; i++) {
            if ($scope.yellowStripList[i].type == "olTreatExpress") {
                $scope.yellowStripList[i].isShow = false;
            }
        }
    }

    // 图文问诊倒计时
    $scope.timeCountdownBYTreatPadding = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftBYTreatPadding = $rootScope.payTimeLeftBYTreatPadding - 1);
        } else {
            $rootScope.payTimeLeftBYTreatPadding = $rootScope.payTimeLeftBYTreatPadding - 1;
        }
        clearTimeout($rootScope.payResendTimeerBYTreatPadding);
        if ($rootScope.payTimeLeftBYTreatPadding > 0) {
            $rootScope.payResendTimeerBYTreatPadding = setTimeout($scope.timeCountdownBYTreatPadding, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusBYTreatPadding = 0);
            } else {
                $rootScope.payStatusBYTreatPadding = 0;
            }

            // 超时处理
            $scope.checkTimeoutBYTreatPadding();
        }
    }

    // 图文问诊超时处理
    $scope.checkTimeoutBYTreatPadding = function () {
        console.log("个人中心图文问诊超时处理");
        for (var i = 0; i < $scope.yellowStripList.length; i++) {
            if ($scope.yellowStripList[i].type == "byTreatPadding") {
                $scope.yellowStripList[i].isShow = false;
            }
        }
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // 跳转登陆页
    $scope.goLogin = function () {
        $state.go("login");
    }

    // #region 跳转
    // 2020-2-21 08:28:33 无脑返回首页 避免死循环
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        $state.go('app.home');
    }
    $scope.goWishlist = function () {
        $state.go('app.wishlist');
    }
    // 我的就诊人
    $scope.goVisitPatient = function (id) {
        $state.go('app.visitPatient', { vpid: id });
    }
    // 我的预约挂号
    $scope.goApptList = function (status) {
        $state.go('app.apptList', { status: status, from: 'app.personal' });
    }
    // 个人设置
    $scope.goSetting = function () {
        $state.go('app.setting');
    }
    // 安全中心
    $scope.goSecurityCenter = function (accountId) {
        $state.go('app.securityCenter', { accountId: accountId });
    }
    $scope.goAddWish = function (accountId) {
        $state.go('app.addWish');
    }
    $scope.goOpReg = function () {
        $state.go('app.opReg');
    }
    $scope.goOpRegList = function (status) {
        $state.go('app.opRegList', { status: status });
    }
    $scope.goOpAppt = function () {
        $state.go('app.opAppt');
    }
    $scope.goOpApptList = function (status) {
        $state.go('app.opApptList', { status: status });
    }
    // 消息中心
    $scope.goMessage = function () {
        $ionicViewSwitcher.nextDirection('forward');
        $state.go('app.message');
    }
    // 满意度调查
    $scope.goSatis = function (status) {
        $state.go('app.satis', { status: status });
    }
    // 预约说明
    $scope.goApptDescr = function (status) {
        $state.go('app.apptDescr');
    }
    // 我的开药
    $scope.goOlTreatRecipeList = function (status) {
        $state.go('app.olTreatRecipeList', { status: status, from: 'app.personal' });
    }
    // 我的查体预约
    $scope.medicalAppointForm = function (status) {
        $state.go('app.medicalAppointForm', { status: status, from: 'app.home' });
    }
    // 我的病案复印
    $scope.goCasePrintList = function (status) {
        $state.go('app.casePrintList');
    }
    // 关于我们
    $scope.goAboutUs = function (status) {
        $state.go('app.aboutUs');
    }
    // 使用帮助
    $scope.goInstruction = function () {
        $state.go('app.instruction');
    }
    // 我的在线问诊
    $scope.goChatRecord = function () {
        $state.go('app.consultationList');
    }
    // 自动问诊
    $scope.goAutoInquiryFeedBack = function () {
        $state.go('app.autoInquiryFeedback');
    }
    // 视频候诊叫号
    $scope.goVideoCall = function () {
        $state.go('app.videoCall');
    }
    // 诊前问卷
    $scope.goOpQuerstionnaire = function (vpid, opregid, type) {
        $state.go('app.opQuestionnaire', { vpid: vpid, opregid: opregid, type: type });
    }
    // 投诉建议
    $scope.goComplain = function () {
        $state.go('app.complain');
    }
    // 患者随访（住院满意度）
    $scope.goIpSatis = function () {
        $state.go('app.ipSatis');
    }
    // 我的检查检验
    $scope.goOpPendingCheck = function () {
        $state.go('app.dealWithCard', { go: 'opPendingCheck' });
    }
    // 我的康复治疗
    $scope.goRhbPlan = function () {
        $state.go('app.dealWithCard', { go: 'rhbPlan' });
    }
    // 我的复诊计划
    $scope.goSubVisit = function () {
        $state.go('app.dealWithCard', { go: 'subVisit' });
    }

    // 跳转就诊人管理（适老化）
    $scope.goVisitPatientManagement = function () {
        $state.go("app.dealWithCard", { go: "home" });
    }

    // 跳转恢复室探视小程序
    $scope.olTreatVisit = function () {
        // 2022-5-23 09:03:51 HM 不用传小程序路径了，在插件里写死了
        var param = { type: "olTreatVisit", param: "olTreatVisit" };

        var funcSuccess = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
            console.log(data);
        }
        var funcError = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
            console.log(data);
        }

        window.plugins.MiniProgramPlugin.launchMiniProgramV2(param, funcSuccess, funcError);
    }

    // 2023-7-31 15:11:41 HM 跳转微信小程序
    $scope.ybPay = function (type, vpId, opPaymentId) {
        if (type == 1) {
            type = "wx";
        }
        else {
            type = "zfb";
        }

        // 先去找首信，请求所需的参数
        $ionicLoading.show();
        OpPaymentService.bjybMobilePayment(vpId, opPaymentId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 跳转小程序的路径url
                var pageUrl = data.url;

                if (type == "zfb") {
                    // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
                    var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent(pageUrl));

                    //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                    //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
                    //2023.7.31 新插件原有调用方式参数不生效
                    showInAppBrowser(herfUrl, '_system');

                    // var param = { type: "BJYB", url: pageUrl };

                    // var funcSuccess = function (data) {
                    //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用成功");
                    //     console.log(data);
                    // }
                    // var funcError = function (data) {
                    //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用失败");
                    //     console.log(data);
                    // }

                    // window.plugins.MiniProgramPlugin.launchZFBMiniProgramByPageUrl(param, funcSuccess, funcError);
                }
                else {
                    $fwCordovaToast.showShortBottom("暂不支持微信小程序");
                }
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }
    // #endregion
})