﻿angular.module('fwapp.controllers')

.controller('PreVisitController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout, $location, $cordovaKeyboard,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $cordovaDatePicker,
    AccountService, VisitPatientService, RequestService, PreVisitService, $fwCordovaToast, $ionicSlideBoxDelegate, $ionicPlatform, $ionicHistory) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义诊前信息滑块
    var slidePreVisit = $ionicSlideBoxDelegate.$getByHandle('slidePreVisit');
    //var scrollPreVisit = new Object();
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slidePreVisit.enableSlide(false);
        //scrollPreVisit = $ionicScrollDelegate.$getByHandle('scrollPreVisit');
        //console.log(scrollPreVisit);
        // 判断from跳转到子页面
        if ($scope.from != "") {
            console.log($scope.from);
            setTimeout(function () {
                $scope.loadPvDetail('');
            }, 500);
        }
    });

    // 初始滑块状态
    $scope.step = 0;

    $scope.currentPlatform = currentPlatform;

    // 打哪儿来
    $scope.from = ($stateParams.from == null || $stateParams.from.length == 0) ? "" : $stateParams.from;
    // 就诊人ID
    $scope.vpId = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "" : $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人列表
    $scope.vpList = [];

    // 是否加载完成
    $scope.isLoadFinish = false;
    // 保存按钮可用
    $scope.canSave = true;

    // 诊前信息列表
    $scope.pvInfoList = [];
    // 诊前信息数据
    $scope.pvInfo = new Object();
    // 诊前信息数据 用于返回时判断是否更改
    $scope.pvInfoOri = new Object();
    // 本页诊前信息数据
    $scope.pvInfoMain = new Object();
    // 本页诊前信息数据 用于返回时判断是否更改
    $scope.pvInfoMainOri = new Object();

    // 检查化验图像
    $scope.imageList = [];
    // 大图列表
    $scope.uploadImgList = [];
    // 图片服务器路径
    $scope.imgServerUrl = uploadUrl;
    $scope.slides = [];
    $scope.currentImgIndex = 0;
    $scope.currentSlideIndex = 0;
    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 注册模态窗口：弹出图片
    $ionicModal.fromTemplateUrl("popup_image.html", {
        scope: $scope,
        animation: "fade-in"
    }).then(function (modal) {
        $scope.popupImageModal = modal;
    });

    // 绑定清除事件，移除所有模态窗口，防止溢出
    $scope.$on("$destroy", function () {
        $scope.popupImageModal.remove();
    })

    // 滑到指定页
    $scope.toSlide = function (index) {
        slidePreVisit.slide(index);
        $scope.step = slidePreVisit.currentIndex();
        if ($scope.step == 0) {
            $scope.pvInfo = new Object();
            $scope.pvInfoOri = new Object();
        }
        console.log("页码");
        console.log($scope.step);
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页 用药计划列表 正常后退
        if ($scope.step == 0) {
            //$rootScope.goBack();
            if ($stateParams.vpid == "") {
                //$scope.toggleSlideMenu();
                $rootScope.goBack();
            }
            else {
                //$scope.toggleSlideMenu();
                $state.go('app.visitPatient', { vpid: $scope.vpId });
            }
        }
        // 其他页返回第一个滑块
        else {
            // 检查是否更改
            $scope.checkChange();
        }
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    //#region 列表加载
    function loadStart() {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        $scope.canSave = false;
    }

    function loadFinish() {
        $scope.isLoadFinish = true;
        $scope.canSave = true;
        $ionicLoading.hide();
    }

    // 读取诊前信息详情
    $scope.loadPvDetail = function () {
        loadStart();
        $scope.pvInfo = new Object();
        $scope.pvInfoOri = new Object();
        $scope.toSlide(1);

        PreVisitService.detail($scope.vpId, localStorage.queryToken).then(function (data) {
            //console.log(data.result);
            // 无效QueryToken
            if (data.result == -2) {
                loadFinish();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadPvDetail();
                    }
                })
                return;
            }
            // 请求错误
            else if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            else if (data.result == 1) {
                $scope.pvInfo = data.data;
                // 格式化日期
                for (var i in data.data.visitHistoryHeart) {
                    if (currentPlatform == "iOS") {
                        data.data.visitHistoryHeart[i].DATE_VISIT = data.data.visitHistoryHeart[i].DATE_VISIT.replace(/-/g, "/");
                    }
                    data.data.visitHistoryHeart[i].DATE_VISIT = new Date(data.data.visitHistoryHeart[i].DATE_VISIT).Format("yyyy-MM-dd");
                }
                for (var i in data.data.operationHistory) {
                    if (currentPlatform == "iOS") {
                        data.data.operationHistory[i].DATE_VISIT = data.data.operationHistory[i].DATE_VISIT.replace(/-/g, "/");
                    }
                    data.data.operationHistory[i].DATE_VISIT = new Date(data.data.operationHistory[i].DATE_VISIT).Format("yyyy-MM-dd");
                }
                for (var i in data.data.diseaseHistory) {
                    if (currentPlatform == "iOS") {
                        data.data.diseaseHistory[i].DATE_DISEASE = data.data.diseaseHistory[i].DATE_DISEASE.replace(/-/g, "/");
                    }
                    data.data.diseaseHistory[i].DATE_DISEASE = new Date(data.data.diseaseHistory[i].DATE_DISEASE).Format("yyyy-MM-dd");
                }
                // 本页可修改数据
                $scope.pvInfoMain.pvId = data.data.preVisitInfo.PREVISIT_INFO_ID;
                $scope.pvInfoMain.mainComplain = data.data.preVisitInfo.MAIN_COMPLAIN;
                $scope.pvInfoMain.symptom = data.data.preVisitInfo.SYMPTOM;
                if (currentPlatform == "iOS") {
                    data.data.preVisitInfo.DATE_DISEASE = data.data.preVisitInfo.DATE_DISEASE.replace(/-/g, "/");
                }
                $scope.pvInfoMain.diseaseDate = new Date(data.data.preVisitInfo.DATE_DISEASE).Format("yyyy-MM-dd");
                console.log(new Date(data.data.preVisitInfo.DATE_DISEASE));
                $scope.pvInfoMain.diseaseName = data.data.preVisitInfo.DISEASE_NAME;
                // 保留一份初始数据
                $.extend($scope.pvInfoMainOri, $scope.pvInfoMain);
                // textarea高度调整
                setTimeout(function () {
                    $scope.autoHight('taMainComplain');
                    $scope.autoHight('taSymptom');
                }, 500);
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();
            }
            loadFinish();
        });
    }

    //#endregion
    // 新建/编辑诊前信息
    $scope.editPreVisitInfo = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        console.log($.param($scope.pvInfoMain));
        console.log($scope.pvInfoMain);
        loadStart();
        // 保存
        PreVisitService.editInfo($scope.pvInfoMain, $scope.vpId).then(function (data) {
            console.log(data);
            // 请求错误
            if (data.result == "0") {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == "1") {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.loadPvDetail();
                $.extend($scope.pvInfoMainOri, $scope.pvInfoMain);
            }
            loadFinish();
        });
    }

    // 检查是否更改
    $scope.checkChange = function () {
        console.log($.param($scope.pvInfoMainOri));
        console.log($.param($scope.pvInfoMain));
        if ($.param($scope.pvInfoMainOri) != $.param($scope.pvInfoMain)) {
            // 提示保存
            var confirmPopup = $ionicPopup.confirm({
                title: '保存诊前信息',
                template: "诊前信息已更改,是否保存？",
                cancelText: '放弃更改',
                okText: '保存'
            }).then(function (res) {
                if (res) {
                    $scope.editPreVisitInfo();
                }
                else {
                    $scope.toSlide(0);
                }
            })
        }
        else {
            $scope.toSlide(0);
        }
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid;
        $scope.vpInfo = new Object();
        $scope.loadVPInfo();
        $scope.popVplist.hide();
    }

    // 滑块切换触发
    $scope.slideChanged = function () {
        // 返回清空数据
        //$scope.isLoadFinish = false;
        $scope.pvInfo = new Object();
        $scope.pvInfoMain = new Object();
        $scope.pvInfoMainOri = new Object();
        $scope.imageList = [];

        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'preVisit');
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }

                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                } else {
                    console.log($scope.vpId);
                    $scope.loadVPInfo();
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'preVisit') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    //#region cordova日期选择
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
    //#endregion

    //#region 列表中图片操作
    $scope.imageAddSave = function (type, path) {
        // 保存数据vpId, preVisitInfoId, type, filePath
        PreVisitService.imageAdd($scope.vpId, $scope.pvInfo.PREVISIT_INFO_ID, type, path).then(function (data) {
            if (data.result == 1) {
                $scope.imageList.push(data.data);
            }
            //break;
            //$scope.currentIncidentId = 0;
        })
    }

    // 显示图片删除按钮
    $scope.showImgDelete = function () {
        for (var i = 0; i < $scope.imageList.length; i++) {
            $scope.imageList[i].isImgDelete = true;
        }
    }

    // 隐藏图片删除按钮
    $scope.cancelImgDelete = function () {
        for (var i = 0; i < $scope.imageList.length; i++) {
            $scope.imageList[i].isImgDelete = false;
        }
    }

    // 删除图片
    $scope.imgDelete = function (id) {
        console.log(id);
        //console.log($scope.donatorImage);
        $ionicPopup.confirm({
            title: "删除确认",
            template: "确定要删除该图片？",
            cancelText: "取消",
            okText: "确定"
        }).then(function (res) {
            if (res) {
                PreVisitService.imageDelete(id).then(function (data) {
                    for (var j = 0; j < $scope.imageList.length; j++) {
                        if ($scope.imageList[j].PREVISIT_IMAGE_ID == id) {
                            $scope.imageList.splice(j, 1);
                            $fwCordovaToast.showShortBottom("删除成功");
                            break;
                        }
                    }
                })
            }
            $scope.showImgDelete();
        });
    }

    // 显示弹出大图
    $scope.popupImgShow = function (list, index) {
        $ionicModal.fromTemplateUrl("popup_image.html", {
            scope: $scope,
            animation: "fade-in"
        }).then(function (modal) {
            $scope.popupImageModal = modal;
            // 赋值图片列表
            $scope.uploadImgList = list;
            var cIndex = index;
            var preIndex = index == 0 ? list.length - 1 : index - 1;
            var nextIndex = index == list.length - 1 ? 0 : index + 1;

            $scope.currentImgIndex = cIndex;
            $scope.currentSlideIndex = 1;

            $scope.slides[0] = { src: list[preIndex].URL, seq: preIndex };
            $scope.slides[1] = { src: list[cIndex].URL, seq: cIndex };
            $scope.slides[2] = { src: list[nextIndex].URL, seq: nextIndex };
            //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
            // 显示弹出层
            $scope.popupImageModal.show();
        });
    }

    // 隐藏弹出大图
    $scope.popupImgHide = function () {
        // 清空图片列表
        $scope.uploadImgList = [];
        //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
        // 隐藏弹出
        $scope.popupImageModal.hide();
        $scope.popupImageModal.remove();
    }

    // 选中切换
    $scope.popupImgSlideChange = function (index) {
        var change = $scope.currentSlideIndex + ">" + index;
        $scope.currentSlideIndex = index;
        if (change == "2>0" || change == "0>1" || change == "1>2") {
            var sIndex = index + 1;
            if (sIndex == 3) {
                sIndex = 0;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex + 1;
            if (iIndex == $scope.uploadImgList.length) {
                iIndex = 0;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
        else if (change == "0>2" || change == "2>1" || change == "1>0") {
            var sIndex = index - 1;
            if (sIndex == -1) {
                sIndex = 2;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex - 1;
            if (iIndex == -1) {
                iIndex = $scope.uploadImgList.length - 1;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
    }

    // 阻止事件冒泡
    $scope.stopPropagation = function () {
        event.stopPropagation();
    }
    //#endregion

    //#region 单选多选控件
    // 延迟重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicScrollDelegate.resize();
        }, 500);
    }

    // 不可取消单选按钮
    $scope.flupRadio = function (qstnId, dicValue) {
        $scope.pvInfo[qstnId] = dicValue;
        $scope.scrollResize();
    }

    // 可取消单选按钮
    $scope.flupCheckbox = function (qstnId, dicValue) {
        $scope.pvInfo[qstnId] = $scope.pvInfo[qstnId] == dicValue ? "" : dicValue;
        $scope.scrollResize();
    }

    //#endregion

    //#region textarea自适应高度
    $scope.autoHight = function (id) {
        console.log($("#" + id));
        console.log($("#" + id)[0].scrollHeight);
        $("#" + id).css("height", ($("#" + id)[0].scrollHeight + 2) + "px");
        $ionicScrollDelegate.resize();
    }
    //#endregion

    // 判断当前就诊记录是否有图
    $scope.hasImage = function (vhId) {
        for (var i in $scope.pvInfo.visitImageHeart) {
            if (vhId == $scope.pvInfo.visitImageHeart[i].VISIT_HISTORY_ID) {
                return true;
            }
        }
        return false;
    }

    // 计算年龄
    $scope.getAge = function (strDate) {
        if (currentPlatform == "iOS") {
            strDate = strDate.replace(/-/g, "/");
        }
        var birthday = new Date(strDate);
        return birthday.GetAge();
    }

    // 计算年数
    $scope.getYears = function (strDate) {
        if (currentPlatform == "iOS") {
            strDate = strDate.replace(/-/g, "/");
        }
        var dateStart = new Date(strDate);
        var years = dateStart.GetAge();
        return years.indexOf('/') > -1 ? '不足1年' : (years + ' 年');
    }

    // 导航栏
    $scope.navList = [
    { title: '主诉', col: "preVisitInfo" },
    { title: '就诊记录', col: "visitHistoryHeart" },
    { title: '基本信息', col: "baseInfo" },
    { title: '手术史', col: "operationHistory" },
    { title: '身体概况', col: "bodyInfo" },
    { title: '既往史', col: "diseaseHistory" },
    { title: '目前用药', col: "medicationPlan"}];

    // 滚动至id
    $scope.anchorScroll = function (id) {
        //console.log(id + ',' + $("#" + id)[0].offsetTop);
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
        //console.log($ionicScrollDelegate.getScrollPosition());
    }

    // #region 跳转
    // 前进至就诊记录
    $scope.goVisitHistory = function () {
        $state.go("app.visitHistory", { vpid: $scope.vpId, from: "app.preVisit" });
    }

    // 前进至健康资料列表
    $scope.goHealthInfo = function (part) {
        $state.go("app.healthinfo", { vpid: $scope.vpId, part: part, from: "app.preVisit" });
    }

    // 前进至既往史
    $scope.goDiseaseHistory = function () {
        $state.go("app.diseaseHistory", { vpid: $scope.vpId, from: "app.preVisit" });
    }

    // 前进至用药提醒
    $scope.goMedication = function () {
        $state.go("app.medicationPlan", { vpid: $scope.vpId, from: "app.preVisit" });
    }
    // #endregion

    // 绑定键盘事件
    window.addEventListener('native.keyboardshow', function () {
        console.log('keyboardshow');
    });
    window.addEventListener('native.keyboardhide', function () {
        console.log('keyboardhide');
    });
});
