﻿angular.module('fwapp.controllers')

// 查询密码
.controller('QueryPasswordController', function ($scope, $rootScope, $state, $stateParams, $timeout, $fwCordovaToast,
    QueryPasswordService, ChangePhoneNumberService, AccountService,
    $ionicPopup, $ionicHistory, $ionicModal, $ionicSlideBoxDelegate, $ionicPlatform) {

    $scope.goBackType = 0;

    $scope.phone = {
        number: '',
        code: '',
        imageVericode: ''
    }

    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};

    $scope.goBack = function () {
        switch ($scope.goBackType) {
            case 0:
                //                $state.go("app.securityCenter");
                $ionicHistory.goBack();
                break;
            case 1:
                slideBox.slide(0);
                $scope.goBackType = 0;
                break;
        }

    }

    // slide box
    var slideBox = $ionicSlideBoxDelegate.$getByHandle('slideBox');

    //不准滑动
    //$scope.lockSilde = function () {
    //    $ionicSlideBoxDelegate.enableSlide(false);
    //}

    // 2023-10-13 08:59:18 CGZ #hzfwx-280 不知道当年为什么注释了禁用滑动，但是此处滑动会导致白屏问题，在DomUtil.ready事件中加回来
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideBox.enableSlide(false);
    });

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'queryPassword');

        // 2020.02.28 BST 根据登录账号获取手机号,无需用户再次输入手机号
        AccountService.accountInfo().then(function (data) {
            if (data.result == 1) {
                var accountPhoneNum = data.data.PHONENUM;
                if (accountPhoneNum != null && accountPhoneNum != "") {
                    $scope.phone.number = accountPhoneNum;
                }
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'queryPassword') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });


    // 防止多次获取验证码
    $scope.disableGetVericode = false;
    // 防止多次下一步
    $scope.disableVerify = false;

    $scope.type = $stateParams.type;

    // 模拟键盘结果
    $scope.simKeyValue = [];
    // 模拟键盘用途
    $scope.simKeyPurpose = 0;

    // 验证码发送时间间隔
    $scope.timespan = 0;

    //手机获取验证码
    $scope.getVerifyCode = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 验证图片验证码
        if ($scope.phone.imageVericode == null || $scope.phone.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        //如果填写的旧号码正确
        if ($stateParams.phoneNumber == '' || $scope.phone.number == $stateParams.phoneNumber) {
            $scope.disableGetVericode = true;
            AccountService.sendVericodeByPhone($scope.phone.number, "4", $scope.phone.imageVericode).then(function (data) {
                // 发送成功
                if (data.result == 1) {
                    // 倒计时
                    $scope.timespan = 60;
                    TimeCount();
                }
                // 服务调用失败
                else if (data.result == 0) {
                    // 刷新图片验证码
                    $scope.getImageVericode();
                    var alertPopup = $ionicPopup.alert({
                        title: '验证失败',
                        template: data.msg
                    });
                }
                // 发送次数过多
                else {
                    // 刷新图片验证码
                    $scope.getImageVericode();
                    var alertPopup = $ionicPopup.alert({
                        title: '验证失败',
                        template: '获取验证码失败，请稍后重试'
                    });
                }
                $scope.disableGetVericode = false;
            }, function (data) {
                $scope.disableGetVericode = false;
            });
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '手机号错误',
                template: '您输入的手机号与本账号手机号不符，请检查'
            });
        }
    }

    //验证手机验证码
    $scope.verifyCode = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $scope.accountId = localStorage.currentAccountId;
        // 如果不能获取到accountId，转到登录页，如果能，修改密码
        if ($scope.accountid == '') {
            var alertPopup = $ionicPopup.alert({
                title: '请先登录',
                template: null
            });
            // 删除用户信息
            localStorage.hasLogin = 0;
            $rootScope.hasLogin = 0;
            localStorage.currentAccountId = "";
            // 初始化一下消息中心提示
            // 是否有未读消息
            $rootScope.hasUnread = false;
            $rootScope.unReadCount = 0;
            // 跳转到登录页
            $state.go('login');
        }
        else {
            $scope.disableVerify = true;
            ChangePhoneNumberService.compareVericode($scope.phone.number, $scope.phone.code, currentPlatform, deviceToken, "4").then(function (data) {
                if (data.result == 1) {
                    slideBox.next();
                    $scope.timespan = 0; //倒计时清零
                    $scope.simKeyShow("reset1");
                    $scope.simKeyInfo = "请输入新的查询密码";
                    $scope.simKeyValue = [];
                }
                else {
                    var alertPopup = $ionicPopup.alert({
                        title: '验证失败',
                        template: data.msg
                    });
                }
                $scope.disableVerify = false;
            }, function (data) {
                $scope.disableVerify = false;
            })
        }
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 注册模态窗口：查询密码
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('simKeyboard.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.simKeyboardModal = modal;
        //console.log($stateParams.type);
        $scope.type = $stateParams.type == 'new';
        //console.log($scope.type);
        if ($stateParams.type == 'new') {
            $scope.simKeyShow("new1");
        } else if ($stateParams.type == 'change') {
            //            console.log(slideBox);
            //            slideBox.next();
        } else if ($stateParams.type == 'changePwd') {
            $scope.getImageVericode();
            $timeout(function () {
                slideBox.next();
            }, 1);
            $scope.goBackType = 0;
        }
    });

    $scope.changeQueryPassword = function () {
        $scope.simKeyShow("verify");
    }

    $scope.resetQueryPassword = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        slideBox.next();
        $scope.goBackType = 1;
    }

    // 显示模拟键盘
    $scope.simKeyShow = function (purpose) {
        switch (purpose) {
            case "new1":
                $scope.simKeyInfo = "首次使用，请设置查询密码";
                break;
            case "new2":
                $scope.simKeyInfo = "确认查询密码";
                break;
            case "verify":
                $scope.simKeyInfo = "验证查询密码";
                break;
        }
        $scope.simKeyPurpose = purpose;
        $scope.simShowIndex = 0;
        $scope.simKeyValue = [];
        $scope.simKeyboardModal.show();
    }


    // 模拟键盘关闭事件
    $scope.simKeyClose = function () {
        $scope.simKeyboardModal.hide();
        if ($scope.type) {
            $state.go("app.securityCenter");
        }
    }

    // 模拟键盘输入完成事件
    $scope.simKeyFinish = function () {
        console.log($scope.simKeyValue);
        switch ($scope.simKeyPurpose) {
            case "new1":     // 设置查询密码1
                $scope.simKeyValue1 = $scope.simKeyValue;
                $scope.simKeyInfo = "请再次输入查询密码";
                $scope.simKeyValue = [];
                $scope.simKeyPurpose = "new2";
                break;
            case "new2":     // 确认查询密码
                console.log('from queryPwd');
                var temp1 = '';
                var temp2 = '';
                for (var i = 0; i < 6; i++) {
                    temp1 += $scope.simKeyValue1[i];
                    temp2 += $scope.simKeyValue[i];
                }
                if (temp1 != temp2) {
                    $scope.simKeyValue = [];
                    $fwCordovaToast.showShortBottom("两次输入的密码不一致");
                } else {
                    $scope.simShowIndex = 1;    // 等待页
                    AccountService.setQueryPassword('', temp1).then(function (data) {
                        if (data.result == 0) {
                            $scope.simShowIndex = 0;
                            $scope.simKeyValue = [];
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                        else {
                            $scope.simShowIndex = 2;    // 成功
                            $timeout(function () {
                                $scope.simKeyboardModal.hide();
                            }, 1000);
                            $state.go("app.securityCenter");
                        }
                    });
                }
                break;
            case "verify":     // 验证查询密码
                var temp = '';
                for (var i = 0; i < 6; i++) {
                    temp += $scope.simKeyValue[i];
                }
                $scope.simShowIndex = 1;    // 等待页
                AccountService.checkQueryPassword(localStorage.currentAccountId, temp, false).then(function (data) {
                    if (data.result == 0) {
                        $scope.simShowIndex = 3;
                        $scope.simKeyResult = data.msg;
                        $timeout(function () {
                            $scope.simShowIndex = 0;
                            $scope.simKeyValue = [];
                        }, 1000);
                    }
                    else {
                        $scope.simShowIndex = 0;
                        $scope.simKeyValueVerify = $scope.simKeyValue;
                        $scope.simKeyInfo = "请输入新的查询密码";
                        $scope.simKeyValue = [];
                        $scope.simKeyPurpose = "change1";
                    }
                })
                break;
            case "change1":
                $scope.simKeyValueNew1 = $scope.simKeyValue;
                $scope.simKeyInfo = "请再次输入新的查询密码";
                $scope.simKeyValue = [];
                $scope.simKeyPurpose = "change2";
                break;
            case "change2":
                var temp1 = '';
                var temp2 = '';
                var verify = '';
                for (var i = 0; i < 6; i++) {
                    temp1 += $scope.simKeyValueNew1[i];
                    temp2 += $scope.simKeyValue[i];
                    verify += $scope.simKeyValueVerify[i];
                }
                if (temp1 != temp2) {
                    $scope.simKeyValue = [];
                    $fwCordovaToast.showShortBottom("两次输入的密码不一致");
                } else {
                    $scope.simShowIndex = 1;    // 等待页
                    AccountService.setQueryPassword(verify, temp1).then(function (data) {
                        if (data.result == 0) {
                            $scope.simShowIndex = 0;
                            $scope.simKeyValue = [];
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                        else {
                            $scope.simShowIndex = 2;    // 成功
                            $timeout(function () {
                                $scope.simKeyboardModal.hide();
                                //                                simKeyDefferd.resolve(true);
                            }, 1000);
                            $state.go("app.securityCenter");
                        }
                    });
                }
                break;
            case "reset1":     // 设置查询密码1
                $scope.simKeyValueSet1 = $scope.simKeyValue;
                $scope.simKeyInfo = "请再次输入新的查询密码";
                $scope.simKeyValue = [];
                $scope.simKeyPurpose = "reset2";
                break;
            case "reset2":     // 确认查询密码
                var temp1 = '';
                var temp2 = '';
                for (var i = 0; i < 6; i++) {
                    temp1 += $scope.simKeyValueSet1[i];
                    temp2 += $scope.simKeyValue[i];
                }
                if (temp1 != temp2) {
                    $scope.simKeyValue = [];
                    $fwCordovaToast.showShortBottom("两次输入的密码不一致");
                } else {
                    $scope.simShowIndex = 1;    // 等待页
                    QueryPasswordService.resetQueryPassword($scope.phone.code, temp1).then(function (data) {
                        if (data.result == 0) {
                            $scope.simShowIndex = 0;
                            $scope.simKeyValue = [];
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                        else {
                            $scope.simShowIndex = 2;    // 成功
                            $timeout(function () {
                                $scope.simKeyboardModal.hide();
                            }, 1000);
                            $scope.phone = {
                                number: '',
                                code: ''
                            }
                            $state.go("app.securityCenter");
                        }
                    });
                }
                break;
        }
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.phone.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
})