﻿angular.module('fwapp.controllers')

.controller('ReportController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicPlatform, $ionicHistory, $cordovaInAppBrowser,
    ReportService, AccountService, VisitPatientService, RequestService, ChangePhoneNumberService, $fwCordovaToast) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义检验查询滑块
    var slideReport = $ionicSlideBoxDelegate.$getByHandle('slideReport');
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideReport.enableSlide(false);
    });

    // 初始滑块状态
    $scope.step = 0;
    // 标题数组
    // 2021-4-29 20:40:22 应对4s评审 报告查询模块包含了门诊病历住院病历 改名为诊疗资料
    //$scope.titleList = ['报告查询', '化验单', '检查报告', '门诊病历', '住院列表', '住院病历'];
    $scope.titleList = ['诊疗资料', '化验单', '检查报告', '门诊病历', '住院列表', '住院病历', '健康教育处方'];

    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人列表
    $scope.vpList = [];

    // 是否加载完成
    $scope.isLoadFinish = false;
    // 2021-11-5 19:19:12 检验结果仅显示异常
    $scope.screenFlag = true;
    $scope.showAvailable = false;
    // 防止多次下一步
    $scope.disableVerify = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 防止多次获取验证码
    $scope.disableGetVericode = false;
    //手机验证后直接进入
    $scope.thisResultIndex = 0;
    $scope.thisResultFunc = "";
    //手机验证成功的ID
    $scope.authId = "";
    //下载验证成功的ID
    $scope.downloadId = "";
    // LIS列表
    $scope.lisList = [];
    // 当前检验类型
    $scope.lisType = 1;
    // LIS结果
    $scope.lisResult = {
        INDEX: 0,
        TEST_ORDER_NAME: '',
        SAMPLING_TIME: '',
        SAMPLE_CLASS_NAME: '',
        LIS_RESULT: []
    }
    $scope.timespan = 0;
    $scope.reqId = '';
    $scope.watermark = {};

    // 检查列表
    $scope.checkList = [];
    // 当前检查项目类型  2020-11-27 LBZ 增加注释 查阅后发现，此类型非彼类型，而是检查可查的日期段
    $scope.checkType = 1;
    // 检查结果
    $scope.checkResult = {
        INDEX: 0,
        REPORT_IMAGE: '',
        TITLE: "检查报告"
    }
    // 检查报告图像
    $scope.imgCheckResult = {};
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);

    // 核医学科检查列表 来源于自助机
    $scope.nuclearList = [];
    // 当前核医学科项目类型  2020-11-27 LBZ 增加注释 查阅后发现，此类型非彼类型，而是检查可查的日期段
    $scope.nuclearType = 1;
    // 检查结果
    $scope.nuclearResult = {
        INDEX: 0,
        REPORT_IMAGE: ''
    }

    // 检查影像 门诊病历 住院病历 开关
    $scope.checkReportImageServerStatus = devMode ? true : false;
    $scope.opRecordServerStatus = devMode ? true : false;
    $scope.ipRecordServerStatus = devMode ? true : false;

    // 验卡模型
    $scope.vpVerify = {
        phone_num: '',
        phone_num_show: '',
        imageVericode: '',
        messageVericode: ''
    };

    // 检查报告图像
    $scope.imgUnclearResult = {};

    // 门诊病历
    $scope.opRecordList = [];
    // 当前门诊病历类型
    $scope.opRecordType = 1;

    // 住院列表
    $scope.ipList = [];
    // 当前住院病历类型
    $scope.ipType = 1;

    // 住院病历列表
    $scope.ipRecordList = [];
    // 住院病历需要的参数
    $scope.record_type = "";
    $scope.record_oldnew = "";

    // 健康教育处方列表
    $scope.hlthRecipeList = [];
    // 当前健康教育处方类型
    $scope.hlthRecipeType = 1;

    // 获取当前图片列表zzl（新）
    $scope.checkDataList = [];
    // 图片列表当前索引
    $scope.pageIndex = 0;
    // 检查检验空数据提示 默认值365天
    $scope.reportQueryDays = 365;

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注册模态窗口:LIS结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('lis_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.lisResultModal = modal;
    });

    // 注册模态窗口:检查结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultModal = modal;
    });

    // 注册模态窗口:影像结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result_dicom.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultDicomModal = modal;
    });

    // 注册模态窗口:验证手机号
    $ionicModal.fromTemplateUrl('verifyPhone.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.vpVerify.imageVericode = "";
        $scope.vpVerify.messageVericode = "";
        $scope.verifyPhoneModal = modal;
    });

    // 隐藏模态窗口:验证手机号
    $scope.verifyPhoneModalHide = function () {
        // 隐藏
        $scope.verifyPhoneModal.hide();
    }

    // 注销模态窗口
    $scope.$on('$destroy', function () {
        $scope.lisResultModal.remove();
        $scope.checkResultModal.remove();
        $scope.verifyPhoneModal.remove();
        $scope.checkResultDicomModal.remove();
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 验证查询密码
        $scope.queryPassword().then(function (data) {
            if (data) {
                // 验证门诊/住院病历开关
                if (index == 3 && !$scope.opRecordServerStatus) {
                    $fwCordovaToast.showShortBottom("门诊病历查询功能正在维护中，请稍后再试");
                    return;
                }
                if (index == 4 && !$scope.ipRecordServerStatus) {
                    $fwCordovaToast.showShortBottom("住院病历查询功能正在维护中，请稍后再试");
                    return;
                }
                slideReport.slide(index);
                $scope.step = slideReport.currentIndex();
                //console.log("看下适老化变量:" + $rootScope.elderly);
                if ($scope.step == 1) {
                    // 2021-11-23 19:31:35 HM 适老化看全部
                    // 2024-5-14 13:36:58 CGZ 跟白老师确认，适老化也不能看全部，改为正常版本允许的最长时间
                    // 2024-4-24 zyz #hzfwx-919 修改查询天数默认为一年
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        //$scope.changeLisType(0);
                        $scope.changeLisType($scope.reportQueryDays);
                    }
                    else {
                        $scope.changeLisType($scope.reportQueryDays);
                    }
                }
                if ($scope.step == 2) {
                    // 2024-4-24 zyz #hzfwx-919 修改查询天数默认为一年
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        //$scope.changeCheckType(0);
                        $scope.changeCheckType($scope.reportQueryDays);
                    }
                    else {
                        $scope.changeCheckType($scope.reportQueryDays);
                    }
                }
                // 2021-4-18 11:22:07 HM 发现核医学没有入口，暂时先屏蔽掉吧，这个3我用了
                if ($scope.step == 3) {
                    // $scope.loadNuClearList(1);
                    // 门诊病历查询
                    // 2023-3-25 12:18:39 CGZ 门办李菲菲提了OA允许查询、下载门诊处方，褚老师要求限制一周内
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        //$scope.changeOpRecordType(0);
                        $scope.changeOpRecordType(7);
                    }
                    else {
                        $scope.changeOpRecordType(1);
                    }
                }
                if ($scope.step == 4) {
                    // 住院病历查询
                    // 2023年3月25日12:20:35 CGZ 去掉筛选原因为调用终端打印接口，仅显示2021-03-15之后至当前时间7个工作日之前的全部病历
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        //$scope.changeIpType(0);
                        $scope.changeIpType(90);
                    }
                    else {
                        $scope.changeIpType(1);
                    }
                }
                if ($scope.step == 6) {
                    // 门诊健康教育处方
                    // 2024-5-14 14:31:11 CGZ #hzfwx-919 白老师跟郭雨辰确认，健康教育处方同检查检验报告限制，查询天数固定为一年内
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        //$scope.changeHlthRecipeList(365);
                        $scope.changeHlthRecipeList($scope.reportQueryDays);
                    }
                    else {
                        $scope.changeHlthRecipeList($scope.reportQueryDays);
                    }
                }
            }
        })
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择lis/check）正常后退
        if ($scope.step == 0) {
            if ($stateParams.vpid == "") {
                //$scope.toggleSlideMenu();
                $rootScope.goBack();
            }
            else {
                $state.go('app.visitPatient', { vpid: $scope.vpId });
            }
        }
        else if ($scope.step == 5){
            // 如果是住院病历列表，返回到住院列表
            $scope.toSlide(4);
        }
        // 其他页返回第一个滑块
        else {
            slideReport.slide(0);
            $scope.step = slideReport.currentIndex();
        }
    }

    // 仅显示异常
    $scope.screen = function () {
        $scope.screenFlag = !$scope.screenFlag;
        $scope.showAvailable = !$scope.showAvailable;
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 2023-3-6 15:20:54 CGZ 按8级要求，按照身份证号白名单配置功能开关
    // 获取配置（功能开关）
    $scope.getConfig = function () {
        if (devMode) {
            $scope.checkReportImageServerStatus = true;
            $scope.opRecordServerStatus = true;
            $scope.ipRecordServerStatus = true;
        }
        // 获取配置
        ReportService.getConfig($scope.vpId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                if (!devMode) {
                    // 2021-4-27 19:32:57 查询检查影像开关
                    $scope.checkReportImageServerStatus = data.data.checkReportImageServerStatus;
                    // 2021-4-27 19:33:19 查询门诊病历开关
                    $scope.opRecordServerStatus = data.data.opRecordServerStatus;
                    // 2021-4-27 19:34:02 查询住院病历开关
                    $scope.ipRecordServerStatus = data.data.ipRecordServerStatus;
                }
                // 2024-4-24 zyz #hzfwx-919 添加检查检验配置查询时间
                $scope.reportQueryDays = data.data.reportQueryDays;
                //console.log("getConfig: " + $scope.reportQueryDays);
            }
        })
    }

    //#region 列表加载

    // 读取LIS列表
    $scope.loadLisList = function (type) {
        $scope.screenFlag = true;
        $scope.showAvailable = false;
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.lisList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        //console.log("loadLisList: " + type);
        RequestService.lisList($scope.vpId, type, localStorage.queryToken).then(function (data) {
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadLisList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.lisList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }

            if (data.is_null != 1) { // 空结果
                $scope.lisList = data.data;
            }
            // 非缓存
            loadFinish()
        });
    }

    // 读取检查列表
    $scope.loadCheckList = function (type) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.checkList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        //console.log("loadCheckList: " + type);
        RequestService.checkList($scope.vpId, type, localStorage.queryToken).then(function (data) {
            // 无效Token
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadCheckList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 非缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) {
                        $scope.checkList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            // 正常请求
            if (data.is_null != 1) {
                $scope.checkList = data.data;
            }
            loadFinish();
        });
    }

    // 获取核医学科检查列表
    $scope.loadNuClearList = function (type){
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.nuclearList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        //console.log("loadNuClearList: " + type);
        RequestService.unClearList($scope.vpId, type, localStorage.queryToken, "HYXBG").then(function (data) {
            console.log(data);

            // 无效Token
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadNuClearList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 非缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) {
                        $scope.nuclearList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            // 正常请求
            if (data.is_null != 1) {
                $scope.nuclearList = data.data;
            }
            loadFinish();
        });
    }

    // 获取门诊病历列表
    $scope.loadOpRecordList = function (type){
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.opRecordList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        //console.log("loadOpRecordList: " + type);
        RequestService.opRecordList($scope.vpId, type, localStorage.queryToken).then(function (data){
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadOpRecordList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.opRecordList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 空结果
                $scope.opRecordList = data.data;
            }
            // 非缓存
            loadFinish();
        });
    }

    // 获取住院列表
    $scope.loadIpList = function (type){
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.ipList = [];
        $scope.ipType = type;

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        //cfw 2023年3月8日10:50:31 增加参数，出院日期截止时间，默认为当前时间的前5个工作日
        //console.log("loadIpList: " + type);
        RequestService.ipList($scope.vpId, type, localStorage.queryToken, "").then(function (data) {
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadIpList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.ipList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 空结果
                $scope.ipList = data.data;
            }
            // 非缓存
            loadFinish();
        })
    }

    // 获取住院病历列表
    $scope.ipRecordListShow = function (index){
        $ionicLoading.show();
        $scope.ipRecordList = [];

        $scope.record_type = $scope.ipList[index].CG;
        $scope.record_oldnew = $scope.ipList[index].BRXT;
        RequestService.ipRecordList($scope.vpId, $scope.ipList[index].IDB, $scope.ipList[index].CG, localStorage.queryToken).then(function (data){
            console.log(data);
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.ipRecordListShow(index);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 有结果
                        $scope.ipRecordList = data.data;
                        $scope.toSlide(5);
                    }
                    $ionicLoading.hide();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 有结果
                $scope.ipRecordList = data.data;
                $scope.toSlide(5);
            }
            else{
                $fwCordovaToast.showShortBottom("当前病历不支持查看");
            }

            // 非缓存
            $ionicLoading.hide();
        });
    }

    $scope.record_groups = [
        { group_name: "病历", group_show: "0" },
        { group_name: "检查", group_show: "0" },
        { group_name: "检验", group_show: "0" }
    ];
    // 病历列表折叠、展开
    $scope.showRecordList = function (record_type) {
        // 1 折叠 0 展开
        $scope.record_groups.forEach(element_group => {
            if (element_group.group_name == record_type && element_group.group_show == 0) {
                element_group.group_show = 1;
            } else {
                element_group.group_show = 0;
            }
        });

        $scope.ipRecordList.forEach(element => {
            if (element.LX_MC == record_type) {
                element.SHOW_FLAG = 1;
            } else {
                element.SHOW_FLAG = 0;
            }
        });
        console.log($scope.ipRecordList);
    }

    // 获取健康教育处方列表
    $scope.loadHlthRecipeList = function (type) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.hlthRecipeList = [];
        $scope.hlthRecipeType = type;

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        //console.log("loadHlthRecipeList: " + type);
        RequestService.hlthRecipeList($scope.vpId, type, localStorage.queryToken).then(function (data) {
            console.log(data);
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadHlthRecipeList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.hlthRecipeList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 空结果
                $scope.hlthRecipeList = data.data;
            }
            // 非缓存
            loadFinish();
        }, function () {
            loadFinish();
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    function loadFinish() {
        $ionicLoading.hide();
        $scope.isLoadFinish = true;
    }

    //#endregion

    //#region LIS结果查看

    // 查看LIS结果
    $scope.lisResultShow = function (index) {
        $scope.thisResultIndex = index;
        $scope.thisResultFunc = "lis";
        if ($scope.vpInfo.IS_SELF == 1) {
            $scope.getLisInfo(index);
            $scope.lisResultModal.show();
            AccountService.getWatermark().then(function (data) {
                $scope.watermark = data.data;
            });
        }
        else {
            //验证身份及授权
            ReportService.verify($scope.vpId).then(function(data) {
                //已验证过
                if (data.result == 1) {
                    $scope.getLisInfo(index);
                    $scope.lisResultModal.show();
                    AccountService.getWatermark().then(function (data) {
                        $scope.watermark = data.data;
                    });
                }
                else if(data.result == 0) {//没验证
                    $scope.verifyPhoneModal.show();
                    // 获取预留手机号
                    $scope.GetReservedPhone();
                    // 获取图片验证码
                    $scope.getImageVericode();
                }
                else {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            }, function() {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                return;
            })
        }
    }

    // 关闭LIS结果查看
    $scope.lisResultHide = function () {
        $scope.lisResultModal.hide();
        $scope.lisResult = {
            INDEX: 0,
            TEST_ORDER_NAME: '',
            SAMPLING_TIME: '',
            SAMPLE_CLASS_NAME: '',
            LIS_RESULT: []
        }
    }

    // 获取LIS检验结果
    $scope.getLisInfo = function (index) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        var lis = $scope.lisList[index];
        RequestService.lisResult($scope.vpId, lis.INSPECTION_ID, localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadLisList(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.reqId = data.data[0].REQUEST_ID;
            $scope.lisResult.INDEX = index;
            $scope.lisResult.TEST_ORDER_NAME = lis.TEST_ORDER_NAME;
            $scope.lisResult.SAMPLING_TIME = lis.SAMPLING_TIME;
            $scope.lisResult.SAMPLE_CLASS_NAME = lis.SAMPLE_CLASS_NAME;
            $scope.lisResult.LIS_RESULT = data.data;
            loadFinish();
        });
    }

    //#endregion

    // #region 病历详情

    // 获取住院病历详情
    $scope.ipRecordDetail = function (index){
        $ionicLoading.show();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};

        //cfw 2023年4月11日09:08:53 增加参数$scope.ipRecordList[index].LX，区分病历分类
        RequestService.ipRecordDetail($scope.vpId, $scope.ipRecordList[index].IDR, $scope.ipRecordList[index].IDB, $scope.ipRecordList[index].LX, $scope.record_oldnew, localStorage.queryToken).then(function (data) {
            console.log(data);
            $ionicLoading.hide();

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.ipRecordDetail(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom("当前病历不支持查看");
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "病历详情";
            $scope.checkResultModal.show();
        })
    }

    // 获取门诊病历详情
    $scope.opRecordResult = function (index) {
        $ionicLoading.show();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};

        RequestService.opRecordDetail($scope.vpId, $scope.opRecordList[index].IDB_ASC, $scope.opRecordList[index].IDR_ASC, $scope.opRecordList[index].LB, $scope.opRecordList[index].KH_ASC, $scope.opRecordList[index].BAH, $scope.opRecordList[index].IDT_ASC, $scope.opRecordList[index].FILEPATH_ASC, localStorage.queryToken).then(function (data){
            console.log(data);
            $ionicLoading.hide();

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.opRecordResult(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom("当前病历不支持查看");
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "门诊病历";
            $scope.checkResultModal.show();
            // 请求ID，下载图片的是用
            $scope.reqId = data.reqId;
        })
    }

    // #endregion

    //#region

    // 查看自助机检查结果
    $scope.nuclearResultShow = function (index) {
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
//        if ($scope.unclearList[index].CHECK_STATUS == '0') {
//            $fwCordovaToast.showShortBottom("该核医学检查未出报告，请耐心等待");
//            return false;
//        }
        if ($scope.vpInfo.IS_SELF != 1) {
            $fwCordovaToast.showShortBottom("仅允许关系为本人的就诊人查看核医学检查结果");
            return false;
        }
        $scope.getUnclearInfo(index);
        $scope.checkResultModal.show();
    }

    // 获取核医学检查报告图片
    $scope.getUnclearInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.nuclearList[index];
        RequestService.unClearResult($scope.vpId, check.SQDBH, localStorage.queryToken, "HYXBG").then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckInfo(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "检查报告";
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        });
    }

    //#endregion

    //#region 检查结果查看

    // 查看检查结果
    $scope.checkResultShow = function (index) {
        $scope.thisResultIndex = index;
        $scope.thisResultFunc = "check";
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
        if ($scope.checkList[index].CHECK_STATUS == '0') {
            $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
            return false;
        }
        if ($scope.vpInfo.IS_SELF == 1) {
            $scope.checkResult.TITLE = "检查报告";
            $scope.getCheckInfo(index);
        }
        else {
            //验证身份及授权
            ReportService.verify($scope.vpId).then(function(data) {
                //已验证过
                if(data.result == 1) {
                    $scope.checkResult.TITLE = "检查报告";
                    $scope.getCheckInfo(index);
                } else if(data.result == 0) {
                    $scope.verifyPhoneModal.show();
                    $scope.GetReservedPhone();
                    // 获取图片验证码
                    $scope.getImageVericode();
                } else {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            },function() {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                return;
            })
        }
    }

    // 2023-04-07 ZZL 获取多张图片
    // 查看检查结果(新)
    $scope.checkResultShowLst = function (index) {
        $scope.thisResultIndex = index;
        $scope.thisResultFunc = "check";
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
        if ($scope.checkList[index].CHECK_STATUS == '0') {
            $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
            return false;
        }
        if ($scope.vpInfo.IS_SELF == 1) {
            $scope.checkResult.TITLE = "检查报告";
            $scope.getCheckInfoLst(index);
        }
        else {
            //验证身份及授权
            ReportService.verify($scope.vpId).then(function (data) {
                //已验证过
                if (data.result == 1) {
                    $scope.checkResult.TITLE = "检查报告";
                    $scope.getCheckInfoLst(index);
                } else if (data.result == 0) {
                    $scope.verifyPhoneModal.show();
                    $scope.GetReservedPhone();
                    // 获取图片验证码
                    $scope.getImageVericode();
                } else {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            }, function () {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                return;
            })
        }
    }

    // 关闭检查结果
    $scope.checkResultHide = function () {
        $scope.checkResultModal.hide();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
    }

    // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            var src = $("#imgCheckResultOrigin").prop("src");
            // 防止赋值不同步
            if (src == "") {
                $timeout(function () {
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, 0);
                return;
            }
            // 无图片
            if ($("#imgCheckResult").length != 1) {
                return;
            }
            // 初始化
            if ($("#divCheckResult>#imgCheckResult").length == 0) {
                // 还原节点位置
                $("#divCheckResult").append($("#imgCheckResult"));
                // 删除控件
                //$("#divCheckResult .pinch-zoom-container").remove();
                // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
                $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            }
            // 复制图片路径
            $("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgCheckResult");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgCheckResult = new PinchZoom.default(img, zoomOptions);
            $scope.imgCheckResult.enable();
            console.log($scope.imgCheckResult);
        }, 0);
    }

    // 获取检查报告图片
    $scope.getCheckInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        // 2022-3-8 10:29:37 WX 新增乱码报告屏蔽，且指引下载功能  SYS_CONFIG
        var description = $scope.checkList[index].DESCRIPTION;
        ReportService.isErrorCheckResult($scope.vpId, description).then(function (data) {
            // 直接看
            if (data.result == 1) {
                RequestService.checkResult($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (checkResultData) {
                    $scope.checkResultModal.show();
                    $ionicLoading.hide();
                    $scope.reqId = checkResultData.reqId;
                    if (checkResultData.result == 99) {    // 链接超时
                        $fwCordovaToast.showShortBottom("连接超时，请重试");
                        return;
                    }
                    if (checkResultData.result == -2) {
                        $scope.queryPassword().then(function (dataQuery) {
                            if (dataQuery) {
                                $scope.getCheckInfo(index);
                            }
                        })
                        return;
                    }
                    if (checkResultData.result != 1 && checkResultData.result != -1) {  // 请求错误
                        $fwCordovaToast.showShortBottom(checkResultData.msg);
                        return;
                    }
                    if (checkResultData.is_null == 1) { // 空结果
                        return;
                    }
                    // 有结果 显示base64图片
                    $scope.checkResult.INDEX = index;
                    $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + checkResultData.data;
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, function (err) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                });
                // 有乱码，引导直接下载PDF
            }
            else if (data.result == 2) {
                $ionicLoading.hide();
                $ionicPopup.confirm({
                    title: '提示',
                    template: data.msg,
                    okText: '下载',
                    cancelText: '取消'
                }).then(function (res) {
                    // 下载PDF
                    if (res) {
                        $ionicLoading.show();
                        RequestService.checkResult($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (checkResultData) {
                            $ionicLoading.hide();
                            if (checkResultData.result == 99) {    // 链接超时
                                $fwCordovaToast.showShortBottom("连接超时，请重试");
                                return;
                            }
                            if (checkResultData.result == -2) {
                                $scope.queryPassword().then(function (dataQuery) {
                                    if (dataQuery) {
                                        $scope.getCheckInfo(index);
                                    }
                                })
                                return;
                            }
                            if (checkResultData.result != 1 && checkResultData.result != -1) {  // 请求错误
                                $fwCordovaToast.showShortBottom(checkResultData.msg);
                                return;
                            }
                            if (checkResultData.is_null == 1) { // 空结果
                                return;
                            }
                            // 有结果 执行下载PDF
                            $scope.downloadPDF(checkResultData.reqId, index, "门诊病历");
                        }, function (err) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("连接超时，请重试");
                        });
                    }
                })
            }
            else {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
        }, function () {
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: '当前请求失败，请稍后再试',
                okText: "确定"
            });
            return;
        });
    }

    // 2023-04-07 ZZL 获取多张图片
    // 获取检查报告图片列表zzl（新）
    $scope.getCheckInfoLst = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        // 2022-3-8 10:29:37 WX 新增乱码报告屏蔽，且指引下载功能  SYS_CONFIG
        var description = $scope.checkList[index].DESCRIPTION;
        ReportService.isErrorCheckResult($scope.vpId, description).then(function (data) {
            // 直接看
            if (data.result == 1) {
                RequestService.checkResultList($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (checkResultData) {
                    $scope.checkResultModal.show();
                    $ionicLoading.hide();
                    $scope.reqId = checkResultData.reqId;
                    if (checkResultData.result == 99) {    // 链接超时
                        $fwCordovaToast.showShortBottom("连接超时，请重试");
                        return;
                    }
                    if (checkResultData.result == -2) {
                        $scope.queryPassword().then(function (dataQuery) {
                            if (dataQuery) {
                                $scope.getCheckInfoLst(index);
                            }
                        })
                        return;
                    }
                    if (checkResultData.result != 1 && checkResultData.result != -1) {  // 请求错误
                        $fwCordovaToast.showShortBottom(checkResultData.msg);
                        return;
                    }
                    if (checkResultData.is_null == 1) { // 空结果
                        return;
                    }
                    $scope.checkDataList = checkResultData.data;
                    // 有结果 显示base64图片
                    $scope.checkResult.INDEX = index;
                    $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + checkResultData.data[0];
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, function (err) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                });
                // 有乱码，引导直接下载PDF
            }
            else if (data.result == 2) {
                $ionicLoading.hide();
                $ionicPopup.confirm({
                    title: '提示',
                    template: data.msg,
                    okText: '下载',
                    cancelText: '取消'
                }).then(function (res) {
                    // 下载PDF
                    if (res) {
                        $ionicLoading.show();
                        RequestService.checkResultList($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (checkResultData) {
                            $ionicLoading.hide();
                            if (checkResultData.result == 99) {    // 链接超时
                                $fwCordovaToast.showShortBottom("连接超时，请重试");
                                return;
                            }
                            if (checkResultData.result == -2) {
                                $scope.queryPassword().then(function (dataQuery) {
                                    if (dataQuery) {
                                        $scope.getCheckInfoLst(index);
                                    }
                                })
                                return;
                            }
                            if (checkResultData.result != 1 && checkResultData.result != -1) {  // 请求错误
                                $fwCordovaToast.showShortBottom(checkResultData.msg);
                                return;
                            }
                            if (checkResultData.is_null == 1) { // 空结果
                                return;
                            }
                            // 有结果 执行下载PDF
                            $scope.downloadPDF(checkResultData.reqId, index, "门诊病历");
                        }, function (err) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("连接超时，请重试");
                        });
                    }
                })
            }
            else {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
        }, function () {
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: '提示',
                template: '当前请求失败，请稍后再试',
                okText: "确定"
            });
            return;
        });
    }

    //#endregion

    // #region 检查影像查询

    // 获取检查影响详情
    $scope.checkResultImgShow = function (index){
        $ionicPopup.confirm({
            title: "提示",
            template: "调取影像报告资料，需等待1-2分钟，确认申请查看么？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if(res){
                $scope.checkResult = {
                    INDEX: 0,
                    REPORT_IMAGE: ''
                }
                // 清空图片
                $("#imgCheckResult").prop("src", "");
                // 释放内存
                delete $scope.imgCheckResult;
                $scope.imgCheckResult = {};

                if ($scope.checkList[index].CHECK_STATUS == '0') {
                    $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
                    return false;
                }
                if ($scope.vpInfo.IS_SELF != 1) {
                    $fwCordovaToast.showShortBottom("仅允许关系为本人的就诊人查看检查结果");
                    return false;
                }

                $scope.checkResult.TITLE = "检查影像";
                $scope.getCheckImgInfo(index);
                $scope.checkResultModal.show();
            }
        })
    }

    // 获取检查影像图片
    $scope.getCheckImgInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        RequestService.checkResultImg($scope.vpId, check.ID, localStorage.queryToken).then(function (data){
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckImgInfo(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        })
    }
    // #endregion

    // #region 检查影像查询

    // 获取检查影像详情
    $scope.checkResultDicomShow = function (index) {
        // 判断当前检查是否采集过影像，如果未采集过，走原路径申请采集，否则调用查询影像采集状态
        if ($scope.checkList[index].dicomReqId == null) {
            $ionicPopup.confirm({
                title: "提示",
                template: "调取检查影像资料需等待1-2分钟，确认申请查看么？",
                cancelText: '取消',
                okText: '确定'
            }).then(function (res) {
                if (res) {
                    if ($scope.checkList[index].CHECK_STATUS == '0') {
                        $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
                        return false;
                    }
                    if ($scope.vpInfo.IS_SELF != 1) {
                        $fwCordovaToast.showShortBottom("仅允许关系为本人的就诊人查看检查影像");
                        return false;
                    }

                    $scope.checkResult.TITLE = "检查影像";
                    $scope.getCheckDicomInfo(index);
                }
            })
        }
        else {
            // 查询影像采集状态 成功后打开
            $scope.getDicomCollectStatus(index);
        }
    }

    // 获取检查影像图片
    $scope.getCheckDicomInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        RequestService.checkResultDicom($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (dataDicom) {
            if (devMode) {
                console.log(JSON.stringify(dataDicom));
            }
            $ionicLoading.hide();
            if (dataDicom.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (dataDicom.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckDicomInfo(index);
                    }
                })
                return;
            }
            if (dataDicom.result != 1 && dataDicom.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(dataDicom.msg);
                return;
            }
            if (dataDicom.is_null == 1) { // 空结果
                return;
            }

            // 请求成功，获取reqId用于查询影像采集状态
            $scope.checkList[index].dicomReqId = dataDicom.reqId;
            $scope.checkList[index].dicomUrl = dataDicom.data;

            // 查询影像采集状态 成功后打开
            $scope.getDicomCollectStatus(index);
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        })
    }

    // 2023-3-14 13:56:11 CGZ 查询影像采集状态
    $scope.getDicomCollectStatus = function (index) {
        if ($scope.checkList[index].dicomReqId == null) {
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            return
        }
        $ionicLoading.show();
        RequestService.getDicomCollectStatus($scope.checkList[index].dicomReqId).then(function (data) {
            $ionicLoading.hide();
            // 采集完成 result == 1
            if (data.result == 1) {
                // 赋值URL 打开
                $scope.pacsImageUrl = $scope.checkList[index].dicomUrl;
                $scope.checkResultDicomModal.show();
            }
            // 采集中 result == 2
            else if (data.result == 2) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 采集失败 result == 0
            else if (data.result == 0) {
                // 删除reqId 重新获取
                $scope.checkList[index].dicomReqId = null;
                $scope.checkList[index].dicomUrl = null;
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 删除reqId 重新获取
                $scope.checkList[index].dicomReqId = null;
                $scope.checkList[index].dicomUrl = null;
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            return;
        })
    }

    // 2022.11.18 13:32 朱世博 跳转浏览器影像下载
    window.addEventListener('message', e => {
        // 过滤域名，避免XSS攻击
        if (e.origin === 'https://ychz.fuwai.com:9443' || e.origin === 'http://10.10.127.100:8090') {
            if (e.data.type === 'pacsImgSave') {
                var url = e.data.data;
                //$cordovaInAppBrowser.open(url, '_system').then(function (event) { });
                //2023.7.31 新插件原有调用方式参数不生效
                var inapp = showInAppBrowser(url, '_system');
            }
        }
    })

    // 关闭检查影像结果
    $scope.checkDicomResultHide = function () {
        $scope.checkResultDicomModal.hide();
        $scope.pacsImageUrl = "";
    }

    // 2023-04-07 ZZL 获取多张图片
    // 图片翻页(新)
    $scope.nextPage = function (pageIndex, p) {
        if (p == 'p') {
            if (pageIndex == 0) {
                $scope.pageIndex = 0;
            } else {
                $scope.pageIndex = $scope.pageIndex - 1;
            }
        }
        else {
            $scope.pageIndex = $scope.pageIndex + 1;
            var pageCount = $scope.checkDataList.length;
            if ($scope.pageIndex == pageCount) {
                $scope.pageIndex = 0;
            }
        }
        $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + $scope.checkDataList[$scope.pageIndex];
        // 赋值创建手势控件
        $scope.createPinchZoom();
    }
    // #endregion

    // #region 检查报告下载

    //下载PDF
    $scope.downloadPDF = function (reqId, index, checkResultType) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        if (reqId != null && reqId.length > 0) {
            // 2022-12-2 08:36:08 HM 门诊病历也有下载，这里做一下兼容
            var usage = "";
            var fileName = "";
            var fileId = "";
            var fileType = "PDF";
            var columnName = "REPORT_PDF";
            // 2023-10-26 11:18:00 CGZ 文件名改为拼接报告时间/就诊时间，默认当前时间
            var strReportTime = new Date().Format("yyyyMMddhhmmss");

            switch (checkResultType) {
                case "检验结果":
                    usage = $scope.thisResultFunc;
                    if ($scope.lisList[index].CHECK_TIME != null && $scope.lisList[index].CHECK_TIME != '') {
                        strReportTime = new Date(Date.parse($scope.lisList[index].CHECK_TIME)).Format("yyyyMMddhhmmss");
                    }
                    fileName = $scope.lisList[index].TEST_ORDER_NAME + "_" + strReportTime;
                    fileId = $scope.lisList[index].INSPECTION_ID;
                    break;
                case "检查报告":
                    usage = $scope.thisResultFunc;
                    if ($scope.checkList[index].REPORT_DATE != null && $scope.checkList[index].REPORT_DATE != '') {
                        strReportTime = new Date(Date.parse($scope.checkList[index].REPORT_DATE)).Format("yyyyMMddhhmmss");
                    }
                    fileName = $scope.checkList[index].DESCRIPTION + "_" + strReportTime;
                    fileId = $scope.checkList[index].ID;
                    break;
                case "门诊病历":
                    usage = "opRecord";
                    //fileName = $scope.opRecordList[index].XS + $scope.opRecordList[index].SJ;
                    //fileType = "IMAGE";
                    //columnName = "RECORD_DATA";
                    fileId = $scope.opRecordList[index].IDR_ASC;
                    if ($scope.opRecordList[index].SJ != null && $scope.opRecordList[index].SJ != '') {
                        strReportTime = new Date(Date.parse($scope.opRecordList[index].SJ)).Format("yyyyMMddhhmmss");
                    }
                    fileName = "门诊病历" + "_" + strReportTime;
                    break;
                // 2023-10-26 16:13:13 CGZ 目前应该不会走到这个分支，互联网门诊病历在olTreatVideo中实现
                case "互联网门诊病历":
                    usage = "olRecord";
                    //fileName = $scope.opRecordList[index].XS + $scope.opRecordList[index].SJ;
                    //fileType = "IMAGE";
                    //columnName = "RECORD_DATA";
                    fileId = $scope.opRecordList[index].IDR_ASC;
                    if ($scope.opRecordList[index].SJ != null && $scope.opRecordList[index].SJ != '') {
                        strReportTime = new Date(Date.parse($scope.opRecordList[index].SJ)).Format("yyyyMMddhhmmss");
                    }
                    fileName = "互联网门诊病历" + "_" + strReportTime;
                    break;
                default:
                    break;
            }

            ReportService.saveDownloadRecord($scope.vpId, usage, reqId, fileName, "PDF", fileId, columnName).then(function (data) {
                $scope.downloadId = data.downloadId;
                RequestService.downloadPDF(reqId, $scope.vpId, columnName, checkResultType, fileName).then(function (dataPdf) {
                    if (dataPdf.result == 1) {
                        ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 1);
                        var url = dataPdf.data;
                        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                        //$cordovaInAppBrowser.open(url, '_system', '').then(function (event) { });
                        //2023.7.31 新插件原有调用方式参数不生效
                        var inapp = showInAppBrowser(url, '_system');
                        loadFinish();
                        return;
                    }
                    // 链接超时
                    else if (dataPdf.result == 99) {
                        ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 2);
                        loadFinish();
                        $fwCordovaToast.showShortBottom("连接超时，请重试");
                        return;
                    }
                    else {
                        ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 2);
                        loadFinish();
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        return;
                    }
                }, function (errPdf) {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    console.log(errPdf);
                });
            }, function(err) {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                console.log(err);
            });
        }
        else {
            loadFinish();
            $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
            return;
        }
    }

    // 下载图片
    $scope.downloadImage = function (reqId) {
        let newDate = new Date().Format("yyyyMMddhhmmss");
        var url = serviceUrl + "/Report/DownLoadPdf?requestId=" + reqId + newDate + "&columnName=RECORD_DATA";
        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
        //$cordovaInAppBrowser.open(url, '_system', '').then(function (event) { });
        //2023.7.31 新插件原有调用方式参数不生效
        var inapp = showInAppBrowser(url, '_system');
    }

    // #endregion

    // #region 非本人授权浏览

    // 获取预留手机号
    $scope.GetReservedPhone = function () {
        $ionicLoading.show();
        RequestService.GetReservedPhone($scope.vpId).then(function (data) {
            // 圈消失
            $ionicLoading.hide();
            // 链接超时
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom('获取预留手机号失败，服务繁忙，请重试');
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            var phone = data.data[0].PHONENUM;
            $scope.vpVerify.phone_num = phone;
            $scope.vpVerify.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
        });
    }

    //获取短信验证码
    $scope.verifyToGetMsgVericode = function () {
        // 验证图片验证码
        if ($scope.vpVerify.imageVericode == null || $scope.vpVerify.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        AccountService.sendVericodeByPhone($scope.vpVerify.phone_num, "10", $scope.vpVerify.imageVericode,$scope.vpId,$scope.thisResultFunc).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1){
                //记录验证信息
                ReportService.saveVerifyInfo($scope.vpId,$scope.thisResultFunc).then(function(data){
                    if(data.result == 1){
                        $scope.authId = data.authId;
                        $scope.disableGetVericode = true;
                        $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");
                        // 倒计时
                        $scope.timespan = 60;
                        TimeCount();
                    }else{
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        return;
                    }
                })
            }else if (data.result == 0) {// 服务调用失败
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
            $scope.disableGetVericode = false;
        },function(){
            $scope.disableGetVericode = false;
        });
    }

    //验证手机验证码
    $scope.verifyCardSubmit = function () {
        if ($scope.vpVerify.phone_num == '' || $scope.vpVerify.messageVericode == '') {
            $fwCordovaToast.showShortBottom('请完整填写预留手机验证信息');
            return false;
        }
        $scope.disableVerify = true;
        ChangePhoneNumberService.compareVericode($scope.vpVerify.phone_num, $scope.vpVerify.messageVericode, currentPlatform, deviceToken, "10").then(function (data) {
            if (data.result == 1) {
                $scope.timespan = 0; //倒计时清零
                $fwCordovaToast.showShortBottom("验证成功。");
                //记录验证信息
                ReportService.updateVerifyInfo($scope.vpId,$scope.authId).then(function(data){
                    if(data.result == 1){
                        $scope.verifyPhoneModal.hide();
                        if($scope.thisResultFunc == "check"){
                            $scope.checkResult.TITLE = "检查报告";
                            $scope.getCheckInfo($scope.thisResultIndex);
                        }else if($scope.thisResultFunc == "lis"){
                            $scope.getLisInfo($scope.thisResultIndex);
                            $scope.lisResultModal.show();
                            AccountService.getWatermark().then(function (data) {
                                $scope.watermark = data.data;
                            });
                        }
                    }else{
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        $scope.disableVerify = false;
                        return;
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    $scope.disableVerify = false;
                    return;
                })
            }else {
                $scope.getImageVericode();
                $scope.vpVerify.imageVericode = "";
                $scope.vpVerify.messageVericode = "";
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            $scope.disableVerify = false;
        }, function (data) {
            $scope.disableVerify = false;
        })
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpVerify.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
            $scope.disableGetVericode = false;
        }
    };

    // #endregion

    // 获取健康处方详情
    $scope.hlthRecipeShow = function (index) {
        $ionicLoading.show();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};

        console.log(index);
        console.log($scope.hlthRecipeList);
        RequestService.hlthRecipeResult($scope.vpId, $scope.hlthRecipeList[index].ORDER_NO, localStorage.queryToken).then(function (data) {
            console.log(data);
            $ionicLoading.hide();

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.hlthRecipeShow(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom("当前健康教育处方不支持查看");
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "健康教育处方详情";
            $scope.checkResultModal.show();
        })
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid;
        $scope.vpInfo = new Object();
        // 读取就诊人信息
        $scope.loadVPInfo();
        // 获取配置（功能开关）
        $scope.getConfig();
        $scope.loadLisList($scope.lisType);
        $scope.loadCheckList($scope.checkType);
        // $scope.loadNuClearList($scope.nuclearType);
        $scope.loadOpRecordList($scope.opRecordType);
        $scope.loadIpList($scope.ipType);
        $scope.loadHlthRecipeList($scope.hlthRecipeType);
        $scope.popVplist.hide();

        if($scope.step == 5){
            $scope.toSlide(4);
        }
    }

    // 切换LIS类型
    $scope.changeLisType = function (type) {
        $scope.lisType = type;
        $scope.loadLisList(type);
    }

    // 切换检查类型
    $scope.changeCheckType = function (type) {
        $scope.checkType = type;
        $scope.loadCheckList(type);
    }

    // 切换核医学科报告类型
    $scope.changeUnclearType = function (type) {
        $scope.nuclearType = type;
        $scope.loadNuClearList(type);
    }

    // 切换门诊病历类型
    $scope.changeOpRecordType = function (type){
        $scope.opRecordType = type;
        $scope.loadOpRecordList(type);
    }

    // 切换住院病历类型
    $scope.changeIpType = function (type){
        $scope.ipType = type;
        $scope.loadIpList(type);
    }

    // 切换健康教育处方类型
    $scope.changeHlthRecipeList = function (type) {
        $scope.hlthRecipeType = type;
        $scope.loadHlthRecipeList(type);
    }

    // 滑块切换触发
    $scope.slideChanged = function () {
        // 返回清空数据
        $scope.isLoadFinish = false;

        $scope.lisList = [];
        $scope.lisType = 1;

        $scope.checkList = [];
        $scope.checkType = 1;

        $scope.nuclearList = [];
        $scope.nuclearType = 1;

        $scope.opRecordList = [];
        $scope.opRecordType = 1;

        $scope.ipList = [];
        $scope.ipType = 1;

        $scope.hlthRecipeList = [];
        $scope.hlthRecipeType = 1;

        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $ionicHistory.clearHistory();
                $state.go('app.home');
                //console.warn('清空历史测试');
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'report');

        // 获取配置（功能开关）
        $scope.getConfig();
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                for (var i = 0; i < data.data.length; i++) {
                    if (data.data[i].IS_BIND_CARD == '1') {
                        $scope.vpList.push(data.data[i]);
                        if (vpid == "") {
                            vpid = data.data[i].VISIT_PATIENT_ID;
                        }
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }

                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                } else {
                    // 读取就诊人信息
                    $scope.loadVPInfo();

                    // 获取配置（功能开关）
                    $scope.getConfig();

                    // 2023-1-30 13:44:55 HM 如果是从个人中心来的，这里加个类型判断，对应跳转至对应模块，暂时支持lis和check
                    if ($stateParams.type == "lis") {
                        $scope.toSlide('1');
                    }
                    else if ($stateParams.type == "check") {
                        $scope.toSlide('2');
                    }
                    else {
                        // 其他的暂时什么都不多
                    }
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'report') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });
});