﻿angular.module('fwapp.controllers')

// 医院介绍
.controller('ResetPasswordController', function ($scope, $rootScope, $state, $stateParams, $ionicSlideBoxDelegate, $ionicPopup, $ionicPlatform, $ionicLoading
, ChangePhoneNumberService, ChangePasswordService, ResetPasswordService, AccountService, $fwCordovaToast) {
    $scope.findPassword = new Object();

    $scope.phone = {
        number: '',
        code: '',
        imageVericode: ''
    }

    $scope.pwdModel = {
        pwd_new: '',
        pwd_confirm: ''
    }

    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};

    $scope.goBack = function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'resetPwd') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        $state.go("login");
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'resetPassword');
        // 获取密码强度限制
        $scope.getPasswordLevelLimit();
        // 获取图片验证码
        $scope.getImageVericode();
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'resetPassword') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 验证码发送时间间隔
    $scope.timespan = 0;
    // 防止多次获取验证码
    $scope.disableGetVericode = false;
    // 防止多次下一步
    $scope.disableNext = false;
    // 防止多次提交
    $scope.disableSubmit = false;

    // slide box
    var slideBox = $ionicSlideBoxDelegate.$getByHandle('slideBox');

    //不准滑动
    $scope.lockSilde = function () {
        $ionicSlideBoxDelegate.enableSlide(false);
    }

    // 密码强度
    $scope.pwdLevel = 0;
    $scope.pwdLevelDescr = '非常弱';
    $scope.pwdLevelLimit = 1;
    $scope.pwdLevelNotice = '';
    // 错误信息
    $scope.errorMsgPhone = '';
    $scope.errorMsgPwd = '';
    $scope.errorMsgPwd2 = '';

    //手机获取验证码
    $scope.getVerifyCode = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 验证图片验证码
        if ($scope.phone.imageVericode == null || $scope.phone.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空',
                okText: '确定'
            });
            return;
        }
        $scope.disableGetVericode = true;
        AccountService.sendVericodeByPhone($scope.phone.number, "4", $scope.phone.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg,
                    okText: '确定'
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试',
                    okText: '确定'
                });
            }
            $scope.disableGetVericode = false;
        });
    }

    //验证手机验证码
    $scope.verifyCode = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $scope.disableNext = true;
        $scope.accountId = localStorage.currentAccountId;
        // 如果不能获取到accountId，转到登录页，如果能，修改密码
        if ($scope.accountid == '') {
            var alertPopup = $ionicPopup.alert({
                title: '请先登录',
                template: null,
                okText: '确定'
            });
            // 删除用户信息
            localStorage.hasLogin = 0;
            $rootScope.hasLogin = 0;
            localStorage.currentAccountId = "";
            // 初始化一下消息中心提示
            // 是否有未读消息
            $rootScope.hasUnread = false;
            $rootScope.unReadCount = 0;
            $scope.disableNext = false;
            // 跳转到登录页
            $state.go('login');
        }
        else {
            ChangePhoneNumberService.compareVericode($scope.phone.number, $scope.phone.code, currentPlatform, deviceToken, "4").then(function (data) {
                if (data.result == 1) {
                    slideBox.next();
                    $scope.timespan = 0; //倒计时清零
                }
                else {
                    var alertPopup = $ionicPopup.alert({
                        title: '验证失败',
                        template: data.msg,
                        okText: '确定'
                    });
                }
                $scope.disableNext = false;
            }, function (data) {
                $scope.disableNext = false;
            })
        }
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 获取密码强度限制
    $scope.getPasswordLevelLimit = function () {
        //$ionicLoading.show();
        AccountService.getPasswordLevelLimit().then(function (data) {
            //$ionicLoading.hide();
            // 查询成功
            if (data.result == 1) {
                //console.log(data.data);
                $scope.pwdLevelLimit = data.data;
                $scope.pwdLevelNotice = data.notice;
                $scope.errorMsgPwd = $scope.pwdLevelNotice;
            }
        }, function () {
            //$ionicLoading.hide();
        })
    }

    //更改密码
    $scope.submitChange = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        if ($scope.pwdModel.pwd_new == $scope.pwdModel.pwd_confirm) {
            // 验证密码
            if (!$scope.checkPwd()) {
                var checkPwdMsg = $scope.errorMsgPwd == '' ? $scope.errorMsgPwd2 : $scope.errorMsgPwd;
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: checkPwdMsg,
                    okText: '确定'
                });
                return;
            }
            $scope.disableSubmit = true;
            ResetPasswordService.resetPassword($scope.phone.code, $scope.pwdModel.pwd_new, $scope.phone.number).then(function (data) {
                //$scope.changeResult = data;
                if (data.result == 0) {
                    var alertPopup = $ionicPopup.alert({
                        title: '修改失败',
                        template: data.msg,
                        okText: '确定'
                    });
                } else if (data.result == 1) {
                    $fwCordovaToast.showShortBottom("修改密码成功");
                    // 删除用户信息
                    localStorage.hasLogin = 0;
                    $rootScope.hasLogin = 0;
                    localStorage.currentAccountId = "";
                    // 初始化一下消息中心提示
                    // 是否有未读消息
                    $rootScope.hasUnread = false;
                    $rootScope.unReadCount = 0;
                    // 跳转到登录页
                    // $state.go('login');
                    // 2020-2-21 15:00:14 别跳转到登录页了 直接自动登录 跳过短信验证
                    $scope.autoLogin();
                }
                $scope.disableSubmit = false;
            }, function (data) {
                $scope.disableSubmit = false;
            });
        } else {
            var alertPopup = $ionicPopup.alert({
                title: '修改失败',
                template: '两次输入的新密码不一致',
                okText: '确定'
            });
        }
    }

    // 2020-2-21 15:00:14
    // 自动登录
    $scope.autoLogin = function () {
        AccountService.login($scope.phone.number, $scope.pwdModel.pwd_new).then(function (data) {
            // 登录成功
            if (data.result == 1) {
                // 绑定用户信息
                localStorage.hasLogin = 1;
                $rootScope.hasLogin = 1;
                localStorage.currentAccountId = data.data.id;
                $rootScope.currentAccountId = data.data.id;
                // 2017-01-09 14:52:51 上传通知权限
                SetNoticeAuth();
                // 跳转到首页
                $state.go('app.home');
            }
            // 需要短信验证 或 登录失败
            else {
                // 跳转到登录页
                $state.go('login');
            }
        }, function (data) {
            // 跳转到登录页
            $state.go('login');
        });
    };

    // 密码强度
    $scope.checkPwdLevel = function () {
        // 检查密码强度
        $scope.pwdLevel = calcPwdLevel($scope.pwdModel.pwd_new);
        //console.log($scope.pwdLevel);
        if ($scope.pwdLevel > 2) {
            $scope.pwdLevelDescr = '强';
        }
        else if ($scope.pwdLevel > 1) {
            $scope.pwdLevelDescr = '中';
        }
        else if ($scope.pwdLevel > 0) {
            $scope.pwdLevelDescr = '弱';
        }
        else {
            $scope.pwdLevelDescr = '非常弱';
        }
    }

    // 密码验证
    $scope.checkPwd = function () {
        // 检查密码强度
        $scope.checkPwdLevel();
        //console.log($scope.pwdLevel + ":" + $scope.pwdLevelDescr);
        // 密码为空
        if (typeof ($scope.pwdModel.pwd_new) == 'undefined' || $scope.pwdModel.pwd_new.length == 0) {
            $scope.errorMsgPwd = '密码不得为空，' + $scope.pwdLevelNotice;
            return false;
        }
        // 密码强度过弱
        if ($scope.pwdLevel < $scope.pwdLevelLimit) {
            $scope.errorMsgPwd = '密码强度过弱，' + $scope.pwdLevelNotice;
            if ($scope.pwdLevelNotice == null || $scope.pwdLevelNotice == '') {
                switch ($scope.pwdLevelLimit) {
                    case 3:
                        $scope.errorMsgPwd += '密码应至少8位，包含数字、小写字母和大写字母。';
                        break;
                    case 2:
                        $scope.errorMsgPwd += '密码应至少8位，包含数字和字母。';
                        break;
                    case 1:
                    default:
                        $scope.errorMsgPwd += '密码应至少6位，建议包含数字和字母。';
                        break;
                }
            }
            return false;
        }
        $scope.errorMsgPwd = '';
        return $scope.checkPwd2();
    }

    // 确认密码验证
    $scope.checkPwd2 = function () {
        // 确认密码为空
        if (typeof ($scope.pwdModel.pwd_confirm) == 'undefined' || $scope.pwdModel.pwd_confirm.length == 0) {
            $scope.errorMsgPwd2 = '确认密码不得为空';
            return false;
        }
        // 两次输入不一致
        if ($scope.pwdModel.pwd_new != $scope.pwdModel.pwd_confirm) {
            $scope.errorMsgPwd2 = '两次输入的密码不一致';
            return false;
        }
        $scope.errorMsgPwd2 = '';
        return true;
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.phone.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
})