﻿angular.module('fwapp.controllers')

.controller('rhbPlanController', function ($scope, $rootScope, $state, $stateParams, $timeout, $filter,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicPlatform, $ionicSlideBoxDelegate,
    $ionicActionSheet, $cordovaDatePicker, $fwCordovaToast, $ionicScrollDelegate, VisitPatientService, RequestService) {
    // 就诊人ID
    $scope.vpId = $stateParams.vpId;
    // 就诊人列表
    $scope.vpList = [];
    // 选中就诊人信息
    $scope.vpInfo = new Object();
    // 康复治疗计划数据
    $scope.RHBList = [];
    // 当前日期
    $scope.datenow = "";
    // 检查预约序列
    $scope.checkApptIndex = 0;
    // 检查可改约日期数据
    $scope.apptSchedDate = [];
    // 检查预约日期 给控件用的
    $scope.apptDate = {};
    $scope.apptDate.target = "";
    $scope.apptDate.targetOri = "";
    $scope.apptDate.dateMode = "white";
    $scope.apptDate.dateList = [];
    $scope.apptDate.minDate = "1970-01-01";
    $scope.apptDate.maxDate = "1970-01-01";
    // 缓存
    $scope.apptDate.targetCache = "";
    // 改期时段
    $scope.apptDate.targetTime = "";
    $scope.apptDate.targetTimeOri = "";
    // 改期时段ID
    $scope.apptDate.timeAreaId = "";
    // 是否进入预约申请
    $scope.isReservingDate = false;
    // 记录当前预约项目
    $scope.planId = "";
    $scope.itemGroupsNum = "";
    $scope.itemGroup = {};
    // 康复治疗计划状态 进行中 已完成
    $scope.planStatus = 1;
    // 是否加载完康复数据
    $scope.loadingStatus = 0;

    // 是否有进行中的计划
    $scope.isProgressing = false;
    // 是否有已完成的计划
    $scope.isCompleted = false;

    //获取日期前十位
    $scope.getFormatDate = function (date) {
        if (date != null && date.length > 10) {
            return date.substring(0, 10);
        }
        return date;
    }

    //切换康复治疗计划状态
    $scope.set_planStatus = function(status){
        $scope.planStatus = status;
        //if(status == 0){
        //    document.getElementById("processing").className = "modelName";
        //    document.getElementById("done").className = "modelName rhbTabActive";
        //}else{
        //    document.getElementById("processing").className = "modelName rhbTabActive";
        //    document.getElementById("done").className = "modelName";
        //}
    }

    //判断康复治疗计划每一期的状态
    $scope.set_itemStatus = function (itemGroups) {
        var completeNum = 0;
        var cancelNum = 0;
        var readyNum = 0;
        //COMPLETESTATUS 0未完成 1完成 2取消
        for (var i = 0; i < itemGroups.length; i++) {
            if (itemGroups[i].COMPLETESTATUS == 0) {
                readyNum += 1;
            }
            if (itemGroups[i].COMPLETESTATUS == 1) {
                completeNum += 1;
            }
            if (itemGroups[i].COMPLETESTATUS == 2) {
                cancelNum += 1;
            }
        }
        if (completeNum == itemGroups.length) {
            $scope.isCompleted = true;
            return "已完成";
        } else if (readyNum > 0 && readyNum < itemGroups.length) {
            $scope.isProgressing = true;
            return "进行中";
        } else if (readyNum == itemGroups.length) {
            $scope.isProgressing = true;
            return "未开始";
        } else if (cancelNum > 0 && cancelNum == itemGroups.length) {
            //cfw 2023年3月9日13:27:18 如果子项都取消，则父项显示已取消
            return "已取消";
        }
    }
    //class赋值
    $scope.getTitleColor = function(itemGroups){
        var planNum = 0;
        //COMPLETESTATUS 0未完成 1完成 2取消
        for(var i =0; i< itemGroups.length; i++){
            if(itemGroups[i].COMPLETESTATUS != 0){
                planNum += 1;
            }
        }
        if(planNum == itemGroups.length){
            return "color:#0db789;";
        }else if(planNum > 0 && planNum < itemGroups.length){
            return "color:#f39826;";
        }else{
            return "color:#555;";
        }
    }
     //class赋值
    $scope.getClassName = function(itemGroups){
        var planNum = 0;
        //COMPLETESTATUS 0未完成 1完成 2取消
        for(var i =0; i< itemGroups.length; i++){
            if(itemGroups[i].COMPLETESTATUS != 0){
                planNum += 1;
            }
        }
        if(planNum == itemGroups.length){
            return "lineA";
        }else if(planNum > 0 && planNum < itemGroups.length){
            return "lineB";
        }else{
            return "lineC";
        }
    }
    $scope.getCheckmarkClass = function(itemGroups){
        var planNum = 0;
        //COMPLETESTATUS 0未完成 1完成 2取消
        for(var i =0; i< itemGroups.length; i++){
            if(itemGroups[i].COMPLETESTATUS != 0){
                planNum += 1;
            }
        }
        if(planNum == itemGroups.length){
            return "icon ion-ios-checkmark iconA";
        }else if(planNum > 0 && planNum < itemGroups.length){
            return "icon ion-ios-circle-filled iconB";
        }else{
            return "icon ion-ios-circle-outline iconC";
        }
    }
    $scope.set_display = function(planNum, planId, itemNum){
        if(itemNum == ""){
            if(planNum == 1){
                return '';
            }
        }
        
        if(($scope.planId == planId && $scope.itemGroupsNum == itemNum) || planNum == (itemNum + 1)){
            return '';
        }else{
            return "display:none;";
        }
    }

    //展开、收起
    $scope.set_show_hide = function (divId) {
        document.getElementById(divId).style.display = document.getElementById(divId).style.display == "" ? "none" : "";
        $ionicScrollDelegate.resize();
    }

    //获取康复数据
    $scope.getRHBPlan = function(){
        $ionicLoading.show();
        RequestService.getRHBPlan($scope.vpId).then(function (data) {
            $scope.loadingStatus = 1;
            if (data.result == -1) {
                $timeout(function () {
                    if (data.is_null != 1) {
                        $scope.RHBList = data.data;
                        console.log(data.data);
                        var date = new Date();
                        $scope.datenow = date.getFullYear() + "-" + ((date.getMonth() + 1) < 10 ? "0" : "") + (date.getMonth() + 1) + "-" + (date.getDate() < 10 ? "0" : "") + date.getDate();
                    }else{
                        $ionicPopup.alert({
                            title: '提示',
                            template: "未查询到康复治疗计划！",
                            okText: "确定"
                        });
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            $ionicLoading.hide();
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {
                //$fwCordovaToast.showShortBottom(data.msg);
                $ionicPopup.alert({
                    title: '提示',
                    template: "未查询到康复治疗计划！",
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "未查询到康复治疗计划！",
                    okText: "确定"
                });
                return;
            }
            $scope.RHBList = data.data;

            // 按开始时间排序
            $scope.RHBList.sort(function (a, b) {
                return b.KSSJ - a.KSSJ
            });

            console.log(data.data);
            var date = new Date();
            $scope.datenow = date.getFullYear() + "-" + ((date.getMonth() + 1) < 10 ? "0" : "") + (date.getMonth() + 1) + "-" + (date.getDate() < 10 ? "0" : "") + date.getDate();
            $ionicScrollDelegate.resize();
        });
    }

    // 注册模态窗口
    //预约
    $ionicModal.fromTemplateUrl('changeApptDate.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.changeApptDateModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.changeApptDateModal.remove();
    });
    
    //测试checkApptId：121， 实际应该是$scope.itemGroup.GROUPID
    // 选择预约时间--获取预约时间列表
    $scope.getCheckItemSched = function (planId, itemNum, itemGroup) {
        $scope.planId = planId;
        $scope.itemGroupsNum = itemNum;
        $ionicLoading.show();
        RequestService.getCheckItemSched($scope.vpInfo.HIS_CARD_NUM, itemGroup.GROUPID).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        // 有记录
                        $scope.formatCheckItemSchedData(data.data);
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            // 链接超时
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                return;
            }
            $scope.itemGroup = itemGroup;
            $scope.formatCheckItemSchedData(data.data);
        });
    }

    // 格式化并赋值预约改期数据
    $scope.formatCheckItemSchedData = function (data) {
        // 格式化日期
        data.forEach(e => e["ORDER_DATE_FORMAT"] = new Date(e["ORDER_DATE"]).Format("yyyy-MM-dd"));
        // 先赋值 待选择日期后处理
        $scope.apptSchedDate = data;
        // 可预约日期列表
        var dateList = new Set(data.map(e => e["ORDER_DATE_FORMAT"]));
        $scope.apptDate.dateList = Array.from(dateList).sort();
        if($scope.apptDate.dateList.length > 0) {
            $timeout(function () {
                $scope.apptDate.minDate = $scope.apptDate.dateList[0];
                $scope.apptDate.maxDate = $scope.apptDate.dateList[$scope.apptDate.dateList.length - 1];
                console.log($scope.apptDate.minDate + " - " + $scope.apptDate.maxDate);
            }, 0);
        }
        console.log($scope.apptDate.dateList);
        
        // 计划日期赋值 判断是已预约还是未预约
        var dateTarget = "";
        if($scope.itemGroup.YYSTATUS == 0){
            dateTarget = $scope.getFormatDate($scope.itemGroup.JHSJ);
        }else{
            dateTarget = $scope.getFormatDate($scope.itemGroup.YYSJ);
        }
        // 格式化
        if (dateTarget != null && dateTarget.length > 0) {
            dateTarget = new Date(dateTarget).Format("yyyy-MM-dd");
        }
        $scope.apptDate.target = dateTarget;
        
        // 时段
        $scope.apptDate.targetTime = null;
        $scope.apptDate.targetTimeOri = null;
        if($scope.itemGroup.YYSTATUS == 1){
            //使用已预约的数据进行替换
            $scope.apptDate.targetTime = $scope.itemGroup.TIMEAREA;
            $scope.apptDate.targetTimeOri = $scope.itemGroup.TIMEAREA;
        }
        var showSelectTime = 0;
        //判断日期在不在可预约日期列表中
        var isAssigned = false;
        var arrTime = $scope.apptSchedDate.filter(e => e["ORDER_DATE_FORMAT"] == $scope.apptDate.target);
        if(arrTime.length < 1){
            if($scope.itemGroup.YYSTATUS == 1){
                $ionicPopup.alert({
                    title: '说明',
                    template: "日期" + dateTarget + "已不可预约，请重新选择可预约日期！",
                    okText: "确定"
                });
            }else{
                //自动替换为第一个可预约的日期并提示
                $scope.apptSchedDate.forEach(e => {
                    var str = e["ORDER_TIME"];
                    if (e["ORDER_STATUS"] == "0" && !isAssigned) {
                        isAssigned = true;
                        $scope.apptDate.target = e["ORDER_DATE_FORMAT"];
                        $scope.apptDate.targetCache = e["ORDER_DATE_FORMAT"];
                        $scope.apptDate.targetTime = str;
                        $scope.apptDate.targetTimeOri = str;
                        $scope.apptDate.timeAreaId = e["TIME_AREA_ID"];
                    }
                });
                var template = "计划日期" + dateTarget + "已不可预约，自动为您选择可预约日期！";
                if(dateTarget == null || dateTarget == "" || dateTarget == "null"){
                    template = "计划时间为空，自动为您选择可预约日期！";
                }
                $ionicPopup.alert({
                    title: '说明',
                    template: template,
                    okText: "确定"
                });
            }
        }else{
            if($scope.itemGroup.YYSTATUS == 0){
                showSelectTime = 1;
            }
        }

        // 深度制 脏检测
        $scope.apptDate.targetOri = $scope.apptDate.target;

        // 预约改期模态窗口显示
        $scope.changeApptDateShow();

        if(showSelectTime == 1){
             $ionicPopup.confirm({
                title: '您本期康复治疗计划于'+ $scope.apptDate.target +'开始执行，将为您推荐可预约的时段！',
                cancelText: '取消',
                okText: '确认'
            }).then(function (res) {
                if (res) {
                    // 弹出选择时段
                    $scope.selectTimeShow();
                }
            });
        }
    }
    // 弹出选择时段
    $scope.selectTimeShow = function () {
        // 过滤ActionSheet的数据源
        var arrTime = $scope.apptSchedDate.filter(e => e["ORDER_DATE_FORMAT"] == $scope.apptDate.target);
        // 遍历生成按钮
        var arrButton = [];
        arrTime.forEach(e => {
            var str = e["ORDER_TIME"];
            // 判断预约状态 加后缀和样式
            if (e["ORDER_STATUS"] == "0") {
                str += " (可预约)";
                str = '<span>' + str + '</span>';
            }
            else {
                str += " (已约满)";
                str = '<span class="fw-action-sheet-error">' + str + '</span>';
            }
            arrButton.push({ text: str });
        });
        // 弹出透明loading防止快速连击关闭modal
        $ionicLoading.show({template: " "});
        // 确定标识
        var isOk = false;
        // 弹出ActionSheet
        var hideSheet = $ionicActionSheet.show({
            buttons: arrButton,
            titleText: "选择预约时段",
            cancelText: "取消",
            cancel: function () {
                // 未选择时段 回滚日期
                if (!isOk) {
                    // 读取缓存
                    if ($scope.apptDate.targetCache == "") {
                        $scope.apptDate.targetCache = $scope.apptDate.targetOri;
                    }
                    $scope.apptDate.target = $scope.apptDate.targetCache;
                }
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            },
            buttonClicked: function (index) {
                // 约满
                if (arrTime[index]["ORDER_STATUS"] == "1") {
                    return false;
                }
                console.log(arrTime[index]);
                $scope.apptDate.targetTime = arrTime[index]["ORDER_TIME"];
                $scope.apptDate.timeAreaId = arrTime[index]["TIME_AREA_ID"];
                // 写入缓存
                $scope.apptDate.targetCache = $scope.apptDate.target;
                isOk = true;
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200);
            }
        });
    }
    // 选择预约时间--模态窗口显示
    $scope.changeApptDateShow = function () {
        $scope.isReservingDate = true;
        //$scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
        $scope.changeApptDateModal.show();
        $ionicScrollDelegate.$getByHandle('changeApptDate').scrollTop();
    }
    // 选择预约时间--提交
    $scope.checkApptUpdate = function () {
        // 提交改期申请
        $ionicLoading.show();

        //判断YYID是否为空
        var YYID = "";
        var JCDH = "";
        if($scope.itemGroup.YYID != null && $scope.itemGroup.YYID != ""){
            YYID = $scope.itemGroup.YYID;
        }else{
            JCDH = $scope.itemGroup.JCDH;
        }
        RequestService.checkApptUpdate($scope.vpInfo.HIS_CARD_NUM, YYID, $scope.apptDate.target, $scope.apptDate.timeAreaId, JCDH).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                $timeout(function () {
                    if (data.is_null == 1) {
                        ;
                    } else {
                        console.log(data);
                        if (data.data[0].UPDATE_RESULT == "True") {
                            // 重新加载康复治疗计划
                            $scope.getRHBPlan();
                        }
                        else {
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.data[0].ERROR_MSG,
                                okText: "确定"
                            });
                        }
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请重试",
                    okText: "确定"
                });
                return;
            }
            if (data.result != 1 && data.result != -1) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) {
                return;
            }
            if (data.data[0].UPDATE_RESULT == "True") {
                $scope.changeApptDateHide();
                // 重新加载康复治疗计划
                $scope.getRHBPlan();
            }
            else {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.data[0].ERROR_MSG,
                    okText: "确定"
                });
            }
        });
    }
    // 预约改期模态窗口隐藏
    $scope.changeApptDateHide = function () {
        $scope.changeApptDateModal.hide();
        $scope.isChangingDate = false;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
    }

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        //加载就诊人
        VisitPatientService.visitPatientList().then(function (data) {
            if (data.result == 1) {
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到就诊人信息");
                    return;
                }
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if ($stateParams.vpid != "") {
                        if (data.data[i].VISIT_PATIENT_ID == $stateParams.vpid) {
                            $scope.vpInfo = data.data[i];
                            $scope.vpId = $stateParams.vpid;
                        }
                    }
                }

                //获取康复治疗计划
                $scope.getRHBPlan();
            }
            else {
                $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
            }
        }, function () {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络故障，请稍后再试");
        })
    })

    // 进入
    $scope.$on('$ionicView.enter', function () {

    });

    // 回home
    $scope.goBack = function () {
        $state.go("app.home");
    }
});