﻿angular.module('fwapp.controllers')

// 满意度调查
.controller('SatisController', function ($scope, $rootScope, $state, $stateParams, $fwCordovaToast, SatisService
    , $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform) {
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    $scope.satisInfo = new Object();
    $scope.status = $stateParams.status;
    // 满意度意见数组
    $scope.adviceAnser = new Object();

    $scope.changeStatus = function (status) {
        $scope.status = status;
        $scope.loadSatisList();
    }
    // 获取满意度调查列表
    $scope.loadSatisList = function () {
        $ionicLoading.show();
        SatisService.satisList($scope.status).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                //console.log(data.data);
                $scope.satisInfo = data.data;
                // 初始值
                if ($scope.satisInfo.satisList.length > 0) {
                    for (var i in $scope.satisInfo.satisList) {
                        // 未填写 空值
                        if ($scope.satisInfo.satisList[i].SRVY_ANS_INFO == "") {
                            // cfw 2023年6月6日09:21:45 打开未填写满意度页面，默认勾选“很满意”
                            //$scope.satisInfo.satisList[i].ansValue = "";
                            $scope.satisInfo.satisList[i].ansValue = "5";
                        }
                        // 已填写 使用字典转换
                        else {
                            var trans = $scope.satisInfo.dicList.filter(function (e) {
                                return e.descr == $scope.satisInfo.satisList[i].SRVY_ANS_INFO;
                            });
                            if (trans.length > 0 && trans[0].descr != "") {
                                $scope.satisInfo.satisList[i].ansValue = trans[0].value;
                            }
                            // 转换失败
                            else {
                                $scope.satisInfo.satisList[i].ansValue = "";
                            }
                        }
                    }
                }
            }
            // 查询失败
            else {
                console.log(data.msg)
            }
            // 重新计算高度
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        })
    }
    // 保存满意度调查
    $scope.saveSatis = function (satisSrvyId, ansValue) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        if (ansValue == null || ansValue == "") {
            $fwCordovaToast.showShortBottom("请选择满意度");
            return false;
        }

        if ($scope.adviceAnser[satisSrvyId] != null && $scope.adviceAnser[satisSrvyId].length > 100) {
            $fwCordovaToast.showShortBottom("建议反馈最长不超过100字");
            return false;
        }

        $ionicLoading.show();
        SatisService.saveSatis(satisSrvyId, ansValue, $scope.adviceAnser[satisSrvyId]).then(function (data) {
            $ionicLoading.hide();
            // 保存成功
            if (data.result == 1) {
                $scope.loadSatisList();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 保存失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    };

    // cfw 2023年6月2日14:36:24 新增一键保存满意度调查
    $scope.saveALLSatis = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        var satisListFinish = [];
        var flag_allStatis = true;
        //提交前判断是否为“很满意” 或者“满意”,如果不是，则按钮功能不可用
        for (var i in $scope.satisInfo.satisList) {
            if ($scope.satisInfo.satisList[i].ansValue != "5" && $scope.satisInfo.satisList[i].ansValue != "4") {
                flag_allStatis = false;
            }

            //cfw 2023年6月7日10:24:33 构造参数
            var temp = { SATIS_SRVY_ID: '', ansValue: '' };
            temp.SATIS_SRVY_ID = $scope.satisInfo.satisList[i].SATIS_SRVY_ID;
            temp.ansValue = $scope.satisInfo.satisList[i].ansValue;
            satisListFinish.push(temp);
        }

        if (flag_allStatis) {
            $ionicLoading.show();
            // cfw 2023年6月5日14:47:39 由前台提交改为后台提交
            // cfw 2023年6月7日09:41:19 前台分数可以不同，分数从前台传入
            var stringArr = JSON.stringify(satisListFinish);
            SatisService.saveAllSatis(stringArr).then(function (data) {
                // 保存成功
                if (data.result == 1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                    $ionicLoading.hide();
                    //最后刷新待评价列表
                    $scope.loadSatisList();
                }
                // 保存失败
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
            })
        } else {
            $fwCordovaToast.showShortBottom("您的评分中有“满意”以下的评价，请您填写不满意的原因并单独提交。");
        }
    };

    // 易复诊设置满意度
    $scope.bytSetAnsValue = function (index, value) {
        console.log(value);
        if ($scope.satisInfo.satisList[index].ansValue == value) {
            value--;
        }
        $scope.satisInfo.satisList[index].ansValue = value;
    }

    // 易复诊提交满意度
    $scope.bytSaveSatis = function (satisSrvyId, ansValue) {

        console.log(ansValue);

        if (ansValue == null || ansValue == "") {
            $fwCordovaToast.showShortBottom("请为易复诊评价打星！");
            return false;
        }

        if (ansValue <= 4) {
            $ionicPopup.confirm({
                title: '提示',
                template: '您为此次接诊打了4星以下的评价，是否确定提交?',
                cancelText: '取消',
                okText: "确定"
            }).then(function (res) {
                if (res) {
                    $scope.saveSatis(satisSrvyId, ansValue);
                }
            });
        }
        else {
            $scope.saveSatis(satisSrvyId, ansValue);
        }
    }
    // 返回按钮
    $scope.goBack = function () {
        $rootScope.goBack();
    }

    $scope.$on('$ionicView.enter', function () {
        // 获取满意度调查列表
        $scope.loadSatisList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                if ($scope.from.length > 0) {
                    $state.go($scope.from);
                }
                else {
                    $state.go('app.personal');
                }
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'satis');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'satis') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})