﻿angular.module('fwapp.controllers')

// 医院介绍
.controller('SchedulingController', function ($scope, $rootScope, $state, $fwCordovaToast, $timeout,
    DoctorInfoService, SchedulingService, AddWishService, OpApptService, $stateParams,
    $ionicLoading, $ionicScrollDelegate, $ionicPlatform, $ionicActionSheet, $ionicModal, $ionicPopup) {

    // 当前搜索条件
    $scope.cInfo =
    {
        division: '',
        date: '',
        time: '1',
        doctorLevel: ''
    };
    // 出诊信息列表
    $scope.scheduling = new Object();

    //是否显示加载spinner
    //    $scope.spinner = true;
    $ionicLoading.show();
    //是否显示筛选结果为空
    $scope.empty = false;
    $scope.opInfoListByDoctorEmpty = false;
    $scope.doctorInfo = new Object();
    // 按医师搜索
    $scope.doctorSearch = {};
    $scope.doctorSearch.list = []; // 医师搜索结果列表
    $scope.doctorSearch.keyword = ''; // 医师搜索关键词
    $scope.doctorSearch.isSearch = false;  // 是否搜索
    $scope.doctorSearch.isEmpty = false;  // 结果是否空
    // 仅看可约
    $scope.showAvailable = false;
    // 时间选择
    $scope.opApptSelect = {};
    $scope.opApptSelect.schedTime = "";
    $scope.opApptSelect.schedTimeList = [
        { code: '1', name: '上午' },
        { code: '2', name: '下午' },
        { code: '6', name: '午间' },
        { code: '4', name: '晚间'}];

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('doctorIntro.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.doctorIntroModal.remove();
        $scope.showAvatarModal.remove();
    })

    // 2017-4-10 08:38:08 医师头像放大
    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }
    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    $scope.doctorIntro = function (doctorId, doctorLevel, doctorCode, doctorName, doctorPath, doctorSpeciality) {
        // 2019年9月25日16:29:09 HM 预约挂号优化，做弹出处理
        //        if (doctorId == undefined || doctorId.length == 0) {
        //            return;
        //        }
        $scope.doctorInfo = new Object();
        $scope.schedulingModal = new Object();
        $ionicLoading.show();
        if (doctorId == undefined || doctorId.length == 0) {
            var data = new Object();
            data.avatar_path = doctorPath;
            data.description = "";
            data.doctor_code = doctorCode;
            data.doctor_id = doctorId;
            data.doctor_name = doctorName;
            data.speciality = doctorSpeciality;
            data.title = doctorLevel;
            $scope.doctorInfo = data;

            OpApptService.getDoctorScheduling(doctorCode).then(function (data) {
                $scope.schedulingModal = data;
                console.log(data);
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
            $ionicLoading.hide();
        }
        else {
            DoctorInfoService.doctorInfo(doctorId).then(function (data) {
                $ionicLoading.hide();
                $scope.doctorInfo = data;
                console.log($scope.doctorInfo);
                if (doctorLevel.toString() != "") {
                    $scope.doctorInfo.title = doctorLevel;
                }
                if (isOpAppt || $rootScope.opApptData.status) {
                    OpApptService.getDoctorScheduling($scope.doctorInfo.doctor_code).then(funcCBSScheduling_new, funcCBEScheduling_new);
                }
                else {
                    DoctorInfoService.scheduling_new($scope.doctorInfo.doctor_code).then(funcCBSScheduling_new, funcCBEScheduling_new);
                }
                function funcCBSScheduling_new(data) {
                    $scope.schedulingModal = data;
                    console.log(data);
                }
                function funcCBEScheduling_new(resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络'
                    });
                    $ionicLoading.hide();
                }
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
        }
        $scope.doctorIntroModal.show();
        $ionicScrollDelegate.$getByHandle('intro').scrollTop();
    }

    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
    }

    //#region 初始化加载
    // 获取工作日列表
    SchedulingService.schedulingDays().then(function (data) {
        $scope.schedulingDays = data;
        $scope.cInfo.date = data[0];
        $scope.reloadSched();
    }, function (resp) {
        var alertPopup = $ionicPopup.alert({
            title: '网络错误',
            template: '加载失败,请检查网络'
        });
        $ionicLoading.hide();
    });

    // 获取科室列表
    SchedulingService.divisions().then(function (data) {
        $scope.divisions = data;
        // 用select之后，绑定问题先给他延时个500
        $timeout(function () {
            if ($stateParams.division == '') {
                $scope.cInfo.division = data[0].code;
            } else {
                $scope.cInfo.division = $stateParams.division;
            }
            $scope.reloadSched();
        }, 500);
    }, function (resp) {
        $ionicLoading.hide();
        //alert("加载失败,请检查网络");
    });

//    //获取医师等级
//    SchedulingService.doctorLevel().then(function (data) {
//        $scope.doctorLevels = data;
//        $scope.cInfo.doctorLevel = data[0].code;
//        $scope.reloadSched();
//    }, function (resp) {
//        $ionicLoading.hide();
//        //alert("加载失败,请检查网络");
//    });

    // 预约提示
    $scope.apptDoctorTips = new Object();
    // 午间晚间预约挂号提示
    $scope.midEveningNotice = "";
    AddWishService.apptDoctorTips().then(function (data) {
        if (data.result == 1) {
            $scope.apptDoctorTips = data.data;
            $scope.midEveningNotice = data.midEveningNotice;
        }
    })

    //#endregion

    //跳转到医生界面
    $scope.doctor = function (deptId) {
        $state.go("app.doctor", { deptId: deptId });
    }

    //改变科室
    $scope.changeDivision = function (divisionCode) {
        $scope.cInfo.division = divisionCode;
        $scope.reloadSched();
    }

    //改变上下午
    $scope.changeTime = function (timeCode) {
        $scope.cInfo.time = timeCode;
        $scope.reloadSched();
    }

//    //改变医师级别
//    $scope.changeDoctorLevel = function (doctorLevel) {
//        $scope.cInfo.doctorLevel = doctorLevel;
//        $scope.reloadSched();
//    }

    // 重载出诊信息列表
    $scope.reloadSched = function () {
        if ($scope.cInfo.division == '' || $scope.cInfo.date == '') {
            return false;
        }
        $ionicLoading.show();
        //        $scope.spinner = true;
        $scope.empty = false;
        $scope.opInfoListByDoctorEmpty = true;
        if (isOpAppt || $rootScope.opApptData.status) {
            OpApptService.getScheduling($scope.cInfo.division, $scope.cInfo.date, $scope.cInfo.time, "").then(funcCBSScheduling, funcCBEScheduling);
        }
        else {
            SchedulingService.scheduling($scope.cInfo.division, $scope.cInfo.date, $scope.cInfo.time, "").then(funcCBSScheduling, funcCBEScheduling);
        }
        function funcCBSScheduling(data) {
            //            $scope.spinner = false;
            $ionicLoading.hide();
            $scope.scheduling.ds = new Array();
            for (var i = 0; i < data.ds.length; i++) {
                if ($scope.showAvailable && data.ds[i].APPT_STATUS != "1") { continue; }
                $scope.scheduling.ds.push(data.ds[i]);
            }
            if ($scope.scheduling.ds == "") {
                $scope.empty = true;
            } else {
                $scope.empty = false;
            }
            $ionicScrollDelegate.resize();
        }
        function funcCBEScheduling(resp) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("加载失败,请检查网络");
        }
    }

    // 检查预约提示
    $scope.checkApptTips = function (id) {
        var doctor_code = '';
        var opInfo = {};
        for (var i = 0; i < $scope.scheduling.ds.length; i++) {
            if ($scope.scheduling.ds[i].ID == id) {
                doctor_code = $scope.scheduling.ds[i].DOCTOR_CODE;
                opInfo = $scope.scheduling.ds[i];
            }
        }

        if ($scope.apptDoctorTips[doctor_code] != undefined) {
            var tipPopup = $ionicPopup.show({
                title: '提示',
                template: $scope.apptDoctorTips[doctor_code],
                scope: $scope,
                buttons: [{ text: "我知道了，继续预约", type: "button-calm"}]
            });
            tipPopup.then(function () {
                $scope.appt(id);
            })
        }
        else if (opInfo.SCHED_TIME == "午间" || opInfo.SCHED_TIME == "晚间") {
            var tipPopup = $ionicPopup.show({
                title: '提示',
                template: $scope.midEveningNotice,
                scope: $scope,
                buttons: [{ text: "我知道了，继续预约", type: "button-calm"}]
            });
            tipPopup.then(function () {
                $scope.appt(id);
            })
        }
        else {
            $scope.appt(id);
        }
    }
    // 医师预约
    $scope.appt = function (id) {
        if (isOpAppt || $rootScope.opApptData.status) {
            OpApptService.getOpSchedInfo(id).then(funcCBSGetPeriod);
        }
        else {
            AddWishService.getPeriod(id).then(funcCBSGetPeriod);
        }
        function funcCBSGetPeriod(data) {
            console.log(data);
            // 调用失败
            if (data.result == -1) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 已约满
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom("当前选择的医师已约满");
            }
            // 一个时段 直接赋值下一步
            else {
                $scope.opInfoSelect = data.data[0];
                //                    $scope.toSlide(5);
                if (isOpAppt || $rootScope.opApptData.status) {
                    $state.go("app.opAppt", { opid: data.data[0].ID, from: '"app.scheduling"' });
                }
                else {
                    $state.go("app.addWish", { opid: data.data[0].ID, from: '"app.scheduling"' });
                }
            }
        }
        //        $state.go("app.opAppt", { opid: id });
    }

    $scope.apptModal = function (id, color) {
        if (id != "" && (color == "green" || color == "orange")) {
            // 改为上下午分段
            if (isOpAppt || $rootScope.opApptData.status) {
                OpApptService.getOpSchedInfo(id).then(funcCBSGetPeriod2);
            }
            else {
                AddWishService.getPeriod(id).then(funcCBSGetPeriod2);
            }
            function funcCBSGetPeriod2(data) {
                console.log(data);
                // 调用失败
                if (data.result == -1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                // 已约满
                else if (data.result == 0) {
                    $fwCordovaToast.showShortBottom("当前选择的医师已约满");
                }
                // 一个时段 直接赋值下一步
                else {
                    $scope.opInfoSelect = data.data[0];
                    //                    $scope.toSlide(5);
                    if (isOpAppt || $rootScope.opApptData.status) {
                        $state.go("app.opAppt", { opid: data.data[0].ID, from: '"app.scheduling"' });
                    }
                    else {
                        $state.go("app.addWish", { opid: data.data[0].ID, from: '"app.scheduling"' });
                    }
                    //$state.go("app.opAppt", { opid: data.data[0].ID, from: '"app.doctorInfo",{ doctorId: "' + $stateParams.doctorId + '", deptId: "' + $stateParams.deptId + '", doctorCode:"' + $stateParams.doctorCode + '", deptName: "' + $stateParams.deptName + '", doctorName:"' + $stateParams.doctorName + '", doctorLevel:"' + $stateParams.doctorLevel + '"}' })
                }
            }
        } else {
            //alert("NO ID");
        }
        //$state.go("app.opAppt", { opid: id });
    }

    //  切换时段select
    $scope.changeSchedTimeSelect = function () {
        $scope.changeTime($scope.opApptSelect.schedTime);
    }

    $scope.goBack = function () {
        $state.go("app.home");
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'scheduling');
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        //        setTimeout(function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'scheduling') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
        //        }, 500);
    });

    // 搜索医师
    $scope.searchDoctor = function () {
        if ($scope.doctorSearch.keyword == "") {
            $fwCordovaToast.showShortBottom("请输入医生姓名进行搜索");
            return false;
        }
        $scope.doctorSearch.isSearch = true;
        $scope.opApptData.doctorName = $scope.doctorSearch.keyword;
        $scope.loadOpInfoListByDoctor();
    }

    // 根据医生姓名查询列表 2019-9-25 16:26:11 HM
    $scope.loadOpInfoListByDoctor = function () {
        $ionicLoading.show();
        $scope.opInfoListByDoctor = [];
        $scope.empty = true;
        $scope.opInfoListByDoctorEmpty = false;

        OpApptService.getSchedulingByDoctorName($scope.opApptData.doctorName).then(function (data) {
            for (var i = 0; i < data.data.length; i++) {
                var result = data.data[i];
                var regDate = data.data[i].REG_DATE.split(",");
                var regDateList = new Array();
                for (var j = 0; j < regDate.length; j++) {
                    var obj = new Object();
                    var reg = regDate[j].split("|");
                    reg[0] = reg[0].slice(5);
                    obj.date = reg[0];
                    obj.count = reg[1];
                    regDateList.push(obj);
                }

                result.regDateList = regDateList;

                if (!$scope.showAvailable || result.REMAIN_COUNT > 0) {
                    $scope.opInfoListByDoctor.push(result);
                }
            }

            if ($scope.opInfoListByDoctor.length == 0) {
                $scope.opInfoListByDoctorEmpty = true;
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListByDoctorEmpty = true;
            $ionicLoading.hide();
        })
    }

    // 清空搜索结果
    $scope.clearSearch = function () {
        $scope.doctorSearch.list = new Array();
        $scope.doctorSearch.keyword = "";
        $scope.opApptData.doctorName = "";
        $scope.doctorSearch.isSearch = false;
        $scope.doctorSearch.isEmpty = false;
        // 2019-9-25 16:26:11 HM 增加+ 查询医生列表重置
        $scope.opInfoListByDoctorEmpty = true;
        $scope.reloadSched();
    }

    // 切换仅看可约
    $scope.switchShowAvailable = function () {
        $scope.showAvailable = !$scope.showAvailable;
        if ($scope.doctorSearch.isSearch) {
            $scope.loadOpInfoListByDoctor();
        }
        else {
            $scope.reloadSched();
        }
    }
})