﻿angular.module('fwapp.controllers')

// 安全中心
.controller('SecurityCenterController', function ($scope, SecurityCenterService, $state, $stateParams, $ionicHistory, $ionicPlatform) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    $scope.resetPassword = new Object();
    $scope.accountId = localStorage.currentAccountId;


    SecurityCenterService.accountInfo().then(function (data) {
        $scope.accountInfo = data;
        $scope.phoneNumber = $scope.accountInfo.PHONENUM;
        $scope.accountInfo.PHONENUM = $scope.accountInfo.PHONENUM.replace(/(\d{3})\d{6}(\d{2})/, '$1******$2');
        $scope.queryPasswordText = data.QUERY_PASSWORD ? '已设置' : '未设置';
        $scope.data = data;
    });

    $scope.goBack = function () {
//        $ionicHistory.goBack();
        $state.go("app.personal");
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'securityCenter');
    });

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'securityCenter') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });

    $scope.changePassword = function () {
        $state.go("app.changePassword");
    }

    $scope.changePhoneNumber = function () {
        $state.go("app.changePhoneNumber", { phoneNumber: $scope.phoneNumber });
    }

    $scope.writeOffAccount = function () {
        $state.go("app.writeOffAccount");
    }

    $scope.queryPassword = function () {
        if ($scope.data.QUERY_PASSWORD) {
            $state.go("app.queryPassword", { type: 'change', phoneNumber: $scope.phoneNumber });
        } else {
            $state.go("app.queryPassword", { type: 'new', phoneNumber: $scope.phoneNumber });
        }
    }
})