﻿angular.module('fwapp.controllers')

.controller('SpclConsultationController', function ($scope, $rootScope, $state, $stateParams, $timeout,
    SpclConsultationService, UploadImgService,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet, $ionicModal, $ionicPopover,
    $cordovaDatePicker, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $fwCordovaToast) {

    // 检查登录状态
    $rootScope.checkLogin();

    var slideSpclConsultation = $ionicSlideBoxDelegate.$getByHandle('slideSpclConsultation');
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 滑块状态
    $scope.step = 0;
    // 简介信息
    $scope.consultationDescr = {
        descr: '',
        process: ''
    };
    // 可预约时间范围
    $scope.schedDateList = {};
    // 会诊专家团队筛选条件
    $scope.schedTeamFilter = {};
    // 会诊专家团队排班表
    $scope.schedTeamList = [];
    $scope.schedTeamListEmpty = false;
    // 标题
    $scope.title = "特需医疗中心疑难病会诊";
    // 会诊申请详情
    $scope.consultationInfo = {};
    $scope.consultationInfoOri = {};
    // 上传图片列表
    $scope.imgList = []
    // 图片路径
    $scope.imgServerUrl = uploadUrl;
    $scope.slides = [];
    $scope.currentImgIndex = 0;
    $scope.currentSlideIndex = 0;
    // 会诊列表
    $scope.consultationList = []


    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideSpclConsultation.enableSlide(false);
    });

    // 后退
    $scope.goBack = function () {
        // 第一页 或者 从消息中心来
        if ($scope.step == 0 || $scope.from == "app.message") {
            $rootScope.goBack();
        }
        // 申请页面
        else if ($scope.step == 1 || $scope.step == 2) {
            $scope.toSlide(0);  // 回到第一页
        }
        else if ($scope.step == 3) {
            var a = $.param($scope.consultationInfoOri);
            var b = $.param($scope.consultationInfo);
            if (a != b) {
                var confirmPopup = $ionicPopup.confirm({
                    title: '保存疑难病会诊申请',
                    template: "会诊申请已更改,是否保存？",
                    cancelText: '放弃更改',
                    okText: '保存'
                }).then(function (res) {
                    if (res) {
                        $scope.saveApply();
                    }
                    else {
                        $scope.toSlide(2);
                    }
                })
            } else {
                $scope.toSlide(2);
            }
        } else if ($scope.step == 4) {
            if ($scope.consultationInfo.SCHED_DATE != null && $scope.consultationInfo.SCHED_DATE != '') {
                $scope.toSlide(2);
            } else {
                $scope.toSlide(3);
            }
        }
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideSpclConsultation.slide(index);
        $scope.step = slideSpclConsultation.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        // 到申请页，加载申请列表
        if (index == 2) {
            $scope.title = "特需医疗中心疑难病会诊"
            SpclConsultationService.list().then(function (data) {
                if (data.result == 1) {
                    $scope.consultationList = data.data;
                }
            })
        } else if (index == 3) {
            $scope.title = "会诊申请"

        } else {
            $scope.title = "特需医疗中心疑难病会诊";
        }
    }

    //#region 会诊申请增删改操作
    // 新建会诊申请
    $scope.newApply = function () {
        // 初始化申请信息
        $scope.consultationInfo = {
            SPCL_CONSULTATION_ID: '',
            PATIENT_NAME: '',
            PATIENT_SEX: '',
            //BIRTHDAY: '',
            BIRTHDAY: '1990-1-1',
            IDCARD_CODE: '',
            PHONENUM: '',
            MED_HISTORY: '',
            REMARK: ''
        };
        $scope.imgList = [];
        $.extend($scope.consultationInfoOri, $scope.consultationInfo);
        $scope.toSlide(3);
    }

    // 保存按钮点击
    $scope.saveClick = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $ionicLoading.show();
        // 无就诊记录id
        if ($scope.consultationInfo.SPCL_CONSULTATION_ID == null || $scope.consultationInfo.SPCL_CONSULTATION_ID.length == 0) {
            SpclConsultationService.createApply().then(function (data) {
                $scope.consultationInfo.SPCL_CONSULTATION_ID = data.data;
                $scope.saveApply();
            });
        } else {
            $scope.saveApply();
        }
    }

    // 保存申请信息
    $scope.saveApply = function () {
        if ($scope.consultationInfo.SPCL_CONSULTATION_ID == null || $scope.consultationInfo.SPCL_CONSULTATION_ID.length == 0) {
            $fwCordovaToast.showShortBottom("未知的会诊记录ID");
            $ionicLoading.hide();
            return;
        }
        if ($scope.consultationInfo.PATIENT_NAME == null || $scope.consultationInfo.PATIENT_NAME.length == 0
        || $scope.consultationInfo.PATIENT_SEX == null || $scope.consultationInfo.PATIENT_SEX.length == 0
        || $scope.consultationInfo.BIRTHDAY == null || $scope.consultationInfo.BIRTHDAY.length == 0
        || $scope.consultationInfo.IDCARD_CODE == null || $scope.consultationInfo.IDCARD_CODE.length == 0
        || $scope.consultationInfo.PHONENUM == null || $scope.consultationInfo.PHONENUM.length == 0
        || $scope.consultationInfo.MED_HISTORY == null || $scope.consultationInfo.MED_HISTORY.length == 0) {
            $fwCordovaToast.showShortBottom("必填项不得为空");
            $ionicLoading.hide();
            return;
        }
        // 20190403 BST 为处理疑难病会诊新旧版本兼容，增加参数
        $scope.consultationInfo.VERSION = 2;

        SpclConsultationService.saveApply($scope.consultationInfo).then(function (data) {
            if (data.result == "0") {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
                return;
            } else {
                if ($scope.consultationInfo.SCHED_DATE == null || $scope.consultationInfo.SCHED_DATE == '') {
                    $fwCordovaToast.showShortBottom('保存成功，请选择预约会诊日期及团队');
                    // 默认筛选最近一天会诊团队
                    $scope.schedTeamFilter.schedDate = $scope.schedDateList[0].name;
                    $scope.toSlide(4);
                } else {
                    $fwCordovaToast.showShortBottom('保存成功');
                    $scope.toSlide(2);
                }
                $ionicLoading.hide();
            }
        })
    }

    // 修改申请信息
    $scope.editApply = function (id) {
        for (var i = 0; i < $scope.consultationList.length; i++) {
            if ($scope.consultationList[i].SPCL_CONSULTATION_ID == id) {
                $scope.consultationInfo = $scope.consultationList[i];
                $.extend($scope.consultationInfoOri, $scope.consultationInfo);

                UploadImgService.imgList("SPCL_CONSULTATION", id).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        $scope.imgList = data.data;
                        $ionicScrollDelegate.resize();
                    }
                })
                $scope.toSlide(3);
                // 重新计算高度
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();
                return;
            }
        }
    }

    // 修改预约信息
    $scope.editSched = function (id) {
        for (var i = 0; i < $scope.consultationList.length; i++) {
            if ($scope.consultationList[i].SPCL_CONSULTATION_ID == id) {
                $scope.consultationInfo = $scope.consultationList[i];
                $.extend($scope.consultationInfoOri, $scope.consultationInfo);
                // 默认显示之前预约日期
                $scope.schedTeamFilter.schedDate = $scope.consultationInfo.SCHED_DATE.replace('年', '-').replace('月', '-').replace('日', '');
                // 更新会诊排班信息
                $scope.loadSchedTeam();
                $scope.toSlide(4);
                // 重新计算高度
                $ionicScrollDelegate.scrollTop();
                $ionicScrollDelegate.resize();
                return;
            }
        }
    }

    // 删除会诊申请
    $scope.deleteApply = function (id) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除会诊申请',
            template: "您确认删除本条疑难病会诊申请？",
            cancelText: '取消',
            okText: '确认删除'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                SpclConsultationService.deleteApply(id).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        $scope.toSlide(2);
                    }
                    $ionicLoading.hide();
                })
            }
        })
    }

    // 删除会诊申请
    $scope.cancelApply = function (id) {
        var confirmPopup = $ionicPopup.confirm({
            title: '取消会诊申请',
            template: "您确认取消本条疑难病会诊申请？",
            cancelText: '取消',
            okText: '确认取消'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                SpclConsultationService.cancelApply(id).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        $scope.toSlide(2);
                    }
                    $ionicLoading.hide();
                })
            }
        })
    }
    //#endregion

    // 加载疑难病会诊团队排班
    $scope.loadSchedTeam = function () {
        $ionicLoading.show();
        $scope.schedTeamListEmpty = false;
        SpclConsultationService.spclTeamSched($scope.schedTeamFilter.schedDate).then(function (data) {
            if (data.result == 1) {
                $scope.schedTeamList = data.data;
                console.log($scope.schedTeamList)
                if ($scope.schedTeamList.length == 0) {
                    $scope.schedTeamListEmpty = true;
                }
                // 重新计算高度
                $ionicScrollDelegate.resize();
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListEmpty = true;
            $ionicLoading.hide();
        });

    }

    // 切换会诊日期
    $scope.changeSchedDate = function (schedDate) {
        $scope.schedTeamFilter.schedDate = schedDate;
        $scope.loadSchedTeam();
    }

    // 绑定会诊排班
    $scope.bindSchedTeam = function (index) {
        console.log(index);
        console.log($scope.schedTeamList[index]);
        var schedId = $scope.schedTeamList[index].SPCL_TEAM_SCHED_ID;
        var applyId = $scope.consultationInfo.SPCL_CONSULTATION_ID;
        $ionicLoading.show();
        SpclConsultationService.bindSchedTeam(applyId, schedId).then(function (data) {
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('预约成功，请等待会诊中心审核');
                $scope.toSlide(2);
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        });
    }

    //#region 图片相关
    // 保存已上传图像路径
    $scope.imageAddSave = function (path) {
        // 保存数据
        UploadImgService.imgAdd("SPCL_CONSULTATION", $scope.consultationInfo.SPCL_CONSULTATION_ID, '', path, '').then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else {
                $scope.imgList.push(data.data);
            }
            $ionicLoading.hide();
        });
    }

    // 显示弹出大图
    $scope.popupImgShow = function (list, index) {
        $ionicModal.fromTemplateUrl("popup_image.html", {
            scope: $scope,
            animation: "fade-in"
        }).then(function (modal) {
            $scope.popupImageModal = modal;
            // 赋值图片列表
            $scope.uploadImgList = list;
            var cIndex = index;
            var preIndex = index == 0 ? list.length - 1 : index - 1;
            var nextIndex = index == list.length - 1 ? 0 : index + 1;

            $scope.currentImgIndex = cIndex;
            $scope.currentSlideIndex = 1;

            $scope.slides[0] = { src: list[preIndex].URL, seq: preIndex };
            $scope.slides[1] = { src: list[cIndex].URL, seq: cIndex };
            $scope.slides[2] = { src: list[nextIndex].URL, seq: nextIndex };
            //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
            // 显示弹出层
            $scope.popupImageModal.show();
        });
    }

    $scope.deleteImg = function (id) {
        //alert(id);
        var confirmPopup = $ionicPopup.confirm({
            title: '删除报告图片',
            template: "您确认删除本该报告图片？",
            cancelText: '取消',
            okText: '确认删除'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                UploadImgService.imgDelete(id).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        for (var i = 0; i < $scope.imgList.length; i++) {
                            if ($scope.imgList[i].UPLOAD_IMG_ID == id) {
                                $scope.imgList.splice(i, 1);
                            }
                        }
                    }
                    $ionicLoading.hide();
                })
            }
        })
    }

    // 隐藏弹出大图
    $scope.popupImgHide = function () {
        // 清空图片列表
        $scope.uploadImgList = [];
        //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
        // 隐藏弹出
        $scope.popupImageModal.hide();
        $scope.popupImageModal.remove();
    }

    // 选中切换
    $scope.popupImgSlideChange = function (index) {
        var change = $scope.currentSlideIndex + ">" + index;
        $scope.currentSlideIndex = index;
        if (change == "2>0" || change == "0>1" || change == "1>2") {
            var sIndex = index + 1;
            if (sIndex == 3) {
                sIndex = 0;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex + 1;
            if (iIndex == $scope.uploadImgList.length) {
                iIndex = 0;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
        else if (change == "0>2" || change == "2>1" || change == "1>0") {
            var sIndex = index - 1;
            if (sIndex == -1) {
                sIndex = 2;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex - 1;
            if (iIndex == -1) {
                iIndex = $scope.uploadImgList.length - 1;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
    }

    // 阻止事件冒泡
    $scope.stopPropagation = function () {
        event.stopPropagation();
    }

    //#endregion

    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'spclConsultation');
        if ($scope.from == "app.message") {
            $scope.toSlide(2);
        }
        $ionicLoading.show();
        SpclConsultationService.descr().then(function (data) {
            if (data.result == 1) {
                $scope.consultationDescr = data.data;
                $scope.consultationDescr.descr = $scope.consultationDescr.descr;
                $scope.consultationDescr.process = $scope.consultationDescr.process;
                $scope.schedDateList = data.data.schedDateList;
                // 默认值
                $scope.schedTeamFilter.schedDate = $scope.schedDateList[0].name;
                $scope.loadSchedTeam();
            } else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            }
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
        });
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'spclConsultation') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    //#region cordova日期选择
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
    //#endregion

    //#region 图片上传
    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function () {
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var options = {
            quality: 100,
            maximumImagesCount: 1024,
            width: 0,
            height: 0
        };

        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList.length);
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            var imageDataList = [];
            imageDataList[0] = imageData;
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageDataList) {
        // 无就诊记录id
        if ($scope.consultationInfo.SPCL_CONSULTATION_ID == null || $scope.consultationInfo.SPCL_CONSULTATION_ID.length == 0) {
            SpclConsultationService.createApply().then(function (data) {
                $scope.consultationInfo.SPCL_CONSULTATION_ID = data.data;
                UploadImage(data.data, imageDataList, 0);
            });
        }
        // 有就诊记录id
        else {
            UploadImage($scope.consultationInfo.SPCL_CONSULTATION_ID, imageDataList, 0);
        }
    }

    // 批量上传图片
    function UploadImage(scId, imageDataList, index) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageDataList[index].substr(imageDataList[index].lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: scId };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        if (index == 0) {
            $ionicLoading.show();
        }
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageDataList[index], options, true).then(function (result) {
            // 成功处理
            // 保存已上传图像路径
            $scope.imageAddSave(result.response);
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(scId, imageDataList, index + 1);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + error + "。请稍后重试");
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(scId, imageDataList, index + 1);
            }
        }, function (progress) {
            ;
        });
    }
    //#endregion
});