angular.module('fwapp.controllers')

.controller('specialNeedsController', function ($scope, $rootScope, $state, $stateParams, $fwCordovaToast
    , SpecialNeedsService
    , $ionicPlatform, $ionicSlideBoxDelegate, $cordovaInAppBrowser) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }
    // 图片服务器
    $scope.imgServerUrl = uploadUrl;

    // 首页轮播图
    $scope.homeImageList = [0, 1, 2, 3, 4];
    var slideHomeImageList = $ionicSlideBoxDelegate.$getByHandle('slideHomeImageList');
    // 两个区域的功能球
    var slideIpModelList = $ionicSlideBoxDelegate.$getByHandle('slideIpModelList');
    var slideOpModelList = $ionicSlideBoxDelegate.$getByHandle('slideOpModelList');

    // 每行模块数量
    $scope.modelCountPreRow = 4;
    // 每页模块行数
    // 2022-7-6 14:34:09 CGZ APP首页为2 特需分为门诊/住院 功能相对少 没必要分页 改为3行
    $scope.rowCountPrePage = 3;
    // 每页模块数量
    $scope.modelCountPrePage = $scope.modelCountPreRow * $scope.rowCountPrePage;

    // #region 功能球
    $scope.modelColorList = ["#10a6e2", "#f39826", "#0db789", "#f15a4a"];

    // 门诊功能球
    $scope.setSpecialNeedOpPage = function () {
        var arrPage = new Array(Math.ceil($scope.specialOp.length / $scope.modelCountPrePage));
        for (var i = 0; i < arrPage.length; i++) {
            arrPage[i] = i;
        }
        $scope.specialOpRepeat = arrPage;
        slideOpModelList.update();
    }

    // 门诊
    $scope.specialOp = [
    {
        name: "预约挂号",
        href: "#/app/opAppt//specialNeeds/",
        iconClass: "icon icon fwicon-yygh-outline"
    }, {
        name: "检查预约",
        href: "#/app/checkAppt/app.specialNeeds",
        iconClass: "icon fwicon-jcyy-outline"
    }, {
        name: "诊疗资料",
        href: "#/app/report//",
        iconClass: "icon fwicon-bgcx-outline"
    }, {
        name: "候诊叫号",
        href: "#/app/opCallList",
        iconClass: "icon fwicon-hzjh-outline"
    }, {
        name: "处方查询",
        href: "#/app/opPrescription//app.specialNeeds/",
        iconClass: "icon fwicon-mzcf-outline"
    }, {
        name: "院内导航",
        ngClick: "inHospitalNavigate()",
        iconClass: "icon fwicon-yndh-outline"
    }, {
        name: "疑难病会诊",
        href: "#/app/spclConsultation/",
        iconClass: "icon fwicon-hzyy-outline"
    }, {
        name: "门诊自助缴费",
        href: "#/app/opPayment////",
        iconClass: "icon fwicon-mzjf-outline"
    }, {
        // 2022-4-8 14:44:04 CGZ 按褚老师要求将门诊缴费明细合并至门诊自助缴费模块中，腾出位置给体检报告解读
        // 2022-7-6 14:31:34 CGZ 特需要求门诊缴费明细
        name: "门诊缴费明细",
        href: "#/app/dealWithCard/opConsumption",
        iconClass: "icon fwicon-sfxmcx-outline"
    }];

    // 住院功能球
    $scope.setSpecialNeedIpPage = function () {
        var arrPage = new Array(Math.ceil($scope.specialIp.length / $scope.modelCountPrePage));
        for (var i = 0; i < arrPage.length; i++) {
            arrPage[i] = i;
        }
        $scope.specialIpRepeat = arrPage;
        slideIpModelList.update();
    }

    // 住院
    $scope.specialIp = [
    {
        name: "住院患者点餐",
        href: "#/app/dealWithCard/patientMeal",
        iconClass: "icon fwicon-myddc-outline"
    }];
    // #endregion

    // 返回按钮
    $scope.goBack = function () {
        $state.go("app.home");
    }

    // 2017-4-1 14:15:22 新轮播图 可在sys_config中配置
    $scope.goto = function (index) {
        eval($scope.homeImageList[index].id);
    }

    // 病区动态
    $scope.goNews = function (columnId) {
        // id==''跳转到医院动态列表页 其他跳转到id对应文章内容页 newsController处理
        $state.go("app.news", { columnId: columnId });
    }

    // 2022-5-26 19:00:18 CGZ 跳转病区介绍
    $scope.goWardDescr = function (url) {
        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
        //$cordovaInAppBrowser.open(url, '_system', option).then(function (event) { });
        //2023.7.31 新插件原有调用方式参数不生效
        var inapp = showInAppBrowser(url, '_system');
    }

    $scope.$on('$ionicView.enter', function () {
        // 加载功能球
        $scope.setSpecialNeedIpPage();
        $scope.setSpecialNeedOpPage();

        //// 轮播图
        //SpecialNeedsService.homeImage().then(function (data) {
        //    $scope.homeImageList = data.data.page;
        //    for (var i in $scope.homeImageList) {
        //        $scope.homeImageList[i].img_url = $scope.imgServerUrl + $scope.homeImageList[i].ImageUrl;
        //        //$scope.homeImageList[i].img_url = "http://localhost:1793/" + $scope.homeImageList[i].ImageUrl;
        //    }
        //    slideHomeImageList.update();
        //    // 开启循环
        //    slideHomeImageList.loop(true);
        //});

        // 首页图片
        SpecialNeedsService.homeImage().then(function (data) {
            $scope.homeImageList = data.data.page;
            for (var i in $scope.homeImageList) {
                $scope.homeImageList[i].id = $scope.homeImageList[i].ArticleId;
                $scope.homeImageList[i].img_url = picPrefix + $scope.homeImageList[i].ImageUrl;
                //console.log($scope.homeImageList[i].img_url);
                $scope.homeImageList[i].img_descr = $scope.homeImageList[i].Title.length > 17 ? $scope.homeImageList[i].Title.substring(0, 16) + '...' : $scope.homeImageList[i].Title;
            }
            slideHomeImageList.update();
            // 开启循环
            slideHomeImageList.loop(true);
        });

        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $rootScope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'specialNeeds');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'specialNeeds') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
