﻿angular.module('fwapp.controllers')

.controller('SrvyController', function ($scope, $rootScope, $state, $timeout, SrvyService,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet, $ionicModal,
    $cordovaDatePicker, $fwCordovaToast) {

    // 初始滑块状态
    $scope.step = 0;

    // 问卷列表
    $scope.srvyList = [];
    // 个人问卷列表
    $scope.selfSrvyList = [];
    // 问卷Tab
    $scope.srvyTab = 0;

    // 模板内容
    $scope.tmpl = new Object();
    // 模板信息
    $scope.tmplInfo = new Object();
    // 总题数
    $scope.qstnCount = 0;
    // 问卷结果
    $scope.srvyResult = new Object();
    // 当前问卷ID
    $scope.currentRec = new Object();
    // 反馈列表
    $scope.fbResultList = new Object();
    // 反馈列表
    $scope.fbCalcList = new Object();

    // 当前显示删除图片列表ID
    $scope.delImgQstn = new Object();
    // 当前添加图片列表ID
    $scope.addImgQstn = new Object();
    // 图片服务器路径
    $scope.uploadUrl = uploadUrl;

    // 问卷列表是否加载完毕
    $scope.isLoadFinish_Srvy = false;
    // 问卷表单是否加载完毕
    $scope.isLoadFinish_Tmpl = false;

    // 注册模态窗口：建议反馈
    $ionicModal.fromTemplateUrl('feedback.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.feedbackModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.feedbackModal.remove();
    })

    // TAB切换
    $scope.srvyTabChange = function (tabIndex) {
        if (tabIndex == $scope.srvyTab) {
            return false;
        }
        console.log('1');
        $scope.srvyTab = tabIndex;
        switch (tabIndex) {
            case 0:
                $scope.showSrvyList();
                break;
            case 1:
                $scope.showSelfSrvyList();
                break;
        }
    }

    // 刷新列表
    $scope.refreshSrvyTab = function () {
        switch ($scope.srvyTab) {
            case 0:
                $scope.showSrvyList();
                break;
            case 1:
                $scope.showSelfSrvyList();
                break;
        }
    }

    // 加载问卷记录
    $scope.showSrvyList = function () {
        $ionicLoading.show();
        SrvyService.srvyList().then(function (data) {
            if (data.result == 1) {
                $scope.srvyList = data.data;
            }
            $scope.isLoadFinish_Srvy = true;

            $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
            $ionicScrollDelegate.$getByHandle('scollSrvy').scrollTop();

            $ionicLoading.hide();
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        })
    }

    // 加载跟人填写的问卷记录
    $scope.showSelfSrvyList = function () {
        $ionicLoading.show();
        SrvyService.selfSrvyList().then(function (data) {
            if (data.result == 1) {
                $scope.selfSrvyList = data.data;
            }
            $scope.isLoadFinish_Srvy = true;

            $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
            $ionicScrollDelegate.$getByHandle('scollSrvy').scrollTop();

            $ionicLoading.hide();
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        })
    }

    // 显示模板信息
    $scope.showTmpl = function (tmplId, recId, available) {
        $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').slide(1);
        $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').currentIndex();

        $scope.currentRec = recId;
        $scope.loadTmpl(tmplId);
    }

    // 加载模板信息
    $scope.loadTmpl = function (tmplId) {
        $scope.isLoadFinish_Tmpl = false;
        $ionicLoading.show();

        $scope.tmpl = new Object();

        if ($scope.tmplInfo.display == "SLIDE") {
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
        }

        // 加载模板
        SrvyService.items(tmplId).then(function (data) {
            $scope.tmpl = data.QSTN_LIST;
            $scope.tmplInfo.name = data.TMPL_NAME;
            $scope.tmplInfo.id = data.TMPL_ID;
            $scope.tmplInfo.display = data.TMPL_DISPLAY;
            $scope.qstnCount = $scope.tmpl.length;

            $scope.isLoadFinish_Tmpl = true;

            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();

            if ($scope.tmplInfo.display == "SLIDE") {
                $timeout(function () {
                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').enableSlide(false);

                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
                    $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
                    $scope.cQstn = 0;

                    $ionicLoading.hide();
                }, 500);
            } else {
                $ionicLoading.hide();
            }
        })

        $scope.srvyList = [];

        // 加载结果
        //        SrvyService.loadRecord(tmplId, $scope.currentRec).then(function (data) {
        //            $scope.srvyResult = data;
        //        })
    }

    // 显示个人填写的问卷今夕
    $scope.showTmplSelf = function (srvy) {
        if (srvy.SRVY_STATUS == 1) {
            $scope.showFeedback(srvy.REC_ID);
        } else {
            $scope.showTmpl(srvy.LAST_TMPL_ID, srvy.REC_ID, true);
        }
    }

    // 保存问卷结果
    $scope.saveResult = function () {
        $ionicLoading.show();
        SrvyService.saveRecord($scope.tmplInfo.id, $scope.currentRec, $.param($scope.srvyResult)).then(function (data) {
            if (data.result == 1) {
                if (data.nTmplId != '') {
                    $scope.loadTmpl(data.nTmplId);
                } else {
                    $fwCordovaToast.showShortBottom("问卷填写完成！");

                    // 初始化题目信息（防止再次进入显示混乱）
                    $scope.tmpl = new Object();
                    $scope.tmplInfo = new Object();
                    $scope.qstnCount = 0;

                    $scope.showFeedback(data.recId);
                    $scope.srvyTabChange(1);
                    $scope.refreshSrvyTab();

                    $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').slide(0);
                    $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').currentIndex();
                }
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        });
    }

    // 显示反馈信息
    $scope.showFeedback = function (recId) {
        SrvyService.getFeedBack(recId).then(function (data) {
            $scope.tmpl = data.QSTN_LIST;
            $scope.srvyResult = data.REC_QSTN;
            $scope.fbResultList = data.FB_RESULT_LIST;
            $scope.fbCalcList = data.FB_CALC_LIST;

            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.$getByHandle("scrollFeedback").scrollTop();

            $scope.feedbackModal.show();
        });
    }

    // 隐藏反馈信息
    $scope.hideFeedback = function () {
        $scope.feedbackModal.hide();
        $scope.tmpl = new Object();
        $scope.srvyResult = new Object();
    }

    //#region 每道题一个slide版本
    // 当前问题
    $scope.cQstn = 0;

    // 上一题
    $scope.preQstn = function () {
        // 调整问题slide
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').previous();
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();
        // 重计算scroll高度
        $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
        $ionicScrollDelegate.$getByHandle('scollSrvy').scrollTop();
    }

    // 下一题
    $scope.nextQstn = function (currentQstn) {
        // 当前问题必填项验证
        if (!$scope.checkEmpty(currentQstn)) {
            return false;
        }

        // 调整问题slide
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').next();
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();
        // 重计算scroll高度
        $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
        $ionicScrollDelegate.$getByHandle('scollSrvy').scrollTop();
    }

    // 查空
    $scope.checkEmpty = function (qstnInfo) {
        if (qstnInfo.IS_REQUIRED == '1') {
            if (qstnInfo.CONDITION_TYPE == 0 ||(qstnInfo.CONDITION_TYPE == 1 &&
                ($scope.srvyResult[qstnInfo.CONDITION_PARENT] == qstnInfo.CONDITION_VALUE
                || $scope.srvyResult[qstnInfo.CONDITION_PARENT].split(',').indexOf(qstnInfo.CONDITION_VALUE) > -1))) {

                if ($scope.srvyResult[qstnInfo.QSTN_ID] == undefined || $scope.srvyResult[qstnInfo.QSTN_ID] == '') {
                    $fwCordovaToast.showShortBottom("必填项不得为空");
                    return false;
                }
                if (qstnInfo.CHILDS.length > 0) {
                    for (var i = 0; i < qstnInfo.CHILDS.length; i++) {
                        return $scope.checkEmpty(qstnInfo.CHILDS[i]);
                    }
                }
            }

            return true;
        }
        return true;
    }

    //#endregion

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            $rootScope.goBack();
        }
        // 其他（第1页后退到列表页）
        else {
            // 初始化题目信息（防止再次进入显示混乱）
            $scope.tmpl = new Object();
            $scope.tmplInfo = new Object();
            $scope.srvyResult = new Object();
            $scope.qstnCount = 0;

            $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').slide(0);
            $scope.step = $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').currentIndex();
            $scope.showSrvyList();
        }
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        $ionicSlideBoxDelegate.$getByHandle('slideSrvyList').enableSlide(false);
    })

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'srvy');
        // 获取栏目列表
        $scope.showSrvyList();
        //$scope.showFeedback('94e344b6-51bf-4521-be8a-de1b752c792a');
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'srvy') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })

    //#region 问卷真伪控件
    // 问卷重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
        }, 500);
    }

    // 问卷伪单选按钮
    $scope.flupRadio = function (qstnId, dicValue) {
        $scope.srvyResult[qstnId] = dicValue;
        $scope.scrollResize();
    }

    // 问卷伪多选按钮
    $scope.flupCheckBox = function (qstnId, dicValue) {
        if ($scope.srvyResult[qstnId] == null || $scope.srvyResult[qstnId] == '') {
            $scope.srvyResult[qstnId] = dicValue;
        }
        else {
            var value = $scope.srvyResult[qstnId].split(',');
            if (value.indexOf(dicValue) == -1) {
                value.push(dicValue);
            } else {
                value.splice(value.indexOf(dicValue), 1);
            }
            var returnValue = '';
            for (var i = 0; i < value.length; i++) {
                returnValue += value[i] + ",";
            }
            if (returnValue.endsWith(',')) {
                returnValue = returnValue.substr(0, returnValue.length - 1);
            }
            $scope.srvyResult[qstnId] = returnValue;
        }
        $scope.scrollResize();
    }

    // 问卷真时间选择器
    $scope.flupDate = function (qstnId, type) {
        var defaultDate = new Date();

        if ($scope.srvyResult[qstnId] != undefined && $scope.srvyResult[qstnId] != null && $scope.srvyResult[qstnId] != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                $scope.srvyResult[qstnId] = $scope.srvyResult[qstnId].replace(/-/g, "/");
            }
            defaultDate = new Date($scope.srvyResult[qstnId]);
        }
        var options = {
            mode: 'date',  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            var resultDate = new Date(date);
            $scope.srvyResult[qstnId] = resultDate.Format('yyyy-MM-dd');
            $scope.scrollResize();
        })
    }

    //#region 问卷图片处理
    // 问卷图片上传ActionSheet显示
    $scope.imgAddActionSheet = function (qstnId) {
        // 记录问题ID
        $scope.addImgQstn = qstnId;
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                $scope.addImgQstn = new Object();
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.uploadImg(imageData);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "Srvy/" + $scope.currentRec + "/" + $scope.addImgQstn }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/uploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();
            if (result.indexOf('上传失败') >= 0) {
                $fwCordovaToast.showShortBottom(result);
            } else {
                // 保存图片
                $scope.srvyResult[$scope.addImgQstn] += ";" + result;
            }
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 图片删除显示
    $scope.showImgDelete = function (qstnId) {
        $scope.delImgQstn = qstnId;
    }

    // 图片删除隐藏
    $scope.cancelImgDelete = function () {
        $scope.delImgQstn = new Object();
    }

    // 图片删除
    $scope.imgDelete = function (qstnId, imgUrl) {
        console.log(imgUrl)
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                var clist = $scope.srvyResult[qstnId].split(';');
                var nList = '';
                for (var i = 0; i < clist.length; i++) {
                    console.log(clist[i]);
                    if (clist[i] != imgUrl) {
                        nList += clist[i] + ';';
                    }
                }
                if (nList != '') {
                    nList = nList.substr(0, nList.length - 1);
                }
                $scope.srvyResult[qstnId] = nList;
                console.log($scope.srvyResult[qstnId]);
            }
            // 重新显示删除按钮
            $scope.showImgDelete(qstnId);
        });
    }
    //#endregion

    //#endregion
})