﻿angular.module('fwapp.controllers')

.controller('SrvyOperateController', function ($scope, $rootScope, $state, $timeout, SrvyService, flupSrvyService,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet, $ionicModal,
    $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaDatePicker, $fwCordovaToast) {

    // 图片服务器路径
    $scope.imgServerUrl = uploadUrl;

    //#region 每道题一个slide版本
    // 当前问题
    $scope.cQstn = 0;

    // 上一题
    $scope.preQstn = function () {
        // 调整问题slide
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').previous();
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();
        // 2022年3月15日18:51:00 hzg 解决问卷超出界面无法滑动问题
        //$ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
        // 重计算scroll高度
        $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
        $ionicScrollDelegate.$getByHandle('scollSrvy').scrollTop();
    }

    // 下一题
    $scope.nextQstn = function (currentQstn) {
        // 当前问题必填项验证
        if (!$scope.checkEmpty(currentQstn)) {
            return false;
        }
        // 调整问题slide
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').next();
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();
        // 2022年3月15日18:51:00 hzg 解决问卷超出界面无法滑动问题
        //$ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
        // 重计算scroll高度
        $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
        $ionicScrollDelegate.$getByHandle('scollSrvy').scrollTop();
    }

    // 接收srvyController的广播
    $scope.$on('slideTmplList.init', function (event, data) {

        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').enableSlide(false);
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
        $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
        $scope.cQstn = $ionicSlideBoxDelegate.$getByHandle('slideTmplList').currentIndex();

        console.log($scope.srvyType);
        // 2022-7-19 09:09:54 HM 如果是膳食指导，某人给他选中一些选项
        if ($scope.srvyType == "DIETARY_GUIDANCE") {
            if ($scope.diagnoseInfo.gxy == "1") {
                $scope.flupRadio("DIETARY_GUIDANCE_Q09", "1");
            }

            if ($scope.diagnoseInfo.tnb == "1") {
                $scope.flupRadio("DIETARY_GUIDANCE_Q13", "1");
            }

            if ($scope.diagnoseInfo.gzxz == "1") {
                $scope.flupRadio("DIETARY_GUIDANCE_Q18", "1");
            }

            if ($scope.diagnoseInfo.gns == "1") {
                $scope.flupRadio("DIETARY_GUIDANCE_Q24", "1");
            }
        }
    })

    // 查空
    $scope.checkEmpty = function (qstnInfo) {
        if (qstnInfo.INPUT_TYPE == 'LIST') {
            if (qstnInfo.CHILDS.length > 0) {
                for (var i = 0; i < qstnInfo.CHILDS.length; i++) {
                    if (!$scope.checkEmpty(qstnInfo.CHILDS[i])) {
                        return false;
                    }
                }
            }
        }
        if (qstnInfo.IS_REQUIRED == '1') {
            if (qstnInfo.CONDITION_TYPE == 0 || (qstnInfo.CONDITION_TYPE == 1 &&
                ($scope.srvyResult[qstnInfo.CONDITION_PARENT] == qstnInfo.CONDITION_VALUE
                || $scope.srvyResult[qstnInfo.CONDITION_PARENT].toString().split(',').indexOf(qstnInfo.CONDITION_VALUE) > -1))) {

                if ($scope.srvyResult[qstnInfo.QSTN_ID] == undefined || $scope.srvyResult[qstnInfo.QSTN_ID].toString() == '') {
                    $fwCordovaToast.showShortBottom("必填项不得为空");
                    return false;
                }
                if (qstnInfo.CHILDS.length > 0) {
                    for (var i = 0; i < qstnInfo.CHILDS.length; i++) {
                        if (!$scope.checkEmpty(qstnInfo.CHILDS[i])) {
                            return false;
                        }
                    }
                }
            }

            return true;
        }
        return true;
    }

    //#endregion

    //#region 问卷真伪控件
    // 问卷重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
            $ionicScrollDelegate.$getByHandle('scollSrvy').resize();
        }, 100);
    }

    // 问卷伪单选按钮
    $scope.flupRadio = function (qstnId, dicValue) {
        console.log(qstnId, dicValue);
        console.log($scope.diagnoseInfo);

        // 高血压
        if (qstnId == "DIETARY_GUIDANCE_Q09" && dicValue == "2") {
            if ($scope.diagnoseInfo.gxy == "1") {
                return;
            }
        }

        // 糖尿病
        if (qstnId == "DIETARY_GUIDANCE_Q13" && dicValue == "2") {
            if ($scope.diagnoseInfo.tnb == "1") {
                return;
            }
        }

        // 高脂血症
        if (qstnId == "DIETARY_GUIDANCE_Q18" && dicValue == "2") {
            if ($scope.diagnoseInfo.gzxz == "1") {
                return;
            }
        }

        // 高尿酸血症
        if (qstnId == "DIETARY_GUIDANCE_Q24" && dicValue == "2") {
            if ($scope.diagnoseInfo.gns == "1") {
                return;
            }
        }

        // 2023-2-23 17:55:05 HM  如果是冠心病，选了可以随诊，这里给他提示可穿戴设备
        if (qstnId == "CHD_Q01" && dicValue == "1") {
            // 加载模板
            // 2023-2-23 08:37:31 HM 袁老师指示，结合可穿戴设备，获取最新一条的数据
            flupSrvyService.getWearableDeviceCHD($scope.vpId).then(function (data) {
                if (data.result == 1 && (data.data.heartRate != "" || data.data.bloodPressure != "")) {
                    $ionicPopup.alert({
                        title: '提示',
                        template: data.data.msg,
                        okText: "确定"
                    }).then(function (res) {
                        if (res) {
                            $scope.srvyResult["CHD_Q02"] = parseInt(data.data.bloodPressure);
                            $scope.srvyResult["CHD_Q03"] = parseInt(data.data.heartRate);
                        }
                    });
                }
            }, function (e) {
                // $fwCordovaToast.showShortBottom("网络连接异常，请重试");
            })
        }

        $scope.srvyResult[qstnId] = dicValue;
        $scope.scrollResize();
    }

    // 问卷伪多选按钮
    $scope.flupCheckBox = function (qstnId, dicValue) {
        if ($scope.srvyResult[qstnId] == null || $scope.srvyResult[qstnId] == '') {
            $scope.srvyResult[qstnId] = dicValue;
        }
        else {
            var value = $scope.srvyResult[qstnId].toString().split(',');
            // 控制多选互斥
            if (this.dic.DIC_CLASSIFY != this.$parent.item.DIC_VALUES.find(a => { return a.DIC_VALUE == value[0] }).DIC_CLASSIFY) {
                $scope.srvyResult[qstnId] == '';
                value = [];
            }
            if (value.indexOf(dicValue) == -1) {
                value.push(dicValue);
            } else {
                value.splice(value.indexOf(dicValue), 1);
            }
            var returnValue = '';
            for (var i = 0; i < value.length; i++) {
                returnValue += value[i] + ",";
            }
            if (returnValue.endsWith(',')) {
                returnValue = returnValue.substr(0, returnValue.length - 1);
            }
            $scope.srvyResult[qstnId] = returnValue;
        }
        $scope.scrollResize();
    }

    // 问卷真时间选择器
    $scope.flupDate = function (qstnId, type) {
        var defaultDate = new Date();

        if ($scope.srvyResult[qstnId] != undefined && $scope.srvyResult[qstnId] != null && $scope.srvyResult[qstnId] != '') {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                $scope.srvyResult[qstnId] = $scope.srvyResult[qstnId].replace(/-/g, "/");
            }
            defaultDate = new Date($scope.srvyResult[qstnId]);
        }
        var options = {
            mode: type,  	// 'date' or 'time' or 'datetime'
            date: defaultDate,
            okText: '确定',
            cancelText: '取消',
            doneButtonLabel: '确定',
            cancelButtonLabel: '取消',
            is24Hour: true,
            androidTheme: 3,
            locale: 'zh_cn'
        };

        $cordovaDatePicker.show(options).then(function (date) {
            var resultDate = new Date(date);
            if (type == "time") {
                $scope.srvyResult[qstnId] = resultDate.Format('hh:mm');
            }
            else if (type == "date") {
                $scope.srvyResult[qstnId] = resultDate.Format('yyyy-MM-dd');
            }
            else if (type == "datetime") {
                $scope.srvyResult[qstnId] = resultDate.Format('yyyy-MM-dd hh:mm:ss');
            }
            $scope.scrollResize();
        })
    }

    //#region 问卷图片处理
    // 问卷图片上传ActionSheet显示
    $scope.imgAddActionSheet = function (qstnId) {
        // 记录问题ID
        $scope.addImgQstn = qstnId;
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: '请选择上传图片方式',
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i>由相册选择' }
            ],
            cancelText: '取消',
            cancel: function () {
                $scope.addImgQstn = new Object();
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var options = {
            quality: 100,
            maximumImagesCount: 99,
            width: 0,
            height: 0
        };

        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList.length);
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            var imageDataList = [];
            imageDataList[0] = imageData;
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData[0].substr(imageData[0].lastIndexOf('/') + 1);
        options.mimeType = "text/plain";

        // 上传图片参数
        var params = { urlExt: "FLUP_SRVY/" + $scope.vpId + "/" + $scope.addImgQstn }
        options.params = params;

        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        $ionicLoading.show({
            template: '图片上传中...'
        })
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageData[0], options, true).then(function (result) { // 成功处理
            $ionicLoading.hide();
            // result：{"bytesSent":316403, "responseCode":200, "response":"/uploaded//Srvy/PH_Q08/20220429084853073.jpg", "objectId":""}
            if (result.responseCode != "200") {
                $fwCordovaToast.showShortBottom("图片上传失败，请重试！");
            } else {
                if ($scope.srvyResult[$scope.addImgQstn] == null) {
                    $scope.srvyResult[$scope.addImgQstn] = '';
                }
                else {
                    $scope.srvyResult[$scope.addImgQstn] += ";";
                }
                // 保存图片
                var srvyResult = $scope.srvyResult[$scope.addImgQstn] + result.response;
                $scope.srvyResult[$scope.addImgQstn] = srvyResult;
            }
        }, function (error) {   // 错误处理
            $ionicLoading.hide();
            $cordovaToast.showShortBottom("上传失败，错误：" + error + "。请重试");
        }, function (progress) {
        });
    }

    // 图片删除显示
    $scope.showImgDelete = function (qstnId) {
        $scope.delImgQstn = qstnId;
    }

    // 图片删除隐藏
    $scope.cancelImgDelete = function () {
        $scope.delImgQstn = new Object();
    }

    // 图片删除
    $scope.imgDelete = function (qstnId, imgUrl) {
        console.log(imgUrl)
        $ionicPopup.confirm({
            title: '删除确认',
            template: '确认要删除该照片？',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                var clist = $scope.srvyResult[qstnId].split(';');
                var nList = '';
                for (var i = 0; i < clist.length; i++) {
                    console.log(clist[i]);
                    if (clist[i] != imgUrl) {
                        nList += clist[i] + ';';
                    }
                }
                if (nList != '') {
                    nList = nList.substr(0, nList.length - 1);
                }
                $scope.srvyResult[qstnId] = nList;
                console.log($scope.srvyResult[qstnId]);
            }
            // 重新显示删除按钮
            $scope.showImgDelete(qstnId);
        });
    }
    //#endregion

    //#endregion
})