angular.module('fwapp.controllers')

// 复诊计划
.controller('SubVisitController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
    , $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
    , $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
    , SubVisitService) {

    // 检查登录状态
    $rootScope.checkLogin();

    // 传进来的vpId
    $scope.vpId = $stateParams.vpid;

    // 是否加载完成
    $scope.loadfinish = false;
    // 复诊计划主列表
    $scope.subVisitMainList = [];
    // 复诊计划详情
    $scope.subVisitSimpleList = {};

    // 定义滑块
    var slideSubVisit = $ionicSlideBoxDelegate.$getByHandle('slideSubVisit');
    // 初始滑块状态
    $scope.step = 0;
    
    // #region 滑块相关
    // 滑到上一步
    $scope.lastSlide = function () {
        slideSubVisit.previous();
        $scope.step = slideSubVisit.currentIndex();
    }

    // 滑到下一步
    $scope.nextSlide = function () {
        slideSubVisit.next();
        $scope.step = slideSubVisit.currentIndex();
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideSubVisit.slide(index);
        $scope.step = slideSubVisit.currentIndex();
        // 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideSubVisit.currentIndex();
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // #endregion

    // 1.获取复诊计划列表
    $scope.getSubVisitMainList = function () {
        // 初始化变量
        $scope.subVisitMainList = [];
        $scope.loadfinish = false;

        $ionicLoading.show();
        SubVisitService.getSubVisitMainList($scope.vpId).then(function (data) {
            $scope.loadfinish = true;
            if (data.result == 1 && data.data.length > 0){
                console.log(data);
                $scope.subVisitMainList = data.data;

                // 加载第一个复诊计划详情
                $scope.getSubVisitSimpleList($scope.subVisitMainList[0].SUB_VISIT_ID);
            }
            else {
                $ionicLoading.hide();
            }
        }, function () {
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，获取复诊计划列表失败",
                okText: "确定"
            });
            $ionicLoading.hide();
        })
    }

    // 2.获取复诊计划详情
    $scope.getSubVisitSimpleList = function (subVisitMainId) {
        // 初始化变量
        $scope.subVisitSimpleList = [];

        $ionicLoading.show();
        SubVisitService.getSubVisitInfo($scope.vpId, subVisitMainId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1 && data.data.length > 0){
                console.log(data.data);
                $scope.subVisitSimpleList = data.data;

                for(var i = 0;i < $scope.subVisitSimpleList.length;i++){
                    if ($scope.subVisitSimpleList[i].STATUS == 3){
                        continue;
                    }

                    // 帮他点一下
                    $scope.chooseSubVisitSimpleInfo($scope.subVisitSimpleList[i].SUB_VISIT_SIMPLE_ID);
                    break;
                }
            }
        }, function () {
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，获取复诊详情失败",
                okText: "确定"
            });
            $ionicLoading.hide();
        })
    }

    // 3.选择单次复诊计划详情信息
    $scope.chooseSubVisitSimpleInfo = function (simpleId) {
        for (var i = 0;i < $scope.subVisitSimpleList.length;i++){
            if ($scope.subVisitSimpleList[i].SUB_VISIT_SIMPLE_ID == simpleId) {
                if ($scope.subVisitSimpleList[i].CHOOSE == 1){
                    $scope.subVisitSimpleList[i].CHOOSE = 0;
                }
                else {
                    $scope.subVisitSimpleList[i].CHOOSE = 1;
                }
            }
        }

        // 重新计算高度
        $ionicScrollDelegate.resize();
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideSubVisit.enableSlide(false);
    });

    // 返回
    $scope.goBack = function () {
        $state.go("app.dealWithCard", { go: "subVisit" });
    }

    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'subVisit');

        // 获取复诊计划列表
        $scope.getSubVisitMainList();
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'subVisit') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})