angular.module('fwapp.controllers')

// 智能分诊
.controller('TriageController', function ($scope, $rootScope, $state, $stateParams, $timeout, $filter
, $fwCordovaToast, TriageService, AddWishService, SchedulingService, OpApptService, VisitPatientService, DoctorInfoService
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaDatePicker) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义预约申请滑块
    var slideTriage = $ionicSlideBoxDelegate.$getByHandle('slideTriage');
    // 定义预约申请滚动条
    var scrollTriage = $ionicScrollDelegate.$getByHandle('scrollTriage');
    // 初始滑块状态
    $scope.step = 0;
    // 就诊人相关
    $scope.vpList = new Object();
    $scope.vpNew = new Object();
    $scope.vpSelect = ''; // 就诊人ID
    // 症状
    $scope.symptomData = new Object();
    $scope.symptomData.isReview = false;
    $scope.symptomData.symptoms = []; //["心悸","跌倒","吃不饱","乏力","气死偶嘞","腿肿","气不打一处来","迅雷不及掩耳盗铃儿响叮当仁不让之势如破竹"];
    // 复查信息
    $scope.reviewDataRequestId = '';
    $scope.reviewData = [];
    $scope.intoReview = false;
    // 症状查询
    $scope.addSymptomData = {};
    $scope.addSymptomData.keyword = '';
    // 分诊结果
    $scope.sysptomResult = {};
    // 医师列表
    $scope.doctorData = {};
    $scope.doctorData.doctorList = [];
    // 医师信息
    $scope.doctorInfo = {};
    $scope.schedulingModal = {};
    // 从预约挂号传过来的triageId
    $scope.triageId = $stateParams.triageId;
    $scope.doctorId = $stateParams.doctorId;
    $scope.triageInfo = {};
    // 列表滚动条位置
    $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
    // 医师头像路径
    $scope.avatarUrl = "";

    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 是否读取中
    $scope.isLoadFinish = true;
    // 是否正在获取历史就诊
    $scope.isLoadingHistory = false;
    // 从自动问诊那里来的参数
    $scope.autoVpId = $stateParams.vpId; // vpId
    $scope.autoSpeciality = $stateParams.speciality; // 专长
    $scope.firstFrom = $stateParams.firstFrom; // 第一次的入口从哪来的，首页智能分诊 or 预约挂号按症状
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：添加症状
    $ionicModal.fromTemplateUrl('addSymptom.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addSymptomModal = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.addSymptomModal.remove();
        $scope.showAvatarModal.remove();
    })

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideTriage.enableSlide(false);
    });
    // 滑到上一步
    $scope.lastSlide = function () {
        slideTriage.previous();
        $scope.step = slideTriage.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideTriage.next();
        $scope.step = slideTriage.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideTriage.slide(index);
        $scope.step = slideTriage.currentIndex();
        // 进入预约列表 重新计算高度
        scrollTriage.scrollTop();
        scrollTriage.resize();
    }
    // 后退 重写goBack
    $scope.goBack = function () {
        console.log("$rootScope.triageIntoReview: " + $rootScope.triageIntoReview);
        // 第0页（用户须知）正常后退
        if ($scope.step == 0) {
            //$scope.toggleSlideMenu();
            //$rootScope.goBack();
            $state.go("app.home");
        }
        // 第4页（医师详情&&上次就诊）退回分诊结果
        else if ($scope.step == 4 && ($rootScope.triageIntoReview || ($scope.doctorData.doctorList.length == 0 && $scope.isLoadFinish))) {
            $scope.toSlide(2);
            $scope.triageId = "";
            $rootScope.triageIntoReview = false;
        }
        // 如果是自动问诊来的，跳转到自动问诊
        else if ($scope.autoVpId != "" && $scope.autoSpeciality != "" && $scope.step == 3) {
            $state.go("app.autoInquiry", { vpid: $scope.autoVpId, firstFrom: $scope.firstFrom, continueInquiry: 1 });
        }
        // 其他页返回上一个滑块
        else {
            // 第4页 返回医师列表 删除预约挂号返回值 走正常流程
            if ($scope.step == 4) {
                // 从预约挂号返回信息
                $scope.triageId = null;
                $scope.doctorId = null;
                $scope.triageInfo = {};
                $rootScope.triageIntoReview = false;
            }
            // 第2页 返回就诊人选择界面 初始化数据
            else if ($scope.step == 1) {
                // 就诊人相关
                $scope.vpSelect = ''; // 就诊人ID
                // 症状
                $scope.symptomData = new Object();
                $scope.symptomData.isReview = false;
                $scope.symptomData.symptoms = [];
                // 复查信息
                $scope.reviewDataRequestId = '';
                $scope.reviewData = [];
                $scope.intoReview = false;
                // 症状查询
                $scope.addSymptomData = {};
                // 分诊结果
                $scope.sysptomResult = {};
                // 医师列表
                $scope.doctorData = {};
                $scope.doctorData.doctorList = [];
                // 医师信息
                $scope.doctorInfo = {};
                $scope.schedulingModal = {};
                // 从预约挂号返回信息
                $scope.triageId = null;
                $scope.doctorId = null;
                $scope.triageInfo = {};
                $scope.isLoadingHistory = false;
            }
            slideTriage.previous();
            $scope.step = slideTriage.currentIndex();
        }
    }
    // 从预约挂号返回 异步获取智能分诊信息并赋值
    $scope.getTriageInfo = function () {
        console.log($scope.triageId);
        TriageService.triageInfo($scope.triageId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.triageInfo = data.data;
                console.log($scope.triageInfo);
                // 就诊人 自动选择就诊人 异步 不知道谁快 谁慢谁执行
                if ($scope.vpList.length > 0) {
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.triageInfo.vp_id) {
                            $scope.vpSelect = $scope.vpList[i];
                            break;
                        }
                    }
                }
                // 症状
                for (var i in $scope.triageInfo.symptom) {
                    $scope.symptomData.symptoms.push($scope.triageInfo.symptom[i]);
                }
                // 2018-9-3 10:14:38 获取可能伴随症状
                $scope.getRlatSymptom($scope.symptomData.symptoms.join(","), $scope.triageInfo.vp_id);
                // 2018-9-3 10:22:54 获取上次就诊信息
                $scope.getLastOpInfo($scope.triageInfo.vp_id);
                // 分诊结果
                $scope.sysptomResult.triage_id = $scope.triageInfo.triage_id;
                $scope.sysptomResult.triage_result = $scope.triageInfo.triage_result;
                // 选的科室 查找分诊结果中对应division的speciality
                var speciality = "";
                console.log($scope.sysptomResult.triage_result);
                for (var i in $scope.sysptomResult.triage_result) {
                    if ($scope.sysptomResult.triage_result[i].division == $scope.triageInfo.choose_division) {
                        speciality = $scope.sysptomResult.triage_result[i].speciality;
                        break;
                    }
                }
                console.log(speciality);
                if (speciality.length > 0) {
                    // division传空 跳过回调的update过程
                    $scope.getDoctorList(speciality, "");
                }
                // 选的医师
                //if ($scope.symptomData.isReview) {
                // 是否历史就诊
                if ($rootScope.triageIntoReview) {
                    $scope.doctorIntro($scope.doctorId, null, null, null, "1");
                }
                else {
                    $scope.doctorIntro($scope.doctorId);
                }
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
        })
    }
    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.info($scope.vpList);
                // 从预约挂号退回 自动选择就诊人 异步 不知道谁快 谁慢谁执行
                if ($scope.triageId != null && $scope.triageId.length > 0 && $scope.triageInfo.vp_id != null) {
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.triageInfo.vp_id) {
                            $scope.vpSelect = $scope.vpList[i];
                            break;
                        }
                    }
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        })
    }
    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.vpNew.idCardType = $scope.idCardTypeList[0].id;
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if ($scope.vpNew.idCardType == 5) {
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text + '不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }
    // 选择就诊人
    $scope.selectVisitPatient = function (index) {
        $scope.vpSelect = $scope.vpList[index];
        console.log($scope.vpSelect);

        // 2020-7-9 17:46:58 HM 判断是否走自动问诊
        TriageService.checkServerStatus().then(function (data) {
            if (data.data == "1") {
                // 走新的
                $state.go("app.autoInquiry", { vpid: $scope.vpSelect.VISIT_PATIENT_ID, firstFrom: "triage", continueInquiry: 0 });
            }
            else {
                // 走旧的
                // 获取可能伴随症状
                $scope.getRlatSymptom("", $scope.vpSelect.VISIT_PATIENT_ID);
                // 继续下一步
                slideTriage.next();
                $scope.step = slideTriage.currentIndex();
                // 获取上次就诊
                if ($scope.vpSelect.IS_BIND_CARD != 1) {
                    if ($scope.step == 1) {
                        $fwCordovaToast.showShortBottom('当前就诊人未绑定就诊卡，无法查询复诊信息');
                        $scope.symptomData.isReview = false;
                    }
                    return;
                }
                if ($scope.reviewDataRequestId.length == 0) {
                    // 获取上次就诊信息
                    $scope.getLastOpInfo($scope.vpSelect.VISIT_PATIENT_ID);
                }
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络错误，获取服务状态失败');
        })
    }

    // 获取上次就诊信息
    $scope.getLastOpInfo = function (vpId) {
        // 请求上次就诊信息
        $scope.isLoadingHistory = true;
        TriageService.getLastOpInfo(vpId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.reviewDataRequestId = data.data;
                $scope.symptomData.isReview = true;
            }
            else if (data.result == -1) {        // 查询缓存
                if (data.is_null == 1) {
                    $scope.reviewDataRequestId = data.data;
                }
                else {    // 原本data.data能直接用的，但是上次就诊信息返回特殊处理了
                    $scope.reviewDataRequestId = data.data[0].REQUEST_ID;
                }
                $scope.symptomData.isReview = true;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.symptomData.isReview = false;
            }
            // 有结果
            if ($scope.symptomData.isReview) {
                // 获取上次就诊信息
                TriageService.respLastOpInfo($scope.reviewDataRequestId).then(function (data) {
                    console.log(data);
                    // 查询成功
                    if (data.result == 1 && data.is_null == 0) {
                        $scope.reviewData = data.data;
                    }
                    // 无结果
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $scope.symptomData.isReview = false;
                    }
                    $ionicLoading.hide();
                    $scope.isLoadFinish = true;
                    $scope.isLoadingHistory = false;
                }, function (data) {
                    $ionicLoading.hide();
                    $scope.isLoadFinish = true;
                    $scope.symptomData.isReview = false;
                    $scope.isLoadingHistory = false;
                })
            }
            else {
                $ionicLoading.hide();
                $scope.isLoadFinish = true;
                $scope.isLoadingHistory = false;
            }
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $scope.isLoadingHistory = false;
        })
    }

    // 填写症状模态窗口显示
    $scope.addSymptomShow = function () {
        if ($scope.symptomData.symptoms.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的症状过多');
            return;
        }
        $scope.addSymptomData.keyword = "";
        $scope.addSymptomData.results = [];
        $scope.addSymptomModal.show();
        // 自动获取焦点
        $timeout(function () {
            document.getElementById("searchSymptom").focus();
        }, 500);
    }
    // 填写症状模态窗口隐藏
    $scope.addSymptomHide = function () {
        $scope.addSymptomModal.hide();
        $scope.doctorInfo = new Object();
    }
    // 查询症状
    $scope.searchSymptom = function () {
        $scope.addSymptomData.results = [];
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        TriageService.symptomSearch($scope.addSymptomData.keyword, $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.results = data.data;
                $ionicScrollDelegate.scrollTop();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("搜索超时，请稍后再试");
        })
    }
    // 添加症状
    $scope.addSymptom = function (data) {
        if ($scope.symptomData.symptoms.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的症状过多');
            return;
        }
        if ($scope.symptomData.symptoms.indexOf(data) > -1) {
            $fwCordovaToast.showShortBottom('您选择的症状已存在');
            return false;
        }
        $scope.symptomData.symptoms.push(data);
        // 获取可能伴随症状
        $scope.getRlatSymptom($scope.symptomData.symptoms.join(","), $scope.vpSelect.VISIT_PATIENT_ID);
        $scope.addSymptomHide();
    }
    // 删除症状
    $scope.deleteSymptom = function (index) {
        $scope.symptomData.symptoms.splice(index, 1);
        // 获取可能伴随症状
        $scope.getRlatSymptom($scope.symptomData.symptoms.join(","), $scope.vpSelect.VISIT_PATIENT_ID);
    }
    // 获取可能伴随症状
    $scope.getRlatSymptom = function (strSymptoms, vpId) {
        TriageService.rlatSymptom(strSymptoms, vpId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.rlats = data.data;
                $scope.addSymptomData.common = data.common;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            ;
        })
    }
    // 分诊
    $scope.getTriageResult = function () {
        // 症状为空 toast
        if ($scope.symptomData.symptoms.length == 0 && $scope.isLoadingHistory) {
            //$fwCordovaToast.showShortBottom("正在加载历史就诊，请稍候");
            return;
        }
        $scope.sysptomResult = {};
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 计算分诊结果
        TriageService.result($scope.vpSelect.VISIT_PATIENT_ID, $scope.symptomData.symptoms.join(), $scope.symptomData.isReview, $scope.reviewDataRequestId).then(function (data) {
            console.log(data);
            // 查询成功
            if (data.result == 1) {
                $scope.sysptomResult = data.data;
                $scope.nextSlide();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络连接异常，请稍后重试");
        })
    }
    // 获取指定科别医师列表
    $scope.getDoctorList = function (speciality, division) {
        console.log(speciality, division);
        $scope.doctorData.doctorList = [];
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 获取指定科别医师列表
        if (isOpAppt || $rootScope.opApptData.status) {
            OpApptService.getDoctorListBySpeciality(speciality).then(funcCBSGetDoctorListBySpeciality, funcCBEGetDoctorListBySpeciality);
        }
        else {
            SchedulingService.getDoctorListBySpeciality(speciality).then(funcCBSGetDoctorListBySpeciality, funcCBEGetDoctorListBySpeciality);
        }
        function funcCBSGetDoctorListBySpeciality(data) {
            // 查询成功
            if (data.result == 1) {
                // 2019-9-26 10:11:14 HM 增加+ 智能分诊查询医师，显示排班
                for (var i = 0; i < data.data.length; i++) {
                    var result = data.data[i];
                    if (data.data[i].REG_DATE == "") {
                        $scope.doctorData.doctorList.push(result);
                        continue;
                    }
                    var regDate = data.data[i].REG_DATE.split(",");
                    var regDateList = new Array();
                    for (var j = 0; j < regDate.length; j++) {
                        var obj = new Object();
                        var reg = regDate[j].split("|");
                        reg[0] = reg[0].slice(5);
                        obj.date = reg[0];
                        obj.count = reg[1];
                        regDateList.push(obj);
                    }

                    result.regDateList = regDateList;
                    $scope.doctorData.doctorList.push(result);
                }
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 重新计算滚动条高度
            $scope.slideChanged();
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }
        function funcCBEGetDoctorListBySpeciality(data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }
        // 页面调用时触发 从预约挂号退回时略过
        if (division != null && division.length > 0) {
            console.log($scope.sysptomResult.triage_id, division);
            // 分诊科别选择回调
            TriageService.selectDivision($scope.sysptomResult.triage_id, division).then(function (data) {
                ;
            }, function (data) {
                ;
            })
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.nextSlide();
        }
    }
    // 医师信息
    $scope.doctorIntro = function (doctorId, doctorLevel, doctorCode, doctorName, isReview) {
        // 是否从预约挂号退回
        var fromOpAppt = $scope.triageId != null && $scope.triageId.length > 0;
        // 正常流程
        if (!fromOpAppt) {
            // 记录当前列表页滚动条位置
            $scope.scrollPosition = scrollTriage.getScrollPosition();
        }
        $scope.intoReview = isReview == null ? false : true;
        // 2018-9-3 14:19:11 是否历史就诊 用于返回时跳转
        $rootScope.triageIntoReview = isReview == null ? false : true;
        console.log("$rootScope.triageIntoReview: " + $rootScope.triageIntoReview);
        $scope.doctorInfo = new Object();
        $scope.schedulingModal = new Object();
        if (doctorId == undefined || doctorId.length == 0) {
            $scope.doctorInfo.doctor_name = doctorName;
            $scope.doctorInfo.title = doctorLevel;
            $scope.doctorInfo.avatar_path = picPrefix + "/Sites/Uploaded/File/2012/1/Default.jpg";
            if (doctorCode != '') {
                $ionicLoading.show();
                // 获取医师出诊表
                if (doctorCode == null || doctorCode == "") {
                    doctorCode = $scope.doctorInfo.doctor_code;
                }
                if (isOpAppt || $rootScope.opApptData.status) {
                    OpApptService.getDoctorScheduling(doctorCode).then(funcCBSScheduling_new, funcCBEScheduling_new);
                }
                else {
                    DoctorInfoService.scheduling_new(doctorCode).then(funcCBSScheduling_new, funcCBEScheduling_new);
                }
                function funcCBSScheduling_new(data) {
                    $scope.schedulingModal = data;
                    console.log(data);
                    $ionicLoading.hide();
                }
                function funcCBEScheduling_new(resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络'
                    });
                    $ionicLoading.hide();
                }
            }
        }
        else {
            $ionicLoading.show();
            $scope.isLoadFinish = false;
            DoctorInfoService.doctorInfo(doctorId).then(function (data) {
                $ionicLoading.hide();
                $scope.isLoadFinish = true;
                $scope.doctorInfo = data;
                console.log($scope.doctorInfo);
                // 重新计算滚动条高度
                $scope.slideChanged();
                // 获取医师出诊表
                if (doctorCode == null || doctorCode == "") {
                    doctorCode = $scope.doctorInfo.doctor_code;
                }
                if (isOpAppt || $rootScope.opApptData.status) {
                    OpApptService.getDoctorScheduling(doctorCode).then(funcCBSScheduling_new2, funcCBEScheduling_new2);
                }
                else {
                    DoctorInfoService.scheduling_new(doctorCode).then(funcCBSScheduling_new2, funcCBEScheduling_new2);
                }
                function funcCBSScheduling_new2(data) {
                    $scope.schedulingModal = data;
                    console.log(data);
                }
                function funcCBEScheduling_new2(resp) {
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络'
                    });
                    $ionicLoading.hide();
                    $scope.isLoadFinish = true;
                }
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
                $scope.isLoadFinish = true;
            });
        }
        console.log("fromOpAppt: " + fromOpAppt);
        // 正常流程
        if (!fromOpAppt) {
            // 从上次就诊进入 直接进入医师信息
            if ($scope.intoReview) {
                $scope.toSlide(4);
            }
            // 从医师列表进入 进入医师信息
            else {
                $scope.nextSlide();
            }
        }
    }
    // 跳转到opAppt
    $scope.apptModal = function (id, color) {
        console.log(id, color);
        if (id != "" && (color == "green" || color == "orange")) {
            console.log(id, color);
            if (isOpAppt || $rootScope.opApptData.status) {
                OpApptService.getOpSchedInfo(id).then(funcCBSGetPeriod);
            }
            else {
                AddWishService.getPeriod(id).then(funcCBSGetPeriod);
            }
            function funcCBSGetPeriod(data) {
                console.log(data);
                // 调用失败
                if (data.result == -1) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                // 已约满
                else if (data.result == 0) {
                    $fwCordovaToast.showShortBottom("当前选择的医师已约满");
                }
                // 一个时段 直接赋值下一步
                else {
                    $scope.opInfoSelect = data.data[0];

                    // 2020-7-23 16:30:41 HM 按症状预约跳自动问诊，再调智能分诊，再跳预约挂号，多填了一次流调表
                    if (isOpAppt || $rootScope.opApptData.status) {
                        $state.go("app.opAppt", { opid: data.data[0].ID, from: 'app.triage,' + $scope.sysptomResult.triage_id + ',' + $scope.vpSelect.VISIT_PATIENT_ID + ',' + $scope.doctorInfo.doctor_id + ',' + $scope.firstFrom });
                    }
                    else {
                        $state.go("app.addWish", { opid: data.data[0].ID, from: 'app.triage,' + $scope.sysptomResult.triage_id + ',' + $scope.vpSelect.VISIT_PATIENT_ID + ',' + $scope.doctorInfo.doctor_id + ',' + $scope.firstFrom });
                    }
                }
            }
        } else {
            //alert("NO ID");
        }
    }
    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }
    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    // 滑块切换
    $scope.slideChanged = function () {
        // 记录当前步骤
        $scope.step = slideTriage.currentIndex();
        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        // 返回的列表页滚到记录高度
        if ($scope.step == 3) {
            scrollTriage.scrollTo($scope.scrollPosition.left, $scope.scrollPosition.top);
            $scope.doctorInfo = new Object();
        }
        // 内容页滚到顶
        else {
            scrollTriage.scrollTop();
        }
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $state.go('app.home');
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'triage');
        // 获取就诊人列表
        $scope.loadVpList();

        //设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if (data.result == 1) {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else {
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证"}];
        //    }
        //});

        // 从预约挂号返回
        if ($scope.triageId != null && $scope.triageId.length > 0) {
            // 跳转至医师信息页
            $ionicLoading.show();
            $scope.isLoadFinish = false;
            $scope.toSlide(4);
            // 异步获取智能分诊信息并赋值
            $scope.getTriageInfo();
        }

        // 从自动问诊过来的，直接跳去选医生
        if ($scope.autoVpId != null && $scope.autoVpId.length > 0 && $scope.autoSpeciality != null && $scope.autoSpeciality.length > 0) {
            $scope.vpSelect = {};
            $scope.vpSelect.VISIT_PATIENT_ID = $scope.autoVpId;
            $scope.getDoctorList($scope.autoSpeciality, '');
            $scope.toSlide(3);
        }
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'triage') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
