﻿angular.module('fwapp.controllers')

// 视频候诊叫号
.controller('VideoCallController', function ($scope, $rootScope, $state, $ionicLoading, $stateParams, $interval,
    OlTreatRecipeService, $ionicHistory, $ionicPlatform, $ionicActionSheet, $fwCordovaToast, $ionicPopup, $ionicModal) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 列表
    $scope.videoList = [];

    // 检查登录状态
    $rootScope.checkLogin();

    $scope.goBack = function () {
        $state.go('app.home');
    }

    // 手动刷新
    $scope.refresh = function () {
        $ionicLoading.show();
        OlTreatRecipeService.getVideoStatus().then(function (data) {
            $ionicLoading.hide();
            // 有会话
            if (data.result == 1) {

                $scope.videoList = data.data;

            }
            // 无会话
            else {
                $scope.videoList = [];
            }
        })
    }

    // 调用视频小程序
    $scope.goVideo = function (roomId, applyId) {
        if (roomId == null || roomId == "" || applyId == null || applyId == "") {
            $fwCordovaToast.showShortBottom("错误，当前暂时不能进入视频会话");
            return;
        }

        // 测试专用
        //roomId = "889988";
        var param = { roomId: roomId, applyId: applyId };

        var funcSuccess = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
            console.log(data);
        }
        var funcError = function (data) {
            console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
            console.log(data);
        }

        window.plugins.MiniProgramPlugin.launchMiniProgram(param, funcSuccess, funcError);
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        $ionicLoading.show();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'videoCall');

        $scope.videoList = [];

        OlTreatRecipeService.getVideoStatus().then(function (data) {
            console.log(JSON.stringify(data));
            $ionicLoading.hide();
            // 有会话
            if (data.result == 1) {

                $scope.videoList = data.data;

                // 自动刷新，10s一刷新
                $scope.timer = $interval($scope.refresh, 10000);
            }
            // 无会话
            else {
                $scope.videoList = [];
            }
        }, function (error) {
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            $scope.videoShow = false;
            $ionicLoading.hide();
        })
    });

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'videoCall') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    $scope.$on('$destroy', function () {
        $interval.cancel($scope.timer);
    })
})