﻿angular.module('fwapp.controllers')

.controller('VisitHistoryController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout, $ionicActionSheet,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $cordovaDatePicker, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer,
    AccountService, VisitPatientService, RequestService, VisitHistoryService, $fwCordovaToast, $ionicSlideBoxDelegate, $ionicPlatform, $ionicHistory) {
    // 检查登录状态
    $rootScope.checkLogin();

    //#region 就诊记录滑块
    var slideVisitHistory = $ionicSlideBoxDelegate.$getByHandle('slideVisitHistory');
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideVisitHistory.enableSlide(false);
    });

    // 初始滑块状态
    $scope.step = 0;

    // 滑到指定页
    $scope.toSlide = function (index) {
        slideVisitHistory.slide(index);
        $scope.step = slideVisitHistory.currentIndex();
        if ($scope.step == 0) {
            $scope.visitInfo = new Object();
            $scope.visitInfoOri = new Object();
            $scope.visitIndex = -1;
            $scope.imageList = [];
            $scope.imageTypeList = [];
        }
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        console.log("页码");
        console.log($scope.step);
    }
    //#endregion

    // 是否加载完成
    $scope.isLoadFinish = false;
    // 保存按钮可用
    $scope.canSave = true;

    // 就诊记录列表
    $scope.visitList = [];
    $scope.visitInfo = new Object();
    $scope.visitInfoOri = new Object();
    $scope.visitIndex = -1;
    // 上传图像属性
    $scope.imageNew = new Object();
    // 检查化验图像
    $scope.imageListAll = [];
    $scope.imageList = [];
    // 图像类型数组
    $scope.imageTypeList = [];
    // 大图列表
    $scope.uploadImgList = [];
    // 图片服务器路径
    $scope.imgServerUrl = uploadUrl;
    $scope.slides = [];
    $scope.currentImgIndex = 0;
    $scope.currentSlideIndex = 0;
    // 打哪儿来
    $scope.from = ($stateParams.from == null || $stateParams.from.length == 0) ? "" : $stateParams.from;

    //#region 就诊人
    // 就诊人ID
    $scope.vpId = ($stateParams.vpid == null || $stateParams.vpid.length == 0) ? "" : $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人列表
    $scope.vpList = [];

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        if ($scope.vpId != vpid) {
            $scope.vpId = vpid;
            $scope.vpInfo = new Object();
            $scope.loadVPInfo();
            $scope.loadVisitList();
        }
        $scope.popVplist.hide();
    }
    //#endregion

    //#region 注册模态窗口
    // 上传图像
    $ionicModal.fromTemplateUrl("addReportImage.html", {
        scope: $scope
    }).then(function (modal) {
        $scope.addReportImageModal = modal;
    });
    // 大图浏览
    $ionicModal.fromTemplateUrl("popup_image.html", {
        scope: $scope,
        animation: "fade-in"
    }).then(function (modal) {
        $scope.popupImageModal = modal;
    });

    // 绑定清除事件，移除所有模态窗口，防止溢出
    $scope.$on("$destroy", function () {
        $scope.addReportImageModal.remove();
        $scope.popupImageModal.remove();
    })

    // 上传图像 模态窗口显示
    $scope.addReportImageShow = function (type) {
        $scope.imageNew = new Object();
        $scope.imageNew.TYPE = type;
        $scope.addReportImageModal.show();
    }

    // 上传图像 模态窗口隐藏
    $scope.addReportImageHide = function () {
        $scope.addReportImageModal.hide();
        $ionicScrollDelegate.resize();
        $scope.imageNew = new Object();
    }
    //#endregion

    //#region 编辑就诊记录
    function loadStart() {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        $scope.canSave = false;
    }

    function loadFinish() {
        $scope.isLoadFinish = true;
        $scope.canSave = true;
        $ionicLoading.hide();
    }

    // 获取就诊记录列表
    $scope.loadVisitList = function () {
        loadStart();

        $scope.visitList = [];

        VisitHistoryService.list($scope.vpId, localStorage.queryToken).then(function (data) {
            //console.log(data);
            // 无效QueryToken
            if (data.result == -2) {
                loadFinish();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadVisitList();
                    }
                })
                return;
            }
            // 请求错误
            else if (data.result == 0) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            else if (data.result == 1) {
                // 患病日期格式化
                for (var i in data.data) {
                    if (data.data[i].DATE_VISIT == null || data.data[i].DATE_VISIT.length == 0) {
                        data.data[i].DATE_VISIT = "";
                        continue;
                    }
                    if (currentPlatform == "iOS") {
                        data.data[i].DATE_VISIT = data.data[i].DATE_VISIT.replace(/-/g, "/");
                    }
                    data.data[i].DATE_VISIT = new Date(data.data[i].DATE_VISIT).Format("yyyy-MM-dd");
                    console.log(data.data[i].DATE_VISIT);
                }
                $scope.visitList = data.data;
                $scope.imageListAll = data.img;

            }
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            loadFinish();
        });
    }

    // 获取就诊记录详情
    $scope.loadVisitInfo = function (index) {
        $scope.visitIndex = index;
        // 新建
        if (-1 == index) {
            $scope.visitInfo = new Object();
            $scope.visitInfo.VISIT_PATIENT_ID = $scope.vpId;
            $scope.visitInfo.VISIT_HISTORY_ID = "";
            $scope.visitInfo.DATE_VISIT = new Date().Format("yyyy-MM-dd");
            $scope.visitInfo.OPERATION_NAME = "";
        }
        // 编辑
        else {
            $scope.visitInfo = $scope.visitList[index];
            if ($scope.visitInfo.OPERATION_NAME == "undefined") {
                $scope.visitInfo.OPERATION_NAME = "";
            }
            // 图
            for (var i in $scope.imageListAll) {
                // 过滤出本条就诊记录的图
                if ($scope.imageListAll[i].VISIT_HISTORY_ID == $scope.visitInfo.VISIT_HISTORY_ID) {
                    $scope.imageList.push($scope.imageListAll[i]);
                    // 存在类别数组
                    if (-1 == jQuery.inArray($scope.imageListAll[i].TYPE, $scope.imageTypeList)) {
                        $scope.imageTypeList.push($scope.imageListAll[i].TYPE);
                    }
                }
            }
        }
        $.extend($scope.visitInfoOri, $scope.visitInfo);
        $scope.toSlide(1);
    }

    // 删除就诊记录
    $scope.deleteVisit = function (index) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除就诊记录',
            template: "您确定要删除此条就诊记录吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                loadStart();
                console.log('index:' + index);
                console.log($scope.visitList[index]);
                VisitHistoryService.deleteVisit($scope.visitList[index].VISIT_HISTORY_ID).then(function (data) {
                    // 请求错误
                    if (data.result == 0) {
                        loadFinish();
                        $fwCordovaToast.showShortBottom(data.msg);
                        return;
                    }
                    // 请求成功
                    if (data.result == 1) {
                        $scope.visitList[index].STATUS = 0;
                        //$scope.visitList.splice(index, 1);
                        //$scope.loadVisitList();
                        console.log($scope.visitList);
                    }
                    $ionicScrollDelegate.resize();
                    loadFinish();
                });
            }
        })
    }
    //#endregion

    // 编辑就诊记录
    $scope.editVisitInfo = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        loadStart()
        console.log($scope.visitInfo);
        // 查空
        if (null == $scope.visitInfo.DISEASE_NAME || 0 == $scope.visitInfo.DISEASE_NAME.length
        || null == $scope.visitInfo.IS_HEART || 0 == $scope.visitInfo.IS_HEART.length
        || null == $scope.visitInfo.DATE_VISIT || 0 == $scope.visitInfo.DATE_VISIT.length
        || null == $scope.visitInfo.HOSPITAL_NAME || 0 == $scope.visitInfo.HOSPITAL_NAME.length
        || null == $scope.visitInfo.HOSPITAL_RANK || 0 == $scope.visitInfo.HOSPITAL_RANK.length
        || null == $scope.visitInfo.HOSPITAL_DEPT || 0 == $scope.visitInfo.HOSPITAL_DEPT.length
        || null == $scope.visitInfo.HOSPITAL_OPINION || 0 == $scope.visitInfo.HOSPITAL_OPINION.length
        || null == $scope.visitInfo.IS_OPERATION || 0 == $scope.visitInfo.IS_OPERATION.length
        || ("1" == $scope.visitInfo.IS_OPERATION && (null == $scope.visitInfo.OPERATION_NAME || 0 == $scope.visitInfo.OPERATION_NAME.length))) {
            $fwCordovaToast.showShortBottom("必填项不得为空");
            loadFinish()
            return;
        }

        // 拼接查询字符串
        var modelVPInfo = {
            "diseaseName": $scope.visitInfo.DISEASE_NAME,
            "isHeart": $scope.visitInfo.IS_HEART,
            "visitDate": $scope.visitInfo.DATE_VISIT,
            "hospitalName": $scope.visitInfo.HOSPITAL_NAME,
            "hospitalRank": $scope.visitInfo.HOSPITAL_RANK,
            "hospitalDept": $scope.visitInfo.HOSPITAL_DEPT,
            "hospitalOpinion": $scope.visitInfo.HOSPITAL_OPINION,
            "isOperation": $scope.visitInfo.IS_OPERATION,
            "operationName": $scope.visitInfo.OPERATION_NAME,
            "vhId": $scope.visitInfo.VISIT_HISTORY_ID,
            "vpId": $scope.vpId
        };

        // 保存
        VisitHistoryService.editVisit(modelVPInfo).then(function (data) {
            console.log(data);
            // 请求错误
            if (data.result == "0") {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 请求成功
            if (data.result == "1") {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.loadVisitList();
                $scope.toSlide(0);
                $scope.visitInfo = new Object();
                $scope.visitInfoOri = new Object();
                $scope.visitIndex = -1;
            }
            loadFinish();
        });
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页 列表 正常后退
        if ($scope.step == 0) {
            if ($stateParams.vpid == "") {
                $rootScope.goBack();
            }
            else {
                if ($scope.from.length > 0) {
                    $state.go($scope.from, { vpid: $scope.vpId, from: "app.visitHistory" });
                }
                else {
                    $state.go('app.visitPatient', { vpid: $scope.vpId });
                }
            }
        }
        // 其他页返回第一个滑块
        else {
            // 检查是否更改
            $scope.checkChange();
        }
    }

    // 检查是否更改
    $scope.checkChange = function () {
        console.log($.param($scope.visitInfoOri));
        console.log($.param($scope.visitInfo));
        if ($.param($scope.visitInfoOri) != $.param($scope.visitInfo)) {
            // 提示保存
            var confirmPopup = $ionicPopup.confirm({
                title: '保存诊前信息',
                template: "诊前信息已更改,是否保存？",
                cancelText: '放弃更改',
                okText: '保存'
            }).then(function (res) {
                if (res) {
                    $scope.editVisitInfo();
                }
                else {
                    $scope.visitList[$scope.visitIndex] = $scope.visitInfoOri;
                    $scope.loadVisitList();
                    $scope.toSlide(0);
                }
            })
        }
        else {
            $scope.visitList[$scope.visitIndex] = $scope.visitInfoOri;
            $scope.loadVisitList();
            $scope.toSlide(0);
        }
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'visitHistory');
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }
                // 第一就诊人
                var vpid = "";
                console.log(data.data.length);
                for (var i = 0; i < data.data.length; i++) {
                    $scope.vpList.push(data.data[i]);
                    if (vpid == "") {
                        vpid = data.data[i].VISIT_PATIENT_ID;
                    }
                }
                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }
                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                }
                else {
                    console.log($scope.vpId);
                    $scope.loadVPInfo();
                    $scope.loadVisitList();
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'visitHistory') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });

    //#region cordova日期选择
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }
    //#endregion

    //#region 多选控件
    // 延迟重绘高度
    $scope.scrollResize = function () {
        $timeout(function () {
            $ionicScrollDelegate.resize();
        }, 500);
    }

    // 不可取消单选按钮
    $scope.flupRadio = function (qstnId, dicValue) {
        $scope.visitInfo[qstnId] = dicValue;
        $scope.scrollResize();
    }
    //#endregion

    //#region 列表中图片操作
    // 保存已上传图像路径
    $scope.imageAddSave = function (type, path) {
        console.log("保存已上传图像路径");
        console.log($scope.vpId);
        console.log(type);
        console.log(path);
        console.log($scope.visitInfo.VISIT_HISTORY_ID);
        // 保存数据
        VisitHistoryService.imageAdd($scope.vpId, type, path, $scope.visitInfo.VISIT_HISTORY_ID).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 保存成功
            if (data.result == 1) {
                // 当前图像存入大数组
                $scope.imageListAll.push(data.data);
                $scope.imageList = [];
                $scope.imageTypeList = [];
                // 遍历大数组 筛选出本条就诊记录的图
                for (var i in $scope.imageListAll) {
                    // 过滤出本条就诊记录的图
                    if ($scope.imageListAll[i].VISIT_HISTORY_ID == $scope.visitInfo.VISIT_HISTORY_ID) {
                        $scope.imageList.push($scope.imageListAll[i]);
                        // 存在类别数组
                        if (-1 == jQuery.inArray($scope.imageListAll[i].TYPE, $scope.imageTypeList)) {
                            $scope.imageTypeList.push($scope.imageListAll[i].TYPE);
                        }
                    }
                }
                // 新建就诊记录 把id带回来赋值
                if (data.vhId != $scope.visitInfo.VISIT_HISTORY_ID) {
                    $scope.visitInfo.VISIT_HISTORY_ID = data.vhId;
                }
            }
            // 隐藏上传图片窗口 回到就诊记录编辑界面
            $scope.addReportImageHide();
            $ionicLoading.hide();
        })
    }

    // 显示图片删除按钮
    $scope.showImgDelete = function () {
        for (var i = 0; i < $scope.imageList.length; i++) {
            $scope.imageList[i].isImgDelete = true;
        }
    }

    // 隐藏图片删除按钮
    $scope.cancelImgDelete = function () {
        for (var i = 0; i < $scope.imageList.length; i++) {
            $scope.imageList[i].isImgDelete = false;
        }
    }

    // 删除图片
    $scope.imgDelete = function (id) {
        console.log(id);
        //console.log($scope.donatorImage);
        $ionicPopup.confirm({
            title: "删除确认",
            template: "确定要删除该图片？",
            cancelText: "取消",
            okText: "确定"
        }).then(function (res) {
            if (res) {
                VisitHistoryService.imageDelete(id).then(function (data) {
                    for (var j = 0; j < $scope.imageList.length; j++) {
                        if ($scope.imageList[j].REPORT_IMAGE_ID == id) {
                            $scope.imageList.splice(j, 1);
                            $fwCordovaToast.showShortBottom("删除成功");
                            break;
                        }
                    }
                })
            }
            $scope.showImgDelete();
        });
    }

    // 显示弹出大图
    $scope.popupImgShow = function (list, index) {
        $ionicModal.fromTemplateUrl("popup_image.html", {
            scope: $scope,
            animation: "fade-in"
        }).then(function (modal) {
            $scope.popupImageModal = modal;
            // 赋值图片列表
            $scope.uploadImgList = list;
            var cIndex = index;
            var preIndex = index == 0 ? list.length - 1 : index - 1;
            var nextIndex = index == list.length - 1 ? 0 : index + 1;

            $scope.currentImgIndex = cIndex;
            $scope.currentSlideIndex = 1;

            $scope.slides[0] = { src: list[preIndex].URL, seq: preIndex };
            $scope.slides[1] = { src: list[cIndex].URL, seq: cIndex };
            $scope.slides[2] = { src: list[nextIndex].URL, seq: nextIndex };
            //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
            // 显示弹出层
            $scope.popupImageModal.show();
        });
    }

    // 隐藏弹出大图
    $scope.popupImgHide = function () {
        // 清空图片列表
        $scope.uploadImgList = [];
        //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
        // 隐藏弹出
        $scope.popupImageModal.hide();
        $scope.popupImageModal.remove();
    }

    // 选中切换
    $scope.popupImgSlideChange = function (index) {
        var change = $scope.currentSlideIndex + ">" + index;
        $scope.currentSlideIndex = index;
        if (change == "2>0" || change == "0>1" || change == "1>2") {
            var sIndex = index + 1;
            if (sIndex == 3) {
                sIndex = 0;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex + 1;
            if (iIndex == $scope.uploadImgList.length) {
                iIndex = 0;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
        else if (change == "0>2" || change == "2>1" || change == "1>0") {
            var sIndex = index - 1;
            if (sIndex == -1) {
                sIndex = 2;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex - 1;
            if (iIndex == -1) {
                iIndex = $scope.uploadImgList.length - 1;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
    }

    // 阻止事件冒泡
    $scope.stopPropagation = function () {
        event.stopPropagation();
    }
    //#endregion

    //#region 图片上传
    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function (type) {
        if (type.length == 0) {
            $fwCordovaToast.showShortBottom("请选择报告类别");
            return;
        }
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 100,
            maximumImagesCount: 1024,
            width: 0,
            height: 0
        };

        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList.length);
            $scope.uploadImg(imageDataList, type);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            var imageDataList = [];
            imageDataList[0] = imageData;
            $scope.uploadImg(imageDataList, type);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageDataList, type) {
        // 无就诊记录id
        if ($scope.visitInfo.VISIT_HISTORY_ID == null || $scope.visitInfo.VISIT_HISTORY_ID.length == 0) {
            // 新建就诊记录
            VisitHistoryService.addForUpload($scope.vpId).then(function (data) {
                $scope.visitInfo.VISIT_HISTORY_ID = data.id;
                UploadImage(data.id, type, imageDataList, 0);
            })
        }
        // 有就诊记录id
        else {
            UploadImage($scope.visitInfo.VISIT_HISTORY_ID, type, imageDataList, 0);
        }
    }

    // 批量上传图片
    function UploadImage(vhId, type, imageDataList, index) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageDataList[index].substr(imageDataList[index].lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: vhId + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        if (index == 0) {
            $ionicLoading.show();
        }
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageDataList[index], options, true).then(function (result) {
            // 成功处理
            // 保存已上传图像路径
            $scope.imageAddSave(type, result.response);
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(vhId, type, imageDataList, index + 1);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + error + "。请稍后重试");
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(vhId, type, imageDataList, index + 1);
            }
        }, function (progress) {
            ;
        });
    }
    //#endregion
});
