﻿angular.module('fwapp.controllers')

.controller('VisitPatientController', function ($scope, $rootScope, $state, $stateParams, $q, $timeout, $sce, $window, $filter
, $ionicPlatform, $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $fwCordovaToast, $ionicActionSheet, $cordovaInAppBrowser
, AccountService, VisitPatientService, RequestService, OpRegService, OpPaymentService, IpRegService) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 用户信息
    $scope.accountInfo = new Object();
    // 2023-8-28 13:55:26 ZZL #hzfwx-107 现住址省市县字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 就诊人建卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '',
        insurance_type: 0,
        mi_patient_code: '',
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 就诊人绑卡模型
    $scope.vpBind = {
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }

    // 记一下requestId 获取手机号/卡号用
    $scope.requestId = "";
    // 绑卡前一步是否来自选卡
    $scope.lastSelectCard = false;

    // 获取验证码倒计时
    $scope.timespan = 0;
    // 就诊人列表
    $scope.vpList = [];
    // 模拟键盘用途
    $scope.simKeyUsage = 0;
    // 模拟键盘结果
    $scope.simKeyValue = []
    // 模拟键盘结果1
    $scope.simKeyValue1 = []
    // 帮助信息
    $scope.helpInfo = new Object();

    // 院外病历授权
    $scope.outHospitalAuthResult = false;
    // 向其他医疗机构共享本人病历
    $scope.selfHospitalAuthResult = false;
    // 2021-5-15 13:39:03 院外病历授权医院
    $scope.outRecordHosp = {};
    // 无就诊记录医院
    $scope.outRecordHospNo = [];
    // 阜外医院分院
    $scope.hospitalBranch = [];
    // 北京市基层社区医院
    $scope.communityHospital = [];
    // 2021-5-20 09:45:33 袁老师指示 默认折叠无就诊记录医院 可点击展开授权
    $scope.outRecordHospNoVisitShow = false;
    // 2023-1-30 08:41:15 CGZ 阜外医院分院和北京市基层社区医院默认展开
    $scope.hospitalBranchShow = true;
    $scope.communityHospitalShow = true;

    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};

    // 电子就诊卡 二维码
    $scope.qrCodeSrc = "";
    // 电子就诊卡 条形码
    $scope.barCodeSrc = "";
    // 电子就诊卡 开通模型
    $scope.ECard = {
        phoneNum: null,
        phoneNumShow: null,
        messageVericode: '',
        imageVericode: ''
    }
    // 2021-4-22 20:07:58 电子就诊卡只显示条形码或二维码 避免同时出现两种码扫码窗扫不出来
    // 电子就诊卡 显示码类型 默认为条形码
    $scope.showCodeType = "bar";

    // 医保卡号提示
    $scope.MICodeHelp = "医保卡卡号位于卡片正面";

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bind_card.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bind_card_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：电子就诊卡详细
    $ionicModal.fromTemplateUrl('ECard_detail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.ECardDetailModal = modal;
    });

    // 注册模态窗口：电子就诊卡开通
    $ionicModal.fromTemplateUrl('ECard_apply.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.ECardApplyModal = modal;
    });

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注册弹出菜单：院外病例授权
    $ionicPopover.fromTemplateUrl('out_hospital_auth.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.outHospitalAuthModal = modal;
    });

    // 注册模态窗口:建就诊卡
    $ionicModal.fromTemplateUrl('applyCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.applyCardModal = modal;
    });

    // 注册模态窗口:选就诊卡
    $ionicModal.fromTemplateUrl('chooseCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.chooseCardModal = modal;
    });

    // 医保号帮助
    $ionicModal.fromTemplateUrl('MICode_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MICodeHelpModal = modal;
    });

    // 新来院登记
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('temperature.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.temperatureModal = modal;
    });

    // 医保号帮助
    $ionicModal.fromTemplateUrl('YBBindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.YBBindCardModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.outHospitalAuthModal.remove();
        $scope.ECardDetailModal.remove();
        $scope.ECardApplyModal.remove();
        // 新增：绑卡
        $scope.applyCardModal.remove();
        // 新增：选卡
        $scope.chooseCardModal.remove();
        $scope.MICodeHelpModal.remove();
        $scope.temperatureModal.remove();
        $scope.YBBindCardModal.remove();
    })

    // 读取就诊人信息
    $scope.loadVpInfo = function () {
        // 电子就诊卡 二维码
        $scope.qrCodeSrc = "";
        // 电子就诊卡 条形码
        $scope.barCodeSrc = "";
        // 电子就诊卡 开通模型
        $scope.ECard = {
            phoneNum: null,
            phoneNumShow: null,
            messageVericode: '',
            imageVericode: ''
        }
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
                $scope.helpInfo.bindCardHelp = data.bindCardHelp;
                $scope.helpInfo.isSelfDescr = data.isSelfDescr;
                $scope.helpInfo.vpRemoveDescr = $sce.trustAsHtml(data.vpRemoveDescr);
                $scope.outHospitalAuthResult = data.data.OUT_RECORD_AUTH == '1' ? true : false;
                //console.log($scope.helpInfo);
                // e1 => 条形码 & 二维码信息
                if ($scope.vpInfo.IS_BIND_CARD == '1' && ($scope.vpInfo.ECARD_STATUS == '1' || $scope.vpInfo.ECARD_STATUS == '9')) {
                    $scope.getECardInfo($scope.vpInfo.VISIT_PATIENT_ID, $scope.vpInfo.HIS_CARD_NUM);
                }
            }
        })
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.log(data);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid
        $scope.vpInfo = new Object();
        $scope.loadVpInfo();
        $scope.popVplist.hide();
    }

    // 删除就诊人
    $scope.removeVp = function () {
        if (!$scope.vpInfo.DELETABLE) {
            $fwCordovaToast.showShortBottom("用户每两个月只能删除一个就诊人");
            return;
        }

        var confirmPopup = $ionicPopup.confirm({
            title: '确定要删除该就诊人？',
            template: $scope.helpInfo.vpRemoveDescr, //从服务端获取更新的内容
            cancelText: '取消',
            okText: '删除'
        });

        confirmPopup.then(function (res) {
            if (res) {
                VisitPatientService.removeVisitPatient($scope.vpId).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        $fwCordovaToast.showShortBottom("删除成功");
                        $state.go("app.personal");
                    }
                });
            }
        });
    }

    // #region 绑定就诊卡相关(改)

    // 绑卡模态窗口显示(改)
    $scope.bindCardModalShow = function () {
        checkHasCardStatus();
    }

    checkHasCardStatus = function () {
        $ionicLoading.show();
        OpRegService.patientCheck($scope.vpInfo.VISIT_PATIENT_ID).then(function (data) {
            if (data.result == 1) {
                // 无就诊卡
                if (data.is_null == 1) {
                    console.log('无就诊卡：开始办卡流程');
                    var msg = data.msg;
                    // 先创建建卡申请 供上传图片使用
                    OpRegService.createCardApply($scope.vpInfo.VISIT_PATIENT_ID, 1).then(function (data) {
                        $ionicLoading.hide();
                        // 创建建卡申请 成功
                        if (data.result == 1) {
                            $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                            $scope.vpApply.name = data.data.PATIENT_NAME;
                            $scope.vpApply.phone_num = data.data.PHONENUM;
                            $scope.vpApply.address = data.data.ADDRESS;
                            $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                            $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                            $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                            $scope.vpApply.is_self = data.data.IS_SELF;
                            $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                            $scope.vpApply.id_type = data.data.ID_TYPE;
                            $scope.vpApply.insurance_type = data.data.INSURANCE_TYPE;
                            $scope.vpApply.mi_patient_code = data.data.MI_PATIENT_CODE;
                            // 2023-7-19 09:01:07 HM 婚姻情况
                            $scope.vpApply.marital = data.data.MARITAL;

                            // 险种类别：医保卡号说明
                            $scope.MICodeHelp = data.MIPatientCodeHelp;

                            $ionicPopup.alert({
                                title: '请注意',
                                template: msg,
                                okText: '确定'
                            }).then(function () {
                                // 去建卡
                                $scope.applyCardShow();
                            });
                        }
                        // 失败
                        else {
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                    })
                }

                // 有就诊卡 单卡状态
                else if (data.is_null == 0) {
                    console.log('有就诊卡：单卡状态');

                    // 没绑卡的 后台已经自动半绑卡/半绑卡的也在这

                    // 获取requestid
                    $scope.requestId = data.requestId;
                    $scope.getPhoneAndCardNum($scope.requestId, $scope.vpId, data.data, false);
                }

                // 有就诊卡 多卡状态
                else if (data.is_null == 2) {
                    console.log('有就诊卡：多卡状态');
                    $scope.requestId = data.requestId;

                    // 未绑卡状态 => 多卡 => 半绑，用过his_card_num => 不选了，绑它
                    if ($scope.vpInfo.IS_BIND_CARD == "2" && $scope.vpInfo.HIS_CARD_NUM != "") {
                        $scope.getPhoneAndCardNum($scope.requestId, $scope.vpId, $scope.vpInfo.HIS_CARD_NUM, false);
                    }
                    else {
                        $ionicLoading.hide();
                        $scope.cardList = data.data;
                        // 多卡提示
                        $ionicPopup.alert({
                            title: '请注意',
                            template: data.msg,
                            okText: "好的"
                        }).then(function () {
                            $scope.chooseCardModalShow();
                        });
                    }
                }

                // 其他状态(出错)
                else {
                    $ionicLoading.hide();
                    console.log('其他状态：出错');
                    $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
                }
            }
            // result != 1(出错)
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误，请稍后再试");
            }

        }, function () {
            // 真的网络错误 
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 20190930 新增：不带图片码的发送验证码
    getMsgVericodeNew = function (phoneNum, num, isChooseCardHide) {
        AccountService.sendVericodeByPhoneWithoutImgVericode(phoneNum, num).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");
            }
            else {
                $fwCordovaToast.showShortBottom(data.msg + "，请稍后再试");
            }

            // 是否选卡模态窗关闭
            if (isChooseCardHide) {
                $scope.chooseCardModalHide();
            }

            // 倒计时
            $scope.timespan = 60;
            TimeCount();

            // 有预留电话
            // 有卡号
            // 有patient_id(his_card_num)
            // 去绑卡
            $scope.bindCardModal.show();
        })
    }

    // 20190930 新增：选择这张卡
    $scope.bindThisCard = function (index) {
        $ionicPopup.confirm({
            title: '选择绑卡确认',
            template: '是否绑定此就诊卡?',
            okText: '确认',
            cancelText: '取消'
        }).then(function (res) {
            if (res) {
                bindCardSelectSubmit(index);
            }
            else { }
        });
    }

    // 20190930 新增：选卡=>绑它
    bindCardSelectSubmit = function (index) {
        if (index < 0 || index >= $scope.cardList.length || $scope.cardList[index] == null
            || $scope.cardList[index].PATIENT_ID == null || $scope.cardList[index].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }

        $ionicLoading.show();
        VisitPatientService.bindPatientCardSelectV2($scope.vpId, $scope.cardList[index].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 这里出来是半绑卡状态 =>全绑了
                $scope.getPhoneAndCardNum($scope.requestId, $scope.vpId, $scope.cardList[index].PATIENT_ID, true);
            }
        })
    }


    // 20190930 新增：格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 20190930 新增：点击[确认提交] 开通就诊卡
    $scope.submitCardApply = function () {
        // 格式化手机号
        $scope.formatPhone();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
        // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
        var isAddrFormat = false;
        // 现住址不为空-老流程填的，放过，走后边验证
        if ($scope.vpApply.address != '') {
            isAddrFormat = false;
        }
        // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
        else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
            isAddrFormat = true;
            $scope.vpApply.address = '';
            var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
            $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
            var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
            $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
            var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
            $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
            $scope.vpApply.address += $scope.vpApply.address_detail;
        }
        // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
        else {
            $fwCordovaToast.showShortBottom('请完整填写现住址信息');
            return false;
        }
        // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，删除北京医保卡号验证($scope.vpApply.insurance_type == 1 && $scope.vpApply.mi_patient_code == "")
        if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
            || $scope.vpApply.insurance_type == 0
            || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        // 2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
        var addressByteSize = getStringByteSize($scope.vpApply.address);
        //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
        // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
        if (isAddrFormat && addressByteSize > 40) {
            $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
            addressByteSize = getStringByteSize($scope.vpApply.address);
        }
        else if (addressByteSize <= 10 || addressByteSize > 40) {
            var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: msgStr,
                okText: '确定'
            }).then(function () {
            });
            return false;
        }
        // 2023-12-8 13:46:23 ZZL hzfwx-442 医保卡号添加长度限制，超过15位提示，避免超长导致自助机接口报错
        // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，去掉前端、后端、接口、轮询限制，屏蔽掉
        if ($scope.vpApply.mi_patient_code !== undefined && $scope.vpApply.mi_patient_code !== '' && $scope.vpApply.mi_patient_code !== null && $scope.vpApply.mi_patient_code.length > 15) {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '医保卡号格式不正确，请检查后重新填写',
                okText: '确定'
            }).then(function () {
                $scope.MICodeHelpModalShow();
            });
            return false;
        }
        $ionicLoading.show();
        // 提交建卡申请
        // 20181229 BST 暂时把这里的提交建卡申请也按0处理，ZTBZ = 2的建卡机会流程还有问题，暂时不开
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type,
            $scope.vpApply.insurance_type, $scope.vpApply.mi_patient_code, $scope.vpApply.marital).then(function (data) {
                console.log(data);
                // 获取成功
                if (data.result == 1) {
                    // 建卡成功
                    if (data.data == 1) {
                        $scope.applyCardHide();
                        $scope.loadVpList();
                        $scope.loadVpInfo();
                        $fwCordovaToast.showShortBottom('在线建档成功！');
                    }
                    // 建卡失败
                    else if (data.data == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }
                // 获取失败
                else if (data.result == 99) {
                    $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
                } else {
                    // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                    //$fwCordovaToast.showShortBottom(data.msg);
                    var alertPopup = $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: '确定'
                    });
                }
                $ionicLoading.hide();
            })
    }

    // 绑卡模态窗口隐藏
    $scope.bindCardModalHide = function () {
        $scope.bindCardModal.hide();
        $scope.timespan = 0;
        $scope.vpBind = {
            name: '',
            card_num: '',
            card_num_show: '',
            phone_num: null,
            phone_num_show: '',
            veri_code: '',
            patient_id: '',
            is_self: 0
        };

        if ($scope.lastSelectCard) {
            $scope.chooseCardModalShow();
        }
    }

    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpModalShow = function () {
        $scope.bindCardHelpModal.show();
    }

    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpModalHide = function () {
        $scope.bindCardHelpModal.hide();
        $ionicScrollDelegate.scrollTop();
    }

    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败 回滚
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwcordovaToast.showShortTop("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 绑卡 2018.12.29 绑卡 => 自动开通电子就诊卡
    $scope.bindCardSubmit = function () {
        if (!$scope.checkCardNum()) {
            return false;
        }

        if ($scope.vpBind.patient_id == '') {
            $fwCordovaToast.showShortBottom('缺失患者id');
            return false;
        }

        if ($scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请选择患者身份');
            return false;
        }

        VisitPatientService.bindVisitPatient($scope.vpId, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self, true).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showLongBottom(data.msg);
            } else {
                // 隐藏绑定页面
                $scope.bindCardModalHide();

                // 如果来自选卡：隐藏选卡页面 
                if ($scope.lastSelectCard) {
                    $scope.chooseCardModalHide();
                }
                $scope.loadVpInfo();            // 重新获取患者信息
                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
        })
    }


    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function (vpId, phone, card_num, imageVericode) {
        // 验证图片验证码
        if (imageVericode == null || imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }

        $ionicLoading.show();
        RequestService.checkPatientCard(vpId, card_num, phone).then(function (data) {
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，" + data.msg);
                return;
            }
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("绑卡错误，未找到相应患者信息");
                return;
            }

            // patient_id赋值
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            // 就诊卡绑定 => 验证码：5
            $scope.getMsgVericode(phone, '5', imageVericode);
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
    // #endregion

    // #region 跳转
    // 前进至用药提醒
    $scope.goMedication = function () {
        $state.go("app.medicationPlan", { vpid: $scope.vpId });
    }

    // 前进至健康记录
    $scope.goHealth = function () {
        $state.go("app.health", { vpid: $scope.vpId });
    }

    // 前进至健康资料列表
    $scope.goHealthInfo = function () {
        confirmQueryPasswordNoCard("app.healthinfo")
    }

    // 前进至就诊记录
    $scope.goVisitHistory = function () {
        confirmQueryPasswordNoCard("app.visitHistory");
    }

    // 前进至既往史
    $scope.goDiseaseHistory = function () {
        confirmQueryPasswordNoCard("app.diseaseHistory");
    }

    // 前进至诊前信息
    $scope.goPreVisit = function () {
        confirmQueryPasswordNoCard("app.preVisit");
    }

    // 前进至LIS结果
    $scope.goLis = function () {
        confirmQueryPassword("app.lis")
    }

    // 前进至检查列表
    $scope.goCheck = function () {
        confirmQueryPassword("app.check")
    }

    // 前往至修改预留手机号
    $scope.goChangeReservedPhone = function () {
        $state.go("app.changeReservedPhone", { vpid: $scope.vpId });
    }

    // 前往膳食指导
    $scope.goDietaryGuidance = function () {
        // 要走patientCheck
        // 判断患者住没住过院
        $ionicLoading.show();
        RequestService.patientCheck($scope.vpId).then(function (data) {
            console.log(data);

            if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {
                var flag = false;
                for (var i = 0; i < data.data.length; i++) {
                    if (data.data[i].hasOwnProperty("DATE_OUT") && data.data[i]["DATE_OUT"] != "") {
                        flag = true;
                    }
                }

                if (flag) {
                    $ionicLoading.hide();
                    $state.go("app.srvy", { vpid: $scope.vpId, type: "DIETARY_GUIDANCE", from: "visitPatient" });
                }
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("未找到当前患者住院记录，暂不支持进行膳食指导");
                }
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("未找到患者信息");
            }
        }, function () {
            // 真的网络错误
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 前往至新来院登记
    $scope.goTemperature = function () {
        $scope.temperatureShow();
    }

    function confirmQueryPassword(goto) {
        // 未绑定就诊卡
        if ($scope.vpInfo.IS_BIND_CARD != '1') {
            $fwCordovaToast.showShortBottom("请先绑定就诊卡");
            return;
        }

        $scope.queryPassword().then(function (data) {
            if (data) {
                // 跳转
                $state.go(goto, { vpid: $scope.vpId, from: "app.visitPatient" });
            }
        })
    }
    function confirmQueryPasswordNoCard(goto) {
        $scope.queryPassword().then(function (data) {
            if (data) {
                // 跳转
                $state.go(goto, { vpid: $scope.vpId });
            }
        })
    }

    // 后退
    $scope.goBack = function () {
        $state.go("app.personal");
    }
    // #endregion

    //#region 院外病历浏览
    $scope.outHospitalAuthModalShow = function () {
        $ionicLoading.show();
        // 2021-5-13 20:19:23 获取总授权状态及授权医院状态
        // 2023-1-29 10:36:24 CGZ 入参增加multiType，传入"1"时显示阜外医院分院及北京市基层社区医院
        VisitPatientService.getOutRecordHospAuth($scope.vpId, "1").then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 向其他医疗机构共享本人病历
                $scope.selfHospitalAuthResult = data.data.selfAuth;
                // 院外病历授权总开关
                $scope.outHospitalAuthResult = data.data.totalAuth;
                // 院外病历授权医院
                $scope.outRecordHosp = data.data.hospAuth;

                // 2023-1-29 10:36:24 CGZ 增加HOSPITAL_TYPE，用于增加阜外医院分院及北京市基层社区医院分类
                // 北京市电子病历共享医院
                $scope.outRecordHospNo = data.data.hospAuth.filter(item => item.HOSPITAL_TYPE == "1");
                // 阜外医院分院
                $scope.hospitalBranch = data.data.hospAuth.filter(item => item.HOSPITAL_TYPE == "2");
                // 北京市基层社区医院
                $scope.communityHospital = data.data.hospAuth.filter(item => item.HOSPITAL_TYPE == "3");

                // 2021-5-15 14:10:01 获取外院诊疗医院列表 有则排序 报错或超时不影响流程
                RequestService.getOutRecordHosp($scope.vpId).then(function (data) {
                    //console.log(data);
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        // 添加存在外院病历标记
                        for (var i in data.data) {
                            var hospHasRecord = $scope.outRecordHosp.filter(e => e.HOSPITAL_CODE == data.data[i].ORG_ID);
                            if (hospHasRecord.length > 0) {
                                hospHasRecord[0].HAS_RECORD = true;
                            }
                        }
                    }
                    console.log($scope.outRecordHosp);
                    // 开启院外病历授权模态窗口
                    $scope.outHospitalAuthModal.show();
                }, function (data) {
                    $ionicLoading.hide();
                    // 开启院外病历授权模态窗口
                    $scope.outHospitalAuthModal.show();
                })
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常，请稍后重试');
        });
    }

    // 2021-5-20 09:45:33 袁老师指示 默认折叠无就诊记录医院 可点击展开授权
    $scope.toggleAuthHospNoVisitShow = function () {
        $scope.outRecordHospNoVisitShow = !$scope.outRecordHospNoVisitShow;
        $ionicScrollDelegate.resize();
    }

    $scope.toggleAuthHospitalBranchShow = function () {
        $scope.hospitalBranchShow = !$scope.hospitalBranchShow;
        $ionicScrollDelegate.resize();
    }

    $scope.toggleAuthCommunityHospitalShow = function () {
        $scope.communityHospitalShow = !$scope.communityHospitalShow;
        $ionicScrollDelegate.resize();
    }

    // 切换外院病历授权医院授权状态
    $scope.toggleAuthHosp = function (hospCode) {
        if (hospCode == null || hospCode == '') {
            $fwCordovaToast.showShortBottom('未找到指定医院，请稍后重试');
            return;
        }
        var hospSelected = $scope.outRecordHosp.filter(e => e.HOSPITAL_CODE == hospCode);
        if (hospSelected.length > 0) {
            // 2021-5-16 14:40:43 改为点击保存或离开页面时保存
            hospSelected[0].AUTH_VALUE = !hospSelected[0].AUTH_VALUE;
        }
        else {
            $fwCordovaToast.showShortBottom('未找到指定医院，请稍后重试');
        }
    }

    // 同步院外病历医院授权状态
    $scope.syncOutRecordHospAuth = function (isManual) {
        if (isManual) {
            $ionicLoading.show();
        }

        // 获取全部授权医院 拼接待提交列表
        var authHospCodes = $scope.outRecordHosp.filter(e => e.AUTH_VALUE).map(e => e.HOSPITAL_CODE).join(',');

        // 2021-5-15 14:43:52 保存院外病历医院授权状态
        VisitPatientService.saveOutRecordHospAuth($scope.vpId, authHospCodes, $scope.outHospitalAuthResult ? "1" : "0", $scope.selfHospitalAuthResult ? "1" : "0").then(function (data) {
            // 保存成功
            if (data.result == 1) {
                // 同步至HIS
                RequestService.syncOutRecordHospAuth($scope.vpId).then(function (data) {
                    //console.log(data);
                    if (isManual) {
                        $ionicLoading.hide();
                        if (data.result == 1) {
                            $fwCordovaToast.showShortBottom('保存授权成功');
                        }
                        else {
                            $fwCordovaToast.showShortBottom('网络异常，请稍后重试');
                        }
                    }
                }, function (data) {
                    if (isManual) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom('网络异常，请稍后重试');
                    }
                })
            }
            // 保存失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom('网络异常，请稍后重试');
        });
    }

    $scope.OutHospitalAuthModalHide = function () {
        $scope.outRecordHospNoVisitShow = false;
        // 2023-1-30 08:41:15 CGZ 阜外医院分院和北京市基层社区医院默认展开
        $scope.hospitalBranchShow = true;
        $scope.communityHospitalShow = true;
        $ionicScrollDelegate.resize();
        $scope.outHospitalAuthModal.hide();
        $scope.syncOutRecordHospAuth(false);
    }

    $scope.authSelfChange = function () {
        $scope.selfHospitalAuthResult = !$scope.selfHospitalAuthResult;
        $scope.syncOutRecordHospAuth(true);
    }

    $scope.authToggleChange = function () {
        if ($scope.outHospitalAuthResult) {
            $scope.outRecordAuth(false);
        } else {
            var confirmAuth = $ionicPopup.confirm({
                title: "院外病历授权",
                template: "诊疗期间，您是否同意医务人员使用当前就诊人在外院产生的诊疗信息？",
                okText: "同意授权",
                cancelText: '取消'
            });
            confirmAuth.then(function (res) {
                if (res) {
                    $scope.outRecordAuth(true);
                }
            })
        }
    }

    $scope.outRecordAuth = function (auth) {
        $ionicLoading.show();
        RequestService.outRecordAuth($scope.vpId, auth).then(function (data) {
            console.log(data);
            $ionicLoading.hide();

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom('未找到相应的患者信息');
                return;
            }

            if (auth) {
                $fwCordovaToast.showShortBottom('授权成功');
            } else {
                $fwCordovaToast.showShortBottom('取消授权成功');
            }

            VisitPatientService.outRecordAuth($scope.vpId, auth).then(function (data) { });

            $scope.outHospitalAuthResult = auth;
        })
    }
    //#endregion

    //#region 电子就诊卡相关 2018.11.26

    // 已绑卡 => 拥有电子卡 => 显示
    $scope.getECardInfo = function (vpid, cardNum) {
        // 二维码
        VisitPatientService.onlineQRCardInfo(vpid, cardNum).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.qrCodeSrc = "data:image/jpeg;base64," + data.data;
            }
        })
        // 条形码
        VisitPatientService.onlineCardInfo(vpid, cardNum).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.barCodeSrc = "data:image/jpeg;base64," + data.data;
            }
        })
    }

    // 2018.12.29 检查就诊卡状态
    $scope.checkPatientCardStatus = function () {
        // 1 => 已绑卡 => 拥有电子卡 => 显示
        if ($scope.vpInfo.IS_BIND_CARD == '1') {
            // 有卡 显示
            if ($scope.vpInfo.ECARD_STATUS == '1') {
                $scope.ECardDetailShow();
            }
            // 无卡 开通
            else if ($scope.vpInfo.ECARD_STATUS == null || $scope.vpInfo.ECARD_STATUS == '0' || $scope.vpInfo.ECARD_STATUS == '2') {
                $scope.GetReservedPhone($scope.vpInfo.VISIT_PATIENT_ID);
            }
            else if ($scope.vpInfo.ECARD_STATUS == '9') {
                $fwCordovaToast.showShortBottom('请前往门诊大厅激活电子卡');
            }
        }
        // 3 => 3/4绑卡 => 短信验证
        else if ($scope.vpInfo.IS_BIND_CARD == '3') {
            $scope.GetReservedPhone($scope.vpInfo.VISIT_PATIENT_ID);
        }
        // 4 => 未激活
        else {
            $fwCordovaToast.showShortBottom('请前往自助机激活就诊卡');
        }
    }

    // 电子就诊卡_详细页 显示与隐藏
    $scope.ECardDetailShow = function () {
        $scope.ECardDetailModal.show();

    }
    $scope.ECardDetailHide = function () {
        $scope.ECardDetailModal.hide();
        $ionicScrollDelegate.scrollTop();
    }
    // 电子就诊卡_开通页 显示与隐藏     2018.12.29 现用于3/4绑卡 => 已绑卡
    $scope.ECardApplyShow = function () {
        if ($scope.ECardFlag == 'false') {
            $fwCordovaToast.showShortBottom('暂停开通电子就诊卡');
        }
        else {
            $scope.getImageVericode();
            $scope.ECardApplyModal.show();
        }
    }
    $scope.ECardApplyHide = function () {
        $scope.ECardApplyModal.hide();
        $scope.timespan = 0;
        $scope.ECard = {
            phoneNum: null,
            phoneNumShow: null,
            messageVericode: '',
            imageVericode: ''
        }
    }
    // 2021-4-22 20:07:58 电子就诊卡只显示条形码或二维码 避免同时出现两种码扫码窗扫不出来
    // 切换显示码类型
    $scope.switchShowCodeType = function () {
        if ($scope.showCodeType == 'bar') {
            $scope.showCodeType = 'qr';
        }
        else {
            $scope.showCodeType = 'bar';
        }
    }

    // 获取 开电子卡/开卡 标识
    $scope.loadFlag = function () {
        VisitPatientService.getECardFlag().then(function (data) {
            console.log(data);
            if (data.result == 1) {
                $scope.ECardFlag = data.ECardFlag;
                $scope.applyCardFlag = data.applyCardFlag;
            }
        })
    }

    // 电子就诊卡_开通中 获取预留电话
    $scope.GetReservedPhone = function (vpid) {
        $ionicLoading.show();
        RequestService.GetReservedPhone(vpid).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            var phone = data.data[0].PHONENUM;
            $scope.ECard.phoneNum = phone;
            $scope.ECard.phoneNumShow = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
            $scope.ECardApplyShow();
        });
    }

    // 开电子卡 IS_BIND_CARD=1 =>验证码:8    =>只验证 IS_BIND_CARD=3 =>验证码:9
    $scope.toGetMsgVericode = function () {
        if ($scope.vpInfo.IS_BIND_CARD == '1') {
            $scope.getMsgVericode($scope.ECard.phoneNum, '8', $scope.ECard.imageVericode);
        }
        else if ($scope.vpInfo.IS_BIND_CARD == '3') {
            $scope.getMsgVericode($scope.ECard.phoneNum, '9', $scope.ECard.imageVericode);
        }
        else {
            $fwCordovaToast.showShortBottom('绑卡状态错误');
        }
    }

    // 2018.1.8 获取短信验证码 带参数
    $scope.getMsgVericode = function (phoneNum, num, imgVericode) {
        AccountService.sendVericodeByPhone(phoneNum, num, imgVericode).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");

                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            else {
                $scope.getImageVericode();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    }

    // 2018.12.29 绑卡验证(原电子卡开通) 
    $scope.applyECard = function () {
        if ($scope.ECard.phoneNum == '' || $scope.ECard.imageVericode == '' || $scope.ECard.messageVericode == '') {
            $fwCordovaToast.showShortBottom('请完整填写绑卡验证信息');
            return false;
        }
        // 开电子卡 => IS_BIND_CARD == '1' (ECARD_STATUS = null、0、2)
        if ($scope.vpInfo.IS_BIND_CARD == '1') {
            VisitPatientService.applyECard($scope.vpInfo.VISIT_PATIENT_ID, $scope.ECard.phoneNum, $scope.ECard.messageVericode).then(function (data) {
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    $scope.loadVpInfo();
                    $scope.ECardApplyHide();
                    $fwCordovaToast.showShortBottom('电子卡开通成功');
                }
            })
        }
        // 只验证 => IS_BIND_CARD == '3'
        else if ($scope.vpInfo.IS_BIND_CARD == '3') {
            VisitPatientService.bindPatientCardOlAchieve($scope.vpInfo.VISIT_PATIENT_ID, $scope.ECard.phoneNum, $scope.ECard.messageVericode).then(function (data) {
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                } else {
                    $scope.loadVpInfo();
                    $scope.ECardApplyHide();
                    $fwCordovaToast.showShortBottom('就诊卡验证成功');
                }
            })
        }
    }

    // 只代码保留 没有使用 
    // 绑定就诊卡_检查办卡状态
    $scope.checkBindCard = function (vpid) {
        $ionicLoading.show();
        // 获取办卡状态
        OpRegService.checkCardBuilt(vpid).then(function (data) {
            if (data.result == 1) {
                // 没有就诊卡
                if (data.is_null == 1) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("患者无就诊卡，无法绑定");
                }
                // 有就诊卡 单卡状态
                else if (data.is_null == 0) {
                    console.log('单卡');
                    $ionicLoading.hide();
                    // 绑就诊卡页面
                    $scope.bindCardModalShow();
                }
                // 有就诊卡 多卡状态
                else if (data.is_null == 2) {
                    console.log("多卡");
                    $ionicLoading.hide();
                    //绑就诊卡页面
                    $scope.bindCardModalShow();
                }
                // 其他状态(出错)
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                }
            }
            // 获取办卡状态 错误
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误,请稍后重试");
            }

        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    //#endregion

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 未完成
    $scope.notFinished = function () {
        $fwCordovaToast.showShortBottom("敬请期待");
    }



    // 新增 选卡部分
    $scope.chooseCardModalShow = function () {
        $scope.chooseCardModal.show();
    }
    $scope.chooseCardModalHide = function () {
        $scope.chooseCardModal.hide();
    }


    // 新增 建立就诊卡部分
    // 显示
    $scope.applyCardShow = function () {
        $scope.applyCardModal.show();
    }
    // 隐藏
    $scope.applyCardHide = function () {
        $scope.applyCardModal.hide();
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '',
            insurance_type: 0,
            mi_patient_code: '',
            marital: 0
        }
    }

    // 20200302 新增 把getPhoneAndCardNum提出来
    $scope.getPhoneAndCardNum = function (requestId, vpid, his_card_num, isLastStepSelectCard) {
        VisitPatientService.getPhoneAndCardNum(requestId, vpid, his_card_num).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 1) {
                // 拿到了手机号+卡号
                var phone = result.phone_num;
                var card_num = result.card_num;

                if (phone == "" || card_num == "") {
                    $fwCordovaToast.showShortBottom("未能获取您的预留手机号，请前往窗口进行办理");
                }
                else {
                    // 手机号
                    $scope.vpBind.phone_num = phone;
                    // 卡号
                    $scope.vpBind.card_num = card_num;

                    // 带*手机号
                    $scope.vpBind.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
                    // 带*卡号
                    $scope.vpBind.card_num_show = result.card_num_show;

                    $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;

                    // 获取图片验证码
                    $scope.getImageVericode();
                    $fwCordovaToast.showShortBottom("填写正确图片验证码、点击获取验证码后，我们将发送验证码至您的预留手机号");

                    // 上一步是选卡
                    if (isLastStepSelectCard) {
                        $scope.lastSelectCard = true;
                        // 选卡模态窗关闭
                        $scope.chooseCardModalHide();
                    }

                    $scope.bindCardModal.show();
                }
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误，请稍后再试");
            }
        })
    }


    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        //var uri = encodeURI("http://10.10.101.11:8080/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        // 显示上传等待
        $ionicLoading.show();
        // 上传图片
        //$fwCordovaToast.showShortBottom(uri);
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            //$cordovaToast.showLongBottom(angular.toJson(result));
            //console.log(result);
            //console.log(result.response);
            var fileResult = {};
            eval("fileResult = " + result.response);
            $ionicLoading.hide();
            // 上传成功
            if (fileResult.result == 1) {
                $fwCordovaToast.showShortBottom("上传成功");
                // 头像面
                if (type == 0) {
                    $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                }
                // 国徽面
                else if (type == 1) {
                    $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                }
                // 户口簿
                else if (type == 2) {
                    $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                }
            }
            // 上传失败
            else {
                $fwCordovaToast.showShortBottom(fileResult.msg);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }

    // 删除身份证照片
    $scope.deleteImg = function (type) {
        // confirm
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }

    $scope.MICodeHelpModalShow = function () {
        $scope.MICodeHelpModal.show();
    }
    $scope.MICodeHelpModalHide = function () {
        $scope.MICodeHelpModal.hide();
    }

    $scope.temperatureShow = function () {
        var data = {
            vpId: $scope.vpId,
            from: "visitPatient",
            step: ""
        };
        $scope.$broadcast("temperatureShow", data);
        $scope.temperatureModal.show();
    }
    $scope.temperatureHide = function () {
        $scope.temperatureModal.hide();
    }
    $scope.$on('temperatureHide', function () {
        $scope.temperatureHide();
        // 判断是否进黑名单
        VisitPatientService.EpidemiolSrvyToTemperature($scope.vpId, "2").then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                // 2020-11-12 09:59:49 HM 这里提示没用，反而到觉得不太好了。
                // $fwCordovaToast.showShortBottom(result.msg);
            }
        }, function (resp) {
            var alertPopup = $ionicPopup.alert({
                title: '网络错误',
                template: '加载失败,请检查网络'
            });
            $ionicLoading.hide();
        });
    });

    // 医保绑卡模态框展示
    $scope.YBBindCardShow = function () {
        $scope.YBBindCardModal.show();
    }

    // 医保绑卡模态框隐藏
    $scope.YBBindCardHide = function () {
        $scope.YBBindCardModal.hide();
    }

    // 跳转对应小程序
    $scope.chooseYBType = function (type) {
        //var html = "<div>";
        //html += "<p>请选择支付方式</p>";

        //// 微信小程序
        //html += "<div style='display: flex;padding-bottom: 1em;'>";
        //html += "<div style='width: calc(100% - 4em)'>微信小程序</div>";
        //html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
        //html += "<button class='button button-small button-calm' ng-click='ybMiniProgram(\"wx\", \"" + type + "\");' style='max-height: 4em;line-height: 1.5em;'>";
        //html += "<span style='font-size:14px;'>跳转</span>";
        //html += "</button>";
        //html += "</div>";
        //html += "</div>";

        //// 支付宝小程序
        //html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;'>";
        //html += "<div style='width: calc(100% - 4em)'>支付宝小程序</div>";
        //html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
        //html += "<button class='button button-small button-calm' ng-click='ybMiniProgram(\"zfb\", \"" + type + "\");' style='max-height: 4em;line-height: 1.5em;'>";
        //html += "<span style='font-size:14px;'>跳转</span>";
        //html += "</button>";
        //html += "</div>";
        //html += "</div>";

        //html += "</div>";

        //$scope.confirmPopup = $ionicPopup.alert({
        //    title: "提示",
        //    template: html,
        //    buttons: [
        //        {
        //            text: "取消",
        //            onTap: function (e) { }
        //        }
        //    ],
        //    scope: $scope
        //});

        // 2023-10-18 16:08:01 HM 目前仅支持支付宝小程序，之后微信小程序发布后，可进行兼容
        $scope.ybMiniProgram('zfb', type);
    }

    // 跳转小程序
    $scope.ybMiniProgram = function (miniProgram, type) {
        $ionicLoading.show();
        OpPaymentService.ybBindCard(type, $scope.vpId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 跳转小程序的路径url
                var pageUrl = data.url;

                if (miniProgram == "zfb") {
                    // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
                    var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent(pageUrl));

                    //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                    //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
                    //2023.7.31 新插件原有调用方式参数不生效
                    showInAppBrowser(herfUrl, '_system');

                    // var param = { type: "BJYB", url: pageUrl };

                    // var funcSuccess = function (data) {
                    //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用成功");
                    //     console.log(data);
                    // }
                    // var funcError = function (data) {
                    //     console.log("MiniProgramPlugin：launchZFBMiniProgramByPageUrl 调用失败");
                    //     console.log(data);
                    // }

                    // window.plugins.MiniProgramPlugin.launchZFBMiniProgramByPageUrl(param, funcSuccess, funcError);
                }
                else {
                    $fwCordovaToast.showShortBottom("暂不支持微信小程序");
                }
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
        })
    }

    // 放弃lis和check，都走report
    $scope.goReport = function (type) {
        $state.go("app.report", { vpid: $scope.vpId, type: type });
    }

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        // 读取就诊人信息
        $scope.loadVpInfo();
        // 读取就诊人列表
        $scope.loadVpList();
        // 获取用户信息
        AccountService.accountInfo().then(function (data) {
            if (data.result == 1) {
                $scope.accountInfo = data.data;
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
        // 获取开电子卡/开卡 标识
        $scope.loadFlag();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();
    });

    // 进入（执行多次）
    $scope.$on('$ionicView.enter', function () {
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'visitPatient');
    });

    // 退出
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'visitPatient') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
