﻿angular.module('fwapp.controllers')

.controller('VisitPatientMainController', function ($scope, $state, $stateParams, $ionicPopup, $ionicModal, $ionicLoading,
    AccountService, VisitPatientService, RequestService, $cordovaToast) {
    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人绑卡模型
    $scope.vpBind = {
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: ''
    }
    // 获取验证码倒计时
    $scope.timespan = 0;

    // 注册模态窗口:绑定就诊卡
    $ionicModal.fromTemplateUrl('bind_card.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $cordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    // #region 绑定就诊卡相关

    // 绑卡模态窗口显示
    $scope.bindCardModalShow = function () {
        $scope.vpBind.name = $scope.vpInfo.VISIT_PATIENT_NAME;
        $scope.bindCardModal.show();
    }

    // 绑卡模态窗口隐藏
    $scope.bindCardModalHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: ''
        }
    }

    // 绑卡提交
    $scope.bindCardSubmit = function () {
        VisitPatientService.bindVisitPatient(localStorage.currentAccountId, $scope.vpId, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code).then(function (data) {
            if (data.result == 0) {
                $cordovaToast.showShortBottom(data.msg);
            } else {
                $scope.bindCardModalHide();     // 隐藏绑定页面
                $scope.loadVPInfo();            // 重新获取患者信息
                $cordovaToast.showShortBottom("就诊卡绑定成功");
            }
        })
    }

    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        $ionicLoading.show();
        RequestService.checkPatientCard(localStorage.currentAccountId, $scope.vpId, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $cordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $cordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $cordovaToast.showShortBottom(data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        });
    }

    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5').then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                var alertPopup = $ionicPopup.alert({
                    title: '短信验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '短信验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // #endregion

    $scope.goLis = function () {
        if(true){
        }
    }

    $scope.loadVPInfo();
})