angular.module('fwapp.controllers')

// 账号注销
.controller('WriteOffAccountController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
    , $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
    , $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
    , ConsultationService, RequestService, OlTreatRecipeService, ExpressService, AccountService) {
    
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 手机号
    $scope.phoneNum = "";
    // 初始化信息
    $scope.data = new Object();
    $scope.data.imageVericode = "";
    $scope.data.vericode = "";
    $scope.data.accountCode = "";
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 防止多次获取验证码
    $scope.disableGetVericode = false;
    // 验证码发送时间间隔
    $scope.timespan = 0;
    // 提示文字
    $scope.writeOffInfo = "";
    $scope.writeOffSecondInfo = "";

    // 1.先获取当前手机号
    $scope.getPhoneNum = function () {
        $ionicLoading.show();
        AccountService.accountInfo().then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result != 1){
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                if (data.data.PHONENUM == ""){
                    $ionicPopup.alert({
                        title: '提示',
                        template: "网络错误，请稍后重试",
                        okText: "确定"
                    });
                }
                else {
                    $scope.data.accountCode = data.data.PHONENUM;
                    // 脱敏处理
                    $scope.phoneNum = data.data.PHONENUM.substring(0, 3) + "****" + data.data.PHONENUM.substring(7);
                    console.log($scope.data.accountCode);
                }
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.data.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 获取验证码
    $scope.getVericode = function (usage) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 验证图片验证码
        if ($scope.data.imageVericode == null || $scope.data.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空',
                okText: "确定"
            });
            return;
        }

        // 验证手机号
        if ($scope.data.accountCode == null || $scope.data.accountCode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '手机号不得为空',
                okText: "确定"
            });
            return;
        }
        console.log(usage);
        
        $scope.disableGetVericode = true;
        AccountService.sendVericodeByPhone($scope.data.accountCode, usage, $scope.data.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg,
                    okText: "确定"
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试',
                    okText: "确定"
                });
            }
            $scope.disableGetVericode = false;
        })
    };

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };

    // 获取注销文字提示
    $scope.getWriteOffInfo = function () {
        AccountService.getWriteOffInfo().then(function (data) {
            if (data.result == "1"){
                $scope.writeOffInfo = data.data.writeOffInfo;
                $scope.writeOffSecondInfo = data.data.writeOffSecondInfo;
            }
        })
    }

    // 注销确认！！
    $scope.writeOffConfirm = function () {
        // 验证图片验证码
        if ($scope.data.imageVericode == null || $scope.data.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空',
                okText: "确定"
            });
            return;
        }

        // 验证手机号
        if ($scope.data.accountCode == null || $scope.data.accountCode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '手机号不得为空',
                okText: "确定"
            });
            return;
        }

        $ionicPopup.confirm({
            title: "提示",
            template: $scope.writeOffSecondInfo,
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $scope.writeOff();
                console.log("注销了");
            }
        })
    }

    // 注销！！
    $scope.writeOff = function () {
        // 验证短信验证码
        $ionicLoading.show();
        AccountService.compareVericode(localStorage.currentAccountId, $scope.data.vericode, currentPlatform, deviceToken, "12").then(function (data) {
            if (data.result == 1) {
                AccountService.writeOffAccount(localStorage.currentAccountId).then(function (result) {
                    if (result.result == "1"){
                        $ionicLoading.hide();
                        // 删除用户信息
                        localStorage.hasLogin = 0;
                        $rootScope.hasLogin = 0;
                        localStorage.currentAccountId = "";
                        localStorage.queryToken = "";
                        $rootScope.currentAccountId = "";
                        // 初始化一下消息中心提示
                        // 是否有未读消息
                        $rootScope.hasUnread = false;
                        $rootScope.unReadCount = 0;

                        $ionicPopup.alert({
                            title: '提示',
                            template: result.data,
                            okText: "确定"
                        }).then(function (res) {
                            // 跳转到首页
                            $state.go('app.home');
                        });
                    }
                    else {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: '提示',
                            template: result.msg,
                            okText: "确定"
                        });
                    }
                }, function () {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: '提示',
                        template: "网络错误，请稍后重试",
                        okText: "确定"
                    });
                })
            }
            else {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg,
                    okText: "确定"
                });
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 返回
    $scope.goBack = function () {
        $state.go("app.securityCenter");
    }

    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'writeOffAccount');

        $scope.getPhoneNum();
        $scope.getImageVericode();
        $scope.getWriteOffInfo();
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'writeOffAccount') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
});