﻿// 对Date的扩展，将 Date 转化为指定格式的String   
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，   
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)   
// 例子：   
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423   
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
Date.prototype.Format = function (fmt) {
    var Week = ['日', '一', '二', '三', '四', '五', '六'];
    var o = {
        "M+": this.getMonth() + 1,                 //月份   
        "d+": this.getDate(),                    //日   
        "h+": this.getHours(),                   //小时   
        "m+": this.getMinutes(),                 //分   
        "s+": this.getSeconds(),                 //秒   
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度   
        "S": this.getMilliseconds(),             //毫秒   
        "w": Week[this.getDay()]               //星期
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

Date.prototype.AddMonths = function (months) {
    var year = this.getYear();
    var month = this.getMonth();
    var date = this.getDate();
    for (var i = 0; i < Math.abs(months); i++) {
        if (month > 0) {
            month = month + 1;
            if (month == 12) {

            }
        }
    }
}

// 2016-7-20 08:58:49 根据生日计算年龄
// 满一岁 返回year
// 不满一岁 满一月 返回month/12
// 不满一月 返回day/365(366)
Date.prototype.GetAge = function () {
    var now = new Date();
    // 未来
    if (this > now) {
        return 'future';
    }
    // 闰年判断
    var nowYear = now.getFullYear();
    var run = (0 == nowYear % 4 && 0 != nowYear % 100) || 0 == nowYear % 400;
    // 上月天数
    var nowMonth = now.getMonth() + 1;
    var daysLastMonth;
    if (2 == nowMonth || 4 == nowMonth || 6 == nowMonth || 8 == nowMonth || 9 == nowMonth || 11 == nowMonth || 1 == nowMonth) {
        daysLastMonth = 31;
    }
    else if (5 == nowMonth || 7 == nowMonth || 10 == nowMonth || 12 == nowMonth) {
        daysLastMonth = 30;
    }
    else if (run) {
        daysLastMonth = 29;
    }
    else {
        daysLastMonth = 28;
    }
    var deltaYear = now.getFullYear() - this.getFullYear();
    var deltaMonth = now.getMonth() - this.getMonth();
    var deltaDay = now.getDate() - this.getDate();
    if (deltaDay < 0) {
        deltaDay += daysLastMonth;
        deltaMonth--;
    }
    if (deltaMonth < 0) {
        deltaMonth += 12;
        deltaYear--;
    }
    // 满一岁
    if (deltaYear >= 1) {
        return deltaYear + '';
    }
    // 不满一岁 满一月
    if (deltaMonth >= 1) {
        return deltaMonth + '/12';
    }
    // 不满一月
    return deltaDay + '/' + (run ? '366' : '365');
}