﻿angular.module('fwapp.filters', [])

// 星期翻译
.filter('dayOfWeek', function () {
    return function (input) {
        switch (input.getDay()) {
            case 0:
                return "日";
            case 1:
                return "一";
            case 2:
                return "二";
            case 3:
                return "三";
            case 4:
                return "四";
            case 5:
                return "五";
            case 6:
                return "六";
            default:
                return "";
        }
    }
})

// 换行符替换
.filter('wrapTrans', function () {
    return function (input, separator) {
        if (input != undefined) {
            return input.split(separator).join('</br>')
        }
        return input;
    }
})

// HTML直接输出
.filter('trustHtml', function ($sce) {
    return function (input) {
        return $sce.trustAsHtml(input)
    }
})

// 高亮显示
.filter('highLight', function () {
    return function (input) {
        input = input.replace(new RegExp('<h>', 'gm'), '<font class="positive">');
        input = input.replace(new RegExp('</h>', 'gm'), '</font>');
        return input;
    }
})

// 后缀添加
.filter('suffix', function () {
    return function (input, suffix, isadd) {
        if (isadd) {
            return input + suffix;
        }
        return input;
    }
})

// 日期格式化
.filter('datePlus', function () {
    return function (input, format) {
        if (input == undefined) {
            return input;
        }
        if (isNaN(new Date(input.replace(/-/g, "/")).getDate())) {
            return input;
        }
        else {
            return (new Date(input.replace(/-/g, "/"))).Format(format);
        }
    }
})