﻿angular.module('fwapp.services')

// 
.service('AccountService', function ($q, $http, BaseService) {
    return {
        // 登录
        login: function (accountCode, password) {
            return BaseService.post("/Account/Login", { accountCode: accountCode, password: jsencrypt.encrypt(password) });
        },
        // 手机号一键登录
        loginRequestMobile: function (token) {
            return BaseService.post("/Account/LoginRequestMobile", { token: token });
        },
        // 短信验证码登录
        loginShortMessage: function (accountCode, vericode) {
            return BaseService.post("/Account/LoginShortMessage", { accountCode: accountCode, vericode: vericode });
        },
        // 注销
        logout: function () {
            return BaseService.post("/Account/Logout");
        },
        // 注册
        register: function (phoneNum, password, vericode) {
            return BaseService.post("/Account/Register", { phoneNum: phoneNum, password: jsencrypt.encrypt(password), vericode: jsencrypt.encrypt(vericode) });
        },
        // 用用户ID获取验证码
        sendVericodeById: function (accountId, usage, imageVericode) {
            // 2023-10-25 17:04:12 CGZ #hzfwx-313 图片验证码文本存入数据库中，适配由于SameSite策略导致无法存入cookie的Android8及iOS12以下设备，增加入参
            return BaseService.post("/Account/SendVericodeById", { accountId: accountId, usage: usage, imageVericode: jsencrypt.encrypt(imageVericode), imageVericodeId: typeof (window.imageVericodeId) == "undefined" ? "" : window.imageVericodeId });
        },
        // 用电话号码获取验证码
        sendVericodeByPhone: function (phoneNum, usage, imageVericode) {
            // 2023-10-25 17:04:12 CGZ #hzfwx-313 图片验证码文本存入数据库中，适配由于SameSite策略导致无法存入cookie的Android8及iOS12以下设备，增加入参
            return BaseService.post("/Account/SendVericodeByPhone", { phoneNum: phoneNum, usage: usage, imageVericode: jsencrypt.encrypt(imageVericode), imageVericodeId: typeof (window.imageVericodeId) == "undefined" ? "" : window.imageVericodeId });
        },
        // 比对验证码
        compareVericode: function (accountId, vericode, platform, targetcode, usage) {
            return BaseService.post("/Account/CompareVericode", { accountId: accountId, vericode: jsencrypt.encrypt(vericode), platform: platform, targetcode: targetcode, usage: usage });
        },
        // 获取用户信息
        accountInfo: function () {
            return BaseService.post("/Account/AccountInfo");
        },
        // 检查查询密码
        checkQueryPassword: function (accountId, pwd, token) {
            return BaseService.post("/Account/CheckQueryPassword", { accountId: accountId, queryPwd: jsencrypt.encrypt(pwd), token: token });
        },
        // 设置查询密码
        setQueryPassword: function (oldpwd, newpwd) {
            return BaseService.post("/Account/SetQueryPassword", { oldpwd: jsencrypt.encrypt(oldpwd), newpwd: jsencrypt.encrypt(newpwd) });
        },
        // 验证查询TOKEN
        checkQueryToken: function (token) {
            return BaseService.post("/Account/CheckQueryToken", { token: token });
        },
        // 检查登录状态
        checkLogin: function () {
            return BaseService.post("/Account/CheckLogin");
        },
        // 检查登录状态
        checkInHospital: function () {
            return BaseService.post("/Account/CheckInHospital");
        },
        // 获取水印
        getWatermark: function () {
            return BaseService.post("/Account/GetWatermark");
        },
        // 获取图片验证码
        getImageVericode: function () {
            // 2023-10-25 17:04:12 CGZ #hzfwx-313 图片验证码文本存入数据库中，适配由于SameSite策略导致无法存入cookie的Android8及iOS12以下设备，增加入参
            return BaseService.post("/Account/GetImageVericode", { saveMethod: "DB" });
        },
        // 获取密码强度限制
        getPasswordLevelLimit: function () {
            return BaseService.post("/Account/GetPasswordLevelLimit");
        },
        // 获取注销提示文字
        getWriteOffInfo: function () {
            return BaseService.post("/Account/GetWriteOffInfo");
        },
        // 注销账号
        writeOffAccount: function (accountId) {
            return BaseService.post("/Account/WriteOffAccount", { accountId: accountId });
        }
    }
})