﻿angular.module('fwapp.services')

// 
.service('AddWishService', function ($q, $http, BaseService) {
    return {
        // 获取预约申请列表
        wishlist: function (accountId) {
            return BaseService.post("/Appt/Wishlist", { accountId: accountId });
        },
        // 获取预约申请步骤
        addWishSteps: function () {
            return BaseService.post("/Appt/AddWishSteps");
        },
        // 获取用户须知信息
        agreement: function () {
            return BaseService.post("/Appt/Agreement");
        },
        // 获取预约时段
        schedDateList: function () {
            return BaseService.post("/Appt/SchedDateList", { halfday: true });
        },
        // 获取预约时段
        schedTimeList: function () {
            return BaseService.post("/Appt/SchedTimeList");
        },
        // 获取医师级别
        doctorLevelList: function () {
            return BaseService.post("/Appt/DoctorLevelList");
        },
        // 预约医师提示
        apptDoctorTips: function () {
            return BaseService.post("/Appt/ApptDoctorTips");
        },
        // 获取可约医生列表 给预约申请用的 isAll=0
        scheduling: function (division, schedDate, schedTime) {
            return BaseService.post("/Scheduling/GetDivisionScheduling", { divisionCode: division, schedDate: schedDate, schedTime: schedTime, isAll: 0 });
        },
        // 根据opInfoId获取预约信息
        opInfo: function (opInfoId) {
            return BaseService.post("/Appt/OpInfo", { opInfoId: opInfoId });
        },
        // 添加预约申请(已废弃)
        addWish: function (type, vpId, opInfoId, schedDate, schedTime, division, doctorLevel) {
            return BaseService.post("/Appt/SubmitAppt", { type: type, vpId: vpId, opInfoId: opInfoId, schedDate: schedDate, schedTime: schedTime, division: division, doctorLevel: doctorLevel });
        },
        // 提交预约申请
        submitAppt: function (type, vpId, opInfoId, schedDate, schedTime, division, doctorLevel) {
            return BaseService.post("/Appt/SubmitAppt", { type: type, vpId: vpId, opInfoId: opInfoId, schedDate: schedDate, schedTime: schedTime, division: division, doctorLevel: doctorLevel });
        },
        // 确认对应时段 拿id换opInfoId
        getPeriod: function (id) {
            return BaseService.post("/Appt/GetPeriod", { id: id });
        },
        // 查询症状信息填写状态
        checkApptComplaint: function (vpId) {
            return BaseService.post("/Appt/CheckApptComplaint", { vpId: vpId });
        },
        // 填写症状信息
        addApptComplaint: function (vpId, complaint) {
            return BaseService.post("/Appt/AddApptComplaint", { vpId: vpId, symptom: complaint });
        },
        // 提交黑名单申诉
        submitBlackComplaint: function (vpId, complaintInfo) {
            return BaseService.post("/Appt/SubmitBlackComplaint", { vpId: vpId, complaintInfo: complaintInfo });
        }
    }
})