﻿angular.module('fwapp.services')

.service('AutoInquiryService', function ($q, $http, BaseService) {
    return {
        nextQSTNInfo: function (qstn, result, vpId, autoId, apptVericode) {
            return BaseService.post("/AutoInquiry/NextQSTNInfo",
            { qstn: qstn, result: result, vpId: vpId, autoId: autoId, apptVericode: apptVericode });
        },
        getAllRec: function (vpId, autoId) {
            return BaseService.post("/AutoInquiry/GetAllRec", { vpId: vpId, autoId: autoId });
        },
        getAutoInquiryId: function (vpId) {
            return BaseService.post("/AutoInquiry/GetAutoInquiryId", { vpId: vpId });
        },
        submitReportImg: function (vpId, autoId, imgInfoStr) {
            return BaseService.post("/AutoInquiry/SubmitReportImg", { vpId: vpId, autoId: autoId, result: imgInfoStr });
        },
        deleteReportImg: function (imgId) {
            return BaseService.post("/AutoInquiry/DeleteReportImg", { imgId: imgId });
        },
        insertImgOCR: function (imgId) {
            return BaseService.post("/AutoInquiry/InsertImgOCR", { imgId: imgId });
        },
        feedBackList: function () {
            return BaseService.post("/AutoInquiry/FeedBackList", {});
        },
        getInquiryData: function (vpId, dialogueId, parameter, typeEntrance) {
            return BaseService.post("/AutoInquiry/GetInquiryData", { vpId: vpId, dialogueId: dialogueId, parameter: parameter, typeEntrance: typeEntrance });
        },
        getLastInquiryRecord: function (vpId) {
            return BaseService.post("/AutoInquiry/GetLastInquiryRecord", { vpId: vpId });
        },
        getLastAdvice: function (vpId) {
            return BaseService.post("/AutoInquiry/GetLastAdvice", { vpId: vpId });
        },
        getArticleContent: function (articleId, source) {
            return BaseService.post("/AutoInquiry/GetArticleContent", { articleId: articleId, source: source });
        },
        clickAdvicesDetail: function (vpId, dialogueId, detailId, detailName) {
            return BaseService.post("/AutoInquiry/ClickAdvicesDetail", { vpId: vpId, dialogueId: dialogueId, detailId: detailId, detailName: detailName });
        },
        getLastInquiryRecordNew: function (vpId) {
            return BaseService.post("/AutoInquiry/GetLastInquiryRecordNew", { vpId: vpId });
        },
        getGroupDetail: function (groupType, groupCode) {
            return BaseService.post("/AutoInquiry/GetGroupDetail", { groupType: groupType, groupCode: groupCode });
        },
        doctorList: function (groupType, groupCode) {
            return BaseService.post("/AutoInquiry/DoctorList", { groupType: groupType, groupCode: groupCode });
        },
        insertLog: function (vpId, logStr, infoId) {
            return BaseService.post("/AutoInquiry/InsertLog", { vpId: vpId, logStr: logStr, infoId: infoId });
        },
        doctorInfo: function (doctorCode) {
            return BaseService.post("/AutoInquiry/doctorInfo", { doctorCode: doctorCode });
        }
    }
})