﻿angular.module('fwapp.services')

.service('CasePrintService', function ($q, $http, BaseService) {
    return {
        // 获取回答
        caseAnswer: function (applyId) {
            return BaseService.post("/CasePrint/CaseAnswer", { applyId: applyId });
        },
        // 提交
        submit: function (applyId, casePrint) {
            return BaseService.post("/CasePrint/Submit", { applyId: applyId, casePrint: casePrint });
        },
        // 省
        getProvince: function () {
            return BaseService.post("/CasePrint/GetProvince", {});
        },
        // 市
        getCity: function (province) {
            return BaseService.post("/CasePrint/GetCity", { province: province });
        },
        // 县
        getCounty: function (city) {
            return BaseService.post("/CasePrint/GetCounty", { city: city });
        },
        // 计算费用
        calcPay: function (applyId) {
            return BaseService.post("/CasePrint/CalcPay", { applyId: applyId });
        },
        // 加载申请列表
        loadCaseList: function () {
            return BaseService.post("/CasePrint/LoadCaseList", {});
        },
        // 修改申请状态
        caseModify: function (modifyStatus, applyId) {
            return BaseService.post("/CasePrint/CaseModify", { modifyStatus: modifyStatus, applyId: applyId });
        },
        // 检查是否有待审核、未完成的申请
        checkHasApply: function () {
            return BaseService.post("/CasePrint/CheckHasApply", {});
        },
        // 待审核的申请 =>重填申请
        reApply: function (applyId) {
            return BaseService.post("/CasePrint/ReApply", { applyId: applyId });
        },
        // 查看邮递单号
        checkEmsCode: function (applyId) {
            return BaseService.post("/CasePrint/CheckEmsCode", { applyId: applyId });
        },
        // 查看邮递信息
        getEmsTrace: function (ems_code) {
            return BaseService.post("/CasePrint/GetEmsTrace", { ems_code: ems_code });
        },
        // 支付：下订单
        unifiedOrder: function (applyId, pay_method) {
            return BaseService.post("/CasePrint/UnifiedOrder", { applyId: applyId, pay_method: pay_method });
        },
        // 支付：验证HIS是否处理
        checkHisDealWithPay: function (applyId) {
            return BaseService.post("/CasePrint/CheckHisDealWithPay", { applyId: applyId });
        },
        // 图片：保存
        saveUrlDataBase: function (applyId, id, url) {
            return BaseService.post("/CasePrint/SaveUrlDataBase", { applyId: applyId, id: id, url: url });
        },
        // 图片：检查库图
        checkUrlHasLoad: function (applyId, relation) {
            return BaseService.post("/CasePrint/CheckUrlHasLoad", { applyId: applyId, relation: relation });
        },
        // 图片：删除
        detUrl: function (applyId, id) {
            return BaseService.post("/CasePrint/DetUrl", { applyId: applyId, id: id });
        },
        // 同意书
        getAgreeAlert: function () {
            return BaseService.post("/CasePrint/GetAgreeAlert", {});
        }
    }
})