﻿angular.module('fwapp.services')

// 核酸检测预约
.service('CoronavirusService', function ($q, $http, $timeout, BaseService) {
    return {
        // 获取配置信息
        getConfig: function () {
            return BaseService.post("/Coronavirus/GetConfig");
        },
        // 提交申请
        submitApply: function (vpId, checkDate, checkTime, checkAreaId, checkMode) {
            var deferred = $q.defer();
            // 异步等待通用方法
            function RespApply(deferred, requestId, applyId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/Coronavirus/SubmitApplyResp',
                        // 2022-1-19 15:09:37 HM 不用缴费，兼容旧版本app
                        data: { requestId: requestId, applyId: applyId, needPay: "0" },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 1) {
                            // 把applyId加上
                            data.APPLY_ID = applyId;
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 10) {
                                RespApply(deferred, requestId, applyId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }

            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/Coronavirus/SubmitApplyReq',
                data: { vpId: vpId, checkDate: checkDate, checkTime: checkTime, checkAreaId: checkAreaId, checkMode: checkMode, needPay: "0" },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == 1) {
                    RespApply(deferred, data.data.requestId, data.data.applyId, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取服务开启状态
        checkServerStatus: function () {
            return BaseService.post("/Coronavirus/CheckServerStatus");
        },
        // 获取申请列表
        getApplyList: function () {
            return BaseService.post("/Coronavirus/GetApplyList");
        },
        // 获取申请详情
        getApplyDetail: function (applyId) {
            var deferred = $q.defer();
            function WaitResponse(deferred, reqData, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/Request/GetResponse',
                        data: { requestId: reqData.data.REQUEST_ID },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 1) {
                            // reqData加上
                            data.reqData = reqData;
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                WaitResponse(deferred, reqData, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }

            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/Coronavirus/GetApplyDetail',
                data: { applyId: applyId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取支付时间限制
        getTimeLimit: function () {
            return BaseService.post("/Coronavirus/GetTimeLimit");
        },
        // 回库操作
        backLibiray: function () {
            return BaseService.post("/Coronavirus/BackLibiray");
        },
        // 取消申请
        cancelApply: function (applyId) {
            return BaseService.post("/Coronavirus/CancelApply", { applyId: applyId });
        }
    }
})