﻿angular.module('fwapp.services')

// 药品快递到家
.service('ExpressService', function ($q, $http, $timeout, BaseService) {
    return {
        // 获取配置
        getConfig: function (applyId) {
            return BaseService.post("/Express/GetConfig", { applyId: applyId });
        },
        // 添加收货地址
        updateAddress: function (receiverName, phoneNum, province, city, county, detailAddress, isDefault, expressAddressId, isDetele) {
            return BaseService.post("/Express/UpdateAddress", { receiverName: receiverName, phoneNum: phoneNum, province: province, city: city, county: county, detailAddress: detailAddress, isDefault: isDefault, expressAddressId: expressAddressId, isDetele: isDetele });
        },
        // 获取收货地址
        getAddressList: function () {
            return BaseService.post("/Express/GetAddressList");
        },
        // 获取待缴费列表
        getOpPending: function (applyId) {
            var deferred = $q.defer();

            function WaitResponse(deferred, requestId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + "/Request/RespOPPendingPayment",
                        data: { requestId: requestId, rlatObjType: "OL_TREAT_EXPRESS", bjybMobilePaymentStatus: "1" },
                        withCredentials: true
                    }).success(function (data, status) {
                        //console.log(data);
                        data.requestId = requestId;
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                console.log(requestId, count);
                                WaitResponse(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }

            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/Express/GetOpPendingReq',
                data: { applyId: applyId },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else if (data.result == -1) {
                    deferred.resolve(data);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 查询物流信息
        getOrderRoute: function (applyId) {
            return BaseService.post("/Express/GetOrderRoute", { applyId: applyId });
        },
        // 确认收货
        confirmExpress: function (applyId) {
            return BaseService.post("/Express/ConfirmExpress", { applyId: applyId });
        },
        // 提交快递信息
        submitExpress: function (applyId, vpId, expressAddressId, company, money, method) {
            return BaseService.post("/Express/SubmitExpress", { applyId: applyId, vpId: vpId, expressAddressId: expressAddressId, company: company, money: money, method: method });
        }
    }
})