﻿angular.module('fwapp.services')

.service('FlupService', function ($q, $http) {
    return {
        subjectList: function () {
            var deferred = $q.defer();
            $http.jsonp(serviceUrl + "/Flup/subjectList?callback=JSON_CALLBACK")
                .success(function (data, status) {
                    deferred.resolve(data);
                }).error(function (data, status) {
                    deferred.reject(data);
                });
            return deferred.promise;
        },
        items: function (tmplId) {
            var deferred = $q.defer();
            $http.jsonp(serviceUrl + "/Flup/Items?tmplId=" + tmplId + "&callback=JSON_CALLBACK")
                .success(function (data, status) {
                    deferred.resolve(data);
                }).error(function (data, status) {
                    deferred.reject(data);
                });
            return deferred.promise;
        },
        loadRecord: function (tmplId, subjectId) {
            var deferred = $q.defer();
            $http.jsonp(serviceUrl + "/Flup/LoadRecord?tmplId=" + tmplId + "&subjectId=" + subjectId + "&callback=JSON_CALLBACK")
                .success(function (data, status) {
                    deferred.resolve(data);
                }).error(function (data, status) {
                    deferred.reject(data);
                });
            return deferred.promise;
        },
        saveRecord: function (tmplId, subjectId, values) {
            var deferred = $q.defer();
            $http.jsonp(serviceUrl + "/Flup/SaveRecord?tmplId=" + tmplId + "&subjectId=" + subjectId + "&" + values + "&callback=JSON_CALLBACK")
                .success(function (data, status) {
                    deferred.resolve(data);
                }).error(function (data, status) {
                    deferred.reject(data);
                });
            return deferred.promise;
        }
    }
})