﻿angular.module('fwapp.services')

.service('flupSrvyService', function ($q, $http, $timeout, BaseService) {
    return {
        // 获取专病随访患者及任务信息
        getFlupPatient: function (vpId) {
            return BaseService.post("/FlupSrvy/GetFlupPatient");
        },
        // 获取膳食营养患者及任务信息
        getDRIFlupPatient: function (vpId) {
            return BaseService.post("/FlupSrvy/GetDRIFlupPatient", { vpId: vpId });
        },
        // 获取心律失常随访患者及任务信息
        getAFFlupPatient: function (vpId) {
            return BaseService.post("/FlupSrvy/GetAFFlupPatient", { vpId: vpId });
        },
        // 患者加入专病随访
        joinFlup: function (patientId, isJoinFlup) {
            return BaseService.post("/FlupSrvy/JoinFlup", { patientId: patientId, isJoinFlup: isJoinFlup });
        },
        // 患者加入膳食营养专病随访
        DRIjoinFlup: function (patientId, isJoinFlup) {
            return BaseService.post("/FlupSrvy/DRIJoinFlup", { patientId: patientId, isJoinFlup: isJoinFlup });
        },
        // 患者加入心律失常随访
        AFjoinFlup: function (patientId, isJoinFlup) {
            return BaseService.post("/FlupSrvy/AFJoinFlup", { patientId: patientId, isJoinFlup: isJoinFlup });
        },
        // 获取随访记录
        srvyRecordList: function (patientId) {
            return BaseService.post("/FlupSrvy/SrvyRecordList", { patientId: patientId });
        },
        // 膳食营养结果处理
        DRIscanResult: function (IDCARD_CODE, INPATIENT_ID, DATE_IN, DATE_OUT, OUTPATIENT_ID, PHONENUM, BA_ID, WARD_OUT) {
            return BaseService.post("/FlupSrvy/DRIScanResult", { IDCARD_CODE: jsencrypt.encrypt(IDCARD_CODE), INPATIENT_ID: jsencrypt.encrypt(INPATIENT_ID), DATE_IN: DATE_IN, DATE_OUT: DATE_OUT, OUTPATIENT_ID: jsencrypt.encrypt(OUTPATIENT_ID), PHONENUM: jsencrypt.encrypt(PHONENUM), BA_ID: jsencrypt.encrypt(BA_ID), WARD_OUT: jsencrypt.encrypt(WARD_OUT) });
        },
        // 心律失常随访结果处理
        AFscanResult: function (IDCARD_CODE, INPATIENT_ID, DATE_IN, DATE_OUT, OUTPATIENT_ID, PHONENUM, BA_ID, WARD_OUT) {
            return BaseService.post("/FlupSrvy/AFScanResult", { IDCARD_CODE: jsencrypt.encrypt(IDCARD_CODE), INPATIENT_ID: jsencrypt.encrypt(INPATIENT_ID), DATE_IN: DATE_IN, DATE_OUT: DATE_OUT, OUTPATIENT_ID: jsencrypt.encrypt(OUTPATIENT_ID), PHONENUM: jsencrypt.encrypt(PHONENUM), BA_ID: jsencrypt.encrypt(BA_ID), WARD_OUT: jsencrypt.encrypt(WARD_OUT) });
        },
        // 保存问卷
        saveRecord: function (tmplId, recId, vpId, taskId, patientId, values, imgUrl) {
            values["tmplId"] = tmplId;
            values["recId"] = recId;
            values["vpId"] = vpId;
            values["taskId"] = taskId;
            values["patientId"] = patientId;
            values["imgUrl"] = imgUrl;
            return BaseService.post("/FlupSrvy/SaveRecord", values);
        },

        // 获取冠心病随访患者及任务信息
        getCHDFlupPatient: function (vpId, lastMsgId) {
            var deferred = $q.defer();
            // 异步等待通用方法
            function RespFunc(count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/FlupSrvy/GetCHDFlupPatient',
                        data: { vpId: vpId, lastMsgId: lastMsgId },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        else {
                            if ((data.data == null || data.data.length == 0) && data.pollingFlag == "0") {
                                if (count <= 20) {
                                    RespFunc(count + 1);
                                }
                                else {
                                    deferred.resolve({ result: 1, data: [], doctorList: [], articleList: [], pollingFlag: "1" });
                                }
                            }
                            else {
                                deferred.resolve(data);
                            }
                        }
                    })
                }, 1100);
            }

            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/FlupSrvy/GetCHDFlupPatient',
                data: { vpId: vpId, lastMsgId: lastMsgId },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == 0) {
                    deferred.resolve(data);
                }
                else {
                    if ((data.data == null || data.data.length == 0) && data.pollingFlag == "0") {
                        RespFunc(0);
                    }
                    else {
                        deferred.resolve(data);
                    }
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },

        // 获取随访消息列表
        getMessageList: function (vpId, pageNum, messageType) {
            return BaseService.post("/FlupSrvy/GetMessageList", { vpId: vpId, pageNum: pageNum, messageType: messageType });
        },

        // 获取随访消息列表
        getFlupEduContent: function (flupTypeId, pageSize) {
            return BaseService.post("/FlupSrvy/GetFlupEduContent", { flupTypeId: flupTypeId, pageSize: pageSize });
        },
        // 拨打电话
        cdBatBotStart: function (vpId, patientId, tmplId, flupTaskId) {
            return BaseService.post("/FlupSrvy/CdBatBotStart", { vpId: vpId, patientId: patientId, tmplId: tmplId, flupTaskId: flupTaskId });
        },
        // 获取电话结果
        cdBatBotResult: function (vpId, taskId) {
            return BaseService.post("/FlupSrvy/CdBatBotResult", { vpId: vpId, taskId: taskId });
        },
        // 图像识别
        cdBatBotOCRInfo: function (vpId, patientId, tmplId, flupTaskId, uploadType, imgUrl) {
            return BaseService.post("/FlupSrvy/CdBatBotOCRInfo", { vpId: vpId, patientId: patientId, tmplId: tmplId, flupTaskId: flupTaskId, uploadType: uploadType, imgUrl: imgUrl });
        },
        // 获取图片识别的结果
        getOcrImageResultList: function (recId) {
            return BaseService.post("/FlupSrvy/GetOcrImageResultList", { recId: recId });
        },
        // 获取管理计划
        getCHDFlupPlan: function (patientId) {
            return BaseService.post("/FlupSrvy/GetCHDFlupPlan", { patientId: patientId });
        },
        // 获取可穿戴设备数据
        getWearableDeviceCHD: function (vpId) {
            return BaseService.post("/FlupSrvy/GetWearableDeviceCHD", { vpId: vpId });
        },
        // 选就诊人检验是否有住院记录
        checkPatientCHD: function (vpId, requestId) {
            return BaseService.post("/FlupSrvy/CheckPatientCHD", { vpId: vpId, requestId: requestId });
        },
        // 选就诊人检验是否有住院记录
        checkPatientDRI: function (vpId, requestId) {
            return BaseService.post("/FlupSrvy/CheckPatientDRI", { vpId: vpId, requestId: requestId });
        },
        // 房颤选就诊人检验是否有住院记录
        checkPatientAF: function (vpId, requestId) {
            return BaseService.post("/FlupSrvy/CheckPatientAF", { vpId: vpId, requestId: requestId });
        }
    }
})