﻿angular.module('fwapp.services')

.service('HealthService', function ($q, $http, BaseService) {
    return {
        // 获取配置
        getConfig: function () {
            return BaseService.post("/Health/GetConfig");
        },
        getBloodPressureList: function (vpid, startTime, endTime, page) {
            return BaseService.post("/Health/GetBloodPressureList", { vpid: vpid, startTime: startTime, endTime: endTime, page: page });
        },
        getBloodPressureMonthList: function (vpid) {
            return BaseService.post("/Health/GetBloodPressureMonthList", { vpid: vpid });
        },
        getBloodPressureDateList: function (vpid, month) {
            return BaseService.post("/Health/GetBloodPressureDateList", { vpid: vpid, month: month });
        },
        addBloodPressure: function (vpid, sbp, dbp, measureTime) {
            return BaseService.post("/Health/AddBloodPressure", { vpid: vpid, sbp: sbp, dbp: dbp, measureTime: measureTime });
        },
        modifyBloodPressure: function (gpid, sbp, dbp, measureTime) {
            return BaseService.post("/Health/ModifyBloodPressure", { gpid: gpid, sbp: sbp, dbp: dbp, measureTime: measureTime });
        },
        deleteBloodPressure: function (bpid, status) {
            return BaseService.post("/Health/DeleteBloodPressure", { bpid: bpid, status: status });
        },
        getHeartRateList: function (vpid, startTime, endTime, page) {
            return BaseService.post("/Health/GetHeartRateList", { vpid: vpid, startTime: startTime, endTime: endTime, page: page });
        },
        getHeartRateMonthList: function (vpid) {
            return BaseService.post("/Health/GetHeartRateMonthList", { vpid: vpid });
        },
        getHeartRateDateList: function (vpid, month) {
            return BaseService.post("/Health/GetHeartRateDateList", { vpid: vpid, month: month });
        },
        addHeartRate: function (vpid, rate, measureTime) {
            return BaseService.post("/Health/AddHeartRate", { vpid: vpid, rate: rate, measureTime: measureTime });
        },
        modifyHeartRate: function (hrid, rate, measureTime) {
            return BaseService.post("/Health/ModifyHeartRate", { hrid: hrid, rate: rate, measureTime: measureTime });
        },
        deleteHeartRate: function (hrid, status) {
            return BaseService.post("/Health/DeleteHeartRate", { hrid: hrid, status: status });
        },
        getSpecialEventList: function (vpid) {
            return BaseService.post("/Health/GetSpecialEventList", { vpid: vpid });
        },
        addSpecialEvent: function (vpid, symptom, durationHour, durationMinute, relieveMethod, appearedTime) {
            return BaseService.post("/Health/AddSpecialEvent", { vpid: vpid, symptom: symptom, durationHour: durationHour, durationMinute: durationMinute, relieveMethod: relieveMethod, appearedTime: appearedTime });
        },
        modifySpecialEvent: function (msid, symptom, durationHour, durationMinute, relieveMethod, appearedTime) {
            return BaseService.post("/Health/ModifySpecialEvent", { msid: msid, symptom: symptom, durationHour: durationHour, durationMinute: durationMinute, relieveMethod: relieveMethod, appearedTime: appearedTime });
        },
        deleteSpecialEvent: function (seid, status) {
            return BaseService.post("/Health/DeleteSpecialEvent", { seid: seid, status: status });
        },
        bloodPressureTendency: function (type, vpid) {
            return BaseService.post("/Health/BloodPressureTendency", { type: type, vpid: vpid });
        },
        heartRateTendency: function (type, vpid) {
            return BaseService.post("/Health/HeartRateTendency", { type: type, vpid: vpid });
        },
        getDailyDiet: function (vpid, date) {
            return BaseService.post("/Health/GetDailyDiet", { date: date, vpid: vpid });
        },
        getMealDiet: function (vpid, mealId) {
            return BaseService.post("/Health/GetMealDiet", { vpid: vpid, mealId: mealId });
        },
        editMealDiet: function (vpid, date, mealTime, mealId, dietType, mealDetail) {
            return BaseService.post("/Health/EditMealDiet", { vpid: vpid, date: date, mealTime: mealTime, mealId: mealId, dietType: dietType, mealDetail: mealDetail });
        },
        searchFood: function (name) {
            return BaseService.post("/Health/SearchFood", { name: name });
        },
        favoriteFood: function (vpid) {
            return BaseService.post("/Health/FavoriteFood", { vpid: vpid });
        },
        getDietGoal: function (vpId) {
            return BaseService.post("/Health/GetDietGoal", { vpId: vpId });
        },
        setDietGoal: function (vpId, goal) {
            return BaseService.post("/Health/SetDietGoal", { vpId: vpId, goal: goal });
        },
        getLastHeightWeight: function (vpId) {
            return BaseService.post("/Health/GetLastHeightWeight", { vpId: vpId });
        },
        submitHeightWeight: function (vpId, height, weight, pathway, measureTime) {
            return BaseService.post("/Health/SubmitHeightWeight", { vpId: vpId, height: height, weight: weight, pathway: pathway, measureTime: measureTime });
        },
        getHlthAdvice: function (vpId) {
            return BaseService.post("/Health/GetHlthAdvice", { vpId: vpId });
        },
        getHeightWeightList: function (vpId) {
            return BaseService.post("/Health/GetHeightWeightList", { vpId: vpId });
        },
        modifyHeigthWeight: function (htid, height, weight, measureTime) {
            return BaseService.post("/Health/ModifyHeigthWeight", { htId: htid, height: height, weight: weight, measureTime: measureTime });
        },
        deleteHeightWeight: function (htid) {
            return BaseService.post("/Health/DeleteHeightWeight", { htId: htid });
        },
        heightWeightTendency: function (type, vpId) {
            return BaseService.post("/Health/HeightWeightTendency", { type: type, vpid: vpId });
        },
        getBloodGlucoseList: function (vpid, startTime, endTime, page) {
            return BaseService.post("/Health/GetBloodGlucoseList", { vpid: vpid, startTime: startTime, endTime: endTime, page: page });
        },
        getBloodGlucoseMonthList: function (vpid) {
            return BaseService.post("/Health/GetBloodGlucoseMonthList", { vpid: vpid });
        },
        getBloodGlucoseDateList: function (vpid, month) {
            return BaseService.post("/Health/GetBloodGlucoseDateList", { vpid: vpid, month: month });
        },
        addBloodGlucose: function (vpId, glu, measureTime, timeArea) {
            return BaseService.post("/Health/AddBloodGlucose", { vpId: vpId, glu: glu, measureTime: measureTime, timeArea: timeArea });
        },
        modifyBloodGlucose: function (bgId, glu, measureTime, timeArea) {
            return BaseService.post("/Health/ModifyBloodGlucose", { bgId: bgId, glu: glu, measureTime: measureTime, timeArea: timeArea });
        },
        deleteBloodGlucose: function (bgId) {
            return BaseService.post("/Health/DeleteBloodGlucose", { bgId: bgId });
        },
        bloodGlucoseTendency: function (type, vpId) {
            return BaseService.post("/Health/BloodGlucoseTendency", { type: type, vpid: vpId });
        },
        getStepRecordHonorList: function (vpId, honorMode) {
            return BaseService.post("/Health/GetStepRecordHonorList", { vpid: vpId, honorMode: honorMode });
        },
        getBloodOxygenList: function (vpid, startTime, endTime, page) {
            return BaseService.post("/Health/GetBloodOxygenList", { vpid: vpid, startTime: startTime, endTime: endTime, page: page });
        },
        getBloodOxygenMonthList: function (vpid) {
            return BaseService.post("/Health/GetBloodOxygenMonthList", { vpid: vpid });
        },
        getBloodOxygenDateList: function (vpid, month) {
            return BaseService.post("/Health/GetBloodOxygenDateList", { vpid: vpid, month: month });
        },
        bloodOxygenTendency: function (type, vpId) {
            return BaseService.post("/Health/BloodOxygenTendency", { type: type, vpid: vpId });
        },
        getEcgRecordList: function (vpId) {
            return BaseService.post("/Health/GetEcgRecordList", { vpid: vpId });
        },
        heartRateTendencyHonor: function (type, vpid) {
            return BaseService.post("/Health/HeartRateTendencyHonor", { type: type, vpid: vpid });
        },
        stepRecordTendencyHonor: function (type, vpid) {
            return BaseService.post("/Health/StepRecordTendencyHonor", { type: type, vpid: vpid });
        },
        getDialysis_RrecordList: function (vpid) {
            return BaseService.post("/Health/GetDialysis_RrecordList", { vpid: vpid });
        },
        getDialysis_Detail: function (dialysis_record_id) {
            return BaseService.post("/Health/getDialysis_Detail", { dialysis_record_id: dialysis_record_id });
        },
        addDialysis_Rrecord: function (vpid, str) {
            return BaseService.post("/Health/AddDialysis_Rrecord", { vpid: vpid, str: str });
        },
        modifyDialysis_Rrecord: function (vpid, str) {
            return BaseService.post("/Health/ModifyDialysis_Rrecord", { vpid: vpid, str: str });
        },
        deleteDialysis_Rrecord: function (dialysisid, status) {
            console.log("dialysisid:" + dialysisid);
            return BaseService.post("/Health/DeleteDialysis_Rrecord", { dialysisid: dialysisid, status: status });
        },
        checkAuthorzation: function (vpId) {
            return BaseService.post("/WearableDeviceBusiness/CheckAuthorzation", { vpId: vpId });
        },
        getCodeUrl: function (vpId) {
            return BaseService.post("/WearableDeviceBusiness/GetCodeUrl", { vpId: vpId });
        },
        cancelAuthorzation: function (vpId) {
            return BaseService.post("/WearableDeviceBusiness/CancelAuthorzation", { vpId: vpId });
        },
        getStepRecordList: function (vpId) {
            return BaseService.post("/Health/GetStepRecordList", { vpid: vpId });
        },
        stepRecordTendency: function (type, vpid) {
            return BaseService.post("/Health/StepRecordTendency", { type: type, vpid: vpid });
        },
        getHealthKitHeightWeight: function (vpid) {
            return BaseService.post("/Health/GetHealthKitHeightWeight", { vpId: vpid });
        },
        bloodOxygenTendency: function (type, vpId) {
            return BaseService.post("/Health/BloodOxygenTendency", { type: type, vpid: vpId });
        },
        getEcgRecordList: function (vpId) {
            return BaseService.post("/Health/GetEcgRecordList", { vpid: vpId });
        },
        queryHealthKitAuth: function (vpId, title) {
            return BaseService.post("/WearableDeviceBusiness/QueryHealthKitAuth", { vpId: vpId, title: title });
        },
        healthKitSync: function (vpId) {
            return BaseService.post("/WearableDeviceBusiness/HealthKitSync", { vpId: vpId });
        },
        // 2023.4.26 16:26 朱世博 获取华为过期授权
        getExpiredAuths: function () {
            return BaseService.post("/WearableDeviceBusiness/GetExpiredAuths");
        }
    }
})