﻿angular.module('fwapp.services')

// 
.service('HealthInfoService', function ($q, $http, BaseService) {
    return {
        // 获取健康基本信息
        healthinfo: function (vpid, queryToken) {
            return BaseService.post("/HealthInfo/BaseInfo", { vpid: vpid, queryToken: queryToken });
        },
        // 获取身体概况信息
        bodyinfo: function (vpid, queryToken) {
            return BaseService.post("/HealthInfo/BodyInfo", { vpid: vpid, queryToken: queryToken });
        },
        //增加基本信息
        savebaseinfo: function (vpBaseInfo) {
            // 2019-5-31 11:16:12 jsencrypt.js 加密
            // 深度复制
            var data = {};
            $.extend(data, vpBaseInfo);
            if (data) {
                var keyList = ["VISIT_PATIENT_NAME", "SEX", "BIRTHDAY"/*, "HEIGHT", "WEIGHT"*/, "OCCUPATION", "COSTTYPE", "MARRIAGE", "IDCARD", "ADDRESS", "WORKUNIT"]
                Object.keys(data).forEach(e => {
                    if (keyList.indexOf(e) >= 0 && data[e] != null && data[e] != "") {
                        data[e] = jsencrypt.encrypt(data[e]);
                    }
                })
            }
            return BaseService.post("/HealthInfo/SaveBaseInfo", data);
        },
        //增加身体概况信息
        savebodyinfo: function (vpBodyInfo) {
            // 2019-5-31 11:16:12 jsencrypt.js 加密
            // 深度复制
            var data = {};
            $.extend(data, vpBodyInfo);
            if (data) {
                var keyList = ["ALLERGY", "ALLERGEN", "SMOKE"/*, "SMOKE_YEARS", "SMOKE_COUNT"*/, "DRUNK"/*, "DRUNK_YEARS", "DRUNK_COUNT"*/, "MARRIAGE_HISTORY"/*, "MARRIAGE_YEARS", "SON_COUNT", "DAUGHTER_COUNT"*/, "FAMILY_HISTORY"]
                Object.keys(data).forEach(e => {
                    if (keyList.indexOf(e) >= 0 && data[e] != null && data[e] != "") {
                        data[e] = jsencrypt.encrypt(data[e]);
                    }
                })
            }
            return BaseService.post("/HealthInfo/SaveBodyInfo", data);
        }
    }
});