﻿angular.module('fwapp.services')

.service('HospitalService', function ($q, $http, BaseService) {
    return {
        // 简介
        description: function () {
            return BaseService.post("/Hospital/Description");
        },
        // 地理位置
        location: function () {
            return BaseService.post("/Hospital/Location");
        },
        // 获取远程签到范围坐标
        getRemoteCheckInRange: function () {
            return BaseService.post("/Hospital/GetRemoteCheckInRange");
        },
        // 首页图片
        homeImage: function () {
            return BaseService.post("/Hospital/HomeImage");
        },
        // 反馈建议
        feedback: function (content, contact) {
            return BaseService.post("/Hospital/FeedBack", { content: content, contact: contact });
        },
        // 免责声明
        statement: function () {
            return BaseService.post("/Hospital/Statement");
        },
        // 用户隐私政策
        privacyPolicy: function () {
            return BaseService.post("/Hospital/PrivacyPolicy");
        },
        // 使用帮助
        help: function () {
            return BaseService.post("/Hospital/Help");
        },
        // 预约说明
        apptDescr: function () {
            return BaseService.post("/Hospital/ApptDescr");
        },
        // 首页查询分类
        searchType: function () {
            return BaseService.post("/Hospital/SearchType");
        },
        // 首页搜索
        search: function (keyword, type, page) {
            return BaseService.post("/Hospital/Search", { keyword: keyword, type: type, page: page });
        },
        // 出诊排班科室列表
        divisionList: function () {
            return BaseService.post("/Hospital/DivisionList");
        },
        // 扫码结果处理
        scanResult: function (code) {
            return BaseService.post("/Hospital/ScanResult", { code: code });
        },
        // 检查院内导航服务状态
        checkInHospitalNavStatus: function () {
            return BaseService.post("/Hospital/CheckInHospitalNavStatus");
        },
        // 2024-07-05 11:19:44 CGZ #hzfwx-1114 检查医心商店服务状态
        checkYixinShopStatus: function () {
            return BaseService.post("/Hospital/CheckYixinShopStatus");
        },
        // (未过期)消息流
        loadMessageStreams: function () {
            return BaseService.post("/Hospital/LoadMessageStreams");
        },
        // (全部)消息流
        loadWholeMessageStreams: function () {
            return BaseService.post("/Hospital/LoadWholeMessageStreams");
        },
        // 更新RID
        updateRequestId: function (streamId, requestId) {
            return BaseService.post("/Hospital/UpdateRequestId", { streamId: streamId, requestId: requestId });
        },
        // 等待时长
        getAVGLength: function (queueSourceId, queueTypeId) {
            return BaseService.post("/Hospital/GetAVGLength", { queueSourceId: queueSourceId, queueTypeId: queueTypeId });
        },
        // 首页Ajax
        homeAjax: function () {
            return BaseService.post("/Hospital/HomeAjax", { miPatientBJYBFlag: "1" });
        },
        // 忽略本次复诊
        ignoreSubTreat: function (subId, vpId) {
            return BaseService.post("/Hospital/IgnoreThisSubTreat", { subId: subId, vpId: vpId });
        }
    }
})