﻿angular.module('fwapp.services')

// 门诊缴费明细
    .service('IpElecReceiptService', function ($q, $http, $timeout, BaseService) {
    return {
        //查找患者住院记录
        getInpatientInfo: function (cardNo) {
            return BaseService.post("/IpElecReceipt/GetInpatientInfo", { cardNo: cardNo });
        },
        //查询患者某次住院电子发票
        getInpatientElecReceipt: function (patientIdb) {
            return BaseService.post("/IpElecReceipt/GetInpatientElecReceipt", { patientIdb: patientIdb });
        },
        // 患者信息校验查询
        patientCheck: function (visitPatientId) {

            // 患者信息校验查询异步等待通用方法
            function WaitResponse(deferred, requestId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/IpElecReceipt/GetResponse',
                        data: { requestId: requestId },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                WaitResponse(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            var deferred = $q.defer();
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/IpElecReceipt/PatientCheck',
                data: { visitPatientId: visitPatientId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                // 缓存
                // 2019-6-3 09:14:38 不应判断缓存中is_null状态 统一交给controller处理
                else if (data.result == -1 && data.data != null && data.data.length > 0) {
                    WaitResponse(deferred, data.data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
    }
})