﻿angular.module('fwapp.services')

// 门诊缴费明细
.service('IpNurEduService', function ($q, $http, $timeout, BaseService) {
    return {
        //查询患者住院单+宣教列表
        getIpNoticeList: function () {
            return BaseService.post("/IpNurEdu/GetIpNoticeList", { });
        },
        //根据卡号获取宣教推送信息
        getPaeRecord: function (his_idb, current_bqdm,ids) {
            return BaseService.post("/IpNurEdu/GetPaeRecord", { his_idb: his_idb, current_bqdm: current_bqdm, ids: ids });
        },
        //获取宣教二级列表
        getEduItem: function (pae_parent, idb, ids, current_bqdm) {
            return BaseService.post("/IpNurEdu/GetEduItem", { pae_parent: pae_parent, idb: idb, ids: ids, current_bqdm: current_bqdm });
        },
        //获取其中1条宣教
        getPaeRecordItem: function (pae_id) {
            return BaseService.post("/IpNurEdu/GetPaeRecordItem", { pae_id: pae_id });
        },
        //发起计时请求
        commitTimer: function ( idb,  paeid,  type) {
            return BaseService.post("/IpNurEdu/CommitTimer", { idb: idb, paeid: paeid, type: type });
        },
        //提交考试记录
        commitExam: function (vpid,paeid, param) {
            return BaseService.post("/IpNurEdu/CommitExam", { vpid:vpid, paeid: paeid, param: param });
        },

        // 患者信息校验查询
        patientCheck: function (visitPatientId) {

            // 患者信息校验查询异步等待通用方法
            function WaitResponse(deferred, requestId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/IpNurEdu/GetResponse',
                        data: { requestId: requestId },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                WaitResponse(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }


            var deferred = $q.defer();
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/IpNurEdu/PatientCheck',
                data: { visitPatientId: visitPatientId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                // 缓存
                // 2019-6-3 09:14:38 不应判断缓存中is_null状态 统一交给controller处理
                else if (data.result == -1 && data.data != null && data.data.length > 0) {
                    WaitResponse(deferred, data.data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
    }
})