﻿angular.module('fwapp.services')

// 在线开药
.service('OlTreatRecipeService', function ($q, $http, $timeout, BaseService) {
    return {
        // 检查服务状态
        checkServerStatus: function () {
            return BaseService.post("/OlTreatRecipe/CheckServerStatus");
        },
        // 获取配置
        getConfig: function () {
            return BaseService.post("/OlTreatRecipe/GetConfig");
        },
        // 检查开药申请
        checkApply: function (vpId, recipeNum, checkNum, chooseRecipe) {
            var deferred = $q.defer();
            // 异步等待 获取当日号申请状态
            function WaitResponse(deferred, applyCheckId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/OlTreatRecipe/CheckApplyResp',
                        data: { applyCheckId: applyCheckId },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // id无效，报错
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        // 轮询成功
                        else if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        // 轮询中，1秒后重新发起请求
                        else if (data.result == 2) {
                            if (count <= 10) {
                                WaitResponse(deferred, applyCheckId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/CheckApplyReq',
                data: { vpId: vpId, recipeNum: recipeNum, checkNum: checkNum, chooseRecipe: chooseRecipe},
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 提交开药申请
        submitApply: function (applyCheckId, takeMedWay, treatAgentId, currentAreaCode) {
            return BaseService.post("/OlTreatRecipe/SubmitApplyReq", { applyCheckId: applyCheckId, takeMedWay: takeMedWay, treatAgentId: treatAgentId, currentAreaCode: currentAreaCode, miPatientBJYBFlag: "1" });
        },
        // 获取开药申请结果
        getSubmitApply: function (applyId) {
            var deferred = $q.defer();
            function WaitResponse(deferred, applyId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/OlTreatRecipe/SubmitApplyResp',
                        data: { applyId: applyId },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // id无效，报错
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        // 轮询成功
                        else if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        // 轮询中，1秒后重新发起请求
                        else if (data.result == 2) {
                            if (count <= 20) {
                                WaitResponse(deferred, applyId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/SubmitApplyResp',
                data: { applyId: applyId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 0) {
                    deferred.resolve(data);
                }
                else if (data.result == 1) {
                    deferred.resolve(data);
                }
                else {
                    WaitResponse(deferred, applyId, 0);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取开药申请会话
        getApplyConvr: function (applyId) {
            return BaseService.post("/OlTreatRecipe/GetApplyConvr", { applyId: applyId });
        },
        // 获取开药申请列表
        getApplyList: function (status) {
            return BaseService.post("/OlTreatRecipe/GetApplyList", { status: status, ver: 2, miPatientBJYBFlag: "1" });
        },
        // 取消开药申请
        cancelApply: function (applyId) {
            var deferred = $q.defer();
            // 异步等待 获取当日号申请状态
            function WaitResponse(deferred, applyId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/OlTreatRecipe/CancelApplyResp',
                        data: { applyId: applyId },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // id无效，报错
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        // 轮询成功
                        else if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        // 轮询中，1秒后重新发起请求
                        else if (data.result == 2) {
                            if (count <= 10) {
                                WaitResponse(deferred, applyId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/CancelApplyReq',
                data: { applyId: applyId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取检查检验列表
        getCheckList: function (status) {
            return BaseService.post("/OlTreatRecipe/GetCheckList");
        },
        // 换药
        applyChange: function (applyId, changeIndex) {
            var deferred = $q.defer();
            // 异步等待 获取换药轮询结果
            function WaitResponse(deferred, applyId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/OlTreatRecipe/ApplyChangeResp',
                        data: { applyId: applyId },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // id无效，报错
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        // 轮询成功
                        else if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        // 轮询中，1秒后重新发起请求
                        else if (data.result == 2) {
                            if (count <= 20) {
                                WaitResponse(deferred, applyId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/ApplyChangeReq',
                data: { applyId: applyId, changeIndex: changeIndex },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 医保验证
        needCheckMI: function (vpId, requestId, applyType) {
            return BaseService.post("/OlTreatRecipe/NeedCheckMI", { vpId: vpId, requestId: requestId, applyType: applyType });
        },
        // 上传医保信息
        addMIPatientInfo: function (vpid, rid, isPatientMI, MICode, MIUrl, MIHandUrl, verifyRequestId) {
            return BaseService.post("/OlTreatRecipe/AddMIPatientInfo", { vpid: vpid, rid: rid, isPatientMI: isPatientMI, MICode: MICode, MIUrl: MIUrl, MIHandUrl: MIHandUrl, verifyRequestId: verifyRequestId });
        },
        // 回写医保金额拆分结果
        miPreResultApply: function (applyId, cashPay, fundPay, personCountPay) {
            return BaseService.post("/OlTreatRecipe/MIPreResultApply", { applyId: applyId, cashPay: cashPay, fundPay: fundPay, personCountPay: personCountPay });
        },
        // 添加代开药人
        addAgent: function (isCondition, isSelf, name, idCard, phone) {
            return BaseService.post("/OlTreatRecipe/AddAgent", { isCondition: isCondition, isSelf: isSelf, name: name, idCard: idCard, phone: phone });
        },
        // 检查药品库存
        checkRecipe: function (recipeNum, checkNum, patientMI, vpId, opDrugRequestId) {
            return BaseService.post("/OlTreatRecipe/CheckRecipe", { recipeNum: recipeNum, checkNum, checkNum, patientMI: patientMI, vpId: vpId, opDrugRequestId: opDrugRequestId, miPatientBJYBFlag: "1" });
        },
        // 获取视频会话状态
        getVideoStatus: function () {
            return BaseService.post("/OlTreatRecipe/GetVideoStatus");
        },
        // 插视频会话
        addVideoConsultation: function (applyId, vpId) {
            return BaseService.post("/OlTreatRecipe/AddVideoConsultation", { applyId: applyId, vpId: vpId });
        },
        // 检查开药申请V2
        checkApplyV2: function (vpId, recipeNum, checkNum) {
            var deferred = $q.defer();
            // 异步等待 获取当日号申请状态
            function WaitResponse(deferred, applyCheckId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/OlTreatRecipe/CheckApplyResp',
                        data: { applyCheckId: applyCheckId },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // id无效，报错
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        // 轮询成功
                        else if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        // 轮询中，1秒后重新发起请求
                        else if (data.result == 2) {
                            if (count <= 10) {
                                WaitResponse(deferred, applyCheckId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/CheckApplyReqV2',
                data: { vpId: vpId, recipeNum: recipeNum, checkNum: checkNum },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 选就诊人限制
        selectVpLimit: function (vpId) {
            return BaseService.post("/OlTreatRecipe/SelectVpLimit", { vpId: vpId });
        },
        // 请求上次就诊信息
        getLastOpInfo: function (vpId) {
            return BaseService.post("/Request/GetLastOpInfo", { visitPatientId: vpId });
        },
        // 检查复诊续方资质资格条件
        checkOLCondition: function (requestId, vpId){
            var deferred = $q.defer();
            // 异步等待 获取当日号申请状态
            function WaitResponse(deferred, requestId, vpId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/OlTreatRecipe/CheckOLCondition',
                        data: { requestId: requestId, vpId: vpId },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // 报错
                        if (data.result == 0) {
                            deferred.resolve(data);
                        }
                        // 轮询成功
                        else if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        // 轮询中，1秒后重新发起请求
                        else if (data.result == -1) {
                            if (count <= 10) {
                                WaitResponse(deferred, requestId, vpId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/CheckOLCondition',
                data: { requestId: requestId, vpId: vpId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                // 出错了
                if (data.result == 0) {
                    deferred.resolve(data);
                }
                // 轮询成功
                else if (data.result == 1) {
                    deferred.resolve(data);
                }
                // 轮询中，1秒后重新发起请求
                else if (data.result == -1) {
                    WaitResponse(deferred, requestId, vpId, 0);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取门诊药品_请求
        getOpDrugReq: function (visitPatientId, queryToken) {
            return BaseService.post("/Request/GetOpDrug", { visitPatientId: visitPatientId, queryToken: queryToken });
        },
        getOpDrugResp: function (requestId) {
            var deferred = $q.defer();
            // 异步等待通用方法
            function RespOPDrug(deferred, requestId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/Request/RespOPDrug',
                        data: { requestId: requestId },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                RespOPDrug(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }

            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/Request/RespOPDrug',
                data: { requestId: requestId },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == 1) {
                    deferred.resolve(data);
                }
                else {
                    RespOPDrug(deferred, requestId, 0);
                }
            });
            return deferred.promise;
        },
        // 获取门诊处方（带签名）
        getDrugRecord: function (visitPatientId, treatApplyId){
            var deferred = $q.defer();
            // 异步等待 获取检查报告图片
            function WaitResponseImage(deferred, requestId, count) {
                console.log(requestId, count);
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/Request/GetResponseImage',
                        data: { requestId: requestId },
                        withCredentials: true
                    }).success(function (data, status) {
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                WaitResponseImage(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/OlTreatRecipe/GetDrugRecord',
                data: { visitPatientId: visitPatientId, treatApplyId: treatApplyId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                // 轮询成功
                if (data.result == 1) {
                    WaitResponseImage(deferred, data.data, 0);
                }
                else {
                    deferred.resolve(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 关联复诊表
        relationTreatRemind: function (treatApplyId, vpId) {
            return BaseService.post("/OlTreatRecipe/RelationTreatRemind", { treatApplyId: treatApplyId, vpId: vpId });
        },
        // 云南新开药，转换accountId
        convertCommunityApply: function (treatApplyId, idCardCode) {
            // 这里已经是加密过的身份证号了
            return BaseService.post("/OlTreatRecipe/ConvertCommunityApply", { treatApplyId: treatApplyId, idCardCode: idCardCode });
        },
        // 验证是否有门诊就诊记录
        respLastOpInfoNew: function (requestId, type) {
            var deferred = $q.defer();
            function WaitRespLastOpInfoNew(deferred, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + '/Request/RespLastOpInfo_New',
                        data: { requestId: requestId, type: type },
                        withCredentials: true
                    }).success(function (data, status) {
                        console.log(data);
                        // 轮询成功
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                WaitRespLastOpInfoNew(deferred, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    }).error(function (data, status) {
                        deferred.reject(data);
                    });
                }, 1100);
            }

            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + '/Request/RespLastOpInfo_New',
                data: { requestId: requestId, type: type },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                // 轮询成功
                if (data.result == 1) {
                    deferred.resolve(data);
                }
                else {
                    WaitRespLastOpInfoNew(deferred, 0);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取北京医保退费URL
        getRefundBJYBUrlOlTreat: function (treatApplyId, visitPatientId) {
            return BaseService.post("/OlTreatRecipe/GetRefundBJYBUrlOlTreat", { treatApplyId: treatApplyId, visitPatientId: visitPatientId });
        }
    }
})