﻿angular.module('fwapp.services')

// 门诊缴费明细
.service('OpConsumptionService', function ($q, $http, $timeout, BaseService) {
    return {
        // 获取用户须知数据
        agreement: function () {
            return BaseService.post("/OpPayment/Agreement");
        },
        // 获取绑卡帮助
        getBindCardHelp: function () {
            return BaseService.post("/OpPayment/GetBindCardHelp");
        },
        // 获取门诊缴费清单 (2008)
        getConsumptionList: function (vpId, dateStart, dateEnd) {
            var deferred = $q.defer();
            // 异步等待 获取住院单状态
            function WaitResponse(deferred, requestId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + "/Request/RespConsumptionList",
                        data: { requestId: requestId },
                        withCredentials: true
                    }).success(function (data, status) {
                        //console.log(data);
                        data.requestId = requestId;
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                console.log(requestId, count);
                                WaitResponse(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + "/Request/GetConsumptionList",
                data: { visitPatientId: vpId, dateStart: dateStart, dateEnd: dateEnd },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else if (data.result == -1) {
                    deferred.resolve(data);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取门诊缴费明细 (4010)
        getConsumptionDetail: function (vpId, receiptCode) {
            var deferred = $q.defer();
            // 异步等待 获取住院单状态
            function WaitResponse(deferred, requestId, count) {
                var timer = $timeout(function () {
                    $http({
                        method: 'POST',
                        dataType: 'JSON',
                        url: serviceUrl + "/Request/GetResponse",
                        data: { requestId: requestId },
                        withCredentials: true
                    }).success(function (data, status) {
                        //console.log(data);
                        data.requestId = requestId;
                        if (data.result == 1) {
                            deferred.resolve(data);
                        }
                        else {
                            if (count <= 20) {
                                console.log(requestId, count);
                                WaitResponse(deferred, requestId, count + 1);
                            }
                            else {
                                deferred.resolve({ result: 99 });
                            }
                        }
                    })
                }, 1100);
            }
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + "/Request/GetConsumptionDetail",
                data: { visitPatientId: vpId, receiptCode: receiptCode },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == 1) {
                    WaitResponse(deferred, data.data, 0);
                }
                else if (data.result == -1) {
                    deferred.resolve(data);
                }
                else {
                    deferred.reject(data);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 开具电子发票
        createEInvoice: function (vpId, receiptCode) {
            return BaseService.post("/Payment/CreateEInvoice", { vpId: vpId, receiptCode: receiptCode });
        },
        // 查看电子发票
        lookUpEInvoice: function (messageId) {
            return BaseService.post("/Payment/LookUpEInvoice", { messageId: jsencrypt.encrypt(messageId) });
        }
    }
})