﻿angular.module('fwapp.services')

// 
.service('PaymentService', function ($q, $http, $timeout, BaseService) {
    return {
        // 获取可选择支付方式
        getPaymentRoute: function () {
            return BaseService.post("/Payment/GetPaymentRouteWithDescr");
        },
        // 支付下单
        unifiedOrder: function (vpId, hisNum, fee, paymentMethod, prepaidType) {
            return BaseService.post("/Payment/UnifiedOrder", { vpId: vpId, hisNum: hisNum, fee: fee, paymentMethod: paymentMethod, prepaidType: prepaidType });
        },
        // 支付用户须知
        instruction: function () {
            return BaseService.post("/Payment/Instruction");
        },
        // 支付用户须知_住院
        instructionIP: function () {
            return BaseService.post("/Payment/InstructionIP");
        },
        // 微信支付成功回调
        appCallback: function (vpId, outTradeNo, appResult) {
            return BaseService.post("/Payment/AppCallback", { vpId: vpId, outTradeNo: outTradeNo, appResult: appResult });
        },
        // 检查开户情况
        checkPrePayAccount: function (vpId, isBind) {
            var deferred = $q.defer();
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + "/Request/RequestBalance",
                data: { visitPatientId: vpId, isBind: isBind },
                withCredentials: true
            }).success(function (data, status) {
                if (data.result == -1 || data.result == 0 || data.result == -99) {    // 若返回缓存结果 || 报错
                    deferred.resolve(data);
                } else if (data.result == -2) {
                    deferred.resolve({ result: -2 });
                } else {
                    CheckPrePayAccount(deferred, data.data, 0);
                }
            }).error(function (data, status) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        // 获取支付状态
        getTradeStatus: function (outTradeNo) {
            return BaseService.post("/Payment/GetTradeStatus", { outTradeNo: outTradeNo });
        },
        // 优化效率用
        wakeDBConnection: function () {
            return BaseService.post("/Payment/WakeDBConnection");
        }
    }

    // 异步等待检查开户情况
    function CheckPrePayAccount(deferred, requestId, count) {
        console.log("检查开户情况,count=" + count);
        var timer = $timeout(function () {
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + "/Request/CheckPrePayAccount",
                data: { requestId: requestId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    deferred.resolve(data);
                }
                else {
                    if (count < 20) {
                        CheckPrePayAccount(deferred, requestId, count + 1);
                    }
                    else {
                        deferred.resolve({ result: 99 });
                    }
                }
            })
        }, 1100);
    }
})