﻿angular.module('fwapp.services')

// 
.service('PersonalService', function ($q, $http, BaseService) {
    return {
        // 获取就诊人列表
        visitPatientList: function () {
            return BaseService.post("/Personal/VisitPatientList");
        },
        // 添加就诊人 返回就诊人信息
        addVisitPatient: function (realName, idCardCode) {
            return BaseService.post("/Personal/AddVisitPatient", { realName: jsencrypt.encrypt(realName), idCardCode: jsencrypt.encrypt(idCardCode), needRealName: devMode ? "1" : "0" });
        },
        // 获取消息列表
        messageList: function (pageNum, inputType) {
            return BaseService.post("/Personal/GetMessageList", { pageNum: pageNum, inputType: inputType });
        },
        // 获取当前用户最近消息ID
        lastMsg: function (lastMsgId) {
            return BaseService.post("/Personal/GetLastedMessage", { lastMsgId: lastMsgId });
        },
        // 获取微信绑定码
        getWeChatBindCode: function () {
            return BaseService.post("/Personal/GetWeChatBindCode");
        },
        // 通过微信AuthCode关联微信
        bindWeChatByAuthCode: function (authCode) {
            return BaseService.post("/Personal/BindWeChatByAuthCode", { authCode: authCode });
        },
        // 解绑微信
        unbindWeChat: function () {
            return BaseService.post("/Personal/UnbindWeChat");
        },
        // 获取卡号条形码
        getCardCodeBarcode: function (visitPatientId, hisCardNum) {
            return BaseService.post("/Personal/GetCardCodeBarcode", { visitPatientId: visitPatientId, hisCardNum: hisCardNum });
        },
        // 获取个人设置
        getSetting: function () {
            return BaseService.post("/Personal/GetSetting");
        },
        // 保存个人设置
        saveSetting: function (key, value) {
            return BaseService.post("/Personal/SaveSetting", { key: key, value: value });
        },
        // 获取道一循code和name
        getNavigateCode: function (aliasName) {
            return BaseService.post("/Personal/GetNavigateCode", { aliasName: aliasName });
        }
    }
})