﻿angular.module('fwapp.services')

// 报告查询
.service('ReportService', function ($q, $http, $timeout, BaseService) {
    return {
        // 获取配置
        getConfig: function (vpId) {
            return BaseService.post("/Report/GetConfig", { vpId: vpId });
        },
        // 验证身份
        verify: function (vpId, usage) {
            return BaseService.post("/Report/Verify", { vpId: vpId });
        },
        // 保存验证信息
        saveVerifyInfo: function (vpId, usage) {
            return BaseService.post("/Report/SaveVerifyInfo", { vpId: vpId, usage: usage });
        },
        // 更新验证信息
        updateVerifyInfo: function (vpId, authId) {
            return BaseService.post("/Report/UpdateVerifyInfo", { vpId: vpId, authId: authId });
        },
        // 记录下载信息
        saveDownloadRecord: function (vpId, usage, reqId, fileName, fileType, fileId, columnName) {
            return BaseService.post("/Report/SaveDownloadRecord", { vpId: vpId, usage: usage, reqId: reqId, fileName: fileName, fileType: fileType, fileId: fileId, columnName: columnName });
        },
        // 更新下载信息
        changeDownloadStatus: function (vpId, downloadRecordId, status) {
            return BaseService.post("/Report/ChangeDownloadStatus", { vpId: vpId, downloadRecordId: downloadRecordId, status: status });
        },
        // 查看是否乱码
        isErrorCheckResult: function (vpId, description) {
            return BaseService.post("/Report/IsErrorCheckResult", { vpId: vpId, description: description });
        }
    }
})