﻿angular.module('fwapp.services')

// 智能分诊
.service('TriageService', function ($q, $http, $timeout, BaseService) {
    return {
        // 症状查询
        symptomSearch: function (keyword, vpId) {
            return BaseService.post("/Triage/SymptomSearch", { name: keyword, vpId: vpId });
        },
        // 关联症状
        rlatSymptom: function (symptoms, vpId) {
            return BaseService.post("/Triage/RlatSymptom", { symptoms: symptoms, vpId: vpId });
        },
        // 分诊
        result: function (vpId, symptoms, isReview, requestId) {
            return BaseService.post("/Triage/Result", { vpId: vpId, symptoms: symptoms, isReview: isReview, requestId: requestId });
        },
        // 请求上次就诊信息
        getLastOpInfo: function (vpId) {
            return BaseService.post("/Request/GetLastOpInfo", { visitPatientId: vpId });
        },
        // 获取上次就诊信息
        respLastOpInfo: function (requestId) {
            var deferred = $q.defer();
            WaitResponse(deferred, requestId, 0);
            return deferred.promise;
        },
        // 获取智能分诊信息
        triageInfo: function (triageId) {
            return BaseService.post("/Triage/TriageInfo", { triageId: triageId });
        },
        // 分诊科别选择回调
        selectDivision: function (triageId, division) {
            return BaseService.post("/Triage/SelectDivision", { triageId: triageId, division: division });
        },
        // 获取服务状态
        checkServerStatus: function () {
            return BaseService.post("/Triage/CheckServerStatus");
        }
    }
    // 异步等待通用方法(获取上次就诊信息 专用)
    function WaitResponse(deferred, requestId, count) {
        var timer = $timeout(function () {
            $http({
                method: 'POST',
                dataType: 'JSON',
                url: serviceUrl + "/Request/RespLastOpInfo_New",
                data: { requestId: requestId },
                withCredentials: true
            }).success(function (data, status) {
                console.log(data);
                if (data.result == 1) {
                    deferred.resolve(data);
                }
                else {
                    if (count <= 10) {
                        WaitResponse(deferred, requestId, count + 1);
                    }
                    else {
                        deferred.resolve({ result: 99 });
                    }
                }
            }).error(function (data, status) {
                deferred.reject(status);
            });
        }, 1100);
    }
})