﻿angular.module('fwapp.services')

//
.service('VisitHistoryService', function ($q, $http, BaseService) {
    return {
        // 获取就诊记录列表
        list: function (vpId, queryToken) {
            return BaseService.post("/Visit/List", { vpId: vpId, queryToken: queryToken });
        },
        // 新建/编辑就诊记录
        editVisit: function (info) {
            // 2019-5-31 11:16:12 jsencrypt.js 加密
            // 深度复制
            var data = {};
            $.extend(data, info);
            if (data) {
                var keyList = ["diseaseName"/*, "isHeart"*/, "visitDate", "hospitalName", "hospitalRank", "hospitalDept", "hospitalOpinion"/*, "isOperation"*/, "operationName"]
                Object.keys(data).forEach(e => {
                    if (keyList.indexOf(e) >= 0 && data[e] != null && data[e] != "") {
                        data[e] = jsencrypt.encrypt(data[e]);
                    }
                })
            }
            return BaseService.post("/Visit/Edit", data);
        },
        // 删除就诊记录
        deleteVisit: function (vhId) {
            return BaseService.post("/Visit/Delete", { vhId: vhId });
        },
        // 保存报告图像
        imageAdd: function (vpId, type, filePath, vhId) {
            return BaseService.post("/Visit/ImageAdd", { vpId: vpId, type: type, filePath: filePath, vhId: vhId });
        },
        // 删除报告图像
        imageDelete: function (riId) {
            return BaseService.post("/Visit/ImageDelete", { riId: riId });
        },
        // 上传前添加就诊记录
        addForUpload: function (vpId) {
            return BaseService.post("/Visit/AddForUpload", { vpId: vpId });
        }
    }
})