angular.module('fwapp.controllers')

// 预约挂号-缴费版
.controller('OpApptController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http, $filter
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $cordovaDatePicker, $fwCordovaToast
, AccountService, VisitPatientService, DoctorInfoService, TriageService, OpRegService, OpApptService, PaymentService, RequestService, CasePrintService, HealthService, IpRegService) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义预约挂号滑块
    var slideOpAppt = $ionicSlideBoxDelegate.$getByHandle('slideOpAppt');
    // 定义支付滑块
    var slidePay = $ionicSlideBoxDelegate.$getByHandle('slidePay');

    // 服务开关
    $scope.isServerOn = true;
    // 打哪儿来
    $scope.from = $stateParams.from;
    if ($scope.from == "specialNeeds") {
        $scope.isSpecialNeeds = true;
    } else {
        $scope.isSpecialNeeds = false;
    }
    // 从医师出诊表传过来的opInfoId
    $scope.opInfoId = $stateParams.opid;
    // 从智能分诊传过来的数据 0:from, 1:triageId, 2:vpId, 3:doctorId
    $scope.triageData = {};
    if ($scope.from.indexOf('app.triage') > -1) {
        var data = $scope.from.split(',');
        console.log(data);
        $scope.triageData.from = data[0];
        $scope.triageData.triageId = data[1];
        $scope.triageData.vpId = data[2];
        $scope.triageData.doctorId = data[3];
        $scope.triageData.firstFrom = data[4];
        console.log($scope.triageData);
    }
    // 从自动问诊传来的数据 0:from, 1:firstFrom
    $scope.autoInquiryData = {};
    if ($scope.from.indexOf('app.autoInquiry') > -1){
        var data = $scope.from.split(',');
        console.log(data);
        $scope.autoInquiryData.from = data[0];
        $scope.autoInquiryData.firstFrom = data[1];
    }
    // 从在线问诊传来的数据 0:from, 1:doctorCode
    $scope.consultationData = {};
    if ($scope.from.indexOf('app.consultation') > -1){
        var data = $scope.from.split(',');
        $scope.consultationData.from = data[0];
        $scope.consultationData.doctorCode = data[1];
    }
    // 根据传过来的opInfoId获取预约信息
    $scope.opInfo = {};
    // 配置
    $scope.configData = {};
    // 初始滑块状态
    $scope.step = 0;
    // 仅看可约
    $scope.showAvailable = false;
    // 就诊人列表
    $scope.vpList = [];
    $scope.vpNew = {};
    $scope.vpSelect = {};
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    // 多张卡列表
    $scope.cardList = [];
    // 多张卡选择序列
    $scope.cardSelectIndex = 0;
    // 2023-8-28 13:55:26 ZZL #hzfwx-107 现住址省市县字典项数组
    $scope.dict = {
        prvn: [],
        address_city: [],
        address_dstr: []
    }
    // 就诊人办卡模型
    $scope.vpApply = {
        id: '',
        name: '',
        phone_num: null,
        address: '',
        idcard_code: '',
        id_type: '1',
        idcard_front: '',
        idcard_back: '',
        household_register: '',
        is_self: 0,
        apply_id: '',
        insurance_type: 0,
        mi_patient_code: '',
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 添加省市区县选择
        address_prvn: '',
        address_city: '',
        address_dstr: '',
        address_detail: '',
        marital: 0
    }
    // 预约方式 按医生=1, 按条件=2, 按症状=3, 按特色技术=4, 按病种=5
    $scope.apptMethod = '';
    // 按医师搜索
    $scope.doctorSearch = {};
    $scope.doctorSearch.list = []; // 医师搜索结果列表
    $scope.doctorSearch.keyword = ''; // 医师搜索关键词
    $scope.doctorSearch.isSearch = false;  // 是否搜索
    $scope.doctorSearch.isEmpty = false;  // 结果是否空
    // 医生出诊列表
    $scope.opInfoList = [];
    $scope.opInfoSelect = {};
    $scope.opInfoListEmpty = false;
    $scope.opInfoListByDoctorEmpty = false;
    // 按医生数据
    $scope.currentWishByDoctor = {};
    $scope.currentWishByDoctor.schedDate = ''; // 预约日期
    $scope.currentWishByDoctor.schedTime = ''; // 预约时段
    $scope.currentWishByDoctor.division = ''; // 预约科室
    // 按条件数据
    $scope.currentWishByFilter = {}; // 奇葩 必须定义到变量的二级属性才能绑定ng-model 这是为什么
    $scope.currentWishByFilter.schedDate = ''; // 预约日期
    $scope.currentWishByFilter.schedTime = ''; // 预约时段
    $scope.currentWishByFilter.division = ''; // 预约科室
    $scope.currentWishByFilter.doctorLevel = ''; // 预约医师级别
    // 症状
    $scope.symptomData = {};
    $scope.symptomData.isReview = false;
    $scope.symptomData.symptoms = [];
    // 复查信息
    $scope.reviewDataRequestId = '';
    $scope.reviewData = [];
    $scope.intoReview = false;
    // 症状查询
    $scope.addSymptomData = {};
    $scope.addSymptomData.keyword = '';
    // 分诊结果
    $scope.sysptomResult = {};
    // 医师列表
    $scope.doctorData = {};
    $scope.doctorData.doctorList = [];
    // 是否正在获取历史就诊
    $scope.isLoadingHistory = false;
    // 特色技术/病种
    $scope.specialityGroupData = {};
    $scope.specialityGroupData.groupList = [];
    // 就诊人办卡页面显示
    $scope.applyCardType = 1;
    // 获取验证码倒计时
    $scope.timespan = 0;
    // 预约挂号信息
    $scope.opApptData = {};
    // 用户须知倒计时
    $scope.confirmCountdown = 10;
    // 锁定挂号信息
    $scope.lockedRegInfo = {};
    // 挂号错误信息
    $scope.regErrorMsg = '';
    // 防止多次提交
    $scope.disableAddVP = false;
    // 防止多次提交
    $scope.disableSubmit = false;
    // 从微信返回
    $scope.fromWeixin = true;
    // 商户订单号
    $scope.outTradeNo = "";
    // 微信支付返回结果
    $scope.appResult = "";
    // 支付成功显示model
    $scope.resultShow = {};
    // 是否支付成功
    $scope.isPaySuccess = false;
    // 是否挂号成功
    $scope.isRegSuccess = false;
    // 是否继续支付
    $scope.isContinueToPay = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 地图实例
    $scope.map = {}
    $scope.mapSearch = {}
    // 地图模式
    $scope.mapMode = 'map';
    // 上一次地图模式
    $scope.mapLastMode = $scope.mapMode;
    // GCJ坐标
    $scope.locationGCJ = { lng: 0, lat: 0 };
    // 医院中心
    $scope.locationFWCenter = { lng: 116.351256, lat: 39.925325 };
    // 医院门诊
    $scope.locationFWOutpatient = { lng: 116.34998, lat: 39.925289 };
    // 医院停车场
    $scope.locationFWParking = { lng: 116.349711, lat: 39.925087 };
    // 天安门(测试用)
    $scope.locationTAM = { lng: 116.39732405, lat: 39.90874581 };
    // 天津之眼(测试用)
    $scope.locationTJZY = { lng: 117.18631, lat: 39.154161 };
    // 导航实例
    $scope.pathPlan = {};
    $scope.pathPlan.driving = {};
    $scope.pathPlan.transfer = {};
    $scope.pathPlan.riding = {};
    $scope.pathPlan.walking = {};
    // 地图总高度
    $scope.mapTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 108 : 88);
    // 起点
    $scope.startPoint = {};
    $scope.startPoint.keyword = "";
    $scope.startPoint.name = "";
    $scope.startPoint.location = { lng: 0, lat: 0 };
    // 搜索
    $scope.mapSearcData = {};
    $scope.mapSearcData.province = "";
    $scope.mapSearcData.city = "";
    $scope.mapSearcData.provinceList = {};
    $scope.mapSearcData.cityList = {};
    // 验证通知
    $scope.verifyNoticeInfo = new Object();
    $scope.verifyNoticeInfo.noticeAuth = true;
    $scope.accountInfo = new Object();
    // 受限用户申诉
    $scope.complaintStatus = -1;
    $scope.complaintMsg = "";
    $scope.blackComplaint = {};
    $scope.blackComplaint.data = "";
    // 支付途径
    $scope.paymentInfo = new Object();
    $scope.paymentInfo.method = "1";
    // 2018-10-26 14:54:25 可用支付方式
    $rootScope.paymentRouteList = [];

    // 2020-02-19 来院人员登记
    $scope.isOpenApptTemp = "0";
    $scope.temperature = {};
    $scope.tempSelect = [ { key: "是", value: 1 }, { key: "否", value: 0 } ];
    $scope.waySelect = [ "自驾车", "飞机", "火车" ];

    // 医保卡号提示
    $scope.MICodeHelp = "医保卡卡号位于卡片正面";

    // 自动问诊来的vpId
    $scope.paramVpId = $stateParams.vpId;
    // 添加证件类型数组
    // 2020-10-23 16:18:24 由于接口未完成 暂时屏蔽外国人
    // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
    //$scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证" }];
    // 2020-11-18 10:51:47 孙桑说自助机接口好了 开devMode测试外国人
    //if (devMode) {
    //    $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
    //}

    // 身高、体重
    $scope.needHeightWeight = devMode ? true : false;
    $scope.health = {};
    $scope.health.height = "";
    $scope.health.weight = "";

    // 可选择号序
    $scope.chooseSchedSeq = devMode ? true : false;
    $scope.chooseSchedSeqDescr = "以下号序可供您选择：";
    $scope.chooseSchedSeqNotice = "*选择号序仅供参考，实际号序以预约结果为准。";

    // 号序列表
    $scope.schedSeqList = [];
    // 选择的号序
    $scope.schedSeq = "0";
    // 时间选择
    $scope.opApptSelect = {};
    $scope.opApptSelect.schedTime = "";

    // 候补状态
    $scope.isSubmitWaitListSuccess = false;

    // 核酸流调
    $scope.needEpidSrvyNcp = false;
    $scope.epidSrvyId = "";
    $scope.epidSrvyQuestion = "";
    $scope.epidSrvyOptionList = [];

    // 代开药人
    $scope.needAgent = false;
    $scope.agent = {};
    $scope.agent.name = "";
    $scope.agent.idcard = "";
    $scope.agent.phone = "";
    $scope.agent.relation = "";
    $scope.agent.isShow = false;

    // 婚姻状况
    $scope.marital = {};
    $scope.marital.value = "";
    $scope.marital.show = false;

    // 北京医保小程序类型，zfb、wx
    $scope.BJYBMiniProgram = "";

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bindCardHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：多卡选择绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCardSelect.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardSelectModal = modal;
    });

    // 注册模态窗口：在线建档
    $ionicModal.fromTemplateUrl('applyCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.applyCardModal = modal;
    });

    // 注册模态窗口：添加症状
    $ionicModal.fromTemplateUrl('addSymptom.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addSymptomModal = modal;
    });

    // 注册模态窗口：医师介绍
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('doctorIntro.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('showAvatar.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 注册模态窗口：支付
    $ionicModal.fromTemplateUrl('pay.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.payModal = modal;
        $scope.slidePayReady();
    });

    // 注册模态窗口：通知授权帮助
    $ionicModal.fromTemplateUrl('noticeAuthHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.noticeAuthHelpModal = modal;
    });

    // 注册模态窗口 来院导航
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('map.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.amapModal = modal;
    });

    // 注册模态窗口 搜索起点
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('mapSearch.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.amapSearchModal = modal;
    });

    // 注册模态窗口：受限用户申诉
    $ionicModal.fromTemplateUrl('blackComplaint.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.blackComplaintModal = modal;
    });

    // 注册模态窗口：前置温馨提示
    $ionicModal.fromTemplateUrl('preNotice.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.preNoticeModal = modal;
    });

    // 注册模态窗口：来院人员信息采集
    $ionicModal.fromTemplateUrl('temperature.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.temperatureModal = modal;
    });

    // 医保号帮助
    $ionicModal.fromTemplateUrl('MICode_help.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.MICodeHelpModal = modal;
    });

    // 新来院登记
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('temperature.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.temperatureModalNew = modal;
    });

    // 选择号序
    $ionicModal.fromTemplateUrl('schedSeq.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.schedSeqModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.bindCardSelectModal.remove();
        $scope.applyCardModal.remove();
        $scope.addSymptomModal.remove();
        $scope.doctorIntroModal.remove();
        $scope.showAvatarModal.remove();
        $scope.payModal.remove();
        $scope.noticeAuthHelpModal.remove();
        $scope.amapModal.remove();
        $scope.amapSearchModal.remove();
        $scope.blackComplaintModal.remove();
        $scope.preNoticeModal.remove();
        $scope.temperatureModal.remove();
        $scope.MICodeHelpModal.remove();
        $scope.temperatureModalNew.remove();
        $scope.schedSeqModal.remove();
    })

    // 滑到上一步
    $scope.lastSlide = function () {
        slideOpAppt.previous();
        $scope.step = slideOpAppt.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideOpAppt.next();
        $scope.step = slideOpAppt.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOpAppt.slide(index);
        $scope.step = slideOpAppt.currentIndex();
        console.log("toSlide =>" + index);
        // 按医生预约=1
        if (index == '3') {
            // 之前不是按医生 重新加载出诊表
            if ($scope.apptMethod != '1') {
                $scope.apptMethod = '1';
                $scope.loadOpInfoList();
            }
        }
        // 按条件预约=2
        else if (index == '4') {
            $scope.apptMethod = '2';
        }
        // 按症状预约=3
        else if (index == '5') {
            $scope.apptMethod = '3';
            // 获取常见症状
            TriageService.rlatSymptom("", $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                // 查询成功
                if (data.result == 1) {
                    $scope.addSymptomData.rlats = data.data;
                    $scope.addSymptomData.common = data.common;
                }
                // 无结果
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function (data) {
                ;
            })
            // 获取上次就诊
            if ($scope.vpSelect.IS_BIND_CARD != 1) {
                if ($scope.step == 1) {
                    $fwCordovaToast.showShortBottom('当前就诊人未绑定就诊卡，无法查询复诊信息');
                    $scope.symptomData.isReview = false;
                }
                return;
            }
            if ($scope.reviewDataRequestId.length == 0) {
                // 请求上次就诊信息
                $scope.isLoadingHistory = true;
                TriageService.getLastOpInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                    // 查询成功
                    if (data.result == 1) {
                        $scope.reviewDataRequestId = data.data;
                        $scope.symptomData.isReview = true;
                    }
                    else if (data.result == -1) {        // 查询缓存
                        if (data.is_null == 1) {
                            $scope.reviewDataRequestId = data.data;
                        }
                        else {    // 原本data.data能直接用的，但是上次就诊信息返回特殊处理了
                            $scope.reviewDataRequestId = data.data[0].REQUEST_ID;
                        }
                        $scope.symptomData.isReview = true;
                    }
                    // 无结果
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $scope.symptomData.isReview = false;
                    }
                    // 有结果
                    if ($scope.symptomData.isReview) {
                        // 获取上次就诊信息
                        TriageService.respLastOpInfo($scope.reviewDataRequestId).then(function (data) {
                            console.log(data);
                            // 查询成功
                            if (data.result == 1 && data.is_null == 0) {
                                $scope.reviewData = data.data;
                            }
                            // 无结果
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                                $scope.symptomData.isReview = false;
                            }
                            $ionicLoading.hide();
                            $scope.isLoadFinish = true;
                            $scope.isLoadingHistory = false;
                        }, function (data) {
                            $ionicLoading.hide();
                            $scope.isLoadFinish = true;
                            $scope.symptomData.isReview = false;
                            $scope.isLoadingHistory = false;
                        })
                    }
                    else {
                        $ionicLoading.hide();
                        $scope.isLoadFinish = true;
                        $scope.isLoadingHistory = false;
                    }
                }, function (data) {
                    $ionicLoading.hide();
                    $scope.isLoadFinish = true;
                    $scope.isLoadingHistory = false;
                })
            }
        }
        // 信息确认
        else if (index == '10') {
            $scope.needEpidSrvyNcp = false;
            $scope.epidSrvyId = "";
            $scope.epidSrvyQuestion = "";
            $scope.epidSrvyOptionList = [];

            // 2023-2-1 13:34:01 HM #61141 流调已经取消了，这个验证是否有48小时核酸的流调更早取消了，避免重复请求，把判断条件前置
            if ($scope.configData.needEpidSrvyNcp == true) {
                $ionicLoading.show();
                VisitPatientService.epidemiolSrvyCheckNcp($scope.vpSelect.VISIT_PATIENT_ID, $scope.opInfoSelect.ID).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1 && data.data.status == 1) {
                        $scope.needEpidSrvyNcp = true;
                        $scope.epidSrvyId = data.data.epidSrvyId;
                        $scope.epidSrvyQuestion = data.data.question;
                        $scope.epidSrvyOptionList = data.data.optionList;
                        console.log($scope.epidSrvyOptionList);

                        $ionicScrollDelegate.resize();
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    var alertPopup = $ionicPopup.alert({
                        title: '网络错误',
                        template: '加载失败,请检查网络',
                        okText: "确定"
                    });
                })
            }
        }
    }

    // 返回
    $scope.goBack = function () {
        //$fwCordovaToast.showShortBottom("step: " + $scope.step);
        // 第0页（用户须知）正常后退
        if ($scope.step == 0) {
            if ($scope.from.length > 0) {
                // 智能分诊
                if ($scope.from.indexOf('app.triage') > -1) {
                    // 2020-7-2 11:23:40 HM 如果没有triageId，说明是从自动问诊来的，直接返回首页吧
                    if(typeof $scope.triageData.triageId != "undefined"){
                        $state.go("app.home");
                        return;
                    }

                    var strGo = '$state.go("' + $scope.triageData.from + '", { triageId: "' + $scope.triageData.triageId + '", doctorId: "' + $scope.triageData.doctorId + '"});'
                    console.log(strGo);
                    eval(strGo);
                }
                else if($scope.from.indexOf('autoInquiry') > -1){
                    // 如果有opinfoid，回自动问诊
                    if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0){
                        // 走新的
                        $state.go("app.autoInquiry", { vpid: $scope.paramVpId, firstFrom: $scope.autoInquiryData.firstFrom, continueInquiry: 1 });
                    }
                    else{
                        $state.go("app.home");
                    }
                }
                // 在线问诊
                else if ($scope.from.indexOf('app.consultation') > -1) {
                    $state.go("app.consultation", {vpid: $scope.paramVpId, doctorCode: $scope.consultationData.doctorCode});
                }
                // 特需医疗
                else if ($scope.from.indexOf('specialNeeds') > -1) {
                    $state.go("app.specialNeeds");
                }
                else {
                    eval('$state.go(' + $scope.from + ');');
                }
            }
            else {
                //$scope.toggleSlideMenu();
                $rootScope.goBack();
            }
        }
        // 选择就诊人
        else if ($scope.step == 2) {
            // 初始化数据
            // 选中的就诊人
            $scope.vpSelect = {};
            // 清空搜索
            $scope.clearSearch();
            // 医生出诊列表
            $scope.opInfoList = [];
            $scope.opInfoSelect = {};
            $scope.opInfoListEmpty = false;
            // 症状
            $scope.symptomData = {};
            $scope.symptomData.isReview = false;
            $scope.symptomData.symptoms = [];
            // 复查信息
            $scope.reviewDataRequestId = '';
            $scope.reviewData = [];
            $scope.intoReview = false;
            // 症状查询
            $scope.addSymptomData = {};
            $scope.addSymptomData.keyword = '';
            // 分诊结果
            $scope.sysptomResult = {};
            // 医师列表
            $scope.doctorData = {};
            $scope.doctorData.doctorList = [];
            // 是否正在获取历史就诊
            $scope.isLoadingHistory = false;
            $scope.lastSlide();
        }
        // 选择预约方式
        else if ($scope.step == 3 || $scope.step == 4 || $scope.step == 5) {
            $scope.toSlide(2);
        }
        // 选择预约方式 按特色技术/病种预约
        else if ($scope.step == 8) {
            // 初始化标题列表 特色技术/病种分组列表
            //$scope.configData.apptStepList.length = 11;
            // 从最后提前到第8-9页
            $scope.configData.apptStepList.splice(8, 2, "", "");
            $scope.specialityGroupData = {};
            $scope.toSlide(2);
        }
        // 预约信息确认
        else if ($scope.step == 10) {
            console.log($scope.apptMethod);
            // 智能分诊
            if ($scope.from.indexOf('app.triage') > -1) {
                $scope.toSlide(0);
            }
            // 自动问诊 并且 是带有opinfoid的
            else if ($scope.from.indexOf('app.autoInquiry') > -1 && (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0)) {
                $scope.toSlide(0);
            }
            // 在线问诊
            else if ($scope.from.indexOf('app.consultation') > -1) {
                $scope.toSlide(0);
            }
            // 出诊排班 或 专家介绍/搜索
            else if ($scope.from.indexOf('app.scheduling') > -1 || $scope.from.indexOf('app.doctorInfo') > -1) {
                $scope.toSlide(1);
            }
            // 按医生
            else if ($scope.apptMethod == "1") {
                $scope.toSlide(3);
            }
            // 按条件
            else if ($scope.apptMethod == "2") {
                $scope.toSlide(4);
            }
            // 按特色技术/病种
            else if ($scope.apptMethod == "4" || $scope.apptMethod == "5") {
                $scope.toSlide(9);
            }
            // 按症状 历史就诊
            else if ($scope.intoReview) {
                $scope.toSlide(6);
                $scope.intoReview = false;
            }
            // 按症状 医师列表
            else {
                $scope.lastSlide();
            }
        }
        // 已下单 待支付 选择支付方式 或 挂号结果 无论成功失败 全部跳转个人中心
        else if ($scope.step == 11 || $scope.step == 12) {
            $state.go('app.personal');
        }
        else {
            $scope.lastSlide();
        }
    }

    // 页面切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        //$fwCordovaToast.showShortBottom("step: " + $scope.step);
    }

    // 同意
    $scope.agree = function () {
        // 智能分诊
        if ($scope.from.indexOf('app.triage') > -1 && $scope.triageData.vpId != null) {
            // 就诊人id
            var index = $.inArray($scope.triageData.vpId, $scope.vpList.map(function (e) {
                return e.VISIT_PATIENT_ID;
            }));
            $scope.vpSelect = $scope.vpList[index];
            $scope.getLastHeightWeight();

            // 2023-7-27 15:17:07 HM 加载婚姻状况，和身高体重一样，走异步获取
            $scope.getHisPatientInfo();

            // 预约方式为按医生
            $scope.apptMethod = '1';
            // 根据传过来的opInfoId获取预约信息
            if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
                // 跳转到预约确认页面
                // 2020年疫情 =>跳来院登记
                // $scope.toSlide(10);

                // 2020-7-23 15:45:09 HM 按症状预约，从预约挂号 => 自动问诊 => 预约挂号
                if($scope.triageData.firstFrom == "opAppt"){
                    $scope.toSlide(10);
                }
                else{
                    // $scope.temperatureModalOpen(10);
                    // 2020-10-26 08:47:23 HM 新流调
                    $scope.temperatureShowNew(10);
                }
            }
        }
        // 自动问诊
        else if ($scope.from.indexOf('app.autoInquiry') > -1) {
            // 这里不用选就诊人，是因为加载就诊人列表的时候选过了，一期有需要返回到选择预约方式。
            // 预约方式为按医生
            $scope.apptMethod = '1';
            // 再加一手限制，如果没有opinfoid也不行
            if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
                // 去新流调
                $scope.temperatureShowNew(10);
            }
        }
        // 在线问诊
        else if($scope.from.indexOf('app.consultation') > -1) {
            var index = $.inArray($scope.paramVpId, $scope.vpList.map(function (e) {
                return e.VISIT_PATIENT_ID;
            }));
            $scope.vpSelect = $scope.vpList[index];
            $scope.getLastHeightWeight();

            // 2023-7-27 15:17:07 HM 加载婚姻状况，和身高体重一样，走异步获取
            $scope.getHisPatientInfo();

            // 预约方式为按医生
            $scope.apptMethod = '1';
            // 根据传过来的opInfoId获取预约信息
            if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
                // 2020-10-26 08:47:23 HM 新流调
                $scope.temperatureShowNew(10);
            }
            else{
                $scope.toSlide(1);
            }
        }
        else {
            $scope.toSlide(1);
        }
    }

    // 切换仅看可约
    $scope.switchShowAvailable = function () {
        $scope.showAvailable = !$scope.showAvailable;
        if ($scope.step == 9) {
            $scope.loadOpInfoListBySpecialityGroup();
        }
        else {
            if($scope.doctorSearch.isSearch){
                $scope.loadOpInfoListByDoctor();
            }
            else{
                $scope.loadOpInfoList();
            }
        }
    }

    // 切换科室
    $scope.changeDivision = function (division) {
        $scope.opApptData.division = division;
        $scope.loadOpInfoList();
    }

    // 切换时段
    $scope.changeSchedTime = function (schedTime) {
        if (localStorage.isEnglishMode == 1) {
            if ($scope.step == 9) {
                $scope.loadOpInfoListBySpecialityGroup();
            }
            else {
                $scope.loadOpInfoList();
            }
        }
        else {
            $scope.opApptData.schedTime = schedTime;
            if ($scope.step == 9) {
                $scope.loadOpInfoListBySpecialityGroup();
            }
            else {
                $scope.loadOpInfoList();
            }
        }
    }

    //  切换时段select
    $scope.changeSchedTimeSelect = function () {
        $scope.changeSchedTime($scope.opApptSelect.schedTime);
    }

    // 加载就诊人列表
    $scope.loadVpList = function () {
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                console.log($scope.vpList);

                // 等列表加载完了，再跳转
                if($scope.from.indexOf('app.triage') > -1 && $scope.triageData.firstFrom == "opAppt"){
                    $scope.agree();
                }

                if($scope.from.indexOf('autoInquiry') > -1){
                    var index = $.inArray($scope.paramVpId, $scope.vpList.map(function (e) {
                        return e.VISIT_PATIENT_ID;
                    }));
                    $scope.vpSelect = $scope.vpList[index];
                    $scope.getLastHeightWeight();

                    // 2023-7-27 15:17:07 HM 加载婚姻状况，和身高体重一样，走异步获取
                    $scope.getHisPatientInfo();

                    // 2020-12-23 14:34:34 HM 智能分诊二期，如果选择了预约，就不用选择预约方式了
                    if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
                        // 应该走第一页，去点须知，这里不用处理
                    }
                    else{
                        $scope.toSlide(2);
                    }
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.vpNew.idCardType = $scope.idCardTypeList[0].id;
        $scope.addVisitPatientModal.show();
    }

    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }

    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 姓名是否为空验证
        if (typeof ($scope.vpNew.realName) == "undefined" || $scope.vpNew.realName.replace(' ', '') == '') {
            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: '真实姓名不得为空',
                okText: '确定'
            });
            return;
        }

        // 证件编号是否为空
        if (typeof ($scope.vpNew.idCardCode) == "undefined" || $scope.vpNew.idCardCode.replace(' ', '') == '') {
            var text = "身份证号";
            if($scope.vpNew.idCardType == 5){
                text = "证件编码";
            }

            var alertPopup = $ionicPopup.alert({
                title: '添加失败',
                template: text +'不得为空',
                okText: '确定'
            });
            return;
        }

        // 如果选择的是护照/外国人永久身份证
        if ($scope.vpNew.idCardType == 5) {
            if (typeof ($scope.vpNew.sex) == "undefined" || $scope.vpNew.sex == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '性别不得为空',
                    okText: '确定'
                });
                return;
            }

            if (typeof ($scope.vpNew.birthday) == "undefined" || $scope.vpNew.birthday == '') {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '请选择出生日期',
                    okText: '确定'
                });
                return;
            }

            //对年龄进行判断
            $scope.today = new Date();
            $scope.today = $filter('date')($scope.today, 'yyyy-MM-dd');
            $scope.temp_birthday = $filter('date')($scope.vpNew.BIRTHDAY, 'yyyy-MM-dd');
            if ($scope.temp_birthday > $scope.today) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '出生日期不得大于当天，请重新选择',
                    okText: '确定'
                });
                return;
            }
        }

        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode, $scope.vpNew.idCardType, $scope.vpNew.sex, $scope.vpNew.birthday).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showShortBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }

    //#region 绑定就诊卡
    // 绑卡模态窗口显示
    $scope.bindCardShow = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;
        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
        $scope.bindCardModal.show();
    }

    // 绑卡模态窗口隐藏
    $scope.bindCardHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            id: '',
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0
        };
    }

    // 多卡选择绑卡模态窗口显示
    $scope.bindCardSelectShow = function () {
        $scope.bindCardSelectModal.show();
    }

    // 多卡选择绑卡模态窗口隐藏
    $scope.bindCardSelectHide = function () {
        $scope.bindCardSelectModal.hide();
    }

    // 选择就诊卡
    $scope.selectCard = function (index) {
        if (index != $scope.cardSelectIndex && index < $scope.cardList.length) {
            $scope.cardSelectIndex = index;
        }
    }

    // 多卡选择绑卡提交
    $scope.bindCardSelectSubmit = function () {
        if ($scope.cardSelectIndex >= $scope.cardList.length || $scope.cardList[$scope.cardSelectIndex] == null
            || $scope.cardList[$scope.cardSelectIndex].PATIENT_ID == null || $scope.cardList[$scope.cardSelectIndex].PATIENT_ID == '') {
            $fwCordovaToast.showShortBottom("就诊卡信息错误，请重新选择");
            return false;
        }
        $ionicLoading.show();
        var vpId = $scope.vpSelect.VISIT_PATIENT_ID;
        VisitPatientService.bindPatientCardSelect(vpId, $scope.cardList[$scope.cardSelectIndex].PATIENT_ID).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }
            else {
                //$fwCordovaToast.showShortBottom('就诊卡绑定成功');
                $fwCordovaToast.showShortBottom(data.msg);
                // 获取就诊人列表
                VisitPatientService.visitPatientList().then(function (data) {
                    // 获取成功
                    if (data.result == 1) {
                        $scope.vpList = data.data;
                        console.log($scope.vpList);
                        // 重新选择就诊人 检查预存账户状态
                        var vpListFilter = $scope.vpList.filter(e => e.VISIT_PATIENT_ID == vpId);
                        var vpTemp = vpListFilter.length > 0 ? vpListFilter[0] : null;
                        var index = $scope.vpList.indexOf(vpTemp);
                        console.log(index);
                        $ionicLoading.hide();
                        $scope.selectVisitPatient(index);
                        // 隐藏绑定页面
                        $scope.bindCardSelectHide();
                    }
                    // 获取失败
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                    }
                }, function (data) {
                    // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                })
            }
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpShow = function () {
        $scope.bindCardHelpModal.show();
    }

    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpHide = function () {
        $scope.bindCardHelpModal.hide();
    }

    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwCordovaToast.showShortBottom("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }

    // 绑卡提交
    $scope.bindCardSubmit = function () {
        console.log($scope.vpBind);
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
            return false;
        }
        $ionicLoading.show();
        VisitPatientService.bindVisitPatient($scope.vpBind.id, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self).then(function (data) {
            if (data.result == 0) {
                //$fwCordovaToast.showShortBottom(data.msg);
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg,
                    okText: '确定'
                });
            } else {
                $scope.bindCardHide();     // 隐藏绑定页面
                $scope.loadVpList();            // 重新获取患者信息
                // 2017.7.28 孙老师要求开通预存账户需上传身份证
                //$scope.toSlide(2);
                $fwCordovaToast.showShortBottom('就诊卡绑定成功');
            }
            $ionicLoading.hide();
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空',
                okText: '确定'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpBind.id, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                //$fwCordovaToast.showShortBottom(data.msg);
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg,
                    okText: '确定'
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        });
    }

    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
    //#endregion

    //#region 在线办卡
    // 办卡模态窗口显示
    $scope.applyCardShow = function (type) {
        // 复用办卡模态窗口，用于未开通预存患者上传身份证
        if (type == undefined) {
            $scope.applyCardType = 1;
        } else {
            $scope.applyCardType = type;
        }
        $scope.applyCardModal.show();
    }

    // 办卡模态窗口隐藏
    $scope.applyCardHide = function () {
        $scope.applyCardModal.hide();
        $scope.vpApply = {
            id: '',
            name: '',
            phone_num: null,
            address: '',
            idcard_code: '',
            id_type: '1',
            idcard_front: '',
            idcard_back: '',
            household_register: '',
            is_self: 0,
            apply_id: '',
            insurance_type: 0,
            mi_patient_code: '',
            marital: 0
        }
    }

    // 图片上传选择ActionSheet显示
    $scope.imgAddActionSheet = function (type) {
        // type == 0 --> 头像面, type == 1 --> 国徽面, type == 2 --> 户口簿
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg(type);
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg(type);
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function (type) {
        var options = {
            quality: 100,
            maximumImagesCount: 1,
            width: 0,
            height: 0
        };
        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList[0]);
            $scope.uploadImg(imageDataList[0], type);
        }, function (err) {
        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function (type) {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            $scope.uploadImg(imageData, type);
        }, function (err) {
        });
    }

    // 上传图片
    $scope.uploadImg = function (imageData, type) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageData.substr(imageData.lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: $scope.vpApply.apply_id + "/" + type };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        //var uri = encodeURI("http://10.10.101.11:8080/OpReg/UploadIDCard?id=" + $scope.vpApply.apply_id + "&type=" + type);
        // 显示上传等待
        $ionicLoading.show();
        // 上传图片
        //$fwCordovaToast.showShortBottom(uri);
        $cordovaFileTransfer.upload(uri, imageData, options, true).then(function (result) {
            //$cordovaToast.showLongBottom(angular.toJson(result));
            //console.log(result);
            //console.log(result.response);
            var fileResult = {};
            eval("fileResult = " + result.response);
            $ionicLoading.hide();
            // 上传成功
            if (fileResult.result == 1) {
                $fwCordovaToast.showShortBottom("上传成功");
                // 头像面
                if (type == 0) {
                    $scope.vpApply.idcard_back = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=0&randomStr=" + new Date().getTime();
                }
                // 国徽面
                else if (type == 1) {
                    $scope.vpApply.idcard_front = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=1&randomStr=" + new Date().getTime();
                }
                // 户口簿
                else if (type == 2) {
                    $scope.vpApply.household_register = uploadUrl + "/OpReg/IDCardImg?id=" + $scope.vpApply.apply_id + "&type=2&randomStr=" + new Date().getTime();
                }
            }
            // 上传失败
            else {
                $fwCordovaToast.showShortBottom(fileResult.msg);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + angular.toJson(error) + "。请稍后重试");
            console.log(angular.toJson(error));
        }, function (progress) {
            ;
        });
    }

    // 删除身份证照片
    $scope.deleteImg = function (type) {
        // confirm
        $ionicPopup.confirm({
            template: "确认删除并重新上传？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                OpRegService.deleteIDCard($scope.vpApply.apply_id, type).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1) {
                        if (type == "0") {
                            $scope.vpApply.idcard_back = "";
                        }
                        else if (type == "1") {
                            $scope.vpApply.idcard_front = "";
                        }
                        else if (type == "2") {
                            $scope.vpApply.household_register = "";
                        }
                        $fwCordovaToast.showShortBottom("删除成功");
                    }
                    else {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                }, function (resp) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
                });
            }
        })
    }

    // 格式化手机号
    $scope.formatPhone = function () {
        if ($scope.vpApply.phone_num.indexOf(' ') > -1) {
            $scope.vpApply.phone_num = $scope.vpApply.phone_num.split(' ').join('');
        }
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取基础字典
    $scope.getBaseDict = function () {
        IpRegService.getDict("AREA", "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.dict["prvn"] = data.data;
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取级联字典
    $scope.getChildDict = function (type, level) {
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        var parentDictCode = "";
        if (level == "PRVN") {
            $scope.vpApply.address_city = '';
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_city"] = [];
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_prvn;
            console.log($scope.dict[type.toLowerCase() + "_city"]);
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        else if (level == "CITY") {
            $scope.vpApply.address_dstr = '';
            $scope.dict[type.toLowerCase() + "_dstr"] = [];
            parentDictCode = $scope.vpApply.address_city;
            console.log($scope.dict[type.toLowerCase() + "_dstr"]);
        }
        if (parentDictCode == "" || parentDictCode == undefined || parentDictCode == null) {
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    $scope.dict[dictKey + "_dstr"] = [];
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 提交建卡申请
    $scope.submitCardApply = function () {
        console.log($scope.vpBind);
        // 格式化手机号
        $scope.formatPhone();
        if ($scope.applyCardType == 1) {
            // 2023-8-29 13:55:26 ZZL #hzfwx-107 提交前先验证省市区县是否已选择，进行地址拼接
            // 2024-3-7 20:06:30 CGZ 重新梳理逻辑，通过devMode控制前端控件，决定现住址是否结构化填写
            var isAddrFormat = false;
            // 现住址不为空-老流程填的，放过，走后边验证
            if ($scope.vpApply.address != '') {
                isAddrFormat = false;
            }
            // 现住址为空，省市县街道均不为空-新流程填全了，拼接现住址
            else if ($scope.vpApply.address_prvn != '' && $scope.vpApply.address_city != '' && $scope.vpApply.address_dstr != '' && $scope.vpApply.address_detail != '') {
                isAddrFormat = true;
                $scope.vpApply.address = '';
                var prvnItem = $filter('filter')($scope.dict['prvn'], { DICT_CODE: $scope.vpApply.address_prvn });
                $scope.vpApply.address += prvnItem.length > 0 ? prvnItem[0].DICT_NAME : "";
                var cityItem = $filter('filter')($scope.dict['address_city'], { DICT_CODE: $scope.vpApply.address_city });
                $scope.vpApply.address += cityItem.length > 0 ? cityItem[0].DICT_NAME : "";
                var dstrItem = $filter('filter')($scope.dict['address_dstr'], { DICT_CODE: $scope.vpApply.address_dstr });
                $scope.vpApply.address += dstrItem.length > 0 ? dstrItem[0].DICT_NAME : "";
                $scope.vpApply.address += $scope.vpApply.address_detail;
            }
            // 现住址为空，省市县街道之一为空-老流程没填或新流程没填全，提示
            else {
                $fwCordovaToast.showShortBottom('请完整填写现住址信息');
                return false;
            }
            // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，删除北京医保卡号验证($scope.vpApply.insurance_type == 1 && $scope.vpApply.mi_patient_code == "")
            if ($scope.vpApply.phone_num == '' || $scope.vpApply.address == '' || $scope.vpApply.is_self == 0
                || ($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == '')
                || $scope.vpApply.insurance_type == 0)
                || ($scope.vpApply.marital != '1' && $scope.vpApply.marital != '2' && $scope.vpApply.marital != 1 && $scope.vpApply.marital != 2)) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
            // 2024-2-21 09:37:56 ZZL hzfwx-700 计算现住址字节数，添加限制(10,40]
            var addressByteSize = getStringByteSize($scope.vpApply.address);
            //console.log($scope.vpApply.address + '(' + addressByteSize + ')');
            // 2024-3-8 10:27:00 CGZ 省市县拼接会超出40字节限制（如：新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县），按照自助机读取身份证信息建档逻辑，自动截取前20字
            if (isAddrFormat && addressByteSize > 40) {
                $scope.vpApply.address = $scope.vpApply.address.substr(0, 20);
                addressByteSize = getStringByteSize($scope.vpApply.address);
            }
            else if (addressByteSize <= 10 || addressByteSize > 40) {
                var msgStr = addressByteSize <= 10 ? "现住址长度过短" : "现住址长度过长";
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: msgStr,
                    okText: '确定'
                }).then(function () {
                });
                return false;
            }
            // 2023-12-8 13:46:23 ZZL hzfwx-442 医保卡号添加长度限制，超过15位提示，避免超长导致自助机接口报错
            // 2024-2-22 15:57:38 ZZL hzfwx-714 经沟通三代医保卡升级，无需再填写医保卡号，去掉前端、后端、接口、轮询限制，屏蔽掉
            if ($scope.vpApply.mi_patient_code !== undefined && $scope.vpApply.mi_patient_code !== '' && $scope.vpApply.mi_patient_code !== null && $scope.vpApply.mi_patient_code.length > 15) {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: '医保卡号格式不正确，请检查后重新填写',
                    okText: '确定'
                }).then(function () {
                    $scope.MICodeHelpModalShow();
                });
                return false;
            }
        } else if ($scope.applyCardType == 2) {
            if (($scope.vpApply.id_type == '1' && ($scope.vpApply.idcard_front == '' || $scope.vpApply.idcard_back == '')
                || ($scope.vpApply.id_type == '2' && $scope.vpApply.household_register == ''))) {
                $fwCordovaToast.showShortBottom('请完整填写就诊人信息');
                return false;
            }
        }
        $ionicLoading.show();
        // 提交建卡申请
        OpRegService.submitCardApply($scope.vpApply.apply_id, $scope.vpApply.id, $scope.vpApply.address, $scope.vpApply.phone_num, $scope.vpApply.is_self, 0, $scope.vpApply.id_type,
            $scope.vpApply.insurance_type, $scope.vpApply.mi_patient_code, $scope.vpApply.marital).then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                // data == 1 --> 建卡成功
                if (data.data == 1) {
                    $scope.applyCardHide();     // 隐藏绑定页面
                    $scope.loadVpList();            // 重新获取患者信息
                    //$scope.toSlide(2);
                    // 2020年疫情 =>来院登记
                    // $scope.temperatureModalOpen(2);
                    // 2020-10-26 08:47:23 HM 新流调
                    $scope.temperatureShowNew(2);
                    if ($scope.applyCardType == 1) {
                        $fwCordovaToast.showShortBottom('在线建档成功');
                    } else if ($scope.applyCardType == 2) {
                        $fwCordovaToast.showShortBottom('开通预存账户成功');
                    }
                }
                // data == 0 --> 建卡失败
                else if (data.data == 0) {
                    // 2021-4-29 08:11:09 HM 提交建卡申请，错误提示，修改成popup
                    //$fwCordovaToast.showShortBottom(data.msg);
                    var alertPopup = $ionicPopup.alert({
                        title: '提示',
                        template: data.msg,
                        okText: '确认'
                    });
                }
            }
            // 获取失败
            else if (data.result == 99) {
                $fwCordovaToast.showShortBottom("服务繁忙，请稍后重试");
            } else {
                // 2021-5-6 08:16:13 此处报错包含实名认证失败提示 改为popup
                //$fwCordovaToast.showShortBottom(data.msg);
                var alertPopup = $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: '确定'
                });
            }
            $ionicLoading.hide();
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }
    //#endregion

    // 选择就诊人之前判断是否需要弹出窗口绑卡/办卡
    $scope.selectVisitPatient = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];

        // 2021-5-13 18:59:12 HM 从出诊排班跳转，身高体重不会被加载，故选择就诊人后，就加载身高体重
        $scope.getLastHeightWeight();

        // 2023-7-27 15:17:07 HM 加载婚姻状况，和身高体重一样，走异步获取
        $scope.getHisPatientInfo();

        // 2017.7.27 bst 孙老师试用反馈，无默认绑卡功能，全部要求绑定
        // 2017.8.8 bst 杨国胜有要求改回来 MDZZ
        if ($scope.vpSelect.IS_BIND_CARD == '1' || $scope.vpSelect.IS_BIND_CARD == '2' || $scope.vpSelect.IS_BIND_CARD == '3') {
            // 2017.7.27 bst 孙老师试用反馈，若患者未开通预存账户，需上传身份证照片
            // 检查是否开通预存账户
            $ionicLoading.show();
            PaymentService.checkPrePayAccount($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                // 请求错误
                if (data.result == 0 || data.result == -99) {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                // 请求成功
                if (data.result == 1) {
                    // 未开通预存账户
                    if (data.is_null == 1) {
                        console.log('开通预存账户');
                        OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 2).then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $ionicLoading.hide();
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0 直接提交
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                if ($scope.vpApply.id_type == '0') {
                                    $scope.applyCardType = 2;
                                    $scope.submitCardApply();
                                }
                                else {
                                    // 显示办卡提示
                                    var applyCardPopup = $ionicPopup.show({
                                        title: '注意',
                                        template: "患者预存账户未开通，请上传身份证开通预存账户",
                                        buttons: [{
                                            text: '确定',
                                            type: 'button-positive',
                                            onTap: function (e) {
                                                applyCardPopup.close();
                                                // 不加timeout popup关不掉
                                                $timeout(function () {
                                                    $scope.applyCardShow(2);
                                                }, 0);
                                            }
                                        }]
                                    });
                                }
                            }
                            // 获取失败
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        }, function (data) {
                            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                        })
                        return;
                    }
                    // 门诊预存账户余额为负数
                    else if (data.is_null == 2) {
                        $fwCordovaToast.showShortBottom(data.msg);
                        $ionicLoading.hide();
                        return;
                    }
                    // 已开通预存账户
                    console.log(data.data);
                    // 从出诊排班过来的
                    // 预约方式为按医生
                    $scope.apptMethod = '1';
                    $ionicLoading.hide();
                    // 从医师出诊表传了opInfoId过来 直接跳转到预约确认界面
                    if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
                        // 2020-02-19 补：来院人员信息采集
                        // $scope.temperatureModalOpen(10);
                        // 2020-10-26 08:47:23 HM 新流调
                        $scope.temperatureShowNew(10);
                        // 跳转到预约确认页面
                        // $scope.toSlide(10);
                    }
                    // 继续下一步 选择预约方式等
                    else {
                        // 2020-02-19 补：来院人员信息采集
                        // $scope.temperatureModalOpen(2);
                        // 2020-10-26 08:47:23 HM 新流调
                        $scope.temperatureShowNew(2);
                        // $scope.toSlide(2);
                    }
                }
                else {
                    $ionicLoading.hide();
                }
            }, function (data) {
                // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            })
        }
        // 未绑卡
        else if ($scope.vpSelect.IS_BIND_CARD == '0') {
            $ionicLoading.show();
            // 获取办卡状态
            OpRegService.patientCheck($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    // 无卡 --> 办卡
                    if (data.is_null == 1) {
                        console.log('无卡: ' + data.msg);
                        var createCardMsg = data.msg;
                        // 创建建卡申请 供上传图片使用
                        OpRegService.createCardApply($scope.vpSelect.VISIT_PATIENT_ID, 1).then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $scope.vpApply.id = data.data.VISIT_PATIENT_ID;
                                $scope.vpApply.name = data.data.PATIENT_NAME;
                                $scope.vpApply.phone_num = data.data.PHONENUM;
                                $scope.vpApply.address = data.data.ADDRESS;
                                $scope.vpApply.idcard_code = data.data.IDCARD_CODE;
                                $scope.vpApply.idcard_front = data.data.IDCARD_FRONT.length > 0 ? (uploadUrl + data.data.IDCARD_FRONT) : "";
                                $scope.vpApply.idcard_back = data.data.IDCARD_BACK.length > 0 ? (uploadUrl + data.data.IDCARD_BACK) : "";
                                $scope.vpApply.is_self = data.data.IS_SELF;
                                $scope.vpApply.apply_id = data.data.APPLY_CARD_ID;
                                // 2019-6-3 11:16:32 若无需上传证件照片 ID_TYPE = 0
                                $scope.vpApply.id_type = data.data.ID_TYPE;
                                $scope.vpApply.insurance_type = data.data.INSURANCE_TYPE;
                                $scope.vpApply.mi_patient_code = data.data.MI_PATIENT_CODE;
                                // 2023-7-19 09:01:07 HM 婚姻情况
                                $scope.vpApply.marital = data.data.MARITAL;

                                // 险种类别：医保卡号说明
                                $scope.MICodeHelp = data.MIPatientCodeHelp;

                                // 显示办卡提示
                                var applyCardPopup = $ionicPopup.show({
                                    title: '注意',
                                    template: createCardMsg,
                                    buttons: [{
                                        text: '确定',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            applyCardPopup.close();
                                            // 不加timeout popup关不掉
                                            $timeout(function () {
                                                $scope.applyCardShow(1);
                                            }, 0);
                                        }
                                    }]
                                });
                            }
                            // 获取失败
                            else {
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                            $ionicLoading.hide();
                        }, function (data) {
                            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                        })
                    }
                    // 一张卡 --> 下一步
                    else if (data.is_null == 0) {
                        console.log('一张卡: ' + data.msg);
                        // 2019-6-6 17:27:53 一张卡可能未开通预存账户 调用选择就诊人重新判断
                        //$scope.toSlide(2);
                        // 2019-6-13 13:43:17 重新获取就诊人列表 刷新绑卡等状态
                        VisitPatientService.visitPatientList().then(function (data) {
                            // 获取成功
                            if (data.result == 1) {
                                $ionicLoading.hide();
                                $scope.vpList = data.data;
                                console.log($scope.vpList);
                                // 重新选择当前就诊人
                                $scope.selectVisitPatient(index);
                            }
                            // 获取失败
                            else {
                                $ionicLoading.hide();
                                $fwCordovaToast.showShortBottom(data.msg);
                            }
                        }, function () {
                            $ionicLoading.hide();
                        })
                    }
                    // 多张卡 --> 绑卡
                    else if (data.is_null == 2) {
                        console.log('多张卡: ' + data.msg);
                        $scope.cardList = data.data;
                        $ionicLoading.hide();
                        // 显示绑卡提示
                        var bindCardPopup = $ionicPopup.show({
                            title: '提示',
                            template: data.msg,
                            buttons: [{
                                text: '确定',
                                type: 'button-positive',
                                onTap: function (e) {
                                    bindCardPopup.close();
                                    // 不加timeout popup关不掉
                                    $timeout(function () {
                                        $scope.bindCardSelectShow();
                                    }, 0);
                                }
                            }]
                        });
                    }
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                    }
                }
                // 获取错误
                else {
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg ? data.msg : "网络错误,请稍后重试");
                }
            }, function () {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            })
        }
    }

    // 按条件刷新医生列表
    $scope.loadOpInfoList = function () {
        $ionicLoading.show();
        $scope.opInfoListEmpty = false;
        $scope.opInfoListByDoctorEmpty = true;
        $scope.opInfoList = [];
        // 可选搜索条件
        var doctorLevel = $scope.opApptData.doctorLevel ? $scope.opApptData.doctorLevel : "";
        var speciality = $scope.opApptData.speciality ? $scope.opApptData.speciality : "";
        var doctorName = $scope.opApptData.doctorName ? $scope.opApptData.doctorName : "";
        OpApptService.getScheduling($scope.opApptData.division, $scope.opApptData.schedDate, $scope.opApptData.schedTime, doctorLevel, speciality, doctorName).then(function (data) {
            console.log(data);
            // 查询成功
            for (var i = 0; i < data.ds.length; i++) {
                // 若仅看可约 且 APPT_STATUS != 1 跳过
                if ($scope.showAvailable && data.ds[i].APPT_STATUS != "1") { continue; }
                $scope.opInfoList.push(data.ds[i])
            }

            // 2022-5-19 09:44:46 WX 特需医疗进来的只看特需
            if ($scope.from == "specialNeeds") {
                $scope.opInfoList = $scope.opInfoList.filter(item => item.SCHED_LEVEL == "特需");
            }

            if ($scope.opInfoList.length == 0) {
                $scope.opInfoListEmpty = true;
            }
            // 2019-10-22 08:03:12 HM 当日预约，过上午，点击上午，弹toast
            var today = new Date();
            var date = $filter('date')(today,'yyyy-MM-dd');
            date = date + " 00:00:00";
            if ($scope.configData.todaySign == "PM" && $scope.opApptData.schedTime == "1" && $scope.opApptData.schedDate == date) {
                $fwCordovaToast.showShortBottom("当前时段预约已关闭");
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListEmpty = true;
            $ionicLoading.hide();
        })
    }

    // 根据医生姓名查询列表 2019-9-25 16:26:11 HM
    $scope.loadOpInfoListByDoctor = function () {
        $ionicLoading.show();
        $scope.opInfoListByDoctor = [];
        $scope.opInfoListEmpty = true;
        $scope.opInfoListByDoctorEmpty = false;

        OpApptService.getSchedulingByDoctorName($scope.opApptData.doctorName).then(function (data) {
            for(var i=0;i<data.data.length;i++){
                var result = data.data[i];
                var regDate = data.data[i].REG_DATE.split(",");
                var regDateList = new Array();
                for(var j=0;j<regDate.length;j++){
                    var obj = new Object();
                    var reg = regDate[j].split("|");
                    reg[0] = reg[0].slice(5);
                    obj.date = reg[0];
                    obj.count = reg[1];
                    regDateList.push(obj);
                }

                result.regDateList = regDateList;
                console.log($scope.showAvailable);

                if(!$scope.showAvailable || result.REMAIN_COUNT > 0){
                    $scope.opInfoListByDoctor.push(result);
                }
            }

            if($scope.opInfoListByDoctor.length == 0){
                $scope.opInfoListByDoctorEmpty = true;
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListByDoctorEmpty = true;
            $ionicLoading.hide();
        })
    }

    // 搜索医师
    $scope.searchDoctor = function () {
        if ($scope.doctorSearch.keyword == "") {
            $fwCordovaToast.showShortBottom("请输入医生姓名进行搜索");
            return false;
        }
        $scope.doctorSearch.isSearch = true;
        $scope.opApptData.doctorName = $scope.doctorSearch.keyword;
        $scope.loadOpInfoListByDoctor();
    }

    // 清空搜索结果
    $scope.clearSearch = function () {
        $scope.doctorSearch.list = new Array();
        $scope.doctorSearch.keyword = "";
        $scope.opApptData.doctorName = "";
        $scope.doctorSearch.isSearch = false;
        $scope.doctorSearch.isEmpty = false;
        // 2019-9-25 16:26:11 HM 增加+ 查询医生列表重置
        $scope.opInfoListByDoctorEmpty = true;
        $scope.loadOpInfoList();
    }

    // 医师介绍
    $scope.doctorIntro = function (doctorId, doctorLevel, doctorCode, doctorName, isReview, doctorPath, doctorSpeciality) {
        // 2019-9-27 07:50:01 HM 切换医师选择，号表重置
        //$scope.schedulingModal = null;
        // 若无对照医师信息，不做弹出处理
        // 2019年9月25日16:29:09 HM 预约挂号优化，做弹出处理
//        if (doctorId == undefined || doctorId.length == 0) {
//            return;
//        }
        $scope.intoReview = isReview == null ? false : true;
        $scope.doctorInfo = new Object();
        $ionicLoading.show();
        // 2019-9-23 15:31:08 HM 医师简介优化，GW没有维护的数据，从前一页拽过来
        if (doctorId == undefined || doctorId.length == 0) {

            var data = new Object();
            data.avatar_path = doctorPath;
            data.description = "";
            data.doctor_code = doctorCode;
            data.doctor_id = doctorId;
            data.doctor_name = doctorName;
            data.speciality = doctorSpeciality;
            data.title = doctorLevel;
            $scope.doctorInfo = data;

            OpApptService.getDoctorScheduling(doctorCode).then(function (data) {
                $scope.schedulingModal = data;
                console.log(data);

                //$scope.doctorIntroModal.show();
                //$ionicScrollDelegate.$getByHandle('intro').scrollTop();
                $ionicLoading.hide();
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
        }
        else{
             DoctorInfoService.doctorInfo(doctorId).then(function (data) {
                $scope.doctorInfo = data;
                if (doctorLevel.toString() != "") {
                    $scope.doctorInfo.title = doctorLevel;
                }
                // 当前医师出诊表
                if (doctorCode != '') {
                    OpApptService.getDoctorScheduling(doctorCode).then(function (data) {
                        $scope.schedulingModal = data;
                        console.log(data);
                        $ionicLoading.hide();
                    }, function (resp) {
                        var alertPopup = $ionicPopup.alert({
                            title: '网络错误',
                            template: '加载失败,请检查网络'
                        });
                        $ionicLoading.hide();
                    });
                }
            }, function (resp) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
            });
        }
        $scope.doctorIntroModal.show();
        $ionicScrollDelegate.$getByHandle('intro').scrollTop();
    }

    // 医师介绍隐藏
    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
        $scope.schedulingModal = null;
    }

    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }

    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    // 2017-9-13 17:57:22 增加受限用户申诉相关方法
    // 受限用户申诉模态窗口显示
    $scope.blackComplaintShow = function () {
        // 可申诉状态弹出填写窗口
        if ($scope.complaintStatus == 1) {
            $scope.blackComplaintModal.show();
        }
        // 未审核/已驳回 toast提示
        else {
            $fwCordovaToast.showShortBottom($scope.complaintMsg);
        }
    }

    // 受限用户申诉模态窗口隐藏
    $scope.blackComplaintHide = function () {
        $scope.blackComplaintModal.hide();
        $scope.blackComplaint = {};
        $scope.blackComplaint.data = "";
    }

    // 提交黑名单申诉
    $scope.submitBlackComplaint = function () {
        $ionicLoading.show();
        AddWishService.submitBlackComplaint($scope.vpSelect.VISIT_PATIENT_ID, encodeURIComponent($scope.blackComplaint.data)).then(function (data) {
            // 申诉成功
            if (data.result == 1) {
                // 重置申诉状态
                $scope.complaintStatus = data.complaintStatus;
                $scope.complaintMsg = data.complaintMsg;
                // 隐藏模态窗口
                $scope.blackComplaintHide();
            }
            // 申诉失败
            else {
                //$fwCordovaToast.showShortBottom(data.msg);
            }
            $fwCordovaToast.showShortBottom(data.msg);
            $ionicLoading.hide();
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
            $ionicLoading.hide();
        })
    }

    // 弹出来院导航
    $scope.amapShow = function () {
        $scope.mapMode = 'map';
        $scope.mapLastMode = $scope.mapMode;
        $scope.startPoint.keyword = "我的位置";
        $scope.startPoint.name = "我的位置";
        $scope.amapModal.show();
        // 初始化地图
        $scope.initMap();
    }

    // 初始化地图
    $scope.initMap = function () {
        if (typeof (AMap) != "undefined") {
            $ionicLoading.show();
        }
        // 初始化地图
        $scope.map = new AMap.Map('aMapContainer', {
            resizeEnable: true,
            zoom: 15,
            center: [$scope.locationFWCenter.lng, $scope.locationFWCenter.lat]
        });
        // 工具栏
        $scope.map.plugin(["AMap.ToolBar"], function () {
            var toolBar = new AMap.ToolBar({
                locate: true// 定位按钮
                //autoPosition: true// 自动定位
            });
            $scope.map.addControl(toolBar);
        });
        // 比例尺
        $scope.map.plugin(["AMap.Scale"], function () {
            var scale = new AMap.Scale();
            $scope.map.addControl(scale);
        });
        // 医院标记点
        var marker = new AMap.Marker({
            icon: "lib/amap/mark_r.png",
            position: [$scope.locationFWCenter.lng, $scope.locationFWCenter.lat]
        });
        marker.setMap($scope.map);
        if (typeof (AMap) != "undefined") {
            $ionicLoading.hide();
        }
    }

    // 切换地图模式
    $scope.changeMapMode = function (mapMode) {
        if ($scope.mapLastMode == mapMode) {
            return;
        }
        $scope.mapMode = mapMode;
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        // 上次和本次都是导航
        if ($scope.mapLastMode != "map" && mapMode != "map") {
            // 清除所有导航结果
            for (var i in $scope.pathPlan) {
                if ($scope.pathPlan[i].clear) {
                    $scope.pathPlan[i].clear();
                }
            }
        }
        // 上次是地图 这次是导航 或 上次是导航 这次是地图
        else {
            // 销毁地图重新初始化 ps:iOS不触发resize事件
            $scope.map.destroy();
            $("#aMapContainer").css("height", mapMode == "map" ? ($scope.mapTotalHeight + "px") : "61.8vw");
            $scope.initMap();
            console.log('地图大小变为：' + $scope.map.getSize().width + "*" + $scope.map.getSize().height);
        }
        $scope.mapLastMode = mapMode;
        if (mapMode != "map") {
            if ($scope.startPoint.name == "我的位置") {
                // 根据定位导航
                $scope.getLocation(mapMode);
            }
            else {
                // 从起点开始导航
                $scope.planPath(mapMode, $scope.startPoint.location);
            }
        }
    }

    // 获取定位信息
    $scope.getLocation = function (mapMode) {
        $ionicLoading.show();
        // 插件定位
        console.log('定位开始');
        $cordovaGeolocation.getCurrentPosition({
            enableHighAccuracy: true, // 高精度
            timeout: 5000, // 超时时间
            maximumAge: 10000// 缓存有效时间
        }).then(function (position) {
            console.log('定位成功');
            console.log('WGS坐标：' + position.coords.longitude + ', ' + position.coords.latitude);
            // 高德坐标转换 WGS -> GCJ
            AMap.convertFrom(new AMap.LngLat(position.coords.longitude, position.coords.latitude), 'gps', function (status, result) {
                if (status == 'complete' && result.info == 'ok') {
                    console.log('坐标转换成功');
                    $scope.locationGCJ.lng = result.locations[0].lng;
                    $scope.locationGCJ.lat = result.locations[0].lat;
                    // 天安门坐标（测试用）
                    //$scope.locationGCJ.lng = $scope.locationTAM.lng;
                    //$scope.locationGCJ.lat = $scope.locationTAM.lat;
                    console.log('GCJ坐标：' + $scope.locationGCJ.lng + ', ' + $scope.locationGCJ.lat);
                    // 赋值给起点位置
                    $scope.startPoint.location.lng = $scope.locationGCJ.lng;
                    $scope.startPoint.location.lat = $scope.locationGCJ.lat;
                    // 规划路径
                    $scope.planPath(mapMode, $scope.startPoint.location);
                    $ionicLoading.hide();
                }
                else {
                    console.log('坐标转换失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('坐标转换失败，请稍后再试');
                    $ionicLoading.hide();
                }
            });
        }, function (error) {
            console.log('定位失败');
            console.log(error);
            $fwCordovaToast.showShortBottom('定位失败，请开启定位权限后再试');
            $ionicLoading.hide();
        });
    }

    // 导航
    $scope.planPath = function (mapMode, locationStart) {
        // 驾车
        if (mapMode == "driving") {
            $scope.planDriving(locationStart, $scope.locationFWParking);
        }
        // 公交
        else if (mapMode == "transfer") {
            $scope.planTransfer(locationStart, $scope.locationFWOutpatient);
        }
        // 骑行
        else if (mapMode == "riding") {
            $scope.planRiding(locationStart, $scope.locationFWOutpatient);
        }
        // 步行
        else if (mapMode == "walking") {
            $scope.planWalking(locationStart, $scope.locationFWOutpatient);
        }
        else {
            console.log('导航方式错误');
        }
    }

    // 驾车导航
    $scope.planDriving = function (start, end) {
        $ionicLoading.show();
        console.log('规划驾车路线开始');
        AMap.plugin(["AMap.Driving"], function () {
            $scope.pathPlan.driving = new AMap.Driving({
                map: $scope.map,
                panel: "aMapPanel_driving"
            });
            //根据起终点坐标规划路线
            $scope.pathPlan.driving.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                if (status == 'complete') {
                    console.log('规划驾车路线成功');
                    //console.log(result);
                    //$scope.map.panBy
                }
                else {
                    console.log('规划驾车路线失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('规划驾车路线失败，请稍后再试');
                }
                $ionicLoading.hide();
            });

        });
    }

    // 公交导航
    $scope.planTransfer = function (start, end) {
        $ionicLoading.show();
        console.log('计算起点所在城市开始');
        AMap.plugin(["AMap.Geocoder"], function () {
            var geocoder = new AMap.Geocoder();
            geocoder.getAddress(new AMap.LngLat(start.lng, start.lat), function (status, result) {
                // TODO:  && result.info === 'OK'
                if (status == 'complete') {
                    console.log('计算起点所在城市成功');
                    console.log('起点为：' + result.regeocode.addressComponent.province + ',' + result.regeocode.addressComponent.city + ',' + result.regeocode.addressComponent.citycode + ',' + result.regeocode.addressComponent.adcode);
                    console.log('规划公交路线开始');
                    AMap.plugin(["AMap.Transfer"], function () {
                        $scope.pathPlan.transfer = new AMap.Transfer({
                            map: $scope.map,
                            panel: "aMapPanel_transfer",
                            city: result.regeocode.addressComponent.citycode,
                            cityd: "010"
                        });
                        //根据起终点坐标规划路线
                        $scope.pathPlan.transfer.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                            if (status == 'complete') {
                                console.log('规划公交路线成功');
                                //console.log(result);
                            }
                            else {
                                console.log('规划公交路线失败');
                                console.log(status);
                                console.log(result);
                                $fwCordovaToast.showShortBottom('规划公交路线失败，请稍后再试');
                            }
                        });

                    });
                }
                else {
                    console.log('计算起点所在城市失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('计算起点所在城市失败，请稍后再试');
                }
                $ionicLoading.hide();
            });
        });
    }

    // 骑行导航
    $scope.planRiding = function (start, end) {
        $ionicLoading.show();
        console.log('规划骑行路线开始');
        AMap.plugin(["AMap.Riding"], function () {
            $scope.pathPlan.riding = new AMap.Riding({
                map: $scope.map,
                panel: "aMapPanel_riding"
            });
            //根据起终点坐标规划路线
            $scope.pathPlan.riding.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                if (status == 'complete') {
                    console.log('规划骑行路线成功');
                    //console.log(result);
                }
                else {
                    console.log('规划骑行路线失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('规划骑行路线失败，请稍后再试');
                }
                $ionicLoading.hide();
            });

        });
    }

    // 步行导航
    $scope.planWalking = function (start, end) {
        $ionicLoading.show();
        console.log('规划步行路线开始');
        AMap.plugin(["AMap.Walking"], function () {
            $scope.pathPlan.walking = new AMap.Walking({
                map: $scope.map,
                panel: "aMapPanel_walking"
            });
            //根据起终点坐标规划路线
            $scope.pathPlan.walking.search(new AMap.LngLat(start.lng, start.lat), new AMap.LngLat(end.lng, end.lat), function (status, result) {
                if (status == 'complete') {
                    console.log('规划步行路线成功');
                    //console.log(result);
                }
                else {
                    console.log('规划步行路线失败');
                    console.log(status);
                    console.log(result);
                    $fwCordovaToast.showShortBottom('规划步行路线失败，请稍后再试');
                }
                $ionicLoading.hide();
            });

        });
    }

    // 隐藏来院导航
    $scope.amapHide = function () {
        $("#aMapContainer").css("height", $scope.mapTotalHeight + "px");
        $scope.amapModal.hide();
        $scope.mapLastMode = 'map';
        $scope.map.destroy();
    }

    // 弹出起点搜索
    $scope.amapSearchShow = function () {
        //$scope.mapSearcData = {};
        $ionicLoading.show();
        $scope.amapSearchModal.show();
        if ($scope.mapSearch._amap_id) {
            console.log("搜索地图已初始化，id: " + $scope.mapSearch._amap_id);
            $scope.searchStart();
        }
        else {
            console.log("搜索地图未初始化");
            $scope.initMapSearch();
        }
    }

    // 初始化起点搜索地图
    $scope.initMapSearch = function () {
        // 初始化地图
        $scope.mapSearch = new AMap.Map('aMapSearchContainer', {
            resizeEnable: true,
            zoom: 10,
            center: [$scope.locationTAM.lng, $scope.locationTAM.lat]
        });
        // 工具栏
        $scope.mapSearch.plugin(["AMap.ToolBar"], function () {
            var toolBar = new AMap.ToolBar({
                locate: true// 定位按钮
                //autoPosition: true// 自动定位
            });
            $scope.mapSearch.addControl(toolBar);
        });
        // 比例尺
        $scope.mapSearch.plugin(["AMap.Scale"], function () {
            var scale = new AMap.Scale();
            $scope.mapSearch.addControl(scale);
        });
        // 省市搜索
        AMap.service('AMap.DistrictSearch', function () {
            //实例化DistrictSearch
            $scope.mapSearch.districtSearch = new AMap.DistrictSearch({
                level: 'country',
                subdistrict: 1,
                showbiz: false
            });
            // 获取全国省份列表
            $scope.mapSearch.districtSearch.search(100000, function (status, result) {
                console.log(status);
                console.log(JSON.stringify(result));
                if (status == "complete" && result.info == "OK") {
                    $scope.mapSearcData.provinceList = result.districtList[0].districtList;
                    //$scope.mapSearcData.cityList = {};
                }
                $ionicLoading.hide();
            })
        })
        // 搜索地点
        $scope.mapSearch.plugin(["AMap.PlaceSearch"], function () {
            $scope.mapSearch.placeSearch = new AMap.PlaceSearch({
                pageSize: 20,
                pageIndex: 1
            });
        });
        // 搜索结果
        $scope.mapSearch.placeSearchRender = new Lib.AMap.PlaceSearchRender();
    }

    // 搜索所属城市
    $scope.searchCity = function () {
        // 清空原城市列表
        $scope.mapSearcData.city = "";
        $scope.mapSearcData.cityList.length = 0;
        // 设置地图中心
        $scope.mapSearch.setCenter($scope.mapSearcData.provinceList[$scope.mapSearcData.province].center)
        // 搜索当前省份所属城市
        $scope.mapSearch.districtSearch.setLevel("province");
        $scope.mapSearch.districtSearch.search($scope.mapSearcData.provinceList[$scope.mapSearcData.province].adcode, function (status, result) {
            console.log(status);
            console.log(JSON.stringify(result.districtList[0].districtList));
            if (status == "complete" && result.info == "OK") {
                $scope.$apply($scope.mapSearcData.cityList = result.districtList[0].districtList);
                //$scope.mapSearcData.cityList = {};
            }
        })
        // 在当前省份搜索
        $scope.searchStart();
    }

    // 选择城市
    $scope.selectCity = function () {
        console.log(JSON.stringify($scope.mapSearcData.cityList[$scope.mapSearcData.city]));
        // 设置地图中心
        $scope.mapSearch.setCenter($scope.mapSearcData.cityList[$scope.mapSearcData.city].center)
        // 在当前城市搜索
        $scope.searchStart();
    }

    // 清空关键词
    $scope.clearKeyword = function () {
        if ($scope.startPoint.keyword == "我的位置") {
            $scope.startPoint.keyword = "";
        }
    }

    // 搜索地点
    $scope.searchStart = function () {
        console.log('搜索地点开始');
        if ($scope.startPoint.keyword == "" || $scope.startPoint.keyword.length == 0 || $scope.startPoint.keyword == "我的位置") {
            // 定位位置设置地图中心
            $scope.mapSearch.setCenter(new AMap.LngLat($scope.locationGCJ.lng, $scope.locationGCJ.lat));
            $scope.mapSearch.setZoom(16);
            // 清除搜索结果
            $scope.startPoint.keyword = "我的位置"
            document.getElementById('startName').value = "我的位置";
            document.getElementById('startLng').value = $scope.locationGCJ.lng;
            document.getElementById('startLat').value = $scope.locationGCJ.lat;
            $scope.mapSearch.placeSearch.clear();
            document.getElementById("aMapPanel_search").innerHTML = "";
            $ionicLoading.hide();
            return;
        }
        var adcode = "";
        // 已选城市
        if ($scope.mapSearcData.cityList && $scope.mapSearcData.city && $scope.mapSearcData.cityList[$scope.mapSearcData.city]) {
            adcode = $scope.mapSearcData.cityList[$scope.mapSearcData.city].adcode;
        }
        // 已选省份
        else if ($scope.mapSearcData.provinceList && $scope.mapSearcData.province && $scope.mapSearcData.provinceList[$scope.mapSearcData.province]) {
            adcode = $scope.mapSearcData.provinceList[$scope.mapSearcData.province].adcode;
        }
        // 设置搜索范围
        $scope.mapSearch.placeSearch.setCity(adcode);
        // 搜索地点
        $scope.mapSearch.placeSearch.search($scope.startPoint.keyword, function (status, result) {
            console.log(status);
            console.log(JSON.stringify(result));
            if (status == "complete") {
                if (result.info == "OK") {
                    $scope.mapSearch.placeSearchRender.autoRender({
                        placeSearchInstance: $scope.mapSearch.placeSearch,
                        methodName: "search",
                        methodArgumments: [adcode, $scope.searchStart],
                        data: result,
                        map: $scope.mapSearch,
                        panel: "aMapPanel_search"
                    });
                }
                else if (result.info == "TIP_CITIES") {
                    // 提示选择城市 缩小范围
                    $fwCordovaToast.showShortBottom('搜索范围过大，请选择省份、城市后再试');
                }
            }
            if (status == "no_data") {
                // 无搜索结果
                $fwCordovaToast.showShortBottom('无搜索结果');
            }
            $ionicLoading.hide();
        })
    }

    // 选择起点
    $scope.selectSatart = function () {
        // 从hidden取值赋值给起点
        if (document.getElementById('startName').value != "" && document.getElementById('startName').value.length > 0
        && document.getElementById('startLng').value != "" && document.getElementById('startLng').value.length > 0
        && document.getElementById('startLat').value != "" && document.getElementById('startLat').value.length > 0) {
            $scope.startPoint.name = document.getElementById('startName').value;
            $scope.startPoint.location.lng = document.getElementById('startLng').value;
            $scope.startPoint.location.lat = document.getElementById('startLat').value;
            console.log("起点：" + JSON.stringify($scope.startPoint));
            // 清除所有导航结果
            for (var i in $scope.pathPlan) {
                if ($scope.pathPlan[i].clear) {
                    $scope.pathPlan[i].clear();
                }
            }
            // 规划路径方式
            $scope.planPath($scope.mapMode, $scope.startPoint.location);
        }
        // 我的位置
        else if ($scope.startPoint.keyword == "" || $scope.startPoint.keyword.length == 0 || $scope.startPoint.keyword == "我的位置") {
            // 清除所有导航结果
            for (var i in $scope.pathPlan) {
                if ($scope.pathPlan[i].clear) {
                    $scope.pathPlan[i].clear();
                }
            }
            // 规划路径方式
            $scope.planPath($scope.mapMode, $scope.locationGCJ);
        }
        else {
            $fwCordovaToast.showShortBottom('请选择起点');
            return;
        }
        // 隐藏起点搜索
        $scope.amapSearchHide();
    }

    // 隐藏起点搜索
    $scope.amapSearchHide = function () {
        $scope.amapSearchModal.hide();
        if ($scope.startPoint.keyword == "" || $scope.startPoint.keyword.length == 0) {
            $scope.startPoint.keyword = "我的位置"
        }
        // 清除搜索结果
        $scope.mapSearch.placeSearch.clear();
        document.getElementById("aMapPanel_search").innerHTML = "";
        //$scope.mapSearcData = {};
        //$scope.mapSearch.destroy();
    }

    // 医师介绍页确认预约
    $scope.apptModal = function (id, color) {
        if (id != "" && (color == "green" || color == "orange")) {
            $scope.getOpSchedInfo(id);
        }
    }

    // 获取预约信息
    $scope.getOpSchedInfo = function (id) {
        OpApptService.getOpSchedInfo(id).then(function (data) {
            console.log(data);
            // 调用失败
            if (data.result == -1) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 已约满
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom("当前选择的医师已约满");
            }
            // 一个时段 直接赋值下一步
            else {
                console.log(data);
                $scope.opInfoSelect = data.data[0];
                $scope.toSlide(10);
                $scope.doctorIntroHide();
            }
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }

    // 选择预约条件
    $scope.selectCondition = function () {
        if ($scope.currentWishByFilter.division == "") {
            $fwCordovaToast.showShortBottom("请选择预约科别");
            return;
        }
        $scope.toSlide(10);
    }

    // 填写症状模态窗口显示
    $scope.addSymptomShow = function () {
        if ($scope.symptomData.symptoms.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的症状过多');
            return;
        }
        $scope.addSymptomData.keyword = "";
        $scope.addSymptomData.results = [];
        $scope.addSymptomModal.show();
        // 自动获取焦点
        $timeout(function () {
            document.getElementById("searchSymptom").focus();
        }, 500);
    }

    // 填写症状模态窗口隐藏
    $scope.addSymptomHide = function () {
        $scope.addSymptomModal.hide();
    }

    // 查询症状
    $scope.searchSymptom = function () {
        $scope.addSymptomData.results = [];
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        TriageService.symptomSearch($scope.addSymptomData.keyword, $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.results = data.data;
                $ionicScrollDelegate.scrollTop();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("搜索超时，请稍后再试");
        })
    }

    // 添加症状
    $scope.addSymptom = function (data) {
        if ($scope.symptomData.symptoms.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的症状过多');
            return;
        }
        if ($scope.symptomData.symptoms.indexOf(data) > -1) {
            $fwCordovaToast.showShortBottom('您选择的症状已存在');
            return false;
        }
        $scope.symptomData.symptoms.push(data);
        // 可能伴随症状
        TriageService.rlatSymptom($scope.symptomData.symptoms.join(","), $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.rlats = data.data;
                $scope.addSymptomData.common = data.common;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            ;
        })
        $scope.addSymptomHide();
    }

    // 删除症状
    $scope.deleteSymptom = function (index) {
        $scope.symptomData.symptoms.splice(index, 1);
        // 可能伴随症状
        TriageService.rlatSymptom($scope.symptomData.symptoms.join(","), $scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.addSymptomData.rlats = data.data;
                $scope.addSymptomData.common = data.common;
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            ;
        })
    }

    // 分诊
    $scope.getTriageResult = function () {
        // 症状为空 toast
        if ($scope.symptomData.symptoms.length == 0 && $scope.isLoadingHistory) {
            //$fwCordovaToast.showShortBottom("正在加载历史就诊，请稍候");
            return;
        }
        $scope.sysptomResult = {};
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 计算分诊结果
        TriageService.result($scope.vpSelect.VISIT_PATIENT_ID, $scope.symptomData.symptoms.join(), $scope.symptomData.isReview, $scope.reviewDataRequestId).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.sysptomResult = data.data;
                $scope.nextSlide();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
            $fwCordovaToast.showShortBottom("网络连接异常，请稍后重试");
        })
    }

    // 获取指定科别医师列表
    $scope.getDoctorList = function (speciality, division) {
        console.log(speciality, division);
        $scope.doctorData.doctorList = [];
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        // 获取指定科别医师列表
        OpApptService.getDoctorListBySpeciality(speciality).then(function (data) {
            // 查询成功
            if (data.result == 1) {
                // 2019-9-26 10:11:14 HM 增加+ 智能分诊查询医师，显示排班
                for(var i=0;i<data.data.length;i++){
                    var result = data.data[i];
                    if(data.data[i].REG_DATE == ""){
                        $scope.doctorData.doctorList.push(result);
                        continue;
                    }
                    var regDate = data.data[i].REG_DATE.split(",");
                    var regDateList = new Array();
                    for(var j=0;j<regDate.length;j++){
                        var obj = new Object();
                        var reg = regDate[j].split("|");
                        reg[0] = reg[0].slice(5);
                        obj.date = reg[0];
                        obj.count = reg[1];
                        regDateList.push(obj);
                    }

                    result.regDateList = regDateList;
                    $scope.doctorData.doctorList.push(result);
                }
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            // 重新计算滚动条高度
            $scope.slideChanged();
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        }, function (data) {
            $ionicLoading.hide();
            $scope.isLoadFinish = true;
        })
        // 页面调用时触发 从预约挂号退回时略过
        if (division != null && division.length > 0) {
            console.log($scope.sysptomResult.triage_id, division);
            // 分诊科别选择回调
            TriageService.selectDivision($scope.sysptomResult.triage_id, division).then(function (data) {
                ;
            }, function (data) {
                ;
            })
            $scope.scrollPosition = { left: 0, top: 0, zoom: 1 };
            $scope.nextSlide();
        }
    }

    // 确认预约信息提示
    $scope.checkOpRegTips = function (index) {
        var opInfo = $scope.opInfoList[index];
        console.log($scope.configData);
        if ($scope.configData.doctorTips[$scope.opInfoList[index].DOCTOR_CODE] != undefined) {
            if (localStorage.isEnglishMode == 1) {
                var tipPopup = $ionicPopup.show({
                    title: 'Tip',
                    template: $scope.configData.doctorTips[$scope.opInfoList[index].DOCTOR_CODE],
                    scope: $scope,
                    buttons: [{ text: "I see.Continue with the appointment", type: "button-calm" }]
                });
                tipPopup.then(function () {
                    $scope.selectOpInfo(index);
                })
            }
            else {
                var tipPopup = $ionicPopup.show({
                    title: '提示',
                    template: $scope.configData.doctorTips[$scope.opInfoList[index].DOCTOR_CODE],
                    scope: $scope,
                    buttons: [{ text: "我知道了，继续预约", type: "button-calm" }]
                });
                tipPopup.then(function () {
                    $scope.selectOpInfo(index);
                })
            }
        }
        // 2020-5-29 08:43:41 HM 增加午间、晚间的提示
        // 2021-8-31 16:25:45 HM #46655 取消晚间门诊提示，改成可配置的
        else if (opInfo.SCHED_TIME == "午间" && $scope.configData.OpApptMidNotice != '') {
            if (localStorage.isEnglishMode == 1) {
                var tipPopup = $ionicPopup.show({
                    title: '提示',
                    template: $scope.configData.OpApptMidNotice,
                    scope: $scope,
                    buttons: [{ text: "I see.Continue with the appointment", type: "button-calm" }]
                });
                tipPopup.then(function () {
                    $scope.selectOpInfo(index);
                })
            }
            else {
                var tipPopup = $ionicPopup.show({
                    title: '提示',
                    template: $scope.configData.OpApptMidNotice,
                    scope: $scope,
                    buttons: [{ text: "我知道了，继续预约", type: "button-calm" }]
                });
                tipPopup.then(function () {
                    $scope.selectOpInfo(index);
                })
            }
        }
        else if (opInfo.SCHED_TIME == "晚间" && $scope.configData.OpApptEveningNotice != '') {
            if (localStorage.isEnglishMode == 1) {
                var tipPopup = $ionicPopup.show({
                    title: 'Tip',
                    template: $scope.configData.OpApptEveningNotice,
                    scope: $scope,
                    buttons: [{ text: "I see.Continue with the appointment", type: "button-calm" }]
                });
                tipPopup.then(function () {
                    $scope.selectOpInfo(index);
                })
            }
            else {
                var tipPopup = $ionicPopup.show({
                    title: '提示',
                    template: $scope.configData.OpApptEveningNotice,
                    scope: $scope,
                    buttons: [{ text: "我知道了，继续预约", type: "button-calm" }]
                });
                tipPopup.then(function () {
                    $scope.selectOpInfo(index);
                })
            }
        }
        else{
            $scope.selectOpInfo(index);
        }
    }

    // 选择预约信息
    $scope.selectOpInfo = function (index) {
        $scope.opInfoSelect = $scope.opInfoList[index];
        $scope.toSlide(10);
        console.log($scope.opInfoSelect);
    }

    // 2021-5-13 18:52:20 HM 初始化身高体重，异步获取历史身高体重
    $scope.getLastHeightWeight = function () {
        // 初始化身高体重，异步获取历史身高体重
        $scope.health.height = "";
        $scope.health.weight = "";
        HealthService.getLastHeightWeight($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            if (data.result == 0) {
            }
            else {
                // 如果不为空，证明上次有信息，直接带过来
                if(data.is_null == 0) {
                    $scope.health.height = data.data.HEIGHT;
                    $scope.health.weight = data.data.WEIGHT;
                }

            }
        }, function (data) {
        });
    }

    // 2023-7-27 15:17:07 HM 加载婚姻状况，和身高体重一样，走异步获取
    $scope.getHisPatientInfo = function () {
        // 初始化婚姻状况字段
        $scope.marital.value = "";
        $scope.marital.show = false;
        RequestService.getHisPatientInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            if (data.result == 1) {
                if (data.data.maritalStatus == "" || data.data.maritalStatus == null) {
                    $scope.marital.show = true;
                }
            }
        }, function (data) {
        })
    }

    // 算就诊时段
    $scope.getSchedPeriodStr = function (schedTime, schedPeriodCode) {
        var str = "";
        if (schedTime == "上午" && schedPeriodCode == "A") {
            str = "08:00-09:30";
        }
        if (schedTime == "上午" && schedPeriodCode == "B") {
            str = "09:30-11:00";
        }
        if (schedTime == "下午" && schedPeriodCode == "A") {
            str = "13:00-14:30";
        }
        if (schedTime == "下午" && schedPeriodCode == "B") {
            str = "14:30-16:00";
        }
        return str;
    }

    // 2019-8-13 14:40:18 按特色技术/病种预约
    $scope.apptBySpecialityGroup = function (type) {
        if (type == "JS") {
            $scope.specialityGroupData.groupType = type;
            $scope.apptMethod = '4';
        }
        else if (type == "BZ") {
            $scope.specialityGroupData.groupType = type;
            $scope.apptMethod = '5';
        }
        else {
            return false;
        }
        // 获取特色技术/病种列表
        $scope.getSpecialityGroupList();
    }

    // 获取特色技术/病种列表
    $scope.getSpecialityGroupList = function () {
        if ($scope.specialityGroupData.groupType != "JS" && $scope.specialityGroupData.groupType != "BZ") {
            return false;
        }
        // 初始化标题列表 特色技术/病种分组列表
        //$scope.configData.apptStepList.length = 11;
        // 从最后提前到第8-9页
        $scope.configData.apptStepList.splice(8, 2, "", "");
        $scope.specialityGroupData.groupList = [];
        $ionicLoading.show();
        OpApptService.getSpecialityGroupList($scope.specialityGroupData.groupType).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                console.log(data);
                // 列表页 医师筛选页 对应两页标题 push两次
                //$scope.configData.apptStepList.push(data.data.title);
                //$scope.configData.apptStepList.push(data.data.title);
                // 从最后提前到第8-9页
                $scope.configData.apptStepList.splice(8, 2, data.data.title, data.data.title);
                console.log($scope.configData.apptStepList);
                $scope.specialityGroupData.groupList = data.data.groupList;
                console.log($scope.specialityGroupData.groupList);
                // 跳转到特色技术/病种列表页
                $scope.toSlide(8);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            $fwCordovaToast.showShortBottom(data.msg);
            $ionicLoading.hide();
        })
    }

    // 选择特色技术/病种
    $scope.selectSpecialityGroup = function (index) {
        $scope.specialityGroupData.groupSelected = $scope.specialityGroupData.groupList[index];
        if ($scope.specialityGroupData.groupSelected.SUBGROUP_LIST != null && $scope.specialityGroupData.groupSelected.SUBGROUP_LIST.length > 0) {
            $scope.specialityGroupData.groupCode = $scope.specialityGroupData.groupList[index].SUBGROUP_LIST[0].GROUP_CODE;
        }
        else {
            $scope.specialityGroupData.groupCode = $scope.specialityGroupData.groupList[index].GROUP_CODE;
        }
        // 刷新医生列表
        $scope.loadOpInfoListBySpecialityGroup();
    }

    // 切换特色技术/病种子选项
    $scope.changeSpecialitySubgroup = function (code) {
        if ($scope.specialityGroupData.groupCode == code) {
            return false;
        }
        $scope.specialityGroupData.groupCode = code;
        // 刷新医生列表
        $scope.loadOpInfoListBySpecialityGroup();
    }

    // 按特色技术/病种/条件刷新医生列表
    $scope.loadOpInfoListBySpecialityGroup = function () {
        $ionicLoading.show();
        $scope.opInfoListEmpty = false;
        $scope.opInfoList = [];
        OpApptService.getSchedulingBySpecialityGroup($scope.specialityGroupData.groupType, $scope.specialityGroupData.groupCode, $scope.opApptData.schedDate, $scope.opApptData.schedTime).then(function (data) {
            // 查询成功
            for (var i = 0; i < data.ds.length; i++) {
                // 若仅看可约 且 APPT_STATUS != 1 跳过
                if ($scope.showAvailable && data.ds[i].APPT_STATUS != "1") { continue; }
                $scope.opInfoList.push(data.ds[i])
            }

            // 2022-5-19 08:56:55 WX 特需 按病种/特色查询  筛特需
            if ($scope.from == "specialNeeds") {
                $scope.opInfoList = $scope.opInfoList.filter(item => item.SCHED_LEVEL == "特需");
            }

            if ($scope.opInfoList.length == 0) {
                $scope.opInfoListEmpty = true;
            }
            // 如果在列表页 跳转
            if ($scope.step == 8) {
                $scope.toSlide(9);
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.opInfoListEmpty = true;
            $ionicLoading.hide();
        })
    }

    // 2021-2-19 11:16:37 HM 提交挂号前的一些操作
    $scope.submitRegBefore = function () {
        // 候补号，不走按号序预约
        var isWaitList = "0";
        if ($scope.opInfoSelect.APPT_STATUS == 4 && $scope.opInfoSelect.WAITLIST_COUNT > 0){
            isWaitList = "1";
        }

        // 2021-4-13 18:46:14 验证开关 需要填写身高体重
        if ($scope.needHeightWeight) {
            if ($scope.health.height == null || $scope.health.height == "" || $scope.health.weight == null || $scope.health.weight == "") {
                $fwCordovaToast.showLongBottom("请填写身高体重信息");
                return false;
            }
            else if ($scope.health.height <= 0 || $scope.health.weight <= 0) {
                $fwCordovaToast.showLongBottom("请填写正确的身高体重信息");
                return false;
            }
            // #66345 身高和体重的单位从英文改为中文，身高限制不能小于10cm
            else if ($scope.health.height < 10) {
                $fwCordovaToast.showLongBottom("请填写正确的身高信息，身高不应小于10厘米（cm）");
                return false;
            }
            else {
                // 2021-4-13 18:54:54 异步提交 不关注返回结果 不影响预约挂号主流程
                HealthService.submitHeightWeight($scope.vpSelect.VISIT_PATIENT_ID, $scope.health.height, $scope.health.weight, "OpAppt");
            }
        }

        // 2023-7-28 14:39:33 HM 如果婚姻情况显示，这里需要验证必填项
        if ($scope.marital.show == true) {
            console.log($scope.marital.value);
            if ($scope.marital.value == "") {
                $fwCordovaToast.showLongBottom("请选择婚姻状况");
                return false;
            }
        }

        // 2022-4-7 15:45:04 HM 验证是否需要填写核酸流调
        if ($scope.needEpidSrvyNcp) {
            var needEpidTip = false;
            var ncpSrvy = "";
            for (var i = 0; i < $scope.epidSrvyOptionList.length; i++) {
                if ($scope.epidSrvyOptionList[i].status == true) {
                    needEpidTip = true;
                    ncpSrvy = $scope.epidSrvyOptionList[i].model;
                }
            }

            if (!needEpidTip) {
                $fwCordovaToast.showLongBottom("请选择" + $scope.epidSrvyQuestion);
                return false;
            }
            else {
                // 异步提交，不关注返回结果 不影响预约挂号主流程
                VisitPatientService.submitEpidSrvyNcp($scope.vpSelect.VISIT_PATIENT_ID, $scope.epidSrvyId, ncpSrvy);
            }
        }

        // 2022-8-23 08:45:24 HM #52372 慢性病医师代码，需要验证门诊或住院记录
        if ($scope.configData.chronicDoctorCode.indexOf($scope.opInfoSelect.DOCTOR_CODE) > -1) {
            var flag = 0;
            var inPatientFlag = false;
            var outPatientFlag = false;

            $ionicLoading.show();
            RequestService.getLastOpInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                flag++;
                console.log(data);

                if (data.result = 1 && data.is_null == 0 && data.data.length > 0) {
                    outPatientFlag = true;
                }
                else {
                    outPatientFlag = false;
                }
                // 两个请求都完成了才处理，没执行完不处理
                if (flag >= 2) {
                    $ionicLoading.hide();
                    // 没有门诊记录，也没有住院记录，不让预约
                    if (inPatientFlag == false && outPatientFlag == false) {
                        $ionicPopup.alert({
                            title: "提示",
                            template: $scope.configData.chronicDoctorCodeTip,
                            okText: '我知道了'
                        });
                    }
                    else {
                        $scope.submitRegCommon(isWaitList);
                    }
                }
            }, function () {
                flag++;
                if (flag >= 2) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: "提示",
                        template: "网络错误，请稍后重试",
                        okText: '确定'
                    });
                }
            });

            RequestService.patientCheck($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                flag++;
                console.log(data);

                if (data.result == 1 && data.is_null == 0 && data.data.length > 0) {
                    for (var i = 0; i < data.data.length; i++) {
                        if (data.data[i].hasOwnProperty("DATE_IN") && data.data[i]["DATE_IN"] != "") {
                            inPatientFlag = true;
                        }
                    }
                }
                else {
                    inPatientFlag = false;
                }

                // 两个请求都完成了才处理，没执行完不处理
                if (flag >= 2) {
                    $ionicLoading.hide();
                    // 没有门诊记录，也没有住院记录，不让预约
                    if (inPatientFlag == false && outPatientFlag == false) {
                        $ionicPopup.alert({
                            title: "提示",
                            template: $scope.configData.chronicDoctorCodeTip,
                            okText: '我知道了'
                        });
                    }
                    else {
                        $scope.submitRegCommon(isWaitList);
                    }
                }
            }, function () {
                flag++;
                if (flag >= 2) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: "提示",
                        template: "网络错误，请稍后重试",
                        okText: '确定'
                    });
                }
            })
        }
        else {
            $scope.submitRegCommon(isWaitList);
        }
    }

    // 2022-8-23 16:24:21 HM 提交COMMON
    $scope.submitRegCommon = function (isWaitList) {
        // 验证开关 可选择号序
        if ($scope.chooseSchedSeq && isWaitList != "1") {
            // 2021-4-25 08:28:19 HM 增加按号续预约
            $scope.submitRegBySchedSeq();
        }
        else {
            $scope.schedSeq = "0";

            // 2022-6-24 13:26:51 HM #52279 如果是候补号，增加提示文字
            if (isWaitList == "1") {
                $ionicPopup.alert({
                    title: "提示",
                    template: $scope.configData.opRegWaitListAlertMsg,
                    okText: '确定'
                }).then(function (res) {
                    if (res) {
                        $scope.submitReg();
                    }
                })
            }
            else {
                $scope.submitReg();
            }
        }
    }

    // 2021-4-25 08:28:19 HM 增加按号续预约
    $scope.submitRegBySchedSeq = function () {
        $ionicLoading.show();
        OpApptService.getSchedSeq($scope.opInfoSelect.ID).then(function (data) {
            $ionicLoading.hide();
            console.log(data);
            if(data.result == 0){
                $fwCordovaToast.showLongBottom(data.msg);
            }
            else{
                // 先初始化号序变量
                $scope.schedSeq = "0";
                $scope.schedSeqList = data.data;
                if($scope.schedSeqList.length != 0){
                    var allAvail = false;
                    var firstAvail = -1;
                    for(var i = 0; i < $scope.schedSeqList.length; i++){
                        $scope.schedSeqList[i].CHECKED = false;
                        if($scope.schedSeqList[i].IS_AVAIL == "1"){
                            allAvail = true;
                            // 记录第一个可约的序列
                            if(firstAvail == -1){
                                firstAvail = i;
                            }
                        }
                    }
                    // 如果有可约的号序，让他选，没有可约的号序，不让他选
                    if(allAvail == true){
                        // 第一个可约的序列，帮他选中
                        if(firstAvail != -1){
                            $scope.selectTime(firstAvail);
                        }

                        $scope.schedSeqModelShow();
                    }
                    else{
                        $scope.submitReg();
                    }
                }
                else{
                    // 没有列表情况有两种，1种是当日预约，第二种是简易门诊
                    $scope.submitReg();
                }
            }
        }, function (data) {
            $ionicLoading.hide();
            // 获取号序失败走原不选号序预约
            $scope.schedSeq = "0";
            $scope.submitReg();
        })
    }

    // 展示号序模态框
    $scope.schedSeqModelShow = function () {
        $scope.schedSeqModal.show();
    }

    // 隐藏号序模态框
    $scope.schedSeqModelHide = function () {
        $scope.schedSeqModal.hide();
    }

    // 选择号序
    $scope.selectTime = function (index) {
        if($scope.schedSeqList[index].IS_AVAIL == "0") {
            $fwCordovaToast.showLongBottom("当前号序已被预约，请选择其他号序");
            return;
        }

        for (var i = 0; i < $scope.schedSeqList.length; i++) {
            $scope.schedSeqList[i].CHECKED = false;
        }
        $scope.schedSeqList[index].CHECKED = true;
        $scope.schedSeq = $scope.schedSeqList[index].SCHED_SEQ;
    }

    // 提交当日号挂号申请
    $scope.submitReg = function () {
        $scope.schedSeqModelHide();
        console.log($scope.opInfoSelect);
        // 2021-12-12 15:28:11 HM 增加候补号
        var isWaitList = "0";
        if ($scope.opInfoSelect.APPT_STATUS == 4 && $scope.opInfoSelect.WAITLIST_COUNT > 0){
            isWaitList = "1";
        }

        $ionicLoading.show();
        // 提交当日号挂号申请
        OpApptService.submitReg($scope.vpSelect.VISIT_PATIENT_ID, $scope.opInfoSelect.ID, $scope.schedSeq, isWaitList).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 锁号成功，获取reg_info
                if (data.reg_result == 1) {
                    // 2023-7-28 14:39:33 HM 如果婚姻情况显示，这里需要验证必填项
                    if ($scope.marital.show == true) {
                        console.log($scope.marital.value);
                        if ($scope.marital.value != "") {
                            // 走个异步的，不能影响他挂号
                            OpApptService.updatePatientInfo($scope.vpSelect.VISIT_PATIENT_ID, $scope.marital.value);
                        }
                    }

                    // 获取支付时间限制
                    $scope.getTimeLimit();
                    // 跳转支付确认界面
                    $scope.lockedRegInfo = data.reg_info;
                    // 2020-5-18 19:25:12 wxh 小儿外科问卷
                    $scope.QuerstionnaireIsShowPersonal = data.reg_info.IS_QSTN;
                    $scope.QuerstionnaireType = data.reg_info.QSTN_TYPE;
                    $scope.toSlide(11);
                }
                // 锁号失败，TOAST msg
                else if (data.reg_result == 0) {
                    $fwCordovaToast.showLongBottom(data.msg);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            //$fwCordovaToast.showShortBottom(data.msg);
            // 2021-4-27 16:53:21 增加0.5s延迟 避免选择号序modal未收起与popup冲突
            setTimeout(function (){
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                $ionicLoading.hide();
            }, 500);
        })
    }

    // 取消当日号挂号申请
    $scope.cancelReg = function () {
        // confirm
        $ionicPopup.confirm({
            template: "取消挂号操作无法恢复，确认取消？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                console.log($scope.lockedRegInfo);
                $ionicLoading.show();
                // 取消当日号挂号申请
                OpRegService.cancelReg($scope.lockedRegInfo.OP_REG_ID).then(function (data) {
                    // 取消成功
                    if (data.result == 1) {
                        // 继续支付确认 正常后退
                        if ($scope.isContinueToPay) {
                            $rootScope.goBack();
                        }
                        // 退到选择预约方式
                        else {
                            $scope.toSlide(2);
                        }
                    }
                    // 取消失败
                    else {
                        $fwCordovaToast.showLongBottom(data.msg);
                    }
                    $ionicLoading.hide();
                }, function (data) {
                    $fwCordovaToast.showShortBottom(data.msg);
                    $ionicLoading.hide();
                })
            }
        })
    }

    // 获取支付时间限制
    $scope.getTimeLimit = function () {
        OpRegService.getTimeLimit().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $rootScope.payTimeLeft = data.data;
                if ($rootScope.payStatus != 1) {
                    $rootScope.payStatus = 1;
                }
                // 倒计时
                $scope.timeCountdown();
            }
            // 获取失败
            else {
                $rootScope.payStatus = 0;
                $rootScope.payTimeLeft = 0;
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 超时处理
    $scope.checkTimeout = function () {
        //$ionicLoading.show();
        $scope.regErrorMsg = "未在规定时间内成功支付, 挂号自动取消";
        $scope.toSlide(12);
    }

    // 筛选支付方式
    $scope.filterPaymentMethod = function (value) {
        return $rootScope.paymentRouteList.filter(e => e.value == value)[0];
    }

    // 切换支付方式
    $scope.switchPaymentMethod = function (value) {
        var method = $scope.filterPaymentMethod(value);
        if (method == null) {
            $fwCordovaToast.showShortBottom('当前支付方式不可用, 请选择其他支付方式');
            return;
        }
        // 不可用
        if (method.status == "0") {
            $fwCordovaToast.showShortBottom(method.descr);
            return;
        }
        $scope.paymentInfo.method = method.value;
    }

    // 创建支付订单
    $scope.unifiedOrder = function () {
        if ($scope.needAgent) {
            if ($scope.agent.isShow == true) {
                if ($scope.agent.phone.length == 0) {
                    $fwCordovaToast.showLongBottom("请填写代开药人手机号码");
                    return;
                }
                else if ($scope.agent.name.length == 0) {
                    $fwCordovaToast.showLongBottom("请填写代开药人姓名");
                    return;
                }
                else if ($scope.agent.relation.length == 0) {
                    $fwCordovaToast.showLongBottom("请选择就诊人关系");
                    return;
                }
                else if ($scope.agent.idcard.length == 0) {
                    $fwCordovaToast.showLongBottom("请填写代开药人身份证号");
                    return;
                }

                var reg = /^1[3-9][0-9]{9}$/;
                if (!reg.test($scope.agent.phone)) {
                    $fwCordovaToast.showLongBottom("请填写正确手机号码");
                    return;
                }
                else if ($scope.agent.name.length > 50) {
                    $fwCordovaToast.showLongBottom("姓名最长不超过50位");
                    return;
                }
                else if ($scope.agent.idcard.length > 18) {
                    $fwCordovaToast.showLongBottom("身份证最长不超过18位");
                    return;
                }

                // 发个异步请求，无需关心返回值，不影响患者挂号
                $ionicLoading.show();
                OpApptService.submitAgent($scope.lockedRegInfo.OP_REG_ID, $scope.agent.phone, $scope.agent.name, $scope.agent.idcard, $scope.agent.relation).then(function (data) {
                    if (data.result == 0) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom(data.msg);
                        return;
                    }
                    else {
                        $scope.unifiedOrderCommon1();
                    }
                }, function () {
                    $scope.unifiedOrderCommon1();
                });
            }
            else {
                $scope.agent.phone = "";
                $scope.agent.name = "";
                $scope.agent.idcard = "";
                $scope.agent.relation = "";

                $scope.unifiedOrderCommon1();
            }
        }
        else {
            $scope.unifiedOrderCommon1();
        }
    }

    // 提出公共的提交方法
    // 医保移动支付选择支付方式（微信/支付宝）
    // TODO: 正式上线前把微信、支付宝小程序拉到与上一级齐平，去掉此处二级弹出选择
    $scope.unifiedOrderCommon1 = function () {
        if ($scope.paymentInfo.method == 10 || $scope.paymentInfo.method == "10") {
            // var html = "<div>";
            // html += "<p>请选择支付方式</p>";

            // // 微信小程序
            // html += "<div style='display: flex;padding-bottom: 1em;'>";
            // html += "<div style='width: calc(100% - 4em)'>微信小程序</div>";
            // html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
            // html += "<button class='button button-small button-calm' ng-click='ybPay(\"wx\");' style='max-height: 4em;line-height: 1.5em;'>";
            // html += "<span style='font-size:14px;'>跳转</span>";
            // html += "</button>";
            // html += "</div>";
            // html += "</div>";

            // // 支付宝小程序
            // html += "<div style='display: flex;padding-top: 1em;border-top: 1px dashed #999;'>";
            // html += "<div style='width: calc(100% - 4em)'>支付宝小程序</div>";
            // html += "<div style='padding-left: 0.5em;width: 4em;display: flex;flex-direction: column;justify-content: center;'>";
            // html += "<button class='button button-small button-calm' ng-click='ybPay(\"zfb\");' style='max-height: 4em;line-height: 1.5em;'>";
            // html += "<span style='font-size:14px;'>跳转</span>";
            // html += "</button>";
            // html += "</div>";
            // html += "</div>";

            // html += "</div>";

            // $scope.confirmPopup = $ionicPopup.alert({
            //     title: "提示",
            //     template: html,
            //     buttons: [
            //         {
            //             text: "取消",
            //             onTap: function (e) { }
            //         }
            //     ],
            //     scope: $scope
            // });

            // 2023-11-8 15:46:45 HM 首信暂时只支持支付宝小程序，先注释掉，后续再进行适配
            $scope.ybPay('zfb');
        }
        else {
            $scope.unifiedOrderCommon2();
        }
    }

    // 提出公共的提交方法
    $scope.unifiedOrderCommon2 = function () {
        $ionicLoading.show();
        OpRegService.unifiedOrder($scope.lockedRegInfo.OP_REG_ID, $scope.paymentInfo.method).then(function (data) {
            console.log(data);
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            } else {
                switch ($scope.paymentInfo.method) {
                    case 1: case "1":
                        callWXPay(data.data);
                        break;
                    case 4: case "4":
                        $scope.fromWeixin = false;
                        $scope.outTradeNo = data.data;
                        //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                        //$cordovaInAppBrowser.open(serviceUrl + "/Payment/OrderResult?orderId=" + data.data, '_blank', option).then(function (event) { })
                        //2023.7.31 新插件原有调用方式参数不生效
                        var inapp = showInAppBrowser(serviceUrl + "/Payment/OrderResult?orderId=" + data.data, '_blank');

                        // 添加状态监听器
                        inapp.addEventListener('exit', function (event) {
                            //console.log('InAppBrowser exit加载：' + event.url);
                            OnResume();
                        });

                        inapp.addEventListener('loadstart', function (event) {
                            //console.log('loadstart loadstart加载：' + event.url);
                            if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
                                || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
                                if (event.url.endsWith("Success")) {
                                    WXPaySuccess(0);
                                } else if (event.url.endsWith("Failed")) {
                                    WXPayFailed(-2);
                                }

                                $cordovaInAppBrowser.close();
                            }
                        });
                        break;
                    case 6: case "6": // 支付宝
                        callAliPay(data.data);
                        break;
                    case 10: case "10":// 北京医保
                        $ionicLoading.hide();

                        // 注册后台唤醒事件
                        $scope.fromWeixin = false;
                        $scope.outTradeNo = data.data;

                        document.addEventListener("resume", OnResume, false);

                        var pageUrl = data.bjybJumpMiniProgram;
                        if ($scope.BJYBMiniProgram == "zfb") {
                            // 先用cordovaInAppBrowser的方式，后期还得切换到插件的形式
                            var herfUrl = "https://ds.alipay.com/?scheme=" + encodeURIComponent("alipays://platformapi/startapp?appId=2021003175643256&page=" + encodeURIComponent(pageUrl));

                            //var option = { location: 'yes', clearcache: 'no', toolbar: 'yes' }
                            //$cordovaInAppBrowser.open(herfUrl, '_system', option).then(function (event) { });
                            //2023.7.31 新插件原有调用方式参数不生效
                            showInAppBrowser(herfUrl, '_system');
                        }
                        else {
                            $fwCordovaToast.showShortBottom("暂不支持微信小程序");
                        }
                        break;
                    default: // 其他
                        $fwCordovaToast.showShortBottom("暂不支持所选的支付方式");
                        $ionicLoading.hide();
                        break;
                }
            }
        }, function (resp) {
            $fwCordovaToast.showShortBottom("通信失败, 请检查网络");
            $ionicLoading.hide();
        });
    }

    // 选择北京医保小程序
    $scope.ybPay = function (type) {
        //$scope.confirmPopup.close();
        $scope.BJYBMiniProgram = type;
        $scope.unifiedOrderCommon2();
    }

    // 查询挂号状态
    $scope.getRegStatus = function () {
        $scope.isSubmitWaitListSuccess = false;
        OpApptService.regStatus($scope.lockedRegInfo.OP_REG_ID).then(function (data) {
            $ionicLoading.hide();
            // 获取成功 result = 1
            if (data.result == 1) {
                // 挂号成功 reg_result = 1 挂号成功，获取reg_info
                if (data.reg_result == 1) {
                    $scope.isRegSuccess = true;
                    $scope.lockedRegInfo = data.reg_info;
                    $scope.regErrorMsg = "";
                }
                // 候补中
                else if (data.reg_result == 2) {
                    $scope.isSubmitWaitListSuccess = true;
                    $scope.regErrorMsg = data.msg;
                }
                // 挂号失败
                else {
                    $scope.isRegSuccess = false;
                    $scope.regErrorMsg = data.msg;
                }
                // 检查通知权限
                $scope.verifyNoticeAlert();
                $scope.toSlide(12);
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom(data.msg);
        })
    }

    // 调用支付宝支付
    function callAliPay(paydata) {
        var aliBizContent = JSON.parse(getQueryVariable(paydata, "biz_content"));
        $scope.outTradeNo = aliBizContent.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            cordova.plugins.ali.Alipay.pay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.ALiPayPlugin.callALiPay(paydata, function (data) {
                AliPaySuccess(data);
            }, function (error) {
                AliPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持支付宝支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 支付成功
    function AliPaySuccess(statusCode) {
        $ionicLoading.show();
        $scope.resultShow = {};
        $scope.appResult = "";
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                // 支付成功
                $scope.isPaySuccess = true;
                $scope.appResult = "0";
                $scope.resultShow = data.data;
                // 查询挂号状态
                $scope.getRegStatus();
            }
            //
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.appResult = "-1";
                $scope.regErrorMsg = data.msg;
                $scope.toSlide(12);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
            $scope.regErrorMsg = "网络异常, 请稍后重试";
            $scope.toSlide(12);
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        }, function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function AliPayFailed(statusCode) {
        var errMsg = "";
        switch (statusCode.resultStatus) {
            case "8000": // 正在处理中
            case "6004": // 支付结果未知
                AliPaySuccess(statusCode);
                return;
            case "4000": // 支付失败
                errMsg = "支付失败";
                $scope.appResult = "-1";
                break;
            case "5000": // 重复请求
                errMsg = "重复请求";
                $scope.appResult = "-1";
                break;
            case "6001": // 用户取消
                errMsg = "用户取消";
                $scope.appResult = "-2";
                break;
            case "6002": // 网络连接错误
                errMsg = "网络连接错误";
                $scope.appResult = "-1";
                break;
            default: // 其他
                errMsg = "支付错误";
                $scope.appResult = "-1";
                break;
        }
        $fwCordovaToast.showShortBottom(errMsg);
        // 支付失败
        $scope.isPaySuccess = false;
        $scope.regErrorMsg = errMsg;
        $scope.toSlide(12);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        }, function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $ionicLoading.hide();
    }

    // 分平台调用微信支付插件
    function callWXPay(paydata) {
        $scope.outTradeNo = paydata.out_trade_no;
        $scope.appResult = "";
        // 注册后台唤醒事件
        $scope.fromWeixin = false;
        document.addEventListener("resume", OnResume, false);
        if ("iOS" == currentPlatform) {
            wxpay.payment(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else if ("Android" == currentPlatform) {
            window.plugins.WXPayPlugin.callWXPay(paydata, function (data) {
                WXPaySuccess(data);
            }, function (error) {
                WXPayFailed(error);
            });
        }
        else {
            $fwCordovaToast.showShortBottom('您的系统暂不支持微信支付');
            $ionicLoading.hide();
            return;
        }
    }

    // 监听inAppBrowser页面跳转，若到支付结果页，关闭inAppBrowser并跳转结果页面
    $rootScope.$on("$cordovaInAppBrowser:loadstart", function (e, event) {
        if (event.url.startsWith("http://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://app.fuwaihospital.org/Payment/")
         || event.url.startsWith("https://wx.fuwai.com/Payment/")) {
            if (event.url.endsWith("Success")) {
                WXPaySuccess(0);
            } else if (event.url.endsWith("Failed")) {
                WXPayFailed(-2);
            }

            $cordovaInAppBrowser.close();
        }
    })

    // 用户直接关闭弹出支付Browser处理
    $rootScope.$on("$cordovaInAppBrowser:exit", function (e, event) {
        OnResume();
    })

    // 支付成功
    function WXPaySuccess(statusCode) {
        $ionicLoading.show();
        $scope.resultShow = {};
        $scope.appResult = statusCode;
        // 验证支付状态
        PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
            // 真·支付成功
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom('支付成功');
                // 支付成功
                $scope.isPaySuccess = true;
                $scope.resultShow = data.data;
                // 查询挂号状态
                $scope.getRegStatus();
            }
            //
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.regErrorMsg = data.msg;
                $scope.toSlide(12);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
            $scope.regErrorMsg = "网络异常, 请稍后重试";
            $scope.toSlide(12);
        })
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        }, function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        //$scope.outTradeNo = "";
        $scope.appResult = "";
    }

    // 调用失败 或 支付失败
    function WXPayFailed(statusCode) {
        $scope.appResult = statusCode;
        $fwCordovaToast.showShortBottom(-1 == statusCode ? "支付错误" : "用户取消或支付超时");
        // 支付失败
        $scope.isPaySuccess = false;
        $scope.regErrorMsg = -1 == statusCode ? "支付错误" : "用户取消或支付超时";
        $scope.toSlide(12);
        // 回调 保存到服务器
        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, $scope.appResult).then(function (data) {
            ;
        }, function (data) {
            ;
        });
        // 解绑后台唤醒事件监测
        document.removeEventListener("resume", OnResume, false);
        // 由微信回调返回
        $scope.fromWeixin = true;
        $scope.outTradeNo = "";
        $scope.appResult = "";
        $ionicLoading.hide();
    }

    // 后台唤醒 取消loading
    function OnResume() {
        setTimeout(function () {
            // 不是通过微信回调返回
            if (!$scope.fromWeixin) {
                $ionicLoading.show();
                $scope.resultShow = {};
                // 查询支付状态
                PaymentService.getTradeStatus($scope.outTradeNo).then(function (data) {
                    // 真·支付成功
                    if (data.result == 1) {
                        $fwCordovaToast.showShortBottom('支付成功');
                        // 支付成功
                        $scope.isPaySuccess = true;
                        $scope.resultShow = data.data;
                        // 查询挂号状态
                        $scope.getRegStatus();
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "0").then(function (data) {
                            ;
                        }, function (data) {
                            ;
                        });
                    }
                    //
                    else {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom('网络异常, 请稍后重试');
                        // 支付失败
                        $scope.isPaySuccess = false;
                        $scope.regErrorMsg = "网络异常, 请稍后重试";
                        $scope.toSlide(12);
                        // 回调 保存到服务器
                        PaymentService.appCallback($scope.vpSelect.VISIT_PATIENT_ID, $scope.outTradeNo, "-1").then(function (data) {
                            ;
                        }, function (data) {
                            ;
                        });
                    }
                    // 解绑后台唤醒事件监测
                    document.removeEventListener("resume", OnResume, false);
                    // 由微信回调返回
                    $scope.fromWeixin = true;
                    $scope.outTradeNo = "";
                    $scope.appResult = "";
                    $ionicLoading.hide();
                }, function (data) {
                    // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                });
            }
        }, 1000);
    }

    // 倒计时
    $scope.timeCountdown = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeft = $rootScope.payTimeLeft - 1);
        } else {
            $rootScope.payTimeLeft = $rootScope.payTimeLeft - 1;
        }
        clearTimeout($rootScope.payResendTimeer);
        if ($rootScope.payTimeLeft > 0) {
            $rootScope.payResendTimeer = setTimeout($scope.timeCountdown, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatus = 0);
            } else {
                $rootScope.payStatus = 0;
            }
            // 超时处理
            $scope.checkTimeout();
        }
    }

    $scope.slidePayReady = function () {
        // 根据支付状态 弹出跳转
        console.log(slidePay);
    }

    $scope.payShow = function () {
        $scope.payModal.show();
    }
    $scope.payHide = function () {
        $scope.payModal.hide();
    }

    // 2017-1-10 13:29:10 增加验证通知相关方法
    // 通知授权帮助模态窗口显示
    $scope.noticeAuthHelpShow = function () {
        $scope.noticeAuthHelpModal.show();
    }

    // 通知授权帮助模态窗口隐藏
    $scope.noticeAuthHelpHide = function () {
        $scope.noticeAuthHelpModal.hide();
        $ionicScrollDelegate.scrollTop();
    }

    // 跳转至个人中心
    $scope.goPersonal = function () {
        $state.go('app.personal');
    }

    // 2017-1-12 17:45:25 跳转到预约成功页面后 检测弹出 关联微信 iOS通知权限
    $scope.verifyNoticeAlert = function () {
        if ($scope.regErrorMsg.length == 0) {
            // iOS通知权限赋值
            $scope.verifyNoticeInfo.isIOS = currentPlatform == "iOS" ? true : false;
            if ($scope.verifyNoticeInfo.isIOS) {
                $scope.verifyNoticeInfo.noticeAuth = localStorage.noticeAuth == "1" ? true : false;
                console.log("iOS noticeAuth: " + $scope.verifyNoticeInfo.noticeAuth);
            }
            // 拼接弹出的富文本
            var strHtml = "<div><p>请注意，您的：</p>";
            if (!$scope.verifyNoticeInfo.noticeAuth) {
                strHtml += "<p style='display:flex;align-items:center;'><i class='icon ion-ios-cog' style='width:40px;height:40px;padding-right:4px;font-size:40px;text-align:center;color:#89898c;'></i>设备未开启通知权限</p>";
            }
            if (!$scope.accountInfo.isBind) {
                strHtml += "<p style='display:flex;align-items:center;'><i class='icon fwicon-wechat' style='width:40px;height:40px;padding-right:4px;font-size:40px;text-align:center;color:#00c500;'></i>账号未关联微信</p>";
            }
            strHtml += "<p>未开启上述服务可能导致您收不到医师停诊通知，从而给您的就诊带来不便，请及时处理。</p></div>";
            // 没全开 需要弹出提示
            if (!$scope.verifyNoticeInfo.noticeAuth || !$scope.accountInfo.isBind) {
                $ionicPopup.show({
                    title: '预约成功',
                    template: strHtml, // 这是一段富文本
                    buttons: [{
                        text: '确定',
                        type: 'button-positive'
                    }]
                });
            }
        }
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 2020-1-24 16:00:23 增加预约挂号前置温馨提示
    // 前置温馨提示模态窗口显示
    $scope.preNoticeShow = function () {
        if (!$scope.preNoticeModal.isShown()) {
            $scope.preNoticeModal.show();
        }
    }

    // 前置温馨提示模态窗口隐藏
    $scope.preNoticeHide = function () {
        if ($scope.preNoticeModal.isShown()) {
            $scope.preNoticeModal.hide();
        }
    }

    // 2020-02-19 来院人员登记 提交
    $scope.temperatureSubmit = function(){
        console.log($scope.temperature);

        if($scope.temperature.PHONENUM == undefined || $scope.temperature.PHONENUM == ""
            || $scope.temperature.IS_TOUCH == undefined
            || $scope.temperature.IS_INFECT == undefined
            || $scope.temperature.IS_LIVE_HIGH_RISK == undefined
            || $scope.temperature.IS_EXIT_BORDER == undefined
            || $scope.temperature.HAS_FAMILY == undefined){
            $fwCordovaToast.showLongBottom("请完整填写就诊人信息");
            return;
        }

        var reg = /^1[3-9][0-9]{9}$/;
        if (!reg.test($scope.temperature.PHONENUM)) {
            $fwCordovaToast.showLongBottom("请填写正确手机号码");
            return;
        }

        if($scope.vpSelect.IDCARD_CODE.substr(0, 3) != '110' || $scope.vpSelect.IDCARD_TYPE == 5) {
            if($scope.temperature.IS_NOT_BACK == undefined ){
                $fwCordovaToast.showLongBottom("请选择是否常住（居住21天以上）北京");
                return;
            }

            if($scope.temperature.IS_NOT_BACK == 1){
                if($scope.temperature.PROVINCE == undefined || $scope.temperature.PROVINCE == ""
                || $scope.temperature.CITY == undefined || $scope.temperature.CITY == ""
                || $scope.temperature.COUNTRY == undefined || $scope.temperature.COUNTRY == ""
                || $scope.temperature.ADDRESS == undefined || $scope.temperature.ADDRESS == ""
                || $scope.temperature.ADDRESS == "无"){
                    $fwCordovaToast.showLongBottom("请选择来京常住省/市/县，并填写详细住址");
                    return;
                }
            }
            else{
                if($scope.temperature.DATE_BACK == undefined || $scope.temperature.DATE_BACK == ""
                || $scope.temperature.WAY_BACK == undefined
                || $scope.temperature.BACK_PROVINCE == undefined || $scope.temperature.BACK_PROVINCE == ""
                || $scope.temperature.BACK_CITY == undefined || $scope.temperature.BACK_CITY == ""
                || $scope.temperature.BACK_COUNTRY == undefined || $scope.temperature.BACK_COUNTRY == ""
                || $scope.temperature.BACK_ADDRESS == undefined || $scope.temperature.BACK_ADDRESS == ""
                || $scope.temperature.BACK_ADDRESS == "无"){
                    $fwCordovaToast.showLongBottom("请填写返京时间/方式，选择返京前居住省/市/县，并填写详细住址");
                    return;
                }
            }
        }
        // 2020-07-10 北京收集详细地址
        else{
            if($scope.BJ.COUNTRY == undefined || $scope.BJ.COUNTRY == ""
                || $scope.temperature.ADDRESS == undefined || $scope.temperature.ADDRESS == ""
                || $scope.temperature.ADDRESS == "无"){

                    $fwCordovaToast.showLongBottom("请选择在京所在区，并填写详细住址");
                    return;
                }
        }

        // 陪同家属
        if($scope.temperature.HAS_FAMILY == 1){
            if($scope.temperature.FAMILY_NAME == undefined || $scope.temperature.FAMILY_NAME == ""
                || $scope.temperature.FAMILY_IDCARD_CODE == undefined || $scope.temperature.FAMILY_IDCARD_CODE == ""
                || $scope.temperature.FAMILY_PHONENUM == undefined || $scope.temperature.FAMILY_PHONENUM == ""
                || $scope.temperature.FAMILY_IS_TOUCH == undefined
                || $scope.temperature.FAMILY_IS_INFECT == undefined
                || $scope.temperature.FAMILY_IS_LIVE_HIGH_RISK == undefined
                || $scope.temperature.FAMILY_IS_EXIT_BORDER == undefined){
                $fwCordovaToast.showLongBottom("请完整填写陪同家属信息");
                return;
            }

            reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            if (!reg.test($scope.temperature.FAMILY_IDCARD_CODE)) {
                $fwCordovaToast.showLongBottom("陪同家属身份证格式错误");
                return;
            }
            reg = /^1[3-9][0-9]{9}$/;
            if (!reg.test($scope.temperature.FAMILY_PHONENUM)) {
                $fwCordovaToast.showLongBottom("陪同家属联系方式格式错误");
                return;
            }

            if($scope.temperature.FAMILY_IDCARD_CODE.substr(0, 3) != '110'){
                if($scope.temperature.FAMILY_IS_NOT_BACK == undefined) {
                    $fwCordovaToast.showLongBottom("请选择家属是否常住（居住21天以上）北京");
                    return;
                }

                if($scope.temperature.FAMILY_IS_NOT_BACK == 1){
                     if($scope.temperature.FAMILY_PROVINCE == undefined || $scope.temperature.FAMILY_PROVINCE == ""
                        || $scope.temperature.FAMILY_CITY == undefined || $scope.temperature.FAMILY_CITY == ""
                        || $scope.temperature.FAMILY_COUNTRY == undefined || $scope.temperature.FAMILY_COUNTRY == ""
                        || $scope.temperature.FAMILY_ADDRESS == undefined || $scope.temperature.FAMILY_ADDRESS == ""
                        || $scope.temperature.FAMILY_ADDRESS == "无"){
                        $fwCordovaToast.showLongBottom("请选择陪同家属来京常住省/市/县，并填写详细住址");
                        return;
                    }
                }
                else{
                    if($scope.temperature.FAMILY_DATE_BACK == undefined || $scope.temperature.FAMILY_DATE_BACK == ""
                        || $scope.temperature.FAMILY_WAY_BACK == undefined
                        || $scope.temperature.FAMILY_BACK_PROVINCE == undefined || $scope.temperature.FAMILY_BACK_PROVINCE == ""
                        || $scope.temperature.FAMILY_BACK_CITY == undefined || $scope.temperature.FAMILY_BACK_CITY == ""
                        || $scope.temperature.FAMILY_BACK_COUNTRY == undefined || $scope.temperature.FAMILY_BACK_COUNTRY == ""
                        || $scope.temperature.FAMILY_BACK_ADDRESS == undefined || $scope.temperature.FAMILY_BACK_ADDRESS == ""
                        || $scope.temperature.FAMILY_BACK_ADDRESS == "无"){
                        $fwCordovaToast.showLongBottom("请填写陪同家属返京时间/方式，选择陪同家属返京前居住省/市/县，并填写详细住址");
                        return;
                    }
                }
            }
            // 2020-07-10 北京收集详细地址
            else{
                if($scope.BJ.FAMILY_COUNTRY == undefined || $scope.BJ.FAMILY_COUNTRY == ""
                    || $scope.temperature.FAMILY_ADDRESS == undefined || $scope.temperature.FAMILY_ADDRESS == ""
                    || $scope.temperature.FAMILY_ADDRESS == "无"){

                    $fwCordovaToast.showLongBottom("请选择陪同家属在京所在区，并填写详细住址");
                    return;
                }
            }
        }

        // 清除冗余数据 就诊人非京籍
        if($scope.vpSelect.IDCARD_CODE.substr(0, 3) != '110'){
            // 常驻
            if($scope.temperature.IS_NOT_BACK == 1){
                $scope.clearBackSelect();
            }
            else{
                $scope.clearSelect();
            }
        }
        else{
            $scope.temperature.PROVINCE = "北京市";
            $scope.temperature.CITY = "北京市";
            $scope.temperature.COUNTRY = $scope.BJ.COUNTRY;

            $scope.clearBackSelect();
        }

        // 有陪同家属 && 非家属京籍
        if($scope.temperature.HAS_FAMILY == 1 && $scope.temperature.FAMILY_IDCARD_CODE.substr(0, 3) != "110"){
            // 常驻
            if($scope.temperature.FAMILY_IS_NOT_BACK == 1){
                $scope.clearFamilyBackSelect();
            }
            else{
                $scope.clearFamilySelect();
            }
        }
        else{
            $scope.temperature.FAMILY_PROVINCE = "北京市";
            $scope.temperature.FAMILY_CITY = "北京市";
            $scope.temperature.FAMILY_COUNTRY = $scope.BJ.FAMILY_COUNTRY;

            $scope.clearFamilyBackSelect();
        }

        $ionicLoading.show();
        VisitPatientService.temperatureSubmit($scope.temperature).then(function (result) {
            $ionicLoading.hide();
            if(result.result == 0){
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else{
                // 如果有msg 提示出来，没有则证明成功。这样可以兼容旧版本
                if(result.msg != ""){
                    $fwCordovaToast.showLongBottom(result.msg);
                }
                $scope.temperatureModal.hide();
                $scope.toSlide($scope.temperatureNextStep);
            }
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }
    // 2020-02-19 来院人员登记 开modal
    $scope.temperatureModalOpen = function(nextStep){
        $scope.temperatureNextStep = nextStep;
        // 开关关闭
        if($scope.isOpenApptTemp == "0"){
            $ionicLoading.hide();
            $scope.toSlide($scope.temperatureNextStep);
            return;
        }

        $scope.temperature = {};
        $scope.temperature.VISIT_PATIENT_ID = $scope.vpSelect.VISIT_PATIENT_ID;

        VisitPatientService.lastTemperature($scope.vpSelect.VISIT_PATIENT_ID).then(function(result) {
            if (result.result == 1) {
                // 2020-07-10 本地处理一下
                if(result.dt[0].IDCARD_CODE != null && result.dt[0].IDCARD_CODE.substr(0, 3) == "110") {
                    $scope.BJ.COUNTRY = result.dt[0].COUNTRY;
                }
                if(result.dt[0].FAMILY_IDCARD_CODE != null && result.dt[0].FAMILY_IDCARD_CODE.substr(0, 3) == "110") {
                    $scope.BJ.FAMILY_COUNTRY = result.dt[0].FAMILY_COUNTRY;
                }

                // 救一手旧数据
                if(result.dt[0].IS_NOT_BACK == null && result.dt[0].FAMILY_IS_NOT_BACK == null){
                    // 时间处理
                    result.dt[0].FAMILY_DATE_BACK = (result.dt[0].FAMILY_DATE_BACK == null? null : (new Date(result.dt[0].FAMILY_DATE_BACK)).Format("yyyy-MM-dd"));
                    result.dt[0].DATE_BACK = (result.dt[0].DATE_BACK == null? null:(new Date(result.dt[0].DATE_BACK)).Format("yyyy-MM-dd"));

                    $scope.temperature = result.dt[0];

                    // 旧数据重新选择省市县
                    // 2020-07-10 北京也采集地址了，不能轻易清了
                    $scope.clearBackSelect();
                    $scope.clearFamilyBackSelect();

                    $ionicLoading.hide();
                    $scope.popOpen(result.dt[0]);
                    return;
                }

                // 就诊人市/县
                var type = result.dt[0].IS_NOT_BACK == 1 ? 1 : 3;
                $scope.getCitys(type, result.dt[0]);
            }
            else if(result.result == -1){
                // 预留手机号
                RequestService.GetReservedPhone($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
                    $ionicLoading.hide();
                    if (data.result == 1 && data.is_null != 1) {
                        $scope.temperature.PHONENUM = data.data[0].PHONENUM;
                    }
                    $scope.temperatureModal.show();
                }, function (data) {
                    // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                });
            }
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom(result.msg);
            }
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })
    }
    // 2020-02-19 来院人员登记 关modal
    $scope.temperatureHide = function(){
        $scope.temperatureModal.hide();
    }

    // 2020-02-20 来院人员登记
    $scope.selectThis = function (type, value) {
        $scope.temperature[type] = value;

        // 防一手家属的历史数据京籍，改成非京籍在北京
        if(type == "FAMILY_IS_NOT_BACK" && value == 1){
            $scope.clearFamilySelect();
        }

        $ionicScrollDelegate.resize();
    }

    // 2020-02-24 来院人员登记 省市县：省
    $scope.getProvince = function () {
        CasePrintService.getProvince().then(function (result) {
            $scope.provinces = result.provinces;
        }, function (data) {
            ;
        })
    }

    // 2020-03-05 省市县 =>很多省市县
    $scope.addrSetting = {
            1: { PROVINCE: "PROVINCE", CITY: "CITY", COUNTRY: "COUNTRY", citys: "citys", countrys: "countrys" },
            2: { PROVINCE: "FAMILY_PROVINCE", CITY: "FAMILY_CITY", COUNTRY: "FAMILY_COUNTRY", citys:"family_citys", countrys:"family_countrys" },
            3: { PROVINCE: "BACK_PROVINCE", CITY: "BACK_CITY", COUNTRY: "BACK_COUNTRY", citys:"back_citys", countrys:"back_countrys" },
            4: { PROVINCE: "FAMILY_BACK_PROVINCE", CITY: "FAMILY_BACK_CITY", COUNTRY: "FAMILY_BACK_COUNTRY", citys: "family_back_citys", countrys: "family_back_countrys" }
        };
    $scope.citys = { citys:[], family_citys:[], back_citys:[], family_back_citys:[] };
    $scope.countrys = { countrys:[], family_countrys:[], back_countrys:[], family_back_countrys:[] };

    // 省市县：市
    $scope.getCity = function (type) {
        $scope.temperature[$scope.addrSetting[type].CITY] = "";
        $scope.temperature[$scope.addrSetting[type].COUNTRY] = "";
        $scope.getCitys(type, null);
    }
    // 市
    $scope.getCitys = function(type, temp){
        var t = (temp == null? $scope.temperature[$scope.addrSetting[type].PROVINCE] : temp[$scope.addrSetting[type].PROVINCE]);
        CasePrintService.getCity(t).then(function (result) {
            $scope.citys[$scope.addrSetting[type].citys] = result.citys;
            // 初加载
            if(temp != null){
                $scope.getCountrys(type, temp);
            }
        }, function (data) {
            ;
        })
    }

    // 省市县：县
    $scope.getCountry = function (type) {
        $scope.temperature[$scope.addrSetting[type].COUNTRY] = "";
        $scope.getCountrys(type, null);
    }
    // 县
    $scope.getCountrys = function(type, temp){
        var c = (temp == null ? $scope.temperature[$scope.addrSetting[type].CITY] : temp[$scope.addrSetting[type].CITY]);
        CasePrintService.getCounty(c).then(function (result) {
            $scope.countrys[$scope.addrSetting[type].countrys] = result.countys;
            // 初加载
            if(temp != null){
                if(type == 2 || type == 4){
                    $scope.isUse(temp);
                }
                else{
                    if(temp.HAS_FAMILY == 1){
                        type = temp.FAMILY_IS_NOT_BACK == 1 ? 2 : 4;
                        $scope.getCitys(type, temp);
                    }
                    else{
                        $scope.isUse(temp);
                    }
                }
            }
        }, function (data) {
            ;
        })
    }

    // 2020-07-10 北京市辖区
    $scope.getBJCounty = function(){
         CasePrintService.getCounty("北京市").then(function (result) {
            $scope.BJCounty = result.countys;
        });
    }

    // 2020-07-10
    $scope.BJ = { FAMILY_COUNTRY: "", COUNTRY: "" };


    // 是否复用
    $scope.isUse = function(temp){
        $timeout(function(){
            // 时间处理一下
            temp.FAMILY_DATE_BACK = (temp.FAMILY_DATE_BACK == null? null : (new Date(temp.FAMILY_DATE_BACK)).Format("yyyy-MM-dd"));
            temp.DATE_BACK = (temp.DATE_BACK == null? null:(new Date(temp.DATE_BACK)).Format("yyyy-MM-dd"));
            $scope.temperature = temp;
        },500);

        $ionicLoading.hide();
        $scope.popOpen(temp);
    }
    // 是否复用提示
    $scope.popOpen = function(temp){
        $scope.temperatureModal.show();
        $ionicPopup.show({
            title: '提示',
            template: "您存在来院人员登记信息，是否应用?",
            buttons: [
            {
                text: '否',
                onTap: function(){
                    $scope.temperature = {};
                    $scope.temperature.VISIT_PATIENT_ID = $scope.vpSelect.VISIT_PATIENT_ID;
                    $scope.temperature.APPT_TEMPERATURE_ID = temp.APPT_TEMPERATURE_ID;
                    // 2020-07-20 把临时参数也清了
                    $scope.BJ = { FAMILY_COUNTRY: "", COUNTRY: "" };
                    $ionicScrollDelegate.scrollTop();
                }
            },
            { text: '是', type: 'button-positive' }]
        });
    }

    // 清除冗余数据
    $scope.clearSelect = function(){
        $scope.temperature.PROVINCE = "";
        $scope.temperature.CITY = "";
        $scope.temperature.COUNTRY = "";
        $scope.temperature.ADDRESS = "";
    }
    $scope.clearBackSelect = function(){
        $scope.temperature.DATE_BACK = "";
        $scope.temperature.WAY_BACK = "";
        $scope.temperature.BACK_PROVINCE = "";
        $scope.temperature.BACK_CITY = "";
        $scope.temperature.BACK_COUNTRY = "";
        $scope.temperature.BACK_ADDRESS = "";
    }
    $scope.clearFamilySelect = function(){
        $scope.temperature.FAMILY_PROVINCE = "";
        $scope.temperature.FAMILY_CITY = "";
        $scope.temperature.FAMILY_COUNTRY = "";
        $scope.temperature.FAMILY_ADDRESS = "";
    }
    $scope.clearFamilyBackSelect = function(){
        $scope.temperature.FAMILY_DATE_BACK = "";
        $scope.temperature.FAMILY_WAY_BACK = "";
        $scope.temperature.FAMILY_BACK_PROVINCE = "";
        $scope.temperature.FAMILY_BACK_CITY = "";
        $scope.temperature.FAMILY_BACK_COUNTRY = "";
        $scope.temperature.FAMILY_BACK_ADDRESS = "";
    }

    $scope.MICodeHelpModalShow = function () {
        $scope.MICodeHelpModal.show();
    }
    $scope.MICodeHelpModalHide = function () {
        $scope.MICodeHelpModal.hide();
    }

    $scope.temperatureShowNew = function (step) {
        if ($scope.isOpenApptTemp == "1") {
            var data = {
                vpId: $scope.vpSelect.VISIT_PATIENT_ID,
                from: "opAppt",
                step: step
            };

            $scope.$broadcast("temperatureShow", data);
            $scope.temperatureModalNew.show();
        }
        else {
            $scope.toSlide(step);
        }
    }
    $scope.temperatureHideNew = function () {
        $scope.temperatureModalNew.hide();
    }

    $scope.$on('temperatureHide', function (event, data) {
        $scope.temperatureHideNew();
        // 如果是提交
        if(data.type == "submit") {
            // 判断是否进黑名单
            $ionicLoading.show();
            VisitPatientService.EpidemiolSrvyToTemperature($scope.vpSelect.VISIT_PATIENT_ID, "1").then(function (result) {
                $ionicLoading.hide();
                if(result.result == 0){
                    $fwCordovaToast.showShortBottom(result.msg);
                }
                else{
                    $scope.toSlide(data.step);
                }
            }, function (resp) {
                var alertPopup = $ionicPopup.alert({
                    title: '网络错误',
                    template: '加载失败,请检查网络'
                });
                $ionicLoading.hide();
            });
        }
    });

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // wxh 跳转到小儿外科诊前信息问卷
    $scope.goQuestionnaire = function() {
        $state.go('app.opQuestionnaire',{ vpid: $scope.lockedRegInfo.VISIT_PATIENT_ID, opregid: $scope.lockedRegInfo.OP_REG_ID, type: $scope.QuerstionnaireType});
    }

    // 2020-5-6 10:59:13 HM 变更，增加与“在线问诊”关联、跳转功能。
    $scope.toConsultation = function () {
        $state.go('app.dealWithCard', { go: 'consultation'});
    }

    // 2020-7-23 15:25:26 HM 按症状预约，跳转自动问诊
    $scope.toAutoInquiry = function () {
        TriageService.checkServerStatus().then(function (data) {
            if (data.data == "1") {
                // 走新的
                $state.go("app.autoInquiry", { vpid: $scope.vpSelect.VISIT_PATIENT_ID, firstFrom: "opAppt", continueInquiry: 0 });
            }
            else {
                // 走旧的
                $scope.toSlide('5');
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom('网络错误，获取服务状态失败');
        })
    }

    // 2021-3-17 11:14:41 HM 4S评审，个性化推荐，超过80岁提示推荐使用轮椅
    $scope.wheelChairJudeg = function () {
        // 2021-4-18 18:40:21 患者便利保障服务推荐开关
        if (!(devMode || $scope.configData.easyRecommendServerStatus)) {
            return false;
        }
        // 如果大于80岁
        if(typeof($scope.vpSelect.BIRTHDAY) == "undefined" || $scope.vpSelect.BIRTHDAY == ""){
            return false;
        }
        else{
            // 如果是c#的时间戳，要格式化一下
            if($scope.vpSelect.BIRTHDAY.indexOf("/Date(") > -1){
                var d = eval('new ' + $scope.vpSelect.BIRTHDAY.substr(1, $scope.vpSelect.BIRTHDAY.length - 2));

                var ar_date = [d.getFullYear(), d.getMonth() + 1, d.getDate()];
                for(var i = 0; i < ar_date.length;i++){
                    ar_date[i] = ar_date[i] < 10 ? "0" + ar_date[i].toString() : ar_date[i];
                }
                $scope.vpSelect.BIRTHDAY = ar_date.join("-");
            }

            var age = new Date($scope.vpSelect.BIRTHDAY).GetAge();
            console.log(age);
            if(age >= 80){
                return true;
            }
            else{
                return false;
            }
        }
    }

    // 2021-7-6 20:12:40 HM 跳转在线问诊
    $scope.goTreat = function (doctorCode) {
        $state.go("app.consultation", {vpid: $scope.vpSelect.VISIT_PATIENT_ID, doctorCode: doctorCode});
    }

    // 2022-4-7 15:39:46 HM 改变核酸流调
    $scope.changeEpidSrvyNcp = function (params) {
        for (var i = 0; i < $scope.epidSrvyOptionList.length; i++) {
            if ($scope.epidSrvyOptionList[i].model == params) {
                $scope.epidSrvyOptionList[i].status = true;
            }
            else {
                $scope.epidSrvyOptionList[i].status = false;
            }
        }
    }

    // 2023-4-24 13:36:00 HM 展示代开药
    $scope.showAgent = function (flag) {
        $scope.agent.phone = "";
        $scope.agent.name = "";
        $scope.agent.idcard = "";
        $scope.agent.relation = "";
        if (flag == true) {
            // 联系电话设置成当前登录账号
            $scope.agent.phone = $scope.accountInfo.PHONENUM;
        }
        $scope.agent.isShow = flag;
        $ionicScrollDelegate.resize();
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOpAppt.enableSlide(false);
    });

    $scope.$on('$ionicView.enter', function () {
        $ionicLoading.show();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'opAppt');

        // 2020-1-24 16:00:23 增加预约挂号前置温馨提示
        if ($rootScope.opApptPreNoticeInfo && $rootScope.opApptPreNoticeInfo.preNoticeStatus == "1") {
            $scope.preNoticeShow();
        }

        // 检查预约挂号开关
        OpApptService.checkServerStatus().then(function (data) {
            // 开放
            if (isOpAppt || data.result == 1) {
                // 是否继续支付
                // 获取挂号信息
                OpRegService.getLatestReg().then(function (data) {
                    // 待支付 跳转到支付确认界面
                    if (data.result == 1 && data.data.isToday && data.data.opRegToday.STATUS == 2) {
                        // 获取支付时间限制
                        $scope.getTimeLimit();
                        // 跳转支付确认界面
                        $scope.lockedRegInfo = data.data.opRegToday;
                        $scope.isContinueToPay = true;
                        $scope.toSlide(11);

                        // 2023-11-20 08:50:41 HM 如果是医保移动支付，把opInfoId赋值进去
                        if (data.data.opRegToday.PAYMENT_METHOD == 10) {
                            $scope.opInfoId = data.data.opRegToday.OP_SCHED_ID;
                        }
                    }
                    else {
                        //$fwCordovaToast.showShortBottom(data.msg);
                    }
                    console.log($scope.lockedRegInfo);
                    // 2019-8-15 18:46:14 是否从医师列表等模块跳转进来的当日号 替换为当日预约的用户须知
                    // 根据传过来的opInfoId获取预约信息
                    if (typeof ($scope.opInfoId) != 'undefined' && $scope.opInfoId.length > 0) {
                        OpApptService.getOpSchedInfo($scope.opInfoId).then(function (dataOpSched) {
                            // 查询成功
                            if (dataOpSched.result == 1) {
                                var str = $scope.getSchedPeriodStr(dataOpSched.data.SCHED_TIME, dataOpSched.data.SCHED_PERIOD_CODE);
                                dataOpSched.data.SCHED_PERIOD_STR = str;
                                $scope.opInfo = dataOpSched.data;
                                // opInfo赋值 已经在进入页面的时候异步获取opInfo
                                $scope.opInfoSelect = $scope.opInfo[0];
                                console.log($scope.opInfoSelect);
                            }
                            // 查询失败
                            else {
                                console.log(dataOpSched.msg);
                            }
                        }, function (data) {
                            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                        })
                    }
                    // 获取配置
                    OpApptService.getConfig($scope.opInfoId).then(function (data) {
                        // 查询成功
                        if (data.result == 1) {
                            // 格式化医师挂号提示
                            if (data.data.hasOwnProperty("doctorTips") && data.data.doctorTips != null && data.data.doctorTips.length > 0) {
                                data.data.doctorTips = JSON.parse(data.data.doctorTips);
                            }
                            $scope.configData = data.data;
                            // 按特色技术/病种标题占位
                            $scope.configData.apptStepList.splice(8, 0, "", "");
                            console.log($scope.configData);
                            // 默认值
                            $scope.opApptData.division = $scope.configData.divisionList[0].code; // 预约科室
                            $scope.opApptData.schedDate = $scope.configData.schedDateList[0].code; // 预约日期
                            // 2019-10-22 07:49:52 HM 当日预约上午过号后，默认屏蔽上午
                            if ($scope.configData.todaySign == "PM") {
                                $scope.opApptData.schedTime = $scope.configData.schedTimeList[1].code; // 预约时段
                            }
                            else {
                                $scope.opApptData.schedTime = $scope.configData.schedTimeList[0].code; // 预约时段
                            }
                            $scope.currentWishByDoctor.schedDate = $scope.configData.schedDateList[0].code;
                            $scope.currentWishByFilter.schedDate = "0";

                            // 来院登记开关
                            $scope.isOpenApptTemp = $scope.configData.isOpenApptTemp;

                            // 2021-4-13 18:25:58 填写身高体重开关
                            if (devMode || $scope.configData.needHeightWeight) {
                                $scope.needHeightWeight = true;
                            }

                            // 2021-4-27 18:33:43 预约挂号选择号序开关
                            if (devMode || $scope.configData.chooseSchedSeq) {
                                $scope.chooseSchedSeq = true;
                                $scope.chooseSchedSeqDescr = $scope.configData.chooseSchedSeqDescr;
                                $scope.chooseSchedSeqNotice = $scope.configData.chooseSchedSeqNotice;
                            }

                            // 2023-4-24 10:27:50 HM 代开药开关
                            if ($scope.configData.needAgent && $rootScope.elderly == false) {
                                $scope.needAgent = true;
                            }

                            $scope.loadOpInfoList();

                            // 2020-1-24 16:00:23 增加预约挂号前置温馨提示
                            if ($scope.configData && $scope.configData.preNoticeStatus && $scope.configData.preNoticeStatus == "1") {
                                //2023-9-26 08:44:43 zzl hzfwx-55 解决当前页面刷新倒计时卡住问题（本质上app不存在当前页面刷新问题，但还是要处理一下）
                                if ($rootScope.opApptPreNoticeInfo == undefined) {
                                    $rootScope.opApptPreNoticeInfo = {};
                                }
                                if ($rootScope.opApptPreNoticeInfo.preNotice != $scope.configData.preNotice) {
                                    $rootScope.opApptPreNoticeInfo.preNotice = $scope.configData.preNotice;
                                }
                                // 默认弹出 如果没有则隐藏
                                $scope.preNoticeShow();
                            }
                            else {
                                $rootScope.opApptPreNoticeInfo.preNoticeStatus = "0";
                                $scope.preNoticeHide();
                            }

                            // 开启用户须知倒计时
                            $interval(function () {
                                $scope.confirmCountdown -= 1;
                            }, 1000, 10);

                            // 2023-8-9 09:53:16 ZZL #hzfwx-55 添加超时取消定时器，解决偶发用户须知界面倒计时卡住问题（该问题通过home变量声明已解决，先注释掉）
                            //var stopTimer = $interval(function () {
                            //    $scope.confirmCountdown -= 1;
                            //}, 1000, 10);

                            //var timeoutPromise = $timeout(function () {
                            //    $interval.cancel(stopTimer);
                            //    $scope.confirmCountdown = 0;
                            //}, 10000)

                            //stopTimer.then(function () {
                            //    $timeout.cancel(timeoutPromise);
                            //    $interval.cancel(stopTimer);
                            //})
                        }
                        // 查询失败
                        else {
                            var alertPopup = $ionicPopup.alert({
                                title: '网络错误',
                                template: data.msg
                            });
                            $fwCordovaToast.showShortBottom(data.msg);
                        }
                    }, function (data) {
                        // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                        $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                    })
                    // 获取就诊人列表
                    $scope.loadVpList();
                    // 获取账户信息 是否绑定微信 是否关注公众号
                    if ('' != localStorage.currentAccountId) {
                        // 获取用户信息
                        AccountService.accountInfo().then(function (data) {
                            if (data.result == 1) {
                                $scope.accountInfo = data.data;
                                // 新api 有绑定微信的状态值
                                if (null != data.isBind) {
                                    $scope.accountInfo.isBind = data.isBind;
                                    // 已绑定 有关注公众号的状态值
                                    if (null != data.isFollow) {
                                        $scope.accountInfo.isFollow = data.isFollow;
                                        // 已关注 有个人微信信息
                                        if (null != data.wxInfo) {
                                            $scope.accountInfo.wxInfo = data.wxInfo;
                                        }
                                    }
                                    // 有滚动信息
                                    if (null != data.marqueeMsg) {
                                        $scope.accountInfo.marqueeMsg = data.marqueeMsg;
                                    }
                                    // 有iOS允许推送帮助
                                    if (null != data.iOSAllowNoticeHelp) {
                                        $scope.accountInfo.iOSAllowNoticeHelp = data.iOSAllowNoticeHelp;
                                    }
                                }
                            }
                            console.log($scope.accountInfo);
                        }, function (data) {
                            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                        })
                    }
                }, function (data) {
                    // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
                    $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
                });
                // 唤醒数据库
                PaymentService.wakeDBConnection().then(function (data) {
                    //console.log(data);
                }, function (data) {
                    ;
                });
            }
            // 关闭
            else if (data.result == -99) {
                $fwCordovaToast.showShortBottom(data.msg);
                $scope.isServerOn = false;
                $scope.configData.apptDescription = data.msg;
                $ionicLoading.hide();
            }
            // 异常
            else {
                $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
                $scope.isServerOn = false;
                $ionicLoading.hide();
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络异常，请稍后重试");
            $scope.isServerOn = false;
            $ionicLoading.hide();
        })
        // 获取可选择支付方式
        PaymentService.getPaymentRoute().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $rootScope.paymentRouteList = data.data;
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            // 2024-3-7 12:16:47 CGZ 付老师反馈有患者反应近期中午挂号经常卡住，只能杀APP重进，经查存在请求返回502的情况，前端增加请求失败处理
            $fwCordovaToast.showShortBottom("网络错误,请稍后重试");
        })

        // 2020.02.24 省市县：省
        $scope.getProvince();
        // 2020-07-10 北京的区
        $scope.getBJCounty();
        // 2023-8-29 13:55:26 ZZL #hzfwx-107 获取现住址省市县基础字典
        $scope.getBaseDict();

        // 设置当前支持的就诊人方式
        // 2021-12-28 14:35:04 CGZ 此开关已过试用阶段，从前端移除此请求，后端去掉日志，减少数据库连接占用
        //VisitPatientService.ForeignModuleIsOpen().then(function (data) {
        //    if(data.result == 1){
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }, { "id": "5", "name": "护照/外国人永久身份证"}];
        //    }
        //    else{
        //        $scope.idCardTypeList = [{ "id": "1", "name": "身份证" }];
        //    }
        //});
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'opAppt') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
